#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pt {
    ll x, y;

    ll crs(const pt &oth) const {
        return x * oth.y - y * oth.x;
    }

    ll dot(const pt &oth) const {
        return x * oth.x + y * oth.y;
    }

    friend pt operator-(const pt &a, const pt &b) {
        return pt{a.x - b.x, a.y - b.y};
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;

    vector<pt> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
    }
    sort(p.begin(), p.end(), [&](auto a, auto b) {
        return a.x < b.x;
    });

    if (task == 1) {
        if (group == 1) {
            vector<int> ord(n);
            iota(ord.begin(), ord.end(), 0);
            sort(ord.begin(), ord.end(), [&](int i, int j) {
                return p[i].x < p[j].x;
            });
            vector<int> ans;
            for (int l = 0, r = n - 1, f = 0; l <= r; f ^= 1) {
                if (f == 0) {
                    ans.push_back(ord[l++]);
                } else {
                    ans.push_back(ord[r--]);
                }
            }
            for (int x: ans) {
                cout << x + 1 << " ";
            }
            cout << '\n';
        } else if (group == 2) {
            vector<int> ord(n);
            iota(ord.begin(), ord.end(), 0);
            vector<int> ans;
            int curAns = 0;
            do {
                int cur = 0;
                for (int i = 0; i + 2 < n; ++i) {
                    cur += (p[i] - p[i + 1]).dot(p[i + 2] - p[i + 1]) > 0;
                }
                if (cur > curAns) {
                    curAns = cur;
                    ans = ord;
                }
            } while (next_permutation(ord.begin(), ord.end()));
            for (int x: ans) {
                cout << x + 1 << " ";
            }
            cout << '\n';
        }
        return 0;
    }

    return 0;
}