#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7, MAXW = 20'000;

struct Point {
	ll x, y;
	Point() {
		x = 0; y = 0;
	}
	Point(ll xx, ll yy) {
		x = xx; y = yy;
	}
};

Point operator-(Point a, Point b) {
	return Point(a.x - b.x, a.y - b.y);
}

ll scal(Point a, Point b) {
	return a.x * b.x + a.y * b.y;
}
void solve() {
	ll task, g;
	cin >> task >> g;
	ll n;
	cin >> n;
	vector<Point> a(n);
	for (Point& elem : a) {
		cin >> elem.x >> elem.y;
	}

	if (n <= 1000) {
		vector<ll> ind(n);
		for (ll i = 0; i < n; i++) {
			ind[i] = i;
		}
		ll ans = -1;
		vector<ll> rs;

		ll cnt = 100'000;
		while (cnt--) {
			shuffle(ind.begin(), ind.end(), gen);
			ll AOA = 0;
			for (ll i = 0; i + 2 < n; i++) {
				if (scal(a[ind[i]] - a[ind[i + 1]], a[ind[i + 2]] - a[ind[i + 1]]) > 0) {
					AOA++;
				}
			}
			if (AOA > ans) {
				rs = ind;
				ans = AOA;
			}
		}
		for (ll elem : rs) {
			cout << elem + 1 << " ";
		}
		cout << endl;
		return;
	}

	for (ll i = 1; i <= n / 2; i++) {
		cout << i << " " << n + 1 - i << " ";
	}
	if (n % 2 == 1) {
		cout << (n + 1) / 2 << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/