#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<pair<int, int>> cords;
int task;
int n;
vector<int> t1mp;
int t1mc = 0;
int c;
vector<vector<int>> t3res;
const ll mod = 1e9 + 7;
const ll bv = 1e6 + 3;
map<int, ll> t41;
map<int, vector<int>> t42;

ll norm(ll num) {
	return (num % mod + mod) % mod;
}


void Perm(vector<int>& p) {
	vector<char> seen(n);
	int pos = -1;
	for (int i = 0; i < n; i++) {
		if (p[i] == -1) {
			pos = i;
			break;
		}
		seen[p[i]] = 1;
	}

	if (pos == -1) {
		if (task == 1) {
			int cnt = 0;
			for (int i = 2; i < n; i++) {
				ll x1 = cords[p[i - 1]].first - cords[p[i - 2]].first, y1 = cords[p[i - 1]].second - cords[p[i - 2]].second;
				ll x2 = cords[p[i - 1]].first - cords[p[i]].first, y2 = cords[p[i - 1]].second - cords[p[i]].second;
				if (x1 * x2 + y1 * y2 > 0)
					cnt++;
			}
			if (cnt > t1mc) {
				t1mc = cnt;
				t1mp = p;
			}
		}
		else if (task == 2) {
			int cnt = 0;
			for (int i = 2; i < n; i++) {
				ll x1 = cords[p[i - 1]].first - cords[p[i - 2]].first, y1 = cords[p[i - 1]].second - cords[p[i - 2]].second;
				ll x2 = cords[p[i - 1]].first - cords[p[i]].first, y2 = cords[p[i - 1]].second - cords[p[i]].second;
				if (x1 * x2 + y1 * y2 > 0)
					cnt++;
			}

			if (cnt <= c) {
				for (int i : p)
					cout << i + 1 << ' ';
				cout << endl;
				exit(0);
			}
		}
		else if (task == 3) {
			int cnt = 0;
			for (int i = 2; i < n; i++) {
				ll x1 = cords[p[i - 1]].first - cords[p[i - 2]].first, y1 = cords[p[i - 1]].second - cords[p[i - 2]].second;
				ll x2 = cords[p[i - 1]].first - cords[p[i]].first, y2 = cords[p[i - 1]].second - cords[p[i]].second;
				if (x1 * x2 + y1 * y2 > 0)
					cnt++;
			}

			if (cnt >= c && cnt <= n - c && t3res[cnt - c].size() == 0) {
				t3res[cnt - c] = p;
			}
		}
		else {
			int cnt = 0;
			for (int i = 2; i < n; i++) {
				ll x1 = cords[p[i - 1]].first - cords[p[i - 2]].first, y1 = cords[p[i - 1]].second - cords[p[i - 2]].second;
				ll x2 = cords[p[i - 1]].first - cords[p[i]].first, y2 = cords[p[i - 1]].second - cords[p[i]].second;
				if (x1 * x2 + y1 * y2 > 0)
					cnt++;
			}

			if (cnt >= c && cnt <= n - c && t41.count(cnt) == 0) {
				ll hash = 0;
				ll bpow = 1;
				for (int i : p) {
					hash = norm(hash + bpow * (i + 1));
					bpow = norm(bpow * bv);
				}

				t41[cnt] = hash;
				t42[cnt] = p;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (seen[i]) continue;
		seen[i] = 1;
		p[pos] = i;
		Perm(p);
		p[pos] = -1;
	}
}


void solve() {
	int group;
	cin >> task >> group;
	cin >> n;

	cords.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> cords[i].first >> cords[i].second;
	}

	vector<int> p(n, -1);

	if (task == 1) {
		Perm(p);
		for (int i : t1mp)
			cout << i + 1 << ' ';
		cout << endl;
		return;
	}

	if (task == 2) {
		cin >> c;
		Perm(p);
		return;
	}

	if (task == 3) {
		cin >> c;
		t3res.resize(n - c - c + 1);
		Perm(p);

		int q;
		cin >> q;

		while (q--) {
			int k;
			cin >> k;
			for (int i : t3res[k - c])
				cout << i + 1 << ' ';
			cout << endl;
		}
	}

	if (task == 4) {
		cin >> c;
		Perm(p);

		for (auto& el : t41)
			cout << el.second << ' ';
		cout << endl;

		int q;
		cin >> q;

		while (q--) {
			int k;
			cin >> k;

			for (int i : t42[k])
				cout << i + 1 << ' ';
			cout << endl;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
