#include <bits/stdc++.h>
using namespace std;

void solve1(int group) {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    if (group == 1) {
        for (int i = 0; i < (n + 1) / 2; ++i) {
            cout << i + 1 << ' ';
            if (n - 1 - i != i) {
                cout << n - 1 - i + 1 << ' ';
            }
        }
        cout << endl;
    } else {
        vector<int> rest(n - 1);
        iota(rest.begin(), rest.end(), 0);
        int last = n - 1;
        auto getDist = [&](int i, int j) -> long long {
            return (x[i] - x[j]) * 1ll * (x[i] - x[j]) + (y[i] - y[j]) * 1ll * (y[i] - y[j]);
        };
        cout << last + 1 << ' ';
        for (int iter = 0; iter < n - 1; ++iter) {
            int mxidx = rest[0], mxptr = 0;
            long long d = getDist(rest[0], last);
            for (int ptr = 0; ptr < (int)rest.size(); ++ptr) {
                int i = rest[ptr];
                long long curd = getDist(i, last);
                if (curd > d) {
                    d = curd;
                    mxidx = i;
                    mxptr = ptr;
                }
            }
            swap(rest[mxptr], rest.back());
            rest.pop_back();
            last = mxidx;
            cout << last + 1 << ' ';
        }
        cout << endl;
    }
}

void solve3(int group) {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    vector<int> rest(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        rest[i] = i;
    }
    if (group != 7) {
        mt19937 rnd(161);
        shuffle(rest.begin(), rest.end(), rnd);
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        int k;
        cin >> k;
        int need = n - 2 - k;
        int l = 0, r = n - 1;
        for (int i = 0; i < need + 1; ++i) {
            cout << rest[l] + 1 << ' ';
            ++l;
        }
        int step = 1;
        while (l <= r) {
            if (step == 1) {
                cout << rest[r--] + 1 << ' ';
            } else {
                cout << rest[l++] + 1 << ' ';
            }
            step ^= 1;
        }
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        int task, group;
        cin >> task >> group;
        if (task == 1) {
            solve1(group);
        } else {
            solve3(group);
        }
        cout << "--------\n";
        cerr << "--------\n";
    }
    #else
    int T = 1;
    // cin >> T;
    while (T--) {
        int task, group;
        cin >> task >> group;
        if (task == 1) {
            solve1(group);
        } else {
            solve3(group);
        }
    }
    #endif

    return 0;
}