#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct pnt {
    ll x, y;

    pnt() {}

    pnt(ll x, ll y) : x(x), y(y) {}
};

pnt operator+(pnt a, pnt b) {
    return { a.x + b.x, a.y + b.y };
}

pnt operator-(pnt a, pnt b) {
    return { a.x - b.x, a.y - b.y };
}

ll operator*(pnt a, pnt b) {
    return a.x * b.x + a.y * b.y;
}

ll operator%(pnt a, pnt b) {
    return a.x * b.y - a.y * b.x;
}

inline void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pnt> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
    if (group == 1) {
        int l = 0, r = n - 1;
        vector<int> ord(n);
        for (int i = 0; i < n; i += 2, l++)
            ord[i] = l;
        for (int i = 1; i < n; i += 2, r--)
            ord[i] = r;
        for (int i : ord)
            cout << i + 1 << ' ';
        cout << '\n';
        return;
    }
    if (group == 2) {
        vector<int> ord(n);
        iota(all(ord), 0);
        int ans = 0;
        vector<int> opt = ord;
        do {
            int cnt = 0;
            for (int i = 1; i < n - 1; i++) {
                pnt pr = a[ord[i - 1]];
                pnt cur = a[ord[i]];
                pnt nx = a[ord[i + 1]];
                cnt += (cur - nx) * (cur - pr) > 0;
            }
            if (cnt > ans) {
                ans = cnt;
                opt = ord;
            }
        } while (next_permutation(all(ord)));
        for (int i : opt)
            cout << i + 1 << ' ';
        cout << '\n';
        return;
    }
    if (task == 1) {
        return;
    }
    int c;
    cin >> c;
    if (task == 3) {
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            vector<int> ord(n);
            int l = 0, r = n - 1;
            int dir = 1;
            for (int i = 0; i < k + 1; i++) {
                if (dir == 1)
                    ord[i] = l++;
                else
                    ord[i] = r--;
                dir *= -1;
            }
            dir *= -1;
            for (int i = k + 1; i < n; i++) {
                if (dir == -1)
                    ord[i] = r--;
                else
                    ord[i] = l++;
            }
            for (int i : ord)
                cout << i + 1 << ' ';
            cout << endl;
        }
    }
}

signed main() {
    solve();
    return 0;
}
