#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}



void solve() {
    int task, gr;
    cin >> task >> gr;
    int n;
    cin >> n;
    vector<Vect> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (gr == 1) {
        int l = 1, r = n;
        while (l < r) {
            cout << l << " ";
            cout << r << " ";
            l++, r--;
        }
        return;
    }
    if (gr == 7) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        int k;
        for (int i = 0; i < q; i++) {
            cin >> k;
            int cnt = 1;
            int l = 1, r = n;
            while (cnt < k) {
                cout << l << " ";
                l++;
                cnt++;
                if (cnt < k) {
                    cout << r << " ";
                    r--;
                    cnt++;
                }
            }
            for (int j = l; j <= r; j++) {
                cout << j << " ";
            }
            cout << endl;
        }
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
