#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

mt19937 rnd(time(0));

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const ll MAXN = 2e5;
set<pair<ll, ll>> g[MAXN];

ll vec(pair<ll, ll> a, pair<ll, ll> b) {
    return a.first * b.second - a.second * b.first;
}

ll skal(pair<ll, ll> a, pair<ll, ll> b) {
    return a.first * b.first + a.second * b.second;
}

pair<ll, ll> diff(pair<ll, ll> a, pair<ll, ll> b) {
    return {a.first - b.first, a.second - b.second};
}

ll bin_pow(ll a, ll x, ll m) {
    if (!x) return 1;

    ll g = bin_pow(a, x / 2, m);
    g *= g;
    g %= m;

    if (x % 2) {
        g *= a;
        g %= m;
    }

    return g;
}

void solve() {
    ll n, task, group;
    cin >> task >> group >> n;

    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    if (task == 1) {
        if (group == 1) {
            for (ll i = 1; i <= n; ++i) {
                if (i % 2 == 1) {
                    cout << i / 2 + 1 << ' ';
                }
                else {
                    cout << n - i / 2 + 1 << ' ';
                }
            }
            return;
        }
        ll ans = -1;
        vector<ll> to_ans;

        vector<ll> por(n);
        for (ll i = 0; i < n; ++i) por[i] = i;

        for (ll qw = 0; qw < 300000; ++qw) {
            shuffle(all(por), rnd);

            ll local = 0;

            for (ll i = 0; i + 2 < n; ++i) {
                auto fir = diff(a[por[i]], a[por[i + 1]]);
                auto sec = diff(a[por[i + 2]], a[por[i + 1]]);

                if (2 * abs(atan2(vec(fir, sec), skal(fir, sec))) < PI) {
                    local++;
                }
            }

            if (ans < local) {
                ans = local;
                to_ans = por;
            }
        }

        for (auto i : to_ans) cout << i + 1 << ' ';
    }
    if (task == 2) {
        ll c;
        cin >> c;
        vector<ll> por(n);
        for (ll i = 0; i < n; ++i) por[i] = i;

        while (true) {
            shuffle(all(por), rnd);

            ll local = 0;

            for (ll i = 0; i + 2 < n; ++i) {
                auto fir = diff(a[por[i]], a[por[i + 1]]);
                auto sec = diff(a[por[i + 2]], a[por[i + 1]]);

                if (2 * abs(atan2(vec(fir, sec), skal(fir, sec))) < PI) {
                    local++;
                    if (local > c) break;
                }
            }

            if (local <= c) {
                for (auto i : por) cout << i + 1 << ' ';
                return;
            }
        }
    }
    if (task == 3) {
        ll c, q;
        cin >> c >> q;
        if (group == 7) {
            while (q--) {
                ll k;
                cin >> k;

                if (k % 2 == 0) {
                    for (ll i = 1; i <= k + 2; ++i) {
                        if (i % 2 == 1) {
                            cout << i / 2 + 1 << ' ';
                        }
                        else {
                            cout << k / 2 + 1 + (i / 2) << ' ';
                        }
                    }

                    for (ll i = k + 3; i <= n; ++i) {
                        cout << i << ' ';
                    }
                    cout << endl;
                }
                else {
                    for (ll i = 1; i <= k + 1; ++i) {
                        if (i % 2 == 1) {
                            cout << k / 2 + 2 + (i / 2) << ' ';
                        }
                        else {
                            cout << i / 2 << ' ';
                        }
                    }
                    for (ll i = k + 2; i <= n; ++i) {
                        cout << i << ' ';
                    }
                    cout << endl;
                }
            }
            return;
        }
    }
    if (task == 4) {
        ll c;
        cin >> c;

        const ll b = 1e6 + 3, m = 1e9 + 7;

        ll rev_b = bin_pow(b, m - 2, m);

        vector<ll> step_b(n + 30);
        step_b[0] = 1;

        for (ll i = 1; i < n + 30; ++i) {
            step_b[i] = step_b[i - 1] * b;
            step_b[i] %= m;
        }

        vector<ll> lst(n + 2);
        lst[n + 1] = 0;
        for (ll i = n; i >= 1; --i) {
            lst[i] = (lst[i + 1] * b) % m;
            lst[i] += i;
            lst[i] %= m;
        }

        vector<ll> for_nechet(n);
        for_nechet[1] = 2 + b * 1;
        ll fir = 2, sec = b;
        ll beg = 0;

        for (ll k = 3; k <= n - c; k += 2) {
            ll nach = k / 2 + 1;
            fir -= nach;
            if (fir < 0) fir += m;
            fir *= rev_b;
            fir %= m;
            fir *= rev_b;
            fir %= m;

            fir += (beg + 3) * step_b[beg] % m;
            fir %= m;
            fir += (beg + 5) * step_b[beg + 2] % m;
            fir %= m;
            beg += 2;

            sec += ((k + 1) / 2) * step_b[k] % m;
            sec %= m;

            for_nechet[k] = (fir + sec) % m;
        }

        vector<ll> for_chet(n);
        for_chet[2] = (1 + 3 * b + 2 * b * b % m) % m;
        fir = 3 * b, sec = (1 + 2 * b * b % m) % m;
        beg = 4;

        for (ll k = 4; k <= n - c; k += 2) {
            ll nach = k / 2 + 2;
            fir -= (nach * b) % m;
            if (fir < 0) fir += m;

            fir *= rev_b;
            fir %= m;
            fir *= rev_b;
            fir %= m;

            fir += beg * step_b[beg - 3] % m;
            fir %= m;
            fir += (beg + 2) * step_b[beg - 1] % m;
            fir %= m;
            beg += 2;

            sec += (k / 2 + 1) * step_b[k] % m;
            sec %= m;

            for_chet[k] = (fir + sec) % m;
        }

        for (ll k = c; k <= n - c; ++k) {
            if (k % 2 == 1) {
                cout << (for_nechet[k] + lst[k + 2]) % m << ' ';
            }
            else {
                cout << (for_chet[k] + lst[k + 2]) % m << ' ';
            }
        }
        cout << endl;

        ll q;
        cin >> q;

        while (q--) {
            ll k;
            cin >> k;

            if (k % 2 == 0) {
                for (ll i = 1; i <= k + 2; ++i) {
                    if (i % 2 == 1) {
                        cout << i / 2 + 1 << ' ';
                    }
                    else {
                        cout << k / 2 + 1 + (i / 2) << ' ';
                    }
                }

                for (ll i = k + 3; i <= n; ++i) {
                    cout << i << ' ';
                }
                cout << endl;
            }
            else {
                for (ll i = 1; i <= k + 1; ++i) {
                    if (i % 2 == 1) {
                        cout << k / 2 + 2 + (i / 2) << ' ';
                    }
                    else {
                        cout << i / 2 << ' ';
                    }
                }
                for (ll i = k + 2; i <= n; ++i) {
                    cout << i << ' ';
                }
                cout << endl;
            }
        }
    }
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
