#include <bits/extc++.h>

using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ordered_set = tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update>;
std::mt19937 rnd(12307231);

#define ff first
#define ss second
#define int ll

struct point {
    int x, y;

    point operator-(const point p) {
        return {x - p.x, y - p.y};
    }
};

ll dot_pr(const point v, const point u) {
    return v.x * u.x + v.y * u.y;
}

ll dist(const point u, const point v) {
    return (u.x - v.x) * ll(u.x - v.x) + (u.y - v.y) * ll(u.y - v.y);
}

double RND() {
    return rnd() / INT32_MAX;
}

void solve() {
    int task = 1, g = 0;
    std::cin >> task >> g;
    int n = 5;
    std::cin >> n;
    if (task == 1) {
        std::vector<point>a(n);
        for (int i = 0; i < n; ++i) std::cin >> a[i].x >> a[i].y;
        int cur = 0;
        std::cout << cur + 1 << ' ';
        std::vector<int>used(n);
        used[cur] = 1;
        for (int i = 0; i < n - 1; ++i) {
            int can = cur;
            for (int j = 0; j < n; ++j) {
                if (used[j]) continue;
                if (dist(a[can], a[cur]) < dist(a[j], a[cur])) {
                    can = j;
                }
            }
            used[can] = 1;
            std::cout << can + 1 << ' ';
            cur = can;
        }
        std::cout << '\n';
        return;

    } else if (task == 2) {
        double t = 1;
        std::vector<int>p(n);
        std::iota(p.begin(), p.end(), 0);
        int val = 0;
        std::random_shuffle(p.begin(), p.end());
        std::vector<point>a(n);
        for (int i = 0; i < n; ++i) std::cin >> a[i].x >> a[i].y;
        int c; std::cin >> c;
        auto check = [&](int i) {
            if (i == 0 || i == n - 1) return false;
            point v1 = a[p[i - 1]] - a[p[i]],
                    v2 = a[p[i + 1]] = a[p[i]];
            return dot_pr(v1, v2) < 0;
        };
        for (int i = 1; i < n - 1; ++i) {
            val += check(i);
        }
//        std::cout << val << '\n';
        while (val > c && t > 0.0000001) {
            t *= 0.999999;
            int p1 = rnd() % n, p2 = rnd() % n;
            int new_val = val - check(p1) - check(p2);
            std::swap(p[p1], p[p2]);
            new_val += check(p1) + check(p2);
            if (new_val <= val) { //  || RND() < exp((val - new_val) / t)
                val = new_val;
            } else {
                std::swap(p[p1], p[p2]);
            }
        }
        for (const auto &item: p) std::cout << item + 1 << ' ';
    }
//    exit(1);
}

int32_t main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int T = 1;
//    std::cin >> T;
    while(T--) {
        solve();
    }

    return 0;
}