//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e9;

// geometry

using ll = long long;
using ld = long double;
using pt = pair<int, int>;
#define x first
#define y second
const ld pi = acos(-1);

ll vect(pt a, pt b) {
    return (ll) a.x * b.y - (ll) a.y * b.x;
}

ll scal(pt a, pt b) {
    return (ll) a.x * b.x + (ll) a.y * b.y;
}

pt sub(pt &a, pt &b) {
    return {a.x - b.x, a.y - b.y};
}

pt add(pt &a, pt &b) {
    return {a.x + b.x, a.y + b.y};
}

ld angle(pt &a, pt &b, pt &c) { // abc
    return atan2(vect(sub(a, b), sub(c, b)), scal(sub(a, b), sub(c, b)));
}

bool ost(pt &a, pt &b, pt &c) {
    return abs(angle(a, b, c)) * 2 < pi;
}

mt19937 rnd(1337);

void solve() {
    int task, group, n;
    cin >> task >> group >> n;
    vector<pt> p(n);
    for (auto &i: p)
        cin >> i.x >> i.y;
    if (task == 1) {
        int res = -1;
        vector<int> ans = {};
        while (clock() <= 1.9 * CLOCKS_PER_SEC) {
            vector<int> ord(n);
            iota(all(ord), 0);
            int now = 0;
            for (int i = 0; i < n - 2; ++i)
                now += ost(p[ord[i]], p[ord[i + 1]], p[ord[i + 2]]);
            for (int _ = 0; _ < 1e5; ++_) {
                int a = rnd() % (n - 1), b = rnd() % (n - 1);
                int next = now;
                if (a < n - 2)
                    next -= ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                if (a < n - 1 && a > 0)
                    next -= ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                if (a > 1)
                    next -= ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                if (b < n - 2)
                    next -= ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                if (b < n - 1 && b > 0)
                    next -= ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                if (b > 1)
                    next -= ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                swap(ord[a], ord[b]);
                if (a < n - 2)
                    next += ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                if (a < n - 1 && a > 0)
                    next += ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                if (a > 1)
                    next += ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                if (b < n - 2)
                    next += ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                if (b < n - 1 && b > 0)
                    next += ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                if (b > 1)
                    next += ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                if (next < now) {
                    swap(ord[a], ord[b]);
                } else {
                    now = next;
                }
            }
            if (now >= res) {
                res = now;
                ans = ord;
            }
        }
        for (int i: ans)
            cout << i + 1 << ' ';
        cout << endl;
    }
    if (task == 2) {
        int c;
        cin >> c;
        while (true) {
            vector<int> ord(n);
            iota(all(ord), 0);
            int now = 0;
            for (int i = 0; i < n - 2; ++i)
                now += ost(p[ord[i]], p[ord[i + 1]], p[ord[i + 2]]);
            for (int _ = 0; _ < 1e5; ++_) {
                int a = rnd() % (n - 1), b = rnd() % (n - 1);
                int next = now;
                if (a < n - 2)
                    next -= ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                if (a < n - 1 && a > 0)
                    next -= ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                if (a > 1)
                    next -= ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                if (b < n - 2)
                    next -= ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                if (b < n - 1 && b > 0)
                    next -= ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                if (b > 1)
                    next -= ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                swap(ord[a], ord[b]);
                if (a < n - 2)
                    next += ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                if (a < n - 1 && a > 0)
                    next += ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                if (a > 1)
                    next += ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                if (b < n - 2)
                    next += ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                if (b < n - 1 && b > 0)
                    next += ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                if (b > 1)
                    next += ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                if (next > now) {
                    swap(ord[a], ord[b]);
                } else {
                    now = next;
                }
            }
            if (now <= c) {
                for (int i: ord)
                    cout << i + 1 << ' ';
                cout << endl;
                return;
            }
        }
    }
    if (task == 3) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            while (true) {
                vector<int> ord(n);
                iota(all(ord), 0);
                int now = 0;
                for (int i = 0; i < n - 2; ++i)
                    now += ost(p[ord[i]], p[ord[i + 1]], p[ord[i + 2]]);
                for (int _ = 0; _ < n * 2; ++_) {
                    int a = rnd() % (n - 1), b = rnd() % (n - 1);
                    int next = now;
                    if (a < n - 2)
                        next -= ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                    if (a < n - 1 && a > 0)
                        next -= ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                    if (a > 1)
                        next -= ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                    if (b < n - 2)
                        next -= ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                    if (b < n - 1 && b > 0)
                        next -= ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                    if (b > 1)
                        next -= ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                    swap(ord[a], ord[b]);
                    if (a < n - 2)
                        next += ost(p[ord[a]], p[ord[a + 1]], p[ord[a + 2]]);
                    if (a < n - 1 && a > 0)
                        next += ost(p[ord[a - 1]], p[ord[a]], p[ord[a + 1]]);
                    if (a > 1)
                        next += ost(p[ord[a - 2]], p[ord[a - 1]], p[ord[a]]);
                    if (b < n - 2)
                        next += ost(p[ord[b]], p[ord[b + 1]], p[ord[b + 2]]);
                    if (b < n - 1 && b > 0)
                        next += ost(p[ord[b - 1]], p[ord[b]], p[ord[b + 1]]);
                    if (b > 1)
                        next += ost(p[ord[b - 2]], p[ord[b - 1]], p[ord[b]]);
                    if (abs(next - k) > abs(now - k)) {
                        swap(ord[a], ord[b]);
                    } else {
                        now = next;
                    }
                }
                if (now == k) {
                    for (int i: ord)
                        cout << i + 1 << ' ';
                    cout << endl;
                    break;
                }
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
