#include <iostream>
#include <vector>

using namespace std;

struct pt{
    long long x, y;
    pt() {}
    pt(long long x, long long y) : x(x), y(y) {}
};

pt operator-(pt a, pt b) {return pt(a.x - b.x, a.y - b.y);}
long long operator*(pt a, pt b) {return a.x * b.x + a.y * b.y;}

vector<pt> v;

vector<int> ans;
int res = 0;

void check(vector<int> &cur) {
    int cnt = 0;
    for (int i = 1; i < cur.size() - 1; i++) {
        if ((v[cur[i - 1]] - v[cur[i]]) * (v[cur[i + 1]] - v[cur[i]]) > 0) {
            cnt++;
        }
    }
    if (cnt > res) {
        res = cnt;
        ans = cur;
    }
}

void rec(vector<int> &cur, vector<bool> &used, int n) {
    if (cur.size() == n) {
        check(cur);
        return;
    }
    for (int i = 0; i < used.size(); i++) {
        if (!used[i]) {
            used[i] = true;
            cur.push_back(i);
            rec(cur, used, n);
            cur.pop_back();
            used[i] = false;
        }
    }
}

void sol1() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
    }
    int c1 = 1, c2 = n;
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) {
            cout << c1++;
        } else {
            cout << c2--;
        }
        cout << " ";
    }
    cout << endl;
    exit(0);
}

void sol7() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;
        int c1 = 1, c2 = n;
        for (int j = 0; j < k; j++) {
            if (j % 2 == 0) {
                cout << c1++ << " ";
            } else {
                cout << c2-- << " ";
            }
        }
        if (k % 2 == 1) {
            for (; c2 >= c1; c2--) {
                cout << c2 << " ";
            } cout << endl;
        } else {
            for (; c1 <= c2; c1++) {
                cout << c1 << " ";
            } cout << endl;
        }

    }
    exit(0);
}

int main()
{
    int task, group;
    cin >> task >> group;
    if (group == 1) {
        sol1();
    } else if (group == 7) {
        sol7();
    }
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        v[i] = pt(a, b);
    }
    vector<int> cur;
    vector<bool> used(n, false);
    rec(cur, used, n);
    for (auto i : ans) {
        cout << i + 1 << " ";
    } cout << endl;


}
