#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
const int INF = 2e9;
const int mod = 1e9 + 7;

struct Point {
    ll x, y;
    Point() {}
    Point(ll _x, ll _y) {
        x = _x;
        y = _y;
    }
    Point operator+(const Point& p) const {
        return Point(x + p.x, y + p.y);
    }
    Point operator-(const Point& p) const {
        return Point(x - p.x, y - p.y);
    }
    ll operator*(const Point& p) const {
        return x * p.y - y * p.x;
    }
    ll operator%(const Point& p) const {
        return x * p.x + y * p.y;
    }
};

vector<Point> p(N);

ll dist(Point& a, Point& b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll task, group, n;
    cin >> task >> group >> n;
    for (ll i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    /*if (task == 1) {
        vector<ll> used(n);
        vector<ll> order;
        order.push_back(0);
        ll i = 0;
        used[0] = 1;
        while (order.size() < n) {
            ll ans = 0, mx = 0;
            for (ll j = 0; j < n; j++) {
                if (used[j] == 0 && dist(p[i], p[j]) > mx) {
                    ans = j;
                    mx = dist(p[i], p[j]);
                }
            }
            used[ans] = 1;
            order.push_back(ans);
            i = ans;
        }
        for (int a : order) {
            cout << a + 1 << ' ';
        }
        cout << endl;
    }
    else*/ if (task == 2) {
        int c;
        cin >> c;
        vector<ll> order;
        order.push_back(0);
        order.push_back(1);
        ll i1 = 0, i2 = 1;
        unordered_set<int> s;
        for (int i = 2; i < n; i++) {
            s.insert(i);
        }
        while (order.size() < n) {
            ll ans = -1;
            int cnt = 0;
            for (int j : s) {
                cnt++;
                if (cnt > 1e4) {
                    break;
                }
                if ((p[i2] - p[i1]) % (p[j] - p[i2]) > 0) {
                    ans = j;
                    break;
                }
                else if (ans == -1) {
                    ans = j;
                }
            }
            s.erase(ans);
            order.push_back(ans);
            i1 = i2;
            i2 = ans;
        }
        for (int a : order) {
            cout << a + 1 << ' ';
        }
        cout << endl;
    }

}
