#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair<int, int>;

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

struct Vec {
    int x{}, y{};

    Vec() = default;
    Vec(int x, int y) : x(x), y(y) { }
    Vec(Vec a, Vec b) : x(b.x - a.x), y(b.y - a.y) { }
};

long long cross(Vec a, Vec b) {
    return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

long long dot(Vec a, Vec b) {
    return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

double angle(Vec a, Vec b) {
    return atan2(cross(a, b), dot(a, b));
}

struct Task1 {
    void group1(int n, const vector <Vec>& v) {
        int flag = 0;
        int i = 0, j = n - 1;
        while (i <= j) {
            if (!flag) {
                cout << i + 1 << " ";
                ++i;
            } else {
                cout << j + 1 << " ";
                --j;
            }
            flag ^= 1;
        }
        cout << endl;
    }

    void group2(int n, const vector <Vec>& v) {
        vector <int> p(n);
        iota(all(p), 0);
        int bst = -1;
        vector <int> bp;
        do {
            int res = 0;
            for (int i = 1; i + 1 < n; ++i) {
                Vec a(v[p[i]], v[p[i - 1]]);
                Vec b(v[p[i]], v[p[i + 1]]);
                if (abs(angle(a, b)) < M_PI / 2) {
                    ++res;
                }
            }
            if (res > bst) {
                bp = p;
                bst = res;
            }
        } while (next_permutation(all(p)));
        for (auto i : bp) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }

    Task1() {
        int group;
        cin >> group;
        int n;
        cin >> n;
        vector <Vec> v(n);
        for (auto& [x, y] : v) {
            cin >> x >> y;
        }
        if (group == 1) {
            group1(n, v);
        } else {
            group2(n, v);
        }
    }
};



signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
//    cout << angle({0, 1}, {1, 0});
    int task;
    cin >> task;
    if (task == 1) {
        Task1();
    }
}