#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair<int, int>;

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

struct Vec {
    int x{}, y{};

    Vec() = default;
    Vec(int x, int y) : x(x), y(y) { }
    Vec(Vec a, Vec b) : x(b.x - a.x), y(b.y - a.y) { }
};

long long cross(Vec a, Vec b) {
    return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

long long dot(Vec a, Vec b) {
    return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

double angle(Vec a, Vec b) {
    return atan2(cross(a, b), dot(a, b));
}

long long lensq(Vec a) {
    return dot(a, a);
}

long long dstsq(Vec a, Vec b) {
    return lensq(Vec(a, b));
}

struct Task1 {
    void group1(int n, const vector <Vec>& v) {
        int flag = 0;
        int i = 0, j = n - 1;
        while (i <= j) {
            if (!flag) {
                cout << i + 1 << " ";
                ++i;
            } else {
                cout << j + 1 << " ";
                --j;
            }
            flag ^= 1;
        }
        cout << endl;
    }

    void group2(int n, const vector <Vec>& v) {
        vector <int> p(n);
        iota(all(p), 0);
        int bst = -1;
        vector <int> bp;
        do {
            int res = 0;
            for (int i = 1; i + 1 < n; ++i) {
                Vec a(v[p[i]], v[p[i - 1]]);
                Vec b(v[p[i]], v[p[i + 1]]);
                if (abs(angle(a, b)) < M_PI / 2) {
                    ++res;
                }
            }
            if (res > bst) {
                bp = p;
                bst = res;
            }
        } while (next_permutation(all(p)));
        for (auto i : bp) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }

    void group3(int n, const vector <Vec>& v) {
        vector <bool> used(n);
        int bsti = 0;
        long long mxl = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mxl < dstsq(v[i], v[j])) {
                    bsti = i;
                }
                mxr(mxl, dstsq(v[i], v[j]));
            }
        }
        vector <int> ord;
        int cur = bsti;
        ord.push_back(cur);
        used[cur] = true;
        for (int i = 1; i < n; ++i) {
            long long mx = 0;
            int bst = 0;
            for (int j = 0; j < n; ++j) {
                if (!used[j]) {
                    if (mx < dstsq(v[cur], v[j])) {
                        bst = j;
                        mx = dstsq(v[cur], v[j]);
                    }
                }
            }
            used[bst] = true;
            ord.push_back(bst);
            cur = bst;
        }
        for (auto i : ord) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }

    Task1() {
        int group;
        cin >> group;
        int n;
        cin >> n;
        vector <Vec> v(n);
        for (auto& [x, y] : v) {
            cin >> x >> y;
        }
        if (group == 1) {
            group1(n, v);
        } else if (group == 2) {
            group2(n, v);
        } else {
            group3(n, v);
        }
    }
};

double rnd01() {
    return rand() * 1. / RAND_MAX;
}

struct Task2 {
    int calc(const vector <Vec>& v, const vector <int>& p) {
        int res = 0;
        for (int i = 1; i + 1 < sz(v); ++i) {
            Vec a(v[p[i]], v[p[i - 1]]);
            Vec b(v[p[i]], v[p[i + 1]]);
            if (abs(angle(a, b)) < M_PI / 2) {
                ++res;
            }
        }
        return res;
    }

    int check(Vec a, Vec b, Vec c) {
        Vec f(b, a);
        Vec s(b, c);
        return abs(angle(f, s)) < M_PI / 2;
    }

    void solve(int n, const vector <Vec>& v, int c) {
        double t = 1;
        vector <int> p(n);
        iota(all(p), 0ll);
        mt19937 rnd(228);
        shuffle(all(p), rnd);
        int ans = calc(v, p);
        vector <int> ostr(n);
        for (int i = 1; i + 1 < n; ++i) {
            ostr[i] = check(v[p[i - 1]], v[p[i]], v[p[i + 1]]);
        }
        auto recalc = [&](int i) {
            if (ostr[i]) {
                --ans;
            }
            ostr[i] = check(v[p[i - 1]], v[p[i]], v[p[i + 1]]);
            if (ostr[i]) {
                ++ans;
            }
        };
        vector <int> bstp = p;
        int bstans = ans;
        for (int iter = 0; iter < 1000000; ++iter) {
            if (ans <= c) {
                bstans = ans;
                bstp = p;
                break;
            }
            t *= 0.999;
            int ans0 = ans;
            int a = rnd() % n;
            int b = rnd() % n;
            swap(p[a], p[b]);
            for (int i = max(1, a - 1); i < min(n - 1, a + 2); ++i) {
                recalc(i);
            }
            for (int i = max(1, b - 1); i < min(n - 1, b + 2); ++i) {
                recalc(i);
            }
            if (ans0 >= ans || exp((ans0 - ans) / t) < rnd01()) {
                continue;
            }
            swap(p[a], p[b]);
            for (int i = max(1, a - 1); i < min(n - 1, a + 2); ++i) {
                recalc(i);
            }
            for (int i = max(1, b - 1); i < min(n - 1, b + 2); ++i) {
                recalc(i);
            }
        }
        cerr << ans;
        for (auto i : bstp) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }

    Task2() {
        int group;
        cin >> group;
        int n;
        cin >> n;
        vector <Vec> v(n);
        for (auto& [x, y] : v) {
            cin >> x >> y;
        }
        int c;
        cin >> c;
        solve(n, v, c);
    }
};



signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
//    srand(time(nullptr));
//    cout << angle({0, 1}, {1, 0});
    int task;
    cin >> task;
    if (task == 2) {
        Task2();
    }
//    if (task == 1) {
//        Task1();
//    } else {
//        Task2();
//    }
}