#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int BRUNS = 2000;
const int RUNS = 5;

struct Point {
    int x = 0, y = 0;

    Point()=default;
    Point(int x, int y) : x(x), y(y) {}
};

istream& operator>>(istream& in, Point& a) {
    in >> a.x >> a.y;
    return in;
}

ostream& operator<<(ostream& out, const Point& a) {
    out << a.x << " " << a.y;
    return out;
}

Point operator+(const Point& a, const Point& b) {
    return {a.x + b.x, a.y + b.y};
}

Point operator-(const Point& a, const Point& b) {
    return {a.x - b.x, a.y - b.y};
}

int scal(const Point& a, const Point& b) {
    return a.x * b.x + a.y * b.y;
}

bool ang(const Point& a, const Point& b) {
    return scal(a, b) > 0;
}

int rate(const vector<Point>& a, const vector<int>& p) {
    int n = a.size();
    int ans = 0;
    for (int i = 1; i < n - 1; ++i)
        if (ang(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]))
            ++ans;
    return ans;
}

vector<int> burn_max(const vector<Point>& a) {
    int n = a.size();

    vector<int> p(n);
    iota(all(p), 0);
    shuffle(all(p), default_random_engine(4311));

    ld temp = 1;
    vector<int> optp = p;
    int opt = rate(a, p);

    for (int i = 0; i < BRUNS; ++i) {
        auto q = p;
        int it = rand() % (n - 1);
        swap(q[it], q[it + 1]);

        int cur = rate(a, p), to = rate(a, q);
        if (cur < to || exp(-abs(to - cur) / temp) > (ld) rand() / RAND_MAX)
            p = q;

        int tmp = rate(a, p);
        if (tmp > opt) {
            opt = tmp;
            optp = p;
        }
    }

    return optp;
}

vector<int> burn_min(const vector<Point>& a) {
    int n = a.size();

    vector<int> p(n);
    iota(all(p), 0);
    shuffle(all(p), default_random_engine(4311));

    ld temp = 1;
    vector<int> optp = p;
    int opt = rate(a, p);

    for (int i = 0; i < BRUNS; ++i) {
        auto q = p;
        int it = rand() % (n - 1);
        swap(q[it], q[it + 1]);

        int cur = rate(a, p), to = rate(a, q);
        if (cur > to || exp(-abs(to - cur) / temp) > (ld) rand() / RAND_MAX)
            p = q;

        int tmp = rate(a, p);
        if (tmp < opt) {
            opt = tmp;
            optp = p;
        }
    }

    return optp;
}

void solve1() {
    int n;
    cin >> n;
    vector<Point> a(n);
    for (auto& i : a)
        cin >> i;

    vector<int> ans(n);
    iota(all(ans), 0);
    for (int i = 0; i < RUNS; ++i) {
        auto p = burn_max(a);

        if (rate(a, ans) < rate(a, p))
            ans = p;
    }

    for (auto i : ans)
        cout << i + 1 << " ";
    cout << endl;
}

void solve2() {
    int n;
    cin >> n;
    vector<Point> a(n);
    for (auto& i : a)
        cin >> i;
    int c;
    cin >> c;

    vector<int> ans(n);
    iota(all(ans), 0);
    for (int i = 0; i < RUNS; ++i) {
        auto p = burn_min(a);

        if (rate(a, ans) > rate(a, p))
            ans = p;
    }

    for (auto i : ans)
        cout << i + 1 << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t, g;
    cin >> t >> g;
    if (t == 1)
        solve1();
    else if (t == 2)
        solve2();
}