#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw, id;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;

    vector<pair<int,int>> a(n);
    for (int i = 0; i < n; ++i) {
        int u, v;
        cin >> u >> v;

        a[i] = {u, v};
    }

    if (group == 1) {
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                cout << 1 + i / 2 << " ";
            } else {
                cout << n - i / 2 << " ";
            }
        }
    } else {
        vector<int> pts(n);
        std::iota(pts.begin(), pts.end(), 0);
        vector<int> best;
        int bestcnt = -1;
        do {
            int cnt = 0;
            for (int i = 0; i < n - 2; ++i) {
                pair<int,int> v1 = {a[pts[i + 1]].first - a[pts[i]].first, a[pts[i + 1]].second - a[pts[i]].second};
                pair<int,int> v2 = {a[pts[i + 2]].first - a[pts[i + 1]].first, a[pts[i + 2]].second - a[pts[i + 1]].second};

                if (v1.first * v2.first + v1.second * v2.second <= 0){
                    cnt++;
                }
            }
            if (cnt > bestcnt) {
                best = pts;
                bestcnt = cnt;
            }
        } while (std::next_permutation(pts.begin(), pts.end()));

        for (int i = 0; i < n; ++i) {
            cout << best[i] + 1 << " ";
        }
    }
}