#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i] + 1;
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

struct Vector {
    int x = 0, y = 0;
    Vector() {}
    Vector(int x, int y) : x(x), y(y) {}

    friend istream &operator>>(istream &in, Vector &a) {
        return in >> a.x >> a.y;
    }

    friend Vector operator-(Vector a, Vector b) {
        return {a.x - b.x, a.y - b.y};
    }

    friend Vector operator+(Vector a, Vector b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend ll operator*(Vector a, Vector b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ll operator%(Vector a, Vector b) {
        return a.x * b.y - a.y * b.x;
    }
};

mt19937 rnd(123);

ld rng() {
    return (ld) rnd() / LLONG_MAX;
}

ll is_ost(Vector a, Vector b, Vector c) {
    return (a - b) * (c - b) > 0;
}

void anneal(int n, vector<Vector> a) {
    int c;
    cin >> c;
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    for (int i = 0; i < n; ++i) {
        swap(p[i], p[rnd() % (i + 1)]);
    }
    ll now = 0;
    for (int i = 1; i < n - 1; ++i) {
        if (is_ost(a[p[i - 1]], a[p[i]], a[p[i + 1]])) {
            now++;
        }
    }
    ld t = 5000;
    while (now > c) {
        ll i = rnd() % n, j = rnd() % (n - 1);
        if (j >= i) {
            ++j;
        }
        ll nw = now;
        for (int k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                nw -= is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]]);
            }
        }
        for (int k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                nw -= is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]]);
            }
        }
        swap(p[i], p[j]);
        for (int k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                nw += is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]]);
            }
        }
        for (int k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                nw += is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]]);
            }
        }
        if (nw < now || (nw >= now && rng() < exp((ld (now - nw)) / t))) {
            now = nw;
        } else {
            swap(p[i], p[j]);
        }
        t *= 0.99;
    }
    cout << p;
#ifdef LOCAL
    cout << ' ' << now << "\nOK";
#endif
}

void solve1() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int i, int j) {
        return a[i].x < a[j].x;
    });
    for (int i = 1; i + 1 < n; ++i) {
        swap(p[i], p[i + 1]);
    }
    ll cnt = 0;
    for (int i = 1; i < n - 1; ++i) {
        if ((a[p[i]] - a[p[i - 1]]) * (a[p[i + 1]] - a[p[i]]) > 0) {
            cnt++;
        }
    }
    vector<ll> p1(n);
    iota(p1.begin(), p1.end(), 0);
    sort(p1.begin(), p1.end(), [&](int i, int j) {
        return a[i].y < a[j].y;
    });
    for (int i = 1; i + 1 < n; ++i) {
        swap(p1[i], p1[i + 1]);
    }
    ll cnt1 = 0;
    for (int i = 1; i < n - 1; ++i) {
        if ((a[p1[i]] - a[p1[i - 1]]) * (a[p1[i + 1]] - a[p1[i]]) > 0) {
            cnt1++;
        }
    }
    if (cnt > cnt1) {
        cout << p;
    } else {
        cout << p1;
    }
}

void solve2() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;
    anneal(n, a);
}

void solve3() {

}

void solve4() {

}

void solve() {
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        solve1();
    } else if (task == 2) {
        solve2();
    } else if (task == 3) {
        solve3();
    } else {
        solve4();
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
