#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = a.size();
    for (ll i = 0; i < n; ++i) {
        out << a[i] + 1;
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (ll i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

struct Vector {
    ll x = 0, y = 0;
    Vector() {}
    Vector(ll x, ll y) : x(x), y(y) {}

    friend istream &operator>>(istream &in, Vector &a) {
        return in >> a.x >> a.y;
    }

    friend Vector operator-(Vector a, Vector b) {
        return {a.x - b.x, a.y - b.y};
    }

    friend Vector operator+(Vector a, Vector b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend ll operator*(Vector a, Vector b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ll operator%(Vector a, Vector b) {
        return a.x * b.y - a.y * b.x;
    }

    const bool operator<(const Vector b) const {
        return x < b.x || (x == b.x && y < b.y);
    }
};

mt19937 rnd(123);

ld rng() {
    return ((ld) rnd()) / LLONG_MAX;
}

ll is_ost(Vector a, Vector b, Vector c) {
    return (a - b) * (c - b) > 0;
}

void anneal(ll c, vector<Vector> &a) {
    ll n = sz(a);
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    for (ll i = 0; i < n; ++i) {
        swap(p[i], p[rnd() % (i + 1)]);
    }
    ll now = 0;
    for (ll i = 1; i < n - 1; ++i) {
        if (is_ost(a[p[i - 1]], a[p[i]], a[p[i + 1]])) {
            now++;
        }
    }
    ld t = 5000;
    while (now > c) {
        ll i = rnd() % n, j = rnd() % (n - 1);
        if (j >= i) {
            ++j;
        }
        ll nw = now;
        set<ll> st;
        for (ll k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw--;
                    }
                }
            }
        }
        for (ll k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw--;
                    }
                }
            }
        }
        swap(p[i], p[j]);
        st.clear();
        for (ll k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw++;
                    }
                }
            }
        }
        for (ll k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw++;
                    }
                }
            }
        }
        if (nw < now || (nw >= now && rng() < exp(((ld) (now - nw)) / t))) {
            now = nw;
        } else {
            swap(p[i], p[j]);
        }
        t *= 0.9999;
        if (t < 0.000001) {
            t = 100;
        }
    }

    now = 0;
    for (ll i = 1; i < n - 1; ++i) {
        if (is_ost(a[p[i - 1]], a[p[i]], a[p[i + 1]])) {
            now++;
        }
    }
    assert(now <= c);
    for (ll i = 0; i < n; ++i) {
        cout << p[i] + 1 << ' ';
    }
    cout << endl;
}

void anneal1(vector<Vector> &a) {
    ll n = sz(a);
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    for (ll i = 0; i < n; ++i) {
        swap(p[i], p[rnd() % (i + 1)]);
    }
    ll now = 0;
    for (ll i = 1; i < n - 1; ++i) {
        if (is_ost(a[p[i - 1]], a[p[i]], a[p[i + 1]])) {
            now++;
        }
    }
    ld t = 5000;
    for (int www = 0; www < 1000000; ++www) {
        ll i = rnd() % n, j = rnd() % (n - 1);
        if (j >= i) {
            ++j;
        }
        ll nw = now;
        set<ll> st;
        for (ll k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw--;
                    }
                }
            }
        }
        for (ll k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw--;
                    }
                }
            }
        }
        swap(p[i], p[j]);
        st.clear();
        for (ll k = i - 2; k <= i; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw++;
                    }
                }
            }
        }
        for (ll k = j - 2; k <= j; ++k) {
            if (k + 2 < n && k >= 0) {
                if (is_ost(a[p[k]], a[p[k + 1]], a[p[k + 2]])) {
                    if (!st.count(p[k + 1])) {
                        st.insert(p[k + 1]);
                        nw++;
                    }
                }
            }
        }
        if (nw > now || (nw <= now && rng() < exp(((ld) (nw - now)) / t))) {
            now = nw;
        } else {
            swap(p[i], p[j]);
        }
        t *= 0.9999;
        if (t < 0.00001) {
            t = 50;
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << p[i] + 1 << ' ';
    }
    cout << endl;
    exit(0);
}

void solve1(ll n) {
    vector<Vector> a(n);
    cin >> a;
    bool flag = true;
    for (int i = 1; i < n; ++i) {
        if (a[i].x < a[i - 1].x || a[i].y < a[i - 1].y) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        anneal1(a);
        return;
    }
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](ll i, ll j) {
        return a[i].x < a[j].x;
    });
    for (ll i = 1; i + 1 < n; i += 2) {
        swap(p[i], p[i + 1]);
    }
    ll cnt = 0;
    for (ll i = 1; i < n - 1; ++i) {
        if ((a[p[i]] - a[p[i - 1]]) * (a[p[i + 1]] - a[p[i]]) > 0) {
            cnt++;
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << p[i] + 1 << ' ';
    }
    cout << endl;
}

void solve11(ll n) {
    vector<Vector> a(n);
    cin >> a;
    vector<ll> p(n);
    iota(p.begin(), p.end(), 0);
    ll cnt = 0;
    vector<ll> ans;
    do {
        ll cnt1 = 0;
        for (ll i = 1; i < n - 1; ++i) {
            if (is_ost(a[p[i - 1]], a[p[i]], a[p[i + 1]])) {
                cnt1++;
            }
        }
        if (cnt1 > cnt) {
            ans = p;
            cnt = cnt1;
        }
    } while (next_permutation(p.begin(), p.end()));
    for (ll i = 0; i < n; ++i) {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}

void solve2() {
    ll n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;
    ll c;
    cin >> c;
    anneal(c, a);
}

void solve3() {
    ll n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;
    bool flag = true;
    for (int i = 1; i < n; ++i) {
        if (a[i].x < a[i - 1].x || a[i].y < a[i - 1].y) {
            flag = false;
            break;
        }
    }
    ll c, q;
    cin >> c >> q;
    vector<ll> qs(q);
    cin >> qs;
    if (flag) {
        for (int i = 0; i < q; ++i) {
            for (int j = 1; j <= n; ++j) {
                cout << j << ' ';
            }
            cout << endl;
        }
        return;
    }
    for (int i = 0; i < q; ++i) {
        anneal(qs[i], a);
    }
}

void solve4() {

}

void solve() {
    ll task, group;
    cin >> task >> group;
    if (task == 1) {
        ll n;
        cin >> n;
        if (n <= 10) {
            solve11(n);
        } else {
            solve1(n);
        }
    } else if (task == 2) {
        solve2();
    } else if (task == 3) {
        solve3();
    } else {
        solve4();
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
