#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

ll x[MAXN], y[MAXN];

ll f(vector<ll> &p) {
    ll n = (ll)p.size();
    ll win = 0;
    for (ll i = 0; i < n - 2; ++i) {
        ll x1 = x[p[i]] - x[p[i + 1]], y1 = y[p[i]] - y[p[i + 1]];
        ll x2 = x[p[i + 2]] - x[p[i + 1]], y2 = y[p[i + 2]] - y[p[i + 1]];
        ll sum = x1 * x2 + y1 * y2;
        win += (sum > 0);
    }
    return win;
}

mt19937 rnd(1337);

void solve() {
    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    if (group == 1) {
        for (int i = 0; i < n; ++i) {
            cout << i + 1 << ' ';
        }
        cout << endl;
        return;
    }
    ll ans = -1;
    vector<ll> bestans;
    for (ll test = 0; test < 10; ++test) {
        ld t = 1;
        vector<ll> cur(n);
        for (ll i = 0; i < n; ++i) {
            cur[i] = i;
        }
        shuffle(cur.begin(), cur.end(), rnd);
        ll curans = f(cur);
        for (ll step = 0; step < 10000; ++step) {
            t *= 0.99;
            ll i = rnd() % n, j = rnd() % n;
            swap(cur[i], cur[j]);
            ll newans = f(cur);
            if (newans > curans || rand() / RAND_MAX > exp((newans - curans) / t)) {
                curans = newans;
            } else {
                swap(cur[i], cur[j]);
            }
        }
        if (ans < curans) {
            ans = curans;
            bestans = cur;
        }
    }
    for (ll i : bestans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
