#include <bits/stdc++.h>

using namespace std;

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }
};

bool operator<(const Vec a, const Vec b) {
    return a.x < b.x;
}

bool operator>(const Vec a, const Vec b) {
    return a.x > b.x;
}

bool is_sharp(Vec a, Vec b) {
    return a * b > 0;
}

int get_cnt(vector<Vec> ord) {
    int ans = 0;
    for (int i = 1; i + 1 < (int)ord.size(); ++i) {
        if (is_sharp(ord[i - 1] - ord[i], ord[i + 1] - ord[i])) {
            ans++;
        }
    }
    return ans;
}

pair<int, vector<Vec>> get_mn_sharp(vector<Vec> ord) {
    return make_pair(get_cnt(ord), ord);
}

pair<int, vector<Vec>> get_mx_sharp(vector<Vec> ord) {
    vector<Vec> ord_nw;
    for (int i = 0; i < (int)ord.size(); ++i) {
        if (i % 2 == 0) {
            ord_nw.push_back(ord[i / 2]);
        } else {
            ord_nw.push_back(ord[(int)ord.size() - 1 - i / 2]);
        }
    }
    return make_pair(get_cnt(ord_nw), ord_nw);
}

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Vec> a(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        mp[make_pair(a[i].x, a[i].y)] = i;
    }
    if (task == 1) {
        auto ans = get_mx_sharp(a);
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.x < y.x;
        });
        ans = max(ans, get_mx_sharp(a));
        reverse(a.begin(), a.end());
        ans = max(ans, get_mx_sharp(a));
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.y < y.y;
        });
        ans = max(ans, get_mx_sharp(a));
        reverse(a.begin(), a.end());
        ans = max(ans, get_mx_sharp(a));
        for (int i = 0; i < n; ++i) {
            cout << mp[make_pair(ans.second[i].x, ans.second[i].y)] + 1 << ' ';
        }
        cout << endl;
    } else {
        int c;
        cin >> c;
        auto ans = get_mn_sharp(a);
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.x < y.x;
        });
        ans = min(ans, get_mn_sharp(a));
        reverse(a.begin(), a.end());
        ans = min(ans, get_mn_sharp(a));
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.y < y.y;
        });
        ans = min(ans, get_mn_sharp(a));
        reverse(a.begin(), a.end());
        ans = min(ans, get_mn_sharp(a));
        for (int i = 0; i < n; ++i) {
            cout << mp[make_pair(ans.second[i].x, ans.second[i].y)] + 1 << ' ';
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
