#include <bits/stdc++.h>

using namespace std;

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }
};

bool operator<(const Vec a, const Vec b) {
    return a.x < b.x;
}

bool operator>(const Vec a, const Vec b) {
    return a.x > b.x;
}

bool is_sharp(Vec a, Vec b) {
    return a * b > 0;
}

int get_cnt(vector<Vec> ord) {
    int ans = 0;
    for (int i = 1; i + 1 < (int)ord.size(); ++i) {
        if (is_sharp(ord[i - 1] - ord[i], ord[i + 1] - ord[i])) {
            ans++;
        }
    }
    return ans;
}

pair<int, vector<Vec>> get_mn_sharp(vector<Vec> ord) {
    return make_pair(get_cnt(ord), ord);
}

pair<int, vector<Vec>> get_mx_sharp(vector<Vec> ord) {
    vector<Vec> ord_nw;
    for (int i = 0; i < (int)ord.size(); ++i) {
        if (i % 2 == 0) {
            ord_nw.push_back(ord[i / 2]);
        } else {
            ord_nw.push_back(ord[(int)ord.size() - 1 - i / 2]);
        }
    }
    return make_pair(get_cnt(ord_nw), ord_nw);
}

void solve() {
    mt19937 rnd(57);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Vec> a(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        mp[make_pair(a[i].x, a[i].y)] = i;
    }
    shuffle(a.begin(), a.end(), rnd);
    if (task == 1) {
        auto ans = get_mx_sharp(a);
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.x < y.x;
        });
        ans = max(ans, get_mx_sharp(a));
        reverse(a.begin(), a.end());
        ans = max(ans, get_mx_sharp(a));
        sort(a.begin(), a.end(), [&](Vec x, Vec y) {
            return x.y < y.y;
        });
        ans = max(ans, get_mx_sharp(a));
        reverse(a.begin(), a.end());
        ans = max(ans, get_mx_sharp(a));
        long double tm = clock() / CLOCKS_PER_SEC;
        shuffle(a.begin(), a.end(), rnd);
        int nw = get_cnt(a);
        long double t = 1;
        auto sharp = [&](int ind) -> int {
            if (ind <= 0 || ind >= n - 1) {
                return 0;
            }
            if (is_sharp(a[ind - 1] - a[ind], a[ind + 1] - a[ind])) {
                return 1;
            }
            return 0;
        };
        while (true) {
            long double t_nw = clock() / CLOCKS_PER_SEC;
            if (t_nw - tm >= 1) {
                break;
            }
            t *= 0.99999;
            int ind1 = rnd() % n, ind2 = rnd() % n;
            if (ind1 == ind2) {
                continue;
            }
            int cnt_prv = nw;
            set<int> inds = {ind1 - 1, ind1, ind1 + 1, ind2 - 1, ind2, ind2 + 1};
            for (auto ind : inds) {
                nw -= sharp(ind);
            }
            swap(a[ind1], a[ind2]);
            for (auto ind : inds) {
                nw += sharp(ind);
            }
            if (nw < cnt_prv) {
                if (rnd() % 5757 >= t * 5757) {
                    swap(a[ind1], a[ind2]);
                    nw = cnt_prv;
                }
            }
            if (nw > ans.first) {
                ans = make_pair(nw, a);
            }
        }
        for (int i = 0; i < n; ++i) {
            cout << mp[make_pair(ans.second[i].x, ans.second[i].y)] + 1 << ' ';
        }
        cout << endl;
    } else if (task == 2) {
        int c;
        cin >> c;
        int nw = get_cnt(a);
        long double t = 1;
        auto sharp = [&](int ind) -> int {
            if (ind <= 0 || ind >= n - 1) {
                return 0;
            }
            if (is_sharp(a[ind - 1] - a[ind], a[ind + 1] - a[ind])) {
                return 1;
            }
            return 0;
        };
        while (nw > c) {
            t *= 0.99999;
            int ind1 = rnd() % n, ind2 = rnd() % n;
            if (ind1 == ind2) {
                continue;
            }
            int cnt_prv = nw;
            set<int> inds = {ind1 - 1, ind1, ind1 + 1, ind2 - 1, ind2, ind2 + 1};
            for (auto ind : inds) {
                nw -= sharp(ind);
            }
            swap(a[ind1], a[ind2]);
            for (auto ind : inds) {
                nw += sharp(ind);
            }
            if (nw > cnt_prv) {
                if (rnd() % 5757 >= t * 5757) {
                    swap(a[ind1], a[ind2]);
                    nw = cnt_prv;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            cout << mp[make_pair(a[i].x, a[i].y)] + 1 << ' ';
        }
        cout << endl;
    } else if (task == 3) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            int nw = get_cnt(a);
            long double t = 1;
            auto sharp = [&](int ind) -> int {
                if (ind <= 0 || ind >= n - 1) {
                    return 0;
                }
                if (is_sharp(a[ind - 1] - a[ind], a[ind + 1] - a[ind])) {
                    return 1;
                }
                return 0;
            };
            while (nw != k) {
                t *= 0.99999;
                int ind1 = rnd() % n, ind2 = rnd() % n;
                if (ind1 == ind2) {
                    continue;
                }
                int cnt_prv = nw;
                set<int> inds = {ind1 - 1, ind1, ind1 + 1, ind2 - 1, ind2, ind2 + 1};
                for (auto ind : inds) {
                    nw -= sharp(ind);
                }
                swap(a[ind1], a[ind2]);
                for (auto ind : inds) {
                    nw += sharp(ind);
                }
                if (abs(nw - k) > abs(cnt_prv - k)) {
                    if (rnd() % 5757 >= t * 5757) {
                        swap(a[ind1], a[ind2]);
                        nw = cnt_prv;
                    }
                }
            }
            for (int i = 0; i < n; ++i) {
                cout << mp[make_pair(a[i].x, a[i].y)] + 1 << ' ';
            }
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
