#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <iostream>
#include <cstdlib>
#include <cstdint>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

struct Point {
    ll x, y;
    Point() {}
    Point(ll x, ll y) : x(x), y(y) {}
    bool operator<(const Point& other) const {
        return x < other.x || (x == other.x && y < other.y);
    }
    Point operator+(const Point& other) const {
        return Point(x + other.x, y + other.y);
    }
    Point operator-() const {
        return Point(-x, -y);
    }
    Point operator-(const Point& other) const {
        return *this + (-other);
    }
    ll operator*(const Point& other) const {
        return x * other.x + y * other.y;
    }
    ll operator%(const Point& other) const {
        return x * other.y - other.x * y;
    }
};

Point V(const Point& a, const Point& b) {
    return b - a;
}

const int N = 80000;
vector<Point> pts;
int n;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int task, group;
    cin >> task >> group;
    cin >> n;
    pts.resize(n);
    bool ok1 = true;
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
        ok1 &= (i == 0 || pts[i - 1].x < pts[i].x && pts[i - 1].y < pts[i].y);
    }
    if (task == 1) {
        if (!ok1) {
            vector<int> cur(n);
            for (int i = 0; i < n; ++i) cur[i] = i;
            int best = 0;
            vector<int> best_c;
            do {
                int cnt = 0;
                for (int j = 1; j < n - 1; ++j) {
                    int i1 = cur[j - 1];
                    int i2 = cur[j];
                    int i3 = cur[j + 1];
                    if (V(pts[i1], pts[i2]) * V(pts[i2], pts[i3]) > 0) {
                        ++cnt;
                    }
                }
                if (cnt > best) {
                    best = cnt;
                    best_c = cur;
                }
            } while (next_permutation(all(cur)));
            for (int x : best_c) {
                cout << x + 1 << " ";
            }
            cout << endl;
            return 0;
        }
        for (int i = 0; i < n / 2; ++i) {
            cout << i + 1 << " " << n - i << " ";
        }
        if (n & 1) cout << n / 2;
        cout << endl;
    }
}
