#include "bits/stdc++.h"

using ll = long long;
using namespace std;

struct Point {
    int x = 0, y = 0;

    Point() = default;
    Point(int x, int y) : x(x), y(y) {}
    Point(const Point &A, const Point &B) {
        x = B.x - A.x;
        y = B.y - A.y;
    }

    ll operator*(const Point &other) const {
        return 1ll * x * other.x + 1ll * y * other.y;
    }

    ll operator%(const Point &other) const {
        return 1ll * x * other.y - 1ll * other.x * y;
    }

    friend istream& operator>>(istream &in, Point &other) {
        return in >> other.x >> other.y;
    }
};

namespace task1 {
    int x[20000];
    int y[20000];
    bool used[20000];
    int n;

    void read() {
        cin >> n;
        for (int i = 0; i < n; i++) {
            cin >> x[i] >> y[i];
        }
    }

    ll dist(int i, int j) {
        ll a = x[i] - x[j];
        ll b = y[i] - y[j];
        return a * a + b * b;
    }

    void solve() {
        vector<int> ans = {0};
        vector<int> free;
        for (int i = 1; i < n; i++) {
            free.push_back(i);
        }

        while (ans.size() != n) {
            int u = ans.back();
            auto it = min_element(free.begin(), free.end(), [&u](int i, int j) -> bool {
                return dist(u, i) > dist(u, j);
            });
            ans.push_back(*it);
            swap(*it, free.back());
            free.pop_back();
        }

        for (int i = 0; i < n; i++) {
            cout << ans[i] + 1 << " \n"[i + 1 == n];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int task, group;
    cin >> task >> group;

    if (task == 1) {
        task1::read();
        task1::solve();
        return 0;
    }

    int n;
    cin >> n;

    vector<Point> P(n);
    for (int i = 0; i < n; i++) {
        cin >> P[i];
    }

    int c;
    cin >> c;

    if (task == 2) {
        return 0;
    }

    return 0;
}
