#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct point {
    ll x, y;
    int idx;

    point() {
        x = y = 0;
    }
    point(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    ll operator%(point a) {
        return x * a.y - y * a.x;
    }
    ll operator*(point a) {
        return x * a.x + y * a.y;
    }
    point operator-(point a) {
        return point(x - a.x, y - a.y);
    }
};

bool ang(point v1, point v2) {
    return v1 * v2 > 0;
}

bool cmp(point a, point b) {
    return a.x < b.x;
}

mt19937 rnd(179);

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<point> pts;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts.push_back(point(x, y));
        pts.back().idx = i + 1;
    }
    shuffle(pts.begin(), pts.end(), rnd);
    if (task == 1) {
        unordered_set<int> rem;
        vector<int> p;
        p.push_back(pts[0].idx);
        p.push_back(pts[1].idx);
        auto lv = pts[1] - pts[0];
        int last = 1;
        for (int i = 2; i < n; i++) {
            rem.insert(i);
        }
        while (!rem.empty()) {
            int fgood = -1;
            for (auto e : rem) {
                if (ang(lv, pts[e] - pts[last])) {
                    fgood = e;
                    break;
                }
            }
            if (fgood == -1) {
                fgood = *rem.begin();
            }
            rem.erase(fgood);
            p.push_back(pts[fgood].idx);
            lv = pts[fgood] - pts[last];
            last = fgood;
        }
        for (auto e : p) {
            cout << e << ' ';
        }
        cout << '\n';
    } else if (task == 2) {
        int c;
        cin >> c;
        for (int i = 0; i < n; i++) {
            cout << pts[i].idx << ' ';
        }
        cout << '\n';
    } else {
        exit(1);
    }
}

int main() {
    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
