#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define all(v) v.begin(), v.end()
#define pb push_back
#define eb emplace_back
#define pp pop_back
using namespace std;
#define ull unsigned long long
mt19937_64 rd(179);
int inf = 1000000000;
struct ptf {
    long double x, y;
};

struct pt {
    int x = 0, y = 0;

    operator ptf() { return {(long double) x, (long double) y}; }

    pt(int x, int y) {
        this->x = x;
        this->y = y;
    }

    pt() {}

    pt norm() { return {-y, x}; }

    pt normalized() {
        int gc = gcd(abs(x), abs(y));
        return pt(x / gc, y / gc);
    }
};

istream &operator>>(istream &a, pt &x) {
    a >> x.x >> x.y;
    return a;
}

ostream &operator<<(ostream &a, pt &x) {
    a << x.x << " " << x.y;
    return a;
}

int operator*(pt a, pt b) { return a.x * b.x + a.y * b.y; }

int operator/(pt a, pt b) { return a.x * b.y - a.y * b.x; }

int dst2(pt x, pt y) {
    return (x.x - y.x) * (x.x - y.x) + (y.y - x.y) * (y.y - x.y);
}

pt operator-(pt a, pt b) { return {a.x - b.x, a.y - b.y}; }

pt operator+(pt a, pt b) { return {a.x + b.x, a.y + b.y}; }

pt operator-(pt a) { return {-a.x, -a.y}; }

pt &operator+=(pt &a, pt b) {
    a = {a.x + b.x, a.y + b.y};
    return a;
}

pt &operator-=(pt &a, pt b) {
    a += -b;
    return a;
}

pt &operator*=(pt &a, int t) {
    a.x *= t;
    a.y *= t;
    return a;
}

pt operator*(pt a, int t) { return pt(a.x * t, a.y * t); }

struct line {
    pt beg, vc;
    int a = 0, b = 0, c = 0;

    line() {}

    void normalize() {
        vc = vc.normalized();
        if (a < (long double) 0 || a == (long double) 0 && b < 0) {
            a *= -1;
            b *= -1;
            c *= -1;
        }
        int gc = gcd(a, gcd(abs(b), abs(c)));
        a /= gc;
        b /= gc;
        c /= gc;
    }

    long double dst(pt t) {
        long double len = sqrtl(a * a + b * b);
        return abs((long double) a * t.x + b * t.y + c) / len;
    }

    bool on(pt a) { return vc / (a - beg) == 0; }
};

line p2(pt a, pt b) {
    line t;
    t.beg = a;
    t.vc = b - a;
    t.a = t.vc.norm().x;
    t.b = t.vc.norm().y;
    t.c = -(t.vc.norm() * t.beg);
    t.normalize();
    return t;
}

struct seg {
    pt f, s;

    bool stripe(pt a) {
        return (a - f) * (s - f) >= (long double) 0 && (a - s) * (f - s) >= 0;
    }

    long double dst(pt a) {
        if (stripe(a)) {
            long double area = abs((a - f) / (s - f));
            return area / sqrtl(dst2(f, s));
        }
        return sqrtl(min(dst2(a, f), dst2(a, s)));
    }
};

struct ray {
    pt f, s;

    bool stripe(pt a) { return ((a - f) * (s - f) >= 0); }

    long double dst(pt a) {
        if (stripe(a)) {
            long double area = abs((a - f) / (s - f));
            return area / sqrtl(dst2(f, s));
        }
        return sqrtl(dst2(a, f));
    }

    bool on(pt a) { return (s - f) / (a - f) == 0 && (s - f) * (a - f) >= 0; }
};

bool help(int a1, int a2, int b1, int b2) {
    if (b1 > b2) {
        swap(b1, b2);
    }
    if (a1 > a2) {
        swap(a1, a2);
    }
    bool f = (a1 <= b1 && b1 <= a2);
    bool s = (a1 <= b2 && b2 <= a2);
    bool th = (b1 <= a1 && a1 <= b2);
    bool fo = (b1 <= a2 && a2 <= b2);
    return f || s || th || fo;
}

bool inter(seg a, seg b) {
    if (!help(a.f.x, a.s.x, b.f.x, b.s.x)) {
        return false;
    }
    if (!help(a.f.y, a.s.y, b.f.y, b.s.y)) {
        return false;
    }
    if (((b.s - b.f) / (a.s - b.f)) * ((b.s - b.f) / (a.f - b.f)) > 0) {
        return false;
    }
    if (((a.s - a.f) / (b.s - a.f)) * ((a.s - a.f) / (b.f - a.f)) > 0) {
        return false;
    }
    return true;
}

bool inter(ray a, seg b) {
    if (a.on(b.f) || a.on(b.s)) {
        return true;
    }
    if (((a.s - a.f) / (b.s - a.f)) * ((a.s - a.f) / (b.f - a.f)) > 0) {
        return false;
    }
    if (((a.f - b.f) / (b.s - b.f)) * ((a.s - a.f) / (b.s - b.f)) > 0) {
        return false;
    }
    if (((a.f - b.f) / (b.s - b.f)) * ((a.s - a.f) / (b.s - b.f)) == 0) {
        return a.on(b.f);
    }
    return true;
}

bool inter(ray a, ray b) {
    if (a.f.x == b.f.x && a.f.y == b.f.y)
        return true;
    pt bord = (a.f - b.f);
    if (((a.s - a.f) / bord) * ((b.s - b.f) / bord) < 0) {
        return false;
    } else if (((a.s - a.f) / bord) * ((b.s - b.f) / bord) == 0) {
        return b.on(a.f) || a.on(b.f);
    } else {
        if ((a.s - a.f) * bord >= 0 && (b.s - b.f) * bord <= 0) {
            return false;
        } else if ((a.s - a.f) * bord <= 0 && (b.s - b.f) * bord >= 0) {
            return true;
        }
        return ((a.s - a.f) / (b.s - b.f)) * ((a.s - a.f) / bord) > 0;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    if (g == 1) {
        int n;
        cin >> n;
        vector<pair<int, int>> a(n);
        for (auto &i: a) cin >> i.fi >> i.se;
        int ptr1 = 1, ptr2 = n;
        for (int i = 1; i <= n; i++) {
            if (i % 2 == 1) {
                cout << ptr1++ << " ";
            } else {
                cout << ptr2-- << " ";
            }
            cout.flush();
        }
    } else if (t == 1) {
        int n;
        cin >> n;
        vector<pt> a(n);
        for (auto &i: a) {
            cin >> i;
        }
        int t = 0;
        vector<int> p(n);
        vector<int >ans;
        int l = 0;
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
        while (n * t < 1000000) {
            t++;
            shuffle(all(p), rd);
            int cnt = 0;
            for (int i = 0; i < n - 2; i++) {
                cnt += (a[p[i + 1]] - a[p[i]]) * (a[p[i + 2]] - a[p[i + 1]]) < 0;
            }
            if (cnt >= l)  {
                ans = p;
                l = cnt;
            }
        }
        for (auto i : ans) {
            cout << i + 1 << " ";
            cout.flush();
        }
    }
}
