#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const int MOD = 1e9 + 7;
const int B = 1e6 + 3;
const ld EPS = 1e-9;

const ll N = 1e5 + 20;
ll stb[N];

void solve1() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	for (ll i = 0; i < n; i++) {
		if (i % 2 == 0) cout << (i / 2 + 1) << " ";
		else cout << n - (i / 2) << " ";
	}
	cout << endl;
}

void solve7() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	ll c;
	cin >> c;
	ll q;
	cin >> q;
	while (q--) {
		ll k;
		cin >> k;
		ll l = 1, r = n;
		for (ll i = 0; i < k + 1; i++) {
			if (i % 2 == 0) cout << (i / 2 + 1) << " ", l++;
			else cout << n - (i / 2) << " ", r--;
		}
		if (k % 2 == 1) {
			for (ll x = r; x >= l; x--) cout << x << " ";
		} else {
			for (ll x = l; x <= r; x++) cout << x << " ";
		}
		cout << endl;
	}
}

void solve16() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	ll c;
	cin >> c;
	vector<ll> h(n - 1, 0);
	for (ll i = 0; i < n; i++) {
		ll a = i + 1;
		h[0] = (h[0] + a * stb[i]) % MOD;
		ll b = (n - i) % n;
		h[1] = (h[1] + b * stb[i]) % MOD;
	}
	ll f0 = 1 * stb[0], f1 = (1 * stb[0] + n * stb[1]) % MOD;
	for (ll x = 2; x <= n - 2; x++) {
		ll lst, nxt;
		if (x % 2 == 0) {
			lst = n - x / 2 + 1;
			nxt = x / 2 + 1;
			h[x] = ((h[x - 2] - f0 - lst * stb[n - 1]) % MOD * B + f0 + lst * stb[x - 1]) % MOD;
			f0 = (f0 + lst * stb[x - 1] + nxt * stb[x]) % MOD;
		} else {
			lst = x / 2 + 1;
			nxt = n - x / 2;
			h[x] = ((h[x - 2] - f1 - lst * stb[n - 1]) % MOD * B + f1 + lst * stb[x - 1]) % MOD;
			f1 = (f1 + lst * stb[x - 1] + nxt * stb[x]) % MOD;
		}
	}
	for (ll k = c; k <= n - c; k++) {
		cout << (h[k] + MOD) % MOD << " ";
	}
	cout << endl;
	ll q;
	cin >> q;
	while (q--) {
		ll k;
		cin >> k;
		ll l = 1, r = n;
		for (ll i = 0; i < k + 1; i++) {
			if (i % 2 == 0) cout << (i / 2 + 1) << " ", l++;
			else cout << n - (i / 2) << " ", r--;
		}
		if (k % 2 == 1) {
			for (ll x = r; x >= l; x--) cout << x << " ";
		} else {
			for (ll x = l; x <= r; x++) cout << x << " ";
		}
		cout << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	stb[0] = 1;
	for (ll i = 1; i < N; i++) {
		stb[i] = ((long long)stb[i - 1] * B) % MOD;
	}
	ll task, gr;
	cin >> task >> gr;
	if (gr == 1) solve1();
	if (gr == 7) solve7();
	if (gr == 16) solve16();
	return 0;
}