#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const int MOD = 1e9 + 7;
const int B = 1e6 + 3;
const ld EPS = 1e-9;

const ll N = 1e5 + 20;
ll stb[N];

void solve1() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	for (ll i = 0; i < n; i++) {
		if (i % 2 == 0) cout << (i / 2 + 1) << " ";
		else cout << n - (i / 2) << " ";
	}
	cout << endl;
}

void solve2() {
	ll n;
	cin >> n;
	vector<array<ll, 2>> v(n);
	for (ll i = 0; i < n; i++) cin >> v[i][0] >> v[i][1];
	vector<ll> p(n);
	for (ll i = 0; i < n; i++) p[i] = i;
	ll ans = 0;
	auto ansp = p;
	do {
		ll res = 0;
		for (ll i = 0; i + 2 < n; i++) {
			ll x1 = v[p[i]][0] - v[p[i + 1]][0], y1 = v[p[i]][1] - v[p[i+1]][1];
			ll x2 = v[p[i + 2]][0] - v[p[i + 1]][0], y2 = v[p[i + 2]][1] - v[p[i + 1]][1];
			if (x1 * x2 + y1 * y2 > 0) res++;
		}
		if (res > ans) {
			ans = res;
			ansp = p;
		}
	} while (next_permutation(all(p)));
	for (ll x : ansp) cout << x + 1 << " ";
	cout << endl;
}

struct Node {
	ll x;
	Node* pr;
	Node() {}
	Node(ll x, Node* pr) : x(x), pr(pr) {}
};
Node t[N];
ll tnow = 0;
Node* add(Node* d, ll x) {
	t[tnow] = Node(x, d);
	return t + (tnow++);
}

void no() {
	cout << "aboba" << endl;
	exit(0);
}

void solve6() {
	ll n;
	cin >> n;
	vector<array<ll, 3>> v(n);
	vector<ll> ys;
	for (ll i = 0; i < n; i++) {
		cin >> v[i][0] >> v[i][1];
		ys.push_back(v[i][1]);
		v[i][2] = i + 1;
	}
	sort(all(ys));
	sort(all(v));
	for (ll i = 0; i < n; i++) {
		v[i][1] = lower_bound(all(ys), v[i][1]) - ys.begin();
	}
	ll c;
	cin >> c;
	vector<bool> used(n, 0);
	ll cnt = n;
	vector<ll> cov, ans;
	vector<Node*> p;
	while (cnt > 0) {
		tnow = 0;
		ll res = 0;
		Node* f = add(nullptr, -1);
		if (true) {
			ans.assign(n + 1, n);
			p.assign(n + 1, nullptr);
			ans[0] = -1;
			p[0] = add(nullptr, -1);
			for (ll i = 0; i < n; i++) {
				if (used[i]) continue;
				ll u = upper_bound(all(ans), v[i][1]) - ans.begin();
				ans[u] = v[i][1];
				p[u] = add(p[u - 1], i);
			}
			for (ll i = 0; i <= n; i++) {
				if (ans[i] < n) {
					if (i > res) {
						res = i;
						f = p[i];
					}
				}
			}
		}
		vector<ll> nedad;
		for (ll _ = 0; _ < res; _++) {
			if (f == nullptr) {
				no();
			}
			nedad.push_back(f->x);
			f = f->pr;
		}
		tnow = 0;
		res = 0;
		f = add(nullptr, -1);
		if (true) {
			ans.assign(n + 1, n);
			p.assign(n + 1, nullptr);
			ans[0] = -1;
			p[0] = add(nullptr, -1);
			for (ll i = 0; i < n; i++) {
				if (used[i]) continue;
				ll u = upper_bound(all(ans), n - v[i][1] - 1) - ans.begin();
				ans[u] = n - v[i][1] - 1;
				p[u] = add(p[u - 1], i);
			}
			for (ll i = 0; i <= n; i++) {
				if (ans[i] < n) {
					if (i > res) {
						res = i;
						f = p[i];
					}
				}
			}
		}
		if (res > nedad.size()) {
			nedad.clear();
			for (ll _ = 0; _ < res; _++) {
				if (f == nullptr) {
					no();
				}
				nedad.push_back(f->x);
				f = f->pr;
			}
		}
		for (ll x : nedad) {
			cov.push_back(v[x][2]);
			used[x] = 1;
			cnt--;
		}
	}
	for (ll x : cov) cout << x << " ";
	cout << endl;
}

void solve7() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	ll c;
	cin >> c;
	ll q;
	cin >> q;
	while (q--) {
		ll k;
		cin >> k;
		ll l = 1, r = n;
		for (ll i = 0; i < k + 1; i++) {
			if (i % 2 == 0) cout << (i / 2 + 1) << " ", l++;
			else cout << n - (i / 2) << " ", r--;
		}
		if (k % 2 == 1) {
			for (ll x = r; x >= l; x--) cout << x << " ";
		} else {
			for (ll x = l; x <= r; x++) cout << x << " ";
		}
		cout << endl;
	}
}

void solve16() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	ll c;
	cin >> c;
	vector<ll> h(n - 1, 0);
	for (ll i = 0; i < n; i++) {
		ll a = i + 1;
		h[0] = (h[0] + a * stb[i]) % MOD;
		ll b = (n - i) % n + 1;
		h[1] = (h[1] + b * stb[i]) % MOD;
	}
	ll f0 = 1 * stb[0], f1 = (1 * stb[0] + n * stb[1]) % MOD;
	for (ll x = 2; x <= n - 2; x++) {
		ll lst, nxt;
		if (x % 2 == 0) {
			lst = n - x / 2 + 1;
			nxt = x / 2 + 1;
			h[x] = ((h[x - 2] - f0 - lst * stb[n - 1]) % MOD * B + f0 + lst * stb[x - 1]) % MOD;
			f0 = (f0 + lst * stb[x - 1] + nxt * stb[x]) % MOD;
		} else {
			lst = x / 2 + 1;
			nxt = n - x / 2;
			h[x] = ((h[x - 2] - f1 - lst * stb[n - 1]) % MOD * B + f1 + lst * stb[x - 1]) % MOD;
			f1 = (f1 + lst * stb[x - 1] + nxt * stb[x]) % MOD;
		}
	}
	for (ll k = c; k <= n - c; k++) {
		cout << (h[k] + MOD) % MOD << " ";
	}
	cout << endl;
	ll q;
	cin >> q;
	while (q--) {
		ll k;
		cin >> k;
		ll l = 1, r = n;
		for (ll i = 0; i < k + 1; i++) {
			if (i % 2 == 0) cout << (i / 2 + 1) << " ", l++;
			else cout << n - (i / 2) << " ", r--;
		}
		if (k % 2 == 1) {
			for (ll x = r; x >= l; x--) cout << x << " ";
		} else {
			for (ll x = l; x <= r; x++) cout << x << " ";
		}
		cout << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	stb[0] = 1;
	for (ll i = 1; i < N; i++) {
		stb[i] = ((long long)stb[i - 1] * B) % MOD;
	}
	ll task, gr;
	cin >> task >> gr;
	if (gr == 1) solve1();
	if (gr == 2 || (task == 1 && gr == 0)) solve2();
	if (gr == 6 || task == 2) solve6();
	if (gr == 7) solve7();
	if (gr == 16) solve16();
	return 0;
}