#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <random>
#include <cassert>

using namespace std;

#define F frist
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

const double PI = 3.14;
const double EPS = 1e-5;

struct Point {
    int x, y;
    Point() {}
    Point(int x, int y) : x(x), y(y) {}
};

struct Vector {
    int x, y;
    Vector(Point a, Point b) : x(b.x - a.x), y(b.y - a.y) {}
    int operator*(Vector other) {
        return x * other.y - y * other.x;
    }
    int operator^(Vector other) {
        return x * other.x + y * other.y;
    }
};

double angle(Point a, Point o, Point b) {
    Vector x(o, a), y(o, b);
    double ans = atan2(x * y, x ^ y);
    if (ans < 0) ans += PI;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int task, group; cin >> task >> group;
    if (task == 1) {
        int n; cin >> n;
        vector<Point> p(n);
        for (int i = 0; i < n; i++) cin >> p[i].x >> p[i].y;

        vector<int> pos(n);
        for (int i = 0; i < n; i++) pos[i] = i;
        int mx = 0;
        vector<int> mx_pos;
        do {
            int ans = 0;
            for (int i = 1; i < n - 1; i++) {
                if (angle(p[pos[i - 1]], p[pos[i]], p[pos[i + 1]]) < PI / 2) ans++;
            }
            if (ans > mx) {
                mx = ans;
                mx_pos = pos;
            }
        } while (next_permutation(all(pos)));
        for (auto i : mx_pos) cout << i + 1 << " "; cout << endl;
    }
}   