#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <random>
#include <cassert>

using namespace std;

#define F frist
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

const long double PI = 3.14;
const long double EPS = 1e-5;

struct Poll {
    ll x, y;
    Poll() {}
    Poll(ll x, ll y) : x(x), y(y) {}
};

struct Vector {
    ll x, y;
    Vector(Poll a, Poll b) : x(b.x - a.x), y(b.y - a.y) {}
    ll operator*(Vector other) {
        return x * other.y - y * other.x;
    }
    ll operator^(Vector other) {
        return x * other.x + y * other.y;
    }
};

long double angle(Poll a, Poll o, Poll b) {
    Vector x(o, a), y(o, b);
    long double ans = atan2(x * y, x ^ y);
    if (ans < 0) ans += PI;
    //cout << a.x << " " << a.y << "  " << o.x << " " << o.y << "  " << b.x << " " << b.y << "  " << ans << endl;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll task, group; cin >> task >> group;
    if (task == 1) {
        ll n; cin >> n;
        vector<Poll> p(n);
        for (ll i = 0; i < n; i++) cin >> p[i].x >> p[i].y;

        vector<ll> pos(n);
        for (ll i = 0; i < n; i++) pos[i] = i;
        ll mx = 0;
        vector<ll> mx_pos;
        do {
            ll ans = 0;
            for (ll i = 1; i < n - 1; i++) {
                if (angle(p[pos[i - 1]], p[pos[i]], p[pos[i + 1]]) < PI / 2 + EPS) ans++;
            }
            if (ans > mx) {
                mx = ans;
                mx_pos = pos;
            }
        } while (next_permutation(all(pos)));
        for (auto i : mx_pos) cout << i + 1 << " "; cout << endl;
    }
}   