//Туры-пуры

#include<bits/stdc++.h>

using vec = std::pair<long long, long long>;
#define x first
#define y second

long long cross(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}
long long dot(vec a, vec b) {
    return a.x * b.x + a.y * b.y;
}

vec operator-(vec a, vec b) {
    return {a.x - b.x, a.y - b.y};
}

std::mt19937 rnd(std::time(0));

int b = 1e6 + 3;
int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
    return 1ll * a * b % mod;
}
const int N = 1e6;
int pw[N];

signed main() {
//    std::cin.tie(nullptr)->sync_with_stdio(false);

    unsigned start = clock();
    int task, group;
    std::cin >> task >> group;
    int n;
    std::cin >> n;
    std::vector<vec> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i].x >> a[i].y;
    }
    bool ok = true;
    for (int i = 0; i + 1 < n; ++i) {
        ok &= a[i].x < a[i + 1].x;
        ok &= a[i].y < a[i + 1].y;
    }
    if (group == 1) {
        for (int i = 1; i <= n; ++i) {
            if (i & 1) std::cout << i / 2 + 1 << ' ';
            else std::cout << n - i / 2 + 1 << ' ';
        }
        std::cout << std::endl;
        return 0;
    }
    if (group == 7 || group == 16) {
        int c;
        std::cin >> c;
        if (group == 16) {
            pw[0] = 1;
            for (int i = 1; i <= n; ++i) pw[i] = mul(pw[i - 1], b);
            std::vector<int> s1(n + 1), s2(n + 1);
            s1[n] = s2[n] = 0;
            for (int i = n - 1; i >= 0; --i) {
                s1[i] = add(s1[i + 1], mul(n - i,pw[i]));
                s2[i] = add(s2[i + 1], mul(i + 1, pw[i]));
            }
            std::vector<int> ans(n + 2);
            int cur = 0;
            for (int i = 0; i < n; ++i) {
                int k = (i + 1) - 2;
                if (i & 1) cur = add(cur, mul(pw[i], k + 2 - i / 2));
                else cur = add(cur, mul(pw[i], i / 2 + 1));
                int hsh = cur;
                if ((k + 2) & 1) {
                    hsh = add(hsh,mul(n - (k + 2), sub(pw[i + 1], 1)));
                    hsh = add(hsh, s1[i + 1]);
                } else {
                    hsh = add(hsh, s2[i + 1]);
                }
                if (k >= 0) ans[k] = hsh;
            }
            for (int i = c; i <= n - c; ++i) {
                std::cout << ans[i] << ' ';
            }
            std::cout << std::endl;
        }
        int q;
        std::cin >> q;
        while (q--) {
            int k;
            std::cin >> k;
            std::vector<int> p(n);
            for (int i = 0; i < k + 2; ++i) {
                if (i & 1) p[i] = k + 2 - i / 2 - 1;
                else p[i] = i / 2;
            }
            if ((k + 2) & 1) {
                for (int i = 0; i < k + 2; ++i) {
                    p[i] += n - (k + 2);
                }
                int ptr = n - (k + 2) - 1;
                for (int i = k + 2; i < n; ++i) p[i] = ptr--;
            } else {
                int ptr = k + 2;
                for (int i = k + 2; i < n; ++i) p[i] = ptr++;
            }
            for (auto& i : p) std::cout << i + 1 << ' ';
            std::cout << std::endl;
        }
        return 0;
    }
    if (task == 1) {
        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);
        std::shuffle(p.begin(), p.end(), rnd);
        auto calc = [&]() -> int {
            int res = 0;
            for (int i = 1; i < n - 1; ++i) {
                res += dot(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) > 0;
            }
            return res;
        };
        double dt = 0.99, temp = 1;
        int cur = calc();
        while ((double)(clock() - start) / CLOCKS_PER_SEC <= 1.9) {
            int i = rnd() % n;
            int j = rnd() % n;
            if (i > j) std::swap(i, j);
            std::reverse(p.begin() + i, p.begin() + j + 1);
            int nw = calc();
            if (nw > cur || (double)rnd() / INT_MAX <= temp) {
                cur = nw;
            } else {
                std::reverse(p.begin() + i, p.begin() + j + 1);
            }
            temp *= dt;
        }
        for (auto i : p) std::cout << i + 1 << ' ';
        std::cout << std::endl;
    } else if (task == 2 || task == 3) {
        int c;
        std::cin >> c;
        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);
        std::shuffle(p.begin(), p.end(), rnd);
        auto calc = [&]() -> int {
            int res = 0;
            for (int i = 1; i < n - 1; ++i) {
                res += dot(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) > 0;
            }
            return res;
        };
        double dt = 0.99, temp = 1;
        int cur = calc();
        while (cur > c) {
            int i = rnd() % n;
            int j = rnd() % n;
            if (i > j) std::swap(i, j);
            std::reverse(p.begin() + i, p.begin() + j + 1);
            int nw = calc();
            if (nw < cur || (double)rnd() / INT_MAX <= temp) {
                cur = nw;
            } else {
                std::reverse(p.begin() + i, p.begin() + j + 1);
            }
            temp *= dt;
        }
        for (auto i : p) std::cout << i + 1 << ' ';
        std::cout << std::endl;
    }
}