#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;

struct Point {
    ll x, y;
    int id;

    Point() {}

    Point(ll x, ll y) : x(x), y(y) {}

    Point operator+(Point other) const {
        return {x + other.x, y + other.y};
    }

    Point operator-(Point other) const {
        return {x - other.x, y - other.y};
    }

    Point(Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    Point operator*(ll d) const {
        return {x * d, y * d};
    }

    ll operator*(Point other) const {
        return x * other.x + y * other.y;
    }

    ll operator%(Point other) const {
        return x * other.y - y * other.x;
    }
};


bool is_small(Point a, Point b, Point c) {
    Point ab = Point(a, b), bc = Point(b, c);
    double angle = atan2(ab % bc, ab * bc);
    if (angle < M_PI / 2) return true;
    return false;
}

istream& operator>>(istream& in, Point& p) {
    in >> p.x >> p.y;
    return in;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Point> pts(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i];
        pts[i].id = i;
    }
    int ans = 0;
    int cnt = 0;
    vector<Point> ans_v;
    for (int _ = 0; _ < 1000; ++_) {
        int local_ans = 0;
        for (int i = 1; i < n - 1; ++i) {
            if (is_small(pts[i - 1], pts[i], pts[i + 1])) local_ans++;
        }
        if (local_ans > ans) {
            ans = local_ans;
            ans_v = pts;
        }
        std::shuffle(pts.begin(), pts.end(), std::mt19937(std::random_device()()));
    }
//    cout << ans << "\n";
    for (auto el : ans_v) {
        cout << el.id + 1 << " ";
    }
    return 0;
}
