#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")
#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;

struct Point {
    ll x, y;
    int id;

    Point() {}

    Point(ll x, ll y) : x(x), y(y) {}

    Point operator+(Point other) const {
        return {x + other.x, y + other.y};
    }

    Point operator-(Point other) const {
        return {x - other.x, y - other.y};
    }

    Point(Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    Point operator*(ll d) const {
        return {x * d, y * d};
    }

    ll operator*(Point other) const {
        return x * other.x + y * other.y;
    }

    ll operator%(Point other) const {
        return x * other.y - y * other.x;
    }

    ll Len2() {
        return x * x + y * y;
    }

    bool operator<(const Point& other) const {
        return x < other.x || y < other.y && x == other.x;
    }
};


bool is_small(Point a, Point b, Point c) {
    Point ab = Point(b, a), bc = Point(b, c);
    ll x = ab * bc;
    return ab * bc > 0;
}

istream& operator>>(istream& in, Point& p) {
    in >> p.x >> p.y;
    return in;
}

vector<int> por, used;
int n;


bool comp(Point a, Point b) {
    return a.y < b.y || a.y == b.y && a.x < b.x;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int task, group;
    cin >> task >> group;
    cin >> n;
    vector<Point> pts(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i];
        pts[i].id = i;
    }
    if (task == 1 && group == 1) {
        int left = 1, right = n;
        while (right > left) {
            cout << left << " ";
            cout << right << " ";
            left++;
            right--;
            if (left == right) {
                cout << left << " ";
                break;
            }
        }
        return 0;
    }
    if (n <= 10) {
        int ans = 0;
        int cnt = 0;
        vector<Point> ans_v = pts;
        for (int _ = 0; _ < 160000; ++_) {
            int local_ans = 0;
            for (int i = 1; i < n - 1; ++i) {
                if (is_small(pts[i - 1], pts[i], pts[i + 1])) local_ans++;
            }
            if (local_ans > ans) {
                ans = local_ans;
                ans_v = pts;
            }
            std::shuffle(pts.begin(), pts.end(), std::mt19937(std::random_device()()));
        }
//    cout << ans << "\n";
        for (auto el : ans_v) {
            cout << el.id + 1 << " ";
        }
        return 0;
    }
    if (task == 1) {
        std::sort(pts.begin(), pts.end());
        vector <Point> left, right;
        for (int i = 0; i < (n + 1) / 2; ++i) {
            left.push_back(pts[i]);
        }
        for (int i = (n + 1) / 2; i < n; ++i) {
            right.push_back(pts[i]);
        }
        std::sort(left.begin(), left.end());
        std::sort(right.begin(), right.end());
        int p = 0, q = 0;
        while (p < left.size() && q < right.size()) {
            cout << left[p].id + 1 << " ";
            cout << right[q].id + 1 << " ";
            ++p;
            ++q;
        }
        while (p < left.size()) {
            cout << left[p].id + 1 << " ";
            ++p;
        }
        while (q < right.size()) {
            cout << right[q].id + 1 << " ";
            ++p;
        }
        return 0;
    }
    int c;
    cin >> c;
    int ans = 0;
    int cnt = 0;
    vector<Point> ans_v = pts;
    for (int _ = 0; _ < 10000; ++_) {
        int local_ans = 0;
        for (int i = 1; i < n - 1; ++i) {
            if (is_small(pts[i - 1], pts[i], pts[i + 1])) local_ans++;
        }
        if (local_ans <= c) {
            ans_v = pts;
        }
        std::shuffle(pts.begin(), pts.end(), std::mt19937(std::random_device()()));
    }
//    cout << ans << "\n";
    for (auto el : ans_v) {
        cout << el.id + 1 << " ";
    }
    return 0;
    return 0;
}
