#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));
const int N = 2e5 + 100;
vector<pair<int, int>> adj[N];
struct TwoSat {
    vector<vector<int>> g, gr;
    int n;
    TwoSat(int _n) : n(_n), gr(2 * _n), g(2 * _n) {}
    void add_edge(int v1, int f1, int v2, int f2) {
        g[2 * v1 + f1].push_back(2 * v2 + f2);
        gr[2 * v2 + f2].push_back(2 * v1 + f1);
    }
    vector<int> ord, comp;
    vector<bool> us;
    void dfs0(int v) {
        us[v] = true;
        for (int u : g[v]) {
            if (!us[u]) {
                dfs0(u);
            }
        }
        ord.push_back(v);
    }
    int cur;
    void dfs1(int v) {
        us[v] = true;
        comp[v] = cur;
        for (int u : gr[v]) {
            if (!us[u]) {
                dfs1(v);
            }
        }
    }
    vector<int> solve() {
        comp.assign(2 * n, -1);
        us.assign(2 * n, false);
        for (int i = 0; i < 2 * n; i++) {
            if (!us[i]) {
                dfs0(i);
            }
        }
        reverse(ord.begin(), ord.end());
        for (int v : ord) {
            if (!us[v]) {
                cur++;
                dfs1(v);
            }
        }
        vector<int> ans(n);
        for (int i = 0; i < n; i++) {
            if (comp[2 * i] == comp[2 * i + 1]) return {};
            ans[i] = comp[2 * i] > comp[2 * i + 1];
        }
        return ans;
    }
};
struct point {
    int x, y;
    point() = default;
    point(int _x, int _y) : x(_x), y(_y) {}
    void read() {
        cin >> x >> y;
    }
};
void solve_case() {
    int task, test, n;
    cin >> task >> test >> n;
    vector<point> p(n);
    for (int i = 0; i < n; i++) p[i].read();
    if (task == 1) {
        int l = 1, r = n;
        for (int i = 0; i < n; i++) {
            if (i % 2 == 0) {
                cout << l++ << " ";
            } else {
                cout << r-- << " ";
            }
        }
        cout << endl;
    } else if (task == 2) {
        int c; cin >> c;
        vector<int> perm(n);
        iota(perm.begin(), perm.end(), 0);
        //shuffle(perm.begin(), perm.end(), rnd);
        for (int i = 0; i < n; i++) cout << perm[i] + 1 << " ";
        cout << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
