#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

mt19937 rnd(239);

struct point {
	int x, y;
	point() {
		x = y = 0;
	}
	point(int x_, int y_) {
		x = x_;
		y = y_;
	}
};

struct vec {
	int x, y;
	vec() {
		x = y = 0;
	}
	vec(int x_, int y_) {
		x = x_;
		y = y_;
	}
	vec(point p1, point p2) {
		x = p2.x - p1.x;
		y = p2.y - p1.y;
	}
	ll operator^(vec v1) {
		return 1ll * x * v1.y - 1ll * y * v1.x;
	}
	ll operator*(vec v1) {
		return 1ll * x * v1.x + 1ll * y * v1.y;
	}
};

ll dist(point p1, point p2) {
	return 1ll * (p1.x - p2.x) * (p1.x - p2.x) + 1ll * (p1.y - p2.y) * (p1.y - p2.y);
}
 
const int N = 80010;
int t[4 * N], power[N];

void update(int v, int l, int r, int pos, int val) {
	if (l == r) {
		t[v] = val;
		return;
	}
	int m = (l + r) / 2;
	if (pos <= m) {
		update(2 * v, l, m, pos, val);
	} else {
		update(2 * v + 1, m + 1, r, pos, val);
	}
	t[v] = t[v * 2] + t[v * 2 + 1];
}

int go(int v, int l, int r, int k) {
	if (l == r) {
		return l;
	}
	int m = (l + r) / 2;
	if (t[v * 2] >= k) {
		return go(2 * v, l, m, k);
	} else {
		return go(2 * v + 1, m + 1, r, k - t[v * 2]);
	}
}

const int MOD = 1e9 + 7;

int add(int a, int b) {
	return a + b >= MOD ? a + b - MOD : a + b;
}

int sub(int a, int b) {
	return a - b < 0 ? a - b + MOD : a - b;
}

int mul(int a, int b) {
	return 1ll * a * b % MOD;
}

signed main () {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	for (int i = 0; (1 << i) < N; i++) {
		power[1 << i] = i;
	}
	for (int i = 1; i < N; i++) {
		power[i] = max(power[i], power[i - 1]);
	}
	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;
	vector<point> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
	}
	bool super_good = 1;
	for (int i = 1; i < n; i++) {
		super_good &= p[i - 1].x < p[i].x;
		super_good &= p[i - 1].y < p[i].y;
	}
	if (task == 1) {
		int i = 0;
		for (int j = 1; j < n; j++) {
			if (p[j].x < p[i].x) {
				i = j;
			}
		}
		vector<bool> used(n);
		used[i] = 1;
		vector<int> ans{i};
		for (int _ = 0; _ < n - 1; _++) {
			int cur = -1; 	
			for (int j = 0; j < n; j++) {
				if (used[j]) continue;
				if (cur == -1 || dist(p[i], p[j]) > dist(p[i], p[cur])) {
					cur = j;
				}
			}
			used[cur] = 1;
			ans.pb(cur);
			i = cur;
		}
		for (int i : ans) {
			cout << i + 1 << ' ';
		}
		cout << endl;
	} else if (task == 2) {
		int a = rnd() % n;
		vector<bool> used(n);
		used[a] = 1;
		int b = rnd() % n;
		while (b == a) {
			b = rnd() % n;
		}
		used[b] = 1;
		vector<int> ans{a, b};
		for (int i = 0; i < n; i++) {
			if (i == a || i == b) continue;
			update(1, 0, n - 1, i, 1);
		}
		int c;
		cin >> c;
		vector<int> arr;		
		auto check = [&](int a, int b, int v) -> bool {
			if ((vec(p[b], p[a]) * vec(p[b], p[v])) <= 0) {
				return 1;
			} else {
				return 0;
			}
		};
		for (int i = 2; i < n; i++) {
			int need = -1;
			if (n - i <= 5000) {
				if (arr.size() == 0) {
					for (int v = 0; v < n; v++) {
						if (!used[v]) {
							arr.pb(v);
						}
					}
				}
				for (int v : arr) {
					if (check(a, b, v)) {
						if (need == -1 || dist(p[b], p[need]) > dist(p[b], p[v])) {
							need = v;
						}
					}
				}
				if (need == -1) {
					need = arr[0];
					for (int i = 1; i < arr.size(); i++) {
						if (dist(p[b], p[arr[i]]) < dist(p[b], p[need])) {
							need = arr[i];
						}
					}
				}
				used[need] = 1;
				ans.pb(need);
				for (int j = 0; j < arr.size(); j++) {
					if (arr[j] == need) {
						arr.erase(arr.begin() + j);
						break;
					}
				}
			} else {
				int second = -1;
				for (int k = 0; k < 240; k++) {
					int j = rnd() % (n - i) + 1;
					int v = go(1, 0, n - 1, j);
					if (check(a, b, v)) {
						if (need == -1 || dist(p[b], p[need]) > dist(p[b], p[v])) {
							need = v;
						}
					}
					if (second == -1 || dist(p[b], p[v]) < dist(p[b], p[second])) {
						second = v;
					}
				}
				if (need == -1) {
					need = second;
				}
				update(1, 0, n - 1, need, 0);
				used[need] = 1;
				ans.pb(need);
			}
			a = b;
			b = need;
		}
		for (int i : ans) {
			cout << i + 1 << ' ';
		}
		cout << endl;
	} else if (task == 3) {
		assert(super_good);
		int c;
		cin >> c;
		int q;
		cin >> q;
		while (q--) {
			int k;
			cin >> k;
			cout << 1 << ' ' << n << ' ';
			int l = 2, r = n - 1;
			int turn = 0;
			while (1) {
				if (!turn) {
					cout << l++ << ' ';
					k--;
					if (k == 1) {
						while (l <= r) {
							cout << l++ << ' ';
						}
						break;
					}
				} else {
					cout << r-- << ' ';
					k--;
					if (k == 1) {
						while (l <= r) {
							cout << r-- << ' ';
						}
						break;
					}
				}
				turn ^= 1;
			}
			cout << endl;
		}
	} else if (task == 4) {

	}
	return 0;
}