#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

struct point {
    int x, y;
    point (int _x = 0, int _y = 0) {
        x = _x;
        y = _y;
    }
    point (point &a, point &b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    bool operator==(const point &other) const {
        return x == other.x && y == other.y;
    }
    bool operator<(const point &other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
    int operator*(const point &other) const {
        return x * other.x + y * other.y;
    }
    int operator%(const point &other) const {
        return x * other.y - y * other.x;
    }
};

istream& operator>>(istream &in, point &p) {
    in >> p.x >> p.y;
}

int dist(point &a, point &b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return dx * dx + dy * dy;
}

double angle(point &a, point &b) {
    return atan2(a % b, a * b);
}

int n;
vector<pair<point, int>> pts;

void solve1() {
    point p0 = pts[0].first;
    for (int i = 0; i < n; ++i) {
        if (pts[i].first < p0) {
            p0 = pts[i].first;
        }
    }
    sort(all(pts), [&p0](pair<point, int> &a, pair<point, int> &b){
         if (a.first == p0) return true;
         if (b.first == p0) return false;
         point pa(p0, a.first), pb(p0, b.first);
         if (pa % pb == 0) return dist(p0, a.first) < dist(p0, b.first);
         return pa % pb > 0;

    });
    vector<int> ans1, ans2;
    int cnt1 = 0, cnt2 = 0;
    vector<bool> used(n);
    ans1.push_back(0);
    ans1.push_back(1);
    used[0] = true;
    used[1] = true;
    for (int i = 2; i < n; ++i) {
        int best = -1;
        for (int j = 0; j < n; ++j) {
            if (used[j]) continue;
            if (best == -1) {
                best = j;
                continue;
            }
            point p1(pts[ans1[ans1.size() - 2]].first, pts[ans1.back()].first);
            point p2(pts[ans1[ans1.size() - 2]].first, pts[best].first);
            point p3(pts[ans1[ans1.size() - 2]].first, pts[j].first);
            double an1 = angle(p1, p2);
            double an2 = angle(p1, p3);
            if (best == -1 || fabs(an2) > fabs(an1)) {
                best = j;
            }
        }
        point p1(pts[ans1[ans1.size() - 1]].first, pts[ans1[ans1.size() - 2]].first);
        point p2(pts[ans1[ans1.size() - 1]].first, pts[best].first);
        cnt1 += (int)(p1 * p2 > 0);
        ans1.push_back(best);
    }
    ans2.push_back(0);
    ans2.push_back(n - 1);
    used.assign(n, false);
    used[0] = true;
    used[n - 1] = true;
    for (int i = 2; i < n; ++i) {
        int best = -1;
        for (int j = 0; j < n; ++j) {
            if (used[j]) continue;
            if (best == -1) {
                best = j;
                continue;
            }
            point p1(pts[ans2[ans2.size() - 2]].first, pts[ans2.back()].first);
            point p2(pts[ans2[ans2.size() - 2]].first, pts[best].first);
            point p3(pts[ans2[ans2.size() - 2]].first, pts[j].first);
            double an1 = angle(p1, p2);
            double an2 = angle(p1, p3);
            if (best == -1 || fabs(an2) > fabs(an1)) {
                best = j;
            }
        }
        point p1(pts[ans2[ans2.size() - 1]].first, pts[ans2[ans2.size() - 2]].first);
        point p2(pts[ans2[ans2.size() - 1]].first, pts[best].first);
        cnt2 += (int)(p1 * p2 > 0);
        ans2.push_back(best);
    }
    if (cnt1 >= cnt2) {
        for (auto el : ans1) {
            cout << pts[el].second << " ";
        }
    } else {
        for (auto el : ans2) {
            cout << pts[el].second << " ";
        }
    }
    cout << endl;
}

//void solve2() {
//    point p0 = pts[0].first;
//    for (int i = 0; i < n; ++i) {
//        if (i)
//    }
//}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int task, group;
    cin >> task >> group;
    cin >> n;
    pts.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].first;
        pts[i].second = i + 1;
    }
    if (task == 1) {
        solve1();
    }
}
