#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

struct point {
    ll x, y;
    point (ll _x = 0, ll _y = 0) {
        x = _x;
        y = _y;
    }
    point (point &a, point &b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    bool operator==(const point &other) const {
        return x == other.x && y == other.y;
    }
    bool operator<(const point &other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }
    ll operator%(const point &other) const {
        return x * other.y - y * other.x;
    }
};

istream& operator>>(istream &in, point &p) {
    in >> p.x >> p.y;
}

ll dist(point &a, point &b) {
    ll dx = a.x - b.x;
    ll dy = a.y - b.y;
    return dx * dx + dy * dy;
}

double angle(point &a, point &b) {
    return atan2(a % b, a * b);
}

ll n;
vector<pair<point, ll>> pts;

void solve1() {
    point p0 = pts[0].first;
    for (ll i = 0; i < n; ++i) {
        if (pts[i].first < p0) {
            p0 = pts[i].first;
        }
    }
    sort(all(pts), [&p0](pair<point, ll> &a, pair<point, ll> &b){
         if (a.first == p0) return true;
         if (b.first == p0) return false;
         point pa(p0, a.first), pb(p0, b.first);
         if (pa % pb == 0) return dist(p0, a.first) < dist(p0, b.first);
         return pa % pb > 0;

    });
    vector<ll> ans1, ans2;
    ll cnt1 = 0, cnt2 = 0;
    vector<bool> used(n);
    ans1.push_back(0);
    ans1.push_back(1);
    used[0] = true;
    used[1] = true;
    for (ll i = 2; i < n; ++i) {
        ll best = -1;
        for (ll j = 0; j < n; ++j) {
            if (used[j]) continue;
            if (best == -1) {
                best = j;
                continue;
            }
            point p1(pts[ans1[ans1.size() - 2]].first, pts[ans1.back()].first);
            point p2(pts[ans1[ans1.size() - 2]].first, pts[best].first);
            point p3(pts[ans1[ans1.size() - 2]].first, pts[j].first);
            double an1 = angle(p1, p2);
            double an2 = angle(p1, p3);
            if (best == -1 || fabs(an2) > fabs(an1)) {
                best = j;
            }
        }
        point p1(pts[ans1[ans1.size() - 1]].first, pts[ans1[ans1.size() - 2]].first);
        point p2(pts[ans1[ans1.size() - 1]].first, pts[best].first);
        cnt1 += (ll)(p1 * p2 > 0);
        ans1.push_back(best);
    }
    ans2.push_back(0);
    ans2.push_back(n - 1);
    used.assign(n, false);
    used[0] = true;
    used[n - 1] = true;
    for (ll i = 2; i < n; ++i) {
        ll best = -1;
        for (ll j = 0; j < n; ++j) {
            if (used[j]) continue;
            if (best == -1) {
                best = j;
                continue;
            }
            point p1(pts[ans2[ans2.size() - 2]].first, pts[ans2.back()].first);
            point p2(pts[ans2[ans2.size() - 2]].first, pts[best].first);
            point p3(pts[ans2[ans2.size() - 2]].first, pts[j].first);
            double an1 = angle(p1, p2);
            double an2 = angle(p1, p3);
            if (best == -1 || fabs(an2) > fabs(an1)) {
                best = j;
            }
        }
        point p1(pts[ans2[ans2.size() - 1]].first, pts[ans2[ans2.size() - 2]].first);
        point p2(pts[ans2[ans2.size() - 1]].first, pts[best].first);
        cnt2 += (ll)(p1 * p2 > 0);
        ans2.push_back(best);
    }
    assert(!ans1.empty());
    assert(!ans2.empty());
    if (cnt1 >= cnt2) {
        for (auto el : ans1) {
            cout << pts[el].second << " ";
        }
    } else {
        for (auto el : ans2) {
            cout << pts[el].second << " ";
        }
    }
    cout << "\n";
    cout.flush();
}

//void solve2() {
//    point p0 = pts[0].first;
//    for (ll i = 0; i < n; ++i) {
//        if (i)
//    }
//}

int main() {
    ll task, group;
    cin >> task >> group;
    cin >> n;
    pts.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> pts[i].first;
        pts[i].second = i + 1;
    }
    if (task == 1) {
        solve1();
        return 0;
    }
}
