#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
// #define endl "\n"

mt19937_64 rng(556);
constexpr long long N = 1e7;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

struct point {
    int x, y;

    point (int a = 0, int b = 0) {
        x = a; y = b;
    }

    point (point i, point j) {
        x = j.x - i.x;
        y = j.y - i.y;
    }
};

int operator % (point i, point j) {
    return (i.x * j.x + i.y * j.y);
}

int operator ^ (point i, point j) {
    return (i.x * j.y - i.y * j.x);
}

void solve() {
    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }

    if (task == 1) {
        if (group == 1) {
            for (int i = 0; i < (n + 1) / 2; i++) {
                cout << i + 1 << " ";
                if (i + 1 != n - i) {
                    cout << n - i << " ";
                }
            }
            cout << endl;
            return;
        }
        vector<int> p(n);
        for (int i = 0; i < n; i++) p[i] = i;

        // p = {0, 3, 2, 1};

        vector<int> ans;
        int cur = -1;

        int tm = 0;
        for (int _ = 0; _ < N / n; _++) {
            tm = 0;
            for (int i = 2; i < n; i++) {
                point ab(a[p[i - 1]], a[p[i - 2]]);
                point bc(a[p[i - 1]], a[p[i]]);

                // cout << (ab % bc) << endl;

                if ((ab % bc) > 0) {
                    tm++;
                }
                return;
            }

            if (tm > cur) {
                cur = tm;
                ans = p;
            }

            shuffle(p.begin(), p.end(), rng);
        }

        // cout << cur << endl;
        for (auto el : ans) cout << el + 1 << " ";
        cout << endl;
    }
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}