#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
// #define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
int rnd() {return abs((int) rng());}

constexpr long long N = 1e6;
constexpr long long T = 20;
constexpr long long A = 500;
constexpr double eps = 1e-9;

struct point {
    int x, y;

    point (int a = 0, int b = 0) {
        x = a; y = b;
    }

    point (point i, point j) {
        x = j.x - i.x;
        y = j.y - i.y;
    }
};

int operator % (point i, point j) {
    return (i.x * j.x + i.y * j.y);
}

int operator ^ (point i, point j) {
    return (i.x * j.y - i.y * j.x);
}

void solve() {
    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }

    if (task == 1) {
        if (group == 1) {
            for (int i = 0; i < (n + 1) / 2; i++) {
                cout << i + 1 << " ";
                if (i + 1 != n - i) {
                    cout << n - i << " ";
                }
            }
            cout << endl;
            return;
        }

        // cout << "dksdpfkl " << endl;
        vector<int> p(n);
        for (int i = 0; i < n; i++) p[i] = i;

        // p = {0, 3, 2, 1};

        shuffle(p.begin(), p.end(), rng);

        double t = 1.0, dl = 0.9999;
        int cur = 0;

        for (int i = 2; i < n; i++) {
            point ab(a[p[i - 1]], a[p[i - 2]]);
            point bc(a[p[i - 1]], a[p[i]]);

            // cout << (ab % bc) << endl;

            if ((ab % bc) > 0) {
                cur++;
            }
        }

        int op = 0, cnt = 0;

        int mx = -1;
        vector<int> ans;

        while (cnt < N) {
            int i = rnd() % n;
            int j = rnd() % n;
            if (i == j) continue;

            cnt++;

            int nc = 0;
            swap(a[i], a[j]);

            for (int i = 2; i < n; i++) {
                point ab(a[p[i - 1]], a[p[i - 2]]);
                point bc(a[p[i - 1]], a[p[i]]);

                // cout << (ab % bc) << endl;

                if ((ab % bc) > 0) {
                    nc++;
                }
            }

            double r = (double) (rnd() % N) / (double) N;

            t *= dl;

            if (nc >= cur || r < t) {
                cur = nc;
            } else {
                swap(a[i], a[j]);
                op++;
            }

            if (cur > mx) {
                mx = cur;
                ans = p;
            }

            if (op > A) {
                shuffle(p.begin(), p.end(), rng);

                t = 1.0, dl = 0.9999;
                cur = 0;

                for (int i = 2; i < n; i++) {
                    point ab(a[p[i - 1]], a[p[i - 2]]);
                    point bc(a[p[i - 1]], a[p[i]]);

                    // cout << (ab % bc) << endl;

                    if ((ab % bc) > 0) {
                        cur++;
                    }
                }
                op = 0;
            }

        }

        // cout << mx << endl;

        for (auto el : ans) cout << el + 1 << " ";
        cout << endl;

        // sort(p.begin(), p.end(), [&](point i, point j) {
        //     return (i.x < j.x);
        // });

        // vector<int> ans;
        // int cur = -1;

        // int tm = 0;
        // for (int _ = 0; _ < N / n; _++) {
        //     tm = 0;
        //     for (int i = 2; i < n; i++) {
        //         point ab(a[p[i - 1]], a[p[i - 2]]);
        //         point bc(a[p[i - 1]], a[p[i]]);

        //         // cout << (ab % bc) << endl;

        //         if ((ab % bc) > 0) {
        //             tm++;
        //         }
        //     }

        //     if (tm > cur) {
        //         cur = tm;
        //         ans = p;
        //     }

        //     shuffle(p.begin(), p.end(), rng);
        // }

        // // cout << cur << endl;
        // for (auto el : ans) cout << el + 1 << " ";
        // cout << endl;
    } else if (task == 2) {
        int c; cin >> c;

    } else if (task == 3) {
        int c; cin >> c;
        vector<int> ans = {1, n};
        vector<int> ord;
        for (int i = 0; i < n; i++) {
            if (i & 1) ord.push_back(n - i / 2);
            else ord.push_back(i / 2 + 1);
        }

        // cout << ord << endl;
        int q; cin >> q;
        // cout << q << endl;
        while (q --> 0) {
            int k; cin >> k;
            int g = 1 + k;
            // cout << k << endl;
            auto ans = ord;
            if (ord[g - 2] < ord[g - 1]) {
                sort(ans.begin() + g, ans.end());
                reverse(ans.begin() + g, ans.end());
            } else {
                sort(ans.begin() + g, ans.end());
            }

            cout << ans << endl;
        }
    }
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}