#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;

struct Point {
    int x, y;
};

Point operator-(const Point &a, const Point &b) {
    return {a.x - b.x, a.y - b.y};
}

Point operator+(const Point &a, const Point &b) {
    return {a.x + b.x, a.y + b.y};
}

long long operator*(const Point &a, const Point &b) {
    return a.x * b.x + a.y * b.y;
}

long long operator^(const Point &a, const Point &b) {
    return a.x * b.y + a.y * b.x;
}

bool is_good_angle(const Point &a, const Point &b, const Point &c) {
    return (b - a) * (c - b) < 0;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int task, group, n;
    cin >> task >> group >> n;
    vector<Point> A(n);
    for (auto &p: A) {
        cin >> p.x >> p.y;
    }

    vector<int> cur, best;
    int best_val;
    for (int i = 0; i < n; i++) cur.push_back(i);

    do {
        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
        }
        if (sharp > best_val) {
            best_val = sharp;
            best = cur;
        }
    } while (next_permutation(cur.begin(), cur.end()));

    for (int x: best) {
        cout << x + 1 << " ";
    }
    return 0;
}
/*
1 0
4
2 3
1 8
4 2
0 0
*/