    #include <bits/stdc++.h>

    #pragma GCC optimize("O3", "unroll-loops", "inline")
    #pragma GCC target("popcnt")
    using namespace std;
    #define int long long
    mt19937 rnd(42);
    auto start = clock();
    struct Point {
        int x, y;
    };

    int n;
    vector<Point> A;


    Point operator-(const Point &a, const Point &b) {
        return {a.x - b.x, a.y - b.y};
    }

    Point operator+(const Point &a, const Point &b) {
        return {a.x + b.x, a.y + b.y};
    }

    int operator*(const Point &a, const Point &b) {
        return a.x * b.x + a.y * b.y;
    }

    int operator^(const Point &a, const Point &b) {
        return a.x * b.y + a.y * b.x;
    }

    bool is_good_angle(const Point &a, const Point &b, const Point &c) {
        return (b - a) * (c - b) < 0;
    }

    void solve_1() {
        vector<int> cur;
        for (int i = 0; i < n; i++) cur.push_back(i);

        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
        }
        vector<int> best = cur;
        int best_val = sharp;

        while (clock() - start < 1.95 * CLOCKS_PER_SEC) {
            int i = rnd() % n, j = rnd() % n;
            int new_sharp = sharp;
            set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }
            swap(cur[i], cur[j]);
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }

            if (new_sharp > sharp) {
                sharp = new_sharp;
                if (sharp > best_val) {
                    best_val = sharp;
                    best = cur;
                }
            } else {
                swap(cur[i], cur[j]);
            }
        }

        for (int x: best) {
            cout << x + 1 << " ";
        }
    }

    void solve_2() {
        int c;
        cin >> c;
        vector<int> cur;
        for (int i = 0; i < n; i++) cur.push_back(i);

        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
        }
        vector<int> best = cur;
        int best_val = sharp;
        int unchanged = 0;

        while (clock() - start < 1.95 * CLOCKS_PER_SEC) {
            int i = rnd() % n, j = rnd() % n;
            int new_sharp = sharp;
            set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }
            swap(cur[i], cur[j]);
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }

            if (new_sharp < sharp) {
                unchanged = 0;
                sharp = new_sharp;
                if (sharp < best_val) {
                    best_val = sharp;
                    best = cur;
                }
            } else {
                unchanged++;
                swap(cur[i], cur[j]);
            }
            if (unchanged > 500) {
                shuffle(cur.begin(), cur.end(), rnd);
                sharp = 0;
                for (int i = 1; i < n - 1; i++) {
                    sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
                }
            }
        }

        for (int x: best) {
            cout << x + 1 << " ";
        }
    }

    void solve_3() {
        int LIM;
        cin >> LIM;
        int q;
        cin >> q;
        vector<int> cur;
        for (int i = 0; i < n; i++) cur.push_back(i);

        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
        }
        vector<int> best = cur;
        int best_val = sharp;
        int unchanged = 0;
        while (q--) {
            int c;
            cin >> c;

            while (best_val != c) {
                int i = rnd() % n, j = rnd() % n;
                int new_sharp = sharp;
                set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
                for (int p: P) {
                    if (1 <= p && p <= n - 2) {
                        new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                    }
                }
                swap(cur[i], cur[j]);
                for (int p: P) {
                    if (1 <= p && p <= n - 2) {
                        new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                    }
                }

                if (abs(new_sharp - c) < abs(sharp - c)) {
                    unchanged = 0;
                    sharp = new_sharp;
                    if (abs(sharp - c) < abs(best_val - c)) {
                        best_val = sharp;
                        best = cur;
                    }
                } else {
                    unchanged++;
                    swap(cur[i], cur[j]);
                }
                if (unchanged > n) {
                    shuffle(cur.begin(), cur.end(), rnd);
                    sharp = 0;
                    for (int i = 1; i < n - 1; i++) {
                        sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
                    }
                }
            }
            for (int x: best) {
                cout << x + 1 << " ";
            }
            cout << endl;
        }
    }

    int32_t main() {
        ios_base::sync_with_stdio(false);
        cin.tie(0);


        int task, group;
        cin >> task >> group >> n;
        A.resize(n);
        for (auto &p: A) {
            cin >> p.x >> p.y;
        }
        if (task == 1) {
            solve_1();
        } else if (task == 2) {
            solve_2();
        } else if (task == 3) {
            solve_3();
        }
        return 0;
    }
    /*
    1 0
    4
    2 3
    1 8
    4 2
    0 0

    2 0
    5
    -2 0
    -1 -1
    0 1
    2 -2
    3 -3
    2

    3 0
    6
    0 0
    1 1
    2 2
    3 -3
    4 -2
    5 -1
    2
    3
    2

    3

    4
    */