#include <bits/stdc++.h>

//#pragma GCC optimize("O3", "unroll-loops", "inline")
//#pragma GCC target("popcnt")
using namespace std;
#define int long long
mt19937 rnd(46);
auto start = clock();
struct Point {
    int x, y;
};

int n;
vector<Point> A;


Point operator-(const Point &a, const Point &b) {
    return {a.x - b.x, a.y - b.y};
}

Point operator+(const Point &a, const Point &b) {
    return {a.x + b.x, a.y + b.y};
}

int operator*(const Point &a, const Point &b) {
    return a.x * b.x + a.y * b.y;
}

int operator^(const Point &a, const Point &b) {
    return a.x * b.y + a.y * b.x;
}

bool is_good_angle(const Point &a, const Point &b, const Point &c) {
    return (b - a) * (c - b) < 0;
}

void solve_1(bool are_incr) {
    if (are_incr) {
        for (int i = 0; i < (n + 1) / 2; i++) {
            cout << i + 1 << " ";
            if (n - i - 1 != i) cout << n - i << " ";
        }
        return;
    }


    vector<int> cur;
    for (int i = 0; i < n; i++) cur.push_back(i);

    int sharp = 0;
    for (int i = 1; i < n - 1; i++) {
        sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
    }
    vector<int> best = cur;
    int best_val = sharp;

    while (clock() - start < 1.95 * CLOCKS_PER_SEC) {
        int i = rnd() % n, j = rnd() % n;
        int new_sharp = sharp;
        set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
        for (int p: P) {
            if (1 <= p && p <= n - 2) {
                new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
            }
        }
        swap(cur[i], cur[j]);
        for (int p: P) {
            if (1 <= p && p <= n - 2) {
                new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
            }
        }

        if (new_sharp > sharp) {
            sharp = new_sharp;
            if (sharp > best_val) {
                best_val = sharp;
                best = cur;
            }
        } else {
            swap(cur[i], cur[j]);
        }
    }

    for (int x: best) {
        cout << x + 1 << " ";
    }
}

void solve_2() {
    int c;
    cin >> c;
    while (true) {
        vector<bool> used(n);
        vector<int> order(n);
        for (int i = 0; i < n; i++) order[i] = i;
        shuffle(order.begin(), order.end(), rnd);
        vector<int> cur = {order[0], order[1]};
        used[order[0]] = used[order[1]] = true;
        while (cur.size() != n) {
            bool added_anything = false;
            int something = -1;
            for (int i: order) {
                if (!used[i]) {
                    if (!is_good_angle(A[cur[cur.size() - 2]], A[cur[cur.size() - 1]], A[i])) {
                        cur.push_back(i);
                        used[i] = true;
                        added_anything = true;
                    } else {
                        something = i;
                    }
                }
            }
            if (!added_anything) {
                cur.push_back(something);
                used[something] = true;
            }
        }
        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
        }
        if (sharp <= c) {
            for (int x: cur) {
                cout << x + 1 << " ";
            }
            break;
        }
    }
}

void solve_3(bool are_incr) {
    int LIM;
    cin >> LIM;
    int q;
    cin >> q;
    if (are_incr) {
        while (q--) {
            int c;
            cin >> c;
            vector<int> cur = {0, n - 1};
            bool flag = false;
            vector<bool> used(n);
            used[0] = used[n - 1] = true;
            for (int i = 1; i < (n + 1) / 2; i++) {
                if (c == 1) break;
                cur.push_back(i);
                used[i] = true;
                flag = false;
                c -= is_good_angle(A[cur[cur.size() - 3]], A[cur[cur.size() - 2]], A[cur[cur.size() - 1]]);
                if (c == 1) break;
                if (n - i - 1 != i) {
                    cur.push_back(n - i - 1);
                    used[n - i - 1] = true;
                    c -= is_good_angle(A[cur[cur.size() - 3]], A[cur[cur.size() - 2]], A[cur[cur.size() - 1]]);
                    flag = true;
                }
            }
            if (flag) {
                for (int i = n - 1; i >= 0; i--) {
                    if (!used[i]) cur.push_back(i);
                }
            } else {
                for (int i = 0; i < n; i++) {
                    if (!used[i]) cur.push_back(i);
                }
            }
            for (int x: cur) {
                cout << x + 1 << " ";
            }
            cout << endl;
//            int sharp = 0;
//            for (int i = 1; i < n - 1; i++) {
//                sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
//            }
//            cout << "!" << sharp << endl;
        }
        return;
    }

    vector<int> cur;
    for (int i = 0; i < n; i++) cur.push_back(i);

    int sharp = 0;
    for (int i = 1; i < n - 1; i++) {
        sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
    }
    vector<int> best = cur;
    int best_val = sharp;
    int unchanged = 0;
    while (q--) {
        int c;
        cin >> c;

        while (best_val != c) {
            int i = rnd() % n, j = rnd() % n;
            if (i == j) continue;
            int new_sharp = sharp;
            set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }
            swap(cur[i], cur[j]);
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }

            if (abs(new_sharp - c) < abs(sharp - c)) {
                unchanged = 0;
                sharp = new_sharp;
                if (abs(sharp - c) < abs(best_val - c)) {
                    best_val = sharp;
                    best = cur;
                }
            } else {
                unchanged++;
                swap(cur[i], cur[j]);
            }
            if (unchanged > n * 25) {
                shuffle(cur.begin(), cur.end(), rnd);
                sharp = 0;
                for (int i = 1; i < n - 1; i++) {
                    sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
                }
            }
        }
        for (int x: best) {
            cout << x + 1 << " ";
        }
        cout << endl;
    }
}


void solve_4() {
    const int b = 1e6 + 3, m = 1e9 + 7;
    vector<int> power(n + 1);
    power[0] = 1;
    for (int i = 1; i <= n; i++) power[i] = power[i - 1] * b % m;
    int LIM;
    cin >> LIM;

    vector<int> cur;
    for (int i = 0; i < n; i++) cur.push_back(i);

    int sharp = 0;
    for (int i = 1; i < n - 1; i++) {
        sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
    }
    vector<int> best = cur;
    int best_val = sharp;
    int unchanged = 0;
    map<int, vector<int>> ans;
    for (int c = LIM; c <= n - LIM; c++) {
        while (best_val != c) {
            int i = rnd() % n, j = rnd() % n;
            if (i == j) continue;
            int new_sharp = sharp;
            set<int> P = {i - 1, i, i + 1, j - 1, j, j + 1};
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp -= is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }
            swap(cur[i], cur[j]);
            for (int p: P) {
                if (1 <= p && p <= n - 2) {
                    new_sharp += is_good_angle(A[cur[p - 1]], A[cur[p]], A[cur[p + 1]]);
                }
            }

            if (abs(new_sharp - c) < abs(sharp - c)) {
                unchanged = 0;
                sharp = new_sharp;
                if (abs(sharp - c) < abs(best_val - c)) {
                    best_val = sharp;
                    best = cur;
                }
            } else {
                unchanged++;
                swap(cur[i], cur[j]);
            }
            if (unchanged > n * 25) {
                shuffle(cur.begin(), cur.end(), rnd);
                sharp = 0;
                for (int i = 1; i < n - 1; i++) {
                    sharp += is_good_angle(A[cur[i - 1]], A[cur[i]], A[cur[i + 1]]);
                }
            }
        }
        ans[c] = best;
    }
    for (auto &p: ans) {
        int h = 0;
        for (int i = 0; i < n; i++) {
            h = (h + (p.second[i] + 1) * power[i]) % m;
        }
        cout << h << " ";
    }
    cout << endl;
    int q;
    cin >> q;
    while (q--) {
        int c;
        cin >> c;
        for (int x: ans[c]) {
            cout << x + 1 << " ";
        }
        cout << endl;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);


    int task, group;
    cin >> task >> group >> n;
    A.resize(n);
    for (auto &p: A) {
        cin >> p.x >> p.y;
    }
    if (task == 1) {
        solve_1(group == 1);
    } else if (task == 2) {
        solve_2();
    } else if (task == 3) {
        solve_3(group == 7);
    } else {
        solve_4();
    }
    return 0;
}
/*
1 0
4
2 3
1 8
4 2
0 0

2 0
5
-2 0
-1 -1
0 1
2 -2
3 -3
2

3 0
6
0 0
1 1
2 2
3 -3
4 -2
5 -1
2
3
2

3

4


3 7
6
0 0
1 1
2 2
3 3
4 4
5 5
2
3
2

3

4



4 0
5
-2 -1
-1 1
1 6
0 -3
2 0
2

2
2

3

*/