#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ff first
#define sc second

struct V {
    double x, y;
    V() = default;
    V(double x_, double y_) {
        x = x_;
        y =y_;
    }
};

V operator-(V a, V b) {
    return V(a.x - b.x, a.y - b.y);
}

double operator%(V a, V b) {
    return a.x * b.y - a.y * b.x;
}

double operator*(V a, V b) {
    return a.x * b.x + a.y * b.y;
}

double angle(V a, V b) {
    double ans = atan2(a % b, a * b) * 180 / M_PI;
    if (ans < 0) ans += 360;
    return min(ans, 360 - ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);

    int task, group; cin >> task >> group;
    int n; cin >> n;
    vector<pair<int, int>> pts(n);
    vector<V> a(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].ff >> pts[i].sc;
        a[i] = V(pts[i].ff, pts[i].sc);
    }
    if (task == 1) {
        if (group == 1) {
            for (int i = 0; i < n; i++) {
                if (i % 2 == 0) {
                    cout << i / 2 + 1 << ' ';
                } else {
                    cout << n - i / 2 << ' ';
                }
            }
            cout << endl;
            return 0;
        }
        else {
            vector<int> best;
            int BA = 0;
            for (int run = 0; run < 5; run++) {
            vector<int> newp(n);
            mt19937 rnd(time(NULL));
            vector<int> p(n);
            iota(all(p), 0);
            random_shuffle(all(p));
            int ans = 0;
            for (int i = 1; i <n - 1; i++) {
                ans += (angle(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) < 90);
            }
            int N = 0;
            double t = 1;
            auto r01 = [&]() {
                return (double)(rnd()%INT_MAX) / (double)INT_MAX;
            };
            while (N < 2e6) {
                N++;
                t *= 0.99;
                int l = rnd() % n, r = rnd() % n;
                if (l > r) swap(l, r);
                int cntt = ans;
                if (l != r) {
                    if (l > 0) {
                        cntt -= (angle(a[p[l - 1]] - a[p[l]], a[p[l + 1]] - a[p[l]]) < 90);
                        if (r != n - 1) {
                            cntt += (angle(a[p[r + 1]] - a[p[l]], a[p[l + 1 ]] - a[p[l]]) < 90);
                        }
                    }
                    if (r != n - 1) {
                        cntt -= (angle(a[p[r - 1]] - a[p[r]], a[p[r + 1]] - a[p[r]]) < 90);
                        if (l != 0) {
                            cntt += (angle(a[p[r]] - a[p[l - 1]], a[p[r - 1]] - a[p[r]]) < 90);
                        }
                    }
                }
                if (cntt > ans) {
                    for (int i  =0; i < n; i++) {
                        if (l <= i && i <= r) newp[i] = p[r - (i - l)];
                        else newp[i] = p[i];
                    }
                    swap(p, newp);
                    swap(ans, cntt);
                }
            }
            if (ans > BA) {
                BA = ans;
                best = p;
            }
            }
            for (auto &u : best) cout << u + 1 << ' ';
            cout << endl;
        }
    } else if (task == 2) {
        vector<int> newp(n);
            mt19937 rnd(time(NULL));
            vector<int> p(n);
            iota(all(p), 0);
            random_shuffle(all(p));
            int ans = 0;
            for (int i = 1; i <n - 1; i++) {
                ans += (angle(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) < 90);
            }
            int N = 0;
            double t = 1;
            auto r01 = [&]() {
                return (double)(rnd()%INT_MAX) / (double)INT_MAX;
            };
            while (N < 1e6) {
                N++;
                t *= 0.99;
                int l = rnd() % n, r = rnd() % n;
                if (l > r) swap(l, r);
                int cntt = ans;
                if (l != r) {
                    if (l > 0) {
                        cntt -= (angle(a[p[l - 1]] - a[p[l]], a[p[l + 1]] - a[p[l]]) < 90);
                        if (r != n - 1) {
                            cntt += (angle(a[p[r + 1]] - a[p[l]], a[p[l + 1 ]] - a[p[l]]) < 90);
                        }
                    }
                    if (r != n - 1) {
                        cntt -= (angle(a[p[r - 1]] - a[p[r]], a[p[r + 1]] - a[p[r]]) < 90);
                        if (l != 0) {
                            cntt += (angle(a[p[r]] - a[p[l - 1]], a[p[r - 1]] - a[p[r]]) < 90);
                        }
                    }
                }
                if (cntt < ans) {
                    for (int i  =0; i < n; i++) {
                        if (l <= i && i <= r) newp[i] = p[r - (i - l)];
                        else newp[i] = p[i];
                    }
                    swap(p, newp);
                    swap(ans, cntt);
                }
            }
            for (auto &u : p) cout << u + 1 << ' ';
            cout << endl;
     } else if (task == 3) {
        int c; cin >> c;
        int q; cin >> q;
        if (group == 7) {
        while (q--) {
            int k; cin >> k;
            int N = k + 1;
            for (int i = n - 1; i >= N; i--) cout << i + 1 << ' ';
            for (int i = 0; i < N; i++) {
                if (i % 2 == 0) {
                    cout << i / 2 + 1 << ' ';
                } else {
                    cout << N - i / 2 << ' ';
                }
            }
            cout << endl;
        }
        } else {
            mt19937 rnd(time(NULL));
            vector<int> p(n);
            iota(all(p), 0);
            vector<vector<int>> ans(n + 1);
            for (int i = 0; i < 5e5; i++) {
                random_shuffle(all(p));
                int A = 0;
                for (int i = 1; i < n - 1; i++) {
                    A += (angle(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) < 90);
                }
                ans[A] = p;
            }
            
            while(q--) {
                int K; cin >> K;
                if (ans[K].size() > 0) {
                    for (auto &u : ans[K]) cout << u + 1 << ' ';
                    cout << endl;
                    continue;
                }
                vector<int> p(n);
            iota(all(p), 0);
            random_shuffle(all(p));
            int ans = 0;
            for (int i = 1; i <n - 1; i++) {
                ans += (angle(a[p[i - 1]] - a[p[i]], a[p[i + 1]] - a[p[i]]) < 90);
            }
            int N = 0;
            double t = 1;
            auto r01 = [&]() {
                return (double)(rnd()%INT_MAX) / (double)INT_MAX;
            };
            while (ans != K && N < 5e5) {
                N++;
                t *= 0.99;
                int l = rnd() % n, r = rnd() % n;
                if (l > r) swap(l, r);
                vector<int> newp(n);
                for (int j = 0; j < n; j++) {
                    if (l <= j && j <= r) newp[j] = p[r - (j - l)];
                    else newp[j] = p[j];
                }
                int cntt = 0;
                for (int i = 1; i <n - 1; i++) {
                    cntt += (angle(a[newp[i - 1]] - a[newp[i]], a[newp[i + 1]] - a[newp[i]]) < 90);
                }
                if (abs(cntt - K) < abs(ans - K) || r01() < exp((abs(cntt - K) - abs(ans - K) ) * t)) {
                    swap(newp, p);
                    swap(ans, cntt);
                }
            }
            for (auto &u : p) cout << u + 1 << ' ';
            cout << endl;
            }
        }
    }
}