#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7;
const ll INFll = 1e18;
const ll M1 = 1e9 + 7, M2 = 1e9 + 9;
const ll P1 = 137, P2 = 239;
const ld PI = atan2(0, -1), EPS = 1e-10;

struct Point {
	ll x, y;
	Point(ll x1 = 0, ll y1 = 0) {
		x = x1;
		y = y1;
	}
};

istream& operator >>(istream& in, Point& A) {
	in >> A.x >> A.y;
	return in;
}

ostream& operator <<(ostream& out, Point& A) {
	out << A.x << A.y;
	return out;
}

struct Vector {
	ll x, y;
	ll len_2;
	Vector(ll x1 = 0, ll y1 = 0) {
		x = x1;
		y = y1;
		len_2 = x1 * x1 + y1 * y1;
	}
};

Vector operator -(Point A, Point B) {
	return Vector(A.x - B.x, A.y - B.y);
}

ll operator *(Vector a, Vector b) {
	return a.x * b.x + a.y * b.y;
}

bool f(Point A, Point B, Point C) {
	Vector ba = B - A, bc = B - C;
	ll res = ba * bc;
	if (res > 0) {
		return true;
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("i.txt", "r", stdin), freopen("o.txt", "w", stdout);

	//cout << fixed << setprecision(20);

	int task, group, n;
	cin >> task >> group >> n;
	vector<pair<Point, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
	}
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	int max_x = 0;
	vector<int> ans;
	do
	{
		int x = 0;
		for (int i = 1; i < n - 1; ++i) {
			if (f(a[p[i - 1]].first, a[p[i]].first, a[p[i + 1]].first)) {
				x++;
			}
		}
		if (x > max_x) {
			max_x = x;
			ans = p;
		}
	} while (next_permutation(p.begin(), p.end()));
	for (auto x : ans) {
		cout << a[x].second + 1 << " ";
	}
}