#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
//#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;
typedef long double ld;

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 8E4, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr uint32_t MAXC = 2E4;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t RND_SEED = 7200;
mt19937_64 rnd(RND_SEED);

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Vec
{
	int64_t x, y;
	Vec(int64_t x = 0, int64_t y = 0) : x(x), y(y) {}
	Vec(Vec& beg, Vec& end) :x(end.x - beg.x), y(end.y - beg.y) {}
	Vec operator+ (const Vec& v) const
	{
		return Vec(x + v.x, y + v.y);
	}
	Vec operator+= (const Vec& v)
	{
		return *this = *this + v;
	}
	Vec operator- () const
	{
		return Vec(-x, -y);
	}
	Vec operator- (const Vec& v) const
	{
		return Vec(x - v.x, y - v.y);
	}
	Vec operator-=(const Vec& v)
	{
		return *this = *this - v;
	}
	int64_t operator* (const Vec& v) const
	{
		return x * v.x + y * v.y;
	}
	int64_t operator% (const Vec& v) const
	{
		return x * v.y - y * v.x;
	}
};
istream& operator>> (istream& in, Vec& v)
{
	in >> v.x >> v.y;
	return in;
}

int task, group;

vector <int> ans_per, cur_per;
int ans = 0, cur = 0;
bool used[10];

int n;
Vec mas[MAXN];
void per(int nab)
{
	if (nab == n)
	{
		if (rmax(ans, cur))
		{
			ans_per = cur_per;
		}
		return;
	}
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			bool dop = false;
			if (cur_per.size() > 1 and Vec(mas[cur_per[cur_per.size() - 2]], mas[cur_per.back()]) * Vec(mas[cur_per.back()], mas[i]) < 0)
			{
				dop = true;
			}
			used[i] = true;
			cur += dop;
			cur_per.push_back(i);
			per(nab + 1);
			cur_per.pop_back();
			cur -= dop;
			used[i] = false;
		}
	}
}

int check(vector <int>& t_per)
{
	int ans = 0;
	for (int i = 0; i < n - 2; i++)
	{
		ans += Vec(mas[t_per[i]], mas[t_per[i + 1]]) * Vec(mas[t_per[i + 1]], mas[t_per[i + 2]]) < 0;
	}
	return ans;
}

void solve()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
	}
	
	if (task == 1)
	{
		if (n <= 10)
		{
			per(0);
			for (int i = 0; i < n; i++)
			{
				cout << ans_per[i] + 1 << ' ';
			}
		}
		else
		{
			bool voz = true;
			for (int i = 0; i < n - 1; i++)
			{
				if (mas[i].x >= mas[i + 1].x or mas[i].y >= mas[i + 1].y)
				{
					voz = false;
					break;
				}
			}
			if (voz)
			{
				cout << "1 3 2 ";
				int cur = 2;
				while (cur + 3 <= n)
				{
					cout << cur + 3 << ' ' << cur + 2 << ' ';
					cur += 2;
				}
				if (cur + 2 <= n)
				{
					cout << cur + 2;
				}
			}
			else
			{
				constexpr int64_t TL = 1.9E9;
				int64_t begin_time = current_time;
				vector <int> t_per(n);
				for (int i = 0; i < n; i++)
				{
					t_per[i] = i;
				}
				int t_ans = check(t_per);
				ld temp = 1, cool = 0.999;
				uniform_real_distribution <ld> rnd_db(0, 1);
				while (current_time - begin_time < TL)
				{
					int l = rnd() % n, r = l + rnd() % (n - l + 1);
					reverse(t_per.begin() + l, t_per.begin() + r);
					int n_ans = check(t_per);
					if (n_ans > ans or rnd_db(rnd) < expl((n_ans - ans) / temp))
					{
						ans = n_ans;
					}
					else
					{
						reverse(t_per.begin() + l, t_per.begin() + r);
					}

					temp *= cool;
				}

				for (int i = 0; i < n; i++)
				{
					cout << t_per[i] + 1 << ' ';
				}
			}
		}
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	cin >> task >> group;
	while (t--)
	{
		solve();
		cout << endl;
	}
}