//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

const int MAXN = 20003, LOGN = 18, LOGV = 30;

const ll INF = 1ll << 30;

struct vec {
    ll x = 0, y = 0;

    vec() = default;

    vec(ll X, ll Y) {
        x = X, y = Y;
    }

    vec operator-() {
        return vec() - *this;
    }

    vec operator+(vec B) {
        return {x + B.x, y + B.y};
    }

    vec operator-(vec B) {
        return {x - B.x, y - B.y};
    }

    ll operator*(vec B) {
        return (x * B.x + y * B.y);
    }
};

bool son(vec A, vec B) {
    return (A * B) > 0;
}

mt19937 rnd(238545);

vector<vec> a;

void fail() {
    cout << "Oops" << endl;
    exit(0);
}

void initTr(vector<int> &p) {
    p.clear();
    int ta, tb, tc;
    int n = a.size();
    ta = rnd() % n;
    do {
        tb = rnd() % n;
    } while (tb == ta);
    do {
        tc = rnd() % n;
    } while (tc == ta || tc == tb);
    p = {ta, tb, tc};

    for (int i = 0; i < 3; ++i) {
        int ai = (i + 1) % 3, bi = (i + 2) % 3, ci = i;
        if (son(a[p[ai]] - a[p[bi]], a[p[ci]] - a[p[bi]])) {
            p = {ci, bi, ai};
            return;
        }
    }
    fail();
}

void solve() {
    int n, gi, ti;
    cin >> ti >> gi >> n;
    a.resize(n);
    for (auto &i: a)
        cin >> i.x >> i.y;
    vector<int> p;
    bitset<MAXN> used;
    int ta, tb, tc;


    while (p.size() < n) {
        if (p.size() < 3) {
            used.reset();
            initTr(p);
            used[p[0]] = used[p[1]] = used[p[2]] = true;

        }

        int opCnt = 0;
        int cn = p.size();
        ta = p[cn - 1], tb = p[cn - 2], tc = p[cn - 3];

        do {
            opCnt++;
            int nx = rnd() % n;
            if (used[nx])
                continue;
            if (son(a[nx] - a[ta], a[tb] - a[ta])) {
                p.push_back(nx);
                used[nx] = true;
                break;
            }
            if (son(a[tc] - a[tb], a[nx] - a[tb])) {
                p.back() = nx;
                p.push_back(ta);
                used[nx] = true;
                break;
            }

        } while (opCnt < 5 * n);
        if (opCnt >= 5 * n) {
            p.pop_back();
        }

    }
    for (auto i: p)
        cout << i + 1 << ' ';
    cout << endl;

}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
