#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
mt19937 rnd(1337);
struct point{
    ll x, y, id;
};
bool operator <(point a, point b) {
    return tie(a.x, a.y) < tie(b.x, b.y);
}
point operator -(point a, point b) {
    return {a.x - b.x, a.y - b.y, a.id};
}
ll pse(point a, point b) {
    return a.x * b.y - a.y * b.x;
}
ll sca(point a, point b) {
    return a.x * b.x + a.y * b.y;
}
const ld PI = acos(-1);
bool deg(point a, point b) {
    return abs(atan2(pse(a, b), sca(a, b))) <= PI / 2.0;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<point> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        p[i].id = i;
    }
    if (task == 2) {
        int c;
        cin >> c;
        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        shuffle(order.begin(), order.end(), rnd);
        auto count = [&] () -> int {
            int res = 0;
            for (int i = 1; i + 1 < n; i++) {
                res += deg(p[order[i+1]] - p[order[i]], p[order[i-1]] - p[order[i]]);
            }
            return res;
        };
        for (; count() > c;) {
            int t = count();
            int x = rnd() % n;
            int y = rnd() % n;
            if (x > y) swap(x, y);
            reverse(order.begin() + x, order.end() + y + 1);
            if (count() > t) {
                reverse(order.begin() + x, order.end() + y + 1);
            }
        }
        for (int i = 0; i < n; i++) cout << order[i] + 1 << " ";
        cout << endl;
        return 0;
    } else {
        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        sort(order.begin(), order.end(), [&](int a, int b) {return p[a] < p[b];});
        auto count = [&] () -> int {
            int res = 0;
            for (int i = 1; i + 1 < n; i++) {
                res += deg(p[order[i+1]] - p[order[i]], p[order[i-1]] - p[order[i]]);
            }
            return res;
        };
        for (int iter = 0; iter < 1000; iter++) {
            int t = count();
            int x = rnd() % n;
            int y = rnd() % n;
            swap(order[x], order[y]);
            if (count() < t) swap(order[x], order[y]);
        }
        for (int i = 0; i < n; i++) cout << order[i] + 1 << " ";
        cout << endl;
        return 0;
    }
}
