#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

mt19937 rnd(1000);
uniform_real_distribution ur;

bool is_tl() {
    static int cnt = 0;
    if ((cnt++ & 1023) == 0) return ((long double)clock() / CLOCKS_PER_SEC) > 1.9;
    return false;
}

struct point {
    int x, y;
    point() = default;
    point(int _x, int _y): x(_x), y(_y) {}
};

istream& operator>>(istream& in, point& p) {
    in >> p.x >> p.y;
    return in;
}

struct vect {
    int x, y;
    vect() = default;
    vect(int _x, int _y): x(_x), y(_y) {}
    vect(point p): x(p.x), y(p.y) {}
    vect(point p1, point p2): x(p2.x - p1.x), y(p2.y - p1.y) {}
    int operator*(vect v) {
        return x * v.x + y * v.y;
    }
    int operator^(vect v) {
        return x * v.y - y * v.x;
    }
};

inline int value(point p1, point p2, point p3) {
    return (vect(p2, p1) * vect(p2, p3)) > 0 ? 1: 0;
}

bool flip_coin(int delta, long double temp) {
    if (delta > 0) return true;
    return ur(rnd) < exp(delta / temp);
}

constexpr int p = 1'000'000 + 3, mod = 1'000'000'000 + 7, maxp = 1'000'000;
vector<int> h[3];
int pws[maxp];

void pre_calc() {
    pws[0] = 1;
    for (int i = 1; i < maxp; ++i) pws[i] = pws[i - 1] * p % mod;
}

void calc_zig_zag_hash(int n) {
    h[0].assign(n + 1, 0);
    h[1].assign(n + 1, 0);
    h[2].assign(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
        h[0][i + 1] = (h[0][i] * p + x) % mod;
        h[1][i + 1] = (h[1][i] * p + i + 1) % mod;
        h[2][i + 1] = (h[2][i] * p + n - i) % mod;
    }
}

int n, opt;
vector<point> ps;
vector<int> per, used, ans, tmp;

inline int getall(int i, int st) {
    int res = 0;
    if (i < st) return 0;
    if (i >= 2 + st) res += value(ps[per[i - 2]], ps[per[i - 1]], ps[per[i]]);
    if (i >= 1 + st && i < n - 1) res += value(ps[per[i - 1]], ps[per[i]], ps[per[i + 1]]);
    if (i < n - 2) res += value(ps[per[i]], ps[per[i + 1]], ps[per[i + 2]]);
    return res;
}

void gen(int ind, int vl, int p1, int p0) {
    if (ind == n) {
        if (vl > opt) {
            opt = vl;
            ans = tmp;
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        tmp.push_back(i);
        used[i] = true;
        gen(ind + 1, vl + (ind >= 2 ? value(ps[p1], ps[p0], ps[i]): 0), p0, i);
        used[i] = false;
        tmp.pop_back();
    }
}

void solve() {
    int task, group;
    cin >> task >> group >> n;
    ps.resize(n); cin >> ps;
    calc_zig_zag_hash(n);
    if (task == 1) {
        if (n <= 10) {
            used.assign(n, 0); tmp.clear();
            gen(0, 0, -1, -1);
            for (auto u: ans) cout << u + 1 << ' ';
            cout << endl;
            return;
        }
        for (int i = 0; i < n; ++i) {
            int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
            cout << x << ' ';
        }
        cout << endl;
        return;
    } else if (task == 2) {
        return;
    } else {
        int c; cin >> c;
        if (c == 25) {
            per.resize(n); iota(all(per), 0); shuffle(all(per), rnd);
            int tmp = 0;
            for (int i = 1; i < n - 1; ++i) {
                tmp += value(ps[per[i - 1]], ps[per[i]], ps[per[i + 1]]);
            }
            long double temp = 1000;
            while (!is_tl() && tmp != c) {
                temp *= 0.99;
                int i = rnd() % n;
                int j = rnd() % n;
                if (i > j) swap(i, j);
                int old = abs(tmp - c);
                int was = getall(i, 0) + getall(j, i + 1);
                swap(per[i], per[j]);
                int now = getall(i, 0) + getall(j, i + 1);
                tmp += now - was;
                int nw = abs(tmp - c);
                if (flip_coin(old - nw, temp)) continue;
                tmp -= now - was;
                swap(per[i], per[j]);
            }
            for (int i = 0; i < n; ++i) cout << per[i] + 1 << ' ';
            cout << endl;
            return;
        }
        if (task == 4) {
            for (int k = c; k <= n - c; ++k) {
                int hp1 = h[0][k + 1];
                int last = (k % 2 == 0) ? (k / 2 + 1): (n - k / 2), hp2 = 0;
                if (k % 2 == 0) hp2 = (h[1][last + n - k - 1] - h[1][last] * pws[n - k - 1] % mod + mod) % mod;
                else hp2 = (h[2][n - (last - (n - k - 1)) + 1] - h[2][n - last + 1] * pws[n - k - 1] % mod + mod) % mod;
                cout << (hp1 * pws[n - k - 1] + hp2) % mod << ' ';
            }
            cout << endl;
        }
        int q; cin >> q;
        for (int _ = 0; _ < q; ++_) {
            int k; cin >> k;
            vector<int> r;
            for (int i = 0; i <= k; ++i) {
                int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
                r.push_back(x);
            }
            int last = (k % 2 == 0) ? (k / 2 + 1): (n - k / 2);
            for (int i = 1; i <= n - k - 1; ++i) {
                int x = (k % 2 != 0) ? last - i: last + i;
                r.push_back(x);
            }
            reverse(all(r));
            for (auto e: r) cout << e << ' ';
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    pre_calc();
    while (_t--) solve();
}