#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()
int task, group;

typedef complex<ll> point;
#define x_ real()
#define y_ imag()

ll cross(const point& p, const point& q) {
    return (conj(p) * q).y_;
}

ll dot(const point& p, const point& q) {
    return (conj(p) * q).x_;
}

bool left_turn(const point& a, const point& b, const point& c) {
    return cross(b - a, c - a) > 0;
}

const int mxN = 80'001;
int n;
point ps[mxN];

int cost(const vector<int>& perm) {
    int res =0;
    for (int i =0; i + 2 < (int)perm.size(); ++i) {
        point cur = ps[perm[(i + 1) % n]] - ps[perm[i]];
        point nxt = ps[perm[(i + 2) % n]] - ps[perm[(i + 1) % n]];
        if (dot(cur, nxt) < 0) {
            res += 1;
        } 
    }
    return res;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> task >> group;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        ps[i] = point(x, y);
    }
    if (task == 1) {
        vector<int> best;
        int best_val = -1;
        vector<int> perm(n);
        iota(in(perm), 0);

        do {
            int cur_val = cost(perm);
            if (cur_val > best_val) {
                best_val = cur_val;
                best = perm;
            }
        } while (next_permutation(in(perm)));
        for (int i : best) {
            cout << i + 1 << ' ';
        }

    }
    exit(0);
    return 0;
}