#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()
int task, group;

typedef complex<ll> point;
#define x_ real()
#define y_ imag()

ll cross(const point& p, const point& q) {
    return (conj(p) * q).y_;
}

ll dot(const point& p, const point& q) {
    return (conj(p) * q).x_;
}

bool left_turn(const point& a, const point& b, const point& c) {
    return cross(b - a, c - a) > 0;
}

const int mxN = 80'001;
int n;
point ps[mxN];

int cost(const vector<int>& perm) {
    int res =0;
    for (int i =0; i + 2 < (int)perm.size(); ++i) {
        point cur = ps[perm[(i + 1) % n]] - ps[perm[i]];
        point nxt = ps[perm[(i + 2) % n]] - ps[perm[(i + 1) % n]];
        if (dot(cur, nxt) < 0) {
            res += 1;
        } 
    }
    return res;
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

double rnd_f() { return double(rand()) / RAND_MAX; }


int main() {
    srand(time(0));
    cin.tie(0)->sync_with_stdio(0);
    cin >> task >> group;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        ps[i] = point(x, y);
    }
    if (task == 1 && group == 1) {
        vector<int> best;
        int i = -1, j = n;
        while (true) {
            i += 1;
            best.push_back(i);
            if (i + 1 >= j) break;
            j -= 1;
            best.push_back(j);
            if (i + 1 >= j) break;
        }

        for (int i : best) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    if (task == 1 && group == 2) {
        vector<int> best;
        int best_val = -1;
        vector<int> perm(n);
        iota(in(perm), 0);

        do {
            int cur_val = cost(perm);
            if (cur_val > best_val) {
                best_val = cur_val;
                best = perm;
            }
        } while (next_permutation(in(perm)));
        for (int i : best) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    if (task == 1) {
        vector<int> best;
        int best_val = -1;
        vector<int> perm(n);
        iota(in(perm), 0);

        // best = perm;
        // best_val = cost(best);
        for (int t = 0; t < 100; ++t) {
            //ll A = rnd(), B = rnd();
            point norm(rnd(), rnd());
            if (t == 0) norm = point(1, 0);
            vector<int> ord(n);
            iota(in(ord), 0);
            sort(in(ord), [&](int i, int j) {
                return dot(norm, ps[i]) < dot(norm, ps[j]);
            });
            perm = ord;
            
            int cur_val = cost(perm);
            if (cur_val > best_val) {
                best_val = cur_val;
                best = perm;
            }
        }



        if (n < 11) {
            do {
            int cur_val = cost(perm);
            if (cur_val > best_val) {
                best_val = cur_val;
                best = perm;
            }
            } while (next_permutation(in(perm)));
        }
        

        

        // for (int t = 0; t < 10'000; ++t) {
        //     shuffle(in(perm), rnd);
        //     int cur_val = cost(perm);
        //     if (cur_val > best_val) {
        //         best_val = cur_val;
        //         best = perm;
        //     }
        // } 
        for (int i : best) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    
    int c;
    cin >> c;
    if (task == 2) {
        vector<int> best;
        int best_val = -1;
        vector<int> perm(n);
        iota(in(perm), 0);

        // best = perm;
        // best_val = cost(best);
        for (int t = 0; t < 200; ++t) {
            //ll A = rnd(), B = rnd();
            point norm(rnd(), rnd());
            if (t == 0) norm = point(1, 0);
            vector<int> ord(n);
            iota(in(ord), 0);
            sort(in(ord), [&](int i, int j) {
                return dot(norm, ps[i]) < dot(norm, ps[j]);
            });
            perm = ord;
            
            int cur_val = cost(perm);
            if (cur_val <= c) {
                best_val = cur_val;
                best = perm;
                break;
            }
        }



        if (n < 11) {
            do {
            int cur_val = cost(perm);
            if (cur_val <= c) {
                best_val = cur_val;
                best = perm;
                break;
            }
            } while (next_permutation(in(perm)));
        }
        

        

        // for (int t = 0; t < 10'000; ++t) {
        //     shuffle(in(perm), rnd);
        //     int cur_val = cost(perm);
        //     if (cur_val > best_val) {
        //         best_val = cur_val;
        //         best = perm;
        //     }
        // } 
        for (int i : best) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    exit(0);
    return 0;
}