#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

const ll COL = 15;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct point {
	ll x, y, id;
	point(ll x = 0, ll y = 0): x(x), y(y) {}
	ll operator*(point p) {
		return x * p.x + y * p.y;
	}
	point operator-(point p) {
		return point(x - p.x, y - p.y);
	}
};

bool check(point p1, point p2) {
	return p1 * p2 > 0;
}

void solve() {
	ll t, g;
	cin >> t >> g;
	ll n;
	cin >> n;
	vector<point> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
		arr[i].id = i;
	}
	shuffle(arr.begin(), arr.end(), rnd);
	if (t == 1) {
		ll vp = 2;
		while (n - vp > COL) {
			bool b = false;
			for (ll j = vp; j < n; j++) {
				swap(arr[vp], arr[j]);
				if (check(arr[vp - 1] - arr[vp], arr[vp - 1] - arr[vp - 2])) {
					b = true;
					break;
				}
			}
			if (!b) {
				shuffle(arr.begin(), arr.end(), rnd);
				continue;
			}
			vp++;
		}
		vp -= 2;
		assign_max(vp, 0ll);
		vector<point> nall;
		while (arr.size() > vp) {
			nall.push_back(arr.back());
			arr.pop_back();
		}
		reverse(nall.begin(), nall.end());
		vector<vector<vector<bool>>> dp(1 << (n - vp), vector<vector<bool>>(n - vp, vector<bool>(n - vp, false)));
		if (n > COL + 2) {
			dp[3][0][1] = true;
		} else {
			for (ll i = 0; i < n; i++) {
				for (ll j = 0; j < n; j++) {
					if (i == j) {
						continue;
					}
					dp[(1 << i) | (1 << j)][i][j] = true;
				}
			}
		}
		for (ll i = 0; i < (1 << (n - vp)); i++) {
			for (ll j = 0; j < n - vp; j++) {
				for (ll k = 0; k < n - vp; k++) {
					if (!dp[i][j][k]) {
						continue;
					}
					for (ll l = 0; l < n - vp; l++) {
						if (!((i >> l) & 1) && check(nall[k] - nall[l], nall[k] - nall[j])) {
							dp[i | (1 << l)][k][l] = true;
						}
					}
				}
			}
		}
		ll l1 = -1, l2 = -1;
		vector<point> narr;
		for (ll i = 0; i < n - vp; i++) {
			for (ll j = 0; j < n - vp; j++) {
				if (dp.back()[i][j]) {
					l1 = i;
					l2 = j;
					narr.push_back(nall[j]);
					break;
				}
			}
			if (l1 != -1) {
				break;
			}
		}
		narr.push_back(nall[l1]);
		assert(l1 != -1);
		ll ni = (1 << (n - vp)) - 1;
		while (ni != ((1 << l1) | (1 << l2))) {
			for (ll k = 0; k < n - vp; k++) {
				if (((ni >> k) & 1) && dp[ni ^ (1 << l2)][k][l1]) {
					narr.push_back(nall[k]);
					ni ^= (1 << l2);
					l2 = l1;
					l1 = k;
					break;
				}
			}
		}
		reverse(narr.begin(), narr.end());
		for (auto i : narr) {
			arr.push_back(i);
		}
		for (auto i : arr) {
			cout << i.id + 1 << ' ';
		}
		cout << '\n';
		return;
	}
	exit(1);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
