#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x=0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;
	vector<Point> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	if (group == 2)
	{
		vector<int> p(n);
		for (int i = 0; i < n; i++) p[i] = i;
		int anss = -INF;
		do
		{
			int ans = 0;
			for (int i = 2; i < n; i++)
			{
				ans += (a[p[i]] - a[p[i - 1]]) * (a[p[i - 1]] - a[p[i - 2]]) < 0;
			}
			if (ans > anss)
			{
				anss = ans;
			}
		} while (next_permutation(p.begin(), p.end()));
		for (int i = 0; i < n; i++) p[i] = i;
		do
		{
			int ans = 0;
			for (int i = 2; i < n; i++)
			{
				ans += (a[p[i]] - a[p[i - 1]]) * (a[p[i - 1]] - a[p[i - 2]]) < 0;
			}
			if (ans == anss)
			{
				for (int i = 0; i < n; i++) cout << p[i] + 1 << ' ';
				cout << endl;
				break;
			}
		} while (next_permutation(p.begin(), p.end()));
	}
	else if (group == 1)
	{
		for (int i = 0; i*2+2<=n;i++)
		{
			cout << 2*i + 2 << ' ';
			cout << 2*i + 1 << ' ';
		}
		if (n % 2 > 0)
		{
			cout << n << ' ';
		}
		cout << endl;
	}
	else if (group == 7)
	{
		int c;
		cin >> c;
		int q;
		cin >> q;
		while(q--)
		{
			int k;
			cin >> k;
			if (k % 2 == 1)
			{
				cout << 2 << ' ' << 1 << ' ';
				k--;
			}
			else
			{
				cout << 1 << ' ' << 2 << ' ';
			}
			int mx = 1;
			for (int i = 2; i <= k; i+=2)
			{
				cout << i + 2 << ' ';
				cout << i + 1 << ' ';
				mx = i + 1;
			}
			for (int i = mx+1; i < n; i++) cout << i+1 << ' ';
			cout << endl;
		}
	}
	else if (group == 16)
	{
		int c;
		cin >> c;
		ll b = 1e6 + 3;
		ll mod = 0;
		for (int i = 0; i < n; i++) mod = (mod + (i+1)*binpow(b, i)) % INF;
		for (ll i = 1; i < n; i++)
		{
			mod = (mod - (((i % 2 == 1) ? (1 + 2 * b) : (b + 2))%INF) + INF) % INF;
			mod = (mod + ((i % 2 == 0) ? (1 + 2 * b) : (b + 2))) % INF;
			if (i % 2 == 0)
			{
				ll f=i+1, s=i+2;
				mod = (mod - (((f * binpow(b, i - 1)) % INF) + ((s * binpow(b, i))) % INF)%INF + INF) % INF;
				mod = (mod + (((s * binpow(b, i - 1)) % INF) + ((f * binpow(b, i))) % INF)%INF      ) % INF;
			}
			if (i >= c && i <= n - c)
			{
				cout << mod << ' ';
			}
		}
		cout << endl;

		int q;
		cin >> q;
		while (q--)
		{
			int k;
			cin >> k;
			if (k % 2 == 1)
			{
				cout << 2 << ' ' << 1 << ' ';
				k--;
			}
			else
			{
				cout << 1 << ' ' << 2 << ' ';
			}
			int mx = 1;
			for (int i = 2; i <= k; i += 2)
			{
				cout << i + 2 << ' ';
				cout << i + 1 << ' ';
				mx = i + 1;
			}
			for (int i = mx + 1; i < n; i++) cout << i + 1 << ' ';
			cout << endl;
		}
	}
}