#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(time(0));

const int MAXN = 80000;
const int OGR = 2.5e8;

struct Point {
    ll x, y;
    Point (ll x_ = 0, ll y_ = 0) {
        x = x_;
        y = y_;
    }
    Point operator- (Point b) {
        return {x - b.x, y - b.y};
    }
};

ll skal(Point a, Point b) {
    return a.x * b.x + a.y * b.y;
}

ll vec(Point a, Point b) {
    return a.x * b.y + a.y * b.x;
}

vector <bool> used(MAXN);
vector <Point> p(MAXN);
int n;
vector <int> ans;
vector <int> now;
int cnt = 0;
int est = 0;
int nado;

void dfs(int v1, int v2) {
    if (cnt >= OGR) {
        return;
    }
    for (int j = 0; j < n; j++) {
        cnt++;
        if (used[j]) {
            continue;
        }
        if (skal(p[v1] - p[v2], p[j] - p[v2]) > 0) {
            used[j] = true;
            now.push_back(j);
            dfs(v2, j);
            now.pop_back();
            used[j] = false;
        }
        if (cnt >= OGR) {
            break;
        }
    }
    if (ans.size() < now.size()) {
        ans = now;
        cnt += ans.size();
    }
}

void dfs2(int v1, int v2) {
    cnt++;
    if (est == nado && now.size() == n) {
        ans = now;
        nado = -1;
    }
    if (nado == -1) {
        return;
    }
    for (int j = 0; j < n; j++) {
        cnt++;
        if (used[j]) {
            continue;
        }
        if (skal(p[v1] - p[v2], p[j] - p[v2]) > 0 && est < nado) {
            est++;
            used[j] = true;
            now.push_back(j);
            dfs2(v2, j);
            now.pop_back();
            used[j] = false;
            est--;
        }
        if (nado == -1) {
            return;
        }
    }
    for (int j = 0; j < n; j++) {
        cnt++;
        if (used[j]) {
            continue;
        }
        if (skal(p[v1] - p[v2], p[j] - p[v2]) <= 0) {
            used[j] = true;
            now.push_back(j);
            dfs2(v2, j);
            now.pop_back();
            used[j] = false;
        }
        if (nado == -1) {
            return;
        }
    }
}

void solve1() {
    int g;
    cin >> g;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    if (g == 1) {
        int l = 1;
        int r = n;
        while (l <= r) {
            cout << l++ << " ";
            if (l <= r) {
                cout << r-- << " ";
            }
        }
        cout << endl;
        return;
    }
    while (cnt < OGR) {
        int v1 = rnd() % n;
        int v2 = rnd() % n;
        while (v1 == v2) {
            v2 = rnd() % n;
        }
        used[v1] = true;
        used[v2] = true;
        now.push_back(v1);
        now.push_back(v2);
        dfs(v1, v2);
        used[v1] = false;
        used[v2] = false;
        now.pop_back();
        now.pop_back();
    }
    for (auto v : ans) {
        cout << v + 1 << " ";
    }
    cout << endl;
}

void solve3() {
    int g;
    cin >> g;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        cin >> nado;
        while (nado != -1) {
            est = 0;
            cnt = 0;
            now.clear();
            int v1 = rnd() % n;
            int v2 = rnd() % n;
            while (v1 == v2) {
                v2 = rnd() % n;
            }
            used[v1] = true;
            used[v2] = true;
            now.push_back(v1);
            now.push_back(v2);
            dfs2(v1, v2);
            used[v1] = false;
            used[v2] = false;
            now.pop_back();
            now.pop_back();
        }
        for (auto v : ans) {
            cout << v + 1 << " ";
        }
        cout << endl;

    }


}
int start = 0;

void solve2() {
    int g;
    cin >> g;
    cin >> n;
    vector <int> id(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        id[i] = i;
    }
    int c;
    cin >> c;
    cnt = 0;
    while (true) {
        random_shuffle(id.begin(), id.end());
        cnt = 0;
        for (int i = 1; i < n - 1; i++) {
            if (skal(p[id[i - 1]] - p[id[i]], p[id[i + 1]] - p[id[i]]) > 0) {
                cnt++;
            }
        }
        if (cnt < c) {
            for (auto v : id) {
                cout << v << " ";
            }
            cout << endl;
            return;
        }
    }
}

int main() {
    int t;
    cin >> t;
    if (t == 1) {
        solve1();
    } else if (t == 3) {
        solve3();
    } else if (t == 2) {
        solve2();
    }
}
