#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ld EPS = 1e-8;

int task, group;

struct pt {
    int x, y;
    int idx;
    bool operator<(pt other) const {
        return x < other.x;
    }
};

struct vec {
    int x, y;
    friend int operator*(vec a, vec b) {
        return a.x * a.y + b.x * b.y;
    }
    friend int operator%(vec a, vec b) {
        return a.x * b.y - b.x * a.y;
    }
    friend ld angle(vec a, vec b) {
        return fmod(abs(atan2(a % b, a * b)) / M_PI * 180, 360);
    }
    vec(pt a, pt b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

int n;
vector<pt> pts;

void solve1() {
    for (int i = 0; i < n / 2; i++) {
        cout << i + 1 << " " << n - i << " ";
    }
    if (n % 2 == 1) cout << n / 2;
}

void solve2() {
    vector<pt> curr = pts;
    int max_sharp = 0;
    vector<pt> ans = curr;
    do {
        int sharp = 0;
        for (int i = 1; i < n - 1; i++) {
            if (angle(vec(curr[i], curr[i - 1]), vec(curr[i], curr[i + 1])) < 90 - EPS) sharp++;
        }
        if (sharp > max_sharp) {
            max_sharp = sharp;
            ans = curr;
        }
    }
    while (next_permutation(curr.begin(), curr.end()));
    for (pt& p : ans) cout << p.idx << " ";
}

int main() {
    cin >> task >> group;
    cin >> n;
    pts.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
        pts[i].idx = i + 1;
    }
    if (group == 1) {
        solve1();
        return 0;
    }
    if (group == 0 || group == 2) {
        solve2();
        return 0;
    }
}