#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(1472916923);
const int SZ = 1e6 + 1;
const ll b = 1e6 + 3, mod = 1e9 + 7;

struct segtree {
    int sz;
    vector<int> tr;
    segtree(int n) {
        sz = 1;
        while (sz < n)
            sz <<= 1;
        tr.assign(sz * 2 - 1, 0);
    }
};

struct DDnode {
    ll prior, val;
    DDnode* l;
    DDnode* r;
    DDnode(ll v = 0) : val(v) {
        prior = rd();
        l = nullptr;
        r = nullptr;
    }
};

struct pt {
    ll x, y;
    pt(ll x = 0, ll y = 0) : x(x), y(y) {}
};

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<pt> p(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    if (group == 1 || group == 7 || group == 16) {
        vector<ll> stb(n + 2, 1);
        vector<ll> h1(n + 2), h2(n + 2);
        vector<ll> ansh(n + 1, 0);
        h1[0] = h2[n + 1] = 0;
        for (int i = 1; i <= n + 1; i++)
            stb[i] = stb[i - 1] * b % mod;
        for (int i = 1; i <= n; i++)
            h2[i] = (h2[i - 1] * b + i) % mod;
        for (int i = n; i >= 1; i--)
            h1[i] = (h1[i + 1] * b + i) % mod;

        if (task == 1) {
            for (int i = 1; i <= n; i++) {
                cout << (i % 2 == 1 ? i / 2 + 1 : n - i / 2 + 1) << ' ';
            }
            cout << endl;
            return 0;
        }

        //cout << (stb[0] * 1 + stb[1] * 5) % mod << endl;
        //cout << (stb[0] * 1 + stb[1] * 5 + stb[2] * 2 + stb[3] * 3 + stb[4] * 4) % mod << endl;

        int c, t;
        cin >> c;
        if (task == 4) {
            ll v = 0, pv = -1;

            ll h = 0;
            for (int i = 1; i <= c; i++) {
                pv = v;
                v = (i % 2 == 1 ? i / 2 + 1 : n - i / 2 + 1);
                h = (h + v * stb[i - 1]) % mod;
            }
            for (int i = c + 1; i <= n - c + 1; i++) {
                pv = v;
                v = (i % 2 == 1 ? i / 2 + 1 : n - i / 2 + 1);
                if (i % 2 == 1) {
                    ansh[i] = (h + (h1[v] - h1[pv] * stb[pv - v] % mod + mod) % mod * stb[i - 1]) % mod;
                }
                else {
                    ansh[i] = (h + (h2[v] - h2[pv] * stb[v - pv] % mod + mod) % mod * stb[i - 1]) % mod;
                }
                cout << ansh[i] << ' ';
            }
            cout << endl;
        }

        cin >> t;
        for (int q = 0; q < t; q++) {
            int k;
            cin >> k;
            int v = 0, pv = -1;
            for (int i = 1; i <= n; i++) {
                pv = v;
                v = (i % 2 == 1 ? i / 2 + 1 : n - i / 2 + 1);
                if (i - 1 == k) {
                    if (i % 2 == 1) {
                        for (int j = v; j < pv; j++)
                            cout << j << ' ';
                    }
                    else {
                        for (int j = v; j > pv; j--)
                            cout << j << ' ';
                    }
                    break;
                }
                cout << v << ' ';
            }
            cout << endl;
        }
    }
}
