#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct vec2 {
    int x, y;

    vec2(int x = 0, int y = 0) : x(x), y(y) {}

    vec2 operator-(const vec2& other) const {
        return vec2(x - other.x, y - other.y);
    }

    friend int dot(const vec2& a, const vec2& b) {
        return a.x * b.x + a.y * b.y;
    }
};

int group;

void solve1() {
    int n; cin >> n;
    vector <vec2> v(n);
    for (auto& [x, y] : v) cin >> x >> y;

    vector <int> ord;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= ord.size(); ++j) {
            bool flag = true;
            if (j >= 2 && dot(v[ord[j - 1]] - v[ord[j - 2]], v[i] - v[ord[j - 1]]) >= 0) flag = false;
            if (j >= 1 && j < ord.size() && dot(v[i] - v[ord[j - 1]], v[ord[j]] - v[i]) >= 0) flag = false;
            if (j + 1 < ord.size() && dot(v[ord[j]] - v[i], v[ord[j + 1]] - v[ord[j]]) >= 0) flag = false;

            if (flag) {
                ord.insert(ord.begin() + j, i);
                break;
            }
        }
    }

    for (auto x : ord) cout << x + 1 << ' ';
}



class Fenwick {
private:
    vector <pair <int, int>> data;

public:
    Fenwick(int n) {
        data.assign(n, {0, -1});
    }

    void add(int pos, pair <int, int> val) {
        for (; pos < data.size(); ++pos) {
            data[pos] = max(data[pos], val);
        }
    }

    pair <int, int> get(int r) {
        pair <int, int> ans = {0, -1};
        while (r >= 0) {
            ans = max(ans, data[r]);
            r = (r & (r + 1)) - 1;
        }
        return ans;
    }

    void reset() {
        fill(all(data), pair <int, int>(0, -1));
    }
};

void solve2() {
    int n; cin >> n;
    vector <vec2> v(n);
    for (auto& [x, y] : v) cin >> x >> y;
    int c; cin >> c;

    {
        vector <int> big;
        for (auto [x, y] : v) big.push_back(y);

        sort(all(big));
        big.resize(unique(all(big)) - big.begin());

        for (auto& [x, y] : v) {
            y = lower_bound(all(big), y) - big.begin();
        }
    }

    vector <int> p(n); iota(all(p), 0ll);
    sort(all(p), [&](int a, int b) {return v[a].x < v[b].x; });

    vector <int> ord;
    Fenwick treeg(n), treel(n);
    int pr = n + 10;
    while (!p.empty()) {
        treeg.reset();
        treel.reset();
        vector <int> prg(p.size(), -1), prl(p.size(), -1);
        vector <int> dpg(p.size(), -1), dpl(p.size(), -1);

        for (int i = 0; i < p.size(); ++i) {
            auto p1 = treeg.get(v[p[i]].y);
            auto p2 = treel.get(n - v[p[i]].y - 1);
            treeg.add(v[p[i]].y, {p1.first + 1, i});
            treel.add(n - v[p[i]].y - 1, {p2.first + 1, i});
            dpg[i] = p1.first + 1;
            prg[i] = p1.second;
            dpl[i] = p2.first + 1;
            prl[i] = p2.second;
            if (dpg[i] == pr || prl[i] == pr) break;
        }

        vector <int> og, ol;
        {
            int i = max_element(all(dpg)) - dpg.begin();
            while (i != -1) {
                og.push_back(i);
                i = prg[i];
            }
        }
        {
            int i = max_element(all(dpl)) - dpl.begin();
            while (i != -1) {
                ol.push_back(i);
                i = prl[i];
            }
        }
        reverse(all(og));
        reverse(all(ol));

        if (og.size() > ol.size()) {
            for (auto x : og) ord.push_back(p[x]);
            vector <int> p1;
            int j = 0;
            for (int i = 0; i < p.size(); ++i) {
                if (j < og.size() && og[j] == i) {
                    ++j;
                }
                else {
                    p1.push_back(p[i]);
                }
            }
            pr = og.size();
            p = p1;
        }
        else {
            for (auto x : ol) ord.push_back(p[x]);
            vector <int> p1;
            int j = 0;
            for (int i = 0; i < p.size(); ++i) {
                if (j < ol.size() && ol[j] == i) {
                    ++j;
                }
                else {
                    p1.push_back(p[i]);
                }
            }
            pr = ol.size();
            p = p1;
        }
    }

    for (auto x : ord) cout << x + 1 << ' ';
}

void solve3() {

}

void solve4() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int task; cin >> task >> group;

    if (task == 1) solve1();
    if (task == 2) solve2();
    if (task == 3) solve3();
    if (task == 4) solve4();

    return 0;
}
