#include <iostream>
#include <vector>

#pragma target('avx2')
#pragma target('O3')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

class vec {
public:
    int a, b;

    vec() {}

    vec(int a, int b) : a(a), b(b) {}

    vec operator-(vec other) {
        return vec(other.a - a, other.b - b);
    }

    int operator*(vec other) {
        return (a - other.a) * (b - other.b);
    }
};

int n;
vector<vec> A;

void solve() {
    int l = 1, r = n;
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) {
            cout << r << ' ';
            r--;
        } else {
            cout << l << ' ';
            l++;
        }
    }
    cout << endl;
}

void solve1(int c) {
    int l = 1, r = c + 2;
    for (int i = n; i >= c + 3; i--) {
        cout << i << ' ';
    }
    for (int i = 0; i < c + 2; i++) {
        if (i % 2 == 0) {
            cout << r << ' ';
            r--;
        } else {
            cout << l << ' ';
            l++;
        }
    }
    cout << endl;
}

void solve2() {
    vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[i] = i;
    }
    vector<int> ans;
    int c = 0;
    while (next_permutation(pos.begin(), pos.end())) {
        int count = 0;
        for (int i = 2; i < n; i++) {
            if ((A[pos[i]] - A[pos[i - 1]]) * (A[pos[i - 2]] - A[pos[i - 1]]) >= 0){
                count++;
            }
        }
        if (count > c){
            ans = pos;
        }
    }
    int count = 0;
    for (int i = 2; i < n; i++) {
        if ((A[pos[i]] - A[pos[i - 1]]) * (A[pos[i - 2]] - A[pos[i - 1]]) >= 0){
            count++;
        }
    }
    if (count > c){
        ans = pos;
    }
    for (int e: ans){
        cout << e << ' ';
    }cout << endl;
}

int main() {
    int task, group;
    cin >> task >> group;
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        A[i] = vec(a, b);
    }
    if (task == 1 and group == 1) {
        solve();
    } else if (task == 3 and group == 7) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            int k;
            cin >> k;
            solve1(k);
        }
    } else if (task == 1 and group == 2) {
        solve2();
    }
}
