#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

struct Point {
    int x, y;

    Point() {
        x = 0;
        y = 0;
    }

    Point(int _x, int _y) {
        x = _x;
        y = _y;
    }

    Point operator+(Point other) const {
        return {x + other.x, y + other.y};
    }

    Point operator-(Point other) const {
        return {x - other.x, y - other.y};
    }

    Point operator*(int k) const {
        return {x * k, y * k};
    }

    int operator*(Point other) const {
        return x * other.x + y * other.y;
    }

    int operator%(Point other) const {
        return x * other.y - y * other.x;
    }

    friend istream& operator>>(istream &in, Point &other) {
        in >> other.x >> other.y;
        return in;
    }

    friend ostream& operator<<(ostream &out, Point other) {
        out << other.x << ' ' << other.y;
        return out;
    }
};

void solve() {
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        int n;
        cin >> n;
        if (group == 1) {
            vector<int> x(n), y(n);
            for (int i = 0; i < n; ++i) {
                cin >> x[i] >> y[i];
            }
            deque<int> a(n);
            iota(all(a), 1ll);
            int flag = 0;
            while (!a.empty()) {
                if (!flag) {
                    cout << a[0] << ' ';
                    a.pop_front();
                } else {
                    cout << a.back() << ' ';
                    a.pop_back();
                }
                flag ^= 1;
            }
            cout << endl;
            return;
        } else if (group == 2) {
            vector<Point> p(n);
            for (Point &i : p) {
                cin >> i;
            }
            int q = -1;
            vector<int> cur(n), ans;
            iota(all(cur), 0ll);
            do {
                int cnt = 0;
                for (int i = 1; i < n - 1; ++i) {
                    Point A = p[cur[i - 1]] - p[cur[i]];
                    Point B = p[cur[i + 1]] - p[cur[i]];
                    if (A * B > 0) {
                        ++cnt;
                    }
                }
                if (cnt > q) {
                    q = cnt;
                    ans = cur;
                }
            } while (next_permutation(all(cur)));
            for (int i : ans) {
                cout << i + 1 << ' ';
            }
            cout << endl;
            return;
        }
        return;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}