#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

struct r {
    ll x, y;
};
r operator+(r a, r b) {
    return {a.x + b.x, a.y + b.y};
}
r operator-(r a, r b) {
    return {a.x - b.x, a.y - b.y};
}
ll operator *(r a, r b) {
    return a.x * b.x + a.y * b.y;
}
ll operator %(r a, r b) {
    return a.x * b.y - a.y * b.x;
}
istream &operator >>(istream &in, r &p) {
    in >> p.x >> p.y;
    return in;
}
ostream &operator <<(ostream &out, r p) {
    out << p.x << ' ' <<  p.y;
    return out;
}

const int MAXN = 8e4;
int n;
r p[MAXN];
vi order;
vi best;
int ans = 0;

int get_cnt() {
    int res = 0;
    for (int i = 0; i < n - 2; i++) {
        if (((p[order[i]] - p[order[i + 1]]) * (p[order[i + 2]] - p[order[i + 1]])) > 0)
            res++;
    }
    return res;
}

void check() {
    int cnt = get_cnt();
    if (cnt > ans) {
        best = order;
        ans = cnt;
    }
}

void solve_1() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
    }
    for (int i = 0; i < n; i++)
        cout << (i & 1 ? n - (i / 2) : (i / 2) + 1) << ' ';
    cout << endl;
}

void solve_2_5() {
    cin >> n;
    order.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        order[i] = i;
    }

    int cnt = 1e5;
    for (int i = 0; i < cnt; i++) {
        shuffle(all(order), rnd);
        check();
    }
    // cout << ans << '\n';
    for (int i = 0; i < n; i++)
        cout << best[i] + 1 << ' ';
    cout << endl;
}

int main() {
    fast_input;
    cout << setprecision(7) << fixed;
    int task, group;
    cin >> task >> group;
    if (group == 1)
        solve_1();
    else if (group < 6)
        solve_2_5();
}