
#include <bits/stdc++.h>
#include "ext/pb_ds/tree_policy.hpp"
#include "ext/pb_ds/assoc_container.hpp"
using namespace __gnu_pbds;
using namespace std;
#define int long long
struct point{
    int x, y;
    point operator + (const point& p) const {
        return {x + p.x, y + p.y};
    }
    point operator - (const point& p) const {
        return {x - p.x, y - p.y};
    }
    int operator * (const point& p) const {
        return x * p.x + y * p.y;
    }
    int operator ^ (const point& p) const {
        return x * p.y - y * p.x;
    }
};
bool is_sharp(point a, point b, point c) {
    return (a - b) * (c - b) > 0;
}
vector <point> pts;
vector <int> p;
int count_sharp() {
    int c = 0;
    for (int i = 1; i + 1 < pts.size(); i++) {
        c += is_sharp(pts[p[i - 1]], pts[p[i]], pts[p[i + 1]]);
    }
    return c;
}
int f;
mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
pair<int, int> last_change;
int including(int x) {
    int res = 0;
    if (x >= 2) {
        res += is_sharp(pts[p[x - 2]], pts[p[x - 1]], pts[p[x]]);
    }
    if (x >= 1 && x + 1 < p.size()) {
        res += is_sharp(pts[p[x - 1]], pts[p[x]], pts[p[x + 1]]);
    }
    if (x + 2 < p.size()) {
        res += is_sharp(pts[p[x]], pts[p[x + 1]], pts[p[x + 2]]);
    }
    return res;
}
void swap() {
    int x = rnd() % pts.size(), y = rnd() % pts.size();
    if (abs(x - y) <= 2) {
        return;
    }
    f -= including(x);
    f -= including(y);
    last_change = {x, y};
    swap(p[x], p[y]);
    f += including(x);
    f += including(y);
}
void rollback() {
    swap(p[last_change.first], p[last_change.second]);
}
void solve1() {
    int n; cin >> n;
    pts.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
    }
    p.resize(n);
    std::iota(p.begin(), p.end(), 0);
    std::shuffle(p.begin(), p.end(), mt19937 (228));
    f = count_sharp();

    for (int ops = 0; ops < ((int)2e7); ops++) {
        int was_f = f;
        swap();
        if (was_f > f) {
            rollback();
            f = was_f;
        }
    }
    for (int i : p) cout << i + 1 << ' ';
    cout << endl;
}
void solve2() {
    int n; cin >> n;
    pts.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
    }
    int l = 1, r = n;
    bool time = 0;
    while (l <= r) {
        if (time) cout << r << ' ', r--;
        else cout << l << ' ', l++;
        time = !time;
    }
    cout << endl;
}
signed main() {
    int task, group; cin >> task >> group;
    if (group == 2 || group == 3 || group == 4) {
        solve1();
        return 0;
    }
    if (group == 1) {
        solve2();
        return 0;
    }

}