#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define time (double)(clock()) / (double)(CLOCKS_PER_SEC)

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int task, group;

struct Point {
    int x, y;
    Point() : x(0), y(0) {}
    Point (int x, int y) : x(x), y(y) {}

    int operator * (Point other) {
        return x * other.x + y * other.y;
    }

    Point operator - (Point other) {
        return Point(x - other.x, y - other.y);
    }

    int operator ^ (Point other) {
        return x * other.y - y * other.x;
    }

    int len() {
        return x * x + y * y;
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<Point> p(n);

    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    vector<int> ans;

    for (int i = 0; i < (n - 1) / 2; i++) {
        ans.push_back(i);
        ans.push_back(n - i - 1);
    }

    if (n % 2 == 1) ans.push_back(n / 2);

    for (auto v : ans) {
        cout << v + 1 << " ";
    }
    cout << endl;
}

void solve2() {
    int n;
    cin >> n;
    vector<Point> p(n);

    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    Point p0 = p[0];

    for (int i = 0; i < n; i++) {
        if (p[i].x < p0.x) {
            p0 = p[i];
        } else if (p[i].x == p0.x && p0.y < p[i].y) {
            p0 = p[i];
        }
    }

    vector<int> ind(n, 0);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j) {
        Point A = p[i] - p0, B = p[j] - p0;

        if ((A ^ B) == 0) {
            return A.len() < B.len();
        }

        return (A ^ B) > 0;
    });


    int c;
    cin >> c;

    for (int i = 0; i < n; i++) {
        cout << ind[i] + 1 << " ";
    }
    cout << endl;
}

void solve3() {
    int n;
    cin >> n;
    vector<Point> p(n);

    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    vector<int> ind(n, 0);
    iota(all(ind), 0ll);
    int best = -1;
    vector<int> b;

    while (time < 1.9) {
        shuffle(all(ind), rng);
        int score = 0;
//        cout << ind << endl;


        for (int i = 0; i < n - 2; i++) {
            Point A = p[ind[i]] - p[ind[i + 1]];
            Point B = p[ind[i + 2]] - p[ind[i + 1]];
            if ((A * B) > 0) {
                score++;
            }
        }

//        cout << ind << " " << score << endl;

        if (score == n / 2) {
            best = score;
            b = ind;
            break;
        }
    }

    int c;
    cin >> c;

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;
        assert(k == n / 2);
        for (auto v : b) {
            cout << v + 1 << " ";
        }
        cout << endl;
    }
}

void solve4() {

}

void solve() {
    cin >> task >> group;

    if (task == 1) {
        solve1();
        return;
    } else if (task == 2) {
        solve2();
        return;
    } else if (task == 3) {
        solve3();
        return;
    } else if (task == 4) {
        solve4();
        return;
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}