#include <bits/stdc++.h>
#define int long long
#define Point Vec

using namespace std;
using ll = long long;
using db = double;
const db eps = 1e-8;

int sign(int x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

int sign(db x) {
    if (x > eps) return 1;
    if (x < -eps) return -1;
    return 0;
}

struct Vec {
    int x, y;

    Vec() : x(0), y(0) {}
    Vec(int _x, int _y) : x(_x), y(_y) {}
    Vec(const Point& from, const Point& to) {
        x = to.x - from.x;
        y = to.y - from.y;
    }

    int len2() const { return x * x + y * y; }
    db len() const { return sqrt(x * x + y * y); }

    int operator*(const Vec& other) const {
        return x * other.x + y * other.y;
    }

    int operator%(const Vec& other) const {
        return x * other.y - y * other.x;
    }
};

Vec operator+(const Vec& a, const Vec& b) {
    return {a.x + b.x, a.y + b.y};
}

Vec operator-(const Vec& a, const Vec& b) {
    return {a.x - b.x, a.y - b.y};
}

istream& operator>>(istream& in, Point& p) {
    in >> p.x >> p.y;
    return in;
}

ostream& operator<<(ostream& out, const Point& p) {
    out << p.x << ' ' << p.y;
    return out;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    int task, group; cin >> task >> group;
    int n; cin >> n;
    vector<Point> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (task == 1) {
        int st = 0, en = n - 1;
        int now = 0;
        for (int i = 0; i < n; ++i) {
            if (now == 0) {
                cout << st + 1 << ' ';
                st++;
            } else {
                cout << en + 1 << ' ';
                en--;
            }
            now ^= 1;
        }
        return 0;
    } else if (task == 3) {
        int c; cin >> c;
        int q; cin >> q;
        for (int t = 0; t < q; ++t) {
            int k; cin >> k;
            int st = 0, en = n - 1;
            int now = 0, last = 0;
            for (int i = 0; i < k + 1; ++i) {
                if (now == 0) {
                    cout << st + 1 << ' ';
                    last = st;
                    st++;
                } else {
                    cout << en + 1 << ' ';
                    last = en;
                    en--;
                }
                now ^= 1;
            }
            if (now == 0) {
                for (int i = last - 1; i >= st; --i) cout << i + 1 << ' ';
            } else {
                for (int i = last + 1; i <= en; ++i) cout << i + 1 << ' ';
            }
            cout << endl;
        }
    }
    return 0;
}
