#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define ll int
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN = 256, MAXW = 512, MAXN2 = 2048, MAXW2 = 3;

ll dp[MAXN][MAXN][MAXW][2];
ll dp2[MAXN2][MAXN2][MAXW2][2];

struct point{
    ll x, y;
    int id;
};

ll dstsq(point p1, point p2){
    return (p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y);
}

bool prov(point a, point b, point c){
    ll la = dstsq(b, c);
    ll lb = dstsq(a, c);
    ll lc = dstsq(a, b);
    return la + lc > lb;
}

inline bool operator <(const point& p1, const point& p2){
    return make_pair(p1.x, p1.y) < make_pair(p2.x, p2.y);
}

int main() {
    int task, group;
    cin >> task >> group;
    if(task == 1){
        int n;
        cin >> n;
        ve<point> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i].x >> v[i].y;
            v[i].id = i + 1;
        }
        if(n <= 10){
            sort(all(v));
            int ans = -1;
            ve<point> res;
            do{
                int cnt = 0;
                for(int i = 2; i < n ;i++)
                    cnt += prov(v[i - 2], v[i - 1], v[i]);
                if(cnt > ans){
                    ans = cnt;
                    res = v;
                }
            } while(next_permutation(all(v)));
            for(auto i : res)
                cout << i.id << " ";
            if(res.empty())
                return -1
            return 0;
        }
        for(int i = 0; i < n / 2; i++)
            cout << i + 1 << " " << n - i << " ";
        if(n % 2)
            cout << n / 2;
        return 0;
    }
    if(task == 2){
        int n;
        cin >> n;
        ve<point> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i].x >> v[i].y;
            v[i].id = i + 1;
        }
        int c;
        cin >> c;
        sort(all(v));
        point cur = v[0], prev;
        cout << v[0].id << " ";
        ve<bool> del(n,0);
        del[0] = 1;
        for(int it = 0; it < 3; it++){
            for(int i = 0; i < n; i++)
                if(!del[i]){
                    del[i] = 1;
                    cout << v[i].id << " ";
                    prev = cur;
                    cur = v[i];
                    break;
                }
            for(int i = 0; i < n; i++)
                if(!del[i] && !prov(prev, cur, v[i])){
                    del[i] = 1;
                    cout << v[i].id << " ";
                    prev = cur;
                    cur = v[i];
                }
                cout << endl;
        }
        for(int i = 0; i < n; i++)
            if(!del[i])
                return -1;
    }
}
