#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<bitset>
#include<cmath>
#include<iomanip>
#include<deque>
#include<queue>
using namespace std;

const int INF = 1e9;

struct Point {
	double x, y;

	double operator*(const Point& a) const {
		return x * a.x + y * a.y;
	}

	double operator%(const Point& a) const {
		return x * a.y - y * a.x;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//A
	
	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;

	vector<Point> a(n);
	vector<int> p(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		p[i] = i;
	}
	
	if (group == 1) {
		cout << 1 << ' ';
		for (int i = 2; i <= n; ++i) {
			if (n % 2 == 0 && i == n) {
				cout << i;
				break;
			}
			if (i % 2 == 0) {
				cout << i + 1 << ' ';
			}
			else {
				cout << i - 1 << ' ';
			}
		}
		cout << endl;
		return 0;
	}

	bool adachi = true;
	while (adachi == true) {

		int cnt = 0;
		for (int i = 1; i < n - 1; ++i) {
			int j = p[i], pj = p[i - 1], nj = p[i + 1];
			Point ab = { a[j].x - a[pj].x, a[j].y - a[pj].y };
			Point bc = { a[nj].x - a[j].x, a[nj].y - a[j].y };
			if (ab * bc < 0) {
				++cnt;
			}
		}

		if (cnt == n - 2) {
			for (auto e: p) {
				cout << e + 1 << ' ';
			}
			return 0;
		}

		if (!next_permutation(p.begin(), p.end())) {
			break;
		}
	}

	return 0;
}