#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e18;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
const int N = 2e5 + 100;
struct pt {
    int x, y, i;
    pt () {}
    pt (int x, int y, int i = -1) : x(x), y(y) {}
    pt operator + (pt b) {
        return pt(x + b.x, y + b.y);
    }
    pt operator - (pt b) {
        return pt(x - b.x, y - b.y);
    }
    int operator * (pt b) {
        return x * b.y - y * b.x;
    }
    int len () {
        return x * x + y * y;
    }
};

void sort_angle (vc <pt> &a) {
    pt p = a[0];
    sort(a.begin() + 1, a.end(), [&](pt a, pt b) {
        if ((a - p) * (b - p) == 0)
            return (a - p).len() < (b - p).len();
        return (a - p) * (b - p) > 0;
    });
}
mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

pair <vc <pt>, vc <pt>> get_hull (vc <pt> a) {
    vc <pt> hull = {a[0]};
    vc <pt> ost;
    int n = a.size();
    for (int i = 1; i < n; ++i) {
         while (hull.size() >= 2) {
             pt cur = a[i] - hull.back();
             pt top = hull.back() - hull[hull.size() - 2];
             if (cur * top > 0) {
                 ost.push_back(hull.back());
                 hull.pop_back();
             } else
                 break;
         }
         hull.push_back(a[i]);
    }
    return make_pair(hull, ost);
}

void solve() {
    int n, task, group;
    cin >> task >> group >> n;
    vc <pt> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].i = i;
    }
    sort(a.begin(), a.end(), [&](pt a, pt b) {
        return a.x < b.x;
    });
    if (task == 1) {
        vc<int> res = {a[0].i + 1};
        int j = 0;
        vc<int> used(n);
        for (int len = 1; len < n; ++len) {
            used[j] = 1;
            int dist = 0;
            int k = -1;
            for (int i = 0; i < n; ++i) {
                if (!used[i] && chmax(dist, (a[i] - a[j]).len())) {
                    k = i;
                }
            }
            res.push_back(a[k].i + 1);
            j = k;
        }
        for (int i: res)
            cout << i << ' ';
    } else {
        int mysor;
        cin >> mysor;
        int c = 10000;
        vc<int> res[2];
        res[0].push_back(a[0].i + 1);
        int j = 0;
        vc<int> used(n);
        for (int len = 1; len < n; ++len) {
            pt was = a[j];
            swap(a[j], a.back());
            a.pop_back();
            int dist = 0;
            int k = -1;
            if (a.size() <= c * 3) {
                for (int i = 0; i < a.size(); ++i) {
                    if (chmax(dist, (a[i] - was).len())) {
                        k = i;
                    }
                }
            } else {
                for (int i = max(0ll, j - c); i < min((int) a.size(), j + c); ++i) {
                    if (chmax(dist, (a[i] - was).len())) {
                        k = i;
                    }
                }
            }
            res[len % 2].push_back(a[k].i + 1);
            j = k;
        }
        for (int i: res[0])
            cout << i << ' ';
        for (int i : res[1])
            cout << i << ' ';
    }
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
//set PATH=%PATH%;C:\mingw64\bin