#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

struct Vector {
    int x;
    int y;
    Vector() = default;
    Vector(int _x, int _y) : x(_x), y(_y) {}
    Vector(const std::pair<int, int>& from, const std::pair<int, int>& to) {
        x = to.first - from.first;
        y = to.second - from.second;
    }
};

long long dot_prod(const Vector& a, const Vector& b) {
    return a.x * 1ll * b.x + a.y * 1ll * b.y;
}

int main() {
    int task, group;
    std::cin >> task >> group;
    if (group == 1) {
        int n;
        std::cin >> n;
        for (int i = 0; i < n; i++) {
            int x, y;
            std::cin >> x >> y;
        }
        int lastf = 0;
        int lasts = n - 1;
        for (int i = 0; i < n; i++) {
            if (!(i & 1)) {
                std::cout << lastf++ + 1 << " \n"[i == n - 1];
            } else {
                std::cout << lasts-- + 1 << " \n"[i == n - 1];
            }
        }
        return 0;
    } else if (group == 2) {
        int n;
        std::cin >> n;
        std::vector<std::pair<int, int>> a(n);
        for (int i = 0; i < n; i++) {
            std::cin >> a[i].first >> a[i].second;
        }
        std::vector<int> perm(n);
        std::iota(perm.begin(), perm.end(), 0);
        std::vector<int> bestperm(perm.begin(), perm.end());
        int bestcnt = 0;
        do {
            int cnt = 0;
            for (int i = 1; i < n - 1; i++) {
                Vector pv(a[perm[i]], a[perm[i - 1]]);
                Vector cv(a[perm[i]], a[perm[i + 1]]);
                cnt += (dot_prod(pv, cv) > 0);
            }
            if (cnt > bestcnt) {
                bestcnt = cnt;
                bestperm = perm;
            }
        } while (std::next_permutation(perm.begin(), perm.end()));
        for (int i = 0; i < n; i++) {
            std::cout << bestperm[i] + 1 << " \n"[i == n - 1];
        }
        return 0;
    }
}