#include <bits/stdc++.h>

struct Vector {
    int64_t x, y;

    Vector() : x(0), y(0) { ; }
    Vector(int64_t x, int64_t y) : x(x), y(y) { ; }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }
    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    Vector operator*(const double& f) const {
        return Vector(x * f, y * f);
    }

    int64_t operator*(const Vector& other) const {
        return x * other.x + y * other.y;
    }
    int64_t operator%(const Vector& other) const {
        return x * other.y - y * other.x;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int task;
    int group;
    std::cin >> task >> group;
    int n;
    std::cin >> n;
    std::vector<Vector> input(n);
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }

    if (task == 1) {
        std::mt19937 rnd;

        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);

        while (true) {
            std::shuffle(p.begin(), p.end(), rnd);
            int64_t cnt = 0;
            int i = 2;
            for (; i < n && cnt < 1e6; i++) {
                int t = i + rnd() % (n - i);
                std::swap(p[i], p[t]);
                if ((input[p[i - 1]] - input[p[i - 2]]) * (input[p[i]] - input[p[i - 1]]) >= 0) {
                    i--;
                    cnt++;
                    continue;
                }
            }
            if (i == n) {
                for (int i = 0; i < n; i++) {
                    std::cout << p[i] + 1 << " \n"[i == n - 1];
                }
                return 0;
            }
        }
        assert(false);
    } else if (task == 2) {
        int c;
        std::cin >> c;
        std::mt19937 rnd;
        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);

        while (true) {
            std::shuffle(p.begin(), p.end(), rnd);

            int i = 2;
            int cnt = 0;

            for (int cum = 0; i < n && cnt <= c; i++) {
                if (cum == 1000) {
                    cum = 0;
                    cnt++;
                    continue;
                }
                int t = i + rnd() % (n - i);
                std::swap(p[i], p[t]);
                if ((input[p[i - 1]] - input[p[i - 2]]) * (input[p[i]] - input[p[i - 1]]) < 0) {
                    i--;
                    cum++;
                    continue;
                }
            }
            if (cnt <= c) {
                for (int i = 0; i < n; i++) {
                    std::cout << p[i] + 1 << " \n"[i == n - 1];
                }
                return 0;
            }
        }
        assert(false);
    }

    return 0;
}
