#include <iostream>
#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

struct Vector {
    int64_t x, y;

    Vector() : x(0), y(0) { ; }
    Vector(int64_t x, int64_t y) : x(x), y(y) { ; }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }
    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    Vector operator*(const double& f) const {
        return Vector(x * f, y * f);
    }

    int64_t operator*(const Vector& other) const {
        return x * other.x + y * other.y;
    }
    int64_t operator%(const Vector& other) const {
        return x * other.y - y * other.x;
    }
    int64_t sqlen() const {
        return x * x + y * y;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int task;
    int group;
    std::cin >> task >> group;
    int n;
    std::cin >> n;
    std::vector<Vector> input(n);
    for (int i = 0; i < n; i++) {
        input[i] = {i, i};
    }
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }

    if (task == 1) {
        std::mt19937 rnd;

        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);

        while (true) {
            std::shuffle(p.begin(), p.end(), rnd);
            int64_t cnt = 0;
            int i = 2;
            for (; i < n && cnt < 1e6; i++) {
                int t = i + rnd() % (n - i);
                std::swap(p[i], p[t]);
                if ((input[p[i - 1]] - input[p[i - 2]]) * (input[p[i]] - input[p[i - 1]]) >= 0) {
                    i--;
                    cnt++;
                    continue;
                }
            }
            if (i == n) {
                for (int i = 0; i < n; i++) {
                    std::cout << p[i] + 1 << " \n"[i == n - 1];
                }
                return 0;
            }
        }
        assert(false);
    } else if (task == 2) {
        int c;
        std::cin >> c;
        std::mt19937 rnd;
        std::vector<int> p(n);
        std::iota(p.begin(), p.end(), 0);

        auto fuck = [&](int a, int b, int c) {
            return (input[p[b]] - input[p[a]]) * (input[p[c]] - input[p[b]]) >= 0;
        };

        while (true) {
            std::shuffle(p.begin(), p.end(), rnd);

            int i = 2;
            int cnt = 0;

            for (; i < n && cnt <= c; i++) {
                int t = i;
                for (int j = 0; j < 1000; j++) {
                    int t2 = i + rnd() % (n - i);
                    if (fuck(i - 2, i - 1, t2)) {
                        if ((input[p[t]] - input[p[i - 1]]).sqlen() > (input[p[t2]] - input[p[i - 1]]).sqlen()) {
                            t = t2;
                        }
                    }
                }
                std::swap(p[i], p[t]);
                cnt += !fuck(i - 2, i - 1, i);
            }
            if (cnt <= c) {
                int x = 0;
                for (int i = 2; i < n; i++) {
                    x += !fuck(i - 2, i - 1, i);
                }
                assert(x <= c);
                // std::cerr << x << " " << c << "\n";

                for (int i = 0; i < n; i++) {
                    std::cout << p[i] + 1 << " \n"[i == n - 1];
                }
                return 0;
            }
        }
        assert(false);
    }

    return 0;
}
