#include <iostream>
#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

struct Vector {
    int x, y;

    Vector() : x(0), y(0) { ; }
    Vector(int x, int y) : x(x), y(y) { ; }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }
    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    // Vector operator*(const double& f) const {
    //     return Vector(x * f, y * f);
    // }

    int64_t operator*(const Vector& other) const {
        return x * 1LL * other.x + y * 1LL * other.y;
    }
    int64_t operator%(const Vector& other) const {
        return x * 1LL * other.y - y * 1LL * other.x;
    }
    int64_t sqlen() const {
        return x * 1LL * x + y * 1LL * y;
    }
};

std::vector<int> find_full_cum(std::vector<Vector> input) {
    static std::mt19937 rnd;
    int n = input.size();

    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 0);

    while (true) {
        std::shuffle(p.begin(), p.end(), rnd);
        int64_t cnt = 0;
        int i = 2;
        for (; i < n && cnt < 1e6; i++) {
            int t = i + rnd() % (n - i);
            std::swap(p[i], p[t]);
            if ((input[p[i - 1]] - input[p[i - 2]]) * (input[p[i]] - input[p[i - 1]]) >= 0) {
                i--;
                cnt++;
                continue;
            }
        }
        if (i == n) {
            return p;
        }
    }
}

std::vector<int> find_cum(std::vector<Vector> input, int c) {
    int n = input.size();

    static std::mt19937 rnd;
    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 0);

    auto fuck = [&](int a, int b, int c) {
        return (input[p[b]] - input[p[a]]) * (input[p[c]] - input[p[b]]) >= 0;
    };

    while (true) {
        std::shuffle(p.begin(), p.end(), rnd);

        int i = 2;
        int cnt = 0;

        for (; i < n && cnt <= c; i++) {
            int t = i;
            for (int j = 0; j < 1000; j++) {
                int t2 = i + rnd() % (n - i);
                if (fuck(i - 2, i - 1, t2)) {
                    if ((input[p[t]] - input[p[i - 1]]).sqlen() > (input[p[t2]] - input[p[i - 1]]).sqlen()) {
                        t = t2;
                    }
                }
            }
            std::swap(p[i], p[t]);
            cnt += !fuck(i - 2, i - 1, i);
        }
        if (cnt <= c) {
            int x = 0;
            for (int i = 2; i < n; i++) {
                x += !fuck(i - 2, i - 1, i);
            }
            assert(x <= c);
            // std::cerr << x << " " << c << "\n";

            return p;
        }
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int task;
    int group;
    std::cin >> task >> group;
    int n;
    std::cin >> n;
    std::vector<Vector> input(n);
    for (int i = 0; i < n; i++) {
        input[i] = {i, i};
    }
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }

    if (task == 1) {
        auto p = find_full_cum(input);
        for (int i = 0; i < n; i++) {
            std::cout << p[i] + 1 << " \n"[i == n - 1];
        }
        return 0;
    }
    if (task == 2) {
        int c;
        std::cin >> c;
        auto p = find_cum(input, c);
        for (int i = 0; i < n; i++) {
            std::cout << p[i] + 1 << " \n"[i == n - 1];
        }
        return 0;
    }

    return 0;
}
