#include <iostream>
#ifndef LOCAL
#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

constexpr int mod = 1e9 + 7;
constexpr int base = 1e6 + 3;
int mul(int a, int b) {
    return a * 1ULL * b % mod;
}
int add(int a, int b) {
    return a + b - mod * (a + b >= mod);
}

struct Vector {
    int x, y;

    Vector() : x(0), y(0) { ; }
    Vector(int x, int y) : x(x), y(y) { ; }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }
    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    // Vector operator*(const double& f) const {
    //     return Vector(x * f, y * f);
    // }

    int64_t operator*(const Vector& other) const {
        return x * 1LL * other.x + y * 1LL * other.y;
    }
    int64_t operator%(const Vector& other) const {
        return x * 1LL * other.y - y * 1LL * other.x;
    }
    int64_t sqlen() const {
        return x * 1LL * x + y * 1LL * y;
    }
};

bool sharp(Vector a, Vector b, Vector c) {
    return (b - a) * (c - b) < 0;
}

std::vector<int> find_full_cum(std::vector<Vector> input) {
    static std::mt19937 rnd;
    int n = input.size();

    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 0);

    while (true) {
        std::shuffle(p.begin(), p.end(), rnd);
        int64_t cnt = 0;
        int i = 2;
        for (; i < n && cnt < n * 10; i++) {
            int t = i + rnd() % (n - i);
            std::swap(p[i], p[t]);
            if ((input[p[i - 1]] - input[p[i - 2]]) * (input[p[i]] - input[p[i - 1]]) >= 0) {
                i--;
                cnt++;
                continue;
            }
        }
        if (i == n) {
            return p;
        }
    }
}

std::vector<int> find_cum(std::vector<Vector> input, int c) {
    int n = input.size();

    static std::mt19937 rnd;
    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 0);

    auto fuck = [&](int a, int b, int c) {
        return (input[p[b]] - input[p[a]]) * (input[p[c]] - input[p[b]]) >= 0;
    };

    while (true) {
        std::shuffle(p.begin(), p.end(), rnd);

        int i = 2;
        int cnt = 0;

        for (; i < n && cnt <= c; i++) {
            int t = i;
            for (int j = 0; j < 900; j++) {
                int t2 = i + rnd() % (n - i);
                if (fuck(i - 2, i - 1, t2)) {
                    if ((input[p[t]] - input[p[i - 1]]).sqlen() > (input[p[t2]] - input[p[i - 1]]).sqlen()) {
                        t = t2;
                    }
                }
            }
            std::swap(p[i], p[t]);
            cnt += !fuck(i - 2, i - 1, i);
        }
        if (cnt <= c) {
            int x = 0;
            for (int i = 2; i < n; i++) {
                x += !fuck(i - 2, i - 1, i);
            }
            assert(x <= c);
            // std::cerr << x << " " << c << "\n";

            return p;
        }
    }
}

int32_t main() {
    // freopen("test.in", "r", stdin);

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int task;
    int group;
    std::cin >> task >> group;
    int n;
    std::cin >> n;
    std::vector<Vector> input(n);
    for (int i = 0; i < n; i++) {
        input[i] = {i, i};
    }
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }

    if (task == 1) {
        auto p = find_full_cum(input);
        for (int i = 0; i < n; i++) {
            std::cout << p[i] + 1 << " \n"[i == n - 1];
        }
        return 0;
    }
    if (task == 2) {
        int c;
        std::cin >> c;
        auto p = find_cum(input, c);
        for (int i = 0; i < n; i++) {
            std::cout << p[i] + 1 << " \n"[i == n - 1];
        }
        return 0;
    }

    int c;
    std::cin >> c;
    const int c2 = std::max(0, c - 2);

    auto p = find_cum(input, c2);
    auto p0 = p;
    int sh0 = 0;
    for (int i = 0; i + 2 < n; i++) {
        sh0 += sharp(input[p[i]], input[p[i + 1]], input[p[i + 2]]);
    }
    std::vector<int> sz = {2, 3};
    std::vector<int> chg, chg_hs, beg;
    std::vector<std::vector<int>> pr;

    std::vector<int> pw(n);
    pw[0] = 1;
    for (int i = 1; i < n; i++) {
        pw[i] = mul(pw[i - 1], base);
    }
    int hash_p = 0;
    for (int i = 0; i < n; i++) {
        hash_p = add(hash_p, mul(pw[i], p[i] + 1));
    }

    for (int i = 0, j = 0; i + 1 < n; j++) {
        if (j == sz.size()) {
            int s = std::min<int>(n - i, (int)sz.back() * 1.5);
            if (s <= 1) {
                break;
            }
            sz.push_back(s);
        }
        int s = sz[j];
        beg.push_back(i);

        std::vector<int> p2(p.begin() + i, p.begin() + i + s);
        std::vector<Vector> input2(s);
        for (int i = 0; i < s; i++) {
            input2[i] = input[p2[i]];
        }
        std::vector<int> p3;
        if (s != 2) {
            p3 = find_full_cum(input2);
        } else {
            p3 = {1, 0};
        }
        int ch = 0;
        for (int d = -2; d <= s - 1; d++) {
            if (0 <= i + d && i + d + 2 < n)
                ch -= sharp(input[p[i + d]], input[p[i + d + 1]], input[p[i + d + 2]]);
        }
        std::vector<int> p4(s);
        for (int d = 0; d < s; d++) {
            p4[d] = p[i + d] = p2[p3[d]];
        }
        for (int d = -2; d <= s - 1; d++) {
            if (0 <= i + d && i + d + 2 < n)
                ch += sharp(input[p[i + d]], input[p[i + d + 1]], input[p[i + d + 2]]);
        }
        int ch_hs = 0;
        for (int d = 0; d < s; d++) {
            ch_hs = add(ch_hs, mul(pw[i + d], p4[d] + 1));
            ch_hs = add(ch_hs, mod - mul(pw[i + d], p2[d] + 1));
            p[i + d] = p2[d];
        }

        if (ch > 0) {
            chg_hs.push_back(ch_hs);
            pr.push_back(p4);
            chg.push_back(ch);
        } else {
            // std::iota(p3.begin(), p3.end(), 0);
            chg_hs.push_back(0);
            pr.push_back(p2);
            chg.push_back(0);
        }

        i += s + 2;
    }
    sz.resize(beg.size());

    assert(p == p0);

    int g = sz.size();
    std::vector<std::vector<std::pair<int, int>>> fuck(g + 1);
    fuck[0] = {{0, hash_p}};
    for (int i = 0; i < g; i++) {
        fuck[i + 1] = fuck[i];
        for (auto& [a, b] : fuck[i + 1]) {
            if (a >= 0) {
                a = 0;
            }
        }
        int ch = chg[i];
        fuck[i + 1].resize(fuck[i].size() + ch, std::pair{-1, -1});
        for (int t = 0; t < fuck[i].size(); t++) {
            if (fuck[i][t].first == -1) {
                continue;
            }
            int h0 = fuck[i][t].second;
            fuck[i + 1][t + ch] = {1, add(h0, chg_hs[i])};
        }
    }

    if (task == 4) {
        for (int i = c; i <= n - c; i++) {
            int i2 = i - sh0;
            assert(0 <= i2 && i2 < fuck[g].size());
            std::cout << abs(fuck[g][i2].second) % mod << "\n";
        }
        std::cout.flush();
    }

    // if (task == 3) {
    int q;
    std::cin >> q;
    for (int test = 0; test < q; test++) {
        int cnt0;
        std::cin >> cnt0;
        int cnt = cnt0 - sh0;
        assert(0 <= cnt && cnt < fuck[g].size());
        assert(fuck[g][cnt].first != -1);
        auto ans = p;
        for (int i = g - 1; i >= 0; i--) {
            assert(fuck[i + 1][cnt].first != -1);
            if (fuck[i + 1][cnt].first != 0) {
                cnt -= chg[i];
                std::copy(pr[i].begin(), pr[i].end(), ans.begin() + beg[i]);
            }
        }
        int cnts = 0;
        for (int i = 0; i + 2 < n; i++) {
            cnts += sharp(input[ans[i]], input[ans[i + 1]], input[ans[i + 2]]);
        }
        assert(cnts == cnt0);
        for (int i = 0; i < n; i++) {
            std::cout << ans[i] + 1 << " \n"[i == n - 1];
        }
        std::cout.flush();
    }

    return 0;
}
