#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

#define int long long

int n;
const int N = 8e4 + 3;

mt19937_64 rnd(time(0));

struct Point {
    ll x, y, ind;

    ll operator*(Point b) {
        return x * b.x + y * b.y;
    }
    ll operator%(Point b) {
        return x * b.y - y * b.x;
    }
    Point operator-(Point b) {
        return {x - b.x, y - b.y};
    }
};

Point pts[N];

int get_cnt(vector<int> cur) {
    int cnt = 0;
    for (int i = 1; i < n - 1; i++) { //i - 1, i, i + 1
        auto v1 = pts[cur[i - 1]] - pts[cur[i]], v2 = pts[cur[i + 1]] - pts[cur[i]];
        cnt += ((v1 * v2 > 0) && (v1 % v2 > 0)) || ((v2 * v1 > 0) && (v2 % v1 > 0));
    }
    return cnt;
}

void solve() {
    int task, gr;
    cin >> task >> gr >> n;

    if (task != 1)
        exit(0);

    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
        pts[i].ind = i;
    }

    if (gr == 1) {
        sort(pts, pts + n, [&](Point a, Point b) {
            return a.x < b.x;
        });

        vector<int> p;
        int c = 0;
        int j = n - 1, i = 0;
        while (i <= j) {
            if (c == 0) p.emplace_back(pts[i++].ind);
            else p.emplace_back(pts[j--].ind);
            c ^= 1;
        }

        for (auto a: p) cout << a + 1 << ' ';
        cout << endl;
    } else {
        vector<int> p(n), best;
        iota(all(p), 0);
        best = p;
        for (int _ = 0; _ < 100000; _++) {
            shuffle(all(p), rnd);
            //dbg1(p)
            //dbg(get_cnt(p));
            if (get_cnt(p) > get_cnt(best))
                best = p;
        }
        //dbg(get_cnt(best));
        for (auto a : best) cout << a + 1 << ' ';
    }
}

signed main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
