// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <math.h>

using namespace std;
using ll = long long;
using ld = long double;

struct geom
{
	int x, y;
	
	geom operator+(geom oth) const
	{
		return geom{ x + oth.x,y + oth.y };
	}
	geom operator-(geom oth) const
	{
		return geom{ x - oth.x,y - oth.y };
	}
	ll operator*(geom oth) const
	{
		return 1ll * x * oth.x + 1ll * y * oth.y;
	}

	ll operator%(geom oth) const
	{
		return 1ll * x * oth.y - 1ll * y * oth.x;
	}

	void get()
	{
		cin >> x >> y;
	}

	bool operator<(geom oth) const
	{
		return x < oth.x;
	}
};

bool isbad(geom a, geom b)
{
	return (a * b) > 0;
}

bool isbad(geom a, geom b, geom c)
{
	return isbad(a - b, c - b);
}

#include <numeric>
#include <random>

#define TESTMODE

int main()
{
	srand(time(NULL));
	//srand(time(NULL));
    //std::cout << "Hello World!\n";
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	//while (true)
	//{
	//	geom a, b, c;
	//	a.get();
	//	//b.get();
	//	b = { 0,0 };
	//	c.get();
	//	a = a - b;
	//	c = c - b;
	//	cout << (a * c) << ' ' << (a % c) << '\n' << '\n';
	//}
	//cout << isbad(a, b);
	int __task, __group;
	cin >> __task >> __group;
	if (__task == 2)
	{
		int n;
		cin >> n;
		vector<int>etalon(n);
		iota(etalon.begin(), etalon.end(), 0);
		vector <geom> l(n);
		// maximize !isbad
		for (auto& i : l)
		{
			i.get();
		}
		int c;
		cin >> c;
		vector <int>p(n);
		iota(p.begin(), p.end(), 0);
		mt19937 bad_random(rand() + (rand() << 16));
		shuffle(p.begin(), p.end(), bad_random);
		int ans = 0;
		for (size_t i = 0; i < n - 2; i++)
		{
			ans += isbad(l[p[i]], l[p[i + 1]], l[p[i + 2]]);
		}
		while (ans >= c)
		{
			shuffle(p.begin(), p.end(), bad_random);
			// Max Cost Min Flow
			double T = 1.0;
			for (int step = 0; step < n && ans >= c; step++, T *= 0.5)
			{
				int i1 = step, i2 = rand() % n;
				set<int> upd;
				upd.insert(i1 - 2);
				upd.insert(i1 - 1);
				upd.insert(i1);
				upd.insert(i2 - 2);
				upd.insert(i2 - 1);
				upd.insert(i2);
				int tmp = ans;
				for (auto& t : upd)
				{
					if (t < n - 2 && t >= 0)
					{
						tmp -= isbad(l[p[t]], l[p[t + 1]], l[p[t + 2]]);
					}
				}
				swap(p[i1], p[i2]);
				for (auto& t : upd)
				{
					if (t < n - 2 && t >= 0)
					{
						tmp += isbad(l[p[t]], l[p[t + 1]], l[p[t + 2]]);
					}
				}
				if (tmp < ans || RAND_MAX * exp((ans - tmp) / T) > rand())
				{
					ans = tmp;
					continue;
				}
				swap(p[i1], p[i2]);
			}
		}
		for (auto& i : p)
		{
			cout << i + 1 << ' ';
		}
		return 0;
	}
#ifdef TESTMODE
	else
	{
		return -1;
	}
#endif
	if (__task == 1)
	{
		int n;
		cin >> n;
		vector<int>etalon(n);
		iota(etalon.begin(), etalon.end(), 0);
		vector <geom> l(n);
		// maximize !isbad
		for (auto& i : l)
		{
			i.get();
		}
		vector <int>p(n);
		iota(p.begin(), p.end(), 0);
		mt19937 bad_random(rand() + (rand() << 16));
		//shuffle(p.begin(), p.end(), bad_random);
		vector <int> t(n + 1);
		iota(t.begin(), t.end(), 0);
		{
			auto cpy = l;
			sort(cpy.begin(), cpy.end());
			map<geom, int> mp;
			for (size_t i = 0; i < n; i++)
			{
				mp[l[i]] = i;
			}
			for (size_t i = 0; i < n; i++)
			{
				t[i] = mp[cpy[i]];
			}
		}
		p[0] = t[0];
		for (size_t i = 1; i < n; i += 2)
		{
			p[i] = t[i + 1];
		}
		for (size_t i = 2; i < n; i += 2)
		{
			p[i] = t[i - 1];
		}
		if (n % 2 == 0)
		{
			p.back() = t[n - 1];
		}
#ifdef _DEBUG
		if (!is_permutation(p.begin(), p.end(), etalon.begin(), etalon.end()))
			return -1;
		if (!is_permutation(t.begin(), t.end() - 1, etalon.begin(), etalon.end()))
			return -1;
#endif
		int ans = 0;
		for (size_t i = 0; i < n - 2; i++)
		{
			ans += isbad(l[p[i]], l[p[i + 1]], l[p[i + 2]]);
		}
		vector <int>best = p;
		int bestans = ans;
		for (size_t i = 0; i < 150; i++)
		{
			// Max Cost Min Flow
			double T = 1.0;
			for (int step = 0; step < n; step++, T *= 0.8)
			{
				int i1 = rand() % n, i2 = rand() % n;
				set<int> upd;
				upd.insert(i1 - 2);
				upd.insert(i1 - 1);
				upd.insert(i1);
				upd.insert(i2 - 2);
				upd.insert(i2 - 1);
				upd.insert(i2);
				int tmp = ans;
				for (auto& t : upd)
				{
					if (t < n - 2 && t >= 0)
					{
						tmp -= isbad(l[p[t]], l[p[t + 1]], l[p[t + 2]]);
					}
				}
				swap(p[i1], p[i2]);
				for (auto& t : upd)
				{
					if (t < n - 2 && t >= 0)
					{
						tmp += isbad(l[p[t]], l[p[t + 1]], l[p[t + 2]]);
					}
				}
				if (tmp > bestans)
				{
					bestans = tmp;
					best = p;
				}
				if (tmp > ans || RAND_MAX * exp((tmp-ans)/T)>rand())
				{
					ans = tmp;
					continue;
				}
				swap(p[i1], p[i2]);
			}
		}
		for (auto& i : best)
		{
			cout << i + 1 << ' ';
		}
		return 0;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
