#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Vector {
    int x, y;

    Vector operator-(const Vector& b) const {
        return { b.x - x, b.y - y };
    }

    int operator*(const Vector& b) const {
        return x * b.x + y * b.y;
    }

    bool operator<(const Vector& b) const {
        if (x == b.x)
            return y < b.y;
        return x < b.x;
    }
};

using Point = Vector;

mt19937 gen(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
uniform_real_distribution<double> dist;

bool flip_coin(double chance) {
    return dist(gen) < chance;
}

template <typename T>
void shuffle(vector<T>& a) {
    for (int i = 0; i < a.size(); ++i)
        swap(a[i], a[gen() % a.size()]);
}

//meowmeowmeow
const int RUNS = 20, STEPS = 50000;
const int RUNS2 = 20, STEPS2 = 1000;

signed main() {
    int task, gr;
    cin >> task >> gr;
    int n;
    cin >> n;
    vector<Point> pts(n);
    for (auto& [x, y] : pts)
        cin >> x >> y;
    bool cond_inc = 1;
    for (int i = 1; i < n; ++i)
        if (pts[i].x < pts[i - 1].x || pts[i].y < pts[i - 1].y)
            cond_inc = 0;
    if (cond_inc && task == 1) {
        for (int i = 0; i < n / 2; ++i)
            cout << i + 1 << ' ' << n - i << ' ';
        if (n % 2)
            cout << n / 2 + 1;
        return 0;
    }
    auto ok = [&](int a, int b, int c) {
        return (pts[c] - pts[b]) * (pts[a] - pts[b]) > 0;
        };
    if (task == 1) {
        vector<int> perm(n);
        iota(perm.begin(), perm.end(), 0);
        shuffle(perm);
        int cur = 0;
        for (int i = 1; i + 1 < n; ++i)
            cur += ok(perm[i - 1], perm[i], perm[i + 1]);
        int best = cur;
        auto bestp = perm;
        for (int run = 0; run < RUNS; ++run) {
            double temp = 1000;
            for (int step = 0; step < STEPS; ++step) {
                int a = gen() % n, b = gen() % n;
                int ncur = cur;
                if (a - 2 >= 0)
                    ncur -= ok(perm[a - 2], perm[a - 1], perm[a]);
                if (a - 1 >= 0 && a + 1 < n)
                    ncur -= ok(perm[a - 1], perm[a], perm[a + 1]);
                if (a + 2 < n)
                    ncur -= ok(perm[a], perm[a + 1], perm[a + 2]);
                if (b - 2 >= 0)
                    ncur -= ok(perm[b - 2], perm[b - 1], perm[b]);
                if (b - 1 >= 0 && a + 1 < n)
                    ncur -= ok(perm[b - 1], perm[b], perm[b + 1]);
                if (b + 2 < n)
                    ncur -= ok(perm[b], perm[b + 1], perm[b + 2]);
                swap(perm[a], perm[b]);
                if (a - 2 >= 0)
                    ncur += ok(perm[a - 2], perm[a - 1], perm[a]);
                if (a - 1 >= 0 && a + 1 < n)
                    ncur += ok(perm[a - 1], perm[a], perm[a + 1]);
                if (a + 2 < n)
                    ncur += ok(perm[a], perm[a + 1], perm[a + 2]);
                if (b - 2 >= 0)
                    ncur += ok(perm[b - 2], perm[b - 1], perm[b]);
                if (b - 1 >= 0 && a + 1 < n)
                    ncur += ok(perm[b - 1], perm[b], perm[b + 1]);
                if (b + 2 < n)
                    ncur += ok(perm[b], perm[b + 1], perm[b + 2]);
                if (ncur > best) {
                    best = ncur;
                    bestp = perm;
                }
                if (ncur > cur || flip_coin(((double)(ncur - cur) / temp))) {
                    cur = ncur;
                } else {
                    swap(perm[a], perm[b]);
                }
                temp *= 0.9;
            }
        }
        for (auto el : bestp)
            cout << el + 1 << ' ';
        return 0;
    }
    int c;
    cin >> c;
    if (task == 3) {
        int q;
        cin >> q;
        while (q--) {
            int curreq;
            cin >> curreq;
            vector<int> perm(n);
            iota(perm.begin(), perm.end(), 0);
            shuffle(perm);
            int cur = 0;
            for (int i = 1; i + 1 < n; ++i)
                cur += ok(perm[i - 1], perm[i], perm[i + 1]);
            int best = cur;
            auto bestp = perm;
            for (int run = 0; run < RUNS2 && best != curreq; ++run) {
                double temp = 100;
                for (int step = 0; step < STEPS2; ++step) {
                    int a = gen() % n, b = gen() % n;
                    if (a == b) {
                        step -= 1;
                        continue;
                    }
                    if (a > b)
                        swap(a, b);
                    int ncur = cur;
                    if (a - 2 >= 0)
                        ncur -= ok(perm[a - 2], perm[a - 1], perm[a]);
                    if (a - 1 >= 0 && a + 1 < n)
                        ncur -= ok(perm[a - 1], perm[a], perm[a + 1]);
                    if (a + 2 < n)
                        ncur -= ok(perm[a], perm[a + 1], perm[a + 2]);
                    if (b - 2 >= 0 && b - 2 != a && b - 1 != a)
                        ncur -= ok(perm[b - 2], perm[b - 1], perm[b]);
                    if (b - 1 >= 0 && b + 1 < n && b - 1 != a)
                        ncur -= ok(perm[b - 1], perm[b], perm[b + 1]);
                    if (b + 2 < n)
                        ncur -= ok(perm[b], perm[b + 1], perm[b + 2]);
                    swap(perm[a], perm[b]);
                    if (a - 2 >= 0)
                        ncur += ok(perm[a - 2], perm[a - 1], perm[a]);
                    if (a - 1 >= 0 && a + 1 < n)
                        ncur += ok(perm[a - 1], perm[a], perm[a + 1]);
                    if (a + 2 < n)
                        ncur += ok(perm[a], perm[a + 1], perm[a + 2]);
                    if (b - 2 >= 0 && b - 2 != a && b - 1 != a)
                        ncur += ok(perm[b - 2], perm[b - 1], perm[b]);
                    if (b - 1 >= 0 && b + 1 < n && b - 1 != a)
                        ncur += ok(perm[b - 1], perm[b], perm[b + 1]);
                    if (b + 2 < n)
                        ncur += ok(perm[b], perm[b + 1], perm[b + 2]);
                    if (abs(ncur - curreq) < abs(best - curreq)) {
                        best = ncur;
                        bestp = perm;
                    }
                    if (best == curreq)
                        break;
                    if (abs(ncur - curreq) < abs(cur - curreq) || flip_coin(((double)(abs(cur - curreq) - abs(ncur - curreq)) / temp))) {
                        cur = ncur;
                    } else {
                        swap(perm[a], perm[b]);
                    }
                }
            }
            for (auto el : bestp)
                cout << el + 1 << ' ';
            cout << endl;
        }
    }
}