#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
const ll INF = 3e18;
//#define endl "\n"
mt19937 rnd(3);

struct vect {
    ll x, y;
    vect(ll x = 0, ll y = 0) : x(x), y(y) {}
};

vect operator- (vect a, vect b) {
    return { a.x - b.x, a.y - b.y };
}

ll scal(vect a, vect b) {
    return a.x * b.x + a.y * b.y;
}

ll cross(vect a, vect b) {
    return a.x * b.y - a.y * b.x;
}

vector<vect> vec;

bool check(ll i, ll j, ll k) {
    vect v1 = vec[j] - vec[i];
    vect v2 = vec[k] - vec[j];
    if (scal(v1, v2) < 0) return true;
    return false;
}

void update(vector<ll>* cur, ll& lans, ll x, ll i) {
    if (i <= 0 || i + 1 >= cur->size()) return;
    lans += x * check(cur->operator[](i - 1), cur->operator[](i), cur->operator[](i + 1));
}

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0); cout.tie(0);
    
    ll t, g; cin >> t >> g;
    ll n; cin >> n;
    vec.resize(n);
    for (ll i = 0; i < n; i++) cin >> vec[i].x >> vec[i].y;
    ll c = -1;
    if (t != 1) {
        cin >> c;
    }
    if (g == 7) {
        ll q; cin >> q;
        while (q--) {
            cin >> c;
            ll ct = c;
            ll i1 = 1, i2 = n;
            bool b = true;
            while (i1 <= i2) {
                if (b) {
                    cout << i1 << " ";
                    i1++;
                }
                else {
                    cout << i2 << " ";
                    i2--;
                }
                if (ct > 0) b = !b;
                ct--;
            }
            cout << endl;
        }
        return 0;
    }
    if (t == 3) {
        ll q; cin >> q;
        ll c0 = c;
        vector<vector<ll>> anss(n);
        vector<ll>* cur = new vector<ll>(n);
        iota(cur->begin(), cur->end(), 0);
        shuffle(cur->begin(), cur->end(), rnd);
        ll lans = 0;
        for (ll i = 2; i < n; i++) {
            lans += check(cur->operator[](i - 2), cur->operator[](i - 1), cur->operator[](i));
        }
        ll cc = 20000;
        while (cc--) {
            ll i1 = rnd() % n;
            ll i2 = rnd() % n;
            if (i1 > i2) swap(i1, i2);
            if (i1 == i2) continue;
            if (i2 - 1 > i1) update(cur, lans, -1, i1);
            update(cur, lans, -1, i1 - 1);
            if (i2 - 2 > i1) update(cur, lans, -1, i1 + 1);
            update(cur, lans, -1, i2);
            update(cur, lans, -1, i2 - 1);
            update(cur, lans, -1, i2 + 1);
            swap(cur->operator[](i1), cur->operator[](i2));
            if (i2 - 1 > i1) update(cur, lans, 1, i1);
            update(cur, lans, 1, i1 - 1);
            if (i2 - 2 > i1) update(cur, lans, 1, i1 + 1);
            update(cur, lans, 1, i2);
            update(cur, lans, 1, i2 - 1);
            update(cur, lans, 1, i2 + 1);
            if (anss[lans].empty() && lans >= c && lans <= n - c) {
                for (ll j = 0; j < cur->size(); j++) {
                    anss[lans].push_back(cur->operator[](j));
                }
            }
        }
        while (q--) {
            cin >> c;
            for (auto p : anss[c]) cout << p + 1 << " ";
            cout << endl;
        }
        return 0;
    }
    if (g == 1) {
        ll i1 = 1, i2 = n;
        bool b = true;
        while (i1 <= i2) {
            if (b) {
                cout << i1 << " ";
                i1++;
            }
            else {
                cout << i2 << " ";
                i2--;
            }
            b = !b;
        }
        cout << endl;
        return 0;
    }

    vector<ll> best(n);
    iota(best.begin(), best.end(), 0);
    ll bans = -1;
    ll cnt = 100;
    if (g == 8) cnt = 100000;
    while (cnt--) {
        vector<ll> cur(n);
        iota(cur.begin(), cur.end(), 0);
        shuffle(cur.begin(), cur.end(), rnd);
        if (g != 8) {
            for (ll i = 2; i < n; i++) {
                ll mc = 10000;
                while (mc-- && !check(cur[i - 2], cur[i - 1], cur[i])) {
                    ll id = i + rnd() % (n - i);
                    swap(cur[i], cur[id]);
                }
            }
        }
        ll lans = 0;
        for (ll i = 2; i < n; i++) {
            lans += check(cur[i - 2], cur[i - 1], cur[i]);
        }
        if ((c == -1 && lans > bans) || lans == c) {
            best = cur;
            bans = lans;
        }
    }
    for (auto p : best) cout << p + 1 << " ";
    cout << endl;
}