#ifndef LOCALEGOR
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,sse2,bmi2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

struct Point {
    int x, y;
    Point() {}
    Point (int x, int y) : x(x), y(y) {}
    Point (Point a, Point b)  : x(b.x - a.x), y(b.y - a.y) {}
};

istream& operator>>(istream& in, Point& p) {
    return in >> p.x >> p.y;
}

int operator*(Point a, Point b) {
    return a.x * b.x + a.y * b.y;
}

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Point> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    if (task == 1) {
        if (group == 1) {
            for (int i = 1, j = n; i <= j;) {
                cout << i++ << ' ';
                if (i <= j) cout << j-- << ' ';
            }
        } else if (group == 2) {
            int best = 0;
            vector<int> bst;
            vector<int> order(n);
            iota(all(order), 0);
            do {
                    int cnt = 0;
                for (int i = 1; i < n - 1; ++i) {
                    Point v1 = Point(p[order[i]], p[order[i - 1]]);
                    Point v2 = Point(p[order[i]], p[order[i + 1]]);
                    if (v1 * v2 > 0) ++cnt;
                }
                if (cnt == n - 2) {
                    best = cnt;
                    bst = order;
                }
            } while (next_permutation(all(order)));
            for (auto i : bst) {
                cout << i + 1 << '\n';
            }
        } else {
            vector<int> order(n);
            iota(all(order), 0);
            sort(all(order), [&](int a, int b) {
                if (rnd()&1) return p[a].x < p[b].x;
                return p[a].y < p[b].y;
            });
            for (int i = 1, j = n; i <= j;) {
                cout << order[(++i)-2]+1 << ' ';
                if (i <= j) cout << order[--j]+1 << ' ';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}