#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));
//mt19937_64 rnd(0);

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

struct point
{
	long long x, y;
};

struct vec
{
	long long x, y;

	vec(point p1, point p2):
		x(p2.x - p1.x), y(p2.y - p1.y) {}

	long long operator * (vec v)
	{
		return x * v.x + y * v.y;
	}

	long long operator ^ (vec v)
	{
		return x * v.y - y * v.x;
	}
};

int task, group;

void solve1(long long n, vector<point> p)
{
	if (n <= 10)
	{
		vector<long long> perm(n);
		iota(perm.begin(), perm.end(), 0);
		vector<long long> ans;
		long long have = -1;
		do
		{
			long long cnt = 0;
			for (long long i = 1; i < perm.size() - 1; i++)
			{
				if (vec(p[perm[i - 1]], p[perm[i]]) * vec(p[perm[i]], p[perm[i + 1]]) < 0)
				{
					cnt++;
				}
			}
			if (cnt > have)
			{
				have = cnt;
				ans = perm;
			}
			next_permutation(perm.begin(), perm.end());
		} while (!is_sorted(perm.begin(), perm.end()));
		for (auto& i : ans)
		{
			cout << i + 1 << " ";
		}
		cout << "\n";
	}
	else
	{
		for (long long i = 0; i < n / 2; i++)
		{
			cout << i + 1 << " " << n - i << " ";
		}
		if (n % 2)
		{
			cout << n / 2 + 1 << " ";
		}
		cout << "\n";
	}
	cout.flush();
}

void solve3(long long n, vector<point> p)
{
	long long c;
	cin >> c;
	long long q;
	cin >> q;
	while (q--)
	{
		long long k;
		cin >> k;
		cout << 1 << " ";
		long long l = 2, r = n;
		long long rem = n - 2 - k;
		for (long long i = 0; i < rem; i++)
		{
			cout << l << " ";
			l++;
		}
		while (l <= r)
		{
			cout << r << " ";
			r--;
			if (l > r)
			{
				break;
			}
			cout << l << " ";
			l++;
		}
		cout << "\n";
		cout.flush();
	}
}

void solve()
{
	long long n;
	vector<point> p;
	cin >> n;
	p.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> p[i].x >> p[i].y;
	}
	if (task == 1)
	{
		solve1(n, p);
	}
	else if (task == 3)
	{
		solve3(n, p);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> task >> group;

	solve();

	return 0;
}

/*

























*/
