#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;

struct Point {
	ll x, y;
	ll i;

	bool operator< (Point a) {
		return (this->x + this->y) < (a.x + a.y);
	}
};

bool isAngle(Point A, Point B, Point C) {
	ll a = (B.x - A.x) * (B.y - A.y);
	ll b = (B.x - C.x) * (B.y - C.y);
	return a / b < 0;
}

pair<vector<ll>, ll> Buravchik(vector<Point>& vec, vector<ll>& out, map<ll, bool>& used, ll n, ll count) {
	if (count == n) {
		ll out_ll = 0;
		for (ll i = 1; i < n - 1; i++) {
			out_ll += isAngle(vec[i - 1], vec[i], vec[i + 1]);
		}
		return { out, out_ll };
	}
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	ll task, group;
	cin >> task >> group;

	if (task == 1) {
		ll n;
		cin >> n;
		vector<Point> vec(n);
		for (ll i = 0; i < n; i++) {
			cin >> vec[i].x >> vec[i].y;
		}
		if (group == 1) {
			for (ll i = 0; i * 2 < n; i++) {
				cout << i + 1 << " " << n - i << " ";
			}
			if (n % 2 != 0) {
				cout << n / 2;
			}
			return 0;
		}
		vector<ll> out;
		map<ll, bool> used;
		for (ll i : Buravchik(vec, out, used, n, 0).first) {
			cout << i << " ";
		}
	}
	if (task == 2) {
		ll n;
		cin >> n;
		vector<Point> vec(n);
		for (ll i = 0; i < n; i++) {
			cin >> vec[i].x >> vec[i].y;
			vec[i].i = i + 1;
		}
		ll c;
		cin >> c;
		sort(vec.begin(), vec.end());
		for (ll i = 0; i < n; i++) {
			cout << vec[i].i << " ";
		}
		return 0;
	}
}






	/*    \|/ 0
	       | /|\  
	       |~ | '
	         / \       */
