#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct Point {
    ll x, y;

    Point() : x(0), y(0) {}

    Point(ll _x, ll _y) : x(_x), y(_y) {}

    Point operator+(const Point& other) {
        return Point(x + other.x, y + other.y);
    }

    ll operator*(const Point& other) {
        return x * other.x + y * other.y;
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << " " << (n - i) << " ";
    }
    if (n % 2 == 0) {
        cout << n / 2 + 1;
    }
    cout << endl;
}

void solve7() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        int k;
        cin >> k;
        int l = 0, r = n;
        for (int i = 0; i <= k; ++i) {
            if (i % 2 == 0) {
                cout << i / 2 + 1 << " ";
                l = i / 2;
            } else {
                cout << (n - (i / 2)) << " ";
                r = n - (i / 2) - 1;
            }
        }
        if (k % 2 == 0) {
            for (int i = l + 1; i < r; ++i) {
                cout << i + 1 << " ";
            }
        } else {
            for (int i = r - 1; i > l; --i) {
                cout << i + 1 << " ";
            }
        }
        cout << endl;
    }
}

const ll BASE = 1e6 + 3;
const ll MOD = 1e9 + 7;

ll bpow(ll b, ll p) {
    if (p == 0) {
        return 1;
    }
    if (p == 1) {
        return b;
    }
    if (p % 2 == 1) {
        return (bpow(b, p - 1) * b) % MOD;
    }
    ll t = bpow(b, p / 2);
    return (t * t) % MOD;
}

ll inv(ll x) {
    return bpow(x, MOD - 2);
}

ll subh(vector<ll>& h, vector<ll>& pw, int l, int r) {
    return ((((h[r - 1] - h[l - 1]) % MOD + MOD) % MOD) * inv(pw[l])) % MOD;
}

void solve16() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    vector<ll> PW(n);
    PW[0] = 1;
    for (int i = 1; i < n; ++i) {
        PW[i] = (PW[i - 1] * BASE) % MOD;
    }

    vector<ll> phash(n);
    phash[0] = 1;
    for (int i = 1; i < n; ++i) {
        if (i % 2 == 0) {
            phash[i] = (phash[i - 1] + (i / 2 + 1) * PW[i]) % MOD;
        } else {
            phash[i] = (phash[i - 1] + (n - (i / 2)) * PW[i]) % MOD;
        }
    }

    vector<ll> fhash(n), rhash(n);
    fhash[0] = 1;
    rhash[0] = n;

    for (int i = 1; i < n; ++i) {
        fhash[i] = (fhash[i - 1] + (i + 1) * PW[i]) % MOD;
        rhash[i] = (rhash[i - 1] + (n - i) * PW[i]) % MOD;
    }

    int c;
    cin >> c;

    for (int k = c; k <= n - c; ++k) {
        int l, r;
        if (k % 2 == 0) {
            l = k / 2;
            r = n - (k / 2);
            cout << (phash[k] + (subh(fhash, PW, l + 1, r) * PW[k + 1]) % MOD) % MOD << " ";
        } else {
            l = k / 2;
            r = n - (k / 2) - 1;
            cout << (phash[k] + (subh(rhash, PW, n - r, n - l - 1) * PW[k + 1]) % MOD) % MOD << " ";
        }
    }
    cout << endl;
    int q;
    cin >> q;
    while (q--) {
        int k;
        cin >> k;
        int l = 0, r = n;
        for (int i = 0; i <= k; ++i) {
            if (i % 2 == 0) {
                cout << i / 2 + 1 << " ";
                l = i / 2;
            } else {
                cout << (n - (i / 2)) << " ";
                r = n - (i / 2) - 1;
            }
        }
        if (k % 2 == 0) {
            for (int i = l + 1; i < r; ++i) {
                cout << i + 1 << " ";
            }
        } else {
            for (int i = r - 1; i > l; --i) {
                cout << i + 1 << " ";
            }
        }
        cout << endl;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        int task, g;
        cin >> task >> g;

        if (task == 1) {
            solve1();
        } else if (task == 3) {
            solve7();
        } else if (task == 4) {
            solve16();
        }
    }
    return 0;
}
