#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

int n, c, task, group;
vector<ll> x, y;

ll dist(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
}

void solve1() {
    vector<int> ans = {0};
    vector<int> used(n);
    used[0] = 1;

    for (int iter = 0; iter < n - 1; iter++) {
        int lst = ans.back();
        ll mx = -1;
        int id = -1;
        for (int i = 0; i < n; i++) {
            if (used[i]) continue;
            ll d = dist(i, lst);
            if (d > mx) {
                mx = d;
                id = i;
            }
        }
        ans.push_back(id);
        used[id] = 1;
    }

    for (int i = 0; i < n; i++) cout << ans[i] + 1 << ' ';
    cout << endl;
}

ll dot(ll x1, ll y1, ll x2, ll y2) {
    return x1 * x2 + y1 * y2;
}

void solve2() {
    vector<int> p(n);
    iota(all(p), 0);
    shuffle(all(p), rng);

    for (int iteration = 0; iteration < 1000; iteration++) {
        for (int i = 0; i + 2 < n; i++) {
            ll x1 = x[p[i]] - x[p[i + 2]];
            ll y1 = y[p[i]] - y[p[i + 2]];
            ll x2 = x[p[i + 1]] - x[p[i + 2]];
            ll y2 = y[p[i + 1]] - y[p[i + 2]];

            if (dot(x1, y1, x2, y2) <= 0) {
                swap(p[i + 1], p[i + 2]);
            }
        }
    }

    for (int i = 0; i < n; i++) cout << p[i] + 1 << ' ';
    cout << endl;
}

void solve3() {

}

void solve4() {

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> task >> group;
    cin >> n;
    x.resize(n);
    y.resize(n);
    for (int i = 0; i < n; i++) cin >> x[i] >> y[i];

    if (task != 1) cin >> c;

    if (task == 1) solve1();
    if (task == 2) solve2();
    if (task == 3) solve3();
    if (task == 4) solve4();

    return 0;
}
