#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

const ll b = 1e6 + 3;
const int mod = 1e9 + 7;

int n, c, task, group;
vector<ll> x, y;

ll dist(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
}

void solve1() {
    vector<int> ans = {0};
    vector<int> used(n);
    used[0] = 1;

    for (int iter = 0; iter < n - 1; iter++) {
        int lst = ans.back();
        ll mx = -1;
        int id = -1;
        for (int i = 0; i < n; i++) {
            if (used[i]) continue;
            ll d = dist(i, lst);
            if (d > mx) {
                mx = d;
                id = i;
            }
        }
        ans.push_back(id);
        used[id] = 1;
    }

    for (int i = 0; i < n; i++) cout << ans[i] + 1 << ' ';
    cout << endl;
}

ll dot(ll x1, ll y1, ll x2, ll y2) {
    return x1 * x2 + y1 * y2;
}

void solve2() {

}

void solve3() {
    int q;
    cin >> q;
    for (int query = 0; query < q; query++) {
        int k;
        cin >> k;
        vector<int> p(n);

        if (k % 2 == 1) {
            k--;
            p[0] = n;
            iota(p.begin() + 1, p.end(), 1);
            for (int i = 2; i < n && k > 0; i += 2, k -= 2) swap(p[i], p[i + 1]);
        } else {
            iota(all(p), 1);
            for (int i = 1; i < n && k > 0; i += 2, k -= 2) swap(p[i], p[i + 1]);
        }

        for (int i = 0; i < n; i++) cout << p[i] << ' ';
        cout << endl;
    }
}

ll deg[80001];

void solve4() {
    int q, cur;
    ll hash = 0;
    vector<int> p(n);

    vector<ll> res(n + 1);

    {
        iota(all(p), 1);
        hash = 0, cur = 0;
        for (int i = 0; i < n; i++) hash = (hash + p[i] * deg[i]) % mod;

        for (int i = 1; i + 1 < n; i += 2, cur += 2) {
            res[cur] = hash;
            hash -= p[i] * deg[i];
            hash -= p[i + 1] * deg[i + 1];
            swap(p[i], p[i + 1]);
            hash += p[i] * deg[i];
            hash += p[i + 1] * deg[i + 1];

            hash %= mod;
            if (hash < 0) hash += mod;
        }
        res[cur] = hash;
    }

    {
        p[0] = n;
        iota(p.begin() + 1, p.end(), 1);
        hash = 0, cur = 1;
        for (int i = 0; i < n; i++) hash = (hash + p[i] * deg[i]) % mod;

        for (int i = 2; i + 1 < n; i += 2, cur += 2) {
            res[cur] = hash;
            hash -= p[i] * deg[i];
            hash -= p[i + 1] * deg[i + 1];
            swap(p[i], p[i + 1]);
            hash += p[i] * deg[i];
            hash += p[i + 1] * deg[i + 1];

            hash %= mod;
            if (hash < 0) hash += mod;
        }
        res[cur] = hash;
    }

    for (int i = c; i <= n - c; i++) cout << res[i] << ' ';
    cout << endl;

    cin >> q;
    for (int query = 0; query < q; query++) {
        int k;
        cin >> k;
        if (k % 2 == 1) {
            k--;
            p[0] = n;
            iota(p.begin() + 1, p.end(), 1);
            for (int i = 2; i < n && k > 0; i += 2, k -= 2) swap(p[i], p[i + 1]);
        } else {
            iota(all(p), 1);
            for (int i = 1; i < n && k > 0; i += 2, k -= 2) swap(p[i], p[i + 1]);
        }

        for (int i = 0; i < n; i++) cout << p[i] << ' ';
        cout << endl;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    deg[0] = 1;
    for (int i = 1; i <= 80000; i++) deg[i] = (deg[i - 1] * b) % mod;

    cin >> task >> group;
    cin >> n;
    x.resize(n);
    y.resize(n);
    for (int i = 0; i < n; i++) cin >> x[i] >> y[i];

    if (task != 1) cin >> c;

    if (task == 1) solve1();
    if (task == 2) solve2();
    if (task == 3) solve3();
    if (task == 4) solve4();

    return 0;
}
