#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
using namespace std;

typedef long long ll;

int task, group;
int n;
vector<pair<ll, ll>> P;
vector<int> perm;
mt19937 rnd;

int myRand()
{
    return rnd();
}

ll dist(pair<ll, ll>& p1, pair<ll, ll>& p2)
{
    return (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second);
}

bool is_angle_good(pair<ll, ll>& p1, pair<ll, ll>& p2, pair<ll, ll>& p3)
{
    unsigned long long d1 = dist(p1, p2);
    unsigned long long d2 = dist(p2, p3);
    unsigned long long d3 = dist(p1, p3);
    return d1 + d2 > d3;
}

int count(vector<int>& perm)
{
    int cnt = 0;
    for (int i = 1; i < n - 1; i++)
    {
        if (is_angle_good(P[perm[i - 1]], P[perm[i]], P[perm[i + 1]]))
            cnt++;
    }
    return cnt;
}

int main()
{
    // ios::sync_with_stdio(false);
    // cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    rnd.seed(time(0));
    cin >> task >> group >> n;
    P = vector<pair<ll, ll>>(n);
    for (int i = 0; i < n; i++)
        cin >> P[i].first >> P[i].second;
    if (task == 1)
    {
        if (n <= 10)
        {
            perm = vector<int>(n, 0);
            vector<int> best_perm;
            int res = 0;
            for (int i = 0; i < n; i++)
                perm[i] = i;
            for (int i = 0; i < 10000; i++)
            {
                shuffle(perm.begin(), perm.end(), rnd);
                int cur_res = count(perm);
                if (cur_res > res)
                {
                    best_perm = perm;
                    res = cur_res;
                }
            }
            for (int i = 0; i < n; i++)
                cout << best_perm[i] + 1 << ' ';
            cout << endl;
        }else
        {
            for (int i = 0; i < n; i++)
            {
                if (i & 1)
                {
                    cout << n - (i >> 1) << ' ';
                }else
                {
                    cout << (i >> 1) + 1 << ' ';
                }
            }
            cout << endl;
        }
    }else
    {
        int c; cin >> c;
        if (task == 2)
        {
            perm = vector<int>(n, 0);
            for (int i = 0; i < n; i++)
                perm[i] = i;
            while (true)
            {
                shuffle(perm.begin(), perm.end(), rnd);
                if (count(perm) <= c)
                    break;
            }
            for (int i = 0; i < n; i++)
                cout << perm[i] + 1 << ' ';
            cout << endl;
        }else
        {
            vector<int> perm(n);
            for (int i = 0; i < n; i++)
            {
                if (i & 1)
                {
                    perm[i] = n - 1 - (i >> 1);
                }else
                {
                    perm[i] = (i >> 1);
                }
            }
            int q; cin >> q;
            if (n <= 50)
            {
                for (int i = 0; i < q; i++)
                {
                    int x; cin >> x;
                    while (true)
                    {
                        shuffle(perm.begin(), perm.end(), rnd);
                        if (count(perm) == x)
                            break;
                    }
                    for (int i = 0; i < n; i++)
                        cout << perm[i] + 1 << ' ';
                    cout << endl;
                }
            }else
            {
                for (int i = 0; i < q; i++)
                {
                    vector<bool> used(n, false);
                    int x; cin >> x;
                    for (int i = 0; i < x + 1; i++)
                    {
                        used[perm[i]] = true;
                        cout << perm[i] + 1 << ' ';
                    }
                    int t = perm[x];
                    if ((x) & 1)
                    {
                        for (int i = t - 1; i >= 0; i--)
                        {
                            if (used[i])
                                break;
                            cout << i + 1 << ' ';
                        }
                        cout << endl;
                    }else
                    {
                        for (int i = t + 1; i < n; i++)
                        {
                            if (used[i])
                                break;
                            cout << i + 1 << ' ';
                        }
                        cout << endl;
                    }
                }
            }
        }
    }
    return 0;
}