#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

template<typename T>
struct dot{
    T x, y;

    dot() {
        x = 0;
        y = 0;
    }

    dot(T x_, T y_) {
        x = x_;
        y = y_;
    }

    dot operator+(const dot &other) {
        return {x + other.x, y + other.y};
    }

    dot operator-(const dot &other) {
        return {x - other.x, y - other.y};
    }

    T operator%(const dot &other) {
        return x * other.y - y * other.x;
    }

    T operator*(const dot &other) {
        return x * other.x + y * other.y;
    }
};

using point = dot<ll>;

vector<point> a;
vector<int> p, ans;
int need;
int mx;
int n;

mt19937 rnd(5762);

int f() {
    int now = 0;
    for (int i = 0; i < n - 2; ++i) {
        point b = a[i + 1] - a[i], c = a[i + 2] - a[i + 1];
        ld phi = atan2(b % c, b * c);
        if (abs(phi) * 2 > M_PI) {
            ++now;
        }
    }
    return abs(need - now);
}

void gen(int cnt_gen) {
    int now = f();
    for (int i = 0; i < cnt_gen; ++i) {
        int j = rnd() % n;
        int k = rnd() % n;
        swap(j, k);
        int will = f();
        if (will < now || 1.0 * (cnt_gen - i) / cnt_gen <= (rnd() % 10000) / 10000.0) {
            now = will;
            if (now < mx) {
                mx = now;
                ans = p;
                if (mx == 0) {
                    return;
                }
            }
        } else {
            swap(j, k);
        }
    }
}

void solve() {
    int task, group;
    cin >> task >> group;
    cin >> n;
    a.resize(n);
    p.resize(n);
    for (auto &i : a) cin >> i.x >> i.y;
    if (task == 1) {
        ans = p;
        mx = n;
        need = n;
        iota(p.begin(), p.end(), 0);
        gen(300000);
        for (int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << ' ';
        }
        return;
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
    return 0;
}
