#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

template<typename T>
struct dot{
    T x, y;

    dot() {
        x = 0;
        y = 0;
    }

    dot(T x_, T y_) {
        x = x_;
        y = y_;
    }

    dot operator+(const dot &other) {
        return {x + other.x, y + other.y};
    }

    dot operator-(const dot &other) {
        return {x - other.x, y - other.y};
    }

    T operator%(const dot &other) {
        return x * other.y - y * other.x;
    }

    T operator*(const dot &other) {
        return x * other.x + y * other.y;
    }
};

using point = dot<ll>;

vector<point> a;
vector<int> p, ans;
int need;
int mx;
int n;

mt19937 rnd(239);
ld eps = 1e-8;

bool eq(ld c, ld b) {
    return fabs(c - b) <= eps;
}

const ld PI = 3.141592653589793;

int f() {
    int now = 0;
    for (int i = 0; i < n - 2; ++i) {
        point b = a[p[i + 1]] - a[p[i]], c = a[p[i + 2]] - a[p[i + 1]];
        ld phi = atan2(b % c, b * c);
        if (abs(phi) * 2 > PI && !eq(abs(phi) * 2, PI)) {
            ++now;
        }
    }
    return abs(need - now);
}

void gen(int cnt_gen) {
    int now = f();
    if (now < mx) {
        mx = now;
        ans = p;
        if (mx == 0) {
            return;
        }
    }
    for (int i = 0; i < cnt_gen; ++i) {
        int j = rnd() % n;
        int k = rnd() % n;
        swap(p[j], p[k]);
        int will = f();
        if (will < now || 1.0 * (cnt_gen - i) / cnt_gen >= (rnd() % 10000) / 10000.0) {
            now = will;
            if (now < mx) {
                mx = now;
                ans = p;
                if (mx == 0) {
                    return;
                }
            }
        } else {
            swap(p[j], p[k]);
        }
    }
}

void solve() {
    int task, group;
    cin >> task >> group;
    cin >> n;
    a.resize(n);
    p.resize(n);
    for (auto &i : a) cin >> i.x >> i.y;
    if (task == 1) {
        ans = p;
        mx = n;
        need = n - 2;
        iota(p.begin(), p.end(), 0);
        std::random_shuffle(p.begin(), p.end());
        gen(70000);

        for (int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << ' ';
        }
        cout << endl;
        return;
    }
    int c;
    cin >> c;
    if (task == 2) {
        ans = p;
        mx = n;
        need = 0;
        iota(p.begin(), p.end(), 0);
        std::random_shuffle(p.begin(), p.end());
        gen(70000);

        for (int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << ' ';
        }
        cout << endl;
        return;
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
    return 0;
}
