#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

int sqr(int x) {
        return x * x;
}

int sign(int x) {
        if (x < 0)
                return -1;
        return x != 0;
}

struct Point {
        int x, y;

        Point() {
                x = y = 0;
        }

        Point(int _x, int _y) {
                x = _x, y = _y;
        }

        int operator%(Point &t) const {
                return x * t.y - y * t.x;
        }

        int dist2(Point t) {
                return sqr(x - t.x) * sqr(y - t.y);
        }

        int len2() {
                return dist2(Point());
        }
};

void solve() {
        int task, group;
        cin >> task >> group;
        if (task == 1) {
                int n;
                cin >> n;
                vector<Point> vp(n);
                for (auto &[x, y]: vp)
                        cin >> x >> y;
                vector<int> ind(n);
                iota(all(ind), 0ll);
                sort(all(ind), [&](int i, int j) {
                        return vp[i].x < vp[j].x;
                });
                for (int i = 0; i < n / 2; ++i)
                        cout << ind[i] + 1 << ' ' << ind[n - i - 1] + 1 << ' ';
                if (n % 2)
                        cout << ind[n / 2] + 1;
                cout << endl;
        } else if (task == 2) {
                int n;
                cin >> n;
                vector<pair<Point, int>> vp(n);
                for (int j = 0; auto &[p, i]: vp)
                        cin >> p.x >> p.y, i = j++;
                int c;
                cin >> c;
                vector<int> ans;
                while (sz(vp) > 2) {
                        auto p = min_element(all(vp),
                                             [&](auto &i, auto &j) {
                                                     return i.first.y < j.first.y ||
                                                            (i.first.y == j.first.y && i.first.x < j.first.x);
                                             })->first;
                        for (auto &[pp, i]: vp)
                                pp.x -= p.x, pp.y -= p.y;
                        sort(all(vp), [&](auto &i, auto &j) {
                                return i.first % j.first < 0 ||
                                       (i.first % j.first == 0 && i.first.len2() < j.first.len2());
                        });
                        vector<pair<Point, int>> vpp;
                        vector<int> h = {0, 1};
                        for (int i = 2; i < sz(vp); ++i) {
                                while (sz(h) > 1 && vp[i].first % vp[h.back()].first < 0)
                                        vpp.emplace_back(vp[h.back()]), h.pop_back();
                                h.emplace_back(i);
                        }
                        for (int& i : h)
                                ans.emplace_back(vp[i].second);
                        vp = vpp;
                }
                while (sz(vp))
                        ans.emplace_back(vp.front().second), vp.pop_back();
                for (int &i: ans)
                        cout << i + 1 << ' ';
                cout << endl;
        }
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        // cin >> _t;
        while (_t--)
                solve();

        return 0;
}
