#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

int sqr(int x) {
        return x * x;
}

int sign(int x) {
        if (x < 0)
                return -1;
        return x != 0;
}

struct Point {
        int x, y;

        Point() {
                x = y = 0;
        }

        Point(int _x, int _y) {
                x = _x, y = _y;
        }

        int operator%(Point &t) const {
                return x * t.y - y * t.x;
        }

        int operator*(Point t) const {
                return x * t.x - y * t.y;
        }

        Point operator-(Point t) {
                return Point(x - t.x, y - t.y);
        }

        int dist2(Point t) {
                return sqr(x - t.x) * sqr(y - t.y);
        }

        int len2() {
                return dist2(Point());
        }
};

random_device rd;
mt19937 rnd(rd());

ld gen() {
        return rnd() / UINT32_MAX;
}

void solve() {
        int task, group;
        cin >> task >> group;
        if (task == 1) {
                int n;
                cin >> n;
                vector<Point> vp(n);
                for (auto &[x, y]: vp)
                        cin >> x >> y;
                vector<int> ans;
                int anss = 0;
                for (int _ = 0; _ < 1000; ++_) {
                        vector<int> p(n);
                        iota(all(p), 0ll);
                        shuffle(all(p), rnd);
                        ld t = 1;
                        for (int k = 0; k < 10000; ++k) {
                                t *= 0.99;
                                int a = 0, b = 0;
                                int i = rnd() % (n - 3) + 3;
                                a += (vp[p[i - 1]] - vp[p[i - 2]]) * (vp[p[i]] - vp[p[i - 1]]) > 0;
                                a += (vp[p[i - 2]] - vp[p[i - 3]]) * (vp[p[i - 1]] - vp[p[i - 2]]) > 0;
                                b += (vp[p[i - 1]] - vp[p[i - 3]]) * (vp[p[i - 2]] - vp[p[i - 1]]) > 0;
                                b += (vp[p[i - 2]] - vp[p[i - 1]]) * (vp[p[i]] - vp[p[i - 2]]) > 0;
                                if (a < b || expl((b - a) / t) > gen()) {
                                        swap(p[i - 1], p[i - 2]);
                                }
                        }
                        int cur = 0;
                        for (int i = 2; i < n; ++i)
                                cur += (vp[p[i - 1]] - vp[p[i - 2]]) * (vp[p[i]] - vp[p[i - 1]]) > 0;
                        if (smax(anss, cur))
                                ans = p;
                }
                debug(anss);
                for (int &i: ans)
                        cout << i + 1 << ' ';
                cout << endl;
        } else if (task == 2) {
                int n;
                cin >> n;
                vector<Point> vp(n);
                for (auto &[x, y]: vp)
                        cin >> x >> y;
                vector<int> ans;
                int anss = 1e9;
                for (int _ = 0; _ < 1000; ++_) {
                        vector<int> p(n);
                        iota(all(p), 0ll);
                        shuffle(all(p), rnd);
                        ld t = 1;
                        for (int k = 0; k < 10000; ++k) {
                                t *= 0.99;
                                int a = 0, b = 0;
                                int i = rnd() % (n - 3) + 3;
                                a += (vp[p[i - 1]] - vp[p[i - 2]]) * (vp[p[i]] - vp[p[i - 1]]) > 0;
                                a += (vp[p[i - 2]] - vp[p[i - 3]]) * (vp[p[i - 1]] - vp[p[i - 2]]) > 0;
                                b += (vp[p[i - 1]] - vp[p[i - 3]]) * (vp[p[i - 2]] - vp[p[i - 1]]) > 0;
                                b += (vp[p[i - 2]] - vp[p[i - 1]]) * (vp[p[i]] - vp[p[i - 2]]) > 0;
                                if (a > b || expl((a - b) / t) > gen()) {
                                        swap(p[i - 1], p[i - 2]);
                                }
                        }
                        int cur = 0;
                        for (int i = 2; i < n; ++i)
                                cur += (vp[p[i - 1]] - vp[p[i - 2]]) * (vp[p[i]] - vp[p[i - 1]]) > 0;
                        if (smin(anss, cur))
                                ans = p;
                }
                int c;
                cin >> c;
                debug(anss);
                for (int &i: ans)
                        cout << i + 1 << ' ';
                cout << endl;
                
        }
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        // cin >> _t;
        while (_t--)
                solve();

        return 0;
}
