#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

int get(int x, int y) {
    if (x >= 0 && y >= 0) {
        return 1;
    } else if (x < 0 && y >= 0) {
        return 2;
    } else if (x < 0 && y < 0) {
        return 3;
    } else {
        return 4;
    }
}

int len2(int x, int y) {
    return x * x + y * y;
}

int cross(int x1, int y1, int x2, int y2) {
    return x1 * y2 - x2 * y1;
}

int scal(int x1, int y1, int x2, int y2) {
    return x1 * x2 + y1 * y2;
}

void solve1() {
    int g;
    cin >> g;

    int n;
    cin >> n;

    vector <int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }

    if (g == 1) {
        int l = 1, r = n;
        while (l <= r) {
            if (l <= r) {
                cout << l << " ";
                l++;
            }
            if (l <= r) {
                cout << r << " ";
                r--;
            }
        }
        return;
    } else if (g == 2) {
        vector <int> ord(n);
        iota(all(ord), 0);
        sort(all(ord), [&](int i, int j) {
            int gi = get(x[i], y[i]);
            int gj = get(x[j], y[j]);
            if (gi != gj) {
                return gi < gj;
            } else {
                return (x[i] * y[j] - x[j] * y[i] == 0 ? len2(x[i], y[i]) < len2(x[j], y[j]) : x[i] * y[j] - x[j] * y[i] > 0);
            }
        });
        int l = 0, r = n - 1;
        while (l <= r) {
            if (l <= r) {
                cout << ord[l] + 1 << " ";
                l++;
            }
            if (l <= r) {
                cout << ord[r] + 1 << " ";
                r--;
            }
        }
        cout << endl;
        return;
    } else {
        vector <int> ord(n);
        iota(all(ord), 0);
        int T = 10000;
        mt19937 rnd(37);
        vector <int> best(n);
        int res = -1;
        while (T--) {
            shuffle(all(ord), rnd);
            int cnt = 0;
            for (int i = 1; i + 1 < n; i++) {
                if (scal(x[i] - x[i - 1], y[i] - y[i - 1], x[i + 1] - x[i], y[i + 1] - y[i]) < 0) {
                    cnt++;
                }
            }
            if (cnt > res) {
                res = cnt;
                best = ord;
            }
        }
        for (int i : best) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }
}

void solve() {
    int task;
    cin >> task;

    if (task == 1) {
        solve1();
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}