#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
struct point {
	int x, y;
	point operator -(point p) {
		return { x - p.x, y - p.y };
	}
};
ll scalar(point p1, point p2) {
	return p1.x * 1ll * p2.x + p1.y * 1ll * p2.y;
}
ll cross(point p1, point p2) {
	return p1.x * 1ll * p2.y - p1.y * 1ll * p2.x;
}
bool operator <(const point p1, const point p2) {
	return p1.x < p2.x;
}
int get(vector<point> v) {
	int cnt = 0, n = v.size();
	for (int i = 2; i < n; i++) {
		if (scalar(v[i - 2] - v[i - 1], v[i] - v[i - 1]) > 0 &&
		cross(v[i - 2] - v[i - 1], v[i] - v[i - 1]) != 0) cnt++;
	}
	return cnt;
}
const int mx = 1e6;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tsk, gr, n; cin >> tsk >> gr >> n; vector<point> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].x >> v[i].y;
	}
	if (n > 10) {
		set<int> st;
		for (int i = 0; i < n; i++) st.insert(i + 1);
		while (!st.empty()) {
			cout << *st.begin() << " "; st.erase(st.begin());
			if (st.size() >= 2) {
				cout << *next(st.begin()) << " ";
				st.erase(next(st.begin()));
			} else {
				cout << *st.begin() << " "; st.erase(st.begin());
			}
		}
		exit(0);
	}
	vector<int> ord(n), best; int res = -1;
	for (int i = 0; i < n; i++) ord[i] = i;
	for (int it = 0; it < mx / n; it++) {
		random_shuffle(ord.begin(), ord.end());
		vector<point> v1;
		for (auto i : ord) v1.push_back(v[i]);
		if (get(v1) > res) {
			res = get(v1); best = ord;
		}
	}
	for (auto i : best) cout << i + 1 << " ";
	return 0;
}
