#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

random_device rd;
mt19937 rnd(rd());

struct vect {
    ll x, y;

    vect(ll x = 0, ll y = 0): x(x), y(y) {}

    friend vect operator-(vect a, vect b) {
        return {a.x - b.x, a.y - b.y};
    }
};

ll scalar(vect a, vect b) {
    return a.x * b.x + a.y * b.y;
}

ll cross(vect a, vect b) {
    return a.x * b.y - a.y * b.x;
}

bool comp(pair<vect, int> a, pair<vect, int> b) {
    ll x = cross(a.first, b.first);
    return (x > 0 || x == 0 && a.first.x < b.first.x);
}

int n;
vector<vect> d;

int count_keks(vi &p) {
    int res = 0;
    for (int i = 1; i < n - 1; ++i) {
        if (scalar(d[p[i]] - d[p[i - 1]], d[p[i + 1]] - d[p[i]]) < 0)
            ++res;
    }
    return res;
}

const ld T = 0.999;
const int K = 10000;

ld my_rand() {
    return (ld)rnd() / (ld)INT32_MAX;
}

void make_smaller(vi &p, ld t) {
    int i = rnd() % (n - 1);
    vi pp = p;
    swap(pp[i], pp[i + 1]);
    int x = count_keks(p) - count_keks(pp);
    if (x > 0 || exp(x / t) < my_rand())
        p = pp;
}

void otzhig(vi &p) {
    ld t = 1.0;
    for (int i = 0; i < K; ++i) {
        t *= T;
        make_smaller(p, t);
    }
}

vi huina() {
    vect mn = d[0];
    for (int i = 1; i < n; ++i) {
        if (d[i].x < mn.x || d[i].x == mn.x && d[i].y < mn.y)
            mn = d[i];
    }
    vector<pair<vect, int>> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = {d[i] - mn, i};
    sort(all(a), comp);
    vector<vect> st;
    vi ans;
    vector<bool> used(n, false);
    int cnt = n;
    st.push_back(a[0].first);
    ans.push_back(a[0].second);
    used[a[0].second] = true;
    --cnt;
    st.push_back(a[1].first);
    ans.push_back(a[1].second);
    int j = 2;
    while (cnt > 1) {
        if (!used[a[j].second]) {
            if (cross(st.back() - st[(int)st.size() - 2], a[j].first - st.back()) < 0 && scalar(st.back() - st[(int)st.size() - 2], a[j].first - st.back()) < 0) {
                st.pop_back();
                ans.pop_back();
            }
            else {
                used[ans.back()] = true;
                --cnt;
            }
            st.push_back(a[j].first);
            ans.push_back(a[j].second);
        }
        ++j;
        if (j == n)
            j = 0;
    }
    return ans;
}

int main() {
    int task, group;
    cin >> task >> group >> n;
    d.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> d[i].x >> d[i].y;
    if (task == 1) {
        vi p(n);
        iota(all(p), 0);
        shuffle(all(p), rnd);
        for (int k = 0; k < 5000; ++k) {
            for (int i = 1; i < n - 1; ++i) {
                if (scalar(d[p[i]] - d[p[i - 1]], d[p[i + 1]] - d[p[i]]) >= 0)
                    swap(p[i], p[i + 1]);
            }
        }
        for (int i: p)
            cout << i + 1 << ' ';
        cout << endl;
    }
    else if (task == 2) {
        vi p = huina();
        otzhig(p);
        int c;
        cin >> c;
        for (int i: p)
            cout << i + 1 << ' ';
        cout << endl;
    }
    else if (task == 3) {
        vi ans = huina();
        otzhig(ans);
        int c, q;
        cin >> c >> q;
        while (q--) {
            int k;
            cin >> k;
            vi p = ans;
            if (count_keks(p) > k)
                return -1;
            int j = 1;
            while (count_keks(p) < k) {
                if (scalar(d[p[j]] - d[p[j - 1]], d[p[j + 1]] - d[p[j]]) >= 0) {
                    swap(p[j], p[j + 1]);
                    if (count_keks(p) > k)
                        swap(p[j], p[j + 1]);
                }
                ++j;
                if (j == n - 1)
                    j = 1;
            }
            for (int i: p)
                cout << i + 1 << ' ';
            cout << endl;
        }
        cout << endl;
    }
}
