#include "bits/stdc++.h"

using namespace std;
#define int long long

struct point {
	int x, y;
	
	point(): x(0), y(0) {}
	point(int x, int y): x(x), y(y) {}
	friend int operator*(point a, point b) { return a.x * b.x + a.y * b.y; }
	friend point operator-(point a, point b) { return {b.x - a.x, b.y - a.y}; }
};

void solve1() {
	int n;
	cin >> n;
	vector<point> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i].x >> a[i].y;
	
	if (n <= 10) {
		int ans = 0, mx = 0;
		vector<int> res;
		vector<int> perm(n);
		std::iota(perm.begin(), perm.end(), 0);
		do {
			
			int now = 0;
			
			for (int i = 1; i + 1 < n; ++i) {
				now += ((a[perm[i - 1]] - a[perm[i]]) * (a[perm[i + 1]] - a[perm[i]]) > 0);
			}
			
			if (now > mx) res = perm;
		} while (std::next_permutation(perm.begin(), perm.end()));
		
		
		for (auto i: res) cout << i + 1 << ' ';
		return;
	}
	
	for (int i = 1; i <= n; ++i) {
		if (i & 1) cout << i / 2 + 1 << ' ';
		else cout << n - i / 2 + 1 << ' ';
	}
}

void solve2() {
	int n;
	cin >> n;
	vector<array<int, 3>> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i][0] >> a[i][1], a[i][2] = i + 1;
	
	std::sort(a.begin(), a.end());
	for (auto [x, y, id]: a) cout << id << ' ' ;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int task, group;
	cin >> task >> group;
	
	if (task == 1) solve1();
	if (task == 2) solve2();
}