#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool ok(pair<i64, i64> a, pair<i64, i64> b) {
    i64 sign = (a.fi * b.fi) + (a.se * b.se);
    return sign > 0;
}

pair<i64, i64> operator-(pair<i64, i64> a, pair<i64, i64> b){
    return {a.fi - b.fi, a.se - b.se};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> ord(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fi >> a[i].se;
        ord[i] = i;
    }

    sort(ord.begin(), ord.end(), [&] (int i, int j) {
        return a[i].fi < a[j].fi;
    });

    if (task == 1) {
        if (n <= 10) {
            vector<int> perm(n, 0);
            iota(perm.begin(), perm.end(), 0);
            vector<int> res;
            int mxa = 0;
            do {
                int cur = 0;
                for (int i = 2; i < n; ++i) {
                    cur += ok(a[perm[i - 2]] - a[perm[i - 1]], a[perm[i]] - a[perm[i - 1]]);
                }
                if (cur > mxa) {
                    mxa = cur;
                    res = perm;
                }
            } while (next_permutation(perm.begin(), perm.end()));
            for (int x : res) cout << x + 1 << ' ';
            cout << endl;
            return 0;
        }
        int l = 0, r = 0;
        while (l < n) {
            r = l;
            while (r + 1 < n && a[ord[r + 1]].se > a[ord[r]].se) ++r;
            for (int j = l; j <= (l + r) / 2; ++j) {
                cout << ord[j] + 1 << ' ';
                if (j < r - (j - l)) {
                    cout << ord[r - (j - l)] + 1 << ' ';
                }
            }
            l = r + 1;
        }
        cout << endl;

    }
}
