#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
using namespace std;
using ll = long long;

struct Point {
    ll x;
    ll y;

    Point() {}

    Point(ll x_, ll y_): x(x_), y(y_) {}

    Point operator+(const Point& pt) const {
        return {x + pt.x, y + pt.y};
    }

    Point operator-(const Point& pt) const {
        return {x - pt.x, y - pt.y};
    }

    ll operator^(const Point& pt) const {
        return x * pt.x + y * pt.y;
    }

    ll operator*(const Point& pt) const {
        return x * pt.y - y * pt.x;
    }

    friend ostream& operator<<(ostream& o, const Point& pt) {
        o << "(" << pt.x << ' ' << pt.y << ")";
        return o;
    }
};

struct distcmp {
    Point pt;

    distcmp(Point p): pt(p) {}

    bool operator()(Point p0, Point p1) {
        //cout << pt << ' ' << p0 << ' ' << p1 << ": " << ((pt - p0) ^ (pt - 
        return ((pt - p0) ^ (pt - p0)) < ((pt - p1) ^ (pt - p1));
    }
};

const int MAXN = 80001;
Point pt[MAXN];

vector<int> solve_1(int n) {
    vector<int> perm(n);
    perm[0] = max_element(pt, pt + n, distcmp(pt[0])) - pt;
    perm[0] = max_element(pt, pt + n, distcmp(pt[perm[0]])) - pt;
    bitset<MAXN> used;
    used[perm[0]] = 1;
    for (int i = 1; i < n; ++i) {
        vector<Point> npt(n);
        int pi = perm[i - 1];
        for (int j = 0; j < n; ++j) npt[j] = pt[j];
        for (int j = used._Find_first(); j < n; j = used._Find_next(j)) npt[j] = pt[pi];
        //cout << pi + 1 << ": ";
        //for (int j = 0; j < n;  ++j)
            //cout << npt[j] << ' ';
        //cout << endl;
        perm[i] = max_element(npt.begin(), npt.end(), distcmp(pt[pi])) - npt.begin();
        used[perm[i]] = 1;
    }
    return perm;
}

signed main() {
    int ts, g;
    cin >> ts >> g;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> pt[i].x >> pt[i].y;
    }
    if (ts == 1) {
        vector<int> ans = solve_1(n);
        for (int i = 0; i < n; ++i)
            cout << ans[i] + 1 << ' ';
        cout << endl;
        return 0;
    }
}
