﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>

using namespace std;
typedef long long ll;

mt19937 rng(1315);

const int maxn = 8e4;

struct pt {
	ll x, y;
	pt(ll x_, ll y_) : x(x_), y(y_) {}
	pt() {}
	ll operator%(pt  oth) {
		return x * oth.y - y * oth.x;
	}
	ll operator*(pt oth) {
		return x * oth.x + y * oth.y;
	}
	pt operator-(pt oth) {
		return pt(x - oth.x, y - oth.y);
	}
};

vector<pt> a(maxn);

bool ch(pt a, pt b, pt c) {
	return (a - b) * (c - b) > 0;
}

int f(vector<int>& pr) {
	int ans = 0;
	for (int i = 0; i < pr.size() - 2; ++i) {
		ans += ch(a[pr[i]], a[pr[i + 1]], a[pr[i + 2]]);
	}
	return ans;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t, g, n, c;
	cin >> t >> g >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
	if (t == 1) {
		if (n <= 10) {
			vector<int> r(n);
			for (int i = 0; i < n; ++i) {
				r[i] = i;
			}
			vector<int> ib = r;
			int rs = f(ib);
			while (next_permutation(r.begin(), r.end())) {
				int u = f(r);
				if (u > rs) {
					rs = u;
					ib = r;
				}
			}
			for (int i = 0; i < n; ++i) {
				cout << ib[i] + 1 << ' ';
			}
			cout << endl;
		}
		else if (g == 1){
			for (int i = 0; i < n; ++i) {
				if (i % 2 == 0) {
					cout << i / 2 + 1 << ' ';
				}
				else {
					cout << n - i / 2 << ' ';
				}
			}
			cout << endl;
		}
		else {
			int res = 0, rb = 0;
			vector<int> an(n), ib(n);
			for (int i = 0; i < n; ++i) {
				an[i] = i;
			}
			random_shuffle(an.begin(), an.end());
			for (int i = 0; i < n - 2; ++i) {
				if (ch(a[an[i]], a[an[i + 1]], a[an[i + 2]])) {
					res += 1;
				}
			}
			int cnt = 1e6;
			double tm = 1;
			while (cnt--) {
				int i1 = rng() % n, i2 = rng() % n, r1 = res;
				vector<int> u = { i1 - 1, i1, i1 + 1, i2 - 1, i2, i2 + 1 };
				sort(u.begin(), u.end());
				u.resize(unique(u.begin(), u.end()) - u.begin());
				for (auto y : u) {
					if (y >= n - 2 || y < 0) continue;
					if (ch(a[an[y]], a[an[y + 1]], a[an[y + 2]])) {
						--r1;
					}
				}
				swap(an[i1], an[i2]);
				for (auto y : u) {
					if (y >= n - 2 || y < 0) continue;
					if (ch(a[an[y]], a[an[y + 1]], a[an[y + 2]])) {
						++r1;
					}
				}
				if (r1 >= res || rand()/RAND_MAX >= exp((r1 - res) / tm)) {
					res = r1;
				}
				else {
					swap(an[i1], an[i2]);
				}
				if (rb < res) {
					rb = res;
					ib = an;
				}
				tm *= 0.999;
			}
			for (auto i : ib) {
				cout << i + 1 << ' ';
			}
			cout << endl;
		}
	}
	else {
		cin >> c;
		if (t == 2) {

		}
		else if (t == 3) {
			int q;
			cin >> q;
			while (q--) {
				int k, l = 0, r = n-1;
				cin >> k;
				if (k % 2 == 0) {
					for (int i = 0; i < n; ++i) {
						if (i <= k) {
							if (i % 2 == 0) {
								cout << l + 1 << ' ';
								++l;
							}
							else {
								cout << r + 1 << ' ';
								--r;
							}
						}
						else {
							cout << l + 1 << ' ';
							++l;
						}
					}
				}
				else {
					for (int i = 0; i < n; ++i) {
						if (i <= k) {
							if (i % 2 == 0) {
								cout << l + 1 << ' ';
								++l;
							}
							else {
								cout << r + 1 << ' ';
								--r;
							}
						}
						else {
							cout << r + 1 << ' ';
							--r;
						}
					}
				}
				cout << endl;
			}
		}
		else {

		}
	}


	return 0;
}
