#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
mt19937_64 gen(rd());

struct SegmentTree {
    struct Node {
        ll x, ind;
    };

    Node NEUTRAL = {INF, 0};

    Node merge(Node p1, Node p2) {
        if (p1.x <= p2.x) return p1;
        return p2;
    }

    vector<Node> p;
    ll n;

    SegmentTree(ll n): n(n) {
        p.assign(4 * n, NEUTRAL);
    }

    Node _get(ll i, ll l, ll r, ll q_l, ll q_r) {
        if (q_l <= l && r <= q_r) return p[i];
        if (q_r <= l || r <= q_l) return NEUTRAL;

        ll m = (l + r) / 2;
        return merge(_get(2 * i + 1, l, m, q_l, q_r), _get(2 * i + 2, m, r, q_l, q_r));
    }

    void _set(ll i, ll l, ll r, ll q_i, ll q_x) {
        if (l + 1 == r) {
            p[i] = {q_x, l};
            return;
        }

        ll m = (l + r) / 2;
        if (q_i < m)
            _set(2 * i + 1, l, m, q_i, q_x);
        else
            _set(2 * i + 2, m, r, q_i, q_x);

        p[i] = merge(p[2 * i + 1], p[2 * i + 2]);
    }

    Node get(ll l, ll r) {
        return _get(0, 0, n, l, r);
    }

    void set(ll i, ll x) {
        _set(0, 0, n, i, x);
    }
};

struct Point {
    ll x, y, ind;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t, g;
    cin >> t >> g;

    ll n;
    cin >> n;

    vector<Point> p(n);
    for (ll i = 0; i < n; i++) cin >> p[i].x >> p[i].y;

    if (g == 1) {
        vector<ll> ans(n);
        for (ll i = 0; i < n; i++) {
            if (i % 2 == 0)
                ans[i / 2] = i;
            else
                ans[n - ((i + 1) / 2)] = i;
        }

        for (ll w : ans) cout << w + 1 << " ";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
