#include <bits/stdc++.h>
using namespace std;

bool sharp(int x1, int y1, int x2, int y2, int x3, int y3) {
    return 1LL * (x2 - x1) * (x3 - x2) + 1LL * (y2 - y1) * (y3 - y2) < 0;
}

struct fenwick {
    int size;
    vector<pair<int, int>> tree;

    fenwick(int n) : size(n), tree(n + 1, {0, -1}) {}

    void update(int i, pair<int, int> value) {
        for (i++; i <= size; i += i & -i) {
            tree[i] = max(tree[i], value);
        }
    }

    pair<int, int> query(int r) {
        pair<int, int> answer = {0, -1};
        for (; r > 0; r -= r & -r) {
            answer = max(answer, tree[r]);
        }
        return answer;
    }
};

int main() {
    int task, group;
    cin >> task >> group;
    mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
    if (task == 1) {
        int n;
        cin >> n;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; i++) {
            cin >> x[i] >> y[i];
        }
        if (group == 1) {
            for (int i = 0; i < n - n % 2; i++) {
                cout << 1 + (i ^ 1) << " \n"[i + 1 == n - n % 2];
            }
            if (n % 2) {
                cout << n << "\n";
            }
            exit(0);
        }
        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        pair<int, vector<int>> answer = {-1, {}};
        while (1.0 * clock() / CLOCKS_PER_SEC < 1.9) {
            int cnt = 0;
            for (int i = 0; i < n - 2; i++) {
                cnt += sharp(x[order[i]], y[order[i]], x[order[i + 1]], y[order[i + 1]], x[order[i + 2]], y[order[i + 2]]);
            }
            if (cnt > answer.first) {
                answer = {cnt, order};
            }
            shuffle(order.begin(), order.end(), rng);
        }
        for (int i = 0; i < n; i++) {
            cout << 1 + answer.second[i] << " \n"[i + 1 == n];
        }
    } else if (task == 2) {
        int n;
        cin >> n;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; i++) {
            cin >> x[i] >> y[i];
        }
        vector<int> vals(n);
        iota(vals.begin(), vals.end(), 0);
        sort(vals.begin(), vals.end(), [&](int i, int j) {
            return x[i] != x[j] ? x[i] < x[j] : y[i] < y[j];
        });
        vector<int> D;
        for (int i = 0; i < n; i++) {
            D.push_back(y[i]);
        }
        sort(D.begin(), D.end());
        D.resize(unique(D.begin(), D.end()) - D.begin());
        vector<int> yc(n);
        for (int i = 0; i < n; i++) {
            yc[i] = lower_bound(D.begin(), D.end(), y[i]) - D.begin();
        }
        vector<int> ord;
        while (!vals.empty()) {
            fenwick F(n);
            vector<int> dp(vals.size()), par(vals.size(), -1);
            for (int i = 0; i < (int)vals.size(); i++) {
                auto [value, lst] = F.query(yc[vals[i]]);
                dp[i] = value + 1;
                par[i] = lst;
                F.update(yc[vals[i]], {dp[i], i});
            }
            int best = max_element(dp.begin(), dp.end()) - dp.begin();
            vector<bool> del(vals.size());
            while (best != -1) {
                del[best] = true;
                ord.push_back(vals[best]);
                best = par[best];
            }
            vector<int> new_vals;
            for (int i = 0; i < (int)vals.size(); i++) {
                if (!del[i]) {
                    new_vals.push_back(vals[i]);
                }
            }
            swap(vals, new_vals);
        }
        for (int i = 0; i < n; i++) {
            cout << 1 + ord[i] << " \n"[i + 1 == n];
        }
    } else if (task == 3) {
        int n;
        cin >> n;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; i++) {
            cin >> x[i] >> y[i];
        }
        int c;
        cin >> c;
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            vector<int> order(n);
            iota(order.begin(), order.end(), 0);
            pair<int, vector<int>> answer = {INT_MAX, {}};
            for (int i = 0; i < 100000; i++) {
                int cnt = 0;
                for (int i = 0; i < n - 2; i++) {
                    cnt += sharp(x[order[i]], y[order[i]], x[order[i + 1]], y[order[i + 1]], x[order[i + 2]], y[order[i + 2]]);
                }
                if (cnt == k) {
                    for (int i = 0; i < n; i++) {
                        cout << 1 + answer.second[i];
                        if (i + 1 < n) {
                            cout << " ";
                        }
                    }
                    cout << endl;
                    break;
                }
                shuffle(order.begin(), order.end(), rng);
            }
        }
    } else {
        assert(false);
    }
}
