#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const db pi = acosl(-1), eps = 1e-9;

struct P {
    ll x, y;
    P(ll _x = 0, ll _y = 0) : x(_x), y(_y) {}
    
    P operator-(P p) {
        return P(x - p.x, y - p.y);
    }
    P operator+(P p) {
        return P(x + p.x, y + p.y);
    }
    ll operator*(P p) { // cos
        return x * p.x + y * p.y;
    }
    ll operator%(P p) { // sin
        return x * p.y - y * p.x;
    }
    void scan() {
        cin >> x >> y;
    }
};
ll sqr(ll x) {
    return x * x;
}
ll len2(P p) {
    return sqr(p.x) + sqr(p.y);
}
db angle(P a, P b) {
    return abs(atan2(a % b, a * b));
}

int task, group;

void solve1() {
    int n;
    cin >> n;
    
    vector<P> p(n);
    for (int i = 0; i < n; i++) {
        p[i].scan();
    }
    
    if (group == 1) {
        vector<int> ans{0};
        for (int i = 1; i < n; i++) {
            if (i % 2 == 1) {
                ans.push_back(i + 1);
            } else {
                ans.push_back(i - 1);
            }
        }
        if (n % 2 == 0) {
            ans.pop_back();
            ans.push_back(n - 1);
        }
        for (auto i : ans) cout << i + 1 << ' ';
        cout << endl;
        return;
    }
    
    if (group == 2) {
        vector<int> perm(n);
        iota(perm.begin(), perm.end(), 0);
        vector<int> ans;
        int cur = -1;
        for (int rep = 0; rep < 1000; rep++) {
            shuffle(perm.begin(), perm.end(), rng);
            int cnt = 0;
            for (int i = 1; i < n - 1; i++) {
                db ang = angle(p[perm[i-1]] - p[perm[i]],
                               p[perm[i+1]] - p[perm[i]]);
                if (ang < pi / 2 + eps) {
                    cnt++;
                }
            }
            if (cur < cnt) {
                cnt = cur;
                ans = perm;
            }
        }
        for (auto i : ans) cout << i + 1 << ' ';
        cout << '\n';
    }
}
void solve2() {}
void solve3() {}
void solve4() {}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    cin >> task >> group;
    if (task == 1) solve1();
    if (task == 2) solve2();
    if (task == 3) solve3();
    if (task == 4) solve4();
    
    return 0;
}