#define _CRT_SECURE_NO_WARNINGS

#pragma gcc optimise("Ofast")
#pragma gcc optimise("unswith-loops")
#pragma gcc optimise("unroll-loops")
#pragma gcc optimise("no-stack-protector")
#pragma gcc optimise("fast-math")
#pragma gcc optimise("rename-registers")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

struct Vector {
	int x, y;
	Vector(Vector a, Vector b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
	Vector(int x, int y) : x(x), y(y) {}
	Vector() {}

	int operator*(Vector& b) {
		return x * b.x + y * b.y;
	}
	int operator%(Vector& b) {
		return x * b.y - y * b.x;
	}
};

vector<Vector> arr;

void solve_fac(int n) {
	vector<int> order(n);
	iota(walk(order), 0);
	vector<int> ans_arr;
	int ans = -1;
	do {
		int cur = 0;
		for (int i = 1; i < n - 1; i++) {
			Vector a = arr[order[i - 1]], b = arr[order[i]], c = arr[order[i + 1]];
			Vector ab(a, b), bc(b, c);
			if (ab * bc < 0)
				cur++;
		}
		if (ans < cur) {
			ans = cur;
			ans_arr = order;
		}
	} while (next_permutation(walk(order)));
	//cout << ans << "\n";
	for (int u : ans_arr)
		cout << u + 1 << " ";
}


void solve_stupid(int n) {
	vector<int> ans;
	ans.push_back(1);
	for (int i = 1; i < n; i += 2) {
		if (i + 2 <= n)
			ans.push_back(i + 2);
		if (i + 1 <= n)
			ans.push_back(i + 1);
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";
}

void solve() {
	int t, g;
	cin >> t >> g;
	int n;
	cin >> n;
	int f, s;
	for (int i = 0; i < n; i++) {
		cin >> f >> s;
		arr.emplace_back(f, s);
	}
	if (n <= 10)
		solve_fac(n);
	else
		solve_stupid(n);
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}