#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pii pair<int,int>
#define f first
#define s second
#define sort stable_sort
#define mp make_pair
#define pb push_back
const int maxn = 200001;
struct fenwick {
    int n;
    vector<int> t;

    void init() {
        t.resize(n + 1, 0);
    }

    void upd(int i, int x) {
        while (i <= n) {
            t[i] += x;
            i = i | (i + 1);
        }
    }

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += t[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }
};
struct segtree {
    int size;
    vector<int> t;
    void init(){
        t.resize(size,0);
    }
    void upd(int i, int x, int tl=0, int tr = 131072, int n=0){
        if(tr-tl==1){
            t[n] = x;
            return;
        }
        if(i < (tl+tr)/2) upd(i,x,tl,(tl+tr)/2,2*n+1);
        else upd(i,x,(tl+tr)/2,tr,2*n+2);
        t[n] = t[2*n+1] + t[2*n+2];
    }
    int get(int l, int r, int tl=0, int tr=131072, int n=0){
        if(l>=tr || tl >= r) return 0;
        if(tl>=l && tr <= r) return t[n];
        return get(l,r,tl,(tl+tr)/2,2*n+1) + get(l,r,(tl+tr)/2,tr,2*n+2);
    }
};
bool angle(pii a, pii b, pii c){
    return ((b.f-a.f)*(b.f-c.f) + (b.s-a.s)*(b.s-c.s) > 0);
}
int getans(vector<int>& order, vector<pii>& a){
    int ans= 0;
    for(int i = 0; i < a.size()-2; ++i){
        if(angle(a[order[i]], a[order[i+1]], a[order[i+2]])) ans++;
    }
    return ans;
}
signed main() {
#ifdef LOCAL

#else

#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pii> a(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].f >> a[i].s;
    }
    if(group == 2){
        vector<int> order(n);
        for(int i= 0; i < n; ++i){
            order[i] = i;
        }
        vector<int> best = order;
        int ans= getans(order, a);
        while(next_permutation(order.begin(),order.end())){
            if(getans(order,a) > ans){
                ans = getans(order,a);
                best = order;
            }
        }
        for(int uu: best){
            cout << uu+1 << ' ';
        }
        cout << endl;
        return 0;
    }
    if(group==1){
        int l = 1;
        int r = n;
        while(r>=l){
            cout << l << ' ';
            ++l;
            if(l>r){cout << endl;
            return 0;}
            cout << r << ' ';
            --r;
        }
        cout << endl;
        return 0;
    }
    if(group == 7){
        int c;
        cin >> c;
        int q;
        cin >> q;
        for(int qqq = 0; qqq < q; ++qqq){
            int k;
            cin >> k;
            if(k%2==0){
                int l = 1, r = k+2;
                while(r>=l){
                    cout << l << ' ';
                    ++l;
                    if(l>r){break;}
                    cout << r << ' ';
                    --r;
                }
                for(int i = k+3; i <= n; ++i){
                    cout << i << ' ';
                }
                cout << endl;
            }
            else {
                int l = 1, r = k+1;
                while(r>=l){
                    cout << l << ' ';
                    ++l;
                    if(l>r){break;}
                    cout << r << ' ';
                    --r;
                }
                for(int i = k+2; i < n-1; ++i){
                    cout << i << ' ';
                }
                cout << n << ' ' << n-1 << endl;
            }
        }

    }
}
