#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    int x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x - b.x, a.y - b.y));
    }

    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ld operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

int n;
vec<Vector> a;

int res(vec<int>&  b) {
    int cnt = 0;
    for (int i = 1; i < n - 1; ++i) {
        auto a1 = a[b[i + 1]] - a[b[i]];
        auto a2 = a[b[i - 1]] - a[b[i]];
        //cout << b[i + 1] << " " << b[i] << " " << b[i - 1] << " " << a1.x << " " << a1.y << " " << a2.x << " " << a2.y << endl;
        //cout << (a1 * a2) << " " << (a1 ^ a2) << endl;
        if (((a1 * a2) > 0 && (a1 ^ a2) < 0) || ((a1 * a2) < 0 && (a1 ^ a2) > 0)) {
            cnt++;
        }
       // cout << cnt << endl;
    }
    return cnt;
}

void solve() {
    int t, group;
    cin >> t >> group;
    cin >> n;
    a.assign(n, {0, 0});
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    //res(b);
   // return;
    if (t == 1) {
        int cnt = 0;
        int mx2 = -1;
        vec<int> resik;
        for (int _ = 0; _ < 3; ++_) {
            vec<int> b(n);
            for (int i = 0; i < n; ++i) {
                b[i] = i;
            }
            shuffle(all(b), rnd);
            int mx = res(b);
            auto ans = b;
            ld t = 1;
            for (int iter = 0; iter < (1e5) / n; ++iter) {
                int i = rnd() % n;
                int j = rnd() % n;
                if (i == j) j = (i + 1) % n;
                swap(b[i], b[j]);
                cnt = res(b);
                if (cnt > mx || (mx - cnt) > rnd() * t) {
                    cnt = mx;
                    ans = b;
                }
                else swap(b[i], b[j]);
                t *= 0.999;
            }
            if (mx > mx2) {
                mx2 = mx;
                resik = ans;
            }
        }
        //cout << mx2 << endl;
        for (int& i : resik) cout << i + 1 << " ";
        cout << endl;
    }
    else {
        int c;
        cin >> c;
        vec<int> b(n);
        for (int i = 0; i < n; ++i) {
            b[i] = i;
        }
        for (int iter = 0; iter <= 1e2; ++iter) {
            shuffle(all(b), rnd);
            int mx = res(b);
            if (mx <= c) {
                break;
            }
        }
        for (int i = 0; i < n; ++i) cout << b[i] + 1 << " ";
        cout << endl;
    }
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    //cout << ((3e14) < (1ll << 49)) << endl;
    for (; t > 0; --t) {
        solve();
    }
}