#include<bits/stdc++.h>

#include <random>

using namespace std;
typedef long long ll;

#define int ll

struct Vector {
    int x, y;

    Vector operator+(const Vector &oth) const {
        return {x + oth.x, y + oth.y};
    }

    Vector operator-(const Vector &oth) const {
        return {x - oth.x, y - oth.y};
    }

    int dp(const Vector &oth) const {
        return x * oth.x + y * oth.y;
    }

    int cp(const Vector &oth) const {
        return x * oth.y - y * oth.x;
    }

    bool operator==(const Vector &oth) const {
        return make_pair(x, y) == make_pair(y, oth.y);
    }
};


void task1() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    auto get = [&](vector<int> p) -> int {
        int ans = 0;
        for (int i = 1; i + 1 < n; ++i) {
            Vector t1 = a[p[i - 1]] - a[p[i]];
            Vector t2 = a[p[i + 1]] - a[p[i]];
            if (t1.dp(t2) > 0) {
                ++ans;
            }
        }
        return ans;
    };
    vector<int> p(n);
    p = {0, 2, 1};
    for (int i = 4; i < n; i += 2) {
        p.push_back(i);
        p.push_back(i - 1);
    }
    if (~n & 1) p.push_back(n - 1);
    auto ans = p;
    for (int q = 0; q < 5000; ++q) {
        shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
        if (get(p) > get(ans)) ans = p;
    }
    for (auto &el: ans) cout << el + 1 << ' ';
}

void task3() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    auto get = [&](vector<int> p) -> int {
        int ans = 0;
        for (int i = 1; i + 1 < n; ++i) {
            Vector t1 = a[p[i - 1]] - a[p[i]];
            Vector t2 = a[p[i + 1]] - a[p[i]];
            if (t1.dp(t2) > 0) {
                ++ans;
            }
        }
        return ans;
    };
    vector<int> p(n);
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        iota(p.begin(), p.end(), 0);
        int k;
        cin >> k;
        for (; get(p) != k;) {
            shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
        }
        for (auto &el: p) cout << el + 1 << ' ';
        cout << "\n";
    }
}

vector<int> convex_hull(vector<pair<Vector, int>> a) {
    Vector mn = a[0].first;
    for (auto &[el, sdjof] : a) {
        if (el.y < mn.y) {
            mn = el;
        }
    }
    for (auto &el: a) el.first = el.first - mn;
    sort(a.begin(), a.end(), [&](const auto &x, const auto &y) {
        auto vec1 = x.first, vec2 = y.first;
        if (vec1.cp(vec2) == 0) return vec1.dp(vec1) < vec2.dp(vec2);
        return vec1.cp(vec2) > 0;
    });
    vector<Vector> st;
    vector<int> inds;
    st.push_back(a[0].first);
    inds.push_back(a[0].second);
    for (int i = 1; i < a.size(); ++i) {
        while (st.size() >= 2) {
            Vector a1 = st.back() - st[st.size() - 2];
            Vector b1 = a[i].first - st.back();
            if (a1.cp(b1) < 0) {
                st.pop_back();
                inds.pop_back();
            } else {
                break;
            }
        }
        inds.push_back(a[i].second);
        st.push_back(a[i].first);
    }
    return inds;
}

const int K = 20;

void task2() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    auto get = [&](vector<int> ch, vector<int> p1) -> int {
        vector<int> pp;
        for (auto &el : ch) pp.push_back(el);
        for (auto &el : p1) pp.push_back(el);
        int ans = 0;
        for (int i = 1; i + 1 < n; ++i) {
            Vector t1 = a[pp[i - 1]] - a[pp[i]];
            Vector t2 = a[pp[i + 1]] - a[pp[i]];
            if (t1.dp(t2) > 0) {
                ++ans;
            }
        }
        return ans;
    };
    vector<int> ans, usd(n, false);
    for (int iqq = 0; iqq < K; ++iqq) {
        vector<pair<Vector, int>> b;
        for (int i = 0; i < n; ++i) {
            if (!usd[i]) {
                b.emplace_back(a[i], i);
            }
        }
        if (b.empty()) break;
        auto tp = convex_hull(b);
        for (auto &el : tp) {
            ans.push_back(el);
            usd[el] = 1;
        }
    }
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        if (!usd[i]) p.push_back(i);
    }
    int c;
    cin >> c;
    for (; get(ans, p) > c;) {
        //std::random_device()()
        shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
    }
    for (auto &el : ans) cout << el + 1 << ' ';
    for (auto &el: p) cout << el + 1 << ' ';
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        task1();
    } else if (task == 2) {
        task2();
    } else if (task == 3) {
        task3();
    }
}