#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct Vector {
	ll x, y;
	Vector(ll x, ll y): x(x), y(y) {}
	Vector(): Vector(0, 0) {}
};

Vector operator+(Vector a, Vector b) {
	return {a.x + b.x, a.y + b.y};
}
Vector operator-(Vector a, Vector b) {
	return {a.x - b.x, a.y - b.y};
}
ll operator*(Vector a, Vector b) {
	return a.x * b.x + a.y * b.y;
}
ll operator%(Vector a, Vector b) {
	return a.x * b.y - a.y * b.x;
}

int main() {
	int task, group;
	cin >> task >> group;
	assert(task == 1);
	int n;
	cin >> n;
	vector<Vector> points(n);
	for (int i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		points[i] = {x, y};
	}
	vector<int> permutation(n);
	for (int i = 0; i < n; i++) {
		permutation[i] = i;
	}
	vector<int> best_permutation = permutation;
	int answer = 0;
	do {
		int cur = 0;
		for (int i = 1; i < n-1; i++) {
			Vector v1 = points[permutation[i-1]] - points[permutation[i]];
			Vector v2 = points[permutation[i+1]] - points[permutation[i]];
			if (v1 * v2 > 0) cur++;
		}
		if (cur > answer) best_permutation = permutation, answer = cur;
	} while (next_permutation(permutation.begin(), permutation.end()));
	assert(answer == n-2);
	for (int i: best_permutation) {
		cout << i + 1 << " ";
	}
	cout << endl;
}