#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, g;
    cin >> n >> g;

    vector<vector<pair<int, int>>> adj(n);
    vector<vector<int>> C(n);
    vector<int> c(n), W(n), A(n), B(n);
    vector<int> ans, head, mid, tail;

    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a -= 1, b -= 1;
        A[i] = a, B[i] = b;
        W[i] = w;
        adj[a].emplace_back(b, i);
        adj[b].emplace_back(a, i);
    }

    for (int i = 0; i < n; ++i) {
        C[i].resize(adj[i].size());
        for (int &x : C[i]) {
            cin >> x;
        }
    }

    auto dfs = [&](auto self, int v) -> void {
        for (auto [to, i] : adj[v]) {
            adj[to].erase(find(adj[to].begin(), adj[to].end(), pair{v, i}));
            self(self, to);
        }
        if (adj[v].empty()) {
            c[v] = C[v][0];
            return;
        }
        sort(adj[v].begin(), adj[v].end(), [&](auto x, auto y) {
            return (W[x.second] - c[x.first]) > (W[y.second] - c[y.first]);
        });
        vector<int> ord(C[v].size());
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return C[v][i] > C[v][j];
        });
        vector<int> stk;
        vector<int> used(C[v].size(), -1);
        int pnt = 0;
        for (auto [to, id] : adj[v]) {
            ll need = W[id] - c[to];
            while (pnt < size(ord) && C[v][ord[pnt]] >= need) {
                stk.push_back(ord[pnt++]);
            }
            if (stk.empty()) {
                cout << "No\n";
                exit(0);
            }
            used[stk.back()] = id;
            stk.pop_back();
        }
        for (int i = int(C[v].size()) - 1; i >= 0; --i) {
            if (used[i] == -1) {
                c[v] = C[v][i];
                while (--i >= 0) {
                    tail.push_back(used[i]);
                }
                break;
            }
            head.push_back(used[i]);
        }
    };

    dfs(dfs, 0);

    cout << "Yes\n";
    head.insert(head.end(), tail.begin(), tail.end());
    std::reverse(head.begin(), head.end());
    for (int x : head) {
        cout << x + 1 << " ";
    }
    cout << '\n';

//    auto check = [&](vector<int> o) {
//        vector<int> pnt(n);
//        for (int i : o) {
//            int ca = C[A[i]][pnt[A[i]]++];
//            int cb = C[B[i]][pnt[B[i]]++];
//            int ww = W[i];
//            if (ca + cb < ww) {
//                return false;
//            }
//        }
//        return true;
//    };
//
//    assert(check(head));

    return 0;
}