#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7, MAXW = 20'000;

struct edge {
	ll a, b, w;
};

void solve() {
	ll n, g;
	cin >> n >> g;
	vector<edge> edges(n - 1);
	vector<ll> deg(n);
	ll a, b, w;
	for (ll i = 0; i < n - 1; i++) {
		cin >> a >> b >> w; a--; b--;
		deg[a]++;
		deg[b]++;
		edges[i].a = a;
		edges[i].b = b;
		edges[i].w = w;
	}
	vector<vector<ll>> c(n);
	for (ll i = 0; i < n; i++) {
		c[i].assign(deg[i], 0);
		for (ll j = 0; j < deg[i]; j++) {
			cin >> c[i][j];
		}
	}

	if (g == 3) {
		vector<pair<ll, ll>> c_root(n - 1);
		for (ll i = n - 2; i >= 0; i--) {
			c_root[i] = { c[0][i], n - 2 - i};
		}
		set<pair<ll, ll>> c_not_root;
		for (ll i = 0; i < n - 1; i++) {
			a = edges[i].a;
			b = edges[i].b;
			w = edges[i].w;
			if (a == 0) {
				swap(a, b);
			}
			c_not_root.insert({ w - c[a][0], i });
		}
		sort(c_root.begin(), c_root.end());
		vector<ll> ans(n - 1);
		for (pair<ll, ll> elem : c_root) {
			auto it = c_not_root.upper_bound(pair<ll, ll>({ elem.first, INF }));
			if (it == c_not_root.begin()) {
				cout << "No";
				return;
			}
			it--;
			ans[elem.second] = (it->second);
		}
		cout << "Yes\n";
	}
	else {
		vector<ll> ind(n - 1);
		ll cnt = 1;
		for (ll i = 0; i < n - 1; i++) {
			ind[i] = i;
			cnt *= (i + 1);
		}
		bool good;
		while (cnt--) {
			vector<ll> deg_cur = deg;
			good = true;
			for (ll i : ind) {
				a = edges[i].a;
				b = edges[i].b;
				w = edges[i].w;
				deg_cur[a]--;
				deg_cur[b]--;
				ll x = c[a][deg_cur[a]], y = c[b][deg_cur[b]];
				if (w > x + y) {
					good = false;
					break;
				}
			}
			if (good) {
				cout << "Yes\n";
				for (ll elem : ind) {
					cout << elem + 1 << " ";
				}
				return;
			}
			next_permutation(ind.begin(), ind.end());
		}
		cout << "No\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/