#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

struct Edge {
	int a, b, w;
};
vector<vector<pair<int, int>>> G;
vector<vector<int>> st;
vector<Edge> e;
int n;

void Perm(vector<int>& p) {
	vector<char> seen(n - 1);
	int pos = -1;
	for (int i = 0; i < n - 1; i++) {
		if (p[i] == -1) {
			pos = i;
			break;
		}
		seen[p[i]] = 1;
	}

	if (pos == -1) {
		vector<int> state(n + 1);
		for (int i : p) {
			if (e[i].w <= st[e[i].a][state[e[i].a]] + st[e[i].b][state[e[i].b]]) {
				state[e[i].a]++;
				state[e[i].b]++;
			}
			else {
				return;
			}
		}

		cout << "Yes\n";
		for (int i : p)
			cout << i + 1 << ' ';
		exit(0);
	}

	for (int i = 0; i < n - 1; i++) {
		if (seen[i]) continue;
		seen[i] = 1;
		p[pos] = i;
		Perm(p);
		p[pos] = -1;
	}
}


void solve() {
	int g;
	cin >> n >> g;
	G.resize(n + 1);

	e.resize(n - 1);
	for (int i = 1; i < n; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		e[i - 1] = { a, b, w };
		G[a].push_back({ b, w });
		G[b].push_back({ a, w });
	}

	st.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		st[i].resize(G[i].size());
		for (int j = st[i].size() - 1; j >= 0; j--)
			cin >> st[i][j];
	}

	vector<int> p(n - 1, -1);
	Perm(p);
	cout << "No";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
