#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<deque>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

struct edge {
    int u, v, wt;

    edge() = default;

    edge(int a, int b, int c) : u(a), v(b), wt(c) {}
};

void solve() {
    int n, G; cin >> n >> G;
    vector<edge> e(n-1);
    vector<int> deg(n+1);
    vector<set<int>> s(n+1);
    map<pair<int, int>, int> mp, ind;
    for (int i = 0; i<n-1; ++i) {
        int u, v, wt; cin >> u >> v >> wt;
        e.emplace_back(u, v, wt);
        deg[u]++;
        deg[v]++;
        s[u].insert(v);
        s[v].insert(u);
        mp[{u, v}] = mp[{v, u}] = wt;
        ind[{u, v}] = ind[{v, u}] = i+1;
    }
    vector<int> deg2 = deg;
    vector<multiset<int>> a(n+1);
    vector<vector<int>> C(n+1), num(n+1);
    vector<map<int, vector<int>>> pos(n+1);
    for (int i = 1; i<=n; ++i) {
        C[i].resize(deg[i]);
        num[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            int c; cin >> c;
            a[i].insert(c);
            C[i][j] = c;
            pos[i][c].emplace_back(j);
        }
    }
    deque<int> d;
    for (int i = 1; i<=n; ++i) {
        if (deg[i] == 1) d.emplace_back(i);
    }
    vector<vector<int>> g(n), g_rev(n);
    while (!d.empty()) {
        auto u = d.front();
        d.pop_front();
        if (!deg[u]) break;
        int v = *s[u].begin();
//        cout << u << " " << v << endl;
        int need = mp[{u, v}] - *a[u].begin();
        auto it = a[v].lower_bound(need);
        if (it == a[v].end()) {
            cout << "No\n";
            return;
        }
        num[u][pos[u][*a[u].begin()].back()] = ind[{u, v}];
        pos[u][*a[u].begin()].pop_back();
        num[v][pos[v][*it].back()] = ind[{u, v}];
        pos[v][*it].pop_back();
        a[v].erase(it);
        s[v].erase(u);
        a[u].clear();
        s[u].clear();
        deg[u]--;
        deg[v]--;
        if (deg[v] == 1) d.emplace_back(v);
    }
    vector<int> cnt(n);
//    cout << endl;
    for (int i = 1; i<=n; ++i) {
//        print(num[i]);
        for (int j = 0; j<deg2[i]-1; ++j) {
            g[num[i][j]].emplace_back(num[i][j+1]);
            g_rev[num[i][j+1]].emplace_back(num[i][j]);
            cnt[num[i][j]]++;
        }
    }
//    cout << endl;
//    print(cnt);
    vector<int> usd(n);
    bool fl = true;
    auto dfs = [&](auto dfs, int u) -> void {
        usd[u] = 1;
        for (auto v : g[u]) {
            if (!usd[v]) dfs(dfs, v);
            else if (usd[v] == 1) fl = false;
        }
        usd[u] = 2;
    };
    for (int i = 1; i<n; ++i) {
        if (!usd[i]) dfs(dfs, i);
    }
    if (!fl) {
        cout << "No\n";
        return;
    }
    d.clear();
    for (int i = 1; i<n; ++i) {
        if (!cnt[i]) d.emplace_back(i);
    }
    vector<int> res;
    while (!d.empty()) {
        auto u = d.front();
        d.pop_front();
        res.emplace_back(u);
        for (auto v : g_rev[u]) {
            cnt[v]--;
            if (!cnt[v]) d.emplace_back(v);
        }
    }
    cout << "Yes\n";
    print(res);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}

//fft