#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e9;
const int MAXN = 1e5;
int MAXW = 0;

struct Edge {
    int a, b, w;
};

int n;
std::vector<std::vector<int>> v;
std::vector<Edge> p;

std::vector<int> o;
std::vector<bool> used;

void gen(int idx) {
    if (idx == n - 1) {
        std::cout << "Yes\n";
        for (auto &e : o) {
            std::cout << e + 1 << ' ';
        }
        std::exit(0);
    }
    for (int i = 0; i < n - 1; i++) {
        if (!used[i]) {
            auto x = v[p[i].a].back(), y = v[p[i].b].back();
            if (x + y >= p[i].w) {
                o[idx] = i;
                used[i] = true;
                v[p[i].a].pop_back();
                v[p[i].b].pop_back();
                gen(idx + 1);
                used[i] = false;
                v[p[i].a].push_back(x);
                v[p[i].b].push_back(y);
            }

        }
    }
}


void solve() {
    int g;
    std::cin >> n >> g;
    p.resize(n - 1);
    std::vector<int> sz(n);
    for (auto &[a, b, w] : p) {
        std::cin >> a >> b >> w;
        a--; b--;
        sz[a]++;
        sz[b]++;
    }
    o.resize(n - 1);
    used.resize(n, false);
    v.resize(n);
    for (int i = 0; i < n; i++) {
        v[i].resize(sz[i]);
        for (auto &e : v[i]) {
            std::cin >> e;
        }
    }
    if (g == 1) {
        gen(0);
        std::cout << "No\n";
        return;
    }
    if (g == 2) {
        return;
    }
    if (g == 3) {
        if (v[0].size() != n - 1) {
            std::cout << "No\n";
            return;
        }
        for (int i = 1; i < n; i++) {
            if (v[i].size() != 1) {
                std::cout << "No\n";
                return;
            }
        }
        std::vector<std::pair<int, int>> f;
        for (int i = 0; i < n - 1; i++) {
            f.push_back({p[i].w - v[p[i].b][0], i});
        }
        std::vector<std::pair<int, int>> g;
        for (int i = 0; i < n - 1; i++) {
            g.push_back({v[0][n - 1 - i - 1], i});
        }
        std::vector<int> ans(n - 1);
        std::sort(g.begin(), g.end());
        std::sort(f.begin(), f.end());
        for (int i = 0; i < n - 1; i++) {
            if (g[i].first >= f[i].first) {
                ans[g[i].second] = f[i].second;
            } else {
                std::cout << "No\n";
                return;
            }
        }
        std::cout << "Yes\n";
        for (auto e : ans) {
            std::cout << e + 1 << ' ';
        }
    }
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
