#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
using ull = unsigned long long;

const int nMax = 2e5 + 228;

struct dsu {
    int p[nMax];
    int s[nMax];

    int getP(int v) {
        return (p[v] = v ? p[v] : p[v] = getP(p[v]));
    }

    void unite(int v, int u) {
        v = getP(v);
        u = getP(u);
        if (v == u)return;
        if (s[v] < s[u])swap(v, u);
        s[v] += s[u];
        p[u] = v;
    }

    dsu() {
        for (int i = 0; i < nMax; i++) {
            p[i] = i;
            s[i] = 1;
        }
    }
};

using dd = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
dd c[nMax];
set<tuple<int, ll, ll>> g[nMax];
ll sz[nMax];
vector<pair<int, int>> ord[nMax];

void dfs(int v, int p) {
    for (auto [u, id]: ord[v]) {
        if (u == p) {
            cout << id << ' ';
            continue;
        }
        dfs(u, v);
    }
}

void solve() {
    int n, gg;
    cin >> n >> gg;
    dsu d1;
    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        if (d1.getP(u) == d1.getP(v)) {
            cout << "No";
            return;
        }
        d1.unite(u, v);
        g[u].emplace(v, w, i);
        g[v].emplace(u, w, i);
        sz[u]++;
        sz[v]++;
    }
    for (int i = 1; i <= n; i++) {
        int d;
        // cin >> d;
        d = g[i].size();
        ord[i].resize(d);
        for (int j = 0; j < d; j++) {
            int cc;
            cin >> cc;
            c[i].insert({cc, d - j - 1});
        }
    }
    set<pair<int, int>> q;
    for (int i = 1; i <= n; i++) {
        q.emplace(sz[i], i);
    }
    while (!q.empty()) {
        auto [szz, u] = *q.begin();
        q.erase(q.begin());
        if (szz == 0)continue;
        if (szz > 1) {
            cout << "No";
            return;
        }
        auto [v, w, eId] = *g[u].begin();
        q.erase({sz[v], v});
        sz[v]--;
        q.insert({sz[v], v});
        sz[u]--;

        g[u].erase(g[u].begin());
        g[v].erase({u, w, eId});
        auto [ucurC, ucurCid] = *c[u].begin();
        w -= ucurC;
        c[u].erase(c[u].begin());
        auto it = c[v].lower_bound({w, 0});
        if (it == c[v].end()) {
            cout << "No";
            return;
        }
        auto [vcurC, vcurCid] = *it;
        c[v].erase(it);
        ord[v][vcurCid] = {u, eId};
        ord[u][ucurCid] = {v, eId};
    }
    cout << "Yes\n";
    dfs(1, 0);
}

int main() {
#ifdef VANT
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int q = 1;
    //cin>>q;
    while (q--) {
        solve();
        //    cout << '\n';
    }
}
