#include <bits/stdc++.h>
using namespace std;

void solve01(int n) {
    vector<pair<int, int>> edges(n - 1);
    vector<int> w(n - 1), deg(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first >> edges[i].second;
        --edges[i].first, --edges[i].second;
        cin >> w[i];
        ++deg[edges[i].first];
        ++deg[edges[i].second];
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }
    vector<int> p(n - 1), ptr(n);
    iota(p.begin(), p.end(), 0);
    do {
        for (int i = 0; i < n; ++i) {
            ptr[i] = deg[i] - 1;
        }
        bool able = true;
        for (const int& i : p) {
            if (w[i] <= c[edges[i].first][ptr[edges[i].first]] + c[edges[i].second][ptr[edges[i].second]]) {
                --ptr[edges[i].first];
                --ptr[edges[i].second];
            } else {
                able = false;
                break;
            }
        }
        if (able) {
            cout << "Yes\n";
            for (const int& i : p) {
                cout << i + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No\n";
}

void solve2(int n) {
    vector<pair<int, int>> edges(n - 1);
    vector<int> w(n - 1), deg(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first >> edges[i].second;
        --edges[i].first, --edges[i].second;
        cin >> w[i];
        ++deg[edges[i].first];
        ++deg[edges[i].second];
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }
    vector<int> stk, p;
    for (int i = 0; i < n - 1; ++i) {
        int mn = min(c[i + 1][0], c[i + 1].back()), mx = max(c[i + 1][0], c[i + 1].back());
        if (w[i] > c[i][0] + mx) {
            cout << "No\n";
            return;
        }
        if (w[i] <= c[i][0] + mn) {
            if (c[i + 1][0] == mn) {
                swap(c[i + 1][0], c[i + 1].back());
                c[i + 1].pop_back();
                p.emplace_back(i);
                while (!stk.empty()) {
                    p.emplace_back(stk.back());
                    stk.pop_back();
                }
            } else {
                c[i + 1].pop_back();
                stk.emplace_back(i);
            }
        } else if (c[i + 1][0] == mx) {
            swap(c[i + 1][0], c[i + 1].back());
            c[i + 1].pop_back();
            p.emplace_back(i);
            while (!stk.empty()) {
                p.emplace_back(stk.back());
                stk.pop_back();
            }
        } else {
            c[i + 1].pop_back();
            stk.emplace_back(i);
        }
    }
    if (!stk.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (const int& i : p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

void solve3(int n) {
    vector<pair<int, int>> edges(n - 1);
    vector<int> w(n - 1), deg(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first >> edges[i].second;
        --edges[i].first, --edges[i].second;
        cin >> w[i];
        ++deg[edges[i].first];
        ++deg[edges[i].second];
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }
    set<pair<int, int>> s;
    vector<int> p;
    for (int i = 0; i < n - 1; ++i) {
        s.emplace(w[i] - c[i + 1][0], i);
    }
    while (!s.empty()) {
        int curc = c[0].back();
        c[0].pop_back();
        auto it = s.upper_bound(make_pair(curc, n));
        if (it == s.begin()) {
            cout << "No\n";
            return;
        }
        --it;
        p.emplace_back(it->second);
        s.erase(it);
    }
    cout << "Yes\n";
    for (const int& i : p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        int n, group;
        cin >> n >> group;
        if (group <= 1) {
            solve01(n);
        } else if (group == 2) {
            solve2(n);
        } else {
            solve3(n);
        }
        cout << "--------\n";
        cerr << "--------\n";
    }
    #else
    int T = 1;
    // cin >> T;
    while (T--) {
        int n, group;
        cin >> n >> group;
        if (group <= 1) {
            solve01(n);
        } else if (group == 2) {
            solve2(n);
        } else {
            solve3(n);
        }
    }
    #endif

    return 0;
}