#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct edge {
    int v, u, w;

    edge() {}

    edge(int v, int u, int w) : v(v), u(u), w(w) {}
};

inline void solve() {
    int n, g;
    cin >> n >> g;
    vector<int> deg(n);
    vector<edge> edges;
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        deg[v]++;
        deg[u]++;
        edges.push_back({ v, u, w });
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++)
            cin >> c[i][j];
        reverse(all(c[i]));
    }
    vector<int> p(n - 1);
    iota(all(p), 0);
    do {
        bool ok = true;
        vector<int> cur(n);
        for (int i : p) {
            edge e = edges[i];
            if (e.w > c[e.v][cur[e.v]] + c[e.u][cur[e.u]])
                ok = false;
            if (!ok)
                break;
            cur[e.v]++;
            cur[e.u]++;
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : p)
                cout << i + 1 << ' ';
            cout << '\n';
            return;
        }
    } while (next_permutation(all(p)));
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
