#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct edge {
    int v, u, w;

    edge() {}

    edge(int v, int u, int w) : v(v), u(u), w(w) {}
};

const int N = 2e5;
map<int, pii> g[N];
vector<int> g1[N];
map<int, vector<int>> c[N];
vector<int> ord[N];
pii c0[N];
int deg[N];

void dfs(int v, int pr = -1) {
    vector<int> ch;
    for (auto e : g[v])
        if (e.second.first != pr) {
            dfs(e.second.first, v);
            ch.push_back(e.second.first);
        }
    sort(all(ch), [&](int a, int b) {
        int wa = g[a].begin()->second.second;
        int wb = g[b].begin()->second.second;
        return wa - c0[a].first < wb - c0[b].first;
        });
    for (int u : ch) {
        int need = g[u].begin()->second.second - c0[u].first;
        auto it = c[v].lower_bound(need);
        if (it == c[v].end()) {
            cout << "No\n";
            exit(0);
        }
        int i = g[u].begin()->first;
        int jv = it->second.back();
        int ju = c0[u].second;
        ord[u][ju] = i;
        ord[v][jv] = i;
        it->second.pop_back();
        if (it->second.empty())
            c[v].erase(it);
        g[u].clear();
        g[v].erase(i);
    }
    if (pr > -1)
        c0[v] = { c[v].begin()->first, c[v].begin()->second.back() };
}

bool used[N];
vector<int> topsort;

void dfs1(int v) {
    used[v] = true;
    for (int u : g1[v])
        if (!used[u])
            dfs1(u);
    topsort.push_back(v);
}

inline void solve() {
    int n, group;
    cin >> n >> group;
    vector<edge> edges;
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        edges.push_back({ v, u, w });
        g[v][i] = { u, w };
        g[u][i] = { v, w };
        deg[v]++;
        deg[u]++;
    }
    for (int i = 0; i < n; i++) {
        ord[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            int w;
            cin >> w;
            c[i][w].push_back(j);
        }
    }
    dfs(0);
    for (int v = 0; v < n; v++)
        for (int j = deg[v] - 1; j > 0; j--)
            g1[ord[v][j]].push_back(ord[v][j - 1]);
    for (int v = 0; v < n - 1; v++)
        if (!used[v])
            dfs1(v);
    reverse(all(topsort));
    cout << "Yes\n";
    for (int i : topsort)
        cout << i + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
