#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

bool is = 1;

bool get(set<pair<int, int>> S, vector<pair<int, int>> &c1, int n) {
    for (int i = 0; i < c1.size(); i++) {
        if (i == n)
            continue;
        if (S.begin()->first > c1[i].first) {
            return 0;
        }
        auto it = --(S.upper_bound({c1[i].first + 1, -1}));
        S.erase(it);
    }
    return 1;
}

void
dfs_calc(int s, int p, vector<vector<pair<int, int>>> &g, vector<int> &left, vector<vector<int>> &c, vector<int> &ndx) {
    for (auto [i, w]: g[s]) {
        if (i != p)
            dfs_calc(i, s, g, left, c, ndx);
    }
    if (p != -1 && g[s].size() == 1) {
        left[s] = c[s][0];
        ndx[s] = 0;
        return;
    }
    if (p == -1)
        return;
    set<pair<int, int>> S;
    for (auto [i, w]: g[s]) {
        if (i == p)
            continue;
        S.insert({w - left[i], i});
    }

    vector<pair<int, int>> c1;
    for (int i = 0; i < c[s].size(); i++) {
        c1.push_back({c[s][i], i});
    }

    sort(all(c1));

    int l = -1, r = c1.size();

    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (get(S, c1, mid))
            l = mid;
        else
            r = mid;
    }
    if (l == -1)
        is = 0;

    ndx[s] = l;
    left[s] = c1[l].first;
}

void
dfs_ans(int s, int p, vector<vector<pair<int, int>>> &g, vector<int> &ndx, vector<vector<int>> &c, vector<int> &ans,
        map<pair<int, int>, int> &ind, vector<int> &left) {
    vector<pair<int, int>> c1;
    for (int i = 0; i < c[s].size(); i++) {
        c1.push_back({c[s][i], i});
    }
    sort(all(c1));

    set<pair<int, int>> S;
    for (auto [i, w]: g[s]) {
        if (i == p)
            continue;
        S.insert({w - left[i], i});
    }
    vector<int> pa(c1.size());
    for (int i = 0; i < c1.size(); i++) {
        if (i == ndx[s]) {
            pa[c1[i].second] = -1;
            continue;
        }
        auto it = (S.upper_bound({c1[i].first + 1, -1}));
        if (it == S.begin()) {
            cout << "No\n";
            exit(0);
        }
        it--;
        pa[c1[i].second] = it->second;
        S.erase(it);
    }

    for (int i = 0; i < c1.size(); i++) {
        if (pa[i] == -1) {
            ans.push_back(ind[{s, p}]);
        } else {
            dfs_ans(pa[i], s, g, ndx, c, ans, ind, left);
        }
    }
}

void solve() {
    int n, G;
    cin >> n >> G;
    vector<tuple<int, int, int, int>> e(n - 1);
    vector<vector<pair<int, int>>> g(n);
    vector<int> d(n);
    map<pair<int, int>, int> ind;
    int cnt = 1;
    for (auto &[a, b, c, ndx]: e) {
        cin >> a >> b >> c;
        a--;
        b--;
        d[a]++;
        d[b]++;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        ndx = cnt++;
        ind[{a, b}] = ndx;
        ind[{b, a}] = ndx;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        while (d[i]--) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    vector<int> left(n), ndx(n, -1), ans;

    dfs_calc(0, -1, g, left, c, ndx);
    if (!is) {
        cout << "No\n";
        return;
    }
    dfs_ans(0, -1, g, ndx, c, ans, ind, left);
    cout << "Yes\n";
    reverse(all(ans));
    for (int i: ans)
        cout << i << ' ';
}