#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << ": " << x << "\n";
#define watch_arr(arr) cout << #arr << ": "; \
for (auto x : arr) { \
    cout << x << " "; \
} \
cout << "\n";
#define all(arr) arr.begin(), arr.end()


struct Edge {
    int to, id, w;

    Edge(int _to, int _id, int _w) {
        to = _to, id = _id, w = _w;
    }
};


vector<vector<pair<int, int>>> arr;
vector<vector<Edge>> g;
vector<int> ans;
vector<vector<int>> order;

int dfs(int v, int p) {
    vector<pair<int, int>> children;
    for (int j = 0; j < g[v].size(); ++j) {
        Edge e = g[v][j];
        if (e.id == p) {
            continue;
        }
        children.emplace_back(e.w - dfs(e.to, e.id), j);
    }

    sort(all(children));
    sort(all(arr[v]));

    int best_res = -1;
    order[v].resize(arr[v].size());
    forn(i, children.size()) {
        if (arr[v][i].first < children[i].first) {
            if (best_res == -1) {
                best_res = arr[v][i].first;
                order[v][arr[v][i].second] = p;
            } else {
                cout << "No";
                exit(0);
            }
        }
        order[v][arr[v][i].second] = children[i].second;
    }

    if (best_res == -1) {
        return arr[v].back().first;
    }
    return best_res;
}


void get_ans(int v, int edge) {
    // watch_arr(order[v]);
    int i = 0;
    forn(i, order[v].size()) {
        if (g[v][order[v][i]].id == edge) {
            ans.emplace_back(edge);
            continue;
        }
        get_ans(g[v][order[v][i]].to, g[v][order[v][i]].id);
    }
}


int main() {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    
    int n, gr;
    cin >> n >> gr;
    arr.resize(n);
    g.resize(n);
    order.resize(n);
    forn(i, n - 1) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        g[a].emplace_back(Edge(b, i + 1, w));
        g[b].emplace_back(Edge(a, i + 1, w));
    }
    forn(i, n) {
        int deg = g[i].size();
        arr[i].resize(deg);
        forn(j, deg) {
            cin >> arr[i][j].first;
            arr[i][j].second = deg - j - 1;
        }
    }

    // if (gr == 3) {
    //     sort(all(arr[0]));
    //     vector<pair<int, int>> add;
    //     for (int i = 1; i < n; ++i) {
    //         add.emplace_back(g[i][0].w - arr[i][0], g[i][0].id);
    //     }
    //     sort(all(add));

    //     vector<int> ans;
    //     watch_arr(arr[0]);
    //     forn(i, n - 1) {
    //         cout << add[i].first << ' ';
    //     }
    //     cout << '\n';
    //     forn(i, n - 1) {
    //         if (arr[0][i] < add[i].first) {
    //             cout << "No";
    //             return 0;
    //         }
    //         ans.emplace_back(add[i].second);
    //     }

    //     reverse(all(ans));
    //     cout << "Yes\n";
    //     forn(i, n - 1) {
    //         cout << ans[i] << " ";
    //     }
    // }

    dfs(0, -1);
    get_ans(0, -1);
    cout << "Yes\n";
    forn(i, n - 1) {
        cout << ans[i] << ' ';
    }

    return 0;
}