#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}

struct ev{
    int a, b, w;
    int ind;
};

bool operator < (ev a, ev b) {
    return a.ind < b.ind;
}

int n, g;
vector<ev> e;
vector<int> deg;
vector<int> c[maxn];

bool check() {
    for (auto [a, b, w, ind] : e) {
        if (c[a][deg[a] - 1] + c[b][deg[b] - 1] >= w) {
            deg[a]--, deg[b]--;
        } else {
            for (int j = 0; j < n; j++) {
                deg[j] = c[j].size();
            }
            return false;
        }
    }
    for (int j = 0; j < n; j++) {
        deg[j] = c[j].size();
    }
    return true;
}


void solve() {
    cin >> n >> g;
    e.resize(n - 1);
    deg.resize(n, 0);
    for (int i = 0; i < n - 1; i++ ){
        cin >> e[i].a >> e[i].b >> e[i].w;
        e[i].a--, e[i].b--;
        e[i].ind = i;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }

    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
    }

    while (next_permutation(e.begin(), e.end())) {
        if (check()) {
            cout << "Yes\n";
            for (int i = 0; i < n - 1; i++) {
                cout << e[i].ind + 1 << " ";
            }
            return;
        }
    }
    cout << "No\n";
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
