#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}

struct ev{
    int a, b, w;
    int ind;
};

bool operator < (ev a, ev b) {
    return a.ind < b.ind;
}

int n;
vector<ev> e;
vector<int> deg;
vector<int> c[maxn];
set<pii> st[maxn];
set<int> g[maxn];
vector<int> g1[maxn];
vector<int> tin;
vector<int> ans;


void print(int v) {
    if (g[v].size() == 1) return;
    tin[v] = 1;
    for (auto ind : g1[v]) {
        int to = e[ind].a + e[ind].b - v;
        if (tin[to]) {
            ans.push_back(ind + 1);
            continue;
        }
        print(to);
    }
}

void solve() {
    int gr;
    cin >> n >> gr;
    e.resize(n - 1);
    deg.resize(n, 0);
    tin.resize(n, 0);
    for (int i = 0; i < n - 1; i++ ){
        cin >> e[i].a >> e[i].b >> e[i].w;
        e[i].a--, e[i].b--;
        g[e[i].a].insert(i);
        g[e[i].b].insert(i);
        e[i].ind = i;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }

    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        g1[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
            st[i].insert({c[i][j], j});
        }
    }

    deque<int> dq;
    for (int i = 0; i < n; i++) {
        if (st[i].size() == 1) {
            dq.push_back(i);
        }
    }

    while (dq.size() > 1) {
        int v = dq[0];
        dq.pop_front();
        int ind = *g[v].begin();
        g[v].erase(g[v].begin());
        int u = e[ind].a + e[ind].b - v;
        int w = e[ind].w;
        g[u].erase(ind);
        if (g[u].size() == 1) {
            dq.push_back(u);
        }
        auto res = st[u].lower_bound({w - st[v].begin()->first, -1});
        if (res == st[u].end()) {
            cout << "No\n";
            return;
        }
        g1[u][res->second] = ind;
        g1[v][st[v].begin()->second] = ind;
        st[v].erase(st[v].begin());
        st[u].erase(res);
    }


    cout << "Yes\n";
    print(0);
    reverse(ans.begin(), ans.end()) ;
    for (auto el : ans) {
        cout << el << " ";
    }
    /*for (int i = 0; i < n; i++) {
        cout << i << '\n';
        for (int j =  0; j < deg[i]; j++) {
            cout << g1[i][j] << " ";
        }
        cout << '\n';
    }*/
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
