#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const ll MAXN = 2e5;
set<pair<ll, ll>> g[MAXN];

void solve() {
    ll n, group;
    cin >> n >> group;

    map<pair<ll, ll>, ll> get_ind;

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;

        --a, --b;

        g[a].insert({b, w});
        g[b].insert({a, w});

        get_ind[{a, b}] = i;
        get_ind[{b, a}] = i;
    }

    vector<vector<ll>> por(n);
    vector<multiset<ll>> a(n);
    for (ll i = 0; i < n; ++i) {
        por[i].resize(g[i].size());

        for (ll j = 0; j < g[i].size(); ++j) {
            cin >> por[i][j];
            a[i].insert(por[i][j]);
        }

        reverse(all(por[i]));
    }

    vector<vector<ll>> zapr;

    for (ll qw = 0; qw < n - 1; ++qw) {
        for (ll i = 0; i < n; ++i) {
            if (g[i].size() == 1) {
                ll v = i, u = g[i].begin()->first, w = g[i].begin()->second;

                g[v].erase({u, w});
                g[u].erase({v, w});

                ll in_v = *a[i].begin();
                ll need = w - in_v;

                if (*(--a[u].end()) < need) {
                    cout << "No\n";
                    return;
                }

                ll h = *a[u].lower_bound(need);
                a[u].erase(a[u].find(h));

                zapr.push_back({v, in_v, u, h});

                break;
            }
        }
    }

    cout << "Yes\n";

    vector<ll> ans;
    vector<ll> used(n - 1, 0);

    for (ll qw = 0; qw < n - 1; ++qw) {
        for (ll i = 0; i < n - 1; ++i) {
            if (used[i]) continue;
            ll v = zapr[i][0], in_v = zapr[i][1], u = zapr[i][2], in_u = zapr[i][3];

            if (por[v].size() && por[u].size() && por[v].back() == in_v && por[u].back() == in_u) {
                ans.push_back(get_ind[{v, u}]);
                por[v].pop_back();
                por[u].pop_back();
                used[i] = 1;
                break;
            }
        }
    }

    reverse(all(ans));

    for (auto i : ans) cout << i + 1 << ' ';
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
