#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const ll MAXN = 2e5;
set<pair<ll, ll>> g[MAXN];
vector<ll> to_less[MAXN];
ll used[MAXN];
vector<ll> ans;

void dfs(ll v) {
    used[v] = 1;

    for (auto i : to_less[v]) {
        if (used[i]) continue;
        dfs(i);
    }

    ans.push_back(v);
}

void solve() {
    ll n, group;
    cin >> n >> group;

    map<pair<ll, ll>, ll> get_ind;

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;

        --a, --b;

        g[a].insert({b, w});
        g[b].insert({a, w});

        get_ind[{a, b}] = i;
        get_ind[{b, a}] = i;
    }

    vector<vector<ll>> por(n);
    vector<multiset<ll>> a(n);
    for (ll i = 0; i < n; ++i) {
        por[i].resize(g[i].size());

        for (ll j = 0; j < g[i].size(); ++j) {
            cin >> por[i][j];
            a[i].insert(por[i][j]);
        }

        reverse(all(por[i]));
    }

    vector<vector<ll>> zapr;
    set<ll> lists;

    for (ll i = 0; i < n; ++i) {
        if (g[i].size() == 1) lists.insert(i);
    }

    while (lists.size()) {
        ll v = *lists.begin();
        lists.erase(v);

        if (g[v].size() != 1) continue;

        ll u = g[v].begin()->first, w = g[v].begin()->second;

        g[v].erase({u, w});
        g[u].erase({v, w});

        ll in_v = *a[v].begin();
        ll need = w - in_v;

        if (*(--a[u].end()) < need) {
            cout << "No\n";
            return;
        }

        ll h = *a[u].lower_bound(need);
        a[u].erase(a[u].find(h));

        zapr.push_back({v, in_v, u, h});

        if (g[u].size() == 1) {
            lists.insert(u);
        }
    }

//    for (ll qw = 0; qw < n - 1; ++qw) {
//        for (ll i = 0; i < n; ++i) {
//            if (g[i].size() == 1) {
//
//
//                break;
//            }
//        }
//    }

    cout << "Yes\n";

    map<pair<ll, ll>, vector<pair<ll, ll>>> to_check;

    for (auto i : zapr) {
        to_check[{i[0], i[1]}].push_back({i[2], i[3]});
        to_check[{i[2], i[3]}].push_back({i[0], i[1]});
    }

    for (ll i = 0; i < n; ++i) {
        vector<ll> my_order;
        for (ll j = 0; j < por[i].size(); ++j) {
            auto gh = to_check[{i, por[i][j]}].back();
            to_check[{i, por[i][j]}].pop_back();

            my_order.push_back(get_ind[{i, gh.first}]);
        }

        for (ll j = 0; j + 1 < por[i].size(); ++j) {
            to_less[my_order[j]].push_back(my_order[j + 1]);
        }
    }

    for (ll i = 0; i < n - 1; ++i) {
        if (used[i]) continue;

        dfs(i);
    }

    reverse(all(ans));

    for (auto i : ans) cout << i + 1 << ' ';
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
