#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_map>
#define int long long
using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<vector<pair<int, int>>> g(n);
    vector<set<pair<int, int>>> G(n);
    map<pair<int, int>, int> ind;
    int a, b, w;
    for (int i = 0; i < n - 1; ++i) {
        cin >> a >> b >> w;
        a--;
        b--;
        ind[{min(a, b), max(a, b)}] = i;
        g[a].push_back({b, w});
        G[a].insert({b, w});
        g[b].push_back({a, w});
        G[b].insert({a, w});
    }
    vector<vector<int>> edges;
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)g[i].size(); ++j) {
            cin >> w;
            c[i].push_back(w);
        }
        reverse(c[i].begin(), c[i].end());
    }
    vector<multiset<int>> sorted(n);
    for (int i = 0; i < n; ++i) {
        for (auto u : c[i]) {
            sorted[i].insert(u);
        }
    }
    set<pair<int, int>> cnt;
    vector<int> left(n);
    for (int i = 0; i < n; ++i) {
        left[i] = (int)g[i].size();
        cnt.insert({(int)g[i].size(), i});
    }
    while (!cnt.empty()) {
        auto [e, i] = *cnt.begin();
        left[i]--;
        cnt.erase(cnt.begin());
        auto [to, we] = *G[i].begin();
        G[i].erase(G[i].begin());
        G[to].erase({i, we});
        cnt.erase({left[to], to});
        left[to]--;
        if (left[to] != 0) {
            cnt.insert({left[to], to});
        }
        int c1 = *sorted[i].begin();
        sorted[i].erase(sorted[i].begin());
        auto it = lower_bound(sorted[to].begin(), sorted[to].end(), we - c1);
        if (it == sorted[to].end()) {
            cout << "No" << endl;
            exit(0);
        }
        int c2 = *it;
        sorted[to].erase(it);
        edges.push_back({i, to, c1, c2, we});
    }
    for (auto edge : edges) {
        //cout << edge[0] + 1 << " " << edge[1] + 1 << " : " << edge[2] << " " << edge[3] << " " << edge[4] << endl;
    }

    vector<map<int, vector<int>>> pos(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)c[i].size(); ++j) {
            pos[i][c[i][j]].push_back(j);
        }
    }

    vector<vector<int>> ans;
    for (auto edge : edges) {
        int n1 = pos[edge[0]][edge[2]].back();
        pos[edge[0]][edge[2]].pop_back();
        int n2 = pos[edge[1]][edge[3]].back();
        pos[edge[1]][edge[3]].pop_back();
        int weight = n1 + n2;
        int index = ind[{min(edge[0], edge[1]), max(edge[0], edge[1])}];
        ans.push_back({n1, n2, index, edge[0], edge[1]});
    }
    sort(ans.begin(), ans.end());
    vector<int> used(n);
    vector<bool> printed(n, false);
    cout << "Yes" << endl;
    for (int qwe = 0; qwe < (n - 1); ++qwe) {
        for (int i = 0; i < n - 1; ++i) {
            if (!printed[i] && used[ans[i][3]] == ans[i][0] && used[ans[i][4]] == ans[i][1]) {
                cout << ans[i][2] + 1 << " ";
                printed[i] = true;
                used[ans[i][3]]++;
                used[ans[i][4]]++;
            }
        }
    }
    cout << endl;
    return 0;
}
