#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_map>
#define int long long
using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    if (q == 0 || q == 1 || q == 5 || q == 6 || q == 8) {
        vector<vector<pair<int, int>>> g(n);
        vector<set<pair<int, int>>> G(n);
        map<pair<int, int>, int> ind;
        int a, b, w;
        for (int i = 0; i < n - 1; ++i) {
            cin >> a >> b >> w;
            a--;
            b--;
            ind[{min(a, b), max(a, b)}] = i;
            g[a].push_back({b, w});
            G[a].insert({b, w});
            g[b].push_back({a, w});
            G[b].insert({a, w});
        }
        vector<vector<int>> edges;
        vector<vector<int>> c(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < (int)g[i].size(); ++j) {
                cin >> w;
                c[i].push_back(w);
            }
            reverse(c[i].begin(), c[i].end());
        }
        vector<multiset<int>> sorted(n);
        for (int i = 0; i < n; ++i) {
            for (auto u : c[i]) {
                sorted[i].insert(u);
            }
        }
        set<pair<int, int>> cnt;
        vector<int> left(n);
        for (int i = 0; i < n; ++i) {
            left[i] = (int)g[i].size();
            cnt.insert({(int)g[i].size(), i});
        }
        while (!cnt.empty()) {
            auto [e, i] = *cnt.begin();
            left[i]--;
            cnt.erase(cnt.begin());
            auto [to, we] = *G[i].begin();
            G[i].erase(G[i].begin());
            G[to].erase({i, we});
            cnt.erase({left[to], to});
            left[to]--;
            if (left[to] != 0) {
                cnt.insert({left[to], to});
            }
            int c1 = *sorted[i].begin();
            sorted[i].erase(sorted[i].begin());
            auto it = lower_bound(sorted[to].begin(), sorted[to].end(), we - c1);
            if (it == sorted[to].end()) {
                cout << "No" << endl;
                exit(0);
            }
            int c2 = *it;
            sorted[to].erase(it);
            edges.push_back({i, to, c1, c2, we});
        }
        for (auto edge : edges) {
            //cout << edge[0] + 1 << " " << edge[1] + 1 << " : " << edge[2] << " " << edge[3] << " " << edge[4] << endl;
        }

        vector<map<int, vector<int>>> pos(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < (int)c[i].size(); ++j) {
                pos[i][c[i][j]].push_back(j);
            }
        }

        vector<vector<int>> ans;
        for (auto edge : edges) {
            int n1 = pos[edge[0]][edge[2]].back();
            pos[edge[0]][edge[2]].pop_back();
            int n2 = pos[edge[1]][edge[3]].back();
            pos[edge[1]][edge[3]].pop_back();
            int weight = n1 + n2;
            int index = ind[{min(edge[0], edge[1]), max(edge[0], edge[1])}];
            ans.push_back({n1, n2, index, edge[0], edge[1]});
        }
        sort(ans.begin(), ans.end());
        vector<int> used(n);
        vector<bool> printed(n, false);
        cout << "Yes" << endl;
        for (int qwe = 0; qwe < (n - 1); ++qwe) {
            for (int i = 0; i < n - 1; ++i) {
                if (!printed[i] && used[ans[i][3]] == ans[i][0] && used[ans[i][4]] == ans[i][1]) {
                    cout << ans[i][2] + 1 << " ";
                    printed[i] = true;
                    used[ans[i][3]]++;
                    used[ans[i][4]]++;
                }
            }
        }
        cout << endl;

    } else if (q == 2) {
        vector<vector<pair<int, int>>> g(n);
        int a, b, w;
        vector<int> www(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            cin >> a >> b >> w;
            www[i] = w;
            a--;
            b--;
            g[a].push_back({b, w});
            g[b].push_back({a, w});
        }
        vector<vector<int>> c(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < (int) g[i].size(); ++j) {
                cin >> w;
                c[i].push_back(w);
            }
            reverse(c[i].begin(), c[i].end());
        }
        int end = n - 1;
        vector<int> fr, bc;
        while (end > 0) {
            int we = www[end - 1];
            int c1 = c[end][0];
            int mx = 0;
            int mn = 0;
            if (end != 1) {
                if (c[end - 1][1] > c[end - 1][0]) {
                    mx = 1;
                } else {
                    mn = 1;
                }
            }
            if (c1 + c[end - 1][mx] < we) {
                cout << "No" << endl;
                exit(0);
            }
            if (c1 + c[end - 1][mn] >= we) {
                if (mn == 0) {
                    fr.push_back(end);
                    c[end - 1][0] = c[end - 1][1];
                    c[end - 1].pop_back();
                } else {
                    bc.push_back(end);
                    c[end - 1].pop_back();
                }
            } else {
                if (mx == 0) {
                    fr.push_back(end);
                    c[end - 1][0] = c[end - 1][1];
                    c[end - 1].pop_back();
                } else {
                    bc.push_back(end);
                    c[end - 1].pop_back();
                }
            }
            end--;
        }
        cout << "Yes" << endl;
        reverse(bc.begin(), bc.end());
        for (auto u : fr) {
            cout << u << " ";
        }
        for (auto u : bc) {
            cout << u << " ";
        }
        cout << endl;
    } else if (q == 3) {
        vector<pair<int, int>> dif(n - 1);
        int a, b, w;
        for (int i = 0; i < n - 1; ++i) {
            cin >> a >> b >> w;
            dif[i] = {w, i + 1};
        }
        vector<vector<int>> c(n);
        for (int i = 0; i < n; ++i) {
            if (i == 0) {
                for (int j = 0; j < n - 1; ++j) {
                    cin >> w;
                    c[i].push_back(w);
                }
            } else {
                cin >> w;
                c[i].push_back(w);
                dif[i - 1].first -= w;
            }
            reverse(c[i].begin(), c[i].end());
        }
        vector<pair<int, int>> C(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            C[i] = {c[0][i], i};
        }
        sort(C.begin(), C.end());
        sort(dif.begin(), dif.end());
        vector<int> out(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            if (C[i].first >= dif[i].first) {
                out[C[i].second] = dif[i].second;
            } else {
                cout << "No" << endl;
                exit(0);
            }
        }
        cout << "Yes" << endl;
        for (int i = 0; i < n - 1; ++i) {
            cout << out[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
