#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n, g;
    cin >> n >> g;
    vector<vector<int>> edges(n - 1, vector<int> (3));
    vector<int> cnt(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i][0] >> edges[i][1] >> edges[i][2];
        edges[i][0]--;
        edges[i][1]--;
        cnt[edges[i][0]]++;
        cnt[edges[i][1]]++;
    }
    vector<vector<int>> stickers(n);
    for (int i = 0; i < n; i++) {
        stickers[i].resize(cnt[i]);
        for (int& x : stickers[i])
            cin >> x;
    }
    vector<int> perm(n - 1);
    for (int i = 0; i < n - 1; i++)
        perm[i] = i;
    if (g <= 1) {
        do {
            vector<vector<int>> s(n);
            for (int i = 0; i < n; i++)
                s[i] = stickers[i];
            bool good = true;
            for (int x : perm) {
                int v = edges[x][0], u = edges[x][1], c = edges[x][2];
                if (s[v].back() + s[u].back() < c) {
                    good = false;
                    break;
                }
                s[v].pop_back();
                s[u].pop_back();
            }
            if (good) {
                cout << "Yes\n";
                for (int x : perm)
                    cout << x + 1 << ' ';
                return;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        cout << "No";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
