#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using ll = long long;
using ld = long double;

using namespace std;

void f(int i, int j, auto& stickers, auto& edges, auto& dp, vector<int>& ans) {
    if (i == dp.size() - 2) {
        ans.push_back(i + 1);
        return;
    }
    if (edges[i][2] <= stickers[i][j] + stickers[i + 1][0] && dp[i + 1][1]) {
        f(i + 1, 1, stickers, edges, dp, ans);
        ans.push_back(i + 1);
    } else if (edges[i][2] <= stickers[i][j] + stickers[i + 1][1] && dp[i + 1][0]) {
        ans.push_back(i + 1);
        f(i + 1, 0, stickers, edges, dp, ans);
    }
}

void solve() {
    int n, g;
    cin >> n >> g;
    vector<vector<int>> edges(n - 1, vector<int> (3));
    vector<int> cnt(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i][0] >> edges[i][1] >> edges[i][2];
        edges[i][0]--;
        edges[i][1]--;
        cnt[edges[i][0]]++;
        cnt[edges[i][1]]++;
    }
    vector<vector<int>> stickers(n);
    for (int i = 0; i < n; i++) {
        stickers[i].resize(cnt[i]);
        for (int& x : stickers[i])
            cin >> x;
    }
    vector<int> perm(n - 1);
    for (int i = 0; i < n - 1; i++)
        perm[i] = i;
    if (g <= 1) {
        do {
            vector<vector<int>> s(n);
            for (int i = 0; i < n; i++)
                s[i] = stickers[i];
            bool good = true;
            for (int x : perm) {
                int v = edges[x][0], u = edges[x][1], c = edges[x][2];
                if (s[v].back() + s[u].back() < c) {
                    good = false;
                    break;
                }
                s[v].pop_back();
                s[u].pop_back();
            }
            if (good) {
                cout << "Yes\n";
                for (int x : perm)
                    cout << x + 1 << ' ';
                return;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        cout << "No";
    } else if (g == 3) {
        multimap<int, int> st;
        for (int i = 0; i < n - 1; i++)
            st.emplace(edges[i][2] - stickers[edges[i][1]][0], i);
        vector<int> ans;
        for (int i = 0; i < n - 1; i++) {
            int a = stickers[0].back();
            stickers[0].pop_back();
            if (st.begin()->first > a) {
                cout << "No";
                return;
            }
            auto it = st.upper_bound(a);
            if (it == st.begin()) {
                cout << "No";
                return;
            }
            it--;
            ans.push_back(it->second + 1);
            st.erase(it);
        }
        cout << "Yes\n";
        for (int x : ans)
            cout << x << ' ';
    } else if (g == 2) {
        vector<vector<int>> dp(n, vector<int> (2, 0));
        dp[n - 1][0] = 1;
        dp[n - 1][1] = 1;
        for (int i = n - 2; i >= 0; i--) {
            for (int j = 0; j < 2; j++) {
                if (edges[i][2] <= stickers[i][j] + stickers[i + 1][0] && dp[i + 1][1])
                    dp[i][j] = 1;
                else if (edges[i][2] <= stickers[i][j] + stickers[i + 1][1] && dp[i + 1][0])
                    dp[i][j] = 1;
            }
        }
        int j;
        if (!dp[0][0] && !dp[0][1]) {
            cout << "No";
            return;
        } else if (dp[0][0]) {
            j = 0;
        } else {
            j = 1;
        }
        vector<int> ans;
        f(0, j, stickers, edges, dp, ans);
        cout << "Yes\n";
        for (int x : ans)
            cout << x << ' ';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
