#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

using namespace std;
using ll = long long;

const ll INF = 1e18;

ll n, G;
vector <tuple <ll, ll, ll>> edges;
vector <bool> live;
vector <ll> deg, depth;
vector <set <pair <ll, ll>>> sstik;
vector <set <tuple <ll, ll, ll>>> stik;
vector <vector <tuple <ll, ll, ll>>> g;
vector <pair <ll, ll>> ans;

void calcDepth(ll v, ll p) {
    for (auto [to, w, id] : g[v]) {
        if (to == p)
            continue;
        depth[to] = depth[v] + 1;
        calcDepth(to, v);
    }
}

void dfs(ll v, ll p, ll W, ll ID) {
    for (auto [to, w, id] : g[v]) {
        if (to == p)
            continue;
        dfs(to, v, w, id);
    }
    if (p != -1) {
        auto [x, id, j] = *stik[v].begin();
        stik[v].erase(stik[v].begin());
        auto it = stik[p].lower_bound({W - x, -1, -1});
        if (it == stik[p].end()) {
            cout << "No\n";
            exit(0);
        }
        stik[p].erase(it);
        auto [_, num, prio] = *it;
        ans.emplace_back(num, ID);
    }
}

void solve() {
    cin >> n >> G;
    edges.resize(n - 1);
    live.resize(n - 1, true);
    deg.resize(n);
    depth.resize(n);
    g.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        auto& [a, b, w] = edges[i];
        cin >> a >> b >> w, a--, b--, deg[a]++, deg[b]++;
        g[a].emplace_back(b, w, i), g[b].emplace_back(a, w, i);
    }
    sstik.resize(n), stik.resize(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < deg[i]; j++) {
            ll x; cin >> x;
            sstik[i].insert({x, j});
        }
        ll j = 0;
        for (auto [x, id] : sstik[i])
            stik[i].insert({x, id, j++});
    }
    calcDepth(0, -1);
    dfs(0, -1, -1, -1);
    sort(ans.rbegin(), ans.rend());
    cout << "Yes\n";
    for (auto [i, j] : ans)
        cout << j + 1 << ' ';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
