//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int n, g;
    cin >> n >> g;
    vector<vector<array<int, 3>>> gr(n);
    for (int i = 1, u, v, w; i < n; ++i) {
        cin >> u >> v >> w;
        --u, --v;
        gr[u].push_back({v, w, i});
        gr[v].push_back({u, w, i});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(gr[i].size());
        for (auto &j : c[i])
            cin >> j;
    }
    bool ok = true;
    vector<int> num(n);
    vector<pair<int, int>> par(n);
    auto dfs = [&](auto self, int v, int p) -> int {
        vector<int> now;
        for (auto [u, w, _] : gr[v])
            if (u != p) {
                now.push_back(w - self(self, u, v));
                par[u] = {v, _};
            }
        sort(all(now));
        vector<int> need = c[v];
        sort(all(need));
        int ind = -1;
        for (int i = 0; i < now.size(); ++i) {
            if (need[i] >= now[i])
                ind = i;
            else
                break;
        }
        if (v == 0 && ind != (int)now.size() - 1) {
            ok = false;
            return -1;
        } else {
            for (int i = ind + 1; i < now.size(); ++i)
                if (need[i + 1] < now[i]) {
                    ok = false;
                    break;
                }
            for (int i = 0; i < c[v].size(); ++i)
                if (c[v][i] == need[ind + 1]) {
                    num[v] = i;
                    break;
                }
            return need[ind + 1];
        }
    };
    dfs(dfs, 0, -1);
    cout << (ok ? "Yes" : "No") << '\n';
    if (ok) {
        set<pair<int, int>> st;
        vector<int> res, cnt(n);
        for (int i = 1; i < n; ++i) {
            st.insert({num[i], i});
            cnt[i] = num[i];
        }
        while (!st.empty()) {
            int v = st.begin()->second;
            st.erase(st.begin());
            res.push_back(par[v].second);
            if (par[v].first != 0) {
                st.erase({cnt[par[v].first], par[v].first});
                --cnt[par[v].first];
                if (cnt[par[v].first] >= 0)
                    st.insert({cnt[par[v].first], par[v].first});
            }
        }
        for (int i : res)
            cout << i << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
