#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>

using namespace std;

#define ALL(x) x.begin(), x.end()
#define int long long
typedef long long ll;
typedef long double ld;

void solve1(int n)
{
	vector<pair<pair<int, int>, pair<int, int>>> edges;
	vector<int> deg(n, 0);
	vector<int> temmp;
	vector<vector<int>> c(n, temmp);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		deg[a]++;
		deg[b]++;
		edges.push_back({ {a, b}, {w, i} });
	}
	sort(ALL(edges));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < deg[i]; j++)
		{
			int x;
			cin >> x;
			c[i].push_back(x);
		}
	}
	vector<vector<int>> c1 = c;
	do
	{
		c1 = c;
		bool ban = true;
		for (auto [xy, ww] : edges)
		{
			auto [x, y] = xy;
			auto [w, ii] = ww;
			if (c1[x].back() + c1[y].back() < w)
			{
				ban = false;
				break;
			}
			c1[x].pop_back();
			c1[y].pop_back();
		}
		if (ban)
		{
			cout << "Yes\n";
			for (auto [xy, ww] : edges)
			{
				auto [x, y] = xy;
				auto [w, ii] = ww;
				cout << ii + 1 << ' ';
			}
			return;
		}
	} while (next_permutation(ALL(edges)));
	cout << "No";
}

void solve2(int n)
{
	vector<pair<pair<int, int>, pair<int, int>>> edges;
	vector<int> deg(n, 0);
	vector<int> temmp;
	vector<vector<int>> c(n, temmp);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		if (b < a)
		{
			swap(a, b);
		}
		deg[a]++;
		deg[b]++;
		edges.push_back({ {a, b}, {w, i} });
	}
	vector<pair<int, int>> c1;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < deg[i]; j++)
		{
			int x;
			cin >> x;
			c[i].push_back(x);
			if (i == 0)
			{
				c1.push_back({ x, j });
			}
		}
	}
	vector<pair<int, int>> miner(n - 1);
	for (auto i : edges)
	{
 		miner[i.second.second] = { i.second.first - c[i.first.second].back(), i.second.second };
	}
	
	sort(ALL(c1));
	sort(ALL(miner));
	for (int i = 0; i < n - 1; i++)
	{
		if (c1[i].first < miner[i].first)
		{
			cout << "No";
			return;
		}
	}
	cout << "Yes\n";
	vector<int> ans(n - 1);
	for (int i = 0; i < n - 1; i++)
	{
		ans[c1[i].second] = miner[i].second;
	}
	reverse(ALL(ans));
	for (auto i : ans)
	{
		cout << i + 1 << ' ';
	}
}


void solve()
{
	int n, g;
	cin >> n >> g; 
	if (g <= 1)
	{
		solve1(n);
	}
	else
	{
		solve2(n);
	}
}

int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}