#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct Edge {
    ll u, v, w, num;
};

ll n;
vector <ll> pw;
vector <Edge> edges;
vector <vector <ll>> c;

bool can_ch(vector <ll> in_ord, vector <ll> num_ord) {
    vector <ll> tp(n + 1, 0);
    for (auto pos : in_ord) {
        ll ind = num_ord[pos];
        ll u = edges[ind].u, v = edges[ind].v, w = edges[ind].w;
        ++tp[u], ++tp[v];
        if (tp[u] > pw[u] || tp[v] > pw[v] || c[u][tp[u] - 1] + c[v][tp[v] - 1] < w) {
            return false;
        }
    }

    cout << "YES\n";
    for (auto el : in_ord) {
        cout << edges[num_ord[el]].num << ' ';
    }

    return true;
}

void solution1() {
    vector <ll> in_ord(n - 1), num_ord(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        num_ord[i] = i;
        in_ord[i] = i;
    }

    if (can_ch(in_ord, num_ord)) {
        return;
    }

    while (next_permutation(all(num_ord))) {
        for (ll i = 0; i < n - 1; ++i) {
            in_ord[i] = i;
        }

        if (can_ch(in_ord, num_ord)) {
            return;
        }

        while (next_permutation(all(in_ord))) {
//            cout << "num: " << num_ord << "in: " << in_ord;
            if (can_ch(in_ord, num_ord)) {
                return;
            }
        }
    }

    cout << "NO";
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    ll g;
    cin >> n >> g;
    pw.resize(n + 1);
    edges.resize(n - 1);
    ll num = 1;
    for (auto &e : edges) {
        cin >> e.u >> e.v >> e.w;
        ++pw[e.u], ++pw[e.v];
        e.num = num++;
    }

    c.resize(n + 1);
    for (ll i = 1; i <= n; ++i) {
        c[i].resize(pw[i]);
        cin >> c[i];
    }

    if (g <= 1) {
        solution1();
    }

    return 0;
}