#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct Edge {
    ll u, v, w, num;
};

ll n;
vector <ll> pw;
vector <Edge> edges;
vector <vector <ll>> c;

bool can_ch(vector <ll> in_ord, vector <ll> num_ord) {
    vector <ll> tp(n + 1, 0);
    for (auto pos : in_ord) {
        ll ind = num_ord[pos];
        ll u = edges[ind].u, v = edges[ind].v, w = edges[ind].w;
        ++tp[u], ++tp[v];
        if (tp[u] > pw[u] || tp[v] > pw[v] || c[u][tp[u] - 1] + c[v][tp[v] - 1] < w) {
            return false;
        }
    }

    cout << "YES\n";
    for (auto pos : in_ord) {
        cout << edges[num_ord[pos]].num << ' ';
    }

    return true;
}

void solution1() {
    vector <ll> in_ord(n - 1), num_ord(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        num_ord[i] = i;
        in_ord[i] = i;
    }

    if (can_ch(in_ord, num_ord)) {
        return;
    }

    while (next_permutation(all(num_ord))) {
        if (can_ch(in_ord, num_ord)) {
            return;
        }
    }

    cout << "NO";
}

bool edges_comp(Edge &e1, Edge &e2) {
    return (min(e1.u, e1.v) < min(e2.u, e2.v));
}

void solution2() {
    vector <vector <ll>> take(n + 1, {-1, -1});
    sort(all(edges), edges_comp);

    for (auto &e : edges) {
        if (e.u > e.v) {
            swap(e.u, e.v);
        }

        ll lv;
        if (e.u == 1) {
            lv = c[1][0];
            take[1][0] = 1;
        } else {
            if (take[e.u][0] == -1) lv = c[e.u][0], take[e.u][0] = e.num;
            else lv = c[e.u][1], take[e.u][1] = e.num;
        }

        if (e.v == n) {
            if (lv + c[e.v][0] < e.w) {
                cout << "NO";
                return;
            }
            take[e.v][0] = e.num;
            break;
        }

        if (e.w > lv + max(c[e.v][0], c[e.v][1])) {
            cout << "NO";
            return;
        } else if (e.w <= lv + min(c[e.v][0], c[e.v][1])) {
            if (c[e.v][0] < c[e.v][1]) {
                take[e.v][0] = e.num;
            } else {
                take[e.v][1] = e.num;
            }
        } else {
            if (c[e.v][0] < c[e.v][1]) {
                take[e.v][1] = e.num;
            } else {
                take[e.v][0] = e.num;
            }
        }
    }

    vector <ll> under(n + 1);
    vector <vector <ll>> gr(n + 57);
    for (ll i = 1; i + 2 < n; ++i) {
        if (take[edges[i].u][0] == edges[i].num) ++under[edges[i].num], gr[take[edges[i].u][1]].emplace_back(take[edges[i].u][0]);
        if (take[edges[i].v][0] == edges[i].num) ++under[edges[i].num], gr[take[edges[i].v][1]].emplace_back(take[edges[i].v][0]);
    }

    if (take[edges[0].v][0] == edges[0].num) ++under[edges[0].num], gr[take[edges[0].v][1]].emplace_back(take[edges[0].v][0]);;
    if (take[edges[n - 2].u][0] == edges[n - 2].num) ++under[edges[n - 2].num], gr[take[edges[n - 2].u][1]].emplace_back(take[edges[n - 2].u][0]);;

    queue <ll> out;
    for (auto e : edges) {
        if (under[e.num] == 0) {
            out.push(e.num);
        }
    }

    cout << "YES\n";
    while (!out.empty()) {
        ll v = out.front();
        out.pop();
        for (auto to : gr[v]) {
            --under[to];
            if (under[to] == 0) {
                out.push(to);
            }
        }

        cout << v << ' ';
    }
}

void solution3() {
    vector <pll> cn(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll ind = max(edges[i].v, edges[i].u);
        cn[i] = {edges[i].w - c[ind][0], edges[i].num};
    }

    vector <pll> bv(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        bv[i] = {c[1][i], i};
    }

    vector <ll> out(n - 1);
    sort(rall(cn)), sort(rall(bv));
    for (ll i = 0; i < n - 1; ++i) {
        if (bv[i].first < cn[i].first) {
            cout << "NO";
            return;
        } else {
            out[bv[i].second] = cn[i].second;
        }
    }

    cout << "YES\n" << out;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll g;
    cin >> n >> g;
    pw.resize(n + 1);
    edges.resize(n - 1);
    ll num = 1;
    for (auto &e : edges) {
        cin >> e.u >> e.v >> e.w;
        ++pw[e.u], ++pw[e.v];
        e.num = num++;
    }

    c.resize(n + 1);
    for (ll i = 1; i <= n; ++i) {
        c[i].resize(pw[i]);
        cin >> c[i];
        reverse(all(c[i]));
    }

    if (g <= 1) {
        solution1();
    } else if (g == 2) {
        solution2();
    } else {
        solution3();
    }

    return 0;
}