#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, g;
    cin >> n >> g;
    vector<set<tuple<long long, int, int>>> gr(n);
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        long long a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].insert({w, b, i});
        gr[b].insert({w, a, i});
        deg[a]++;
        deg[b]++;
    }
    vector<set<pair<long long, int>>> st(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            long long a;
            cin >> a;
            st[i].insert({a, j});
        }
    }

    set<pair<int, int>> degs;
    for (int i = 0; i < n; i++) {
        degs.insert({deg[i], i});
    }

    vector<vector<int>> ids(n);
    for (int i = 0; i < n; i++) {
        ids[i].resize(deg[i], -1);
    }


    while (degs.size() > 0) {
        auto [dg, v] = *(degs.begin());
        degs.erase(*degs.begin());
        if (dg != 1) {
            cout << "No";
            return 0;
        }
        auto [w, u, ide] = *gr[v].begin();
        gr[v].erase({w, u, ide});
        gr[u].erase({w, v, ide});
        deg[v]--;
        degs.erase({deg[u], u});
        deg[u]--;
        if (deg[u] != 0) {
            degs.insert({deg[u], u});
        }

        auto [x, id] = *st[v].begin();
        st[v].clear();

        auto it = st[u].lower_bound({w - x, -1});
        if (it == st[u].end()) {
            cout << "No";
            return 0;
        }
        st[u].erase(it);
        auto [x2, id2] = *it;
        ids[u][id2] = ide;
        ids[v][id] = ide;
    }
    /*for (auto i : ids) {
        for (auto j : i) {
            cout << j << " ";
        } cout << endl;
    } cout << endl;*/

    vector<vector<int>> dep(n - 1);
    vector<int> depc(n - 1, 0);
    for (int i = 0; i < n; i++) {
        for (int j = ids[i].size() - 1; j > 0; j--) {
            dep[ids[i][j]].push_back(ids[i][j - 1]);
            depc[ids[i][j - 1]]++;
        }
    }
    vector<int> ans;
    set<pair<int, int>> deps;
    for (int i = 0; i < n - 1; i++) {
        deps.insert({depc[i], i});
    }
    while (deps.size() > 0) {
        auto [dp, v] = *deps.begin();
        deps.erase(*deps.begin());
        if (dp != 0) {
            cout << "No";
            return 0;
        }
        ans.push_back(v);
        for (auto u : dep[v]) {
            deps.erase({depc[u], u});
            depc[u]--;
            deps.insert({depc[u], u});
        }
    }
    cout << "Yes" << '\n';
    for (auto i : ans) {
        cout << i + 1 << " ";
    } cout << '\n';
    return 0;
}
