#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5;
const int INF = 2e9;
const int mod = 1e9 + 7;

struct Edge {
    int to, w, idx;
};
vector<vector<Edge>> g(N);
vector<vector<int>> c(N), ord_edges(N);
vector<set<pair<int, int>>> rem(N);

vector<vector<int>> g_e(N);
vector<int> used(N), order;
bool dfs(int v, int p, Edge ep) {
    for (Edge e : g[v]) {
        if (p != e.to) {
            if (!dfs(e.to, v, e)) {
                return false;
            }
        }
    }
    if (p != -1) {
        auto lol = *rem[v].begin();
        int c1 = lol.first;
        int idx = lol.second;
        ord_edges[v][idx] = ep.idx;
        auto it = rem[p].lower_bound({ ep.w - c1, 0 });
        if (it == rem[p].end()) {
            return false;
        }
        idx = (*it).second;
        rem[p].erase(it);
        ord_edges[p][idx] = ep.idx;
    }
    return true;
}



void dfs_e(int v) {
    used[v] = 1;
    for (int to : g_e[v]) {
        if (used[to] == 0) {
            dfs_e(to);
        }
    }
    order.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, group;
    cin >> n >> group;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({ v, w, i });
        g[v].push_back({ u, w, i });
    }
    
    
    for (int v = 0; v < n; v++) {
        for (int i = 0; i < g[v].size(); i++) {
            int x;
            cin >> x;
            c[v].push_back(x);
            rem[v].insert({ x, i });
        }
        ord_edges[v].resize(g[v].size());
    }
    if (!dfs(0, -1, { 0, 0, 0 })) {
        cout << "No";
    }
    else {
        cout << "Yes\n";
        for (int v = 0; v < n; v++) {
            for (int i = 1; i < g[v].size(); i++) {
                g_e[ord_edges[v][i - 1]].push_back(ord_edges[v][i]);
            }
        }
        for (int i = 0; i < n - 1; i++) {
            if (used[i] == 0) {
                dfs_e(i);
            }
        }
        //reverse(order.begin(), order.end());
        for (int e : order) {
            cout << e + 1 << ' ';
        }
    }
    
    
}
