#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair<int, int>;

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

void g1(int n, const vector<tuple<int, int, int> > &edges, const vector<vector<int> > &cost) {
    vector<int> p(n - 1);
    iota(all(p), 0);
    do {
        auto v = cost;
        bool f = true;
        for (auto id: p) {
            auto [a, b, w] = edges[id];
            int sc = v[a].back() + v[b].back();
            if (sc < w) {
                f = false;
                break;
            }
            v[a].pop_back();
            v[b].pop_back();
        }
        if (f) {
//            reverse(all(p));
            cout << "Yes\n";
            for (auto i: p) {
                cout << i + 1 << " ";
            }
            return;
        }
    } while (next_permutation(all(p)));
    cout << "No";
}

constexpr int INF = 1e9;

void bamboo(int n, const vector <tuple <int, int, int> >& edges, vector <vector <int> > cost) {
    vector <array <int, 2> > dp(n);
    dp[n - 2][0] = (cost[n - 2][1] + cost[n - 1][0] >= get<2>(edges.back()));
    dp[n - 2][1] = (cost[n - 2][0] + cost[n - 1][0] >= get<2>(edges.back()));
    for (int i = n - 3; i > 0; --i) {
        for (int j = 0; j < 2; ++j) {
            for (int k = 0; k < 2; ++k) {
                int w = get<2>(edges[i]);
                if (w <= cost[i][j] + cost[i + 1][k]) {
                    dp[i][j] |= dp[i + 1][1 - k];
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        reverse(all(cost[i]));
    }
    vector <int> path(n - 1);
    {
        int w = get<2>(edges[0]);
        if (w <= cost[0][0] + cost[1][0] && dp[1][1]) {
        } else if (w <= cost[0][0] + cost[1][1] && dp[1][0]) {
            path[0] = 1;
        } else {
            cout << "No\n";
            return;
        }
    }
    int cur = 1 - path[0];
    for (int i = 1; i + 1 < n - 1; ++i) {
        int w = get<2>(edges[i]);
        if (w <= cost[i][cur] + cost[i + 1][0] && dp[i + 1][1]) {
            path[i] = 0;
        } else {
            path[i] = 1;
        }
        cur = 1 - path[i];
    }
    vector <int> cnt(n, 0);
//    for (int i = 1; i + 1 < n; ++i) {
//        cnt[i] = 1;
//    }
    vector <int> type(n - 1);
    for (int i = 1; i + 1 < n - 1; ++i) {
        type[i] = ((1 - path[i - 1]) << 1) | (path[i]);
    }
    type[0] = path[0];
    type.back() = (1 - path[n - 3]) * 2;
    queue <int> q;
    auto check = [&](int i) {
        if (i < 0 || i >= n - 1) {
            return false;
        }
        if ((type[i] >> 1 & 1) == cnt[i]
            && (type[i] >> 0 & 1) == cnt[i + 1]) {
            return true;
        }
        return false;
    };
    for (int i = 0; i < n - 1; ++i) {
        if (check(i)) {
            q.push(i);
        }
    }
    vector <int> ord;
    while (!q.empty()) {
        cur = q.front();
        q.pop();
        ord.push_back(cur);
        ++cnt[cur];
        ++cnt[cur + 1];
        if (check(cur - 1)) {
            q.push(cur - 1);
        }
        if (check(cur + 1)) {
            q.push(cur + 1);
        }
    }
    cout << "Yes\n";
    for (auto i : ord) {
        cout << i + 1 << " ";
    }
}

void ezhik(int n, const vector <tuple <int, int, int> >& edges, const vector <vector <int> >& cost) {
    set <pii> edg;
    for (int i = 0; i + 1 < n; ++i) {
        auto [a, b, w] = edges[i];
        int c = (a == 0 ? cost[b][0] : cost[a][0]);
        edg.insert({w - c, i});
    }
    vector <int> ord;
    for (int i = 0; i < sz(cost[0]); ++i) {
        auto it = edg.upper_bound(pii{cost[0][i], n});
        if (it == edg.begin()) {
            cout << "No\n";
            return;
        }
        --it;
        ord.push_back(it->second);
        edg.erase(it);
    }
    reverse(all(ord));
    cout << "Yes\n";
    for (auto i : ord) {
        cout << i + 1 << " ";
    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, GROUP;
    cin >> n >> GROUP;
    vector<tuple<int, int, int> > edges(n - 1);
    vector<vector<int> > cost(n);
    vector<int> deg(n);
    for (auto &[a, b, c]: edges) {
        cin >> a >> b >> c;
        --a, --b;
        ++deg[a], ++deg[b];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int cv;
            cin >> cv;
            cost[i].push_back(cv);
        }
    }
    if (n == 2) {
        if (cost[0][0] + cost[1][0] >= get<2>(edges[0])) {
            cout << "Yes\n1";
        } else {
            cout << "No";
        }
        return 0;
    }
    bamboo(n, edges, cost);
    return 0;
    if (GROUP <= 1) {
        g1(n, edges, cost);
    } else if (GROUP == 3) {
        ezhik(n, edges, cost);
    } else {
        bamboo(n, edges, cost);
    }
}