#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair<int, int>;

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

void g1(int n, const vector<tuple<int, int, int> > &edges, const vector<vector<int> > &cost) {
    vector<int> p(n - 1);
    iota(all(p), 0);
    do {
        auto v = cost;
        bool f = true;
        for (auto id: p) {
            auto [a, b, w] = edges[id];
            int sc = v[a].back() + v[b].back();
            if (sc < w) {
                f = false;
                break;
            }
            v[a].pop_back();
            v[b].pop_back();
        }
        if (f) {
//            reverse(all(p));
            cout << "Yes\n";
            for (auto i: p) {
                cout << i + 1 << " ";
            }
            return;
        }
    } while (next_permutation(all(p)));
    cout << "No";
}

constexpr int INF = 1e9;

void bamboo(int n, const vector <tuple <int, int, int> >& edges, vector <vector <int> > cost) {
    vector <array <int, 2> > dp(n);
    dp[n - 2][0] = (cost[n - 2][0] + cost[n - 1][0] >= get<2>(edges.back()));
    dp[n - 2][1] = (cost[n - 2][1] + cost[n - 1][0] >= get<2>(edges.back()));
    for (int i = n - 3; i > 0; --i) {
        for (int j = 0; j < 2; ++j) {
            for (int k = 0; k < 2; ++k) {
                int w = get<2>(edges[i]);
                if (w <= cost[i][j] + cost[i + 1][k]) {
                    dp[i][j] |= dp[i + 1][1 - k];
                }
            }
        }
    }
    vector <int> path(n - 1);
    {
        int w = get<2>(edges[0]);
        if (w <= cost[0][0] + cost[1][0] && dp[1][1]) {
        } else if (w <= cost[0][0] + cost[1][1] && dp[1][0]) {
            path[0] = 1;
        } else {
            cout << "No\n";
            return;
        }
    }
    int cur = 1 - path[0];
    for (int i = 1; i + 1 < n - 1; ++i) {
        int w = get<2>(edges[i]);
        if (w <= cost[i][cur] + cost[i + 1][0] && dp[i + 1][1]) {
            path[i] = 0;
        } else {
            path[i] = 1;
        }
        cur = 1 - path[i];
    }
    vector <int> ord;
    function <void(int, int)> solve = [&](int id, int cur) {
        if (id == n - 2) {
            ord.push_back(id);
            return;
        }
        if (cur) {
            ord.push_back(id);
        }
        solve(id + 1, path[id + 1]);
        if (!cur) {
            ord.push_back(id);
        }
    };
    solve(0, path[0]);
    cout << "Yes\n";
    for (auto i : ord) {
        cout << i + 1 << " ";
    }
}

void ezhik(int n, const vector <tuple <int, int, int> >& edges, const vector <vector <int> >& cost) {
    set <pii> edg;
    for (int i = 0; i + 1 < n; ++i) {
        auto [a, b, w] = edges[i];
        int c = (a == 0 ? cost[b][0] : cost[a][0]);
        edg.insert({w - c, i});
    }
    vector <int> ord;
    for (int i = 0; i < sz(cost[0]); ++i) {
        auto it = edg.upper_bound(pii{cost[0][i], n});
        if (it == edg.begin()) {
            cout << "No\n";
            return;
        }
        --it;
        ord.push_back(it->second);
        edg.erase(it);
    }
    reverse(all(ord));
    cout << "Yes\n";
    for (auto i : ord) {
        cout << i + 1 << " ";
    }
}

void group568(int n, vector <tuple <int, int, int> > edges, const vector <vector <int> >& cost) {
    vector <vector <pii> > g(n);
    for (auto [a, b, w] : edges) {
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
    }
    map <pii, int> edgeid;
    for (int i = 0; i + 1 < n; ++i) {
        auto [a, b, w] = edges[i];
        edgeid[{a, b}] = edgeid[{b, a}] = i;
    }
    vector <int> color(n);
    vector <vector <int> > vid(n);
    vector <vector <int> > g2(2 * n - 2);
    function <void(int, int)> paint = [&](int cur, int par) {
        for (auto [to, w] : g[cur]) {
            if (to != par) {
                color[to] = color[cur] ^ 1;
                paint(to, cur);
            }
        }
    };
    paint(0, -1);
    vector <int> deg(n);
    int ptr = 0;
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            deg[i] = sz(cost[i]);
            vid[i].resize(deg[i]);
            for (int j = 0; j < deg[i]; ++j) {
                vid[i][j] = ptr++;
            }
        }
    }
    int mxl = ptr;
    for (int i = 0; i < n; ++i) {
        if (color[i] == 1) {
            deg[i] = sz(cost[i]);
            vid[i].resize(deg[i]);
            for (int j = 0; j < deg[i]; ++j) {
                vid[i][j] = ptr++;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            for (int t = 0; t < deg[i]; ++t) {
                for (int k = 0; k < deg[j]; ++k) {
                    if (cost[i][t] + cost[j][k] >= w) {
                        g2[vid[i][t]].push_back(vid[j][k]);
                    }
                }
            }
        }
    }
    int m = 2 * n - 2;
    vector <int> mt(m, -1);
    vector <int> used(m);
    int timer = 1;
    function <bool(int)> kuhn = [&](int cur) {
        if (used[cur] == timer) {
            return false;
        }
        used[cur] = timer;
        for (auto to : g2[cur]) {
            if (mt[to] == -1) {
                mt[to] = cur;
                return true;
            }
        }
        for (auto to : g2[cur]) {
            if (kuhn(mt[to])) {
                mt[to] = cur;
                return true;
            }
        }
        return false;
    };
    for (int i = 0; i < mxl; ++i) {
        if (kuhn(i)) {
            ++timer;
        }
    }
    vector <int> cptr(n);
    vector <pii> tm(n - 1);
    for (int i = mxl; i < m; ++i) {
        if (mt[i] == -1) {
            cout << "No\n";
            return;
        }
    }
    vector <pii> pos(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            pos[vid[i][j]] = {i, j};
        }
    }
    for (int i = mxl; i < m; ++i) {
        auto [i1, j1] = pos[mt[i]];
        auto [i2, j2] = pos[i];
        int ed = edgeid[{i1, i2}];
        auto [a, b, w] = edges[ed];
        if (a != i1) {
            swap(get<0>(edges[ed]), get<1>(edges[ed]));
        }
        tm[ed] = {j1, j2};
    }
    vector <vector <int> > roflan(n);
    for (int i = 0; i < n; ++i) {
        roflan[i].resize(deg[i]);
    }
    for (int i = 0; i + 1 < n; ++i) {
        auto [a, b, w] = edges[i];
        roflan[a][tm[i].first] = i;
        roflan[b][tm[i].second] = i;
    }
    vector <bool> us(n - 1);
    auto check = [&](int ed) {
        if (us[ed]) {
            return false;
        }
        auto [a, b, w] = edges[ed];
        auto [i, j] = tm[ed];
        if (i == cptr[a] && j == cptr[b]) {
            return true;
        }
        return false;
    };
    queue <int> q;
    for (int i = 0; i < n - 1; ++i) {
        if (check(i)) {
            q.push(i);
            us[i] = true;
        }
    }
    auto upd = [&](int vertex) {
        if (cptr[vertex] < deg[vertex]) {
            if (check(roflan[vertex][cptr[vertex]])) {
                q.push(roflan[vertex][cptr[vertex]]);
                us[roflan[vertex][cptr[vertex]]] = true;
            }
        }
    };
    vector <int> ord;
    while (!q.empty()) {
        auto cur = q.front();
        q.pop();
        ord.push_back(cur);
        auto [a, b, w] = edges[cur];
        ++cptr[a], ++cptr[b];
        upd(a);
        upd(b);
    }
    reverse(all(ord));
    cout << "Yes\n";
    for (auto i : ord) {
        cout << i + 1 << " ";
    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, GROUP;
    cin >> n >> GROUP;
    vector<tuple<int, int, int> > edges(n - 1);
    vector<vector<int> > cost(n);
    vector<int> deg(n);
    for (auto &[a, b, c]: edges) {
        cin >> a >> b >> c;
        --a, --b;
        ++deg[a], ++deg[b];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int cv;
            cin >> cv;
            cost[i].push_back(cv);
        }
    }
    if (n == 2) {
        if (cost[0][0] + cost[1][0] >= get<2>(edges[0])) {
            cout << "Yes\n1";
        } else {
            cout << "No";
        }
        return 0;
    }
    if (GROUP == 3) {
        ezhik(n, edges, cost);
    } else if (GROUP == 2) {
        bamboo(n, edges, cost);
    } else {
        group568(n, edges, cost);
    }
}