#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

void solve_nf(int n, const vector<tii>& ed, const vector<vector<int>>& a) {
    vector<vector<pii>> g(n);
    for (auto& [u, v, w] : ed) {
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }

    vector<int> p(n);
    iota(all(p), 0);

    int f = 1;
    for (int i = 1; i < n; ++i)
        f *= i;

    while (f--) {
        vector<int> it(n);
        for (int i = 0; i < n; ++i)
            it[i] = a[i].size() - 1;

        bool flag = 1;
        for (int i = 0; flag && i < n - 1; ++i) {
            auto [u, v, w] = ed[p[i]];
            if (w > a[u][it[u]] + a[v][it[v]])
                flag = 0;
        }

        if (flag) {
            cout << "Yes" << endl;
            for (auto i : p)
                cout << i + 1 << " ";
            cout << endl;
            return;
        }

        next_permutation(all(p));
    }

    cout << "No" << endl;
}

bool dfs(int v, int t, vector<int>& used, vector<int>& to, const vector<vector<int>>& g) {
    used[v] = t;
    for (auto u : g[v])
        if (to[u] == -1) {
            to[u] = v;
            return 1;
        }
    for (auto u : g[v])
        if (used[to[u]] != t && dfs(to[u], t, used, to, g)) {
            to[u] = v;
            return 1;
        }
    return 0;
}

vector<int> kun(const vector<vector<int>>& g, int n, int m) {
    vector<int> used(n, -1), to(m, -1);
    for (int i = 0; i < n; ++i)
        dfs(i, i, used, to, g);
    return to;
    /*
    int ans = 0;
    for (auto i : to)
        ans += i > -1;
    return ans;
     */
}

void get_d(int v, int p, const vector<vector<pii>>& g, vector<int>& d) {
    d[v] = v == p ? 0 : d[p] + 1;
    for (auto [u, w] : g[v])
        if (u != p)
            get_d(u, v, g, d);
}

void solve_kun(int n, const vector<tii>& ed, const vector<vector<int>>& a) {
    vector<vector<pii>> g(n);
    for (auto& [u, v, w] : ed) {
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }

    int cnt = 0;
    vector<vector<int>> id(n);
    for (int i = 0; i < n; ++i) {
        id[i].assign(g[i].size(), 0);
        for (int j = 0; j < g[i].size(); ++j)
            id[i][j] = cnt++;
    }

    vector<int> vrt(cnt);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < g[i].size(); ++j)
            vrt[id[i][j]] = i;

    vector<vector<int>> g1(2 * n - 2);
    int it = 0;
    for (auto [u, v, w] : ed) {
        for (int i = 0; i < g[u].size(); ++i)
            for (int j = 0; j < g[v].size(); ++j)
                if (w <= a[u][i] + a[v][j]) {
                    g1[it].push_back(id[v][j]);
                    g1[it].push_back(id[u][i]);
                    g1[it + 1].push_back(id[v][j]);
                    g1[it + 1].push_back(id[u][i]);
                }
        it += 2;
    }

    for (auto& i : g1) {
        sort(all(i));
        i.resize(unique(all(i)) - i.begin());
    }

    auto to = kun(g1, 2 * n - 2, cnt);
    /*
    for (auto i : to)
        cout << i << " ";
    cout << endl;
    */
    vector<int> tr(2 * n - 2, -1);
    for (int i = 0; i < cnt; ++i) 
        if (to[i] > -1) 
            tr[to[i]] = i;
    for (auto i : tr)
        if (i == -1) {
            cout << "No" << endl;
            return;
        }

    vector<vector<int>> ed1(n - 1);
    for (int i = 0; i < cnt; ++i)
        ed1[to[i] / 2].push_back(i);

    vector<vector<int>> vec(n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < g[i].size(); ++j)
            vec[i].push_back(to[id[i][j]] / 2);

    vector<int> ans;
    set<int> s;
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        s.insert(vec[i][0]);
        pos[i] = g[i].size() - 1;
    }

    while (ans.size() < n - 1) {
        for (int i = 0; i < n - 1; ++i) {
            auto [u,v,w] = ed[i];
            if (vec[u][pos[u]] == i && vec[v][pos[v]] == i) {
                ans.push_back(i);
                --pos[u];
                --pos[v];
                break;
            }
        }
    }

    cout << "Yes" << endl;
    for (auto i : ans)
        cout << i + 1 << " ";
    cout<<endl;
}

void solve() {
    int n, gr;
    cin >> n >> gr;
    vector<tii> ed(n - 1);
    vector<vector<pii>> g(n);
    for (auto& [u, v, w] : ed) {
        cin >> u >> v >> w, --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].assign(g[i].size(), 0);
        for (auto& j : a[i])
            cin >> j;
    }

    if (gr == 1)
        solve_nf(n, ed, a);
    else
        solve_kun(n, ed, a);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}