#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, group;
    cin >> n >> group;

    vector<pair<Edge, int>> edges;
    vector<int> count(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, pw;
        cin >> u >> v >> pw;

        count[u - 1]++;
        count[v - 1]++;
        edges.push_back({{u - 1, v - 1, pw}, i});
    }

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < count[i]; ++j) {
            int num;
            cin >> num;

            a[i].push_back(num);
        }

        std::reverse(a[i].begin(), a[i].end());
    }

    if (group <= 1) {
        std::sort(edges.begin(), edges.end());

        do {
            vector<vector<int>> acopy = a;
            bool flag = true;
            for (auto [edge, id]: edges) {
                if (a[edge.u].back() + a[edge.v].back() < edge.pw){
                    flag = false;
                }
                a[edge.u].pop_back();
                a[edge.v].pop_back();
            }
            a = acopy;

            if (!flag) continue;
            cout << "Yes" << "\n";
            for (auto [edge, id]: edges){
                cout << id + 1 << " ";
            }
            return 0;
        } while (std::next_permutation(edges.begin(), edges.end()));

        cout << "No" << "\n";
        return 0;
    }
    assert(false);
}