#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw, id;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, group;
    cin >> n >> group;

    vector<Edge> edges;
    vector<int> count(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, pw;
        cin >> u >> v >> pw;

        count[u - 1]++;
        count[v - 1]++;
        edges.push_back({u - 1, v - 1, pw, i});
    }

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < count[i]; ++j) {
            int num;
            cin >> num;

            a[i].push_back(num);
        }
    }

    if (group <= 1) {
        std::sort(edges.begin(), edges.end());

        do {
            vector<vector<int>> acopy = a;
            bool flag = true;
            for (auto [u, v, pw, id]: edges) {
                if (a[u].back() + a[v].back() < pw) {
                    flag = false;
                }
                a[u].pop_back();
                a[v].pop_back();
            }
            a = acopy;

            if (!flag) continue;
            cout << "Yes" << "\n";
            for (auto [u, v, pw, id]: edges) {
                cout << id + 1 << " ";
            }
            return 0;
        } while (std::next_permutation(edges.begin(), edges.end()));

        cout << "No" << "\n";
        return 0;
    } else if (group == 2) {
        vector<int> order(n - 1);
        for (int i = 0; i < n - 2; ++i) {
            bool can1 = (a[i].back() + a[i + 1][0] >= edges[i].pw); // second
            bool can2 = a[i + 1].size() > 1 && (a[i].back() + a[i + 1][1] >= edges[i].pw); // first

            if (can1 && can2) {
                if (a[i + 1][0] < a[i + 1][1]) {
                    order[i] = 1;
                    a[i + 1].erase(a[i + 1].begin());
                } else {
                    order[i] = 0;
                    a[i + 1].pop_back();
                }
            } else if (can1) {
                order[i] = 1;
                a[i + 1].erase(a[i + 1].begin());
            } else if (can2) {
                order[i] = 0;
                a[i + 1].pop_back();
            } else {
                cout << "No" << "\n";
                return 0;
            }
        }

        cout << "Yes" << "\n";
        function<void(int)> answer = [&](int v) {
            if (order[v] == 0) cout << v + 1 << " ";
            if (v + 1 != n - 1) answer(v + 1);
            if (order[v] == 1) cout << v + 1 << " ";
        };
        answer(0);
        return 0;
    } else if (group == 3) {
        vector<pair<int, int>> vals;
        for (int i = 0; i < n - 1; ++i) {
            vals.emplace_back(edges[i].pw - a[edges[i].v].back(), i);
        }
        std::sort(vals.begin(), vals.end());

        vector<pair<int, int>> vs;
        for (int i = 0; i < n - 1; ++i) vs.emplace_back(a[0][i], n - i - 2);

        std::sort(vs.begin(), vs.end());

        vector<int> ans(n - 1);
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {
            if (vs[i].first < vals[i].first) flag = false;
            ans[vs[i].second] = vals[i].second;
        }

        if (!flag) {
            cout << "No" << '\n';
            return 0;
        }
        cout << "Yes" << "\n";
        for (int i = 0; i < n - 1; ++i) {
            cout << ans[i] + 1 << " ";
        }


        return 0;
    } else if (group == 4) {
        vector<Edge> edg0, edg1;
        vector<vector<int>> can0, can1; // val, used, id
        for (int i = 0; i < n - 1; ++i) {
            if (edges[i].u == 0 && edges[i].v != 1) edg0.push_back(edges[i]);
            if (edges[i].u == 1 && edges[i].v != 0) edg1.push_back(edges[i]);
        }

        for (int i = 0; i < a[0].size(); i++) can0.push_back({a[0][i], false, i});
        for (int i = 0; i < a[1].size(); i++) can1.push_back({a[1][i], false, i});

        std::sort(can0.begin(), can0.end());
        std::sort(can1.begin(), can1.end());

        vector<int> ans(n - 1, -1);
        for (auto edg: edg0) {
            int need = edg.pw - a[edg.v][0];
            int minn = -1;
            for (int i = 0; i < can0.size(); ++i) {
                if (can0[i][1] || can0[i][0] < need) continue;
                if (minn == -1 || can0[i][0] < can0[minn][0]) minn = i;
            }
            if (minn == -1) {
                cout << "No" << "\n";
                return 0;
            }
            can0[minn][1] = true;
            ans[edg.id] = can0[minn][2];
        }
        for (auto edg: edg1) {
            int need = edg.pw - a[edg.v][0];
            int minn = -1;
            for (int i = 0; i < can1.size(); ++i) {
                if (can1[i][1] || can1[i][0] < need) continue;
                if (minn == -1 || can1[i][0] < can1[minn][0]) minn = i;
            }
            if (minn == -1) {
                cout << "No" << "\n";
                return 0;
            }
            can1[minn][1] = true;
            ans[edg.id] = can1[minn][2];
        }

        vector<int> used0(can0.size());
        vector<int> used1(can1.size());
        vector<int> par0(can0.size());
        vector<int> par1(can1.size());
        for (int i = 1; i < n; i++) {
            if (edges[i].u == 0 && edges[i].v != 1) par0[ans[i]] = i;
            if (edges[i].u == 1 && edges[i].v != 0) par1[ans[i]] = i;
        }
        for (int i = 0; i < can0.size(); i++) used0[can0[i][2]] = can0[i][1];
        for (int i = 0; i < can1.size(); i++) used1[can1[i][2]] = can1[i][1];

        int l = 0;
        int r = 0;
        while (used0[l]) l++;
        while (used1[r]) r++;

        if (a[0][l] + a[1][r] < edges[0].pw){
            cout << "No" << "\n";
            return 0;
        }

        cout << "Yes" << "\n";
        for (int i = 0; i < l; ++i) {
            cout << par0[i] + 1 << " ";
        }
        for (int i = 0; i < r; ++i) {
            cout << par1[i] + 1 << " ";
        }
        cout << 1 << " ";
        for (int i = l + 1; i < par0.size(); ++i) {
            cout << par0[i] + 1 << " ";
        }
        for (int i = r + 1; i < par1.size(); ++i) {
            cout << par1[i] + 1 << " ";
        }
    }
}