#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw, id;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, group;
    cin >> n >> group;

    vector<Edge> edges;
    vector<vector<pair<int, int>>> g(n);
    vector<int> count(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, pw;
        cin >> u >> v >> pw;

        if (u > v) swap(u, v);

        count[u - 1]++;
        count[v - 1]++;
        g[u - 1].emplace_back(v - 1, i);
        g[v - 1].emplace_back(u - 1, i);
        edges.push_back({u - 1, v - 1, pw, i});
    }

    vector<vector<pair<int, int>>> a(n);
    vector<vector<int>> par(n);
    for (int i = 0; i < n; ++i) {
        par[i].resize(count[i]);
        for (int j = 0; j < count[i]; ++j) {
            int num;
            cin >> num;

            a[i].emplace_back(num, j);
        }
        std::sort(a[i].begin(), a[i].end());
    }
    auto acopy = a;

    deque<int> q;
    for (int i = 0; i < n; ++i) if (a[i].size() == 1) q.push_back(i);

    vector<pair<int, int>> ans(n - 1);
    vector<int> used(n);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        used[v] = true;
        int edge = -1;
        for (auto [u, id]: g[v]) if (!used[u]) edge = id;

        if (edge == -1) continue;

        int u = (edges[edge].u ^ edges[edge].v) ^ v;
        int first = -1;
        int fv = 1e9;
        for (auto [val, id]: a[u]) {
            if (val < edges[edge].pw - a[v].back().first) continue;
            if (first == -1 || fv > val) {
                first = id;
                fv = val;
            }
        }

        if (first == -1) {
            cout << "No" << "\n";
            return 0;
        }

        ans[edge] = {first, a[v].front().second};
        if (u > v) swap(ans[edge].first, ans[edge].second);

        par[u][first] = edge;
        par[v][a[v].front().second] = edge;

        a[u].erase(std::find(a[u].begin(), a[u].end(), make_pair(fv, first)));
        a[v].erase(a[v].begin());

        if (a[u].size() == 1)q.push_back(u);
    }

    a = acopy;
    
    cout << "Yes" << "\n";
    vector<int> usedE(n - 1);
    for (int j = 0; j < n - 1; ++j) {
        for (int i = 0; i < n - 1; ++i) {
            if (usedE[i]) continue;
            int level1 = ans[i].first;
            int level2 = ans[i].second;
            if (a[edges[i].u].size() == level1 + 1 &&
                a[edges[i].v].size() == level2 + 1) {
                cout << i + 1 << " ";
                a[edges[i].u].pop_back();
                a[edges[i].v].pop_back();
                usedE[i] = true;
                break;
            }
        }
    }
}