#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw, id;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, group;
    cin >> n >> group;

    vector<Edge> edges;
    vector<vector<pair<int, int>>> g(n);
    vector<int> count(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, pw;
        cin >> u >> v >> pw;

        if (u > v) swap(u, v);

        count[u - 1]++;
        count[v - 1]++;
        g[u - 1].emplace_back(v - 1, i);
        g[v - 1].emplace_back(u - 1, i);
        edges.push_back({u - 1, v - 1, pw, i});
    }

    vector<vector<pair<int, int>>> aa(n);
    vector<set<pair<int, int>>> a(n);
    vector<vector<int>> par(n);
    for (int i = 0; i < n; ++i) {
        par[i].resize(count[i]);
        for (int j = 0; j < count[i]; ++j) {
            int num;
            cin >> num;

            aa[i].emplace_back(num, j);
            a[i].emplace(num, j);
        }
        a[i].insert({1e9 + 10, 1e9});
    }

    deque<int> q;
    for (int i = 0; i < n; ++i) if (a[i].size() == 2) q.push_back(i);

    vector<pair<int, int>> ans(n - 1);
    vector<int> used(n);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        used[v] = true;
        int edge = -1;
        for (auto [u, id]: g[v]) if (!used[u]) edge = id;

        if (edge == -1) continue;

        int u = (edges[edge].u ^ edges[edge].v) ^ v;
        int first = -1;
        int fv = 1e9;

        pair<int,int> vv = *a[u].lower_bound({edges[edge].pw - a[v].begin()->first, -1e9});
        fv = vv.first;
        first = vv.second;
        if (vv.first == 1e9 + 10) {
            cout << "No" << "\n";
            return 0;
        }

        ans[edge] = {first, a[v].begin()->second};
        if (u > v) swap(ans[edge].first, ans[edge].second);

        par[u][first] = edge;
        par[v][a[v].begin()->second] = edge;

        a[u].erase(make_pair(fv, first));
        a[v].erase(a[v].begin());

        if (a[u].size() == 2)q.push_back(u);
    }

    cout << "Yes" << "\n";
    deque<int> q2;
    vector<int> usedE(n - 1);
    vector<vector<int>> with1(n);
    for (int i = 0; i < n - 1; ++i) {
        int level1 = ans[i].first;
        int level2 = ans[i].second;
        if (aa[edges[i].u].size() == level1 + 1 &&
            aa[edges[i].v].size() == level2 + 1) {
            q2.push_back(i);
            usedE[i] = true;
        }
    }

    while (!q2.empty()) {
        int i = q2.front();
        q2.pop_front();

        cout << i + 1 << " ";
        aa[edges[i].u].pop_back();
        aa[edges[i].v].pop_back();

        {
            int u = edges[i].u;
            int v = edges[i].v;

            if (!aa[u].empty()) {
                int id = par[u][aa[u].size() - 1];
                int level1 = ans[id].first;
                int level2 = ans[id].second;

                if (usedE[id]) continue;

                if (aa[edges[id].u].size() == level1 + 1 &&
                    aa[edges[id].v].size() == level2 + 1) {
                    q2.push_back(id);
                    usedE[id] = true;
                }
            }
            if (!aa[v].empty()) {
                int id = par[v][aa[v].size() - 1];
                int level1 = ans[id].first;
                int level2 = ans[id].second;

                if (usedE[id]) continue;

                if (aa[edges[id].u].size() == level1 + 1 &&
                    aa[edges[id].v].size() == level2 + 1) {
                    q2.push_back(id);
                    usedE[id] = true;
                }
            }
        }
    }
}