#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

const int MAXN = 2e5 + 1;
vector<pair<ll, ll>> g[MAXN];
vector<ll> c[MAXN];
ll idx[MAXN], deg[MAXN];

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<tuple<ll, ll, ll>> e;
    e.push_back({0, 0, 0});
    for (int i = 1; i < n; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
        e.emplace_back(a, b, w);
        deg[a]++, deg[b]++;
    }
    for (int i = 1; i <= n; ++i) {
        c[i].resize(deg[i]);
        cin >> c[i];
    }
    if (group <= 1) {
        vector<ll> p(n - 1);
        iota(p.begin(), p.end(), 1);
        do {
            fill(idx, idx + n + 1, 0);
            bool ok = true;
            for (int i = 0; i < n - 1; ++i) {
                auto [a, b, w] = e[p[i]];
                if (w > c[a][idx[a]] + c[b][idx[b]]) {
                    ok = false;
                    break;
                }
                idx[a]++;
                idx[b]++;
            }
            if (ok) {
                cout << "Yes\n";
                for (int i = sz(p) - 1; i >= 0; --i) {
                    cout << p[i] << ' ';
                }
                return;
            }
        } while (next_permutation(p.begin(), p.end()));
        return void(cout << "No");
    } else if (group == 3) {
        vector<ll> p(n - 1);
        iota(p.begin(), p.end(), 1);
        sort(p.begin(), p.end(), [&](ll a, ll b) {
            auto [a1, b1, w1] = e[a];
            auto [a2, b2, w2] = e[b];
            return w1 - c[b1][0] < w2 - c[b2][0];
        });
        vector<pair<ll, ll>> help(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            help[i] = {c[1][i], i};
        }
        sort(help.begin(), help.end());
        vector<ll> ans(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            ans[help[i].second] = p[i];
        }
        bool ok = true;
        for (int i = 0; i < n - 1; ++i) {
            auto [a, b, w] = e[ans[i]];
            if (w > c[a][idx[a]] + c[b][idx[b]]) {
                ok = false;
                break;
            }
            idx[a]++;
            idx[b]++;
        }
        if (ok) {
            cout << "Yes\n";
            reverse(ans.begin(), ans.end());
            for (int i = 0; i < n - 1; ++i) {
                cout << ans[i] << ' ';
            }
            return;
        }
        cout << "No";
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
