#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9, MAXN = (1 << 18), mod = 1e9 + 7, P = 1073;
mt19937 rnd(1337);

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) ans *= n;
        ans %= mod;
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

struct Point{
    long double x, y;
    Point() {
        x = 0;
        y = 0;
    }
    Point(long double xx, long double yy) {x = xx, y = yy;}
    long double operator*(const Point &b) {return x * b.x + y * b.y;}
};

vector<int> g[MAXN], num[MAXN];
vector<int> w[MAXN];
vector<int> cost[MAXN];
vector<pair<int, int>> por[MAXN];
bool ok = true;
int dfs(int v, int p) {
    if (!ok) return 0;
//    cout << v << '\n';
    int parent = -1;
    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i], c = w[v][i];
        if (u == p) {
            parent = i;
            continue;
        }
        int k = dfs(u, v);
//        cout << k << '\n';
        c -= k;
        int ma = INF, pos = -1;
        for (int j = 0; j < cost[v].size(); j++) {
            if (cost[v][j] >= c && cost[v][j] < ma) {
                ma = cost[v][j];
                pos = j;
            }
        }
        if (pos == -1) {
            ok = false;
            return 0;
        }
        cost[v][pos] = INF;
        por[v].push_back({-pos, i});
    }
    for (int i = 0; i < cost[v].size(); i++) {
        if (cost[v][i] != INF) {
            if (p != -1)
                por[v].push_back({-i, parent});
            if (p == -1) {
                ok = false;
                return 0;
            }
            return cost[v][i];
        }
    }
    if (p != -1) {
        ok = false;
    }
    return 0;
}

void printdfs(int v, int p) {
//    cout << v + 1 << '\n';
    sort(por[v].begin(), por[v].end());
//    for (int i = 0; i < por[v].size(); i++) {
//        int u = g[v][por[v][i].second];
//        cout << u + 1 << ' ';
//    }
//    cout << '\n';
    for (int i = 0; i < por[v].size(); i++) {
        int u = g[v][por[v][i].second];
        if (u == p) {
            cout << num[v][por[v][i].second] << ' ';
        }
        if (u != p) {
            printdfs(u, v);
        }
    }
}

void solve() {
   int n, group;
   cin >> n >> group;
   vector<int> deg(n, 0);
   for (int i = 1; i < n; i++) {
       int u, v, c;
       cin >> u >> v >> c;
       u--, v--;
       deg[v]++;
       deg[u]++;
       g[u].push_back(v);
       g[v].push_back(u);
       w[u].push_back(c);
       w[v].push_back(c);
       num[u].push_back(i);
       num[v].push_back(i);
   }

    for (int i = 0; i < n; i++) {
        while (deg[i]--) {
            int c;
            cin >> c;
            cost[i].push_back(c);
        }
    }
    dfs(0, -1);
    if (!ok) {
        cout << "No";
        return;
    }
   cout << "Yes" << '\n';
   printdfs(0, -1);
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    int test = 1;
    //cin >> test;
    while (test--) solve();
}
