#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<pair<pair<ll, ll>, ll>> edges;
set<pair<int, int>> have[MAXN];
vector<bool> used[MAXN];
vector<ll> ord;
vector<int> g[MAXN];

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    map<pair<int, int>, int> mp;
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        mp[{u, v}] = i;
        mp[{v, u}] = i;
        g[u].emplace_back(i);
        g[v].emplace_back(i);
        deg[u]++, deg[v]++;
        edges.emplace_back(make_pair(u, v), w);
    }
    for (ll i = 0; i < n; ++i) {
        used[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            int x;
            cin >> x;
            have[i].insert({x, j});
        }
    }
    vector<int> lists;
    for (int i = 0; i < n; ++i) {
        if ((int)have[i].size() == 1) {
            lists.emplace_back(i);
        }
    }
    vector<pair<pair<int, int>, pair<int, int>>> ordkek;
    while (!lists.empty()) {
        int x = lists.back();
        lists.pop_back();
        for (int id_edge : g[x]) {
            int to = edges[id_edge].first.first;
            if (to == x) {
                to = edges[id_edge].first.second;
            }
            if (!have[to].empty()) {
                int w = edges[id_edge].second;
                int cur = have[x].begin()->first;
                auto it = have[to].lower_bound({w - cur, -1});
                if (it == have[to].end()) {
                    cout << "No" << '\n';
                    return;
                } else {
                    ordkek.emplace_back(make_pair(x, to), make_pair(have[x].begin()->second, it->second));
                    have[to].erase(it);
                    if ((int)have[to].size() == 1) {
                        lists.emplace_back(to);
                    }
                }
            }
        }
        have[x].clear();
    }
    cout << "Yes" << '\n';
    sort(ordkek.begin(), ordkek.end(), [&](pair<pair<int, int>, pair<int, int>> a, pair<pair<int, int>, pair<int, int>> b) {
        return a.second.second + a.second.first > b.second.second + b.second.first;
    });
    for (auto e : ordkek) {
        int a = e.first.first;
        int b = e.first.second;
        int orda = e.second.first;
        int ordb = e.second.second;
        ord.emplace_back(mp[{a, b}]);
    }
    for (int i : ord) {
        cout << i + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
