#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<pair<pair<ll, ll>, ll>> edges;
set<pair<ll, ll>> have[MAXN];
map<ll, vector<ll>> mpv[MAXN];
vector<bool> used[MAXN];
vector<ll> ord;
vector<ll> g[MAXN];

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    map<pair<ll, ll>, ll> mp;
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        mp[{u, v}] = i;
        mp[{v, u}] = i;
        g[u].emplace_back(i);
        g[v].emplace_back(i);
        deg[u]++, deg[v]++;
        edges.emplace_back(make_pair(u, v), w);
    }
    for (ll i = 0; i < n; ++i) {
        used[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            ll x;
            cin >> x;
            have[i].insert({x, j});
        }
    }
    vector<ll> lists;
    for (ll i = 0; i < n; ++i) {
        if ((ll)have[i].size() == 1) {
            lists.emplace_back(i);
        }
    }
    vector<pair<pair<ll, ll>, pair<ll, ll>>> ordkek;
    while (!lists.empty()) {
        ll x = lists.back();
        lists.pop_back();
        for (ll id_edge : g[x]) {
            ll to = edges[id_edge].first.first;
            if (to == x) {
                to = edges[id_edge].first.second;
            }
            if (!have[to].empty()) {
                ll w = edges[id_edge].second;
                ll cur = have[x].begin()->first;
                auto it = have[to].lower_bound({w - cur, -1});
                if (it == have[to].end()) {
                    cout << "No" << '\n';
                    return;
                } else {
                    ordkek.emplace_back(make_pair(x, to), make_pair(have[x].begin()->second + 1, it->second + 1));
                    have[to].erase(it);
                    if ((ll)have[to].size() == 1) {
                        lists.emplace_back(to);
                    }
                }
            }
        }
        have[x].clear();
    }
    cout << "Yes" << '\n';
    vector<ll> need(n - 1, 2);
    for (ll i = 0; i < n - 1; ++i) {
        mpv[ordkek[i].first.first][ordkek[i].second.first].emplace_back(i);
        mpv[ordkek[i].first.second][ordkek[i].second.second].emplace_back(i);
    }
    vector<pair<ll, ll>> ed;
    for (ll i = 0; i < n; ++i) {
        for (auto ind : mpv[i][deg[i]]) {
            need[ind]--;
            if (need[ind] == 0) {
                ed.emplace_back(ordkek[ind].first);
            }
        }
    }
    while (!ed.empty()) {
        auto [u, v] = ed.back();
        ed.pop_back();
        deg[u]--, deg[v]--;
        for (auto ind : mpv[u][deg[u]]) {
            need[ind]--;
            if (need[ind] == 0) {
                ed.emplace_back(ordkek[ind].first);
            }
        }
        for (auto ind : mpv[v][deg[v]]) {
            need[ind]--;
            if (need[ind] == 0) {
                ed.emplace_back(ordkek[ind].first);
            }
        }
        ord.emplace_back(mp[{u, v}]);
    }
    for (ll i : ord) {
        cout << i + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
