#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <iostream>
#include <cstdlib>
#include <cstdint>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <random>
#include <queue>
#include <chrono>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 2e5;
int n;
int group;
vector<int> c[N];

struct edge {
    int a, b, w;
    edge() {}
    edge(int a, int b, int w) : a(a), b(b), w(w) {}
};

edge edges[N - 1];
vector<pair<int, int>> g[N];
int ptr[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> group;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {a, b, w};
    }
    for (int i= 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); ++j) {
            cin >> c[i][j];
        }
    }
    if (group <= 1) {
            // WRONG NEED C[I][J] REVERSED
        vector<int> cur(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            cur[i] = i;
        }
        mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
        shuffle(all(cur), gen);
        do {
            memset(ptr, 0, sizeof(ptr));
            bool ok = true;
            for (int i = 0; i < n - 1; ++i) {
                int j = cur[i];
                int v = edges[j].a;
                int u = edges[j].b;
                if (ptr[v] == c[v].size() || ptr[u] == c[u].size() ||
                    edges[j].w > c[v][ptr[v]] + c[u][ptr[u]]) {
                    ok = false;
                    break;
                }
                ++ptr[v];
                ++ptr[u];
            }
            if (ok) {
                cout << "Yes\n";
                for (int x : cur) cout << x + 1 << " ";
                return 0;
            }
        } while (next_permutation(all(cur)));
        cout << "No\n";
    } else if (group == 3) {
        vector<pair<int, int>> ts(n - 1);
        for (auto& u : g[0]) {
            ts[u.second] = {edges[u.second].w - c[u.first][0], u.second};
        }
        sort(all(ts));
        vector<pair<int, int>> cs(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            cs[i] = {c[0][i], n - 1 - i - 1};
        }
        sort(all(cs));
        vector<pair<int, int>> num(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            if (cs[i].first < ts[i].first) {
                cout << "No\n";
                return 0;
            }
            num[ts[i].second] = {cs[i].second, ts[i].second};
        }
        cout << "Yes\n";
        sort(all(num));
        for (auto& x : num) {
            cout << x.second + 1 << " ";
        }
    }
}

/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3
*/
