#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const int INF = 2e9;
const int MAXN = 1e5 + 5;

using t3 = tuple<int, int, int>;

int n, g;
vector<t3> edges;
vector<vector<int>> c;

void solve01() {
    vector<int> tmp(n - 1);
    iota(tmp.begin(), tmp.end(), 0);

    for (int i = 0; i < n; ++i) {
        reverse(c[i].begin(), c[i].end());
    }
    
    do {
        vector<int> it(n, -1);
        int flag = 1;
        for (auto i : tmp) {
            auto [a, b, w] = edges[i];
            ++it[a], ++it[b];

            if (it[a] >= (int)(c[a].size())) {
                flag = 0;
                break;
            }
            if (it[b] >= (int)(c[b].size())) {
                flag = 0;
                break;
            }

            if (c[a][it[a]] + c[b][it[b]] < w) {
                flag = 0;
                break;
            }
        }

        if (flag) {
            cout << "Yes\n";
            for (int i = 0; i < n - 1; ++i) {
                cout << tmp[i] + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(tmp.begin(), tmp.end()));

    cout << "No\n";
}

void start() {
    cin >> n >> g;
    c.assign(n, {});
    edges.assign(n - 1, {});

    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        edges[i] = {a, b, w};
    }

    string razrab_huesos = "iyaegomatebal";
    int i = -1;
    while (getline(cin, razrab_huesos)) {
        //cout << razrab_huesos << '\n';
        int x = 0;
        for (auto X : razrab_huesos) {
            if ('0' <= X && X <= '9') {
                x *= 10;
                x += (X - '0');
            } else {
                c[i].push_back(x);
                x = 0;
            }
        }
        if (i >= 0) {
            c[i].push_back(x);
        }
        ++i;
    }

    solve01();
}

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    int T = 1;
#ifdef WIN32
    cin >> T;
#endif

// R.I.P. Alexei Navalny
// 1976-2024

    while (T --> 0) {
        start();
    }

    return 0;
}
