#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 2e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<ll, ll, ll>;

ll n, g;
vector<t3> edges;
vector<vector<ll>> c;

void solve01() {
    vector<ll> tmp(n - 1);
    iota(tmp.begin(), tmp.end(), 0);

    for (ll i = 0; i < n; ++i) {
        reverse(c[i].begin(), c[i].end());
    }

    do {
        vector<ll> it(n, -1);
        ll flag = 1;
        for (auto i : tmp) {
            auto [a, b, w] = edges[i];
            ++it[a], ++it[b];

            if (it[a] >= (ll)(c[a].size())) {
                flag = 0;
                break;
            }
            if (it[b] >= (ll)(c[b].size())) {
                flag = 0;
                break;
            }

            if (c[a][it[a]] + c[b][it[b]] < w) {
                flag = 0;
                break;
            }
        }

        if (flag) {
            cout << "Yes\n";
            for (ll i = 0; i < n - 1; ++i) {
                cout << tmp[i] + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(tmp.begin(), tmp.end()));

    cout << "No\n";
}

bool cmp(t3 a, t3 b) {
    return get<2>(a) < get<2>(b);
}

void solve3() {
    sort(edges.begin(), edges.end(), cmp);

    if ((ll)c[0].size() != n - 1) {
        cout << "No\n";
        return;
    }
    for (ll i = 1; i < n; ++i) {
        if ((ll)c[i].size() != 1) {
            cout << "No\n";
            return;
        }
    }
    
    reverse(c[0].begin(), c[0].end());
    vector<pair<ll, ll>> c0;
    for (ll i = 0; i < n - 1; ++i) {
        c0.emplace_back(c[0][i], i);
    }
    sort(c0.begin(), c0.end());

    for (ll i = 0; i < n - 1; ++i) {
        auto [a, b, w] = edges[i];

        if (c0[i].first + c[b][0] < w) {
            cout << "No\n";
            return;
        }
    }

    cout << "Yes\n";
    for (ll i = 0; i < n - 1; ++i) {
        cout << c0[i].second + 1 << ' ';
    }
    cout << '\n';
}

void start() {
    cin >> n >> g;
    c.assign(n, {});
    edges.assign(n - 1, {});

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        if (a > b) {
            swap(a, b);
        }
        edges[i] = {a, b, w};
    }

    string razrab_huesos = "iyaegomatebal";
    ll i = -1;
    while (getline(cin, razrab_huesos)) {
        //cout << razrab_huesos << '\n';
        ll x = 0;
        for (auto X : razrab_huesos) {
            if ('0' <= X && X <= '9') {
                x *= 10;
                x += (X - '0');
            } else {
                c[i].push_back(x);
                x = 0;
            }
        }
        if (i >= 0) {
            c[i].push_back(x);
        }
        ++i;
    }

    if (g <= 1) {
        solve01();
    } else {
        solve3();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

// R.I.P. Alexei Navalny
// 1976-2024

    while (T --> 0) {
        start();
    }

    return 0;
}
