#include <bits/stdc++.h>

//#pragma GCC optimize("03")
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using ld = long double;

using pld = pair<ld, ld>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using vin = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpl = vector<pll>;
using vpi = vector<pii>;
using vpd = vector<pld>;

using vvi = vector<vin>;
using vvl = vector<vll>;
using vvo = vector<vbo>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for (auto &i : a)

#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

mt19937 rnd(718314);

struct heaptree {
    struct Node {
        Node *l = nullptr;
        Node *r = nullptr;

        ll x, prior;
        ll id;

        Node() {}

        Node(ll _x, ll _id) { x = _x, id = _id, prior = rnd(); }
    };

    Node *root = nullptr;

    Node *merge(Node *a, Node *b) {
        if (!a) return b;
        if (!b) return a;
        if (a->prior > b->prior) {
            a->r = merge(a->r, b);
            return a;
        } else {
            b->l = merge(a, b->l);
            return b;
        }
    }

    using pNN = pair<Node *, Node *>;

    pNN split(Node *v, ll x) {
        if (!v) return {nullptr, nullptr};
        if (v->x <= x) {
            pNN d = split(v->r, x);
            v->r = d.first;
            return {v, d.second};
        } else {
            pNN d = split(v->l, x);
            v->l = d.second;
            return {d.first, v};
        }
    }

    void insert(ll x, ll id) {
        pNN d = split(root, x);
        Node *v = new Node(x, id);
        root = merge(d.first, merge(v, d.second));
    }

    ll erase_max(ll x) {
        pNN d = split(root, x - 1);
        Node *v = d.second;
        Node *p = v;
        if (v == nullptr) {
            cout << "No";
            exit(0);
        }
        while (v->l != nullptr) {
            p = v;
            v = v->l;
        }
        if (p != v) {
            p->l = nullptr;
            root = merge(d.first, d.second);
        } else {
            root = merge(d.first, v->r);
        }
        return v->id;
    }
};

ll n;
vector<vvl> tree;
vector<heaptree> hptree;
vector<deque<ll>> ids;

void dfs(ll v, ll p = -1) {
    each(k, tree[v]) {
        ll u = k[0];
        ll w = k[1];
        ll id = k[2];
        if (u == p) {
            continue;
        }
        dfs(u, v);
        ll l = hptree[v].erase_max(w - hptree[u].root->x);
        ids[v][l] = id;
        ids[u][hptree[u].root->id] = id;
        hptree[u].root = nullptr;
    }
}

int main() {
    fastio;
    ll g;
    cin >> n >> g;
    hptree.resize(n);
    tree.resize(n);
    ids.resize(n);
    vpl edges;
    F0R(i, n - 1) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        edges.pub({v, u});
        tree[v].pub({u, w, i});
        tree[u].pub({v, w, i});
    }
    F0R(i, n) {
        F0R(j, sz(tree[i])) {
            ll x;
            cin >> x;
            hptree[i].insert(x, sz(tree[i]) - j - 1);
            ids[i].pub(-1);
        }
    }
    dfs(0);
    deque<ll> dq;
    vll cnt(n - 1, 0);
    F0R(i, n) {
        cnt[ids[i][0]]++;
        if (cnt[ids[i][0]] == 2) {
            dq.pub(ids[i][0]);
        }
    }
    cout << "Yes\n";
    while (sz(dq) > 0) {
        ll id = dq[0];
        dq.pof();
        cout << id + 1 << ' ';
        ids[edges[id].first].pof();
        if (sz(ids[edges[id].first]) > 0) {
            cnt[ids[edges[id].first][0]]++;
            if (cnt[ids[edges[id].first][0]] == 2) {
                dq.pub(ids[edges[id].first][0]);
            }
        }
        ids[edges[id].second].pof();
        if (sz(ids[edges[id].second]) > 0) {
            cnt[ids[edges[id].second][0]]++;
            if (cnt[ids[edges[id].second][0]] == 2) {
                dq.pub(ids[edges[id].second][0]);
            }
        }
    }
    return 0;
}
