#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

vector<vector<int>> edge, wh, c;
vector<int> U, V, ans;
vector<ll> w;
bool y = true;

ll dfs(int u, int p) {
	vector<pair<ll, int>> prs;
	for (int i : edge[u]) {
		int v = (U[i] ^ V[i] ^ u);
		if (p == v) {
			continue;
		}
		prs.push_back({ w[i] - dfs(v, u), i });
		if (!y) {
			return 0;
		}
	}
	sort(all(prs));
	vector<pair<int, int>> bc;
	for (int i = 0; i < (int)edge[u].size(); ++i) {
		bc.push_back({ c[u][i], i });
	}
	sort(all(bc));
	wh[u].resize(edge[u].size(), -1);
	int nxt = 0;
	for (int i = 0; i < (int)prs.size(); ++i) {
		while (nxt < (int)bc.size() && bc[nxt].first < prs[i].first) {
			++nxt;
		}
		if (nxt == (int)bc.size()) {
			y = false;
			return 0;
		}
		wh[u][bc[nxt].second] = prs[i].second;
		++nxt;
	}
	for (int i = 0; i < (int)wh[u].size(); ++i) {
		if (wh[u][i] == -1) {
			return c[u][i];
		}
	}
	return 0;
}

void dfs2(int u, int p) {
	for (int i = 0; i < (int)wh[u].size(); ++i) {
		if (wh[u][i] == -1) {
			ans.push_back(p);
		} else {
			int j = wh[u][i];
			int v = (V[j] ^ U[j] ^ u);
			dfs2(v, j);
		}
	}
}

void solve() {
	int n, g; cin >> n >> g;
	U.resize(n);
	V.resize(n);
	w.resize(n);
	edge.resize(n);
	wh.resize(n);
	for (int i = 0; i + 1 < n; ++i) {
		cin >> U[i] >> V[i] >> w[i];
		--U[i]; --V[i];
		edge[U[i]].push_back(i);
		edge[V[i]].push_back(i);
	}
	c.resize(n);
	for (int i = 0; i < n; ++i) {
		int dg = edge[i].size();
		c[i].resize(dg);
		for (int j = 0; j < dg; ++j) {
			cin >> c[i][j];
		}
	}
	dfs(0, 0);
	if (y == false) {
		cout << "No\n";
	} else {
		cout << "Yes\n";
		dfs2(0, -1);
		reverse(all(ans));
		for (int j : ans) {
			cout << j + 1 << ' ';
		}
		cout << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}