#pragma optimize("Ofast,unroll-loops");
#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    srand(time(0));

    int n, g;
    cin >> n >> g;

    vector<pair<pint, int>> edges(n - 1);
    vector<vector<int>> c(n + 1);
    vector<vector<int>> gr(n + 1);
    forn(i, 0, n - 1) {
        int v, u, w;
        cin >> v >> u >> w;
        edges[i] = mp(mp(v, u), w);
        gr[v].push_back(u);
        gr[u].push_back(v);
    }

    forn(i, 1, n + 1) {
        int cnt = gr[i].size();
        c[i].resize(cnt);
        forn(j, 0, cnt) {
            cin >> c[i][j];
        }
    }

    auto keker = [&](vector<int>& ord) {
        vector<int> pointers(n + 1, 0);
        forn(i, 1, n + 1) {
            pointers[i] = c[i].size() - 1;
        }

        forn(i, 0, ord.size()) {
            auto v = edges[ord[i]].first.first, u = edges[ord[i]].first.second, w = edges[ord[i]].second;
            if (c[v][pointers[v]] + c[u][pointers[u]] < w) return false;
            pointers[v]--;
            pointers[u]--;
        }
        return true;
    };

    vector<int> ord(n - 1);
    iota(all(ord), 0);

    do {
        if (keker(ord)) {
            cout << "Yes\n";
            forn(i, 0, n - 1) {
                cout << ord[i] + 1 << " ";
            }
            return;
        }
    } while (next_permutation(all(ord)));

    cout << "No";
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
