#pragma optimize("Ofast,unroll-loops");
#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    srand(time(0));

    int n, g;
    cin >> n >> g;

    vector<pair<pint, int>> edges(n - 1);
    vector<vector<int>> c(n + 1);
    vector<vector<int>> gr(n + 1);
    vector<vector<int>> vedges(n + 1);
    forn(i, 0, n - 1) {
        int v, u, w;
        cin >> v >> u >> w;
        edges[i] = mp(mp(v, u), w);
        gr[v].push_back(u);
        gr[u].push_back(v);
        vedges[v].push_back(i);
        vedges[u].push_back(i);
    }

    forn(i, 1, n + 1) {
        int cnt = gr[i].size();
        c[i].resize(cnt);
        forn(j, 0, cnt) {
            cin >> c[i][j];
        }
    }

    auto keker = [&](vector<int>& ord) {
        vector<int> pointers(n + 1, 0);
        forn(i, 1, n + 1) {
            pointers[i] = c[i].size() - 1;
        }

        forn(i, 0, ord.size()) {
            auto v = edges[ord[i]].first.first, u = edges[ord[i]].first.second, w = edges[ord[i]].second;
            if (c[v][pointers[v]] + c[u][pointers[u]] < w) return false;
            pointers[v]--;
            pointers[u]--;
        }
        return true;
    };

    if (g <= 1) {
        vector<int> ord(n - 1);
        iota(all(ord), 0);

        do {
            if (keker(ord)) {
                cout << "Yes\n";
                forn(i, 0, n - 1) {
                    cout << ord[i] + 1 << " ";
                }
                return;
            }
        } while (next_permutation(all(ord)));

        cout << "No";
        return;
    } else if (g == 3) {
        vector<int> ord(n - 1);
        iota(all(ord), 2);
        sort(all(ord), [&](int f, int s) {
            return edges[f - 2].second - c[f][0] < edges[s - 2].second - c[s][0];
        });


        vector<pint> sorry;
        forn(i, 0, c[1].size()) {
            sorry.push_back(mp(c[1][i], i));
        }
        sort(all(sorry));
        int p = 0;
        vector<int> ans(n - 1);
        int curr = 0;
        for(auto& [u, v] : sorry) {
            int need = edges[ord[p] - 2].second - c[ord[p]][0];
            if (need > u) {
                cout << "No";
                return;
            }
            ans[v] = ord[p]- 1;
            ++p;
        }
        cout << "Yes\n";
        forn(i, 0, n - 1) {
            cout << ans[i] << " ";
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
