#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

struct E {
	ll u, v, w, num;
};

const ll N = 2e5 + 20;
ll n, group;
vector<E> g[N];
set<array<ll, 2>> c[N];
vector<ll> gde[N];
ll t[N], used[N];
vector<array<ll, 2>> zakem[N];
ll tnow = 0;

void gett(ll e) {
	used[e] = 1;
	t[e] = tnow;
	for (auto& p : zakem[e]) {
		ll f = gde[p[0]][p[1]];
		if (!used[f]) gett(f);
		t[e] = max(t[e], t[f] + 1);
	}
	if (t[e] == tnow) tnow++;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> group;
	for (ll i = 0; i < n - 1; i++) {
		ll u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		g[u].push_back({u, v, w, i});
		g[v].push_back({v, u, w, i});
	}
	queue<ll> que;
	for (ll i = 0; i < n; i++) {
		gde[i].resize(g[i].size());
		for (ll j = 0; j < g[i].size(); j++) {
			ll x;
			cin >> x;
			c[i].insert({x, j});
		}
		if (g[i].size() == 1) que.push(i);
	}
	fill(used, used + n, 0);
	while (que.size() > 0) {
		ll v = que.front();
		que.pop();
		used[v] = 1;
		E t;
		for (auto& r : g[v]) {
			if (!used[r.v]) {
				t = r;
				break;
			}
		}
		auto it = c[t.v].lower_bound({t.w - (*c[t.u].begin())[0], 0});
		if (it == c[t.v].end()) {
			cout << "No\n";
			return 0;
		}
		ll iv = (*it)[1];
		ll iu = (*c[t.u].begin())[1];
		gde[t.u][iu] = t.num;
		gde[t.v][iv] = t.num;
		if (iu + 1 < gde[t.u].size()) zakem[t.num].push_back({t.u, iu + 1});
		if (iv + 1 < gde[t.v].size()) zakem[t.num].push_back({t.v, iv + 1});
		c[t.v].erase(it);
		c[t.u].erase(c[t.u].begin());
		if (c[t.v].size() == 1) que.push(t.v);
		else if (c[t.v].size() == 0) break;
	}
	fill(used, used + n, 0);
	for (ll i = 0; i < n - 1; i++) {
		if (!used[i])
			gett(i);
	}
	vector<ll> ans(n - 1);
	for (ll i = 0; i < n - 1; i++) {
		ans[t[i]] = i + 1;
	}
	cout << "Yes\n";
	for (ll x : ans) cout << x << " ";
	return 0;
}