#include <bits/stdc++.h>
#include<bits/extc++.h>
using namespace __gnu_pbds;
#define int long long

struct Node
{
    int val;
};

struct SegmentTree
{
    int n;
    std::vector<Node> t;

    SegmentTree(std::vector<int> &a)
    {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    Node mer(Node a, Node b)
    {
        return {a.val + b.val};
    }

    void build(int i, int l, int r, std::vector<int> &a)
    {
        if (l == r - 1)
        {
            t[i].val = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * i + 1, l, mid, a);
        build(2 * i + 2, mid, r, a);
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    void upd(int i, int l, int r, int pos, int v)
    {
        if (l == r - 1)
        {
            t[i].val = v;
            return;
        }
        int mid = (l + r) / 2;
        if (mid > pos)
        {
            upd(2 * i + 1, l, mid, pos, v);
        }
        else
        {
            upd(2 * i + 2, mid, r, pos, v);
        }
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    Node query(int i, int l, int r, int ql, int qr)
    {
        if (l >= ql && r <= qr)
        {
            return t[i];
        }
        if (r <= ql || l >= qr)
        {
            return {0};
        }
        int mid = (l + r) / 2;
        return mer(query(2 * i + 1, l, mid, ql, qr), query(2 * i + 2, mid, r, ql, qr));
    }
};

std::mt19937_64 rnd(2683248);

std::map<std::pair<std::pair<int,int>,int>,int> m;
std::map<int,std::pair<std::pair<int,int>,int>> m1;


bool Check(std::vector<std::vector<int>> ct,std::vector<int>& now){
    for(int i:now){
        std::pair<std::pair<int,int>,int> tmp=m1[i];
        int first=ct[tmp.first.first].back();
        int second=ct[tmp.first.second].back();
        if(first+second<tmp.second){
            return false;
        }
        ct[tmp.first.first].pop_back();
        ct[tmp.first.second].pop_back();
    }
    return true;
}

void f(std::set<std::pair<std::pair<int,int>,int>>& a,std::vector<std::vector<int>>& ct,std::vector<int>& now){
    if(a.size()==0){
        if(Check(ct,now)){
            std::cout<<"YES"<<std::endl;
            for(int i:now){
                std::cout<<i<<' ';
            }
            exit(0);
        }
    }

    for(std::pair<std::pair<int,int>,int> i:a){
        int tmp=m[i];
        std::set<std::pair<std::pair<int,int>,int>> a1=a;
        a1.erase(a1.find(i));
        now.push_back(tmp);
        f(a1,ct,now);
        now.pop_back();
    }
}

struct edge{
    int start,stop,weight;
};

int32_t main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n,g;
    std::cin>>n>>g;

    std::set<std::pair<std::pair<int,int>,int>> a;
    std::vector<int> count(n+1);
    for(int i=0;i<n-1;i++){
        int x,y,z;
        std::cin>>x>>y>>z;

        a.insert({{x,y},z});

        m[{{x,y},z}]=i+1;
        m1[i+1]={{x,y},z};
        count[x]++,count[y]++;
    }
    std::vector<std::vector<int>> ct(n+1);
    for(int i=0;i<n;i++){
        std::vector<int> tmp;
        for(int j=0;j<count[i+1];j++){
            int x;
            std::cin>>x;

            tmp.push_back(x);
        }
        std::reverse(tmp.begin(),tmp.end());
        ct[i+1]=tmp;
    }
    std::vector<int> now;
    f(a,ct,now);
    std::cout<<"NO";
}
