#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct edge {
	int a, b, w;
};
struct edge2 {
	int w, c1, c2, i, v;
};
vector<int> ans2;
vector<bool> vis;
vector<vector<int>> grp;

void dfs(int u) {
	vis[u] = true;
	ans2.push_back(u);
	for (int v : grp[u]) {
		if (!vis[v])
			dfs(v);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, g;
	cin >> n >> g;
	vector<edge> mas(n - 1);
	vector<int> deg(n, 0);
	for (int i = 0; i < n - 1; ++i) {
		cin >> mas[i].a >> mas[i].b >> mas[i].w;
		mas[i].a--; mas[i].b--;
		deg[mas[i].a]++;
		deg[mas[i].b]++;
	}
	vector<vector<int>> c(n);
	for (int i = 0; i < n; ++i) {
		c[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; ++j)
			cin >> c[i][j];
	}
	if (g == 2) {
		vector<edge2> gr(n);
		for (int i = 0; i < n - 1; ++i) {
			int u = mas[i].a;
			gr[u].w = mas[i].w;
			gr[u].i = i;
		}
		int pred = 1;
		grp.resize(n - 1);
		vector<int> deg2(n - 1, 0);
		for (int i = 1; i <= n - 1; ++i) {
			int c1 = c[i - 1][0];
			if (pred == 0) c1 = c[i - 1][1];
			int c2 = gr[i - 1].w - c1;
			if (i == n - 1) {
				if (c[i][0] < c2) {
					cout << "No";
					return 0;
				}
				break;
			}
			if (c[i][0] < c2 && c[i][1] < c2) {
				cout << "No";
				return 0;
			}
			if (c[i][1] >= c2 && c[i][0] < c2) {
				grp[gr[i - 1].i].push_back(gr[i].i);
				deg2[gr[i].i]++;
				pred = 1;
			}
			else if (c[i][1] < c2 && c[i][0] >= c2) {
				grp[gr[i].i].push_back(gr[i - 1].i);
				deg2[gr[i - 1].i]++;
				pred = 0;
			}
			else {
				if (c[i][1] < c[i][0]) {
					grp[gr[i - 1].i].push_back(gr[i].i);
					deg2[gr[i].i]++;
					pred = 1;
				}
				else {
					grp[gr[i].i].push_back(gr[i - 1].i);
					deg2[gr[i - 1].i]++;
					pred = 0;
				}
			}
		}
		vis.resize(n - 1, false);
		for (int i = 0; i < n - 1; ++i) {
			if (!vis[i] && deg2[i] == 0)
				dfs(i);
		}
		cout << "Yes\n";
		for (int el : ans2)
			cout << el + 1 << " ";
	}
	else if (n <= 10) {
		vector<int> posl(n - 1);
		for (int i = 0; i < n - 1; ++i)
			posl[i] = i;
		do {
			vector<int> cur_ind(n);
			for (int i = 0; i < n; ++i)
				cur_ind[i] = deg[i] - 1;
			bool flag = true;
			for (int i : posl) {
				int u = mas[i].a, v = mas[i].b, w = mas[i].w;
				if (c[u][cur_ind[u]] + c[v][cur_ind[v]] < w) {
					flag = false;
					break;
				}
				cur_ind[u]--; cur_ind[v]--;
			}
			if (flag) {
				cout << "Yes\n";
				for (int el : posl) cout << el + 1 << " ";
				return 0;
			}
		} while (next_permutation(posl.begin(), posl.end()));
		cout << "No";
	}
	else {
		vector<edge2> gr(n);
		int w12, i12;
		for (int i = 0; i < n - 1; ++i) {
			if (mas[i].a == 0 && mas[i].b == 1) {
				w12 = mas[i].w;
				i12 = i;
				continue;
			}
			int u = mas[i].b;
			gr[u].w = mas[i].w;
			gr[u].i = i;
			gr[u].v = mas[i].a;
		}
		set<pair<int, int>> se1, se2;
		for (int i = 0; i < deg[0]; ++i) {
			se1.insert({ c[0][i], i});
		}
		for (int i = 0; i < deg[1]; ++i) {
			se2.insert({ c[1][i], i });
		}
		vector<int> ans1(deg[0]), ans2(deg[1]);
		for (int u = 2; u < n; ++u) {
			int v = gr[u].v;
			if (v == 0) {
				if (se1.lower_bound({ gr[u].w - c[u][0], -1}) == se1.end()) {
					cout << "No";
					return 0;
				}
				int j = se1.lower_bound({ gr[u].w - c[u][0], -1 })->second;
				se1.erase(se1.lower_bound({ gr[u].w - c[u][0], -1 }));
				ans1[deg[0] - j - 1] = gr[u].i;
			}
			else {
				if (se2.lower_bound({ gr[u].w - c[u][0], -1 }) == se2.end()) {
					cout << "No";
					return 0;
				}
				int j = se2.lower_bound({ gr[u].w - c[u][0], -1 })->second;
				se2.erase(se2.lower_bound({ gr[u].w - c[u][0], -1 }));
				ans2[deg[1] - j - 1] = gr[u].i;
			}
		}
		auto el1 = *se1.begin(), el2 = *se2.begin();
		if (el1.first + el2.first < w12) {
			cout << "No";
			return 0;
		}
		cout << "Yes\n";
		for (int i = 0; i < deg[0] - el1.second - 1; ++i) {
			cout << ans1[i] + 1 << " ";
		}
		for (int i = 0; i < deg[1] - el2.second - 1; ++i) {
			cout << ans2[i] + 1 << " ";
		}
		cout << i12 + 1 << " ";
		for (int i = deg[0] - el1.second; i < ans1.size(); ++i) {
			cout << ans1[i] + 1 << " ";
		}
		for (int i = deg[1] - el2.second; i < ans2.size(); ++i) {
			cout << ans2[i] + 1 << " ";
		}
	}

	return 0;
}