//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 2e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct edge{
    int a, b, w;
    edge(){}
    edge(int a, int b, int w) {
        this->a = a, this->b = b, this->w = w;
    }
};

int n, G;
vector<int> g[N];
vector<vector<int>> c;
vector<edge> ed;
vector<int> ans, step(N);

void bamboo() {
    int last = c[1][0];
    for (int i = 2; i < n; i++) {
        if (last + max(c[i][0], c[i][1]) < ed[i - 2].w) {
            cout << "No";
            return;
        }
        if (last + min(c[i][0], c[i][1]) >= ed[i - 2].w) {
            if (c[i][0] <= c[i][1]) {
                g[i - 2].push_back(i - 1);
                step[i - 1]++;
                last = c[i][1];
            } else {
                g[i - 1].push_back(i - 2);
                step[i - 2]++;
                last = c[i][0];
            }
        } else {
            if (c[i][0] < c[i][1]) {
                g[i - 1].push_back(i - 2);
                step[i - 2]++;
                last = c[i][0];
            } else {
                g[i - 2].push_back(i - 1);
                step[i - 1]++;
                last = c[i][1];
            }
        }
    }
    if (last + c[n][0] < ed[n - 2].w) {
        cout << "No";
        return;
    }
    set<pair<int, int>> st1;
    for (int i = 0; i < n - 1; i++) {
        st1.insert({step[i], i});
    }
    while (!st1.empty()) {
        auto [cnt, i] = *st1.begin();
        st1.erase(st1.begin());
        for (int &e : g[i]) {
            st1.erase({step[e], e});
            step[e]--;
            st1.insert({step[e], e});
        }
        ans.push_back(i);
    }
    cout << "Yes\n";
    for (int &e : ans) {
        cout << e + 1 << ' ';
    }
}

void sun() {
    vector<pair<int, int>> a;
    for (int i = 0; i < n - 1; i++) {
        int diff = ed[i].w - c[ed[i].b][0];
        a.emplace_back(diff, i);
    }
    sort(a.begin(), a.end());
    vector<pair<int, int>> ord;
    for (int i = 0; i < n - 1; i++) {
        ord.emplace_back(c[1][i], i);
    }
    sort(ord.begin(), ord.end());
    vector<int> go(n - 1);
    for (int i = 0; i < n - 1; i++) {
        if (ord[i].first < a[i].first) {
            cout << "No";
            return;
        }
        go[ord[i].second] = a[i].second;
    }
    cout << "Yes\n";
    for (int &e : go) {
        cout << e + 1 << ' ';
    }
}

vector<int> st(N);

void solve() {
    cin >> n >> G;
    c.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        st[a]++;
        st[b]++;
        ed.emplace_back(a, b, w);
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < (int)st[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    if (G == 3) {
        for (int i = 1; i <= n; i++) {
            reverse(c[i].begin(), c[i].end());
        }
        sun();
        return;
    }
    if (G == 2) {
        for (int i = 1; i <= n; i++) {
            reverse(c[i].begin(), c[i].end());
        }
        bamboo();
        return;
    }
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    do {
        vector<vector<int>> c1 = c;
        bool fl = true;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b, w] = ed[p[i]];
            if (c1[a].back() + c1[b].back() < w) {
                fl = false;
                break;
            }
            c1[a].pop_back(), c1[b].pop_back();
        }
        if (fl) {
            cout << "Yes\n";
            for (int &e : p) {
                cout << e + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}

/*
 4 3
1 2 8
1 3 6
1 4 5
3 2 2
5
4
3
 */
