//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 2e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct edge{
    int a, b, w;
    edge(){}
    edge(int a, int b, int w) {
        this->a = a, this->b = b, this->w = w;
    }
};

int n, G;
vector<int> g[N];
vector<vector<int>> c;
vector<edge> ed;
vector<int> ans, step(N);

void bamboo() {
    int last = c[1][0];
    for (int i = 2; i < n; i++) {
        if (last + max(c[i][0], c[i][1]) < ed[i - 2].w) {
            cout << "No";
            return;
        }
        if (last + min(c[i][0], c[i][1]) >= ed[i - 2].w) {
            if (c[i][0] <= c[i][1]) {
                g[i - 2].push_back(i - 1);
                step[i - 1]++;
                last = c[i][1];
            } else {
                g[i - 1].push_back(i - 2);
                step[i - 2]++;
                last = c[i][0];
            }
        } else {
            if (c[i][0] < c[i][1]) {
                g[i - 1].push_back(i - 2);
                step[i - 2]++;
                last = c[i][0];
            } else {
                g[i - 2].push_back(i - 1);
                step[i - 1]++;
                last = c[i][1];
            }
        }
    }
    if (last + c[n][0] < ed[n - 2].w) {
        cout << "No";
        return;
    }
    set<pair<int, int>> st1;
    for (int i = 0; i < n - 1; i++) {
        st1.insert({step[i], i});
    }
    while (!st1.empty()) {
        auto [cnt, i] = *st1.begin();
        st1.erase(st1.begin());
        for (int &e : g[i]) {
            st1.erase({step[e], e});
            step[e]--;
            st1.insert({step[e], e});
        }
        ans.push_back(i);
    }
    cout << "Yes\n";
    for (int &e : ans) {
        cout << e + 1 << ' ';
    }
}

void sun() {
    vector<pair<int, int>> a;
    for (int i = 0; i < n - 1; i++) {
        int diff = ed[i].w - c[ed[i].b][0];
        a.emplace_back(diff, i);
    }
    sort(a.begin(), a.end());
    vector<pair<int, int>> ord;
    for (int i = 0; i < n - 1; i++) {
        ord.emplace_back(c[1][i], i);
    }
    sort(ord.begin(), ord.end());
    vector<int> go(n - 1);
    for (int i = 0; i < n - 1; i++) {
        if (ord[i].first < a[i].first) {
            cout << "No";
            return;
        }
        go[ord[i].second] = a[i].second;
    }
    cout << "Yes\n";
    for (int &e : go) {
        cout << e + 1 << ' ';
    }
}

struct gre{
    int to, w, id;
    gre(int to, int w, int id) {
        this->to = to, this->w = w, this->id = id;
    }
};

vector<gre> gr[N];
vector<bool> isleaf(N), used(N);
vector<int> val(N);

void leafs(int v) {
    used[v] = true;
    isleaf[v] = true;
    for (auto [to, w, id] : gr[v]) {
        if (!used[to]) {
            leafs(to);
            isleaf[v] = false;
        }
    }
    if (isleaf[v]) {
        val[v] = c[v][0];
    }
}

gp_hash_table<int, vector<int>> mp[N];

void dfs(int v) {
    used[v] = true;
    vector<pair<int, int>> need;
    for (auto [to, w, id] : gr[v]) {
        if (used[to]) {
            continue;
        }
        if (isleaf[to]) {
            need.emplace_back(w - val[to], id);
        } else {
            dfs(to);
            need.emplace_back(w - val[to], id);
        }
    }
    vector<pair<int, int>> id;
    for (auto [x, i] : need) {
        if (mp[v][x].empty()) {
            cout << "No";
            exit(0);
        }
        id.emplace_back(mp[v][x].back(), i);
        mp[v][x].pop_back();
    }
    sort(id.begin(), id.end());
    for (auto [x, y] : id) {
        ans.push_back(y);
    }
    for (auto &[cl, vec] : mp[v]) {
        if (!vec.empty()) {
            val[v] = cl;
            isleaf[v] = true;
            break;
        }
    }
    if (v != 1 && !isleaf[v]) {
        assert(0);
    }
}

void df() {
    for (int i = 0; i < n - 1; i++) {
        auto [a, b, w] = ed[i];
        gr[a].emplace_back(b, w, i);
        gr[b].emplace_back(a, w, i);
    }
    leafs(1);
    used.assign(n + 1, false);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < (int)c[i].size(); j++) {
            mp[i][c[i][j]].push_back(j);
        }
//        for (int j = 0; j < (int)c[i].size(); j++) {
//            reverse(mp[i][c[i][j]].begin(), mp[i][c[i][j]].end());
//        }
    }
    dfs(1);
    cout << "Yes\n";
    for (int &e : ans) {
        cout << e + 1 << ' ';
    }
}

vector<int> st(N);

void solve() {
    cin >> n >> G;
    c.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        st[a]++;
        st[b]++;
        ed.emplace_back(a, b, w);
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < (int)st[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    if (G == 7) {
        for (int i = 1; i <= n; i++) {
            reverse(c[i].begin(), c[i].end());
        }
        df();
        return;
    }
    return;
    if (G == 3) {
        for (int i = 1; i <= n; i++) {
            reverse(c[i].begin(), c[i].end());
        }
        sun();
        return;
    }
    if (G == 2) {
        for (int i = 1; i <= n; i++) {
            reverse(c[i].begin(), c[i].end());
        }
        bamboo();
        return;
    }
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    do {
        vector<vector<int>> c1 = c;
        bool fl = true;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b, w] = ed[p[i]];
            if (c1[a].back() + c1[b].back() < w) {
                fl = false;
                break;
            }
            c1[a].pop_back(), c1[b].pop_back();
        }
        if (fl) {
            cout << "Yes\n";
            for (int &e : p) {
                cout << e + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}

/*

 4 7
 1 2 7
 1 3 6
 1 4 5
 3 3 1
 4
 5
 2

 */
