#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <deque>

using namespace std;

using ll = long long;
using pii = pair<int, int>;

struct edge {
    int u, v;
    int w, id;
};

vector<vector<edge>> g;
vector<vector<int>> c;
vector<vector<int>> por_c;

int n;
vector<edge> edges;
vector<vector<int>> used;


bool ans_correct = true;

void dfs(int v, int p, int wp, int id_edge) {
    for (auto e : g[v]) {
        if (e.u == p || e.v == p) continue;
        dfs(e.u + e.v - v, v, e.w, e.id);
    }
    if (p == -1) return;
    int start = -1;
    for (int i = 0; i < c[v].size(); ++i) {
        if (!used[v][i]) start = i;
    }
    int id = -1;
    for (int i = 0; i < c[p].size(); ++i) {
        if (used[p][i]) continue;
        if ((id == -1 || c[p][id] > c[p][i]) && wp <= c[v][start] + c[p][i]) id = i;
    }
    if (id == -1) {
        ans_correct = false;
        return;
    } else {
        por_c[p][id] = id_edge;
        used[p][id] = 1;
    }
}

void dfs_print(int v, int p, int id_edge) {
    for (int i = 0; i < por_c[v].size(); ++i) {
        if (!used[v][i]) {
            cout << id_edge + 1 << " ";
            continue;
        }
        dfs_print(edges[por_c[v][i]].u + edges[por_c[v][i]].v - v, v, por_c[v][i]);
        //cout << por_c[v][i] + 1 << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int group;
    cin >> n >> group;
    g.resize(n);
    c.resize(n);
    por_c.resize(n);
    used.resize(n);
    edges.resize(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].id = i;
        edges[i].u--;
        edges[i].v--;
        g[edges[i].v].push_back(edges[i]);
        g[edges[i].u].push_back(edges[i]);
    }
    int start = 0;
    for (int i = 0; i < n; ++i) {
        int k = g[i].size();
        if (k != 1) start = i;
        c[i].resize(k);
        por_c[i].resize(k);
        used[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> c[i][j];
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    if (group == 3) {
        vector<pii> dif(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            dif[i] = {g[i + 1][0].w - c[i + 1][0], g[i + 1][0].id};
        }
        std::sort(dif.begin(), dif.end());
        std::reverse(dif.begin(), dif.end());
        vector<pii> c0(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            c0[i] = {c[0][i], i};
        }
        std::sort(c0.begin(), c0.end());
        std::reverse(c0.begin(), c0.end());
        vector<int> ans(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            if (dif[i].first > c0[i].first) {
                cout << "No";
                return 0;
            }
            ans[c0[i].second] = dif[i].second;
        }
        cout << "Yes\n";
        for (auto el : ans) cout << el + 1 << " ";
        return 0;
    }
    dfs(start, -1, -1, -1);
    if (!ans_correct) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    dfs_print(start, -1, -1);
    return 0;
}
