#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>
#include <deque>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
#define endl "\n"

struct Vertex {
    int to, w, id;

    Vertex(int _to, int _w, int _id) {
        to = _to;
        w = _w;
        id = _id;
    };
};

vector<vector<Vertex>> g;
int n, tp;

vector<vector<pair<int, int>>> c;

bool ans = true;
vector<int> posl;

vector<vector<int>> new_g;

void dfs(int v, int p, int root_vertex) {
    deque<pair<int, int>> need;
    for (auto [u, w, id]: g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v, id);
        need.push_back({w - c[u][0].first, id});
    }
    sort(all(need));
    vector<pair<int, int>> left;
    vector<pair<int, int>> add;

    for (auto [num, i]: c[v]) {

        if (need.size() == 0) {
            left.push_back({num, i});
            break;
        }

        if (num < need.front().first) {
            if (left.size()) {
                cout << "No" << endl;
                exit(0);
            } else {
                left.push_back({num, i});
            }
        } else {
            add.push_back({i, need.front().second});
            need.pop_front();
        }
    }
    if (need.size()) {
        cout << "No" << endl;
        exit(0);
    }
    if (root_vertex != -1) {
        add.push_back({left[0].ss, root_vertex});
    }
    c[v] = left;
    sort(all(add));
    for (int i = 0; i < add.size(); i++) {
        if (i != add.size() - 1) {
            new_g[add[i + 1].second].push_back(add[i].second);
        }
    }
}

vector<int> used;

void topsort(int v) {
    used[v] = 1;
    for (auto u: new_g[v]) {
        if (!used[u]) {
            topsort(u);
        }
    }
    posl.push_back(v);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> tp;

    g.resize(n + 1);
    c.resize(n + 1);
    new_g.resize(n);

    for (int i = 1; i <= n - 1; i++) {
        int aa, bb, ww;
        cin >> aa >> bb >> ww;
        g[aa].push_back({bb, ww, i});
        g[bb].push_back({aa, ww, i});
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            c[i].push_back({x, j});
        }
        sort(all(c[i]));
    }

    dfs(1, 0, -1);

    cout << "Yes" << endl;

//    for (int i = 1; i <= n - 1; i++) {
//        cout << "~~~ " << i << endl;
//        for (auto it: new_g[i]) {
//            cout << it << " ";
//        }
//        cout << endl;
//    }

    used.resize(n, 0);

    for (int i = 1; i <= n - 1; i++) {
        if (!used[i]) {
            topsort(i);
        }
    }

    reverse(all(posl));

    for (auto it: posl) {
        cout << it << " ";
    }

}
