#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(time(0));
const int N = 2e5 + 100;
vector<pair<int, int>> adj[N];
struct TwoSat {
    vector<vector<int>> g, gr;
    int n;
    TwoSat(int _n) : n(_n), gr(2 * _n), g(2 * _n) {}
    void add_edge(int v1, int f1, int v2, int f2) {
        g[2 * v1 + f1].push_back(2 * v2 + f2);
        gr[2 * v2 + f2].push_back(2 * v1 + f1);
    }
    vector<int> ord, comp;
    vector<bool> us;
    void dfs0(int v) {
        us[v] = true;
        for (int u : g[v]) {
            if (!us[u]) {
                dfs0(u);
            }
        }
        ord.push_back(v);
    }
    int cur;
    void dfs1(int v) {
        us[v] = true;
        comp[v] = cur;
        for (int u : gr[v]) {
            if (!us[u]) {
                dfs1(v);
            }
        }
    }
    vector<int> solve() {
        comp.assign(2 * n, -1);
        us.assign(2 * n, false);
        for (int i = 0; i < 2 * n; i++) {
            if (!us[i]) {
                dfs0(i);
            }
        }
        reverse(ord.begin(), ord.end());
        for (int v : ord) {
            if (!us[v]) {
                cur++;
                dfs1(v);
            }
        }
        vector<int> ans(n);
        for (int i = 0; i < n; i++) {
            if (comp[2 * i] == comp[2 * i + 1]) return {};
            ans[i] = comp[2 * i] > comp[2 * i + 1];
        }
        return ans;
    }
};
void solve_case() {
    int n, G;
    cin >> n >> G;
    vector<array<int, 3>> edges;
    for (int i = 0; i < n - 1; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        edges.push_back({x, y, w});
        adj[x].push_back({y, w});
        adj[y].push_back({x, w});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(adj[i].size());
        for (int x = 0; x < adj[i].size(); x++) {
            cin >> c[i][x];
        }
    }
    if (G == 6) {
        vector<int> ans;
        vector<bool> us(n - 1);
        for (int step = 0; step < n - 1; step++) {
            int id = -1;
            int score = inf;
            for (int i = 0; i < n - 1; i++) {
                if (us[i]) continue;
                int a = edges[i][0], b = edges[i][1], w = edges[i][2];
                if (c[a].back() + c[b].back() < w) continue;
                int me = max(c[a].back(), c[b].back());
                if (id == -1) {
                    id = i;
                    score = me;
                } else if (score > me){
                    score = me;
                    id = i;
                }
            }
            if (id == -1) {
                cout << "No\n";
                return;
            }
            ans.push_back(id);
            c[edges[id][0]].pop_back();
            c[edges[id][1]].pop_back();
            us[id] = true;
        }
        cout << "Yes\n";
        for (int v : ans) cout << v + 1 << " ";
        cout << "\n";
        return;
    }
    if (G == 1 || G == 0) {
        vector<int> perm(n - 1);
        iota(perm.begin(), perm.end(), 0);
        do {
            bool ok = true;
            auto cc = c;
            for (int i : perm) {
                int a = edges[i][0], b = edges[i][1], w = edges[i][2];
                if (c[a].back() + c[b].back() < w) {
                    ok = false;
                } else {
                    c[a].pop_back();
                    c[b].pop_back();
                }
            }
            c = cc;
            if (ok) {
                cout << "Yes\n";
                for (int v : perm) cout << v + 1 << " ";
                cout << "\n";
                return;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        cout << "No\n";
        return;
    }
    if (G == 2) {
        vector<int> ans(n - 1);
        int lptr = 0, rptr = n - 2;
        for (int i = 0; i < n - 1; i++) {
            int x = c[i].back(), w = edges[i][2];
            int id = -1;
            for (int v = 0; v < 2; v++) {
                if (w <= x + c[i + 1][v]) {
                    if (id == -1 || c[i + 1][id] > c[i + 1][v]) {
                        id = v;
                    }
                }
            }
            if (id == -1) {
                cout << "No\n";
                return;
            }
            if (id == 1) {
                ans[lptr++] = i;
            } else {
                ans[rptr--] = i;
            }
            c[i + 1].erase(c[i + 1].begin() + id);
        }
        cout << "Yes\n";
        for (int v : ans) cout << v + 1 << " ";
        cout << "\n";
        return;
    }
    if (G == 3) {
        reverse(c[0].begin(), c[0].end());
        vector<int> ord1(n - 1), ord2(n - 1);
        iota(ord1.begin(), ord1.end(), 0);
        iota(ord2.begin(), ord2.end(), 0);
        sort(ord1.begin(), ord1.end(), [&](int l, int r){
            return edges[l][2] - c[l + 1].back() < edges[r][2] - c[r + 1].back();
        });
        sort(ord2.begin(), ord2.end(), [&](int l, int r){
            return c[0][l] < c[0][r];
        });
        vector<int> ans(n - 1);
        for (int i = 0; i < n - 1; i++) {
            if (c[0][ord2[i]] + c[ord1[i] + 1].back() < edges[ord1[i]][2]) {
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n";
        for (int i = 0; i < n - 1; i++) {
            ans[ord2[i]] = ord1[i];
        }
        for (int v : ans) cout << v + 1 << " ";
        cout << "\n";
        return;
    }
    if (G == 5) {
        vector<int> ans;
        vector<vector<int>> ord(n);
        vector<set<int>> g(n);
        for (int i = 0; i < n - 1; i++) {
            int a = edges[i][0], b = edges[i][1], w = edges[i][2];
            g[a].insert(i);
            g[b].insert(i);
        }
        for (int i = 0; i < n; i++) {
            ord[i].assign(g[i].size(), -1);
        }
        for (int it = 0; it < n - 1; it++) {
            for (int v = 0; v < n; v++) {
                if (g[v].size() != 1) continue;
                int id = *g[v].begin();
                g[v].erase(id);
                int me = -1;
                for (int i = 0; i < ord[v].size(); i++) {
                    if (ord[v][i] == -1) {
                        me = c[v][i];
                    }
                }
                int u = edges[id][1], w = edges[id][2];
                g[u].erase(id);
                bool any = false;
                for (int i = 0; i < ord[u].size(); i++) {
                    if (ord[u][i] != -1) continue;
                    if (me + c[u][i] >= w) {
                        any = true;
                        ord[u][i] = id;
                        break;
                    }
                }
                if (!any) {
                    cout << "No\n";
                    return;
                }
                break;
            }
        }
        vector<vector<int>> g2(n);
        for (int i = 0; i < n; i++) {
            vector<int> lst;
            for (int j = 0; j + 1 < ord[i].size(); j++) {
                if (ord[i][j] != -1) {
                    lst.push_back(ord[i][j]);
                }
            }
            for (int j = 0; j + 1 < lst.size(); j++) {
                g2[lst[i + 1]].push_back(lst[i]);
            }
        }
        for (int i = 0; i < n - 1; i++) {
            g2[n - 1].push_back(i);
        }
        vector<int> color(n);
        bool bad = false;
        function<void(int)> dfs = [&](int v) {
            ans.push_back(v);
            color[v] = 1;
            for (int u : g2[v]) {
                if (color[u] == 0) {
                    dfs(u);
                } else if (color[u] == 2) {
                    bad = true;
                }
            }
            color[v] = 2;
        };
        dfs(n - 1);
        ans.erase(ans.begin());
        if (bad) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        for (int v : ans) cout << v + 1 << " ";
        cout << "\n";
        return;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}

