#include "bits/stdc++.h"
using namespace std;
#define int long long

mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());

int get_rand(int l, int r) {
    return uniform_int_distribution<>(l, r)(gen);
}

long double magic() {
    return uniform_real_distribution<>(0., 1.)(gen);
}

const int N = 200'000 + 228;

struct edge {
    int a, b, w;
};

edge edges[N];
int deg[N];
vector<int> c[N];

int f(vector<int> &p) {
    vector<int> used(N);
    int res = 0;
    for (int i : p) {
        auto [a, b, w] = edges[i];
        if (w <= c[a][used[a]] + c[b][used[b]]) {
            res++;
            used[a]++;
            used[b]++;
        } else {
            break;
        }
    }
    return res;
}

void solve() {
    int n, g;
    cin >> n >> g;

    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;

        deg[a]++;
        deg[b]++;
        edges[i] = { a, b, w };
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int cij;
            cin >> cij;
            c[i].push_back(cij);
        }
    }

    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    shuffle(p.begin(), p.end(), gen);
    int ans = f(p);

    long double t = 1;
    for (int i = 0; ans != n - 1 && i < 3000; i++) {
        t *= 0.99;
        auto q = p;
        swap(q[get_rand(0, n - 2)], q[get_rand(0, n - 2)]);
        int ansq = f(q);
        if (ansq > ans || magic() < exp((ansq - ans) / t)) {
            p = q;
            ans = ansq;
        }
    }

    if (ans == n - 1) {
        reverse(p.begin(), p.end());
        cout << "Yes\n";
        for (auto i : p) {
            cout << i + 1 << " ";
        }
    } else {
        cout << "No\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}