#include <bits/stdc++.h>

using namespace std;

#define int long long

using ll = long long;
using ld = long double;
using li = __int128;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18;
const int maxn = 2e5 + 10;
const int mod = 1e9 + 7;

struct edge{
    int v, u;
    int w;
    int ind;
};

bool f(vector<vector<int>> &c, vector<int> &ord, vector<edge> &e, int n) {
    vector<int> cur(n, 0);
    for (int i = 0; i < n; ++i) cur[i] = c[i].size() - 1;
    for (int i = 0; i < n - 1; ++i) {
        int j = ord[i];
        if (c[e[j].v][cur[e[j].v]] + c[e[j].u][cur[e[j].u]] < e[j].w) {
            return false;
        }
        cur[e[j].v]--;
        cur[e[j].u]--;
    }
    return true;
}

vector<int> cost(maxn, 0);

bool cmp(edge e1, edge e2) {
    return (cost[e1.u] - e1.w < cost[e2.u] - e2.w);
}

void solve() {
    int n;
    int g;
    cin >> n >> g;
    vector<edge> e(n - 1);
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        cin >> e[i].v >> e[i].u >> e[i].w;
        e[i].v--;
        e[i].u--;
        e[i].ind = i;
        deg[e[i].v]++;
        deg[e[i].u]++;
    }
    //for (int x : deg) cout << x << " ";
    //return;
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int x;
            cin >> x;
            cost[i] = x;
            c[i].push_back(x);
        }
    }
    if (g <= 1) {
        vector<int> ord;
        for (int i = 0; i < n - 1; ++i) {
            ord.push_back(i);
        }
        //return;
        if (f(c, ord, e, n)) {
            cout << "Yes" << endl;
            for (int x : ord) cout << x + 1 << " ";
            return;
        }
        while (next_permutation(ord.begin(), ord.end())) {
            //for (int x : ord) cout << x + 1 << " ";
            //cout << endl;
            if (f(c, ord, e, n)) {
                cout << "Yes" << endl;
                for (int x : ord) cout << x + 1 << " ";
                return;
            }
        }
        cout << "No";
    } else if (g == 2) {
        c[n - 1].push_back(0);
        vector<int> ans(n - 1);
        int l = 0, r = n - 2;
        int cc = c[0][0];
        for (int i = 0; i < n - 1; ++i) {
            if (cc + min(c[i + 1][0], c[i + 1][1]) >= e[i].w) {
                if (c[i + 1][0] > c[i + 1][1]) {
                    ans[l] = i;
                    l++;
                } else {
                    ans[r] = i;
                    r--;
                }
                cc = max(c[i + 1][0], c[i + 1][1]);
            } else if (cc + max(c[i + 1][0], c[i + 1][1]) >= e[i].w) {
                if (c[i + 1][0] < c[i + 1][1]) {
                    ans[l] = i;
                    l++;
                } else {
                    ans[r] = i;
                    r--;
                }
                cc = min(c[i + 1][0], c[i + 1][1]);
            } else {
                cout << "No";
                return;
            }
        }
        cout << "Yes" << endl;
        for (int x : ans) cout << x + 1 << " ";
    } else if (g == 3) {
        vector<pii> p;
        for (int i = 0; i < n - 1; ++i) {
            p.push_back({c[0][i], i});
        }
        sort(p.begin(), p.end());
        sort(e.begin(), e.end(), cmp);
        vector<int> ans(n - 1);
        for (int i = 0; i < n; ++i) {
            if (p[i].first + cost[e[i].u] < e[i].w) {
                cout << "No";
                return;
            }
            ans[n - 1 - p[i].second] = e[i].ind;
        }
        cout << "Yes" << endl;
        for (int x : ans) cout << x + 1 << " ";
        return;
    }


}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    //cin >> ttp;
    while (ttp--) {
        solve();
        cout << endl;
    }
}
