#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n, gr;
    cin >> n >> gr;
    struct edge {
        int v, u, w, i;
    };
    vector<edge> rb;
    vector<int> sz(n);
    vector<set<pair<int, int>>> g(n);
    vector<int> wh(n);
    for (int i = 1; i < n; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        --v, --u;
        if (v > u) swap(v, u);
        rb.push_back({v, u, w, i});
        ++sz[v], ++sz[u];
        g[v].insert({u, i});
        g[u].insert({v, i});
        wh[i] = w;
    }
    sort(rb.rbegin(), rb.rend(), [&](edge& f, edge& s) {
        return f.w < s.w;
    });
    vector<set<pair<int, int>>> c(n);
    for (int v = 0; v < n; ++v) {
        for (int it = 0; it < sz[v]; ++it) {
            int x;
            cin >> x;
            c[v].insert({x, it});
        }
    }
    set<pair<int, int>> deg;
    for (int i = 0; i < n; ++i) {
        deg.insert({sz[i], i});
    }
    vector<int> res;
    while (deg.size()) {
        int v = deg.begin()->second;
        deg.erase(deg.begin());
        if (sz[v] == 0) continue;
        int u = g[v].begin()->first;
        int id = g[v].begin()->second;
        int w = wh[id];
        g[v].erase(g[v].begin());
        g[u].erase({v, id});
        auto j = c[u].lower_bound({w - c[v].begin()->first, -1});
        if (j != c[u].end()) {
            res.push_back(id);
            c[u].erase(j);
            deg.erase({sz[u], u});
            --sz[u];
            deg.insert({sz[u], u});
        } else {
            cout << "No\n";
            return;
        }
    }
    reverse(res.begin(), res.end());
    cout << "Yes\n";
    for (auto& e : res) cout << e << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
