#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    struct edge {
        int to, w, i;
    };
    struct ev {
        int x, i;
    };
    
    
    int n, g;
    cin >> n >> g;
    vector<vector<edge>> gr(n, vector<edge> (0));
    for (int i = 1; i < n; i++) {
        int u, v, w; cin >> u >> v >> w; u--;--v;
        gr[u].push_back({v, w, i}); gr[v].push_back({u, w, i});
    }

    vector<set<pair<int, int>>> al(n);
    for (int v = 0; v < n; v++) {
        for (int i = 0; i < gr[v].size(); i++) {
            int x; cin >> x;
            al[v].insert({x, i});
        }
        // sort(al[v].begin(), al[v].end(), [&](ev i, ev j) {
        //     return (i.x < j.x);
        // });
    }

    auto dfs1 = [&](auto dfs, int v, int p) -> void {
        for (int i = 0; i < gr[v].size(); i++) {
            if (gr[v][i].to == p) {
                gr[v].erase(gr[v].begin() + i);
                break;
            }
        }

        for (auto [to, w, i] : gr[v]) {
            dfs(dfs, to, v);
        }
    };

    dfs1(dfs1, 0, -1);

    // for (auto el : gr) cout << el.size() << endl;

    struct elem {
        int p1, ind, to;
    };

    vector<vector<elem>> anses(n, vector<elem> (0));

    auto dfs2 = [&](auto dfs, int v, int p) -> void {
        if (gr[v].size() == 0) return;

        sort(gr[v].begin(), gr[v].end(), [&](edge i, edge j) -> int {
            return (i.w - al[i.to].begin()->first < j.w - al[j.to].begin()->first);
        });

        for (auto [to, w, i] : gr[v]) {
            dfs(dfs, to, v);
        }

        for (int i = 0; i < gr[v].size(); i++) {
            auto [to, w, t] = gr[v][i];
            int tm = w - al[to].begin()->first;
            auto it = al[v].upper_bound({tm, -1});

            if (it == al[v].end()) {
                cout << "No" << endl;
                exit(0);
            } else {
                anses[v].push_back({it->second, t, to});
                al[v].erase(it);
            }
            // if (al[v][i].x + al[to].begin()->first >= w) {
            //     anses[v].push_back({al[v][i].i, t});

            //     // cout << "went" << " " << v << " -> " << to << endl;
            // } else {

            //     cout << "! " << v + 1 << " -> " << to + 1 << endl;
            //     cout << "No" << endl;
            //     exit(0);
            // }
        }
    };

    dfs2(dfs2, 0, -1);

    for (int v = 0; v < n; v++) {
        sort(anses[v].begin(), anses[v].end(), [&](elem i, elem j) {
            return (i.p1 > j.p1);
        });
    }

    // for (int v = 0; v < n; v++) {
    //     cout << v << " | ";
    //     for (auto [p1, ind, to] : anses[v]) {
    //         cout << "| " << p1 << " " << ind << " " << to << " | ";
    //     }
    //     cout << endl;
    // }
    
    cout << "Yes" << endl;
    vector<int> ans;
    auto dfs3 = [&](auto dfs, int v, int p, int j) -> void {
        int ok = 0;
        int e = gr[v].size();
        for (auto [p1, i, to] : anses[v]) {
            if (p1 != e && ok == 0 && j != -1) {
                ok = 1;
                // cout << j << " ";
                ans.push_back(j);
            }
            dfs(dfs, to, v, i);
            e--;

            // cout << v << " " << to << " " << i << endl;
        }

        if (!ok && j != -1) {
            // cout << j << " ";
            ans.push_back(j);
        }
    };

    dfs3(dfs3, 0, -1, -1);
    // reverse(ans.begin(), ans.end());
    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}