#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;
auto start = clock();

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, g;
    cin >> n >> g;
    vector<int> deg(n + 1);
    vector<tuple<int, int, int>> A;
    vector<vector<int>> stickers(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        deg[a]++, deg[b]++;
        A.emplace_back(a, b, w);
    }
    for (int i = 1; i <= n; i++) {
        stickers[i].resize(deg[i]);
        for (int &x: stickers[i]) cin >> x;
        reverse(stickers[i].begin(), stickers[i].end());
    }
    vector<int> order;
    for (int i = 0; i < n - 1; i++) order.push_back(i);

    if (g == 3) {
        vector<pair<int, int>> W;
        for (int i = 0; i < n; i++) {
            auto [a, b, w] = A[i];
            W.emplace_back(w, i);
        }
        sort(order.begin(), order.end(), [&](int a, int b) {
            return stickers[1][a] < stickers[1][b];
        });
        sort(W.begin(), W.end());
        vector<int> answer(n - 1);
        for (int i = 0; i < n - 1; i++) {
            answer[order[i]] = W[i].second;
        }
        bool flag = true;
        vector<int> stick_pos(n + 1, -1);
        for (int p: order) {
            auto [a, b, w] = A[p];
            stick_pos[a]++, stick_pos[b]++;
            if (stickers[a][stick_pos[a]] + stickers[b][stick_pos[b]] < w) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES\n";
            for (int x: order) {
                cout << x + 1 << " ";
            }
        } else {
            cout << "NO";
        }
        return 0;
    }

    do {
        bool flag = true;
        vector<int> stick_pos(n + 1, -1);
        for (int p: order) {
            auto [a, b, w] = A[p];
            stick_pos[a]++, stick_pos[b]++;
            if (stickers[a][stick_pos[a]] + stickers[b][stick_pos[b]] < w) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES\n";
            for (int x: order) {
                cout << x + 1 << " ";
            }
            return 0;
        }
    } while (clock() < CLOCKS_PER_SEC * 1.95 && next_permutation(order.begin(), order.end()));
    cout << "NO";
    return 0;
}
/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3
*/