#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef int ll;

const ll inf = 1e9;
const ll mxn = 2 * 1e5 + 1;

struct node {
    ll k1, k2, k3;
};

vector<node> g[mxn];
ll was[mxn];
set<pair<ll, ll>> k[mxn];
ll p[mxn];
vector<ll> v2[mxn];
vector<ll> v3[mxn];

ll dfs(ll v) {
    was[v] = 1;
    ll col = 0;
    vector<ll> res3(k[v].size(), -1);
    vector<ll> res4(k[v].size(), -1);
    for(int i = 0; i < g[v].size(); i++) {
        if (was[g[v][i].k1] == 0) {
            p[g[v][i].k1] = g[v][i].k3;
            col++;
            ll res1 = dfs(g[v][i].k1);
            ll need = g[v][i].k2 - res1;
            auto it = lower_bound(k[v].begin(), k[v].end(), pair<ll, ll>{need, -inf});
            if (it == k[v].end()) {
                cout << "No";
                exit(0);
            }
            pair<ll, ll> a1 = *it;
            k[v].erase(k[v].find(a1));
            res3[a1.second] = g[v][i].k1;
            res4[a1.second] = g[v][i].k3;
        }
    }
    swap(v2[v], res3);
    swap(v3[v], res4);
    return (*k[v].begin()).first;
}

void dfs1(ll v, ll ind) {
    was[v] = 1;
    ll ok = 0;
    for(int i = 0; i < v2[v].size(); i++) {
        if (v2[v][i] == -1) {
            ok = 1;
            cout << ind + 1 << " ";
            continue;
        }
        if (was[v2[v][i]] == 0) {
            dfs1(v2[v][i], v3[v][i]);
        }
    }
    if (!ok && ind != -1) cout << ind + 1 << " ";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, g1; cin >> n >> g1;
    for(int i = 0 ; i < n - 1; i++) {
        ll a, b, c; cin >> a >> b >> c;
        a--; b--;
        g[a].push_back({b, c, i});
        g[b].push_back({a, c, i});
    }
    for(int i = 0; i < n; i++) {
        ll col = g[i].size();
        for(int j = 0; j < col; j++) {
            ll y1; cin >> y1;
            k[i].insert({y1, col - j - 1});
        }
    }
    dfs(0);
    for(int i = 0; i < mxn; i++) was[i] = 0;
    cout << "Yes\n";
    dfs1(0, -1);
    return 0;
}
