#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, G;
  cin >> n >> G;
  vector<int> x(n - 1), y(n - 1), z(n - 1);
  vector<int> deg(n);
  for (int i = 0; i < n - 1; ++i) {
    cin >> x[i] >> y[i] >> z[i];
    --x[i], --y[i];
    deg[x[i]] += 1;
    deg[y[i]] += 1;
  }
  vector<vector<int>> c(n);
  for (int i = 0; i < n; ++i) {
    c[i].resize(deg[i]);
    for (int j = 0; j < deg[i]; ++j) {
      cin >> c[i][j];
    }
    reverse(c[i].begin(), c[i].end());
  }
  if (G <= 1) {
    vector<int> order(n - 1);
    iota(order.begin(), order.end(), 0);
    do {
      vector<int> ptr(n);
      bool ok = true;
      for (int i: order) {
        if (c[x[i]][ptr[x[i]]] + c[y[i]][ptr[y[i]]] < z[i]) {
          ok = false;
          break;
        }
        ptr[x[i]] += 1;
        ptr[y[i]] += 1;
      }
      if (ok) {
        cout << "Yes\n";
        for (int i: order) {
          cout << i + 1 << ' ';
        }
        return;
      }
    } while (next_permutation(order.begin(), order.end()));
    cout << "No";
    return;
  }
  if (G == 2) {
    vector<vector<int>> g(n - 1);
    vector<array<int, 2>> ban(n);
    for (int i = 0; i < n - 1; ++i) {
      for (int j = 0; j < 2; ++j) {
        if (!ban[i][j]) {
          int t1 = j;
          int t2 = 0;
          if (c[i + 1].size() == 2) {
            if (c[i][t1] + c[i + 1][0] < z[i]) {
              t2 = 1;
            } else if (c[i + 1][1] <= c[i + 1][0] && c[i][t1] + c[i + 1][1] >= z[i]) {
              t2 = 1;
            }
          }
          if (c[i][t1] + c[i + 1][t2] < z[i]) {
            cout << "No";
            return;
          }
          ban[i + 1][t2] = 1;
          if (c[i].size() > 1) {
            if (t1 == 0) {
              g[i].push_back(i - 1);
            } else {
              g[i - 1].push_back(i);
            }
          }
          break;
        }
      }
    }
    vector<int> order, used(n - 1);

    function<void(int)> Dfs = [&](int v) {
      used[v] = 1;
      for (int u : g[v]) {
        if (!used[u]) {
          Dfs(u);
        }
      }
      order.push_back(v);
    };

    for (int v = 0; v < n - 1; ++v) {
      if (!used[v]) {
        Dfs(v);
      }
    }
    reverse(order.begin(), order.end());
    cout << "Yes\n";
    for (int i : order) {
      cout << i + 1 << ' ';
    }
    return;
  }
  cout << "No";
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
