#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, G;
  cin >> n >> G;
  vector<int> x(n - 1), y(n - 1), z(n - 1);
  vector<int> deg(n);
  for (int i = 0; i < n - 1; ++i) {
    cin >> x[i] >> y[i] >> z[i];
    --x[i], --y[i];
    if (x[i] > y[i]) swap(x[i], y[i]);
    deg[x[i]] += 1;
    deg[y[i]] += 1;
  }
  vector<vector<int>> c(n);
  for (int i = 0; i < n; ++i) {
    c[i].resize(deg[i]);
    for (int j = 0; j < deg[i]; ++j) {
      cin >> c[i][j];
    }
    reverse(c[i].begin(), c[i].end());
  }
  if (G <= 1) {
    vector<int> order(n - 1);
    iota(order.begin(), order.end(), 0);
    do {
      vector<int> ptr(n);
      bool ok = true;
      for (int i: order) {
        if (c[x[i]][ptr[x[i]]] + c[y[i]][ptr[y[i]]] < z[i]) {
          ok = false;
          break;
        }
        ptr[x[i]] += 1;
        ptr[y[i]] += 1;
      }
      if (ok) {
        cout << "Yes\n";
        for (int i: order) {
          cout << i + 1 << ' ';
        }
        return;
      }
    } while (next_permutation(order.begin(), order.end()));
    cout << "No";
    return;
  }
  if (G == 2) {
    vector<vector<int>> g(n - 1);
    vector<array<int, 2>> ban(n);
    for (int i = 0; i < n - 1; ++i) {
      for (int j = 0; j < 2; ++j) {
        if (!ban[i][j]) {
          int t1 = j;
          int t2 = 0;
          if (c[i + 1].size() == 2) {
            if (c[i][t1] + c[i + 1][0] < z[i]) {
              t2 = 1;
            } else if (c[i + 1][1] <= c[i + 1][0] && c[i][t1] + c[i + 1][1] >= z[i]) {
              t2 = 1;
            }
          }
          if (c[i][t1] + c[i + 1][t2] < z[i]) {
            cout << "No";
            return;
          }
          ban[i + 1][t2] = 1;
          if (c[i].size() > 1) {
            if (t1 == 0) {
              g[i].push_back(i - 1);
            } else {
              g[i - 1].push_back(i);
            }
          }
          break;
        }
      }
    }
    vector<int> order, used(n - 1);

    function<void(int)> Dfs = [&](int v) {
      used[v] = 1;
      for (int u : g[v]) {
        if (!used[u]) {
          Dfs(u);
        }
      }
      order.push_back(v);
    };

    for (int v = 0; v < n - 1; ++v) {
      if (!used[v]) {
        Dfs(v);
      }
    }
    reverse(order.begin(), order.end());
    cout << "Yes\n";
    for (int i : order) {
      cout << i + 1 << ' ';
    }
    return;
  }
  if (G == 3) {
    set<pair<int, int>> a;
    for (int i = 0; i < n - 1; ++i) {
      a.emplace(c[0][i], i);
    }
    vector<int> pos(n);
    for (int i = 1; i < n; ++i) {
      auto it = a.lower_bound(make_pair(z[i - 1] - c[i][0], 0));
      if (it == a.end()) {
        cout << "No";
        return;
      }
      int id = it->second;
      a.erase(it);
      pos[i] = id;
    }
    vector<int> rpos(n - 1);
    for (int i = 1; i < n; ++i) {
      rpos[pos[i]] = i;
    }
    cout << "Yes\n";
    for (int i : rpos) {
      cout << i << ' ';
    }
    return;
  }
  if (G == 5) {
    for (int i = 0; i < n; ++i) {
      reverse(c[i].begin(), c[i].end());
    }
    vector<int> order;
    vector<int> ptr(n);
    vector<int> take(n - 1);
    for (int t = 0; t < n - 1; ++t) {
      bool found = false;
      for (int i = 0; i < n - 1; ++i) {
        if (take[i]) {
          continue;
        }
        if (c[x[i]][ptr[x[i]]] + c[y[i]][ptr[y[i]]] >= z[i]) {
          take[i] = 1;
          ptr[x[i]] += 1;
          ptr[y[i]] += 1;
          order.push_back(i);
          found = true;
          break;
        }
      }
      if (!found) {
        cout << "No";
        return;
      }
    }
    reverse(order.begin(), order.end());
    cout << "Yes\n";
    for (int i : order) {
      cout << i + 1 << ' ';
    }
    return;
  }
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < n - 1; ++i) {
    g[x[i]].emplace_back(y[i], i);
    g[y[i]].emplace_back(x[i], i);
  }
  vector<set<pair<int, int>>> s(n);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < deg[i]; ++j) {
      s[i].emplace(c[i][j], j);
    }
  }
  vector<vector<int>> who(n);
  for (int i = 0; i < n; ++i) {
    who[i].resize(deg[i], -1);
  }
  function<void(int, int)> Dfs = [&](int v, int p) {
    for (auto [u, id] : g[v]) {
      if (u != p) {
        Dfs(u, v);
        assert(s[u].size() == 1);
        auto [valU, idU] = *s[u].begin();
        auto it = s[v].lower_bound(make_pair(z[id] - valU, 0));
        if (it == s[v].end()) {
          cout << "No";
          exit(0);
        }
        auto [valV, idV] = *it;
        s[v].erase(it);
        who[v][idV] = who[u][idU] = id;
      }
    }
  };
  Dfs(0, 0);
  vector<vector<int>> gg(n - 1);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < deg[i] - 1; ++j) {
      gg[who[i][j]].push_back(who[i][j + 1]);
    }
  }
  vector<int> used(n - 1), order;

  function<void(int)> Dfs2 = [&](int v) {
    used[v] = 1;
    for (int u : gg[v]) {
      if (!used[u]) {
        Dfs2(u);
      }
    }
    order.push_back(v);
  };

  for (int v = 0; v < n - 1; ++v) {
    if (!used[v]) {
      Dfs2(v);
    }
  }
  reverse(order.begin(), order.end());
  cout << "Yes\n";
  for (int i : order) {
    cout << i + 1 << ' ';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
