#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, group;
        cin >> n >> group;
        vector<pair<pair<int, int>, int>> edges(n - 1);
        vector<int> deg(n, 0);
        for (auto &it: edges) {
            int a, b, w;
            cin >> a >> b >> w;
            a--;
            b--;
            it = {{a, b}, w};
            deg[a]++;
            deg[b]++;
        }
        vector<vector<int>> cs(n);
        for (int v = 0; v < n; ++v) {
            cs[v].resize(deg[v]);
            for (auto &it: cs[v])
                cin >> it;
        }
        if (group == 1)
            return solve_nleq10(n, edges, deg, cs);
        multiset<pair<int, int>> degs;
        for (int i = 0; i < deg[0]; ++i)
            degs.insert({cs[0][i], n - i});
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            int u = i + 1;
            int mxcv = edges[i].second - cs[u][0];
            auto it = degs.lower_bound({mxcv, -1});
            if (it == degs.end()) {
                cout << "No\n";
                return 0;
            }
            ans.push_back({it->second, i});
            degs.erase(it);
        }
        rng::sort(ans);
        cout << "Yes\n";
        for (auto& it : ans)
            cout << it.second + 1 << " ";
        cout << ent;
        return 0;
    }

//    4 0
//    1 2 1
//    1 3 1
//    1 4 1
//    3 2 1
//    5
//    4
//    3

    int
    solve_nleq10(int n, const vector<pair<pair<int, int>, int>> &edges, vector<int> &deg,
                 const vector<vector<int>> &cs) const {
        vector<int> ord(n - 1);
        iota(ord.begin(), ord.end(), 0);
        do {
            deg.assign(n, 0);
            bool ok = true;
            for (int i: ord) {
                int a = edges[i].first.first;
                int b = edges[i].first.second;
                int w = edges[i].second;
                if (cs[a][deg[a]++] + cs[b][deg[b]++] < w) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                rng::reverse(ord);
                cout << "Yes\n";
                for (auto &it: ord)
                    cout << it + 1 << " ";
                cout << "\n";
                return 0;
            }
        } while (rng::next_permutation(ord).found);
        cout << "No\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}

