#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, group;
        cin >> n >> group;
        vector<pair<pair<int, int>, int>> edges(n - 1);
        vector<int> deg(n, 0);
        for (auto &it: edges) {
            int a, b, w;
            cin >> a >> b >> w;
            a--;
            b--;
            it = {{a, b}, w};
            deg[a]++;
            deg[b]++;
        }
        vector<vector<int>> cs(n);
        for (int v = 0; v < n; ++v) {
            cs[v].resize(deg[v]);
            for (auto &it: cs[v])
                cin >> it;
        }
        if (
#ifndef ILKRAS
group == 0 ||
#endif
group == 1)
            return solve_nleq10(n, edges, deg, cs);
        array<multiset<pair<int, int>>, 2> degs;
        for (int i = 0; i < deg[0]; ++i)
            degs[0].insert({cs[0][i], deg[0] - i - 1});
        for (int i = 0; i < deg[1]; ++i)
            degs[1].insert({cs[1][i], deg[1] - i - 1});
        array<vector<pair<int, int>>, 2> ans;
        auto iter = [&](int i) -> bool {
            int v = edges[i + 1].first.first;
            if (v > 1) {
                return false;
            }
            int u = i + 1;
            int mxcv = edges[i].second - cs[u][0];
            auto it = degs[v].lower_bound({mxcv, -1});
            if (it == degs[v].end()) {
                cout << "No\n";
                return false;
            }
            ans[v].push_back({it->second, i});
            degs[v].erase(it);
            return true;
        };
        
        for (int i = 1; i < n - 1; ++i) {
            if (!iter(i)) {
                return 0;
            }
        }

        int w1 = degs[0].begin()->first;
        int w2 = degs[1].begin()->first;

        if (w1 + w2 < edges[0].second) {
            cout << "No\n";
            return 0;
        }

        int pos0 = 0;
        int pos1 = 0;

        rng::sort(ans[0]);
        rng::sort(ans[1]);

        cout << "Yes\n";

        for (; pos0 < ans[0].size() && pos0 == ans[0][pos0].first; ++pos0) {
            cout << ans[0][pos0].second + 1 << " ";
        }
        for (; pos1 < ans[1].size() && pos1 == ans[1][pos1].first; ++pos1) {
            cout << ans[1][pos1].second + 1 << " ";
        }

        cout << 1 << " ";

        for (; pos0 < ans[0].size(); ++pos0) {
            cout << ans[0][pos0].second + 1 << " ";
        }
        for (; pos1 < ans[1].size(); ++pos1) {
            cout << ans[1][pos1].second + 1 << " ";
        }

        cout << ent;
        return 0;
    }
//
//    4 0
//    1 2 1
//    1 3 1
//    1 4 1
//    3 2 1
//    5
//    4
//    3

//
//    4 0
//    1 2 1
//    1 3 1
//    2 4 1
//    3 2
//    5 1
//    4
//    3

    int
    solve_nleq10(int n, const vector<pair<pair<int, int>, int>> &edges, vector<int> &deg,
                 const vector<vector<int>> &cs) const {
        vector<int> ord(n - 1);
        iota(ord.begin(), ord.end(), 0);
        do {
            deg.assign(n, 0);
            bool ok = true;
            for (int i: ord) {
                int a = edges[i].first.first;
                int b = edges[i].first.second;
                int w = edges[i].second;
                if (cs[a][deg[a]++] + cs[b][deg[b]++] < w) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                rng::reverse(ord);
                cout << "Yes\n";
                for (auto &it: ord)
                    cout << it + 1 << " ";
                cout << "\n";
                return 0;
            }
        } while (rng::next_permutation(ord).found);
        cout << "No\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}

