#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;
typedef long double ld;

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 2E5, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr uint32_t MAXC = 1E9;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t RND_SEED = 7200;
mt19937_64 rnd(RND_SEED);

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

set <pair <int, int>> nak[MAXN];
int deg[MAXN], par[MAXN], ind_edg[MAXN];
vector <pair <int, pair <int, int>>> cn_dop[MAXN];
struct Edge
{
	int u, v, w;
	Edge(int u = 0, int v = 0, int w = 0) :u(u), v(v), w(w) {}
};
vector <Edge> edges;
vector <int> av_edg;
bool used_edg[MAXN - 1];

void check_ver(int v)
{
	if (deg[v] == cn_dop[v].size())
	{
		return;
	}
	int cur_ind = cn_dop[v][deg[v]].first, nxt = cn_dop[v][deg[v]].second.first, need = cn_dop[v][deg[v]].second.second;
	if (!used_edg[cur_ind] and deg[nxt] == need)
	{
		used_edg[cur_ind] = true;
		av_edg.push_back(cur_ind);
	}
}

void solve()
{
	int n, num_g;
	cin >> n >> num_g;
	for (int i = 0; i < n - 1; i++)
	{
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;

		edges.push_back(Edge(u, v, w));
		++deg[u];
		++deg[v];
		par[u] ^= v;
		ind_edg[u] ^= i;
		par[v] ^= u;
		ind_edg[v] ^= i;
	}
	for (int i = 0; i < n; i++)
	{
		cn_dop[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; j++)
		{
			int c;
			cin >> c;
			nak[i].insert({ c, deg[i] - j - 1 });
		}
	}

	vector <int> lists;
	for (int i = 0; i < n; i++)
	{
		if (deg[i] == 1)
		{
			lists.push_back(i);
		}
	}
	for (int it = 0; it < n - 1; it++)
	{
		int cur = lists.back();
		lists.pop_back();

		int t_ind = ind_edg[cur], t_par = par[cur];
		auto nak_it = nak[t_par].lower_bound(make_pair(edges[t_ind].w - nak[cur].begin()->first, 0));
		if (nak_it == nak[t_par].end())
		{
			cout << "No";
			return;
		}

		int cur_need = nak[cur].begin()->second, par_need = nak_it->second;
		cn_dop[t_par][par_need] = { t_ind, { cur, cur_need } };
		nak[t_par].erase(nak_it);
		par[t_par] ^= cur;
		ind_edg[t_par] ^= t_ind;
		--deg[t_par];

		cn_dop[cur][cur_need] = { t_ind, { t_par, par_need } };
		nak[cur].erase(nak[cur].begin());
		par[cur] ^= t_par;
		ind_edg[cur] ^= t_ind;
		--deg[cur];

		if (deg[t_par] == 1)
		{
			lists.push_back(t_par);
		}
	}

	for (int i = 0; i < n; i++)
	{
		check_ver(i);
	}

	cout << "Yes" << endl;
	while (!av_edg.empty())
	{
		int ind = av_edg.back();
		av_edg.pop_back();
		cout << ind + 1 << ' ';
		int u = edges[ind].u, v = edges[ind].v;
		++deg[u];
		++deg[v];
		check_ver(u);
		check_ver(v);
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}