#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

void solve() {
    int n, g;
    cin >> n >> g;
    vector<int> w(n - 1);
    for (int i = 0; i + 1 < n; i++) {
        int a, b, wg;
        cin >> a >> b >> wg;
        a--;
        b--;
        w[a] = wg;
    }
    vector<vector<int>> lst(n);
    for (int i = 0; i < n; i++) {
        if (i == 0 || i == n - 1) {
            lst[i].assign(1, 0);
        } else {
            lst[i].assign(2, 0);
        }
        cin >> lst[i];
    }
    int prev_idx = 0;
    vector<pp> ans(n - 1);
    for (int i = 0; i + 2 < n; i++) {
        int rq = w[i] - lst[i][prev_idx];
        int min_idx = min_element(lst[i + 1].begin(), lst[i + 1].end()) - lst[i + 1].begin();
        int max_idx = 1 - min_idx;
        if (lst[i + 1][min_idx] >= rq) {
            ans[i] = {prev_idx, min_idx};
            //cout << prev_idx << ' ' << min_idx << '\n';
            prev_idx = max_idx;
        } else if (lst[i + 1][max_idx] >= rq) {
            ans[i] = {prev_idx, max_idx};
            //cout << prev_idx << ' ' << max_idx << '\n';
            prev_idx = min_idx;
        } else {
            cout << "No";
            return;
        }
    }
    if (w[n - 2] > lst[n - 1][0] + lst[n - 2][prev_idx]) {
        cout << "No";
        return;
    }
    ans[n - 2] = {prev_idx, 0};
    //cout << ans << endl;
    vector<vector<int>> graph(n - 1);
    for (int i = 0; i + 1 < n - 1; i++) {
        if (ans[i].second > ans[i + 1].first) {
            graph[i].push_back(i + 1);
        } else {
            graph[i + 1].push_back(i);
        }
    }
    vector<bool> used(n - 1);
    vector<int> tout(n - 1);
    int timer = 0;
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (int to: graph[v]) {
            if (!used[to]) {
                dfs(to);
            }
        }
        tout[v] = timer++;
    };
    for (int i = 0; i < n - 1; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    vector<int> seq(n - 1);
    iota(seq.begin(), seq.end(), 0);
    sort(seq.begin(), seq.end(), [&](int a, int b) { return tout[a] > tout[b]; });
    cout << "Yes\n";
    for (int el: seq) {
        cout << el + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
