#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

const int MAXN = 1 << 18, LOGN = 18, LOGV = 30;

const ll INF = 1ll << 60;

struct Edge {
    ll a, b, w, id;

    Edge() = default;

    Edge(ll A, ll B, ll W, ll Id) {
        a = A, b = B, w = W, id = Id;
    }

    bool operator<(Edge E) const {
        if (a != E.a)
            return a < E.a;
        else
            return b < E.b;
    }
};

vector<pll> g[MAXN];
set<pll> dirs[MAXN]; // { c, id }
vector<int> ordD[MAXN]; // { to } in order of c
int ptr[MAXN]; // id of next edge in ord

set<Edge> ES; // Edge set

void fail() {
    cout << "NO\n";
    exit(0);
}

bool failed = false;

ll dfs1(int v, int p, ll pw) {
    for (auto [u, w]: g[v])
        if (u != p) {
            ll minCC = dfs1(u, v, w);
            if (dirs[v].empty())
                fail();
            auto conn = dirs[v].lower_bound({minCC, -1});
            if (conn == dirs[v].end())
                fail();
            ordD[v][conn->second] = u;
            dirs[v].erase(conn);
        }
    if (v == p)
        return -1;
    if (dirs[v].size() != 1)
        fail();
    ll lastC = dirs[v].begin()->first;
    ordD[v][dirs[v].begin()->second] = p;
    ll minPC = pw - lastC;
    return minPC;
}

vector<int> Eord;

void dfs2(int v, int p) { // links edges until meets par
    auto &pt = ptr[v];
    for (; pt < g[v].size(); ++pt) {
        int u = ordD[v][pt];

        if (u == p) {
            pt++;
            return;
        }

        dfs2(u, v); // sure? cycle?

        int eid = ES.find({u, v, 0, 0})->id; // fail?
        Eord.push_back(eid);

    }


}

void solve() {
    int n, gi;
    cin >> n >> gi;
    vector<Edge> E;
    for (int i = 0; i < n - 1; ++i) {
        ll ta, tb, tw;
        cin >> ta >> tb >> tw;
        ta--, tb--;
        E.emplace_back(ta, tb, tw, i);
        ES.insert(E.back());
        swap(E.back().a, E.back().b);
        ES.insert(E.back());

        g[ta].emplace_back(tb, tw);
        g[tb].emplace_back(ta, tw);

    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < g[i].size(); ++j) {
            ll cc;
            cin >> cc;
            dirs[i].insert({cc, j});
            ordD[i].resize(g[i].size());
        }
    dfs1(0, 0, 0);
    fill(ptr, ptr + MAXN, 0);
    for (int i = 0; i < n; ++i)
        dfs2(i, -1);

    reverse(Eord.begin(), Eord.end());
    cout << "YES\n";
    for (auto i: Eord)
        cout << i + 1 << ' ';
    cout << endl;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
