#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct Edge{
    int v, u, w, id;
};
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, G;
    cin >> n >> G;
    vector<Edge> e(n-1);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        e[i] = {a, b, c, i};
        deg[a]++;
        deg[b]++;
    }
    vector<vector<int>> stick(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int v;
            cin >> v;
            stick[i].push_back(v);
        }
        reverse(stick[i].begin(), stick[i].end());
    }
    if (G == 1) {
        vector<int> order(n - 1);
        iota(order.begin(), order.end(), 0);
        do {
            vector<int> cur(n, 0);
            int good = 1;
            for (int i = 0; i < n - 1; i++) {
                int id = order[i];
                int a = e[id].v;
                int b = e[id].u;
                if (cur[b] >= stick[b].size() || cur[a] >= stick[a].size()) {
                    good = 0;
                    break;
                }
                if (stick[a][cur[a]] + stick[b][cur[b]] >= e[id].w) {
                    cur[a]++;
                    cur[b]++;
                } else {
                    good = 0;
                    break;
                }
            }
            if (good) {
                cout << "Yes\n";
                for (int i = 0; i < n - 1; i++) cout << order[i] + 1 << " ";
                return 0;
            }
        } while (next_permutation(order.begin(), order.end()));
        cout << "No\n";
    } else {
        set<pair<int, int>> order;
        for (int i = 0; i < n - 1; i++) {
            order.insert({e[i].w - stick[e[i].u][0], e[i].id});
        }
        vector<int> out;
        for (int i = 0; i < n - 1; i++) {
            int val = stick[0][i];
            auto it = order.upper_bound({val, 1e9});
            if (it == order.begin()) {
                cout << "No\n";
                return 0;
            }
            it = prev(it);
            out.push_back(it->second);
            order.erase(it);
        }
        cout << "Yes\n";
        for (int i = 0; i < n - 1; i++) cout << out[i] + 1 << " ";
        return 0;
    }
}
