//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <vector>
using namespace std;




using ll = long long;



#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()



const int N = 2e5 + 10, INF = 1e9 + 10;

using pii = pair<int, int>;

int n, group;


struct Edge {
    int from, to, w;
    Edge() {}
    Edge(int f, int t, int w) : from(f), to(t), w(w) {}
};


vec<int> nums[N], cop[N];
vec<int> g[N];
vec<pii> g2[N];
vec<Edge> edges;
vec<int> ans[N];


void input() {
    cin >> n >> group;
    edges.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int from, to, w;
        cin >> from >> to >> w;
        g[from].eb(to); g2[from].eb(to, i);
        g[to].eb(from); g2[to].eb(from, i);
        edges[i] = {from, to, w};
    }

    for (int i = 1; i <= n; ++i) {
        int siz = sz(g[i]);
        nums[i].resize(siz);
        //cout << i << " " << siz << endl;
        for (auto& it : nums[i]) cin >> it;
    }
}

void no() {
    cout << "No" << endl;
    exit(0);
}

void n10() {
    vec<int> arr(n - 1);
    for (int i = 0; i < n - 1; ++i)
        arr[i] = i;
    for (int i = 1; i <= n; ++i) cop[i] = nums[i];

    do {
//        cout << "arr : ";
//        for (auto& it : arr) cout << it << " "; cout << endl;
        for (int i = 1; i <= n; ++i) nums[i] = cop[i];

        // cout << "-------------------" << endl;

        bool flag = true;
        for (auto& it : arr) {
            auto [from, to, w] = edges[it];
            int x = nums[from].back();
            int y = nums[to].back();
            nums[from].pop_back();
            nums[to].pop_back();
            // cout << x << " " << y << " w : " << w << endl;
            if (x + y < w) {
                flag = false;
                break;
            }
        }

        if (flag) {
            cout << "Yes" << endl;
            for (auto &it: arr) cout << it + 1 << " ";
            cout << endl;
            exit(0);
        }
    } while (next_permutation(all(arr)));

    cout << "No" << endl;
    exit(0);
}




void dfs(int v, int pre) {
    if (v != 1)
        g[v].erase(find(all(g[v]), pre));
    for (auto& to : g[v]) {
        dfs(to, v);
    }


    if (g[v].empty()) {
        ans[v] = {v};
        return;
    }

    auto func = [&](const pii& it){
        auto [to, i] = it;

        int num = nums[to].back(); nums[to].pop_back();
        int left = num - edges[i].w;
        return left;
    };

    vec<pii> be;
    for (auto& [to, i] : g2[v])
        if (to != pre)
            be.eb(func(mp(to, i)), to);
    sort(all(be));

    vec<int> order;
    //cout << "nums : "; for (auto& it : nums[v]) cout << it << " "; cout << endl;
    while (sz(nums[v]) != 1 - (v == 1)) {
        int x = nums[v].back();
        nums[v].pop_back();

        auto it = upper_bound(all(be), mp(x, (int)INF));
        if (it == be.begin()) no();
        --it;

        auto [_, to] = *it;
//        cout << "be : ";
//        for (auto& [xx, y] : be) cout << xx << " " << y << endl;
//        cout << endl;
//        cout << "to : " << to << endl;
        order.eb(to);
        be.erase(find(all(be), *it));
    }

    for (auto& to : order) {
        for (auto& it : ans[to])
            ans[v].eb(it);
    }

//    cout << "v : " << v << endl;
//    cout << "order : "; for (auto& it : order) cout << it << " "; cout << endl;
//    for (auto& it : ans[v]) cout << it << " "; cout << endl;
//    cout << "nums : "; for (auto& it : nums[v]) cout << it << " "; cout << endl;
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif


    input();
    if (n <= 10) n10();


    dfs(1, -1);
    cout << "Yes" << endl;
    for (auto& it : ans[1]) cout << it << " "; cout << endl;


}
