#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
const char endc = '\n';

using namespace std;

int n, g;

struct border {
    int a, b;
    ll w;
};

vector<border> borders;
vector<vector<ll>> stickers;
vector<set<int>> blank;
vector<set<pair<ll, int>>> unused;
vector<vector<int>> bidsBy;
vector<vector<int>> g1, g2;

vector<bool> used;

void NO() {
    cout << "No" << endc;
    exit(0);
}

vector<int> answer;

void dfs(int v) {
    used[v] = 1;
    answer.push_back(v);
    for (auto& e : g2[v]) {
        if (used[e]) continue;
        dfs(e);
    }
}

inline void work() {
    cin >> n >> g;
    borders.resize(n);
    stickers.resize(n);
    blank.resize(n);
    unused.resize(n);
    bidsBy.resize(n);
    vector<int> degrees(n, 0);
    for (int i = 0; i < n-1; ++i) {
        cin >> borders[i].a >> borders[i].b >> borders[i].w;
        --borders[i].a;
        --borders[i].b;
        degrees[borders[i].a]++;
        degrees[borders[i].b]++;
        blank[borders[i].a].insert(i);
        blank[borders[i].b].insert(i);
    }
    for (int i = 0; i < n; ++i) {
        int c = degrees[i];
        stickers[i].resize(c);
        bidsBy[i].resize(c, -1);
        for (int j = 0; j < c; ++j) {
            cin >> stickers[i][j];
            unused[i].insert({stickers[i][j], j});
        }
    }
    set<int> leafs;
    for (int i = 0; i < n; ++i) if (stickers[i].size() == 1) leafs.insert(i);
    while (leafs.size() > 0) {
        int leaf = *leafs.begin();
        leafs.erase(leafs.begin());
        if (blank[leaf].size() == 0) continue;
        int borderId = *blank[leaf].begin();
        int other = borders[borderId].a == leaf ? borders[borderId].b : borders[borderId].a;
        blank[leaf].erase(borderId);
        blank[other].erase(borderId);
        auto [leafStickerValue, leafStickerId] = *unused[leaf].begin();
        unused[leaf].clear();
        ll needWeight = borders[borderId].w - leafStickerValue;
        auto it = unused[other].lower_bound({needWeight, -1});
        if (it == unused[other].end()) NO();
        auto [otherStickerValue, otherStickerId] = *it;
        unused[other].erase(it);
        if (blank[other].size() == 1) leafs.insert(other);
        bidsBy[leaf][leafStickerId] = borderId;
        bidsBy[other][otherStickerId] = borderId;
    }
    g1.resize(n-1);
    g2.resize(n-1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < int(bidsBy[i].size()) - 1; ++j) {
            int a = bidsBy[i][j], b = bidsBy[i][j+1];
            g1[a].push_back(b);
            g2[b].push_back(a);
        }
    }
    used.resize(n-1, 0);
    for (int i = 0; i < n-1; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(answer.begin(), answer.end());
    cout << "Yes" << endc;
    for (auto& e : answer) cout << e+1 << endc;
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t-- > 0) work();
}
