//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Point{
    ld x, y;

    Point() = default;

    Point(ld x, ld y): x(x), y(y){}

    ld sqr_len(){
        return x * x + y * y;
    }

    ld len(){
        return sqrtl(sqr_len());
    }
};

ld operator*(Point a, Point b){
    return a.x * b.x + a.y * b.y;
}

ld operator%(Point a, Point b){
    return a.x * b.y - a.y * b.x;
}

Point operator+(Point a, Point b){
    return Point(a.x + b.x, a.y + b.y);
}

Point operator-(Point a, Point b){
    return Point(a.x - b.x, a.y - b.y);
}

istream& operator>>(istream& in, Point& a){
    in >> a.x >> a.y;
    return in;
}

struct segtree{
    vector<ll> tree;
    int size;

    void push(int v, int vl, int vr){

    }


    void init(int n){
        size = 1;
        while(size < n)
            size++;
        tree.assign(size * 2 - 1, 0);
    }


};

struct dsu{
    vector<int> par, size;

    void init(int n){
        for(int i = 0; i < n; i++){
            par.push_back(i);
            size.push_back(1);
        }
    }

    bool get(int v) {
        if (v == par[v])
            return v;
        return par[v] = get(par[v]);
    }

    bool union_sets(int v, int u){
        v = get(v), u = get(u);
        if(v == u)
            return false;
        if(size[v] < size[u])
            swap(u,v);
        size[v] += size[u];
        par[u] = v;
        size[u] = 0;
    }
};

bool kuhn(int v){
    return false;
}

struct fenwick{
    vector<ll> tree, ar;
    int size;

    void init(vector<ll>& a){
        ar = a;
        size = a.size() + 1;
        tree.assign(a.size() + 1, 0);
    }

    void change(int i, ll x){
        for(int j = i; j < size; j += j & -j){
            tree[j] += x;
        }
    }

    void set(int i, ll x){
        change(i, ar[i - 1] - x);
        ar[i - 1] = x;
    }

    ll get(int i){
        ll res = 0;
        for(int j = i; j > 0; j -= j & -j)
            res += tree[j];
        return res;
    }

    ll get(int l, int r){
        return get(r) - get(l - 1);
    }
};

map<pair<int, int>, int> inds;
vector<vector<pair<ll, int>>> stickers;
vector<vector<int>> ans;
vector<pair<int, int>> edges;
vector<int> seq;
void dfs(int v, vector<vector<pair<int, ll>>>& g, int p = -1){
    if(p != -1) {
        if (g[v].size() == 1) {
            return;
        }
    }
        for(auto to : g[v]){
            if(to.first != p)
                dfs(to.first, g, v);
        }
        vector<vector<int>> ranges(g[v].size());
        for(auto to : g[v]){
            if(to.first == p)
                continue;
            ll w = to.second, c = stickers[to.first][0].first;
            int l = -1, r = stickers[v].size();
            while(r - l > 1){
                int m = (r + l) / 2;
                if(c + stickers[v][m].first >= w)
                    r = m;
                else
                    l = m;
            }
            if(r == stickers[v].size()){
                cout<<"No";
                exit(0);
            }
            ranges[r].push_back(to.first);
        }
        vector<int> used(g[v].size(), -1);
        int right = 0;
        for(int i = 0; i < g[v].size(); i++){
            for(auto b : ranges[i]){
                right = max(right, i);
                while (right < g[v].size() && used[right] != -1)
                    right++;
                if(right == g[v].size()){
                    cout<<"No";
                    exit(0);
                }
                used[right] = inds[{v, b}];
            }
        }
        auto pred_c = stickers[v][0];
        for(int i = 0 ; i<g[v].size();i++){
            if(used[i] == -1) {
                pred_c = stickers[v][i];
                if(p != -1){
                    used[i] = inds[{p, v}];
                }
            }
        }
        ans[v] = used;
        stickers[v] = {pred_c};
}

int index_higher = -1;
void dfs1(vector<vector<pair<ll, int>>>& st1, int v, int p = -1){
    vector<int> order(st1[v].size());
    if(st1[v].size() == 1 && p != -1) {
        return;
    }
    for(int i = 0; i < st1[v].size(); i++){
        order[st1[v][i].second] = ans[v][i];
    }

    for(int i = st1[v].size() - 1; i > -1; i--){
        int index = order[i] - 1;
        int a = edges[index].first, b = edges[index].second;
        if(a != v)
            swap(a,b);
        if(b == p) {
            seq.push_back(index + 1);
            continue;
        }
        else if(st1[b].size() == 1)
            seq.push_back(index + 1);
        dfs1(st1, b, v);
    }
}

void solve(){
    int n, group;
    cin >> n >> group;
    vector<vector<pair<int, ll>>> g(n);
    for(int i = 0; i < n - 1; i++){
        int a, b;
        ll w;
        cin >> a >> b >> w;
        a--, b--;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
        pair<int, int> pr = {a, b};
        inds[pr] = i + 1;
        pr = {pr.second, pr.first};
        inds[pr] = i + 1;
        edges.push_back({a,b});
    }

   stickers.resize(n);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < g[i].size();j++) {
            ll ci;
            cin >> ci;
            stickers[i].push_back({ci, j});
        }
    }
    ans.resize(n);
    for(int i = 0; i < n; i++){
        sort(stickers[i].begin(), stickers[i].end());
    }
    auto stickers_copy = stickers;
    dfs(0, g);
    cout<<"Yes\n";
    dfs1(stickers_copy, 0);
    for(auto i : seq)
        cout<<i<<' ';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    solve();
    return 0;
}
