#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()


struct DSU {
    int sz;
    vector<int> par;
    vector<int> rank;
    DSU(int num) : sz(num) {
        par.resize(sz);
        iota(in(par), 0);
        rank.assign(sz, 1);
    }
    int find_par(int v) {
        if (par[v] == v) return v;
        return par[v] = find_par(par[v]);
    }
    bool unite(int u, int v) {
        u = find_par(u);
        v = find_par(v);
        if (u == v) return false;
        if (rank[u] < rank[v]) swap(u, v);
        par[v] = u;
        rank[u] += rank[v];
        return true;
    }
};
const int mxN = 2e5 + 500;
int n, G;

struct edge {
    int u, v, w;
};
edge edges[mxN];
vector<int> c[mxN];
vector<pair<int, int>> g[mxN];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> G;
    for (int  i= 0 ; i+ 1 < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        edges[i] = {u, v, w};
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);

    }
    for (int i = 0; i < n; ++i) {
        // int d;
        // cin >> d;
        for (int j = 0; j < (int) g[i].size(); ++j) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        revers(in(c[i]));
    }
    vector<int> perm(n - 1);
    iota(in(perm), 0);
    vector<int> ans;
    do {
        for (int i : perm) debug << i << ' ';
        debug << endl;
        DSU dsu(n);
        vector<int> inds(n);
        bool ok = true;
        for (int id : perm) {
            int u = edges[id].u;
            int v = edges[id].v;
            debug << id << ' ';
            debug.flush();
            if (c[u][inds[u]] + c[v][inds[v]] >= edges[id].w) {
                if (dsu.unite(u, v)) {
                    inds[u] += 1;
                    inds[v] += 1;
                    continue;
                }
            }
            ok = false;
            break;
        }
        if (ok) {
            ans = perm;
            break;
        }
    } while (next_permutation(in(perm)));
    if (ans.empty()) {
        cout << "No\n";
    }
    else {
        cout << "Yes\n";
        for (int i : ans) cout << i + 1 << ' ';
        cout << '\n';
    }
    return 0;
}