#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()


struct DSU {
    int sz;
    vector<int> par;
    vector<int> rank;
    DSU(int num) : sz(num) {
        par.resize(sz);
        iota(in(par), 0);
        rank.assign(sz, 1);
    }
    int find_par(int v) {
        if (par[v] == v) return v;
        return par[v] = find_par(par[v]);
    }
    bool unite(int u, int v) {
        u = find_par(u);
        v = find_par(v);
        if (u == v) return false;
        if (rank[u] < rank[v]) swap(u, v);
        par[v] = u;
        rank[u] += rank[v];
        return true;
    }
};
const int mxN = 2e5 + 500;
int n, G;

struct edge {
    int u, v, w;
};
edge edges[mxN];
vector<int> c[mxN];
vector<pair<int, int>> g[mxN];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> G;
    for (int  i= 0 ; i+ 1 < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        edges[i] = {u, v, w};
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);

    }
    for (int i = 0; i < n; ++i) {
        // int d;
        // cin >> d;
        for (int j = 0; j < (int) g[i].size(); ++j) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(in(c[i]));
    }
    vector<int> perm(n - 1);
    iota(in(perm), 0);

    if (G == 2) {
        vector<array<int, 2>> dp(n, array<int, 2>{0, 0}),
            mem(n, array<int, 2>{-1, -1});
        dp[0][1] = true;
        for (int i = 1; i < n; ++i) {
            {
                if (dp[i - 1][0]) {
                    if (i - 1 > 0 && c[i - 1][1] + c[i][0] >= edges[i - 1].w) {
                        dp[i][0] = true;
                        mem[i][0] = 2;
                    }
                    if (i - 1 > 0 && i < n - 1 && c[i - 1][1] + c[i][1] >= edges[i - 1].w) {
                        dp[i][1] = true;
                        mem[i][1] = 3;
                    }
                    
                }
                if (dp[i - 1][1]) {
                    if (c[i - 1][0] + c[i][0] >= edges[i - 1].w) {
                        dp[i][0] = true;
                        mem[i][0] = 0;
                    }
                    if (i < n - 1 && c[i - 1][0] + c[i][1] >= edges[i - 1].w) {
                        dp[i][1] = true;
                        mem[i][1] = 1;
                    }
                    
                }
            }
        }
        if (dp[n - 1][0]) {
            vector<int> tp(n - 1);
            int i = n - 1;
            int cur = 0;
            while (i > 0) {
                tp[i - 1] = mem[i][cur];
                if (tp[i - 1] == 0) {
                    i -= 1;
                    cur = 1;
                }
                else if (tp[i - 1] == 1) {
                    i -= 1;
                    cur = 1;
                }
                else {
                    i -= 1;
                    cur = 0;
                }
            }
            for (int i = 0; i + 1 < n; ++i) {
                debug << tp[i] << ' ';
            }
            debug << endl;
            sort(in(perm), [&](int i, int j) { 
                if (tp[i] != tp[j]) return tp[i] < tp[j]; 
                if (tp[i] == 1) return i > j;
                if (tp[i] == 2) return i < j;
                return i < j;
            });
            
            cout << "Yes\n";
            for (int i : perm) cout << i + 1 << ' ';
            cout << '\n';
        }
        else {
            cout << "No\n";
        }
        return 0;
    }

    vector<int> ans;
    do {
        for (int i : perm) debug << i << ' ';
        debug << endl;
        DSU dsu(n);
        vector<int> inds(n);
        bool ok = true;
        for (int id : perm) {
            int u = edges[id].u;
            int v = edges[id].v;
            debug << id << ' ';
            debug.flush();
            if (c[u][inds[u]] + c[v][inds[v]] >= edges[id].w) {
                if (dsu.unite(u, v)) {
                    inds[u] += 1;
                    inds[v] += 1;
                    continue;
                }
            }
            ok = false;
            break;
        }
        if (ok) {
            ans = perm;
            break;
        }
    } while (next_permutation(in(perm)));
    if (ans.empty()) {
        cout << "No\n";
    }
    else {
        cout << "Yes\n";
        for (int i : ans) cout << i + 1 << ' ';
        cout << '\n';
    }
    return 0;
}