#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, G;
    cin >> n >> G;
    vector<int> deg(n);
    vector<vector<int>> a(n);
    vector<tuple<int, int, int, int>> e(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w, u--, v--;
        e[i] = make_tuple(u, v, w, i);
        deg[u]++;
        deg[v]++;
    }
    for (int v = 0; v < n; v++) {
        a[v].resize(deg[v]);
        for (int i = 0; i < deg[v]; i++) {
            cin >> a[v][i];
        }
    }
    sort(e.begin(), e.end());
    do {
        vector<int> it(n);
        bool ok = true;
        for (auto [u, v, w, id] : e) {
            if (a[u][it[u]] + a[v][it[v]] >= w) {
                it[u]++;
                it[v]++;
            } else {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (auto [u, v, w, id] : e) {
                cout << id + 1 << ' ';
            }
            return 0;
        }
    } while (next_permutation(e.begin(), e.end()));
    cout << "No\n";
    return 0;
}
