#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<int> used, mt;
int step = 1;

int try_kuhn(int v) {
    if (used[v] == step) {
        return 0;
    }
    used[v] = step;
    for (int to : g[v]) {
        if (mt[to] == -1 || try_kuhn(mt[to])) {
            mt[to] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, G;
    cin >> n >> G;
    if (G == 1) {
        vector<int> deg(n);
        vector<vector<int>> a(n);
        vector<tuple<int, int, int, int>> e(n - 1);
        for (int i = 0; i < n - 1; i++) {
            int u, v, w;
            cin >> u >> v >> w, u--, v--;
            e[i] = make_tuple(u, v, w, i);
            deg[u]++;
            deg[v]++;
        }
        for (int v = 0; v < n; v++) {
            a[v].resize(deg[v]);
            for (int i = 0; i < deg[v]; i++) {
                cin >> a[v][i];
            }
            reverse(a[v].begin(), a[v].end());
        }
        sort(e.begin(), e.end());
        do {
            vector<int> it(n);
            bool ok = true;
            for (auto [u, v, w, id]: e) {
                if (a[u][it[u]] + a[v][it[v]] >= w) {
                    it[u]++;
                    it[v]++;
                } else {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                cout << "Yes\n";
                for (auto [u, v, w, id]: e) {
                    cout << id + 1 << ' ';
                }
                return 0;
            }
        } while (next_permutation(e.begin(), e.end()));
        cout << "No\n";
        return 0;
    }

    return 0;
}
/*

5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3

4 3
1 2 7
1 3 6
1 4 5
3 2 1
5
4
3


 */