#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<int> used, mt;
int step = 1;

int try_kuhn(int v) {
    if (used[v] == step) {
        return 0;
    }
    used[v] = step;
    for (int to : g[v]) {
        if (mt[to] == -1 || try_kuhn(mt[to])) {
            mt[to] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, G;
    cin >> n >> G;
    if (n <= 10) {
        vector<int> deg(n);
        vector<vector<int>> a(n);
        vector<tuple<int, int, int, int>> e(n - 1);
        for (int i = 0; i < n - 1; i++) {
            int u, v, w;
            cin >> u >> v >> w, u--, v--;
            e[i] = make_tuple(u, v, w, i);
            deg[u]++;
            deg[v]++;
        }
        for (int v = 0; v < n; v++) {
            a[v].resize(deg[v]);
            for (int i = 0; i < deg[v]; i++) {
                cin >> a[v][i];
            }
            reverse(a[v].begin(), a[v].end());
        }
        sort(e.begin(), e.end());
        do {
            vector<int> it(n);
            bool ok = true;
            for (auto [u, v, w, id]: e) {
                if (a[u][it[u]] + a[v][it[v]] >= w) {
                    it[u]++;
                    it[v]++;
                } else {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                cout << "Yes\n";
                for (auto [u, v, w, id]: e) {
                    cout << id + 1 << ' ';
                }
                return 0;
            }
        } while (next_permutation(e.begin(), e.end()));
        cout << "No\n";
        return 0;
    }
    if (G == 2) {
        vector<int> w(n - 1);
        for (int i = 0; i < n - 1; i++) {
            cin >> w[i] >> w[i] >> w[i];
        }
        vector<vector<int>> a(n, vector<int>(2));
        a[0] = a[n - 1] = vector<int>(1);
        for (int i = 0; i < n; i++) {
            for (int &x : a[i]) {
                cin >> x;
            }
        }
        int N = n + n - 2;
        g.resize(N);
        mt.resize(N);
        for (int i = 0; i < n; i += 2) {

        }
        return 0;
    }
    if (G == 3) {
        vector<int> w(n - 1);
        vector<vector<int>> a(n);
        for (int i = 0; i < n - 1; i++) {
            int u, v;
            cin >> u >> v >> w[i], u--, v--;
            a[u].push_back(0);
            a[v].push_back(0);
        }
        for (int v = 0; v < n; v++) {
            for (int & x : a[v]) {
                cin >> x;
            }
        }
        set<pair<int, int>> s;
        for (int i = 1; i < n; i++) {
            s.emplace(w[i - 1] - a[i][0], i);
        }
        vector<int> ans;
        for (int j = n - 2; j >= 0; j--) {
            auto it = s.upper_bound({a[0][j], n});
            if (it == s.begin()) {
                cout << "No\n";
                return 0;
            }
            it--;
            ans.push_back(it->second);
            s.erase(it);
        }
        cout << "Yes\n";
        for (int x : ans) {
            cout << x << ' ';
        }
        cout << '\n';
        return 0;
    }
    if (G == 5) {
        vector<tuple<int, int, int, int>> e(n - 1);
        vector<vector<int>> a(n);
        for (int i = 0; i < n - 1; i++) {
            int u, v, w;
            cin >> u >> v >> w, u--, v--;
            a[u].push_back(0);
            a[v].push_back(0);
            e[i] = make_tuple(w, u, v, i);
        }
        for (int v = 0; v < n; v++) {
            for (int & x : a[v]) {
                cin >> x;
            }
            reverse(a[v].begin(), a[v].end());
        }
        sort(e.begin(), e.end(), [&](auto lhs, auto rhs) {
            return get<0>(lhs) > get<0>(rhs) ||
                    (get<0>(lhs) == get<1>(rhs) && a[get<1>(lhs)].back() + a[get<2>(lhs)].back() < a[get<1>(rhs)].back() + a[get<2>(rhs)].back());
        });
        vector<int> ans;
        for (auto [w, u, v, i] : e) {
            if (a[u].back() + a[v].back() < w) {
                cout << "No\n";
                return 0;
            }
            a[u].pop_back();
            a[v].pop_back();
            ans.push_back(i);
        }
        cout << "Yes\n";
        for (int x : ans) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
        return 0;
    }
    return 0;
}
/*

5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3

4 3
1 2 7
1 3 6
1 4 5
3 2 1
5
4
3


 */