#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ff first
#define ss second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 1;
const ll N = 3e5 + 1;
const ll MOD = 1e9 + 7;
struct edge{
    ll a, b, w;
};
vector <edge> ed;
vector <ll> gr[N];
vector <ll> deg;
ll n, g;

void check(vector <ll> &p){
    vector <ll> cnt(n);
    for (int i = 0; i < n - 1; i++){
        ll a = ed[p[i]].a;
        ll b = ed[p[i]].b;
        ll w = ed[p[i]].w;

        if (gr[a][deg[a] - cnt[a] - 1] + gr[b][deg[b] - cnt[b] - 1] >= w){
            cnt[a]++;
            cnt[b]++;
        } else return;
    }

    cout << "Yes" << endl;
    for (auto x: p) cout << x + 1 << " ";
    exit(0);
}

void solve1(){
    vector <ll> p(n - 1);
    iota(all(p), 0);
    check(p);
    while (next_permutation(all(p))) check(p);

    cout << "No";
}

void solve2(){
    vector <pair <ll, ll>> need(n);
    for (int i = 0; i < n - 1; i++){
        need[ed[i].b].ff = ed[i].w - gr[ed[i].b][0];
        need[ed[i].b].ss = i + 1;
    }
    reverse(all(need));
    need.pop_back();
    sort(all(need));

    vector <pair <ll, ll>> have(deg[0]);
    for (int i = 0; i < deg[0]; i++){
        have[i].ff = gr[0][i];
        have[i].ss = i;
    }
    sort(all(have));

    vector <ll> ans(n - 1);
    for (int i = 0; i < n - 1; i++){
        if (have[i].ff >= need[i].ff){
            ans[have[i].ss] = need[i].ss;
        } else {
            cout << "No" << endl;
            return;
        }
    }

    cout << "Yes" << endl;
    reverse(all(ans));
    for (auto x: ans) cout << x << " ";
}

void start(){
    cin >> n >> g;
    deg.assign(n, 0);
    ed.assign(n - 1, {0, 0, 0});
    for (int i = 0; i < n - 1; i++){
        ll a, b, w; cin >> a >> b >> w; a--, b--;
        ed[i] = {a, b, w};

        deg[a]++, deg[b]++;
    }

    for (int i = 0; i < n; i++){
        gr[i].assign(deg[i], 0);
        for (auto &x: gr[i]) cin >> x;
    }

    /*for (auto x: ed) cout << x.a << " " << x.b << " " << x.w << endl;
    for (int i = 0; i < n; i++){
        cout << i << ": ";
        for (auto x: gr[i]) cout << x << " ";
        cout << endl;
    }*/


    if (g == 0 || g == 1) solve1();
    else if (g == 3) solve2();
    //solve2();
}

int main(){
    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    start();
    return 0;
}


