#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <random>
#include <chrono>
#include <assert.h>
#include <stack>
#include <numeric>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using uid = uniform_int_distribution<int>;
using lst = vector<vector<int>>;

const int type = 0;
const int MAXN = 2e5 + 1;
const int LOGN = 17;
const int MOD = 1e9 + 7;

class SegmentTree {
private:
	int n;
	int size;
	vector<int> t;

	void build(int v, int tl, int tr) {
		if (tl == tr) {
			return;
		}
		int tm = (tl + tr) >> 1;
		build(v << 1, tl, tm);
		build(v << 1 | 1, tm + 1, tr);
	}

public:

	SegmentTree(const int _n)
		:n(_n)
		, size(n << 2)
		, t(size) {
		build(1, 0, n);
	}
};

struct HashTable {
	static const int TABLE_SIZE = 1e7;
	static const int MAX_ELEMENTS = 1e5;
	int head[TABLE_SIZE];
	int next[MAX_ELEMENTS];
	int val[MAX_ELEMENTS];
	int itemCount = 0;

	void update() {
		for (int i = 0;i < TABLE_SIZE;i++) {
			next[i] = -1;
			head[i] = -1;
		}
		return;
	}

	HashTable() {
		update();
	}

	void add(ll hash) {
		ll h = hash % TABLE_SIZE;
		for (int i = head[h]; i != -1;i = next[i]) {
			if (val[i] == hash) {
				return;
			}
		}
		next[++itemCount] = head[h];
		head[h] = itemCount;
		val[itemCount] = hash;
		return;
	}
};

bool isPrime(ll x) {
	for (int i = 2;i <= x / i;i++) {
		if (x % i == 0) {
			return false;
		}
 	}
	return (x > 1);
}

void genModule(mt19937& gen, ll& MOD) {
	while (1) {
		MOD = uid(1e9, 2e9)(gen);
		if (isPrime(MOD)) return;
	}
}

int __lg(ll x) {
	int ans = 0;
	for (int i = 0;i < 63;i++) {
		if (x & (1 << i)) ans = i;
	}
	return ans;
}

int __builtin_popcount(ll x) {
	int ans = 0;
	for (int i = 0;i < 63;i++) {
		if (x & (1 << i)) ans++;
	}
	return ans;
}

void solve2() {

}

struct Edge {
	ll v1, v2, w;
};

void solve(int att) {
	// mt19937 gen(att);
	int nV, nG;
	cin >> nV >> nG;
	vector<Edge> edges;
	vector<int> deg(nV);
	for (int i = 0;i + 1 < nV;i++) {
		ll v, u, w;
		cin >> v >> u >> w; v--; u--;
		deg[v]++;
		deg[u]++;
		edges.pb({ v,u,w });
	}
	lst c(nV);
	for (int v = 0;v < nV;v++) {
		c[v].resize(deg[v]);
		for (int i = 0;i < deg[v];i++) {
			ll cr;
			cin >> cr;
			c[v][i] = cr;
		}
		reverse(all(c[v]));
	}
	if (nG <= 1) {  // при n <= 10 можно просто перебрать порядок добавления рёбер за n!
		vector<int> state(nV - 1); // порядок добавления рёбер
		iota(all(state), 0);
		do {
			// нам дан порядок, теперь необходимо проверить, может ли условие выполнится
			vector<int> iter(nV, 0);
			bool good = true;
			for (int i = 0;i < state.size();i++) {
				int v1 = edges[state[i]].v1;
				int v2 = edges[state[i]].v2;
				ll w = edges[state[i]].w;
				if (w <= c[v1][iter[v1]] + c[v2][iter[v2]]) {
					iter[v1]++;
					iter[v2]++;
				}
				else good = false;
			}
			if (good) {
				std::cout << "Yes\n";
				for (int i = 0;i + 1 < nV;i++) {
					std::cout << state[i] + 1 << " ";
				}
				return;
			}
		} while (next_permutation(all(state)));
		std::cout << "No";
	}
}

int main() {
	cin.tie(0)->ios::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int nT = 1;
	if (type) cin >> nT;
	for (int t = 0;t < nT;t++) {
		solve(t);
		if (t != nT - 1) std::cout << "\n";
	}
	return 0;
}