#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, gr;
	cin >> n >> gr;
	vector<vector<pair<int, int>>> g(n);
	vector<tuple<int, int, int>> r;
	vector<int> deg(n);
	vector<vector<int>> c(n);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--; b--;
		r.push_back({ a,b,w });
		g[a].push_back({ b,w });
		g[b].push_back({ a,w });
		deg[a]++;
		deg[b]++;
	}
	for (int i = 0; i < n; i++)
	{
		c[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; j++)
		{
			cin >> c[i][j];
		}
	}
	if (gr <= 1)
	{
		vector<int> p(n - 1);
		for (int i = 0; i < n - 1; i++) p[i] = i;
		do
		{
			vector<int> dg(n);
			bool good = true;
			for (int i = 0; i < n - 1; i++)
			{
				auto [v, u, w] = r[p[i]];
				int a = c[v][deg[v] - dg[v] - 1];
				int b = c[u][deg[u] - dg[u] - 1];
				if (w <= a + b)
				{
					dg[v]++;
					dg[u]++;
				}
				else
				{
					good = false;
					break;
				}
			}
			if (good)
			{
				cout << "YES\n";
				for (int x : p) cout << x + 1 << ' ';
				return 0;
			}
		} while (next_permutation(p.begin(), p.end()));
		cout << "NO\n";
	}
	else if (gr == 5)
	{
		bool good = true;
		vector<int> dg(n);
		vector<int> p;
		while (good)
		{
			good = false;
			for (int i = 0; i < n - 1; i++)
			{
				auto [v, u, w] = r[i];
				int a = c[v][deg[v] - dg[v] - 1];
				int b = c[v][deg[u] - dg[u] - 1];
				if (w <= a + b)
				{
					good = true;
					dg[v]++;
					dg[u]++;
					p.push_back(i);
				}
			}
		}
		if (p.size() == n - 1)
		{
			cout << "YES\n";
			for (int x : p) cout << x + 1 << ' ';
			return 0;
		}
		else
		{
			cout << "NO\n";
			return 0;
		}
	}
}