// #include <bits/stdc++.h>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;

// template <typename T>
// istream& operator>>(istream& in, vector<T>& a) {
//     for (auto& el : a) {
//         in >> a;
//     }
//     return in;
// }

template <typename T>
void print(vector<T>& a) {
    for (auto& el : a) {
        cout << el << " ";
    }
}

struct segtree {
    ll sz = 1;
    vector<ll> tr;

    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
    }
    void ch(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tr[v] = x;
            return;
        }
        int mid = (r + l) / 2;
        if (ind < mid) {
            ch(2 * v + 1, l, mid, ind, x);
        } else {
            ch(2 * v + 2, mid, r, ind, x);
        }
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
    }

    void ch(int ind, int x) { ch(0, 0, sz, ind, x); }

    ll sumseg(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return 0;
        }
        int mid = (r + l) / 2;
        ll m1 = sumseg(2 * v + 1, l, mid, lseg, rseg);
        ll m2 = sumseg(2 * v + 2, mid, r, lseg, rseg);
        return m1 + m2;
    }

    ll sumseg(int lseg, int rseg) { return sumseg(0, 0, sz, lseg, rseg); }
};

struct xui {
    map<ll, ll> had;
    ll cnt = 0;
    void add(ll x) {
        had[x]++;
        if (had[x] == 1) {
            cnt++;
        }
    }

    void del(ll x) {
        had[x]--;
        if (had[x] == 0) {
            cnt--;
        }
    }
};
vector<vector<pair<ll, ll>>> gr;

vector<set<pair<ll, ll>>> c;

map<pair<ll, ll>, pair<ll, ll>> our;

map<pair<ll, ll>, pair<ll, ll>> for_ret;

map<pair<ll, ll>, ll> good;

pair<ll, ll> dfs(int v, int pred = -1) {
    for (auto el : gr[v]) {
        if (el.first != pred) {
            pair<ll, ll> x = dfs(el.first, v);
            if (x.first == -1) {
                return {-1, -1};
            }
            auto it = c[v].lower_bound({el.second - x.first, -1});
            if (it == c[v].end()) {
                return {-1, -1};
            }
            our[{v, el.first}] = {it->second, x.second};
            for_ret[{el.first, x.second}] = {v, el.first};
            for_ret[{v, it->second}] = {v, el.first};
            c[v].erase(it);
        }
    }
    if (pred != -1) {
        return *c[v].begin();
    }
    return {0, 0};
}
void solve() {
    ll n, g;
    cin >> n >> g;
    gr.resize(n);
    c.resize(n);
    map<pair<ll, ll>, ll> num;
    for (int i = 0; i < n - 1; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].emplace_back(b, w);
        gr[b].push_back({a, w});
        num[{a, b}] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < gr[i].size(); j++) {
            ll x;
            cin >> x;
            c[i].insert({x, j});
        }
    }
    pair<ll, ll> x = dfs(0);
    if (x.first == -1) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    vector<ll> steps(n, 0);
    queue<pair<ll, ll>> z;
    vector<ll> ans;
    for (auto el : our) {
        ll u1 = el.second.first;
        ll v1 = el.second.second;
        good[el.first] = (u1 != 0) + (v1 != 0);
        if (good[el.first] == 0) {
            z.push(el.first);
        }
    }
    while (!z.empty()){
        pair<ll, ll> v = z.front();
        z.pop();
        ans.push_back(num[v]);
        steps[v.first]++;
        steps[v.second]++;
        pair<ll, ll> bb = for_ret[{v.first, steps[v.first]}];
        good[bb]--;
        if (good[bb] == 0){
            z.push(bb);
        }
        bb = for_ret[{v.second, steps[v.second]}];
        good[bb]--;
        if (good[bb] == 0){
            z.push(bb);
        }
    }
    reverse(ans.begin(), ans.end());
    assert(ans.size() == n - 1);
    for (auto el : ans){
        cout << el << " ";
    }
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
