#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u, w;
};

void solve() {
    ll n, g;
    cin >> n >> g;
    if (g == 0 || g == 1) {
        vector<ll> deg(n);
        vector<Edge> edges(n - 1);
        for (auto &item: edges) {
            cin >> item.v >> item.u >> item.w;
            --item.v;
            --item.u;
            ++deg[item.v];
            ++deg[item.u];
        }

        vector<vector<ll>> cs(n);
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < deg[i]; ++j) {
                ll x;
                cin >> x;
                cs[i].push_back(x);
            }
        }

        vector<ll> prm(n - 1);
        for (ll i = 0; i < n - 1; ++i) {
            prm[i] = i;
        }

        do {
            vector<vector<ll>> tCs = cs;
            bool bad = false;
            for (auto &eI: prm) {
                Edge e = edges[eI];
                if (tCs[e.v].back() + tCs[e.u].back() < e.w) {
                    bad = true;
                    break;
                }
                tCs[e.v].pop_back();
                tCs[e.u].pop_back();
            }

            if (!bad) {
                cout << "Yes\n";
                for (const auto &item: prm) {
                    cout << item + 1 << ' ';
                }
                cout << '\n';
                return;
            }
        } while (next_permutation(prm.begin(), prm.end()));

        cout << "No\n";
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3

 */