#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;
const int N = 2e5 + 5;
const int MOD = 1e9 + 7;
const int M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

struct edge {
    ll to, w, i;
};

vector<ll> tps[N];
vector<edge> g[N];
ll ans_deg[N];
vector<pair<ll, ll>> a[N];
ll deg[N];
ll dp[N];

void dfs(ll v, ll p = -1, ll num_e = N - 1) {
    vector<pair<ll, ll>> has;
    vector<ll> son;
    for (auto to : g[v]) {
        if (to.to == p) continue;
        dfs(to.to, v, to.i);
        son.push_back(to.to);
        has.push_back({to.w - dp[to.to], to.i});
    }
    sort(has.begin(), has.end());
    bool ok = true;
    ll bad = -1;
    ll j = 0;
    for (int i = 0; i < deg[v]; i++) {
        if (j < has.size() && has[j].first <= a[v][i].first) {
            j++;
        } else {
            bad = i;
            break;
        }
    }
    if (p == -1 && bad != -1) {
        cout << "No" << '\n';
        exit(0);
    }
    vector<pair<ll, ll>> who;
    j = 0;
    for (int i = 0; i < deg[v]; i++) {
        if (i == bad) {
            who.push_back({a[v][i].second, num_e});
            continue;
        }
        if (has[j].first <= a[v][i].first) {
            who.push_back({a[v][i].second, has[j].second});
            j++;
        } else {
            ok = false;
        }
    }
    // cout << v + 1 << " " << has.size() << " " << j << '\n';
    if (!ok) {
        cout << "No" << '\n';
        exit(0);
    }
    dp[v] = a[v][bad].first;
    sort(who.begin(), who.end());
    for (int i = 1; i < who.size(); i++) {
        // cout << who[i].second + 1 << " " << who[i - 1].second + 1 << '\n';
        tps[who[i].second].push_back(who[i - 1].second);
        ans_deg[who[i - 1].second]++;
    }
}

vector<ll> top;
bool used[N];

void restore(ll v) {
    used[v] = true;
    for (auto to : tps[v]) {
        if (!used[to]) {
            restore(to);
        }
    }
    top.push_back(v);
}

void solve() {
    ll n, group; cin >> n >> group;
    for (int i = 0; i < n - 1; i++) {
        ll u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].push_back({v, w, i});
        g[v].push_back({u, w, i});
        deg[u]++;
        deg[v]++;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            ll x; cin >> x;
            a[i].push_back({x, j});
        }
        sort(a[i].begin(), a[i].end());
    }
    dfs(0);
    for (int i = 0; i < n - 1; i++) {
        if (ans_deg[i] == 0 && !used[i]) {
            restore(i);
        }
    }
    reverse(top.begin(), top.end());
    cout << "Yes" << '\n';
    for (auto i : top) cout << i + 1 << " ";
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tst = 1;
    while (tst--) {
        solve();
    }
}
