#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int a, b, w;
    int idx;
    bool operator<(edge other) const {
        return idx < other.idx;
    }
};

int n, group;
vector<vector<edge>> adj;
vector<vector<int>> c;
vector<edge> edges;

void solve1() {
    vector<edge> curr = edges;
    do {
        vector<int> cnt(n);
        bool valid = true;
        for (edge& e : curr) {
            int ca = c[e.a][cnt[e.a]++];
            int cb = c[e.b][cnt[e.b]++];
            if (ca + cb < e.w) {
                valid = false;
            }
        }
        if (valid) {
            cout << "Yes\n";
            for (edge& e : curr) cout << e.idx << " ";
            return;
        }
    } while (next_permutation(curr.begin(), curr.end()));
    cout << "No\n";
}

void solve2() {
    vector<int> order(edges.size());
    int prev = c[0][0];
    for (int i = 1; i < n - 1; i++) {
        int use = 0;
        if (prev + min(c[i][0], c[i][1]) >= edges[i - 1].w) {
            if (c[i][0] < c[i][1]) {
                use = 0;
            } else {
                use = 1;
            }
        } else if (prev + c[i][0] >= edges[i - 1].w) {
            use = 0;
        } else if (prev + c[i][1] >= edges[i - 1].w) {
            use = 1;
        } else {
            cout << "No\n";
            return;
        }
        if (use == 0) {
            order[i] = order[i - 1] + 1;
        } else {
            order[i] = order[i - 1] - 1;
        }
        prev = c[i][1 - use];
    }
    if (prev + c[n - 1][0] >= edges.back().w) {
        cout << "Yes\n";
        vector<pair<int, int>> ord_edges;
        for (edge& e : edges) {
            ord_edges.push_back({order[e.idx - 1], e.idx});
        }
        sort(ord_edges.begin(), ord_edges.end());
        for (auto [_, i] : ord_edges) cout << i << " ";
    } else {
        cout << "No\n";
    }
}

int main() {
    cin >> n >> group;
    c.resize(n);
    adj.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        adj[a - 1].push_back({a - 1, b - 1, w, i + 1});
        adj[b - 1].push_back({b - 1, a - 1, w, i + 1});
        edges.push_back({a - 1, b - 1, w, i + 1});
    }
    string s;
    getline(cin, s);
    for (int i = 0; i < n; i++) {
        getline(cin, s);
        stringstream ss(s);
        int v;
        while (ss >> v) {
            c[i].push_back(v);
        }
        reverse(c[i].begin(), c[i].end());
    }
    if (group == 0 || group == 1) {
        solve1();
        return 0;
    }
    if (group == 2) {
        solve2();
        return 0;
    }
}