#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(1472916923);
const int SZ = 1e6 + 1;

struct segtree {
    int sz;
    vector<int> tr;
    segtree(int n) {
        sz = 1;
        while (sz < n)
            sz <<= 1;
        tr.assign(sz * 2 - 1, 0);
    }
};

struct DDnode {
    ll prior, val;
    DDnode* l;
    DDnode* r;
    DDnode(ll v = 0) : val(v) {
        prior = rd();
        l = nullptr;
        r = nullptr;
    }
};

struct ed {
    int u, v, ind;
    ll w;
    ed(int u = 0, int v = 0, ll w = 0, int ind = 0) : u(u), v(v), w(w), ind(ind) {}
};

vector<vector<ed>> g;
vector<vector<ll>> c;
vector<int> ans1, ans2;


ll dfs(int v, int p = -1) {
    vector<pair<ll, ll>> e;
    vector<pair<ll, ll>> cv(g[v].size());
    vector<int> por(g[v].size(), -1);
    for (int i = 0; i < g[v].size(); i++)
        cv[i] = make_pair(c[v][i], i);
    sort(cv.rbegin(), cv.rend());
    for (auto u : g[v]) {
        if (u.v == p)
            continue;

        e.push_back({ dfs(u.v, v), u.ind });
        if (e.back().first == -1)
            return -1;
        e.back().first = u.w - e.back().first;
    }
    sort(e.rbegin(), e.rend());

    ll ret = -1;
    while (!e.empty() && e.back().first <= cv.back().first) {
        por[cv.back().second] = e.back().second;
        e.pop_back();
        cv.pop_back();
    }
    if (!e.empty() && e.back().first > cv.back().first) {
        if (p == -1)
            return -1;
        por[cv.back().second] = -1;
        ret = cv.back().first;
        cv.pop_back();
    }
    while (!e.empty() && e.back().first <= cv.back().first) {
        por[cv.back().second] = e.back().second;
        e.pop_back();
        cv.pop_back();
    }
    if (!e.empty() && e.back().first > cv.back().first) {
        return -1;
    }
    else {
        if (!cv.empty())
            ret = cv.back().first;
    }

    int tf = 0;
    for (int i = (int)g[v].size() - 1; i >= tf; i--) {
        if (por[i] == -1) {
            tf = i;
            continue;
        }
        ans1.push_back(por[i]);
    }
    for (int i = 0; i < tf; i++)
        ans2.push_back(por[i]);

    if (p == -1)
        return 0;
    return ret;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int n, G;
    cin >> n >> G;
    g.assign(n + 1, {});
    c.assign(n + 1, {});
    for (int i = 1; i < n; i++) {
        int a, b;
        ll w;
        cin >> a >> b >> w;
        g[a].push_back(ed(a, b, w, i));
        g[b].push_back(ed(b, a, w, i));
    }

    for (int i = 1; i <= n; i++) {
        c[i].assign(g[i].size(), 0);
        for (int j = 0; j < g[i].size(); j++)
            cin >> c[i][j];
    }

    if (dfs(1) == -1) {
        cout << "No";
        return 0;
    }

    cout << "Yes\n";
    for (auto x : ans1)
        cout << x << ' ';
    reverse(ans2.begin(), ans2.end());
    for (auto x : ans2)
        cout << x << ' ';
}
