#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

vector<vector<pair<int, int>>> g; // vertex, edge ind
vector<int> edge_w, up, parent;
vector<vector<int>> cards;
vector<set<pair<int, int>>> cards_ordered;
vector<pair<int, int>> edges, edge_info;
vector<vector<int>> edge_by_vert, g2;

void dfs(int v, int p) {
    parent[v] = p;
    for (auto [u, ind] : g[v]) {
        if (u == p) {
            up[v] = ind;
            continue;
        }
        dfs(u, v);
    }
}
vector<int> ord;
vector<int> e_used;
void dfs2(int v) {
    e_used[v] = 1;
    for (int u : g2[v]) {
        if (!e_used[u]) dfs2(u);
    }
    ord.push_back(v);
}

void solve() {
    int n, G;
    cin >> n >> G;
    g.resize(n);
    edge_w.resize(n);
    cards.resize(n);
    cards_ordered.resize(n);
    up.resize(n, -1);
    parent.resize(n, -1);
    edge_info.resize(n - 1);
    edge_by_vert.resize(n);
    g2.resize(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        edge_w[i] = w;
        edges.emplace_back(a, b);
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
    }
    for (int i = 0; i < n; i++) {
        edge_by_vert[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            cards[i].push_back(x);
        }
        std::reverse(cards[i].begin(), cards[i].end());
        for (int j = 0; j < cards[i].size(); j++) {
            cards_ordered[i].insert({cards[i][j], j});
        }
    }

//    for (int i = 0; i <n; i++) {
//        cout << i << " :::: " << endl;
//        for (auto [a, b] : cards_ordered[i]) {
//            cout << a << " " << b << endl;
//        }
//    }
//    cout << endl;

    if (n == 2) {
        if (cards[0][0] + cards[1][0] >= edge_w[0]) {
            cout << "Yes\n1";
        } else {
            cout << "No";
        }
        exit(0);
    }
    int root = 0;
    for (; root < n; root++) {
        if (g[root].size() > 1) break;
    }
    if (root == n) {
        cout << "fhfjjfjf\n";
        exit(1);
    }
    dfs(root, -1);

    vector<int> used(n);
    queue<int> q;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == 1) {
            q.push(i);
            used[i] = 1;
        }
    }

    while (q.size()) {
        int v = q.front();
        q.pop();
        int p = parent[v];
        if (p == -1) continue;
        auto [cv, v_ind] = *cards_ordered[v].rbegin();
        int w = edge_w[up[v]];
        if (cards_ordered[p].rbegin()->first < w - cv) {
            cout << "No";
            exit(0);
        }
        auto [cp, p_ind] = *cards_ordered[p].lower_bound(make_pair(w - cv, -1ll));
//        cout << v << " " << p << " " << up[v] << " " << cv << " " << cp << " " << w << endl;
        cards_ordered[p].erase({cp, p_ind});
        if (edges[up[v]].first == v) {
            edge_info[up[v]] = {v_ind, p_ind};
        } else {
            edge_info[up[v]] = {p_ind, v_ind};
        }

        edge_by_vert[v][v_ind] = up[v];
        edge_by_vert[p][p_ind] = up[v];

        if (!used[p]) {
            q.push(p);
            used[p] = 1;
        }
    }

//    for (auto [a, b] : edge_info) {
//        cout << a << " " << b << endl;
//    }

    for (int i = 0; i < n -1; i++) {
        auto [a, b] = edges[i];
        int a_ord = edge_info[i].first;
        int b_ord = edge_info[i].second;
        if (a_ord > 0) {
            g2[i].push_back(edge_by_vert[a][a_ord - 1]);
        }
        if (b_ord > 0) {
            g2[i].push_back(edge_by_vert[b][b_ord - 1]);
        }
    }

    e_used.resize(n - 1);
    vector<int> not_istok(n - 1);
    for (int i = 0; i < n -1; i++) {
        for (int u : g2[i]) {
            not_istok[u] = 1;
        }
    }
    int cnt = 0;
    for (int i = 0; i < n - 1; i++) {
        if (!e_used[i] && !not_istok[i]) {
            cnt++;
            dfs2(i);
        }
    }
    if (cnt == 0) exit(1);
    cout << "Yes\n";
    if (ord.size() != n - 1) exit(1);
    for (int i : ord) {
        cout << i + 1 << " ";
    }
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
