#include <iostream>
#include <vector>

#pragma target('avx2')
#pragma target('O3')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, g;
    cin >> n >> g;
    vector<map<int, vector<int>>> A(n);
    vector<vector<int>> edge(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        A[a][b] = {w, i};
        A[b][a] = {w, i};
        edge[i] = {a, b, w};
    }
    vector<vector<int>> stick(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < A[i].size(); j++) {
            int temp;
            cin >> temp;
            stick[i].push_back(temp);
        }
        reverse(stick[i].begin(), stick[i].end());
    }
    if (g == 2) {
        vector<int> ans(n - 1);
        int l = 0, r = n - 2, t = stick[0][0];
        for (int i = 0; i < n - 2; i++) {
            int ind = 0;
            if (stick[i + 1][0] > stick[i + 1][1]) {
                ind = 1;
            }
            if (stick[i + 1][ind] + t >= A[i][i + 1][0]) {
                t = stick[i + 1][1 - ind];
                if (ind == 0) {
                    ans[l] = A[i][i + 1][1];
                    l++;
                } else {
                    ans[r] = A[i][i + 1][1];
                    r--;
                }
            } else if (stick[i + 1][1 - ind] + t >= A[i][i + 1][0]) {
                ind = 1 - ind;
                t = stick[i + 1][1 - ind];
                if (ind == 0) {
                    ans[l] = A[i][i + 1][1];
                    l++;
                } else {
                    ans[r] = A[i][i + 1][1];
                    r--;
                }
            } else {
                cout << "No";
                exit(0);
            }
        }
        if (stick[n - 1][0] + t >= A[n - 2][n - 1][0]) {
            ans[l] = A[n - 2][n - 1][1];
        } else {
            cout << "No";
            exit(0);
        }
        cout << "Yes\n";
        for (int e: ans) {
            cout << e + 1 << ' ';
        }
    }
    if (g == 3) {
        vector<vector<int>> f, s;
        for (int i = 0; i < n - 1; i++) {
            f.push_back(A[0][i + 1]);
            f.back()[0] -= stick[i + 1][0];
            s.push_back({stick[0][i], i});
        }
        sort(f.begin(), f.end());
        sort(s.begin(), s.end());
        vector<int> ans(n - 1);
        for (int i = 0; i < n - 1; i++) {
            if (s[i][0] >= f[i][0]) {
                ans[s[i][1]] = f[i][1];
            } else {
                cout << "No";
                exit(0);
            }
        }
        cout << "Yes\n";
        for (int e: ans) {
            cout << e + 1 << ' ';
        }
    }
    if (g == 1) {
        vector<int> pos(n - 1);
        for (int i = 0; i < n - 1; i++) {
            pos[i] = i;
        }
        while (next_permutation(pos.begin(), pos.end())) {
            vector<int> st(n);
            bool flag;
            for (int i = 0; i < n - 1; i++) {
                int a = edge[i][0], b = edge[i][1], w = edge[i][2];
                if (stick[a][st[a]] + stick[b][st[b]] < w){
                    flag = false;
                    break;
                }
            }
            if (flag){
                cout << "Yes\n";
                for (int e: pos){
                    cout << e + 1 << ' ';
                }
            }
        }
        vector<int> st(n);
        bool flag;
        for (int i = 0; i < n - 1; i++) {
            int a = edge[i][0], b = edge[i][1], w = edge[i][2];
            if (stick[a][st[a]] + stick[b][st[b]] < w){
                flag = false;
                break;
            }
        }
        if (flag){
            cout << "Yes\n";
            for (int e: pos){
                cout << e + 1 << ' ';
            }
        }
        cout << "No";
    }
}
