#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, group;
vector<pii > g[maxn];
set<pii > c[maxn];
vector<int> const_c[maxn];
vector<tuple<int, int, int>> e;

int check(const vector<int> &ord) {
    vector<int> wh(n);
    for (int i: ord) {
        auto [a, b, w] = e[i];
        int ca = const_c[a][wh[a]++];
        int cb = const_c[b][wh[b]++];
        if (ca + cb < w) return 0;
    }
    return 1;
}

void solve() {
    cin >> n >> group;
    e.resize(n - 1);
    map<pii, pii > WWW;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        if (a > b) swap(a, b);
        e[i] = {a, b, w};
        WWW[{a, b}] = {w, i};
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    for (int i = 0; i < n; i++) {
        int deg = sz(g[i]);
        vector<int> b;
        for (int j = 0; j < deg; j++) {
            int x;
            cin >> x;
            b.push_back(x);
        }
        reverse(all(b));
        for (int j = 0; j < deg; j++) {
            int x = b[j];
            c[i].insert({x, j});
            const_c[i].push_back(x);
        }
    }
    if (group < 2) {
        vector<int> ord;
        for (int i = 0; i < n - 1; ++i) {
            ord.push_back(i);
        }
        int good = check(ord);
        while (!good && next_permutation(all(ord))) good = check(ord);
        if (!good) {
            cout << "No";
            return;
        }
        cout << "Yes\n";
        for (int i: ord) cout << i + 1 << ' ';
    }
    if (group == 3) {
        vector<pii > so;
        for (int i = 1; i < n; i++) {
            int w = WWW[{0, i}].first;
            so.push_back({w - (c[i].begin())->first, i});
        }
        sort(all(so));
        vector<int> ord(n - 1);
        while (!so.empty()) {
            auto [nado, i] = so.back();
            so.pop_back();
            auto it = --c[0].end();
            if (it->first < nado) {
                cout << "No";
                return;
            }
            ord[it->second] = (WWW[{0, i}].second + 1);
            c[0].erase(it);
        }
        cout << "Yes\n";
        for (int i: ord) cout << i << ' ';
        return;
    }
    if (group == 4) {
        vector<vector<int>> ord(2);
        for (int v = 0; v < 2; v++) {
            vector<pii > so;
            for (auto [i, id]: g[v]) {
                if (i < 2) continue;
                int w = WWW[{v, i}].first;
                so.push_back({w - (c[i].begin())->first, i});
            }
            sort(all(so));
            ord[v].resize(sz(g[v]));
            while (!so.empty()) {
                auto [nado, i] = so.back();
                so.pop_back();
                auto it = c[v].lower_bound({nado, 0});
                if (it == c[v].end()) {
                    cout << "No";
                    return;
                }
                ord[v][it->second] = (WWW[{v, i}].second + 1);
                c[v].erase(it);
            }
        }
        auto [x0, j0] = *c[0].begin();
        auto [x1, j1] = *c[1].begin();
        auto [w, i] = WWW[{0, 1}];
        if (x0 + x1 < w) {
            cout << "No";
            return;
        }
        cout << "Yes\n";
        for (int id = 0; id < j0; id++) {
            cout << ord[0][id] << ' ';
        }
        for (int id = 0; id < j1; id++) {
            cout << ord[1][id] << ' ';
        }
        cout << i + 1 << ' ';
        for (int id = j0 + 1; id < sz(ord[0]); id++) {
            cout << ord[0][id] << ' ';
        }
        for (int id = j1 + 1; id < sz(ord[1]); id++) {
            cout << ord[1][id] << ' ';
        }
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
