#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 2e5;

struct edge {
    int v, u, w, id_v, id_u;
};

int n;
int cur[MAXN];
edge e[MAXN];
// номера стикеров с их порядком
vpii c[MAXN];
// предок вершины v + какое это было ребро
pii p[MAXN];
int degree[MAXN];
vpii g[MAXN];

// номера текущих листов
stack <int> mini;

void dfs(int v, int prev = -1, int prev_id = -1) {
    p[v] = {prev, prev_id};
    for (auto [u, id] : g[v]) {
        if (u == prev)
            continue;
        dfs(u, v, id);
    }
}

void solve() {
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].pb({u, i});
        g[u].pb({v, i});
        degree[v]++;
        degree[u]++;
        e[i].v = v;
        e[i].u = u;
        e[i].w = w;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < degree[i]; j++) {
            int color;
            cin >> color;
            c[i].pb({color, degree[i] - j - 1});
        }
    }
    for (int i = 0; i < n; i++)
        if (degree[i] == 1)
            mini.push(i);

    dfs(0);

    while (!mini.empty()) {
        int v = mini.top();
        mini.pop();
        if (v == 0)
            continue;
        int u = p[v].ff;
        int id_edge = p[v].ss;
        degree[v]--;
        degree[u]--;
        if (degree[u] == 1)
            mini.push(u);

        int need = e[id_edge].w - c[v].back().ff;
        int best_color = -1;
        int pos_stiker = -1;
        for (int i = 0; i < sz(c[u]); i++) {
            auto [color, pos] = c[u][i];
            if (color >= need && (color < best_color || best_color == -1)) {
                best_color = color;
                pos_stiker = i;
            }
        }

        int cur_v = c[v].back().ss;
        if (best_color == -1) {
            cout << "No\n";
            return;
        }
        int cur_u = c[u][pos_stiker].ss;
        c[u].erase(c[u].begin() + pos_stiker);

        if (e[id_edge].v != v) {
            swap(v, u);
            swap(cur_v, cur_u);
        }
        e[id_edge].id_v = cur_v;
        e[id_edge].id_u = cur_u;
    }

    vi ans;
    int l = 0;
    while (l < n - 1) {
        bool any = false;
        for (int j = 0; j < n - 1; j++) {
            int v = e[j].v;
            int u = e[j].u;
            int pos_v = e[j].id_v;
            int pos_u = e[j].id_u;
            if (cur[v] == pos_v && cur[u] == pos_u) {
                cur[v]++;
                cur[u]++;
                ans.pb(j);
                any = true;
                l++;
            }
        }
        if (!any) {
            cout << "No\n";
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < n - 1; i++)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
}

int main() {
    fast_input;
    cout << setprecision(7) << fixed;
    int g;
    cin >> n >> g;
    if (n <= 1000)
        solve();
}