#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;

vector<pair<int, int>> g[N];

void solve() {
    int n, t;
    cin >> n >> t;

    vector<vector<int>> edges;
    vector<int> d(n, 0);

    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        d[u]++;
        d[v]++;
        edges.push_back({u, v, w});
    }

    vector<vector<int>> deg(n);

    for (int i = 0; i < n; i++) {
        deg[i].resize(d[i]);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz(deg[i]); j++) {
            cin >> deg[i][j];
        }
        reverse(all(deg[i]));
    }

    vector<int> p(n - 1, 0);
    iota(all(p), 0ll);

    do {
        vector<int> ptr(n, 0);
        bool f = true;
        for (int i = 0; i < n - 1; i++) {
            int ind = p[i];
            int weight = edges[ind][2];
            int A = edges[ind][0], B = edges[ind][1];
            if (deg[A][ptr[A]] + deg[B][ptr[B]] < weight) {
                f = false;
            }
            ptr[A]++;
            ptr[B]++;
        }

        if (f) {
            cout << "Yes\n";
            for (auto v : p) {
                cout << v + 1 << " ";
            }
            cout << "\n";
            return;
        }
    } while (next_permutation(all(p)));

    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}