#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 4e5 + 10;

vector<pair<int, int>> g[N];

vector<int> r[N];

int used[N];
int timer = 1;

int mt[N];

bool kun (int i) {
    if (used[i] == timer) return false;
    used[i] = timer;

    for (auto v : r[i]) {
        if (mt[v] == -1) {
            mt[v] = i;
            return true;
        }
    }

    for (auto v : r[i]) {
        if (kun(mt[v])) {
            mt[v] = i;
            return true;
        }
    }

    return false;
}

int col[N];

void dfs (int u, int p = -1) {
    col[u] = (p == -1 ? 0 : col[p] ^ 1);

    for (auto v : g[u]) {
        if (v.first == p) continue;
        dfs(v.first, u);
    }
}

void solve() {
    int n, t;
    cin >> n >> t;

    vector<vector<int>> edges;
    vector<int> d(n, 0);
    vector<int> s(n, 0);

    map<pair<int, int>, int> id;

    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        d[u]++;
        d[v]++;
        id[{u, v}] = id[{v, u}] = i;
        edges.push_back({u, v, w});
    }

    dfs(0);

    vector<vector<int>> deg(n);

    for (int i = 0; i < n; i++) {
        deg[i].resize(d[i]);
    }

    vector<int> which(2 * n, 0);

    for (int i = 1; i < n; i++) {
        s[i] = s[i - 1] + d[i - 1];
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz(deg[i]); j++) {
            cin >> deg[i][j];
        }
        reverse(all(deg[i]));
    }

    for (int i = 0; i < n; i++) {
        for (auto x : g[i]) {
            int v = x.first, w = x.second;

            for (int j = 0; j < sz(deg[i]); j++) {
                for (int k = 0; k < sz(deg[v]); k++) {
                    if (deg[i][j] + deg[v][k] >= w) {
                        r[s[i] + j].push_back(s[v] + k);
                    }
                }
            }
        }
    }

    fill(mt, mt + N, -1);

    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            for (int j = 0; j < sz(deg[i]); j++) {
                timer++;
                kun(s[i] + j);
            }
        }
    }

    vector<pair<pair<int, int>, pair<int, int>>> st;

    vector<int> ptr(n, 0);

    for (int i = 0; i < n; i++) {
        if (col[i] == 0) {
            for (int j = 0; j < sz(deg[i]); j++) {
                if (mt[s[i] + j] == -1) {
                    cout << "No\n";
                    return;
                }
                int pos = upper_bound(all(s), mt[s[i] + j]) - s.begin();
                pos--;



                st.push_back({{i, j}, {pos, mt[s[i] + j] - s[pos]}});
            }
        }
    }

    vector<bool> used(sz(st), false);

    vector<int> p;

    while (true) {
        int cnt = 0;
        for (int j = 0; j < sz(st); j++) {
            if (used[j]) continue;
            cnt++;
            if (st[j].first.second == ptr[st[j].first.first]) {
                if (st[j].second.second == ptr[st[j].second.first]) {
                    used[j] = true;
                    p.push_back(id[{st[j].first.first, st[j].second.first}]);
                    ptr[st[j].first.first]++;
                    ptr[st[j].second.first]++;
                }
            }
        }
        if (cnt == 0) break;
    }

    cout << "Yes\n";

    for (auto v : p) {
        cout << v + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}