#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 4e5 + 10;

vector<pair<int, int>> g[N];
set<int> sx[N];

vector<int> r[N];

int used[N];
int timer = 1;

int mt[N];

bool kun (int i) {
    if (used[i] == timer) return false;
    used[i] = timer;

    for (auto v : r[i]) {
        if (mt[v] == -1) {
            mt[v] = i;
            return true;
        }
    }

    for (auto v : r[i]) {
        if (kun(mt[v])) {
            mt[v] = i;
            return true;
        }
    }

    return false;
}

int col[N];

void dfs (int u, int p = -1) {
    col[u] = (p == -1 ? 0 : col[p] ^ 1);

    for (auto v : g[u]) {
        if (v.first == p) continue;
        dfs(v.first, u);
    }
}

int n, t;

void solve2() {
    vector<vector<int>> edges;
    vector<int> d(n, 0);
    vector<int> s(n, 0);

    map<pair<int, int>, int> id;

    vector<vector<int>> deg(n);

    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        d[u]++;
        d[v]++;
        id[{u, v}] = id[{v, u}] = i;
        edges.push_back({u, v, w});
    }

    for (int i = 0; i < n; i++) {
        deg[i].resize(d[i]);
    }

    vector<int> which(2 * n, 0);

    vector<int> ss(n - 1, -1);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz(deg[i]); j++) {
            cin >> deg[i][j];
        }
        reverse(all(deg[i]));

        if (i > 0) {
            ss[i - 1] = edges[id[{i, 0}]][2] - deg[i][0];
        }
    }

    vector<int> ind2(n - 1, 0);
    iota(all(ind2), 0ll);
    sort(all(ind2), [&] (int i, int j){
        return deg[0][i] < deg[0][j];
    });
    vector<int> ind(n - 1, 0);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j){
        return ss[i] < ss[j];
    });

    vector<int> p(n - 1);

    for (int i = 0; i < n - 1; i++) {
        if (deg[0][ind2[i]] < ss[ind[i]]) {
            cout << "No\n";
            return;
        }
        p[ind2[i]] = id[{0, ind[i] + 1}];
    }

    cout << "Yes\n";

    for (auto v : p) {
        cout << v + 1 << " ";
    }

    cout << endl;
}

void solve() {
    cin >> n >> t;

    if (t == 3) {
        solve2();
        return;
    }

    vector<vector<int>> edges;
    vector<int> d(n, 0);
    vector<int> s(n, 0);

    vector<map<int, vector<int>>> meg(n);
    vector<set<pair<int, int>>> power(n);

    map<pair<int, int>, int> id;

    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        sx[u].insert(v);
        sx[v].insert(u);
        d[u]++;
        d[v]++;
        id[{u, v}] = id[{v, u}] = i;
        edges.push_back({u, v, w});
    }

    dfs(0);

    vector<vector<int>> deg(n);

    for (int i = 0; i < n; i++) {
        deg[i].resize(d[i]);
    }

    vector<int> which(2 * n, 0);

    for (int i = 1; i < n; i++) {
        s[i] = s[i - 1] + d[i - 1];
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz(deg[i]); j++) {
            cin >> deg[i][j];
            meg[i][deg[i][j]].push_back(j);
            power[i].insert({deg[i][j], j});
        }
        reverse(all(deg[i]));
    }

    if (t == 7) {
        // start with leaves
        vector<int> leaves;

        for (int i = 0; i < n; i++) {
            if (sz(sx[i]) == 1) leaves.push_back(i);
        }

        while (sz(leaves)) {
            int x = leaves.back();
            leaves.pop_back();

            if (sz(sx[x]) == 0) continue;

            for (auto u : sx[x]) {
                auto z = *power[x].begin();
                int need = edges[id[{x, u}]][2] - z.first;

                if (sz(meg[u][need])) {
                    int was = meg[u][need].back();
                    sx[u].erase(x);
                    if (sz(sx[u]) == 1) {
                        leaves.push_back(u);
                    }
                    power[u].erase({need, was});
                    was += s[u];
                    meg[u][need].pop_back();
                    r[s[x] + z.second].push_back(was);
                    r[was].push_back(s[x] + z.second);
                } else {
                    break;
                }
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            for (auto x : g[i]) {
                int v = x.first, w = x.second;

                for (int j = 0; j < sz(deg[i]); j++) {
                    for (int k = 0; k < sz(deg[v]); k++) {
                        if (deg[i][j] + deg[v][k] >= w) {
                            r[s[i] + j].push_back(s[v] + k);
                        }
                    }
                }
            }
        }
    }

    fill(mt, mt + N, -1);

    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            for (int j = 0; j < sz(deg[i]); j++) {
                timer++;
                kun(s[i] + j);
            }
        }
    }

    vector<pair<pair<int, int>, pair<int, int>>> st;

    vector<pair<int, int>> waiting(n - 1);
    vector<vector<int>> rem(n);

    for (int i = 0; i < n; i++) {
        rem[i].resize(d[i]);
    }

    vector<int> ptr(n, 0);

    for (int i = 0; i < n; i++) {
        if (col[i] == 0) {
            for (int j = 0; j < sz(deg[i]); j++) {
                if (mt[s[i] + j] == -1) {
                    cout << "No\n";
                    return;
                }
                int pos = upper_bound(all(s), mt[s[i] + j]) - s.begin();
                pos--;

                int u = i, v = pos, wu = j, wv = mt[s[i] + j] - s[pos];

                if (u > v) swap(u, v), swap(wu, wv);

                int X = id[{u, v}];

                waiting[X] = {wu, wv};

                rem[u][wu] = X;
                rem[v][wv] = X;

//                st.push_back({{i, j}, {pos, mt[s[i] + j] - s[pos]}});
            }
        }
    }

    vector<bool> was(n - 1, false);

    vector<int> p;

    vector<int> waiting_room;

    for (int i = 0; i < n - 1; i++) {
        if (waiting[i] == make_pair(0, 0)) waiting_room.push_back(i), was[i] = true;
    }

    while (sz(waiting_room)) {
        auto idx = waiting_room.back();
        waiting_room.pop_back();

        p.push_back(idx);
        ptr[edges[idx][0]]++;
        ptr[edges[idx][1]]++;

        for (int x = 0; x < 2; x++) {
            int u = edges[idx][x];
            if (ptr[u] != d[u]) {
                int who = rem[u][ptr[u]];
                if (!was[who]) {
                    int i = edges[who][0], j = edges[who][1];
                    if (i > j) swap(i, j);
                    if (ptr[i] == waiting[who].first && ptr[j] == waiting[who].second) {
                        was[who] = true;
                        waiting_room.push_back(who);
                    }
                }
            }
        }
    }

    cout << "Yes\n";

    for (auto v : p) {
        cout << v + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}