#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using db = double;

struct Edge {
    int u, v, w;
};

struct Input {
    int n, G;
    vector<Edge> e;
    vector<vector<int>> c;
};

Input input() {
    int n, G;
    cin >> n >> G;
    vector<Edge> e;
    vector<int> deg(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, c; cin >> a >> b >> c; a--; b--;
        deg[a]++;
        deg[b]++;
        e.push_back({a, b, c});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) cin >> c[i][j];
    }
    return {n, G, e, c};
}

vector<int> stupidSolve(Input inp) {
    auto [n, G, e, c] = std::move(inp);
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    vector<int> deg(n);
    for (auto [u, v, w] : e) {
        deg[v]++;
        deg[u]++;
    }
    do {
        if (p[0] == 4) {
            int tr = 0;
        }
        vector<int> ptrs(n);
        for (int i = 0; i < n; ++i) ptrs[i] = deg[i] - 1;
        bool ok = true;
        for (int i = 0; i < n - 1; ++i) {
            auto [u, v, w] = e[p[i]];
            if (c[u][ptrs[u]] + c[v][ptrs[v]] < w) {
                ok = false;
                break;
            }
            ptrs[u]--;
            ptrs[v]--;
        }
        if (ok) return p;
    } while (next_permutation(p.begin(), p.end()));
    return {};
}

void output(const vector<int>& a) {
    if (a.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (auto i : a) cout << i + 1 << ' ';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    output(stupidSolve(input()));
    return 0;
}
