#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using db = double;

struct Edge {
    int u, v, w;
};

struct Input {
    int n, G;
    vector<Edge> e;
    vector<vector<int>> c;
};

Input input() {
    int n, G;
    cin >> n >> G;
    vector<Edge> e;
    vector<int> deg(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, c; cin >> a >> b >> c; a--; b--;
        deg[a]++;
        deg[b]++;
        e.push_back({a, b, c});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) cin >> c[i][j];
    }
    return {n, G, e, c};
}

vector<int> stupidSolve(Input inp) {
    auto [n, G, e, c] = std::move(inp);
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    vector<int> deg(n);
    for (auto [u, v, w] : e) {
        deg[v]++;
        deg[u]++;
    }
    do {
        if (p[0] == 4) {
            int tr = 0;
        }
        vector<int> ptrs(n);
        for (int i = 0; i < n; ++i) ptrs[i] = deg[i] - 1;
        bool ok = true;
        for (int i = 0; i < n - 1; ++i) {
            auto [u, v, w] = e[p[i]];
            if (c[u][ptrs[u]] + c[v][ptrs[v]] < w) {
                ok = false;
                break;
            }
            ptrs[u]--;
            ptrs[v]--;
        }
        if (ok) return p;
    } while (next_permutation(p.begin(), p.end()));
    return {};
}

//bool ok(vector<int> a, vector<int> b) {
//    sort(a.begin(), a.end());
//    sort(b.begin(), b.end());
//    for (int i = 0; i < (int)a.size(); ++i) {
//        if (b[i] > a[i]) return false;
//    }
//    return true;
//}
//
//void dfs(int v, int p, vector<vector<Edge>>& g, const vector<vector<int>>& c, vector<int>& dp) {
//    for (int i = 0; i < (int)g[v].size(); ++i) {
//        if (g[v][i].v == p) {
//            g[v].erase(g[v].begin() + i);
//            break;
//        }
//    }
//    vector<int> childr;
//    for (auto [from, to, w] : g[v]) {
//        dfs(to, v, g, c, dp);
//        childr.push_back(w - c[to][dp[to]]);
//    }
//    if (v == 0) {
//        if ()
//    }
//    if (g[v].empty()) {
//        dp[v] = 0;
//        return;
//    }
//    dp[v] = -1;
//    for (int i = 0; i < (int)g[v].size(); ++i) {
//        vector<int> me;
//        for (int j = 0; j < (int)g[v].size(); ++j) {
//            if (i == j) continue;
//            me.push_back(c[v][j]);
//        }
//        if (ok(childr, me)) {
//            if (dp[v] == -1 || c[v][dp[v]] > c[v][i]) {
//                dp[v] = i;
//            }
//        }
//    }
//}
//
//vector<int> smartSolve(Input inp) {
//    auto [n, G, e, c] = std::move(inp);
//    vector<vector<Edge>> g(n);
//    for (auto [u, v, w] : e) {
//        g[u].push_back({u, v, w});
//        g[v].push_back({v, u, w});
//    }
//    vector<int> dp(n);
//    dfs(0, 0, g, c, dp);
//}

vector<int> EchSolve(Input inp) {
    auto [n, G, e, c] = std::move(inp);
    vector<pair<int, int>> a(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        a[i] = {c[0][i], n - 1 - i};
    }
    vector<pair<int, int>> b(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        auto [u, v, w] = e[i];
        if (u != 0) swap(u, v);
        b[i] = {w - c[v][0], i};
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<int> ans(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        if (a[i].first < b[i].first) {
            return {};
        }
        ans[a[i].second] = b[i].second;
    }
    return ans;
}

void output(const vector<int>& a) {
    if (a.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (auto i : a) cout << i + 1 << ' ';
}

mt19937 rnd(57);

Input gen() {
    int n = rnd() % 7 + 2;
    int G = 0;
    vector<Edge> e(n - 1);
    vector<int> deg(n);
    for (int i = 1; i < n; ++i) {
        int p = 0;
        deg[i]++;
        deg[p]++;
        int w = rnd() % 10 + 1;
        e[i - 1] = {i, p, w};
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            c[i][j] = (int)(rnd() % 10);
        }
    }
    return {n, G, e, c};
}

void stress() {
    while (true) {
        auto test = gen();
        auto ansTrue = stupidSolve(test);
        auto ansFalse = EchSolve(test);
        if (ansFalse.size() != ansTrue.size()) {
            cout << test.n << ' ' << test.G << '\n';
            for (auto i : test.e) {
                cout << i.u + 1 << ' ' << i.v + 1 << ' ' << i.w << '\n';
            }
            for (int i = 0; i < test.n; ++i) {
                for (auto j : test.c[i]) {
                    cout << j << ' ';
                }
                cout << '\n';
            }
            output(ansTrue);
            output(ansFalse);
            break;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    stress();
//    Input inp = input();
//    if (inp.n <= 1) {
//        output(stupidSolve(inp));
//    } else {
//        output(EchSolve(inp));
//    }
    return 0;
}
