#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<bitset>
#include<cmath>
#include<iomanip>
#include<deque>
#include<queue>
using namespace std;

const int INF = 1e9;

struct edge {
	int a, b, w, id;

	bool operator<(const edge& other) const {
		return w < other.w;
	}
};

struct sticker {
	int num, id;

	bool operator<(const sticker& other) const {
		return num < other.num;
	}
};

vector<edge> g;
vector<int> deg;
vector<vector<sticker>> st;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//B

	int n, test;
	cin >> n >> test;
	
	vector<int> p(n - 1);
	g.resize(n - 1);
	st.resize(n);
	deg.resize(n);

	for (int i = 0; i < n - 1; ++i) {
		p[i] = i;
		cin >> g[i].a >> g[i].b >> g[i].w;
		g[i].a--;
		g[i].b--;
		deg[g[i].a]++;
		deg[g[i].b]++;
		g[i].id = i;
	}

	for (int i = 0; i < n; ++i) {
		st[i].resize(deg[i]);
		for (int j = deg[i] - 1; j >= 0; --j) {
			cin >> st[i][j].num;
			st[i][j].id = j;
		}
	}

	if (n <= 10) {
		while (true) {
			vector<int> cur_w(n, 0);
			bool f = true;
			for (int i = 0; i < n - 1; ++i) {
				int j = p[i];
				int a = g[j].a, b = g[j].b;
				if (g[j].w <= st[a][cur_w[a]].num + st[b][cur_w[b]].num) {
					cur_w[a]++;
					cur_w[b]++;
				}
				else {
					f = false;
					break;
				}
			}

			if (f) {
				cout << "Yes\n";
				for (auto e : p) {
					cout << e + 1 << ' ';
				}
				return 0;
			}

			if (!next_permutation(p.begin(), p.end())) {
				break;
			}
		}

		cout << "No";
		return 0;
	}

	for (int i = 0; i < n - 1; ++i) {
		g[i].w -= st[g[i].b][0].num;
	}
	
	sort(g.begin(), g.end());
	sort(st[0].begin(), st[0].end());

	vector<int> ans(n - 1);
	for (int i = 0; i < n - 1; ++i) {
		if (st[0][i].num >= g[i].w) {
			ans[st[0][i].id] = g[i].id;
		}
		else {
			cout << "No";
			return 0;
		}
	}

	cout << "Yes\n";
	for (auto e: ans) {
		cout << e + 1 << ' ';
	}

	return 0;
}