#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<bitset>
#include<cmath>
#include<iomanip>
#include<deque>
#include<queue>
using namespace std;

const int INF = 1e9;

struct edge {
	int a, b, w, id;

	bool operator<(const edge& other) const {
		return w < other.w;
	}
};

struct sticker {
	int num, id;

	bool operator<(const sticker& other) const {
		return num < other.num;
	}
};

vector<edge> g;
vector<vector<edge>> gr;
vector<int> deg;
vector<vector<sticker>> st;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//B

	int n, test;
	cin >> n >> test;
	
	vector<int> p(n - 1);
	g.resize(n - 1);
	st.resize(n);
	deg.resize(n);
	gr.resize(n);

	for (int i = 0; i < n - 1; ++i) {
		p[i] = i;
		cin >> g[i].a >> g[i].b >> g[i].w;
		g[i].a--;
		g[i].b--;
		deg[g[i].a]++;
		deg[g[i].b]++;/*
		gr[g[i].a].push_back(g[i]);
		gr[g[i].b].push_back({ g[i].b, g[i].a, g[i].w });*/
		g[i].id = i;
	}

	for (int i = 0; i < n; ++i) {
		st[i].resize(deg[i]);
		for (int j = deg[i] - 1; j >= 0; --j) {
			cin >> st[i][j].num;
			st[i][j].id = j;
		}
	}

	if (n <= 10) {
		while (true) {
			vector<int> cur_w(n, 0);
			bool f = true;
			for (int i = 0; i < n - 1; ++i) {
				int j = p[i];
				int a = g[j].a, b = g[j].b;
				if (g[j].w <= st[a][cur_w[a]].num + st[b][cur_w[b]].num) {
					cur_w[a]++;
					cur_w[b]++;
				}
				else {
					f = false;
					break;
				}
			}

			if (f) {
				cout << "Yes\n";
				for (auto e : p) {
					cout << e + 1 << ' ';
				}
				return 0;
			}

			if (!next_permutation(p.begin(), p.end())) {
				break;
			}
		}

		cout << "No";
		return 0;
	}

	if (test == 3) {
		for (int i = 0; i < n - 1; ++i) {
			g[i].w -= st[g[i].b][0].num;
		}

		sort(g.begin(), g.end());
		sort(st[0].begin(), st[0].end());

		vector<int> ans(n - 1);
		for (int i = 0; i < n - 1; ++i) {
			if (st[0][i].num >= g[i].w) {
				ans[st[0][i].id] = g[i].id;
			}
			else {
				cout << "No";
				return 0;
			}
		}

		cout << "Yes\n";
		for (auto e : ans) {
			cout << e + 1 << ' ';
		}

		return 0;
	}

	if (test == 2) {
		
		for (int i = 0; i < n; ++i) {
			sort(st[i].begin(), st[i].end());
		}

		int cur = 0, i = 0;
		bool adachi = true;
		deque<int> ans;
		
		while (cur < n - 1) {
			if (g[cur].w <= st[cur][i].num + st[cur + 1][0].num) {
				if (!st[cur][i].id) {
					ans.push_front(cur + 1);
				}
				else {
					ans.push_back(cur + 1);
				}
				i = 1;
			}
			else if (g[cur].w <= st[cur][i].num + st[cur + 1][1].num) {
				if (!st[cur][i].id) {
					ans.push_front(cur + 1);
				}
				else {
					ans.push_back(cur + 1);
				}
				i = 0;
			}
			else {
				cout << "No";
				return 0;
			}
			++cur;
		}

		cout << "Yes\n";
		for (auto e: ans) {
			cout << e << ' ';
		}

		return 0;
	}

	if (test == 4) {

		sort(g.begin(), g.end());
		sort(st[0].begin(), st[0].end());
		sort(st[1].begin(), st[1].end());

		vector<int> ans0(deg[0]), ans1(deg[1]);

		for (int i = 2; i < n; ++i) {
			g[i - 1].w -= st[i][0].num;
		}

		int sk0 = -1, sk1 = -1;
		int j = 0, k = 0, oz;
		for (int i = 0; i < n - 1; ++i) {
			if (g[i].a == 0 && g[i].b == 1) {
				oz = i;
				continue;
			}
			if (g[i].a == 0) {
				if (st[0][j].num >= g[i].w) {
					ans0[st[0][j].id] = g[i].id + 1;
				}
				else {
					if (sk0 == -1 && st[0][j + 1].num >= g[i].w) {
						sk0 = j;
						ans0[st[0][j + 1].id] = g[i].id + 1;
					}
					else {
						cout << "No";
						return 0;
					}
				}
				++j;
			}
			else {
				if (st[1][k].num >= g[i].w) {
					ans1[st[1][k].id] = g[i].id + 1;
				}
				else {
					if (sk1 == -1 && st[1][k + 1].num >= g[i].w) {
						sk1 = k;
						ans1[st[1][k + 1].id] = g[i].id + 1;
					}
					else {
						cout << "No";
						return 0;
					}
				}
				++k;
			}
		}
		if (sk0 == -1) {
			sk0 = deg[0] - 1;
		}
		if (sk1 == -1) {
			sk1 = deg[1] - 1;
		}
		if (st[0][sk0].num + st[1][sk1].num < g[oz].w) {
			cout << "No";
			return 0;
		}

		cout << "Yes\n";
		
		j = 0;
		k = 0;
		while (j < st[0][sk0].id) {
			cout << ans0[j++] << ' ';
		}
		while (k < st[1][sk1].id) {
			cout << ans1[k++] << ' ';
		}
		cout << 1 << ' ';
		++j;
		++k;
		while (j < deg[0]) {
			cout << ans0[j++] << ' ';
		}
		while (k < deg[1]) {
			cout << ans1[k++] << ' ';
		}

		return 0;
	}

	return 0;
}