#pragma target("Ofast, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long

using namespace std;

#define debug(x) cout << #x << " = " << x << endl;

struct Edge {
    int a, b, w;
    Edge(int z, int x, int y) {
        a = z;
        b = x;
        w = y;
    }
};

const int N = 2e5 + 228;

vector<Edge> G[N];
vector<Edge> edges;
vector<int> C[N];
int P[N], SZ[N];

int get_p(int v) {
    if (P[v] == v) {
        return v;
    }
    return P[v] = get_p(P[v]);
}

void unite(int a, int b) {
    a = get_p(a);
    b = get_p(b);
    if (SZ[a] > SZ[b])
        swap(a, b);
    SZ[b] += SZ[a];
    P[a] = b;
}

void solve() {
    int n, g;
    cin >> n >> g;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        edges.push_back(Edge(a, b, w));
        G[a].push_back(Edge(a, b, w));
        G[b].push_back(Edge(b, a, w));
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < G[i].size(); ++j) {
            int x;
            cin >> x;
            C[i].push_back(x);
        }
    }
//    for (auto el : C[0]) {
//        cout << el << ' ';
//    }
//    cout << '\n';
//    for (auto el : C[1]) {
//        cout << el << ' ';
//    }
//    cout << '\n';
//    cout << "---" << endl;
    if (n <= 10) {
        vector<int> perm;
        for (int i = 0; i < n - 1; ++i) {
            perm.push_back(i);
        }
        vector<int> ans;
        do {
            for (int i = 0; i < n; ++i) {
                P[i] = i;
                SZ[i] = 1;
            }
            vector<int> idxs(n);
            for (int i = 0; i < n; ++i) {
                idxs[i] = (int)C[i].size() - 1;
            }
            bool ok = true;
//            vector<int> lol = {0, 3, 1, 2};
//            if (perm == lol) {
//                cout << "OP" << endl;
//            }
            for (auto idx : perm) {
                if (get_p(edges[idx].a) == get_p(edges[idx].b)) {
//                    if (perm == lol) {
//                        debug(idx);
//                        debug((get_p(edges[idx].a) == get_p(edges[idx].b)));
//                    }
                    ok = false;
                    break;
                }
                if (idxs[edges[idx].a] < 0 || idxs[edges[idx].b] < 0 || edges[idx].w > C[edges[idx].a][idxs[edges[idx].a]] + C[edges[idx].b][idxs[edges[idx].b]]) {
//                    if (perm == lol) {
//                        debug(idx);
//                        debug((idxs[edges[idx].a] < 0));
//                        debug((idxs[edges[idx].b] < 0));
//                        debug(edges[idx].w);
//                        debug(C[edges[idx].a][idxs[edges[idx].a]]);
//                        debug(C[edges[idx].b][idxs[edges[idx].b]]);
//                        debug(edges[idx].a);
//                        debug(edges[idx].b);
//                        for (auto el : C[edges[idx].a]) cout << el << ' ';
//                        cout << '\n';
//                        for (auto el : C[edges[idx].b]) cout << el << ' ';
//                        cout << '\n';
//                        debug((edges[idx].w >
//                               C[edges[idx].a][idxs[edges[idx].a]] + C[edges[idx].b][idxs[edges[idx].b]]));
//                    }
                    ok = false;
                    break;
                }
                idxs[edges[idx].a]--;
                idxs[edges[idx].b]--;
                unite(edges[idx].a, edges[idx].b);
            }
            if (ok) {
                ans = perm;
                break;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        if (ans.empty()) {
            cout << "No";
        } else {
            cout << "Yes\n";
            for (auto el : ans) {
                cout << el + 1 << ' ';
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
