#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a, b, c, i;
    Edge() = default;
};

int main() {
    int n, g;
    std::cin >> n >> g;
    std::vector<Edge> edges(n - 1);
    std::vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        std::cin >> edges[i].a >> edges[i].b >> edges[i].c;
        edges[i].a--;
        edges[i].b--;
        edges[i].i = i;
        deg[edges[i].a]++;
        deg[edges[i].b]++;
    }
    // std::sort(edges.begin(), edges.end(), [](const Edge& a, const Edge& b) {
    //     return a.c < b.c;
    // });
    std::vector<std::vector<int>> vals(n);
    for (int i = 0; i < n; i++) {
        vals[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            std::cin >> vals[i][j];
        }
        std::reverse(vals[i].begin(), vals[i].end());
    }

    std::vector<bool> used(n - 1, false);
    std::vector<int> ord;
    ord.reserve(n - 1);
    bool found = true;
    while (found) {
        found = false;
        int besti = -1;
        int bestres = 2100000000;
        for (int i = n - 2; i >= 0; i--) {
            if (!used[i]) {
                if (vals[edges[i].a].back() + vals[edges[i].b].back() < edges[i].c) {
                    continue;
                }
                if (vals[edges[i].a].back() + vals[edges[i].b].back() - edges[i].c < bestres) {
                    bestres = vals[edges[i].a].back() + vals[edges[i].b].back() - edges[i].c;
                    besti = i;
                }
            }
        }
        if (besti != -1) {
            found = true;
            used[besti] = true;
            ord.emplace_back(besti);
            vals[edges[besti].a].pop_back();
            vals[edges[besti].b].pop_back();
        }
    }
    std::reverse(ord.begin(), ord.end());
    if (ord.size() == n - 1) {
        std::cout << "Yes\n";
        for (int i = 0; i < (int)n - 1; i++) {
            std::cout << ord[i] + 1 << " \n"[i == n - 2];
        }
    } else {
        std::cout << "No\n";
    }
    return 0;
}