#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

struct Edge {
    int a, b, c, i;
    Edge() = default;
};

int solve56(int n, std::vector<Edge>& edges, std::vector<std::vector<int>>& vals) {
    std::vector<bool> used(n - 1, false);
    std::vector<int> ord;
    ord.reserve(n - 1);
    bool found = true;
    while (found) {
        found = false;
        int besti = -1;
        int bestres = 2100000000;
        for (int i = n - 2; i >= 0; i--) {
            if (!used[i]) {
                if (vals[edges[i].a].back() + vals[edges[i].b].back() < edges[i].c) {
                    continue;
                }
                if (vals[edges[i].a].back() + vals[edges[i].b].back() - edges[i].c < bestres) {
                    bestres = vals[edges[i].a].back() + vals[edges[i].b].back() - edges[i].c;
                    besti = i;
                }
            }
        }
        if (besti != -1) {
            found = true;
            used[besti] = true;
            ord.emplace_back(besti);
            vals[edges[besti].a].pop_back();
            vals[edges[besti].b].pop_back();
        }
    }
    std::reverse(ord.begin(), ord.end());
    if (ord.size() == n - 1) {
        std::cout << "Yes\n";
        for (int i = 0; i < (int)n - 1; i++) {
            std::cout << ord[i] + 1 << " \n"[i == n - 2];
        }
    } else {
        std::cout << "No\n";
    }
    return 0;
}

int solve1(int n, std::vector<Edge>& edges, std::vector<std::vector<int>>& vals) {
    std::vector<int> perm(n - 1);
    std::iota(perm.begin(), perm.end(), 0);
    do {
        bool good = true;
        std::vector<std::vector<int>> cvals(n);
        for (int i = 0; i < n; i++) {
            cvals[i] = std::vector<int>(vals[i].begin(), vals[i].end());
        }
        for (int i = 0; i < n - 1; i++) {
            int cn = perm[i];
            if (cvals[edges[cn].a].back() + cvals[edges[cn].b].back() < edges[cn].c) {
                good = false;
                break;
            } else {
                cvals[edges[cn].a].pop_back();
                cvals[edges[cn].b].pop_back();
            }
        }
        if (good) {
            std::cout << "Yes\n";
            for (int i = 0; i < n - 1; i++) {
                std::cout << perm[i] + 1 << " \n"[i == n - 2];
            }
            return 0;
        }
    } while (std::next_permutation(perm.begin(), perm.end()));
    std::cout << "No\n";
    return 0;
}

int main() {
    int n, g;
    std::cin >> n >> g;
    std::vector<Edge> edges(n - 1);
    std::vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        std::cin >> edges[i].a >> edges[i].b >> edges[i].c;
        edges[i].a--;
        edges[i].b--;
        edges[i].i = i;
        deg[edges[i].a]++;
        deg[edges[i].b]++;
    }
    std::vector<std::vector<int>> vals(n);
    for (int i = 0; i < n; i++) {
        vals[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            std::cin >> vals[i][j];
        }
        std::reverse(vals[i].begin(), vals[i].end());
    }

    if (g == 1) {
        return solve1(n, edges, vals);
    }
    if (g == 5 || g == 6) {
        return solve56(n, edges, vals);
    }
}