#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

struct Edge {
    int v, u, w, id;

    Edge(int v, int u, int w, int id) : v(v), u(u), w(w), id(id) {}
};

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, subtask;
    cin >> n >> subtask;
    vector<vector<pair<int, int>>> a(n);
    vector<Edge> e;
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n - 1; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        mp[{v, u}] = i;
        mp[{u, v}] = i;
        e.emplace_back(v, u, w, i);
        a[v].emplace_back(u, w);
        a[u].emplace_back(v, w);
    }

    vector<vector<int>> d(n);
    vector<vector<int>> id(n);
    for (int v = 0; v < n; ++v) {
        d[v].resize((int) a[v].size());
        id[v].assign((int) a[v].size(), -1);
        for (int &i : d[v]) {
            cin >> i;
        }
    }

    //cout << "GOOD" << endl;

    vector<pair<int, int>> l, r;
    vector<int> col(n), tin(n);

    auto dfs_part = [&] (auto self, int v, int p, int c) -> void {
        col[v] = c;
        if (c == 0) {
            for (int i = 0; i < (int) d[v].size(); ++i) {
                int x = d[v][i];
                id[v][i] = (int) l.size();
                l.emplace_back(i, v);
            }
            tin[v] = (int) l.size() - 1;
        } else {
            for (int i = 0; i < (int) d[v].size(); ++i) {
                int x = d[v][i];
                id[v][i] = (int) r.size();
                r.emplace_back(i, v);
            }
            tin[v] = (int) r.size() - 1;
        }
        for (auto [u, w] : a[v]) {
            if (u == p) {
                continue;
            }
            self(self, u, v, !c);
        }
    };
    dfs_part(dfs_part, 0, -1, 0);

    /*for (auto [i, j] : l) {
        cout << i << ',' << j << ' ';
    }
    cout << endl;
    for (auto [i, j] : r) {
        cout << i << ',' << j << ' ';
    }
    cout << endl;
    for (auto i : tin) {
        cout << i << ' ';
    }
    cout << endl;*/

    int m = (int) l.size();
    vector<vector<int>> g(m);
    for (auto [v, u, w, ind] : e) {
        for (int i = 0; i < (int) d[v].size(); ++i) {
            for (int j = 0; j < (int) d[u].size(); ++j) {
                if (d[v][i] + d[u][j] >= w) {
                    //cout << v << ',' << u << ' ' << d[v][i] << ',' << d[u][j] << ' ';
                    if (col[v] == 0) {
                        g[id[v][i]].push_back(id[u][j]);
                        //cout << id[v][i] << ' ' << id[u][j];
                    } else {
                        g[id[u][j]].push_back(id[v][i]);
                        //cout << id[u][j] << ' ' << id[v][i];
                    }
                    //cout << endl;
                }
            }
        }
    }

    int k = (int) r.size();
    vector<int> used, p(k, -1);
    auto dfs = [&] (auto self, int v) -> bool {
        if (used[v]) {
            return false;
        }
        used[v] = 1;
        for (int u : g[v]) {
            if (p[u] == -1) {
                p[u] = v;
                return true;
            }
        }
        for (int u : g[v]) {
            if (self(self, p[u])) {
                p[u] = v;
                return true;
            }
        }
        return false;
    };


    for (int x = 0; x < m; ++x) {
        used.assign(m, 0);
        dfs(dfs, x);
    }

    for (int i = 0; i < k; ++i) {
        if (p[i] == -1) {
            cout << "No\n";
            return 0;
        }
    }
    cout << "Yes\n";
    set<int> t;
    for (int i = 0; i < k; ++i) {
        t.insert(i);
    }
    vector<int> ans;
    while (!t.empty()) {
        int er = -1;
        for (auto i : t) {
            int j = p[i];
            int x = r[i].first, v = r[i].second;
            int y = l[p[i]].first, u = l[p[i]].second;
            if (tin[v] == id[v][x] && tin[u] == id[u][y]) {
                ans.push_back(mp[{v, u}]);
                tin[v]--;
                tin[u]--;
                er = i;
                break;
            }
        }
        t.erase(er);
    }
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
}