#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

const int N = 2e5 + 3;

vector<tuple<int, int, int>> g[N];
set<pair<int, int>> c[N];
//set<pair<int, int>> sv[N];

vector<int> g2[N];

pair<int, int> dfs(int v, int p) {
    vector<int> nw_inds(g[v].size());
    vector<int> old_inds(g[v].size());
    for (auto [u, w, ind] : g[v]) {
        if (u == p) continue;
        auto [cfr, indfr] = dfs(u, v);
        auto cur = c[v].lower_bound({w - cfr, -1});
        if (cur == c[v].end()) {
            cout << "No";
            exit(0);
        }

        nw_inds[ind] = cur->S;
        old_inds[cur->S] = ind;

        c[v].erase(cur);
    }

    for (auto [u, w, ind] : g[v]) {
        if (u != p) continue;
        auto cur = c[v].begin();
        nw_inds[ind] = cur->S;
        old_inds[cur->S] = ind;
    }

    for (auto [u, w, ind] : g[v]) {
        if (nw_inds[ind] + 1 == g[v].size()) continue;
        g2[ind].emplace_back(old_inds[nw_inds[ind] + 1]);
    }

    return (c[v].empty() ? make_pair(0, 0) : *c[v].begin());
}

bool used[N];
vector<int> p;

void topsort(int v) {
    used[v] = true;
    for (auto u : g2[v]) {
        if (used[u]) continue;
        topsort(u);
    }
    p.emplace_back(v);
}

void solve() {
    int n, gr;
    cin >> n >> gr;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w, i);
        g[v].emplace_back(u, w, i);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int cur;
            cin >> cur;
            c[i].insert({cur, g[i].size() - j - 1});
            //sv[i].insert({cur, g[i].size() - j - 1});
        }
    }

    dfs(0, 0);
    vector<bool> not_intresting(n, false);
    for (int i = 0; i < n - 1; i++) {
        for (auto u : g2[i]) {
            not_intresting[u] = true;
        }
    }
    for (int i = 0; i < n - 1; i++) {
        if (!not_intresting[i])
            topsort(i);
    }

    reverse(all(p));
    cout << "Yes\n";
    for (auto &i : p) cout << i + 1 << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
