// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;

#ifndef _DEBUG
const int MAXN = 2e5 + 10;
#else
const int MAXN = 100;
#endif // _DEBUG
set <pair<int,int>>g[MAXN];
set<pair<int,int>> evidence[MAXN];
vector<int>real[MAXN], act[MAXN];
int db[MAXN][4];
unordered_set<int>leaf;
set<pair<int, int>> cur;

void onchange(int v)
{
	if (g[v].size() == 0)
		leaf.erase(v);
	else if (g[v].size() == 1)
		leaf.insert(v);
}

void onchange2(int v)
{
	if (act[v].empty())
		return;
	cur.erase({ db[act[v].back()][1],act[v].back() });
	db[act[v].back()][1]--;
	cur.insert({ db[act[v].back()][1],act[v].back() });

}

void edge(int id)
{
	cur.erase({ db[id][1],id });
	act[db[id][2]].pop_back();
	act[db[id][3]].pop_back();
	onchange2(db[id][2]);
	onchange2(db[id][3]);
}

int main()
{
	//std::cout << "Hello World!\n";
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	memset(db, 0, sizeof(db));
	int n, _unused;
	cin >> n >> _unused;
	for (size_t i = 1; i < n; i++)
	{
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		db[i][0] = w;
		db[i][2] = u;
		db[i][3] = v;
		g[u].emplace(v, i);
		g[v].emplace(u, i);
	}
	for (size_t i = 0; i < n; i++)
	{
		int deg = g[i].size();
		for (size_t j = 0; j < deg; j++)
		{
			int c;
			cin >> c;
			evidence[i].emplace(c, j);
			real[i].push_back(c);
			act[i].emplace_back();
		}
	}
	for (size_t i = 0; i < n; i++)
	{
		onchange(i);
	}
	while (!leaf.empty())
	{
		int v = *leaf.begin();
		int u = g[v].begin()->first;
		int e = g[v].begin()->second;
		auto ev = *evidence[v].begin();
		act[v][ev.second] = e;
		int least = db[e][0] - ev.first;
		g[v].erase(g[v].begin());
		g[u].erase({ v,e });
		auto oth = evidence[u].lower_bound({ least,0 });
		if (oth == evidence[u].end())
		{
			cout << "No\n";
			return 0;
		}
		act[u][oth->second] = e;
		evidence[u].erase(oth);
		onchange(v);
		onchange(u);
	}
	for (size_t i = 1; i < n; i++)
	{
		db[i][1] = 2;
		cur.emplace(db[i][1], i);
	}
	for (size_t i = 0; i < n; i++)
	{
		onchange2(i);
	}
	cout << "Yes\n";
	while (!cur.empty())
	{
		cout << cur.begin()->second << ' ';
		edge(cur.begin()->second);
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
