#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<tuple<int, int, int>>> g;
vector<vector<int>> c;
vector<int> dp;
vector<vector<pair<int, int>>> edgord;

void dfs(int v, int p = -1) {
    vector<int> ord(c[v].size());
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int a, int b) {
        return c[v][a] < c[v][b];
        });
    vector<vector<pair<int, int>>> cnt(c[v].size());
    for (auto [to, tow, toid] : g[v]) {
        if (to == p)
            continue;
        dfs(to, v);
        int town = tow - c[to][dp[to]];
        if (c[v][ord.back()] < town) {
            cout << "No";
            exit(0);
        }
        int l = -1, r = ord.size() - 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (c[v][ord[m]] >= town)
                r = m;
            else
                l = m;
        }
        cnt[r].push_back({ to, toid });
    }
    edgord[v].resize(ord.size(), { -1, -1 });
    queue<pair<int, int>> toins;
    for (int i = 0; i < ord.size(); ++i) {
        for (auto el : cnt[i])
            toins.push(el);
        if (toins.size()) {
            edgord[v][ord[i]] = toins.front();
            toins.pop();
        }
    }
    if (toins.size()) {
        cout << "No";
        exit(0);
    }
    for (int i = 0; i < ord.size(); ++i)
        if (edgord[v][ord[i]].first == -1)
            dp[v] = ord[i];
}

vector<int> ans;

void push(int v, int p = -1, int pid = -1) {
    for (int toidi = 0; toidi < dp[v]; ++toidi) {
        auto [to, toid] = edgord[v][toidi];
        push(to, v, toid);
    }
    if (dp[v] != -1) {
        ans.push_back(pid);
    }
    for (int toidi = dp[v] + 1; toidi < g[v].size(); ++toidi) {
        auto [to, toid] = edgord[v][toidi];
        push(to, v, toid);
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, gr;
    cin >> n >> gr;
    g.resize(n), c.resize(n), dp.resize(n, -1), edgord.resize(n);
    for (int i = 1; i < n; ++i) {
        int ai, bi, wi;
        cin >> ai >> bi >> wi;
        --ai, --bi;
        g[ai].push_back({ bi, wi, i });
        g[bi].push_back({ ai, wi, i });
    }
    for (int i = 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (auto& el : c[i])
            cin >> el;
        reverse(c[i].begin(), c[i].end());
    }
    dfs(0);
    push(0);
    cout << "Yes\n";
    for (auto el : ans)
        cout << el << " ";
}