#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int to, len;
};

struct e {
	int x, y, w;
};

bool operator<(e a, e b) { return tie(a.x, a.y) < tie(b.x, b.y); }

int n, nmb;
vector <vector <st>> g;
vector <e> ed;
vector <vector <int>> c, gn;
vector <int> ord, ans;
vector <bool> used;

bool check() {
	vector <int> kol(n);
	for (int i = 0; i < n; i++) kol[i] = g[i].size() - 1;
	for (auto i : ord) {
		if (c[ed[i].x][kol[ed[i].x]] + c[ed[i].y][kol[ed[i].y]] < ed[i].w) return 0;
		kol[ed[i].x]--, kol[ed[i].y]--;
	}
	return 1;
}

void dfs(int v, int pr) {
	ord.push_back(v);
	for (auto i : g[v]) {
		if (i.to != pr) dfs(i.to, v);
	}
}

void gettp(int v) {
	used[v] = 1;
	for (auto i : gn[v]) {
		if (!used[i]) gettp(i);
	}
	ans.push_back(v);
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n >> nmb;
	g.resize(n), c.resize(n), ed.resize(n - 1), used.resize(n - 1);
	map <e, int> inded;
	for (int i = 0; i < n - 1; i++) {
		ord.push_back(i);
		int x, y, w; cin >> x >> y >> w; x--, y--;
		if (x > y) swap(x, y);
		g[x].push_back({ y, w });
		g[y].push_back({ x, w });
		ed[i] = { x, y, w };
		inded[{x, y, w}] = i;
	}
	for (int i = 0; i < n; i++) {
		c[i].resize(g[i].size());
		for (int j = 0; j < c[i].size(); j++) cin >> c[i][j];
	}
	if (nmb == 0 || nmb == 1) {
		do {
			if (check()) {
				cout << "Yes\n";
				for (auto i : ord) cout << i + 1 << ' ';
				return 0;
			}
		} while (next_permutation(ord.begin(), ord.end()));
		cout << "No";
	}
	if (nmb == 3) {
		vector <pair <int, int>> ost(n - 1);
		vector <pair <int, int>> c1(n - 1);
		for (int i = 0; i < n - 1; i++) {
			ost[i] = { ed[i].w - c[ed[i].y][0], i };
			c1[i] = { c[0][i], i };
		}
		sort(ost.begin(), ost.end());
		sort(c1.begin(), c1.end());
		vector <int> ord1(n - 1);
		for (int i = 0; i < n - 1; i++) {
			ord1[ost[i].second] = n - 1 - c1[i].second;
		}
		for (int i = 0; i < n - 1; i++) ord[ord1[i] - 1] = i;
		if (check()) {
			cout << "Yes\n";
			for (auto i : ord) cout << i + 1 << ' ';
		}
		else cout << "No";
	}
	if (nmb == 2) {
		int v = 0, pr = -1, cnt;
		for (int i = 0; i < n; i++) {
			if (g[v].size() == 1) { v = i, cnt = c[i][0]; break; }
		}
		gn.resize(n - 1);
		ord.clear();
		dfs(v, -1);
		for (int i = 0; i < n - 1; i++) {
			bool fl0 = 0, fl1 = 0;
			int nmbr = inded[{ord[i], ord[i + 1]}], len = ed[nmbr].w;
			if (cnt + c[i + 1][0] >= len) fl0 = 1;
			if (i != n - 2 && cnt + c[i + 1][1] >= len) fl1 = 1;
			if (!fl0 && !fl1) { cout << "No"; return 0; }
			if (fl0 && !fl1) {
				if (i != n - 2) {
					gn[inded[{ord[i + 1], ord[i + 2]}]].push_back(inded[{ord[i], ord[i + 1]}]);
					cnt = c[i + 1][1];
				}
			}
			if (!fl0 && fl1) {
				if (i != n - 2) {
					gn[inded[{ord[i], ord[i + 1]}]].push_back(inded[{ord[i + 1], ord[i + 2]}]);
					cnt = c[i + 1][0];
				}
			}
			if (fl0 && fl1) {
				if (i == n - 2) continue;
				if (c[i + 1][0] < c[i + 1][1]) {
					gn[inded[{ord[i + 1], ord[i + 2]}]].push_back(inded[{ord[i], ord[i + 1]}]);
					cnt = c[i + 1][1];
				}
				else {
					gn[inded[{ord[i], ord[i + 1]}]].push_back(inded[{ord[i + 1], ord[i + 2]}]);
					cnt = c[i + 1][0];
				}
			}
		}
		for (int i = 0; i < n - 1; i++) {
			if (!used[i]) gettp(i);
		}
		reverse(ans.begin(), ans.end());
		cout << "Yes\n";
		for (auto i : ans) cout << i + 1 << ' ';
	}
	return 0;
}