#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll MAXN = 3e5;
unordered_map<ll, ll> ord_c;

struct Edge {
    ll to, w;

    Edge(ll to, ll w) : to(to), w(w) {};
};

struct Edge_c {
    ll ca, cb, to, w;

    Edge_c(ll ca, ll cb, ll to, ll w) : ca(ca), cb(cb), to(to), w(w) {};
};

void dfs_connect(vector<ll> &leaves, vector<set<ll>> &left_edges, unordered_map<ll, ll> &edges_w, vector<vector<Edge_c>> &edges1, vector<multiset<ll>> &c_sorted) {
    ll v = leaves[leaves.size() - 1], to = *left_edges[v].begin(), w = edges_w[MAXN * v + to], ca = *c_sorted[v].begin();
    auto cb = c_sorted[to].lower_bound(w - ca);
    if (cb == c_sorted[to].end()) {
        cout << "No\n";
        exit(0);
    }
    leaves.pop_back();
    left_edges[to].erase(v);
    if (left_edges[to].size() == 1) {
        leaves.push_back(to);
    } else if (left_edges[to].empty()) {
        leaves.pop_back();
    }
    edges1[v].emplace_back(ca, *cb, to, w);
    edges1[to].emplace_back(*cb, ca, v, w);
    c_sorted[to].erase(cb);
}

bool comp_edges1(Edge_c a, Edge_c b) {
    return ord_c[a.ca] < ord_c[b.ca];
}

void dfs_order(ll v, vector<vector<Edge_c>> &edges1, ll prev, vector<ll> &ord, unordered_map<ll, ll> &edges_ord) {
    for (Edge_c to : edges1[v]) {
        if (to.to != prev) {
            dfs_order(to.to, edges1, v, ord, edges_ord);
            continue;
        }
        ord.push_back(edges_ord[MAXN * v + prev]);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, q;
    cin >> n >> q;
    vector<vector<Edge>> edges(n, vector<Edge> ());
    vector<set<ll>> left_edges(n, set<ll> ());
    unordered_map<ll, ll> edges_w, edges_ord;
    for (ll i = 0; i < n - 1; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        edges[a].emplace_back(b, w);
        edges[b].emplace_back(a, w);
        left_edges[a].insert(b);
        left_edges[b].insert(a);
        edges_w[MAXN * a + b] = w;
        edges_w[MAXN * b + a] = w;
        edges_ord[MAXN * a + b] = i + 1;
        edges_ord[MAXN * b + a] = i + 1;
    }

    vector<ll> leaves;
    vector<vector<ll>> c(n, vector<ll> ());
    vector<multiset<ll>> c_sorted(n, multiset<ll> ());
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < edges[i].size(); ++j) {
            ll cij;
            cin >> cij;
            c[i].push_back(cij);
            c_sorted[i].insert(cij);
        }
        if (edges[i].size() == 1) {
            leaves.push_back(i);
        }
    }
    ll dfs_order_prev = leaves[0];

    vector<vector<Edge_c>> edges1(n, vector<Edge_c> ());
    while (!leaves.empty()) {
        dfs_connect(leaves, left_edges, edges_w, edges1, c_sorted);
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < c[i].size(); ++j) {
            ord_c[c[i][j]] = j;
        }
        sort(edges1[i].begin(), edges1[i].end(), comp_edges1);
    }

    ll dfs_order_start = edges[dfs_order_prev][0].to;
    vector<ll> ord;
    dfs_order(dfs_order_start, edges1, dfs_order_prev, ord, edges_ord);
    reverse(ord.begin(), ord.end());
    cout << "Yes\n";
    for (auto f : ord) {
        cout << f << ' ';
    }
    cout << '\n';
}
