#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(2);

vector<vector<pair<ll, ll>>> graph;
vector<vector<pair<ll, ll>>> g2;
vector<vector<pair<ll, ll>>> c;
vector<vector<ll>> path;
vector<ll> index;
bool can = true;

ll dfs(ll i, ll par, ll w) {
    vector<pair<ll, ll>> vec;
    for (auto p : graph[i]) {
        if (p.first == par) continue;
        ll a = dfs(p.first, i, p.second);
        vec.push_back({ a, p.first });
    }
    sort(vec.begin(), vec.end());
    ll i1 = 0, i2 = 0;
    ll num = 0;
    path[i].resize(c[i].size());
    while (i1 < vec.size() && i2 < c[i].size()) {
        if (c[i][i2].first >= vec[i1].first) {
            path[i][c[i][i2].second] = vec[i1].second;
            i1++;
            i2++;
        } else {
            path[i][c[i][i2].second] = -1;
            num = c[i][i2].first;
            i2++;
        }
    }
    if (i2 < c[i].size()) {
        path[i][c[i][i2].second] = -1;
        num = c[i][i2].first;
        i2++;
    }
    if (i2 < c[i].size() || i1 < vec.size()) can = false;
    return max(0ll, w - num);
}

void dfs2(ll i, ll par) {
    for (auto p : g2[i]) {
        if (p.first == par) continue;
        index[p.first] = p.second;
        dfs2(p.first, i);
    }
}

vector<ll> ans;

void go(ll i) {
    for (auto p : path[i]) {
        if (p == -1) {
            ans.push_back(index[i]);
        } else {
            go(p);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    ll n, g; cin >> n >> g;
    graph.resize(n);
    g2.resize(n);
    index.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, w; cin >> a >> b >> w; a--; b--;
        graph[a].push_back({ b, w });
        graph[b].push_back({ a, w });
        g2[a].push_back({ b, i });
        g2[b].push_back({ a, i });
    }
    c.resize(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < graph[i].size(); j++) {
            ll h; cin >> h;
            c[i].push_back({ h, j });
        }
        sort(c[i].begin(), c[i].end());
    }
    path.resize(n);
    dfs2(0, 0);
    dfs(0, 0, 0);
    if (!can) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    go(0);
    reverse(ans.begin(), ans.end());
    for (auto p : ans) cout << p + 1 << " ";
    cout << endl;
}