#ifndef LOCALEGOR
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,sse2,bmi2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

vector<set<vector<int>>> g;
vector<set<pair<int, int>>> sc;
vector<vector<int>> perc;
vector<int> deg;
vector<pair<int, int>> edge;
void solve() {
    int n, G;
    cin >> n >> G;
    g.resize(n);
    deg.resize(n);
    edge.resize(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        edge[i] = {a, b};
        g[a].insert({b, w, i});
        g[b].insert({a, w, i});
        deg[a]++;
        deg[b]++;
    }
    sc.resize(n);
    perc.resize(n);
    for (int i = 0; i < n; ++i) {
        int c;
        perc[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c;
            sc[i].emplace(c, j);
        }
    }
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (sz(g[i]) == 1) {
            q.push(i);
        }
    }
    vector<int> cnt(n - 1);

    while (sz(q)) {
        int v = q.front();
        q.pop();
        if (sz(g[v]) == 0) continue;
        vector<int> dat = *g[v].begin();
        auto [a, id] = *sc[v].begin();
        auto it = sc[dat[0]].lower_bound({dat[1] - a, 0});
        if (it == sc[dat[0]].end()) {
            cout << "NO\n";
            return;
        }
        auto [a2, id2] = *it;
        cnt[dat[2]] = min(1, deg[v] - id - 1) + min(1, deg[dat[0]] - id2 - 1);
        perc[v][id] = dat[2];
        perc[dat[0]][id2] = dat[2];

        sc[dat[0]].erase(it);
        sc[v].erase(sc[v].begin());
        g[v].erase(g[v].begin());
        g[dat[0]].erase({v, dat[1], dat[2]});

        if (sz(g[dat[0]]) == 1) {
            q.push(dat[0]);
        }
    }
    cout << "YES\n";
    queue<int> t;
    for (int i = 0; i < n - 1; ++i) {
        if (cnt[i] == 0) {
            t.push(i);
        }
    }
    vector<int> kr(n);
    for (int i = 0; i < n; ++i) {
        kr[i] = deg[i] - 1;
    }
    vector<int> ans;
    while (sz(t)) {
        auto [a, b] = edge[t.front()];
        ans.push_back(t.front());
        t.pop();
        --kr[a];
        --kr[b];
        if (kr[a] >= 0) {
            --cnt[perc[a][kr[a]]];
            if (cnt[perc[a][kr[a]]] == 0) {
                t.push(perc[a][kr[a]]);
            }
        }
        if (kr[b] >= 0) {
            --cnt[perc[b][kr[b]]];
            if (cnt[perc[b][kr[b]]] == 0) {
                t.push(perc[b][kr[b]]);
            }
        }
    }
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}