#include <bits/stdc++.h>
#include <bits/extc++.h>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v).size()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld  = long double;
mt19937 Rand(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
const int inf = 1e9;
const ll INF = 1e18;

struct edge {
    int a, b, c;
};

const int N = 3e5 + 1;
int n, G, num = 1;
vector <int> g[N];
vector <int> c[N], c2[N];
set <pair <int, int>> s[N];
edge e[N];
int edge_num[N];

int dfs(int v, int p) {
    for (auto el: g[v]) {
        int i = e[el].a + e[el].b - v, w = e[el].c;
        if (i == p) {
            continue;
        }
        int x = dfs(i, v);
        if (!x) {
            return 0;
        }
        auto it = s[v].lower_bound({ w - s[i].begin() -> first, -1 });
        if (it == s[v].end()) {
            return 0;
        }
        edge_num[s[i].begin() -> second] = edge_num[it -> second] = el;
        s[v].erase(it);
    }
    return 1;
}

vector <int> g2[N];
int used[N];
vector <int> ts;

void topsort(int v) {
    used[v] = 1;
    for (int i : g2[v]) {
        if (!used[i]) {
            topsort(i);
        }
    }
    ts.push_back(v);
}

int findCycle(int v) {
    used[v] = 1;
    for (int i : g2[v]) {
        if (used[i] == 1) {
            return 1;
        }
        if (used[i] == 0) {
            int x = findCycle(i);
            if (x) {
                return 1;
            }
        }
    }
    used[v] = 2;
    return 0;
}

void solve() {
    cin >> n >> G;
    for (int i = 1; i < n; ++i) {
        cin >> e[i].a >> e[i].b >> e[i].c;
        g[e[i].a].push_back(i);
        g[e[i].b].push_back(i);
    }
    for (int i = 1; i <= n; ++i) {
        c[i].resize(sz(g[i]));
        c2[i].resize(sz(g[i]));
        for (int &el : c[i]) {
            cin >> el;
        }
        for (int j = 0; j < sz(g[i]); ++j) {
            s[i].insert({ c[i][j], num });
            c2[i][j] = num++;
        }
    }
    int x = dfs(Rand() % n + 1, -1);
    if (!x) {
        cout << "No";
        return;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < sz(g[i]) - 1; ++j) {
            g2[edge_num[c2[i][j]]].push_back(edge_num[c2[i][j + 1]]);
        }
    }
    int ok = 1;
    for (int i = 1; i < n; ++i) {
        if (used[i] == 0) {
            ok &= !findCycle(i);
        }
    }
    if (!ok) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    fill(used, used + n, 0);
    for (int i = 1; i < n; ++i) {
        if (!used[i]) {
            topsort(i);
        }
    }
    for (int i : ts) {
        cout << i << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
