#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <stack>

typedef long long ll;
using namespace std;

struct Line {
	ll a, b, w;
};

stack<ll> explode(string& s) {
	ll now = 0;
	ll num = 0;
	stack<ll> out;
	for (ll i = s.length() - 1; i > -1; i--) {
		if (s[i] == 32) {
			out.push(num);
			num = 0;
			now = 0;
		}
		else {
			num += (s[i] - 48) * pow(10, now);
			now++;
		}
	}
	out.push(num);
	return out;
}


bool Buravchik(vector<Line>& vec, vector<stack<ll>>& sticks, map<ll, bool>& used, ll count_use, ll n) {
	if (count_use == n) {
		cout << "Yes" << endl;
		return true;
	}

	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			if (vec[i].w <= sticks[vec[i].a - 1].top() + sticks[vec[i].b - 1].top()) {
				used[i] = true;
				ll a_s = sticks[vec[i].a - 1].top();
				ll b_s = sticks[vec[i].b - 1].top();
				sticks[vec[i].a - 1].pop();
				sticks[vec[i].b - 1].pop();
				if (Buravchik(vec, sticks, used, count_use + 1, n)) {
					cout << i + 1 << " ";
					return true;
				}
				sticks[vec[i].a - 1].push(a_s);
				sticks[vec[i].b - 1].push(b_s);
				used[i] = false;
			}
		}
	}
	return false;
}



int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr);

	ll n, g;
	cin >> n >> g;

	vector<Line> vec(n - 1);
	for (ll i = 0; i < n - 1; i++) {
		cin >> vec[i].a >> vec[i].b >> vec[i].w;
	}
	vector<stack<ll>> sticks(n);
	string s;
	getline(cin, s);
	for (ll i = 0; i < n; i++) {
		getline(cin, s);
		sticks[i] = explode(s);
	}

	map<ll, bool> used;
	if (!Buravchik(vec, sticks, used, 0, n - 1)) {
		cout << "No" << endl;
	}
	else {
		cout << endl;
	}
}
