#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <stack>

typedef int ll;
using namespace std;

struct Line {
	ll a, b, w;
};

class Sticker {
 public:
	vector<ll> vec;
	ll r;

	Sticker(vector<ll>& v) {
		vec = v;
		r = v.size() - 1;
	}
	
	ll top() {
		return vec[r];
	}

	void pop() {
		r--;
	}

	void push() {
		r++;
	}
};

Sticker explode(string& s) {
	ll now = 0;
	ll num = 0;
	vector<ll> out;
	for (ll i = s.length() - 1; i > -1; i--) {
		if (s[i] == 32) {
			out.push_back(num);
			num = 0;
			now = 0;
		}
		else {
			num += (s[i] - 48) * pow(10, now);
			now++;
		}
	}
	out.push_back(num);
	return Sticker(out);
}


bool Buravchik(vector<Line>& vec, vector<Sticker>& Stickers, map<ll, bool>& used, ll count_use, ll n) {
	if (count_use == n) {
		cout << "Yes" << endl;
		return true;
	}

	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			if (vec[i].w <= Stickers[vec[i].a - 1].top() + Stickers[vec[i].b - 1].top()) {
				used[i] = true;
				Stickers[vec[i].a - 1].pop();
				Stickers[vec[i].b - 1].pop();
				if (Buravchik(vec, Stickers, used, count_use + 1, n)) {
					cout << i + 1 << " ";
					return true;
				}
				Stickers[vec[i].a - 1].push();
				Stickers[vec[i].b - 1].push();
				used[i] = false;
			}
		}
	}
	return false;
}



int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr);

	ll n, g;
	cin >> n >> g;

	vector<Line> vec(n - 1);
	for (ll i = 0; i < n - 1; i++) {
		cin >> vec[i].a >> vec[i].b >> vec[i].w;
	}
	vector<ll> fill;
	vector<Sticker> Stickers(n, Sticker(fill));
	string s;
	getline(cin, s);
	for (ll i = 0; i < n; i++) {
		getline(cin, s);
		Stickers[i] = explode(s);
	}

	map<ll, bool> used;
	if (!Buravchik(vec, Stickers, used, 0, n - 1)) {
		cout << "No" << endl;
	}
	else {
		cout << endl;
	}
}
