#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct edge {
    int a, b, w;
};

void solve() {
    int n, g;
    cin >> n >> g;
    vector<edge> edges(n - 1);
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].a >> edges[i].b >> edges[i].w;
        edges[i].a--;
        edges[i].b--;
        deg[edges[i].a]++;
        deg[edges[i].b]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
        reverse(c[i].begin(), c[i].end());
    }

    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    while (true) {
        vector<int> cur(n, 0);
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {
            auto [a, b, w] = edges[p[i]];
            if (c[a][cur[a]] + c[b][cur[b]] < w) {
                flag = false;
                break;
            }
            cur[a]++;
            cur[b]++;
        }
        if (flag) {
            cout << "Yes\n";
            for (auto el : p) {
                cout << el + 1 << " ";
            }
            cout << "\n";
            return;
        }
        if (!next_permutation(p.begin(), p.end())) {
            break;
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
