#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct edge {
    int a, b, w;
};

void solve1(int n) {
    vector<edge> edges(n - 1);
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].a >> edges[i].b >> edges[i].w;
        edges[i].a--;
        edges[i].b--;
        deg[edges[i].a]++;
        deg[edges[i].b]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
        reverse(c[i].begin(), c[i].end());
    }

    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    while (true) {
        vector<int> cur(n, 0);
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {
            auto [a, b, w] = edges[p[i]];
            if (c[a][cur[a]] + c[b][cur[b]] < w) {
                flag = false;
                break;
            }
            cur[a]++;
            cur[b]++;
        }
        if (flag) {
            cout << "Yes\n";
            for (auto el : p) {
                cout << el + 1 << " ";
            }
            cout << "\n";
            return;
        }
        if (!next_permutation(p.begin(), p.end())) {
            break;
        }
    }
    cout << "No\n";
}

void solve2(int n) {
    vector<edge> edges(n - 1);
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].a >> edges[i].b >> edges[i].w;
        edges[i].a--;
        edges[i].b--;
        deg[edges[i].a]++;
        deg[edges[i].b]++;
    }
    vector<vector<pair<int, int>>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j].first;
            c[i][j].second = j;
        }
        reverse(c[i].begin(), c[i].end());
    }

    vector<pair<int, int>> b(n - 1);
    for (int i = 0; i < n; ++i) {
        b[i] = {edges[i].w - c[i + 1][0].first, i + 1};
    }
    sort(c[0].begin(), c[0].end());
    sort(b.begin(), b.end());
    for (int i = 0; i < n; ++i) {
        if (c[0][i].first < b[i].first) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    vector<int> ans(n - 1);
    for (int i = 0; i < n; ++i) {
        ans[c[0][i].second] = b[i].second;
    }
    for (auto el : ans) {
        cout << el << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        int n, g;
        cin >> n >> g;
        if (g == 1) {
            solve1(n);
        } else {
            solve2(n);
        }
    }
    return 0;
}
