#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
>;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

vector<vector<int>> g;
vector<array<int, 3>> e;
vector<set<pair<int, int>>> c;
vector<vector<int>> id;

vector<int> pe;
void calc(int v, int p) {
    for (auto ind : g[v]) {
        int u = v ^ e[ind][0] ^ e[ind][1];
        if (u == p) continue;

        pe[u] = ind;
        calc(u, v);
    }
}

vector<int> ans;

void dfs(int v, int pe) {
    for (int i = g[v].size() - 1; i >= 0; i--) {
        int cur = id[v][i];
        if (cur == -1) {
            ans.push_back(pe);
        } else {
            int u = v ^ e[cur][0] ^ e[cur][1];
            dfs(u, cur);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, group;
    cin >> n >> group;

    g.resize(n);
    e.resize(n - 1);

    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        e[i] = {u, v, w};
        g[u].push_back(i);
        g[v].push_back(i);
    }

    pe.assign(n, -1);
    calc(0, -1);

    c.resize(n);
    id.resize(n);
    for (int i = 0; i < n; i++) {
        int d = g[i].size();
        id[i].assign(d, -1);
        for (int j = 0; j < d; j++) {
            int x;
            cin >> x;
            c[i].emplace(x, j);
        }
    }

    deque<int> q;
    for (int i = 1; i < n; i++) {
        if (c[i].size() == 1) {
            q.push_back(i);
        }
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();

        int p = v ^ e[pe[v]][0] ^ e[pe[v]][1];

        auto [ca, ind] = *c[v].begin();
        int w = e[pe[v]][2];
        auto it = c[p].lower_bound({w - ca, -1});

        if (it == c[p].end()) {
            cout << "No\n";
            return 0;
        }
        id[p][it->second] = pe[v];

        c[v].clear();
        c[p].erase(it);

        if (c[p].size() == 1 && p != 0) {
            q.push_back(p);
        }
    }

    dfs(0, -1);
    cout << "Yes\n";
    for (int i = 0; i < n - 1; i++) cout << ans[i] + 1 << " \n"[i + 1 == n - 1];

    return 0;
}
