#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
using namespace std;

typedef long long ll;

int n, g;
vector<vector<pair<int, int>>> G;
vector<vector<pair<int, int>>> C;
vector<vector<int>> G2;
vector<int> val, weights, order;
vector<bool> used;

bool dfs(int v, int p = -1, int pwi = -1)
{
    vector<pair<int, int>> cur_vals;
    for (auto& elem : G[v])
    {
        if (elem.first == p)
            continue;
        if (!dfs(elem.first, v, elem.second))
            return false;
        cur_vals.push_back({weights[elem.second] - val[elem.first], elem.second});
    }
    if (cur_vals.size() == 0)
    {
        val[v] = C[v][0].first;
        return true;
    }
    sort(cur_vals.begin(), cur_vals.end());
    vector<int> edges_order(G[v].size());
    if (p != -1)
    {
        bool flag = false;
        int cur_i = 0;
        for (int i = 0; i < C[v].size() && cur_i < cur_vals.size(); i++)
        {
            if (C[v][i].first < cur_vals[cur_i].first)
            {
                if (flag)
                    return false;
                flag = true;
                edges_order[C[v][i].second] = pwi;
                val[v] = C[v][i].first;
                continue;
            }
            edges_order[C[v][i].second] = cur_vals[cur_i].second;
            cur_i++;
        }
        if (flag == false)
        {
            edges_order[C[v].back().second] = pwi;
            val[v] = C[v].back().first;
        }
    }else
    {
        for (int i = 0; i < C[v].size(); i++)
        {
            if (C[v][i].first < cur_vals[i].first)
                return false;
            edges_order[C[v][i].second] = cur_vals[i].second;
        }
    }
    for (int i = 1; i < G[v].size(); i++)
        G2[edges_order[i]].push_back(edges_order[i - 1]);
    return true;
}

void dfs2(int v)
{
    used[v] = true;
    for (int u : G2[v])
    {
        if (used[u]) continue;
        dfs2(u);
    }
    order.push_back(v);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    cin >> n >> g;
    int u, v, w;
    G = vector<vector<pair<int, int>>>(n);
    weights = vector<int>(n);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> u >> v >> w; u--; v--;
        G[u].emplace_back(v, i);
        G[v].emplace_back(u, i);
        weights[i] = w;
    }
    C = vector<vector<pair<int, int>>>(n);
    for (int i = 0; i < n; i++)
    {
        C[i] = vector<pair<int, int>>(G[i].size());
        for (int j = 0; j < G[i].size(); j++)
        {
            cin >> v;
            C[i][j] = {v, j};
        }
        sort(C[i].begin(), C[i].end());
    }
    val = vector<int>(n, 0);
    G2 = vector<vector<int>>(n - 1);
    if (dfs(0))
    { 
        cout << "Yes\n";
        used = vector<bool>(n, false);
        for (int i = 0; i < n - 1; i++)
            if (!used[i])
                dfs2(i);
        reverse(order.begin(), order.end());
        for (int i = 0; i < order.size(); i++)
            cout << order[i] + 1 << ' ';
        cout << '\n';
    }else{
        cout << "No\n";
    }
    return 0;
}