//
// Created by olymp on 3/8/24.
//
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using oset = tree<
        ll,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

struct Edge {
    ll a, b, w;
};

vector<Edge> ed;
vector<ll> deg;
vector<vector<ll>> st;

void check(vector<ll> &res, ll n) {
    vector<ll> uk(n + 1);
    bool ok = true;
    for (auto &i : res) {
        auto &[a, b, w] = ed[i];
        if (w > st[a][uk[a]] + st[b][uk[b]])
            ok = false;
        uk[a]++, uk[b]++;
    }
    if (!ok)
        return;
    cout << "Yes\n";
    for (auto &i : res) {
        cout << i + 1 << " ";
    }
    exit(0);
    // 3214
}

void gen(vector<ll> &res, ll n, vector<bool> &used) {
    if (res.size() == n) {
        check(res, n + 1);
        return;
    }
    for (ll i = 0; i < res.size(); i++) {
        if (!used[i]) {
            used[i] = true;
            res[n] = i;
            gen(res, n + 1, used);
            used[i] = false;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr),
            cout.tie(nullptr);
    ll n, test;
    cin >> n >> test;
    deg.resize(n + 1);
    ed.resize(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        auto &[a, b, w] = ed[i];
        cin >> a >> b >> w;
        deg[a]++, deg[b]++;
    }
    st.resize(n + 1);
    for (ll i = 1; i <= n; i++) {
        st[i].resize(deg[i]);
        for (auto &j : st[i])
            cin >> j;
        reverse(st[i].begin(), st[i].end());
    }
    {
        vector<ll> res(n - 1);
        vector<bool> used(n - 1);
        gen(res, 0, used);
        cout << "No";
    }
    vector<bool> used(n - 1);
    vector<ll> res(n - 1);
    vector<ll> uk(n);
    for (ll _ = 0; _ < n - 1; _++) {
        ll maxv = 0, r = 0;
        for (ll i = 0; i < n - 1; i++) {
            if (used[i])
                continue;
            auto &[a, b, w] = ed[i];
            if (st[a][uk[a]] + st[b][uk[b]] >= w && w > maxv) {
                maxv = w;
                r = i;
            }
        }
        if (maxv == 0) {
            cout << "No";
            return 0;
        }
        res[_] = r;
        uk[ed[r].a]++;
        uk[ed[r].b]++;
        used[r] = true;
    }
    cout << "Yes\n";
    for (auto &i : res)
        cout << i + 1  << " ";
}
