#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define p_b push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> using oset =
tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using pq =
priority_queue<T>;
template<class T> using pqg =
priority_queue<T, vector<T>, greater<T>>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 2e5 + 5;

vector<ll> c[N];
int deg[N];
unordered_set<int> lft[N];

void solve() {
    int n, group;
    cin >> n >> group;
    vector<array<ll, 3>> edges(n - 1);
    int timer = 0;
    for (auto &[u, v, w] : edges) {
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++;
        deg[v]++;
        lft[u].insert(timer);
        lft[v].insert(timer);
        timer++;
    }
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (auto &j : c[i])
            cin >> j;
        deg[i] = 0;
    }
    set<array<ll, 2>> my;
    timer = 0;
    for (auto [u, v, w] : edges) {
        ll cur = c[u][0] + c[v][0] - w;
        if (cur < 0)
            cur = 1e18;
        my.insert({cur, timer++});
    }
    vector<int> ans;
    while (!my.empty()) {
        auto [here, ind] = *my.begin();
        my.erase(my.begin());
        ans.p_b(ind + 1);
        auto [u, v, w] = edges[ind];
        if (here == 1e18) {
            cout << "No";
            return;
        }
        for (auto i : lft[u]) {
            auto [u1, v1, w1] = edges[i];
            ll cur = c[u1][deg[u1]] + c[v1][deg[v1]] - w1;
            if (cur < 0)
                cur = 1e18;
            my.erase({cur, i});
        }
        for (auto i : lft[v]) {
            auto [u1, v1, w1] = edges[i];
            ll cur = c[u1][deg[u1]] + c[v1][deg[v1]] - w1;
            if (cur < 0)
                cur = 1e18;
            my.erase({cur, i});
        }
        deg[u]++;
        deg[v]++;
        lft[u].erase(ind);
        lft[v].erase(ind);
        for (auto i : lft[u]) {
            auto [u1, v1, w1] = edges[i];
            ll cur = c[u1][deg[u1]] + c[v1][deg[v1]] - w1;
            if (cur < 0)
                cur = 1e18;
            my.insert({cur, i});
        }
        for (auto i : lft[v]) {
            auto [u1, v1, w1] = edges[i];
            ll cur = c[u1][deg[u1]] + c[v1][deg[v1]] - w1;
            if (cur < 0)
                cur = 1e18;
            my.insert({cur, i});
        }
    }
    reverse(all(ans));
    cout << "Yes\n";
    for (auto i : ans)
        cout << i << ' ';
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n===\n\n\nTime : " << clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
