#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int u, v, w;
};

void solve1(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }

    vector <int> ord(n);
    iota(all(ord), 0);
    do {
        vector <int> cur(n, 0);
        bool ok = true;
        for (int i : ord) {
            int u = edges[i].u, v = edges[i].v, w = edges[i].w;
            if (c[u][cur[u]] + c[v][cur[v]] < w) {
                ok = false;
                break;
            }
            cur[u]++;
            cur[v]++;
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : ord) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            break;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

void solve() {
    int n, g;
    cin >> n >> g;

    if (g <= 1) {
        solve1(n);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}