#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int u, v, w, id;
};

void solve1(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }

    vector <int> ord(n - 1);
    iota(all(ord), 0);
    do {
        vector <int> cur(n, 0);
        bool ok = true;
        for (int i : ord) {
            int u = edges[i].u, v = edges[i].v, w = edges[i].w;
            if (c[u][cur[u]] + c[v][cur[v]] < w) {
                ok = false;
                break;
            }
            cur[u]++;
            cur[v]++;
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : ord) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            return;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

bool dfs(int v, vector <vector <int>>& gr, vector <int>& pr, vector <bool>& used) {
    used[v] = true;
    for (int u : gr[v]) {
        if (pr[u] == -1) {
            pr[u] = v;
            return true;
        }
    }
    for (int u : gr[v]) {
        if (!used[pr[u]] && dfs(pr[u], gr, pr, used)) {
            pr[u] = v;
            return true;
        }
    }
    return false;
}

vector <int> findMaximalMatching(vector <vector <int>>& gr) {
    int n = (int)gr.size();
    vector <int> pr(n, -1);
    vector <bool> used(n, false);
    for (int v = 0; v < n; v++) {
        if (dfs(v, gr, pr, used)) {
            used.assign(n, false);
        }
    }
    return pr;
}

void solve2(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        edges[i].id = i;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    vector <vector <int>> id(n);
    vector <pair <int, int>> rev(2 * n - 2);
    int timer = 0;
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        id[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
            rev[timer] = {i, j};
            id[i][j] = timer++;
        }
        reverse(all(c[i]));
    }

    vector <vector <int>> gr(2 * n - 2);

    for (Edge& e : edges) {
        int u = e.u, v = e.v, w = e.w;
        for (int i = 0; i < deg[u]; i++) {
            for (int j = 0; j < deg[v]; j++) {
                if (c[u][i] + c[v][j] >= w) {
                    gr[id[u][i]].push_back(id[v][j]);
                    gr[id[v][j]].push_back(id[u][i]);
                }
            }
        }
    }

    vector <int> pr = findMaximalMatching(gr);
    for (int i = 0; i < 2 * n - 2; i++) {
        if (pr[i] == -1) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";

    vector <vector <Edge>> g(n);
    for (Edge& e : edges) {
        g[e.u].push_back(e);
        g[e.v].push_back(e);
    }

    vector <bool> used(n - 1, false);
    vector <int> cur(n, 0);
    queue <int> q;
    for (Edge& e : edges) {
        int u = e.u, v = e.v;
        if (pr[id[u][0]] == id[v][0]) {
            used[e.id] = true;
            q.push(e.id);
        }
    }
    while (!q.empty()) {
        int i = q.front();
        q.pop();
        cout << i + 1 << " ";

        int u = edges[i].u, v = edges[i].v;
        cur[u]++;
        cur[v]++;
        if (cur[u] < deg[u]) {
            for (Edge &e: g[u]) {
                if (used[e.id]) continue;
                if (pr[id[e.u][cur[e.u]]] == id[e.v][cur[e.v]]) {
                    used[e.id] = true;
                    q.push(e.id);
                }
            }
        }
        if (cur[v] < deg[v]) {
            for (Edge &e: g[v]) {
                if (used[e.id]) continue;
                if (pr[id[e.u][cur[e.u]]] == id[e.v][cur[e.v]]) {
                    used[e.id] = true;
                    q.push(e.id);
                }
            }
        }
    }
    cout << "\n";
}

void solve() {
    int n, g;
    cin >> n >> g;

    if (g <= 1) {
        solve1(n);
    } else if (g == 2 || true) {
        solve2(n);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}