#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int u, v, w, id;
};

void solve1(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }

    vector <int> ord(n - 1);
    iota(all(ord), 0);
    do {
        vector <int> cur(n, 0);
        bool ok = true;
        for (int i : ord) {
            int u = edges[i].u, v = edges[i].v, w = edges[i].w;
            if (c[u][cur[u]] + c[v][cur[v]] < w) {
                ok = false;
                break;
            }
            cur[u]++;
            cur[v]++;
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : ord) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            return;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

void solve2(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        edges[i].id = i;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    vector <vector <int>> id(n);
    vector <pair <int, int>> rev(2 * n - 2);
    int timer = 0;
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        id[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
        for (int j = 0; j < deg[i]; j++) {
            id[i][j] = timer++;
        }
    }

    vector <int> gr(n);
    for (Edge& e : edges) {
        gr[max(e.u, e.v)] = e.w;
    }

    vector <vector <bool>> can(2, vector <bool> (n, false));
    if (n == 2) {
        if (c[0][0] + c[1][0] >= gr[1]) {
            cout << "Yes\n1\n";
        } else {
            cout << "No\n";
        }
        return;
    }
    if (c[0][0] + c[1][0] >= gr[1]) {
        can[0][1] = true;
    }
    if (c[0][0] + c[1][1] >= gr[1]) {
        can[1][1] = true;
    }
    for (int i = 2; i < n - 1; i++) {
        if (c[i - 1][0] + c[i][0] >= gr[i] && can[i - 1][1]) {
            can[i][0] = true;
        }
        if (c[i - 1][0] + c[i][1] >= gr[i] && can[i - 1][1]) {
            can[i][1] = true;
        }
        if (c[i - 1][1] + c[i][0] >= gr[i] && can[i - 1][0]) {
            can[i][0] = true;
        }
        if (c[i - 1][1] + c[i][1] >= gr[i] && can[i - 1][0]) {
            can[i][1] = true;
        }
    }
    
    int cur = 0;
    vector <int> w1, w2, w3;
    for (int i = n - 1; i > 0; i--) {
        if (i - 1 == 0) {
            if (cur == 0) {
                cout << i + 1 << " ";
            } else {
                w1.push_back(i + 1);
            }
        } else {
            if (cur == 0) {
                if (c[i - 1][0] + c[i][cur] >= gr[i] && can[i - 1][1]) {
                    cout << i + 1 << " ";
                    cur = 1;
                } else if (c[i - 1][1] + c[i][cur] >= gr[i] && can[i - 1][0]) {
                    w2.push_back(i + 1);
                    cur = 0;
                }
            } else {
                if (c[i - 1][0] + c[i][cur] >= gr[i] && can[i - 1][1]) {
                    w1.push_back(i + 1);
                    cur = 1;
                } else if (c[i - 1][1] + c[i][cur] >= gr[i] && can[i - 1][0]) {
                    w3.push_back(i + 1);
                    cur = 0;
                }
            }
        }
    }
    for (int i : w2) {
        cout << i << " ";
    }
    reverse(all(w1));
    for (int i : w1) {
        cout << i << " ";
    }
    for (int i : w3) {
        cout << i << " ";
    }
    cout << "\n";
}

void solve() {
    int n, g;
    cin >> n >> g;

    if (g <= 1) {
        solve1(n);
    } else if (g == 2) {
        solve2(n);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}