#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int u, v, w, id;
};

void solve1(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }

    vector <int> ord(n - 1);
    iota(all(ord), 0);
    do {
        vector <int> cur(n, 0);
        bool ok = true;
        for (int i : ord) {
            int u = edges[i].u, v = edges[i].v, w = edges[i].w;
            if (c[u][cur[u]] + c[v][cur[v]] < w) {
                ok = false;
                break;
            }
            cur[u]++;
            cur[v]++;
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : ord) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            return;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

void solve2(int n) {
    vector <Edge> edges(n - 1);
    vector <int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        edges[i].id = i;
        deg[edges[i].v]++;
        deg[edges[i].u]++;
    }

    vector <vector <int>> c(n);
    vector <vector <int>> id(n);
    vector <pair <int, int>> rev(2 * n - 2);
    int timer = 0;
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        id[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
        for (int j = 0; j < deg[i]; j++) {
            id[i][j] = timer++;
        }
    }

    vector <int> gr(n);
    for (Edge& e : edges) {
        gr[max(e.u, e.v)] = e.w;
    }

    vector <vector <bool>> can(n, vector <bool> (2, false));
    if (n == 2) {
        if (c[0][0] + c[1][0] >= gr[1]) {
            cout << "Yes\n1\n";
        } else {
            cout << "No\n";
        }
        return;
    }
    if (c[0][0] + c[1][0] >= gr[1]) {
        can[1][0] = true;
    }
    if (c[0][0] + c[1][1] >= gr[1]) {
        can[1][1] = true;
    }
    for (int i = 2; i < n - 1; i++) {
        if (c[i - 1][0] + c[i][0] >= gr[i] && can[i - 1][1]) {
            can[i][0] = true;
        }
        if (c[i - 1][0] + c[i][1] >= gr[i] && can[i - 1][1]) {
            can[i][1] = true;
        }
        if (c[i - 1][1] + c[i][0] >= gr[i] && can[i - 1][0]) {
            can[i][0] = true;
        }
        if (c[i - 1][1] + c[i][1] >= gr[i] && can[i - 1][0]) {
            can[i][1] = true;
        }
    }

    int cur = 0;
    vector <int> w0, w1, w2, w3;
    for (int i = n - 1; i > 0; i--) {
        if (i - 1 == 0) {
            if (cur == 0) {
                w0.push_back(i);
            } else {
                w1.push_back(i);
            }
        } else {
            if (cur == 0) {
                if (c[i - 1][0] + c[i][cur] >= gr[i] && can[i - 1][1]) {
                    w0.push_back(i);
                    cur = 1;
                } else if (c[i - 1][1] + c[i][cur] >= gr[i] && can[i - 1][0]) {
                    w2.push_back(i);
                    cur = 0;
                } else {
                    cout << "No\n";
                    return;
                }
            } else {
                if (c[i - 1][0] + c[i][cur] >= gr[i] && can[i - 1][1]) {
                    w1.push_back(i);
                    cur = 1;
                } else if (c[i - 1][1] + c[i][cur] >= gr[i] && can[i - 1][0]) {
                    w3.push_back(i);
                    cur = 0;
                } else {
                    cout << "No\n";
                    return;
                }
            }
        }
    }
    cout << "Yes\n";
    for (int i : w0) {
        cout << i << " ";
    }
    reverse(all(w2));
    for (int i : w2) {
        cout << i << " ";
    }
    for (int i : w1) {
        cout << i << " ";
    }
    for (int i : w3) {
        cout << i << " ";
    }
    cout << "\n";
}

void solve3(int n) {
    vector <int> a(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;

        a[v] = w;
    }
    vector <int> c1(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> c1[i];
    }
    reverse(all(c1));
    set <pair <int, int>> st;
    for (int i = 0; i < n - 1; i++) {
        st.insert({c1[i], i});
    }
    vector <int> ord(n - 1);
    for (int v = 1; v < n; v++) {
        int x;
        cin >> x;
        int need = a[v] - x;
        auto it = st.lower_bound({need, -1});
        if (it == st.end()) {
            cout << "No\n";
            return;
        }
        ord[it->second] = v;
        st.erase(it);
    }
    cout << "Yes\n";
    for (int i = 0; i < n - 1; i++) {
        cout << ord[i] << " ";
    }
    cout << "\n";
}

void solve4(int n) {
    vector <int> a(n);
    int bruh;
    int cnt1 = 1, cnt2 = 1;
    vector <bool> first(n, false);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;

        if (i == 0) {
            bruh = w;
        } else {
            if (u == 0) {
                cnt1++;
                first[v] = true;
            } else {
                cnt2++;
            }
        }

        a[v] = w;
    }
    vector <int> c1(cnt1);
    for (int i = 0; i < cnt1; i++) {
        cin >> c1[i];
    }
    reverse(all(c1));
    set <pair <int, int>> st1;
    for (int i = 0; i < cnt1; i++) {
        st1.insert({c1[i], i});
    }
    vector <int> ord1(cnt1);
    vector <int> c2(cnt2);
    for (int i = 0; i < cnt2; i++) {
        cin >> c2[i];
    }
    reverse(all(c2));
    set <pair <int, int>> st2;
    for (int i = 0; i < cnt2; i++) {
        st2.insert({c2[i], i});
    }
    vector <int> ord2(cnt2);
    for (int v = 2; v < n; v++) {
        int x;
        cin >> x;
        int need = a[v] - x;
        if (first[v]) {
            auto it = st1.lower_bound({need, -1});
            if (it == st1.end()) {
                cout << "No\n";
                return;
            }
            ord1[it->second] = v;
            st1.erase(it);
        } else {
            auto it = st2.lower_bound({need, -1});
            if (it == st2.end()) {
                cout << "No\n";
                return;
            }
            ord2[it->second] = v;
            st2.erase(it);
        }
    }
    if (st1.begin()->first + st2.begin()->first < bruh) {
        cout << "No\n";
        return;
    }
    int l = st1.begin()->second, r = st2.begin()->second;
    cout << "Yes\n";
    int cnt_output = 0;
    for (int i = 0; i < l; i++) {
        cout << ord1[i] << " ";
        assert(ord1[i] > 0);
        cnt_output++;
    }
    for (int i = 0; i < r; i++) {
        cout << ord2[i] << " ";
        assert(ord2[i] > 0);
        cnt_output++;
    }
    cout << 1 << " ";
    cnt_output++;
    for (int i = l + 1; i < cnt1; i++) {
        cout << ord1[i] << " ";
        assert(ord1[i] > 0);
        cnt_output++;
    }
    for (int i = r + 1; i < cnt2; i++) {
        cout << ord2[i];
        assert(ord2[i] > 0);
        cnt_output++;
    }
    cout << "\n";
}

void solve() {
    int n, g;
    cin >> n >> g;

    if (g <= 1) {
        solve1(n);
    } else if (g == 2) {
        solve2(n);
    } else if (g == 3) {
        solve4(n);
    } else if (g == 4) {
        solve4(n);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}