#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll inf = ll(2e18) + 36;
const int mod = int(1e9) + 7;

struct edge {
    ll u, w, id;
    edge() = default;
    edge(ll u, ll w, ll id): u(u), w(w), id(id) {}
};

struct node {
    ll t, v, id;
    node() = default;
    node(ll t, ll v, ll id): t(t), v(v), id(id) {}
    bool operator<(const node& r) {
        return t < r.t;
    }
};

vector<vector<edge>> g;
vector<vector<pair<ll, ll>>> srt;
vector <vector <pair <ll, ll>>> t;
vector<vector<ll>> c;
vector<ll> toPar;
vector<ll> deg;

bool can = true;

void dfs(ll v, ll p = -1, ll idP = -1) {
    vector<node> f;
    for (auto &[u, w, id]: g[v]) {
        if (u == p) continue;
        dfs(u, v, id);
        if (!can) return;
        f.emplace_back(w - toPar[u], u, id);
    }
    sort(f.begin(), f.end());
    ll l = 0, r = 0;
    while (l < deg[v] && r < ll(f.size())) {
        if (f[r].t <= srt[v][l].first) {
            t[v][srt[v][l].second] = {f[r].v, f[r].id};
            l++;
            r++;
        } else {
            t[v][srt[v][l].second] = {p, idP};
            toPar[v] = srt[v][l].first;
            l++;
        }
    }
    if (r < ll(f.size())) {
        can = false;
        return;
    }
    if (toPar[v] == -inf && p >= 0) {
        assert(l == deg[v] - 1);
        t[v][srt[v].back().second] = {p, idP};
        toPar[v] = srt[v].back().first;
    }
}

vector <ll> path;

void repair(ll v, ll p = -2) {
    for (auto& [u, id] : t[v]) {
        if (p == -2 && u == -1) continue;
        if (u == p) {
            path.emplace_back(id);
            continue;
        }
        repair(u, v);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, group;
    cin >> n >> group;
    g.resize(n);
    toPar.resize(n, -inf);
    deg.resize(n);
    srt.resize(n);
    c.resize(n);
    t.resize(n);
    for (ll i = 1; i < n; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w, i);
        g[v].emplace_back(u, w, i);
        deg[u]++;
        deg[v]++;
    }
    for (ll v = 0; v < n; v++) {
        c[v].resize(deg[v]);
        t[v].resize(deg[v]);
        for (ll j = 0; j < deg[v]; j++) {
            cin >> c[v][j];
            srt[v].emplace_back(c[v][j], j);
        }
        sort(srt[v].begin(), srt[v].end());
    }
    dfs(0);
    if (!can) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    repair(0);
    reverse(path.begin(), path.end());
    for (auto& it : path) {
        cout << it << ' ';
    }
    return 0;
}
