#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

vector<vector<int>> new_g;
vector<bool> used;

void dfs(int v) {
    used[v] = 1;
    for (auto x : new_g[v]) {
        if (used[x]) continue;
        dfs(x);
    }
    cout << v + 1 << " ";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, g1;
    cin >> n >> g1;
    vector<int> rebr(n - 1);
    vector<set<pair<int, int>>> g(n);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        rebr[i] = w;
        g[a].insert({ b, i });
        g[b].insert({ a, i });
        deg[a]++;
        deg[b]++;
    }
    vector<multiset<pair<int, int>>> inf(n);
    vector<vector<int>> qu(n);
    for (int i = 0; i < n; i++) {
        qu[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            int c;
            cin >> c;
            inf[i].insert({ c, j });
        }
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.insert({ deg[i], i });
    }
    while (s.size()) {
        auto p1 = *s.begin();
        s.erase(s.begin());
        int from = p1.second;
        auto p2 = *g[from].begin();
        int to = p2.first;
        int rebr_num = p2.second;
        int w = rebr[rebr_num];
        g[from].erase(p2);
        g[to].erase({ from, rebr_num });
        auto p3 = *inf[from].begin();
        int a = p3.first;
        int to_put1 = p3.second;
        qu[from][to_put1] = rebr_num;
        inf[from].erase(p3);
        if (inf[to].lower_bound({ w - a, 0 }) == inf[to].end()) {
            cout << "No";
            return 0;
        }
        auto p4 = *inf[to].lower_bound({ w - a, 0 });
        int b = p4.first;
        int to_put2 = p4.second;
        qu[to][to_put2] = rebr_num;
        inf[to].erase(p4);
        s.erase({ deg[to], to });
        deg[to]--;
        if (deg[to] != 0) {
            s.insert({ deg[to], to });
        }
    }
    new_g.resize(n - 1);
    used.resize(n - 1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < qu[i].size() - 1; j++) {
            new_g[qu[i][j]].push_back(qu[i][j + 1]);
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < n - 1; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
}