#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, gr;
    cin >> n >> gr;

    if (gr <= 1) {
        vector<ll> deg(n);
        vector<array<ll, 4>> edges(n - 1);
        for (ll i = 0; i < n - 1; i++) {
            ll a, b, w;
            cin >> a >> b >> w;
            a--; b--;
            deg[a]++; deg[b]++;
            edges[i] = {a, b, w, i + 1};
        }

        vector<vector<ll>> c(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < deg[i]; j++) {
                ll in; cin >> in;
                c[i].push_back(in);
            }
        }

        do {
            bool ok = true;
            vector<ll> cwh(n);
            for (auto [a, b, w, cnt] : edges) {
                if (c[a][cwh[a]] + c[b][cwh[b]] < w) {
                    ok = false;
                    break;
                } else {
                    cwh[a]++; cwh[b]++;
                }
            }

            if (ok) {
                cout << "Yes\n";
                vector<ll> ans;
                for (auto [a, b, w, cnt] : edges) {
                    ans.push_back(cnt);
                }
                reverse(ans.begin(), ans.end());
                for (ll i : ans) {
                    cout << i << ' ';
                }
                return 0;
            }
        } while (next_permutation(edges.begin(), edges.end()));

        cout << "No\n";
    }

    return 0;
}
