#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <numeric>
#include <cmath>


#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

vector<int>ansb;
void build(int i, int ix, vector<vector<int>>&dp) {
    if (i == 0) return;
    if (dp[i][ix] == 0)
        ansb.push_back(i);
    build(i - 1, dp[i][ix], dp);
    if (dp[i][ix] == 1)
        ansb.push_back(i);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, tq;
    cin >> vs >> tq;
    if (tq <= 1) {
        vector<tuple<int, int, int>> ej;
        vector<vector<int>>x(vs);
        for (int i = vs - 1; i--;) {
            int f, t;
            cin >> f >> t;
            f--, t--;
            x[f].push_back(0);
            x[t].push_back(0);
            int w;
            cin >> w;
            ej.push_back({f, t, w});
        }
        for (int v = 0; v < vs; v++) {
            for (int &i : x[v])
                cin >> i;
            x[v] = {rall(x[v])};
        }

        vector<int>ord(vs - 1);
        iota(all(ord), 0);

        do {
            vector<int>ind(vs);
            bool chk = 1;
            for (int i : ord) {
                auto [f, t, w] = ej[i];
                chk &= x[f][ind[f]] + x[t][ind[t]] >= w;
                ind[f]++;
                ind[t]++;
            }
            if (chk) {
                cout << "Yes\n";
                for (int i : ord)
                    cout << i + 1 << ' ';
                return 0;
            }
        } while (next_permutation(all(ord)));
        cout << "No";
    }

    if (tq == 3) {
        vector<int>ej;
        for (int t = 1; t < vs; t++) {
            int f, tq;
            cin >> f >> tq;
            int w;
            cin >> w;
            ej.push_back(w);
        }
        vector<int>xf(vs - 1);
        for (int &i : xf)
            cin >> i;
        xf = {rall(xf)};

        for (int di = 0; di < vs - 1; di++) {
            int d;
            cin >> d;
            ej[di] -= d;
        }

        vector<int>orde(vs - 1);
        iota(all(orde), 0);
        sort(all(orde), [&](int l, int r) {return ej[l] < ej[r];});
        vector<int>ordx(vs - 1);
        iota(all(ordx), 0);
        sort(all(ordx), [&](int l, int r) {return xf[l] < xf[r];});

        vector<int>ans(vs - 1);
        for (int i = 0; i < vs - 1; i++) {
            if (xf[ordx[i]] < ej[orde[i]]) {
                cout << "No";
                return 0;
            } else {
                ans[ordx[i]] = orde[i];
            }
        }
        cout << "Yes\n";
        for (int i : ans)
            cout << i + 1 << ' ';
    }

    if (tq == 2) {
        vector<int>w;
        for (int i = vs - 1; i--;) {
            int f, t;
            cin >> f >> t;
            f--, t--;
            cin >> w[f];
        }
        vector<vector<int>>x(vs, vector<int>(2));
        for (int v = 0; v < vs; v++) {
            cin >> x[v][0];
            if (v != vs - 1 && v != 0) {
                cin >> x[v][1];
            }
            x[v] = {rall(x[v])};
        }
        vector<vector<int>>dp(vs, vector<int>(2, -1));
        dp[0][0] = 1;
        for (int i = 0; i < vs - 1; i++) {
            for (int f = 0; f < 2; f++) {
                for (int t = 0; t < (i != vs - 1 ? 2 : 1); t++) {
                    if (dp[i][f] != -1 && x[i][f] + x[i + 1][t] >= w[i])
                        dp[i + 1][1 - t] = f;
                }
            }
        }

        if (dp.back()[1] == -1) {
            cout << "No";
        } else {
            build(vs - 1, 1, dp);
            cout << "Yes\n";
            for (int i : ansb)
                cout << i << ' ';
        }
    }

}