#include <iostream>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ll long long
#define vi vector <int>
#define pii pair <int, int>
#define endl '\n'
#define pb push_back
#define ft first
#define sd second
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
using pbds = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;
using gp_hash = gp_hash_table <int, int>;
mt19937 rng(time(0));
//#define int long long
///
constexpr int MAX = 2e5 + 7, INF = 1e9 + 7, MOD = 1e9 + 7, LG = 18, R = 1 << LG, B = 320;
constexpr ll INFLL = 1e18 + 7;

// O(n * log(n) + sum(deg(i)^2) * log(n))

int n, group;
vi g[MAX]; // edg ids
vi kids[MAX]; // in needed order
pii par[MAX];
vector <pii> c[MAX]; // cost, pos
pii edg[MAX]; // u + v, w

void dfs(int v = 0, int p = 0) { // cost, pos
    vector <array <int, 2>> ch; // cost, id, pos
    EACH(e, g[v]) {
        int u = edg[e].ft - v;
        if (u != p) {
            dfs(u, v);
            ch.pb({edg[e].sd - par[u].ft, e});
        }
    }
    sort(all(ch)), reverse(all(ch));
    if (v) {
        int l = -1, r = sz(g[v]);
        while (l < r - 1) {
            int m = (l + r) / 2;
            bool f = 1;
            FOR(i, 0, m) if (ch[i][0] > c[v][i].ft) {
                f = 0;
                break;
            }
            FOR(i, 0, sz(g[v]) - m - 1) if (ch[m + i][0] > c[v][m + i + 1].ft) {
                f = 0;
                break;
            }
            (f ? r : l) = m;
        }
        if (r == sz(g[v])) {
            cout << "No";
            exit(0);
        }
        kids[v].resize(sz(g[v]));
        FOR(i, 0, r) kids[v][c[v][i].sd] = ch[i][1];
        FOR(i, 0, sz(g[v]) - r - 1) kids[v][c[v][r + i + 1].sd] = ch[r + i][1];
        par[v] = c[v][r];
    }
    else {
        FOR(i, 0, sz(g[v])) if (ch[i][0] > c[v][i].ft) {
            cout << "No";
            exit(0);
        }
        kids[v].resize(sz(g[v]));
        FOR(i, 0, sz(g[v])) kids[v][c[v][i].sd] = ch[i][1];
        par[v] = make_pair(-1, -1);
    }
}

void restore(int v = 0, int p = 0) {
    FOR(i, 0, sz(g[v])) {
        if (par[v].sd == i) cout << p + 1 << ' ';
        else restore(edg[kids[v][i]].ft - v, kids[v][i]);
    }
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> group;
    FOR(i, 0, n - 1) {
        int u, v, w; cin >> u >> v >> w, --u, --v;
        g[u].pb(i), g[v].pb(i);
        edg[i] = make_pair(u + v, w);
    }
    FOR(i, 0, n) {
        vi kek(sz(g[i]));
        EACH(e, kek) cin >> e;
        reverse(all(kek));
        c[i].resize(sz(g[i]));
        FOR(j, 0, sz(g[i])) c[i][j] = make_pair(kek[j], j);
        sort(all(c[i])), reverse(all(c[i]));
    }
    dfs();
    cout << "Yes\n";
    restore();
}
