#include <bits/stdc++.h>

#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 3e5;
const int MAXX = 2e6;
const int MOD = 998244353;
const int INF = 2e9;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 30;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(228);

struct Edge{
    int i;
    int to;
    int w;
    Edge(int a, int b, int c){
        to = a;
        w = b;
        i = c;
    }
};

vector <Edge> vp[MAXN];

vector <int> ans(MAXN);

vector <pair<int, int>> chs[MAXN];
vector <int> nms[MAXN];

vector <int> top(MAXN, -1);

vector <int> vp1[MAXN];

void dfs(int v, int pr, int i1){
    multiset <int> ms;
    map <int, vector<int>> mp;
    for(auto ed:vp[v]){
        if(ed.to == pr){
            continue;
        }
        dfs(ed.to, v, ed.i);
        mp[ed.w - top[ed.to]].push_back(ed.i);
        ms.insert(ed.w - top[ed.to]);
    }
    int last = -1;
    for(int i = 0; i < chs[v].size(); i++){
        if(!ms.size()){
            top[v] = chs[v][i].first;
            nms[v][chs[v][i].second] = i1;
            break;
        }
        auto it = ms.upper_bound(chs[v][i].first);
        if(it == ms.begin()){
            //cout << "IN: " << v << ' ' << chs[v][i] << endl;
            if(top[v] == -1){
                top[v] = chs[v][i].first;
                nms[v][chs[v][i].second] = i1;
            }
            else{
                cout << "No";
                exit(0);
            }
        }
        else{
            it--;
            //cout << "TOO IN: " << v << ' ' << chs[v][i] << ' ' << *it << endl;
            nms[v][chs[v][i].second] = mp[*it].back();
            mp[*it].pop_back();
            ms.erase(it);
        }
    }
    for(int i = 0; i < nms[v].size() - 1; i++){
        vp1[nms[v][i]].push_back(nms[v][i + 1]);
    }
    if(pr == -1 && top[v] != -1){
        cout << "No";
        exit(0);
    }
}

vector <int> used(MAXN);

vector <int> ts;

void dfs2(int v){
    used[v] = 1;
    for(auto to:vp1[v]){
        if(!used[to]){
            dfs2(to);
        }
    }
    ts.push_back(v);
}

vector <int> get_from_str(string &s){
    vector <int> v;
    int nw = 0;
    for(auto i:s){
        if(i >= '0' && i <= '9'){
            nw *= 10;
            nw += i - '0';
        }
        else{
            v.push_back(nw);
            nw = 0;
        }
    }
    v.push_back(nw);
    return v;
}

void solve(){
    string s;
    getline(cin, s);
    vector <int> v = get_from_str(s);
    int n =  v[0], g = v[1];
    //cout << n << ' ' << g << endl;
    for(int i = 0; i < n - 1; i++){
        int a, b, c;
        getline(cin, s);
        v = get_from_str(s);
        a = v[0];
        b = v[1];
        c = v[2];
        //cin >> a >> b >> c;
        a--;
        b--;
        //cout << a << ' ' << b << ' ' << c << endl;
        vp[a].push_back({b, c, i});
        vp[b].push_back({a, c, i});
    }
    for(int i = 0; i < n; i++){
        getline(cin, s);
        v = get_from_str(s);
        for(int j = 0; j < v.size(); j++){
            chs[i].push_back({v[j], j});
            nms[i].push_back(-1);
        }
        sort(chs[i].begin(), chs[i].end());
    }
    dfs(0, -1, -1);
    for(int i = 0; i < n - 1; i++){
        if(!used[i]){
            dfs2(i);
        }
    }
    cout << "Yes" << endl;
    for(auto i:ts){
        cout << i + 1 << ' ';
    }
}
/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3

7 0
1 2 4
2 3 4
3 4 4
4 5 4
5 6 4
6 7 4
2
1 2
2 3
1 2
3 2
1 2
179

4 0
1 2 7
1 3 6
1 4 5
3 2 1
5
4
3
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
