#include "bits/stdc++.h"

using namespace std;

const int N = 2e5 + 5;
map<pair<int, int>, int> e, ids;
set<int> g[N];
set<pair<int, int> > cs[N];

struct Node {
	int val, id;
	
	Node(): val(1e9), id(-1) {}
	Node(int val, int id): val(val), id(id) {}
	friend Node operator+(Node x, Node y) {
		if (x.val == 0 and y.val == 0) return Node();
		if (x.val == 0) return y;
		if (y.val == 0) return x;
		if (x.val <= y.val) return x;
		return y;
	}
};

struct Segtree {
	int sz;
	vector<Node> tree;
	
	Segtree(int n) {
		sz = 1;
		while (sz < n) sz <<= 1;
		tree.assign(sz << 1, Node());
		
		for (int i = 0; i < n; ++i) tree[i + sz] = {(int)g[i].size(), i};
		for (int i = sz - 1; i > 0; --i) tree[i] = tree[i << 1] + tree[i << 1 | 1];
	}
	
	void set(int i) {
		tree[i += sz].val--;
		for (i >>= 1; i > 0; i >>= 1) tree[i] = tree[i << 1] + tree[i << 1 | 1];
	}
	
	int get() { return tree[1].id; }
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, group;
	cin >> n >> group;
	
	for (int i = 1; i < n; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v --;
		g[u].emplace(v);
		g[v].emplace(u);
		e[{u, v}] = w;
		e[{v, u}] = w;
		ids[{u, v}] = i;
		ids[{v, u}] = i;
	}
	
	vector<int> sz(n);
	
	for (int i = 0; i < n; ++i) {
		sz[i] = g[i].size();
		for (int j = 0; j < g[i].size(); ++j) {
			int x;
			cin >> x;
			cs[i].emplace(x, g[i].size() - 1 - j);
		}
	}
	
	Segtree st(n);
	
	vector<pair<int, int>> edg[n];
	
	for (int i = 0; i < n; ++i) edg[i].resize(sz[i]);
	
	for (int cnt = 0; cnt < n - 1; ++cnt) {
		int u = st.get(), v = *g[u].begin();
		int w = e[{u, v}];
		auto it = cs[v].lower_bound({w - cs[u].begin()->first, -1e9});
		if (it == cs[v].end()) {
			cout << "No\n";
			return 0;
		}
		int j = it->second;
		
		edg[u][cs[u].begin()->second] = {v, j};
		edg[v][j] = {u, cs[u].begin()->second};
		
		st.set(u), st.set(v);
		g[u].erase(v);
		g[v].erase(u);
		cs[v].erase(it);
		cs[u].erase(cs[u].begin());
	}
	
	vector<int> used(n);
	vector<int> ans;
	
//	for (auto [v, j]: edg[2]) cout << v << ' ' << j << '\n';
//	cout << edg[2];
	
	function<void(int, int)> dfs = [&](int u, int p) {
		for (int i = 0; i < sz[u]; ++i) {
			auto [v, j] = edg[u][i];
			if (v == p){
				ans.push_back(ids[{u, p}]);
				continue;
			}
			
			dfs(v, u);
		}
	};
	
	dfs(0, -1);
	
	for (auto i: ans) cout << i << ' ';
}