#include <bits/stdc++.h>

const int maxn = 200000 + 111;
const int maxm = 100000 + 111;
const long long MOD = 1234567891;
const long long mod = 1e9 + 7;
const long long oo = 1e18;

using namespace std;

//#define int long long
int n, m, k, GGG;
vector <pair <int, int>> g[maxn];

struct edge {
    int u, v, w;
} ed[maxn];

vector <unordered_map <int, int>> pos(maxn);
vector <multiset <int>> cis(maxn);
vector <int> c[maxn];
vector <int> ost(maxn);

int dfs(int v, int p = -1) {
    vector <int> d;
    for (auto &u : g[v]) {
        if (u.first == p) {
            continue;
        }

        int cost = ed[u.second].w;
        d.push_back(cost - dfs(u.first, v));
    }

    for (auto &dd : d) {
        auto it = cis[v].lower_bound(dd);
        if (it == cis[v].end()) {
            cout << "No\n";
            exit(0);
        }

        cis[v].erase(it);
    }

    int x = *cis[v].begin();
    ost[v] = x;
    return x;
}

vector <int> ans;

void dfs_build(int v, int p = -1) {
    set <pair <int, int>> q;
    for (auto &u : g[v]) {
        if (u.first == p) {
            continue;
        }

        int cost = ed[u.second].w;
        q.insert({cost - ost[u.first], u.first});
    }

    if (g[v].size() == 1 && p != -1) {
        ans.push_back(pos[v][p]);
        return;
    }

    bool ok = false;
    for (auto &i : c[v]) {
        if (p != -1 && !ok && i == ost[v]) {
            ans.push_back(pos[v][p]);
            ok = true;
            continue;
        }

        auto x = q.upper_bound({i, 1e9});
        --x;

        dfs_build(x->second, v);

        q.erase(x);
    }
}

void solve() {
    cin >> n >> GGG;

    for (int i = 0, u, v, w; i < n - 1; i = i + 1) {
        cin >> u >> v >> w;

        ed[i] = {u, v, w};
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        pos[u][v] = i;
        pos[v][u] = i;
    }

    for (int i = 1; i <= n; i = i + 1) {
        for (int q = 0; q < g[i].size(); q = q + 1) {
            int t;
            cin >> t;

            c[i].push_back(t);
            cis[i].insert(t);
        }

        reverse(c[i].begin(), c[i].end());
    }


    dfs(1);

    dfs_build(1);

    cout << "Yes\n";
    for (auto &i : ans) {
        cout << i + 1 << ' ';
    }
}

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

signed main() {
    files();
    fastio();
    int qq = 1;
    //cin >> qq;

    while (qq--) {
        solve();
    }

    return 0;
}
