#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

struct dsu {
    vector<int> p, sz;
    dsu (int n) {
        p.assign(n, 0);
        sz.assign(n, 1);
        iota(p.begin(), p.end(), 0);
    }
    int get(int x) {
        if (p[x] != x) {
            p[x] = get(p[x]);
        }
        return p[x];
    }
    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return false;
        else if (sz[u] > sz[v]) swap(u, v);
        sz[v] += sz[u];
        p[u] = v;
        return true;
    }
    bool check(int u, int v) {
        u = get(u), v = get(v);
        return (u == v);
    }
};

struct edge {
    int u, v, w, id;
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, _;
    cin >> n >> _;
    dsu dsu(n + 1);

    vector<edge> edges(n - 1);
    vector<vector<int>> c(n + 1);
    vector<int> deg(n + 1, 0);
    vector<int> ans;
    vector<int> iter(n + 1, 0);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        ++deg[edges[i].u], ++deg[edges[i].v];
        edges[i].id = i + 1;
    }

    sort(edges.begin(), edges.end(), [&] (auto e1, auto e2) {
        return e1.w > e2.w;
    });

    for (int i = 1; i <= n; ++i) {
        c[i].assign(deg[i], 0);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }

    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            auto [u, v, w, id] = edges[j];
            if (!dsu.check(u, v) && c[v][iter[v]] + c[u][iter[u]] >= w) {
                dsu.unite(u, v);
                ++iter[v];
                ++iter[u];
                ans.pb(id);
                break;
            }
        }
    }

    if (ans.size() != n - 1) {
        cout << "No\n";
        return 0;
    }

    cout << "Yes\n";
    reverse(ans.begin(), ans.end());
    for (int x : ans) {
        cout << x << ' ';
    }
    cout << '\n';
}
