#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 998244353;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

const int N = 2e5 + 1;
int n, group, deg[N], root = -1;
vector <int> belong[N];
vector <pii> g[N];
vector<vector<int>> e;
set <pii> c[N], c1[N];
unordered_map <int, int> gt[N];

inline void dfs (int k, int par) {
    // debug(k);
    gt[k].reserve(g[k].size());
    for (auto i : g[k]) {
        if (i.first != par) {
            gt[k][i.first] = i.second;
            dfs(i.first, k);
        }
    }
    if (par == -1) {
        if (!c[k].empty()) {
            cout << "No" << endl;
            exit(0);
        }
        return;
    }
    for (auto i : c[k]) {
        int W = e[gt[par][k]][2];
        auto t = c[par].lower_bound({W - i.first, -1});
        if (t == c[par].end()) {
            cout << "No" << endl;
            exit(0);
        }
        else {
            auto [weight, index] = *t;
            c[par].erase(t);
            belong[k][i.second] = gt[par][k];
            belong[par][index] = gt[par][k];
        }
    }
    c[k].clear();
}

vector <int> G[N];
bool used[N];
vector <int> ord;

void dfs1 (int k) {
    used[k] = true;
    for (auto i : G[k]) {
        if (!used[i]) dfs1(i);
    }
    ord.push_back(k + 1);
}

void solve() {
    cin >> n >> group;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w; cin >> a >> b >> w; --a; --b;
        ++deg[a]; ++deg[b];
        e.push_back({a, b, w});
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    for (int i = 0; i < n; ++i) {
        belong[i].assign(deg[i], -1);
        for (int j = 0; j < deg[i]; ++j) {
            int x; cin >> x;
            c[i].insert({x, j});
        }
        c1[i] = c[i];
    }
    if (n == 2) {
        if (e[0][2] <= (*c[0].begin()).first + (*c[1].begin()).first) {
            cout << "Yes" << endl;
            cout << 1 << endl;
        }
        else {
            cout << "No" << endl;
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (deg[i] >= 2) {
            root = i; break;
        }
    }
    dfs(root, -1);
    for (int i = 0; i < n; ++i) {
        if (deg[i]) {
            int leader = -1;
            for (auto j : c1[i]) {
                if (!j.second) {
                    leader = belong[i][j.second];
                }
            }
            for (auto j : c1[i]) {
                if (leader != belong[i][j.second]) {
                    G[leader].push_back(belong[i][j.second]);
                }
            }
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i]) dfs1(i);
    }
    cout << "Yes" << endl;
    vout(ord);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}