#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n;
vector<pair<int, int>> e;
vector<int> w, deg;
vector<vector<int>> c;
vector<vector<pair<int, int>>> g;

void solve1() {
    vector<int> ord(n - 1);
    iota(all(ord), 0);
    do {
        vector<int> p(n);
        bool good = true;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b] = e[ord[i]];
            if (w[ord[i]] > c[a][p[a]++] + c[b][p[b]++]) {
                good = false;
                break;
            }
        }
        if (good) {
            cout << "Yes\n";
            for (int x : ord) cout << x + 1 << " ";
            return;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

void solve2() {
    vector<pair<int, int>> dp(n, make_pair(-1, -1));
    dp[0] = {0, -1};
    for (int i = 1; i < n; i++) {
        int ww = w[(g[i][0].first == i - 1 ? g[i][0].second : g[i][1].second)];
        if (i != n - 1) {
            if (dp[i - 1].first != -1 && ww <= c[i][1] + c[i - 1][0]) {
                dp[i].first = 0;
            }
            if (dp[i - 1].second != -1 && ww <= c[i][1] + c[i - 1][1]) {
                dp[i].first = 1;
            }
        }
        if (dp[i - 1].first != -1 && ww <= c[i][0] + c[i - 1][0]) {
            dp[i].second = 0;
        }
        if (dp[i - 1].second != -1 && ww <= c[i][0] + c[i - 1][1]) {
            dp[i].second = 1;
        }
    }

    if (dp.back().second == -1) cout << "No";
    else {
        cout << "Yes\n";
        deque<int> ans;
        int pre = 1;
        for (int i = n - 1; i > 0; i--) {
            int wi = (g[i][0].first == i - 1 ? g[i][0].second : g[i][1].second);
            if (pre == 0) ans.push_back(wi);
            else ans.push_front(wi);
            pre = (pre == 0 ? dp[i].first : dp[i].second);
        }
        for (int x : ans) cout << x + 1 << " ";
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int G;
    cin >> n >> G;
    deg.resize(n);
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, W;
        cin >> a >> b >> W;
        a--, b--;
        e.emplace_back(a, b);
        w.push_back(W);
        deg[a]++;
        deg[b]++;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
    }
    c.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(all(c[i]));
    }

    if (G == 0 || G == 1) solve1();
    else if (G == 2) solve2();
}