#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()
#define f first
#define s second
#define pb push_back

using pii = pair<int, int>;

const int N = 2e5 + 5;
int n, G, deg[N];
vec<pii> g[N];
vec<int> val[N];

struct Edge {
    int u;
    int v;
    int w;
};
vec<Edge> edges;

bool check(vec<int> &order) {
    vec<int> ptr(n + 1);
    bool ok = true;
    for (int i = 0; i < n - 1; i++) {
        int sum = val[edges[order[i]].u][ptr[edges[order[i]].u]]
                    + val[edges[order[i]].v][ptr[edges[order[i]].v]];
        if (edges[order[i]].w > sum) {
            ok = false;
            break;
        }

        ptr[edges[order[i]].u]++;
        ptr[edges[order[i]].v]++;
    }
    return ok;
}

bool cmp(int i, int j) {
    return edges[i].w - val[edges[i].v][0] < edges[j].w - val[edges[j].v][0];
}

void solve() {
    cin >> n >> G;
    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});

        deg[u]++;
        deg[v]++;
        edges.pb({u, v, w});
    }

    for (int i = 1; i <= n; i++) {
        val[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> val[i][j];
        }
        reverse(all(val[i]));
    }

    if (G <= 1) {
        vec<int> order(n - 1);
        for (int i = 0; i < n - 1; i++) {
            order[i] = i;
        }
        do {
            if (check(order)) {
                cout << "Yes\n";
                for (int i = 0; i < n - 1; i++) {
                    cout << order[i] + 1 << ' ';
                }
                return;
            }
        } while (next_permutation(all(order)));

        cout << "No";
        return;
    }

    vec<int> order(n - 1);
    for (int i = 0; i < n - 1; i++) {
        order[i] = i;
    }

    sort(all(order), cmp);

    if (check(order)) {
        cout << "Yes\n";
        for (int i = 0; i < n - 1; i++) {
            cout << order[i] + 1 << ' ';
        }
    } else {
        cout << "No";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
