#include <bits/stdc++.h>
using namespace std;

int n, g;
vector<vector<pair<int, int>>> graph;
vector<vector<int>> graph_c, c, edge;
vector<set<pair<int, int>>> pos;
vector<int> weight;
vector<int> ts;
vector<bool> used;

void DFS(int u, int p, int e) {
  for (auto [v, i] : graph[u]) {
    if (i != e) {
      DFS(v, u, i);
    }
  }
  if (e != -1) {
    auto it = pos[p].lower_bound({weight[e] - pos[u].begin()->first, -1});
    if (it == pos[p].end()) {
      cout << "No\n";
      exit(0);
    }
    edge[u][pos[u].begin()->second] = e;
    edge[p][it->second] = e;
    pos[u].erase(pos[u].begin());
    pos[p].erase(it);
  }
}

void topsort(int u, int p) {
  used[u] = true;
  for (int v : graph_c[u]) {
    if (!used[v]) {
      topsort(v, u);
    }
  }
  ts.push_back(u);
}

int main() {
  cin >> n >> g;
  graph.resize(n);
  c.resize(n);
  vector<int> deg(n);
  weight.resize(n - 1);
  for (int i = 0; i < n - 1; i++) {
    int a, b;
    cin >> a >> b >> weight[i];
    a--, b--;
    graph[a].push_back({b, i});
    graph[b].push_back({a, i});
    deg[a]++, deg[b]++;
  }
  pos.resize(n);
  edge.resize(n);
  for (int i = 0; i < n; i++) {
    c[i].resize(deg[i]);
    edge[i].resize(deg[i]);
    for (auto &value : c[i]) {
      cin >> value;
    }
    for (int j = 0; j < deg[i]; j++) {
      pos[i].insert({c[i][j], j});
    }
  }
  DFS(0, -1, -1);
  graph_c.resize(n - 1);
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < deg[i] - 1; j++) {
      graph_c[edge[i][j + 1]].push_back(edge[i][j]);
    }
  }
  used.assign(n - 1, false);
  for (int i = 0; i < n - 1; i++) {
    if (!used[i]) {
      topsort(i, -1);
    }
  }
  reverse(ts.begin(), ts.end());
  cout << "Yes\n";
  for (int i = 0; i < n - 1; i++) {
    cout << 1 + ts[i] << " \n"[i + 1 == n - 1];
  }
}
