#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;

void solve1() {
    vector<int> deg(n);
    vector<array<int, 3>> edg;
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        edg.push_back({a, b, w});
        deg[a]++;
        deg[b]++;
    }
    
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (auto &j : c[i]) {
            cin >> j;
        }
    }
    
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    do {
        bool good = true;
        auto cc = c;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b, w] = edg[p[i]];
            int ca = cc[a].back();
            cc[a].pop_back();
            int cb = cc[b].back();
            cc[b].pop_back();
            if (ca + cb < w) {
                good = false;
                break;
            }
        }
        if (good) {
            cout << "Yes\n";
            for (auto i : p) cout << i + 1 << ' ';
            cout << '\n';
            exit(0);
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No\n";
}

void solve2() {
    vector<int> w(n), deg(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b >> w[i];
        a--, b--;
        deg[a]++;
        deg[b]++;
    }
    
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (auto &j : c[i]) {
            cin >> j;
        }
    }
    
    vector<int> ans;
    auto dfs = [&](auto self, int v) -> void {
        if (v == n - 2) {
            if (c[v][0] + c[v + 1][0] < w[v]) {
                cout << "No\n";
                exit(0);
            }
            ans.push_back(v);
            return;
        }
        if (c[v][0] + min(c[v + 1][0], c[v + 1][1]) >= w[v]) {
            if (c[v + 1][0] < c[v + 1][1]) {
                swap(c[v + 1][0], c[v + 1][0]);
                c[v + 1].pop_back();
                self(self, v + 1);
                ans.push_back(v);
            } else {
                ans.push_back(v);
                c[v + 1].pop_back();
                self(self, v + 1);
            }
        } else if (c[v][0] + c[v + 1][0] >= w[v]) {
            swap(c[v + 1][0], c[v + 1][1]);
            c[v + 1].pop_back();
            self(self, v + 1);
            ans.push_back(v);
        } else if (c[v][0] + c[v + 1][1] >= w[v]) {
            ans.push_back(v);
            c[v + 1].pop_back();
            self(self, v + 1);
        } else {
            cout << "No\n";
            exit(0);
        }
    };
    dfs(dfs, 0);
    
    cout << "Yes\n";
    for (auto i : ans) cout << i + 1 << ' ';
    cout << '\n';
    return;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    // int group;
    // cin >> n >> group;
    // if (group == 0 || group == 1) solve1();
    // if (group == 2) solve2();
    
    cin >> n;
    solve2();
    
    return 0;
}