#define _CRT_SECURE_NO_WARNINGS

#pragma gcc optimise("Ofast")
#pragma gcc optimise("unswith-loops")
#pragma gcc optimise("unroll-loops")
#pragma gcc optimise("no-stack-protector")
#pragma gcc optimise("fast-math")
#pragma gcc optimise("rename-registers")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

struct edge {
	int a, b, cost;
};

const int N = 2e5 + 228;
vector<int> marks[N];
vector<edge> edges;
vector<pii> arr[N];

void solve_fac(int n) {
	vector<int> order(n - 1);
	iota(walk(order), 0);
	do {
		vector<int> pointers(n);
		for (int i = 0; i < n; i++)
			pointers[i] = sz(marks[i]) - 1;
		bool flag = true;
		for (int i : order) {
			auto [fir, sec, cost] = edges[i];
			if (marks[fir][pointers[fir]] + marks[sec][pointers[sec]] >= cost) {
				pointers[fir]--;
				pointers[sec]--;
			}
			else {
				flag = false;
				break;
			}
		}
		if (flag) {
			cout << "Yes\n";
			for (int i : order)
				cout << i + 1 << " ";
			return;
		}
	} while (next_permutation(walk(order)));
	cout << "No";
}

void solve_bamboo(int n) {
	cout << "No";
}

void solve() {
	int n, g;
	cin >> n >> g;
	int f, s, c;
	for (int i = 0; i < n - 1; i++) {
		cin >> f >> s >> c;
		f--, s--;
		edges.emplace_back(f, s, c);
		arr[f].emplace_back(s, c);
		arr[s].emplace_back(f, c);
	}
	for (int i = 0; i < n; i++) {
		marks[i].resize(sz(arr[i]));
		for (int& u : marks[i])
			cin >> u;
	}
	if (g <= 1)
		solve_fac(n);
	else if (g == 2)
		solve_bamboo(n);
	else
		cout << "No";
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}