//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

struct Edge {
    int v, u, w, i;

    Edge() {}

    Edge(int v, int u, int w, int i) : v(v), u(u), w(w), i(i) {}
};

void solve() {
    int n, g;
    std::cin >> n >> g;
    std::vector<Edge> edges(n - 1);
    std::vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        std::cin >> v >> u >> w;
        v--, u--;
        deg[v]++, deg[u]++;
        edges[i] = Edge(v, u, w, i);
    }
    std::vector<std::vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            std::cin >> c[i][j];
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    std::vector<int> res;
    for (int it = 0; it < n - 1; it++) {
        int best = -1;
        int opt = 2e9 + 1;
        for (int i = 0; i < edges.size(); i++) {
            auto [v, u, w, _] = edges[i];
            if (c[v].back() + c[u].back() >= w && c[v].back() + c[u].back() - w < opt) {
                opt = c[v].back() + c[u].back() - w;
                best = i;
            }
        }
        if (best == -1) {
            std::cout << "No\n";
            return;
        }
        res.emplace_back(edges[best].i);
        c[edges[best].v].pop_back();
        c[edges[best].u].pop_back();
        edges.erase(edges.begin() + best);
    }
    std::reverse(res.begin(), res.end());
    std::cout << "Yes\n";
    for (int i = 0; i < n - 1; i++) {
        std::cout << res[i] + 1 << " \n"[i == n - 2];
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}