//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

struct Edge {
    int v, u, w, i;

    Edge() {}

    Edge(int v, int u, int w, int i) : v(v), u(u), w(w), i(i) {}
};

void solve() {
    int n, g;
    std::cin >> n >> g;
    std::vector<Edge> edges(n - 1);
    std::vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        std::cin >> v >> u >> w;
        v--, u--;
        deg[v]++, deg[u]++;
        edges[i] = Edge(v, u, w, i);
    }
    std::vector<std::vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            std::cin >> c[i][j];
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    if (g == 2) {
        std::vector<int> res;
        auto get = [&](auto self, int i, int x) -> void {
            if (i == n - 1) {
                int w = edges[i - 1].w;
                int y = c[i][0];
                if (x + y >= w) {
                    res.emplace_back(edges[i - 1].i);
                } else {
                    std::cout << "No\n";
                    exit(0);
                }
            } else {
                int y = c[i][1], z = c[i][0];
                int w = edges[i - 1].w;
                if (x + y >= w && x + z >= w) {
                    if (y <= z) {
                        res.emplace_back(edges[i - 1].i);
                        self(self, i + 1, z);
                    } else {
                        self(self, i + 1, y);
                        res.emplace_back(edges[i - 1].i);
                    }
                } else if (x + y >= w) {
                    res.emplace_back(edges[i - 1].i);
                    self(self, i + 1, z);
                } else if (x + z >= w) {
                    self(self, i + 1, y);
                    res.emplace_back(edges[i - 1].i);
                } else {
                    std::cout << "No\n";
                    exit(0);
                }
            }
        };
        get(get, 1, c[0][0]);
        std::reverse(res.begin(), res.end());
        std::cout << "Yes\n";
        for (int i = 0; i < n - 1; i++) {
            std::cout << res[i] + 1 << " \n"[i == n - 2];
        }
        return;
    }
    if (g == 3) {
        std::multiset<std::pair<int, int>> st;
        for (int i = 1; i < n; i++) {
            st.insert(std::make_pair(c[i][0] - edges[i - 1].w, i));
        }
        std::vector<int> res;
        for (int iter = 0; iter < n - 1; iter++) {
            auto it = st.lower_bound(std::make_pair(-c[0].back(), 0));
            if (it == st.end()) {
                std::cout << "No\n";
                return;
            }
            auto [p, i] = *it;
            st.erase(it);
            res.emplace_back(i - 1);
            c[0].pop_back();
        }
        std::reverse(res.begin(), res.end());
        std::cout << "Yes\n";
        for (int i = 0; i < n - 2; i++) {
            std::cout << res[i] + 1 << " \n"[i == n - 2];
        }
        return;
    }
    if (g == 4) {

    }
    std::vector<int> res;
    for (int it = 0; it < n - 1; it++) {
        int best = -1;
        int opt = 2e9 + 1;
        for (int i = 0; i < edges.size(); i++) {
            auto [v, u, w, _] = edges[i];
            if (c[v].back() + c[u].back() >= w && c[v].back() + c[u].back() - w < opt) {
                opt = c[v].back() + c[u].back() - w;
                best = i;
            }
        }
        if (best == -1) {
            std::cout << "No\n";
            return;
        }
        res.emplace_back(edges[best].i);
        c[edges[best].v].pop_back();
        c[edges[best].u].pop_back();
        edges.erase(edges.begin() + best);
    }
    std::reverse(res.begin(), res.end());
    std::cout << "Yes\n";
    for (int i = 0; i < n - 1; i++) {
        std::cout << res[i] + 1 << " \n"[i == n - 2];
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}