#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
//#define int long long

random_device rd;
mt19937 rnd(rd());

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    ld x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ld operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

void solve() {
    int n, gg;
    cin >> n >> gg;
    vec<vec<pair<int, int>>> g(n);
    vec<pair<pair<int, int>, int>> edge;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[--a].push_back({--b, w});
        g[b].push_back({a, w});
        edge.push_back({{a, b}, w});
    }
    vec<vec<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].assign((int)g[i].size(), 0);
        for (int j = 0; j < (int)c[i].size(); ++j) {
            cin >> c[i][(int)c[i].size() - j - 1];
        }
    }
    if (gg <= 1) {
        vec<bool> dp(1 << (n - 1));
        vec<int> pred(1 << (n - 1));
        dp[0] = 1;
        for (int mask = 0; mask < (1 << (n - 1)) - 1; ++mask) {
            if (!dp[mask]) continue;
            //cout << mask << " " << dp[mask] << " " << pred[mask] << endl;
            vec<int> ind(n);
            for (int i = 0; i < n - 1; ++i) {
                if ((mask | (1 << i)) == mask) {
                    ind[edge[i].first.first]++;
                    ind[edge[i].first.second]++;
                }
            }
            for (int i = 0; i < n - 1; ++i) {
                if ((mask | (1 << i)) != mask) {
                   //cout << "a" << mask << " " << i << " " << edge[i].second << " " << c[edge[i].first.first][ind[edge[i].first.first]] << " " << c[edge[i].first.second][ind[edge[i].first.second]] << endl;
                    if (edge[i].second <= c[edge[i].first.first][ind[edge[i].first.first]] +
                                                  c[edge[i].first.second][ind[edge[i].first.second]]) {
                        dp[mask | (1 << i)] = 1;
                        pred[mask | (1 << i)] = i;
                    }
                }
            }
        }
        if (dp[(1 << (n - 1)) - 1]) {
            cout << "Yes\n";
            int res = (1 << (n - 1)) - 1;
            vec<int> ans;
            while (res > 0) {
                ans.push_back(pred[res]);
                res -= (1 << pred[res]);
            }
            reverse(all(ans));
            cout << (int)ans.size() << endl;
            for (int& i : ans) {
                cout << i + 1 << " ";
            }
            cout << endl;
        }
        else cout << "No\n";
    }
}

signed main() {
   // freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
   // freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}