#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
//#define int long long

random_device rd;
mt19937 rnd(rd());

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    ld x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ld operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

vec<vec<int>> c(2e5);
vec<set<pair<int, int>>> st(2e5);
vec<vec<int>> gr(2e5);
vec<vec<pair<int, int>>> g(2e5);

int dfs(int v, int parent = -1) {
    //cout << v << " " << parent << endl;
    for (auto& u : g[v]) {
        if (u.first != parent) {
            int cc = dfs(u.first, v);
            auto it = st[v].lower_bound({u.second - cc, -1});
            if (it == st[v].end()) {
                cout << "No\n";
                exit(0);
            }
            gr[v][(*it).second] = u.first;
            st[v].erase(it);
        }
    }
    for (int i = 0; i < (int)gr[v].size(); ++i) {
        if (gr[v][i] == -1) {
            return c[v][i];
        }
    }
}

map<pair<int, int>, int> mp;

void dfs2(int v, int parent = -1) {
    for (int i = 0; i < (int)gr[v].size(); ++i) {
        if (gr[v][i] == -1) {
            cout << mp[{v, parent}] + 1 << " ";
        }
        else {
            dfs2(gr[v][i], v);
        }
    }
}

void solve() {
    int n, gg;
    cin >> n >> gg;
    vec<pair<pair<int, int>, int>> edge;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[--a].push_back({--b, w});
        g[b].push_back({a, w});
        edge.push_back({{a, b}, w});
        mp[{a, b}] = mp[{b, a}] = i;
    }
    c.assign(n, vec<int>());
    for (int i = 0; i < n; ++i) {
        c[i].assign((int)g[i].size(), 0);
        for (int j = 0; j < (int)c[i].size(); ++j) {
            cin >> c[i][(int)c[i].size() - j - 1];
            st[i].insert({c[i][(int)c[i].size() - j - 1], (int)c[i].size() - j - 1});
        }
        gr[i].assign((int)g[i].size(), -1);
    }
    dfs(0);
    cout << "Yes\n";
    dfs2(0);
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}