 #define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <set>
#include <map>
#include <functional>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <iostream>
#include <algorithm>
#include <array>
#include <string>
#include <tuple>
#include <random>
#include <numeric>
#include <mutex>
#include <memory>
#include <locale>
#include <list>
#include <limits>
#include <iterator>
#include <functional>
#include <format>
#include <exception>
#include <ctime>
#include <ctgmath>
#include <cwchar>
#include <complex>
#include <bit>
#include <bitset>
#include <cassert>
#include <chrono>

using namespace std;

int n, G;
vector<vector<int>> arr;
vector<vector<pair<int, int>>> ll;
vector<vector<pair<int, int>>> g;
vector<tuple<int, int, int>> edges;
vector<int> maxAv;
bool ext = false;
vector<vector<int>> histRecover;
vector<int> pred;

int vK;
int banInd;
vector<int> usK;
vector<int> ansK;
vector<int> avVals;
vector<int> ww;
vector<int> vertexs;

bool kuhn(int v, int c) {
    if (usK[v] == c) return false;
    usK[v] = c;
    for (pair<int, int> pr : ll[vK]) {
        if (pr.second == banInd) continue;
        if (avVals[v] + pr.first < ww[v]) break;
        if (ansK[pr.second] == -1) {
            ansK[pr.second] = v;
//             cout << "KUHN TRUE1 " << v << " " << c << "  " << avVals[v] << " " << ww[v] << " " << pr.first << " " << pr.second << endl;
            return true;
        }
    }
//    cout << "KUHN TRY " << v << " " << c << endl;
    for (pair<int, int> pr : ll[vK]) {
        if (pr.second == banInd) continue;
        if (avVals[v] + pr.first < ww[v]) break;
        if (kuhn(ansK[pr.second], c)) {
            ansK[pr.second] = v;
//             cout << "KUHN TRUE2 " << v << " " << c << "  " << avVals[v] << " " << ww[v] << " " << pr.first << " " << pr.second << endl;
            return true;
        }
    }
    return false;
}

void dfs(int v, int p) {
    pred[v] = p;
    if (g[v].size() == 1 && p != v) {
        maxAv[v] = ll[v][0].first;
        histRecover[v] = {p};
        return;
    }

    int sz = (int)g[v].size();
    if (p != v) sz--;

    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;
        dfs(u, v);
        if (ext) return;
    }

    avVals.clear();
    ww.clear();
    vertexs.clear();
    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;
        avVals.push_back(maxAv[u]);
        ww.push_back(get<2>(edges[pr.second]));
        vertexs.push_back(u);
    }

//    cout << "DFS " << v + 1 << " " << p + 1 << endl;
//    cout << "ww: ";
//    for (auto el : ww) cout << el << " ";
//    cout << endl << "avVals: ";
//    for (auto el : avVals) cout << el << " ";
//    cout << endl << "vert: ";
//    for (auto el : vertexs) cout << el + 1 << " ";
//    cout << endl;

    usK.assign(sz, -1);
    ansK.assign(ll[v].size(), -1);
    vK = v;
    banInd = -1;
    int indV = 0;
    for (pair<int, int> pr : g[v]) {
        if (pr.first == p) continue;
        if (!kuhn(indV, indV)) {
            cout << "No" << endl;
            // cout << "LOx " << v + 1 << " " << p + 1 << "  " << pr.first + 1 << endl;
            ext = true;
            return;
        }
        indV++;
    }
    if (v == p) {
        for (int i = 0; i < sz; i++) {
            ansK[i] = vertexs[ansK[i]];
        }
        histRecover[v] = ansK;

//         cout << "DFS DONE " << v + 1 << " " << p + 1 << "   " << maxAv[v] << endl;
//
//         cout << "ww: ";
//         for (auto el : ww) cout << el << " ";
//         cout << endl << "avVals: ";
//         for (auto el : avVals) cout << el << " ";
//         cout << endl;
//
//         for (int i = 0; i < (int)ll[v].size(); i++) {
//             cout << i << " " << ll[v][i].first << " " << ll[v][i].second << "  " << ansK[ll[v][i].second] << endl;
//         }
//         cout << endl;

        return;
    }

    // cout << "DFS DONE " << v + 1 << " " << p + 1 << endl;
    // return;

    int l = -1, r = (int)ll[v].size() - 1;
    while (r - l > 1) {
        int m = (l + r) / 2;

        usK.assign(sz, -1);
        ansK.assign(ll[v].size(), -1);
        banInd = m;

//        cout << "banInd " << m << " " << ll[v][m].first << " " << ll[v][m].second << endl;

        bool ch = true;
        indV = 0;
        for (pair<int, int> pr : g[v]) {
            if (pr.first == p) continue;
            if (!kuhn(indV, indV)) {
                ch = false;
                break;
            }
            indV++;
        }
        if (!ch) {
            l = m;
        } else {
            r = m;
        }
    }

    for (int i = 0; i <= sz; i++) {
        if (ansK[i] != -1) {
            ansK[i] = vertexs[ansK[i]];
        } else ansK[i] = p;
    }
    histRecover[v] = ansK;
    maxAv[v] = ll[v][r].first;

//     cout << "DFS DONE " << v + 1 << " " << p + 1 << "   " << maxAv[v] << endl;
//     for (int i = 0; i < (int)ll[v].size(); i++) {
//         cout << i << " " << ll[v][i].first << " " << ll[v][i].second << "  " << ansK[ll[v][i].second] << endl;
//     }
//     cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> G;
    arr.resize(n);
    g.resize(n);
    edges.resize(n - 1);
    ll.resize(n);
    pred.resize(n, -1);

    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {a, b, c};
    }

    for (int v = 0; v < n; v++) {
        arr[v].resize(g[v].size());
        for (int& j : arr[v]) cin >> j;
        for (int j = 0; j < (int)g[v].size(); j++) ll[v].emplace_back(arr[v][j], j);
        sort(ll[v].rbegin(), ll[v].rend());
    }
    maxAv.resize(n, -1);
    histRecover.resize(n);
    dfs(0, 0);
    if (ext) {
         cout << "LOOOX" << endl;
        return 0;
    }
    map<pair<int, int>, int> edgeRev;
    for (int i = 0; i < n - 1; i++) {
        edgeRev[{get<0>(edges[i]), get<1>(edges[i])}] = edgeRev[{get<1>(edges[i]), get<0>(edges[i])}] = i;
    }

    vector<pair<int, int>> info(n - 1, {-1, -1});
    for (int v = 0; v < n; v++) {
        for (int i = 0; i < (int)g[v].size(); i++) {
            int ind = edgeRev[{v, histRecover[v][i]}];
            // cout << "vv " << v + 1 << " " << i << "  " << ind << " " << 
            if (v == get<0>(edges[ind])) {
                info[ind].first = i;
            } else {
                info[ind].second = i;
            }
        }
    }

    // cout << "INFO: ";
    // for (int i = 0; i < n - 1; i++) {
    //     cout << i << " " << get<0>(edges[i]) + 1 << " " << get<1>(edges[i]) + 1 << "  " << info[i].first + 1 << " " << info[i].second + 1 << endl; 
    // }
    // return 0;

    vector<int> ans;
    vector<int> pop(n, 0);
    vector<bool> us(n - 1, false);
    for (int it = 0; it < n - 1; it++) {
        bool st = false;
        for (int i = 0; i < n - 1; i++) {
            if (us[i]) continue;
            int a = get<0>(edges[i]);
            int b = get<1>(edges[i]);
            if (pop[a] == info[i].first && pop[b] == info[i].second) {
                pop[a]++;
                pop[b]++;
                us[i] = true;
                ans.push_back(i);
                st = true;
                break;
            } 
        }

        if (!st) {
            cout << "No";
            return 0;
        }
    }
    reverse(ans.begin(), ans.end());


    cout << "Yes\n";
    for (int el : ans) cout << el + 1 << " ";
}