#define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <set>
#include <map>
#include <functional>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <iostream>
#include <algorithm>
#include <array>
#include <string>
#include <tuple>
#include <random>
#include <numeric>
#include <mutex>
#include <memory>
#include <locale>
#include <list>
#include <limits>
#include <iterator>
#include <functional>
#include <format>
#include <exception>
#include <ctime>
#include <ctgmath>
#include <cwchar>
#include <complex>
#include <bit>
#include <bitset>
#include <cassert>
#include <chrono>

using namespace std;

int n, G;
vector<vector<int>> arr;
vector<vector<pair<int, int>>> ll;
vector<vector<pair<int, int>>> g;
vector<tuple<int, int, int>> edges;
vector<int> maxAv, indAv;
bool ext = false;
vector<int> pred;
map<pair<int, int>, int> revEdge;
vector<int> avVals;
vector<int> ww;
vector<int> vertexs;
vector<int> pref;
vector<pair<int, int>> info;

void dfs(int v, int p) {
    pred[v] = p;
    if (g[v].size() == 1 && p != v) {
        maxAv[v] = ll[v][0].first;
        indAv[v] = 0;
        return;
    }

    int sz = (int)g[v].size();
    if (p != v) sz--;

    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;
        dfs(u, v);
        if (ext) return;
    }

    avVals.clear();
    ww.clear();
    vertexs.clear();
    pref.clear();
    vector<pair<int, int>> l;

    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;
        avVals.push_back(maxAv[u]);
        ww.push_back(get<2>(edges[pr.second]));
        vertexs.push_back(u);

        int mxPr = (int)(lower_bound(ll[v].begin(), ll[v].end(), make_pair(ww.back() - avVals.back(), -1)) - ll[v].begin());
//        cout << "DFS " << v + 1 << " " << p + 1 << "  " << u + 1 << " " << maxAv[u] << " " << ww.back() << "  " << mxPr << endl;
        if (mxPr == (int)ll[v].size()) {
//            cout << "LOOOO" << endl;
            cout << "No";
            ext = true;
            return;
        }
        l.emplace_back(mxPr, u);
    }

    sort(l.begin(), l.end());
    int fl = 0;
    for (auto [ln, u] : l) {
        if (fl == (int)ll[v].size() || ln > fl + 1 || (ln == fl + 1 && maxAv[v] != -1)) {
            cout << "No";
            ext = true;
            return;
        }
        if (ln == fl + 1) {
            maxAv[v] = ll[v][fl].first;
            indAv[v] = ll[v][fl].second;
            fl = ln;
        }
        info[revEdge[{v, u}]] = {ll[v][fl].second, indAv[u]};
        fl++;
    }
    if (fl < (int)ll[v].size() && maxAv[v] == -1) {
        maxAv[v] = ll[v][fl].first;
        indAv[v] = ll[v][fl].second;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> G;
    arr.resize(n);
    g.resize(n);
    edges.resize(n - 1);
    ll.resize(n);
    pred.resize(n, -1);

    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {a, b, c};
        revEdge[{a, b}] = revEdge[{b, a}] = i;
    }

    for (int v = 0; v < n; v++) {
        arr[v].resize(g[v].size());
        for (int& j : arr[v]) cin >> j;
        // reverse(arr[v].begin(), arr[v].end());
        for (int j = 0; j < (int)g[v].size(); j++) ll[v].emplace_back(arr[v][j], j);
        sort(ll[v].begin(), ll[v].end());
    }
    maxAv.resize(n, -1);
    indAv.resize(n, -1);
    info.resize(n - 1);
    dfs(0, 0);
    if (ext) {
        return 0;
    }
//
//    for (int i = 0; i < n - 1; i++) {
//        cout << i << " " << info[i].first << " " << info[i].second << endl;
//    }
    vector<int> pop(n);
    for (int v = 0; v < n; v++) pop[v] = (int)g[v].size() - 1;

    vector<int> ans;
    vector<bool> us(n - 1, false);
    for (int it = 0; it < n - 1; it++) {
        bool ch = false;
        for (int i = 0; i < n - 1; i++) {
            if (us[i]) continue;
            int a = get<0>(edges[i]);
            int b = get<1>(edges[i]);
            if (pop[a] == info[i].first && pop[b] == info[i].second) {
                ans.push_back(i + 1);
                pop[a]--;
                pop[b]--;
                us[i] = true;
                ch = true;
//                cout << "pop " << a + 1 << " " << b + 1 << endl;
            }
        }
//        if (!ch) {
//            cout << "LOX" << endl;
//            cout << "No";
//            return 0;
//        }
    }
    if (ans.size() < n - 1) {
        cout << "No";
        return 0;
    }

//    reverse(ans.begin(), ans.end());
    cout << "Yes" << endl;
    for (int el : ans) cout << el << " ";
}