#define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <map>
#include <iostream>
#include <algorithm>
#include <array>
#include <tuple>

using namespace std;

int n, G;
vector<vector<int>> arr;
vector<vector<pair<int, int>>> ll;
vector<vector<pair<int, int>>> g;
vector<tuple<int, int, int>> edges;
vector<int> maxAv, indAv;
bool ext = false;
map<pair<int, int>, int> revEdge;
vector<pair<int, int>> info;

void dfs(int v, int p) {
//    cout << "DFS " << v + 1 << " " << p + 1 << endl;
    if (g[v].size() == 1 && p != v) {
        maxAv[v] = ll[v][0].first;
        indAv[v] = 0;
        return;
    }

    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;
        dfs(u, v);
        if (ext) return;
    }
    vector<pair<int, int>> l;

    for (pair<int, int> pr : g[v]) {
        int u = pr.first;
        if (u == p) continue;

        int mxPr = (int)(lower_bound(ll[v].begin(), ll[v].end(), make_pair(get<2>(edges[pr.second]) - maxAv[u], -1)) - ll[v].begin());
//        cout << "DFS " << v + 1 << " " << p + 1 << "  " << u + 1 << " " << maxAv[u] << " " << ww.back() << "  " << mxPr << endl;
        l.emplace_back(mxPr, u);
    }

    sort(l.begin(), l.end());
    vector<int> paint(ll[v].size(), -1);
    int fl = 0;
    for (auto [ln, u] : l) {
//        cout << "dfs " << v + 1 << " " << p + 1 << "  " << ln << " " << u + 1 << "  " << fl << endl;
//        if (fl == (int)ll[v].size() || ln > fl + 1) {
//            cout << "No";
//            ext = true;
//            return;
//        }
//        if (ln == fl + 1) {
//            if (maxAv[v] == -1) {
//                maxAv[v] = ll[v][fl].first;
//                indAv[v] = ll[v][fl].second;
//            }
//            fl = ln;
//        }
        fl = max(fl, ln);
        if (fl >= ll[v].size()) {
            cout << "No";
            ext = true;
            return;
        }
        paint[fl] = u;
        info[revEdge[{v, u}]] = {ll[v][fl].second, indAv[u]};
        fl++;
    }
    for (int i = 0; i < (int)ll[v].size(); i++) {
        if (paint[i] == -1 && maxAv[i] == -1) {
            maxAv[v] = ll[v][i].first;
            indAv[v] = ll[v][i].second;
//            cout << "dfs " << v + 1 << " " p + 1 << "  " << maxAv[]
        }
    }
//    if (fl < (int)ll[v].size() && maxAv[v] == -1) {
//        maxAv[v] = ll[v][fl].first;
//        indAv[v] = ll[v][fl].second;
//    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

    cin >> n >> G;
    arr.resize(n);
    g.resize(n);
    edges.resize(n - 1);
    ll.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {a, b, c};
        revEdge[{a, b}] = revEdge[{b, a}] = i;
    }

    for (int v = 0; v < n; v++) {
        arr[v].resize(g[v].size());
        for (int& j : arr[v]) cin >> j;
        // reverse(arr[v].begin(), arr[v].end());
        for (int j = 0; j < (int)g[v].size(); j++) ll[v].emplace_back(arr[v][j], j);
        sort(ll[v].begin(), ll[v].end());
    }
    maxAv.resize(n, -1);
    indAv.resize(n, -1);
    info.resize(n - 1);
    dfs(0, 0);
    if (ext) {
        return 0;
    }
//    cout << "LOXOXOOXOXO" << endl;
//    return 0;
//
//    for (int i = 0; i < n - 1; i++) {
//        cout << i << " " << info[i].first << " " << info[i].second << endl;
//    }
    vector<int> pop(n);
    for (int v = 0; v < n; v++) pop[v] = (int)g[v].size() - 1;

    vector<int> ans;
    vector<bool> us(n - 1, false);
    for (int it = 0; it < n - 1; it++) {
        bool ch = false;
        for (int i = 0; i < n - 1; i++) {
            if (us[i]) continue;
            int a = get<0>(edges[i]);
            int b = get<1>(edges[i]);
            if (pop[a] == info[i].first && pop[b] == info[i].second) {
                ans.push_back(i + 1);
                pop[a]--;
                pop[b]--;
                us[i] = true;
                ch = true;
//                cout << "pop " << a + 1 << " " << b + 1 << endl;
                break;
            }
        }
        if (!ch) {
//            cout << "HUI " << ans.size() << endl;
            cout << "No";
            return 0;
        }
    }
    if (ans.size() < n - 1) {
        cout << "No";
        return 0;
    }

//    reverse(ans.begin(), ans.end());
    cout << "Yes" << endl;
    for (int el : ans) cout << el << " ";
}