#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

using pii = pair<int, int>;

struct edge {
    int v, u, w;
    explicit edge(int v1 = 0, int u1 = 0, int w1 = 0) {
        v = v1, u = u1, w = w1;
    }
};

void solve() {
    int n, gr; cin >> n >> gr;
    vector<vector<int>> ord;
    vector<edge> ed;
    vector<int> deg(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w; cin >> v >> u >> w;
        v--, u--;
        ed.emplace_back(v, u, w);
        deg[v]++;
        deg[u]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x; cin >> x;
            c[i].push_back(x);
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    vector<int> p(n - 1);
    for (int i = 0; i < n - 1; i++) {
        p[i] = i;
    }
    int op = 1;
    for (int i = 2; i < n; i++) {
        op *= i;
    }
    vector<int> id(n, 0);
    while (op--) {
        std::next_permutation(p.begin(), p.end());
        std::fill(id.begin(), id.end(), 0);
        bool f = true;
        for (int i = 0; i < n - 1; i++) {
            int v = ed[p[i]].v, u = ed[p[i]].u;
            int w = ed[p[i]].w;
            if (c[v][id[v]] + c[u][id[u]] < w) {
                f = false;
            }
            id[v]++;
            id[u]++;
        }
        if (f) {
            cout << "Yes\n";
            for (auto i : p) {
                cout << i + 1 << " ";
            }
            return;
        }
    }
    cout << "No\n";
}

/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3
 */

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
