#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<int>> new_edges;
vector<int> topsort;
vector<bool> used;

void dfs(int v) {
	used[v] = true;
	for (int u: new_edges[v]) {
		if (used[u]) continue;
		dfs(u);
	}
	topsort.push_back(v);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, g;
	cin >> n >> g;
	vector<vector<tuple<int, int, int>>> edges(n);
	vector<int> degrees(n, 0);
	vector<bool> disabled_edges(n-1, false);
	for (int i = 0; i < n-1; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		edges[a].emplace_back(b, w, i);
		edges[b].emplace_back(a, w, i);
		degrees[a]++;
		degrees[b]++;
	}
	queue<int> leaves;
	for (int i = 0; i < n; i++) {
		if (degrees[i] == 1) leaves.push(i);
	}
	vector<int> clue_id(2*n-2, -1);
	int counter = 0;
	vector<vector<int>> stickers(n);
	vector<set<pair<int, int>>> sorted_stickers(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < degrees[i]; j++) {
			int x;
			cin >> x;
			stickers[i].push_back(counter);
			sorted_stickers[i].emplace(x, counter);
			counter++;
		}
	}
	while (!leaves.empty()) {
		int v = leaves.front();
		leaves.pop();
		if (degrees[v] == 0) continue;
		auto [x, sticker_id] = *sorted_stickers[v].begin();
		while (true) {
			auto [u, w, edge_id] = edges[v].back();
			if (disabled_edges[edge_id]) {
				edges[v].pop_back();
				continue;
			}
			break;
		}
		auto [u, w, edge_id] = edges[v].back();
		disabled_edges[edge_id] = true;
		auto it = sorted_stickers[u].lower_bound({w - x, 0});
		if (it == sorted_stickers[u].end()) {
			cout << "No\n";
			return 0;
		}
		auto [y, sticker_id2] = *it;
		sorted_stickers[u].erase(it);
		degrees[u]--;
		if (degrees[u] == 1) leaves.push(u);
		clue_id[sticker_id] = edge_id;
		clue_id[sticker_id2] = edge_id;
	}
	new_edges.resize(n-1);
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < stickers[i].size(); j++) {
			new_edges[clue_id[stickers[i][j]]].push_back(clue_id[stickers[i][j-1]]);
		}
	}
	used.resize(n, false);
	for (int i = 0; i < n-1; i++) {
		if (used[i]) continue;
		dfs(i);
	}
	reverse(topsort.begin(), topsort.end());
	cout << "Yes\n";
	for (int i: topsort) {
		cout << i + 1 << " ";
	}
}