// In the name of Allah

#include <bits/stdc++.h>
using namespace std;

typedef		long long			ll;
typedef		long double			ld;
typedef		pair<int, int>		pii;
typedef		pair<ll, ll>		pll;

#define		endl				'\n'
#define		sep					' '
#define		all(x)				(x).begin(),(x).end()
#define		len(x)				((ll) (x).size())
#define		F					first
#define		S					second
#define		Mp					make_pair
#define		pb					push_back

const int maxn = 1e6 + 7;
const int oo = 1e9 + 7;

struct MaxFlow {
	struct Edge {
		int fr, to, cp, fl;
	};

	int n, src, snk;
	int D = 1, flow = 0;
	vector<Edge> E;
	vector<int> adj[maxn];
	int dis[maxn], cnt[maxn];
	queue<int> qu;

	void init(int sz, int v1, int v2) {
		n = sz; src = v1; snk = v2;
		for (int i = 0; i < n; i++) adj[i].clear();
		E.clear();
	}

	void addEdge(int u, int v, int w) {
		adj[u].pb(len(E)); E.pb({u, v, w, 0});
		adj[v].pb(len(E)); E.pb({v, u, 0, 0});
	}

	bool bfs() {
		fill(dis, dis + n, oo); fill(cnt, cnt + n, 0);
		dis[src] = 0; qu.push(src);
		while (!qu.empty()) {
			int v = qu.front(); qu.pop();
			for (int j : adj[v]) {
				int u = E[j].to, cp = E[j].cp, fl = E[j].fl, rm = cp - fl;
				if (rm < D) continue;
				if (dis[v] + 1 < dis[u]) {
					dis[u] = dis[v] + 1;
					qu.push(u);
				}
			}
		}
		return (dis[snk] < oo);
	}

	int dfs(int v, int f) {
		if (f < D) f = 0;
		if (v == snk || f == 0) return f;

		int res = 0;
		for (; cnt[v] < len(adj[v]); cnt[v]++) {
			int j = adj[v][cnt[v]];
			int u = E[j].to, cp = E[j].cp, fl = E[j].fl, rm = cp - fl;
			if (dis[v] + 1 != dis[u]) continue;

			int x = dfs(u, min(f, rm));
			res += x; f -= x;
			E[j].fl += x; E[j ^ 1].fl -= x;
			if (f == 0) break;
		}
		return res;
	}

	void dinic() {
		D = 1; flow = 0;
		while (D > 0) {
			while (bfs()) flow += dfs(src, oo);
			D /= 2;
		}
	}
};

int n;
vector<int> adj[maxn];
vector<pair<pii, int>> E; map<pii, int> Ex;
vector<pii> ls[maxn]; int ind[maxn];
int h[maxn], M[maxn], Ax[maxn], Mx[maxn];
MaxFlow A; vector<int> ans;

int GI(int i, int j) {
	return ind[i] + ls[i][j].S;
}

void pre_dfs(int v, int p = -1) {
	for (int j = 0; j < len(ls[v]); j++) {
		M[GI(v, j)] = (h[v] & 1);
	}

	for (int u : adj[v]) {
		if (u == p) continue;
		h[u] = h[v] + 1;
		pre_dfs(u, v);
	}
}

void res_dfs(int v, int p = -1) {
	for (int j = 0; j < len(ls[v]); j++) {
		int vx = GI(v, j), ux = Mx[vx];
		int u = upper_bound(ind, ind + n, ux) - ind - 1;
		if (u == p) ans.pb(Ex[Mp(u, v)]);
		else res_dfs(u, v);
	}
}

bool cmp(pii i, pii j) {
	return (i.S > j.S);
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int g;
	cin >> n >> g;

	for (int i = 0; i < n - 1; i++) {
		int u, v, w;
		cin >> u >> v >> w; u--; v--;
		adj[u].pb(v); adj[v].pb(u);
		E.pb(Mp(Mp(u, v), w)); Ex[Mp(u, v)] = i; Ex[Mp(v, u)] = i;
	}

	for (int i = 0; i < n; i++) {
		ls[i].resize(len(adj[i]));
		for (int j = 0; j < len(adj[i]); j++) {
			cin >> ls[i][j].F; ls[i][j].S = j;
		}
		sort(all(ls[i]));
	}
	for (int i = 1; i < n; i++) {
		ind[i] = ind[i - 1] + len(ls[i - 1]);
	}

	pre_dfs(0);

	for (int i = 0; i < len(E); i++) {
		if (h[E[i].F.F] & 1) swap(E[i].F.F, E[i].F.S);
	}
	
	int sz = 2 * n - 2;
	A.init(maxn, maxn - 2, maxn - 1);
	for (int i = 0; i < sz; i++) {
		if (!M[i]) A.addEdge(A.src, i, 1);
		else A.addEdge(i, A.snk, 1);
	}

	for (auto f : E) {
		int u = f.F.F, v = f.F.S, w = f.S;
		int j2 = len(ls[v]); int vx = -1;
		for (int j1 = 0; j1 < len(ls[u]); j1++) {
			while (j2 - 1 >= 0 && ls[u][j1].F + ls[v][j2 - 1].F >= w) {
				j2--; int ux = sz++;
				if (vx != -1) A.addEdge(ux, vx, 1);
				A.addEdge(ux, GI(v, j2), 1);
				vx = ux;
			}
			if (vx != -1) A.addEdge(GI(u, j1), vx, 1);
		}
	}

	A.dinic();

	if (A.flow != n - 1) {
		cout << "No" << endl;
		return 0;
	}

	for (int i = 0; i < n; i++) sort(all(ls[i]), cmp);
	for (int j = 0; j < len(A.E); j += 2) {
		int u = A.E[j].fr, v = A.E[j].to, fl = A.E[j].fl;
		if (fl != 1) continue;
		if (u != A.src && v != A.snk) Ax[u] = v;
	}

	for (int i = 0; i < 2 * n - 2; i++) {
		if (!M[i]) {
			int j = Ax[Ax[i]];
			Mx[i] = j; Mx[j] = i;
		}
	}

	res_dfs(0);
	
	cout << "Yes" << endl;
	for (int i : ans) cout << i + 1 << sep;
	cout << endl;

	return 0;
}