#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <map>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7, LOG = 50;

void solve() {
	ll n, k, t;
	cin >> n >> k >> t;
	vector<ll> a(n);
	set<ll> st;
	for (ll& elem : a) {
		cin >> elem;
		st.insert(elem);
	}

	if (ll(st.size()) <= t) {
		cout << 1;
		return;
	}

	vector<ll> b;
	for (ll i = 0; i < n; i++) {
		if (i == 0 || a[i] != a[i - 1]) {
			b.push_back(a[i]);
		}
	}
	ll m = b.size();
	map<ll, ll> mp;
	ll l = 0;

	ll cnt = 0;
	ll ans = 0;
	ll i1 = 0;
	for (ll i = 0; i < m; i++) {
		if (mp[b[i]] == 0) {
			cnt++;
		}
		mp[b[i]]++;
		
		if (cnt > t) {
			ans++;
			mp.clear();
			i--;
			cnt = 0;
		}
	}

	vector<ll> c = b;
	if (b[0] == b.back()) {
		c.erase(c.begin());
	}
	ll sz = c.size();
	ll ind;
	if (cnt > 0) {
		for (ll i = 0; i < sz; i++) {
			if (mp[c[i]] == 0) {
				cnt++;
			}
			mp[b[i]]++;

			if (cnt > t) {
				ans++;
				mp.clear();
				ind = i;
				i--;
				break;
			}
		}
	}

	vector<vector<int>> up(sz, vector<int>(LOG, -1));
	vector<vector<ll>> sum(sz, vector<ll>(LOG, 0));
	

	mp.clear();
	cnt = 0;
	ll r = 0;
	for (ll i = 0; i < sz; i++) {
		while (cnt < t || mp[c[r]] != 0) {
			if (mp[c[r]] == 0) {
				cnt++;
			}
			mp[c[r]]++;
			r++;
			r %= sz;
		}
		mp[c[i]]--;
		if (mp[c[i]] == 0) {
			cnt--;
		}
		up[i][0] = r;
		sum[i][0] = (r < i);
	}
	for (ll j = 1; j < LOG; j++) {
		for (ll i = 0; i < sz; i++) {
			up[i][j] = up[up[i][j - 1]][j - 1];
			sum[i][j] = sum[i][j - 1] + sum[up[i][j - 1]][j - 1];
		}
	}

	// ind - начало
	ll need = k - 1;
	for (ll i = LOG - 1; i >= 0; i--) {
		if (sum[ind][i] < need) {
			need -= sum[ind][i];
			ans += (1ll << i);
			ind = up[ind][i];
		}
	}
	cout << ans + (k > 1);
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/