#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

void solve() {
	int n, k, t;
	cin >> n >> k >> t;

	vector<int> a(n);
	set<int> unique;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		unique.insert(a[i]);
	}

	if (t >= unique.size()) {
		cout << 1;
		return;
	}

	if (t == 1) {
		ll cnt = 1;
		for (int i = 1; i < n; i++) {
			if (a[i] != a[i - 1])
				cnt++;
		}

		ll res = 0;
		if (a[0] == a[n - 1])
			res = k * (cnt - 1) + 1;
		else
			res = k * cnt;

		cout << res;
		return;
	}

	ll cnt = 0;
	unique.clear();
	for (ll i = 0; true; i++) {
		unique.insert(a[i % n]);
		if (unique.size() > t) {
			cnt++;
			unique.clear();
			unique.insert(a[i % n]);
		}
		if ((i + 1) % n == 0 && (i + 1) / n == k)
			break;
	}

	if (unique.size())
		cnt++;
	cout << cnt;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}