#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;
namespace Test {
    random_device dev;
    uint32_t seed = dev();
    mt19937 rng(seed);

    int randint(int a, int b) {
        return uniform_int_distribution(a, b)(rng);
    }

    int sol1(int n, int k, int t, vector<int> ts) {
        vector<int> temp = ts;
        sort(temp.begin(), temp.end());
        for (auto &ty: ts) ty = distance(temp.begin(), lower_bound(temp.begin(), temp.end(), ty));
        vector<bool> difs_vec(n, false);
        for (auto ty: ts) difs_vec[ty] = true;
        int difs_cnt = count(difs_vec.begin(), difs_vec.end(), true);
        if (difs_cnt <= t) {
            return 1;
        }
        vector<int> add_pos(n, -1);
        vector<int> cur_used(n, 0);
        int timer = 1;
        int cur_pos = 0, cur_box = 0;
        int res = 0;
        while (cur_box < k) {
            if (add_pos[cur_pos] != -1) {
                cur_pos += add_pos[cur_pos];
                cur_box += cur_pos / n;
                cur_pos %= n;
            } else {
                int st_pos = cur_pos;
                int new_types = 0;
                for (; new_types <= t; ++cur_pos) {
                    if (cur_used[ts[cur_pos % n]] != timer) {
                        ++new_types;
                        cur_used[ts[cur_pos % n]] = timer;
                    }
                }
                --cur_pos;
                ++timer;
                add_pos[st_pos] = cur_pos - st_pos;
                cur_box += cur_pos / n;
                cur_pos %= n;
            }
            ++res;
        }
        return res;
    }

    int sol2(int n, int k, int t, vector<int> ts) {
        vector<int> temp = ts;
        sort(temp.begin(), temp.end());
        for (auto &ty: ts) ty = distance(temp.begin(), lower_bound(temp.begin(), temp.end(), ty));
        vector<bool> difs_vec(n, false);
        for (auto ty: ts) difs_vec[ty] = true;
        int difs_cnt = count(difs_vec.begin(), difs_vec.end(), true);
        if (difs_cnt <= t) {
            return 1;
        }
        vector<int> add_pos(n, -1);
        vector<int> cur_used(n, 0);
        int timer = 1;
        int cur_pos = 0, cur_box = 0;
        int res = 0;
        bool cycle_found = false;
        while (cur_box < k) {
            if (add_pos[cur_pos] != -1) {
                cycle_found = true;
                break;
            } else {
                int st_pos = cur_pos;
                int new_types = 0;
                for (; new_types <= t; ++cur_pos) {
                    if (cur_used[ts[cur_pos % n]] != timer) {
                        ++new_types;
                        cur_used[ts[cur_pos % n]] = timer;
                    }
                }
                --cur_pos;
                ++timer;
                add_pos[st_pos] = cur_pos - st_pos;
                cur_box += cur_pos / n;
                cur_pos %= n;
            }
            ++res;
        }
        if (cycle_found) {
            int st_pos = cur_pos;
            int plus_box_cnt = 0, plus_res_cnt = 0;
            do {
                cur_pos += add_pos[cur_pos];
                plus_box_cnt += cur_pos / n;
                cur_pos %= n;
                ++plus_res_cnt;
            } while (cur_pos != st_pos);
            int cycles_cnt = (k - cur_box - 1) / plus_box_cnt;
            res += plus_res_cnt * cycles_cnt;
            cur_box += plus_box_cnt * cycles_cnt;
        }
        while (cur_box < k) {
            if (add_pos[cur_pos] != -1) {
                cur_pos += add_pos[cur_pos];
                cur_box += cur_pos / n;
                cur_pos %= n;
            } else {
                int st_pos = cur_pos;
                int new_types = 0;
                for (; new_types <= t; ++cur_pos) {
                    if (cur_used[ts[cur_pos % n]] != timer) {
                        ++new_types;
                        cur_used[ts[cur_pos % n]] = timer;
                    }
                }
                --cur_pos;
                ++timer;
                add_pos[st_pos] = cur_pos - st_pos;
                cur_box += cur_pos / n;
                cur_pos %= n;
            }
            ++res;
        }
        return res;
    }

    void gen(int &n, int &k, int &t, vector<int> &ts) {
        n = randint(1, 10);
        k = randint(1, 10);
        t = randint(1, 10);
        ts.assign(n, 0);
        for (auto &ty: ts) ty = randint(0, n - 1);
    }

    void Test() {
        int n, k, t;
        vector<int> ts;
//        int n = 4, k = 2, t = 2;
//        vector<int> ts{1, 0, 1, 2};
        while (true) {
            gen(n, k, t, ts);
            int res1 = sol1(n, k, t, ts), res2 = sol2(n, k, t, ts);
            if (res1 != res2) {
                cout << n << " " << k << " " << t << "\n";
                for (auto ty: ts) cout << ty << " ";
                cout << "\n right: " << res1 << ", my: " << res2 << "\n";
                break;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    Test::Test();
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> ts(n);
    for (auto &ty: ts) cin >> ty;
    cout << Test::sol2(n, k, t, ts);
//    vector<int> temp = ts;
//    sort(temp.begin(), temp.end());
//    for (auto &ty: ts) ty = distance(temp.begin(), lower_bound(temp.begin(), temp.end(), ty));
//    vector<bool> difs_vec(n, false);
//    for (auto ty: ts) difs_vec[ty] = true;
//    int difs_cnt = count(difs_vec.begin(), difs_vec.end(), true);
//    if (difs_cnt <= t) {
//        cout << 1;
//        return 0;
//    }
    return 0;
}
