#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << ": " << x << "\n";
#define watch_arr(arr) cout << #arr << ": "; \
for (auto x : arr) { \
    cout << x << " "; \
} \
cout << "\n";

struct SegmentTree {
    vector<int>& arr;
    vector<int> tree, push;

    SegmentTree(vector<int>& _arr) : arr(_arr) {
        tree.resize(arr.size() * 4, 0);
        push.resize(arr.size() * 4, 0);
    };

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) {
            tree[v] = arr[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2 + 1, tl, tm);
        build(v * 2 + 2, tm, tr);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    void make_push(int v) {
        if (push[v] == 0) {
            return;
        }

        tree[v * 2 + 1] += push[v];
        tree[v * 2 + 2] += push[v];
        push[v * 2 + 1] += push[v];
        push[v * 2 + 2] += push[v];
        push[v] = 0;
    }

    void add(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l) {
            return;
        }
        if (tr <= r && tl >= l) {
            ++tree[v];
            ++push[v];
            if (tr - tl > 1) {
                make_push(v);
            }
            return;
        }
        
        make_push(v);
        int tm = (tl + tr) / 2;
        add(v * 2 + 1, tl, tm, l, r);
        add(v * 2 + 2, tm, tr, l, r);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    int get(int v, int tl, int tr, int id) {
        if (tr - tl == 1) {
            return tree[v];
        }

        make_push(v);
        int tm = (tl + tr) / 2;
        if (tm > id) {
            return get(v * 2 + 1, tl, tm, id);
        } else {
            return get(v * 2 + 2, tm, tr, id);
        }
    }

    void build() {
        build(0, 0, arr.size());
    }

    void add(int l, int r) {
        add(0, 0, arr.size(), l, r);
    }

    int get(int id) {
        return get(0, 0, arr.size(), id);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> arr(n);
    forn(i, n) {
        cin >> arr[i];
    }

    unordered_map<int, int> last;
    int cur = 0;
    vector<int> cnt(n * 2, 0), to(n * 2, 0);
    SegmentTree tree(cnt);
    tree.build();

    forn(i, n * 2) {
        if (last.find(arr[i % n]) != last.end()) {
            tree.add(max(cur, last[arr[i % n]]), i + 1);
        } else {
            tree.add(cur, i + 1);
        }
        last[arr[i % n]] = i + 1;

        // cout << i << ' ' << cur << ' ' << tree.get(cur) << ' ' << t + 1 << ' ' << (cur < i + 1) << (tree.get(cur) == t + 1) << "\n";
        // watch_arr(tree.tree);
        while (cur < i + 1 && tree.get(cur) == t + 1) {
            to[cur] = i;
            ++cur;
        }
    }

    if (!to[0]) {
        cout << 1;
        return 0;
    }

    // watch_arr(to);

    vector<pair<ll, ll>> used(n);
    cur = 0;
    ll len = 0, num = 0;
    while(used[cur].first == 0 && (cur != 0 || num == 0)) {
        used[cur] = {len, num};
        len += to[cur] - cur;
        ++num;
        cur = to[cur] % n;
    }

    ll cycle_len = len - used[cur].first,
        cycle_num = num - used[cur].second;
    // watch(cycle_len);
    // watch(cycle_num);
    // watch(cur);

    if (used[cur].first >= n * k) {
        cur = 0, len = 0, num = 0;
        while(len < n * k) {
            len += to[cur] - cur;
            ++num;
            cur = to[cur] % n;
        }
        cout << num;
        return 0;
    } 

    ll nk = n * k - used[cur].first;
    ll ans = used[cur].second;
    // watch(nk);
    // watch(ans);

    ll cnt_cycle = nk / cycle_len;
    nk -= cnt_cycle * cycle_len;
    ans += cnt_cycle * cycle_num;

    len = 0, num = 0;
    while(len < nk) {
        len += to[cur] - cur;
        ++num;
        cur = to[cur] % n;
    }

    cout << ans + num;

    // exit(0);
    return 0;
}