#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

int64_t readA(vector<int64_t>& a, int64_t n) {
    vector<int64_t> b(n);
    for (int64_t i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b.begin(), b.end());
    vector<int64_t> c = {b[0]};
    for (int64_t i = 1; i < n; ++i) {
        if (b[i] > c.back()) {
            c.push_back(b[i]);
        }
    }
    for (int64_t i = 0; i < n; ++i) {
        int64_t L = 0, R = (int64_t)c.size();
        while (R-L > 1) {
            int64_t M = (R+L)/2;
            if (c[M] <= a[i]) {
                L = M;
            } else {
                R = M;
            }
        }
        a[i] = L;
    }
    return (int64_t)c.size();
}

void calkJump(vector<int64_t>& jump, vector<int64_t>& a, int64_t n, int64_t t, int64_t cnt) {
    vector<int64_t> count(cnt, 0);
    int64_t num = 0;

    vector<int64_t> r = a;
    for (auto i : a) {
        r.push_back(i);
    }
    int64_t i = 0;
    for (int64_t j = 0; (j < 2*n) && (i<n); ++j) {
        ++count[r[j]];
        if (count[r[j]] == 1) {
            ++num;
            if (num > t) {
                while ((num > t) && (i<n)) {
                    jump[i] = j-i;
                    --count[r[i]];
                    if (count[r[i]] == 0) {
                        --num;
                    }
                    ++i;
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n, k, t;
    cin >> n >> k >> t;

    vector<int64_t> a(n);
    int64_t cnt = readA(a, n);
    if (cnt <= t) {
        cout << "1\n";
        return 0;
    }

    vector<int64_t> jump(n, 0);
    calkJump(jump, a, n, t, cnt);

    int64_t ans = 0;
    int64_t id = 0;
    vector<int64_t> num(n, -1);
    vector<int64_t> mov(n, -1);
    num[0] = 0;
    mov[0] = 0;
    int64_t m = 0;
    while (k > 0) {
        ++ans;
        m += jump[id];
        id += jump[id];
        if (id >= n) {
            id -= n;
            --k;
        }
        if (num[id] != -1) {
            break;
        }
        num[id] = ans;
        mov[id] = m;
    }
    if (k == 0) {
        cout << ans << '\n';
        return 0;
    }

    int64_t jmp = (m-mov[id])/n;
    ans += (ans-num[id])*((k-1)/jmp);
    k -= ((k-1)/jmp)*jmp;

    while (k > 0) {
        ++ans;
        id += jump[id];
        if (id >= n) {
            id -= n;
            --k;
        }
    }
    cout << ans << '\n';

    return 0;
}
