#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

const int MAXN = 3e5 + 1, LG = 20;
ll go_next[LG][MAXN], cost[LG][MAXN];

void add(int x, map<int, int>  &a) {
    a[x]++;
}

void erase(int x, map<int, int> &a) {
    a[x]--;
    if (a[x] == 0) {
        a.erase(x);
    }
}

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    cin >> a;
    vector<ll> b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    ll cnt = sz(b);
    if (t >= cnt) {
        return void(cout << 1);
    }
    a.resize(unique(a.begin(), a.end()) - a.begin());
    n = sz(a);
    for (int i = 0; i < n; ++i) {
        a.push_back(a[i]);
    }
    vector<ll> go(n);
    map<int, int> st;
//    for (int j = 0; j < n; ++j) {
//        add(a[j], st);
//        if (sz(st) > t) {
//            go[0] = j;
//            erase(a[j], st);
//            break;
//        }
//    }
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            erase(a[i - 1], st);
            go[i] = go[i - 1];
        }
        while (go[i] < n * 2) {
            add(a[go[i]], st);
            if (sz(st) > t) {
                erase(a[go[i]], st);
                break;
            }
            go[i]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        go[i] %= n;
    }
    //vector<ll> go_next(n), cnt_next(n);
    for (int i = n - 1; i >= 0; --i) {
        if (go[i] < i) {
            go_next[0][i] = go[i];
            cost[0][i] = 1;
        } else {
            go_next[0][i] = go_next[0][go[i]];
            cost[0][i] = cost[0][go[i]] + 1;
        }
    }
    for (int i = 1; i < LG; ++i) {
        for (int j = 0; j < n; ++j) {
            go_next[i][j] = go_next[i - 1][go_next[i - 1][j]];
            cost[i][j] = cost[i - 1][j] + cost[i - 1][go_next[i - 1][j]];
        }
    }
    ll ans = 0, now = 0;
    for (int i = LG - 1; i >= 0; --i) {
        if (k & (1ll << i)) {
            ans += cost[i][now];
            now = go_next[i][now];
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
