#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9, MAXN = (1ll << 15), mod = 1e9 + 7, P = 1073;
mt19937 rnd(1337);

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) ans *= n;
        ans %= mod;
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

struct MST{
    vector<int> tree[MAXN * 2];
    MST() {}
    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v].push_back(a[l]);
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        int u1 = 0, u2 = 0;
        int sz1 = tree[2 * v].size(), sz2 = tree[2 * v + 1].size();
        while (u1 < sz1 && u2 < sz2) {
            if (tree[2 * v][u1] < tree[2 * v + 1][u2]) {
                tree[v].push_back(tree[2 * v][u1]);
                u1++;
            } else {
                tree[v].push_back(tree[2 * v + 1][u2]);
                u2++;
            }
        }
        while (u1 < sz1) {
            tree[v].push_back(tree[2 * v][u1]);
            u1++;
        }
        while (u2 < sz2) {
            tree[v].push_back(tree[2 * v + 1][u2]);
            u2++;
        }
    }
    int get(int v, int lv, int rv, int l, int r, int x) {
//        cout << v << ' ' << lv << ' ' << rv << '\n';
        if (l >= rv || r <= lv) return 0;
        if (lv >= l && rv <= r) {
            int left = -1, right = tree[v].size();
            while (left + 1 < right) {
                int m = (left + right) / 2;
                if (tree[v][m] < x) left = m;
                else right = m;
            }
            return left + 1;
        }
        int mv = (lv + rv) / 2;
        return get(2 * v, lv, mv, l, r, x) + get(2 * v + 1, mv, rv, l, r, x);
    }
};

void solve() {
//    cout << "KOK" << '\n';
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> diff;
    for (auto &el : a) {
        cin >> el;
        diff.insert(el);
    }
//    if (diff.size() <= t) {
//        cout << 1;
//        return;
//    }
    for (int i = 0; i < n; i++) a.push_back(a[i]);
    map<int, int> lst;
    vector<int> b(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        lst[a[i]]++;
        lst[a[i]]--;
        b[i] = lst[a[i]];
        lst[a[i]] = i + 1;
    }
    MST tree;
    tree.build(1, 0, 2 * n, b);
    vector<int> len(n);
    for (int i = 0; i < n; i++) {
        int l = i + 1, r = i + n + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (tree.get(1, 0, 2 * n, i, m, i + 1) <= t) l = m;
            else r = m;
        }
        len[i] = l - i;
    }
    int ans = 0;
    int pos = 0;
    vector<int> last(n, -1);
    vector<int> it(n, -1);
    int hod = 0;
    while (pos < n * k) {
        if (last[pos % n] != -1) {
            ans += (ans + 1 - it[pos % n]) * ((n * k - pos) / (pos - last[pos % n]));
            pos += (n * k - pos) / (pos - last[pos % n]) * (pos - last[pos % n]);
        }
        if (pos < n * k) {
            it[pos % n] = ans + 1;
            last[pos % n] = pos;
            ans++;
            pos += len[pos % n];
        }
    }
    cout << ans;
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    int test = 1;
    //cin >> test;
    while (test--) solve();
}
