#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 2e9;
const ll MAXN = 1e5 + 5;

ll n, k, t;
vector<ll> a;
vector<ll> d;
void solve() {
    vector<ll> pref(n + 1);
    set<ll> tmp;
    for (ll i = 0; i < n; ++i) {
        tmp.insert(a[i]);
    }

    if ((ll)tmp.size() <= t) {
        cout << 1 << '\n';
        return;
    }

    vector<ll> nxt(n, n);
    ll cnt = 0;
    vector<ll> cntval(n, 0);
    for (ll l = 0, r = -1; l < n; ++l) {
        while (cnt <= t && r < n) {
            ++r;
            if (r < n && cntval[a[r]]++ == 0) {
                ++cnt;
            }
        }
        nxt[l] = r;

        if (--cntval[a[l]] == 0) {
            --cnt;
        }
    }

    vector<pair<ll, ll>> start(n + 1, {n, 0});
    for (ll i = n - 1; i >= 0; --i) {
        if (nxt[i] < n) {
            start[i] = start[nxt[i]];
            ++start[i].second;
        } else {
            start[i] = {i, 0};
        }
    }

    vector<ll> jump(n);
    cntval.assign(n, 0);
    cnt = (ll)tmp.size();
    for (ll i = 0; i < n; ++i) {
        ++cntval[a[i]];
    }

    for (ll l = n - 1, r = n - 1; l >= 0; --l) {
        if (cntval[a[l]]++ == 0) {
            ++cnt;
        }

        while (cnt > t && r >= 0) {
            if (--cntval[a[r]] == 0) {
                --cnt;
            }

            --r;
        }

        jump[l] = r;
    }

    for (ll i = 0; i < n; ++i) {
        cerr << jump[i] << ' ';
    }
    cerr << '\n';

    ll ans = 0;
    ll now = 0;
    for (ll i = 0; i < k; ++i) {
        ans += start[now].second;
        now = start[now].first;

        ++ans;
        now = jump[now] + 1;
    }

    cout << ans << '\n';
}

void start() {
    cin >> n >> k >> t;
    a.assign(n, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    d = a;
    sort(d.begin(), d.end());
    d.resize(unique(d.begin(), d.end()) - d.begin());
    for (ll i = 0; i < n; ++i) {
        a[i] = lower_bound(d.begin(), d.end(), a[i]) - d.begin();
    }

    solve();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

// R.I.P. Alexei Navalny
// 1976-2024

    while (T --> 0) {
        start();
    }

    return 0;
}
