#include <bits/stdc++.h>

using namespace std;

struct segtree{
    int sz;
    vector<int> t;

    void init(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        t.assign(2 * sz - 1, 0);
    }

    void set(int i, int v, int l, int r, int x) {
        if (r - l == 1) {
            t[x] = v;
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            set(i, v, l, m, 2 * x + 1);
        } else {
            set(i, v, m, r, 2 * x + 2);
        }
        t[x] = t[2 * x + 1] + t[2 * x + 2];
    }

    void set(int i, int v) {
        set(i, v, 0, sz, 0);
    }

    int sum(int ql, int qr, int l, int r, int x) {
        if (ql <= l && r <= qr) {
            return t[x];
        }
        if (ql >= r || l >= qr) {
            return 0;
        }
        int m = (l + r) / 2;
        return sum(ql, qr, l, m, 2 * x + 1) + sum(ql, qr, m, r, 2 * x + 2);
    }

    int sum(int l, int r) {
        return sum(l, r, 0, sz, 0);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    map<int, int> mp;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (mp.find(a[i]) == mp.end()) {
            ++cnt;
            mp[a[i]] = 1;
        }
    }
    if (cnt <= t) {
        cout << 1 << "\n";
        return 0;
    }
    map<int, int> prev;
    segtree sg;
    sg.init(2 * n);
    for (int i = 0; i < n; ++i) {
        a.push_back(a[i]);
    }
    queue<int> inds;
    vector<int> res(n);
    for (int i = 0; i < 2 * n; ++i) {
        if (prev.find(a[i]) == prev.end()) {
            sg.set(i, 1);
            prev[a[i]] = i;
        } else {
            sg.set(prev[a[i]], 0);
            sg.set(i, 1);
            prev[a[i]] = i;
        }
        while (!inds.empty()) {
            int cur = inds.front();
            if (sg.sum(cur, i + 1) > t) {
                res[cur] = i % n;
                inds.pop();
            } else {
                break;
            }
        }
        if (i < n) {
            inds.push(i);
        }
    }
    vector<int> was(n);
    int cur = 0, sm = 0, kol = 0;
    vector<int> c(n), cn(n);
    while (true) {
        if (res[cur] <= cur) ++sm;
        ++kol;
        if (sm >= k) {
            cout << kol << "\n";
            return 0;
        }
        was[cur] = 1;
        cur = res[cur];
        if (was[cur]) break;
        c[cur] = sm;
        cn[cur] = kol;
    }
    int rs = 0;
    k -= c[cur];
    rs += cn[cur];
//    cout << rs << "\n";
    int len = kol - cn[cur], wt = sm - c[cur];
//    cout << len << " " << wt << "\n";
    rs += (k / wt) * len;
    k %= wt;
    while (k > 0) {
        ++rs;
        if (cur >= res[cur]) --k;
        if (k <= 0) break;
        cur = res[cur];
    }
    cout << rs << "\n";
}
