#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define fi first
#define se second

int n, k, T;
const int N = 6e5 + 12;
int a[N], nxt[N];

struct par_bin {
    int l, r, mid, id;
    bool operator <(const par_bin &a) {
        return mid < a.mid;
    }
} q[N];

struct Fenwick {
    vector <int> t;
    int n;
    void resiz(int _n) {
        n = _n;
        t.resize(_n + 1, 0);
    }
    void upd(int id, int x) {
//        cerr << id << ' ' << x << endl;
        for(int i = id; i <= n; i += (i & -i)) {
            t[i] += x;
        }
        return;
    }
    int get(int pos) {
        int ans = 0;
        for(int i = pos; i >= 1; i -= (i & -i)) {
            ans += t[i];
        }
        return ans;
    }
    int get(int l, int r) {
//        cerr << l << ' ' << r << endl;
        int ans = get(r);
        if(l - 1 >= 0)
            ans -= get(l - 1);
        return ans;
    }
};

void szhat() {
    vector <int> v;
    v.push_back(0);
    for(int i = 0; i < n; ++i) {
        v.push_back(a[i]);
    }
    sort(v.begin(), v.end());
    v.erase(unique(v.begin(), v.end()), v.end());
    for(int i = 0; i < 2 * n; ++i) {
        a[i] = lower_bound(v.begin(), v.end(), a[i]) - v.begin();
    }
//    for(int i = 0; i < 2 * n; ++i) {
//        cout << a[i] << ' ';
//    }
//    cout << '\n';
    return;
}

int POS[N];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    fill(POS, POS + N, -1);
    cin >> n >> k >> T;
    set <int> ST;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        ST.insert(a[i]);
        a[i+n] = a[i];
    }
    szhat();
    Fenwick t;
    t.resiz(2 * n);
    if(ST.size() <= T) {
        cout << 1;
        return 0;
    }
    for(int i = 0; i < n; ++i) {
        q[i].l = i, q[i].r = 2 * n;
        q[i].id = i;
    }
    for(int it = 0; it < 20; ++it) {
        for(int i = 0; i < n; ++i) {
            q[i].mid = (q[i].l + q[i].r) / 2;
        }
        sort(q, q + n);
        int uk = 0;
        for(int i = 0; i < n; ++i) {
            while(uk <= q[i].mid) {
                int x = a[uk];
                if(POS[x] != -1) {
                    int was = POS[x];
                    t.upd(was + 1, -1);
                }
                t.upd(uk + 1, 1);
                POS[x] = uk;
                uk++;
            }
            int cnt = t.get(q[i].id + 1, q[i].mid + 1);
            if(cnt <= T) {
                q[i].l = q[i].mid;
            } else {
                q[i].r = q[i].mid;
            }
        }
        for(int i = 1; i <= n; ++i) {
            if(POS[i] != -1) {
                t.upd(POS[i] + 1, -1);
                POS[i] = -1;
            }
        }
    }
    for(int i = 0; i < n; ++i) {
        nxt[q[i].id] = q[i].l + 1;
    }
    for(int i = 0; i < n; ++i) {
        nxt[i] %= n;
//        cout << nxt[i] << '\n';
    }
    int pos = 0;
    map <int,bool> was;
    int C;
    while(true) {
//        cout << "!" << pos << '\n';
        if(was[pos] == 1) {
            C = pos;
            break;
        }
        was[pos] = 1;
        pos = nxt[pos];
    }
    int cans = 0, ccur = 0, cpos = C;
    while(true) {
        int will = nxt[cpos];
        cans++;
        if(will < cpos)
            ccur++;
        cpos = will;
        if(cpos == C)
            break;
    }
    int l = -1, r = 1e9;
    while(l + 1 < r) {
        int mid = (l + r) >> 1;
        int cur = 1 + mid * ccur;
        bool f = 0;
        pos = C;
        fill(POS, POS + n, 0);
        while(true) {
            if(POS[pos] == 1)
                break;
            POS[pos] = 1;
            int will = nxt[pos];
            if(will < pos && cur + 1 > k) {
                f = 1;
                break;
            }
            if(will < pos)
                cur++;
            pos = will;
        }
        if(f) {
            r = mid;
        } else {
            l = mid;
        }
    }
    r = max(r - 1, 0LL);
    int ans = cans * r;
    pos = 0;
    while(true) {
//        cout << pos << '\n';
        if(pos == C)
            break;
        ans++;
        if(k == 1 && nxt[pos] < pos) {
            cout << ans;
            return 0;
        }
        if(nxt[pos] < pos)
            k--;
        pos = nxt[pos];
    }
//    cout << '\n';
    int cur = 1 + r * ccur;
    pos = C;
    was.clear();
    while(true) {
//        cout << pos << '\n';
        ans++;
        int will = nxt[pos];
        if(will < pos && cur + 1 > k)
            break;
        if(will < pos)
            cur++;
        pos = will;
    }
    cout << ans;
    return 0;
}
