#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

ll dfs(int u, ll depth, ll n, ll k, ll nw, vector<int>& used, vector<int>& TO, vector<ll> &ws, vector<ll> &depw) {
	if (nw >= k * n) {
		return depth;
	}
	if (used[u] == 1) {
		ll cyc = nw - ws[u];
		ll ost = n * k - nw;
		ll fulc = ost / cyc;
		for (int i = 0; i < n; ++i) {
			used[u] = 0;
		}
		return dfs(u, depth + (depth - depw[u]) * fulc, n, k, nw + fulc * cyc, used, TO, ws, depw);
	}
	used[u] = 1;
	depw[u] = depth;
	ws[u] = nw;
	ll ta = TO[u] - u;
	if (ta < 0) {
		ta += n;
	}
	return dfs(TO[u], depth + 1, n, k, nw + ta, used, TO, ws, depw);
}

void solve() {
	int n; ll k, t; cin >> n >> k >> t;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	int cntnw = 0;
	map<int, int> gist;
	for (int i = 0; i < n; ++i) {
		++gist[a[i]];
		if (gist[a[i]] == 1) {
			++cntnw;
		}
	}
	if (cntnw <= t) {
		cout << "1\n";
		return;
	}
	int r = n - 1;
	vector<int> TO(n);
	for (int i = n - 1; i >= 0; --i) {
		++gist[a[i]];
		if (gist[a[i]] == 1) {
			++cntnw;
		}
		while (cntnw > t) {
			--gist[a[r]];
			if (gist[a[r]] == 0) {
				--cntnw;
			}
			r = (r + n - 1) % n;
		}
		TO[i] = (r + 1) % n;
	}
	vector<ll> ws(n, 0);
	vector<ll> depw(n, 0);
	vector<int> used(n, 0);
	cout << dfs(0, 0, n, k, 0, used, TO, ws, depw) << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}