#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3")

struct Node
{
    int val;
};

struct SegmentTree
{
    int n;
    std::vector<Node> t;

    SegmentTree(std::vector<int> &a)
    {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    Node mer(Node a, Node b)
    {
        return {a.val + b.val};
    }

    void build(int i, int l, int r, std::vector<int> &a)
    {
        if (l == r - 1)
        {
            t[i].val = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * i + 1, l, mid, a);
        build(2 * i + 2, mid, r, a);
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    void upd(int i, int l, int r, int pos, int v)
    {
        if (l == r - 1)
        {
            t[i].val = v;
            return;
        }
        int mid = (l + r) / 2;
        if (mid > pos)
        {
            upd(2 * i + 1, l, mid, pos, v);
        }
        else
        {
            upd(2 * i + 2, mid, r, pos, v);
        }
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    Node query(int i, int l, int r, int ql, int qr)
    {
        if (l >= ql && r <= qr)
        {
            return t[i];
        }
        if (r <= ql || l >= qr)
        {
            return {0};
        }
        int mid = (l + r) / 2;
        return mer(query(2 * i + 1, l, mid, ql, qr), query(2 * i + 2, mid, r, ql, qr));
    }
};

std::mt19937_64 rnd(2683248);

int32_t main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, k, t;
    std::cin >> n >> k >> t;

    std::vector<int> a;
    int prev=-1;
    for (int i = 0; i < n; i++)
    {
        int x;
        std::cin>>x;

        if(x!=prev){
            a.push_back(x);
        }
        prev=x;
    }
    std::vector<int> b;
    for(int i=0;i<a.size();i++){
        b.push_back(a[i]);
    }
    for(int i=0;i<a.size();i++){
        b.push_back(a[i]);
    }
    if (t >= n)
    {
        std::cout << 1;
        return 0;
    }
    int count_type=0;
    std::set<int> tmp2;
    for(int j=0;j<a.size();j++){

        tmp2.insert(b[j]);
    }
    if(tmp2.size()<=t){
        std::cout<<1;
        return 0;
    }

    std::vector<std::pair<int,int>> dp(n);
    for(int i=a.size()-1;i>=0;i--){
        std::set<int> tmp1;
        int last=i;
        for(int j=i;tmp1.size()<=t && j<2*a.size();j++){
            tmp1.insert(b[j]);
            last=j;
        }
      //  std::cout<<last<<' '<<i<<std::endl;
        if(last>=a.size()){
            dp[i]={1,last-a.size()};
        }else{
            dp[i]={dp[last].first+1,dp[last].second};
        }
        //td::cout<<dp[i]<<' ';
    }
   // std::cout<<std::endl;

    int i=0;
    int count_sloy=0;
    int ans=0;
    while(count_sloy<k){
        std::pair<int,int> tmp=dp[i];
        count_sloy++;
        ans+=tmp.first;
       // std::cout<<count_sloy<<' '<<ans<<' '<<i<<' '<<tmp.second<<std::endl;
        i=tmp.second;
    }
    std::cout<<ans;
}
