#include "bits/stdc++.h"
using namespace std;
#define int long long

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    
    vector<int> a(2 * n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i + n] = a[i];
    }

    if (t >= n) {
        cout << 1 << "\n";
        return;
    }

    vector<vector<int>> diffs(2 * n, vector<int> (2 * n, 0));
    for (int i = 0; i < 2 * n; i++) {
        unordered_set<int> s;
        for (int j = i; j < 2 * n; j++) {
            diffs[i][j] = s.size();
            s.insert(a[j]);
        }
    }

    auto get = [&](int l, int r) -> int {
        if (r - l >= n) {
            return diffs[0][n];
        } else {
            return diffs[l % (2 * n)][r % (2 * n)];
        }
    };

    auto give = [&](int pos) -> int {
        int l = 0, r = n * k - pos;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get(pos, pos + m) <= t) {
                l = m;
            } else {
                r = m;
            }
        }

        if (get(pos, pos + r) <= t) {
            return r;
        } else {
            return l;
        }
    };

    auto check = [&](int m) -> bool {
        int pos = 0;
        for (int i = 0; i < m; i++) {
            pos += give(pos);
        }
        return pos == n * k;
    };

    int l = 0, r = n * k;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }

    if (check(l)) {
        cout << l << "\n";
    } else {
        cout << r << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}