#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;

#define int ll

vector<int> to;
vector<int> cycle;
vector<int> used;
vector<int> euler;
vector<int> depth;
vector<int> depth1;

void dfs(int v, int n) {
    used[v] = 1;
    euler.push_back(v);
    if (used[to[v]] == 1) {
        while (euler.back() != to[v]) {
            cycle.push_back(euler.back());
            euler.pop_back();
        }
        cycle.push_back(to[v]);
        reverse(cycle.begin(), cycle.end());
    } else {
        depth[to[v]] = depth[v] + (to[v] - v + n) % n;
        depth1[to[v]] = depth1[v] + 1;
        dfs(to[v], n);
    }
    if (!euler.empty()) euler.pop_back();
    used[v] = 2;
}

vector<int> mark;


void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    set<int> st;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        st.insert(v[i]);
    }
    if (st.size() <= t) cout << 1;
    else {
        to.resize(n);
        used.resize(n);
        depth.resize(n);
        depth1.resize(n);
        map<int, int> mp;
        int curr = 0;
        for (int i = 0; i < n; ++i) {
            while (mp.size() <= t) {
                mp[v[curr % n]]++;
                curr++;
            }
            to[i] = (curr - 1) % n;
            mp[v[i]]--;
            if (mp[v[i]] == 0) mp.erase(v[i]);
        }
        depth[0] = 0;
        depth1[0] = 0;
        dfs(0, n);
        int d = 0;
        for (int i = 0; i < cycle.size(); ++i)
            d += (cycle[(i + 1) % (int) cycle.size()] - cycle[i] + n) % n;
        int need = n * k;
        need -= depth[cycle[0]];
        int ans = (need / d) * cycle.size() + depth1[cycle[0]];
        need %= d;
        for (int i = 0; i < cycle.size(); ++i) {
            if (need <= 0) break;
            ans++;
            need -= (cycle[(i + 1) % (int) cycle.size()] - cycle[i] + n) % n;
        }
        cout << ans;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
}