#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

int n, k, t;
int tr[N << 2];

void update(int p, int x, int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        tr[v] = x;
        // cout << v << " " << vl << " " << vr << endl;
        return;
    }
    int vm = vl + vr >> 1;
    if (p < vm) update(p, x, v * 2 + 1, vl, vm);
    else update(p, x, v * 2 + 2, vm, vr);
    tr[v] = tr[v * 2 + 1] + tr[v * 2 + 2];
}

int down(int k, int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        return vl;
    }

    int vm = vl + vr >> 1;
    if (tr[v * 2 + 1] > k) return down(k, v * 2 + 1, vl, vm);
    else return down(k - tr[v * 2 + 1], v * 2 + 2, vm, vr);
}

void solve() {
    memset(tr, 0, sizeof tr);

    cin >> n >> k >> t;
    n <<= 1;

    // cout << n << endl;
    vector<int> a(n);
    for (int i = 0; i < n / 2; i++) {
        cin >> a[i]; a[i + n / 2] = a[i];
    }
    // cout << a << endl;
    map<int, vector<int>> pos;
    for (int i = 0; i < n; i++) {
        pos[a[i]].push_back(i);
    }

    for (auto& el : pos) reverse(el.second.begin(), el.second.end());

    if (pos.size() <= t) {
        cout << 1 << endl;
        return;
    }

    for (auto el : pos) {
        update(el.second.back(), 1);
        // cout << el.second.back() << endl;
    }

    // cout << tr[0] << endl;

    vector<int> sts(n, 0);
    for (int i = 0; i < n / 2; i++) {
        sts[i] = down(t) - i;
        update(pos[a[i]].back(), 0);
        pos[a[i]].pop_back();
        if (pos[a[i]].size()) update(pos[a[i]].back(), 1);
    }


    n >>= 1;
    vector<int> used(n, -1);
    int cur = 0;

    int cyc = 0;
    vector<int> szs;
    int ans = 0;

    int al = n * k;
    // cout << al << endl;
    while (1) {
        if (al <= 0) break;
        if (used[cur] >= 0) {
            cyc = used[cur];
            break;
        }
        used[cur] = szs.size();
        szs.push_back(sts[cur]);

        al -= sts[cur];
        cur = (cur + sts[cur]) % n;
        ans++;
    }

    if (al > 0) {
        int cs = 0, cnt = 0;
        for (int i = cyc; i < szs.size(); i++) {
            al -= szs[i];
            ans++; cnt++;
            cs += szs[i];
            if (al <= 0) break;
        }

        if (al > 0) {
            ans += cnt * (al / cs);
            al %= cs;
        }

        if (al > 0) {
            for (int i = cyc; i < szs.size(); i++) {
                al -= szs[i];
                ans++;
                if (al <= 0) break;
            }
        }
    }

    // cout << sts << endl;
    // cout << szs << endl;

    cout << ans << endl;

}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}