#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> p;
vector<ll> sz;
vector<ll> res;

ll get(ll v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void merge(ll a, ll b) {
    ll a1 = get(a), b1 = get(b);
    if (sz[b1] > sz[a1]) swap(a1, b1);
    if (a1 != b1) {
        p[b1] = a1;
        sz[a1] += sz[b1];
        res[a1] += res[b1];
    }
}

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    ll n, k, t; cin >> n >> k >> t;
    vector<ll> a(n);
    p.resize(n);
    sz.resize(n, 1);
    res.resize(n, 0);
    for(int i = 0; i < n; i++) p[i] = i;
    set<ll> s;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    vector<ll> b;
    for(int i = 0; i < n; i++) b.push_back(a[i]);
    for(int i = 0; i < n; i++) b.push_back(a[i]);
    if (s.size() <= t) {
        cout << 1;
        return 0;
    }
    vector<pair<ll, ll>> dp(n, {-1, -1});
    ll ind = n * 2 - 1, col1 = 0;
    map<ll, ll> mapa;
    for(int i = n; i < n * 2 - 1; i++) {
        col1 += (mapa[b[i]] == 0);
        mapa[b[i]]++;
    }
    for(int i = n - 1; i >= 0; i--) {
        col1 += (mapa[b[i]] == 0);
        mapa[b[i]]++;
        if (ind == i + n) {
            mapa[b[ind]]--;
            col1 -= (mapa[b[ind]] == 0);
        }
        ind = i + n - 1;
        while(col1 > t) {
            if (ind < 0) break;
            mapa[b[ind]]--;
            col1 -= (mapa[b[ind]] == 0);
            ind--;
        }
        dp[i] = {ind - i, ind % n};
    }
//    for(int i = 0; i < n; i++) {
//        map<ll, ll> mapa;
//        ll pos = i, col = 0;
//        while(1) {
//            if (mapa.size() == t && mapa[a[pos]] == 0) break;
//            mapa[a[pos]]++;
//            pos = (pos + 1) % n;
//            col++;
//        }
//        dp[i] = {col, pos};
//    }
    vector<ll> g(n);
    vector<ll> g1(n);
    vector<ll> was1(n);
    ll pos = 0, col = 0, res1 = 0;
    while(1) {
        if (col >= n * k) break;
        if (was1[pos] == 0) {
            was1[pos] = 1;
            g[pos] = col;
            g1[pos] = res1;
        } else {
            ll o = col - g[pos], o1 = res1 - g1[pos];
            res1 += ((n * k - col) / o) * o1;
            col += ((n * k - col) / o) * o;
            was1[pos] = 1;
            g[pos] = col;
        }
        if (col >= n * k) break;
        res1++;
        col += dp[pos].first;
        pos = dp[pos].second;
    }
    cout << res1;
    return 0;
}
