#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <climits>
#define _GLIBCXX_DEBUG

using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, k, t;
vector<int> arr;

void solve2() {
    vector<int> dp;
    vector<bool> used(n, false);
    set<int> total;
    for (int i = 0; i < n; ++i) {
        total.insert(arr[i]);
    }
    if (total.size() <= t) {
        cout << 1 << endl;
        return;
    }
    for (int i = 0; i < n; ++i) {
        int mx = i;
        set<int> els;
        int t = i;
        int sz = 1;
        while (els.size() <= t) {
            int nxt = (t + 1) % n;
            els.insert(arr[nxt]);
            t = nxt;
        }
        t = (t - 1 + n) % n;
        dp[i] = t;
    }
    int cur = 0;
    int ans = 0;
    vector<pii> tr;
    int left = n * k;
    int cycle_len, cycle_size;
    while (left > 0) {
        used[cur] = true;
        int nxt = dp[cur];
        int dist = (nxt - cur + n + n) % n;
        assert((cur + dist) % n == nxt);
        if (used[nxt]) {
            // found cycle
            cycle_len = dist;
            cycle_size = 1;
            while (tr.back().first != nxt) {
                cycle_len += tr.back().second;
                cycle_size += 1;
                tr.pop_back();
            }
            break;
        } else {
            // make step
            ++ans;
            left -= dist;
            tr.push_back({cur, dist});
            cur = nxt;
        }
    }
    if (left <= 0) {
        cout << ans << endl;
        return;
    }
    int x = left / cycle_len;
    ans += x * cycle_size;
    left -= x * cycle_len;
    while (left > 0) {
        int nxt = dp[cur];
        int dist = (nxt - cur + n + n) % n;
        assert((cur + dist) % n == nxt);
        // make step
        ++ans;
        left -= dist;
        tr.push_back({cur, dist});
        cur = nxt;
    }
    cout << ans << endl;
}

void solve1() {
    vector<int> a(n * k);
    for (int j = 0; j < k; ++j) {
        for (int i = 0; i < n; ++i) {
            a[j * n + i] = arr[i];
        }
    }

    int ans = 0;
    int i = 0;
    while (i < a.size()) {
        set<int> els;
        els.insert(a[i]);
        while (i < a.size() && els.size() <= t) {
            if (i == a.size() - 1) {
                ++i;
            } else {
                els.insert(a[i + 1]);
                ++i;
            }
        }
        ++ans;
    }
    assert(ans != 0);
    cout << ans << endl;
}

signed main() {
    //   freopen("/mnt/commons/code/in.txt", "r", stdin);
    cin >> n >> k >> t;

    arr.resize(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    if (t == 1) {
        solve2();
    } else {
        solve1();
    }

    return 0;
}