#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <climits>
#include <map>
// #define _GLIBCXX_DEBUG

using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, k, t;
vector<int> arr;

struct nmset {
    map<int, int> cnt;
    void insert(int el) {
        ++cnt[el];
    }
    void erase(int el) {
        --cnt[el];
        if (cnt[el] == 0) cnt.erase(el);
    }
    int lower_bound(int k) {
        auto it = cnt.lower_bound(k);
        if (it == cnt.end()) return -1;
        return it->first;
    }
};


void solve2() {
    vector<int> dp(n);
    vector<bool> used(n, false);
    set<int> total;
    for (int i = 0; i < n; ++i) {
        total.insert(arr[i]);
    }
    if (total.size() <= t) {
        // can fit into one
        cout << 1 << endl;
        return;
    }
    nmset els;
    int target = n - 1;
    for (int i = n - 1; i >= 0; --i) {
        while (els.cnt.size() <= t) {
            int nxt = (target + 1) % n;
            els.insert(arr[target]);
            target = nxt;
        }
        while (els.cnt.size() > t) {
            els.erase(arr[target]);
            target = (target - 1 + n + n) % n;
        }
        dp[i] = target;
    }
    int cur = 0;
    int ans = 0;
    vector<pii> tr;
    int left = n * k;
    int cycle_len, cycle_size;
    while (left > 0) {
        used[cur] = true;
        int nxt = dp[cur];
        int dist = (nxt - cur + n + n) % n;
        assert((cur + dist) % n == nxt);
        if (used[nxt]) {
            // found cycle
            cycle_len = dist;
            cycle_size = 1;
            while (tr.back().first != nxt) {
                cycle_len += tr.back().second;
                cycle_size += 1;
                tr.pop_back();
            }
            cycle_len += tr.back().second;
            cycle_size += 1;
            tr.pop_back();
            break;
        } else {
            // make step
            ++ans;
            left -= dist;
            tr.push_back({cur, dist});
            cur = nxt;
        }
    }
    if (left <= 0) {
        cout << ans << endl;
        return;
    }
    int x = left / cycle_len;
    ans += x * cycle_size;
    left -= x * cycle_len;
    while (left > 0) {
        int nxt = dp[cur];
        int dist = (nxt - cur + n + n) % n;
        assert((cur + dist) % n == nxt);
        // make step
        ++ans;
        left -= dist;
        tr.push_back({cur, dist});
        cur = nxt;
    }
    cout << ans << endl;
}

void small() {

    int unique_cnt = 1;
    for (int i = 1; i < arr.size(); ++i) {
        if (arr[i] != arr[i - 1]) ++unique_cnt;
    }
    int total_cnt = unique_cnt * k;
    if (arr[0] == arr[n - 1]) {
        total_cnt -= k - 1;
    }
    cout << total_cnt << endl;
}

signed main() {
    //   freopen("/mnt/commons/code/in.txt", "r", stdin);
    cin >> n >> k >> t;

    arr.resize(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    if (t == 1) {
        small();
    } else {
    solve2();
    }


    return 0;
}