#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

#define int long long

struct node {
	int li, ri, val;
};

vector<node> t(3000000);
int maxNode = 0;
int newNode() {
	t[maxNode] = {};
	return maxNode++;
}

int maxVersion = 0;
vector<int> versionRoot(3000000);

int newVersion() {
	versionRoot[maxVersion] = newNode();
	return maxVersion++;
}


void update(int now, int left, int right, int ind, int val, int now2) {
	if (left == right) {
		t[now2].val = val;
		return;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	t[now2].li = t[now].li;
	t[now2].ri = t[now].ri;
	int mid = (left + right) / 2;
	if (ind <= mid) {
		t[now2].li = newNode();
		update(t[now].li, left, mid, ind, val, t[now2].li);
	}
	else {
		t[now2].ri = newNode();
		update(t[now].ri, mid + 1, right, ind, val, t[now2].ri);
	}
	t[now2].val = t[t[now2].li].val + t[t[now2].ri].val;
}

void startUpdate(int baseVersion, int left, int right, int ind, int val) {
	newVersion();
	update(versionRoot[baseVersion], left, right, ind, val, versionRoot[maxVersion - 1]);
}
int n, k, m;

int sum(int now, int left, int right, int k) {
	if (left == right) {
		if (k == t[now].val) return left;
		else return n * 2;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (t[t[now].li].val >= k) return sum(t[now].li, left, mid, k);
	else return sum(t[now].ri, mid + 1, right, k - t[t[now].li].val);
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k >> m;
	vector<int> l(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	vector<int> l2(n * 2);
	for (int i = 0; i < n; i++) {
		l.push_back(l[i]);
	}
	map<int, int> d;
	for (int i = n * 2 - 1; i >= 0; i--) {
	}
	newVersion();
	map<int, int> starts;
	int timer = 0;
	for (int i = n * 2 - 1; i >= 0; i--) {
		l2[d[l[i]]] = 0;
		startUpdate(timer++, 0, n * 2 - 1, d[l[i]], 0);
		l2[i] = 1;
		startUpdate(timer++, 0, n * 2 - 1, i, 1);
		d[l[i]] = i;
		starts[i] = timer;
	}
	vector<int> l3(n);
	for (int i = 0; i < n; i++) {
		int u = sum(versionRoot[starts[i]], 0, n * 2 - 1, m + 1);
		if (u == 2 * n) {
			cout << 1; // Количество уникальных меньше m
			return 0;
		}
		l3[i] = u % n;
	}
	vector<int> cycle;
	int now = 0;
	int pers = 0;
	int ans = 0;
	map<int, int> d2;
	d2[0] = 0;
	timer = 1;
	int prev = 0;
	while (timer == 1 or d2.count(now) == 0) {
		//cout << now << " ehehe\n";
		ans++;
		d2[now] = timer++;
		prev = now;
		now = l3[now];
		if (now <= prev) {
			pers++;
			k--;
			if (k == 0) {
				cout << ans;
				return 0;
			}
		}
	}
	int cycleStart = d2[now];
	int cycteSize = timer - d2[now];
	//cout << ans << " " << k << " hehe\n";
	ans += cycteSize * (k / pers);
	//cout << ans << " hehe\n";
	k %= pers;
	now = cycleStart;
	if (k > 0) {
		while (true) {
			ans++;
			prev = now;
			now = l3[now];
			if (prev >= now) {
				k--;
				if (k == 0) {
					break;
				}
			}
		}
	}
	cout << ans;
	
	




}

/*



*/
