#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;
typedef long double ld;

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 3E5, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr uint32_t MAXC = 1E9;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t RND_SEED = 7200;
mt19937_64 rnd(RND_SEED);

constexpr uint32_t MOD = 998244353, MOD_phi = MOD - 1;
struct Mod_int
{
	uint32_t val;
	Mod_int(uint32_t val = 0) : val(val% MOD) {}
	Mod_int operator+ (const Mod_int m) const
	{
		return val + m.val;
	}
	Mod_int operator+= (const Mod_int m)
	{
		return *this = *this + m;
	}
	Mod_int operator- () const
	{
		return MOD - val;
	}
	Mod_int operator- (const Mod_int m) const
	{
		return *this + -m;
	}
	Mod_int operator* (const Mod_int m) const
	{
		return uint64_t(val) * m.val;
	}
	Mod_int operator*= (const Mod_int m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			step >>= 1;
			t *= t;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int m) const
	{
		return *this * m.step(MOD_phi - 1);
	}
	Mod_int operator/= (const Mod_int m)
	{
		return *this = *this / m;
	}
};

int cnt[MAXN];

void solve()
{
	int n, k, t;
	cin >> n >> k >> t;
	unordered_map <int, int> mp;
	vector <int> mas(2 * n);
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		if (!mp.count(x))
		{
			mp[x] = mp.size();
		}
		mas[i] = mas[i + n] = mp[x];
	}
	if (mp.size() <= t)
	{
		cout << 1;
		return;
	}

	vector <int> nxt(n);
	int last = -1, cnt_raz = 0;
	for (int i = 0; i < n; i++)
	{
		while (cnt_raz <= t)
		{
			++last;
			if (cnt[mas[last]] == 0)
			{
				++cnt_raz;
			}
			++cnt[mas[last]];
		}
		nxt[i] = last % n;

		--cnt[mas[i]];
		if (cnt[mas[i]] == 0)
		{
			--cnt_raz;
		}
	}

	vector <bool> used(n);
	vector <int> cnt_ch(n), ind_cor(n);
	int cur = 0, beg_cyc, cnt_cor_cyc, cnt_ch_cyc;
	ind_cor[0] = 1;
	while (!used[nxt[cur]])
	{
		used[cur] = true;

		int nxt_ind = nxt[cur];
		cnt_ch[nxt_ind] = cnt_ch[cur] + 1;
		ind_cor[nxt_ind] = ind_cor[cur] + (nxt_ind < cur);

		cur = nxt_ind;
	}
	beg_cyc = nxt[cur];
	cnt_cor_cyc = ind_cor[cur] + (nxt[cur] < cur) - ind_cor[nxt[cur]];
	cnt_ch_cyc = cnt_ch[cur] - cnt_ch[nxt[cur]] + 1;

	if (ind_cor[beg_cyc] > k)
	{
		int cur_cor = 1, cur_ind = 0, ans = 0;
		while (cur_cor < k or (cur_cor == k and cur_ind < nxt[cur_ind]))
		{
			++ans;
			cur_cor += nxt[cur_ind] < cur_ind;
			cur_ind = nxt[cur_ind];
		}
		cout << ans + 1;
	}
	else
	{
		int64_t ans = cnt_ch[beg_cyc];
		int tot_cyc = (k - ind_cor[beg_cyc]) / cnt_cor_cyc;
		ans += int64_t(tot_cyc) * cnt_ch_cyc;
		
		int cur_cor = ind_cor[beg_cyc] + tot_cyc * cnt_cor_cyc, cur_ind = beg_cyc;
		while (cur_cor < k or (cur_cor == k and cur_ind < nxt[cur_ind]))
		{
			++ans;
			cur_cor += nxt[cur_ind] < cur_ind;
			cur_ind = nxt[cur_ind];
		}
		cout << ans + 1;
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}