#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18 + 7;

template <typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << ' ';
    return out;
}

ll n, k, t, h = 0;
vector<ll> tree, lst, lpos, nxt, used;
vector<pair<ll, ll>> gr;

void update(ll ind, ll l, ll r, ll qi, ll qx) {
    if (r - l == 1) {
        tree[ind] += qx;
        return;
    }

    ll m = (l + r) / 2;
    if (qi < m) update(ind * 2, l, m, qi, qx);
    else update(ind * 2 + 1, m, r, qi, qx);

    tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
}

void update(ll qi, ll qx) { update(1, 1, (1 << h) + 1, qi + 1, qx); }

ll query(ll ind, ll l, ll r, ll qk) {
    if (r - l == 1) {
        if (qk > 1) return -1;
        return l - 1;
    }

    ll m = (l + r) / 2;
    if (tree[ind * 2] >= qk) return query(ind * 2, l, m, qk);
    return query(ind * 2 + 1, m, r, qk - tree[ind * 2]);
}

ll query(ll qk) { return query(1, 1, (1 << h) + 1, qk); }

ll dfs(ll v, ll cnt, vector<ll>& path) {
    used[v] = true;
    path.emplace_back(v);

    ll u = gr[v].first, w = gr[v].second;

    cnt -= w;
    if (cnt == 0) return 1;

    if (!used[u]) return dfs(u, cnt, path) + 1;

    bool flag = false;
    vector<ll> vec;
    for (auto i : path) {
        if (i == u) flag = true;
        if (flag) vec.emplace_back(i);
    }

    ll m = vec.size();
    vector<ll> pref(m + 1);
    for (ll i = 0; i < m; i++) pref[i + 1] = pref[i] + gr[vec[i]].second;

    ll ans = 1 + cnt / pref[m] * m;
    cnt %= pref[m];

    for (ll i = 0; i < m; i++) {
        if (cnt == 0) break;

        cnt -= gr[vec[i]].second;
        ans++;
    }

    return ans;
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> k >> t;
    while ((1 << h) < (2 * n)) h++;

    if (t != 1 and (n > 500 or k > 20)) assert(false);

    lst.resize(n);
    lpos.assign(n + 1, -1);
    nxt.resize(n);
    gr.assign(n, {0, 0});
    used.assign(n, false);
    tree.assign(1 << (h + 1), 0);

    for (ll i = 0; i < n; i++) cin >> lst[i];
    for (ll i = 0; i < n; i++) lst.emplace_back(lst[i]);

    set<ll> tmp;
    for (auto i : lst) tmp.emplace(i);

    if (t >= tmp.size()) {
        cout << 1 << endl;
        return 0;
    }

    ll abc = 0;
    map<ll, ll> dct;
    for (ll i = 0; i < n; i++) {
        if (dct.contains(lst[i])) continue;
        dct[lst[i]] = ++abc;
    }

    for (ll i = 0; i < 2 * n; i++) lst[i] = dct[lst[i]];

    for (ll i = 2 * n - 1; i >= 0; i--) {
        if (lpos[lst[i]] != -1) update(lpos[lst[i]], -1);

        lpos[lst[i]] = i;
        update(i, 1);

        if (i >= n) continue;

        nxt[i] = query(t + 1);
    }

    for (ll i = 0; i < n; i++) {
        gr[i].first = nxt[i] % n;
        if (nxt[i] >= n) gr[i].second = 1;
    }

    vector<ll> path;
    ll ans = dfs(0, k, path);

    cout << ans << endl;
}
