#include <algorithm>
#include <bits/extc++.h>
#include <memory>
#include <unordered_set>
#include <vector>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = long long;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

ll mod(ll x, ll m) {
    return ((x % m) + m) % m;
}

ll k, n, t;
const ll lg9 = 40;
vector<ll> a;

struct fgraph {
    vector<ll> nxt, len;

    fgraph(): nxt(n, -1), len(n, 0) {}
    fgraph(vector<ll> &next, vector<ll> &len): nxt(next), len(len) {}
};

fgraph precalc_dumb() {
    fgraph f;
    for (ll i = 0; i < n; i++) {
        unordered_set<ll> st;
        ll j = i, cnt = 0;
        while (st.size() <= t) {
            st.insert(a[j]);
            j = mod(j + 1, n), cnt++;
        }
        f.nxt[i] = mod(j-1,n);
        f.len[i] = cnt - 1;
    }
    return f;
}

fgraph calc_smart() {
    vector<vector<ll>> jmp(lg9, vector<ll>(n)); //slow
    vector<vector<ll>> cnt(lg9, vector<ll>(n)); //slow

    for (ll i = 0; i < n; i++) {
        if (a[i] != a[n-1]) {
            jmp[0][n-1] = i;
            cnt[0][n-1] = i + 1;
            break;
        }
    }

    for (ll i = n - 2; i >= 0; i--) {
        if (a[i] == a[i+1]) {
            jmp[0][i] = jmp[0][i+1];
            cnt[0][i] = cnt[0][i+1] + 1;
        } else {
            jmp[0][i] = i + 1;
            cnt[0][i] = 1;
        }
    }

    for (ll i = 1; i < lg9; i++) {
        for (ll j = 0; j < n; j++) {
            jmp[i][j] = jmp[i-1][jmp[i-1][j]];
            cnt[i][j] = cnt[i-1][jmp[i-1][j]] + cnt[i-1][j];
        }
    }

    vector<ll> nxt(n, -1);
    vector<ll> len(n, 0);

    for (ll i = 0; i < n; i++) {
        ll dest = i;
        ll x = t;
        for (ll l = lg9 - 1; l >= 0; l--) {
            if (x >= (1ll << l)) {
                x -= 1ll << l;
                len[i] += cnt[l][dest];
                dest = jmp[l][dest];
            }
        }

        nxt[i] = dest;
    }

    return {nxt, len};
}

ll cntu() {
    unordered_set<ll> st;
    for (ll i: a) st.insert(i);
    return st.size();
}

void solve() {
    cin >> n >> k >> t;

    a.resize(n);
    for (ll &i: a) {
        cin >> i;
    }

    if (cntu() <= t) {
        cout << 1 << endl;
        return;
    }

    auto f = calc_smart();

    ll cnt = 0, i = 0, ans = 0;
    while (cnt < n * k) {
        cnt += f.len[i];
        i = f.nxt[i];
        ans++;
    }

    cout << ans << endl;    
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    // ll t; cin >> t; while (t--)
    solve();
}