#include <algorithm>
#include <bits/extc++.h>
#include <memory>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = long long;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

ll mod(ll x, ll m) {
    return ((x % m) + m) % m;
}

ll k, n, t;
const ll lg9 = 40;
vector<ll> a;

struct fgraph {
    vector<ll> nxt, len;

    fgraph(): nxt(n, -1), len(n, 0) {}
    fgraph(vector<ll> &next, vector<ll> &len): nxt(next), len(len) {}
};

fgraph precalc_dumb() {
    fgraph f;
    for (ll i = 0; i < n; i++) {
        unordered_set<ll> st;
        ll j = i, cnt = 0;
        while (st.size() <= t) {
            st.insert(a[j]);
            j = mod(j + 1, n), cnt++;
        }
        f.nxt[i] = mod(j-1,n);
        f.len[i] = cnt - 1;
    }
    return f;
}

ll cntu() {
    unordered_set<ll> st;
    for (ll i: a) st.insert(i);
    return st.size();
}

fgraph calc_smart() {
    unordered_map<ll, ll> st; // compress
    fgraph f;
    
    ll l = 0;
    ll r = 0;
    while (st.size() < t) {
        st[a[r++]]++;
    }
    r--;
    while (a[r+1] == a[r]) r++;

    bool change = true;
    while (change && l < n) {
        change = false;
        while (st.size() >= t) {
            if (f.nxt[l % n] == -1) {
                f.nxt[l % n] = (r + 1) % n;
                f.len[l % n] = r - l + 1;
            }
            st[a[l]]--;
            if (st[a[l]] <= 0) st.erase(a[l]);
            l++;
            change = true;
        }
        while (st.size() < t && r < 2 * n - 1) {
            st[a[++r]]++;
            change = true;
        }
        while (r < 2 * n - 1 && a[r+1] == a[r]) {
            r++;
            change = true;
        }
    }

    for (ll i = 0; i < n; i++) {
        if (f.nxt[i] == -1) {
            exit(-1);
        }
    }

    return f;
}

void solve() {
    cin >> n >> k >> t;

    a.resize(n);
    for (ll &i: a) {
        cin >> i;
    }

    a.resize(n * 2);
    copy(a.begin(), a.begin() + n, a.begin() + n);

    ll diff = cntu();

    if (diff <= t) {
        cout << 1 << endl;
        return;
    }

    auto f = calc_smart();

    ll left = n * k;

    ll cnt = 0, i = 0, ans = 0;

    while (a[i] == a[i+1]) i++;

    ll cost = 0;
    ll i0 = 0;
    ll res = 0;
    while (cost == 0 || i != i0) {
        res += f.len[i];
        i = f.nxt[i];
        cost += 1;
    }

    cnt = 0, i = 0, ans = 0;

    while (a[i] == a[i+1]) i++;

    ans += (left / res) * cost;
    left %= res;

    // TODO

    while (cnt < left) {
        cnt += f.len[i];
        i = f.nxt[i];
        ans++;
    }

    cout << ans << endl;    
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    // ll t; cin >> t; while (t--)
    solve();
}