//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Point{
    ld x, y;

    Point() = default;

    Point(ld x, ld y): x(x), y(y){}

    ld sqr_len(){
        return x * x + y * y;
    }

    ld len(){
        return sqrtl(sqr_len());
    }
};

ld operator*(Point a, Point b){
    return a.x * b.x + a.y * b.y;
}

ld operator%(Point a, Point b){
    return a.x * b.y - a.y * b.x;
}

Point operator+(Point a, Point b){
    return Point(a.x + b.x, a.y + b.y);
}

Point operator-(Point a, Point b){
    return Point(a.x - b.x, a.y - b.y);
}

istream& operator>>(istream& in, Point& a){
    in >> a.x >> a.y;
    return in;
}

struct segtree{
    vector<ll> tree;
    int size;

    void push(int v, int vl, int vr){

    }


    void init(int n){
        size = 1;
        while(size < n)
            size++;
        tree.assign(size * 2 - 1, 0);
    }


};

struct dsu{
    vector<int> par, size;

    void init(int n){
        for(int i = 0; i < n; i++){
            par.push_back(i);
            size.push_back(1);
        }
    }

    bool get(int v) {
        if (v == par[v])
            return v;
        return par[v] = get(par[v]);
    }

    bool union_sets(int v, int u){
        v = get(v), u = get(u);
        if(v == u)
            return false;
        if(size[v] < size[u])
            swap(u,v);
        size[v] += size[u];
        par[u] = v;
        size[u] = 0;
    }
};

bool kuhn(int v){
    return false;
}

struct fenwick{
    vector<ll> tree, ar;
    int size;

    void init(vector<ll>& a){
        ar = a;
        size = a.size() + 1;
        tree.assign(a.size() + 1, 0);
    }

    void change(int i, ll x){
        for(int j = i; j < size; j += j & -j){
            tree[j] += x;
        }
    }

    void set(int i, ll x){
        change(i, ar[i - 1] - x);
        ar[i - 1] = x;
    }

    ll get(int i){
        ll res = 0;
        for(int j = i; j > 0; j -= j & -j)
            res += tree[j];
        return res;
    }

    ll get(int l, int r){
        return get(r) - get(l - 1);
    }
};

void solve(){

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;

    vector<int> a(n);
    for(auto& i : a)
        cin >> i;

    vector<int> rightb(n);
    auto tmp = a;
    sort(tmp.begin(), tmp.end());
    tmp.resize(unique(tmp.begin(), tmp.end()) - tmp.begin());
    for(int i = 0; i < n; i++){
        a[i] = upper_bound(tmp.begin(), tmp.end(), a[i]) - tmp.begin() - 1;
    }
    if(tmp.size() <= t){
        cout<<1;
        return 0;
    }

    vector<int> cnt(tmp.size());
    int u = 1;
    int right = 0;
    cnt[a[0]]++;
//    for(int i = 0; i < n; i++)
//        a.push_back(a[i]);
    for(int left = 0; left < n; left++){
        while(u <= t){
            right++;
            cnt[a[right % n]]++;
            if(cnt[a[right % n]] == 1)
                u++;
        }
        while(u > t){
            cnt[a[right % n]]--;
            if(cnt[a[right % n]] == 0)
                u--;
            right--;
        }
        if(right >= 2 * n)
            assert(0);
        rightb[left] = right - left + 1;
        cnt[a[left]]--;
        if(cnt[a[left]] == 0)
            u--;
    }

    vector<int> seq = {0};
    vector<bool> used(n);
    used[0] = true;
    int v = 0;
    ll len = rightb[0];
    while(true){
        v = (v + rightb[v]) % n;
        if(used[v])
            break;
        used[v] = true;
        len += rightb[v];
        seq.push_back(v);
    }
    ll all = k * n;
    ll ans = 0;
    ll cnt_in = seq.size();
    for(auto elem : seq){
        if(elem == v)
            break;
        all -= rightb[elem];
        len -= rightb[elem];
        ans++;
        cnt_in--;
        if(all <= 0){
            cout<<ans;
            return 0;
        }
    }

    ans += (all / len) * cnt_in;
    ll mod = all % len;
    ll mod0 = 0;
    bool flag = false;
    for(auto elem : seq){
        if(mod0 >= mod)
            break;
        if(elem == v)
            flag = true;
        if (!flag)
            continue;
        mod0 += rightb[elem];
        ans++;
        if(mod0 >= mod)
            break;
    }
    cout<<ans;
    return 0;
}
