#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>

#define int long long

using namespace std;

struct fenw {
    vector<int> t;
    void init(int n) {
        t.assign(n, 0);
    }
    void add(int i, int x) {
        while (i < (int)t.size()) {
            t[i] += x;
            i |= i + 1;
        }
    }
    int get(int i) {
        int s = 0;
        while (i >= 0) {
            s += t[i];
            i &= i + 1, i--;
        }
        return s;
    }
    int get(int i, int j) {
        return get(j) - get(i - 1);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n), all;
    set<int> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all.push_back(a[i]);
        s.insert(a[i]);
    }
    if ((int) s.size() <= t) {
        cout << "1\n";
        return 0;
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    for (int i = 0; i < n; i++) {
        a[i] = (int) (lower_bound(all.begin(), all.end(), a[i]) - all.begin());
    }
    vector<int> b = a;
    for (int i = 0; i < n; i++) {
        b.push_back(a[i]);
    }
    fenw F;
    F.init(n * 2);
    vector<int> last(n, -1), jump(n);
    for (int i = 2 * n - 1; i >= 0; i--) {
        if (last[b[i]] != -1) {
            F.add(last[b[i]], -1);
        }
        F.add(last[b[i]] = i, 1);
        if (i < n) {
            int l = i, r = 2 * n;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                if (F.get(i, m) <= t) {
                    l = m;
                } else {
                    r = m;
                }
            }
            jump[i] = r - i;
//            cerr << "! " << i << ' ' << jump[i] << '\n';
        }
    }
    vector<int> pos(n, -1), it(n, -1);
    pos[0] = 0;
    it[0] = 0;
    int cur = 0;
    int len = 0;
    int cnt = 0;
    bool just_go = false;
    while (true) {
        len += jump[cur];
        cnt++;
        if (len >= n * k) {
            cout << cnt << '\n';
            return 0;
        }
        int to = len % n;
//        if (pos[to] != -1 && !just_go) {
//            int x = cnt - it[to];
//            int h = len - pos[to];
//            int ggg = (n * k - 1 - len) / h;
//            cerr << "!!!!! " << cur << ' ' << to << "  " << x << ' ' << h << ' ' << ggg << '\n';
//            cnt += x * ggg;
//            len += h * ggg;
//            cur = len % n;
//            just_go = true;
//        } else {
            cur = len % n;
            pos[cur] = cnt;
//        }
    }
    assert(false);
    return 0;
}
/*

2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7 8

 */