#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <random>
#include <chrono>
#include <assert.h>
#include <stack>
#include <numeric>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using uid = uniform_int_distribution<int>;
using lst = vector<vector<int>>;

const int type = 0;
const int MAXN = 2e5 + 1;
const int LOGN = 17;
const int MOD = 1e9 + 7;

class SegmentTree {
private:
	int n;
	int size;
	vector<int> t;

	void build(int v, int tl, int tr) {
		if (tl == tr) {
			return;
		}
		int tm = (tl + tr) >> 1;
		build(v << 1, tl, tm);
		build(v << 1 | 1, tm + 1, tr);
	}

public:

	SegmentTree(const int _n)
		:n(_n)
		, size(n << 2)
		, t(size) {
		build(1, 0, n);
	}
};

struct HashTable {
	static const int TABLE_SIZE = 1e7;
	static const int MAX_ELEMENTS = 1e5;
	int head[TABLE_SIZE];
	int next[MAX_ELEMENTS];
	int val[MAX_ELEMENTS];
	int itemCount = 0;

	void update() {
		for (int i = 0;i < TABLE_SIZE;i++) {
			next[i] = -1;
			head[i] = -1;
		}
		return;
	}

	HashTable() {
		update();
	}

	void add(ll hash) {
		ll h = hash % TABLE_SIZE;
		for (int i = head[h]; i != -1;i = next[i]) {
			if (val[i] == hash) {
				return;
			}
		}
		next[++itemCount] = head[h];
		head[h] = itemCount;
		val[itemCount] = hash;
		return;
	}
};

bool isPrime(ll x) {
	for (int i = 2;i <= x / i;i++) {
		if (x % i == 0) {
			return false;
		}
 	}
	return (x > 1);
}

void genModule(mt19937& gen, ll& MOD) {
	while (1) {
		MOD = uid(1e9, 2e9)(gen);
		if (isPrime(MOD)) return;
	}
}

int _lg(ll x) {
	int ans = 0;
	for (int i = 0;i < 63;i++) {
		if (x & (1 << i)) ans = i;
	}
	return ans;
}

int _builtin_popcount(ll x) {
	int ans = 0;
	for (int i = 0;i < 63;i++) {
		if (x & (1 << i)) ans++;
	}
	return ans;
}

void solve2() {

}

void solve(int att) {
	ll n, k, t;
	cin >> n >> k >> t;
	vector<int> a(n);
	for (int i = 0;i < n;i++) {
		cin >> a[i];
	}
	if (n <= 1000 && k <= 1000) {
		map<int, int> mp;
		int cnt = 0;
		for (int i = 0;i < n * k;i++) {
			if (mp.size() == t && mp.find(a[i % n]) == mp.end()) {
				cnt++;
				mp.clear();
				//cout << "\n";
			}
			//cout << a[i % n] << " ";
			mp[a[i % n]]++;
		}
		if (mp.size() != 0) cnt++;
		cout << cnt;
		return;
	}
	if (t == 1) {
		map<int, int> mp;
		int cnt = 0;
		for (int i = 0;i < n;i++) {
			if (mp.size() == t && mp.find(a[i % n]) == mp.end()) {
				cnt++;
				mp.clear();
				mp[a[i % n]]++;
				continue;
			}
			mp[a[i % n]]++;
		}
		if (!mp.empty()) cnt++;
		ll cycle = cnt;
		if (a[n - 1] == a[0]) { // последний равный с первым
			cycle--;
		}
		cout << cnt + (k - 1) * cycle;
		return;
	}
	if (n <= 1500) {
		vector<ll> len(n);
		int n2 = n << 1;
		vector<ll> b(n2);
		for (int i = 0;i < n2;i++) {
			b[i] = a[i % n];
		}
		for (int i = 0;i < n;i++) {  // начало отрезка, но отрезок не может быть больше n
			map<int, int> mp;
			for (int j = i; j - i <= n;j++) {
				len[i] = j - i;
				if (mp.size() == t && mp.find(b[j]) == mp.end()) {
					break;
				}
				mp[b[j]]++;
			}
		}  // посчитали
		vector<bool> vis(n, false);
		vector<ll> nmbC(n, -1);
		vector<ll> sumLens(n, 0);
		ll ind = 0;
		ll cycle = 0;
		ll sumlen = 0;
		while (!vis[ind]) { 
			vis[ind] = true;  // посетили
			sumLens[ind] = sumlen; // прибавили
			nmbC[ind] = cycle;  // сколько длинн нужно пройти до текущего индекса
			sumlen += len[ind];  // перешли к новому индексу -> прибавили новый отрезок
			cycle++;  // переход к следующему индексу -> новая длинна
			ind = (ind + len[ind]) % n;  // новый индекс
			if (sumlen >= n * k) {  // если теперь, мы обогнули, то выводим кол-во cycle 
				cout << cycle;
				return;
			}
		}
		ll nmbLen = cycle - nmbC[ind];  // т.к. завершаем, когда пришли в посещённую вершину, тогда у нас сейчас cycle на посещённой, а первое посещение nmbC[ind], тогда всего цикл длится
		ll LEN_OF_CYCLE = sumlen - sumLens[ind]; // длина самого цикла
		if (LEN_OF_CYCLE == n) {
			cout << 1;
			return;
		}
		ll ans = cycle + (n * k - sumlen)/LEN_OF_CYCLE * nmbLen; // количество длинн, которые мы успели пройти
		sumlen = sumlen + (n * k - sumlen) / LEN_OF_CYCLE * LEN_OF_CYCLE; // теперь длинна, которую мы суммарно успели пройти 
		while (1) { 
			if (sumlen >= n * k) { // если мы выходим за границы массива, не зайдя в цикл
				cout << ans;
				return;  // выходим
			}
			sumlen += len[ind];  // прибавили длинну
			ans++;  // прибавили к счётчику
			ind = (ind + len[ind]) % n;  // новый индекс
		}  // если всё же мы нашли цикл, то теперь мы можем идти циклами, пока всё норм, а дальше просто пройтись вручную
	}
}

int main() {
	cin.tie(0)->ios::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int nT = 1;
	if (type) cin >> nT;
	for (int t = 0;t < nT;t++) {
		solve(t);
		if (t != nT - 1) std::cout << "\n";
	}
	return 0;
}