// #include <bits/stdc++.h>
#include <cmath>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <vector>
using namespace std;
using ll = long long;

// template <typename T>
// istream& operator>>(istream& in, vector<T>& a) {
//     for (auto& el : a) {
//         in >> a;
//     }
//     return in;
// }

template <typename T>
void print(vector<T>& a) {
    for (auto& el : a) {
        cout << el << " ";
    }
}

struct segtree {
    ll sz = 1;
    vector<ll> tr;

    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
    }
    void ch(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tr[v] = x;
            return;
        }
        int mid = (r + l) / 2;
        if (ind < mid) {
            ch(2 * v + 1, l, mid, ind, x);
        } else {
            ch(2 * v + 2, mid, r, ind, x);
        }
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
    }

    void ch(int ind, int x) { ch(0, 0, sz, ind, x); }

    ll sumseg(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return 0;
        }
        int mid = (r + l) / 2;
        ll m1 = sumseg(2 * v + 1, l, mid, lseg, rseg);
        ll m2 = sumseg(2 * v + 2, mid, r, lseg, rseg);
        return m1 + m2;
    }

    ll sumseg(int lseg, int rseg) { return sumseg(0, 0, sz, lseg, rseg); }
};

struct xui {
    map<ll, ll> had;
    ll cnt = 0;
    void add(ll x) {
        had[x]++;
        if (had[x] == 1) {
            cnt++;
        }
    }

    void del(ll x) {
        had[x]--;
        if (had[x] == 0) {
            cnt--;
        }
    }
};
void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    set<ll> f;
    for (int i = 0; i < n; i++) {
        f.insert(a[i]);
    }
    if (f.size() <= t) {
        cout << 1 << "\n";
        return;
    }
    vector<ll> jump(n);
    ll yk = 0;
    xui mach;
    for (int i = 0; i < n; i++) {
        while (mach.cnt <= t) {
            mach.add(a[yk]);
            yk = (yk + 1) % n;
        }
        yk = (yk - 1 + n) % n;
        mach.del(a[yk]);
        jump[i] = yk;
        mach.del(a[i]);
    }
    vector<vector<pair<ll, ll>>> bins(30, vector<pair<ll, ll>>(n));
    for (int i = 0; i < n; i++) {
        bins[0][i] = {jump[i] < i, jump[i]};
    }
    for (int g = 1; g < 30; g++) {
        for (int i = 0; i < n; i++) {
            int j = bins[g - 1][i].second;
            bins[g][i] = {bins[g - 1][i].first + bins[g - 1][j].first,
                          bins[g - 1][j].second};
        }
    }
    ll our = 0;
    ll i = 0;
    ll ans = 0;
    for (int g = 29; g > -1; g--) {
        if (our + bins[g][i].first < k) {
            our += bins[g][i].first;
            ans += (1ll << g);
            i = bins[g][i].second;
        }
    }
    cout << ans + 1 << "\n";
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
