#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(1472916923);
const int SZ = 1e6 + 1;

struct segtree {
    int sz;
    vector<int> tr;
    segtree(int n) {
        sz = 1;
        while (sz < n)
            sz <<= 1;
        tr.assign(sz * 2 - 1, 0);
    }
};

struct DDnode {
    ll prior, val;
    DDnode* l;
    DDnode* r;
    DDnode(ll v = 0) : val(v) {
        prior = rd();
        l = nullptr;
        r = nullptr;
    }
};

vector<int> g;
vector<ll> sz_len, sz;
ll sz1 = -1, szl1, sz2, szl2, cy;

void dfs(int v, int n, ll sl = 0, ll s = 0) {
    sz_len[v] = sl;
    sz[v] = s;
    if (sz[g[v]] != -1) {
        cy = g[v];
        sz1 = sz[g[v]];
        szl1 = sz_len[g[v]];
        sz2 = s + 1 - sz[g[v]];
        szl2 = sl + (g[v] > v ? g[v] - v : g[v] + n - v) - sz_len[g[v]];
        return;
    }
    else {
        dfs(g[v], n, sl + (g[v] > v ? g[v] - v : g[v] + n - v), s + 1);
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ll n, k, t;
    cin >> n >> k >> t;
    g.assign(n, 0);
    sz.assign(n, -1);
    sz_len.assign(n, -1);
    vector<ll> a(n);
    multiset<ll> st;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert(a[i]);
    }
    if (st.size() <= t) {
        cout << 1;
        return 0;
    }

    vector<int> best(n);
    map<ll, int> mp;
    mp[a[0]] = 1;
    int cnt = 1;
    int l = 0, r = 0;
    while (l < n) {
        while (cnt <= t) {
            r = (r + 1) % n;
            mp[a[r]]++;
            if (mp[a[r]] == 1)
                cnt++;
        }
        best[l] = r;
        g[l] = r;
        mp[a[l]]--;
        if (mp[a[l]] == 0)
            cnt--;
        l++;
    }
    dfs(0, n);
    ll all = n * k;
    ll ans = 0;
    if (all > szl1) {
        ans += sz1;
        all -= szl1;
        ans += (all / szl2) * sz2;
        all %= szl2;
    }
    else {
        cy = 0;
    }

    while (all > 0) {
        ans++;
        all -= (g[cy] > cy ? g[cy] - cy : g[cy] + n - cy);
        cy = g[cy];
    }
    cout << ans;
}
