#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
//#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define vi vector<ll>
#define vii vector<vi>

struct seg_tree{
    vii t;

    seg_tree(ll n) {
        t.resize(4 * n);
    }

    void build(ll v, ll tl, ll tr, vi&a) {
        if (tl == tr) {
            t[v] = {a[tl]};
            return;
        }
        ll m = (tl + tr) / 2;
        build(2 * v, tl, m, a);
        build(2 * v + 1, m + 1, tr,  a);
        ll sz1 = t[2*v].size();
        ll sz2 = t[2*v+1].size();
        t[v].resize(sz1 + sz2);
        merge(all(t[2*v]), all(t[2*v+1]), t[v].begin());
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (l > r) {
            return 0;
        }
        if (tl == l && tr == r) {
            return lower_bound(all(t[v]), x) - t[v].begin();
        }
        ll m = (tl + tr) / 2;
        ll res1 = get(2*v, tl, m, l, min(r, m), x);
        ll res2 = get(2*v+1, m+1, tr, max(l, m + 1), r, x);
        return res1 + res2;
    }
};

void solve() {
    ll n, k, dif;
    cin >> n >> k >> dif;
    if (n == 1 && k == 1) {
        cout << 1;
        return;
    }
    vi a(n), last(2 * n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; i++) {
        a.pb(a[i]);
    }
    ll m = 2 * n;
    map<ll,ll> key;
    for (ll i = 0; i < m; i++) {
        if (key.find(a[i]) == key.end()) {
            last[i] = -1;
        } else {
            last[i] = key[a[i]];
        }
        key[a[i]] = i;
       // cout << a[i] << ' ' << last[i] << endl;
    }
    seg_tree t(m);
    t.build(1, 0, m-1, last);
    vi nxt(n); // включительно

    for (ll i = 0; i < n; i++) {
        ll l = i, r = 2 * n;

        while (r - l > 1) {
            ll mid = (l + r) / 2;
            ll L = i, R = mid;
            ll res = t.get(1, 0, m-1, L, R, L);
            if (res <= dif) {
                l = mid;
            } else {
                r = mid;
            }
        }
        nxt[i] = l;
        //cout << i << " " << l << endl;
    }

    ll start = 0, d = 0;
    ll ans = 0;
    while (d < n * k) {
        ll f = nxt[start];
        d += f - start + 1;
        start = (f + 1) % n;
        ans++;
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    clock_t timer = clock();
#endif
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
#ifdef LOCAL
    // cout << endl << "time: " << (ld) (clock() - timer) / CLOCKS_PER_SEC;
#endif
}
