#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define vi vector<ll>
#define vii vector<vi>

const ll N = 3e5;

ll inf = 1e15;
ll nxt[N], p[N], used[N];

struct seg_tree {
    vector<ll> t[8 * N];
    vector<pair<ll, ll>> lw[8 * N];

    void build(ll v, ll tl, ll tr, vi &a) {
        if (tl == tr) {
            t[v] = {a[tl]};
            lw[v] = {{0, 0}};
            return;
        }
        ll m = (tl + tr) / 2;
        build(2 * v, tl, m, a);
        build(2 * v + 1, m + 1, tr, a);

        ll sz1 = t[2 * v].size();
        ll sz2 = t[2 * v + 1].size();
        ll x = 0, y = 0;
        while (x != sz1 || y != sz2) {
            if (x == sz1) {
                t[v].pb(t[2 * v + 1][y]);
                y++;
            } else if (y == sz2) {
                t[v].pb(t[2 * v][x]);
                x++;
            } else {
                if (t[2 * v + 1][y] < t[2 * v][x]) {
                    t[v].pb(t[2 * v + 1][y]);
                    y++;
                } else {
                    t[v].pb(t[2 * v][x]);
                    x++;
                }
            }
            lw[v].pb({x, y});
        }
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r,  ll pos) {
        if (l > r || pos == 0) {
            return 0;
        }
        if (tl == l && tr == r) {
            return pos;
        }
        pos--;
        ll m = (tl + tr) / 2;
        ll left, rig;
        left = lw[v][pos].first;
        rig = lw[v][pos].second;
        ll res1 = get(2 * v, tl, m, l, min(r, m), left);
        ll res2 = get(2 * v + 1, m + 1, tr, max(l, m + 1), r,  rig);
        return res1 + res2;
    }
};

void solve() {
    clock_t timer = clock();
    ll n, k, dif;
    cin >> n >> k >> dif;
    if (n == 1 && k == 1) {
        cout << 1;
        return;
    }
    ll fl = 0;
    vi a(n), last(2 * n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i] != a[i - 1]) {
            fl = 1;
        }
    }
    if (fl == 0) {
        cout << 1;
        return;
    }
    for (ll i = 0; i < n; i++) {
        a.pb(a[i]);
    }
    ll m = 2 * n;
    unordered_map<ll, ll> key;
    for (ll i = 0; i < m; i++) {
        if (key.find(a[i]) == key.end()) {
            last[i] = -1;
        } else {
            last[i] = key[a[i]];
        }
        key[a[i]] = i;
    }

    vi nx(m, -1);
    for (ll i = m - 2; i >= 0; i--) {
        if (a[i] != a[i + 1]) {
            nx[i] = i;
        } else {
            nx[i] = nx[i + 1];
        }
    }
    if (a[0] == a[m - 1]) {
        nx[m - 1] = nx[0];
    } else {
        nx[m - 1] = m - 1;
    }
    vi b = last;
    sort(all(b));

    if (dif != 1) {
        seg_tree t;
        t.build(1, 0, m - 1, last);
        for (ll i = 0; i < n; i++) {
            ll l = i, r = 2 * n;
            ll val = lower_bound(all(b), i) - b.begin();
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                ll L = i, R = mid;
                ll res = t.get(1, 0, m - 1, L, R, val);
                if (res <= dif) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (i + n <= l) {
                nxt[i] = inf;
            } else {
                nxt[i] = l;
            }
        }
    } else {
        for (ll i = 0; i < n; i++) {
            ll l = nx[i];
            if (i + n <= l) {
                nxt[i] = inf;
            } else {
                nxt[i] = l;
            }
        }
    }

    ll st = 0, c = 0;
    vi in_c(n);
    vi cycle;
    while (c != n) {
        used[st] = 1;
        ll f = nxt[st];
        if (f == inf)
            break;
        f++;
        f %= n;
        p[f] = st;
        if (used[f]) {
            ll j = st;
            while (j != f) {
                cycle.push_back(j);
                in_c[j] = 1;
                j = p[j];
            }
            in_c[f] = 1;
            cycle.push_back(f);
            break;
        }
        st = f;
        c++;
    }
    reverse(all(cycle));
    ll cycsum = 0;
    for (ll i = 1; i < cycle.size(); i++) {
        ll w;
        ll a1 = cycle[i - 1];
        ll a2 = cycle[i];
        if (a2 < a1) {
            w = n - a1 + a2;
        } else {
            w = a2 - a1;
        }
        cycsum += w;
    }
    if (cycle.size() > 0) {
        ll a1 = cycle.back();
        ll a2 = cycle[0];
        ll ee;
        if (a2 < a1) {
            ee = n - a1 + a2;
        } else {
            ee = a2 - a1;
        }
        cycsum += ee;
    }

    ll ans = 0;
    st = 0;
    ll w = 0;
    ll sz = cycle.size();

    if (in_c[st]) {
        w = 0;
        ll ost = n * k - w;
        ll h = ost / cycsum;
        ans += sz * h;
        w += h * cycsum;
        if (w == n * k) {
            cout << ans;
            return;
        } else {
            ll z = st;
            while (w < n * k) {
                ll q = nxt[z] + 1;
                q %= n;
                if (q < z) {
                    w += n - z + q;
                } else {
                    w += q - z;
                }
                ans++;
                z = q;
            }
            cout << ans;
            return;
        }
    }

    while (w < n * k) {
        ll gg = nxt[st];
        if (gg == inf) {
            ans++;
            cout << ans;
            return;
        }
        gg = (gg + 1) % n;
        if (gg < st) {
            w += n - st + gg;
        } else {
            w += gg - st;
        }
        ans++;

        if (in_c[gg]) {
            ll ost = n * k - w;
            ll h = ost / cycsum;
            ans += sz * h;
            w += h * cycsum;
            if (w == n * k) {
                cout << ans;
                return;
            } else {
                ll z = gg;
                while (w < n * k) {
                    ll q = nxt[z] + 1;
                    q %= n;
                    if (q < z) {
                        w += n - z + q;
                    } else {
                        w += q - z;
                    }
                    ans++;
                    z = q;
                }
                cout << ans;
                return;
            }
        }
        st = gg;
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
#ifdef LOCAL
    // cout << endl << "time: " << (ld) (clock() - timer) / CLOCKS_PER_SEC;
#endif
}
