#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 3e5;
int n, k, t;
int a[MAXN * 2];
int s[MAXN * 2];
int ans = 0;
int cnt[MAXN];

bool check() {
    unordered_set<int> q;
    for (int i = 0; i < n; i++)
        q.insert(a[i]);
    if (sz(q) <= t)
        return true;
    else
        return false;
}
void compress() {
    vi temp(a, a + n);
    sort(all(temp));
    temp.erase(unique(all(temp)), temp.end());
    for (int i = 0; i < n; i++)
        a[i] = int(lower_bound(all(temp), a[i]) - temp.begin());
}
void make_longer() {
    for (int i = 0; i < n; i++)
        a[i + n] = a[i];
}

void add(int x) {
    if (cnt[x] == 0)
        ans++;
    cnt[x]++;
}
void rem(int x) {
    if (cnt[x] == 1)
        ans--;
    cnt[x]--;
}

int used[MAXN];
ll pref_sum[MAXN];
int pref_s[MAXN];
ll sum;
int s_cycle;
int beg, mini_path;
ll mini_sum;

void get_sz_cycle() {
    s_cycle = 0;
    sum = 0;
    int cur = 0;
    while (!used[cur]) {
        pref_sum[cur] = sum;
        pref_s[cur] = s_cycle;
        used[cur] = 1;
        sum += s[cur];
        s_cycle++;
        cur = (cur + s[cur]) % n;
    }
    sum -= pref_sum[cur];
    s_cycle -= pref_s[cur];
    beg = cur;
    cur = 0;
    mini_sum = 0;
    mini_path = 0;
    while (cur != beg) {
        mini_sum += s[cur];
        mini_path++;
        cur = (cur + s[cur]) % n;
    }
}

void solve() {
    cin >> n >> k >> t;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (check()) {
        cout << 1 << '\n';
        return;
    }

    compress();
    make_longer();

    for (int l = 0, r = 0; l < n; l++) {
        while (ans <= t && r < 2 * n)
            add(a[r++]);
        if (r < 2 * n)
            rem(a[--r]);
        s[l] = r - l;
        rem(a[l]);
    }

    get_sz_cycle();

    if (mini_sum > 1LL * n * k) {
        ll res = 0;
        ll cur_pos = 0;
        while (cur_pos < 1LL * n * k) {
            res++;
            cur_pos += s[cur_pos % n];
            if (cur_pos > 1LL * n * k)
                break;
        }
        cout << res << '\n';
    } else {
        ll left = 1LL * n * k - mini_sum;
        ll cnt_cycles_need = left / sum;
        ll left_go = left % sum;

        ll res = 0;
        ll cur_sum = 0;
        ll cur_pos = beg;
        while (cur_sum < left_go) {
            res++;
            cur_sum += s[cur_pos];
            cur_pos = (cur_pos + s[cur_pos]) % n;
            if (cur_sum > left_go)
                break;
        }
        cout << 1LL * cnt_cycles_need * s_cycle + res + mini_path << '\n';
    }
}

int main() {
    fast_input;
    cout << setprecision(7) << fixed;
    solve();
}