#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint = unsigned long;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int L = 50;

const int N = 3e5 + 10;
pair<int, int> jump[N][L];

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> x = a;
    sort(all(x));
    x.erase(unique(all(x)), x.end());

    if (sz(x) <= t) {
        cout << 1 << "\n";
        return;
    }

    vector<int> go(2 * n, 0);

    vector<int> b = a;
    for (auto v : a) {
        b.push_back(v);
    }

    set<int> l;

    map<int, int> mp;
    map<int, int> ind;

    for (int i = sz(b) - 1; i >= 0; i--) {
        if (mp.find(b[i]) == mp.end()) {
            if (sz(mp) == t) {
                auto it = -*l.begin();
                l.erase(l.begin());
                mp.erase(ind[it]);
                ind.erase(it);
            }

            mp[b[i]] = i;
            ind[i] = b[i];
            l.insert(-i);
        } else {
            // okay
        }

        go[i] = -*l.begin() + 1;
    }

    for (int i = 0; i < n; i++) {
        jump[i][0] = {go[i] >= n, go[i] % n};
    }

    for (int j = 0; j < L - 1; j++) {
        for (int i = 0; i < n; i++) {
            pair<int, int> where = jump[i][j];
            pair<int, int> here = jump[where.second][j];
            jump[i][j + 1] = {where.first + here.first, here.second};
        }
    }

    int lx = 0, rx = 3e14 + 100;
    while (rx - lx > 1) {
        int mid = (rx + lx) / 2;
        int s = 0;
        int score = 0;
        for (int j = L - 1; j >= 0; j--) {
            if ((mid >> j) & 1) {
                score += jump[s][j].first;
                s = jump[s][j].second;
            }
        }
        if (score >= k) {
            rx = mid;
        } else {
            lx = mid;
        }
    }

    cout << rx << '\n';

//    for (int i = 0; i < n; i++) {
//        cout << go[i] << " ";
//    }
//    cout << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}