#include "bits/stdc++.h"

using namespace std;

#pragma GCC optimize("O3, Ofast")
#pragma GCC target("avx2")

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int L = 55;

const int N = 3e5 + 10;

int jump[N][L];
ll sc[N][L];

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> x = a;
    sort(all(x));
    x.erase(unique(all(x)), x.end());

    if (sz(x) <= t) {
        cout << 1 << "\n";
        return;
    }

    vector<int> go(2 * n, 0);

    vector<int> b(sz(a) * 2);
    for (int i = 0; i < sz(a) * 2; i++) {
        b[i] = a[i % sz(a)];
    }

    set<int> st;
    map<int, int> cnt;
    int r = sz(b) - 1;

    for (int i = sz(b) - 1; i >= 0; i--) {
        st.insert(b[i]);
        cnt[b[i]]++;

        while (sz(st) > t) {
            cnt[b[r]]--;
            if (cnt[b[r]] == 0) {
                st.erase(b[r]);
            }
            r--;
        }

        go[i] = r + 1;
    }

    for (int i = 0; i < n; i++) {
        sc[i][0] = go[i] >= n;
        jump[i][0] = go[i] % n;
    }

    for (int j = 0; j < L - 1; j++) {
        for (int i = 0; i < n; i++) {
            jump[i][j + 1] = jump[jump[i][j]][j];
            sc[i][j + 1] = sc[i][j] + sc[jump[i][j]][j];
        }
    }

#ifndef home
    ll lx = 0, rx = 3e14 + 100;
#else
    ll lx = 0, rx = 4;
#endif
    while (rx - lx > 1) {
        ll mid = (rx + lx) / 2;
        int s = 0;
        ll score = 0;
        for (int j = L - 1; j >= 0; j--) {
            if ((mid >> j) & 1) {
                score += sc[s][j];
                s = jump[s][j];
            }
        }
        if (score >= k) {
            rx = mid;
        } else {
            lx = mid;
        }
    }

    cout << rx << '\n';

//    for (int i = 0; i < n; i++) {
//        cout << go[i] << " ";
//    }
//    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}