#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 3e5 + 10;

bool used[N];
int go[N * 2];

vector<int> score;
vector<int> tour;

int start = -1;

ll n, k, t;

void dfs (int u, int s = 0) {
    score.push_back(s);
    tour.push_back(u);
    if (used[u]) {
        start = u;
        return;
    }
    used[u] = true;

    if (go[u] >= n){
        s += 1;
    }

    dfs(go[u] % n, s);
}

void solve() {
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> x = a;
    sort(all(x));
    x.erase(unique(all(x)), x.end());

    if (sz(x) <= t) {
        cout << 1 << "\n";
        return;
    }

    vector<int> b(sz(a) * 2);
    for (int i = 0; i < sz(a) * 2; i++) {
        b[i] = a[i % sz(a)];
    }

    set<int> st;
    map<int, int> cnt;
    int r = sz(b) - 1;

    for (int i = sz(b) - 1; i >= 0; i--) {
        st.insert(b[i]);
        cnt[b[i]]++;

        while (sz(st) > t) {
            cnt[b[r]]--;
            if (cnt[b[r]] == 0) {
                st.erase(b[r]);
            }
            r--;
        }

        go[i] = r + 1;
    }

    dfs(0);

    int c = -1;

    for (int i = 0; i < sz(tour); i++) {
        if (tour[i] == start) {
            c = i;
            break;
        }
    }

    int before = score[c];

    if (before >= k) {
        for (int i = 0; i < sz(tour); i++) {
            if (score[i] >= k) {
                cout << i << "\n";
                return;
            }
        }
    }

    k -= before;

    int cycles = k / (score.back() - score[c]) - 1;

    int ans = 0;
    ans += c;

    if (cycles >= 0) {
        ans += cycles * (sz(tour) - c - 1);
        k -= cycles * (score.back() - score[c]);
    }

    int where = tour[c];

    while (k > 0) {
        if (go[where] >= n) {
            k--;
        }
        ans++;
        where = go[where] % n;
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}