#include <iostream>
#include <unordered_map>
#include <set>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using indset = __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void getlasts(int m, std::vector<int> b, std::vector<int>& last, int t) {
    b.reserve(b.size() << 1);
    for (int i = 0; i < m; i++) {
        b.emplace_back(b[i]);
    }
    std::unordered_map<int, int> inds;
    indset allinds;
    for (int i = 2 * m - 1; i >= m; i--) {
        allinds.erase(inds[b[i]]);
        inds[b[i]] = i;
        allinds.insert(i);
    }
    for (int i = m - 1; i >= 0; i--) {
        allinds.erase(inds[b[i]]);
        inds[b[i]] = i;
        allinds.insert(i);
        auto citer = allinds.find_by_order(t);
        if (citer == allinds.end()) {
            last[i] = m;
        } else {
            last[i] = *citer - i;
        }
    }
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n, k, t;
    std::cin >> n >> k >> t;
    std::vector<int> a(n);
    std::vector<int> types;
    types.reserve(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        if (types.empty() || types.back() != a[i]) {
            types.emplace_back(a[i]);
        }
    }
    if (types.size() == 1) {
        std::cout << "1\n";
        return 0;
    }
    a.swap(types);
    std::vector<int> b(a.begin(), a.end());
    if (b.front() == b.back()) {
        b.erase(b.begin());
    }
    std::set<int> cur;
    long long res = 0;
    for (int i = 0; i < (int)a.size(); i++) {
        if (cur.size() == t && !cur.contains(a[i])) {
            res++;
            cur.clear();
        }
        cur.insert(a[i]);
    }

    if (t == 1) {
        std::cout << a.size() + b.size() * (k - 1) << '\n';
        return 0;
    }
    if (k == 1) {
        std::cout << res + (!cur.empty()) << '\n';
        return 0;
    }

    int m = (int)b.size();
    std::vector<int> last(m);
    // for (int i = 0; i < m; i++) {
    //     last[i] = getlast(b, i, t);
    // }
    getlasts(m, b, last, t);
    int clast = 0;
    for (; clast != m;) {
        if (cur.size() == t && !cur.contains(b[clast])) {
            break;
        }
        cur.insert(b[clast]);
        clast++;
    }
    if (clast == m) {
        std::cout << res + (!cur.empty()) << '\n';
        return 0;
    } else {
        res++;
        cur.clear();
        long long cind = clast;
        cind += (int)a.size();
        int cpos = cind % m;
        while (cind < (k - 1ll) * m + (int)a.size()) {
            res++;
            cind += last[cpos];
            cpos += last[cpos];
            if (cpos >= m) {
                cpos -= m;
            }
        }
    }
    std::cout << res << '\n';
    return 0;
}