#include <iostream>
#include <unordered_map>
#include <set>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using indset = __gnu_pbds::tree<long long, __gnu_pbds::null_type, std::less<long long>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void getlasts(long long m, std::vector<long long> b, std::vector<long long>& last, long long t) {
    b.reserve(b.size() << 1);
    for (long long i = 0; i < m; i++) {
        b.emplace_back(b[i]);
    }
    std::unordered_map<long long, long long> inds;
    indset allinds;
    for (long long i = 2 * m - 1; i >= m; i--) {
        allinds.erase(inds[b[i]]);
        inds[b[i]] = i;
        allinds.insert(i);
    }
    for (long long i = m - 1; i >= 0; i--) {
        allinds.erase(inds[b[i]]);
        inds[b[i]] = i;
        allinds.insert(i);
        auto citer = allinds.find_by_order(t);
        if (citer == allinds.end()) {
            last[i] = m;
        } else {
            last[i] = *citer;
        }
    }
}

constexpr long long maxlog = 31;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    long long n, k, t;
    std::cin >> n >> k >> t;
    std::vector<long long> a(n);
    std::vector<long long> types;
    types.reserve(n);
    for (long long i = 0; i < n; i++) {
        std::cin >> a[i];
        if (types.empty() || types.back() != a[i]) {
            types.emplace_back(a[i]);
        }
    }
    if (types.size() == 1) {
        std::cout << "1\n";
        return 0;
    }
    a.swap(types);
    std::vector<long long> b(a.begin(), a.end());
    if (b.front() == b.back()) {
        b.erase(b.begin());
    }
    std::set<long long> cur;
    long long res = 0;
    for (long long i = 0; i < (long long)a.size(); i++) {
        if (cur.size() == t && !cur.contains(a[i])) {
            res++;
            cur.clear();
        }
        cur.insert(a[i]);
    }

    if (t == 1) {
        std::cout << a.size() + b.size() * (k - 1) << '\n';
        return 0;
    }
    if (k == 1) {
        std::cout << res + (!cur.empty()) << '\n';
        return 0;
    }

    long long m = (long long)b.size();
    std::vector<long long> last(m);
    getlasts(m, b, last, t);
    std::vector<std::pair<long long, long long>> nxt(m);
    for (long long i = m - 1; i >= 0; i--) {
        nxt[i] = {1, last[i]};
        if (last[i] < m) {
            nxt[i].first += nxt[last[i]].first;
            nxt[i].second = nxt[last[i]].second;
        }
    }
    std::vector<std::vector<std::pair<long long, long long>>> nxtj(maxlog, std::vector<std::pair<long long, long long>>(m));
    for (long long i = 0; i < m; i++) {
        nxtj[0][i] = nxt[i];
        nxtj[0][i].second %= m;
    }
    for (long long j = 1; j < maxlog; j++) {
        for (long long i = 0; i < m; i++) {
            long long cnxtpos = nxtj[j - 1][i].second;
            if (cnxtpos >= m) {
                cnxtpos -= m;
            }
            nxtj[j][i].first = nxtj[j - 1][i].first + nxtj[j - 1][cnxtpos].first;
            nxtj[j][i].second = nxtj[j - 1][cnxtpos].second;
        }
    }
    long long clast = 0;
    for (; clast != m;) {
        if (cur.size() == t && !cur.contains(b[clast])) {
            break;
        }
        cur.insert(b[clast]);
        clast++;
    }
    if (clast == m) {
        std::cout << res + (!cur.empty()) << '\n';
        return 0;
    } else {
        res++;
        cur.clear();
        long long cind = clast;
        cind += (long long)a.size();
        long long cpos = cind % m;
        // while (cind < (k - 1ll) * m + (long long)a.size()) {
        //     res += nxt[cpos].first;
        //     cind += nxt[cpos].second;
        //     cpos += nxt[cpos].second;
        //     if (cpos >= m) {
        //         cpos -= m;
        //     }
        // }
        long long carrnum = 2;
        for (long long j = maxlog - 1; j >= 0; j--) {
            if (carrnum + (1 << j) <= k + 1) {
                res += nxtj[j][cpos].first;
                // cind += nxtj[j][cpos].second;
                cpos = nxtj[j][cpos].second;
                carrnum += (1 << j);
            }
        }
    }
    std::cout << res << '\n';
    return 0;
}