#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;

ll n, k, t;

ll next(const vi &v, ll start) {
    unordered_map<int, int> mp;

    while (mp.size() <= t && (start < (int)1e3)) {
        int x = start % n;
        mp[v[x]] = 1;
        start++;
    }
    start--;
    return start;
}

void shiftR(vi &v, ll m) {
    while (v.size() > 1 && (v.front() == v.back()))
        v.pop_back();
    n = (int)v.size();
    m %= n;
    vi v2(n);
    for (int i = 0; i < n; i++) {
        v2[(i-m+n)%n] = v[i];
    }
    v = v2;
}

int stupid(const vi &v) {
    int c = 0;
    ll now = 0;
    while (now < n*k) {
        now = next(v, now);
        c++;
    }
    return c;
}

ll calc(vi &v) {
    set<int> ms;
    for (int i : v)
        ms.insert(i);
    if (t >= ms.size()) {
        return 1;
    }

    if (t == 1) {
        if (v.front() != v.back())
            return n*k;
        while (v.size() > 1 && v.front() == v.back())
            v.pop_back();
        return v.size()*k + 1;
    }

    // calc nexts O(n^2)
    vl v2(n);
    for (int i = 0; i < n; i++) {
        v2[i] = next(v, i) - i;
    }

    // calc first loop O(n)
    vector<pi> was(n, {-1, -1});
    ll x = 0;
    int c = 0;
    while (true) {
        if (was[x%n].first != -1)
            break;
        was[x%n] = {x, c};
        x += v2[x%n];
        c++;
    }
    ll delta = x - was[x%n].first;
    x %= n;
    int dc = c - was[x].second;
    // 0 ->(was[x]) x ->(delta) -> x

    ll l = 0, r = 1e9;
    while (l < r) {
        ll m = (l + r + 1) / 2;
        if (was[x].first + delta*m < n*k)
            l = m;
        else
            r = m-1;
    }

    ll ans = was[x].second + l*dc;
    ll now = was[x].first + delta*l;
    while (now < n*k) {
        now = next(v, now);
        ans++;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k >> t;

    vi v;
    for (int i = 0; i < n; i++) {
        int a; cin >> a;
        if (!v.empty() && v.back() == a) continue;
        v.push_back(a);
    }
    n = v.size();

    cout << calc(v);
}
