#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
using namespace std;

const int maxn = 3e5 + 5, inf = 1e18, mod = 1e9 + 7;

struct TREE {
    vector <int> tree, f;

    TREE() {

    }

    TREE(int n) {
        tree.resize(4 * n);
        f.resize(4 * n);
    }



    void build(int l, int r, int h, vector <int> & a) {
        if (l + 1 == r) {
            tree[h] = a[l];
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        build(l, m, h1, a);
        build(m, r, h2, a);
        tree[h] = tree[h1] + tree[h2];
    }

    void upd(int l, int r, int h, int pos, int x) {
        if (l + 1 == r) {
            tree[h] = x;
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        if (pos < m) {
            upd(l, m, h1, pos, x);
        } else {
            upd(m, r,  h2, pos, x);
        }
        tree[h] = tree[h1] + tree[h2];
    }

    int get(int l, int r, int h, int tl, int tr) {
        if (tl <= l && r <= tr) {
            return tree[h];
        }
        if (tr <= l || r <= tl) {
            return 0;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        return get(l, m, h1, tl, tr) + get(m, r, h2, tl, tr);
    }

    int find_pos(int l, int r, int h, int x) {
        if (l + 1 == r) {
            return l;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        if (tree[h1] >= x) {
            return find_pos(l, m, h1, x);
        } else {
            return find_pos(m, r, h2, x - tree[h1]);
        }
    }

    TREE(vector <int> & a) {
        TREE(sz(a));
        build(0, sz(a), 0, a);
    }
};


vector <vector <pii> > sparse(31, vector <pii> (maxn));

void build_sparse(int n, vector <int> & nxt) {
    for (int i = 0; i < n; i++) {
        sparse[0][i] = {nxt[i], (nxt[i] < i)};
    }
    for (int pw = 1; pw < sz(sparse); pw++) {
        for (int i = 0; i < n; i++) {
            sparse[pw][i].x = sparse[pw - 1][sparse[pw - 1][i].x].x;
            sparse[pw][i].y = sparse[pw - 1][sparse[pw - 1][i].x].y + sparse[pw - 1][i].y;
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, k, t;
    cin >> n >> k >> t;
    vector <int> a(n);
    set <int> s;
    for (auto & e : a) {
        cin >> e;
        s.insert(e);
    }
    if (sz(s) <= t) {
        cout << "1\n";
    }
    vector <int> tmp = a;
//    reverse(all(tmp));
    for (int i = 0; i < n; i++) {
        tmp.emplace_back(tmp[i]);
    }
    s.clear();
    int r = 0;
    vector <int> nxt(sz(tmp));
    map <int, int> cnt;
    for (int l = 0; l < sz(tmp); l++) {
        while (r < sz(tmp) && sz(s) <= t) {
            s.insert(tmp[r]);
            cnt[tmp[r]]++;
            r++;
        }
        nxt[l] = (r - 1) % n;
        cnt[tmp[l]]--;
        if (!cnt[tmp[l]]) {
            s.erase(tmp[l]);
        }

    }
//    for (int i = 0; i < n; i++) {
//        cout << nxt[i] << " ";
//    }
//    cout << "\n\n";
    build_sparse(n, nxt);

    int ans = 0, h = 0;
    k--;
    for (int pw = sz(sparse) - 1; pw >= 0; pw--) {
        if (sparse[pw][h].y <= k) {
//            cout << pw << " " << sparse[pw][h].y << "\n";

            k -= sparse[pw][h].y;
            h = sparse[pw][h].x;
            ans += (1ll << pw);
        }
    }
    if (h) {
        ans++;
    }
    cout << ans;
//    TREE tree(sz(tmp));

}
