#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct SegmentTree {
    vector<ll> tree;

    ll merge(ll l, ll r) {
        return min(l, r);
    }

    void build(int v, int l, int r, vector<ll>& a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void modify(int v, int l, int r, int qi, ll qx) {
        if (qi < l || r <= qi) {
            return;
        }
        if (r - l == 1) {
            tree[v] = qx;
            return;
        }
        int mid = (l + r) / 2;
        modify(2 * v + 1, l, mid, qi, qx);
        modify(2 * v + 2, mid, r, qi, qx);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return INF;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        auto lres = get(2 * v + 1, l, mid, ql, qr);
        auto rres = get(2 * v + 2, mid, r, ql, qr);
        return merge(lres, rres);
    }
};

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a;
    for (int i = 0; i < n; ++i) {
        ll el;
        cin >> el;
        if (a.empty() || el != a.back()) {
            a.push_back(el);
        }
    }
    bool c = false;
    if (a[0] == a.back()) {
        if (a.size() == 1) {
            cout << "1\n";
            return;
        }
        c = true;
        a.pop_back();
    }
    n = a.size();
    vector<ll> nxt(a.size());
    int j = 0;
    map<ll, ll> cnt;
    for (int i = 0; i < n; ++i) {
        while (j - i < n && (cnt.contains(a[j % n]) || cnt.size() < t)) {
            cnt[a[j % n]]++;
            j++;
        }
        nxt[i] = j % n;
        cnt[a[i]]--;
        if (cnt[a[i]] == 0) {
            cnt.erase(a[i]);
        }
    }

    int i = 0;
    vector<bool> vis(n, false);
    ll loop_size = 0, loop_len = 0;
    int loop_end = 0;
    while (true) {
        vis[i] = true;
        loop_size++;
        if (nxt[i] <= i) {
            loop_len += nxt[i] + n - i;
        } else {
            loop_len += nxt[i] - i;
        }
        i = nxt[i];
        if (vis[i]) {
            loop_end = i;
            break;
        }
    }

    loop_len /= n;

    ll ans = loop_size * (k / loop_len);
    k %= loop_len;

    int cur = 0;
    while (k > 1) {
        ans++;
        if (nxt[cur] <= cur) {
            k--;
        }
        cur = nxt[cur];
    }
    if (k == 1) {
        if (c) {
            a.push_back(a[0]);
        }
        set<int> curnums;
        ans++;
        for (int j = cur; j < a.size(); ++j) {
            if (curnums.contains(a[j])) {
                continue;
            }
            if (curnums.size() == t) {
                curnums.clear();
                ans++;
            }
            curnums.insert(a[j]);
        }
    } else {
        if (c && cur == 0) {
            ans++;
        }
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
