#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct SegmentTree {
    vector<ll> tree;

    ll merge(ll l, ll r) {
        return min(l, r);
    }

    void build(int v, int l, int r, vector<ll>& a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void modify(int v, int l, int r, int qi, ll qx) {
        if (qi < l || r <= qi) {
            return;
        }
        if (r - l == 1) {
            tree[v] = qx;
            return;
        }
        int mid = (l + r) / 2;
        modify(2 * v + 1, l, mid, qi, qx);
        modify(2 * v + 2, mid, r, qi, qx);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return INF;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        auto lres = get(2 * v + 1, l, mid, ql, qr);
        auto rres = get(2 * v + 2, mid, r, ql, qr);
        return merge(lres, rres);
    }
};

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a;
    for (int i = 0; i < n; ++i) {
        ll el;
        cin >> el;
        if (a.empty() || el != a.back()) {
            a.push_back(el);
        }
    }
    bool c = false;
    if (false && a[0] == a.back()) {
        if (a.size() == 1) {
            cout << "1\n";
            return;
        }
        c = true;
        a.pop_back();
    }
    n = a.size();
    vector<ll> nxt(a.size());
    int j = 0;
    map<ll, ll> cnt;
    for (int i = 0; i < n; ++i) {
        while (j - i < n && (cnt.contains(a[j % n]) || cnt.size() < t)) {
            cnt[a[j % n]]++;
            j++;
        }
        nxt[i] = j % n;
        cnt[a[i]]--;
        if (cnt[a[i]] == 0) {
            cnt.erase(a[i]);
        }
    }

    if (nxt[0] == 0) {
        cout << "1\n";
        return;
    }

    ll ans = 0;

    int i = 0;
    vector<ll> vis(n, -1);
    vis[0] = 0;
    while (true) {
        ans++;
        if (nxt[i] <= i) {
            k--;
            if (k == 0) {
                cout << ans << "\n";
                return;
            }
        }
        if (vis[nxt[i]] != -1) {
            break;
        }
        vis[nxt[i]] = vis[i] + 1;
        i = nxt[i];
    }

    vis.assign(n, -1);
    vis[i] = 0;

    ll loop_size = 0, loop_len = 0;
    while (true) {
        loop_size++;
        if (nxt[i] <= i) {
            loop_len++;
        }
        if (vis[nxt[i]] != -1) {
            break;
        }
        vis[nxt[i]] = vis[i] + 1;
        i = nxt[i];
    }

    while (false && k > 2 * loop_len) {
        ans += loop_size;
        k -= loop_len;
//        ans += loop_size * (k / loop_len - 1);
//        k = (k % loop_len) + loop_len;
    }
    int cur = i;
//    while (k > 1) {
//        ans++;
//        if (nxt[cur] <= cur) {
//            k--;
//        }
//        cur = nxt[cur];
//    }
    if (c) {
        a.push_back(a[0]);
        if (cur == 0) {
            cur = n;
            k++;
        }
    }
    set<int> curnums;
    for (; cur < (ll)a.size() * k; ++cur) {
        if (curnums.empty()) {
            ans++;
        }
        if (curnums.contains(a[cur])) {
            continue;
        }
        if (curnums.size() == t) {
            curnums.clear();
            ans++;
        }
        curnums.insert(a[cur]);
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
