#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
using namespace std;

typedef long long ll;

ll n, k, t;
vector<ll> A, AA, B;
vector<ll> tree;
vector<vector<ll>> binup;
vector<vector<ll>> binup_dist;

void update(ll v, ll tl, ll tr, ll pos, ll val)
{
    if (tl == tr)
    {
        tree[v] = val;
    }else{
        ll tm = tl + tr >> 1;
        if (pos <= tm)
            update(v << 1, tl, tm, pos, val);
        else
            update(v << 1 | 1, tm + 1, tr, pos, val);
        tree[v] = tree[v << 1] + tree[v << 1 | 1];
    }
}

ll find_pos(ll v, ll tl, ll tr, ll sum, ll cur_sum = 0)
{
    if (tl == tr)
        return tl;
    ll tm = tl + tr >> 1;
    if (tree[v << 1] + cur_sum >= sum)
        return find_pos(v << 1, tl, tm, sum, cur_sum);
    return find_pos(v << 1 | 1, tm + 1, tr, sum, cur_sum + tree[v << 1]);
}

bool check(ll m)
{
    ll cnt = 0, v = 0;
    for (ll i = 59; i >= 0; i--)
    {
        if (m & (1LL << i))
        {
            cnt += binup_dist[v][i];
            v = binup[v][i];
        }
    }
    if (cnt >= k * n)
        return true;
    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    cin >> n >> k >> t;
    AA = vector<ll>(2 * n, 0);
    A = vector<ll>(n, 0);
    set<ll> C;
    for (ll i = 0; i < n; i++)
    {
        cin >> A[i];
        AA[i] = AA[i + n] = A[i];
        C.insert(A[i]);
    }
    if (C.size() <= t)
    {
        cout << 1 << '\n';
        return 0;
    }
    reverse(AA.begin(), AA.end());
    map<ll, ll> last_pos;
    binup = vector<vector<ll>>(n, vector<ll>(60, 0));
    binup_dist = vector<vector<ll>>(n, vector<ll>(60, 0));
    tree = vector<ll>(8 * n, 0);
    ll cnt = 0;
    for (ll i = 0; i < 2 * n; i++)
    {
        if (last_pos.count(AA[i]))
            update(1, 0, 2 * n - 1, last_pos[AA[i]], 0);
        else
            cnt++;
        last_pos[AA[i]] = i;
        update(1, 0, 2 * n - 1, i, 1);
        if (i >= n)
            binup[2 * n - 1 - i][0] = n - 1 - (find_pos(1, 0, 2 * n - 1, cnt - t) % n);
    }
    for (ll i = 0; i < n; i++)
    {
        binup_dist[i][0] = binup[i][0] - i;
        if (binup_dist[i][0] < 0)
            binup_dist[i][0] += n;
    }
    for (ll i = 1; i < 60; i++)
    {
        for (ll j = 0; j < n; j++)
        {
            binup[j][i] = binup[binup[j][i - 1]][i - 1];
            binup_dist[j][i] = binup_dist[j][i - 1] + binup_dist[binup[j][i - 1]][i - 1];
        }
    }
    ll l = 1, r = (n * k + t - 1) / t + 1, m;
    while (r - l > 1)
    {
        m = (l + r) >> 1LL;
        if (check(m))
            r = m;
        else
            l = m;
    }
    if (check(l))
        cout << l << '\n';
    else
        cout << r << '\n';
    return 0;
}