#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
using namespace std;

typedef long long ll;

const int K = 60;
ll n, k, t;
vector<int> A, AA, B;
vector<int> tree;
vector<int> binup[K];
vector<ll> binup_dist[K];

void update(int v, int tl, int tr, int pos, int val)
{
    if (tl == tr)
    {
        tree[v] = val;
    }else{
        int tm = tl + tr >> 1;
        if (pos <= tm)
            update(v << 1, tl, tm, pos, val);
        else
            update(v << 1 | 1, tm + 1, tr, pos, val);
        tree[v] = tree[v << 1] + tree[v << 1 | 1];
    }
}

int find_pos(int v, int tl, int tr, int sum, int cur_sum = 0)
{
    if (tl == tr)
        return tl;
    int tm = tl + tr >> 1;
    if (tree[v << 1] + cur_sum >= sum)
        return find_pos(v << 1, tl, tm, sum, cur_sum);
    return find_pos(v << 1 | 1, tm + 1, tr, sum, cur_sum + tree[v << 1]);
}

bool check(ll m)
{
    ll cnt = 0;
    int v = 0;
    for (ll i = K - 1; i >= 0; i--)
    {
        if (m & (1LL << i))
        {
            cnt += binup_dist[i][v];
            v = binup[i][v];
        }
    }
    if (cnt >= k * n)
        return true;
    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    cin >> n >> k >> t;
    AA = vector<int>(2 * n, 0);
    A = vector<int>(n, 0);
    set<int> C;
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
        AA[i] = AA[i + n] = A[i];
        C.insert(A[i]);
    }
    if (C.size() <= t)
    {
        cout << 1 << '\n';
        return 0;
    }
    reverse(AA.begin(), AA.end());
    map<int, int> last_pos;
    for (int i = 0; i < K; i++)
    {
        binup[i] = vector<int>(n, 0);
        binup_dist[i] = vector<ll>(n, 0);
    }
    tree = vector<int>(8 * n, 0);
    int cnt = 0;
    for (int i = 0; i < 2 * n; i++)
    {
        if (last_pos.count(AA[i]))
            update(1, 0, 2 * n - 1, last_pos[AA[i]], 0);
        else
            cnt++;
        last_pos[AA[i]] = i;
        update(1, 0, 2 * n - 1, i, 1);
        if (i >= n)
            binup[0][2 * n - 1 - i] = n - 1 - (find_pos(1, 0, 2 * n - 1, cnt - t) % n);
    }
    for (int i = 0; i < n; i++)
    {
        binup_dist[0][i] = binup[0][i] - i;
        if (binup_dist[0][i] < 0)
            binup_dist[0][i] += n;
    }
    for (int i = 1; i < 60; i++)
    {
        for (int j = 0; j < n; j++)
        {
            binup[i][j] = binup[i - 1][binup[i - 1][j]];
            binup_dist[i][j] = binup_dist[i - 1][j] + binup_dist[i - 1][binup[i - 1][j]];
        }
    }
    ll l = 1, r = (n * k + t - 1) / t + 1, m;
    while (r - l > 1)
    {
        m = (l + r) >> 1LL;
        if (check(m))
            r = m;
        else
            l = m;
    }
    if (check(l))
        cout << l << '\n';
    else
        cout << r << '\n';
    return 0;
}