#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
using namespace std;

struct cycle_arr {
    vector<int> els;

    cycle_arr(vector<int> a): els(a) {}

    int& operator[](int i) {
        return els[i % els.size()];
    }
};

pair<int, cycle_arr> init(int n, int k, int t) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<int> cpr;
    for (int i = 0; i < n; ++i)
        cpr.push_back(a[i]);
    sort(cpr.begin(), cpr.end());
    cpr.resize(unique(cpr.begin(), cpr.end()) - cpr.begin());
    int ut = cpr.size();
    for (int i = 0; i < n; ++i)
        a[i] = lower_bound(cpr.begin(), cpr.end(), a[i]) - cpr.begin();
    return {ut, a};
}

vector<int> get_next(cycle_arr a, int n, int t) {
    int r = 0;
    vector<int> cnts(n, 0);
    int nonzero_cnt = 0;
    vector<int> ans(n);
    for (int l = 0; l < n; ++l) {
        while (nonzero_cnt < t || cnts[a[r]] > 0) {
            if (++cnts[a[r++]] == 1)
                ++nonzero_cnt;
        }
        ans[l] = r % n;
        if (--cnts[a[l]] == 0)
            --nonzero_cnt;
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    auto [ut, a] = init(n, k, t);
    if (ut <= t) { cout << 1 << endl; return 0; }
    cycle_arr nt = get_next(a, n, t);
    int bx = 0;
    int i = 0;
    int ans = 0;
    while (bx < k) {
        if (nt[i] < i)
            ++bx;
        ++ans;
        i = nt[i];
    }
    cout << ans << endl;
}
