#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--------------------------------------------------------------//
#define int long long
#define pii pair<int, int>
#define ft first
#define sd second
/*
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")
*/
#define file_in freopen("input.txt", "r", stdin)
#define file_out freopen("output.txt", "w", stdout)
#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0);                   \
    cout.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(15)
//-------------------------------------------------------------------//
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--------------------------------------------------------------------//

struct mergesorttree {
    int size;
    vector< vector<int> > tree;

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, vector<int> ());
    }

    void UPD(int x) {
        int n = (int)tree[2 * x + 1].size();
        int m = (int)tree[2 * x + 2].size();
        int i = 0, j = 0;
        while (i < n || j < m) {
            if (i == n) {
                tree[x].push_back(tree[2 * x + 2][j]);
                ++j;
            } else if (j == m) {
                tree[x].push_back(tree[2 * x + 1][i]);
                ++i;
            } else if (tree[2 * x + 1][i] < tree[2 * x + 2][j]) {
                tree[x].push_back(tree[2 * x + 1][i]);
                ++i;
            } else {
                tree[x].push_back(tree[2 * x + 2][j]);
                ++j;
            }
        }
        return;
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (lx < (int)a.size()) {
                tree[x].push_back(a[lx]);
            }
            return;
        }
        int mx = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, mx);
        build(a, 2 * x + 2, mx, rx);
        UPD(x);
    }

    void build(vector<int> &a) {
        init((int)a.size());
        build(a, 0, 0, size);
    }

    int get_am(int l, int r, int y, int x, int lx, int rx) {
        if (r <= lx || rx <= l) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            int i = distance(tree[x].begin(), lower_bound(tree[x].begin(), tree[x].end(), y));
            return (int)tree[x].size() - i;
        }
        int mx = (lx + rx) / 2;
        int a = get_am(l, r, y, 2 * x + 1, lx, mx);
        int b = get_am(l, r, y, 2 * x + 2, mx, rx);
        return a + b;
    }

    int get_am(int l, int r, int y) {
        return get_am(l, r, y, 0, 0, size);
    }
};

signed main() {
    fast;
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    set<int> alltypes;
    for (int i = 0; i < n; ++i) alltypes.insert(a[i]);
    if ((int)alltypes.size() <= t) {
        cout << "1\n";
        return 0;
    }
    vector<int> b(2 * n);
    for (int i = 0; i < n; ++i) {
        b[i] = a[i];
        b[n + i] = a[i];
    }

    vector<int> next_right(2 * n);
    map<int, int> last_ind;
    for (int i = 2 * n - 1; i > -1; --i) {
        if (last_ind.count(b[i]) == 0) {
            last_ind[b[i]] = i;
            next_right[i] = 2 * n;
        } else {
            next_right[i] = last_ind[b[i]];
            last_ind[b[i]] = i;
        }
    }

    mergesorttree mst;
    mst.build(next_right);
    vector<int> follower(n);
    for (int i = 0; i < n; ++i) {
        int l = i + 1, r = 2 * n, m;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (mst.get_am(i, m, m) > t) {
                r = m;
            } else {
                l = m;
            }
        }
        follower[i] = l;
    }

    set<int> travels;
    int cur_top = 1;
    int cur_x = 0;
    int am = 0;
    while (cur_top <= k && travels.count(cur_x) == 0) {
        travels.insert(cur_x);
        ++am;
        if (follower[cur_x] >= n) {
            ++cur_top;
            cur_x = follower[cur_x] - n;
        } else {
            cur_x = follower[cur_x];
        }
    }
    if (cur_top > k) {
        cout << am << "\n";
        return 0;
    }

    int cctop = 1;
    int ccam = 0;
    int ccx = 0;
    while (ccx != cur_x) {
        ++ccam;
        if (follower[ccx] >= n) {
            ++cctop;
            ccx = follower[ccx] - n;
        } else {
            ccx = follower[ccx];
        }
    }
    int delta_top = cur_top - cctop;
    int delta_am = am - ccam;
    int Cycles = (k - cctop) / delta_top;
    int ans = ccam + delta_am * Cycles;


    int FFtop = Cycles * delta_top + cctop;
    int FFam = 0;
    int FFx = cur_x;
    while (FFtop <= k) {
        ++FFam;
        if (follower[FFx] >= n) {
            ++FFtop;
            FFx = follower[FFx] - n;
        } else {
            FFx = follower[FFx];
        }
    }
    ans += FFam;
    cout << ans << "\n";

    return 0;
}
