#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--------------------------------------------------------------//
#define int long long
#define pii pair<int, int>
#define ft first
#define sd second

#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")

#define file_in freopen("input.txt", "r", stdin)
#define file_out freopen("output.txt", "w", stdout)
#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0);                   \
    cout.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(15)
//-------------------------------------------------------------------//
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--------------------------------------------------------------------//

const int MAX = 3e5 + 10;
vector<int> next_right(2 * MAX);

struct Node {
    int s;
    Node* left = nullptr;
    Node* right = nullptr;
    Node(Node* left, Node*right): left(left), right(right), s(left->s + right->s){}
    Node(int v): s(v){}
};

Node* buildNull(int lx, int rx) {
    if (rx - lx == 1) {
        return new Node((ll)0);
    }
    int mx = (lx + rx) / 2;
    return new Node(buildNull(lx, mx), buildNull(mx, rx));
}

Node* update(Node* node, int lx, int rx, int i, int v) {
    if (rx - lx == 1) {
        return new Node(node->s + v);
    }
    int mx = (lx + rx) / 2;
    if (i < mx) return new Node(update(node->left, lx, mx, i, v), node->right);
    else return new Node(node->left, update(node->right, mx, rx, i, v));
}

int get_sum(Node* node, int lx, int rx, int l, int r) {
    if (r <= lx || rx <= l) {
        return 0;
    }
    if (l <= lx && rx <= r) {
        return node->s;
    }
    int mx = (lx + rx) / 2;
    int a = get_sum(node->left, lx, mx, l, r);
    int b = get_sum(node->right, mx, rx, l, r);
    return a + b;
}

signed main() {
    fast;
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    set<int> alltypes;
    for (int i = 0; i < n; ++i) alltypes.insert(a[i]);
    if ((int)alltypes.size() <= t) {
        cout << "1\n";
        return 0;
    }
    vector<int> b(2 * n);
    for (int i = 0; i < n; ++i) {
        b[i] = a[i];
        b[n + i] = a[i];
    }

    map<int, int> last_ind;
    for (int i = 2 * n - 1; i > -1; --i) {
        if (last_ind.count(b[i]) == 0) {
            last_ind[b[i]] = i;
            next_right[i] = 2 * n;
        } else {
            next_right[i] = last_ind[b[i]];
            last_ind[b[i]] = i;
        }
    }


    int size = 2 * MAX;
    vector<Node*> versions(2 * n + 1);
    versions[0] = buildNull(0, size);
    for (int i = 0; i < 2 * n; ++i) {
        versions[i + 1] = update(versions[i], 0, size, next_right[i], 1);
    }


    vector<int> follower(n);
    for (int i = 0; i < n; ++i) {
        int l = i + 1, r = 2 * n, m;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (get_sum(versions[m], 0, size, m, size) - get_sum(versions[i], 0, size, m, size) > t) {
                r = m;
            } else {
                l = m;
            }
        }
        follower[i] = l;
    }

    set<int> travels;
    int cur_top = 1;
    int cur_x = 0;
    int am = 0;
    while (cur_top <= k && travels.find(cur_x) == travels.end()) {
        travels.insert(cur_x);
        ++am;
        if (follower[cur_x] >= n) {
            ++cur_top;
            cur_x = follower[cur_x] - n;
        } else {
            cur_x = follower[cur_x];
        }
    }
    if (cur_top > k) {
        cout << am << "\n";
        return 0;
    }

    int cctop = 1;
    int ccam = 0;
    int ccx = 0;
    while (ccx != cur_x) {
        ++ccam;
        if (follower[ccx] >= n) {
            ++cctop;
            ccx = follower[ccx] - n;
        } else {
            ccx = follower[ccx];
        }
    }
    int delta_top = cur_top - cctop;
    int delta_am = am - ccam;
    int Cycles = (k - cctop) / delta_top;
    int ans = ccam + delta_am * Cycles;


    int FFtop = Cycles * delta_top + cctop;
    int FFam = 0;
    int FFx = cur_x;
    while (FFtop <= k) {
        ++FFam;
        if (follower[FFx] >= n) {
            ++FFtop;
            FFx = follower[FFx] - n;
        } else {
            FFx = follower[FFx];
        }
    }
    ans += FFam;
    cout << ans << "\n";

    return 0;
}
