#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
//#define int long long

random_device rd;
mt19937 rnd(rd());

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    ld x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ld operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vec<int> a(n);
    set<int> sta;
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mp[a[i]] = 0;
        sta.insert(a[i]);
    }
    int cnt = 0;
    for (auto it : mp) {
        mp[it.first] = (cnt++);
    }
    if ((int) sta.size() <= t) {
        cout << 1 << endl;
        return;
    }
    int j = 0;
    int k_ = 0;
    vec<vec<pair<int, int>>> p(n, vec<pair<int, int>>(50));
    vec<int> us(n + 1);
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            us[a[i - 1]]--;
            if (us[a[i - 1]] == 0) c--;
        }
        if (i == j) {
            us[a[i]]++;
            if (us[a[i]] == 1) c++;
        }
        if (k_ == 0 && i == j) {
            if (i + 1 == n) {
                k_++;
            }
            j = (j + 1) % n;
        }
        while (true) {
            us[a[j]]++;
            if (us[a[j]] == 1) c++;
            if (c > t) {
                us[a[j]]--;
                c--;
                break;
            }
            j++;
            if (j == n) {
                k_++;
                j = 0;
            }
        }
        p[i][0] = {k_, j};
    }
    for (int lg = 1; lg < 50; ++lg) {
        for (int i = 0; i < n; ++i) {
            p[i][lg] = {min(k + 1, p[i][lg - 1].first + p[p[i][lg - 1].second][lg - 1].first),
                        p[p[i][lg - 1].second][lg - 1].second};
        }
    }
    int ind = 0;
    ll cnt2 = 0;
    for (int lg = 49; lg >= 0; --lg) {
        if (p[ind][lg].first < k) {
            //cout << ind << " " << lg << " " << p[ind][lg].first << " " << p[ind][lg].second << endl;
            k -= p[ind][lg].first;
            ind = p[ind][lg].second;
            cnt2 += (1ll << lg);
        }
    }
    cout << cnt2 + 1 << endl;
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    //cout << ((3e14) < (1ll << 49)) << endl;
    for (; t > 0; --t) {
        solve();
    }
}