#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

#define int long long

using pii = pair<int, int>;

struct node {
    int val, prior, l, r;
    explicit node(int val1 = 0) {
        val = val1;
        prior = (rand() << 15) + rand();
        l = -1;
        r = -1;
    }
};

vector<node> dd;

int merge(int l, int r) {
    if (l == -1) return r;
    if (r == -1) return l;
    if (dd[l].prior < dd[r].prior) {
        l = merge(dd[l].r, r);
        return l;
    } else {
        r = merge(l, dd[r].l);
        return r;
    }
}

pii split(int p, int x) {
    if (p == -1) return {-1, -1};
    if (dd[p].prior <= x) {
        auto [l, r] = split(dd[p].r, x);
        dd[p].r = l;
        return {p, r};
    } else {
        auto [l, r] = split(dd[p].l, x);
        dd[p].l = r;
        return {l, p};
    }
}

int insert(int p, int x) {
    auto [l, r] = split(p, x);
    int id = dd.size();
    dd.emplace_back(x);
    p = merge(l, merge(id, r));
    return p;
}

void check(int p) {
    if (p == -1) return;
    check(dd[p].l);
    cout << dd[p].val << endl;
    check(dd[p].r);
}

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < k - 1; i++) {
        for (int j = 0; j < n; j++) {
            a.push_back(a[j]);
        }
    }
    n = a.size();
    vector<int> b = {a[0]};
    for (int i = 1; i < n; i++) {
        if (a[i] != b.back()) {
            b.push_back(a[i]);
        }
    }
    set<int> s;
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (s.size() == t) {
            s.clear();
            res++;
        }
        s.insert(a[i]);
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
