#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<long long, long long>;

struct el {
    int v, l, r;
    explicit el(int v1 = 0, int l1 = 0, int r1 = 0) {
        v = v1, l = l1, r = r1;
    }
};

vector<el> segs;

struct mst {
    vector<vector<int>> tree;
    vector<int> a;
    mst(vector<int> a1) {
        a = a1;
        tree.resize(4 * a.size() + 10);
    }
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        for (auto i : tree[2 * v + 1]) {
            tree[v].push_back(i);
        }
        for (auto i : tree[2 * v + 2]) {
            tree[v].push_back(i);
        }
        std::sort(tree[v].begin(), tree[v].end());
    }
    void split(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            segs.emplace_back(v, l, r);
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        int m = (l + r) / 2;
        split(2 * v + 1, l, m, ql, qr);
        split(2 * v + 2, m, r, ql, qr);
    }
    int calc(int v, int x) {
        int l = -1, r = tree[v].size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (tree[v][m] <= x) {
                l = m;
            } else {
                r = m;
            }
        }
        return r;
    }
    int spusk(int v, int l, int r, int mn, int x) {
        if (r - l == 1) {
            return l;
        }
        int m = (l + r) / 2;
        int temp = calc(2 * v + 1, mn);
        if (temp >= x) {
            return spusk(2 * v + 1, l, m, mn, x);
        } else {
            return spusk(2 * v + 2, m, r, mn, x - temp);
        }
    }
};

vector<int> compr(vector<int> a) {
    int n = a.size();
    vector<int> b = a;
    std::sort(b.begin(), b.end());
    vector<int> res;
    for (int i = 0; i < n; i++) {
        int l = -1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (b[m] <= a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        res.push_back(l);
    }
    return res;
}

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (1) {
        vector<int> b = {a[0]};
        for (int i = 1; i < n; i++) {
            if (a[i] != b.back()) {
                b.push_back(a[i]);
            }
        }
        a = b;
        n = a.size();
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }
    if (1) {
        set<int> s;
        for (int i = 0; i < n; i++) {
            s.insert(a[i]);
        }
        if (s.size() <= t) {
            cout << 1;
            return;
        }
    }
    a = compr(a);
    vector<int> pr(2 * n), pos(n + 10, -1);
    for (int i = 0; i < 2 * n; i++) {
        pr[i] = pos[a[i]];
        pos[a[i]] = i;
    }
    mst tree(pr);
    tree.build(0, 0, 2 * n);
    vector<pll> id(n, {-1, -1});
    int temp = 0;
    id[0] = {0, 0};
    ll cnt = 0;
    ll len = 0;
    for (int i = 0; i > -1; i++) {
        int ql = temp, qr = 2 * n;
        segs = {};
        tree.split(0, 0, 2 * n, ql, qr);
        int x = t + 1;
        for (auto j : segs) {
            if (tree.calc(j.v, i - 1) <= x) {
                int b = tree.spusk(j.v, j.l, j.r, i - 1, x);
                len += b + 1 - temp;
                temp = b;
                if (len >= n * k) {
                    cout << i+1;
                    return;
                }
                break;
//                if (len >= b + n - )
//                if (id[b % n].first != -1) {
//
//                    return;
//                }
//                break;
            }
            x -= tree.calc(j.v, i - 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
