#include <iostream>
#include <iomanip>
#include <vector>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

int n, k, t;
vector<int> a;

namespace solve2 {
    void solve() {
        ll count = 0;
        RANGE(i, n - 1) {
            count += a[i] != a[i + 1];
        }
        count *= k;
        if (a[0] != a[n - 1]) {
            count += k - 1;
        }
        cout << (count + t) / t << ENDLINE;
    }
}

namespace solve13 {
    void solve() {
        ll ans = 1;
        set<int> has = {a[0]};
        int t1 = t - 1;
        for (int i = 1, j = 0; j < k; i++, j += (i == n), i -= n * (i == n)) {
            if (has.find(a[i]) == has.end()) {
                if (t1) {
                    t1--;
                } else {
                    ans++;
                    t1 = t - 1;
                    has.clear();
                }
                has.insert(a[i]);
            }
        }
        cout << ans << ENDLINE;
    }
}

namespace solve4 {
    void solve() {
        vector<int> sk(n);
        multiset<int> ms = {a[0]};
        set<int> s = {a[0]};
        int j = 1;
        for (int i = 0; i < n; i++) {
            while (true) {
                if (s.find(a[j]) != s.end()) {
                    ms.insert(a[j]);
                    j++;
                } elif (s.size() < t) {
                    s.insert(a[j]);
                    ms.insert(a[j]);
                    j++;
                } else {
                    sk[i] = j;
                    break;
                }
                if (j == n) {
                    j = 0;
                }
                if (j == i) {
                    cout << 1 << ENDLINE;
                    return;
                }
            }
            auto it = ms.find(a[i]);
            if (it != ms.end()) {
                ms.erase(it);
            } else {
                int x = 0;
            }
            if (ms.find(a[i]) == ms.end()) {
                s.erase(a[i]);
            }
        }
        ll ans = 0;
        int i = 0;
        j = 0;
        while (j < k) {
            if (sk[i] < i) {
                j++;
            }
            i = sk[i];
            ans++;
        }
        cout << ans << ENDLINE;
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cin >> n >> k >> t;
    a.reserve(n);
    int last;
    cin >> last;
    a.push_back(last);
    RANGE(i, n - 1) {
        int tmp;
        cin >> tmp;
        if (tmp != last) {
            last = tmp;
            a.push_back(last);
        }
    }
    n = a.size();
//    solve4::solve();
//    return 0;
    if (n == 1) {
        cout << 1 << ENDLINE;
    } elif (t == 1) {
        solve2::solve();
    } elif (n <= 1000 && k <= 1000) {
        solve13::solve();
    } else {
        solve4::solve();
    }
}
