#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2000 + 1, W = 40'000 + 2 + N, inf = 1e9 + 7;

int dp[2][N][W];
int pref[N], w[N];
int prec[2][W];

int rangeSum(int l, int r) {
    return l > r ? 0 : pref[r] - (l == 0 ? 0 : pref[l - 1]);
}

// returns the max player "m" can get if player "m^1" ate and now the time capacity is d
int solve(int l, int r, int d, int m) {
    if (l > r) {
        return 0;
    }
    if (d == 0 && m == 1 || d < 0) {
        return inf;
    }
    int w_sum = pref[r] + d + r;
    if (dp[m][l][w_sum] != -1) {
        return dp[m][l][w_sum];
    }
    int &res = dp[m][l][w_sum];
    int most = d + (m == 1 ? -1 : 0); // the most we can eat so that the move will stay ours
    int seg_sum = rangeSum(l, r);
    if (seg_sum <= most) {
        return res = seg_sum;
    }
    // 0: we take l and move won't go to m^1
    if (w[l] <= most) {
        res = max(res, w[l] + solve(l + 1, r, d - w[l], m));
    }
    // 1: we take l and the move will go to m^1
    int r_, sum_r;
    if (prec[m][w_sum] == -1) {
        r_ = r, sum_r = 0;
        while (r_ >= l && sum_r <= most) {
            sum_r += w[r_--];
        }
        r_ += 1;
        sum_r -= w[r_];
        prec[m][w_sum] = r_;
    }
    r_ = prec[m][w_sum];
    sum_r = rangeSum(r_ + 1, r);
    if (sum_r + w[l] > most) {
        res = max(res, rangeSum(l + 1, r_) - solve(l + 1, r_, (sum_r + w[l]) - d, m ^ 1) + sum_r + w[l]);
    }
    // 2: we don't take l
    sum_r += w[r_--];
    res = max(res, rangeSum(l, r_) - solve(l, r_, sum_r - d, m ^ 1) + sum_r);
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    memset(dp, -1, sizeof(dp));
    memset(prec, -1, sizeof(prec));

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < n; ++i) {
        pref[i] = (i > 0 ? pref[i - 1] : 0) + w[i];
    }

    int ans = rangeSum(1, n - 1) - solve(1, n - 1, w[0], 1) + w[0];
    ans = max(ans, rangeSum(0, n - 2) - solve(0, n - 2, w[n - 1], 1) + w[n - 1]);
    cout << ans << " " << pref[n - 1] - ans << '\n';

    return 0;
}