#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

pair<int, int> solve(int n, vector<int> &a) {
    vector<int> srt = a;
    sort(all(srt));
    srt.erase(unique(all(srt)), srt.end());
    int m = (int)srt.size();
    vector<vector<vector<vector<pair<int, int>>>>> dp(n, vector<vector<vector<pair<int, int>>>> (n, vector<vector<pair<int, int>>> (m, vector<pair<int, int>> (2, {-inf, -inf}))));
    for (int l = 0; l<n; ++l) {
        for (int i = 0; i<m; ++i) {
            dp[l][l][i][0] = {a[l], 0};
            dp[l][l][i][1] = {0, a[l]};
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l+len <= n; ++l) {
            int r = l + len - 1;
            for (int i = 0; i<m; ++i) {
                if (i > a[r]) {
                    pair<int, int> p1 = dp[l][r-1][i-a[r]][0], p2 = dp[l][r-1][i-a[r]][1];
                    dp[l][r][i][0] = {p1.first + a[r], p1.second};
                    dp[l][r][i][1] = {p2.first, p2.second + a[r]};
                } else if (i < a[r]) {
                    pair<int, int> p1 = dp[l][r-1][a[r]-i][1], p2 = dp[l][r-1][a[r]-i][0];
                    dp[l][r][i][0] = {p1.first + a[r], p1.second};
                    dp[l][r][i][1] = {p2.first, p2.second + a[r]};
                } else {
                    pair<int, int> p = dp[l][r-1][0][0];
                    dp[l][r][i][0] = {p.first + a[r], p.second};
                    dp[l][r][i][1] = {p.first, p.second + a[r]};
                }
                if (i > a[l]) {
                    pair<int, int> p1 = dp[l+1][r][i-a[l]][0], p2 = dp[l+1][r][i-a[l]][1];
                    if (p1.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else if (i < a[l]) {
                    pair<int, int> p1 = dp[l+1][r][a[l]-i][1], p2 = dp[l+1][r][a[l]-i][0];
                    if (p1.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else {
                    pair<int, int> p = {dp[l+1][r][0][0]};
                    if (p.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p.first + a[l], p.second};
                    }
                    if (p.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p.first, p.second + a[l]};
                    }
                }
            }
        }
    }
    return dp[0][n-1][0][0];
}

pair<int, int> stupid_solve(int n, vector<int> &a) {
    if (a[2] > a[0] + a[1]) {
        return {a[2], a[0] + a[1]};
    } else {
        return {a[0] + a[1], a[2]};
    }
}

pair<int, int> f(int l, int r, int lsta, int lstb, int resa, int resb, vector<int> &a) {
    while (l <= r) {
        if (lsta) {
            while (l <= r && lsta - a[l] >= 0) {
                lsta -= a[l];
                resb += a[l];
                l++;
            }
            if (l <= r) {
                lstb = a[r] - lsta;
                lsta = 0;
                resb += a[r];
                r--;
            }
        } else {
            while (l <= r && lstb - a[l] >= 0) {
                lstb -= a[l];
                resa += a[l];
                l++;
            }
            if (l <= r) {
                lsta = a[r] - lstb;
                lstb = 0;
                resa += a[r];
                r--;
            }
        }
    }
    return {resa, resb};
}

pair<int, int> solve(int n, vector<int> &a, int lsta, int lstb, int suma, int sumb, int l) {
    if (l == n) {
        return {suma, sumb};
    }
    if (l&1) {
        pair<int, int> p1 = f(l, n-2, 0, a[n-1] - lsta, suma, sumb + a[n-1], a);
        pair<int, int> p2 = solve(n, a, 0, a[l] - lsta, suma, sumb + a[l], l+1);
        return (p1.second > p2.second ? p1 : p2);
    }
    pair<int, int> p1 = f(l, n-2, a[n-1] - lstb, 0, suma + a[n-1], sumb, a);
    pair<int, int> p2 = solve(n, a, a[l] - lstb, 0, suma + a[l], sumb, l+1);
    return (p1.first > p2.first ? p1 : p2);
}

pair<int, int> solve2(int n, vector<int> &a) {
    return solve(n, a, 0, 0, 0, 0, 0);
    int suma = 0, sumb = 0;
    for (int i = 0; i<n; ++i) {
        (i&1 ? sumb : suma) += a[i];
    }

    for (int i = n-1; i >= 0; --i) {

    }
    pair<int, int> p1 = f(1, n-1, a[0], 0, a[0], 0, a);
    pair<int, int> p2 = f(0, n-2, a[n-1], 0, a[n-1], 0, a);
    return (p1.first > p2.first ? p1 : p2);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    while (true) {
//        int n = 3;
//        vector<int> a(3);
//        for (int i = 0; i<3; ++i) a[i] = rand()%20000 + 1;
//        sort(all(a));
//        if (stupid_solve(n, a) != solve(n, a)) {
//            cout << "WA\n";
//            cout << n << '\n';
//            print(a);
//            cout << stupid_solve(n, a) << '\n';
//            cout << solve(n, a) << endl;
//        }
//    }
    int n; cin >> n;
    vector<int> a(n); input(a);
    cout << solve2(n, a) << '\n';
    return 0;
}

//fft