#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5, K = 500;
const long double eps = 1e-9;

pair<int, int> solve(int n, vector<int> &a) {
    vector<vector<vector<vector<pair<int, int>>>>> dp(2, vector<vector<vector<pair<int, int>>>> (n, vector<vector<pair<int, int>>> (K+1, vector<pair<int, int>> (2, {-inf, -inf}))));
    for (int l = 0; l<n; ++l) {
        for (int i = 0; i<=K; ++i) {
            dp[0][l][i][0] = {a[l], 0};
            dp[0][l][i][1] = {0, a[l]};
        }
    }
    for (int it = 2; it <= n; ++it) {
        for (int l = 0; l+it <= n; ++l) {
            int r = l + it - 1, len = 1;
            for (int i = 0; i<=K; ++i) {
                if (i > a[r]) {
                    pair<int, int> p1 = dp[len-1][l][i-a[r]][0], p2 = dp[len-1][l][i-a[r]][1];
                    dp[len][l][i][0] = {p1.first + a[r], p1.second};
                    dp[len][l][i][1] = {p2.first, p2.second + a[r]};
                } else if (i < a[r]) {
                    pair<int, int> p1 = dp[len-1][l][a[r]-i][1], p2 = dp[len-1][l][a[r]-i][0];
                    dp[len][l][i][0] = {p1.first + a[r], p1.second};
                    dp[len][l][i][1] = {p2.first, p2.second + a[r]};
                } else {
                    pair<int, int> p = dp[len-1][l][0][0];
                    dp[len][l][i][0] = {p.first + a[r], p.second};
                    dp[len][l][i][1] = {p.first, p.second + a[r]};
                }
                if (i > a[l]) {
                    pair<int, int> p1 = dp[len-1][l+1][i-a[l]][0], p2 = dp[len-1][l+1][i-a[l]][1];
                    if (p1.first + a[l] > dp[len][l][i][0].first) {
                        dp[len][l][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[len][l][i][1].second) {
                        dp[len][l][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else if (i < a[l]) {
                    pair<int, int> p1 = dp[len-1][l+1][a[l]-i][1], p2 = dp[len-1][l+1][a[l]-i][0];
                    if (p1.first + a[l] > dp[len][l][i][0].first) {
                        dp[len][l][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[len][l][i][1].second) {
                        dp[len][l][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else {
                    pair<int, int> p = {dp[len-1][l+1][0][0]};
                    if (p.first + a[l] > dp[len][l][i][0].first) {
                        dp[len][l][i][0] = {p.first + a[l], p.second};
                    }
                    if (p.second + a[l] > dp[len][l][i][1].second) {
                        dp[len][l][i][1] = {p.first, p.second + a[l]};
                    }
                }
            }
        }
        dp[0] = dp[1];
    }
    return dp[0][0][0][0];
}

pair<int, int> stupid_solve(int n, vector<int> &a) {
    if (a[2] > a[0] + a[1]) {
        return {a[2], a[0] + a[1]};
    } else {
        return {a[0] + a[1], a[2]};
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    while (true) {
//        int n = 3;
//        vector<int> a(3);
//        for (int i = 0; i<3; ++i) a[i] = rand()%20000 + 1;
//        sort(all(a));
//        if (stupid_solve(n, a) != solve(n, a)) {
//            cout << "WA\n";
//            cout << n << '\n';
//            print(a);
//            cout << stupid_solve(n, a) << '\n';
//            cout << solve(n, a) << endl;
//        }
//    }
    int n; cin >> n;
    vector<int> a(n); input(a);
    cout << solve(n, a) << '\n';
    return 0;
}

//fft