#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e9;
const int MAXN = 1e5;
int MAXW = 0;

void solve() {
    int n, g;
    std::cin >> n;
    std::vector<int> w(n);
    int S = 0;
    for (auto &e : w) {
        std::cin >> e;
        S += e;
        MAXW = std::max(MAXW, e + 1);
    }
    std::vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + w[i];
    }
    auto get = [&](int i, int j) {
        return pref[j] - pref[i];
    };
    std::vector<std::vector<std::unordered_map<int, int>>> dp(n + 1, std::vector<std::unordered_map<int, int>>(n + 1));
    dp[0][n][0] = -1;
    if (g >= 5) {
        for (int len = 1; len <= n; len++) {
            for (int i = 0; i + len <= n; i++) {
                int j = i + len;
                int W = std::max(w[i], w[j - 1]);
                for (int b = -W; b <= W; b++) {
                    if (b < 0) {
                        dp[i][j][b] = std::min(dp[i + 1][j][b + w[i]], dp[i][j - 1][b + w[j - 1]]);
                    } else {
                        dp[i][j][b] = std::max(dp[i + 1][j][b - w[i]] + w[i], dp[i][j - 1][b - w[j - 1]] + w[j - 1]);
                    }
                }
            }
        }
    } else {
        dp[0][n][0] = -1;
        for (int len = n; len > 0; len--) {
            for (int i = 0; i + len <= n; i++) {
                int j = i + len;
                for (auto [b, val] : dp[i][j]) {
                    if (b < 0) {
                        dp[i + 1][j][b + w[i]] = 0;
                        dp[i][j - 1][b + w[j - 1]] = 0;
                    } else {
                        dp[i + 1][j][b - w[i]] = 0;
                        dp[i][j - 1][b - w[j - 1]] = 0;
                    }
                }
            }
        }
        for (int len = 1; len <= n; len++) {
            for (int i = 0; i + len <= n; i++) {
                int j = i + len;
                int W = std::max(w[i], w[j - 1]);
                for (auto &[b, val] : dp[i][j]) {
                    if (b < 0) {
                        val = std::min(dp[i + 1][j][b + w[i]], dp[i][j - 1][b + w[j - 1]]);
                    } else {
                        val = std::max(dp[i + 1][j][b - w[i]] + w[i], dp[i][j - 1][b - w[j - 1]] + w[j - 1]);
                    }
                }
            }
        }
    }
    int ans = dp[0][n][0];
    std::cout << ans << ' ' << S - ans;
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
