#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#ifdef DEBUG
const int N = 100;
const int W = 101;
#else
const int N = 500;
const int W = 1001;
#endif

int dp[2][N][N][W];

void smin(int& a, int b) {
    a = min(a, b);
}

void smax(int& a, int b) {
    a = max(a, b);
}

int n;
vector<int> w;

int save[2][2000][2000][3];
bool NEED = false;

int rec(int l, int r, int time, int turn) {
    if (NEED) {
        if (save[turn][l][r][time] > -1)
            return save[turn][l][r][time];
    }
    if (turn == 0) {
        if (l == r)
            return w[l];
        int s1, s2;
        int t = time - w[l];
        s1 = rec(l + 1, r, abs(t), t < 0) + w[l];
        t = time - w[r];
        s2 = rec(l, r - 1, abs(t), t < 0) + w[r];
        if (NEED)
            save[turn][l][r][time] = max(s1, s2);
        return max(s1, s2);
    } else {
        if (l == r)
            return 0;
        int s1, s2;
        int t = time - w[l];
        s1 = rec(l + 1, r, abs(t), t > 0);
        t = time - w[r];
        s2 = rec(l, r - 1, abs(t), t > 0);
        if (NEED)
            save[turn][l][r][time] = min(s1, s2);
        return min(s1, s2);
    }
}

int rec1(int l, int r, int time, int turn) {
    if (dp[turn][l][r][time] > -1)
        return dp[turn][l][r][time];
    if (turn == 0) {
        if (l == r)
            return w[l];
        int s1, s2;
        int t = time - w[l];
        s1 = rec(l + 1, r, abs(t), t < 0) + w[l];
        t = time - w[r];
        s2 = rec(l, r - 1, abs(t), t < 0) + w[r];
        dp[turn][l][r][time] = max(s1, s2);
        return max(s1, s2);
    }
    else {
        if (l == r)
            return 0;
        int s1, s2;
        int t = time - w[l];
        s1 = rec(l + 1, r, abs(t), t > 0);
        t = time - w[r];
        s2 = rec(l, r - 1, abs(t), t > 0);
        dp[turn][l][r][time] = min(s1, s2);
        return min(s1, s2);
    }
}

inline void solve1() {
    int sum = accumulate(all(w), 0);
    int res = rec(0, n - 1, 0, 0);
    cout << res << ' ' << sum - res << '\n';
}

inline void solve2() {
    NEED = true;
    for (auto& i : save)
        for (auto& j : i)
            for (auto& k : j)
                for (auto& l : k)
                    l = -1;
    int sum = accumulate(all(w), 0);
    int res = rec(0, n - 1, 0, 0);
    cout << res << ' ' << sum - res << '\n';
}

inline void solve() {
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    if (n <= 20) {
        solve1();
        return;
    }
    if (w.back() <= 2) {
        solve2();
        return;
    }
    int sum = accumulate(all(w), 0);
    /*
    for (int i = 0; i < n; i++)
        for (int t = 0; t <= w.back(); t++)
            dp[0][i][i][t] = w[i];
    for (int l = n - 1; l > -1; l--)
        for (int r = l + 1; r < n; r++) {
            for (int t = 0; t <= w.back(); t++) {
                int tp = t - w[l];
                if (tp >= 0) {
                    if (tp <= w.back())
                        smax(dp[0][l][r][t], dp[0][l + 1][r][tp] + w[l]);
                }
                else {
                    if (-tp <= w.back())
                        smax(dp[0][l][r][t], dp[1][l + 1][r][-tp] + w[l]);
                }
                tp = t - w[r];
                if (tp >= 0) {
                    if (tp <= w.back())
                        smax(dp[0][l][r][t], dp[0][l][r - 1][tp] + w[r]);
                }
                else {
                    if (-tp <= w.back())
                        smax(dp[0][l][r][t], dp[1][l][r - 1][-tp] + w[r]);
                }
                smin(dp[0][l][r][t], sum + 1);
            }
            for (int t = 1; t <= w.back(); t++) {
                int tp = t - w[l];
                dp[1][l][r][t] = sum + 1;
                if (tp > 0) {
                    if (tp <= w.back())
                        smin(dp[1][l][r][t], dp[1][l + 1][r][tp]);
                }
                else {
                    if (-tp <= w.back())
                        smin(dp[1][l][r][t], dp[0][l + 1][r][-tp]);
                }
                tp = t - w[r];
                if (tp > 0) {
                    if (tp <= w.back())
                        smin(dp[1][l][r][t], dp[1][l][r - 1][tp]);
                }
                else {
                    if (-tp <= w.back())
                        smin(dp[1][l][r][t], dp[0][l][r - 1][-tp]);
                }
            }
        }
        */
    for (auto& i : dp)
        for (auto& j : i)
            for (auto& k : j)
                for (auto& l : k)
                    l = -1;
    rec1(0, n - 1, 0, 0);
    cout << dp[0][0][n - 1][0] << ' ' << sum - dp[0][0][n - 1][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
