#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}

struct ev{
    int a, b, w;
    int ind;
};

bool operator < (ev a, ev b) {
    return a.ind < b.ind;
}

struct comb{
    int l, r;
    int a, b;
};

bool operator < (comb a, comb b) {
    if (a.a != b.a) {
        return a.a < b.a;
    }
    if (a.b != b.b) {
        return a.b < b.b;
    }
    if (a.l != b.l) {
        return a.l < b.l;
    }
    //if (a.r != b.r) {
        return a.r < b.r;
    //}
    //return a.last < b.last;
}

void solve() {
    int n;
    cin >> n;
    vector<int> w(n);
    int s = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        s += w[i];
    }
    map<pii, set<pii>> dp;
    deque<comb> dq;
    dq.push_back({-1, n, 0, 0});
    vector<pii>ord;
    while (dq.size() > 0) {
        auto [l, r, a, b] = dq[0];
        ord.push_back({a, b});
        dq.pop_front();
        if (r - l == 1) continue;
        if (a <= b) {
            if (dp[{ a, b}].find({a + w[l + 1], b}) == dp[{ a, b}].end()) {
                dp[{a, b}].insert({ a + w[l + 1], b});
                dq.push_back({l + 1, r, a + w[l + 1], b});
            }
            if (dp[{a, b}].find({ a + w[r - 1], b}) == dp[{ a, b}].end()) {
                dp[{a, b}].insert({a + w[r - 1], b});
                dq.push_back({l, r - 1, a + w[r - 1], b});
            }
        } else {
            if (dp[{a, b}].find({ a, b + w[l + 1]}) == dp[{ a, b}].end()) {
                dp[{ a, b}].insert({ a, b + w[l + 1]});
                dq.push_back({l + 1, r, a, b + w[l + 1]});
            }
            if (dp[{a, b}].find({a , b+ w[r - 1]}) == dp[{ a, b}].end()) {
                dp[{ a, b}].insert({a, b + w[r - 1]});
                dq.push_back({l, r - 1, a, b + w[r - 1]});
            }
        }
    }

    reverse(ord.begin(), ord.end());
    map<pii, pii> res;
    for (auto [a, b] : ord) {
        if (res.find({a, b}) != res.end()) continue;
        if (s == a + b) {
            res[{a, b}] = {a, b};
            continue;
        }
        if (a <= b) {
            res[{a, b}] = { -inf, -inf};
        }
        if (a > b) {
            res[{a, b}] = {inf, inf};
        }
        for (auto to : dp[{a, b}]) {
            if (a <= b) {
                if (res[{a, b}] < res[to]) {
                    res[{a, b}] = res[to];
                }
            } else {
                if (res[to] < res[{ a, b}]) {
                    res[{ a, b}] = res[to];
                }
            }
        }
    }
    cout << res[{0, 0}].first << " " << res[{0, 0}].second;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
