#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const ll MAXW = 20000;

void random(ll n, vector<ll> a) {
    ll sum = 0;
    for (auto i : a) sum += i;

    bitset<MAXW + 1> st;
    st[0] = 1;

    for (auto i : a) {
        st |= (st << i);
    }

    for (ll i = (sum + 1) / 2; i <= sum; ++i) {
        if (st[i] == 1) {
            cout << i << ' ' << sum - i << endl;
            return;
        }
    }
}

void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    bool flag = true;

    for (ll i = 0; i + 1 < n; ++i) {
        if (a[i + 1] > 2 * a[i]) {
            flag = false;
            break;
        }
    }

    if (flag) {
        random(n, a);
        return;
    }

    ll W = a.back();

    pair<ll, ll> dp_a[n][n][W + 1], dp_b[n][n][W + 1];

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j <= W; ++j) {
            dp_a[i][i][j] = {a[i], 0};
            if (j > 0) dp_b[i][i][j] = {0, a[i]};
        }
    }

    for (ll lenn = 2; lenn <= n; ++lenn) {
        for (ll left = 0; left + lenn <= n; ++left) {
            ll right = left + lenn - 1;

            for (ll i = 0; i <= W; ++i) {
                if (a[left] <= i) {
                    auto gh = dp_a[left + 1][right][i - a[left]];
                    dp_a[left][right][i] = {gh.first + a[left], gh.second};
                }
                else {
                    auto gh = dp_b[left + 1][right][a[left] - i];
                    dp_a[left][right][i] = {gh.first + a[left], gh.second};
                }
            }
            for (ll i = 1; i <= W; ++i) {
                if (a[left] < i) {
                    auto gh = dp_b[left + 1][right][i - a[left]];
                    dp_b[left][right][i] = {gh.first, gh.second + a[left]};
                }
                else {
                    auto gh = dp_a[left + 1][right][a[left] - i];
                    dp_b[left][right][i] = {gh.first, gh.second + a[left]};
                }

//                if (left == 1 && right == 3 && i == 1) {
//                    cout << "? " << dp_b[left][right][i].first << ' ' << dp_b[left][right][i].second << endl;
//                }
            }

            ///////////////////////

            for (ll i = 0; i <= W; ++i) {
                if (a[right] <= i) {
                    auto gh = dp_a[left][right - 1][i - a[right]];
                    if (gh.first + a[right] > dp_a[left][right][i].first) {
                        dp_a[left][right][i] = {gh.first + a[right], gh.second};
                    }
                }
                else {
                    auto gh = dp_b[left][right - 1][a[right] - i];
                    if (gh.first + a[right] > dp_a[left][right][i].first) {
                        dp_a[left][right][i] = {gh.first + a[right], gh.second};
                    }
                }
            }
            for (ll i = 1; i <= W; ++i) {
                if (a[right] < i) {
                    auto gh = dp_b[left][right - 1][i - a[right]];
                    if (gh.second + a[right] > dp_b[left][right][i].second) {
                        dp_b[left][right][i] = {gh.first, gh.second + a[right]};
                    }
                }
                else {
                    auto gh = dp_a[left][right - 1][a[right] - i];
                    if (gh.second + a[right] > dp_b[left][right][i].second) {
                        dp_b[left][right][i] = {gh.first, gh.second + a[right]};
                    }
                }

//                if (left == 1 && right == 3 && i == 1) {
//                    cout << "! " << dp_b[left][right][i].first << ' ' << dp_b[left][right][i].second << endl;
//                }
            }
        }
    }

//    cout << dp_a[1][2][8].first << ' ' << dp_a[1][2][8].second << endl;
//    cout << dp_a[2][3][6].first << ' ' << dp_a[2][3][6].second << endl;
//    cout << dp_b[1][3][1].first << ' ' << dp_b[1][3][1].second << endl;
    cout << dp_a[0][n - 1][0].first << ' ' << dp_a[0][n - 1][0].second;
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
