#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<int> pref(n + 1);
    pref[0] = 0;

    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }

    int W = a.back();

    int sum = 0;
    for (int i = 0; i < n - 1; ++i) sum += a[i];

    if (sum <= W) {
        cout << W << ' ' << sum;
        return;
    }

    int dp_a[n][W + 1], dp_b[n][W + 1];

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= W; ++j) {
            dp_a[i][j] = a[i];
            if (j > 0) dp_b[i][j] = a[i];
        }
    }

    int last_dp_a[n][W + 1], last_dp_b[n][W + 1];

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= W; ++j) {
            last_dp_a[i][j] = dp_a[i][j];
            last_dp_b[i][j] = dp_b[i][j];
        }
    }

    for (int lenn = 2; lenn <= n; ++lenn) {
        for (int left = 0; left + lenn <= n; ++left) {
            int right = left + lenn - 1;

            for (int i = 0; i <= W; ++i) {
                if (a[left] <= i) {
                    auto gh = last_dp_a[left + 1][i - a[left]];
                    dp_a[left][i] = gh + a[left];
                }
                else {
                    auto gh = last_dp_b[left + 1][a[left] - i];
                    dp_a[left][i] = pref[right + 1] - pref[left + 1] - gh + a[left];
                }
            }
            for (int i = 1; i <= W; ++i) {
                if (a[left] < i) {
                    auto gh = last_dp_b[left + 1][i - a[left]];
                    dp_b[left][i] = gh + a[left];
                }
                else {
                    auto gh = last_dp_a[left + 1][a[left] - i];
                    dp_b[left][i] = pref[right + 1] - pref[left + 1] - gh + a[left];
                }

//                if (left == 1 && right == 3 && i == 1) {
//                    cout << "? " << dp_b[left][right][i].first << ' ' << dp_b[left][right][i].second << endl;
//                }
            }

            ///////////////////////

            for (int i = 0; i <= W; ++i) {
                if (a[right] <= i) {
                    auto gh = last_dp_a[left][i - a[right]];
                    if (gh + a[right] > dp_a[left][i]) {
                        dp_a[left][i] = gh + a[right];
                    }
                }
                else {
                    auto gh = last_dp_b[left][a[right] - i];
                    if (pref[right] - pref[left] - gh + a[right] > dp_a[left][i]) {
                        dp_a[left][i] = pref[right] - pref[left] - gh + a[right];
                    }
                }
            }
            for (int i = 1; i <= W; ++i) {
                if (a[right] < i) {
                    auto gh = last_dp_b[left][i - a[right]];
                    if (gh + a[right] > dp_b[left][i]) {
                        dp_b[left][i] = gh + a[right];
                    }
                }
                else {
                    auto gh = last_dp_a[left][a[right] - i];
                    if (pref[right] - pref[left] - gh + a[right] > dp_b[left][i]) {
                        dp_b[left][i] = pref[right] - pref[left] - gh + a[right];
                    }
                }

//                if (left == 1 && right == 3 && i == 1) {
//                    cout << "! " << dp_b[left][right][i].first << ' ' << dp_b[left][right][i].second << endl;
//                }
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j <= W; ++j) {
                last_dp_a[i][j] = dp_a[i][j];
                last_dp_b[i][j] = dp_b[i][j];
            }
        }
    }

//    cout << dp_a[1][2][8].first << ' ' << dp_a[1][2][8].second << endl;
//    cout << dp_a[2][3][6].first << ' ' << dp_a[2][3][6].second << endl;
//    cout << dp_b[1][3][1].first << ' ' << dp_b[1][3][1].second << endl;
    cout << dp_a[0][0] << ' ' << sum + W - dp_a[0][0];
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
