#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

void solution() {
    ll n;
    cin >> n;
    vector <ll> w(n);
    cin >> w;

    ll maxwi = 0;
    for (auto el : w) maxwi = max(maxwi, el);
    ll boost = maxwi;
    maxwi *= 3;

    vector <vector <vector <pll>>> dp(n + 1); // first - Alice, second - Bob.
    for (ll i = 0; i <= n; ++i) {
        dp[i].resize(n - i + 1, vector <pll> (maxwi, {0, 0}));
    }

    for (ll len = 1; len <= n; ++len) {
//        cout << "len = " << len << ":\n";
        for (ll beg = 0; beg + len <= n; ++beg) {
//            cout << "beg = " << beg << ":\n";
            ll lw = w[beg], rw = w[beg + len - 1];
            for (ll diff = -boost; diff <= boost; ++diff) {
                if (diff < 0) {
                    ll ld = diff + lw + boost, rd = diff + rw + boost;
                    if (dp[len - 1][beg][rd].second + rw < dp[len - 1][beg + 1][ld].second + lw) {
                        dp[len][beg][diff + boost] = dp[len - 1][beg + 1][ld];
                        dp[len][beg][diff + boost].second += lw;
                    } else {
                        dp[len][beg][diff + boost] = dp[len - 1][beg][rd];
                        dp[len][beg][diff + boost].second += rw;
                    }
                } else {
                    ll ld = diff - lw + boost, rd = diff - rw + boost;
                    if (dp[len - 1][beg][rd].first + rw < dp[len - 1][beg + 1][ld].first + lw) {
                        dp[len][beg][diff + boost] = dp[len - 1][beg + 1][ld];
                        dp[len][beg][diff + boost].first += lw;
                    } else {
                        dp[len][beg][diff + boost] = dp[len - 1][beg][rd];
                        dp[len][beg][diff + boost].first += rw;
                    }
                }

//                cout << diff << ' ' << dp[len][beg][diff].first << ' ' << dp[len][beg][diff].second << '\n';
            }
        }
    }

//    for (auto el : dp[n][0]) {
//        cout << el.first << ' ' << el.second << '\n';
//    }

    cout << dp[n][0][boost].first << ' ' << dp[n][0][boost].second;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solution();

    return 0;
}