#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

const int MAXN = 2002;
vector<vector<vector<ll>>> dp[2];

void solve() {
    ll n;
    cin >> n;
    vector<ll> w(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
    }
    ll W = accumulate(w.begin(), w.end(), 0ll);
    dp[0].resize(n + 2, vector<vector<ll>>(n + 2, vector<ll>(W + 1)));
    dp[1].resize(n + 2, vector<vector<ll>>(n + 2, vector<ll>(W + 1)));
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= W; ++j) {
            dp[0][i][i + 1][j] = dp[1][i][i + 1][j] = 0;
        }
    }
    vector<ll> pref(n + 2);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + w[i];
    }
    pref[n + 1] = pref[n];
    for (int len = 1; len <= n; ++len) {
        for (int l = 0, r = len + 1; r <= n + 1; l++, r++) {
            for (int j = 0; j <= W; ++j) {
                if (w[l + 1] > j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], pref[r - 1] - pref[l] - dp[1][l + 1][r][w[l + 1] - j]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], pref[r - 1] - pref[l] - dp[0][l + 1][r][w[l + 1] - j]);
                }
                if (w[l + 1] == j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], dp[0][l + 1][r][0] + w[l + 1]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], pref[r - 1] - pref[l] - dp[0][l + 1][r][0]);
                }
                if (w[l + 1] < j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], dp[0][l + 1][r][j - w[l + 1]] + w[l + 1]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], dp[1][l + 1][r][j - w[l + 1]] + w[l + 1]);
                }
                if (w[r - 1] > j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], pref[r - 1] - pref[l] - dp[1][l][r - 1][w[r - 1] - j]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], pref[r - 1] - pref[l] - dp[0][l][r - 1][w[r - 1] - j]);
                }
                if (w[r - 1] == j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], dp[0][l][r - 1][0] + w[r - 1]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], pref[r - 1] - pref[l] - dp[0][l][r - 1][0]);
                }
                if (w[r - 1] < j) {
                    dp[0][l][r][j] = max(dp[0][l][r][j], dp[0][l][r - 1][j - w[r - 1]] + w[r - 1]);
                    dp[1][l][r][j] = max(dp[1][l][r][j], dp[1][l][r - 1][j - w[r - 1]] + w[r - 1]);
                }
            }
        }
    }
    cout << dp[0][0][n + 1][0] << ' ' << W - dp[0][0][n + 1][0];
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
