#pragma GCC optimize("O3")
#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <iostream>
#include <cstdlib>
#include <cstdint>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 2000;
int n;
int w[N];

struct chash {
    ull splitmix64(ull a) const {
        static const ull t1 = 0x1658e38dad00cce8;
        static const ull t2 = 0x1658e38dad00cce8;
        static const ull t3 = 0x1658e38dad00cce8;
        a += t1;
        a = (a ^ (a >> 27)) * t2;
        a = (a ^ (a >> 31)) * t3;
        return a ^ (a >> 30);
    }
    ull operator()(ull a) const {
        return splitmix64(a + 0x1658e38dad00cce8);
    }
};

vector<vector<unordered_map<int, pair<int, int>, chash>>> ans;

pair<int, int> solve(int l, int r, int d) {
    if (l > r) return {0, 0};
    if (ans[l][r].count(d)) return ans[l][r][d];
    if (l == r) {
        if (d <= 0) {
            ans[l][r][d] = {w[l], 0};
        } else {
            ans[l][r][d] = {0, w[l]};
        }
        return ans[l][r][d];
    }
    if (d <= 0) {
        int st = 0;
        while (st + w[l] <= abs(d) && l <= r) {
            st += w[l++];
        }
        auto f = solve(l + 1, r, d + w[l] + st);
        f.first += w[l] + st;
        auto s = solve(l, r - 1, d + w[r] + st);
        s.first += w[r] + st;
        if (f.first > s.first) {
            ans[l][r][d] = f;
        } else {
            ans[l][r][d] = s;
        }
    } else {
        int st = 0;
        while (st + w[l] < d && l <= r) {
            st += w[l++];
        }
        auto f = solve(l + 1, r, d - w[l] - st);
        f.second += w[l] + st;
        auto s = solve(l, r - 1, d - w[r] - st);
        s.second += w[r] + st;
        if (f.second > s.second) {
            ans[l][r][d] = f;
        } else {
            ans[l][r][d] = s;
        }
    }
    return ans[l][r][d];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    bool ok4 = true;
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i + 1 < n; ++i) {
        ok4 &= w[i] * 2 >= w[i + 1];
    }
    if (n == 3) {
        if (w[1] == w[2]) {
            cout << w[2] + w[0] << " " << w[1] << "\n";
        } else if (w[0] + w[1] > w[2]) {
            cout << w[0] + w[1] << " " << w[2] << "\n";
        } else {
            cout << w[2] << " " << w[1] + w[0] << "\n";
        }
    } else if (all_of(w, w + n, [&](int c){return c <= 2;})) {
        int cnt[3]{0};
        for (int i = 0; i < n; ++i) {
            ++cnt[w[i]];
        }
        ll a = cnt[2] / 2 * 2, b = cnt[2] / 2 * 2;
        a += cnt[1] / 2;
        b += cnt[1] / 2;
        cnt[1] &= 1;
        cnt[2] &= 1;
        if (cnt[2]) a += 2, b += (cnt[1] > 0);
        else a += (cnt[1] > 0);
        cout << a << " " << b << "\n";
    } else {
        ans.resize(n);
        for (int i = 0; i < n; ++i) {
            ans[i].resize(n);
        }
        auto r = solve(0, n - 1, 0);
        cout << r.first << " " << r.second;
    }
}
