#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

int dpa[50000000];
int dpb[50000000];
int n, maxw = 0;
vector<int> a;
int por[2000][2000];

int GT(int l, int r, int tm) {
	return por[l][r] * maxw + tm;
}

int gta(int l, int r, int tm);

int gtb(int l, int r, int tm) {
	int nd = GT(l, r, tm);
	if (dpb[nd] != -1) {
		return dpb[nd];
	}
	if (l == r) {
		dpb[nd] = 0;
		return dpb[nd];
	}
	dpb[nd] = MOD;
	if (a[l] < tm) {
		dpb[nd] = min(dpb[nd], gtb(l + 1, r, tm - a[l]));
	} else {
		dpb[nd] = min(dpb[nd], gta(l + 1, r, a[l] - tm));
	}
	if (a[r] < tm) {
		dpb[nd] = min(dpb[nd], gtb(l, r - 1, tm - a[r]));
	} else {
		dpb[nd] = min(dpb[nd], gta(l, r - 1, a[r] - tm));
	}
	return dpb[nd];
}

int gta(int l, int r, int tm) {
	int nd = GT(l, r, tm);
	if (dpa[nd] != -1) {
		return dpa[nd];
	}
	if (l == r) {
		dpa[nd] = a[l];
		return dpa[nd];
	}
	if (a[l] <= tm) {
		dpa[nd] = max(dpa[nd], gta(l + 1, r, tm - a[l]) + a[l]);
	} else {
		dpa[nd] = max(dpa[nd], gtb(l + 1, r, a[l] - tm) + a[l]);
	}
	if (a[r] <= tm) {
		dpa[nd] = max(dpa[nd], gta(l, r - 1, tm - a[r]) + a[r]);
	} else {
		dpa[nd] = max(dpa[nd], gtb(l, r - 1, a[r] - tm) + a[r]);
	}
	return dpa[nd];
}

void solve() {
	cin >> n; int NXT = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			por[i][j] = NXT++;
		}
	}
	a.resize(n);
	int sm = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		maxw = max(maxw, a[i]);
		sm += a[i];
	}
	for (int l = 0; l < n; ++l) {
		for (int r = l; r < n; ++r) {
			for (int i = 0; i <= maxw; ++i) {
				dpa[GT(l, r, i)] = dpb[GT(l, r, i)] = -1;
			}
		}
	}
	int mx = gta(0, n - 1, 0);
	cout << mx << ' ' << sm - mx << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}