#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using db = long double;

#define mp make_pair

struct State {
    int l, r, w;
    bool f;

    operator<(const State &other) const {
        return mp(mp(l, r), mp(w, f)) < mp(mp(other.l, other.r), mp(other.w, other.f));
    }
};

void test_case() {
    int n;
    cin >> n;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<int> pw(n + 1);
    for (int i = 1; i <= n; i++) {
        pw[i] = pw[i - 1] + w[i - 1];
    }
    auto get = [&](int l, int r) -> int {
        return pw[r + 1] - pw[l];
    };
    map<State, int> mp;
    auto apply = [&](State a, int v) {
        if (mp.contains(a)) {
            mp[a] = max(mp[a], v);
        } else {
            mp[a] = v;
        }
    };
    auto calc = [&](auto self, State cur) -> int {
        if (cur.l == cur.r) return w[cur.l];
        if (mp.contains(cur)) return mp[cur];
        { // l++
            State next = cur;
            next.l++;
            if (w[cur.l] < cur.w) {
                next.w -= w[cur.l];
            } else if (w[cur.l] > cur.w) {
                next.w = w[cur.l] - cur.w;
                next.f = !cur.f;
            } else if (w[cur.l] == cur.w) {
                next.w = 0;
                next.f = 0;
            }
            apply(cur, w[cur.l] + (cur.f == next.f ? self(self, next) : get(next.l, next.r) - self(self, next)));
        }
        { // r--
            State next = cur;
            next.r--;
            if (w[cur.r] < cur.w) {
                next.w -= w[cur.r];
            } else if (w[cur.r] > cur.w) {
                next.w = w[cur.r] - cur.w;
                next.f = !cur.f;
            } else if (w[cur.r] == cur.w) {
                next.w = 0;
                next.f = 0;
            }
            apply(cur, w[cur.r] + (cur.f == next.f ? self(self, next) : get(next.l, next.r) - self(self, next)));
        }
        return mp[cur];
    };
    State st = {0, n - 1, 0, 0};
    cout << calc(calc, st) << ' ' << pw[n] - calc(calc, st);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}
