// JafoNoksy's code
#include <bits/stdc++.h>

#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
// #define int ll
#define ve vector
mt19937 rnd(4732);

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, _l, _r) + get(2 * v + 2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree(ve<int> a = {1}) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }
};

ve<pll> ext(ve<pll> a, ve<pll> b) {
    int n = a.size();
    ve<pll> c(n);
    for (int i = 0; i < n; ++i) {
        c[i] = {a[b[i].F].F, a[b[i].F].S + b[i].S};
    }
    return c;
}

ve<pll> fpow(ve<pll> &a, int d) {
    if (d == 1)
        return a;
    if (d & 1)
        return ext(fpow(a, d - 1), a);
    auto c = fpow(a, d / 2);
    return ext(c, c);
}

int ans(int num, int l, int r, int weight, ve<ve<int>> &sum, ve<int> &w) {
    if (num == 0) {
        int res = 0;
        if (weight > w[l]) {
            res = max(res, w[l] + ans(0, l + 1, r, weight - w[l], sum, w));
        } else {
            res = max(res, sum[l][r] - ans(1, l + 1, r, w[l] - weight, sum, w));
        }
        if (weight > w[r]) {
            res = max(res, w[r] + ans(0, l, r - 1, weight - w[r], sum, w));
        } else {
            res = max(res, sum[l][r] - ans(1, l, r - 1, w[r] - weight, sum, w));
        }
        return res;
    } else {
        int res = 0;
        if (weight >= w[l]) {
            res = max(res, w[l] + ans(1, l + 1, r, weight - w[l], sum, w));
        } else {
            res = max(res, sum[l][r] - ans(0, l + 1, r, w[l] - weight, sum, w));
        }
        if (weight >= w[r]) {
            res = max(res, w[r] + ans(1, l, r - 1, weight - w[r], sum, w));
        } else {
            res = max(res, sum[l][r] - ans(0, l, r - 1, w[r] - weight, sum, w));
        }
        return res;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    ve<int> w(n);
    cin >> w;
    int W = *max_element(all(w));
    ve<ve<int>> sum(n, ve<int>(n, 0));
    for (int i = 0; i < n; ++i)
        sum[i][i] = w[i];
    for (int len = 1; len < n; ++len) {
        for (int i = 0; i + len < n; ++i) {
            sum[i][i + len] = sum[i + 1][i + len] + w[i];
        }
    }
    int dp[2][n][n][W+1];
    for (int i = 0; i < n; ++i) {
        dp[0][i][i][0] = 0;
        dp[1][i][i][0] = w[i];
        for (int weight = 1; weight <= W; ++weight) {
            dp[0][i][i][weight] = dp[1][i][i][weight] = w[i];
        }
    }
    for (int len = 1; len < n; ++len) {
        for (int i = 0; i + len < n; ++i) {
            int l = i, r = i + len;
            for (int weight = 0; weight <= W; ++weight) {
                dp[0][l][r][weight] = dp[1][l][r][weight] = 0;
                if (weight > w[l]) {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], w[l] + dp[0][l + 1][r][weight - w[l]]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], w[l] + dp[1][l + 1][r][weight - w[l]]);
                } else if (weight == w[l]) {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], sum[l][r] - dp[1][l + 1][r][0]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], w[l] + dp[1][l + 1][r][weight - w[l]]);
                } else {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], sum[l][r] - dp[1][l + 1][r][w[l] - weight]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], sum[l][r] - dp[0][l + 1][r][w[l] - weight]);
                }

                if (weight > w[r]) {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], w[r] + dp[0][l][r - 1][weight - w[r]]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], w[r] + dp[1][l][r - 1][weight - w[r]]);
                } else if (weight == w[r]) {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], sum[l][r] - dp[1][l][r - 1][0]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], w[r] + dp[1][l][r - 1][weight - w[r]]);
                } else {
                    dp[0][l][r][weight] = max(dp[0][l][r][weight], sum[l][r] - dp[1][l][r - 1][w[r] - weight]);
                    dp[1][l][r][weight] = max(dp[1][l][r][weight], sum[l][r] - dp[0][l][r - 1][w[r] - weight]);
                }
            }
        }
    }
    cout << dp[1][0][n - 1][0] << ' ' << sum[0][n - 1] - dp[1][0][n - 1][0];
}