#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef int ll;
typedef long double ld;

map<vector<ll>, vector<ll>> dp;
map<vector<ll>, ll> was;
vector<ll> a;
vector<ll> pref;

ll sum(ll i, ll j) {
    if (i < 0 || j >= a.size()) return 0;
    ll res = pref[j];
    if (i != 0) res -= pref[i - 1];
    return res;
}

vector<ll> ans2(ll sum, ll r1) {
    ll s = sum;
    ll x = (s - abs(r1)) / 2;
    ll k1 = x + (r1 >= 0) * abs(r1);
    ll k2 = x + (r1 <= 0) * abs(r1);
    return {k1, k2};
}

vector<ll> f(ll i, ll j, ll r1) {
    if (was[{i, j, r1}] != 0) return dp[{i, j, r1}];
    ll r2 = sum(0, i - 1) + sum(j + 1, a.size() - 1) - r1;
    if (i > j) {
        return {r1, r2};
    }
    vector<ll> res3;
    if (r1 <= r2) {
        vector<ll> res1 = f(i + 1, j, r1 + a[i]);
        vector<ll> res2 = f(i, j - 1, r1 + a[j]);
        if (res1[0] > res2[0]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    } else {
        vector<ll> res1 = f(i + 1, j, r1);
        vector<ll> res2 = f(i, j - 1, r1);
        if (res1[1] > res2[1]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    }
    dp[{i, j, r1}] = res3;
    was[{i, j, r1}] = 1;
    return res3;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    a.resize(n);
    pref.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    pref = a;
    for(int i = 1; i < n; i++) pref[i] += pref[i - 1];
    if (n > 100) {
        ll i1 = 0, i2 = n - 1, col1 = 0, col2 = 0;
        while(i1 > i2) {
            if (col1 <= col2) {
                col1 += a[i2];
                i2--;
            } else {
                col2 += a[i2];
                i2--;
            }
        }
        cout << col1 << " " << col2 << "\n";
        return 0;
    }
    vector<ll> v = f(0, n - 1, 0);
    cout << v[0] << " " << v[1];
    return 0;
}
