#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#define fastio
// #define LOCAL

using namespace std;

#ifdef fastio
#define endl '\n'
#endif

// #define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

// (pref, suf, diff) -> a, b
vector<vector<unordered_map<int, pii>>> dp;
vector<int> arr;

pii rec(int l, int r, int diff) {
    if (r == l - 1) return {0, 0};
    if (dp[l][r].count(diff)) return dp[l][r][diff];
    pii res;
    if (diff <= 0) {
        // take for alice
        auto [a1, b1] = rec(l + 1, r, (arr[l]) - (-1 * diff));
        a1 += arr[l];
        auto [a2, b2] = rec(l, r - 1, (arr[r]) - (-1 * diff));
        a2 += arr[r];
        if (a1 > a2) {
            res = {a1, b1};
        } else {
            res = {a2, b2};
        }
    } else {
        // take for bob
        auto [a1, b1] = rec(l + 1, r, (diff) - (arr[l]));
        b1 += arr[l];
        auto [a2, b2] = rec(l, r - 1, (diff) - (arr[r]));
        b2 += arr[r];
        if (b1 > b2) {
            res = {a1, b1};
        } else {
            res = {a2, b2};
        }
    }
    dp[l][r][diff] = res;
    return res;
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef LOCAL
    freopen("/mnt/commons/code/in.txt", "r", stdin);
    #endif

    int n;
    cin >> n;
    dp.resize(n, vector(n, unordered_map<int, pii>()));
    arr.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    auto [a, b] = rec(0, n - 1, 0);

    cout << a << " " << b << endl;

    return 0;
}