#ifndef DBG
#pragma GCC optimize("Ofast")
// #pragma GCC target("avx2")
#endif

#include <bits/extc++.h>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
#include <tuple>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = int;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

template <typename K, typename V>
using hmap = pbds::gp_hash_table<K, V>;

const ll inf = 2 << 20;

struct st {
    ll al = 0, bob = 0;

    ll &ch(bool is_al) {
        return is_al ? al : bob;
    }
};

st fake = {-inf, -inf};

ll n;
vector<ll> a;

struct indx {
    ll l, r, t, ch_al; 

    bool operator==(const indx &o) const {
        return l == o.l && r == o.r && t == o.t && ch_al == o.ch_al;
    }

    bool operator<(const indx &o) const {
        return make_tuple(l, r, t, ch_al) < make_tuple(o.l, o.r, o.t, o.ch_al);
    }
};

const ull hcnst = 0xab0baab0ba;

template <typename T>
struct myhs {};

template<>
struct myhs<indx> {
    ull operator()(indx i) const {
        // ull h1 = hash<ll>()(i.l);
        // ull h2 = hash<ll>()(i.r);
        // ull h3 = hash<ll>()(i.t);
        // ull h4 = hash<bool>()(i.ch_al);
        ull h1 = i.l;
        ull h2 = i.r;
        ull h3 = i.t;
        ull h4 = i.ch_al;
        return hash<ull>()(h1 * (hcnst * hcnst * hcnst) + h2 * (hcnst * hcnst) + h3 * hcnst + h4);
    }
};

// template<>
// struct std::hash<indx> {
//     size_t operator()(indx i) const {
//         ull h1 = hash<ll>()(i.l);
//         ull h2 = hash<ll>()(i.r);
//         ull h3 = hash<ll>()(i.t);
//         ull h4 = hash<bool>()(i.ch_al);
//         return hash<ull>()(h1 * (hcnst * hcnst * hcnst) + h2 * (hcnst * hcnst) + h3 * hcnst + h4);
//     }
// };

pbds::gp_hash_table<indx, st, myhs<indx>> dpcache;
// pbds::cc_hash_table<indx, st, myhs<indx>> dpcache;
// map<indx, st> dpcache;

// todo cache
st dp(ll l, ll r, ll t, bool ch_al) {
    if (l + r > n) return fake;
    if (l + r == n) return {0, 0};
    // TODO MORE

    indx ix = {l, r, t, ch_al};

    auto fit = dpcache.find(ix);
    if (fit != dpcache.find_end()) {
        return fit->second;
    }

    //if (dpcache.count(ix)) return dpcache[ix];

    ll lval = a[l], rval = a[n - r - 1];

    st nl = fake, nr = fake;
    
    if (lval == t) {
        nl = dp(l + 1, r, 0, true);
    } else if (lval < t) {
        nl = dp(l + 1, r, t - lval, ch_al);
    } else {
        nl = dp(l + 1, r, lval - t, !ch_al);
    }

    nl.ch(ch_al) += lval;

    if (rval == t) {
        nr = dp(l, r + 1, 0, true);
    } else if (rval < t) {
        nr = dp(l, r + 1, t - rval, ch_al);
    } else {
        nr = dp(l, r + 1, rval - t, !ch_al);
    }

    nr.ch(ch_al) += rval;

    st res;
    if (ch_al) {
        if (nl.al >= nr.al) {
            res = nl;
        } else {
            res = nr;
        }
    } else {
        if (nl.bob >= nr.bob) {
            res = nl;
        } else {
            res = nr;
        }
    }

    dpcache[ix] = res;

    return res;
}

void solve() {
    cin >> n;

    a.resize(n);
    for (ll &i: a) cin >> i;

    sort(a.begin(), a.end());

    auto ans = dp(0, 0, 0, true);

    cout << ans.al << ' ' << ans.bob << endl;
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    // ll t; cin >> t; while (t--)
    solve();
}
