#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <unordered_map>
#include <set>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;
ll n;
vector <vector <ll> > g;
vector <bool> used;
vector <ll> oldnew;
vector <ll> newold;
vector <ll> eul;
vector <ll> first;
vector <ll> st;
ll c = 0;

void dfs(ll cur)
{
    used[cur] = 1;
    oldnew[cur] = c++;
    newold[c] = cur;
    eul.push_back(cur);
    first[oldnew[cur]] = eul.size() - 1;
    for (auto i : g[cur])
    {
        if (!used[i])
        {
            dfs(i);
            eul.push_back(cur);
        }
    }
}

void build(ll v, ll l, ll r)
{
    if (l == r)
    {
        st[v] = eul[l];
        return;
    }
    ll mid = (l + r) >> 1;
    build(v + v, l, mid);
    build(v + v + 1, mid + 1, r);
}

ll query(ll v, ll l, ll r, ll tl, ll tr)
{
    if (l > tr || r < tl) return inf;
    if (tl <= l && r <= tr)
    {
        return st[v];
    }
    ll mid = (l + r) >> 1;
    ll ml = query(v + v, l, mid, tl, tr);
    ll mr = query(v + v + 1, mid + 1, r, tl, tr);
    return min(ml, mr);
}

ll lca(ll a, ll b)
{
    a = oldnew[a];
    b = oldnew[b];
    ll u = query(1, 0, eul.size() - 1, min(first[a], first[b]), max(first[a], first[b]));
    return newold[u];
}

int main()
{
    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector <ll> v(n);
    for (ll i = 0; i < n; i++) cin >> v[i];
    if (n == 1)
    {
        cout << v[0] << " " << 0;
        return 0;
    }
    if (n == 2)
    {
        cout << v[1] << " " << v[0];
        return 0;
    }
    if (n == 3)
    {
        if (v[1] == v[2])
        {
            cout << v[2] + v[0] << " " << v[1];
        }
        else
        {
            cout << max(v[2], v[1] + v[0]) << " " << min(v[2], v[1] + v[0]);
        }
        return 0;
    }
    ll a = 0, b = 0;
    for (ll i = 0; i < n; i += 2) a += v[i];
    for (ll i = 1; i < n; i += 2) b += v[i];
    cout << a << " " << b;
}

