#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(1472916923);
const int SZ = 1e6 + 1;

struct segtree {
    int sz;
    vector<int> tr;
    segtree(int n) {
        sz = 1;
        while (sz < n)
            sz <<= 1;
        tr.assign(sz * 2 - 1, 0);
    }
};

struct DDnode {
    ll prior, val;
    DDnode* l;
    DDnode* r;
    DDnode(ll v = 0) : val(v) {
        prior = rd();
        l = nullptr;
        r = nullptr;
    }
};

vector<int> g;
vector<ll> sz_len, sz;
ll sz1 = -1, szl1, sz2, szl2, cy;

void dfs(int v, int n, ll sl = 0, ll s = 0) {
    sz_len[v] = sl;
    sz[v] = s;
    if (sz[g[v]] != -1) {
        cy = g[v];
        sz1 = sz[g[v]];
        szl1 = sz_len[g[v]];
        sz2 = s + 1 - sz[g[v]];
        szl2 = sl + (g[v] > v ? g[v] - v : g[v] + n - v) - sz_len[g[v]];
        return;
    }
    else {
        dfs(g[v], n, sl + (g[v] > v ? g[v] - v : g[v] + n - v), s + 1);
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> w(n);
    int sum = 0, mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sum += w[i];
        mx = max(mx, w[i]);
    }

    vector<vector<vector<ll>>> dp(2, vector<vector<ll>> (n, vector<ll>(mx * 2 + 1, 0)));

    for (int i = 0; i < n; i++) {
        for (int a = 0; a <= mx * 2; a++) {
            if (a <= mx) {
                dp[0][i][a] = w[i];
            }
            else {
                dp[0][i][a] = 0;
            }
        }
    }
    for (int sz = 1; sz <= n; sz++) {
        for (int i = 0; i + sz < n; i++) {
            for (int a = 0; a <= mx * 2; a++) {
                if (a <= mx) {
                    dp[sz % 2][i][a] = max(dp[(sz - 1) % 2][i + 1][a + w[i]] + w[i], dp[(sz - 1) % 2][i][a + w[i + sz]] + w[i + sz]);
                }
                else {
                    dp[sz % 2][i][a] = min(dp[(sz - 1) % 2][i + 1][a - w[i]], dp[(sz - 1) % 2][i][a - w[i + sz]]);
                }
            }
        }
    }

    cout << dp[(n - 1) % 2][0][mx] << ' ' << sum - dp[(n - 1) % 2][0][mx];

    //int l = 0, r = n - 1;
    //ll ta = 0, tb = 0;
    //ll sa = 0, sb = 0;
    //while (sum > 0) {
    //    if (ta <= tb) {
    //        tb -= ta;
    //        if (w[r] * 2 >= sum) {
    //            ta = w[r];
    //            sa += w[r];
    //            sum -= w[r];
    //            r--;
    //        }
    //        else {
    //            ta = w[l];
    //            sa += w[l];
    //            sum -= w[l];
    //            l++;
    //        }
    //    }
    //    else {
    //        ta -= tb;
    //        if (w[r] * 2 >= sum) {
    //            tb = w[r];
    //            sb += w[r];
    //            sum -= w[r];
    //            r--;
    //        }
    //        else {
    //            tb = w[l];
    //            sb += w[l];
    //            sum -= w[l];
    //            l++;
    //        }
    //    }
    //}
}
