#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using int32 = signed;
using uint64 = unsigned long long;

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e3 + 10;

unordered_map<int, int> dp[N][N][2];
unordered_map<int, int> used[N][N][2];

int sx[N][N];

int w[N];
int n;

int solve (int l, int r, int time, int who) { //  противник ест еще time времени
    if (used[l][r][who][time]) return dp[l][r][who][time];
    used[l][r][who][time] = true;
    if (l > r) {
        dp[l][r][who][time] = 0;
        return dp[l][r][who][time];
    }

    if (l == r) {
        if (time == 0 && who == 1) {
            dp[l][r][who][time] = 0;
        } else {
            dp[l][r][who][time] = w[l];
        }
        return dp[l][r][who][time];
    }


    // сколько есть еще противник
    // два случая

    if (time == 0 && who == 1) {
        solve(l, r, time, who ^ 1);
        dp[l][r][who][time] = max(dp[l][r][who][time], sx[l][r] - dp[l][r][who ^ 1][time]);
        return dp[l][r][who][time];
    }

    {
        if (w[l] <= time) {
            solve(l + 1, r, time - w[l], who);
            dp[l][r][who][time] = max(dp[l][r][who][time], dp[l + 1][r][who][time - w[l]] + w[l]);
        } else {
            solve(l + 1, r, w[l] - time, who ^ 1);
            dp[l][r][who][time] = max(dp[l][r][who][time], sx[l + 1][r] - dp[l + 1][r][who ^ 1][w[l] - time] + w[l]);
        }
    }

    {
        if (w[r] <= time) {
            solve(l, r - 1, time - w[r], who);
            dp[l][r][who][time] = max(dp[l][r][who][time], dp[l][r - 1][who][time - w[r]] + w[r]);
        } else {
            solve(l, r - 1, w[r] - time, who ^ 1);
            dp[l][r][who][time] = max(dp[l][r][who][time], sx[l][r - 1] - dp[l][r - 1][who ^ 1][w[r] - time] + w[r]);
        }
    }

    return dp[l][r][who][time];
}

void solve() {
    cin >> n;

    int s = 0;

    for (int i = 0; i < n; i++) {
        cin >> w[i];
        s += w[i];
    }

    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            sx[i][j] = (j == i ? 0 : sx[i][j - 1]) + w[j];
        }
    }

    int x = solve(0, n - 1, 0, 0);

    cout << x << " " << s - x << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}