#include <bitset>
#include <iostream>
#include <map>
#include <tuple>

constexpr int maxn = 2000;
constexpr int maxw = 30000;
int a[maxn];
int n;

std::map<std::tuple<int, int, int, int>, std::pair<int, int>> ress;

std::pair<int, int> getres(int f, int l, int sum1, int sum2) {
    if (ress.find({f, l, sum1, sum2}) != ress.end()) {
        return ress[{f, l, sum1, sum2}];
    }
    if (f + l == n) {
        return {sum1, sum2};
    }
    if (sum1 <= sum2) {
        auto r1 = getres(f + 1, l, sum1 + a[f], sum2);
        auto r2 = getres(f, l + 1, sum1 + a[n - 1 - l], sum2);
        if (r1.first > r2.first) {
            return ress[{f, l, sum1, sum2}] = r1;
        } else {
            return ress[{f, l, sum1, sum2}] = r2;
        }
    } else {
        auto r1 = getres(f + 1, l, sum1, sum2 + a[f]);
        auto r2 = getres(f, l + 1, sum1, sum2 + a[n - 1 - l]);
        if (r1.second > r2.second) {
            return ress[{f, l, sum1, sum2}] = r1;
        } else {
            return ress[{f, l, sum1, sum2}] = r2;
        }
    }
}

void solve2() {
    // int sum = 0;
    // for (int i = 0; i < n; i++) {
    //     sum += a[i];
    // }
    // if (a[0] == 1) {
    //     std::cout << (sum + 1) / 2 << ' ' << sum / 2 << '\n';
    // } else {
    //     if (sum % 4 == 0) {
    //         std::cout << (sum / 2) << ' ' << sum / 2 << '\n';
    //     } else {
    //         std::cout << (sum / 2) + 1 << ' ' << sum / 2 - 1 << '\n';
    //     }
    // }
    int sum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i];
    }
    std::bitset<maxw> bs;
    bs.set(0);
    for (int i = 0; i < n; i++) {
        bs |= (bs << a[i]);
    }
    std::pair<int, int> res(sum, 0);
    for (int i = 0; i <= sum; i++) {
        if (bs.test(i)) {
            int first = i;
            int second = sum - i;
            if (first < second) {
                std::swap(first, second);
            }
            res = std::min(res, std::make_pair(first, second));
        }
    }
    std::cout << res.first << ' ' << res.second << '\n';
}

int main() {
    std::cin >> n;
    bool good = true;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        if (i > 0 && a[i] > 2 * a[i - 1]) {
            good = false;
        }
    }
    if (n > 500 && good) {
        solve2();
        return 0;
    }
    // if (a[n - 1] == 2) {
    //     solve2();
    //     return 0;
    // }
    auto [ra, rb] = getres(0, 0, 0, 0);
    std::cout << ra << ' ' << rb << '\n';
    return 0;
}