#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }

    vector<vector<pair<int, int>>> get(n + 1, vector<pair<int, int>> (n + 1, {-1, -1}));

    auto calc = [&] (auto self, int l, int r, int time_l, int time_r) -> pair<int, int> {
        //cout << l << ' ' << r << ' ' << time_l << ' ' << time_r << endl;
        if (get[l][r].first != -1) {
            if (time_l <= time_r) {
                return get[l][r];
            }
            return {get[l][r].second, get[l][r].first};
        }
        if (l + 1 == r) {
            get[l][r] = {a[l], 0};
            if (time_l <= time_r) {
                return {a[l], 0};
            } else {
                return {0, a[l]};
            }
        }
        if (time_l <= time_r) {
            auto [x1, y1] = self(self, l + 1, r, time_l + a[l], time_r);
            auto [x2, y2] = self(self, l, r - 1, time_l + a[r - 1], time_r);
            if (y1 > y2 || (y1 == y2 && x1 > x2)) {
                get[l][r] = {y1 + a[l], x1};
                return {time_l + x1, time_r + y1};
            }
            get[l][r] = {y2, x2 + a[r - 1]};
            return {time_l + x2, time_r + y2};
        } else {
            auto [x1, y1] = self(self, l + 1, r, time_l, time_r + a[l]);
            auto [x2, y2] = self(self, l, r - 1, time_l, time_r + a[r - 1]);
            if (x1 > x2 || (x1 == x2 && y1 > y2)) {
                get[l][r] = {x1 + a[l], y1};
                return {time_l + x1, time_r + y1};
            }
            get[l][r] = {x2, y2 + a[r - 1]};
            return {time_l + x2, time_r + y2};

        }
    };

    auto [x, y] = calc(calc, 0, n, 0, 0);
    //cout << get[0][n].first << ' ' << get[0][n].second << endl;
    cout << x << ' ' << y;
}