#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e9, MOD = 1e9 + 7, LOG = 20;

int n;
int v[2005], pv[2005];
vector<pair<int, int>> dp[2005][2005][2];

int getv(int l, int r)
{
	if (l > r)
	{
		return 0;
	}
	l = max(0, l);
	r = min(n - 1, r);
	return pv[r + 1] - pv[l];
}

void calc(int l, int r, int turn, int dif)
{
	if (dp[l][r][turn][dif].first != -1)
	{
		return;
	}
	if (turn == 0)
	{
		if (getv(l, r - 1) <= dif)
		{
			dp[l][r][turn][dif] = { getv(l, r), 0 };
			return;
		}

		int rest = dif;
		int ptrl = l - 1;
		while (rest >= 0)
		{
			ptrl++;
			rest -= v[ptrl];
		}
		int ptrr = r + 1;
		while (true)
		{
			calc(ptrl + 1, ptrr - 1, turn ^ 1, -rest);
			auto [a, b] = dp[ptrl + 1][ptrr - 1][turn ^ 1][-rest];
			a += getv(l, ptrl) + getv(ptrr, r);
			dp[l][r][turn][dif] = max(dp[l][r][turn][dif], { a, b });

			ptrr--;
			rest -= v[ptrr];
			while (rest + v[r] < 0 && l <= ptrl)
			{
				rest += v[ptrl];
				ptrl--;
			}
			if (rest + v[r] < 0)
			{
				break;
			}
		}
	}
	else
	{
		if (getv(l, r - 1) < dif)
		{
			dp[l][r][turn][dif] = { 0, getv(l, r) };
			return;
		}

		int rest = dif;
		int ptrl = l - 1;
		while (rest > 0)
		{
			ptrl++;
			rest -= v[ptrl];
		}
		int ptrr = r + 1;
		while (true)
		{
			calc(ptrl + 1, ptrr - 1, turn ^ 1, -rest);
			auto [a, b] = dp[ptrl + 1][ptrr - 1][turn ^ 1][-rest];
			b += getv(l, ptrl) + getv(ptrr, r);
			if (b > dp[l][r][turn][dif].second)
			{
				dp[l][r][turn][dif] = { a, b };
			}

			ptrr--;
			rest -= v[ptrr];
			while (rest + v[r] <= 0 && l <= ptrl)
			{
				rest += v[ptrl];
				ptrl--;
			}
			if (rest + v[r] <= 0)
			{
				break;
			}
		}
	}
}

void solve()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
		pv[i + 1] = pv[i] + v[i];
	}

	for (int l = 0; l < n; l++)
	{
		for (int r = l; r < n; r++)
		{
			for (long long ab = 0; ab < 2; ab++)
			{
				if (r == n - 1)
				{
					dp[l][r][ab].resize(v[n - 1] + 5, {-1, -1});
					continue;
				}

				dp[l][r][ab].resize(v[r + 1] + 5, {-1, -1});
			}
		}
	}

	calc(0, n - 1, 0, 0);
	auto [a, b] = dp[0][n - 1][0][0];
	cout << a << " " << b << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
