#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;

pair<ll, ll> Buravchik(ll tb, ll ta, ll sumb, ll suma, vector<ll>& vec, ll l, ll r) {
	if (l > r) {
		return { suma, sumb };
	}
	pair<ll, ll> out;
	ll minimum = INT64_MAX;
	if (ta <= 0 && tb >= 0) {
		pair<ll, ll> version1 = Buravchik(tb - 1, ta + vec[r] - 1, sumb, suma + vec[r], vec, l, r - 1);
		pair<ll, ll> version2 = Buravchik(tb - 1, ta + vec[l] - 1, sumb, suma + vec[l], vec, l + 1, r);
		if (abs(version1.first - version1.second) < minimum) {
			minimum = abs(version1.first - version1.second);
			out = version1;
		}
		if (abs(version2.first - version2.second) < minimum) {
			minimum = abs(version2.first - version2.second);
			out = version2;
		}
	}
	else if (tb <= 0) {
		pair<ll, ll> version1 = Buravchik(tb + vec[r] - 1, ta - 1, sumb + vec[r], suma, vec, l, r - 1);
		pair<ll, ll> version2 = Buravchik(tb + vec[l] - 1, ta - 1, sumb + vec[l], suma, vec, l + 1, r);
		if (abs(version1.first - version1.second) < minimum) {
			minimum = abs(version1.first - version1.second);
			out = version1;
		}
		if (abs(version2.first - version2.second) < minimum) {
			minimum = abs(version2.first - version2.second);
			out = version2;
		}
	}
	else {
		out = Buravchik(tb - min(tb, ta), ta - min(tb, ta), sumb, suma, vec, l, r);
	}
	return out;
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	ll n;
	cin >> n;
	vector<ll> vec;
	map<ll, ll> counts;
	for (ll i = 0; i < n; i++) {
		ll b;
		cin >> b;
		counts[b]++;
		vec.push_back(b);
	}
	sort(vec.begin(), vec.end());
	if (n == 3) {
		ll v1 = vec[0] + vec[1];
		ll v2 = vec[2];
		cout << max(v1, v2) << " " << min(v1, v2) << endl;
		return 0;
	}
	if (vec.back() <= 2) {
		ll v1 = n / 2;
		ll v2 = n - v1;
		cout << max(v1, v2) << " " << min(v1, v2) << endl;
		return 0;
	}
	ll suma = 0, sumb = 0;
	ll ta = 0, tb = 0;
	pair<ll, ll> out = Buravchik(tb, ta, sumb, suma, vec, 0, n - 1);
	cout << out.first << " " << out.second << endl;
}
