#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct SegmentTree {
    vector<ll> tree;

    ll merge(ll l, ll r) {
        return min(l, r);
    }

    void build(int v, int l, int r, vector<ll>& a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void modify(int v, int l, int r, int qi, ll qx) {
        if (qi < l || r <= qi) {
            return;
        }
        if (r - l == 1) {
            tree[v] = qx;
            return;
        }
        int mid = (l + r) / 2;
        modify(2 * v + 1, l, mid, qi, qx);
        modify(2 * v + 2, mid, r, qi, qx);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return INF;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        auto lres = get(2 * v + 1, l, mid, ql, qr);
        auto rres = get(2 * v + 2, mid, r, ql, qr);
        return merge(lres, rres);
    }
};

vector<int> a;
map<tuple<int, int, int>, int> memo;

int calc(int l, int r, int offset) {
    if (!memo.contains({l, r, offset})) {
        if (offset >= 0) {
            if (l == r) {
                memo[{l, r, offset}] = a[l];
            } else {
                auto lres = calc(l + 1, r, offset - a[l]);
                lres += a[l];
                auto rres = calc(l, r - 1, offset - a[r]);
                rres += a[r];
                if (lres > rres) {
                    memo[{l, r, offset}] = lres;
                } else {
                    memo[{l, r, offset}] = rres;
                }
            }
        } else {
            if (l == r) {
                memo[{l, r, offset}] = 0;
            } else {
                auto lres = calc(l + 1, r, offset + a[l]);
                auto rres = calc(l, r - 1, offset + a[r]);
                if (lres < rres) {
                    memo[{l, r, offset}] = lres;
                } else {
                    memo[{l, r, offset}] = rres;
                }
            }
        }
    }
    return memo[{l, r, offset}];
}

void solve() {
    int n;
    cin >> n;
    a.resize(n);
    int W = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        W += a[i];
    }
    auto res = calc(0, n - 1, 0);
    cout << res << " " << W - res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
