#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
>;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

vector<vector<vector<int>>> dp;
vector<int> pref, suf, w;

void calc(int l, int r, int A) {
    if (dp[l][r][A] != -1) return;
    if (l + 1 == r) {
        dp[l][r][A] = A;
        return;
    }

    int B = pref[l] + suf[r] - A;

    if (A <= B) {
        calc(l + 1, r, A + w[l + 1]);
        calc(l, r - 1, A + w[r - 1]);
        dp[l][r][A] = max(dp[l + 1][r][A + w[l + 1]], dp[l][r - 1][A + w[r - 1]]);
    } else {
        calc(l + 1, r, A);
        calc(l, r - 1, A);
        dp[l][r][A] = min(dp[l + 1][r][A], dp[l][r - 1][A]);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int n;
    cin >> n;
    w.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> w[i];

    int sum = accumulate(all(w), 0);
    dp.assign(n + 2, vector<vector<int>>(n + 2, vector<int>(sum + 1, -1)));

    pref.resize(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + w[i];
    suf.resize(n + 2);
    for (int i = n; i >= 1; i--) suf[i] = suf[i + 1] + w[i];

    int A, B;
    if (n == 3) {
        calc(0, n + 1, 0);
        A = dp[0][n + 1][0];
        B = sum - A;
    } else {
        int one = count(all(w), 1);
        int two = count(all(w), 2);
        A = (sum + 1) / 2;
    }

    cout << A << ' ' << B << '\n';

    return 0;
}
