#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
using namespace std;

typedef long long ll;

int n, mxW;
vector<int> A;
vector<vector<vector<int>>> dp;

int getVal(int l, int r, int w)
{
    if (l > r)
        return 0;
    return dp[l][r][w];
}

void build_dp(int l, int r, int w)
{
    if (getVal(l, r, w) != -1)
        return;
    if (w > mxW)
    {
        build_dp(l + 1, r, w - A[l]);
        build_dp(l, r - 1, w - A[r]);
        dp[l][r][w] = min(getVal(l + 1, r, w - A[l]), getVal(l, r - 1, w - A[r]));
    }else{
        build_dp(l + 1, r, w + A[l]);
        build_dp(l, r - 1, w + A[r]);
        dp[l][r][w] = max(getVal(l + 1, r, w + A[l]) + A[l], getVal(l, r - 1, w + A[r]) + A[r]);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    cin >> n;
    A = vector<int>(n, 0);
    int sum = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
        sum += A[i];
    }
    mxW = A[n - 1];
    dp = vector<vector<vector<int>>>(n + 1, vector<vector<int>>(n + 1, vector<int>(2 * mxW + 1, -1)));
    build_dp(0, n - 1, mxW);
    cout << dp[0][n - 1][mxW] << ' ' << sum - dp[0][n - 1][mxW] << '\n';
    return 0;
}