#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;
vector<vector<vector<vector<int>>>> dp(2, vector<vector<vector<int>>>(200 + 1, vector<vector<int>>(200 + 1, vector<int>(500 + 1))));
vector<vector<vector<vector<bool>>>> used(2, vector<vector<vector<bool>>>(200 + 1, vector<vector<bool>>(200 + 1, vector<bool>(500 + 1))));
vector<int> inf;

void dfs(int v, int l, int r, int left) {
	used[v][l][r][left] = 1;
	if (v == 0) dp[v][l][r][left] = 0;
	else dp[v][l][r][left] = 1e9;
	if (l == r) {
		if (v == 0) {
			dp[v][l][r][left] = inf[l];
		}
		else {
			dp[v][l][r][left] = 0;
		}
		return;
	}
	if (v == 0) {
		if (inf[l] <= left) {
			if (used[0][l + 1][r][left - inf[l]] == 0) {
				dfs(0, l + 1, r, left - inf[l]);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[0][l + 1][r][left - inf[l]] + inf[l]);
		}
		else {
			if (used[1][l + 1][r][inf[l] - left] == 0) {
				dfs(1, l + 1, r, inf[l] - left);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[1][l + 1][r][inf[l] - left] + inf[l]);
		}
		if (inf[r] <= left) {
			if (used[0][l][r - 1][left - inf[r]] == 0) {
				dfs(0, l, r - 1, left - inf[r]);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[0][l][r - 1][left - inf[r]] + inf[r]);
		}
		else {
			if (used[1][l][r - 1][inf[r] - left] == 0) {
				dfs(1, l, r - 1, inf[r] - left);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[1][l][r - 1][inf[r] - left] + inf[r]);
		}
	}
	else {
		if (inf[l] < left) {
			if (used[1][l + 1][r][left - inf[l]] == 0) {
				dfs(1, l + 1, r, left - inf[l]);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[1][l + 1][r][left - inf[l]]);
		}
		else {
			if (used[0][l + 1][r][inf[l] - left] == 0) {
				dfs(0, l + 1, r, inf[l] - left);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[0][l + 1][r][inf[l] - left]);
		}
		if (inf[r] < left) {
			if (used[1][l][r - 1][left - inf[r]] == 0) {
				dfs(1, l, r - 1, left - inf[r]);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[1][l][r - 1][left - inf[r]]);
		}
		else {
			if (used[0][l][r - 1][inf[r] - left] == 0) {
				dfs(0, l, r - 1, inf[r] - left);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[0][l][r - 1][inf[r] - left]);
		}
	}
}

int main()
{
	int n;
	cin >> n;
	inf.resize(n);
	int s = 0;
	for (auto& x : inf) {
		cin >> x;
		s += x;
	}
	sort(inf.begin(), inf.end());
	dfs(0, 0, n - 1, 0);
	cout << dp[0][0][n - 1][0] << " " << s - dp[0][0][n - 1][0];
}