#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;
vector<vector<vector<vector<int>>>> dp;
vector<vector<vector<vector<bool>>>> used;
vector<int> inf;

void dfs(int v, int l, int r, int left) {
	used[v][l][r][left] = 1;
	if (v == 0) dp[v][l][r][left] = 0;
	else dp[v][l][r][left] = 1e9;
	if (l == r) {
		if (v == 0) {
			dp[v][l][r][left] = inf[l];
		}
		else {
			dp[v][l][r][left] = 0;
		}
		return;
	}
	if (v == 0) {
		if (inf[l] <= left) {
			if (used[0][l + 1][r][left - inf[l]] == 0) {
				dfs(0, l + 1, r, left - inf[l]);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[0][l + 1][r][left - inf[l]] + inf[l]);
		}
		else {
			if (used[1][l + 1][r][inf[l] - left] == 0) {
				dfs(1, l + 1, r, inf[l] - left);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[1][l + 1][r][inf[l] - left] + inf[l]);
		}
		if (inf[r] <= left) {
			if (used[0][l][r - 1][left - inf[r]] == 0) {
				dfs(0, l, r - 1, left - inf[r]);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[0][l][r - 1][left - inf[r]] + inf[r]);
		}
		else {
			if (used[1][l][r - 1][inf[r] - left] == 0) {
				dfs(1, l, r - 1, inf[r] - left);
			}
			dp[v][l][r][left] = max(dp[v][l][r][left], dp[1][l][r - 1][inf[r] - left] + inf[r]);
		}
	}
	else {
		if (inf[l] < left) {
			if (used[1][l + 1][r][left - inf[l]] == 0) {
				dfs(1, l + 1, r, left - inf[l]);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[1][l + 1][r][left - inf[l]]);
		}
		else {
			if (used[0][l + 1][r][inf[l] - left] == 0) {
				dfs(0, l + 1, r, inf[l] - left);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[0][l + 1][r][inf[l] - left]);
		}
		if (inf[r] < left) {
			if (used[1][l][r - 1][left - inf[r]] == 0) {
				dfs(1, l, r - 1, left - inf[r]);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[1][l][r - 1][left - inf[r]]);
		}
		else {
			if (used[0][l][r - 1][inf[r] - left] == 0) {
				dfs(0, l, r - 1, inf[r] - left);
			}
			dp[v][l][r][left] = min(dp[v][l][r][left], dp[0][l][r - 1][inf[r] - left]);
		}
	}
}

int main()
{
	int n;
	cin >> n;
	int w = 0;
	inf.resize(n);
	int s = 0;
	for (auto& x : inf) {
		cin >> x;
		s += x;
		w = max(w, x);
	}
	dp.resize(2, vector<vector<vector<int>>>(n + 1, vector<vector<int>>(n + 1, vector<int>(w + 1))));
	used.resize(2, vector<vector<vector<bool>>>(n + 1, vector<vector<bool>>(n + 1, vector<bool>(w + 1))));
		for (int len = 1; len <= n; len++) {
			for (int l = 0; l + len <= n; l++) {
				int r = l + len - 1;
				for (int left = 0; left <= w; left++) {
					if (l < 0 || l > n || r < 0 || r > n) {
						cout << "1 2";
						return 0;
					}
					dp[0][l][r][left] = 0;
					dp[1][l][r][left] = 1e9;
					if (l == r) {
						dp[0][l][r][left] = inf[l];
						dp[1][l][r][left] = 0;
						continue;
					}
					if (inf[l] <= left) {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l + 1][r][left - inf[l]] + inf[l]);
					}
					else {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l + 1][r][inf[l] - left] + inf[l]);
					}
					if (inf[r] <= left) {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l][r - 1][left - inf[r]] + inf[r]);
					}
					else {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l][r - 1][inf[r] - left] + inf[r]);
					}


					if (inf[l] < left) {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l + 1][r][left - inf[l]]);
					}
					else {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l + 1][r][inf[l] - left]);
					}
					if (inf[r] < left) {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l][r - 1][left - inf[r]]);
					}
					else {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l][r - 1][inf[r] - left]);
					}
				}
			}
		}
	cout << dp[0][0][n - 1][0] << " " << s - dp[0][0][n - 1][0];
}