#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = short;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 20001;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
mt19937_64 gen(rd());

struct SegmentTree {
    struct Node {
        ll x, ind;
    };

    Node NEUTRAL = {INF, 0};

    Node merge(Node p1, Node p2) {
        if (p1.x <= p2.x) return p1;
        return p2;
    }

    vector<Node> p;
    ll n;

    SegmentTree(ll n): n(n) {
        p.assign(4 * n, NEUTRAL);
    }

    Node _get(ll i, ll l, ll r, ll q_l, ll q_r) {
        if (q_l <= l && r <= q_r) return p[i];
        if (q_r <= l || r <= q_l) return NEUTRAL;

        ll m = (l + r) / 2;
        return merge(_get(2 * i + 1, l, m, q_l, q_r), _get(2 * i + 2, m, r, q_l, q_r));
    }

    void _set(ll i, ll l, ll r, ll q_i, ll q_x) {
        if (l + 1 == r) {
            p[i] = {q_x, l};
            return;
        }

        ll m = (l + r) / 2;
        if (q_i < m)
            _set(2 * i + 1, l, m, q_i, q_x);
        else
            _set(2 * i + 2, m, r, q_i, q_x);

        p[i] = merge(p[2 * i + 1], p[2 * i + 2]);
    }

    Node get(ll l, ll r) {
        return _get(0, 0, n, l, r);
    }

    void set(ll i, ll x) {
        _set(0, 0, n, i, x);
    }
};

struct DP {
    ll l, r, dx;
    bool operator<(const DP &other) const {
        return mt(l, r, dx) < mt(other.l, other.r, other.dx);
    }
};

map<DP, pll> dp;
//vector<vector<vector<pll>>> dp;

vector<ll> pref;
ll n;

vector<ll> a;

pll solve(ll l, ll r, ll dx) {
    if (dp.find({l, r, dx}) != dp.end()) return dp[{l, r, dx}];

    if (dx <= 0) {
        if (l == r) return dp[{l, r, dx}] = {a[l], 0};
        pll dpLeft = solve(l + 1, r, dx + a[l]);
        pll dpRight = solve(l, r - 1, dx + a[r]);

        if (dpLeft.first + a[l] > dpRight.first + a[r] || dpLeft.first + a[l] == dpRight.first + a[r] && dpLeft.second < dpRight.second)
            return dp[{l, r, dx}] = {dpLeft.first + a[l], dpLeft.second};
        else
            return dp[{l, r, dx}] = {dpRight.first + a[r], dpRight.second};
    } else {
        if (l == r) return dp[{l, r, dx}] = {0, a[r]};
        pll dpLeft = solve(l + 1, r, dx - a[l]);
        pll dpRight = solve(l, r - 1, dx - a[r]);

        if (dpLeft.second + a[l] > dpRight.second + a[r] || dpLeft.second + a[l] == dpRight.second + a[r] && dpLeft.first < dpRight.first)
            return dp[{l, r, dx}] = {dpLeft.first, dpLeft.second + a[l]};
        else
            return dp[{l, r, dx}] = {dpRight.first, dpRight.second + a[r]};
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    cin >> n;
    a.assign(n, 0);
    for (ll i = 0; i < n; i++) cin >> a[i];

    pll s = solve(0, n - 1, 0);
    cout << s.first << " " << s.second;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
