#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
//#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    ld x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ld operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

void solve() {
    int n;
    cin >> n;
    vec<int> a(n);
    int s = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s += a[i];
    }
    s2 = a[n - 1] + 2;
    if (n == 3) {
        sort(all(a));
        int ans = 0;
        {
            int s = 1e9;
            {
                int s2 = a[0];
                if (a[0] <= a[1]) s2 += a[2];
                s = min(s, s2);
            }
            {
                int s2 = a[0];
                if (a[0] <= a[2]) s2 += a[1];
                s = min(s, s2);
            }
            ans = max(ans, s);
        }
        {
            int s = 1e9;
            {
                int s2 = a[2];
                if (a[2] <= a[1]) s2 += a[0];
                s = min(s, s2);
            }
            {
                int s2 = a[2];
                if (a[2] <= a[0]) s2 += a[1];
                s = min(s, s2);
            }
            ans = max(ans, s);
        }
        cout << ans << " " << s - ans << endl;
    }
    else {
        reverse(all(a));
        int C = n;
        if (n <= 500 && n > 200) C = 200;
        else if (n > 500) C = 75;
        vec<vec<int>> dp(C, vec<int>(2 * s2 + 1, 0));
        for (int len = 1; len <= n; ++len) {
            vec<vec<int>> dp2(C, vec<int>(2 * s2 + 1, -INF));
            for (int j = 0; j < C; ++j) {
                for (int q = s2 + 1; q <= 2 * s2; ++q) {
                    dp2[j][q] = INF;
                }
            }
            for (int j = 0; j + len <= n && j < C; ++j) { // начало текущего
                for (int w = 0; w <= 2 * s2; ++w) {
                    if (w <= s2) {
                        if (j + 1 < C && abs(dp[j + 1][w + a[j]]) <= 1e10) {
                            dp2[j][w] = max(dp2[j][w], dp[j + 1][w + a[j]] + a[j]);
                        }
                        if (abs(dp[j][w + a[j + len - 1]]) <= 1e10) {
                            dp2[j][w] = max(dp2[j][w], dp[j][w + a[j + len - 1]] + a[j + len - 1]);
                        }
                    }
                    else {
                        if (j + 1 < C && abs(dp[j + 1][w - a[j]]) <= 1e10) {
                            dp2[j][w] = min(dp2[j][w], dp[j + 1][w - a[j]] - a[j]);
                        }
                        if (abs(dp[j][w - a[j + len - 1]]) <= 1e10) {
                            dp2[j][w] = min(dp2[j][w], dp[j][w - a[j + len - 1]] - a[j + len - 1]);
                        }
                    }
                }
            }
            swap(dp, dp2);
        }
        for (int g = 0; g <= s; ++g) {
            if (g - (s - g) == dp[0][s2]) {
                cout << g << " " << s - g << endl;
                break;
            }
        }
        //cout << s / 2 + dp[0][s2] / 2 << " " << s / 2 - dp[0][s2] / 2 << endl;
    }
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    //cout << ((3e14) < (1ll << 49)) << endl;
    for (; t > 0; --t) {
        solve();
    }
}