#include <iostream>
#include <iomanip>
#include <vector>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}

int n;
vector<int> w;

namespace solve1 {
    void solve() {
        if (w[2] > w[0] + w[1]) {
            cout << w[2] << " " << w[0] + w[1] << ENDLINE;
        } else {
            cout << w[0] + w[1] << " " << w[2] << ENDLINE;
        }
    }
}

namespace solve2 {
    pair<int, int> _solve() {
        int c1 = 0;
        for (; c1 < n && w[c1] == 1; c1++) {}
        int c2 = n - c1;
        if (c2 % 2) {
            if (c1 == 0) {
                return {c2 + 1, c2 - 1};
            }
            if (c1 == 1) {
                return {c2 + 1, c2};
            }
            if (c1 > 2) {
                c1 -= 2;
                c2++;
            }
        }
        if (c1 % 2 == 0) {
            return {c1 / 2 + c2, c1 / 2 + c2};
        }
        return {c1 / 2 + c2 + 1, c1 / 2 + c2};
        
    }

    void solve() {
        cout << _solve() << ENDLINE;
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cin >> n;
    w.resize(n);
    cin >> w;
    if (n == 3) {
        solve1::solve();
    } elif (w[n - 1] <= 2) {
        solve2::solve();
    }
}
