#include <iostream>
#include <iomanip>
#include <vector>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;
using pss = pair<short, short>;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}

int n;
vector<int> w;

namespace solve1 {
    void solve() {
        if (n == 1) {
            cout << w[0] << " " << 0 << ENDLINE;
        } elif (n == 2) {
            cout << w[1] << " " << w[0] << ENDLINE;
        } elif (w[2] > w[0] + w[1]) {
            cout << w[2] << " " << w[0] + w[1] << ENDLINE;
        } else {
            cout << w[0] + w[1] << " " << w[2] << ENDLINE;
        }
    }
}

namespace solve2 {
    pair<int, int> _solve() {
        int c1 = 0;
        for (; c1 < n && w[c1] == 1; c1++) {}
        int c2 = n - c1;
        if (c2 % 2) {
            if (c1 == 0) {
                return {c2 + 1, c2 - 1};
            }
            if (c1 == 1) {
                return {c2 + 1, c2};
            }
            if (c1 > 2) {
                c1 -= 2;
                c2++;
            }
        }
        if (c1 % 2 == 0) {
            return {c1 / 2 + c2, c1 / 2 + c2};
        }
        return {c1 / 2 + c2 + 1, c1 / 2 + c2};

    }

    void solve() {
        cout << _solve() << ENDLINE;
    }
}

namespace solve34 {
    int K;

    pss get(int w0, int w1, int w2, int s) {
        if (s >= 0) {
            if (w0 + w1 <= s) {
                return {w0 + w1 + w2, 0};
            } elif (w1 <= s) {
                return {w1 + w2, w0};
            } elif (w0 <= s) {
                return {w0 + w2, w1};
            } elif (w2 >= w0 + w1) {
                return {w2, w0 + w1};
            } else {
                return {w0 + w1, w2};
            }
        }
        s *= -1;
        if (w0 + w1 < s) {
            return {0, w0 + w1 + w2};
        } elif (w1 < s) {
            return {w0, w1 + w2};
        } elif (w0 < s) {
            return {w1, w0 + w2};
        }  elif (w2 >= w0 + w1) {
            return {w0 + w1, w2};
        } else {
            return {w2, w0 + w1};
        }
    }

    pss _solve() {
        K = w[n - 1];
        vector<vector<pss>> dp(n, vector<pss>(2 * K + 1));
        vector<vector<pss>> dp2(n, vector<pss>(2 * K + 1));
        for (int i = 0, j = 3; j <= n; i++, j++) {
            for (int s = 0; s <= 2 * K; s++) {
                dp[i][s] = get(w[i], w[i + 1], w[i + 2], s - K);
            }
        }
        for (int len = 4; len <= n; len++) {
            for (int i = 0, j = len; j <= n; i++, j++) {
                for (int s = 0; s < K; s++) {
                    auto v1 = dp[i + 1][s + w[i]]; // w[i] - (-(s - K)) + K = w[i] + (s - K) + K
                    auto v2 = dp[i][s + w[j - 1]];
                    if (v1.second + w[i] >= v2.second + w[j - 1]) {
                        dp2[i][s] = {v1.first, v1.second + w[i]};
                    } else {
                        dp2[i][s] = {v1.first, v1.second + w[j - 1]};
                    }
                }
                for (int s = K; s <= 2 * K; s++) {
                    auto v1 = dp[i + 1][s - w[i]]; // (s - K) - w[i] + K
                    auto v2 = dp[i][s - w[j - 1]];
                    if (v1.first + w[i] >= v2.first + w[j - 1]) {
                        dp2[i][s] = {v1.first + w[i], v1.second};
                    } else {
                        dp2[i][s] = {v1.first + w[j - 1], v1.second};
                    }
                }
            }
            swap(dp, dp2);
        }
        return dp[0][K];
    }

    void solve() {
        cout << _solve() << ENDLINE;
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cin >> n;
    w.resize(n);
    cin >> w;
    if (n <= 3) {
        solve1::solve();
    } elif (w[n - 1] <= 2) {
        solve2::solve();
    } else {
        solve34::solve();
    }
}
