// mangooste_ok1.cpp
#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g(n);
    for (int _ = 0; _ < m1; _++) {
        int v, u;
        cin >> v >> u;
        g[v - 1].push_back(u - 1);
        g[u - 1].push_back(v - 1);
    }
    
    set<pair<int, int>> edges;
    for (int _ = 0; _ < m2; _++) {
        int v, u;
        cin >> v >> u;
        edges.insert(minmax(v - 1, u - 1));
    }

    vector<pair<int, int>> ops;
    auto make_op = [&](int v, int u) {
        if (edges.count(minmax(v, u))) {
            edges.erase(minmax(v, u));
        } else {
            edges.insert(minmax(v, u));
        }
        g[v].push_back(u);
        g[u].push_back(v);
        ops.emplace_back(v, u);
    };

    if (m1 == 0) {
        m1++;
        bool found = false;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n && !found; j++) {
                if (!edges.count({i, j}) || (i == n - 2 && j == n - 1)) {
                    found = true;
                    make_op(i, j);
                }
            }
        }
        assert(found);
    }

    vector<bool> used(n);
    vector<vector<int>> comps;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        comps.push_back({});

        auto dfs = [&](auto self, int v) -> void {
            used[v] = true;
            comps.back().push_back(v);
            for (auto u : g[v]) {
                if (!used[u]) self(self, u);
            }
        };
        dfs(dfs, i);
    }
    sort(comps.begin(), comps.end(), [](const auto &a, const auto &b) {
        return a.size() < b.size();
    });

    while (comps.size() >= 2 && comps[comps.size() - 2].size() >= 2) {
        vector<int> &first = comps[comps.size() - 2];
        vector<int> &second = comps.back();
        bool found = false;
        for (int i : {0, 1}) {
            for (int j : {0, 1}) {
                if (!found && (!edges.count(minmax(first[i], second[j])) || (i == 1 && j == 1))) {
                    found = true;
                    make_op(first[i], second[j]);
                }
            }
        }
        assert(found);
        second.insert(second.end(), first.begin(), first.end());
        swap(first, second);
        comps.pop_back();
    }
    assert(comps.back().size() >= 2);

    if (comps.size() != 1) {
        auto big = comps.back();
        comps.pop_back();
        int c = -1;
        for (auto v : comps) {
            assert(v.size() == 1);
            bool found = false;
            for (int i = 0; i < int(big.size()) && !found; i++) {
                if (!edges.count(minmax(v[0], big[i]))) {
                    found = true;
                    make_op(v[0], big[i]);
                }
            }
            if (found) continue;

            if (c == -1) {
                c = v[0];
            } else {
                make_op(v[0], big[0]);
            }
        }

        if (c != -1 && n == 3 && edges.size() == 2) {
            cout << "No\n";
            return;
        }

        bool found = (c == -1);
        for (int i = 0; i < n && !found; i++) {
            if (i == c) continue;
            if (!edges.count(minmax(c, i))) {
                found = true;
                make_op(c, i);
                continue;
            }
        }

        for (int i = 0; i < n && !found; i++) {
            if (i == c) continue;
            sort(g[i].begin(), g[i].end());
            for (int j = i + 1; j < n && !found; j++) {
                if (j != c && !binary_search(g[i].begin(), g[i].end(), j)) {
                    found = true;
                    if (!edges.count({i, j})) make_op(i, j);
                    make_op(c, i);
                }
            }
        }
        if (!found) {
            int v = (c == 0);
            int u = 1 + (c <= 1);
            if (!edges.count({v, u})) make_op(v, u);
            make_op(c, v);
        }
    }

    cout << "Yes\n";
    cout << ops.size() << '\n';
    for (auto [v, u] : ops) {
        cout << v + 1 << ' ' << u + 1 << '\n';
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests, group;
    cin >> tests >> group;
    while (tests--) {
        solve();
    }
}
