#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 3e5 + 1;
int fa[N];

int find(int x) {
    return x == fa[x] ? x : fa[x] = find(fa[x]);
}

int unite(int x, int y) {
    x = find(x), y = find(y);
    if (x == y) {
        return false;
    }
    return fa[y] = x, true;
}

void solve() {
    int n, m[2];
    cin >> n >> m[0] >> m[1];

    vector<vector<int>> adj[2];
    set<pair<int, int>> g[2];
    for (int t = 0; t < 2; ++t) {
        adj[t].resize(n);
        for (int i = 0; i < m[t]; ++i) {
            int a, b;
            cin >> a >> b;
            a -= 1, b -= 1;
            g[t].insert(minmax(a, b));
            adj[t][a].push_back(b);
            adj[t][b].push_back(a);
        }
        for (int i = 0; i < n; ++i) {
            std::sort(adj[t][i].begin(), adj[t][i].end());
        }
    }

    if (n <= 3) {
        cout << "No\n";
        return;
    }

    vector<pair<int, int>> ans;

    auto add = [&](int x, int y) {
        if (x > y) {
            swap(x, y);
        }
        ans.push_back({x, y});
        for (int t = 0; t < 2; ++t) {
            if (g[t].count({x, y})) {
                g[t].extract({x, y});
            } else {
                g[t].emplace(x, y);
            }
        }
    };

    auto print = [&]() {
        sort(ans.begin(), ans.end());
        vector<pair<int, int>> nxt;
        for (int i = 0, j = 0; i < size(ans); i = j) {
            while (j < size(ans) && ans[j] == ans[i]) {
                j += 1;
            }
            if ((j - i) % 2) {
                nxt.push_back(ans[i]);
            }
        }
        cout << "Yes\n";
        cout << size(nxt) << '\n';
        for (auto [x, y] : nxt) {
            cout << x + 1 << " " << y + 1 << '\n';
        }
        for (int t = 0; t < 2; ++t) {
            iota(fa, fa + n, 0);
            int cnt = 0;
            for (auto [x, y] : g[t]) {
                cnt += unite(x, y);
            }
            if (cnt != n - 1) {
                cout << t << endl;
                for (auto [x, y] : g[t]) {
                    cout << x << " " << y << endl;
                }
                assert(false);
            }
        }
    };

    iota(fa, fa + n, 0);

    auto solve = [&](int x, int y) {
        for (int i = 0; i < n; ++i) {
            if (i == x || i == y) {
                continue;
            }
            int x0 = g[0].count(minmax(x, i));
            int y0 = g[0].count(minmax(y, i));
            int x1 = g[1].count(minmax(x, i));
            int y1 = g[1].count(minmax(y, i));
            if ((x0 || y0) && (x1 || y1)) {
                continue;
            }
            if (!x0 && !y0) {
                if (x1) {
                    add(i, y);
                } else {
                    add(i, x);
                }
            } else {
                if (x0) {
                    add(i, y);
                } else {
                    add(i, x);
                }
            }
        }
        print();
    };

    for (int x = 0; x < n; ++x) {
        for (int y : adj[0][x]) {
            if (binary_search(adj[1][x].begin(), adj[1][x].end(), y)) {
                solve(x, y);
                return;
            }
        }
    }

    for (int x = 0; x < n; ++x) {
        for (int y = x + 1; y < n; ++y) {
            if (!binary_search(adj[0][x].begin(), adj[0][x].end(), y) && !binary_search(adj[1][x].begin(),
                                                                                        adj[1][x].end(), y)) {
                add(x, y);
                solve(x, y);
                return;
            }
        }
    }

    for (int iso = 0; iso < n; ++iso) {
        if (adj[0][iso].empty()) {
            vector<int> a;
            for (int i = 0; i < n; ++i) {
                if (i != iso) {
                    a.push_back(i);
                }
            }
            for (int i = 0; i + 1 < size(a); ++i) {
                if (!g[0].count({a[i], a[i + 1]})) {
                    add(a[i], a[i + 1]);
                }
            }
            add(iso, a[0]);
            if (!g[1].count({a[0], a.back()})) {
                add(a[0], a.back());
            }
            print();
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int to : adj[0][i]) {
            unite(i, to);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (!binary_search(adj[1][i].begin(), adj[1][i].end(), j) && unite(i, j)) {
                add(i, j);
            }
        }
    }

    print();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1, group;
    cin >> test >> group;
    while (test--) {
        solve();
    }

    return 0;
}
