#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 3e5 + 1;
int fa[N];

int find(int x) {
    return x == fa[x] ? x : fa[x] = find(fa[x]);
}

int unite(int x, int y) {
    x = find(x), y = find(y);
    if (x == y) {
        return false;
    }
    return fa[y] = x, true;
}

void solve() {
    int n, m[2];
    cin >> n >> m[0] >> m[1];

    array<vector<vector<int>>, 2> adj;
    array<set<pair<int, int>>, 2> g;
    for (int t = 0; t < 2; ++t) {
        adj[t].resize(n);
        for (int i = 0; i < m[t]; ++i) {
            int a, b;
            cin >> a >> b;
            assert(a != b);
            a -= 1, b -= 1;
            g[t].insert(minmax(a, b));
            adj[t][a].push_back(b);
            adj[t][b].push_back(a);
        }
        for (int i = 0; i < n; ++i) {
            std::sort(adj[t][i].begin(), adj[t][i].end());
        }
    }

    if (n <= 4) {
        int M = n * (n - 1) / 2;
        vector<int> A, B;
        int e1 = 0, e2 = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                A.push_back(i);
                B.push_back(j);
                if (std::binary_search(adj[0][A.back()].begin(), adj[0][A.back()].end(), B.back())) {
                    e1 ^= 1 << int(size(A) - 1);
                }
                if (std::binary_search(adj[1][A.back()].begin(), adj[1][A.back()].end(), B.back())) {
                    e2 ^= 1 << int(size(A) - 1);
                }
            }
        }
        vector<int> ok(1 << M);
        for (int mask = 0; mask < (1 << M); ++mask) {
            iota(fa, fa + n, 0);
            int c = 0;
            for (int i = 0; i < M; ++i) {
                if (mask >> i & 1) {
                    c += unite(A[i], B[i]);
                }
            }
            if (c == n - 1) {
                ok[mask] = true;
            }
        }
        for (int mask = 0; mask < (1 << M); ++mask) {
            if (__builtin_popcount(mask) > n) {
                continue;
            }
            vector<int> p;
            for (int i = 0; i < M; ++i) {
                if (mask >> i & 1) {
                    p.push_back(i);
                }
            }
            do {
                auto sa = g;
                bool yay = true;
                int x = e1, y = e2;
                for (int i : p) {
                    x ^= 1 << i;
                    y ^= 1 << i;
                    if (!ok[y]) {
                        yay = false;
                        break;
                    }
                }
                if (yay && ok[x]) {
                    cout << "Yes\n";
                    cout << size(p);
                    for (int i : p) {
                        cout << A[i] + 1 << " " << B[i] + 1 << '\n';
                    }
                    return;
                }
                swap(g, sa);
            } while (next_permutation(p.begin(), p.end()));
        }
        cout << "No\n";
        return;
    }

    map<pair<int, int>, int> st;
    int T = 0;

    auto add = [&](int x, int y) {
        if (x > y) {
            swap(x, y);
        }
        if (st.count({x, y})) {
            st.extract({x, y});
        } else {
            st[{x, y}] = T++;
        }
        for (int t = 0; t < 2; ++t) {
            if (g[t].count({x, y})) {
                g[t].extract({x, y});
            } else {
                g[t].emplace(x, y);
            }
        }
    };

    auto print = [&]() {
        vector<array<int, 3>> ans;
        for (auto [a, b] : st) {
            ans.push_back({b, a.first, a.second});
        }
        sort(ans.begin(), ans.end());
        for (int t = 0; t < 2; ++t) {
            iota(fa, fa + n, 0);
            int cnt = 0;
            for (auto [x, y] : g[t]) {
                cnt += unite(x, y);
            }
            if (cnt != n - 1) {
                cout << "No\n";
                return;
                assert(false);
                cout << t << endl;
                for (auto [x, y] : g[t]) {
                    cout << x << " " << y << endl;
                }
                assert(false);
            }
        }
        cout << "Yes\n";
        cout << size(st) << '\n';
        for (auto [t, x, y] : ans) {
            cout << x + 1 << " " << y + 1 << '\n';
        }
    };

    iota(fa, fa + n, 0);

    auto solve = [&](int x, int y) {
        for (int i = 0; i < n; ++i) {
            if (i == x || i == y) {
                continue;
            }
            int x0 = g[0].count(minmax(x, i));
            int y0 = g[0].count(minmax(y, i));
            int x1 = g[1].count(minmax(x, i));
            int y1 = g[1].count(minmax(y, i));
            if ((x0 || y0) && (x1 || y1)) {
                continue;
            }
            if (!x0 && !y0) {
                if (x1) {
                    add(i, y);
                } else {
                    add(i, x);
                }
            } else {
                if (x0) {
                    add(i, y);
                } else {
                    add(i, x);
                }
            }
        }
        print();
    };

    for (int x = 0; x < n; ++x) {
        for (int y : adj[0][x]) {
            if (binary_search(adj[1][x].begin(), adj[1][x].end(), y)) {
                solve(x, y);
                return;
            }
        }
    }

    for (int x = 0; x < n; ++x) {
        for (int y = x + 1; y < n; ++y) {
            if (!binary_search(adj[0][x].begin(), adj[0][x].end(), y) && !binary_search(adj[1][x].begin(),
                                                                                        adj[1][x].end(), y)) {
                add(x, y);
                solve(x, y);
                return;
            }
        }
    }

    for (int iso = 0; iso < n; ++iso) {
        if (adj[0][iso].empty()) {
            vector<int> a;
            for (int i = 0; i < n; ++i) {
                if (i != iso) {
                    a.push_back(i);
                }
            }
            for (int i = 0; i + 1 < size(a); ++i) {
                if (!g[0].count({a[i], a[i + 1]})) {
                    add(a[i], a[i + 1]);
                }
            }
            if (!g[1].count({a[0], a.back()})) {
                add(a[0], a.back());
            }
            add(iso, a[0]);
            print();
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int to : adj[0][i]) {
            unite(i, to);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (!binary_search(adj[1][i].begin(), adj[1][i].end(), j) && unite(i, j)) {
                add(i, j);
            }
        }
    }

    print();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1, group;
    cin >> test >> group;
    while (test--) {
        solve();
    }

    return 0;
}
