#pragma GCC optimaze("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <queue>
using namespace std;

ostream& operator<< (ostream& stream, const pair<int, int>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<int>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<int, int>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const pair<long long, long long>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<long long>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const multiset<long long>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<long long, long long>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}







void dfs(int v, vector<bool>& used, int& c, const vector<vector<bool>>& g) {
    used[v] = true;
    c++;
    for (int u = 0; u < (int) g.size(); u++) {
        if (g[u][v] && !used[u]) {
            dfs(u, used, c, g);
        }
    }
}

bool check(int mask, const vector<pair<int, int>>& edges, vector<vector<bool>> g1, vector<vector<bool>> g2) {
    int n = (int) g1.size();
    int sz = (int) edges.size();
    for (int i = 0; i < sz; i++) {
        if (!((mask >> i) & 1)) {
            continue;
        }
        int u = edges[i].first;
        int v = edges[i].second;
        g1[u][v] = g1[v][u] = g1[u][v] ^ 1;
        g2[u][v] = g2[v][u] = g1[u][v] ^ 1;
    }
    int c1 = 0;
    vector<bool> used1(n, false);
    dfs(0, used1, c1, g1);
    int c2 = 0;
    vector<bool> used2(n, false);
    dfs(0, used2, c2, g2);
    return c1 == n && c2 == n;
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<bool>> g1(n, vector<bool>(n, false)), g2(n, vector<bool>(n, false));
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u - 1][v - 1] = g1[v - 1][u - 1] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        g2[u - 1][v - 1] = g2[v - 1][u - 1] = true;
    }
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            edges.push_back({i, j});
        }
    }
    int sz = (int) edges.size();
    for (int mask = 0; mask < (1 << sz); mask++) {
        int c = __builtin_popcount(mask);
        if (c <= n && check(mask, edges, g1, g2)) {
            cout << "Yes\n";
            cout << c << "\n";
            for (int i = 0; i < sz; i++) {
               
                if ((mask >> i) & 1) {
                    cout << edges[i].first + 1 << " " << edges[i].second + 1 << "\n";
                }
            }
            return;
        }
    }
    cout << "No\n";
}

int main() {
    int t, G;
    cin >> t >> G;
    while (t--) {
        if (G <= 1) {
            solve1();
        }
    }
}