#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

int g;

vector<set<ll>> G1, G2;

vector<ll> v1, v2;

vector<bool> used;
void dfs(ll v) {
	used[v] = true;
	v1.push_back(v);
	for (ll to : G1[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	G1.assign(n, {});
	G2.assign(n, {});
	ll u, v;
	unordered_set<pair<ll, ll>> edges1, edges2;
	for (ll i = 0; i < m1; i++) {
		cin >> u >> v; u--; v--;
		G1[u].insert(v);
		G1[v].insert(u);
		edges1.insert({ u, v });
		edges1.insert({ v, u });
	}
	for (ll i = 0; i < m1; i++) {
		cin >> u >> v; u--; v--;
		G2[u].insert(v);
		G2[v].insert(u);
		edges2.insert({ u, v });
		edges2.insert({ v, u });
	}
	used.assign(n, false);
	dfs(0);
	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			v2.push_back(i);
		}
	}
	for (ll cur_v : v1) {
		for (ll cur_u : v2) {
			if (edges2.find({ cur_v, cur_u }) == edges2.end()) {
				cout << "Yes\n1\n";
				cout << cur_v + 1 << " " << cur_u + 1 << "\n";
				return;
			}
		}
	}
	if (v1.size() == 1 || v2.size() == 1) {
		cout << "No\n";
	}

	cout << "Yes\n1\n";
	cout << v1[0] + 1 << " " << v2[0] + 1 << "\n";
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	cin >> t >> g;
	assert(g == 3);
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/