#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

int g;

vector<set<ll>> G1, G2;

vector<ll> v1, v2;

vector<bool> used;
void dfs(ll v) {
	used[v] = true;
	v1.push_back(v);
	for (ll to : G1[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

vector<ll> color;
const ll WHITE = 0, GREY = 1, BLACK = 2;

ll rs1, rs2;

void dfs2(ll v, ll p) {
	color[v] = GREY;
	for (ll to : G2[v]) {
		if (color[to] == WHITE) {
			dfs2(to, v);
		}
		else if (color[to] == GREY) {
			rs1 = v;
			rs2 = to;
		}
	}
	color[v] = BLACK;
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	rs1 = -1;
	rs2 = -1;
	color.assign(n, WHITE);
	G1.assign(n, {});
	G2.assign(n, {});
	v1.clear();
	v2.clear();
	ll u, v;
	for (ll i = 0; i < m1; i++) {
		cin >> u >> v; u--; v--;
		G1[u].insert(v);
		G1[v].insert(u);
	}
	vector<vector<bool>> G2_v(n, vector<bool>(n, false));
	for (ll i = 0; i < m2; i++) {
		cin >> u >> v; u--; v--;
		G2_v[u][v] = true;
		G2_v[v][u] = true;
		G2[u].insert(v);
		G2[v].insert(u);
	}
	used.assign(n, false);
	dfs(0);
	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			v2.push_back(i);
		}
	}


	for (ll cur_v : v1) {
		for (ll cur_u : v2) {
			if (!G2_v[cur_v][cur_u]) {
				cout << "Yes\n1\n";
				cout << cur_v + 1 << " " << cur_u + 1 << "\n";
				return;
			}
		}
	}
	dfs2(v1[0], -1);
	if (rs1 == -1) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n1\n" << rs1 << " " << rs2 << "\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	cin >> t >> g;
	assert(g == 3);
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/