#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<vector<int>> G1, G2;
vector<char> seen1;

void dfs(int vertex) {
	seen1[vertex] = 1;

	for (int v : G1[vertex]) {
		if (seen1[v]) continue;
		dfs(v);
	}
}

void solve() {
	G1.clear();
	G2.clear();
	seen1.clear();

	int n, m1, m2;
	cin >> n >> m1 >> m2;

	G1.resize(n + 1);
	G2.resize(n + 1);
	seen1.resize(n + 1);

	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		G1[v].push_back(u);
		G1[u].push_back(v);
	}

	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		G2[v].push_back(u);
		G2[u].push_back(v);
	}

	dfs(1);
	for (int i = 1; i <= n; i++) {
		if (seen1[i]) continue;
		cout << "No";
		return;
	}

	cout << "Yes\n0";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1, g;
	cin >> t >> g;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
