#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g1, g2;
set<int> unused;
set<pair<int, int>> edges;
vector<pair<int, int>> tree_edges;

void dfs1(int v, int n) {
    unused.erase(v);
    for (auto u : unused) {
        if (edges.find({v, u}) == edges.end()) {
            tree_edges.push_back({v, u});
            dfs1(u, n);
        }
        if (tree_edges.size() == n - 1) {
            return;
        }
    }
}

vector<int> used, pred, r;

void dfs2(int v, int c) {
    used[v] = 1;
    pred[v] = c;
    r[c]++;
    for (auto u : g1[v]) {
        if (!used[u]) {
            dfs2(u, c);
        }
    }
}

int get(int v) {
    while (pred[v] != -1) {
        v = pred[v];
    }
    return v;
}

void merg(int v, int u) {
    v = get(v);
    u = get(u);
    if (r[v] < r[u]) {
        pred[v] = u;
        r[u] += r[v];
    } else {
        pred[u] = v;
        r[v] += r[u];
    }
}

int main() {
    int t, group;
    cin >> t >> group;
    for (int q = 0; q < t; ++q) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.clear();
        g2.clear();
        g1.resize(n + 1);
        g2.resize(n + 1);
        edges.clear();
        unused.clear();
        for (int i = 0; i < m1; ++i) {
            int v, u; cin >> v >> u;
            g1[v].push_back(u);
            g1[u].push_back(v);
        }
        for (int i = 0; i < m2; ++i) {
            int v, u; cin >> v >> u;
            g2[v].push_back(u);
            g2[u].push_back(v);
            edges.insert({v, u});
            edges.insert({u, v});
        }
        for (int i = 1; i <= n; ++i) {
            unused.insert(i);
        }
        tree_edges.clear();
        dfs1(1, n);
        r.clear();
        used.clear();
        pred.clear();
        r.resize(n + 1);
        used.resize(n + 1);
        pred.resize(n + 1);
        for (int i = 1; i <= n; ++i) {
            if (!used[i]) {
                dfs2(i, i);
                pred[i] = -1;
            }
        }
/*for (auto [v, u] : tree_edges) {
            cout << v << ' ' << u << '\n';
        }
        for (int i = 1; i <= n; ++i) {
            cout << pred[i] << ' ';
        }*/


        vector<pair<int, int>> ans;
        for (auto [v, u] : tree_edges) {
            if (get(v) != get(u)) {
                ans.push_back({v, u});
                merg(v, u);
            }
        }
        cout << "Yes" << '\n' << ans.size() << '\n';
        for (auto el : ans) {
            cout << el.first << ' ' << el.second << '\n';
        }
    }
}
