#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
typedef tree<long long, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int G;
vector<vector<int>> g1, g2;
vector<set<int>> sg1, sg2;
set<pair<int, int>> s1, s2;
vector<int> used;
int col = 0;

void dfs2(int v) {
    used[v] = 1;
    ++col;
    for (auto to: sg2[v]) {
        if (!used[to]) {
            dfs2(to);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n);
    g2.resize(n);
    sg1.resize(n);
    sg2.resize(n);
    for (int i = 0; i < m1; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        g1[q].emplace_back(w);
        g1[w].emplace_back(q);
        sg1[q].insert(w);
        sg1[w].insert(q);
        s1.insert({min(q, w), max(q, w)});
    }
    for (int i = 0; i < m2; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        g2[q].emplace_back(w);
        g2[w].emplace_back(q);
        sg2[q].insert(w);
        sg2[w].insert(q);
        s2.insert({min(q, w), max(q, w)});
    }
    if (G == 1) {
        vector<pair<int, int>> d;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                d.emplace_back(i, j);
            }
        }
        do {
            int ok = 1;
            for (int i = 0; i < n; ++i) {
                if (s2.find({d[i].first, d[i].second}) == s2.end()) {
                    sg2[d[i].first].insert(d[i].second);
                    sg2[d[i].second].insert(d[i].first);
                } else {
                    sg2[d[i].first].erase(d[i].second);
                    sg2[d[i].second].erase(d[i].first);
                }
                used.resize(n);
                dfs2(0);
                used.clear();
                if (col != n) {
                    ok = 0;
                }
                col = 0;
            }
            if (ok) {
                cout << "Yes\n" << n << '\n';
                for (int j = 0; j < n; ++j) {
                    cout << d[j].first + 1 << ' ' << d[j].second + 1 << '\n';
                }
                return;
            }
            col = 0;
            for (int i = 0; i < n; ++i) {
                if (s2.find({d[i].first, d[i].second}) == s2.end()) {
                    sg2[d[i].first].insert(d[i].second);
                    sg2[d[i].second].insert(d[i].first);
                } else {
                    sg2[d[i].first].erase(d[i].second);
                    sg2[d[i].second].erase(d[i].first);
                }
            }
        } while (std::next_permutation(d.begin(), d.end()));
        cout << "No\n";
        return;
    } else if (G == 2) {
        if (n == 3 && m1 == 0) {
            cout << "No\n";
        } else {
            vector<pair<int, int>> ans;
            for (int i = 0; i < n - 1; ++i) {
                if (s1.find({i, i + 1}) == s1.end()) {
                    ans.emplace_back(i, i + 1);
                }
            }
            cout << "Yes\n";
            cout << (int) ans.size() << '\n';
            for (auto [it1, it2]: ans) {
                cout << it1 + 1 << ' ' << it2 + 1 << '\n';
            }
        }
        return;
    } else if (G == 7) {
        vector<pair<int, int>> ans;
        for (int i = 3; i < n; ++i) {
            if (s1.find({0, i}) == s1.end() && s1.find({1, i}) == s1.end()) {
                if (s2.find({0, i}) == s2.end()) {
                    ans.emplace_back(0, i);
                } else {
                    ans.emplace_back(1, i);
                }
            }
        }
        cout << "Yes\n";
        cout << (int) ans.size() << '\n';
        for (auto [it1, it2]: ans) {
            cout << it1 + 1 << ' ' << it2 + 1 << '\n';
        }
        return;
    }
}

signed main() {
    fast_in_out();
    int t;
    cin >> t >> G;
    while (t--) {
        solve();
        g1.clear();
        g2.clear();
        sg1.clear();
        sg2.clear();
        s1.clear();
        s2.clear();
        col = 0;
        used.clear();
//        cout << '\n';
    }
    return 0;
}
