#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e18;
const int MAXN = 1e5;
int MAXW = 0;

void solve(int g) {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::set<std::pair<int, int>> a, b;
    auto check_a = [&](int u, int v) {
        return a.count({u, v}) || a.count({v, u});
    };
    auto check_b = [&](int u, int v) {
        return b.count({u, v}) || b.count({v, u});
    };
    for (int i = 0; i < m1; i++) {
        int u, v;
        std::cin >> u >> v;
        u--; v--;
        a.insert({u, v});
    }
    int s = -1, t = -1;
    for (int i = 0; i < m2; i++) {
        int u, v;
        std::cin >> u >> v;
        u--; v--;
        b.insert({u, v});
        if (s == -1 && check_a(u, v)) {
            s = u, t = v;
        }
    }
    std::vector<std::pair<int, int>> ans;
    if (s == -1) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (!check_a(i, j) && !check_b(i, j)) {
                    s = i;
                    t = j;
                    break;
                }
            }
            if (s != -1) {
                break;
            }
        }
        ans.push_back({s, t});
    }
    if (s == -1) {
        std::cout << "No\n";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (i == s || i == t) continue;
        if (!check_a(s, i) && !check_a(t, i)) {
            if (check_b(s, i)) {
                ans.emplace_back(t, i);
            } else {
                ans.emplace_back(s, i);
            }
        }
    }
    std::cout << "Yes\n";
    std::cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        std::cout << i + 1 << ' ' << j + 1 << '\n';
    }
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1, g;
    std::cin >> t >> g;
    while (t --> 0) {
        solve(g);
    }
    return 0;
}
