#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e18;
const int MAXN = 1e5;
int MAXW = 0;

std::vector<std::vector<int>> g;
std::vector<bool> used;
std::vector<std::set<int>> comp;
void dfs(int node) {
    comp.back().insert(node);
    for (auto to : g[node]) {
        if (!used[to]) {
            used[to] = true;
            dfs(to);
        }
    }
}

void solve(int h) {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::set<std::pair<int, int>> a, b;
    auto check_a = [&](int u, int v) {
        return a.count({u, v}) || a.count({v, u});
    };
    auto check_b = [&](int u, int v) {
        return b.count({u, v}) || b.count({v, u});
    };
    g.assign(n, {});
    comp.clear();
    for (int i = 0; i < m1; i++) {
        int u, v;
        std::cin >> u >> v;
        u--; v--;
        a.insert({u, v});
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int s = -1, t = -1;
    for (int i = 0; i < m2; i++) {
        int u, v;
        std::cin >> u >> v;
        u--; v--;
        b.insert({u, v});
        if (s == -1 && check_a(u, v)) {
            s = u, t = v;
        }
    }
    std::vector<std::pair<int, int>> ans;
    if (s == -1) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (!check_a(i, j) && !check_b(i, j)) {
                    s = i;
                    t = j;
                    ans.push_back({s, t});
                    break;
                }
            }
            if (s != -1) {
                break;
            }
        }
    }
    if (s == -1) {
        if (n <= 3) {
            std::cout << "No\n";
        }
        used.assign(n, false);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                comp.emplace_back();
                dfs(i);
            }
        }
        if (comp.size() == 1) {
            std::cout << "Yes\n0\n";
            return;
        }
        std::sort(comp.begin(), comp.end(), [&](auto &a, auto &b){
            return a.size() < b.size();
        });
        if (comp[0].size() == 1 && comp[1].size() != 1) {
            int u = *comp[0].begin();
            int v1 = *comp[1].begin();
            comp[1].erase(comp[1].begin());
            int v2 = *comp[1].begin();
            comp[1].erase(comp[1].begin());
            int v3 = *comp[1].begin();
            comp[1].erase(comp[1].begin());
            ans.emplace_back(u, v1);
            if (check_a(v1, v3)) {
                ans.emplace_back(v1, v3);
            }
            if (!check_a(v1, v2)) {
                ans.emplace_back(v1, v2);
            }
            if (!check_a(v2, v3)) {
                ans.emplace_back(v2, v3);
            }
            std::cout << "Yes\n";
            std::cout << ans.size() << '\n';
            for (auto [i, j] : ans) {
                std::cout << i + 1 << ' ' << j + 1 << '\n';
            }
            return;
        }
        for (int i = 0; i + 1 < comp.size(); i++) {
            int u = *comp[i].begin();
            int v = *comp[i + 1].begin();
            ans.emplace_back(u, v);
        }
        std::cout << "Yes\n";
        std::cout << ans.size() << '\n';
        for (auto [i, j] : ans) {
            std::cout << i + 1 << ' ' << j + 1 << '\n';
        }
        return;
    }
    for (int i = 0; i < n; i++) {
        if (i == s || i == t) continue;
        if (!check_a(s, i) && !check_a(t, i)) {
            if (check_b(s, i)) {
                ans.emplace_back(t, i);
            } else {
                ans.emplace_back(s, i);
            }
        }
    }
    std::cout << "Yes\n";
    std::cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        std::cout << i + 1 << ' ' << j + 1 << '\n';
    }
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1, h;
    std::cin >> t >> h;
    while (t --> 0) {
        solve(h);
    }
    return 0;
}
