#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<int>> gr1, gr2;
int n;
vector<int> color;
vector<int> used2;

void dfs(int v, int c, vector<vector<int>> &gr) {
    color[v] = c;
    for (auto x : gr[v]) {
        if (!color[x]) {
            dfs(x, c, gr);
        }
    }
}

void dfs2(int v) {
    used2[v] = 1;
    for (int i = 0; i < n; i++) {
        if (gr2[v][i] == 1 && used2[i] == 0) {
            dfs2(i);
        }
    }
}

int main() {
    int t, g; cin >> t >> g;
    // g = 2
    while (t--) {
        vector<pair<int, int>> edges1, edges2, edge;
        int m1, m2; cin >> n >> m1 >> m2;
        gr1.assign(n, vector<int>());
        gr2.assign(n, vector<int>(n, 0));
        for (int i = 0; i < m1; i++) {
            int v, u; cin >> v >> u;
            v--; u--;
            gr1[u].push_back(v);
            gr1[v].push_back(u);
        }
        for (int i = 0; i < m2 ; i++) {
            int a, b; cin >> a >> b;
            a--; b--;
            gr2[a][b] = 1;
            gr2[b][a] = 1;
        }
        color.assign(n, 0);
        dfs(0, 1, gr1);
        for (int i2 = 0; i2 < n; i2++) {
            for (int i1 = 0; i1 < n; i1++) {
                if (color[i1] != color[i2]) {
                    edge.push_back({i1, i2});
                }
            }
        }
        pair<int, int> ans = {-1, -1};
        for (auto x : edge) {
            // проверить не ломает ли заклинание этого ребра gr2
            gr2[x.first][x.second] = 1 - gr2[x.first][x.second];
            gr2[x.second][x.first] = 1 - gr2[x.second][x.first];
            used2.assign(n, 0);
            dfs2(0);
            bool ok = 1;
            for (int i = 0; i < n; i++) {
                if (used2[i] == 0) {
                    ok = 0;
                }
            }
            if (ok) {
                ans = x;
                break;
            }
            gr2[x.first][x.second] = 1 - gr2[x.first][x.second];
            gr2[x.second][x.first] = 1 - gr2[x.second][x.first];
        }
        if (ans.first != -1) {
            cout << "Yes" << '\n';
            cout << 1 << '\n';
            cout << ans.first + 1 << " " << ans.second + 1 << '\n';
        } else {
            cout << "No" << '\n';
        }
    }

}
