#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()

int n, m1, m2;

bool checkCon(vector<vector<int>>& g) {
	vector<bool> used(n);
	queue<int> q;
	q.push(0);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u = 0; u < n; u++)
			if (g[v][u] && !used[u]) {
				used[u] = true;
				q.push(u);
			}
	}
	return count(all(used), true) == n;
}

inline void solve1(bool inp = true) {
	if (inp)
		cin >> n >> m1 >> m2;
	vector<vector<int>> g1(n, vector<int>(n));
	auto g2 = g1;
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g1[v][u] = g2[u][v] = 1;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g2[v][u] = g2[u][v] = 1;
	}
	if (checkCon(g1)) {
		cout << "Yes\n";
		cout << 0 << '\n';
		return;
	}
	vector<pii> edges;
	for (int v = 0; v < n; v++)
		for (int u = 0; u < v; u++)
			edges.push_back({ u, v });
	vector<int> p(edges.size());
	iota(all(p), 0);
	do {
		vector<pii> cur;
		bool ans = false;
		bool ban = false;
		for (pii e : edges) {
			cur.push_back(e);
			if (cur.size() > n) {
				ban = true;
				break;
			}
			int v, u;
			v = e.first, u = e.second;
			g1[v][u] ^= 1;
			g1[u][v] ^= 1;
			g2[v][u] ^= 1;
			g2[u][v] ^= 1;
			if (!checkCon(g2)) {
				ban = true;
				break;
			}
			if (checkCon(g1)) {
				ans = true;
				break;
			}
		}
		if (ban)
			continue;
		if (ans) {
			cout << "Yes\n";
			cout << cur.size() << '\n';
			for (pii p : cur)
				cout << p.first + 1 << ' ' << p.second + 1 << '\n';
			return;
		}
	} while (next_permutation(all(p)));
	cout << "No\n";
}

inline void solve2() {
	cin >> n >> m1 >> m2;
	if (n <= 5) {
		solve1(false);
		return;
	}
	vector<bool> un(n);
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if (v > u)
			swap(v, u);
		if (u == v + 1)
			un[v] = true;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
	}
	vector<pii> ans;
	for (int i = 0; i < n - 1; i++)
		if (!un[i])
			ans.push_back({ i, i + 1 });
	cout << "Yes\n";
	cout << ans.size() << '\n';
	for (pii e : ans)
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
}

inline void solve() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	int group;
	cin >> group;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		if (group == 1)
			solve1();
		else if (group == 2)
			solve2();
		else
			solve();
	}
	return 0;
}
