#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()

const int N = 3e5;
int n, m1, m2;

vector<pii> edges;
vector<pii> curans;
vector<int> g1[N], g2[N];
int ma1[5][5], ma2[5][5];
int used[N];
int usedEdges[N];
int timer = 1;

void dfsCon1(int v) {
	used[v] = timer;
	for (int u = 0; u < n; u++)
		if (ma1[v][u] && used[u] < timer)
			dfsCon1(u);
}

void dfsCon2(int v) {
	used[v] = timer;
	for (int u = 0; u < n; u++)
		if (ma2[v][u] && used[u] < timer)
			dfsCon2(u);
}

bool discon() {
	return count(used, used + n, timer) < n;
}

bool rec(int i, int last = -1) {
	if (i > n)
		return false;
	timer++;
	dfsCon2(0);
	if (discon())
		return false;
	timer++;
	dfsCon1(0);
	if (!discon())
		return true;
	for (int j = 0; j < (int)edges.size(); j++) {
		if (j == last)
			continue;
		usedEdges[j] ^= 1;
		int v, u;
		v = edges[j].first;
		u = edges[j].second;
		ma1[v][u] ^= 1;
		ma1[u][v] ^= 1;
		ma2[v][u] ^= 1;
		ma2[u][v] ^= 1;
		curans.push_back(edges[j]);
		if (rec(i + 1))
			return true;
		usedEdges[j] ^= 1;
		ma1[v][u] ^= 1;
		ma1[u][v] ^= 1;
		ma2[v][u] ^= 1;
		ma2[u][v] ^= 1;
		curans.pop_back();
	}
	return false;
}

inline void solve1(bool inp = true) {
	if (inp)
		cin >> n >> m1 >> m2;
	assert(n < 4);
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		ma1[v][u] = ma1[u][v] = 1;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		ma2[v][u] = ma2[u][v] = 1;
	}
	for (int v = 0; v < n; v++)
		for (int u = 0; u < v; u++)
			edges.push_back({ u, v });
	if (rec(0)) {
		cout << "Yes\n";
		cout << curans.size() << '\n';
		for (pii e : curans)
			cout << e.first + 1 << ' ' << e.second + 1 << '\n';
		curans.clear();
		edges.clear();
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				ma1[i][j] = ma2[i][j] = 0;
		timer++;
		return;
	}
	cout << "No\n";
	curans.clear();
	edges.clear();
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			ma1[i][j] = ma2[i][j] = 0;
	timer++;
}

inline void solve2() {
	cin >> n >> m1 >> m2;
	if (n <= 5) {
		solve1(false);
		return;
	}
	vector<bool> un(n);
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if (v > u)
			swap(v, u);
		if (u == v + 1)
			un[v] = true;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
	}
	vector<pii> ans;
	for (int i = 0; i < n - 1; i++)
		if (!un[i])
			ans.push_back({ i, i + 1 });
	cout << "Yes\n";
	cout << ans.size() << '\n';
	for (pii e : ans)
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
}

inline void solve() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	int group;
	cin >> group;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		if (group <= 1)
			solve1();
		else if (group == 2)
			solve2();
		else
			solve();
	}
	return 0;
}
