#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct DSU {
	vector<int> pr, sz;

	DSU() {}

	DSU(int n) {
		pr.resize(n);
		iota(all(pr), 0);
		sz.resize(n, 1);
	}

	int get(int a) {
		return pr[a] = (pr[a] == a ? a : get(pr[a]));
	}
	
	bool unite(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return false;
		if (sz[a] < sz[b])
			swap(a, b);
		sz[a] += sz[b];
		pr[b] = a;
		return true;
	}
};

const int N = 5000;
int g1[N][N], g2[N][N];
int used[N];
int timer = 1;
int n;

void dfsCon(int v, int c) {
	used[v] = timer;
	if (c == 1) {
		for (int u = 0; u < n; u++)
			if (g1[v][u] && used[u] < timer)
				dfsCon(u, c);
	} else {
		for (int u = 0; u < n; u++)
			if (g2[v][u] && used[u] < timer)
				dfsCon(u, c);
	}
}

bool discon() {
	return count(used, used + n, timer) < n;
}

vector<pii> edges, upd;

bool rec(int i) {
	if (i > n)
		return false;
	timer++;
	dfsCon(0, 2);
	if (discon())
		return false;
	timer++;
	dfsCon(0, 1);
	if (!discon())
		return true;
	for (int j = 0; j < (int)edges.size(); j++) {
		int v, u;
		v = edges[j].first;
		u = edges[j].second;
		g1[v][u] ^= 1;
		g1[u][v] ^= 1;
		g2[v][u] ^= 1;
		g2[u][v] ^= 1;
		upd.push_back(edges[j]);
		if (rec(i + 1))
			return true;
		g1[v][u] ^= 1;
		g1[u][v] ^= 1;
		g2[v][u] ^= 1;
		g2[u][v] ^= 1;
		upd.pop_back();
	}
	return false;
}

inline void solve() {
	int m1, m2;
	cin >> n >> m1 >> m2;
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g1[v][u] = 1;
		g1[u][v] = 1;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g2[v][u] = 1;
		g2[u][v] = 1;
	}
	if (n <= 5) {
		if (rec(0)) {
			cout << "Yes\n";
			cout << upd.size() << '\n';
			for (pii p : upd)
				cout << p.first + 1 << ' ' << p.second + 1 << '\n';
			return;
		}
		else
			cout << "No\n";
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				g1[i][j] = g2[i][j] = 0;
		upd.clear();
		edges.clear();
		timer++;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	int group;
	cin >> group;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
