#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

bool svyaz(ll n, vector<vector<ll>> g) {
    vector<ll> used(n, 0);
    queue<ll> q;
    used[0] = 1;
    q.push(0);

    while (q.size()) {
        ll v = q.front();
        q.pop();

        for (ll i = 0; i < n; ++i) {
            if (g[v][i] && used[i] == 0) {
                used[i] = 1;
                q.push(i);
            }
        }
    }

    for (auto i : used) {
        if (i == 0) return false;
    }
    return true;
}

vector<pair<ll, ll>> diff;
vector<vector<pair<ll, ll>>> all;
ll n, m1, m2;
vector<pair<ll, ll>> now;
vector<ll> used;

void gen() {
    if (now.size()) {
        all.push_back(now);

        if (now[0] == make_pair(1LL, 2LL) && now[2] == make_pair(1LL, 2LL)) {
            cout << "OK";
            return;
        }
    }

    if (now.size() == n) return;

    for (ll i = 0; i < diff.size(); ++i) {
        if (used[i] == 0) {
            used[i] = 1;
            now.push_back(diff[i]);
            gen();
            used[i] = 0;
            now.pop_back();
        }
    }
}

void solve(ll group) {
    cin >> n >> m1 >> m2;

    if (n <= 5) {
        vector<vector<ll>> fir(n, vector<ll> (n, 0)), sec(n, vector<ll>(n, 0));

        for (ll i = 0; i < m1; ++i) {
            ll a, b;
            cin >> a >> b;

            --a, --b;

            fir[a][b] = 1;
            fir[b][a] = 1;
        }
        for (ll i = 0; i < m2; ++i) {
            ll a, b;
            cin >> a >> b;

            --a, --b;

            sec[a][b] = 1;
            sec[b][a] = 1;
        }

        if (svyaz(n, fir)) {
            cout << "Yes\n";
            cout << "0\n";
            return;
        }

        for (ll i = 0; i < n; ++i) {
            for (ll j = i + 1; j < n; ++j) {
                diff.push_back({i, j});
            }
        }

        used.resize(diff.size(), 0);

        gen();
        vector<pair<ll, ll>> to_ans;

        for (auto i : all) {
            auto now_fir = fir, now_sec = sec;
            bool flag = true;
            for (auto j : i) {
                now_fir[j.first][j.second] ^= 1;
                now_fir[j.second][j.first] ^= 1;
                now_sec[j.first][j.second] ^= 1;
                now_sec[j.second][j.first] ^= 1;

                if (!svyaz(n, now_sec)) {
                    flag = false;
                    break;
                }
            }

            if (flag && svyaz(n, now_fir)) {
                to_ans = i;
                break;
            }
        }

        if (to_ans.size() == 0) {
            cout << "No\n";
        }
        else {
            cout << "Yes\n";
            cout << to_ans.size() << '\n';
            for (auto i : to_ans) {
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
        }

        diff.clear();
        all.clear();
        used.clear();
    }
}

int main() {
    fast_stream();

    int tests = 1, group;
    cin >> tests >> group;

    while (tests--) {
        solve(group);
    }
}
