#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

bool svyaz(int n, vector<vector<int>> g) {
    vector<int> used(n, 0);
    queue<int> q;
    used[0] = 1;
    q.push(0);

    while (q.size()) {
        int v = q.front();
        q.pop();

        for (int i = 0; i < n; ++i) {
            if (g[v][i] && used[i] == 0) {
                used[i] = 1;
                q.push(i);
            }
        }
    }

    for (auto i : used) {
        if (i == 0) return false;
    }
    return true;
}

vector<pair<int, int>> diff;
int n, m1, m2;
vector<pair<int, int>> now;
vector<int> used;
vector<vector<int>> fir, sec;

bool gen() {
    if (svyaz(n, fir)) {
        cout << "Yes\n";
        cout << now.size() << '\n';
        for (auto i : now) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return true;
    }

    if (now.size() == n) return false;

    for (int i = 0; i < diff.size(); ++i) {
        if (used[i] == 0) {
            used[i] = 1;
            now.push_back(diff[i]);
            fir[diff[i].first][diff[i].second] ^= 1;
            fir[diff[i].second][diff[i].first] ^= 1;
            sec[diff[i].first][diff[i].second] ^= 1;
            sec[diff[i].second][diff[i].first] ^= 1;
            if (svyaz(n, sec)) {
                if (gen()) {
                    return true;
                }
            }
            fir[diff[i].first][diff[i].second] ^= 1;
            fir[diff[i].second][diff[i].first] ^= 1;
            sec[diff[i].first][diff[i].second] ^= 1;
            sec[diff[i].second][diff[i].first] ^= 1;
            used[i] = 0;
            now.pop_back();
        }
    }

    return false;
}

void solve(int group) {
    cin >> n >> m1 >> m2;

    if (n <= 5) {
        fir.resize(n, vector<int> (n, 0)), sec.resize(n, vector<int>(n, 0));

        for (int i = 0; i < m1; ++i) {
            int a, b;
            cin >> a >> b;

            --a, --b;

            fir[a][b] = 1;
            fir[b][a] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int a, b;
            cin >> a >> b;

            --a, --b;

            sec[a][b] = 1;
            sec[b][a] = 1;
        }

//        if (svyaz(n, fir)) {
//            cout << "Yes\n";
//            cout << "0\n";
//            return;
//        }

        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                diff.push_back({i, j});
            }
        }

        used.resize(diff.size(), 0);

        if (!gen()) {
            cout << "No\n";
        }

        diff.clear();
        used.clear();
        now.clear();
        fir.clear();
        sec.clear();
    }
}

int main() {
    fast_stream();

    int tests = 1, group;
    cin >> tests >> group;

    while (tests--) {
        solve(group);
    }
}
