#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

bool svyaz(int n, vector<vector<int>> g) {
    vector<int> used(n, 0);
    queue<int> q;
    used[0] = 1;
    q.push(0);

    while (q.size()) {
        int v = q.front();
        q.pop();

        for (int i = 0; i < n; ++i) {
            if (g[v][i] && used[i] == 0) {
                used[i] = 1;
                q.push(i);
            }
        }
    }

    for (auto i : used) {
        if (i == 0) return false;
    }
    return true;
}

vector<pair<int, int>> diff;
int n, m1, m2;
vector<pair<int, int>> now;
vector<int> used;
vector<vector<int>> fir, sec;

bool gen() {
    if (svyaz(n, fir)) {
        cout << "Yes\n";
        cout << now.size() << '\n';
        for (auto i : now) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return true;
    }

    if (now.size() == n) return false;

    for (int i = 0; i < diff.size(); ++i) {
        if (used[i] == 0) {
            used[i] = 1;
            now.push_back(diff[i]);
            fir[diff[i].first][diff[i].second] ^= 1;
            fir[diff[i].second][diff[i].first] ^= 1;
            sec[diff[i].first][diff[i].second] ^= 1;
            sec[diff[i].second][diff[i].first] ^= 1;
            if (svyaz(n, sec)) {
                if (gen()) {
                    return true;
                }
            }
            fir[diff[i].first][diff[i].second] ^= 1;
            fir[diff[i].second][diff[i].first] ^= 1;
            sec[diff[i].first][diff[i].second] ^= 1;
            sec[diff[i].second][diff[i].first] ^= 1;
            used[i] = 0;
            now.pop_back();
        }
    }

    return false;
}

void solve(int group) {
    cin >> n >> m1 >> m2;

    if (n <= 5) {
        fir.resize(n, vector<int> (n, 0)), sec.resize(n, vector<int>(n, 0));

        for (int i = 0; i < m1; ++i) {
            int a, b;
            cin >> a >> b;

            --a, --b;

            fir[a][b] = 1;
            fir[b][a] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int a, b;
            cin >> a >> b;

            --a, --b;

            sec[a][b] = 1;
            sec[b][a] = 1;
        }

        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                diff.push_back({i, j});
            }
        }

        used.resize(diff.size(), 0);

        if (!gen()) {
            cout << "No\n";
        }

        diff.clear();
        used.clear();
        now.clear();
        fir.clear();
        sec.clear();
        return;
    }
    vector<vector<ll>> g(n), h(n);
    vector<set<ll>> set_g(n), set_h(n);

    for (ll i = 0; i < m1; ++i) {
        ll a, b;
        cin >> a >> b;

        --a, --b;

        g[a].push_back(b);
        g[b].push_back(a);
        set_g[a].insert(b);
        set_g[b].insert(a);
    }
    for (ll i = 0; i < m2; ++i) {
        ll a, b;
        cin >> a >> b;

        --a, --b;

        h[a].push_back(b);
        h[b].push_back(a);
        set_h[a].insert(b);
        set_h[b].insert(a);
    }

    for (ll i = 0; i < n; ++i) {
        sort(all(g[i]));
        sort(all(h[i]));
    }

    if (group == 5) {
        cout << "Yes\n";
        vector<pair<ll, ll>> ans;

        for (ll i = 1; i < n - 1; ++i) {
            if (set_g[i].find(i + 1) == set_g[i].end()) {
                ans.push_back({i, i + 1});
            }
        }
        if (set_g[0].find(n - 1) == set_g[0].end()) {
            ans.push_back({0, n - 1});
        }

        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }

    if (group == 9) {
        cout << "Yes\n";

        set<ll> in_one;

        for (auto i : g[0]) in_one.insert(i);

        vector<pair<ll, ll>> ans;

        for (ll i = 2; i < n; ++i) {
            if (in_one.find(i) == in_one.end()) {
                ans.push_back({0, i});
            }
        }

        if (g[1].size() == 0 || g[1].back() != n - 1) {
            ans.push_back({1, n - 1});
        }

        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }

    if (group == 2) {
        cout << "Yes\n";
        vector<pair<ll, ll>> ans;

        for (ll i = 1; i <= n - 2; ++i) {
            if (set_g[0].find(i) == set_g[0].end()) {
                ans.push_back({0, i});
            }
        }
        if (set_g[n - 2].find(n - 1) == set_g[n - 2].end()) {
            ans.push_back({n - 1, n - 2});
        }
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }

    if (group == 4) {
        vector<vector<ll>> comp;
        used.resize(n, 0);

        for (ll i = 0; i < n; ++i) {
            if (!used[i]) {
                queue<ll> q;
                q.push(i);
                used[i] = 1;
                comp.push_back({i});

                while (q.size()) {
                    ll v = q.front();
                    q.pop();

                    for (auto j : g[v]) {
                        if (!used[j]) {
                            used[j] = 1;
                            comp.back().push_back(j);
                            q.push(j);
                        }
                    }
                }
            }
        }

        vector<pair<ll, ll>> ans;
        for (ll i = 0; i < comp.size() - 1; ++i) {
            if (comp[i].size() == 1 || comp[i + 1].size() == 1) {
                cout << "HFHBVFDB";
                exit(0);
            }
            bool flag = false;
            for (ll s = 0; s < 2; ++s) {
                for (ll t = 0; t < 2; ++t) {
                    ll v = comp[i][s], u = comp[i + 1][t];
                    if (set_h[v].find(u) == set_h[v].end()) {
                        flag = true;
                        set_h[v].insert(u);
                        set_h[u].insert(v);
                        flag = true;
                        ans.push_back({v, u});
                    }
                    if (flag) break;
                }
                if (flag) break;
            }
            if (!flag) {
                ans.push_back({comp[i][0], comp[i + 1][0]});
                set_h[comp[i][0]].erase(comp[i + 1][0]);
                set_h[comp[i + 1][0]].erase(comp[i][0]);
            }
        }

        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }
}

int main() {
    fast_stream();

    int tests = 1, group;
    cin >> tests >> group;

    while (tests--) {
        solve(group);
    }
}
