#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
int n, m1, m2;
vector<vector<int>> g, d;
map<pair<int, int>, int> e1, e2;
vector<int> sz;
vector<pair<int, int>> order;

struct dsu {
    int n;
    vector<int> p;

    dsu(int _n) {
        n = _n;
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int get(int a) {
        if (p[a] == a)
            return a;
        p[a] = get(p[a]);
        return p[a];
    }

    bool same(int a, int b) {
        return get(a) == get(b);
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        p[a] = b;
    }
};

void solve3() {
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        e1[{u - 1, v - 1}] = e1[{v - 1, u - 1}] = 1;
    }
    dsu s(n);
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        e2[{u, v}] = e1[{v, u}] = 1;
        if (!s.same(u, v)) {
            s.unite(u, v);
            d[u].push_back(v);
            d[v].push_back(u);
        }
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if(m1 == 0) {
        cout << "No\n";
        return;
    }
    if(m1 == 1) {
        if(e1[{0, 1}]) {
            if(m2 == 3) {
                cout << "Yes\n";
                cout << "1\n" << "2 3\n";
            } else if(m2 == 2 && !e2[{1, 2}]) {
                cout << "Yes\n";
                cout << "1\n" << "2 3\n";
            } else if(m2 == 2 && !e2[{0, 2}]) {
                cout << "Yes\n";
                cout << "1\n" << "1 3\n";
            } else {
                cout << "No\n";
            }
        } else if(e1[{0, 2}]) {
             if(m2 == 3) {
                cout << "Yes\n";
                cout << "1\n" << "2 3\n";
            } else if(m2 == 2 && !e2[{1, 2}]) {
                cout << "Yes\n";
                cout << "1\n" << "2 3\n";
            } else if(m2 == 2 && !e2[{0, 1}]) {
                cout << "Yes\n";
                cout << "1\n" << "1 2\n";
            } else {
                cout << "No\n";
            }
        } else {
             if(m2 == 3) {
                cout << "Yes\n";
                cout << "1\n" << "1 2\n";
            } else if(m2 == 2 && !e2[{0, 2}]) {
                cout << "Yes\n";
                cout << "1\n" << "1 3\n";
            } else if(m2 == 2 && !e2[{0, 1}]) {
                cout << "Yes\n";
                cout << "1\n" << "1 2\n";
            } else {
                cout << "No\n";
            }
        }
        return;
    }
    if(m2 >= 2) {
        cout << "Yes\n0\n";
    }
}

int dfs_sz(int v, int p) {
    sz[v] = 1;
    for (auto u : d[v]) {
        if (u != p) {
            sz[v] += dfs_sz(u, v);
        }
    }
    return sz[v];
}

void dfs2(int v, int p, int root) {
    if (d[v].size() == 1) {
        if (!e1[{v, root}]) {
            order.emplace_back(v + 1, root + 1);
            e1[{v, root}] = e1[{root, v}] = 1;
            return;
        }
    }
    for (auto u : d[v]) {
        if (u != p) {
            dfs2(u, v, root);
            return;
        }
    }
}

void dfs1(int u, int root) {
    for (int i = 0; i < n; ++i) {
        if (i == u || i == root)
            continue;

        if (!e1[{u, i}]) {
            order.emplace_back(u + 1, i + 1);
            e1[{u, i}] = e1[{i ,u}] = 1;
        }
    }
}

void not_full(int root) {
    dfs_sz(root, root);
    bool flag1 = 1, flag2 = 1;
    for (auto u : g[root]) {
        if (sz[u] > 1 && flag2) {
            dfs2(u, root, root);
            flag2 = 0;
        }
        if (sz[u] == 1 && flag1) {
            dfs1(u, root);
            flag1 = 1;
        }
    }
}

void full_root(int root) {
    int u = d[root][n - 2], v = d[root][n - 3];
    if (!e2[{u, v}]) {
        d[u].pop_back();
        d[u].push_back(v);
        d[v].push_back(u);
        order.emplace_back(u + 1, v + 1);
        e2[{u, v}] = e2[{v, u}] = 1;
        e1[{u, v}] = e1[{v, u}] = 1 - e1[{u, v}];
    }
    order.emplace_back(root + 1, u + 1);
    e2[{root, u}] = e2[{u, root}] = 0;
    e1[{root, u}] = e1[{u, root}] = 1 - e1[{u, root}];
    d[root].pop_back();
    not_full(root);
}

void solve() {
    cin >> n >> m1 >> m2;
    g.assign(n, {});
    d.assign(n, {});
    e1.clear();
    e2.clear();
    sz.resize(n);
    order.clear();
    if (n == 3) {
        solve3();
        return;
    }

    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        e1[{u - 1, v - 1}] = e1[{v - 1, u - 1}] = 1;
    }
    dsu s(n);
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        e2[{u, v}] = e1[{v, u}] = 1;
        if (!s.same(u, v)) {
            s.unite(u, v);
            d[u].push_back(v);
            d[v].push_back(u);
        }
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int root = -1;
    for (int v = 0; v < n; ++v) {
        if (d[v].size() == 1) {
            root = d[v][0];
            if (d[root].size() == n - 1) {
                full_root(root);
            } else {
                not_full(root);
            }
            cout << "Yes\n"
                 << order.size() << '\n';
            for (auto [a, b] : order) {
                cout << a << " " << b << '\n';
            }
            break;
        }
    }
}

signed main() {
    init();
    int t, group;
    cin >> t >> group;
    while (t--) {
        solve();
    }
}