#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

const int inf = 1e9 + 100;
const int mod = 1e9 + 9;

int add(int a, int b) {
	return a + b < mod ? a + b : a + b - mod;
}

int rem(int a, int b) {
	return a - b >= 0  ? a - b : a - b + mod;
}

int mul(int a, int b) {
	return 1ll * a * b % mod;
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int bin_pow(int a, int b) {
	if (b == 0) return 1;
	if (b % 2) return 1ll * a * bin_pow(a, b - 1) % mod;
	ll z = bin_pow(a, b / 2);
	return z * z % mod;
}

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

const int SIZE = 1e5 + 5;
int tree[4 * SIZE];

void build(int v, int l, int r) {
	if (l == r - 1) {
		tree[v] = l;
		return;
	}
	int m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
}

int ask(int v, int l, int r, int askl, int askr) {
	if (l >= askr || r <= askl) {
		return 0;
	}
	if (l >= askl && r <= askr) {
		return tree[v];
	}
	int m = (l + r) / 2;
	return ask(2 * v + 1, l, m, askl, askr) + ask(2 * v + 2, m, r, askl, askr);
}

void dfs(int v, vector<vector<int>>& gr, vector<vector<int>>&n_gr, vector<bool>&used) {
	used[v] = true;
	for (int u : gr[v]) {
		if (used[u]) continue;
		if (n_gr[v].size() == n_gr.size() - 2) {
			break;
		}
		n_gr[v].push_back(u);
		n_gr[u].push_back(v);
		dfs(u, gr, n_gr, used);
	}
}

void dfs2(int v, vector<vector<int>>& gr, vector<bool>&used) {
	used[v] = true;
	for (int u : gr[v]) {
		if (used[u]) continue;
		dfs2(u, gr, used);
	}
}

void solve3(int n, int m1, int m2) {
	vector<vector<bool>> mat1(n, vector<bool>(n)), mat2(n, vector<bool>(n));
	for (int i = 0; i < m1; i++) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		mat1[a][b] = mat1[b][a] = true;
	}
	for (int i = 0; i < m2; i++) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		mat2[a][b] = mat2[b][a] = true;
	}
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (!mat1[i][j] && !mat2[i][j]) {
				mat1[i][j] = mat2[i][j] = true;
				ans.emplace_back(i + 1, j + 1);
				++m1, ++m2;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (!mat1[i][j] && mat2[i][j] && m2 >= n) {
				++m1, --m2;
				ans.emplace_back(i + 1, j + 1);
			}
		}
	}
	if (m1 < n - 1) {
		cout << "NO\n";
		return;
	}
	else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto& i : ans) {
			cout << i.first << ' ' << i.second << '\n';
		}
	}
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	/*if (n == 3) {
		solve3(n, m1, m2);
		return;
	}*/
	vector<vector<int>> gr1(n), gr2(n);
	set<pair<int, int>> edgs;
	for (int i = 0; i < m1; i++) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		gr1[a].push_back(b);
		gr1[b].push_back(a);
		edgs.insert({ min(a, b), max(a, b) });
	}
	for (int i = 0; i < m2; i++) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		gr2[a].push_back(b);
		gr2[b].push_back(a);
	}
	vector<bool>used(n);
	vector<vector<int>> n_gr(n);
	dfs(0, gr2, n_gr, used);
	used.assign(n, false);
	dfs2(0, n_gr, used);
	if (count(used.begin(), used.end(), false)) {
		int num = -1;
		for (int i = 0; i < n; i++) {
			if (gr2[i].size() == n - 1) {
				num = i;
				break;
			}
		}
		for (int i = 0; i < n; i++) {
			if (i == num) continue;
			if (edgs.find({ min(i, num), max(i, num) }) != edgs.end()) {
				vector<pair<int, int>> ans;
				for (int j = 0; j < n; j++) {
					if (j == num || j == i) continue;
					if (edgs.find({ min(i, j), max(i, j) }) == edgs.end()) {
						ans.push_back({ i, j });
					}
				}
				cout << "YES\n";
				cout << ans.size() << '\n';
				for (auto& i : ans) {
					cout << i.first + 1 << ' ' << i.second + 1 << '\n';
				}
				return;

			}
		}
		vector<pair<int, int>> ans;
		for (int i = 0; i < n; i++) {
			if (i == num) continue;
			for (int j = i + 1; j < n; j++) {
				if (j == num) continue;
				if (edgs.find({ i, j }) == edgs.end()) {
					ans.push_back({ i, j });
					for (int k = j + 1; k < n; k++) {
						if (edgs.find({ i, j }) == edgs.end()) {
							ans.push_back({ i, j });
						}
					}
					cout << "YES\n";
					cout << ans.size() << '\n';
					for (auto& i : ans) {
						cout << i.first + 1 << ' ' << i.second + 1 << '\n';
					}
					return;
				}
			}
		}
		int val1 = (num + 1) % n, val2 = (num + 2) % n;
		ans.push_back({ val1, val2 });
		ans.push_back({ val1, num });
		for (int i = 0; i < n; i++) {
			if (i == val1 || i == val2 || i == num) continue;
			if (edgs.find({ min(i, val1), max(i, val1) }) == edgs.end()) {
				ans.push_back({ i, val1 });
			}
		}
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto& i : ans) {
			cout << i.first + 1 << ' ' << i.second + 1 << '\n';
		}
		return;
	}
	vector<vector<int>> ost_gr(n);
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++) {
		if (n_gr[i].size() == 1) {
			int u = n_gr[i][0];
			for (int j = 0; j < n; j++) {
				if (j != u && j != i) {
					ost_gr[i].push_back(j);
					ost_gr[j].push_back(i);
					if (edgs.find(make_pair(min(i, j), max(i, j))) == edgs.end()) {
						ans.emplace_back(min(i, j), max(i, j));
					}
				}
			}
			vector<bool>usd(n);
			usd[u] = true;
			for (int j : n_gr[u]) {
				usd[j] = true;
			}
			for (int j = 0; j < n; j++) {
				if (!usd[j]) {
					ost_gr[u].push_back(j);
					ost_gr[j].push_back(u);
					if (edgs.find(make_pair(min(u, j), max(u, j))) == edgs.end()) {
						ans.emplace_back(min(u, j), max(u, j));
					}
					break;
				}
			}
			break;
		}
	}
	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto& i : ans) {
		cout << i.first + 1 << ' ' << i.second + 1 << '\n';
	}

}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t, g;
	cin >> t >> g;
	while (t--) {
		solve();
	}
	
}