//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

struct disjoint_set_union {
    vector<int> p;

    disjoint_set_union(int n) {
        p.resize(n, -1);
    }

    int get(int v) {
        return p[v] < 0 ? v : p[v] = get(p[v]);
    }

    void merge(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (p[u] > p[v])
            swap(u, v);
        p[u] += p[v];
        p[v] = u;
    }
};

void solve() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        disjoint_set_union dsu(n);
        vector<int> cnt(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            ++cnt[u], ++cnt[v];
            dsu.merge(u, v);
        }
        vector<unordered_set<int>> e(n);
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e[u].insert(v);
            e[v].insert(u);
        }
        vector<pair<int, int>> res;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (dsu.get(i) == dsu.get(j) || e[i].count(j))
                    continue;
                res.push_back({i + 1, j + 1});
                dsu.merge(i, j);
            }
        }
        set<int> q;
        for (int i = 0; i < n; ++i)
            q.insert(dsu.get(i));
        if (q.size() > 1) {
            if (n == 3) {
                cout << "No\n";
            } else {
                assert(!(*max_element(all(cnt)) == n - 1));
                cout << "No\n";
            }
            continue;
        }
        cout << "Yes\n" << res.size() << '\n';
        for (auto i : res)
            cout << i.first << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
