//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

struct disjoint_set_union {
    vector<int> p;

    disjoint_set_union(int n) {
        p.resize(n, -1);
    }

    int get(int v) {
        return p[v] < 0 ? v : p[v] = get(p[v]);
    }

    void merge(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (p[u] > p[v])
            swap(u, v);
        p[u] += p[v];
        p[v] = u;
    }
};

void solve() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<unordered_set<int>> e1(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e1[u].insert(v);
            e1[v].insert(u);
        }
        vector<unordered_set<int>> e2(n);
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e2[u].insert(v);
            e2[v].insert(u);
        }
        vector<pair<int, int>> res;
        if (g == 1) {
            if (n == 3) {
                cout << "No\n";
            } else {
                for (int i = 2; i < n; ++i) {
                    if (e1[0].count(i))
                        continue;
                    res.push_back({0, i});
                }
                if (!e1[1].count(2))
                    res.push_back({1, 2});
                cout << "Yes\n" << res.size() << '\n';
                for (auto i : res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            continue;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
