//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

struct disjoint_set_union {
    vector<int> p;

    disjoint_set_union(int n) {
        p.resize(n, -1);
    }

    int get(int v) {
        return p[v] < 0 ? v : p[v] = get(p[v]);
    }

    void merge(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (p[u] > p[v])
            swap(u, v);
        p[u] += p[v];
        p[v] = u;
    }
};

void solve() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<unordered_set<int>> e1(n);
        vector<pair<int, int>> ee1;
        vector<int> cnt(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e1[u].insert(v);
            e1[v].insert(u);
            ee1.push_back({u, v});
            ee1.push_back({v, u});
            ++cnt[u], ++cnt[v];
        }
        vector<unordered_set<int>> e2(n);
        vector<pair<int, int>> ee2;
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e2[u].insert(v);
            e2[v].insert(u);
            ee2.push_back({u, v});
            ee2.push_back({v, u});
        }
        vector<pair<int, int>> res;
        if (*max_element(all(cnt)) == n - 1) {
            vector<int> ord;
            for (int i = 0; i < n; ++i)
                if (cnt[i] == n - 1)
                    ord.push_back(i);
            for (int i = 0; i < n; ++i)
                if (cnt[i] != n - 1)
                    ord.push_back(i);
            if (n == 3) {
                if (m1 >= 2) {
                    cout << "Yes\n" << 0 << '\n';
                } else if (m1 == 0) {
                    cout << "Yes\n" << 2 << '\n';
                    cout << ord[1] + 1 << ' ' << ord[2] + 1 << '\n';
                    cout << ord[0] + 1 << ' ' << ord[1] + 1 << '\n';
                } else {
                    if (ee1[0] == make_pair(ord[0], ord[1]) || ee1[1] == make_pair(ord[0], ord[1]) || ee1[0] == make_pair(ord[0], ord[2]) || ee1[1] == make_pair(ord[0], ord[2])) {
                        cout << "Yes\n" << 1 << '\n';
                        cout << ord[1] + 1 << ' ' << ord[2] + 1 << '\n';
                    } else {
                        cout << "No\n";
                    }
                }
            } else {
                assert(false);
                for (int i = 2; i < n; ++i)
                    if (!e1[ord[1]].count(ord[i]))
                        res.push_back({ord[1], ord[i]});
                res.push_back({ord[2], ord[3]});
                if (!e1[ord[0]].count(ord[2]))
                    res.push_back({ord[0], ord[2]});
                cout << "Yes\n" << res.size() << '\n';
                for (auto i : res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            continue;
        }
        if (m2 == n * (n - 1) / 2) {
            if (n == 3) {
                if (m1 >= 2) {
                    cout << "Yes\n" << 0 << '\n';
                } else if (m1 == 0) {
                    cout << "No\n";
                } else {
                    cout << "Yes\n" << 1 << '\n';
                    if (ee1[0] != make_pair(0ll, 1ll) && ee1[1] != make_pair(0ll, 1ll))
                        cout << 1 << ' ' << 2 << '\n';
                    else
                        cout << 2 << ' ' << 3 << '\n';
                }
            } else {
                for (int i = 2; i < n; ++i) {
                    if (e1[0].count(i))
                        continue;
                    res.push_back({0, i});
                }
                if (!e1[1].count(2))
                    res.push_back({1, 2});
                cout << "Yes\n" << res.size() << '\n';
                for (auto i : res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            continue;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
