#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e9;

struct disjoint_set_union {
    vector<int> p;
    int cnt;

    disjoint_set_union(int n) {
        p.resize(n, -1);
        cnt = n;
    }

    int get(int v) {
        return p[v] < 0 ? v : p[v] = get(p[v]);
    }

    void merge(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (p[u] > p[v])
            swap(u, v);
        p[u] += p[v];
        --cnt;
        p[v] = u;
    }
};

void solve() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<unordered_set<int>> e1(n);
        disjoint_set_union dsu(n);
        vector<pair<int, int>> ee1;
        vector<int> cnt(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e1[u].insert(v);
            e1[v].insert(u);
            ee1.push_back({u, v});
            ee1.push_back({v, u});
            dsu.merge(u, v);
        }
        vector<unordered_set<int>> e2(n);
        vector<pair<int, int>> ee2;
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            e2[u].insert(v);
            e2[v].insert(u);
            ee2.push_back({u, v});
            ee2.push_back({v, u});
            ++cnt[u], ++cnt[v];
        }
        vector<pair<int, int>> res;
        if (*max_element(all(cnt)) == n - 1 && m2 == n - 1) {
            vector<int> ord;
            for (int i = 0; i < n; ++i)
                if (cnt[i] == n - 1)
                    ord.push_back(i);
            for (int i = 0; i < n; ++i)
                if (cnt[i] != n - 1)
                    ord.push_back(i);
            if (n == 3) {
                if (m1 >= 2) {
                    cout << "Yes\n" << 0 << '\n';
                } else if (m1 == 0) {
                    cout << "Yes\n" << 2 << '\n';
                    cout << ord[1] + 1 << ' ' << ord[2] + 1 << '\n';
                    cout << ord[0] + 1 << ' ' << ord[1] + 1 << '\n';
                } else {
                    if (ee1[0] == make_pair(ord[0], ord[1]) || ee1[1] == make_pair(ord[0], ord[1]) ||
                        ee1[0] == make_pair(ord[0], ord[2]) || ee1[1] == make_pair(ord[0], ord[2])) {
                        cout << "Yes\n" << 1 << '\n';
                        cout << ord[1] + 1 << ' ' << ord[2] + 1 << '\n';
                    } else {
                        cout << "No\n";
                    }
                }
            } else {
                for (int i = 2; i < n; ++i)
                    if (!e1[ord[1]].count(ord[i]))
                        res.push_back({ord[1], ord[i]});
                res.push_back({ord[2], ord[3]});
                if (!e1[ord[0]].count(ord[2]))
                    res.push_back({ord[0], ord[2]});
                cout << "Yes\n" << res.size() << '\n';
                for (auto i: res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            continue;
        } else if (m2 == n - 1 && n <= 3000) {
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (dsu.get(i) == dsu.get(j) || e2[i].count(j))
                        continue;
                    res.push_back({i + 1, j + 1});
                    dsu.merge(i, j);
                }
            }
            set<int> q;
            for (int i = 0; i < n; ++i)
                q.insert(dsu.get(i));
            if (q.size() > 1) {
                cout << "No\n";
                continue;
            }
            cout << "Yes\n" << res.size() << '\n';
            for (auto i: res)
                cout << i.first << ' ' << i.second << '\n';
            continue;
        } else if (m2 == n - 1) {
            for (int i = 2; i < n; ++i)
                if (!e1[0].count(i))
                    res.push_back({0, i});
            res.push_back({1, 3});
            if (!e1[0].count(1))
                res.push_back({0, 1});
            cout << "Yes\n" << res.size() << '\n';
            for (auto i: res)
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            continue;
        }
        if (m2 == n * (n - 1) / 2) {
            if (n == 3) {
                if (m1 >= 2) {
                    cout << "Yes\n" << 0 << '\n';
                } else if (m1 == 0) {
                    cout << "No\n";
                } else {
                    cout << "Yes\n" << 1 << '\n';
                    if (ee1[0] != make_pair(0, 1) && ee1[1] != make_pair(0, 1))
                        cout << 1 << ' ' << 2 << '\n';
                    else
                        cout << 2 << ' ' << 3 << '\n';
                }
            } else {
                for (int i = 2; i < n; ++i) {
                    if (e1[0].count(i))
                        continue;
                    res.push_back({0, i});
                }
                if (!e1[1].count(2))
                    res.push_back({1, 2});
                cout << "Yes\n" << res.size() << '\n';
                for (auto i: res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            continue;
        }
        if (g == 3) {
            map<int, vector<int>> comp;
            for (int i = 0; i < n; ++i)
                comp[dsu.get(i)].push_back(i);
            auto a = comp.begin()->second, b = next(comp.begin())->second;
            if (a.size() > b.size())
                swap(a, b);
            if (a.size() == 1) {
                int ind = -1;
                for (int i = 0; i < n; ++i)
                    if (i != a[0] && !e2[a[0]].count(i))
                        ind = i;
//                assert(ind != -1);
                if (ind == -1) {
                    for (int i = 0; i < n; ++i)
                        if (i != a[0] && cnt[i] >= 2)
                            ind = i;
                }
                cout << "Yes\n" << 1 << '\n';
                cout << a[0] + 1 << ' ' << ind + 1 << '\n';
            } else {
                pair<int, int> ans = {-1, -1};
                for (int i = 0; i < 2; ++i)
                    for (int j = 0; j < 2; ++j) {
                        if (!e2[a[i]].count(b[j]))
                            ans = {a[i], b[j]};
                    }
                if (ans.first != -1) {
                    cout << "Yes\n" << 1 << '\n' << ans.first + 1 << ' ' << ans.second + 1 << '\n';
                } else {
                    cout << "Yes\n" << 1 << '\n' << a[0] + 1 << ' ' << b[0] + 1 << '\n';
                }
            }
            continue;
        }
        if (g == 7) {
            for (int i = 2; i < n; ++i) {
                if (e1[0].count(i) && e2[0].count(i))
                    continue;
                if (e1[1].count(i) && e2[1].count(i))
                    continue;
                if (!e1[0].count(i) && !e2[0].count(i)) {
                    res.push_back({0, i});
                    continue;
                }
                if (!e1[1].count(i) && !e2[1].count(i)) {
                    res.push_back({1, i});
                    continue;
                }
                if (e1[0].count(i) && e2[1].count(i))
                    continue;
                if (e1[1].count(i) && e2[0].count(i))
                    continue;
                res.push_back({1, i});
            }
            cout << "Yes\n" << res.size() << '\n';
            for (auto i: res)
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        if (g == 1) {
            vector<pair<int, int>> e;
            for (int i = 0; i < n; ++i)
                for (int j = i + 1; j < n; ++j)
                    e.push_back({i, j});
            vector<pair<int, int>> ans = {{-1, -1}};
            for (int mask = 0; mask < (1 << e.size()); ++mask) {
                int sz = __builtin_popcount(mask);
                if (sz > n)
                    continue;
                vector<pair<int, int>> now;
                for (int i = 0; i < e.size(); ++i)
                    if (mask & (1 << i))
                        now.push_back(e[i]);
                do {
                    disjoint_set_union z(n);
                    for (auto i: now)
                        if (!e1[i.first].count(i.second))
                            z.merge(i.first, i.second);
                    for (int i = 0; i < n; ++i)
                        for (auto j: e1[i]) {
                            if (j < i)
                                continue;
                            if (find(all(now), make_pair(i, j)) == now.end())
                                z.merge(i, j);
                        }
                    if (z.cnt != 1)
                        continue;
                    bool ok = true;
                    disjoint_set_union p(n);
                    for (int i = 0; i < n; ++i)
                        for (auto j: e2[i]) {
                            if (j < i)
                                continue;
                            if (find(all(now), make_pair(i, j)) == now.end())
                                p.merge(i, j);
                        }
                    if (p.cnt != 1)
                        ok = false;
                    if (ok) {
                        ans = now;
                        break;
                    }
                } while (next_permutation(all(now)));
                if (ans[0].first != -1)
                    break;
            }
            if (ans[0].first != -1) {
                vector<pair<int, int>> res;
                for (auto i : ans)
                    if (!e2[i.first].count(i.second))
                        res.push_back(i);
                for (auto i : ans)
                    if (e2[i.first].count(i.second))
                        res.push_back(i);
                cout << "Yes\n" << res.size() << '\n';
                for (auto i: res)
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            } else {
                cout << "No\n";
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
