#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

struct SegmentTree {
    struct Node {
        int l, r;
        int min, idx;
        Node(int l) : l(-1), r(-1), min(0), idx(l) {}
    };
    vector<Node> tree;
    int size;
    void init(int n) {
        tree.push_back(Node(0));
        size = 1;
        while (size < n) size *= 2;
    }
    void set(int i, int x, int l, int r, int node) {
        if (l + 1 == r) {
            tree[node].min = 1;
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            if (tree[node].l == -1) {
                tree[node].l = tree.size();
                tree.push_back(Node(l));
            }
            set(i, x, l, m, tree[node].l);
        } else {
            if (tree[node].r == -1) {
                tree[node].r = tree.size();
                tree.push_back(Node(m));
            }
            set(i, x, m, r, tree[node].r);
        }
        if (tree[node].l == -1) tree[node].min = 0, tree[node].idx = l;
        else if (tree[tree[node].l].min == 0) tree[node].min = 0, tree[node].idx = tree[tree[node].l].idx;
        else if (tree[node].r == -1) tree[node].min = 0, tree[node].idx = m;
        else if (tree[tree[node].r].min == 0) tree[node].min = 0, tree[node].idx = tree[tree[node].r].idx;
        else tree[node].min = 1;
    }
    void set(int i, int x) {
        set(i, x, 0, size, 0);
    }
    int get() {
        if (tree[0].min == 1) return -1;
        return tree[0].idx;
    }
};

struct DSU {
    vector<int> r, p;
    void init(int n) {
        r.resize(n + 1);
        p.resize(n + 1);
        for (int i = 0; i <= n; ++i) {
            r[i] = 1;
            p[i] = i;
        }
    }
    int find(int u) {
        if (p[u] != u) p[u] = find(p[u]);
        return p[u];
    }
    bool connect(int u, int v) {
        return find(u) == find(v);
    }
    void merge(int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return;
        if (r[u] > r[v]) swap(u, v);
        p[u] = v;
        if (r[u] == r[v]) r[v]++;
    }
};

void dfs(int v, vector<int> &used, vector<pair<int, int>> &ostov, vector<vector<int>> &g) {
    used[v] = 1;
    for (int to : g[v]) {
        if (!used[to]) {
            ostov.push_back({v, to});
            dfs(to, used, ostov, g);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.insert({i, j});
        }
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        e.push_back({a, b});
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b; a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int>> ostov;
    vector<int> used(n, 0);
    dfs(0, used, ostov, g);
    for (auto [a, b] : ostov) {
        if (a > b) swap(a, b);
        edges.erase(edges.find({a, b}));
    }
    vector<vector<int>> g2(n);
    for (auto [a, b] : e) {
        edges.insert({a, b});
    }
    for (auto &[a, b] : edges) {
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    ostov.clear();
    used.assign(n, 0);
    dfs(0, used, ostov, g2);
    if (ostov.size() != n - 1) {
        cout << "No\n";
        return;
    }
    set<pair<int, int>> st;
    for (auto [a, b] : ostov) {
        if (a > b) swap(a, b);
        st.insert({a, b});
    }
    for (auto [a, b] : e) if (st.count({a, b})) st.erase(st.find({a, b}));
    cout << "Yes\n";
    cout << st.size() << '\n';
    for (auto [a, b] : st) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1, _g;
    cin >> tests >> _g;
    while (tests--) {
        solve();
    }
}
