#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

void dfs(int v, int &cnt, vector<int> &used, vector<vector<int>> &g) {
    used[v] = 1;
    cnt++;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs(to, cnt, used, g);
        }
    }
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.push_back({i, j});
        }
    }
    set<pair<int, int>> e1;
    set<pair<int, int>> e2;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        e1.insert({a, b});
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        e2.insert({a, b});
    }
    for (int mask = 0; mask < (1 << ((int)edges.size())); ++mask) {
        vector<vector<int>> g1(n), g2(n);
        for (int i = 0; i < edges.size(); ++i) {
            if ((mask >> i & 1) ^ e1.count({edges[i].first, edges[i].second})) {
                g1[edges[i].first].push_back(edges[i].second);
                g1[edges[i].second].push_back(edges[i].first);
            }
            if ((mask >> i & 1) ^ e2.count({edges[i].first, edges[i].second})) {
                g2[edges[i].first].push_back(edges[i].second);
                g2[edges[i].second].push_back(edges[i].first);
            }
        }
        vector<int> used1(n), used2(n);
        int cnt1 = 0, cnt2 = 0;
        dfs(0, cnt1, used1, g1);
        dfs(0, cnt2, used2, g2);
        if (cnt1 == n && cnt2 == n) {
            cout << "Yes\n";
            cout << __builtin_popcount(mask) << '\n';
            for (int i = 0; i < edges.size(); ++i) {
                if (mask >> i & 1) {
                    cout << edges[i].first + 1 << ' ' << edges[i].second + 1 << '\n';
                }
            }
            return;
        }
    }
    cout << "No\n";
}

void solve3() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
}

void dfs5(int v, vector<int> &used, vector<pair<int, int>> &ostov, vector<vector<int>> &g) {
    used[v] = 1;
    for (int to : g[v]) {
        if (!used[to]) {
            ostov.push_back({v, to});
            dfs5(to, used, ostov, g);
        }
    }
}

void solve4() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.insert({i, j});
        }
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        e.push_back({a, b});
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b; a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int>> ostov;
    vector<int> used(n, 0);
    dfs5(0, used, ostov, g);
    for (auto [a, b] : ostov) {
        if (a > b) swap(a, b);
        edges.erase(edges.find({a, b}));
    }
    vector<vector<int>> g2(n);
    for (auto [a, b] : e) {
        edges.insert({a, b});
    }
    for (auto &[a, b] : edges) {
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    ostov.clear();
    used.assign(n, 0);
    dfs5(0, used, ostov, g2);
    if (ostov.size() != n - 1) {
        cout << "No\n";
        return;
    }
    set<pair<int, int>> st;
    for (auto [a, b] : ostov) {
        if (a > b) swap(a, b);
        st.insert({a, b});
    }
    for (auto [a, b] : e) if (st.count({a, b})) st.erase(st.find({a, b}));
    cout << "Yes\n";
    cout << st.size() << '\n';
    for (auto [a, b] : st) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n);
    for (int i = 0; i + 1 < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }
    set<pair<int, int>> e;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        e.insert({a, b});
    }
    vector<pair<int, int>> ostov;
    vector<int> used(n);
    for (int i = 0; i < m2; ++i) {int a, b;cin >>a>>b;}
    dfs5(0, used, ostov, g);
    vector<pair<int, int>> ans;
    for (auto [a, b] : ostov) {
        if (a > b) swap(a, b);
        if (e.count({a, b})) continue;
        ans.push_back({a, b});
    }
    if (n == 3) {
        queue<int> q;
        q.push(0);
        vector<vector<int>> g2(n);
        for (auto [a, b] : ostov) {
            if (a > b) swap(a, b);
            e.erase(e.find({a, b}));
        }
        for (auto [a, b] : e) {
            g2[a].push_back(b);
            g2[b].push_back(a);
        }
        int cnt = 0;
        vector<int> used(n);
        dfs(0, cnt, used, g2);
        if (cnt != n) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';;
    for (auto [a, b] : ans) cout << a + 1 << ' ' << b + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1, _g;
    cin >> tests >> _g;
    while (tests--) {
        if (_g == 4) solve4();
        else if (_g == 3) solve3();
        else if (_g == 2) solve2();
        else solve1();
    }
}
