#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void sol2(int n) {
    int m1, m2;
    cin >> m1 >> m2;
    set<pair<int, int>> st;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (a > b) {
            swap(a, b);
        }
        st.insert({a, b});
    }
    for (int i = 0; i < m2; i++)  {
        int a, b;
        cin >> a >> b;
    }
    if (n == 3) {
        if (m1 == 0) {
            cout << "No" << '\n';
            return;
        }
        cout << "Yes" << '\n';
        if (st.size() == 2) {
            cout << "0" << '\n';
            return;
        }
        auto [a, b] = *st.begin();
        a = (a + 1) % 3;
        b = (b + 1) % 3;
        cout << "1" << '\n' << a + 1 << " " << b + 1 << '\n';
        return;
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n - 1; i++) {
        if (st.find({i, i + 1}) == st.end()) {
            ans.push_back({i, i + 1});
        }
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << '\n';
    }
}

void dfs(int v, vector<bool> &used, vector<vector<int>> &gr) {
    used[v] = true;
    for (auto u : gr[v]) {
        if (!used[u]) {
            dfs(u, used, gr);
        }
    }
}

void sol3(int n) {
    int m1, m2;
    cin >> m1 >> m2;
    vector<vector<int>> gr(n);
    set<pair<int, int>> st1;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
        st1.insert({a, b});
        st1.insert({b, a});
    }
    set<pair<int, int>> st;
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        st.insert({a, b});
        st.insert({b, a});
    }

    vector<bool> used(n, false);
    dfs(0, used, gr);
    vector<int> a1;
    vector<int> a2;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            a1.push_back(i);
        } else {
            a2.push_back(i);
        }
    }

    if (a1.size() < a2.size()) {
        swap(a1, a2);
    }

    for (int i = 0; i < a1.size(); i++) {
        for (int j = 0; j < a2.size(); j++) {
            if (st.find({a1[i], a2[j]}) == st.end()) {
                cout << "Yes" << '\n' << "1" << '\n';
                cout << a1[i] + 1 << " " << a2[j] + 1 << '\n';
                return;
            }
        }
    }
    if (n == 3 && st.find({a1[0], a1[1]}) == st.end()) {
        cout << "No" << '\n';
        return;
    }
    if (n != 3 && a2.size() == 1) {
        vector<pair<int, int>> ans;
        for (int i = 0; i < a1.size(); i++) {
            for (int j = i + 1; j < a1.size(); j++) {
                if (st.find({i, j}) != st.end()) {
                    cout << "Yes" << '\n' << "1" << '\n' << a2[0] << " " << a1[i] << '\n';
                    return;
                }
            }
        }
        exit(0);
        for (int i = 0; i < a1.size(); i++) {
            for (int j = i + 1; j < a1.size(); j++) {
                if (st1.find({i, j}) == st1.end()) {
                    cout << "Yes" << '\n' << "2" << '\n' << a1[j] << " " << a1[i] << '\n' << a1[i] << " " << a2[0] << '\n';
                    return;
                }
            }
        }
        exit(0);
    }
    cout << "Yes" << '\n' << "1" << '\n';
    cout << a1[0] + 1 << " " << a2[0] + 1 << '\n';
}


int main()
{
    int t, g;
    cin >> t >> g;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        if (g == 2) {
            sol2(n);
        } else if (g == 3) {
            sol3(n);
        }

    }
    return 0;
}
