#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 1000000007;
vector <set <ll> > gr1;
vector <vector <ll> > gr2;

void DFS1(ll v, vector <ll>& used, vector <ll>& h, vector <vector <ll> >& tree) {
	used[v] = 1;
	for (auto u : gr2[v]) {
		if (used[u] == 0) {
			tree[v].push_back(u);
			h[u] = h[v] + 1;
			DFS1(u, used, h, tree);
		}
	}
}

void solve() {
	ll n, m1, m2, i, v, u, p;
	cin >> n >> m1 >> m2;
	gr1.resize(n);
	gr2.resize(n);
	for (i = 0; i < m1; i++) {
		cin >> v >> u;
		v--, u--;
		gr1[v].insert(u);
		gr1[u].insert(v);
	}
	for (i = 0; i < m2; i++) {
		cin >> v >> u;
		v--, u--;
		gr2[v].push_back(u);
		gr2[u].push_back(v);
	}

	vector <vector <ll> > tree(n);
	vector <ll> used(n);
	vector <ll> h(n);
	DFS1(0, used, h, tree);
	ll mh = 0;
	for (i = 0; i < n; i++) mh = max(mh, h[i]);
	if (mh <= 3) {
		vector <pair<ll, ll> > ans;
		map <ll, ll> lst;
		for (i = 0; i < n; i++) lst[i] = -1;
		for (i = 0; i < n; i++) {
			if (lst[h[i]] != -1) {
				p = lst[h[i]];
				if (!gr1[p].count(i)) {
					gr1[p].insert(i);
					gr1[i].insert(p);
					ans.push_back({ i, p });
				}
			}
			lst[h[i]] = i;
		}
		for (i = 2; i <= mh; i++) {
			v = lst[i];
			if (!gr1[0].count(v)) {
				gr1[v].insert(0);
				gr1[0].insert(v);
				ans.push_back({ 0, v });
			}
		}
		v = lst[1];
		p = lst[mh];
		if (!gr1[v].count(p)) {
			gr1[p].insert(v);
			gr1[v].insert(p);
			ans.push_back({ v, p });
		}
		cout << "Yes" << endl;
		cout << ans.size() << endl;
		for (i = 0; i < ans.size(); i++) {
			v = ans[i].first;
			u = ans[i].second;
			if (u < v) swap(v, u);
			cout << v + 1 << " " << u + 1 << endl;
		}
		return;
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1, tt;
	cin >> t >> tt;
	while (t--) solve();
}