#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 1000000007;

void DFS1(ll v, vector <ll>& used, vector <ll>& h, vector <set <ll> >& tree, vector <set <ll> >& gr2) {
	used[v] = 1;
	for (auto u : gr2[v]) {
		if (used[u] == 0) {
			tree[v].insert(u);
			h[u] = h[v] + 1;
			DFS1(u, used, h, tree, gr2);
		}
	}
}

void print(vector <pair<ll, ll> >& ans) {
	cout << "Yes" << endl;
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		int v = ans[i].first;
		int u = ans[i].second;
		if (u < v) swap(v, u);
		cout << v + 1 << " " << u + 1 << endl;
	}
}

void solve() {
	ll n, m1, m2, i, v, u, p;
	cin >> n >> m1 >> m2;
	vector <set <ll> > gr1(n);
	vector <set <ll> > gr2(n);
	for (i = 0; i < m1; i++) {
		cin >> v >> u;
		v--, u--;
		gr1[v].insert(u);
		gr1[u].insert(v);
	}
	for (i = 0; i < m2; i++) {
		cin >> v >> u;
		v--, u--;
		gr2[v].insert(u);
		gr2[u].insert(v);
	}
	vector <set <ll> > tree(n);
	vector <ll> used(n);
	vector <ll> h(n);
	DFS1(0, used, h, tree, gr2);
	ll mh = 0;
	for (i = 0; i < n; i++) mh = max(mh, h[i]);

	if (mh == 1) {
		if (gr1[0].size() == 0) {
			if (n > 3) {
				vector <pair<ll, ll> > ans;
				for (i = 1; i < n - 1; i++) {
					v = i, u = i + 1;
					if (!gr1[v].count(u)) ans.push_back({ v, u });
				}
				ans.push_back({ 1, 3 });
				ans.push_back({ 0, 1 });
				print(ans);
				return;
			}
			else {
				vector <pair<ll, ll> > ans;
				if (m1 == 0) {
					ans.push_back({ 1, 2 });
					ans.push_back({ 0, 1 });
					print(ans);
					return;
				}
				else {
					cout << "No" << endl;
					return;
				}
			}
		}
		else {
			vector <pair<ll, ll> > ans;
			for (i = 1; i < n - 1; i++) {
				v = i, u = i + 1;
				if (!gr1[v].count(u)) ans.push_back({ v, u });
			}
			print(ans);
			return;
		}
	}

	if (mh == 2) {
		ll dp = 0;
		for (i = 0; i < n; i++) {
			if (h[i] == 1) {
				for (auto x : gr1[i]) {
					if (h[x] != 1) {
						dp = 1;
						break;
					}
				}
			}
		}
		if (dp == 1) {
			vector <pair<ll, ll> > ans;
			map <ll, ll> lst;
			for (i = 0; i < n; i++) lst[i] = -1;
			for (i = 0; i < n; i++) {
				if (lst[h[i]] != -1) {
					p = lst[h[i]];
					if (!gr1[p].count(i)) {
						gr1[p].insert(i);
						gr1[i].insert(p);
						ans.push_back({ i, p });
					}
				}
				lst[h[i]] = i;
			}
			for (i = 2; i <= mh; i++) {
				v = lst[i];
				if (!gr1[0].count(v)) {
					gr1[v].insert(0);
					gr1[0].insert(v);
					ans.push_back({ 0, v });
				}
			}
			print(ans);
			return;
		}
		else {
			ll k = 0;
			for (i = 0; i < n; i++) if (h[i] == 1) k++;
			if (k > 1) {
				vector <pair<ll, ll> > ans;
				map <ll, ll> lst;
				for (i = 0; i < n; i++) {
					if (h[i] == 2) {
						p = i;
						break;
					}
				}
				for (i = 0; i < n; i++) {
					if (h[i] == 1 && !tree[i].count(p)) {
						ans.push_back({ i, p });
						break;
					}
				}
				for (i = 0; i < n; i++) lst[i] = -1;
				for (i = 0; i < n; i++) {
					if (lst[h[i]] != -1) {
						p = lst[h[i]];
						if (!gr1[p].count(i)) {
							gr1[p].insert(i);
							gr1[i].insert(p);
							ans.push_back({ i, p });
						}
					}
					lst[h[i]] = i;
				}
				for (i = 2; i <= mh; i++) {
					v = lst[i];
					if (!gr1[0].count(v)) {
						gr1[v].insert(0);
						gr1[0].insert(v);
						ans.push_back({ 0, v });
					}
				}
				print(ans);
				return;
			}
			else {
				if (n == 3) {
					if (m1 == 0 && m2 == 3) {
						cout << "No" << endl;
						return;
					}
					if (m1 == 1 && m2 == 2) {
						cout << "No" << endl;
						return;
					}
					if (m1 == 0 && m2 == 2) {
						vector <pair<ll, ll> > ans;
						for (i = 0; i < n; i++) {
							if (h[i] == 1) v = i;
							if (h[i] == 2) u = i;
						}
						ans.push_back({ 0, u });
						ans.push_back({ 0, v });
						print(ans);
						return;
					}
					if (m1 == 1 && m2 == 3) {
						for (i = 0; i < n; i++) {
							if (h[i] == 1) v = i;
							if (h[i] == 2) u = i;
						}
						cout << "Yes" << endl;
						cout << 1 << endl;
						cout << 1 << " " << v + 1 << endl;
						return;
					}
				}
				else {
					vector <pair<ll, ll> > ans;
					ll fr = -1, ls = -1;
					for (i = 0; i < n; i++) {
						if (h[i] == 2) {
							if (ls != -1) {
								if (!gr1[ls].count(i)) ans.push_back({ ls, i });
							}
							ls = i;
							if (fr == -1) fr = i;
						}
					}
					if (!gr1[0].count(ls)) ans.push_back({ 0, ls });
					if (!gr2[0].count(fr)) ans.push_back({ 0, fr });
					for (i = 0; i < n; i++) if (h[i] == 1) p = i;
					ans.push_back({ 0, p });
					print(ans);
					return;
				}
			}
		}
	}

	if (mh >= 3) {
		vector <pair<ll, ll> > ans;
		map <ll, ll> lst;
		for (i = 0; i < n; i++) lst[i] = -1;
		for (i = 0; i < n; i++) {
			if (lst[h[i]] != -1) {
				p = lst[h[i]];
				if (!gr1[p].count(i)) {
					gr1[p].insert(i);
					gr1[i].insert(p);
					ans.push_back({ i, p });
				}
			}
			lst[h[i]] = i;
		}
		for (i = 2; i <= mh; i++) {
			v = lst[i];
			if (!gr1[0].count(v)) {
				gr1[v].insert(0);
				gr1[0].insert(v);
				ans.push_back({ 0, v });
			}
		}
		v = lst[1];
		p = lst[mh];
		if (!gr1[v].count(p)) {
			gr1[p].insert(v);
			gr1[v].insert(p);
			ans.push_back({ v, p });
		}
		print(ans);
		return;
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1, tt;
	cin >> t >> tt;
	while (t--) solve();
}