#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

struct DSU {
    vector<int> p, sz;

    DSU()=default;
    DSU(int n) {
        p.assign(n, 0);
        iota(all(p), 0);

        sz.assign(n, 1);
    }

    int root(int v) {
        if (p[v] == v)
            return v;
        p[v] = root(p[v]);
        return p[v];
    }

    void unite(int u, int v) {
        if (root(u) == root(v))
            return;

        u = root(u), v = root(v);
        if (sz[u] < sz[v])
            swap(u, v);

        p[v] = u;
        sz[u] += sz[v];
    }

    bool get(int u, int v) {
        return root(u) == root(v);
    }
};


void dfs(int v, vector<int>& c, const vector<vector<int>>& g) {
    for (auto u : g[v])
        if (c[u] == -1) {
            c[u] = c[v];
            dfs(u, c, g);
        }
}

void get_st(int v, vector<bool>& used, vector<pii>& res, const vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v])
        if (!used[u]) {
            res.push_back({v, u});
            get_st(u, used, res, g);
        }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pii> ed1(m1), ed2(m2);
    for (auto& [u, v] : ed1)
        cin >> u >> v, --u, --v;
    for (auto& [u, v] : ed2)
        cin >> u >> v, --u, --v;

    vector<vector<int>> g1(n);
    for (auto [u, v] : ed1) {
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    vector<vector<int>> g2(n);
    for (auto [u, v] : ed2) {
        g2[u].push_back(v);
        g2[v].push_back(u);
    }

    vector<pii> st;
    vector<bool> used(n);
    get_st(0, used, st, g2);
    sort(all(st));

    vector<int> cmp(n, -1);
    int c = 0;
    for (int i = 0; i < n; ++i)
        if (cmp[i] == -1) {
            cmp[i] = c++;
            dfs(i, cmp, g1);
        }

    vector<vector<int>> cv(c);
    for (int i = 0; i < n; ++i)
        cv[cmp[i]].push_back(i);

    DSU dsu(c);

    vector<pii> ans;
    for (int i = 0; i < c; ++i)
        for (int j = 0; j < c; ++j)
            if (!dsu.get(i, j))
                for (auto u : cv[i])
                    for (auto v : cv[j]) {
                        auto it1 = lower_bound(all(st), make_pair(u, v));
                        auto it2 = lower_bound(all(st), make_pair(v, u));
                        if (*it1 == make_pair(u, v) || *it2 == make_pair(v, u))
                            continue;

                        ans.push_back({u, v});
                        dsu.unite(i, j);
                    }

    if (ans.size() < c - 1)
        cout << "No\n";
    else {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [i, j] : ans)
            cout << i + 1 << " " << j + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1, g;
    cin >> t >> g;
    while (t--)
        solve();
}