#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = 1e9 + 42;

struct DSU {
    int cmp = 0;
    vector<int> p, sz;

    DSU()=default;
    DSU(int n) {
        p.assign(n, 0);
        iota(all(p), 0);
        sz.assign(n, 1);
        cmp = n;
    }

    int root(int v) {
        if (p[v] == v)
            return v;
        p[v] = root(p[v]);
        return p[v];
    }

    void unite(int u, int v) {
        if (root(u) == root(v))
            return;

        u = root(u), v = root(v);
        if (sz[u] < sz[v])
            swap(u, v);

        p[v] = u;
        sz[u] += sz[v];
        --cmp;
    }

    bool get(int u, int v) {
        return root(u) == root(v);
    }
};

void dfs(int v, vector<int>& c, const vector<vector<int>>& g) {
    for (auto u : g[v])
        if (c[u] == -1) {
            c[u] = c[v];
            dfs(u, c, g);
        }
}

void get_st(int v, vector<bool>& used, vector<pii>& res, const vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v])
        if (!used[u]) {
            res.push_back({v, u});
            get_st(u, used, res, g);
        }
}

void get_dep(int v, int p, vector<int>& d, const vector<vector<int>>& g) {
    d[v] = v == p ? 0 : d[p] + 1;
    for (auto u : g[v])
        if (d[u] == -1)
            get_dep(u, v, d, g);
}

void get_dp(int v, int p, vector<bool>& used, vector<int>& dp, const vector<int>& d, const vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        if (used[u])
            dp[v] = min(dp[v], d[u]);
        else {
            get_dp(u, v, used, dp, d, g);
            dp[v] = min(dp[v], dp[u]);
        }
    }
}

vector<bool> bridge(const set<pii>& ed, int n) {
    vector<vector<int>> g(n);
    for (auto [u, v] : ed) {
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> d(n, -1);
    get_dep(0, 0, d, g);

    vector<int> dp(n, INF);
    vector<bool> used(n);
    for (int i = 0; i < n; ++i)
        if (!used[i])
            get_dp(i, i, used, dp, d, g);

    vector<bool> ans(ed.size());
    auto it = ed.begin();
    for (int i = 0; i < ed.size(); ++i, ++it) {
        auto [u, v] = *it;

        if (d[u] < d[v])
            swap(u, v);
        if (abs(d[u] - d[v]) == 1)
            ans[i] = d[u] <= dp[u];
    }
    return ans;
}

bool fnd(const vector<pii>& ed, const pii& e) {
    auto [u, v] = e;
    auto it1 = lower_bound(all(ed), make_pair(u, v));
    auto it2 = lower_bound(all(ed), make_pair(v, u));
    if ((it1 != ed.end() && *it1 == make_pair(u, v)) || (it2 != ed.end() && *it2 == make_pair(v, u)))
        return 1;
    return 0;
}

bool fnd(const set<pii>& ed, const pii& e) {
    auto [u, v] = e;
    return ed.count({u, v}) || ed.count({v, u});
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pii> ed1(m1), ed2(m2);
    for (auto& [u, v] : ed1)
        cin >> u >> v, --u, --v;
    for (auto& [u, v] : ed2)
        cin >> u >> v, --u, --v;

    vector<vector<int>> g1(n);
    for (auto [u, v] : ed1) {
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    vector<vector<int>> g2(n);
    for (auto [u, v] : ed2) {
        g2[u].push_back(v);
        g2[v].push_back(u);
    }

    vector<pii> st;
    vector<bool> used(n);
    get_st(0, used, st, g2);
    sort(all(st));
    sort(all(ed2));

    vector<int> cmp(n, -1);
    int c = 0;
    for (int i = 0; i < n; ++i)
        if (cmp[i] == -1) {
            cmp[i] = c++;
            dfs(i, cmp, g1);
        }

    vector<vector<int>> cv(c);
    for (int i = 0; i < n; ++i)
        cv[cmp[i]].push_back(i);

    DSU dsu(c);

    vector<pii> ans;
    for (int i = 0; i < c; ++i)
        for (int j = 0; j < c; ++j)
            if (!dsu.get(i, j)) {
                bool flag = 1;
                for (int u = 0; flag && u < cv[i].size(); ++u)
                    for (int v = 0; flag && v < cv[j].size(); ++v) {
                        if (fnd(ed2, {cv[i][u], cv[j][v]}))
                            continue;

                        ans.push_back({cv[i][u], cv[j][v]});
                        dsu.unite(i, j);
                        flag = 0;
                    }
            }

    for (int i = 0; i < c; ++i)
        for (int j = 0; j < c; ++j)
            if (!dsu.get(i, j)) {
                bool flag = 1;
                for (int u = 0; flag && u < cv[i].size(); ++u)
                    for (int v = 0; flag && v < cv[j].size(); ++v) {
                        if (fnd(st, {cv[i][u], cv[j][v]}))
                            continue;

                        ans.push_back({cv[i][u], cv[j][v]});
                        dsu.unite(i, j);
                        flag = 0;
                    }
            }

    if (dsu.cmp == 1) {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [i, j] : ans)
            cout << i + 1 << " " << j + 1 << "\n";
        return;
    }

    vector<int> sz4(n);
    for (auto [u, v] : st)
        ++sz4[u], ++sz4[v];

    int bad = -1;
    int cnt_bad = 0;
    for (int i = 0; i < n; ++i)
        if (sz4[i] == n - 1) {
            bad = i;
            ++cnt_bad;
        }

    assert(cnt_bad == 1);

    /*
    int to = bad == 0 ? 1 : 0;
    vector<bool> ban(n);
    ban[bad] = 1;
    for (auto i : g2[to])
        ban[i] = 1;
    int to0 = 0;
    while (to0 < n && ban[to0])
        ++to0;

    if (to0 == n) {

    } else {
        ans.push_back({to, to0});
        ans.push_back({bad, to});
    }
     */
    //cout << "BP" << endl;
    set<pii> ed3;
    for (auto i : ed1)
        ed3.insert(i);
    for (auto i : ans) {
        if (!ed3.count(i))
            ed3.insert(i);
        else
            ed3.erase(i);
    }

    set<pii> ed4;
    for (auto i : ed2)
        ed4.insert(i);
    for (auto i : ans) {
        if (!ed4.count(i))
            ed4.insert(i);
        else
            ed4.erase(i);
    }

    auto br = bridge(ed3, n);
    set<pii> brd;
    auto it = ed3.begin();
    for (int i = 0; i < br.size(); ++i, ++it)
        if (br[i])
            brd.insert(*it);

    bool flag = 0;
    pii xuy = {-1, -1};
    for (int u = 0; !flag && u < n; ++u)
        for (int v = 0; !flag && v < n; ++v)
            if (u != v) {
                if (brd.count({u, v}) || brd.count({v, u}))
                    continue;
                if (!fnd(st, {u, v}) && fnd(ed2, {u, v})) {
                    xuy = {u, v};
                    flag = 1;
                    break;
                }
                if (!fnd(st, {u, v}) && !fnd(ed2, {u, v})) {
                    xuy = {u, v};
                    ans.push_back(xuy);
                    flag = 1;
                    break;
                }
            }

    if (!flag) {
        cout << "No" << "\n";
        return;
    }

    auto [u, v] = xuy;
    ans.push_back({bad, u});

    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto [i, j] : ans)
        cout << i + 1 << " " << j + 1 << "\n";
}

signed main() {
    srand(time(0));

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1, g;
    cin >> t >> g;
    while (t--)
        solve();
}