#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

bool has(const vector<pair<int, int>>& a, const pair<int, int>& i) {
    if (a.empty()) {
        return false;
    }
    uint64_t L = 0, R = a.size();
    while (R-L > 1) {
        uint64_t M = (L+R)/2;
        if (a[M] <= i) {
            L = M;
        } else {
            R = M;
        }
    }
    return (a[L]==i);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> a1(m1), a2(m2);
    for (int i = 0; i < m1; ++i) {
        cin >> a1[i].first >> a1[i].second;
        --a1[i].first; --a1[i].second;
        if (a1[i].first > a1[i].second) {
            swap(a1[i].first, a1[i].second);
        }
    }
    for (int i = 0; i < m2; ++i) {
        cin >> a2[i].first >> a2[i].second;
        --a2[i].first; --a2[i].second;
        if (a2[i].first > a2[i].second) {
            swap(a2[i].first, a2[i].second);
        }
    }
    sort(a1.begin(), a1.end());
    sort(a2.begin(), a2.end());

    vector<pair<int, int>> unique;
    for (auto i : a1) {
        if (!has(a2, i)) {
            unique.push_back(i);
        }
    }
    for (auto i : a2) {
        if (!has(a1, i)) {
            unique.push_back(i);
        }
    }
    sort(unique.begin(), unique.end());

    if (n == 3) {
        if (unique.size() == 3) {
            cout << "No" << endl;
            return;
        }
        cout << "Yes\n";
        if (m1 >= 2) {
            cout << "0\n";
        } else if (m1 == 1) {
            cout << "1\n";
            for (auto i : {pair<int, int>{0, 1}, pair<int, int>{1, 2}, pair<int, int>{0, 2}}) {
                if (!has(a1, i) && ((m2 == 3) || !has(a2, i))) {
                    cout << i.first+1 << ' ' << i.second+1 << '\n';
                    break;
                }
            }
        } else {
            cout << "2\n";
            if (!has(a2, pair<int, int>{0, 1})) {
                cout << "1 2\n2 3\n";
            } else if (!has(a2, pair<int, int>{1, 2})) {
                cout << "2 3\n1 2\n";
            } else {
                cout << "1 3\n1 2\n";
            }
        }
        cout << flush;
        return;
    }

    vector<pair<int, int>> b1, b2;
    for (int i = 0; i < n-1; ++i) {
        b1.emplace_back(i, i+1);
    }
    if (n%2 == 0) {
        b2.emplace_back(0, n-1);
        b2.emplace_back(0, n-2);
        for (int i = 1; i < n-2; ++i) {
            b2.emplace_back(i, i+2);
        }
    } else {
        b2.emplace_back(0, n-2);
        b2.emplace_back(1, n-1);
        for (int i = 1; i < n-2; ++i) {
            b2.emplace_back(i, i+2);
        }
    }
    sort(b1.begin(), b1.end());
    sort(b2.begin(), b2.end());

    for (auto i : b1) {
        if (!has(unique, i)) {
            b2.push_back(i);
        }
    }
    for (auto i : unique) {
        if (!has(b1, i) && !has(b2, i)) {
            b2.push_back(i);
        }
    }
    sort(b2.begin(), b2.end());

    vector<pair<int, int>> ans;
    for (auto i : b2) {
        if (!has(a2, i)) {
            ans.push_back(i);
        }
    }
    for (auto i : a2) {
        if (!has(b2, i)) {
            ans.push_back(i);
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first+1 << ' ' << i.second+1 << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t, g; cin >> t >> g;
    while (t--) {
        solve();
    }

    return 0;
}