#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

bool has(const vector<pair<int, int>>& a, const pair<int, int>& i) {
    if (a.empty()) {
        return false;
    }
    uint64_t L = 0, R = a.size();
    while (R-L > 1) {
        uint64_t M = (L+R)/2;
        if (a[M] <= i) {
            L = M;
        } else {
            R = M;
        }
    }
    return (a[L]==i);
}

int pred(int v, vector<int>& pr) {
    if (v == pr[v]) {
        return v;
    }
    return pr[v] = pred(pr[v], pr);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> a1(m1), a2(m2);
    for (int i = 0; i < m1; ++i) {
        cin >> a1[i].first >> a1[i].second;
        --a1[i].first; --a1[i].second;
        if (a1[i].first > a1[i].second) {
            swap(a1[i].first, a1[i].second);
        }
    }
    for (int i = 0; i < m2; ++i) {
        cin >> a2[i].first >> a2[i].second;
        --a2[i].first; --a2[i].second;
        if (a2[i].first > a2[i].second) {
            swap(a2[i].first, a2[i].second);
        }
    }
    sort(a1.begin(), a1.end());
    sort(a2.begin(), a2.end());

    vector<pair<int, int>> unique;
    for (auto i : a1) {
        if (!has(a2, i)) {
            unique.push_back(i);
        }
    }
    for (auto i : a2) {
        if (!has(a1, i)) {
            unique.push_back(i);
        }
    }
    sort(unique.begin(), unique.end());

    if (n == 3) {
        if (unique.size() == 3) {
            cout << "No" << endl;
            return;
        }
        cout << "Yes\n";
        if (m1 >= 2) {
            cout << "0\n";
        } else if (m1 == 1) {
            cout << "1\n";
            for (auto i : {pair<int, int>{0, 1}, pair<int, int>{1, 2}, pair<int, int>{0, 2}}) {
                if (!has(a1, i) && ((m2 == 3) || !has(a2, i))) {
                    cout << i.first+1 << ' ' << i.second+1 << '\n';
                    break;
                }
            }
        } else {
            cout << "2\n";
            if (!has(a2, pair<int, int>{0, 1})) {
                cout << "1 2\n2 3\n";
            } else if (!has(a2, pair<int, int>{1, 2})) {
                cout << "2 3\n1 2\n";
            } else {
                cout << "1 3\n1 2\n";
            }
        }
        cout << flush;
        return;
    }

    vector<int> pr(n);
    vector<int> sz(n, 1);
    for (int i = 0; i < n; ++i) {
        pr[i] = i;
    }
    for (auto i : a1) {
        int p1 = pred(i.first, pr), p2 = pred(i.second, pr);
        if (p1 != p2) {
            pr[p2] = p1;
            sz[p1] += sz[p2];
        }
    }
    vector<vector<int>> elements(n);
    for (int i = 0; i < n; ++i) {
        elements[pred(i, pr)].push_back(i);
    }

    vector<pair<int, int>> ans;
    for (auto i : a2) {
        int p1 = pred(i.first, pr), p2 = pred(i.second, pr);
        if (p1 != p2) {
            if ((sz[p1]==1) || (sz[p2]==1)) {
                continue;
            }
            bool ok = false;
            for (int j = 0; j <= 1; ++j) {
                for (int k = 0; k <= 1; ++k) {
                    pair<int, int> x = {elements[p1][j], elements[p2][k]};
                    if (x.first > x.second) {
                        swap(x.first, x.second);
                    }
                    if (!has(a2, x)) {
                        ok = true;
                        ans.push_back(x);
                        break;
                    }
                }
                if (ok) {
                    break;
                }
            }
            if (!ok) {
                pair<int, int> x = {elements[p1][0], elements[p2][0]};
                if (x.first > x.second) {
                    swap(x.first, x.second);
                }
                ans.emplace_back(x);
            }
            pr[p2] = p1;
            sz[p1] += sz[p2];
        }
    }
    if (sz[pred(0, pr)] != n) {
        vector<vector<int>> soed(n);
        for (int i = 0; i < m2; ++i) {
            soed[a2[i].first].push_back(a2[i].second);
            soed[a2[i].second].push_back(a2[i].first);
        }
        for (int i = 0; i < n; ++i) {
            soed[i].push_back(i);
            sort(soed[i].begin(), soed[i].end());
        }
        for (int i = 0; i < n; ++i) {
            if ((pr[i] == i) && (sz[i]==1)) {
                if (soed[i].size() != n) {
                    if (soed[i].empty() || (soed[i].back() != n-1)) {
                        ans.emplace_back(i, n-1);
                        pr[i] = pred(n-1, pr);
                        sz[pred(n-1, pr)] += sz[i];
                        continue;
                    }
                    if (soed[i][0] != 0) {
                        ans.emplace_back(0, i);
                        pr[i] = pred(0, pr);
                        sz[pred(0, pr)] += sz[i];
                        continue;
                    }
                    for (int j = 1; j < soed[i].size(); ++j) {
                        if (soed[i][j-1] != soed[i][j]-1) {
                            ans.emplace_back(i, soed[i][j]-1);
                            pr[i] = pred(soed[i][j]-1, pr);
                            sz[pred(soed[i][j]-1, pr)] += sz[i];
                            break;
                        }
                    }
                }
            }
        }
    }

    cout << "Yes\n" << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first+1 << ' ' << i.second+1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t, g; cin >> t >> g;
    while (t--) {
        solve();
    }

    return 0;
}