#include <bits/stdc++.h>

#define int long long
using namespace std;

struct dsu {
    vector<int> p, sz;

    void init(int n) {
        p.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            sz[i] = 1;
        }
    }

    int getpar(int u) {
        return (p[u] == u ? u : getpar(p[u]));
    }

    void unite(int u, int v) {
        u = getpar(u);
        v = getpar(v);
        if (u == v) {
            return;
        }
        if (sz[u] > sz[v]) {
            swap(u, v);
        }
        p[u] = v;
        sz[v] += sz[u];
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> e1, e2;
    vector<pair<int, int>> ae;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ae.emplace_back(i, j);
        }
    }
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        e1.insert({u, v});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        e2.insert({u, v});
    }
    for (int i = 0; i < (1 << ae.size()); ++i) {
        int x = i;
        int id = 0;
        vector<pair<int, int>> a;
        while (x) {
            if (x & 1) {
                a.push_back(ae[id]);
            }
            x >>= 1;
            ++id;
        }
        dsu d1, d2;
        d1.init(n);
        d2.init(n);
        auto e_1 = e1;
        for (auto &j: a) {
            if (e_1.count({j.first, j.second}) || e_1.count({j.second, j.first})) {
                e_1.erase({j.first, j.second});
            } else {
                e_1.insert({j.first, j.second});
            }
        }
        auto e_2 = e2;
        vector<pair<int, int>> f, s;
        for (auto &j: a) {
            if (e_2.count({j.first, j.second}) || e_2.count({j.second, j.first})) {
                e_2.erase({j.first, j.second});
                s.push_back(j);
            } else {
                e_2.insert({j.first, j.second});
                f.push_back(j);
            }
        }
        for (auto j: e_1) {
            d1.unite(j.first, j.second);
        }
        for (auto j: e_2) {
            d2.unite(j.first, j.second);
        }
        if (d1.sz[d1.getpar(0)] == n && d2.sz[d2.getpar(0)] == n) {
            cout << "Yes\n" << f.size() + s.size() << '\n';
            for (auto j: f) {
                cout << j.first + 1 << " " << j.second + 1 << "\n";
            }
            for (auto j: s) {
                cout << j.first + 1 << " " << j.second + 1 << "\n";
            }
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
