#include <bits/stdc++.h>

#define int long long
using namespace std;

struct dsu {
    vector<int> p, sz;

    void init(int n) {
        p.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            sz[i] = 1;
        }
    }

    int getpar(int u) {
        return (p[u] == u ? u : p[u] = getpar(p[u]));
    }

    void unite(int u, int v) {
        u = getpar(u);
        v = getpar(v);
        if (u == v) {
            return;
        }
        if (sz[u] > sz[v]) {
            swap(u, v);
        }
        p[u] = v;
        sz[v] += sz[u];
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<set<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u].insert(v);
        g2[v].insert(u);
    }
    for (int mask = 0; mask < 1 << (n * (n - 1) / 2); ++mask) {
        int cnt = 0;
        vector<pair<int, int>> a;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mask & (1 << cnt)) {
                    a.emplace_back(i, j);
                }
                ++cnt;
            }
        }
        auto ng1 = g1;
        auto ng2 = g2;
        for (auto i: a) {
            if (ng1[i.first].count(i.second)) {
                ng1[i.first].erase(i.second);
                ng1[i.second].erase(i.first);
            } else {
                ng1[i.first].insert(i.second);
                ng1[i.second].insert(i.first);
            }
        }
        vector<pair<int, int>> bef, aft;
        for (auto i: a) {
            if (ng2[i.first].count(i.second)) {
                aft.push_back(i);
                ng2[i.first].erase(i.second);
                ng2[i.second].erase(i.first);
            } else {
                bef.push_back(i);
                ng2[i.first].insert(i.second);
                ng2[i.second].insert(i.first);
            }
        }
        dsu d1, d2;
        d1.init(n);
        d2.init(n);
        for (int i = 0; i < ng1.size(); ++i) {
            for (auto j: ng1[i]) {
                d1.unite(i, j);
            }
        }
        for (int i = 0; i < ng2.size(); ++i) {
            for (auto j: ng2[i]) {
                d2.unite(i, j);
            }
        }
        if (d1.sz[d1.getpar(0)] == n && d2.sz[d2.getpar(0)] == n) {
            cout << "Yes\n";
            for (auto &i: bef) {
                cout << i.first + 1 << " " << i.second + 1 << "\n";
            }
            for (auto &i: aft) {
                cout << i.first + 1 << " " << i.second + 1 << "\n";
            }
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}

