#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct DSU {
    vector<int> p, size;

    DSU(int n) {
        p.resize(n), size.resize(n, 1);
        std::iota(p.begin(), p.end(), 0);
    }

    int get(int v) {
        if (p[v] == v) return v;
        p[v] = get(p[v]);
        return p[v] = get(p[v]);
    }

    bool connected(int u, int v) {
        return get(u) == get(v);
    }

    void join(int u, int v) {
        u = get(u);
        v = get(v);

        if (size[u] > size[v]) swap(u, v);
        p[u] = v;
        size[v] += size[u];
    }
};

void solve(int group) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g1(n);
    vector<vector<int>> g2(n);

    DSU ds(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;

        g1[u - 1].push_back(v - 1);
        g1[v - 1].push_back(u - 1);
        ds.join(u - 1, v - 1);
    }

    if (group == 2) {
        cout << "Yes" << "\n";
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (!ds.connected(i, j)){
                    cout << i + 1 << " " << j + 1 << "\n";
                    ds.join(i, j);
                }
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t, g;
    cin >> t >> g;

    while (t--) {
        solve(g);
    }
}