#include "bits/stdc++.h"

using namespace std;

using ll = long long;

void solve(int group) {

    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g1(n, vector<int>(n));
    vector<vector<int>> g2(n, vector<int>(n));

    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;

        g1[u - 1][v - 1] = 1;
        g1[v - 1][u - 1] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;

        g2[u - 1][v - 1] = 1;
        g2[v - 1][u - 1] = 1;
    }

    function<bool(vector<vector<int>> &)> check = [](vector<vector<int>> &g) -> bool {
        int n = g.size();
        vector<int> used(n);

        function<void(int)> dfs = [&](int v) {
            used[v] = true;
            for (int i = 0; i < n; ++i) {
                if (used[i] || !g[v][i]) continue;
                dfs(i);
            }
        };
        dfs(0);

        return std::find(used.begin(), used.end(), 0) == used.end();
    };

    int M = n * (n - 1) / 2;
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.push_back({i, j});
        }
    }
    for (int mask = 0; mask < (1 << M); ++mask) {
        vector<pair<int, int>> remove;
        vector<pair<int, int>> add;
        for (int i = 0; i < M; ++i) {
            if ((mask >> i) & 1) {
                int u = edges[i].first;
                int v = edges[i].second;

                if (g2[u][v]) remove.push_back({u, v});
                else add.push_back({u, v});
            }
        }

        for (auto [u, v]: add) g2[u][v] ^= 1, g2[v][u] ^= 1;
        for (auto [u, v]: remove) g2[u][v] ^= 1, g2[v][u] ^= 1;
        bool flag = check(g2);
        for (auto [u, v]: add) g1[u][v] ^= 1, g1[v][u] ^= 1;
        for (auto [u, v]: remove) g1[u][v] ^= 1, g1[v][u] ^= 1;
        flag &= check(g1);

        for (auto [u, v]: add) g2[u][v] ^= 1, g2[v][u] ^= 1;
        for (auto [u, v]: remove) g2[u][v] ^= 1, g2[v][u] ^= 1;
        for (auto [u, v]: add) g1[u][v] ^= 1, g1[v][u] ^= 1;
        for (auto [u, v]: remove) g1[u][v] ^= 1, g1[v][u] ^= 1;

        if (add.size() + remove.size() > n) continue;

        if (flag) {
            cout << "Yes" << "\n";
            cout << add.size() + remove.size() << "\n";
            for (auto [u, v]: add) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
            for (auto [u, v]: remove) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
            return;
        }
    }

    cout << "No" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t, g;
    cin >> t >> g;

    while (t--) solve(g);
}