#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s = "\n") {
    for (int i = 0; i < sz(a); ++i) {
        cout << a[i] << s;
    }
}

const int MAXN = 3e5 + 1;
vector<ll> g1[MAXN], g2[MAXN];
set<ll> g22[MAXN];
ll col[MAXN], T = 1, p[MAXN], d[MAXN];

int get_leader(int v) {
    if (v == p[v]) {
        return v;
    }
    p[v] = get_leader(p[v]);
    return p[v];
}

bool unite(int v, int u) {
    ll l1 = get_leader(v), l2 = get_leader(u);
    if (l1 == l2) {
        return false;
    }
    if (d[l1] > d[l2]) {
        d[l1] += d[l2];
        p[l2] = l1;
    } else {
        p[l1] = l2;
        d[l2] += d[l1];
    }
    return true;
}

void dfs(int v) {
    col[v] = T;
    for (auto u : g1[v]) {
        if (!col[u]) {
            dfs(u);
        }
    }
}

int group;

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    fill(p, p + n + 1, 0);
    iota(p, p + n + 1, 0);
    fill(d, d + n + 1, 1);
    fill(col, col + n + 1, 0);
    fill(g1, g1 + n + 1, vector<ll>(0));
    fill(g2, g2 + n + 1, vector<ll>(0));
    int start_T = T;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        g1[a].push_back(b);
        g1[b].push_back(a);
        unite(a, b);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    if (group == 9 || group == 2) {
        vector<pair<int, int>> ans;
        for (int u = n; u >= 3; --u) {
            if (unite(u, 1)) {
                ans.push_back({1, u});
            }
        }
        if (unite(2, n)) {
            ans.push_back({2, n});
        }
        cout << "Yes\n" << sz(ans) << '\n';
        print(ans);
    } else if (group == 2) {

    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
}
