#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s = "\n") {
    for (int i = 0; i < sz(a); ++i) {
        cout << a[i] << s;
    }
}

const int MAXN = 3e5 + 1;
vector<ll> g1[MAXN], g2[MAXN];
set<ll> g22[MAXN], g11[MAXN];
ll col[MAXN], T = 1, p[MAXN], d[MAXN];

int get_leader(int v) {
    if (v == p[v]) {
        return v;
    }
    p[v] = get_leader(p[v]);
    return p[v];
}

bool unite(int v, int u) {
    ll l1 = get_leader(v), l2 = get_leader(u);
    if (l1 == l2) {
        return false;
    }
    if (d[l1] > d[l2]) {
        d[l1] += d[l2];
        p[l2] = l1;
    } else {
        p[l1] = l2;
        d[l2] += d[l1];
    }
    return true;
}

void dfs(int v) {
    col[v] = T;
    for (auto u : g1[v]) {
        if (!col[u]) {
            dfs(u);
        }
    }
}

int group;

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    fill(p, p + n + 1, 0);
    iota(p, p + n + 1, 0);
    fill(d, d + n + 1, 1);
    fill(col, col + n + 1, 0);
    fill(g1, g1 + n + 1, vector<ll>(0));
    fill(g2, g2 + n + 1, vector<ll>(0));
    T = 1;
    for (int i = 1; i <= n; ++i) {
        g11[i].clear();
        g22[i].clear();
    }
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        g1[a].push_back(b);
        g1[b].push_back(a);
        unite(a, b);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    for (int i = 1; i <= n; ++i) {
        if (!col[i]) {
            dfs(i);
            ++T;
        }
    }
    if (m2 == n - 1) {
        vector<ll> leaves;
        for (int i = 1; i <= n; ++i) {
            if (sz(g2[i]) == 1) {
                leaves.push_back(i);
            }
        }
        int fst = leaves[0];
        vector<pair<int, int>> ans;
        for (int i = 1; i <= n; ++i) {
            if (i != fst && g11[fst].count(i) == 0) {
                ans.push_back({i, fst});
            }
        }
        bool ok = false;
        for (int i = 1; i < sz(leaves); ++i) {
            ll v = leaves[i];
            if (g2[v][0] != g2[fst][0]) {
                ok = true;
                if (g11[v].count(g2[fst][0]) == 0) {
                    ans.push_back({v, g2[fst][0]});
                }
            }
        }
        if (!ok) {
            cout << "No\n";
        } else {
            cout << "Yes\n" << sz(ans) << '\n';
            for (auto [aa, bb] : ans) {
                cout << aa << ' ' << bb << '\n';
            }
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
}
