#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9, MAXN = (1ll << 18), mod = 1e9 + 7, P = 1073;
mt19937 rnd(2356374786);

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) ans *= n;
        ans %= mod;
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

struct SegmentTree{
    vector<int> tree;
    vector<int> p;
    SegmentTree() {
        tree.resize(MAXN * 2, 0);
        p.resize(MAXN * 2, 0);
    }
    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    void push(int v, int l, int r) {
        if (p[v] == 0) return;
        tree[v] = (r - l) * p[v];
        if (l + 1 != r) {
            p[2 * v] = p[v];
            p[2 * v + 1] = p[v];
        }
        p[v] = 0;
    }
    void update(int v, int lv, int rv, int l, int r, int x) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return;
        if (lv >= l && rv <= r) {
            p[v] += x;
            push(v, lv, rv);
            return;
        }
        int mv = (lv + rv) / 2;
        update(2 * v, lv, mv, l, r, x);
        update(2 * v + 1, mv, rv, l, r, x);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    int get(int v, int lv, int rv, int l, int r) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return 0;
        if (lv >= l && rv <= r) {
            return tree[v];
        }
        int mv = (lv + rv) / 2;
        return get(2 * v, lv, mv, l, r) + get(2 * v + 1, mv, rv, l, r);
    }
};

struct Fenwick{
    vector<int> pref;
    int n;
    Fenwick(int nn) {
        n = nn;
        pref.resize(n + 1, 0);
    }
    void update(int i, int x) {
        for (; i < n + 1; i += (i & -i))
            pref[i] += x;
    }
    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= (i & -i))
            ans += pref[i];
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

vector<int> g[MAXN];
vector<bool> used(MAXN, false);
vector<int> p(MAXN, -1);
int vis;
void dfs(int v, int deep = 0) {
    used[v] = true;
    if (g[v].size() == 1 && used[g[v][0]]) {
        vis = v;
        return;
    }
    for (auto u : g[v]) {
        if (used[u]) continue;
        p[u] = v;
        dfs(u);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map<pair<int, int>, bool> ber;
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        p[i] = -1;
        g[i].clear();
    }
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        ber[{u, v}] = true;
        ber[{v, u}] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n == 3) {
        cout << "No";
        return;
    }
    dfs(0);
    cout << "Yes" << '\n';
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (i != p[vis] && i != vis && !ber[{vis, i}]) {
            ans.push_back({vis + 1, i + 1});
        }
    }
    for (int i = 0; i < n; i++) {
        if (i != p[vis] && i != vis && !ber[{p[vis], i}]) {
            ans.push_back({p[vis] + 1, i + 1});
            break;
        }
    }
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) cout << u << ' ' << v << '\n';
}



signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef home
    int test;
    int cnt = 0;
    while(cin >> test) {
        cnt++;
        cout << "TEST " << cnt << ":\n";
        solve();
        cout << '\n' << '\n';
    }
#else
    int test = 1, int g;
    cin >> test >> g;
    while (test--) {
        solve();
    }
#endif
}
