#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9, MAXN = (1ll << 18), mod = 1e9 + 7, P = 1073;
mt19937 rnd(2356374786);

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) ans *= n;
        ans %= mod;
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

struct SegmentTree{
    vector<int> tree;
    vector<int> p;
    SegmentTree() {
        tree.resize(MAXN * 2, 0);
        p.resize(MAXN * 2, 0);
    }
    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    void push(int v, int l, int r) {
        if (p[v] == 0) return;
        tree[v] = (r - l) * p[v];
        if (l + 1 != r) {
            p[2 * v] = p[v];
            p[2 * v + 1] = p[v];
        }
        p[v] = 0;
    }
    void update(int v, int lv, int rv, int l, int r, int x) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return;
        if (lv >= l && rv <= r) {
            p[v] += x;
            push(v, lv, rv);
            return;
        }
        int mv = (lv + rv) / 2;
        update(2 * v, lv, mv, l, r, x);
        update(2 * v + 1, mv, rv, l, r, x);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    int get(int v, int lv, int rv, int l, int r) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return 0;
        if (lv >= l && rv <= r) {
            return tree[v];
        }
        int mv = (lv + rv) / 2;
        return get(2 * v, lv, mv, l, r) + get(2 * v + 1, mv, rv, l, r);
    }
};

struct Fenwick{
    vector<int> pref;
    int n;
    Fenwick(int nn) {
        n = nn;
        pref.resize(n + 1, 0);
    }
    void update(int i, int x) {
        for (; i < n + 1; i += (i & -i))
            pref[i] += x;
    }
    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= (i & -i))
            ans += pref[i];
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map<pair<int, int>, bool> ber;
    map<pair<int, int>, bool> cher;
    vector<int> st(n, 0);
    int a = -1, b = -1;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        st[u]++;
        st[v]++;
        ber[{u, v}] = true;
        ber[{v, u}] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        cher[{u, v}] = true;
        cher[{v, u}] = true;
    }
    if (n == 3 && (ber[{0, 1}] != cher[{0 ,1}]) && (ber[{0, 2}] != cher[{0 ,2}]) && (ber[{2, 1}] != cher[{2 ,1}])) {
        cout << "No" << '\n';
        return;
    }
    vector<pair<int, int>> ans;
    if (a == -1) {
        for (int i = 0; i < min((int)3000, n); i++) {
            if (a != -1) break;
            for (int j = 0; j < min((int)3000, n); j++) {
                if (i == j) continue;
                if (cher[{i, j}] == ber[{i, j}]) {
                    if (!cher[{i, j}]) {
                        ans.push_back({i + 1, j + 1});
                    }
                    a = i, b = j;
                    break;
                }
            }
        }
//        for (int i = 1; i < n; i++) {
//            if (cher[{0, i}] == ber[{0, i}]) {
//                if (!cher[{0, i}]) {
//                    ans.push_back({1, i + 1});
//                }
//                a = 0, b = i;
//                break;
//            }
//        }
    }
    if (a == -1) {
        bool ok = true;
        for (int i = 1; i < n; i++) {
            if (!cher[{0, i}]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            if (!cher[{1, 2}]) ans.push_back({2, 3});
            ans.push_back({1, 2});
            if (!ber[{2, 3}]) ans.push_back({3, 4});
            for (int i = 3; i < n; i++) {
                if (!ber[{1, i}]) ans.push_back({2, i + 1});
            }
        } else {
            int cnt = 0;
            for (int i = 1; i < n; i++) {
                if (cher[{0, i}]) {
                    cnt++;
                    a = i;
                }
            }
            if (cnt == 1) {
                cnt = 0;
                for (int i = 0; i < n; i++) {
                    if (i == a) continue;
                    if (cher[{a, i}]) {
                        cnt++;
                    }
                }
                if (cnt == n - 1) {
                    int c = 1, d = 2;
                    if (c == a) c = 3;
                    if (d == a) d = 3;
                    if (!cher[{c, d}]) ans.push_back({c + 1, d + 1});
                    if (!ber[{a, c}]) ans.push_back({a + 1, c + 1});
                }
            } else if (cnt > 1) {
                a = -1, b = -1;
                for (int i = 1; i < n; i++) {
                    if (cher[{0, i}]) {
                        if (a == -1) {
                            a = i;
                        } else {
                            b = i;
                            break;
                        }
                    }
                }
                for (int i = 1; i < n; i++) {
                    if (!cher[{0, i}]) {
                        if (cher[{a, i}] && cher[{b, i}]) {
                            ans.push_back({a + 1, i + 1});
                        }
                        break;
                    }
                }
                int lst = -1;
                for (int i = 1; i < n; i++) {
                    if (cher[{0, i}]) {
                        if (lst != -1) {
                            if (!ber[{lst, i}]) {
                                ans.push_back({lst + 1, i + 1});
                            }
                        }
                        lst = i;
                    }
                }
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            if (i != a && i != b) {
                if (!cher[{a, i}]) {
                    if (!ber[{a, i}]) ans.push_back({a + 1, i + 1});
                } else {
                    if (!ber[{b, i}]) ans.push_back({b + 1, i + 1});
                }
            }
        }
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) cout << u << ' ' << v << '\n';
}



signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef home
    int test;
    int cnt = 0;
    while(cin >> test) {
        cnt++;
        cout << "TEST " << cnt << ":\n";
        solve();
        cout << '\n' << '\n';
    }
#else
    int test = 1, group;
    cin >> test >> group;
    while (test--) {
        solve();
    }
#endif
}
