#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

void func(vector <vector <int>>& g1, vector <vector <int>>& g2, vector <pair <int, int>>& ans, int v, int u){
    g1[v][u] ^= 1, g1[u][v] ^= 1, g2[v][u] ^= 1, g2[u][v] ^= 1, ans.push_back({v, u});
}

void dfs(vector <vector <int>>& g, vector <char>& used, int v){
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++){
        if(!used[i] && g[v][i] == 1){
            dfs(g, used, i);
        }
    }
}

bool check(vector <char>& used){
    for(int i = 0; i < used.size(); i++){
        if(!used[i]) return false;
    }
    return true;
}

void solve(){
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector <vector <int>> g1(n, vector <int> (n, 0)), g2(n, vector <int> (n, 0));
    for(int i = 0; i < m1; i++){
        ll a, b;
        cin >> a >> b;
        a--, b--, g1[a][b] = 1, g1[b][a] = 1;
    }
    for(int i = 0; i < m2; i++){
        ll a, b;
        cin >> a >> b;
        a--, b--, g2[a][b] = 1, g2[b][a] = 1;
    }
    if(n <= 5){
        for(int mask = 0; mask < (1 << (n * (n - 1) / 2)); mask++){
            vector <vector <int>> gr1 = g1, gr2 = g2;
            vector <pair <int, int>> ans;
            int cnt = 0;
            vector <char> used1(n, false), used2(n, false);
            if(mask & 1){
                func(gr1, gr2, ans, 0, 1), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 1)){
                func(gr1, gr2, ans, 0, 2), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 2) && n >= 4){
                func(gr1, gr2, ans, 0, 3), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 3) && n == 5){
                func(gr1, gr2, ans, 0, 4), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 4)){
                func(gr1, gr2, ans, 2, 1), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 5) && n >= 4){
                func(gr1, gr2, ans, 3, 1), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 6) && n == 5){
                func(gr1, gr2, ans, 4, 1), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 7) && n >= 4){
                func(gr1, gr2, ans, 2, 3), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 8) && n == 5){
                func(gr1, gr2, ans, 2, 4), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            if(mask & (1 << 9) && n == 5){
                func(gr1, gr2, ans, 3, 4), cnt++;
            }
            dfs(gr2, used2, 0);
            if(!check(used2))continue;
            used2.assign(n, false);
            dfs(gr1, used1, 0), dfs(gr2, used2, 0);
            if(check(used1) && check(used2) && cnt <= n){
                cout << "Yes\n" << ans.size() << "\n";
                for(int i = 0; i < ans.size(); i++){
                    cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
                }
                return;
            }
        }
        cout << "No\n";
    }
}

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t, g;
    cin >> t >> g;
    while(t--){
        solve();
    }
}