#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

void func(vector <vector <int>>& g1, vector <vector <int>>& g2, vector <pair <int, int>>& ans, int v, int u){
    g1[v][u] ^= 1, g1[u][v] ^= 1, g2[v][u] ^= 1, g2[u][v] ^= 1, ans.push_back({v, u});
}

void dfs(vector <vector <int>>& g, vector <char>& used, int v){
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++){
        if(!used[i] && g[v][i] == 1){
            dfs(g, used, i);
        }
    }
}

bool check(vector <char>& used){
    for(int i = 0; i < used.size(); i++){
        if(!used[i]) return false;
    }
    return true;
}

int get(vector <int>& p, int a){
    return p[a] = (p[a] == a ? a : get(p, p[a])); 
}

bool uni(vector <int>& p, vector <int>& w, int a, int b){
    int v = get(p, a), u = get(p, b);
    if(v == u) return false;
    if(w[v] > w[u]){
        p[v] = u, w[v] += w[u];
    }
    else{
        p[u] = v, w[u] += w[v];
    }
    return true;
}

void solve(int g){
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector <vector <int>> g1(n, vector <int> (n, 0)), g2(n, vector <int> (n, 0));
    for(int i = 0; i < m1; i++){
        ll a, b;
        cin >> a >> b;
        a--, b--, g1[a][b] = 1, g1[b][a] = 1;
    }
    for(int i = 0; i < m2; i++){
        ll a, b;
        cin >> a >> b;
        a--, b--, g2[a][b] = 1, g2[b][a] = 1;
    }
    if(g == 2){
        if(n == 3 && m1 == 0){
            cout << "No\n";
            return;
        } 
        vector <int> p(n), w(n, 1);
        for(int i = 0; i < n; i++){
            p[i] = i;
        }
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n; j++){
                if(g1[i][j] == 1){
                    uni(p, w, i, j);
                }
            }
        }
        int a = 0;
        vector <pair <int, int>> ans;
        for(int i = 0; i < n; i++){
            if(uni(p, w, a, i)){
                ans.push_back({a, i}), a = i;
            }
        }
        cout << "Yes\n" << ans.size() << "\n";
        for(int i = 0; i < ans.size(); i++){
            cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
        }
    }
}

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t, g;
    cin >> t >> g;
    while(t--){
        solve(g);
    }
}