#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector <vector <int>> g;
vector <pair <int, int>> edges_first;
vector <pair <int, int>> edges;
vector <pair <int, int>> edges_ans;
vector <pair <int, int>> good_edges;
map <pair <int, int>, int>  cnt;
vector <int> p;
vector <int> sz;
vector <int> tmp_v;
int n;

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}
void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    p[b] = a;
}

void build_dsu() {
    p.assign(n, 0);
    sz.assign(n, 1);
    iota(p.begin(), p.end(), 0);
}

void find_ost() {
    build_dsu();
    good_edges.clear();
    tmp_v.clear();
    vector <int> deg(n, 0);
    for (auto &now : edges) {
        int u = now.first;
        int v = now.second;
        if (get(u) != get(v)) {
            unite(u, v);
            cnt[{u, v}] = 1;
            cnt[{v, u}] = 1;
            deg[u]++;
            deg[v]++;
        } else {
            good_edges.emplace_back(u, v);
        }
    }
}
void find_ans() {
    find_ost();
    build_dsu();
    vector <pair < int, int>> ost_tmp_e;
    for (auto &now : edges_first) {
        int u = now.first;
        int v = now.second;
        if (get(u) != get(v)) {
            unite(u, v);
        } else {
            ost_tmp_e.emplace_back(u, v);
        }
    }
    tmp_v.emplace_back(ost_tmp_e[0].first);
    tmp_v.emplace_back(ost_tmp_e[1].second);
    for (auto &now : good_edges) {
        int u = now.first;
        int v = now.second;
        if (get(u) != get(v)) {
            unite(u, v);
            edges_ans.emplace_back(u, v);
        }
    }
    for (auto &v : tmp_v) {
        for (int i = 0; i < n; i++) {
            if (get(i) != get(v)) {
                if (cnt.count({i, v}) == 0) {
                    unite(i, v);
                    edges_ans.emplace_back(i, v);
                } else {
                    unite(i, v);
                    edges_ans.emplace_back(i, v);
                    edges_ans.emplace_back(ost_tmp_e[0]);
                }
            }
        }
    }

}

void solve() {
    int m1, m2; cin >> n >> m1 >> m2;
    g.assign(n, vector <int>(0, 0));
    edges.clear();
    edges_ans.clear();
    edges_first.clear();
    cnt.clear();
    for (int i = 0; i < m1; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        edges_first.emplace_back(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        edges.emplace_back(a, b);
    }
    find_ans();
    int fl = 1;
    int last = -1;
    for (int i = 0; i < n; i++) {
        if (last == -1) {
            last = get(i);
        } else {
            if (last != get(i)) {
                fl = 0;
            }
        }
    }
    if (fl) {
        cout << "Yes" << endl;
        cout << (int) edges_ans.size() << endl;
        for (auto &now : edges_ans) {
            cout << now.first + 1 << " " << now.second + 1 << endl;
        }
    } else {
        cout << "No" << endl;
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    int type = 1;
    cin >> test >> type;
    while (test--) {
        solve();
    }
}


