#include <bits/stdc++.h>

using namespace std;

struct DSU {
    int n;
    vector<int> sz, p;

    DSU(int _n) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    bool unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        return true;
    }
};

constexpr int maxn_part = 5;

int g[2][maxn_part][maxn_part];

bool is_connected(int n, int tp) {
    DSU d(n);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (g[tp][i][j]) {
                if (d.unite(i, j)) {
                    cnt++;
                }
            }
        }
    }
    return cnt == n - 1;
}

pair<bool, vector<pair<int, int>>> gen(int n, int pos, vector<pair<int, int>> nw) {
    // cout << pos << endl;
    if (!is_connected(n, 1)) {
        return make_pair(false, vector<pair<int, int>>());
    }
    if (is_connected(n, 0)) {
        return make_pair(true, nw);
    }
    if (pos == n) {
        return make_pair(false, vector<pair<int, int>>());
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            g[0][i][j] ^= 1;
            g[0][j][i] ^= 1;
            g[1][i][j] ^= 1;
            g[1][j][i] ^= 1;
            nw.emplace_back(i, j);
            auto ans = gen(n, pos + 1, nw);
            if (ans.first) {
                return ans;
            }
            nw.pop_back();
            g[0][i][j] ^= 1;
            g[0][j][i] ^= 1;
            g[1][i][j] ^= 1;
            g[1][j][i] ^= 1;
        }
    }
    return make_pair(false, vector<pair<int, int>>());
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (n <= 5) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                g[0][i][j] = g[1][i][j] = 0;
            }
        }
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[0][u][v] = g[0][v][u] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[1][u][v] = g[1][v][u] = 1;
        }
        // cout << "!!!" << endl;
        auto ans = gen(n, 0, vector<pair<int, int>>());
        if (!ans.first) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << ans.second.size() << '\n';
            for (auto [u, v] : ans.second) {
                cout << u + 1 << ' ' << v + 1 << '\n';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
