#include <bits/stdc++.h>

using namespace std;

struct DSU {
    int n;
    vector<int> sz, p;

    DSU(int _n) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    bool unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        return true;
    }
};

constexpr int maxn_part = 5;

int g[2][maxn_part][maxn_part];

bool is_connected(int n, int tp) {
    DSU d(n);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (g[tp][i][j]) {
                if (d.unite(i, j)) {
                    cnt++;
                }
            }
        }
    }
    return cnt == n - 1;
}

pair<bool, vector<pair<int, int>>> gen(int n, int pos, vector<pair<int, int>> nw) {
    // cout << pos << endl;
    if (!is_connected(n, 1)) {
        return make_pair(false, vector<pair<int, int>>());
    }
    if (is_connected(n, 0)) {
        return make_pair(true, nw);
    }
    if (pos == n) {
        return make_pair(false, vector<pair<int, int>>());
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            g[0][i][j] ^= 1;
            g[0][j][i] ^= 1;
            g[1][i][j] ^= 1;
            g[1][j][i] ^= 1;
            nw.emplace_back(i, j);
            auto ans = gen(n, pos + 1, nw);
            if (ans.first) {
                return ans;
            }
            nw.pop_back();
            g[0][i][j] ^= 1;
            g[0][j][i] ^= 1;
            g[1][i][j] ^= 1;
            g[1][j][i] ^= 1;
        }
    }
    return make_pair(false, vector<pair<int, int>>());
}

constexpr int maxn = 3e5 + 5;

int tmm = 1;

int tin[maxn], tup[maxn], used[maxn];

void calc_tin(int v, int pr, vector<vector<int>> &g) {
    tin[v] = tmm++;
    tup[v] = tin[v];
    for (auto u : g[v]) {
        if (!tin[u]) {
            calc_tin(u, v, g);
            tup[v] = min(tup[v], tup[u]);
        } else if (u != pr) {
            tup[v] = min(tup[v], tin[u]);
        }
    }
}

void get_bridges(int v, int pr, vector<vector<int>> &g, set<pair<int, int>> &ans) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            if (tup[u] > tin[v]) {
                ans.emplace(u, v);
                ans.emplace(v, u);
            }
            get_bridges(u, v, g, ans);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (n <= 5) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                g[0][i][j] = g[1][i][j] = 0;
            }
        }
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[0][u][v] = g[0][v][u] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[1][u][v] = g[1][v][u] = 1;
        }
        // cout << "!!!" << endl;
        auto ans = gen(n, 0, vector<pair<int, int>>());
        if (!ans.first) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << ans.second.size() << '\n';
            for (auto [u, v] : ans.second) {
                cout << u + 1 << ' ' << v + 1 << '\n';
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            tin[i] = tup[i] = used[i] = 0;
        }
        DSU d(n);
        vector<vector<int>> g1(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g1[u].push_back(v);
            g1[v].push_back(u);
            d.unite(u, v);
        }
        set<int> prs;
        map<int, vector<int>> mp;
        for (int i = 0; i < n; ++i) {
            prs.insert(d.pr(i));
            mp[d.pr(i)].push_back(i);
        }
        assert(prs.size() == 2);
        calc_tin(*prs.begin(), -1, g1);
        calc_tin(*prs.rbegin(), -1, g1);
        set<pair<int, int>> s1;
        get_bridges(*prs.begin(), -1, g1, s1);
        get_bridges(*prs.rbegin(), -1, g1, s1);
        vector<vector<int>> g(n);
        set<pair<int, int>> s2;
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u].push_back(v);
            g[v].push_back(u);
            s2.emplace(u, v);
            s2.emplace(v, u);
        }
        mt19937 rnd(57);
        if (m2 == n - 1) {
            while (true) {
                int u = rnd() % n, v = rnd() % n;
                if (u == v || s1.count({u, v}) || s2.count({u, v})) {
                    break;
                }
                g[u].push_back(v);
                g[v].push_back(u);
                break;
            }
        }
        calc_tin(0, -1, g);
        set<pair<int, int>> s;
        get_bridges(0, -1, g, s);
        int vl1 = *prs.begin(), vl2 = *prs.rbegin();
        assert(vl1 != vl2);
        for (auto u : mp[vl1]) {
            for (auto v : mp[vl2]) {
                if (!s.count({u, v})) {
                    cout << "Yes\n";
                    cout << 1 << '\n';
                    cout << u + 1 << ' ' << v + 1 << '\n';
                    return;
                }
            }
        }
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
