#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <cstring>
#include <random>
#include <chrono>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t, group;
    cin >> t >> group;
    if (group == 1) {
        while (t--) {
            int n, m1, m2;
            cin >> n >> m1 >> m2;
            vector<set<int>> b(n), c(n);
            for (int i = 0; i < m1; ++i) {
                int v, u;
                cin >> v >> u;
                --v, --u;
                b[v].insert(u);
                b[u].insert(v);
            }
            for (int i = 0; i < m2; ++i) {
                int a, b;
                cin >> a >> b;
                --a, --b;
                c[a].insert(b);
                c[b].insert(a);
            }
            auto connected = [&](const vector<set<int>>& g) -> bool {
                bool used[n]{0};
                vector<int> vs;
                vs.push_back(0);
                used[0] = true;
                while (vs.size()) {
                    int u = vs.back();
                    vs.pop_back();
                    for (int q : g[u]) {
                        if (!used[q]) {
                            used[q] = true;
                            vs.push_back(q);
                        }
                    }
                }
                return all_of(used, used + n, [&](bool v){return v;});
            };
            auto inverse = [&](vector<set<int>>& g, int i, int j) -> void {
                if (g[i].count(j)) {
                    g[i].erase(j);
                    g[j].erase(i);
                } else {
                    g[i].insert(j);
                    g[j].insert(i);
                }
            };
            auto get = [&](int value) -> pair<int, int> {return {value / n, value % n};};
            bool found = false;
            int mask = (1 << (n * (n - 1)));
            for (int cur = 0; cur < mask; ++cur) {
                if (__builtin_popcount(cur) > n)
                    continue;
                auto bmod = b;
                auto cmod = c;
                bool ok = true;
                for (int j = 0; j < n * (n - 1); ++j) {
                    if (cur >> j & 1) {
                        auto q = get(j);
                        inverse(bmod, q.first, q.second);
                        inverse(cmod, q.first, q.second);
                        if (!connected(cmod)) {
                            ok = false;
                            break;
                        }
                    }
                }
                if (ok && connected(bmod)) {
                    vector<int> ans;
                    for (int j = 0; j < n * (n - 1); ++j) {
                        if (cur >> j & 1) {
                            ans.push_back(j);
                        }
                    }
                    cout << "Yes\n" << ans.size() << "\n";
                    for (int x : ans) {
                        auto p = get(x);
                        cout << p.first + 1 << " " << p.second + 1 << "\n";
                    }
                    found = true;
                    break;
                }
            }
            if (!found) {
                cout << "No\n";
            }
        }
    }
}
