#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <cstring>
#include <random>
#include <chrono>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t, group;
    cin >> t >> group;
    if (group == 1) {
        while (t--) {
            int n, m1, m2;
            cin >> n >> m1 >> m2;
            vector<set<int>> b(n), c(n);
            for (int i = 0; i < m1; ++i) {
                int v, u;
                cin >> v >> u;
                --v, --u;
                b[v].insert(u);
                b[u].insert(v);
            }
            for (int i = 0; i < m2; ++i) {
                int a, b;
                cin >> a >> b;
                --a, --b;
                c[a].insert(b);
                c[b].insert(a);
            }
            auto connected = [&](const vector<set<int>>& g) -> bool {
                bool used[n]{0};
                vector<int> vs;
                vs.push_back(0);
                used[0] = true;
                while (vs.size()) {
                    int u = vs.back();
                    vs.pop_back();
                    for (int q : g[u]) {
                        if (!used[q]) {
                            used[q] = true;
                            vs.push_back(q);
                        }
                    }
                }
                return all_of(used, used + n, [&](bool v){return v;});
            };
            auto inverse = [&](vector<set<int>>& g, int i, int j) -> void {
                if (g[i].count(j)) {
                    g[i].erase(j);
                    g[j].erase(i);
                } else {
                    g[i].insert(j);
                    g[j].insert(i);
                }
            };
            vector<pair<int, int>> edges;
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    edges.push_back({i, j});
                }
            }
            bool found = false;
            int k = edges.size();
            int mask = (1 << k);
            for (int cur = 0; cur < mask; ++cur) {
                if (__builtin_popcount(cur) > n)
                    continue;
                auto bg = b;
                auto cg = c;
                bool ok = true;
                for (int j = 0; j < k; ++j) {
                    if (cur >> j & 1) {
                        auto pq = edges[j];
                        inverse(bg, pq.first, pq.second);
                        inverse(cg, pq.first, pq.second);
                        if (!connected(cg)) {
                            ok = false;
                            break;
                        }
                    }
                }
                if (ok && connected(bg)) {
                    vector<pair<int, int>> ans;
                    for (int j = 0; j < k; ++j) {
                        if (cur >> j & 1) {
                            auto pq = edges[j];
                            ans.push_back({pq.first + 1, pq.second + 1});
                        }
                    }
                    cout << "Yes\n";
                    cout << ans.size() << "\n";
                    for (auto& p : ans) cout << p.first << " " << p.second << "\n";
                    found = true;
                    break;
                }
            }
            if (!found) {
                cout << "No\n";
            }
        }
    } else if (group == 2) {
        while (t--) {
            int n, m1, m2;
            cin >> n >> m1 >> m2;
            vector<set<int>> b(n), c(n);
            for (int i = 0; i < m1; ++i) {
                int v, u;
                cin >> v >> u;
                --v, --u;
                b[v].insert(u);
                b[u].insert(v);
            }
            for (int i = 0; i < m2; ++i) {
                int v, u;
                cin >> v >> u;
                --v, --u;
                c[v].insert(u);
                c[u].insert(v);
            }
            auto connected = [&](const vector<set<int>>& g) -> bool {
                bool used[n];
                memset(used, 0, sizeof(used));
                vector<int> vs;
                vs.push_back(0);
                used[0] = true;
                while (vs.size()) {
                    int u = vs.back();
                    vs.pop_back();
                    for (int q : g[u]) {
                        if (!used[q]) {
                            used[q] = true;
                            vs.push_back(q);
                        }
                    }
                }
                return all_of(used, used + n, [&](bool v){return v;});
            };
            if (n == 3 && m1 == 0) {
                cout << "No\n";
                continue;
            }
            vector<pair<int, int>> ans;
            for (int i = 0; i < n - 1; ++i) {
                if (!b[i].count((i + 1) % n)) {
                    ans.push_back({i + 1, i + 2});
                    b[i].insert(i + 1);
                    b[i + 1].insert(i);
                    c[i].erase(i + 1);
                    c[i + 1].erase(i);
                    if (connected(b))
                        break;
                }
            }
            if (!connected(b) || !connected(c)) {
                cout << "No\n";
                continue;
            }
            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto& p : ans) cout << p.first << " " << p.second << '\n';
        }
    }
}
