#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <queue>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 1e9;
const ll MAXN = 1e5 + 5;

int g;
int n, m1, m2;
vector<set<int>> g1, g2;
vector<int> used;

int dfs1(int v) {
    used[v] = 1;

    int res = 1;
    for (auto to : g1[v]) {
        if (!used[to]) {
            res += dfs1(to);
        }
    }

    return res;
}
int dfs2(int v) {
    used[v] = 1;

    int res = 1;
    for (auto to : g2[v]) {
        if (!used[to]) {
            res += dfs2(to);
        }
    }

    return res;
}

void solve2() {
    if (m2 == 3) {
        exit(1);
    }

    vector<pair<int, int>> ans;
    for (int u = 0; u < n - 1; ++u) {
        if (g1[u].find(u + 1) == g1[u].end()) {
            ans.emplace_back(u, u + 1);
        }
    }

    for (auto [x, y] : ans) {
        g1[x].insert(y);
        g1[y].insert(x);
        g2[x].erase(y);
        g2[y].erase(x);
    }

    used.assign(n, 0);
    if (dfs1(0) != n) {
        cout << "No\n";
        return;
    }
    used.assign(n, 0);
    if (dfs2(0) != n) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";
    cout << (int)ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

void solve56() {
    set<int> kids;
    set<pair<int, int>> kek;
    for (int u = 0; u < n; ++u) {
        for (auto to : g1[u]) {
            kek.insert({u, to});
        }
    }
    for (auto to : g2[0]) {
        kids.insert(to);
    }

    vector<pair<int, int>> ans;
    for (int to = 1; to < n; ++to) {
        if (kids.find(to) != kids.end()) {
            continue;
        }

        if (kek.find({0, to}) == kek.end()) {
            ans.push_back({0, to});
            g1[0].insert(to);
            g1[to].insert(0);
            g2[0].insert(to);
            g2[to].insert(0);
        }
    }

    vector<int> tmp;
    for (auto to : kids) {
        tmp.push_back(to);
    }

    for (int i = 0; i < (int)tmp.size() - 1; ++i) {
        if (kek.find({tmp[i], tmp[i + 1]}) == kek.end()) {
            ans.push_back({tmp[i], tmp[i + 1]});
            g1[tmp[i]].insert(tmp[i + 1]);
            g1[tmp[i + 1]].insert(tmp[i]);
        }
    }

    if (kek.find({0, tmp[0]}) == kek.end()) {
        ans.push_back({0, tmp[0]});
        g1[0].insert(tmp[0]);
        g1[tmp[0]].insert(0);
        g2[0].erase(tmp[0]);
        g2[tmp[0]].erase(0);
    }

    used.assign(n, 0);
    if (dfs1(0) != n) {
        cout << "No\n";
        return;
    }
    used.assign(n, 0);
    if (dfs2(0) != n) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";
    cout << (int)ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

void start() {
    cin >> n >> m1 >> m2;
    g1.assign(n, {});
    g2.assign(n, {});

    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g1[a].insert(b);
        g1[b].insert(a);
    }

    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g2[a].insert(b);
        g2[b].insert(a);
    }

    if (g == 2) {
        solve2();
    } else if (g == 5 || g == 6) {
        solve56();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
    cin >> T >> g;

    while (T --> 0) {
        start();
    }

    return 0;
}
