#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

struct dsu {
    int n;
    vector<int> p;

    dsu(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int get(int x) {
        if (p[x] == x) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void join(int u, int v) {
        u = get(u);
        v = get(v);
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    dsu d1(n);
    vector<vector<int>> cnt(n, vector<int>(n));

    vector<pair<int, int>> edges1(m1);
    for (auto &[u, v] : edges1) {
        cin >> u >> v;
        u--, v--;
        d1.join(u, v);
        cnt[u][v] += 1;
        cnt[v][u] += 1;
    }

    vector<pair<int, int>> edges2(m2);
    for (auto &[u, v] : edges2) {
        cin >> u >> v;
        u--, v--;
        cnt[u][v] += 1;
        cnt[v][u] += 1;
    }

    vector<pair<int, int>> ans;

    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (!d1.check(u, v) && cnt[u][v] == 0) {
                d1.join(u, v);
                ans.emplace_back(u, v);
                cnt[u][v] = cnt[v][u] = 2;
            }
        }
    }

    map<int, vector<int>> C;
    for (int u = 0; u < n; u++) {
        C[d1.get(u)].push_back(u);
    }

    vector<vector<int>> A;
    for (auto &[x, y] : C) {
        A.emplace_back();
        A.back().swap(y);
    }

    sort(A.begin(), A.end(), [](auto &a, auto &b) {
        return a.size() < b.size();
    });

    if (A.back().size() == 1) {
        if (A.size() <= 3) {
            cout << "No\n";
            return;
        } else {
            for (int i = 1; i < (int)A.size(); i++) {
                ans.emplace_back(A[i - 1].front(), A[i].front());
            }

            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto &[u, v] : ans) {
                cout << u + 1 << ' ' << v + 1<< '\n';
            }
            return;
        }
    }

    while (A.size() >= 2 && A[A.size() - 1].size() >= 2 && A[A.size() - 2].size() >= 2) {
        ans.emplace_back(A[A.size() - 1].front(), A[A.size() - 2].front());
        A.pop_back();
    }

    if (A.size() == 1) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto &[u, v] : ans) {
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
        return;
    }

    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, g;
    cin >> t >> g;

    while (t--) {
        solve();
    }
    return 0;
}
