#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

struct dsu {
    int n;
    vector<int> p;

    dsu(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int get(int x) {
        if (p[x] == x) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void join(int u, int v) {
        u = get(u);
        v = get(v);
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    dsu d1(n);
    vector<vector<int>> cnt(n, vector<int>(n));

    vector<pair<int, int>> edges1(m1);
    set<pair<int, int>> R1;

    for (auto &[u, v] : edges1) {
        cin >> u >> v;
        u--, v--;
        if (u > v) {
            swap(u, v);
        }
        R1.emplace(u, v);
        d1.join(u, v);
        cnt[u][v] += 1;
        cnt[v][u] += 1;
    }

    vector<pair<int, int>> edges2(m2);
    set<pair<int, int>> R;

    for (auto &[u, v] : edges2) {
        cin >> u >> v;
        u--, v--;
        if (u > v) swap(u, v);
        R.emplace(u, v);
        cnt[u][v] += 1;
        cnt[v][u] += 1;
    }

    vector<pair<int, int>> ans;

    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (!d1.check(u, v) && cnt[u][v] == 0) {
                d1.join(u, v);
                ans.emplace_back(u, v);
                R1.emplace(u, v);
                R.emplace(u, v);
                cnt[u][v] = cnt[v][u] = 2;
            }
        }
    }

    map<int, vector<int>> C;
    for (int u = 0; u < n; u++) {
        C[d1.get(u)].push_back(u);
    }

    deque<vector<int>> A;
    for (auto &[x, y] : C) {
        A.emplace_back();
        A.back().swap(y);
    }

    sort(A.begin(), A.end(), [](auto &a, auto &b) {
        return a.size() < b.size();
    });

    if (A.back().size() == 1) {
        if (A.size() <= 3) {
            cout << "No\n";
            return;
        } else {
            for (int i = 1; i < (int)A.size(); i++) {
                d1.join(A[i - 1].front(), A[i].front());
                ans.emplace_back(A[i - 1].front(), A[i].front());
            }

            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto &[u, v] : ans) {
                cout << u + 1 << ' ' << v + 1<< '\n';
            }
            return;
        }
    }

    while (A.size() >= 2 && A[A.size() - 1].size() >= 2 && A[A.size() - 2].size() >= 2) {
        int u = A[A.size() - 1].front();
        int v = A[A.size() - 2].front();
        if (u > v) {
            swap(u, v);
        }
        d1.join(u, v);
        ans.emplace_back(u, v);
        R1.emplace(u, v);
        R.erase(pair(u, v));
        A.pop_back();
    }

    if (A.size() == 1) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto &[u, v] : ans) {
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
        return;
    }

    while (A.size() > 2) {
        int u = A.front().front();
        int v = A.back().front();
        ans.emplace_back(u, v);
        R1.emplace(u, v);
        d1.join(u, v);
        R.erase(pair(u, v));
        A.pop_front();
    }

    for (auto [u, v] : R) {
        if (d1.check(u, v)) {
            ans.emplace_back(u, A.front().front());
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto &[u, v] : ans) {
                cout << u + 1 << ' ' << v + 1 << '\n';
            }
            return;
        }
    }

    if (n == 3) {
        cout << "No\n";
    } else {
        ll m = n - 1;
        if (R1.size() == m * (m - 1) / 2) {
            int u = A.back().front();
            int v = A.back().back();
            ans.emplace_back(u, v);
            ans.emplace_back(A.front().front(), u);
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto &[u, v] : ans) {
                cout << u + 1 << ' ' << v + 1 << '\n';
            }
            return;
        } else {
            for (int u = 0; u < n; u++) {
                if (u == A.front().front()) {
                    continue;
                }

                for (int v = 0; v < n; v++) {
                    if (v == u || v == A.front().front()) {
                        continue;
                    }

                    if (!R1.contains(pair(min(u, v), max(u, v)))) {
                        ans.emplace_back(A.front().front(), u);
                        cout << "Yes\n";
                        cout << ans.size() << '\n';
                        for (auto &[u, v] : ans) {
                            cout << u + 1 << ' ' << v + 1 << '\n';
                        }
                    }
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, g;
    cin >> t >> g;

    while (t--) {
        solve();
    }
    return 0;
}
