#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

struct dsu {
    vector<int> p;

    dsu(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int get(int x) {
        if (p[x] == x) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void join(int u, int v) {
        u = get(u);
        v = get(v);
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    auto pair_comp = [&](pair<int, int> A, pair<int, int> B) {
        if (A.first > A.second) {
            swap(A.first, A.second);
        }

        if (B.first > B.second) {
            swap(B.first, B.second);
        }

        return A < B;
    };

    set<pair<int, int>, decltype(pair_comp)> E1(pair_comp);
    set<pair<int, int>, decltype(pair_comp)> E2(pair_comp);

    dsu D(n);

    vector<vector<int>> cnt(n, vector<int>(n));

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        E1.emplace(u, v);
        D.join(u, v);
        cnt[u][v]++;
        cnt[v][u]++;
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        E2.emplace(u, v);
        cnt[u][v]++;
        cnt[v][u]++;
    }

    vector<pair<int, int>> ans;

    auto answer = [&]() -> void {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (const auto &[u, v] : ans) {
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
    };

    auto swap_edge = [&](int u, int v) {
        ans.emplace_back(u, v);

        if (E1.contains(pair(u, v))) {
            E1.erase(pair(u, v));
        } else {
            E1.emplace(u, v);
            D.join(u, v);
        }

        if (E2.contains(pair(u, v))) {
            E2.erase(pair(u, v));
        } else {
            E2.emplace(u, v);
        }
    };

    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (!D.check(u, v) && cnt[u][v] == 0) {
                swap_edge(u, v);
            }
        }
    }

    map<int, vector<int>> C;
    for (int u = 0; u < n; u++) {
        C[D.get(u)].push_back(u);
    }

    deque<vector<int>> A;
    for (auto &[x, y] : C) {
        A.emplace_back();
        A.back().swap(y);
    }

    sort(A.begin(), A.end(), [](auto &a, auto &b) {
        return a.size() < b.size();
    });

    if (A.back().size() == 1) {
        if (A.size() <= 3) {
            cout << "No\n";
            return;
        } else {
            for (int i = 0; i + 1 < (int)A.size(); i++) {
                swap_edge(A[i].front(), A[i + 1].front());
            }
            answer();
            return;
        }
    }

    while (A.size() >= 2 && A[A.size() - 1].size() >= 2 && A[A.size() - 2].size() >= 2) {
        int u = A[A.size() - 1].front();
        int v = A[A.size() - 2].front();
        swap_edge(u, v);
    }

    if (A.size() == 1) {
        answer();
        return;
    }

    while (A.size() > 2) {
        int u = A.front().front();
        int v = A.back().front();
        swap_edge(u, v);
    }

    int z = A.front().front();

    for (auto [u, v] : E2) {
        if (u != z && v != z) {
            swap_edge(z, u);
            answer();
            return;
        }
    }

    if (n == 3) {
        cout << "No\n";
    } else {
        ll m = n - 1;
        if (E1.size() == m * (m - 1) / 2) {
            int u = A.back().front();
            int v = A.back().back();
            swap_edge(u, v);
            swap_edge(z, u);
            answer();
            return;
        } else {
            for (int u = 0; u < n; u++) {
                if (u == z) {
                    continue;
                }

                for (int v = 0; v < n; v++) {
                    if (v == u || v == z) {
                        continue;
                    }

                    if (!E1.contains(pair(u, v))) {
                        swap_edge(u, v);
                        swap_edge(z, u);
                        answer();
                        return;
                    }
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, g;
    cin >> t >> g;

    while (t--) {
        solve();
    }
    return 0;
}
