#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

struct dsu {
    vector<int> p;
    vector<vector<int>> d;

    dsu(int n) {
        p.resize(n);
        d.resize(n);
        for (int i = 0; i < n; i++) {
            d[i].push_back(i);
        }
        iota(p.begin(), p.end(), 0);
    }

    int get(int x) {
        if (p[x] == x) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void join(int u, int v) {
        u = get(u);
        v = get(v);
        if (u != v) {
            if (d[u].size() < d[v].size()) {
                swap(u, v);
            }
            for (int x : d[v]) {
                d[u].push_back(x);
            }
            d[v].clear();
            d[v].shrink_to_fit();
            p[v] = u;
        }
    }

    const vector<int> &all(int u) {
        return d[get(u)];
    }
};

pair<int, int> converted(const pair<int, int> &A) {
    return pair(min(A.first, A.second), max(A.first, A.second));
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    auto pair_comp = [&](const pair<int, int> &A, const pair<int, int> &B) {
        return converted(A) < converted(B);
    };

    set<pair<int, int>, decltype(pair_comp)> E1(pair_comp);
    set<pair<int, int>, decltype(pair_comp)> E2(pair_comp);

    dsu D(n);

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        E1.emplace(u, v);
        D.join(u, v);
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        E2.emplace(u, v);
    }

    vector<pair<int, int>> ans;

    auto answer = [&]() -> void {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (const auto &[u, v] : ans) {
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
    };

    auto swap_edge = [&](int u, int v) {
        ans.emplace_back(u, v);

        if (E1.contains(pair(u, v))) {
            E1.erase(pair(u, v));
        } else {
            E1.emplace(u, v);
            D.join(u, v);
        }

        if (E2.contains(pair(u, v))) {
            E2.erase(pair(u, v));
        } else {
            E2.emplace(u, v);
        }
    };

    {
        set<int> free;
        for (int i = 0; i < n; i++) {
            free.insert(i);
        }

        while (!free.empty()) {
            vector<int> bfs = D.all(*free.begin());
            for (int v : bfs) {
                free.erase(v);
            }

            for (int i = 0; i < (int)bfs.size(); i++) {
                int u = bfs[i];

                set<int> closed;

                while (!free.empty()) {
                    int v = *free.begin();
                    free.erase(free.begin());

                    if (D.check(u, v)) {
                        continue;
                    }

                    if (!E1.contains(pair(u, v)) && !E2.contains(pair(u, v))) {
                        swap_edge(u, v);
                        bfs.push_back(v);
                    } else {
                        closed.insert(v);
                    }
                }

                free = closed;
            }
        }
    }

    map<int, vector<int>> C;
    for (int u = 0; u < n; u++) {
        C[D.get(u)].push_back(u);
    }

    deque<pair<int, int>> A;
    for (auto &[x, y] : C) {
        if (y.size() == 1) {
            A.emplace_back(y.front(), -1);
        } else {
            A.emplace_back(y.front(), y.back());
        }
    }
    C.clear();

    sort(A.begin(), A.end(), [](const auto &a, const auto &b) {
        return a.second == -1 && b.second != -1;
    });

    if (A.back().second == -1) {
        if (A.size() <= 3) {
            cout << "No\n";
            return;
        } else {
            for (int i = 0; i + 1 < (int)A.size(); i++) {
                swap_edge(A[i].first, A[i + 1].first);
            }
            answer();
            return;
        }
    }

    while (A.size() >= 2 && A[A.size() - 1].second != -1 && A[A.size() - 2].second != -1) {
        int u = A[A.size() - 1].first;
        int v = A[A.size() - 2].first;
        A.pop_back();
        swap_edge(u, v);
    }

    if (A.size() == 1) {
        answer();
        return;
    }

    while (A.size() > 2) {
        int u = A.front().first;
        int v = A.back().first;
        swap_edge(u, v);
        A.pop_front();
    }

    int z = A.front().first;

    for (auto [u, v] : E2) {
        if (u != z && v != z) {
            swap_edge(z, u);
            answer();
            return;
        }
    }

    if (n == 3) {
        cout << "No\n";
    } else {
        ll m = n - 1;
        if (E1.size() == m * (m - 1) / 2) {
            int u = A.back().first;
            int v = A.back().second;
            swap_edge(u, v);
            swap_edge(z, u);
            answer();
            return;
        } else {
            for (int u = 0; u < n; u++) {
                if (u == z) {
                    continue;
                }

                for (int v = 0; v < n; v++) {
                    if (v == u || v == z) {
                        continue;
                    }

                    if (!E1.contains(pair(u, v))) {
                        swap_edge(u, v);
                        swap_edge(z, u);
                        answer();
                        return;
                    }
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, g;
    cin >> t >> g;

    while (t--) {
        solve();
    }
    return 0;
}
