#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {
    ll n, m1, m2;
    vector<pair<ll, ll>> ribes;
    vector<vector<bool>> g1, g2;
    vector<bool> used1, used2;

    void dfs1(ll v) {
        used1[v] = true;
        for (int to = 0; to < n; to++) {
            if (!used1[to] && g1[v][to]) {
                dfs1(to);
            }
        }
    }

    void dfs2(ll v) {
        used2[v] = true;
        for (int to = 0; to < n; to++) {
            if (!used2[to] && g2[v][to]) {
                dfs2(to);
            }
        }
    }

    void solve() {
        cin >> n >> m1 >> m2;
        g1.resize(n, vector<bool>(n, false));
        g2.resize(n, vector<bool>(n, false));
        used1.resize(n, false);
        used2.resize(n, false);
        if (n <= 5) {
            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    ribes.emplace_back(i, j);
                }
            }
            for (int i = 0; i < m1; i++) {
                ll f, s;
                cin >> f >> s, f--, s--;
                g1[f][s] = g1[s][f] = true;
            }
            for (int i = 0; i < m2; i++) {
                ll f, s;
                cin >> f >> s, f--, s--;
                g2[f][s] = g2[s][f] = true;
            }
            ll sz = n * (n - 1) / 2;
            for (ll msk = 0; msk < (1ll << sz); msk++) {
                for (ll i = 0; i < sz; i++) {
                    if (msk & (1ll << i)) {
                        g1[ribes[i].first][ribes[i].second] = !g1[ribes[i].first][ribes[i].second];
                        g1[ribes[i].second][ribes[i].first] = !g1[ribes[i].second][ribes[i].first];
                        g2[ribes[i].first][ribes[i].second] = !g2[ribes[i].first][ribes[i].second];
                        g2[ribes[i].second][ribes[i].first] = !g2[ribes[i].second][ribes[i].first];
                    }
                }
                fill(used1.begin(), used1.end(), false);
                fill(used2.begin(), used2.end(), false);
                dfs1(0);
                dfs2(0);
                bool ok = true;
                for (int i = 0; i < n; i++) {
                    if (!used1[i] || !used2[i]) {
                        ok = false;
                        break;
                    }
                }
                if (ok) {
                    vector<pair<ll, ll>> res;
                    for (ll i = 0; i < sz; i++) {
                        if (msk & (1ll << i)) {
                            res.push_back({ribes[i].first, ribes[i].second});
                        }
                    }
                    cout << "Yes\n";
                    cout << res.size() << '\n';
                    for (auto el: res) {
                        cout << el.first + 1 << ' ' << el.second + 1<< '\n';
                    }
                    return;
                }
                for (ll i = 0; i < sz; i++) {
                    if (msk & (1ll << i)) {
                        g1[ribes[i].first][ribes[i].second] = !g1[ribes[i].first][ribes[i].second];
                        g1[ribes[i].second][ribes[i].first] = !g1[ribes[i].second][ribes[i].first];
                        g2[ribes[i].first][ribes[i].second] = !g2[ribes[i].first][ribes[i].second];
                        g2[ribes[i].second][ribes[i].first] = !g2[ribes[i].second][ribes[i].first];
                    }
                }
            }
            cout << "No\n";
            return;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    bool stres = false;
    if (stres) times = 1e9;
    else cin >> times;
    while (times--) {
        Fast f;
        f.solve();
    }
    return 0;
}
