#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {
    ll n, m1, m2;
    vector<vector<bool>> g1, g2;
    vector<bool> used1, used2;
    vector<vector<bool>> ban;
    vector<pair<ll, ll>> res;

    void dfs1(ll v) {
        used1[v] = true;
        for (int to = 0; to < n; to++) {
            if (!used1[to] && g1[v][to]) {
                dfs1(to);
            }
        }
        for (int to = 0; to < n; to++) {
            if (!used1[to] && !ban[v][to]) {
                res.push_back({v, to});
                dfs1(to);
            }
        }
    }

    void dfs2(ll v) {
        used2[v] = true;
        for (int to = 0; to < n; to++) {
            if (!used2[to]) {
                ban[v][to] = ban[to][v] = true;
                dfs2(to);
            }
        }
    }


    void solve() {
        cin >> n >> m1 >> m2;
        g1.resize(n, vector<bool>(n, false));
        g2.resize(n, vector<bool>(n, false));
        ban.resize(n, vector<bool>(n, false));
        used1.resize(n, false);
        used2.resize(n, false);
        for (int i = 0; i < m1; i++) {
            ll f, s;
            cin >> f >> s, f--, s--;
            g1[f][s] = g1[s][f] = true;
        }
        for (int i = 0; i < m2; i++) {
            ll f, s;
            cin >> f >> s, f--, s--;
            g2[f][s] = g2[s][f] = true;
        }
        dfs2(0);
        dfs1(0);
        bool ok = true;
        for (int i = 0; i < n; i++){
            if (!used1[i]) {
                ok = false;
                break;
            }
        }
        if (ok){
            cout << "Yes\n";
            cout << ll(res.size()) << '\n';
            for (auto el : res){
                cout << el.first + 1 << ' ' << el.second + 1 << '\n';
            }
        } else {
            cout << "No\n";
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    ll group;
    bool stres = false;
    if (stres) times = 1e9;
    else cin >> times >> group;
    while (times--) {
        Fast f;
        f.solve();
    }
    return 0;
}
