#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

int gist2[3000][3000];
vector<vector<int>> edge1;
vector<vector<int>> bcl;
vector<int> used;

void dfs(int u, int cl) {
    used[u] = 1;
    bcl[cl].push_back(u);
    for (int v : edge1[u]) {
        if (used[v] == 0) {
            dfs(v, cl);
        }
    }
}

inline void solve() {
    edge1.clear();
    bcl.clear();
    used.clear();
    int n, m1, m2; cin >> n >> m1 >> m2;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            gist2[i][j] = 0;
        }
    }
    edge1.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        edge1[u].push_back(v);
        edge1[v].push_back(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        gist2[u][v] = gist2[v][u] = 1;
    }
    int nx = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            bcl.push_back({});
            dfs(i, nx);
            ++nx;
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i + 1 < nx; ++i) {
        bool added = false;
        for (int u : bcl[i]) {
            for (int v : bcl[i + 1]) {
                if (gist2[u][v] == 0) {
                    ans.push_back({ u, v });
                    added = true;
                    break;
                }
            }
            if (added == true) {
                break;
            }
        }
        if (added == false) {
            ans.push_back({ bcl[i][0], bcl[i + 1][0] });
        }
    }
    cout << "Yes\n";
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); ++i) {
        cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1, g; cin >> t >> g;
    while (t--) {
        solve();
    }
}