#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

set<pair<int, int>> gist2;
vector<set<int>> edge1;
vector<vector<int>> bcl;
vector<int> used;

vector<pair<int, int>> ans;

void dfs(int u, int cl) {
    used[u] = 1;
    bcl[cl].push_back(u);
    for (int v : edge1[u]) {
        if (used[v] == 0) {
            dfs(v, cl);
        }
    }
}

void ch(int u, int v) {
    if (edge1[u].count(v)) {
        edge1[u].erase(v);
        edge1[v].erase(u);
    } else {
        edge1[u].insert(v);
        edge1[v].insert(u);
    }
    if (gist2.count({ u, v })) {
        gist2.erase({ u, v });
        gist2.erase({ v, u });
    } else {
        gist2.insert({ u, v });
        gist2.insert({ v, u });
    }
}

void check_con1(int u, vector<int>& ver) {
    used[u] = 1;
    for (int v : ver) {
        if (used[v] == 0 && edge1[u].count(v)) {
            check_con1(v, ver);
        }
    }
}

void check_con2(int u, vector<int>& ver) {
    used[u] = 1;
    for (int v : ver) {
        if (used[v] == 0 && gist2.count({ u, v })) {
            check_con2(v, ver);
        }
    }
}

bool connect(vector<int> ver) {
    vector<pair<int, int>> prs;
    for (int i = 0; i < (int)ver.size(); ++i) {
        for (int j = i + 1; j < (int)ver.size(); ++j) {
            prs.push_back({ ver[i], ver[j] });
        }
    }
    int bstm = -1, chd = 100;
    int n = prs.size();
    for (int mask = 0; mask < (1 << n); ++mask) {
        int cn = 0;
        for (int j = 0; j < n; ++j) {
            if (((mask >> j) & 1)) {
                ch(prs[j].first, prs[j].second);
                ++cn;
            }
        }
        for (int v : ver) {
            used[v] = 0;
        }
        check_con1(ver[0], ver);
        bool y = true;
        for (int v : ver) {
            if (used[v] == 0) {
                y = false;
            }
        }
        if (y) {
            for (int v : ver) {
                used[v] = 0;
            }
            check_con2(ver[0], ver);
            y = true;
            for (int v : ver) {
                if (used[v] == 0) {
                    y = false;
                }
            }
            if (y) {
                if (cn < chd) {
                    bstm = mask;
                    chd = cn;
                }
            }
        }
        for (int j = 0; j < n; ++j) {
            if (((mask >> j) & 1)) {
                ch(prs[j].first, prs[j].second);
            }
        }
    }
    if (bstm == -1) {
        return false;
    }
    int mask = bstm;
    for (int j = 0; j < n; ++j) {
        if (((mask >> j) & 1)) {
            ch(prs[j].first, prs[j].second);
            ans.push_back({ prs[j].first, prs[j].second });
        }
    }
    return true;
}

inline void solve() {
    edge1.clear();
    bcl.clear();
    used.clear();
    gist2.clear();
    ans.clear();
    int n, m1, m2; cin >> n >> m1 >> m2;
    edge1.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        edge1[u].insert(v);
        edge1[v].insert(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        gist2.insert({ u, v });
        gist2.insert({ v, u });
    }
    int nx = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            bcl.push_back({});
            dfs(i, nx);
            ++nx;
        }
    }
    int lst = -1;
    vector<int> alc;
    vector<int> nc;
    for (int i = 0; i < nx; ++i) {
        if (bcl[i].size() == 1) {
            nc.push_back(bcl[i][0]);
            continue;
        }
        if (lst == -1) {
            lst = i;
            alc = bcl[i];
            continue;
        }
        bool added = false;
        for (int A = 0; A < 2; ++A) {
            for (int B = 0; B < 2; ++B) {
                int u = bcl[i][A];
                int v = bcl[lst][B];
                if (gist2.count({u, v}) == 0) {
                    ans.push_back({ u, v });
                    gist2.insert({ u, v });
                    gist2.insert({ v, u });
                    added = true;
                    break;
                }
            }
            if (added == true) {
                break;
            }
        }
        if (added == false) {
            ans.push_back({ bcl[i][0], bcl[lst][0] });
            gist2.erase({ bcl[i][0], bcl[lst][0] });
            gist2.erase({ bcl[lst][0], bcl[lst][0] });
        }
        for (int j : bcl[i]) {
            alc.push_back(j);
        }
    }
    int mstb = 4;
    for (int i = 0; i < (int)nc.size(); i += mstb - 1) {
        vector<int> nw;
        for (int j = i; j < min((int)nc.size(), i + mstb - 1); ++j) {
            nw.push_back(nc[j]);
        }
        int nx = 0;
        while (nx != alc.size() && nw.size() != mstb) {
            nw.push_back(alc[nx]);
            ++nx;
        }
        if (nw.size() < mstb) {
            while (i + mstb - 1 < (int)nc.size()) {
                nw.push_back(nc[i + mstb - 1]);
                ++i;
            }
        }
        if (connect(nw) == false) {
            cout << "No\n";
            return;
        }
        for (int j : nw) {
            alc.push_back(j);
        }
    }
    cout << "Yes\n";
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); ++i) {
        cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1, g; cin >> t >> g;
    while (t--) {
        solve();
    }
}