#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

int gist2[3000][3000];
int edge1[3000][3000];
vector<vector<int>> bcl;
vector<int> used;
int n;

vector<pair<int, int>> ans;

void dfs(int u, int cl) {
    used[u] = 1;
    bcl[cl].push_back(u);
    for (int v = 0; v < n; ++v) {
        if (edge1[u][v] == 0) {
            continue;
        }
        if (used[v] == 0) {
            dfs(v, cl);
        }
    }
}

void ch(int u, int v) {
    edge1[u][v] ^= 1;
    edge1[v][u] ^= 1;
    gist2[u][v] ^= 1;
    gist2[v][u] ^= 1;
}

void check_con1(int u, vector<int>& ver) {
    used[u] = 1;
    for (int v : ver) {
        if (used[v] == 0 && edge1[u][v]) {
            check_con1(v, ver);
        }
    }
}

void check_con2(int u, vector<int>& ver) {
    used[u] = 1;
    for (int v : ver) {
        if (used[v] == 0 && gist2[u][v]) {
            check_con2(v, ver);
        }
    }
}


bool check_ops(vector<int>& ops, vector<pair<int, int>>& prs, vector<int>& ver) {
    bool y = true;
    for (int j : ops) {
        ch(prs[j].first, prs[j].second);
    }
    for (int v : ver) {
        used[v] = 0;
    }
    check_con1(ver[0], ver);
    for (int v : ver) {
        if (used[v] == 0) {
            y = false;
        }
    }
    if (y) {
        for (int v : ver) {
            used[v] = 0;
        }
        check_con2(ver[0], ver);
        y = true;
        for (int v : ver) {
            if (used[v] == 0) {
                y = false;
            }
        }
        if (y) {
            for (int j : ops) {
                ch(prs[j].first, prs[j].second);
            }
            return true;
        }
    }
    for (int j : ops) {
        ch(prs[j].first, prs[j].second);
    }
    return false;
}

bool connect(vector<int> ver) {
    vector<pair<int, int>> prs;
    for (int i = 0; i < (int)ver.size(); ++i) {
        for (int j = i + 1; j < (int)ver.size(); ++j) {
            prs.push_back({ ver[i], ver[j] });
        }
    }
    int bstm = -1, chd = 100;
    vector<int> posl;
    int n = prs.size();
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> op;
        for (int j = 0; j < n; ++j) {
            if (((mask >> j) & 1)) {
                op.push_back(j);
            }
        }
        if (op.size() >= chd) {
            continue;
        }
        if (check_ops(op, prs, ver)) {
            if (op.size() < chd) {
                bstm = mask;
                chd = op.size();
                posl = op;
            }
        }
    }
    if (bstm == -1) {
        return false;
    }
    int mask = bstm;
    vector<int> posl2;
    for (int j : posl) {
        if (gist2[prs[j].first][prs[j].second]) {
            posl2.push_back(j);
            continue;
        }
        ch(prs[j].first, prs[j].second);
        ans.push_back({ prs[j].first, prs[j].second });
    }
    for (int j : posl2) {
        ch(prs[j].first, prs[j].second);
        ans.push_back({ prs[j].first, prs[j].second });
    }
    return true;
}

inline void solve() {
    bcl.clear();
    used.clear();
    ans.clear();
    int m1, m2; cin >> n >> m1 >> m2;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            edge1[i][j] = gist2[i][j] = 0;
        }
    }
    used.resize(n, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        ++edge1[u][v];
        ++edge1[v][u];
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        ++gist2[u][v];
        ++gist2[v][u];
    }
    int nx = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            bcl.push_back({});
            dfs(i, nx);
            ++nx;
        }
    }
    int lst = -1;
    vector<int> alc;
    vector<int> nc;
    for (int i = 0; i < nx; ++i) {
        if (bcl[i].size() == 1) {
            nc.push_back(bcl[i][0]);
            continue;
        }
        if (lst == -1) {
            lst = i;
            alc = bcl[i];
            continue;
        }
        bool added = false;
        for (int A = 0; A < 2; ++A) {
            for (int B = 0; B < 2; ++B) {
                int u = bcl[i][A];
                int v = bcl[lst][B];
                if (gist2[u][v] == 0) {
                    ch(u, v);
                    ans.push_back({ u, v });
                    added = true;
                    break;
                }
            }
            if (added == true) {
                break;
            }
        }
        if (added == false) {
            ans.push_back({ bcl[i][0], bcl[lst][0] });
            ch(bcl[i][0], bcl[lst][0]);
        }
        for (int j : bcl[i]) {
            alc.push_back(j);
        }
    }
    int mstb = 4;
    for (int i = 0; i < (int)nc.size(); i += mstb - 1) {
        vector<int> nw;
        for (int j = i; j < min((int)nc.size(), i + mstb - 1); ++j) {
            nw.push_back(nc[j]);
        }
        int nx = 0;
        while (nx != alc.size() && nw.size() != mstb) {
            nw.push_back(alc[nx]);
            ++nx;
        }
        if (nw.size() < mstb) {
            while (i + mstb - 1 < (int)nc.size()) {
                nw.push_back(nc[i + mstb - 1]);
                ++i;
            }
        }
        if (connect(nw) == false) {
            cout << "No\n";
            return;
        }
        for (int j : nw) {
            alc.push_back(j);
        }
    }
    cout << "Yes\n";
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); ++i) {
        cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1, g; cin >> t >> g;
    while (t--) {
        solve();
    }
}