#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//#define int long long

int t;
int group;

mt19937 rnd(229);

namespace solve_459 {
    struct DSU {
        vector<int> dsu;
        int comps = 0;
        DSU(int n) {
            dsu.assign(n, -1);
            comps = n;
        }
        int get_parent(int u) {
            if (dsu[u] < 0) return u;
            return dsu[u] = get_parent(dsu[u]);
        }

        bool join(int u, int v) {
            u = get_parent(u);
            v = get_parent(v);
            if (u == v) return false;
            if (dsu[u] < dsu[v]) {
                swap(u, v);
            }
            // u ----> v
            if (dsu[u] == dsu[v]) --dsu[v];
            dsu[u] = v;
            --comps;
            return true;
        }
    };

    signed solve() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<pair<int, int>> g1(m1), g2(m2);
        for (pair<int, int> &now : g1) cin >> now.first >> now.second, now = minmax(now.first - 1, now.second - 1);
        for (pair<int, int> &now : g2) cin >> now.first >> now.second, now = minmax(now.first - 1, now.second - 1);

        DSU first(n);
        for (auto now : g1) {
            first.join(now.first, now.second);
        }
        if (first.comps == 1) {
            cout << "Yes\n0\n";
            return 0;
        }


        set<pair<int, int>> g1e, g2e;
        copy(g1.begin(), g1.end(), inserter(g1e, g1e.end()));
        copy(g2.begin(), g2.end(), inserter(g2e, g2e.end()));

        vector<pair<int, int>> cs;

        pair<int, int> ch = {-1, -1};
        if (m2 == n - 1) {
            int u = -1, v = -1;
            int iter = 0;
            while (u == -1 && iter < n * 2) {
                ++iter;
                u = rnd() % n;
                v = rnd() % n;
                auto edge = minmax(u, v);
                if (u != v && g1e.find(edge) == g1e.end() && g2e.find(edge) == g2e.end()) {
                    g2e.insert(edge);
                    g2.emplace_back(edge);
                    cs.push_back(edge);
                    g1e.insert(edge);
                    g1.push_back(edge);
                    first.join(u, v);
                    ch = edge;
                } else {
                    u = -1;
                }
            }
            while (u == -1) {
                u = rnd() % n;
                v = rnd() % n;
                auto edge = minmax(u, v);
                if (u != v && g2e.find(edge) == g2e.end()) {
                    g2e.insert(edge);
                    g2.emplace_back(edge);
                    cs.push_back(edge);
                    if (g1e.find(edge) != g1e.end()) {
                        g1e.erase(edge);
                        g1.erase(std::find(g1.begin(), g1.end(), pair<int, int>(edge)));
                        first = DSU(n);
                        for (auto now : g1) {
                            first.join(now.first, now.second);
                        }
                    }
                    else {
                        first.join(u, v);
                        g1e.insert(edge);
                        g1.push_back(edge);
                    }
                    ch = edge;
                } else {
                    u = -1;
                }
            }
        }

        std::set<pair<int, int>> tmp;
        int shared = (std::set_intersection(g1e.begin(), g1e.end(), g2.begin(), g2.end(), inserter(tmp, tmp.end())), tmp.size());
        std::sort(g2.begin(), g2.end(), [&](auto qw, auto er) {
            if (ch == er) return false;
            if (ch == qw) return true;
            return (g1e.find(qw) != g1e.end()) > (g1e.find(er) != g1e.end());
        });

        shuffle(g2.begin() + shared, g2.end(), rnd);

        std::set<pair<int, int>> ostov_2;
        DSU second(n);
        for (auto now : g2) {
            if (second.join(now.first, now.second)) {
                ostov_2.insert(now);
            }
        }

        int u, v;
        int iter = 0;
        while (first.comps != 1) {
            ++iter;
            if (iter == 100 && n == 3) {
                cout << "No\n";
                return 0;
            }
            u = rnd() % n;
            v = rnd() % n;
            auto edge = minmax(u, v);
            if (first.get_parent(u) != first.get_parent(v) && ostov_2.find(edge) == ostov_2.end()) {
                g2e.insert(edge);
                g2.emplace_back(edge);
                cs.push_back(edge);
                g1e.insert(edge);
                g1.push_back(edge);
                first.join(u, v);
            } else {
                u = -1;
            }
        }

        cout << "Yes\n";
        cout << cs.size() << '\n';
        for (auto now : cs) {
            cout << now.first + 1 << ' ' << now.second + 1 << '\n';
        }

        return 0;
    }
}

struct DSU {
    vector<int> dsu;
    int comps = 0;
    DSU(int n) {
        dsu.assign(n, -1);
        comps = n;
    }
    int get_parent(int u) {
        if (dsu[u] < 0) return u;
        return dsu[u] = get_parent(dsu[u]);
    }

    bool join(int u, int v) {
        u = get_parent(u);
        v = get_parent(v);
        if (u == v) return false;
        if (dsu[u] < dsu[v]) {
            swap(u, v);
        }
        // u ----> v
        if (dsu[u] == dsu[v]) --dsu[v];
        dsu[u] = v;
        --comps;
        return true;
    }
};

signed solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> g1(m1), g2(m2);
    for (pair<int, int> &now : g1) cin >> now.first >> now.second, now = minmax(now.first - 1, now.second - 1);
    for (pair<int, int> &now : g2) cin >> now.first >> now.second, now = minmax(now.first - 1, now.second - 1);

    DSU first(n);
    for (auto now : g1) {
        first.join(now.first, now.second);
    }
    if (first.comps == 1) {
        cout << "Yes\n0\n";
        return 0;
    }

    if (n == 3) {
        if (m1 == 0 && m2 == 3) {
            cout << "No\n";
        } else if (m1 == 0 && m2 == 2) {
            cout << "Yes\n2\n";
            bool ok = false;
            for (int i = 0; !ok && i < 2; ++i) {
                for (int j = i + 1; j <3; ++j) {
                    if (find(g2.begin(), g2.end(), pair{i, j}) == g2.end()) {
                        cout << i + 1 << ' ' << j + 1 << '\n';
                        ok = true;
                        break;
                    }
                }
            }
            cout << g2[0].first + 1 << ' ' << g2[0].second + 1 << '\n';
        } else if (m1 == 1 && m2 == 3) {
            cout << "Yes\n1\n";
            bool ok = false;
            for (int i = 0; !ok && i < 2; ++i) {
                for (int j = i + 1; j <3; ++j) {
                    if (find(g1.begin(), g1.end(), pair{i, j}) == g1.end()) {
                        cout << i + 1 << ' ' << j + 1 << '\n';
                        ok = true;
                        break;
                    }
                }
            }
        } else {
            assert(m1 == 1 && m2 == 2);
            bool ok = false;
            pair<int, int> gg;
            for (int i = 0; !ok && i < 2; ++i) {
                for (int j = i + 1; j <3; ++j) {
                    if (find(g1.begin(), g1.end(), pair{i, j}) == g1.end()
                    && find(g2.begin(), g2.end(), pair{i, j}) == g2.end()) {
                        gg = {i + 1, j + 1};
                        ok = true;
                        break;
                    }
                }
            }
            if (!ok) {
                cout << "No\n";
            } else {
                cout << "Yes\n1\n" << gg.first << ' ' << gg.second << '\n';
            }
        }
        return 0;
    }

    set<pair<int, int>> g1e, g2e;
    copy(g1.begin(), g1.end(), inserter(g1e, g1e.end()));
    copy(g2.begin(), g2.end(), inserter(g2e, g2e.end()));

    vector<pair<int, int>> cs;

    pair<int, int> ch = {-1, -1};
    if (m2 == n - 1) {
        int u = -1, v = -1;
        int iter = 0;
        while (u == -1 && iter < n * 2) {
            ++iter;
            u = rnd() % n;
            v = rnd() % n;
            auto edge = minmax(u, v);
            if (u != v && g1e.find(edge) == g1e.end() && g2e.find(edge) == g2e.end()) {
                g2e.insert(edge);
                g2.emplace_back(edge);
                cs.push_back(edge);
                g1e.insert(edge);
                g1.push_back(edge);
                first.join(u, v);
                ch = edge;
            } else {
                u = -1;
            }
        }
        while (u == -1) {
            u = rnd() % n;
            v = rnd() % n;
            auto edge = minmax(u, v);
            if (u != v && g2e.find(edge) == g2e.end()) {
                g2e.insert(edge);
                g2.emplace_back(edge);
                cs.push_back(edge);
                if (g1e.find(edge) != g1e.end()) {
                    g1e.erase(edge);
                    g1.erase(std::find(g1.begin(), g1.end(), pair<int, int>(edge)));
                    first = DSU(n);
                    for (auto now : g1) {
                        first.join(now.first, now.second);
                    }
                }
                else {
                    first.join(u, v);
                    g1e.insert(edge);
                    g1.push_back(edge);
                }
                ch = edge;
            } else {
                u = -1;
            }
        }
    }

    if (first.comps == 1) {
        cout << "Yes\n";
        cout << cs.size() << '\n';
        for (auto now : cs) {
            cout << now.first + 1 << ' ' << now.second + 1 << '\n';
        }
        return 0;
    }

    std::set<pair<int, int>> tmp;
    int shared = (std::set_intersection(g1e.begin(), g1e.end(), g2.begin(), g2.end(), inserter(tmp, tmp.end())), tmp.size());
    std::sort(g2.begin(), g2.end(), [&](auto qw, auto er) {
        if (ch == er) return false;
        if (ch == qw) return true;
        return (g1e.find(qw) != g1e.end()) > (g1e.find(er) != g1e.end());
    });


    std::set<pair<int, int>> ostov_2;
    while (ostov_2.size() != n - 1) {
        shuffle(g2.begin() + shared, g2.end(), rnd);
        ostov_2.clear();
        vector<int> cnt(n);
        DSU second(n);
        for (auto now: g2) {
            if (n != 3 && (cnt[now.first] == n - 2 || cnt[now.second] == n - 2)) continue;
            if (second.join(now.first, now.second)) {
                ++cnt[now.first];
                ++cnt[now.second];
                ostov_2.insert(now);
            }
        }
    }

    int u, v;
    int iter = 0;
    while (first.comps != 1) {
        ++iter;
        if (iter == 100 && n == 3) {
            cout << "No\n";
            return 0;
        }
        u = rnd() % n;
        v = rnd() % n;
        auto edge = minmax(u, v);
        if (first.get_parent(u) != first.get_parent(v) && ostov_2.find(edge) == ostov_2.end()) {
            g2e.insert(edge);
            g2.emplace_back(edge);
            cs.push_back(edge);
            g1e.insert(edge);
            g1.push_back(edge);
            first.join(u, v);
        } else {
            u = -1;
        }
    }

    cout << "Yes\n";
    assert(cs.size() <= n);
    cout << cs.size() << '\n';
    for (auto now : cs) {
        cout << now.first + 1 << ' ' << now.second + 1 << '\n';
    }

    return 0;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> t >> group;
    while (t --> 0) {
//        if (group == 4 || group == 5 || group == 9) solve_459::solve();
//        else
            solve();
//            solve_459::solve();
    }
//    return solve();
    return 0;
}
