#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

vector<vector<int> > a, b, g, c;
vector<int> color;

void dfs(int v, int cur) {
    c[cur].pb(v);
    color[v] = cur;
    for (auto u : g[v]) {
        if (color[u] != cur) dfs(u, cur);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    a.assign(n, vector<int> (n));
    b.assign(n, vector<int> (n));
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v; u--, v--;
        a[u][v] = 1;
        a[v][u] = 1;
    }    
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v; u--, v--;
        b[u][v] = 1;
        b[v][u] = 1;
    } 
    g.assign(n, vector<int> (0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == b[i][j]) g[i].pb(j);
        }
    }

    c.assign(n + 1, vector<int> (0));
    color.assign(n + 1, 0);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) dfs(i, ++cnt);
    }

    int sum2 = 0, sum3 = 0;
    if (cnt == 2) sum2 = (c[1].size() > 1) + (c[2].size() > 1);
    if (cnt == 3) sum3 = (c[1].size() > 1) + (c[2].size() > 1) + (c[3].size() > 1);
    if (cnt > 3 || (cnt == 3 && sum3 >= 1) || (cnt == 2 && sum2 == 2) || cnt == 1) {
        cout << "Yes\n";
        vector<pair<int, int> > ans;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (a[i][j] == b[i][j] && a[i][j] == 0) ans.pb(mp(i, j));
            }
        }

        if (cnt > 3) {
            for (int i = 1; i < cnt; i++) {
                if (a[c[i][0]][c[i + 1][0]] == 0) ans.pb(mp(c[i][0], c[i + 1][0]));
                if (i < cnt - 1) {
                    if (b[c[i][0]][c[i + 2][0]] == 0) ans.pb(mp(c[i][0], c[i + 2][0]));
                }
            }
            if (b[c[1][0]][c[cnt][0]] == 0) ans.pb(mp(c[1][0], c[cnt][0]));
        } 
        if (cnt == 3) {
            if (c[1].size() == 1 && c[2].size() > 1) swap(c[1], c[2]);
            else if (c[1].size() == 1 && c[3].size() > 1) swap(c[1], c[3]);

            if (a[c[1][0]][c[2][0]] == 0) ans.pb(mp(c[1][0], c[2][0]));
            if (a[c[1][0]][c[3][0]] == 0) ans.pb(mp(c[1][0], c[3][0]));
            if (b[c[1][1]][c[2][0]] == 0) ans.pb(mp(c[1][1], c[2][0]));
            if (b[c[1][1]][c[3][0]] == 0) ans.pb(mp(c[1][1], c[3][0]));
        }
        if (cnt == 2) {
            if (a[c[1][0]][c[2][0]] == 0) ans.pb(mp(c[1][0], c[2][0]));
            if (b[c[1][1]][c[2][1]] == 0) ans.pb(mp(c[1][1], c[2][1]));
        }

        cout << ans.size() << "\n";
        for (auto i : ans) cout << i.F + 1 << " " << i.S + 1 << "\n";
    } else {
        cout << "No\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt, group; cin >> tt >> group;
    while (tt--) {
        solve();
    }
}
