#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

int n, m1, m2;
vector<vector<int> > a, b, g, c;
vector<int> color;

void dfsa(int v) {
    color[v] = 1;
    for (int u = 0; u < n; u++) {
        if (a[v][u] == 1 && !color[u]) dfsa(u); 
    }
}

void dfsb(int v) {
    color[v] = 1;
    for (int u = 0; u < n; u++) {
        if (b[v][u] == 1 && !color[u]) dfsb(u); 
    }
}

void stupid() {
    vector<pair<int, int> > p;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            p.push_back(mp(i, j));
        }
    }
    
    int sz = (1 << int(p.size()));
    for (int mask = 0; mask < sz; mask++) {
        for (int pos = 0; pos < p.size(); pos++) {
            if ((mask >> pos) & 1) {
                a[p[pos].F][p[pos].S] ^= 1;
                b[p[pos].F][p[pos].S] ^= 1;
            }
        }
        color.assign(n, 0);
        dfsa(0);
        int oka = 1;
        for (int i = 0; i < n; i++) {
            if (color[i] == 0) oka = 0;
        }
        color.assign(n, 0);
        dfsb(0);
        int okb = 1;
        for (int i = 0; i < n; i++) {
            if (color[i] == 0) okb = 0;
        }
        if (oka && okb) {
            cout << "Yes\n";
            vector<pair<int, int> > ans;
            for (int pos = 0; pos < p.size(); pos++) {
                if ((mask >> pos) & 1) {
                    ans.pb(mp(p[pos].F, p[pos].S));
                }
            }
            cout << ans.size() << "\n";
            for (auto j : ans) cout << j.F + 1 << " " << j.S + 1 << "\n";
            return;
        }
        for (int pos = 0; pos < p.size(); pos++) {
            if ((mask >> pos) & 1) {
                a[p[pos].F][p[pos].S] ^= 1;
                b[p[pos].F][p[pos].S] ^= 1;
            }
        }
    }
    cout << "No\n";
}

void input() {
    cin >> n >> m1 >> m2;
    a.assign(n, vector<int> (n));
    b.assign(n, vector<int> (n));
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v; u--, v--;
        a[u][v] = 1;
        a[v][u] = 1;
    }    
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v; u--, v--;
        b[u][v] = 1;
        b[v][u] = 1;
    } 
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt, group; cin >> tt >> group;
    while (tt--) {
        input();
        stupid();
    }
}
