#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int tt, gr;
int n, m1, m2;

set < int > g[N], g1[N];

struct dsu {
    vector < int > par;
    vector < int > sz;

    void init (int _n) {
        par.resize(_n + 1);
        sz.resize(_n + 1, 1);
        iota(all (par), 0);
        fill(all (sz), 1);
    }

    int get (int x) { return x == par[x] ? x : par[x] = get (par[x]);}

    void uni (int a, int b) {
        a = get (a), b = get (b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap (a, b);
        par[b] = a;
        sz[a] += sz[b];
    }
} t;

bool used [N];
void dfs1 (int v, int& cnt) {
    if (used[v]) return;
    used[v] = true;
    ++ cnt;
    for (auto& to : g1[v]) dfs1 (to, cnt);
}

void dfs (int v, int& cnt) {
    if (used[v]) return;
    used[v] = true;
    ++ cnt;
    for (auto& to : g[v]) dfs (to, cnt);
}
void solve () {

    cin >> n >> m1 >> m2;

    t.init (n);
    vector < pii > edge;

    for (int i = 1; i <= m1; ++ i) {
        int u, v;
        cin >> u >> v;

        t.uni (u, v);
        g[v].insert (u);
        g[u].insert (v);
    }

    for (int i = 1; i <= m2; ++ i) {
        int u, v;
        cin >> u >> v;

        g1[v].insert (u);
        g1[u].insert (v);
    }


    for (int i = 1; i <= n; ++ i) {
        for (int j = i + 1; j <= n; ++ j) {
            if (t.get (i) != t.get (j)) edge.pb ({i, j});
        }
    }

    vector < pii > answer;

    while (sz(answer) < n) {
        for (auto[a, b] : edge) {
            if (t.get (a) == t.get (b)) continue;

            if (g1[a].find (b) != g1[a].end()) g1[a].erase (b), g1[b].erase (a);
            else g1[a].insert (b), g1[b].insert (a);

            for (int i = 1; i <= n; ++ i) used[i] = false;

            int cnt = 0;
            dfs1 (1, cnt);
            if (cnt == n) {
                t.uni (a, b);
                answer.pb ({a, b});
            } else {
                if (g1[a].find (b) != g1[a].end()) g1[a].erase (b), g1[b].erase (a);
                else g1[a].insert (b), g1[b].insert (a);
            }
        }
        if (t.sz[t.get(1)] == n) break;

        bool whole = false;
        for (int i = 1; i <= n && !whole ; ++ i) {
            for (int j = i + 1; j <= n && !whole; ++ j) {
                if (g[i].find (j) != g[i].end() && t.get (i) == t.get (j)) {

                    g[j].erase (i);
                    g[i].erase (j);

                    for (int z = 0; z <= n; ++ z) used[z] = false;

                    int cnt = 0;
                    dfs (i, cnt);

                    if (cnt == t.sz [t.get (j)]) {
                        if (g1[i].find (j) != g1[i].end()) g1[j].erase (i), g1[i].erase (j);
                        else g1[i].insert (j), g1[i].insert (j);

                        for (int z = 1; z <= n; ++ z) used[z] = false;

                        int cnt = 0;
                        dfs1 (1, cnt);

                        if (cnt == n) {
                            whole = true;
                            answer.pb ({i, j});
                        } else {
                            if (g1[i].find (j) != g1[i].end()) g1[j].erase (i), g1[i].erase (j);
                            else g1[i].insert (j), g1[i].insert (j);

                            g[i].insert (j);
                            g[j].insert (i);
                        }

                    } else {
                        g[i].insert (j), g[j].insert (i);
                    }

                }
            }
        }

        if (!whole) break;

    }


    for (int i = 1; i <= n; ++ i) g[i].clear();
    for (int i = 1; i <= n; ++ i) g1[i].clear();
    if (sz(answer) > n) {
        cout << "No\n";
        return;
    }

    if (t.sz[t.get(1)] == n) {
        cout << "Yes\n";
        cout << sz(answer) << "\n";
        for (auto [a, b]: answer) {
            cout << a << " " << b << "\n";
        }
        return;
    }
    cout << "No\n";
}

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> tt >> gr;
    while (tt --) {
        solve ();
    }

    return 0;
}
