#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x).size()

const int N= 3005;
vector<int>gr1[N], gr2[N];
int r[N], p[N], used[N];

int conn[N][N];

void dfs(int v){
    used[v] = 1;
    //cout << v << endl;
    for(int u : gr2[v]){
        if(used[u])
            continue;
        conn[v][u] = conn[u][v] = 1;
        dfs(u);
    }
}


int get(int x){
    return (x == p[x] ? x : p[x] = get(p[x]));
}

int unite(int v, int u){
    v = get(v);
    u = get(u);
    if(u == v)
        return 0;
    if(r[u] > r[v])
        swap(u, v);
    r[v] += r[u];
    p[u] = v;
    return 1;
}

void solve(){
    int n;
    cin >> n;

    fill(r, r + n, 1);
    iota(p, p + n, 0);
    fill(used, used + n, 0);
    for(int i =0; i < n; i++){
        gr1[i].clear();
        gr2[i].clear();
        for(int j = 0; j < n; j++){
            conn[i][j] = 0;
        }
    }
    int m1, m2;
    cin >> m1 >> m2;
    for(int i =0; i < m1; i++){
        int u, v;
        cin >> u >> v;
        u--,v--;
        unite(u,v);
        gr1[u].push_back(v);
        gr1[v].push_back(u);
    }

    for(int i =0; i < m2; i++){
        int u, v;
        cin >> u >> v;
        u--,v--;
        gr2[u].push_back(v);
        gr2[v].push_back(u);
    }

    dfs(0);
    vector<pair<int, int>>ans;

    for(int i = 0; i < n; i++){
        for(int j =0; j < n; j++){
            int I = get(i);
            int J = get(j);
            if(I != J && conn[i][j] == 0){
                unite(i, j);
                ans.push_back({i + 1, j + 1});
            }
        }
    }

    set<int>q;
    for(int i =0; i < n; i++){
        q.insert(get(i));
    }

    if(sz(q) == 1){
        cout << "Yes\n";
        cout << sz(ans) << '\n';
        for(auto [x, y] : ans){
            cout << x << ' ' << y << '\n';
        }
    }else{
        cout << "No\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0)->sync_with_stdio(false);
#endif
    int tt,g;
    cin >> tt >> g;
    while(tt--)
    solve();
    return 0;
}
