#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ll inf = 1e9;
vector<vector<int>> g;
vector<int> color;
vector<vector<int>> par;
vector<bool> used;
vector<int> p;
vector<int> sz;
int k;

void dfs(int v) {
    used[v] = true;
    color[v] = k;
    par[k].push_back(v);
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}

void unite(int v, int u) {
    v = get(v);
    u = get(u);
    if (u == v) {
        return;
    }
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    sz[u] += sz[v];
    p[v] = p[u];
}

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    color.assign(n, -1);
    par.clear();
    par.resize(n);
    g.clear();
    g.resize(n);
    used.assign(n, false);
    map<pii, int> used1, used2;
    vector<pii> a, b;
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
        a.push_back({u, v});
        used1[{u, v}]++;
        used1[{v, u}]++;
    }
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        b.push_back({u, v});
        used2[{u, v}]++;
        used2[{v, u}]++;
    }
    k = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            k++;
        }
    }
    p.resize(k); iota(all(p), 0);
    sz.assign(k, 1);
    int ost = n;
    vector<pii> ans;
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (get(i) == get(j)) {
                continue;
            }
            bool flag = false;
            for (auto k : par[i]) {
                for (auto z : par[j]) {

                    if (!used1[{k, z}] && !used2[{k, z}]) {
                        unite(i, j);
                        flag = true;
                        ans.push_back({k, z});
                        break;
                    }
                }
                if (flag) {
                    break;
                }
            }
        }
    }
    if (sz[p[0]] == k) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "No\n";
    }
}

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int tt, group; cin >> tt >> group;
    while (tt--) {
        solve();
    }
}
