#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ll inf = 1e9;
vector<vector<int>> g;
map<pii, bool> ostov;
vector<int> p;
vector<int> sz;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            ostov[{v, to}] = true;
            ostov[{to, v}] = true;
            dfs(to);
        }
    }
}

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    if (sz[a] < sz[b]) {
        swap(a, b);
    }
    sz[a] += sz[b];
    p[b] = p[a];
}

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    g.clear();
    ostov.clear();
    g.resize(n);
    used.assign(n, false);
    //map<pii, int> used1, used2;
    vector<pii> a, b;
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        a.push_back({u, v});
        //used1[{u, v}]++;
        //used1[{v, u}]++;
    }
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
        b.push_back({u, v});
        //used2[{u, v}]++;
        //used2[{v, u}]++;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    int ost = n;
    vector<pii> ans;
    p.resize(n); iota(all(p), 0);
    sz.assign(n, 1);
    for (auto i : a) {
        unite(i.first, i.second);
    }
    for (auto i : b) {
        if (!ostov[i] && get(i.first) != get(i.second)) {
            unite(i.first, i.second);
            ans.push_back({i.first, i.second});
        }
    }
    if (sz[p[0]] == n) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "No\n";
    }
}

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int tt, group; cin >> tt >> group;
    while (tt--) {
        solve();
    }
}
