#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ll inf = 1e9;
vector<vector<int>> g;
map<pii, bool> ostov;
vector<int> p;
vector<int> sz;
vector<bool> used;
int k;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            ostov[{v, to}] = true;
            ostov[{to, v}] = true;
            dfs(to);
        }
    }
}

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    if (sz[a] < sz[b]) {
        swap(a, b);
    }
    sz[a] += sz[b];
    p[b] = p[a];
}

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    g.clear();
    ostov.clear();
    g.resize(n);
    used.assign(n, false);
    map<pii, int> used1, used2;
    vector<pii> a, b;
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        a.push_back({u, v});
        used1[{u, v}]++;
        used1[{v, u}]++;
    }
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
        b.push_back({u, v});
        used2[{u, v}]++;
        used2[{v, u}]++;
    }
    int mmax = (n - 1) * n / 2;
    vector<pii> all_;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            all_.push_back({i, j});
        }
    }
    for (int mask = 0; mask < (1 << mmax); mask++) {
        if (__builtin_popcount(mask) > n) {
            continue;
        }
        vector<pii> q, w, cur;
        for (int i = 0; i < mmax; i++) {
            if ((1 << i) & mask) {
                if (!used1[all_[i]]) {
                    q.push_back(all_[i]);
                }
                if (!used2[all_[i]]) {
                    w.push_back(all_[i]);
                }
                cur.push_back(all_[i]);
            } else {
                if (used1[all_[i]]) {
                    q.push_back(all_[i]);
                }
                if (used2[all_[i]]) {
                    w.push_back(all_[i]);
                }
            }
        }
        g.clear();
        g.resize(n);
        for (auto i : q) {
            g[i.first].push_back(i.second);
            g[i.second].push_back(i.first);
        }
        used.assign(n, false);
        k = 0;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
                k++;
            }
        }
        if (k != 1) {
            continue;
        }
        g.clear();
        g.resize(n);
        for (auto i : w) {
            g[i.first].push_back(i.second);
            g[i.second].push_back(i.first);
        }
        used.assign(n, false);
        k = 0;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
                k++;
            }
        }
        if (k == 1) {
            cout << "Yes\n";
            cout << cur.size() << '\n';
            for (auto i : cur) {
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            return;
        }
    }
    cout << "No\n";
}

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int tt, group; cin >> tt >> group;
    while (tt--) {
        solve();
    }
}
