#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

int group;

void dfs(int v, vector<bool>& vis, vector<set<int>>& g) {
	vis[v] = 1;
	for (auto to : g[v]) {
		if (!vis[to]) {
			dfs(to, vis, g);
		}
	}
}

void dfsm(int v, int p, vector<bool>& vis, vector<int>& h, vector<int>& up, vector<set<int>>& g) {
	vis[v] = 1;
	up[v] = h[v];
	for (auto to : g[v]) {
		if (!vis[to]) {
			h[to] = h[v] + 1;
			dfsm(to, v, vis, h, up, g);
		}
		if (to != p) {
			up[v] = min(up[v], up[to]);
		}
	}
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	vector<set<int>> g1(n), g2(n);
	for (int i = 0; i < m1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g1[u].insert(v);
		g1[v].insert(u);
	}
	for (int i = 0; i < m2; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g2[u].insert(v);
		g2[v].insert(u);
	}
	vector<bool> used(n);
	dfs(0, used, g1);
	vector<int> h(n), up(n);
	vector<bool> used2(n);
	dfsm(0, -1, used2, h, up, g2);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (used[i] || !used[j]) {
				continue;
			}
			if (g2[i].find(j) == g2[i].end()) {
				cout << "Yes\n1\n";
				cout << i + 1 << ' ' << j + 1 << '\n';
				return;
			}

			if (h[i] < h[j] && up[i] != h[i] || h[i] > h[j] && up[j] != h[j]) {
				cout << "Yes\n1\n";
				cout << i + 1 << ' ' << j + 1 << '\n';
				return;
			}
		}
	}
	cout << "No\n";
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t >> group;
	while (t--) {
		solve();
	}
	return 0;
}