#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

int group;

vector<int> par, sz;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u == v) return;
	par[u] = v;
	sz[v] += sz[u];
}

bool rec(vector<set<int>> g1, vector<set<int>> g2, int it, int n, vector<pair<int, int>> h) {
	par.resize(n);
	sz.resize(n);
	for (int i = 0; i < n; i++) {
		par[i] = i;
		sz[i] = 1;
	}
	for (int i = 0; i < n; i++) {
		for (auto j : g1[i]) {
			unite(i, j);
		}
	}
	if (sz[find(0)] == n) {
		cout << "Yes\n";
		cout << it << '\n';
		for (auto i : h) {
			cout << i.first + 1 << ' ' << i.second + 1 << '\n';
		}
		return 1;
	}
	if (it == n) {
		return 0;
	}
	for (int i = 0; i < n;i++) {
		for (int j = i + 1; j < n; j++) {
			auto g11 = g1;
			auto g21 = g2;
			if (g1[i].find(j) == g1[i].end()) {
				g11[i].insert(j);
				g11[j].insert(i);
			}
			else {
				g11[i].erase(j);
				g11[j].erase(i);
			}
			if (g2[i].find(j) == g2[i].end()) {
				g21[i].insert(j);
				g21[j].insert(i);
			}
			else {
				g21[i].erase(j);
				g21[j].erase(i);
			}
			par.resize(n);
			sz.resize(n);
			for (int i = 0; i < n; i++) {
				par[i] = i;
				sz[i] = 1;
			}
			for (int i = 0; i < n; i++) {
				for (auto j : g21[i]) {
					unite(i, j);
				}
			}
			if (sz[find(0)] == n) {
				h.push_back({ i, j });
				if (rec(g11, g21, it + 1, n, h)) return 1;
				h.pop_back();
			}

		}
	}
	return 0;
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	if (group == 2) {
		par.resize(n);
		sz.resize(n);
		for (int i = 0; i < n; i++) {
			par[i] = i;
		}
		vector<set<int>> g1(n), g2(n);
		for (int i = 0; i < m1; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			g1[u].insert(v);
			g1[v].insert(u);
			unite(u, v);
		}
		for (int i = 0; i < m2; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			g2[u].insert(v);
			g2[v].insert(u);
		}
		if (n == 3 && m1 == 0) {
			cout << "No\n";
			return;
		}
		cout << "Yes\n";
		vector<pair<int, int>> ans;
		for (int i = 0; i < n - 1; i++) {
			if (find(i) != find(i + 1)) {
				ans.push_back({ i + 1, i + 2 });
				unite(i, i + 1);
			}
		}
		cout << ans.size() << '\n';
		for (auto [i, j] : ans) {
			cout << i << ' ' << j << '\n';
		}
		return;
	}
	vector<set<int>> g1(n), g2(n);
	for (int i = 0; i < m1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g1[u].insert(v);
		g1[v].insert(u);
	}
	for (int i = 0; i < m2; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g2[u].insert(v);
		g2[v].insert(u);
	}
	if (!rec(g1, g2, 0, n, {})) {
		cout << "No\n";
	}
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t >> group;
	while (t--) {
		solve();
	}
	return 0;
}