#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

const int N = 300'010;

set<pair<int, int>> g1;
set<pair<int, int>> g2s;
vector<int> g2[N];
vector<int> g3[N];

bool used[N];

int leaf;

void precount() {
	leaf = -1;
	g1.clear();
	for (int i = 0; i < N; ++i) {
		g2[i].clear();
		g3[i].clear();
		used[i] = 0;
	}
}

void dfs(int v) {
	used[v] = 1;
	int tmp = 0;
	for (auto u : g2[v]) {
		if (used[u]) continue;
		++tmp;
		g3[v].emplace_back(u);
		g3[u].emplace_back(v);
		dfs(u);
	}
	if (tmp == 0) leaf = v;
}

bool contains1(int u, int v) {
	if (u > v) swap(u, v);
	return g1.count(make_pair(u, v));
}

bool contains2(int u, int v) {
	if (u > v) swap(u, v);
	return g2s.count(make_pair(u, v));
}

void solve() {
	precount();
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	for (int i = 0; i < m1; ++i) {
		int u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		g1.insert(make_pair(u - 1, v - 1));
	}
	for (int i = 0; i < m2; ++i) {
		int u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		g2s.insert(make_pair(u, v));
		g2[u - 1].emplace_back(v - 1);
		g2[v - 1].emplace_back(u - 1); 
	}
	if (n <= 3) {
		cout << "No\n";
		return;
	}

	dfs(0); // now v_0 is root (g3)
	
	int nr = g3[leaf][0];

	int tmp1 = (g3[nr][0] == leaf ? g3[nr][1] : g3[nr][0]);
	int tmp2 = -1;

	vector<pair<int, int>> ans;
	
	for (int v = 0; v < n; ++v) {
		if (v == leaf || v == nr) continue;
		if (!contains1(v, leaf)) {
			ans.emplace_back(v, leaf); 
		}
		if (tmp2 == -1 && v != tmp1) tmp2 = v;
	}

	if (!contains2(tmp1, tmp2)) {
		ans.emplace_back(tmp1, tmp2);
	}

	if (!contains1(nr, tmp2)) {
		ans.emplace_back(nr, tmp2);
	}

	cout << "Yes\n";
	cout << ans.size() << '\n';
	for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
}

signed main() {
	FastIO;
	int t, gr;
	cin >> t >> gr;
	while (t--) {
		solve();
	}
	return 0;
}


