#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

int p[MAXN], sz[MAXN];

int get(int v) {
    return (p[v] == v ? v : p[v] = get(p[v]));
}

set<int> comp;
void merge(int a, int b) {
    a = get(a); b = get(b);
    if (a == b)
        return;
    comp.erase(b);
    sz[a] += sz[b];
    p[b] = a;
}

vector<pii> ans;
set<pii> g1, g2;

void change(int a, int b) {
    if (a > b)
        swap(a, b);
    ans.push_back({ a + 1, b + 1 });
    if (g1.find({ a, b }) != g1.end())
        g1.erase({ a, b });
    else
        g1.insert({ a, b });
    if (g2.find({ a, b }) != g2.end())
        g2.erase({ a, b });
    else
        g2.insert({ a, b });
}

bool check_ed(int a, int b) {
    if (a > b)
        swap(a, b);
    return g2.find({ a, b }) != g2.end();
}

void print() {
    cout << "Yes\n" << ans.size() << '\n';
    for (pii p : ans) {
        cout << p.F << ' ' << p.S << '\n';
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    iota(p, p + n, 0);
    fill(sz, sz + n, 1);
    g1.clear();
    g2.clear();
    comp.clear();
    ans.clear();
    for (int i = 0; i < n; i++)
        comp.insert(i);

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        g1.insert({ a, b });
        merge(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        g2.insert({ a, b });
    }
    if (comp.size() == 1) {
        cout << "Yes\n0\n";
        return;
    }
    while (comp.size() >= 3) {
        int a = *comp.begin(), b = *next(comp.begin()), c = *next(next(comp.begin()));
        if (!check_ed(a, b)) {
            change(a, b);
            merge(a, b);
        } else if (!check_ed(b, c)) {
            change(b, c);
            merge(b, c);
        } else {
            change(a, c);
            merge(a, c);
        }
    }
    int a = *comp.begin(), b = *next(comp.begin());
    if (sz[a] == 1 || sz[b] == 1) {
        if (sz[b] == 1)
            swap(a, b);
        for (int i = 0; i < n; i++) {
            if (i == a)
                continue;
            if (!check_ed(a, i)) {
                change(a, i);
                print();
                return;
            }
        }
        if (g2.size() != n - 1) {
            for (pii p : g2) {
                if (p.F != a && p.S != a) {
                    change(a, p.F);
                    print();
                    return;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (i == a || j == a)
                    continue;
                if (g1.find({ i, j }) == g1.end()) {
                    change(i, j);
                    change(a, i);
                    print();
                    return;
                }
            }
        }
        if (n - 1 >= 3) {
            change((a + 1) % n, (a + 2) % n);
            change(a, (a + 1) % n);
            print();
            return;
        }
        cout << "No\n"; // говно
        // cumming
    } else {
        int ua = a, ub = b, va = -1, vb = -1;
        for (int i = 0; i < n; i++) {
            if (i == a || i == b)
                continue;
            if (get(i) == a)
                va = i;
            else
                vb = i;
        }
        if (!check_ed(ua, ub)) {
            change(ua, ub);
        } else if (!check_ed(ua, vb)) {
            change(ua, vb);
        } else if (!check_ed(va, ub)) {
            change(va, ub);
        } else {
            change(va, vb);
        }
        print();
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    
    return 0;
}
