#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;

vector<bool> used;

void dfs(int v, vector<vector<bool>> &g) {
    used[v] = true;
    int n = g.size();
    for (int j = 0; j < n; ++j) {
        if (!used[j] && g[v][j]) dfs(j, g);
    }
}

void solve(int g) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<bool>> gb(n, vector<bool>(n));
    vector<vector<bool>> gc(n, vector<bool>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gb[u][v] = true;
        gb[v][u] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gc[u][v] = true;
        gc[v][u] = true;
    }
    if (g <= 1) {
        int all = n * (n - 1) / 2;
        vector<pair<int, int>> edges;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                edges.emplace_back(j, i);
            }
        }
        for (int j = 0; j < (1 << all); ++j) {
            vector<vector<bool>> gbb = gb;
            vector<vector<bool>> gcc = gc;
            int d = 0;
            for (int k = 0; k < all; ++k) {
                if (j & (1 << k)) {
                    d++;
                    auto [u, v] = edges[k];
                    gbb[u][v] = !gbb[u][v];
                    gcc[u][v] = !gcc[u][v];
                    gbb[v][u] = !gbb[v][u];
                    gcc[v][u] = !gcc[v][u];
                }
            }
            if (d <= n) {
                int cnt = 0;
                used.assign(n, false);
                for (int i = 0; i < n; ++i) {
                    if (!used[i]) {
                        dfs(i, gbb);
                        cnt++;
                    }
                }
                used.assign(n, false);
                for (int i = 0; i < n; ++i) {
                    if (!used[i]) {
                        dfs(i, gcc);
                        cnt++;
                    }
                }
                if (cnt == 2) {
                    cout << "Yes\n";
                    vector<pair<int, int>> ans;
                    for (int k = 0; k < all; ++k) {
                        if (j & (1 << k)) ans.push_back(edges[k]);
                    }
                    cout << ans.size() << "\n";
                    for (auto [a, b]: ans) cout << a + 1 << " " << b + 1 << "\n";
                    return;
                }
            }
        }
        cout << "No\n";
    }
    if (g == 5) {
        vector<pair<int, int>> ans;
        bool x = false;
        for (int i = 1; i < n - 1; ++i) {
            if (!gb[i][i + 1]) ans.push_back({i, i + 1});
            if (gb[0][i]) x = true;
        }
        if (!x) ans.push_back({0, 1});
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [a, b]: ans) cout << a + 1 << " " << b + 1 << "\n";
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1, g = 0;
    cin >> t >> g;
    while (t--) solve(g);
}
