#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;


void solve(int g) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<bool>> gb(n, vector<bool>(n));
    vector<vector<bool>> gc(n, vector<bool>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gb[u][v] = true;
        gb[v][u] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gc[u][v] = true;
        gc[v][u] = true;
    }
    vector<pair<int, int>> ans;
    for (int i = 2; i < n; ++i) {
        if (!gb[0][i] && !gb[1][i]) {
            if (gc[0][i]) ans.push_back({1, i});
            else ans.push_back({0, i});
        }
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto [u, v]: ans) cout << u + 1 << " " << v + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1, g;
    cin >> t >> g;
    while (t--) solve(g);
}
