#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 310000;
const int C = 4;

bool used[N], mt1[C][C], mt2[C][C];
int t, g, n, m1, m2, comp_cnt;
vector<int> g1[N], g2[N], comp[N];
set<pair<int, int>> st1, st2;
vector<pair<int, int>> ans;

void dfs(int v) {
	used[v] = true;
	comp[comp_cnt].push_back(v);
	for (int u : g1[v])
		if (!used[u])
			dfs(u);
}

void swt(int i, int j) {
	ans.push_back({i, j});
	if (st2.find({i, j}) != st2.end()) {
		st2.erase({i, j});
		st2.erase({j, i});
	} else {
		st2.insert({i, j});
		st2.insert({j, i});
	}
	if (st1.find({i, j}) != st1.end()) {
		st1.erase({i, j});
		st1.erase({j, i});
	} else {
		st1.insert({i, j});
		st1.insert({j, i});
	}
}

// c1.size() >= 2; c2.size() >= 2; or c1.size() == 0; or c2.size() == 0; count = 1;
int merge_comps(vector<int> &c1, vector<int>& c2) {
	if (c1.empty()) return -1;
	if (c2.empty()) return -1;
	for (int a : c1)
	for (int b : c2) {
		if (st2.count({a, b})) continue;
		swt(a, b);
		return b;
	}
	swt(c1[0], c2[0]);
	return c2[0];
}

// vert.size() >= 4; count = vert.size() - 1;
void solve_strong(vector<int> &vert) {
	for (int i = 2; i < (int) vert.size(); i++)
		swt(vert[0], vert[i]);
	swt(vert[1], vert[2]);
}

void test_case() {
	cin >> n >> m1 >> m2;
	st1.clear();
	st2.clear();
	for (int i = 1; i <= n; i++) {
		g1[i].clear();
		g2[i].clear();
		comp[i].clear();
		used[i] = false;
	}
	for (int i = 1; i <= m1; i++) {
		int u, v; cin >> u >> v;
		g1[u].push_back(v);
		g1[v].push_back(u);
		st1.insert({u, v});
		st1.insert({v, u});
	}
	for (int i = 1; i <= m2; i++) {
		int u, v; cin >> u >> v;
		g2[u].push_back(v);
		g2[v].push_back(u);
		st2.insert({u, v});
		st2.insert({v, u});
	}
	ans.clear();
	comp_cnt = 0;
	for (int i = 1; i <= n; i++) {
		if (used[i]) continue;
		comp_cnt++;
		dfs(i);
	}
	vector<int> good_comps;
	set<int> bad_comps;
	for (int i = 1; i <= comp_cnt; i++)
		if ((int) comp[i].size() == 1)
			bad_comps.insert(comp[i][0]);
		else good_comps.push_back(i);
	vector<int> big_comp;
	for (int cc : good_comps) {
		merge_comps(big_comp, comp[cc]);
		for (int x : comp[cc])
			big_comp.push_back(x);
	}
	vector<int> nbad_comps;
	while (!bad_comps.empty()) {
		int v = *bad_comps.begin();
		bad_comps.erase(bad_comps.begin());
		int good = -1;
		for (int u : bad_comps) {
			if (st2.count({v, u})) continue;
			swt(v, u);
			vector<int> ncomp = {v, u};
			merge_comps(big_comp, ncomp);
			for (int x : ncomp)
				big_comp.push_back(x);
			good = u;
			break;
		}
		if (good != -1) bad_comps.erase(good);
		else nbad_comps.push_back(v);
	}
	if ((int) nbad_comps.size() == 3 && big_comp.empty()) {
		cout << "No\n";
		return;
	} else if ((int) nbad_comps.size() >= 4) {
		solve_strong(nbad_comps);
		merge_comps(big_comp, nbad_comps);
	} else if (!nbad_comps.empty()) {
		while ((int) nbad_comps.size() > 1) {
			vector<int> vals = {nbad_comps[0], nbad_comps[1]};
			int v = merge_comps(big_comp, vals);
			big_comp.push_back(v);
			if (v == nbad_comps[0]) nbad_comps.erase(nbad_comps.begin() + 0);
			if (v == nbad_comps[1]) nbad_comps.erase(nbad_comps.begin() + 1);
		}
		int v = nbad_comps[0];
		bool good = false;
		for (int i = 1; i <= n; i++) {
			if (i == v) continue;
			if (st2.count({i, v})) continue;
			ans.push_back({i, v});
			good = true;
			break;
		}
		if (!good) {
			for (auto [a, b] : st2) {
				if (a == v || b == v) continue;
				ans.push_back({a, v});
				good = true;
				break;
			}
			if (!good) {
				for (int i = 1; i <= n && !good; i++) if (i != v)
				for (int j = 1; j <= n && !good; j++) if (j != v && j != i) {
					if (st1.count({i, j})) continue;
					ans.push_back({i, j});
					ans.push_back({i, v});
					good = true;
				}
				if (!good) {
					int i = 1;
					while (i == v) i++;
					int j = 1;
					while (j == v || j == i) j++;
					ans.push_back({i, j});
					ans.push_back({i, v});
				}
			}
		}
	}
	cout << "Yes\n";
	cout << (int) ans.size() << '\n';
	for (auto [x, y] : ans)
		cout << x << ' ' << y << '\n';
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> t >> g;
	while (t--) test_case();
}
