#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct dsu {
	vector<int> par;
	dsu(int n) {
		par.resize(n);
		for (int i = 0; i < n; i++) {
			par[i] = i;
		}
	}
	int find_set(int v) {
		if (v == par[v]) {
			return v;
		} else {
			return par[v] = find_set(par[v]);
		}
	}
	bool union_set(int a, int b) {
		a = find_set(a);
		b = find_set(b);
		if (a == b) {
			return 0;
		}
		par[b] = a;
		return 1;
	}
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t, g;
	cin >> t >> g;
	while (t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		vector<vector<bool>> edge1(n, vector<bool>(n)), edge2(n, vector<bool>(n));
		for (int i = 0; i < m1; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			edge1[a][b] = edge1[b][a] = 1;
		}
		dsu kek(n);
		for (int i = 0; i < m2; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			if (kek.union_set(a, b)) {
				edge2[a][b] = edge2[b][a] = 1;
			}
		}
		dsu d(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (edge1[i][j] || !edge2[i][j]) {
					d.union_set(i, j);
				}
			}
		}
		set<int> st;
		for (int i = 0; i < n; i++) {
			st.insert(d.find_set(i));
		}
		if (st.size() == 1) {
			cout << "Yes\n";
			dsu d2(n);
			vector<pair<int, int>> ans;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (edge1[i][j]) {
						d2.union_set(i, j);
					}
				}
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (!edge2[i][j]) {
						if (d2.union_set(i, j)) {
							ans.pb({i, j});
						}
					}
				}
			}
			cout << ans.size() << endl;
			for (auto [a, b] : ans) {
				cout << a + 1 << ' ' << b + 1 << endl;
			}
		} else {
			cout << "No\n";
		}
	}
	return 0;
}