// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

int group;
int n;

vector<vector<int>> g[2];

int iter = 0;
vector<int> used;

int dfs(int v, int t) {
    int res = 1;
    used[v] = iter;
    for (int j = 0; j < n; ++j) {
        if (used[j] != iter && g[t][v][j]) {
            res += dfs(j, t);
        }
    }
    return res;
}

bool isGood(int t) {
    ++iter;
    return dfs(0, t) == n;
}

void solve1() {
    int m1, m2;
    cin >> n >> m1 >> m2;

    vector<pii> edges;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            edges.pb({i, j});

    g[0].assign(n, vector<int>(n, 0));
    g[1].assign(n, vector<int>(n, 0));
    used.assign(n, 0);

    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[0][v][u] = 1;
        g[0][u][v] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[1][v][u] = 1;
        g[1][u][v] = 1;
    }

    int maxM = n * (n - 1) / 2;

    vector<pii> res;
    for (int mask = 0; mask < (1 << maxM); ++mask) {
        if (__builtin_popcount(mask) > n) continue;

        res.clear();
        for (int i = 0; i < maxM; ++i) {
            if (mask & (1 << i)) {
                res.pb({g[1][edges[i].ff][edges[i].sc], i});
            }
        }
        sort(all(res));

        for (auto [lol, id] : res) {
            auto [v, u] = edges[id];
            g[0][v][u] ^= 1;
            g[0][u][v] ^= 1;
            g[1][v][u] ^= 1;
            g[1][u][v] ^= 1;
        }

        if (isGood(1) && isGood(0)) {
            cout << "Yes\n";
            cout << sz(res) << '\n';
            for (auto [lol, id] : res) {
                cout << edges[id].ff + 1 << ' ' << edges[id].sc + 1 << '\n';
            }
            return;
        }

        for (auto [lol, id] : res) {
            auto [v, u] = edges[id];
            g[0][v][u] ^= 1;
            g[0][u][v] ^= 1;
            g[1][v][u] ^= 1;
            g[1][u][v] ^= 1;
        }
    }
    cout << "No\n"; 

    // нужно провести 1 ребро между компонентами связности
}

void solve2() {
    int m1, m2;
    cin >> n >> m1 >> m2;

    g[0].assign(n, vector<int>(n, 0));
    g[1].assign(n, vector<int>(n, 0));
    used.assign(n, 0);

    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[0][v][u] = 1;
        g[0][u][v] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[1][v][u] = 1;
        g[1][u][v] = 1;
    }

    if (n == 3 && m1 == 0) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";

    vector<pii> res;

    int cnt = 0;
    for (int i = 1; i < n && cnt < n - 2; ++i)
        if (!g[0][0][i]) {
            res.pb({1, i + 1});
            ++cnt;
            g[0][0][i] ^= 1;
            g[0][i][0] ^= 1;
            g[1][0][i] ^= 1;
            g[1][i][0] ^= 1;
        }
    
    if (!isGood(0))
        res.pb({2, n});
    // if (!isGood(0) || !isGood(1)) assert(false);
    cout << sz(res) << '\n';
    for (auto el : res) cout << el << '\n';
}

vector<int> c;

void col(int v) {
    c[v] = 0;
    for (int to = 0; to < n; ++to)
        if (g[0][v][to] && c[to] == 1)
            col(to);
}

// void solve3() {
//     int m1, m2;
//     cin >> n >> m1 >> m2;

//     g[0].assign(n, vector<int>(n, 0));
//     g[1].assign(n, vector<int>(n, 0));
//     used.assign(n, 0);

//     for (int i = 0; i < m1; ++i) {
//         int v, u;
//         cin >> v >> u;
//         --v; --u;
//         g[0][v][u] = 1;
//         g[0][u][v] = 1;
//     }
//     for (int i = 0; i < m2; ++i) {
//         int v, u;
//         cin >> v >> u;
//         --v; --u;
//         g[1][v][u] = 1;
//         g[1][u][v] = 1;
//     }

//     c.assign(n, 1);

//     col(0);

//     vector<int> cmp[2];

//     for (int i = 0; i < n; ++i) {
//         cmp[c[i]].pb(i);
//     }
//     if (sz(cmp[0]) > sz(cmp[1])) swap(cmp[0], cmp[1]);

//     for (auto v : cmp[0]) {
//         for (auto to : cmp[1]) {
//             if (m2 == (n * (n - 1) / 2) || !g[1][v][to]) {
//                 cout << "Yes\n1\n";
//                 cout << v + 1 << " " << to + 1;
//                 return;
//             }
//         }
//     }
//     // if (sz(cmp[0]) != 1) assert(false);

//     vector<int> ord();

//     int flag = -1;
//     for (int i = 0; i < sz(cmp[1]); ++i) {
//         for (int j = i + 1; j < sz(cmp[1]); ++j)
//             if (!g[1][cmp[1][i]][cmp[1][j]] && !g[1][cmp[1][i]][cmp[1][j]]) {
                
//                 flag = i;
//                 break;
//             }
//         if (flag != -1)
//             break;
//     }

// }

void solve4() {
    int m1, m2;
    cin >> n >> m1 >> m2;

    g[0].assign(n, vector<int>(n, 0));
    g[1].assign(n, vector<int>(n, 0));
    used.assign(n, 0);

    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[0][v][u] = 1;
        g[0][u][v] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[1][v][u] = 1;
        g[1][u][v] = 1;
    }

    cout << "Yes\n";

    vector<pii> res;

    for (int i = 2; i < n; ++i) {
        if (!g[0][0][i]) {
            res.pb({1, i + 1});
        }
    }
    if (!g[0][1][n - 1])
        res.pb({2, n});
    cout << sz(res) << '\n';
    for (auto el : res) cout << el << '\n';
}


signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int t;
    cin >> t >> group;
    while (t--) {
        if (group <= 1)
            solve1();
        else if (group == 2)
            solve2();
        else
            solve4();
    }

    return 0;
}
