#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e9;

vector<vector<bool>> g1, g2;
vector<int> p1, p2, sz1, sz2;

int up1(int v) {
    if (p1[v] == v) return v;
    return p1[v] = up1(p1[v]);
}

void unite1(int v, int u) {
    v = up1(v), u = up1(u);
    if (v == u) return;
    if (sz1[v] > sz1[u]) swap(v, u);
    p1[v] = u;
    sz1[u] += sz1[v];
}

int up2(int v) {
    if (p2[v] == v) return v;
    return p2[v] = up2(p2[v]);
}

void unite2(int v, int u) {
    v = up2(v), u = up2(u);
    if (v == u) return;
    if (sz2[v] > sz2[u]) swap(v, u);
    p2[v] = u;
    sz2[u] += sz2[v];
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    p1.resize(n);
    iota(all(p1), 0);
    sz1.assign(n, 1);
    p2.resize(n);
    iota(all(p2), 0);
    sz2.assign(n, 1);
    g1.assign(n, vector<bool>(n, false));
    g2.assign(n, vector<bool>(n, false));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u - 1][v - 1] = true;
        g1[v - 1][u - 1] = true;
        unite1(u - 1, v - 1);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        g2[u - 1][v - 1] = true;
        g2[v - 1][u - 1] = true;
        unite2(u - 1, v - 1);
    }
    vector<pii> ans;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (up1(i) != up1(j)) {
                ans.push_back({i + 1, j + 1});
                unite1(i, j);
                unite2(i, j);
            }
        }
    }
    if (sz1[up1(0)] != n) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v] : ans) {
            cout << u << " " << v << "\n";
        }
    }
}

int main() {
    int tests, group;
    cin >> tests >> group;
    while (tests--) {
        solve();
    }
}

