#include<bits/stdc++.h>

using namespace std;

using ll = long long;

void dfs(int v, int p, vector<vector<int>> &g, set<pair<int, int>> &bridge, vector<int> &up, vector<int> &d, vector<int> &used) {
    up[v] = d[v] = d[p] + 1;
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        if (!used[u]) {
            dfs(u, v, g, bridge, up, d, used);
            up[v] = min(up[u], up[v]);
        } else {
            up[v] = min(up[v], d[u]);
        }
        if (up[u] > d[v])
            bridge.insert({min(v, u), max(v, u)});
    }
}

void dfs1(int v, vector<vector<int>> &g, set<int> &comp, vector<int> &used) {
    used[v] = 1;
    comp.insert(v);
    for (auto u : g[v]) {
        if (!used[u])
            dfs1(u, g, comp, used);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t, x;
    cin >> t >> x;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<vector<int>> g1(n), g2(n);
        for (int i = 0; i < m1; ++i) {
            int v, u;
            cin >> v >> u;
            v--; u--;
            g1[v].push_back(u);
            g1[u].push_back(v);
        }
        for (int i = 0; i < m2; ++i) {
            int v, u;
            cin >> v >> u;
            v--; u--;
            g2[v].push_back(u);
            g2[u].push_back(v);
        }
        set<pair<int, int>> bridge;
        vector<int> up(n), d(n, -1), used(n), used1(n);
        dfs(0, 0, g2, bridge, up, d, used);
        set<int> comp1, comp2;
        dfs1(0, g1, comp1, used1);
        for (int i = 0; i < n; ++i) {
            if (comp1.find(i) == comp1.end()) {
                comp2.insert(i);
            }
        }
        string ans = "No";
        if (comp1.size() == 0 || comp2.size() == 0) {
            cout << "Yes\n" << 0 << "\n";
            continue;
        }
        int v, u;
        for (auto el : comp1) {
            if (ans == "Yes")
                break;
            for (auto e : comp2) {
                if (bridge.find({min(el, e), max(el, e)}) == bridge.end()) {
                    ans = "Yes";
                    v = el;
                    u = e;
                    break;
                }
            }
        }
        cout << ans << "\n";
        if (ans == "Yes") {
            cout << 1 << "\n";
            cout << v + 1 << " " << u + 1 << "\n";
        }
    }
}


