#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long inf = 1e18;
constexpr long long A = 26;
constexpr double eps = 1e-9;

int p[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

int unite(int a, int b) {
    a = get(a); b = get(b);
    if (a == b) return 0;
    if (rng() & 1) p[a] = b;
    else p[b] = a;
    return 1;
}

void solve(int g) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    for (int i = 0; i < n; i++) p[i] = i;

    vector<vector<int>> g1(n, vector<int> (n, 0));
    vector<vector<int>> g2(n, vector<int> (n, 0));

    // vector<vector<int>> a1, a2;

    

    if (g == 2) {
        for (int i = 0; i < m1; i++) {
            int u, v; cin >> u >> v; u--;--v;
            g1[u][v] = 1; g1[v][u] = 1;
            unite(u, v);
        }

        for (int i = 0; i < m2; i++) {
            int u, v; cin >> u >> v; u--;--v;
            g2[u][v] = 1; g2[v][u] = 1;
        }

        vector<vector<int>> cps;
        vector<int> used(n, 0);
        auto dfs1 = [&](auto dfs, int v) -> void {
            used[v] = 1;
            cps.back().push_back(v);
            for (int to : g1[v]) {
                if (!used[to]) {
                    dfs(dfs, to);
                }
            }
        };
        for (int v = 0; v < n; v++) {
            if (!used[v]) {
                cps.push_back(vector<int> (0));
                dfs1(dfs1, v);
            }
        }

        vector<pair<int, int>> ans;

        vector<int> nb(n, 0);
        for (int i = 0; i < n; i++) {
            nb[i] = count(g2[i].begin(), g2[i].end(), 1);
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (get(i) == get(j)) continue;

                if (!g1[i][j] && !g2[i][j]) {
                    ans.push_back({i, j});
                    unite(i, j);
                } else if (!g1[i][j] && nb[i] > 1 && nb[j] > 1) {
                    nb[i]--; nb[j]--;
                    unite(i, j);
                    ans.push_back({i, j});
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (get(i) != get(0)) {
                cout << "No" << endl;
                return;
            }
        }
        cout << "Yes" << endl;
        cout << ans.size() << endl;
        for (auto [u, v] : ans) cout << u + 1 << " " << v + 1 << endl;
    } else {
        for (int i = 0; i < m1; i++) {
            int u, v; cin >> u >> v; u--;--v;
            g1[u][v] = 1; g1[v][u] = 1;
            unite(u, v);
        }

        for (int i = 0; i < m2; i++) {
            int u, v; cin >> u >> v; u--;--v;
            g2[u][v] = 1; g2[v][u] = 1;
        }

        vector<int> nb(n, 0);
        for (int i = 0; i < n; i++) {
            nb[i] = count(g2[i].begin(), g2[i].end(), 1);
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (get(i) == get(j)) continue;

                if (!g1[i][j] && !g2[i][j]) {
                    cout << "Yes" << endl;
                    cout << 1 << endl;
                    cout << i + 1 << " " << j + 1 << endl;
                    return;
                } else if (!g1[i][j] && nb[i] > 1 && nb[j] > 1) {
                    cout << "Yes" << endl;
                    cout << 1 << endl;
                    cout << i + 1 << " "  << j + 1 << endl;
                    return;
                }
            }
        }

        pair<int, int> tg = {-1, -1};
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (get(i) != get(j)) {
                    tg = {i, j};
                    break;
                }
            }
            if (tg.first != -1) break;
        }
        int tg1 = -1, tg2 = -1;
        for (int i = 0; i < n; i++) {
            if (!g2[tg.first][i] && tg.first != i) {
                tg1 = i;
            }
            if (!g2[tg.second][i] && tg.second != i) {
                tg2 = i;
            }
        }

        if (tg.first == -1) {
            cout << "No" << endl;
            return;
        }

        if (tg.first == -1 || (tg1 == -1 && nb[tg.first] == 1) || (tg2 == -1 && nb[tg.second] == 1)) {
            cout << "No" << endl;
        } else {
            cout << "Yes" << endl;
            vector<pair<int, int>> ans;
            if (tg1 != -1) {
                ans.push_back({tg.first, tg1});
            }
            if (tg2 != -1) {
                ans.push_back({tg.second, tg2});
            }
            ans.push_back(tg);

            cout << ans.size() << endl;
            for (auto [u, v] : ans) cout << u + 1 << " " << v + 1 << endl;
        }

        

        // for (int i = 0; i < n; i++) {

        // }
    }
}

signed main() {
    int g, tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests >> g;

    while (tests --> 0) solve(g);
}