#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;
int n, m1, m2, used;

int dfs(vector<vector<bool>> &g, int u) {
    used ^= 1 << u;
    int result = 1;
    for (int v = 0; v < n; v++) {
        if (((used >> v) & 1) || !g[u][v]) {
            continue;
        }
        result += dfs(g, v);
    }
    return result;
}

bool is_connected(vector<vector<bool>> &g) {
    used = 0;
    return dfs(g, 0) == n;
}

void solve() {
    cin >> n >> m1 >> m2;
    vector<vector<bool>> g1(n, vector<bool>(n)), g2(n, vector<bool>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            g1[i][j] = g2[i][j] = false;
        }
    }
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g1[u][v] = g1[v][u] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g2[u][v] = g2[v][u] = true;
    }
    vector<pair<int, int>> E;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            E.emplace_back(i, j);
        }
    }
    vector<bool> dp(1 << E.size());
    vector<int> last(1 << E.size(), -1);
    dp[0] = true;
    for (int mask = 1; mask < (1 << E.size()); mask++) {
        for (int v = 0; v < E.size(); v++) {
            if (((mask >> v) & 1) && dp[mask ^ (1 << v)]) {
                last[mask] = v;
                break;
            }
        }
        if (last[mask] != -1) {
            for (int i = 0; i < E.size(); i++) {
                if ((mask >> i) & 1) {
                    auto [u, v] = E[i];
                    g1[u][v] = g1[v][u] = !g1[u][v];
                    g2[u][v] = g2[v][u] = !g2[u][v];
                }
            }
            if (is_connected(g2)) {
                dp[mask] = true;
                if (is_connected(g1)) {
                    vector<pair<int, int>> ans;
                    while (mask) {
                        ans.push_back(E[last[mask]]);
                        mask ^= 1 << last[mask];
                    }
                    reverse(ans.begin(), ans.end());
                    cout << "Yes\n" << ans.size() << "\n";
                    for (auto [u, v]: ans) {
                        cout << u + 1 << " " << v + 1 << "\n";
                    }
                    return;
                }
            }
            for (int i = 0; i < E.size(); i++) {
                if ((mask >> i) & 1) {
                    auto [u, v] = E[i];
                    g1[u][v] = g1[v][u] = !g1[u][v];
                    g2[u][v] = g2[v][u] = !g2[u][v];
                }
            }
        }
    }
    cout << "No\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t, gr;
    cin >> t >> gr;
    while (t--) {
        solve();
    }
    return 0;
}