#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;

vector<vector<ll>> g1;
vector<vector<ll>> g2;
vector<ll> was;
ll col = 0;
map<pair<ll, ll>, ll> was1;

void dfs2(ll v, ll a, ll b) {
    was[v] = 1;
    col++;
    for(int i = 0; i < g2[v].size(); i++) {
        if ((v == a && b == g2[v][i]) || (v == b && a == g2[v][i])) continue;
        if (was1[{v, g2[v][i]}] == 1) continue;
        if (was[g2[v][i]] == 0) {
            dfs2(g2[v][i], a, b);
        }
    }
}

vector<ll> p;
vector<ll> sz;

ll get(ll v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

ll sum = 0;
void merge(ll a, ll b) {
    ll a1 = get(a), b1 = get(b);
    if (sz[b1] > sz[a1]) swap(a1, b1);
    if (a1 != b1) {
        sum++;
        p[b1] = a1;
        sz[a1] += sz[b1];
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t, g11; cin >> t >> g11;
    while(t--) {
        sum = 0;
        was1.clear();
        ll n, m1, m2; cin >> n >> m1 >> m2;
        g1.assign(n, {});
        g2.assign(n, {});
        was.assign(n, 0);
        p.assign(n, 0);
        sz.assign(n, 1);
        for(int i = 0; i < n; i++) p[i] = i;
        vector<pair<ll, ll>> k1;
        vector<pair<ll, ll>> k2;
        map<pair<ll, ll>, ll> mapa;
        vector<vector<ll>> v5;
        for(int i = 0; i < m1; i++) {
            ll a, b; cin >> a >> b;
            a--; b--;
            g1[a].push_back(b);
            g1[b].push_back(a);
            k1.push_back({a, b});
            if (get(a) == get(b) && v5.size() == 0) {
                g2[a].push_back(b);
                g2[b].push_back(a);
                k2.push_back({a, b});
                mapa[{a, b}] = 1;
                mapa[{b, a}] = 1;
                v5.push_back({a, b});
            } else {
                merge(a, b);
            }
        }
        for(int i = 0; i < m2; i++) {
            ll a, b; cin >> a >> b;
            a--; b--;
            g2[a].push_back(b);
            g2[b].push_back(a);
            k2.push_back({a, b});
            mapa[{a, b}] = 1;
            mapa[{b, a}] = 1;
        }
        for(int i = 0; i < n; i++) {
            for(int j = i + 1; j < n; j++) {
                if (mapa[{i, j}] == 0 && get(i) != get(j)) {
                    merge(i, j);
                    v5.push_back({i, j});
                }
            }
        }
        for(int i = 0; i < ll(k2.size()); i++) {
            fill(was.begin(), was.end(), 0);
            col = 0;
            dfs2(0, k2[i].first, k2[i].second);
            ll u1 = k2[i].first, u2 = k2[i].second;
            if (col == n && get(u1) != get(u2)) {
                merge(u1, u2);
                v5.push_back({u1, u2});
                was1[{u1, u2}] = 1;
                was1[{u2, u1}] = 1;
            }
        }
        if (sum != n - 1) {
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
        cout << v5.size() << "\n";
        for(int i = 0; i < v5.size(); i++) {
            cout << v5[i][0] + 1 << " " << v5[i][1] + 1 << "\n";
        }
    }
    return 0;
}
