#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

// #define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

vector<int> comp, comp_v;
vector<vector<int>> g;
int n, m1, m2, G, ct = 0;

void clear() {
    ct = 0;
    comp.clear();
    comp_v.clear();
    g.clear();
}

void resize() {
    comp.resize(n, -1);
    g.resize(n);
}

void dfs1(int v, int c) {
    comp[v] = c;
    comp_v[c] = v;
    for (const auto &u : g[v]) {
        if (comp[u] != -1) continue;
        dfs1(u, c);
    }
}

void solve() {
    clear();
    cin >> n >> m1 >> m2;
    resize();
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
    }
    assert(m2 == n * (n - 1) / 2);
    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) continue;
        comp_v.push_back(-1);
        dfs1(i, ct);
        ++ct;
    }
    cout << "Yes" << endl;
    vector<pii> ans;
    for (int i = 1; i < ct; ++i) {
        ans.push_back({comp_v[0], comp_v[i]});
    }
    assert(ans.size() < n);
    cout << ans.size() << endl;
    for (const auto &[a, b] : ans) {
        assert(a != -1 && b != -1);
        cout << a + 1 << " " << b + 1 << endl;
    }
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    // #ifdef ROMALOCAL
    // cout << "local run" << endl;
    // freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    // #endif

    int t;
    cin >> t >> G;

    while (t--) {
        solve();
    }

    return 0;
}