#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#include <set>
#include <unordered_set>
// #define fastio
#define _GLIBCXX_DEBUG


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

vector<int> comp, comp_v;
vector<vector<int>> g1, g2;
int n, m1, m2, G, ct = 0;

void clear() {
    ct = 0;
    comp.clear();
    comp_v.clear();
    g1.clear();
    g2.clear();
}

void resize() {
    comp.resize(n, -1);
    g1.resize(n);
}

void dfs1(int v, int c) {
    comp[v] = c;
    comp_v[c] = v;
    for (const auto &u : g1[v]) {
        if (comp[u] != -1) continue;
        dfs1(u, c);
    }
}

void solve2() {
    clear();
    cin >> n >> m1 >> m2;
    resize();
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
    }
    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) continue;
        comp_v.push_back(-1);
        dfs1(i, ct);
        ++ct;
    }
    if (n == 2 && m1 == 0) {
        cout << "No" << endl;
        return;
    } else if (n == 3 && m1 == 0) {
        cout << "No" << endl;
        return;
    }
    cout << "Yes" << endl;
    vector<pii> ans;
    for (int i = 0; i < ct - 1; ++i) {
        ans.push_back({comp_v[i], comp_v[i + 1]});
    }
    assert(ans.size() < n);
    cout << ans.size() << endl;
    for (const auto &[a, b] : ans) {
        assert(a != -1 && b != -1);
        cout << a + 1 << " " << b + 1 << endl;
    }
}

void dfs2(const vector<vector<int>> &g, vector<bool> &used, int v) {
    used[v] = true;
    for (const auto &u : g[v]) {
        if (used[u]) continue;
        dfs2(g, used, u);
    }
}

bool check(const vector<vector<int>> &g) {
    vector<bool> used(n, false);
    dfs2(g, used, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) return false;
    }
    return true;
}

void solve1() {
    cin >> n >> m1 >> m2;
    unordered_set<int> e1, e2;
    vector<pii> edges;
        int m = n * (n - 1) / 2;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.push_back({i, j});
        }
    }
    assert(edges.size() == m);

    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a > b) swap(a, b);
        int x = find(edges.begin(), edges.end(), make_pair(a, b)) - edges.begin();
        assert(x < m);
        e1.insert(x);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a > b) swap(a, b);
        int x = find(edges.begin(), edges.end(), make_pair(a, b)) - edges.begin();
        assert(x < m);
        e2.insert(x);
    }
    assert(m <= 10);
    bool found = false;
    vector<pii> ans;
    for (int mask = 0; mask < (1 << m); ++mask) {
        g1.clear();
        g2.clear();
        g1.resize(n);
        g2.resize(n);
        for (int i = 0; i < m; ++i) {
            bool h1 = ((e1.count(i)) ^ ((mask >> i) & 1));
            bool h2 = ((e2.count(i)) ^ ((mask >> i) & 1));
            const auto [a, b] = edges[i];
            if (h1) {
                g1[a].push_back(b);
                g1[b].push_back(a);
            }
            if (h2) {
                g2[a].push_back(b);
                g2[b].push_back(a);
            }
        }
        if (check(g1) && check(g2)) {
            found = true;
            for (int i = 0; i < m; ++i) {
                const auto [a, b] = edges[i];
                if (mask & (1 << i)) {
                    ans.push_back({a, b});
                }
            }
            break;
        }
    }
    if (!found) {
        cout << "No" << endl;
    } else {
        cout << "Yes" << endl;
        cout << ans.size() << endl;
        for (const auto [a, b] : ans) {
            cout << a + 1 << " " << b + 1 << endl;
        }
    }
}

signed main() {
    // #ifdef fastio
    // cin.tie(0);
    // ios::sync_with_stdio(0);
    // #endif
    #ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    int t;
    cin >> t >> G;

    while (t--) {
        // if (G == 2) {
            // solve2();
        // } else {
            solve1();
        // }
    }

    return 0;
}