#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m1, m2;
  cin >> n >> m1 >> m2;

  vector<int> p(n), s(n);
  for (int i = 0; i < n; ++i) {
    p[i] = i;
    s[i] = 1;
  }

  function<int(int)> Find = [&](int v) {
    if (v == p[v]) return v;
    return p[v] = Find(p[v]);
  };

  auto Unite = [&](int a, int b) {
    a = Find(a), b = Find(b);
    if (a == b) return;
    if (s[a] > s[b]) swap(a, b);
    s[b] += s[a];
    p[a] = b;
  };

  vector<vector<int>> g(n);
  vector<set<int>> gg(n);
  int comps = n;
  for (int i = 0; i < m1; ++i) {
    int x, y;
    cin >> x >> y;
    --x, --y;
    g[x].push_back(y);
    g[y].push_back(x);
    if (Find(x) != Find(y)) {
      comps -= 1;
      Unite(x, y);
    }
  }
  for (int i = 0; i < m2; ++i) {
    int x, y;
    cin >> x >> y;
    --x, --y;
    gg[x].insert(y);
    gg[y].insert(x);
  }
  vector<pair<int, int>> res;
  while (comps > 1) {
    bool found = false;
    for (int x = 0; x < n; ++x) {
      for (int y = x + 1; y < n; ++y) {
        if (Find(x) == Find(y)) {
          continue;
        }
        if (gg[x].find(y) != gg[x].end()) {
          gg[x].erase(y);
          gg[y].erase(x);
        } else {
          gg[x].insert(y);
          gg[y].insert(x);
        }
        vector<int> used(n);

        function<void(int)> Dfs = [&](int v) {
          used[v] = 1;
          for (int u : gg[v]) {
            if (!used[u]) {
              Dfs(u);
            }
          }
        };

        Dfs(0);
        bool ok = true;
        for (int v = 0; v < n; ++v) {
          if (!used[v]) {
            ok = false;
            break;
          }
        }
        if (ok) {
          found = true;
          res.emplace_back(x, y);
          Unite(x, y);
          comps -= 1;
          break;
        }
        if (gg[x].find(y) != gg[x].end()) {
          gg[x].erase(y);
          gg[y].erase(x);
        } else {
          gg[x].insert(y);
          gg[y].insert(x);
        }
      }
      if (found) {
        break;
      }
      if (found) {
        break;
      }
    }
    if (!found) {
      cout << "No\n";
      return;
    }
  }
  cout << "Yes\n";
  cout << res.size() << '\n';
  for (auto [x, y] : res) {
    cout << x + 1 << ' ' << y + 1 << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1, gg;
  cin >> tt >> gg;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
