#include "bits/stdc++.h"

#define int long long

int n, m1, m2;
std::vector<int> used;
std::vector<std::vector<int>> g1, g2;

void dfs1(int v) {
    used[v] = true;
    for (int to = 0; to < n; ++to) {
        if (!used[to] && g1[v][to]) {
            dfs1(to);
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    for (int to = 0; to < n; ++to) {
        if (!used[to] && g2[v][to]) {
            dfs2(to);
        }
    }
}

void not_main() {
    std::cin >> n >> m1 >> m2;
    used.resize(n);
    g1.resize(n, std::vector<int>(n));
    g2.resize(n, std::vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
        g1[a][b] = g1[b][a] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
        g2[a][b] = g2[b][a] = 1;
    }
    std::vector<std::pair<int, int>> edge;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edge.emplace_back(i, j);
        }
    }
    std::vector<int> mask((int) edge.size());
    for (int msk = 0; msk < (1 << (int) mask.size()); ++msk) {
        for (int i = 0; i < (int) edge.size(); ++i) {
            mask[i] = (msk >> i) & 1;
        }
        for (int i = 0; i < (int) edge.size(); ++i) {
            if (mask[i]) {
                auto [u, v] = edge[i];
                g1[u][v] = g1[v][u] ^= 1;
                g2[u][v] = g2[v][u] ^= 1;
            }
        }
        bool cnt1 = false, cnt2 = false;
        used.assign(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs1(i);
                cnt1 ^= 1;
                if (!cnt1) {
                    break;
                }
            }
        }
        used.assign(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs2(i);
                cnt2 ^= 1;
                if (!cnt2) {
                    break;
                }
            }
        }
        if (cnt1 && cnt2) {
            std::cout << "Yes\n" << std::count(mask.begin(), mask.end(), 1) << '\n';
            for (int i = 0; i < (int) edge.size(); ++i) {
                if (mask[i]) {
                    auto [u, v] = edge[i];
                    std::cout << u + 1 << ' ' << v + 1 << '\n';
                }
            }
            return;
        }
        for (int i = 0; i < (int) edge.size(); ++i) {
            if (mask[i]) {
                auto [u, v] = edge[i];
                g1[u][v] = g1[v][u] ^= 1;
                g2[u][v] = g2[v][u] ^= 1;
            }
        }
    }
    std::cout << "No\n";
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
    int tests = 1, gr;
    std::cin >> tests >> gr;
    while (tests--) {
        not_main();
        used.clear();
        g1.clear();
        g2.clear();
    }
    return 0;
}
