#include "bits/stdc++.h"

int n, m1, m2;
std::vector<int> used;
std::vector<std::set<int>> g1, g2;

void dfs1(int v) {
    used[v] = true;
    for (auto &i : g1[v]) {
        if (!used[i]) {
            dfs1(i);
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    for (auto &i : g2[v]) {
        if (!used[i]) {
            dfs2(i);
        }
    }
}

void not_main() {
    std::cin >> n >> m1 >> m2;
    used.resize(n);
    g1.resize(n);
    g2.resize(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
        g1[a].emplace(b);
        g1[b].emplace(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
        g2[a].emplace(b);
        g2[b].emplace(a);
    }
    std::vector<std::pair<int, int>> edges(n * (n - 1) / 2);
    int edges_el = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges[edges_el++] = {i, j};
        }
    }
    int m = edges_el;
    for (int mask = 0; mask < (1 << m); ++mask) {
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1) {
                ++cnt;
                auto [u, v] = edges[i];
                if (g1[u].find(v) == g1[u].end()) {
                    g1[u].emplace(v);
                    g1[v].emplace(u);
                } else {
                    g1[u].erase(v);
                    g1[v].erase(u);
                }
                if (g2[u].find(v) == g2[u].end()) {
                    g2[u].emplace(v);
                    g2[v].emplace(u);
                } else {
                    g2[u].erase(v);
                    g2[v].erase(u);
                }
            }
        }
        bool f1 = false, f2 = false;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs1(i);
                f1 ^= true;
                if (!f1) {
                    break;
                }
            }
        }
        used.assign(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs2(i);
                f2 ^= true;
                if (!f2) {
                    break;
                }
            }
        }
        used.assign(n, false);
        if (f1 && f2) {
            std::cout << "Yes\n" << cnt << '\n';
            for (int i = 0; i < m; ++i) {
                if (mask >> i & 1) {
                    auto [u, v] = edges[i];
                    std::cout << u + 1 << ' ' << v + 1 << '\n';
                }
            }
            return;
        }
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1) {
                auto [u, v] = edges[i];
                if (g1[u].find(v) == g1[u].end()) {
                    g1[u].emplace(v);
                    g1[v].emplace(u);
                } else {
                    g1[u].erase(v);
                    g1[v].erase(u);
                }
                if (g2[u].find(v) == g2[u].end()) {
                    g2[u].emplace(v);
                    g2[v].emplace(u);
                } else {
                    g2[u].erase(v);
                    g2[v].erase(u);
                }
            }
        }
    }
    std::cout << "No\n";
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
    int tests = 1, gr;
    std::cin >> tests >> gr;
    while (tests--) {
        not_main();
        used.clear();
        g1.clear();
        g2.clear();
    }
    return 0;
}
