//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
//#include <bits/extc++.h>

//using namespace __gnu_pbds;
using namespace std;
//typedef tree<int, nuint_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define int long long
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()

mt19937_64 rd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e18;

struct DSU{
    vector<int> p;

    DSU(int n) {
        p.assign(n, 0);
        for (int i = 0; i < n; ++i) p[i] = i;
    }

    int get(int u) {
        if (p[u] == u) return u;
        return p[u] = get(p[u]);
    }

    void uni(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;
        if (rd() & 1) swap(u, v);
        p[u] = v;
    }
};

const int MAXN = 3e5 + 1;

int tin[MAXN] = {0}, fup[MAXN] = {0}, used[MAXN] = {0}, timer = 0;

set<pair<int, int>> bridges;

void dfs(int u, vector<set<int>> &g1, int p = -1) {
    tin[u] = timer++;
    fup[u] = tin[u];
    used[u] = 1;
    for (auto it: g1[u]) {
        if (it == p) continue;
        if (used[it])
            fup[it] = min(fup[it], tin[it]);
        else {
            dfs(it, g1, u);
            fup[u] = min(fup[it], fup[u]);
            if (tin[u] < fup[it]) {
                bridges.insert({u, it});
                bridges.insert({it, u});
            }
        }
    }
}

void solve() {
    int n, m, m1;
    cin >> n >> m >> m1;
    vector<set<int>> g(n + 1), g1(n + 1);
    DSU t(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].insert(v);
        g[v].insert(u);
        t.uni(u, v);
    }
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        g1[a].insert(b);
        g1[b].insert(a);
    }
    if (n == 3 && m1 == 3 && m == 0) {
        cout << "No\n";
        return;
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (t.get(i) == t.get(j) || g1[i].count(j)) continue;
            ans.pb({i, j});
            g[i].insert(j);
            g[j].insert(i);
            g1[i].insert(j);
            g1[j].insert(i);
            t.uni(i, j);
        }
    }
    dfs(1, g1);
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (t.get(i) == t.get(j) || bridges.count({i, j})) continue;
            t.uni(i, j);
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto [u, v]: ans) cout << u << " " << v << '\n';
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1, g;
    cin >> T >> g;
    while (T--)
        solve();
}
