//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
//#include <bits/extc++.h>

//using namespace __gnu_pbds;
using namespace std;
//typedef tree<int, nuint_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define int long long
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()

mt19937_64 rd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e18;

struct DSU {
    vector<int> p, sz;

    DSU(int n) {
        p.assign(n, 0);
        sz.assign(n, 1);
        for (int i = 0; i < n; ++i) p[i] = i;
    }

    int get(int u) {
        if (p[u] == u) return u;
        return p[u] = get(p[u]);
    }

    void uni(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;
        if (sz[u] < sz[v]) swap(u, v);
        p[v] = u;
        sz[u] += sz[v];
    }
};

const int MAXN = 3e5 + 1;
set<int> g1[MAXN], g2[MAXN], ost[MAXN];
int used[MAXN] = {0};

void dfs(int u) {
    used[u] = 1;
    for (auto it: g2[u]) {
        if (used[it]) continue;
        ost[u].insert(it);
        ost[it].insert(u);
        dfs(it);
    }
}
set<int> path;

bool dfs2(int u, int depth=0) {
    used[u] = 1;
    path.insert(u);
    if (depth >= 3) return 1;
    for (auto it: ost[u]) {
        if (used[it]) continue;
        if (dfs2(it, depth + 1)) return 1;
    }
    path.erase(u);
    return 0;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> have1, have2;
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u].insert(v);
        g1[v].insert(u);
        have1.insert({u, v});
        have1.insert({v, u});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        g2[u].insert(v);
        g2[v].insert(u);
        have2.insert({u, v});
        have2.insert({v, u});
    }
    
    
    if (n == 3) {

        vector<pair<int, int>> ans;
        bool good = 0;
        for (int i = 1; i <= 3; ++i) {
            int i1 = i % 3 + 1;
            if (have1.count({i, i1}) == 0 && have2.count({i, i1}) == 0) {
                ans.pb({i, i1});
            }
            if (have1.count({i, i1}) == 1 && have2.count({i, i1}) == 1) {
               good = 1;
            }
        }
        if (m1 >= 2) {
            cout << "Yes\n0\n";
        } else if (!good && ans.empty()) {
            cout << "No\n";
        } else {
            if (ans.size() + m1 < 2) {
                for (int i = 1; i <= 3; ++i) {
                    int i1 = i % 3 + 1;
                    if (have2.count({i, i1}) == 1 && have1.count({i, i1}) == 0) {
                        ans.pb({i, i1});
                        break;
                    }
                }
            }
            cout << "Yes\n" << ans.size() << '\n';
            for (auto [a, b]: ans)
                cout << a << " " << b << '\n';
        }

        for (int j = 1; j <= n; ++j) {
            ost[j].clear();
            g1[j].clear();
            g2[j].clear();
        }
        path.clear();
        return;
    }
    
    
    fill(used, used + MAXN, 0);
    dfs(1);
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        if (ost[i].size() == n - 1) {
            vector<int> a;
            for (auto it: ost[i])
                a.pb(it);
            int u = a[0], v = a[1];
            if (have2.count({u, v}) == 0) {
                ans.pb({u, v});
                if (have1.count({u, v})) {
                    have1.erase({u, v});
                    have1.erase({v, u});
                } else {
                    have1.insert({u, v});
                    have1.insert({v, u});
                }
                have2.insert({u, v});
                have2.insert({v, u});
            } else {
                have2.erase({u, v});
                have2.erase({v, u});
            }
            ost[i].erase(u);
            ost[u].erase(i);
            ost[u].insert(v);
            ost[v].insert(u);
        }
    }
    set<int> curr;
    set<pair<int, int>> ost2;
    deque<int> to_add;
    for (int i = 1; i <= n; ++i) {
        if (ost[i].size() == 1) {
            fill(used, used + MAXN, 0);
            if (!dfs2(i)) {
                for (int j = 1; j <= n; ++j) {
                    ost[j].clear();
                    g1[j].clear();
                    g2[j].clear();
                }
                path.clear();
                cout << "No\n";
                return;
            }
            vector<int> need;
            for (auto it: path) need.pb(it);
            for (int sa = 0; sa < 4; ++sa) {
                int it = need[sa];
                for (int sn = sa + 1; sn < 4; ++sn) {
                    int it1 = need[sn];
                    if (it == it1 || ost[it].count(it1)) continue;
                    ost2.insert({it, it1});
                }
                curr.insert(it);
                to_add.pb(it);
            }
        }
    }
    while (!to_add.empty()) {
        int u = to_add[0];
        to_add.pop_front();
        if (curr.count(u) == 0) {
            for (auto it: curr) {
                if (ost[u].count(it) == 0) {
                    ost2.insert({u, it});
                    break;
                }
            }
            curr.insert(u);
        }
        for (auto it: ost[u]) {
            if (curr.count(it)) continue;
            to_add.pb(it);
        }
    }

    for (auto it: ost2) {
        if (have1.count(it) == 0) {
            ans.pb(it);
        }
    }

    cout << "Yes\n" << ans.size() << '\n';
    for (auto [a, b]: ans) {
        cout << a << " " << b << '\n';
    }

    for (int j = 1; j <= n; ++j) {
        ost[j].clear();
        g1[j].clear();
        g2[j].clear();
    }
    path.clear();
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1, g;
    cin >> T >> g;
    while (T--)
        solve();
}
