#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<int> par, ran;

void make_set(int v) {
    par[v] = v;
    ran[v] = 1;
}

int find_set(int v) {
    if (v == par[v]) return v;
    return par[v] = find_set(par[v]);
}

void union_sets(int v, int u) {
    v = find_set(v), u = find_set(u);
    if (v == u) return;
    if (ran[v] < ran[u]) {
        swap(v, u);
    }
    par[u] = v;
    ran[v] += ran[u];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g; cin >> t >> g;
    while (t--) {
        vector<set<int>> g1, g2;
        int n, m1, m2; cin >> n >> m1 >> m2;
        par.resize(n);
        ran.resize(n);
        for (int i = 0; i < n; ++i) {
            make_set(i);
        }
        g1.resize(n);
        g2.resize(n);
        for (int i = 0; i < m1; ++i) {
            int u, v; cin >> u >> v; u--, v--;
            g1[u].emplace(v);
            g1[v].emplace(u);
            union_sets(v, u);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v; cin >> u >> v; u--, v--;
            g2[u].emplace(v);
            g2[v].emplace(u);
        }
        vector<pair<int, int>> ans;

        if (m2 == (n - 1) * n / 2) {
            for (int i = 1; i < n; ++i) {
                if (g1[0].find(i) == g1[0].end()) {
                    ans.emplace_back(1, i + 1);
                    union_sets(0, i);
                }
            }
        } else {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (find_set(i) != find_set(j)) {
                        if (g2[i].find(j) == g2[i].end()) {
                            union_sets(i, j);
                            ans.emplace_back(i + 1, j + 1);
                        } else {
                            for (int k = 0; k < i; ++k) {
                                if (find_set(k) == find_set(i) && k != i && g2[j].find(k) == g2[j].end()) {
                                    union_sets(i, j);
                                    ans.emplace_back(j + 1, k + 1);
                                    ans.emplace_back(j + 1, i + 1);
                                }
                            }
                        }
                    }
                }
            }
        }

        bool fl = true;
        for (int i = 0; i < n; ++i) {
            if (par[i] != par[0]) {
                fl = false;
                break;
            }
        }
        if (!fl) {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << "\n";
    }
}
