#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 6e5 + 1;
const int M = 3e5;

int par[N], sz[N];

int get(int a) {
    if(par[a] == a) {
        return a;
    }
    return par[a] = get(par[a]);
}

void dsu(int a, int b) {
    a = get(a);
    b = get(b);

    if(a == b) {
        return;
    }

    if(sz[a] < sz[b]) {
        swap(a, b);
    }

    par[b] = a;
    sz[a] += sz[b];
}

int main() {
    int t, g;
    cin >> t >> g;

    while(t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        fr (i, 1, n * 2) {
            par[i] = i;
            sz[i] = 1;
        }

        vector<pii> edge(m1);
        vector<pii> edge2(m2);
        vector<bool> used(m2);
        fr (i, 0, m1 - 1) {
            int a, b;
            cin >> a >> b;
            edge.pb({a, b});
        }
        fr (i, 0, m2 - 1) {
            int a, b;
            cin >> a >> b;
            edge2.pb({a, b});
        }

        if(g == 2) {
            int i = 0;
            fe (x, edge) {
                int u = M + x.fi;
                int v = M + x.se;

                if(get(u) != get(v)) {
                    dsu(u, v);
                    used[i] = 1;
                }
            }
            fe (x, edge2) {
                int u = M + x.fi;
                int v = M + x.se;

                if(get(u) != get(v)) {
                    dsu(u, v);
                    used[i] = 1;
                }
                i++;
            }

            int cnt = 1;
            fe (x, edge) {
                int u = x.fi;
                int v = x.se;

                if(get(u) != get(v)) {
                    cnt++;
                    dsu(u, v);
                }
            }

            i = 0;
            vector<pii> ans;
            fe (x, edge2) {
                if(!used[i]) {
                    int u = x.fi;
                    int v = x.se;

                    if(get(u) != get(v)) {
                        dsu(u, v);
                        cnt++;
                        ans.pb({u, v});
                    }
                }
            }

            if(cnt == n) {
                cout << "Yes" << endl;
                fe (x, ans) {
                    cout << x.fi << " " << x.se << endl;
                }
            } else {
                cout << "No" << endl;
            }
        }
    }

    return 0;
}