#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using namespace __gnu_pbds;

template < typename T >
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
bool umx(T& a, T b) {
    return (a < b ? a = b, 1 : 0);
}

template<typename T>
bool umn(T& a, T b) {
    return (a > b ? a = b, 1 : 0);
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int N = 3e5 + 222;
const int mod = 1e9 + 7;
set<int> g1[N], g2[N];
void add1 (int u, int v) {
    g1[u].insert(v);
    g1[v].insert(u);
}

void add2 (int u, int v) {
    g2[u].insert(v);
    g2[v].insert(u);
}

void del1 (int u, int v) {
    g1[v].erase(u);
    g1[u].erase(v);
}

void del2 (int u, int v) {
    g2[v].erase(u);
    g2[u].erase(v);
}
void dfs (int v, vector<bool>&used) {
    used[v] = 1;
    for (auto to : g2[v]) {
        if (!used[to]) dfs(to, used);
    }
}
void dfs2 (int v, vector<bool>&used) {
    used[v] = 1;
    for (auto to : g1[v]) {
        if (!used[to]) dfs2(to, used);
    }
}

void solve() {
    int n;
    int m1, m2;
    cin >> n;
    cin >> m1 >> m2;
    vector<pair<int,int>> ve;
    for (int i = 1; i <= n; ++i) {
        g1[i].clear(); g2[i].clear();
        for (int j = i + 1; j <= n; ++j) {
            ve.push_back({i, j});
        }
    }
    for (int i = 1; i <= m1; ++i) {
        int u, v;
        cin >> u >> v;
        add1(u, v);
    }
    for (int i = 1; i <= m2; ++i) {
        int u, v;
        cin >> u >> v;
        add2(u, v);
    }
    vector<int> p(ve.size());
    iota(begin(p), end(p), 0);
    do {
        vector<pair<int,int>> edge;
        for (auto it : p) {
            edge.push_back(ve[it]);
            int u = ve[it].first, v = ve[it].second;
            if (g1[u].find(v) != g1[u].end()) del1(u, v);
            else add1(u, v);

            if (g2[u].find(v) != g2[u].end()) del2(u, v);
            else add2(u, v);
            int cnt = 0;
            vector<bool> used(n + 1);
            dfs(1, used);
            for (int i = 1; i <= n; ++i) if (!used[i]) ++cnt;
            if (cnt) break;
            for (int i = 1; i <= n; ++i) used[i] = 0;
            cnt = 0;
            dfs2(1, used);
            for (int i = 1; i <= n; ++i) if (!used[i]) ++cnt;
            if (cnt == 0) {
                cout << "Yes\n";
                cout << edge.size() << endl;
                for (auto to : edge) cout << to.first << ' ' << to.second << '\n';
                return;
            }
        }
    } while (next_permutation(begin(p), end(p)));
    cout << "No\n";
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T, g;
    cin >> T >> g;
    while (T--) solve();
    return 0;
}
