#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct DSU {
    vector<int> dt;
    vector<int> sz;

    DSU() {}

    DSU(int n) {
        dt.resize(n);
        iota(dt.begin(), dt.end(), 0);
        sz.resize(n, 1);
    }

    int get(int v) {
        if (dt[v] == v)
            return v;
        return dt[v] = get(dt[v]);
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b)
            return false;
        if (sz[a] < sz[b])
            swap(a, b);
        sz[a] += sz[b];
        dt[b] = a;
        return true;
    }
};

struct Solution {
    int TEST = -1;
    int GROUP = 0;

    signed operator()() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        if (n == 3 && m1 == 0) {
            while (m2--) {
                int a, b;
                cin >> a >> b;
            }
            cout << "No\n";
            return 0;
        }
        DSU cum(n);
        while (m1--) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            cum.unite(a, b);
        }
        while (m2--) {
            int a, b;
            cin >> a >> b;
        }
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            if (cum.get(i) != cum.get(i + 1)) {
                ans.emplace_back(i, i + 1);
                cum.unite(i, i + 1);
            }
        }
        cout << "Yes\n" << ans.size() << "\n";
        for (auto &it: ans)
            cout << it.first + 1 << " " << it.second + 1 << "\n";
        return 0;
    }

    Solution(int TEST = -1, int GROUP = 0) : TEST(TEST), GROUP(GROUP) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1, g;
    cin >> t >> g;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST, g)();
        if (res != 0)
            return res;
    }
    return 0;
}