#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;

typedef long double ld;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 3E5, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t MOD = 998244353, MOD_phi = MOD - 1;
struct Mod_int
{
	uint32_t val;
	Mod_int(uint64_t val = 0) :val(val% MOD) {}
	Mod_int operator+ (const Mod_int m) const
	{
		return val + m.val;
	}
	Mod_int operator+= (const Mod_int m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int m) const
	{
		return MOD - m.val + val;
	}
	Mod_int operator-= (const Mod_int m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int m) const
	{
		return uint64_t(val) * m.val;
	}
	Mod_int operator*= (const Mod_int m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step_val) const
	{
		Mod_int ans = 1, cur = *this;
		while (step_val > 0)
		{
			if (step_val & 1)
			{
				ans *= cur;
			}
			step_val >>= 1;
			cur *= cur;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int m) const
	{
		return *this * m.step(MOD_phi - 1);
	}
	Mod_int operator/= (const Mod_int m)
	{
		return *this = *this / m;
	}
};

vector <int> g1[MAXN], g2[MAXN];
int par[MAXN];
uint64_t pair_to_int(uint32_t f, uint32_t s)
{
	return (uint64_t(f) << 32) ^ s;
}
int get_parent(int u)
{
	if (par[u] < 0)
	{
		return u;
	}
	return par[u] = get_parent(par[u]);
}
void unite(int u, int v)
{
	u = get_parent(u);
	v = get_parent(v);
	if (u == v)
	{
		return;
	}
	if (par[v] < par[u])
	{
		swap(u, v);
	}
	rmin(par[u], par[v] - 1);
	par[v] = u;
}

vector <int> comp[MAXN];
bool used[MAXN];
int cur_comp = 0;
void make_comp(int v)
{
	comp[cur_comp].push_back(v);
	used[v] = true;
	for (int i = 0; i < g1[v].size(); i++)
	{
		int nxt = g1[v][i];
		if (!used[nxt])
		{
			make_comp(nxt);
		}
	}
}

void merge_comp(int l, int r)
{
	if (comp[l].size() < comp[r].size())
	{
		comp[l].swap(comp[r]);
	}
	for (int i = 0; i < comp[r].size(); i++)
	{
		comp[l].push_back(comp[r][i]);
	}
}

void solve()
{
	int n, m1, m2;
	cin >> n >> m1 >> m2;

	cur_comp = 0;
	for (int i = 0; i < n; i++)
	{
		g1[i].clear();
		g2[i].clear();
		comp[i].clear();
	}

	for (int i = 0; i < m1; i++)
	{
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g1[u].push_back(v);
		g1[v].push_back(u);
	}

	vector <pair <int, int>> edg;
	for (int i = 0; i < m2; i++)
	{
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		edg.push_back({ u, v });
	}
	fill(par, par + n, -1);
	unordered_set <uint64_t> used_edg;
	for (int i = 0; i < m2; i++)
	{
		int u = edg[i].first, v = edg[i].second;
		if (get_parent(u) == get_parent(v))
		{
			continue;
		}
		g2[u].push_back(v);
		g2[v].push_back(u);
		unite(u, v);
		used_edg.insert(pair_to_int(u, v));
		used_edg.insert(pair_to_int(v, u));
	}
	int ezh = -1;
	for (int i = 0; i < n; i++)
	{
		if (g2[i].size() == n - 1)
		{
			ezh = i;
			break;
		}
	}

	fill(used, used + n, false);
	bool bad = false;
	if (ezh != -1)
	{
		make_comp(ezh);
		++cur_comp;
		bad = comp[0].size() == 1;
	}
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			make_comp(i);
			++cur_comp;
		}
	}

	vector <pair <int, int>> answ;
	while (cur_comp > 2)
	{
		for (int tr_comp = cur_comp - 2; tr_comp >= 0; tr_comp--)
		{
			bool h = false;
			for (int i = 0; i < comp[cur_comp - 1].size(); i++)
			{
				int u = comp[cur_comp - 1][i];
				for (int j = 0; j < comp[tr_comp].size(); j++)
				{
					int v = comp[tr_comp][j];

					if (used_edg.count(pair_to_int(u, v)))
					{
						continue;
					}
					else
					{
						h = true;
						answ.push_back({ u, v });
						merge_comp(tr_comp, cur_comp - 1);
						break;
					}
				}
				if (h)
				{
					break;
				}
			}
			if (h)
			{
				break;
			}
		}
		--cur_comp;
	}

	if (bad)
	{
		if (n == 3)
		{
			cout << "No";
		}
		else
		{
			
		}
	}
	else
	{
		if (cur_comp > 1)
		{
			bool h = false;
			for (int i = 0; i < comp[cur_comp - 1].size(); i++)
			{
				int u = comp[cur_comp - 1][i];
				for (int j = 0; j < comp[0].size(); j++)
				{
					int v = comp[0][j];

					if (used_edg.count(pair_to_int(u, v)))
					{
						continue;
					}
					else
					{
						h = true;
						answ.push_back({ u, v });
						merge_comp(0, cur_comp - 1);
						break;
					}
				}
				if (h)
				{
					break;
				}
			}
		}

		cout << "Yes" << endl << answ.size();
		for (int i = 0; i < answ.size(); i++)
		{
			cout << endl;
			cout << answ[i].first + 1 << ' ' << answ[i].second + 1;
		}
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	
	int g;
	cin >> g;

	while (t--)
	{
		solve();
		cout << endl;
	}
}