#include<bits/stdc++.h>
#define sz(a) (int)a.size()
//#define int long long

using namespace std;

int G;

vector<int> pr, sz;

int get(int x) {
    if (pr[x] == x) {
        return x;
    }
    return pr[x] = get(pr[x]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    sz[a] += sz[b];
    pr[b] = a;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    pr.clear();
    pr.resize(n);
    sz.clear();
    sz.resize(n, 1);
    iota(pr.begin(), pr.end(), 0);
    vector<pair<int, int>> extra;
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (get(u) == get(v)) {
            extra.push_back({u, v});
        }
        unite(u, v);
    }
    vector<vector<int>> g(n, vector<int> (n));
    vector<int> deg(n);
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u][v] = g[v][u] = 1;
        ++deg[u];
        ++deg[v];
    }
    set<int> s;
    vector<int> idtc(n);
    vector<int> alone;
    for (int i = 0; i < n; ++i) {
        s.insert(get(i));
    }
    int id = 0;
    for (int i : s) {
        idtc[i] = id;
        ++id;
    }
    vector<vector<int>> comps(id);
    vector<int> lol(n);
    for (int i = 0; i < n; ++i) {
        comps[idtc[get(i)]].push_back(i);
        lol[i] = idtc[get(i)];
    }
    for (int i = 0; i < id; ++i) {
        if (sz(comps[i]) == 1) {
            alone.push_back(i);
        }
    }
    vector<pair<int, int>> ans;
    if (sz(alone) == 0) {
        int A = comps[0][0], B = comps[0][1];
        for (int i = 1; i < id; ++i) {
            int C = comps[i][0], D = comps[i][1];
            if (g[A][C] && g[A][D] && g[B][C] && g[B][D]) {
                ans.push_back({A, C});
                g[A][C] = g[C][A] = 0;
            }
            else {
                if (!g[A][C]) {
                    ans.push_back({A, C});
                    g[A][C] = g[C][A] = 1;
                }
                else if (!g[A][D]) {
                    ans.push_back({A, D});
                    g[A][D] = g[D][A] = 1;
                }
                else if (!g[B][C]) {
                    ans.push_back({B, C});
                    g[B][C] = g[C][B] = 1;
                }
                else {
                    ans.push_back({B, D});
                    g[B][D] = g[D][B] = 1;
                }
            }
        }
        cout << "Yes" << '\n';
        cout << sz(ans) << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }
    for (int i : alone) {
        if (sz(comps[i]) > 1) continue;
        int v = comps[i][0];
        bool ok = 0;
        for (int j = 0; j < n; ++j) {
            if (v == j) continue;
            if (g[v][j] == 0) {
                ++m2;
                g[v][j] = g[j][v] = 1;
                ++deg[v];
                ++deg[j];
                ans.push_back({v, j});
                int ID = lol[j];
                comps[ID].push_back(v);
                ok = 1;
                break;
            }
        }
        if (ok) {
            comps[i].clear();
            continue;
        }
        if (m2 > n - 1) {
            for (int U = 0; U < n; ++U) {
                if (U == v) continue;
                if (deg[U] > 1) {
                    g[v][U] = g[U][v] = 0;
                    deg[U]--;
                    deg[v]--;
                    ans.push_back({v, U});
                    --m2;
                    int ID = lol[U];
                    comps[ID].push_back(v);
                    break;
                }
            }
            comps[i].clear();
            continue;
        }
        if (sz(extra) == 0) {
            cout << "No" << '\n';
            return;
        }
        int A = extra[sz(extra) - 1].first, B = extra[sz(extra) - 1].second;
        extra.pop_back();
        g[A][B] = g[B][A] = 1;
        ++deg[A];
        ++deg[B];
        ans.push_back({A, B});
        g[v][A] = g[A][v] = 0;
        ans.push_back({A, v});
        deg[A]--;
        deg[v]--;
        int ID = lol[A];
        comps[ID].push_back(v);
        comps[i].clear();
    }
    int A = -1, B = -1;
    for (int i = 0; i < id; ++i) {
        if (sz(comps[i]) == 0) continue;
        if (A == -1) {
            A = comps[i][0];
            B = comps[i][1];
            continue;
        }
        int C = comps[i][0], D = comps[i][1];
        if (g[A][C] && g[A][D] && g[B][C] && g[B][D]) {
            ans.push_back({A, C});
            g[A][C] = g[C][A] = 0;
        }
        else {
            if (!g[A][C]) {
                ans.push_back({A, C});
                g[A][C] = g[C][A] = 1;
            }
            else if (!g[A][D]) {
                ans.push_back({A, D});
                g[A][D] = g[D][A] = 1;
            }
            else if (!g[B][C]) {
                ans.push_back({B, C});
                g[B][C] = g[C][B] = 1;
            }
            else {
                ans.push_back({B, D});
                g[B][D] = g[D][B] = 1;
            }
        }
    }
    if (sz(ans) > n) {
        cout << "No" << '\n';
        return;
    }
    cout << "Yes" << '\n';
    cout << sz(ans) << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t >> G;
    while (t--) {
        solve();
    }
}
