#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9 + 7;

int n, m1, m2;
vector<vector<bool>> gr1, gr2, chk;

void dfs(int v, vector<bool>& used, vector<vector<bool>>& gr) {
    used[v] = true;
    for (int u = 0; u < n; u++) {
        if (!gr[v][u] or used[u]) continue;
        dfs(u, used, gr);
    }
}

bool check(vector<vector<bool>>& gr) {
    vector<bool> used(n);
    dfs(0, used, gr);

    for (int i = 0; i < n; i++) {
        if (!used[i]) return false;
    }

    return true;
}

bool rec(int cnt, vector<pair<int, int>>& add) {
    if (check(gr1)) {
        cout << "YES" << endl;
        cout << cnt << endl;
        for (auto &[a, b] : add) cout << a + 1 << " " << b + 1 << endl;
        return true;
    }

    if (cnt == n) return false;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j or chk[i][j]) continue;

            add.emplace_back(i, j);
            chk[i][j] = chk[j][i] = true;
            gr1[i][j] = !gr1[i][j]; gr1[j][i] = !gr1[j][i];
            gr2[i][j] = !gr2[i][j]; gr2[j][i] = !gr2[j][i];

            if (check(gr2) and rec(cnt + 1, add)) return true;

            add.pop_back();
            chk[i][j] = chk[j][i] = false;
            gr1[i][j] = gr1[j][i] = !gr1[i][j];
            gr2[i][j] = gr2[j][i] = !gr2[i][j];
        }
    }

    return false;
}

void solve() {
    cin >> n >> m1 >> m2;

    gr1.assign(n, vector<bool>(n));
    gr2.assign(n, vector<bool>(n));
    chk.assign(n, vector<bool>(n));

    for (int i = 0; i < m1; i++) {
        int a, b; cin >> a >> b;
        a--, b--;
        gr1[a][b] = gr1[b][a] = true;
    }

    for (int i = 0; i < m2; i++) {
        int a, b; cin >> a >> b;
        a--, b--;
        gr2[a][b] = gr2[b][a] = true;
    }

    vector<pair<int, int>> add;
    if (rec(0, add)) return;

    cout << "NO" << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t, g; cin >> t >> g;
    while (t--) solve();
}
