#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}


void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g2(n);
    vector<int> root(n), sz(n, 1);
    iota(root.begin(), root.end(), 0);
    function<int(int)> get_root = [&](int v) {
        if (root[v] == v) {
            return v;
        }
        root[v] = get_root(root[v]);
        return root[v];
    };
    function<void(int, int)> merge = [&](int a, int b) {
        a = get_root(a);
        b = get_root(b);
        if (a == b) {
            return;
        }
        if (sz[a] > sz[b]) {
            swap(a, b);
        }
        root[a] = b;
        sz[b] += sz[a];
    };
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        merge(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    int blocked = -1;
    for (int i = 0; i < n; i++){
        if (g2[i].size() == n - 1){
            blocked = i;
        }
    }
    assert(blocked == -1);
    set<pp> banned;
    vector<bool> used(n);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (int to: g2[v]) {
            if (!used[to]) {
                dfs(to);
                banned.emplace(min(v, to), max(v, to));
            }
        }
    };
    dfs(0);
    vector<pp> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (get_root(i) == get_root(j) || banned.find({i, j}) != banned.end()) {
                continue;
            }
            merge(i, j);
            ans.emplace_back(i, j);
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto [a, b]: ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';

    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
