#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

pp sort(pp x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<set<int>> g2(n);
    vector<int> root(n), sz(n, 1);
    iota(root.begin(), root.end(), 0);
    function<int(int)> get_root = [&](int v) {
        if (root[v] == v) {
            return v;
        }
        root[v] = get_root(root[v]);
        return root[v];
    };
    function<void(int, int)> merge = [&](int a, int b) {
        a = get_root(a);
        b = get_root(b);
        if (a == b) {
            return;
        }
        if (sz[a] > sz[b]) {
            swap(a, b);
        }
        root[a] = b;
        sz[b] += sz[a];
    };
    set<pp> s1, s2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        s1.insert(sort({a, b}));
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].insert(b);
        g2[b].insert(a);
        s2.insert(sort({a, b}));
    }
    int blocked = -1;
    for (int i = 0; i < n; i++) {
        if (g2[i].size() == n - 1) {
            blocked = i;
        }
    }
    vector<pp> ans;
    if (blocked != -1) {
        pp curr = sort({*g2[blocked].begin(), *prev(g2[blocked].end())});
        if (s2.find(curr) == s2.end()) {
            ans.push_back(curr);
            s2.insert(curr);
            g2[curr.first].insert(curr.second);
            g2[curr.second].insert(curr.first);
            if (s1.find(curr) == s1.end()) {
                s1.insert(curr);
            } else {
                s1.erase(curr);
            }
        }
    }
    for (auto &[a, b]: s1) {
        merge(a, b);
    }
    set<pp> banned;
    vector<bool> used(n);
    vector<vector<int>> dfs_g(n);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (int to: g2[v]) {
            if (!used[to]) {
                dfs_g[v].push_back(to);
                dfs_g[to].push_back(v);
                dfs(to);
                banned.emplace(min(v, to), max(v, to));
            }
        }
    };
    dfs(0);
    for (int i = 0; i < n; i++) {
        if (dfs_g[i].size() == n - 1) {
            for (auto [a, b]: s2) {
                if (a != i && b != i) {
                    banned.insert(sort({a, b}));
                    banned.erase(sort({a, i}));
                    break;
                }
            }
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (get_root(i) == get_root(j) || banned.find({i, j}) != banned.end()) {
                continue;
            }
            merge(i, j);
            ans.emplace_back(i, j);
        }
    }
    for (int i = 0; i < n; i++) {
        if (get_root(i) != get_root(0)) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto [a, b]: ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
