#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

pp sort(pp x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<set<int>> g2(n), g1(n);
    vector<int> root(n), sz(n, 1);
    iota(root.begin(), root.end(), 0);
    function<int(int)> get_root = [&](int v) {
        if (root[v] == v) {
            return v;
        }
        root[v] = get_root(root[v]);
        return root[v];
    };
    function<void(int, int)> merge = [&](int a, int b) {
        a = get_root(a);
        b = get_root(b);
        if (a == b) {
            return;
        }
        if (sz[a] > sz[b]) {
            swap(a, b);
        }
        root[a] = b;
        sz[b] += sz[a];
    };
    set<pp> s1, s2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].insert(b);
        g1[b].insert(a);
        s1.insert(sort({a, b}));
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].insert(b);
        g2[b].insert(a);
        s2.insert(sort({a, b}));
    }
    vector<pp> ans;
    set<pp> banned;
    vector<bool> used(n);
    vector<set<int>> dfs_g(n);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (int to: g2[v]) {
            if (!used[to]) {
                dfs_g[v].insert(to);
                dfs_g[to].insert(v);
                dfs(to);
                banned.emplace(sort({v, to}));
            }
        }
    };
    dfs(0);

    function<void(pp)> add_to_ban = [&](pp x) {
        dfs_g[x.first].insert(x.second);
        dfs_g[x.second].insert(x.first);
        banned.insert(x);
    };
    function<void(pp)> del_from_ban = [&](pp x) {
        dfs_g[x.first].erase(x.second);
        dfs_g[x.second].erase(x.first);
        banned.erase(x);
    };
    for (int i = 0; i < n; i++) {
        if (dfs_g[i].size() == n - 1 && g1[i].empty()) {
            bool fnd = false;
            for (auto [a, b]: s2) {
                if (a != i && b != i) {
                    add_to_ban(sort({a, b}));
                    del_from_ban(sort({a, i}));
                    fnd = true;
                    break;
                }
            }
            if (!fnd) {
                pp new_edg = sort({*dfs_g[i].begin(), *prev(dfs_g[i].end())});
                ans.emplace_back(new_edg);
                if (s1.find(new_edg) == s1.end()) {
                    s1.insert(new_edg);
                } else {
                    s1.erase(new_edg);
                }
                if (s2.find(new_edg) == s2.end()) {
                    s2.insert(new_edg);
                } else {
                    s2.erase(new_edg);
                }
                add_to_ban(sort(new_edg));
                del_from_ban(sort({*dfs_g[i].begin(), i}));
            }
            break;
        }
    }
    for (auto &[a, b]: s1) {
        merge(a, b);
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (get_root(i) == get_root(j) || banned.find(sort({i, j})) != banned.end()) {
                continue;
            }
            merge(i, j);
            ans.emplace_back(i, j);
        }
    }*/
    vector<int> tmp;
    for (int i = 0; i < n; i++) {
        if (dfs_g[i].size() == 1) {
            tmp.push_back(i);
        }
    }
    for (int it = 0; it < 2; it++) {
        for (int a = 0; a < n; a++) {
            if (a == tmp[it] || banned.find(sort({a, tmp[it]})) != banned.end() ||
                get_root(a) == get_root(tmp[it])) { continue; }
            ans.emplace_back(a, tmp[it]);
            merge(a, tmp[it]);
        }
    }
    for (
            int i = 0;
            i < n;
            i++) {
        if (
                get_root(i)
                != get_root(0)) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n" << ans.

            size()

         << '\n';
    for (auto [a, b]: ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
