//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

const int MAXN = 20003, LOGN = 18, LOGV = 30;

const ll INF = 1ll << 30;


mt19937 rnd(245);


void fail() {
    cout << "Oops" << endl;
    exit(0);
}


set<int> ga[MAXN], gb[MAXN];

set<int> pool;
int comp[MAXN];
vector<int> compV[MAXN];


vector<pll> E;

void addAEdge(int a, int b) {
    if (ga[a].find(b) != ga[a].end())
        return;
    E.emplace_back(a, b);
}

void addBEdge(int a, int b) {
    if (gb[a].find(b) != gb[a].end())
        return;
    E.emplace_back(a, b);
}

int dfs(int v, int ci) {
    comp[v] = ci;
    compV[ci].push_back(v);
    pool.erase(v);
    int csz = 1;
    auto u = pool.begin();
    while (u != pool.end()) {
        if (gb[v].find(*u) == gb[v].end()) {
            int prevU = *u;
            csz += dfs(*u, ci);
            u = pool.upper_bound(prevU);
            if (u == pool.begin())
                break;
            else
                u--;
        }
        u++;
    }
    return csz;
}

void dfs2(int v) {
    pool.erase(v);
    auto u = pool.begin();
    while (u != pool.end()) {
        if (gb[v].find(*u) == gb[v].end()) {
            addAEdge(v, *u);
            int prevU = *u;
            dfs2(*u);
            u = pool.upper_bound(prevU);
            if (u == pool.begin())
                break;
            else
                u--;
        }
        u++;
    }
}

void solve() {
    int n, ma, mb;
    cin >> n >> ma >> mb;

    for (int i = 0; i < ma; ++i) {
        int ta, tb;
        cin >> ta >> tb;
        ta--, tb--;
        ga[ta].insert(tb);
        ga[tb].insert(ta);
    }
    for (int i = 0; i < mb; ++i) {
        int ta, tb;
        cin >> ta >> tb;
        ta--, tb--;
        gb[ta].insert(tb);
        gb[tb].insert(ta);
    }


    for (int i = 0; i < n; ++i)
        pool.insert(i);

    int ccnt = 0, soloV = -1;

    fill(comp, comp + n, -1);
    for (int i = 0; i < n; ++i) {
        if (comp[i] == -1)
            if (dfs(i, ccnt++) == 1)
                soloV = i;
    }

    if (soloV == -1) {
        int prevCompV = -1, curCompV = -1;
        for (int ci = 0; ci < ccnt; ++ci) {
            pool.clear();
            curCompV = compV[ci].front();
            for (auto i: compV[ci])
                pool.insert(i);
            dfs2(curCompV);
            if (prevCompV != -1)
                addAEdge(prevCompV, curCompV);
            prevCompV = curCompV;
        }

    } else {
        vector<int> other;
        for (int i = 0; i < n; ++i)
            if (i != soloV)
                other.push_back(i);
        for (int i = 0; i < (int) other.size() - 1; ++i)
            addAEdge(other[i], other[i + 1]);
        addBEdge(other.front(), other.back());
        addAEdge(other.back(), soloV);
    }


    if (n == 3) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        cout << E.size() << '\n';
        for (auto i: E)
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
    pool.clear();
    E.clear();
    for (int i = 0; i < n; ++i)
        ga[i].clear(), gb[i].clear();
    for (int i = 0; i < ccnt; ++i)
        compV[i].clear();
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t, gi;
    cin >> t >> gi;
    for (int i = 0; i < t; ++i)
        solve();

    return 0;
}
