#include <bits/stdc++.h>

using namespace std;
using ll = long long;
struct dsu{
    vector<int> p, sz;
    dsu(int n) {
        p.resize(n + 1);
        iota(p.begin(), p.end(), 0);
        sz.resize(n + 1, 1);
    }
    int get(int a) {
        if (a == p[a]) return a;
        return p[a] = get(p[a]);
    }
    bool merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        sz[b] += sz[a];
        p[a] = b;
        return true;
    }
};
mt19937 rnd(10);
void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> e1(n, vector<int> (n, 0));
    vector<vector<int>> e2(n, vector<int> (n, 0));
    set<pair<int, int>> edge1, edge2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        e1[a][b] = e1[b][a] = 1;
        edge1.insert({a, b});
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        e2[a][b] = e2[b][a] = 1;
        edge2.insert({a, b});
    }
    auto check = [&] ()-> bool {
        dsu d(n);
        for (auto [i, j] : edge2) if (e2[i][j]) d.merge(i, j);
        return d.sz[d.get(0)] == n;
    };
    for (int iter = 0; iter < 100; iter++) {
        auto st1 = edge1;
        auto st2 = edge2;
        auto ste1 = e1;
        auto ste2 = e2;
        dsu d(n);
        vector<pair<int, int>> out;
        for (auto e : edge1) d.merge(e.first, e.second);
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (!e2[i][j]) {
                    if (d.merge(i, j)) {
                        out.push_back({i, j});
                        e2[i][j] = 1;
                        e1[i][j] = 1;
                        edge1.insert({i, j});
                        edge2.insert({i, j});
                    }
                    continue;
                }
                if (edge2.find({i, j}) != edge2.end()) edge2.erase({i, j});
                if (edge2.find({j, i}) != edge2.end()) edge2.erase({j, i});
                if (check() && d.merge(i, j)) {
                    out.push_back({i, j});
                    e2[i][j] ^= 1;
                    e1[i][j] ^= 1;
                    edge1.insert({i, j});
                } else edge2.insert({i, j});
            }
        }
        if (d.sz[d.get(0)] == n) {
            cout << "Yes\n";
            cout << out.size() << "\n";
            for (int i = 0; i < out.size(); i++) cout << out[i].first + 1 << " " << out[i].second + 1 << "\n";
            return;
        }
        edge1 = st1;
        edge2 = st2;
        e1 = ste1;
        e2 = ste2;
        int t = rnd() % e1.size();
        int c = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                c += e1[i][j];
                if (c == t) {
                    edge1.erase({i, j});
                    c++;
                    break;
                }
            }
        }
    }
    cout << "No\n";
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    for (int i = 0; i < t; i++) {
        solve();
    }
}