#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1, g;
	cin >> t >> g;
	while (t--) {
		solve();
	}
}

const int N = 300300;
int dsu[N];
set<int> hds;
map<pair<int, int>, int> ed;
vector<pair<int, int>> e;
vector<int> g[N], bad, used;

int get(int x) {
	return dsu[x] == x ? x : dsu[x] = get(dsu[x]);
}

void merge(int x, int y) {
	x = get(x);
	y = get(y);
	if (x == y) {
		return;
	}
	hds.erase(y);
	dsu[y] = x;
}

void dfs(int s, int p) {
	used[s] = 1;
	for (int i : g[s]) {
		if (!used[i]) {
			dfs(i, s);
			if (p == -1) {
				bad[i] = 1;
			}
		}
	}
}

void solve() {
	hds.clear();
	ed.clear();
	e.clear();
	bad.clear();
	used.clear();
	vector<pair<int, int>> ans;
	int n;
	cin >> n;
	bad.resize(n, 0);
	used.resize(n, 0);
	for (int i = 0; i < n; i++) {
		dsu[i] = i;
		hds.insert(i);
		g[i].clear();
	}
	int m1, m2;
	cin >> m1 >> m2;
	for (int i = 0; i < m1; i++) {
		int u, v;
		cin >> u >> v; u--; v--;
		e.emplace_back(u, v);
		merge(u, v);
	}
	for (int i = 0; i < m2; i++) {
		int u, v;
		cin >> u >> v; u--; v--;
		ed[{u, v}] = 1;
		ed[{v, u}] = 1;
	}
	while (hds.size() > 2) {
		int a = *hds.begin();
		hds.erase(a);
		int b = *hds.begin();
		hds.erase(b);
		int c = *hds.begin();
		hds.erase(c);
		if (!ed[{a, b}]) {
			merge(a, b);
			ed[{a, b}] = 1;
			ed[{b, a}] = 1;
			e.emplace_back(a, b);
			ans.emplace_back(a, b);
		} else if (!ed[{b, c}]) {
			merge(c, b);
			ed[{c, b}] = 1;
			ed[{b, c}] = 1;
			e.emplace_back(c, b);
			ans.emplace_back(c, b);
		} else if (!ed[{a, c}]) {
			merge(c, a);
			ed[{c, a}] = 1;
			ed[{a, c}] = 1;
			e.emplace_back(c, a);
			ans.emplace_back(a, c);
		} else {
			ed[{a, b}] = 0;
			ed[{b, a}] = 0;
			merge(a, b);
			e.emplace_back(a, b);
			ans.emplace_back(a, b);
		}
		hds.insert(get(a));
		hds.insert(get(b));
		hds.insert(get(c));
	}
	if (hds.size() == 1) {
		cout << "Yes\n";
		cout << ans.size() << '\n';
		for (auto [u, v] : ans) {
			cout << u + 1 << ' ' << v + 1 << '\n';
		}
		return;
	}
	vector<int> a, b;
	for (int i = 0; i < n; i++) {
		if (get(i) == get(0)) {
			a.push_back(i);
		} else {
			b.push_back(i);
		}
	}
	if (a.size() > b.size()) {
		swap(a, b);
	}
	if (a.size() == 1) {
		for (auto [edge, bb] : ed) {
			if (edge.x < edge.y && bb) {
				g[edge.x].push_back(edge.y);
				g[edge.y].push_back(edge.x);
			}
		}
		dfs(a[0], -1);
		bad[a[0]] = 1;
		for (int i = 0; i < n; i++) {
			if (!bad[i]) {
				merge(a[0], i);
				ans.emplace_back(a[0], i);
				break;
			}
		}
		if (hds.size() != 1) {
			ed.clear();
			for (auto [u, v] : e) {
				ed[{u, v}] = 1;
				ed[{v, u}] = 1;
			}
			if (n == 3) {
				cout << "No\n";
				return;
			}
			int u = b[0], v = b[1], w = b[2];
			if (!ed[{u, w}]) {
				ans.emplace_back(u, w);
				ans.emplace_back(u, a[0]);
			} else if (!ed[{v, w}]) {
				ans.emplace_back(v, w);
				ans.emplace_back(v, a[0]);
			} else if (!ed[{v, u}]) {
				merge(v, u);
				ed[{v, u}] = 1;
				ed[{u, v}] = 1;
				e.emplace_back(v, u);
				ans.emplace_back(v, u);
				ans.emplace_back(v, a[0]);
			} else {
				merge(u, w);
				ed[{u, w}] = 0;
				ed[{w, u}] = 0;
				e.emplace_back(u, w);
				ans.emplace_back(u, w);
				ans.emplace_back(u, a[0]);
			}
		}
		cout << "Yes\n";
		cout << ans.size() << '\n';
		for (auto [u, v] : ans) {
			cout << u + 1 << ' ' << v + 1 << '\n';
		}
		return;
	} else {
		int u = a[0], w = b[0], v = a[1];
		for (auto [edge, bb] : ed) {
			if (edge.x == u && bb && get(edge.y) == get(0)) {
				v = edge.y;
				break;
			}
		}
		// cout << u << ' ' << v << ' ' << w << '\n';
		if (!ed[{u, w}]) {
			merge(u, w);
			ed[{u, w}] = 1;
			ed[{w, u}] = 1;
			e.emplace_back(u, w);
			ans.emplace_back(u, w);
		} else if (!ed[{v, w}]) {
			merge(v, w);
			ed[{v, w}] = 1;
			ed[{w, v}] = 1;
			e.emplace_back(v, w);
			ans.emplace_back(v, w);
		} else {
			merge(u, w);
			ed[{u, w}] = 0;
			ed[{w, u}] = 0;
			e.emplace_back(u, w);
			ans.emplace_back(u, w);
		}
		cout << "Yes\n";
		cout << ans.size() << '\n';
		for (auto [u, v] : ans) {
			cout << u + 1 << ' ' << v + 1 << '\n';
		}
		return;
	}
}