//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <bits/stdc++.h>
using namespace std;




using ll = long long;


int bubble = 0;
#ifdef RODYA
#include "Templates/Debug Template.cpp"
#else
#define dbg(...) ++bubble;
#endif


#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()

using pii = pair<int, int>;



const int N = 3e5 + 10;

int group;
int n, m1, m2;
vec<int> g2[N], g[N];
map<pii, bool> used;
bitset<N> is;



struct DSU {
    int pr[N];
    DSU() {
    }
    void init() {
        for (int i = 1; i <= n; ++i) pr[i] = i;
    }
    int getPr(int v) {
        if (v == pr[v]) return v;
        return pr[v] = getPr(pr[v]);
    }
    bool unite(int x, int y) {
        x = getPr(x), y = getPr(y);
        if (x == y) return false;
        pr[y] = x;
        return true;
    }
} dsu;



vec<pii> ans;

void input() {
    cin >> n >> m1 >> m2;
    ans.clear();


    for (int i = 1; i <= n; ++i)
        is[i] = false;
    dsu.init();
    used.clear();
    for (int i = 1; i <= n; ++i)
        g2[i].clear(), g[i].clear();


    for (int i = 0; i < m1; ++i) {
        int x, y; cin >> x >> y;
        if (!dsu.unite(x, y)) {
            if (sz(ans) == 0) {
                ans.eb(x, y);
            }
        } else {
            used[mp(x, y)] = used[mp(y, x)] = true;
            g[x].eb(y); g[y].eb(x);
            dbg(10, x, y);
        }
    }


    map<pii, bool> wasE;
    for (int i = 0; i < m2; ++i) {
        int x, y; cin >> x >> y;
        g2[x].eb(y); g2[y].eb(x);
        wasE[mp(x, y)] = wasE[mp(y, x)] = true;
    }

    if (!ans.empty()) {
        auto [x, y] = ans[0];
        if (wasE.find(mp(x, y)) == used.end()) {
            g2[x].eb(y);
            g2[y].eb(x);
            dbg(20, x, y);
        } else ans.clear();
    }
}






void dfs(int v, int pr) {
    is[v] = true;
    for (auto& to : g2[v]) {
        if (is[to]) continue;
        used[mp(v, to)] = used[mp(to, v)] = true;
        dbg(v, to);
        dfs(to, v);
    }
}




void solve() {
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (used.find(mp(i, j)) != used.end()) continue;
            if (dsu.unite(i, j)) {
                ans.eb(i, j);
            }
        }
    }

    int cnt = 0;
    for (int i = 1; i <= n; ++i)
        if (dsu.getPr(i) == i) ++cnt;

    if (cnt != 1) {
        cout << "No" << endl;
        return;
    }


    cout << "Yes" << endl;
    assert(sz(ans) <= n);
    cout << sz(ans) << endl;
    for (auto& [x, y] : ans) cout << x << " " << y << endl;
}


mt19937_64 rnd(228);

void test() {
    input();



    vec<int> be;
    for (int i = 1; i <= n; ++i)
        if (sz(g[i]) == 0)
            be.eb(i);

    if (be.empty()) {
        dfs(1, -1);
        solve();
        return;
    }




    bool f = false;
    for (int _ =0; _ < 1000; ++_) {
        used.clear();
        for (int v = 1; v <= n; ++v) {
            is[v] = false;
//            for (auto& it : g[v]) used[mp(v, it)] = true;
//            for (auto& it : g2[v]) used[mp(v, it)] = true;
        }


        for (int i = 1; i <= n; ++i)
            shuffle(all(g2[i]), rnd);

        int ee = rnd() % n + 1;
        dfs(ee, -1);

        vec<int> cnt(n + 1);
        f = true;

        for (auto &[it, _]: used) {
            auto [x, y] = it;
            dbg(x, y);
            if (x < y) ++cnt[x], ++cnt[y];
        }


        dbg(be[0], cnt[be[0]]);
        for (auto& v : be)
            if (cnt[v] == n - 1) {
                f = false;
                break;
            }

        if (f) break;
    }
    if (!f) {
        cout << "No" << endl;
        return;
    }

    for (int v = 1; v <= n; ++v) {
        is[v] = false;
        for (auto& it : g[v])
            used[mp(v, it)] = true;
    }


    solve();
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif


    int t; cin >> t >> group;
    while (t--) test();

}
