#include <bits/extc++.h>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = long long;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

struct dsu {
    vector<ll> par, sz;

    dsu(ll n): par(n), sz(n, 1) {
        iota(par.begin(), par.end(), 0);
    }

    ll leader(ll v) {
        return v == par[v] ? v : (par[v] = leader(par[v]));
    }

    void unite(ll a, ll b) {
        a = leader(a), b = leader(b);

        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        par[b] = a;
        sz[a] += sz[b];
    }
};

void dfs_link(ll v, set<ll> &left, set<pair<ll, ll>> &res, set<pair<ll, ll>> &red) {
    while (!left.empty()) {
        for (ll u: left) {
            if (red.count({min(u, v), max(u, v)})) continue; // extra sus, slow

            res.insert({v, u});
            left.erase(u);

            dfs_link(u, left, res, red);
            goto nxt;
        }
        return;

        nxt:;
    }
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<ll>> g1(n), g2(n);

    for (ll i = 0; i < m1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }

    dsu d2(n);
    set<pair<ll, ll>> red;

    for (ll i = 0; i < m2; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;

        if (d2.leader(u) != d2.leader(v)) {
            d2.unite(u, v);
            g2[u].push_back(v);
            g2[v].push_back(u);

            red.insert({min(u, v), max(u, v)}); // sus
        }
    }

    set<pair<ll, ll>> res;
    set<ll> left;

    for (ll i = 1; i < n; i++) left.insert(i);

    dfs_link(0, left, res, red);

    if (left.size() > 0 && n == 3) {
        cout << "No" << endl;
        return;
    } else {
        res.insert({0, *left.begin()}); // sus
    }

    if (res.size() > n) exit(-1);

    cout << "Yes\n";
    cout << res.size() << "\n";

    for (auto [u, v]: res) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }

    #ifdef DBG
    cout << endl;
    #endif
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    ll t, g; cin >> t >> g; while (t--) solve();
}
