#include <algorithm>
#include <bits/extc++.h>
#include <utility>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = long long;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

struct dsu {
    vector<ll> par, sz;

    dsu(ll n): par(n), sz(n, 1) {
        iota(par.begin(), par.end(), 0);
    }

    ll leader(ll v) {
        return v == par[v] ? v : (par[v] = leader(par[v]));
    }

    void unite(ll a, ll b) {
        a = leader(a), b = leader(b);

        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        par[b] = a;
        sz[a] += sz[b];
    }
};

void dfs_link(ll v, set<ll> &left, set<pair<ll, ll>> &res, set<pair<ll, ll>> &red) {
    while (!left.empty()) {
        for (ll u: left) {
            if (red.count({min(u, v), max(u, v)})) continue; // extra sus, slow

            res.insert({min(u, v), max(u, v)});
            left.erase(u);

            dfs_link(u, left, res, red);
            goto nxt;
        }
        return;

        nxt:;
    }
}

ll GRP;
ll n, m1, m2;


ll vis(ll v, vector<vector<ll>> &g, set<ll> &used) {
    if (used.count(v)) return 0;
    used.insert(v);

    ll res = 1;
    for (ll u: g[v]) {
        res += vis(u, g, used);
    }
    return res;
}

ll vismat(ll v, vector<vector<bool>> &mat, set<ll> &used) {
    if (used.count(v)) return 0;
    used.insert(v);

    ll res = 1;
    for (ll u = 0; u < mat.size(); u++) {
        if (mat[v][u]) res += vismat(u, mat, used);
    }
    return res;
}

void solve_3() {
    vector<vector<bool>> mat1(n, vector<bool>(n, false));
    vector<vector<bool>> mat2(n, vector<bool>(n, false));
    vector<vector<ll>> g1(n, vector<ll>());
    for (ll i = 0; i < m1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        mat1[u][v] = true;
        mat1[v][u] = true;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }

    for (ll i = 0; i < m2; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        mat2[u][v] = true;
        mat2[v][u] = true;
    }

    set<ll> used0;
    if (vis(0, g1, used0) == n) {
        cout << "Yes\n0\n";
        return;
    }

    // 9 vars

    vector<pair<ll, ll>> edges = {{0, 1}, {0, 2}, {1, 2}};

    sort(edges.begin(), edges.end());

    while (next_permutation(edges.begin(), edges.end())) {
        for (ll cnt = 0; cnt <= 3; cnt++) {
            set<ll> u1;
            for (ll ei = 0; ei < cnt; ei++) {
                mat1[edges[ei].first][edges[ei].second].flip();
                mat1[edges[ei].second][edges[ei].first].flip();

                mat2[edges[ei].first][edges[ei].second].flip();
                mat2[edges[ei].second][edges[ei].first].flip();

                set<ll> u0;
                if (vismat(0, mat2, u0) != n) {
                    goto nxt;
                }
            }

            if (vismat(0, mat1, u1) != n) {
                goto nxt;
            }

            cout << "Yes\n";
            cout << cnt << '\n';
            for (ll ei = 0; ei < cnt; ei++) {
                cout << edges[ei].first + 1 << ' ' << edges[ei].second << '\n';
            }
            return;
            nxt:;
        }
    }

    cout << "No\n";
}

void solve() {
    cin >> n >> m1 >> m2;

    if (n == 3) { solve_3(); return; }

    dsu d1(n), d2(n);
    set<pair<ll, ll>> red, blue;

    vector<vector<ll>> g1(n, vector<ll>());

    for (ll i = 0; i < m1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        blue.insert({min(u, v), max(u, v)});
        // if (d1.leader(u) != d1.leader(v)) {
        //     d1.unite(u, v);
        //     blue.insert({min(u, v), max(u, v)}); // sus
        // }

        g1[u].push_back(v);
        g1[v].push_back(u);
    }

    for (ll i = 0; i < m2; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;

        if (d2.leader(u) != d2.leader(v)) {
            d2.unite(u, v);
            red.insert({min(u, v), max(u, v)}); // sus
        }
    }

    set<ll> used0;
    if (vis(0, g1, used0) == n) {
        cout << "Yes\n0\n";
        return;
    }

    for (ll start = 0; start < n; start++) {
        set<pair<ll, ll>> res;
        set<ll> left;

        for (ll i = 0; i < n; i++) left.insert(i);
        left.erase(start);

        dfs_link(start, left, res, red);
        if (left.size() > 1) continue;

        // if (left.size() > 0 && n == 3) {
        //     cout << "No" << endl;
        //     return;
        // } else if (left.size() > 0) {
        //     res.insert({0, *left.begin()}); // sus
        // }

        vector<pair<ll, ll>> force;

        if (left.size() > 0) { // then 1
            for (ll i = 0; i < n; i++) { // todo
                if (i == *left.begin()) continue;
                for (ll j = i + 1; j < n; j++) {
                    if (j == *left.begin()) continue;

                    if (red.count({i, j})) {
                        force.push_back({i, *left.begin()});
                        goto normal;
                    }

                    if (res.count({i, j}) == 0) {
                        force.push_back({i, j});
                        force.push_back({i, *left.begin()});
                        goto normal;
                    }
                }
            }

            // if (GRP > 0 && n == 3) {
            //     continue;
            // }

            continue;
            // cout << "No\n";
        }

        normal:
        // if (res.size() > n) exit(-1);

        cout << "Yes\n";
        // cout << res.size() << "\n";

        vector<pair<ll, ll>> final;

        for (auto [u, v]: res) {
            if (blue.count({min(u, v), max(u, v)})) continue;
            // cout << u + 1 << ' ' << v + 1 << '\n';
            final.push_back({u, v});
        }

        for (auto [u, v]: force) {
            // cout << u + 1 << ' ' << v + 1 << '\n';
            final.push_back({u, v});
        }

        cout << final.size() << '\n';
        for (auto [u, v]: final) {
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
        return;
    }

    cout << "No\n";

    #ifdef DBG
    cout << endl;
    #endif
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    ll t; cin >> t >> GRP; while (t--) solve();
}
