#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

struct dsu {
    vector<int> p;
    explicit dsu(int n) {
        p.assign(n, 0);
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
    }
    int id(int x) {
        return x == p[x] ? x : p[x] = id(p[x]);
    }
    void unite(int x, int y) {
        p[id(y)] = id(x);
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> e;
    vector<int> g1(n), g2(n);
    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            e.emplace_back(u, v);
        }
    }
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v, u--, v--;
        g1[u] |= 1 << v;
        g1[v] |= 1 << u;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v, u--, v--;
        g2[u] |= 1 << v;
        g2[v] |= 1 << u;
    }
    sort(e.begin(), e.end(), [&](pair<int, int> lhs, pair<int, int> rhs) {
        auto [u1, v1] = lhs;
        auto [u2, v2] = rhs;
        int f1 = (g2[u1] >> v1) & 1;
        int f2 = (g2[u2] >> v2) & 1;
        if (f1 && !f2) {
            return false;
        }
        return true;
    });
    int N = (int)e.size();
    for (int mask = 0; mask < (1 << N); mask++) {
        vector<int> gg1 = g1, gg2 = g2;
        for (int i = 0; i < N; i++) {
            if (mask & (1 << i)) {
                auto [u, v] = e[i];
                gg1[u] ^= 1 << v;
                gg1[v] ^= 1 << u;
                gg2[u] ^= 1 << v;
                gg2[v] ^= 1 << u;
            }
        }
        dsu s1(n), s2(n);
        int c1 = n, c2 = n;
        for (int v = 0; v < n; v++) {
            for (int to = 0; to < n; to++) {
                if (gg1[v] & (1 << to)) {
                    if (s1.id(v) != s1.id(to)) {
                        c1--;
                        s1.unite(v, to);
                    }
                }
            }
        }
        for (int v = 0; v < n; v++) {
            for (int to = 0; to < n; to++) {
                if (gg2[v] & (1 << to)) {
                    if (s2.id(v) != s2.id(to)) {
                        c2--;
                        s2.unite(v, to);
                    }
                }
            }
        }
        if (c1 == 1 && c2 == 1 && __builtin_popcount(mask) <= n) {
            cout << "Yes\n" << __builtin_popcount(mask) << '\n';
            for (int i = 0; i < N; i++) {
                if (mask & (1 << i)) {
                    auto [u, v] = e[i];
                    cout << u + 1 << ' ' << v + 1 << '\n';
                }
            }
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
/*

3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

1 0
4 2 3
1 2
3 4
1 3
1 4
2 3

 */