#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;

vector<vector<bool>> g1, g2;

int get(int v, vector<int> & p) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v], p);
}

void unite(int u, int v, vector<int> & p, vector<int> & sz) {
    v = get(v, p);
    u = get(u, p);
    if (u == v) {
        return;
    }
    if (sz[v] > sz[u]) {
        swap(u, v);
    }
    sz[u] += sz[v];
    p[v] = u;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n, vector<bool> (n, false)), g2.resize(n, vector<bool> (n, false));
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a][b] = true;
        g1[b][a] = true;
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g2[a][b] = true;
        g2[b][a] = true;
    }

    vector<int> p1(n, -1), sz1(n, 1), p2(n, -1), sz2(n, 1);
    for (int i = 0; i < n; i++) {
        p1[i] = i;
        p2[i] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (g1[i][j]) {
                unite(i, j, p1, sz1);
            }
            if (g2[i][j]) {
                unite(i, j, p2, sz2);
            }
        }
    }
    vector<pii> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i + 2; j < n; j++) {
            if (get(i, p1) != get(j, p1) && !g2[i][j]) {
                unite(i, j, p1, sz1);
                ans.push_back({i, j});
            }
        }
    }
    set<int> vals = set<int>(p1.begin(), p1.end());
    if (vals.size() > 1) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n" << ans.size() << "\n";
    for (auto e : ans) {
        cout << e.first + 1 << " " << e.second + 1 << "\n";
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);




    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }






    return 0;
}
