#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x = 0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
	ll operator%(Point oth)
	{
		return x * oth.y - y * oth.x;
	}
	Point operator+(Point oth)
	{
		return Point(x + oth.x, y + oth.y);
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}
int gr;

void solve()
{
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	vector<vector<int>> g1(n),g2(n);
	vector<vector<bool>> gg(n, vector<bool>(n));
	for (int i = 0; i < m1; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g1[a].push_back(b);
		g1[b].push_back(a);
		gg[a][b] = true;
		gg[b][a] = true;
	}
	for (int i = 0; i < m2; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g2[a].push_back(b);
		g2[b].push_back(a);
	}
	if (gr == 2)
	{
		vector<pair<int, int>> ans;
		for (int i = 0; i < n - 1; i++)
		{
			if (!gg[i][i + 1])
			{
				ans.push_back({ i,i + 1 });
			}
		}
		cout << "Yes\n";
		cout << ans.size() << '\n';
		for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	cin >> gr;
	while (t--) solve();
}