#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x = 0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
	ll operator%(Point oth)
	{
		return x * oth.y - y * oth.x;
	}
	Point operator+(Point oth)
	{
		return Point(x + oth.x, y + oth.y);
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}
int gr;

vector<int> p, sz;
int pr(int v)
{
	if (p[v] == v) return v;
	return p[v] = pr(p[v]);
}
bool merge(int v, int u)
{
	v = pr(v);
	u = pr(u);
	if (v == u) return false;
	if (sz[v] < sz[u]) swap(v, u);
	p[u] = v;
	sz[v] += sz[u];
	return true;
}


void solve()
{
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	vector<set<int>> g(n);
	p.assign(n,0);
	sz.assign(n, 1);
	for (int i = 0; i < n; i++) p[i] = i;
	vector<vector<int>> g1(n),g2(n);
	vector<vector<bool>> gg1(n, vector<bool>(n)), gg2(n, vector<bool>(n));
	for (int i = 0; i < m1; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g1[a].push_back(b);
		g1[b].push_back(a);
		merge(a, b);
		gg1[a][b] = true;
		gg1[b][a] = true;
	}
	for (int i = 0; i < m2; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g2[a].push_back(b);
		g2[b].push_back(a);
		gg2[a][b] = true;
		gg2[b][a] = true;
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			int v = pr(i), u = pr(j);
			if (v == u) continue;
			if (!gg2[i][j])
			{
				g[i].insert(j);
				g[j].insert(i);
			}
		}
	}
	vector<pair<int,int>> ans;
	for (int i = 0; i < n; i++)
	{
		for (int j : g[i])
		{
			if (merge(i, j))
			{
				ans.push_back({ i,j });
			}
		}
	}
	int pp = pr(0);
	for (int i = 1; i < n; i++)
	{
		if (pr(i) != pp)
		{
			cout << "No\n";
			return;
		}
	}
	cout << "Yes\n";
	cout << ans.size() << '\n';
	for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	cin >> gr;
	while (t--) solve();
}