#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

struct CHT {
    int n;
    vector <int> p;
    vector <vector <int>> a;
    CHT(int n_ = 0) {
        n = n_;
        p.resize(n);
        a.resize(n);
        for (int i = 0; i < n; i++) {
            a[i].push_back(i);
            p[i] = i;
        }
    }
    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }
    void merge(int v, int u) {
        v = pr(v);
        u = pr(u);
        if (v == u) {
            return;
        }
        if (a[v].size() < a[u].size()) {
            swap(v, u);
        }
        for (auto zn : a[u]) {
            a[v].push_back(zn);
        }
        a[u].clear();
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map <int, bool> g1[n];
    map <int, bool> g2[n];
    vector <pair <int, int>> ans;
    CHT s = n;
    int a, b;
    for (int i = 0; i < m1; i++) {
        cin >> a >> b;
        a--;
        b--;
        g1[a][b] = true;
        g1[b][a] = true;
        s.merge(a, b);
    }
    for (int i = 0; i < m2; i++) {
        cin >> a >> b;
        a--;
        b--;
        g2[a][b] = true;
        g2[b][a] = true;
    }
    if (n <= 3) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    int last = -1;
    for (int i = 0; i < n; i++) {
        int v = s.pr(i);
        if (s.a[v].size() == 1) {
            int nado = 0;
            for (auto [u, zn] : g2[v]) {
                if (u != nado) {
                    break;
                }
                nado++;
            }
            if (nado != n) {
                g1[v][nado] = true;
                g1[nado][v] = true;
                g2[v][nado] = true;
                g2[nado][v] = true;
                ans.push_back({nado, v});
                s.merge(v, nado);
            } else {
                if (last == -1 || last == v) {
                    last = v;
                } else {
                    g1[v][last] = true;
                    g1[last][v] = true;
                    g2[v][last] = false;
                    g2[last][v] = false;
                    s.merge(v, last);
                    ans.push_back({last, v});
                }
            }
        }
    }
    int lastmn = -1;
    for (int i = 0; i < n; i++) {
        int v = s.pr(i);
        if (s.a[v].size() == 1) {
            continue;
        }
        if (lastmn == -1 || lastmn == v) {
            lastmn = v;
            continue;
        }
        bool ok = false;
        for (int j1 = 0; j1 < 2; j1++) {
            for (int j2 = 0; j2 < 2; j2++) {
                if (!g1[s.a[v][j1]][s.a[lastmn][j2]] && !g2[s.a[v][j1]][s.a[lastmn][j2]]) {
                    ok = true;
                    g1[s.a[v][j1]][s.a[lastmn][j2]] = true;
                    g1[s.a[v][j2]][s.a[lastmn][j1]] = true;
                    g2[s.a[v][j1]][s.a[lastmn][j2]] = true;
                    g2[s.a[v][j2]][s.a[lastmn][j1]] = true;
                    ans.push_back({s.a[v][j2], s.a[lastmn][j1]});
                    break;
                }
            }
            if (ok) {
                break;
            }
        }
        if (!ok) {
            ans.push_back({s.a[v][0], s.a[lastmn][0]});
            g1[s.a[v][0]][s.a[lastmn][0]] = true;
            g1[s.a[v][0]][s.a[lastmn][0]] = true;
            g2[s.a[v][0]][s.a[lastmn][0]] = false;
            g2[s.a[v][0]][s.a[lastmn][0]] = false;
        }
        lastmn = s.pr(v);
    }
    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
