#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

struct CHT {
    int n;
    vector <int> p;
    vector <vector <int>> a;
    CHT(int n_ = 0) {
        n = n_;
        p.resize(n);
        a.resize(n);
        for (int i = 0; i < n; i++) {
            a[i].push_back(i);
            p[i] = i;
        }
    }
    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }
    void merge(int v, int u) {
        //cout << v << " " << u << "\n";
        v = pr(v);
        u = pr(u);
        if (v == u) {
            return;
        }

        if (a[v].size() < a[u].size()) {
            swap(v, u);
        }
        for (auto zn : a[u]) {
            a[v].push_back(zn);
        }
        a[u].clear();
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map <int, bool> g1[n];
    map <int, bool> g2[n];
    vector <pair <int, int>> ans;
    CHT s = n;
    int a, b;
    for (int i = 0; i < m1; i++) {
        cin >> a >> b;
        a--;
        b--;
        g1[a][b] = true;
        g1[b][a] = true;
        s.merge(a, b);
    }
    for (int i = 0; i < m2; i++) {
        cin >> a >> b;
        a--;
        b--;
        g2[a][b] = true;
        g2[b][a] = true;
    }
    if (n <= 3) {
        for (int i1 = 0; i1 < 3; i1++) {
            for (int i2 = i1 + 1; i2 < 3; i2++) {
                if (!g1[i1][i2] && !g2[i1][i2]) {
                    g1[i1][i2] = true;
                    g1[i2][i1] = true;
                    g2[i1][i2] = true;
                    g2[i2][i1] = true;
                    m1++;
                    m2++;
                    ans.push_back({i1, i2});
                }
            }
        }
        if (m1 >= 2) {
            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto [u, v] : ans) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
        } else if (m2 == 2){
            cout << "No\n";
        } else if (m1 == 0) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            if (!g1[0][1]) {
                ans.push_back({0, 1});
            } else {
                ans.push_back({0, 2});
            }
            cout << ans.size() << "\n";
            for (auto [u, v] : ans) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
        }
        return;
    }
    cout << "Yes\n";
    int last = -1;
    for (int i = 0; i < n; i++) {
        int v = s.pr(i);
        if (s.a[v].size() == 1) {
            int nado = 0;
            for (auto [u, zn] : g2[v]) {
                if (nado == v) {
                    nado++;
                }
                if (u != nado) {
                    break;
                }
                nado++;
            }
            if (nado == v) {
                nado++;
            }
            //cout << v << " " << nado << "\n";
            if (nado != n) {
                g1[v][nado] = true;
                g1[nado][v] = true;
                g2[v][nado] = true;
                g2[nado][v] = true;
                ans.push_back({nado, v});
                s.merge(v, nado);
            } else {
                if (last == -1) {
                    last = v;
                } else if (last != v) {
                    g1[v][last] = true;
                    g1[last][v] = true;
                    g2[v][last] = true;
                    g2[last][v] = true;
                    s.merge(v, last);
                    ans.push_back({last, v});
                    last = -1;
                }
            }
        }
    }

    int lastmn = -1;
    for (int i = 0; i < n; i++) {
        int v = s.pr(i);
        if (s.a[v].size() == 1) {
            continue;
        }
        if (lastmn == -1) {
            lastmn = v;
            continue;
        }
        if (lastmn == v) {
            continue;
        }
        bool ok = false;
        for (int j1 = 0; j1 < 2; j1++) {
            int v1 = s.a[v][j1];
            for (int j2 = 0; j2 < 2; j2++) {
                int v2 = s.a[lastmn][j2];
                if (g2[v1].find(v2) == g2[v1].end()) {
                    ok = true;
                    g1[v1][v2] = true;
                    g1[v2][v1]= true;
                    g2[v1][v2] = true;
                    g2[v2][v1]= true;
                    ans.push_back({v1, v2});
                    s.merge(v1, v2);
                    break;
                }
            }
            if (ok) {
                break;
            }
        }
        if (!ok) {
            int v1 = s.a[v][0];
            int v2 = s.a[lastmn][0];
            g1[v1][v2] = true;
            g1[v2][v1]= true;
            g2[v1][v2] = false;
            g2[v2][v1]= false;
            ans.push_back({v1, v2});
            s.merge(v1, v2);
        }
        lastmn = s.pr(lastmn);
    }
    if (last != -1) {
        bool ok = false;
        for (int i = 0; i < n; i++) {
            if (last != i) {
                for (auto [u, zn] : g2[i]) {
                    if (u == last) {
                        continue;
                    }
                    if (zn) {
                        ans.push_back({i, last});
                        ok = true;
                        break;
                    }
                }
                break;
            }
        }
        if (!ok) {
            for (int i = 0; i < n; i++) {
                if (last != i) {
                    for (auto [u, zn] : g1[i]) {
                        if (zn) {
                            ans.push_back({u, i});
                            ans.push_back({i, last});
                            break;
                        }
                    }
                    break;
                }
            }
        }

    }
    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
