#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

map <pair <int, int>, int> U1;
map <pair <int, int>, int> U2;
vector <vector <int>> g;
vector <pair <int, int>> Add;
vector <int> used;
vector <vector <int>> M1;
vector <vector <int>> M2;
vector <bool> UsedEdge;
vector <pair <int, int>> edge;
int st = -1;
int bad = -1;
int ns = -1;
int St = 0;

void dfs(int cur, int d) {
    if (cur == St) {
    } else if (d == 1 && st == -1) {
        bad = cur;
    } else if (d == 2 && st == -1) {
        st = cur;
        if (U1[{st, St}] == 0 && U1[{St, st}] == 0) {
            Add.push_back({st, St});
        }
    } else {
        if (U1[{cur, st}] == 0 && U1[{st, cur}] == 0) {
            if (U2[{cur, st}] == 0 && U2[{st, cur}] == 0) {
                Add.push_back({cur, st});
            } else {
                if (U1[{cur, St}] == 0 && U1[{St, cur}] == 0) {
                    Add.push_back({cur, St});
                }
            }
        }
        if (ns == -1 && (U2[{cur, bad}] == 0 && U2[{bad, cur}])) {
            ns = cur;
        }
    }
    used[cur] = 1;
    for (auto ti : g[cur]) {
        if (used[ti]) {
            continue;
        }
        dfs(ti, d + 1);
    }
}

int dfs1(int cur, vector <int>& Used) {
    Used[cur] = 1;
    int cnt = 1;
    for (int i = 0; i < g.size(); ++i) {
        if (Used[i] == 1) {
            continue;
        }
        if (M1[cur][i] == 1) {
            cnt += dfs1(i, Used);
        }
    }
    return cnt;
}

int dfs2(int cur, vector <int>& Used) {
    Used[cur] = 1;
    int cnt = 1;
    for (int i = 0; i < g.size(); ++i) {
        if (Used[i] == 1) {
            continue;
        }
        if (M2[cur][i] == 1) {
            cnt += dfs2(i, Used);
        }
    }
    return cnt;
}

bool check1() {
    vector <int> Used(g.size(), 0);
    if (dfs1(0, Used) < g.size()) {
        return false;
    }
    return true;
}

bool check2() {
    vector <int> Used(g.size(), 0);
    if (dfs2(0, Used) < g.size()) {
        return false;
    }
    return true;
}


bool f(int c, int num, int N) {
    if (!check2()) {
        return false;
    }
    if (check1()) {
        return true;
    }
    if (num == N) {
        return false;
    }
    for (int i = 0; i < c; ++i) {
        if (UsedEdge[i] == 1) {
            continue;
        }
        Add.push_back(edge[i]);
        M1[edge[i].first][edge[i].second] ^= 1;
        M1[edge[i].second][edge[i].first] ^= 1;
        M2[edge[i].first][edge[i].second] ^= 1;
        M2[edge[i].second][edge[i].first] ^= 1;
        UsedEdge[i] = 1;
        if (f(c, num + 1, N)) {
            return true;
        }
        Add.pop_back();
        UsedEdge[i] = 0;
        M1[edge[i].first][edge[i].second] ^= 1;
        M1[edge[i].second][edge[i].first] ^= 1;
        M2[edge[i].first][edge[i].second] ^= 1;
        M2[edge[i].second][edge[i].first] ^= 1;
    }
    return false;
}

void solveM(int n, int m1, int m2) {
    M1 = {};
    M2 = {};
    M1.resize(n);
    M2.resize(n);
    for (int i = 0; i < n; ++i) {
        M1[i].resize(n, 0);
        M2[i].resize(n, 0);
    }
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        M1[a][b] = 1;
        M1[b][a] = 1;
    }
    g.resize(n);
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        M2[a][b] = 1;
        M2[b][a] = 1;
    }
    UsedEdge = {};
    edge = {};
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edge.push_back({i, j});
        }
    }
    UsedEdge.resize(edge.size(), 0);
    if (f(n * (n - 1) / 2, 0, n)) {
        cout << "Yes" << endl;
        cout << Add.size() << endl;
        for (int i = 0; i < Add.size(); ++i) {
            cout << Add[i].first + 1 << " " << Add[i].second + 1 << endl;
        }
    } else {
        cout << "No" << endl;
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    st = -1;
    bad = -1;
    ns = -1;
    g = {};
    used = {};
    Add = {};
    if (n <= 5) {
        solveM(n, m1, m2);
        return;
    }
    used.resize(n, 0);
    U1.clear();
    U2.clear();
    g.resize(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        U1[{a, b}] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        U2[{a, b}] = 1;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    ns = -1;
    for (int i = 0; i < n; ++i) {
        if (i == bad) {
            continue;
        }
        if (U2[{bad, i}] == 0 && U2[{i, bad}] == 0) {
            ns = i;
            break;
        }
    }
    //cout << ns + 1 << " ns " << bad + 1 << " bad " << st + 1 << " st " << endl;
    if (ns == -1 || st == -1) {
        int S;
        if (st == -1) {
            S = 0;
        } else {
            S = bad;
            St = bad;
            dfs(bad, 0);
        }
        Add = {};
        vector <int> q;
        for (int i = 0; i < n - 1; ++i) {
            if (i == S) {
                continue;
            }
            q.push_back(i);
        }
        for (int i = 0; i < q.size() - 1; ++i) {
            if (U1[{q[i], q[i + 1]}] == 0 && U1[{q[i + 1], q[i]}] == 0) {
                Add.push_back({q[i], q[i + 1]});
            }
        }
        if (U2[{q[0], q[q.size() - 1]}] == 0 && U2[{q[q.size() - 1], q[0]}] == 0) {
            Add.push_back({q[0], q[q.size() - 1]});
        }
        if (U1[{q[0], S}] == 0 && U1[{S, q[0]}] == 0) {
                Add.push_back({q[0], S});
            }
    } else {
        if (U1[{bad, ns}] == 0 && U1[{ns, bad}] == 0) {
            Add.push_back({bad, ns});
        }
    }
    cout << "Yes" << endl;
    cout << Add.size() << endl;
    for (int i = 0; i < Add.size(); ++i) {
        cout << Add[i].first + 1 << " " << Add[i].second + 1 << endl;
    }
}

int main() {
    int t, g;
    cin >> t >> g;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
