// #include <bits/stdc++.h>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct segtree {
    ll sz = 1;
    vector<ll> tr;

    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
    }

    ll sumseg(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return 0;
        }
        int mid = (r + l) / 2;
        ll m1 = sumseg(2 * v + 1, l, mid, lseg, rseg);
        ll m2 = sumseg(2 * v + 2, mid, r, lseg, rseg);
        return m1 + m2;
    }

    ll sumseg(int lseg, int rseg) {
        sumseg(0, 0, sz, lseg, rseg);
    }

    void ch(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tr[v] = x;
            return;
        }
        int mid = (r + l) / 2;
        if (ind < mid) {
            ch(2 * v + 1, l, mid, ind, x);
        } else {
            ch(2 * v + 2, mid, r, ind, x);
        }
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
    }

    void ch(int ind, int x) {
        ch(0, 0, sz, ind, x);
    }
};

vector<pair<ll, ll>> ans;
struct xui{
    vector<set<ll>> gr1;
    vector<set<ll>> gr2;
    xui(ll n){
        gr1.resize(n);
        gr2.resize(n);
    }

    void ch(ll a, ll b){
        if (gr1[a].find(b) != gr1[a].end()){
            gr1[a].erase(b);
        }
        else{
            gr1[a].insert(b);
        }
        if (gr2[a].find(b) != gr2[a].end()){
            gr2[a].erase(b);
        }
        else{
            gr2[a].insert(b);
        }
    }

    bool check2(ll a, ll b){
        return gr2[a].find(b) != gr2[a].end();
    }

    void swedge(ll a, ll b){
        ans.push_back({a, b});
        ch(a, b);
        ch(b, a);
    }
};


xui mach(1);
vector<bool> used;
pair<ll, ll> dfs(int v){
    used[v] = true;
    pair<ll, ll> d = {v, v};
    for (auto el : mach.gr1[v]){
        if (!used[el]){
            pair<ll, ll> x = dfs(el);
            d.first = min(d.first, x.first);
            d.second = max(d.second, x.second);
        }
    }
    return d;
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    mach = xui(n);
    used.clear();
    ans.clear();
    used.resize(n, false);
    for (int i = 0; i < m1; i++){
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        mach.gr1[a].insert(b);
        mach.gr1[b].insert(a);
    }
    for (int i = 0; i < m2; i++){
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        mach.gr2[a].insert(b);
        mach.gr2[b].insert(a);
    }
    vector<ll> stek;
    for (int el = 0; el < n; el++){
        if (mach.gr1[el].size() == 0) {
            stek.push_back(el);
            if (stek.size() == 2) {
                int u = stek.back();
                stek.pop_back();
                int v = stek.back();
                stek.pop_back();
                int mid = 0;
                if (mid == u || mid == v) {
                    mid++;
                }
                if (mid == u || mid == v) {
                    mid++;
                }
                if (!mach.check2(u, v)) {
                    mach.swedge(u, v);
                } else if (!mach.check2(u, mid)) {
                    mach.swedge(u, mid);
                    stek.push_back(v);
                } else {
                    mach.swedge(mid, v);
                    stek.push_back(u);
                }
            }
        }
    }
    if (!stek.empty()) {
        int v = stek.back();
        if (mach.gr2[v].size() != n - 1){
            for (int j = 0; j < n; j++){
                if (!mach.check2(v, j) && v != j){
                    mach.swedge(v, j);
                    break;
                }
            }
        }
        else{
            bool is = false;
            for (int j = 0; j < n; j++){
                if (mach.gr2[j].size() != 1 && j != v){
                    mach.swedge(v, j);
                    is = true;
                    break;
                }
            }
            if (!is){
                vector<ll> good;
                for (int j = 0; j < n; j++){
                    if (mach.gr1[j].size() > 1){
                        good.push_back(j);
                    }
                }
                if (good.size() > 1){
                    mach.swedge(good[0], good[1]);
                    mach.swedge(good[0], v);
                }
                else {
                    is = false;
                    for (int j = 0; j < n; j++){
                        if (mach.gr1[j].size() == 1){
                            set<ll> nn;
                            nn.insert(*mach.gr1[j].begin());
                            nn.insert(v);
                            nn.insert(j);
                            int mid = 0;
                            while (nn.find(mid) != nn.end()){
                                mid++;
                            }
                            if (mid != n){
                                is = true;
                                mach.swedge(mid, j);
                                mach.swedge(mid, v);
                                break;
                            }
                        }
                    }
                    if (!is) {
                        cout << "No\n";
                        return;
                    }
                }
            }
        }
    }
    vector<pair<ll, ll>> had;
    for (int i = 0; i < n; i++){
        if (!used[i]){
            had.push_back(dfs(i));
        }
    }

    for (int j = 0; j < had.size() - 1; j++){
        if (!mach.check2(had[j].first, had[j + 1].first)){
            mach.swedge(had[j].first, had[j + 1].first);
        }
        else if (!mach.check2(had[j].first, had[j + 1].second)){
            mach.swedge(had[j].first, had[j + 1].second);
        }
        else if (!mach.check2(had[j].second, had[j + 1].first)){
            mach.swedge(had[j].second, had[j + 1].first);
        }
        else{
            mach.swedge(had[j].second, had[j + 1].second);
        }
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto el : ans){
        cout << el.first + 1 << " " << el.second + 1 << "\n";
    }


}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    int g;
    cin >> g;
    while (t--) {
        solve();
    }
}
