#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <stack>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <string>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;
ll n;
vector <vector <ll> > ber, cher;
vector <pair <ll, ll> > edges;
bool done = 0;

void dfs(ll cur, vector <bool> &used, vector <vector <ll> > &gr)
{
    used[cur] = 1;
    for (ll i = 0; i < n; i++)
    {
        if (gr[cur][i] == 1 && !used[i]) dfs(i, used, gr);
    }
}

bool togetherb()
{
    vector <bool> used(n, 0);
    dfs(0, used, ber);
    bool flag = 1;
    for (auto i : used)
    {
        if (!i) flag = 0;
    }
        return flag;
}
bool togetherc()
{
    vector <bool> used(n, 0);
    bool flag = 1;
    dfs(0, used, cher);

    for (auto i : used)
    {
        if (!i) flag = 0;
    }
    return flag;
}

void ch(pair <ll, ll> p)
{
    ll a = p.first;
    ll b = p.second;
    ber[a][b] = 1 - ber[a][b];
    ber[b][a] = 1 - ber[b][a];
    cher[a][b] = 1 - cher[a][b];
    cher[b][a] = 1 - cher[b][a];
}

void print(vector <ll> &all)
{
    cout << "Yes" << '\n' << all.size() << '\n';
    for (auto i : all)
    {
        cout << edges[i].first + 1 << " " << edges[i].second + 1 << '\n';
    }
}

void rec(ll cnt, vector <ll> &all)
{
    if (cnt == n) return;
    //for (auto i : all) cout << i << " ";
    //cout << endl;
    if (done) return;
    for (ll i = 0; i < edges.size() && !done; i++)
    {
        ch(edges[i]);
        bool tb = togetherb();
        bool tc = togetherc();
        if (tb && tc)
        {
            done = 1;
            all.push_back(i);
            print(all);
        }
        else if (tc)
        {
            all.push_back(i);
            rec(cnt + 1, all);
            all.pop_back();
        }
        ch(edges[i]);
        
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t, g;
    cin >> t >> g;
    if (g <= 1) {
        while (t--)
        {
            ll m1, m2;
            cin >> n >> m1 >> m2;
            ber = vector <vector <ll> >(n, vector <ll> (n, 0));
            cher = vector <vector <ll> >(n, vector <ll> (n, 0));
            for (ll i = 0; i < m1; i++)
            {
                ll a, b;
                cin >> a >> b;
                a--; b--;
                ber[a][b] = 1;
                ber[b][a] = 1;
                
            }
            for (ll i = 0; i < m2; i++)
            {
                ll a, b;
                cin >> a >> b;
                a--; b--;
                cher[a][b] = 1;
                cher[b][a] = 1;
            }
            edges.clear();
            for (ll i = 0; i < n; i++)
            {
                for (ll j = i + 1; j < n; j++)
                {
                    edges.push_back({ i, j });
                }
            }
            ll m = edges.size();
            done = 0;
            vector <ll> all;
            rec(0, all);
            if (!done) cout << "No" << '\n';
        }
    }
    if (g == 2)
    {
        while (t--)
        {
            ll m1, m2;
            cin >> n >> m1 >> m2;
            ber = vector <vector <ll> >(n, vector <ll>(n, 0));
            cher = vector <vector <ll> >(n, vector <ll>(n, 0));
            for (ll i = 0; i < m1; i++)
            {
                ll a, b;
                cin >> a >> b;
                a--; b--;
                ber[a][b] = 1;
                ber[b][a] = 1;

            }
            for (ll i = 0; i < m2; i++)
            {
                ll a, b;
                cin >> a >> b;
                a--; b--;
                cher[a][b] = 1;
                cher[b][a] = 1;
            }
            if (n <= 5)
            {
                edges.clear();
                for (ll i = 0; i < n; i++)
                {
                    for (ll j = i + 1; j < n; j++)
                    {
                        edges.push_back({ i, j });
                    }
                }
                ll m = edges.size();
                done = 0;
                vector <ll> all;
                rec(0, all);
                if (!done) cout << "No" << '\n';
            }
            else {
                vector <pair <ll, ll> > ans;
                for (ll i = 0; i < n - 1; i++)
                {
                    if (ber[i + 1][i] == 0) ans.push_back({ i, i + 1 });
                }
                cout << "Yes" << '\n' << ans.size() << '\n';
                for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << '\n';
            }
        }
    }
}

