#pragma GCC optimized("O3")

#include <random>
#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const ll maxn = 2e5 + 1, inf = 1e18, mod = 1e9 + 7;

//template<typename T>
//int sz(T a) {
//    return (int) a.size();
//}

struct edge {
    int u, v;
};
vector<edge> ed1;
vector<edge> ed2;
vector<int> p;
vector<int> sz;
set<pair<int, int>> ostov;
vector<int> c;

int get_p(int a) {
    if (p[a] == a)
        return a;
    p[a] = get_p(p[a]);
    return p[a];
}

void join(int a, int b) {
    int pa = get_p(a);
    int pb = get_p(b);
    if (sz[pa] > sz[pb]) {
        p[b] = pa;
        sz[pa] += sz[pb];
    } else {
        p[a] = pb;
        sz[pb] += sz[pa];
    }
}

void build() {
    int n = (int) ed2.size();
    for (int i = 0; i < n; ++i) {
        if (get_p(ed2[i].u) != get_p(ed2[i].v)) {
            join(ed2[i].u, ed2[i].v);
            pair<int, int> k = {ed2[i].u, ed2[i].v};
            if (k.first > k.second)
                swap(k.first, k.second);
            ostov.insert(k);
        }
    }
}

vector<vector<int>> g;
vector<vector<int>> comp;

void dfs(int v, int col) {
    comp.back().push_back(v);
    c[v] = col;
    for (auto to: g[v]) {
        if (!c[to]) {
            dfs(to, col);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    ed1.assign(m1, {0, 0});
    ed2.assign(m2, {0, 0});
    p.assign(n, 0);
    sz.assign(n, 1);
    c.assign(n, 0);
    g.clear();
    g.resize(n);
    comp.clear();
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    for (int i = 0; i < m1; ++i) {
        cin >> ed1[i].u >> ed1[i].v, ed1[i].u--, ed1[i].v--;
        g[ed1[i].u].push_back(ed1[i].v);
        g[ed1[i].v].push_back(ed1[i].u);
    }
    for (int i = 0; i < m2; ++i) {
        cin >> ed2[i].u >> ed2[i].v, ed2[i].u--, ed2[i].v--;
    }
    ostov.clear();
    build();
    int col = 0;
    for (int i = 0; i < n; ++i) {
        if (c[i] == 0) {
            comp.emplace_back();
            col++;
            dfs(i, col);
        }
    }
    bool flag = false;
    map<int, int> cnt;
    for (auto i: ostov) {
        cnt[i.second]++;
        cnt[i.first]++;
    }
    for (auto i: cnt) {
        if (i.second == n - 1) {
            int u = i.second;
            pair<int, int> o = {(u - 1 + n) % n, (u + 1) % n};
            if (o.first > o.second)
                swap(o.first, o.second);
            ostov.insert(o);
            o =  {u, (u + 1) % n};
            if (o.first > o.second)
                swap(o.first, o.second);
            ostov.erase(o);
            break;
        }
    }
    vector<pair<int, int>> s;
    for (int i = 0; i < col - 1; ++i) {
        bool d = false;
        for (int j = 0; j < (int) comp[i].size(); ++j) {
            for (int k = 0; k < (int) comp[i + 1].size(); ++k) {
                pair<int, int> l = {comp[i][j], comp[i + 1][k]};
                if (l.first > l.second)
                    swap(l.first, l.second);
                if (ostov.find(l) == ostov.end()) {
                    d = true;
                    s.push_back(l);
                }
                if (d)break;
            }
            if (d)break;
        }
    }
    if ((int) s.size() == col - 1) {
        cout << "Yes\n" << (int) s.size() << "\n";
        for (auto i: s) {
            cout << i.first + 1<< " " << i.second + 1<< "\n";
        }
    } else
        cout << "No\n";
}

signed main() {
    int _ = 1;
    int t;
    cin >> _ >> t;
    while (_--) {
        solve();
    }
    return 0;
}
