#pragma GCC optimized("O3")

#include <random>
#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const ll maxn = 2e5 + 1, inf = 1e18, mod = 1e9 + 7;

//template<typename T>
//int sz(T a) {
//    return (int) a.size();
//}

struct edge {
    int u, v;
};
set<pair<int, int>> aboba;
set<pair<int, int>> ed2;
vector<int> p;
vector<int> sz;
set<pair<int, int>> ostov;
vector<int> c;

int get_p(int a) {
    if (p[a] == a)
        return a;
    p[a] = get_p(p[a]);
    return p[a];
}

void join(int a, int b) {
    int pa = get_p(a);
    int pb = get_p(b);
    if (sz[pa] > sz[pb]) {
        p[b] = pa;
        sz[pa] += sz[pb];
    } else {
        p[a] = pb;
        sz[pb] += sz[pa];
    }
}

void build() {
    for (auto i: ed2) {
        if (get_p(i.first) != get_p(i.second)) {
            join(i.first, i.second);
            pair<int, int> k = {i.first, i.second};
            if (k.first > k.second)
                swap(k.first, k.second);
            ostov.insert(k);
        }
    }
}

vector<vector<int>> g;
vector<vector<int>> comp;

void dfs(int v, int col) {
    comp.back().push_back(v);
    c[v] = col;
    for (auto to: g[v]) {
        if (!c[to]) {
            dfs(to, col);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    aboba.clear();
    ed2.clear();
    p.assign(n, 0);
    sz.assign(n, 1);
    c.assign(n, 0);
    g.clear();
    g.resize(n);
    comp.clear();
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    for (int i = 0; i < m1; ++i) {
        pair<int, int> e;
        cin >> e.first >> e.second, e.first--, e.second--;
        if (e.first > e.second)
            swap(e.first, e.second);
        aboba.insert(e);
    }
    for (int i = 0; i < m2; ++i) {
        pair<int, int> e;
        cin >> e.first >> e.second, e.first--, e.second--;
        if (e.first > e.second)
            swap(e.first, e.second);
        ed2.insert(e);
    }
    ostov.clear();
    build();
    map<int, int> cnt;
    for (auto i: ostov) {
        cnt[i.second]++;
        cnt[i.first]++;
    }
    vector<pair<int, int>> s;
    for (auto i: cnt) {
        if (i.second == n - 1) {
            int u = i.second;
            pair<int, int> o = {(u - 1 + n) % n, (u + 1) % n};
            if (o.first > o.second)
                swap(o.first, o.second);
            if (ed2.find(o) == ed2.end()) {
                s.push_back(o);
                if (aboba.find(o) == aboba.end()) {
                    aboba.insert(o);
                } else {
                    aboba.erase(o);
                }
            }
            ostov.insert(o);
            o = {u, (u + 1) % n};
            if (o.first > o.second)
                swap(o.first, o.second);
            ostov.erase(o);
            break;
        }
    }
    for (auto i: aboba) {
        g[i.second].push_back(i.first);
        g[i.first].push_back(i.second);
    }
    int col = 0;
    for (int i = 0; i < n; ++i) {
        if (c[i] == 0) {
            comp.emplace_back();
            col++;
            dfs(i, col);
        }
    }
    for (int i = 0; i < col - 1; ++i) {
        bool d = false;
        for (int j = 0; j < (int) comp[i].size(); ++j) {
            for (int k = 0; k < (int) comp[i + 1].size(); ++k) {
                pair<int, int> l = {comp[i][j], comp[i + 1][k]};
                if (l.first > l.second)
                    swap(l.first, l.second);
                if (ostov.find(l) == ostov.end()) {
                    d = true;
                    s.push_back(l);
                }
                if (d)break;
            }
            if (d)break;
        }
        if(!d){
            cout << "No\n";
            return;
        }
    }
    if ((int) s.size() <= n) {
        cout << "Yes\n" << (int) s.size() << "\n";
        for (auto i: s) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }
    } else
        cout << "No\n";
}

signed main() {
    int _ = 1;
    int t;
    cin >> _ >> t;
    while (_--) {
        solve();
    }
    return 0;
}
