#pragma GCC optimized("O3")

#include <random>
#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const ll maxn = 2e5 + 1, inf = 1e18, mod = 1e9 + 7;

set<pair<int, int>> ostov;
set<pair<int, int>> ed1;
set<pair<int, int>> ed2;
vector<vector<int>> g;
vector<int> p;

int gp(int a) {
    if (p[a] == a)
        return a;
    p[a] = gp(p[a]);
    return p[a];
}

void join(int a, int b) {
    int pa = gp(a);
    int pb = gp(b);
    if (pa != pb) {
        ostov.insert({a, b});
        if (rnd() % 2 == 0)
            p[pb] = pa;
        else
            p[pa] = pb;
    }
}

void build() {
    for (auto i: ed2) {
        join(i.first, i.second);
    }
}

vector<int> c;

void dfs(int v, int col) {
    c[v] = col;
    for (auto to: g[v]) {
        if (!c[to]) {
            dfs(to, col);
        }
    }
}

bool aboba(vector<pair<int, int>> &s, int n) {
    for (auto i: ed1) {
        g[i.first].push_back(i.second);
        g[i.second].push_back(i.first);
    }
    int col = 0;
    for (int i = 0; i < n; ++i) {
        if (!c[i]) {
            col++;
            dfs(i, col);
        }
    }
    set<pair<int,int>>comp;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            pair<int,int>t = {c[i], c[j]};
            if(c[i] > c[j])
                swap(t.first, t.second);
            if(c[i]!=c[j] && comp.find(t) == comp.end() && ostov.find({i,j}) == ostov.end()){
                s.push_back({i,j});
                comp.insert(t);
                break;
            }
        }
    }
    if ((int) s.size() >= col - 1) {
        cout << "Yes\n" << (int) s.size() << "\n";
        for (auto i: s) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }
        return true;
    } else {
        s.clear();
        return false;
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    p.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    c.assign(n, 0);
    ostov.clear();
    ed1.clear();
    ed2.clear();
    g.clear();
    g.resize(n);
    for (int i = 0; i < m1; ++i) {
        pair<int, int> e;
        cin >> e.first >> e.second, e.first--, e.second--;
        if (e.first > e.second)
            swap(e.first, e.second);
        ed1.insert(e);
    }
    for (int i = 0; i < m2; ++i) {
        pair<int, int> e;
        cin >> e.first >> e.second, e.first--, e.second--;
        if (e.first > e.second)
            swap(e.first, e.second);
        ed2.insert(e);
    }
    build();
    vector<pair<int, int>> s;
    if (aboba(s, n))
        return;

    g.clear();
    g.resize(n);
    c.assign(n, 0);
    map<int, int> cnt;
    for (auto i: ostov) {
        cnt[i.first]++;
        cnt[i.second]++;
    }
    for (auto i: cnt) {
        if (i.second == n - 1) {
            int u = i.first;
            pair<int, int> k = {(u - 1 + n) % n, (u + 1) % n};
            if (k.first > k.second)
                swap(k.first, k.second);
            if (ed2.find(k) == ed2.end()) {
                ed2.insert(k);
                s.push_back(k);
                if (ed1.find(k) == ed1.end())
                    ed1.insert(k);
                else
                    ed1.erase(k);
            }
            ostov.insert(k);
            k = {u, (u + 1) % n};
            if (k.first > k.second)
                swap(k.first, k.second);
            ostov.erase(k);
        }
    }
    if (aboba(s, n))
        return;
    cout << "No\n";
}

signed main() {
    int _ = 1;
    int t;
    cin >> _ >> t;
    while (_--) {
        solve();
    }
    return 0;
}
