#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> g1;
vector<vector<int>> g2;
vector<int> color;
void dfs(int u, int c)
{
    color[u] = c;
    for (int v : g1[u])
        if (color[v] == -1)
            dfs(v, c);
}

void solve()
{
    g1.clear();
    g2.clear();
    color.clear();

    int n, m1, m2;
    cin >> n >> m1 >> m2;

    color.resize(n, -1);
    g1.resize(n);
    g2.resize(n);

    for (int i = 0; i < m1; i++)
    {
        int a, b;
        cin >> a >> b;
        --a;
        --b;

        g1[a].push_back(b);
        g1[b].push_back(a);
    }

    for (int i = 0; i < m2; i++)
    {
        int a, b;
        cin >> a >> b;
        --a;
        --b;

        g2[a].push_back(b);
        g2[b].push_back(a);
    }

    int clr = 0;
    for (int i = 0; i < n; i++)
        if (color[i] == -1)
            dfs(i, clr++);
    vector<vector<int>> g3(clr);
    for (int i = 0; i < n; i++)
        g3[color[i]].push_back(i); 

    vector<pair<int, int>> ans;
    for (int i = 0; i < clr - 1; i++)
    {
        bool ok = false;
        for (int u : g3[i])
        {
            unordered_set<int> visited;
            for (int v : g2[u])
            {
                if (color[v] == i + 1)
                    visited.insert(v);
            }
            if (visited.size() != g3[i + 1].size())
            {
                ok = true;
                for (int v : g3[i + 1])
                {
                    if (!visited.count(v))
                    {
                        ans.emplace_back(u, v);
                        break;
                    }
                }
            }
        }
        if (!ok)
            ans.emplace_back(g3[i][0], g3[i + 1][0]);
    }

    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto [a, b] : ans)
        cout << a + 1 << ' ' << b + 1 << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 2/in.txt", "r", stdin);
    freopen("D:/olymp/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif
    int g;
    cin >> g;
    while (t--)
        solve();
    return 0;
}