#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = 1e9;
const ll N = 2005;
const ll MOD = 1e9 + 7;
const ll M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

ll group;

set<pair<ll, ll>> e1, e2;
vector<set<ll>> g1, g2;

void add(ll u, ll v) {
    if (e1.find({u, v}) != e1.end()) {
        e1.erase({u, v});
        e1.erase({v, u});
        g1[u].erase(v);
        g1[v].erase(u);
    } else {
        g1[u].insert(v);
        g1[v].insert(u);
        e1.insert({u, v});
        e1.insert({v, u});
    }
    if (e2.find({u, v}) != e2.end()) {
        e2.erase({u, v});
        e2.erase({v, u});
        g2[u].erase(v);
        g2[v].erase(u);
    } else {
        g2[u].insert(v);
        g2[v].insert(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }
}

void solve() {
    ll n, m1, m2; cin >> n >> m1 >> m2;
    e1.clear();
    e2.clear();
    g1.assign(n, {}); g2.assign(n, {});
    for (int i = 0; i < m1; i++) {
        ll u, v; cin >> u >> v;
        u--; v--;
        g1[u].insert(v);
        g1[v].insert(u);
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        ll a, b; cin >> a >> b;
        a-- ;b--;
        g2[a].insert(b);
        g2[b].insert(a);
        e2.insert({a, b});
        e2.insert({b, a});
    }
    if (n == 3) {
        bool ok = false;
        vector<pair<ll, ll>> good, bad, all;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                ll val1 = (e1.find({i, j}) != e1.end());
                ll val2 = (e2.find({i, j}) != e2.end());
                if (val1 + val2 != 1) {
                    good.push_back({i, j});
                    ok = true;
                } else {
                    bad.push_back({i, j});
                }
                all.push_back({i, j});
            }
        }
        if (!ok) {
            cout << "No" << '\n';
        } else {
            if (m1 >= 2) {
                cout << "Yes" << '\n';
                cout << 0 << '\n';
            } else if (m1 == 1) {
                cout << "Yes" << '\n';
                if (m2 == 3) {
                    cout << 1 << '\n';
                    cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                } else {
                    cout << 1 << '\n';
                    if (e1.find({good[0].first, good[0].second}) == e1.end()) {
                        cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                    } else {
                        cout << good[1].first + 1 << " " << good[1].second + 1 << '\n';
                    }
                }
            } else {
                cout << "Yes" << '\n';
                cout << 2 << '\n';
                cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
            }
        }

        return;
    }

    ll bad = -1;
    for (int i = 0; i < n; i++) {
        if (g2[i].size() == n - 1) {
            bad = i;
            break;
        }
    }

    vector<ll> leaf2;
    for (int i = 0; i < n; i++) {
        if (g2[i].size() == 1) {
            leaf2.push_back(i);
        }
    }
    vector<pair<ll, ll>> ans;

    ll parent = -1;
    ll start = -1;
    if (bad != -1) {
        ll to = -1;
        for (int i = 0; i < n; i++) {
            if (i == bad) continue;
            if (e1.find({bad, i}) == e1.end()) {
                to = i;
                break;
            }
        }
        if (to == -1) {
            cout << "Yes" << '\n';
            cout << 0 << '\n';
            return;
        }
        ll from = leaf2[0];
        if (from == to) {
            from = leaf2[1];
        }
        ans.push_back({from, to});
        add(from, to);
        ans.push_back({bad, to});
        add(bad, to);
        start = to;
    } else {
        for (auto v : leaf2) {
            if (start != -1) break;
            for (int i = 0; i < n; i++) {
                if (g2[v].find(i) != g2[v].end() || v == i) continue;
                if (e1.find({v, i}) == e1.end()) {
                    start = v;
                    break;
                }
            }
        }
    }

    parent = *g2[start].begin();
    for (int i = 0; i < n; i++) {
        if (i == parent || i == start) continue;
        if (e1.find({start, i}) == e1.end()) {
            ans.push_back({start, i});
            add(start, i);
        }
    }

    if (e1.find({start, parent}) == e1.end()) {
        ans.push_back({start, parent});
        add(start, parent);
    }


    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << " " << i.second + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst; cin >> tst;
    cin >> group;
    while (tst--) {
        solve();
    }
}