#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using str = string;

ll maxn = 3e5 + 1;
vector <vector <ll>> g1(maxn);
vector <vector <ll>> g2(maxn);
vector <ll> used(maxn);
vector <ll> comp(maxn);

void dfs(int v) {
	comp[v] = 1;
	used[v] = 1;
	for (int u : g1[v]) {
		if (used[u] == 1) {
			dfs(u);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll tt, gg;
	cin >> tt >> gg;
	if (gg == 9) {
		while (tt > 0) {
			tt--;
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
			}
			vector <pair <ll, ll>> ans;
			for (int i = 1; i <= n - 2; i += 2) {
				if (st.count({ i, i + 2 }) == 0) {
					ans.push_back({ i, i + 2 });
				}
			}
			for (int i = 2; i <= n - 2; i += 2) {
				if (st.count({ i, i + 2 }) == 0) {
					ans.push_back({ i, i + 2 });
				}
			}
			int f = 0;
			if (n == 3 && st.size() == 1 && st.count({ 1, 3 }) == 1) {
				f = 1;
			}
			else if (n == 3) {
				if (g1[2].size() == 0) {
					ans.push_back({ 1, 2 });
				}
			}
			else {
				if (st.count({ 1, 4 }) == 0) {
					ans.push_back({ 1, 4 });
				}
			}
			if (f == 0) {
				cout << "Yes" << '\n';
				cout << ans.size() << '\n';
				for (int i = 0; i < ans.size(); i++) {
					cout << ans[i].first << ' ' << ans[i].second << '\n';
				}
			}
			else {
				cout << "No" << '\n';
			}
			for (int i = 1; i <= n; i++) {
				g1[i].clear();
				g2[i].clear();
			}
			st.clear();
		}
	}
	else if (gg == 5) {
		while (tt > 0) {
			tt--;
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
			}
			vector <pair <ll, ll>> ans;
			for (int i = 2; i < n; i++) {
				if (st.count({ i, i + 1 }) == 0) {
					ans.push_back({ i, i + 1 });
				}
			}
			int f = 0;
			if (g1[1].size() == 0) {
				if (n == 3 && st.size() == 1 && st.count({ 2, 3 }) == 1) {
					f = 1;
				}
				else {
					int pos = -1;
					for (int i = 2; i < n; i++) {
						if (st.count({ i, i + 1 }) == 0) {
							pos = i;
						}
					}
					if (pos == -1) {
						ans.push_back({ 2, 4 });
						ans.push_back({ 1, 2 });
					}
					else {
						ans.push_back({ 1, pos });
					}
				}
			}
			if (f == 0) {
				cout << "Yes" << '\n';
				cout << ans.size() << '\n';
				for (int i = 0; i < ans.size(); i++) {
					cout << ans[i].first << ' ' << ans[i].second << '\n';
				}
				st.clear();
				for (int i = 1; i <= n; i++) {
					g1[i].clear();
					g2[i].clear();
				}
			}
			else {
				cout << "No" << '\n';
			}
		}
	}
	else if (gg == 2) {
		while (tt > 0) {
			tt--;
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
			}
			vector <pair <ll, ll>> ans;
			int f = 0;
			if (n == 3) {
				if (st.size() == 0) {
					f = 1;
				}
				else {
					if (g1[1].size() == 0) {
						ans.push_back({ 1, 2 });
					}
					if (g1[2].size() == 0) {
						ans.push_back({ 1, 2 });
					}
					if (g1[3].size() == 0) {
						ans.push_back({ 1, 3 });
					}
				}
			}
			else {
				for (int i = 1; i < n; i++) {
					if (st.count({ i, i + 1 }) == 0) {
						ans.push_back({ i, i + 1 });
					}
				}
			}
			if (f == 0) {
				cout << "Yes" << '\n';
				cout << ans.size() << '\n';
				for (int i = 0; i < ans.size(); i++) {
					cout << ans[i].first << ' ' << ans[i].second << '\n';
				}
			}
			else {
				cout << "No" << '\n';
			}
			st.clear();
			for (int i = 1; i <= n; i++) {
				g1[i].clear();
				g2[i].clear();
			}
		}
	} 
	else if (gg == 7) {
		while (tt > 0) {
			tt--;
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st1;
			set <pair <ll, ll>> st2;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st1.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
				st2.insert({ min(v, u), max(v, u) });
			}
			vector <pair <ll, ll>> ans;
			for (int i = 3; i <= n; i++) {
				if (st1.count({ 1, i }) == 0) {
					if (st2.count({ 1, i }) == 0) {
						ans.push_back({ 1, i });
					}
					else {
						if (st1.count({ 2, i }) == 0) {
							if (st2.count({ 2, i }) == 0) {
								ans.push_back({ 2, i });
							}
							else {
								ans.push_back({ 1, i });
							}
						}
					}
				}
			}
			cout << "Yes" << '\n';
			cout << ans.size() << '\n';
			for (int i = 0; i < ans.size(); i++) {
				cout << ans[i].first << ' ' << ans[i].second << '\n';
			}
			st1.clear();
			st2.clear();
			for (int i = 1; i <= n; i++) {
				g1[i].clear();
				g2[i].clear();
			}
		}
	}
	else if (gg == 3) {
		while (tt > 0) {
			tt--;
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st1;
			set <pair <ll, ll>> st2;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st1.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
				st2.insert({ min(v, u), max(v, u) });
			}
			dfs(1);
			int ans1 = -1;
			int ans2 = -1;
			for (int i = 1; i <= n; i++) {
				for (int j = 1; j <= n;  j++) {
					if (comp[i] != comp[j]) {
						if (st2.count({ min(i, j), max(i, j) }) == 0) {
							ans1 = i;
							ans2 = j;
						}
					}
				}
			}
			if (ans1 == -1) {
				for (int i = 1; i <= n; i++) {
					for (int j = 1; j <= n; j++) {
						if (comp[i] != comp[j]) {
							ans1 = i;
							ans2 = j;
						}
					}
				}
			}
			cout << "Yes" << '\n';
			cout << 1 << '\n';
			cout << ans1 << ' ' << ans2 << '\n';
			for (int i = 1; i <= n; i++) {
				used[i] = 0;
				g1[i].clear();
				g2[i].clear();
			}
			st1.clear();
			st2.clear();
		}
	}
}