//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());



class DSU {
private:
    vector <int> p, h;

public:
    DSU(int n) {
        p.resize(n); iota(all(p), 0);
        h.assign(n, 0);
    }

    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;

        if (h[u] < h[v]) swap(u, v);
        if (h[u] == h[v]) ++h[u];
        p[v] = u;
    }
};

int group;

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector <vector <bool>> g1(n, vector <bool>(n, false)), g2(n, vector <bool>(n, false));
    DSU dsu(n);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v;
        --u; --v;
        dsu.unite(u, v);
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v;
        --u; --v;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }

    vector <pair <int, int>> ans;

    auto solve5 = [&](int a, int b) {
        for (int i = 0; i < n; ++i) {
            if (dsu.get(i) != dsu.get(a)) {
                if (!g2[a][i] || g2[b][i]) {
                    ans.push_back({a, i});
                    dsu.unite(a, i);
                }
                else {
                    ans.push_back({b, i});
                    dsu.unite(b, i);
                }
            }
        }
    };

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dsu.get(i) == dsu.get(j) && g2[i][j]) {
                solve5(i, j);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
            if (dsu.get(i) != dsu.get(j) && !g2[i][j]) {
                ans.push_back({i, j});
                dsu.unite(i, j);

                solve5(i, j);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }

    vector <int> cnt(n);
    for (int i = 0; i < n; ++i) {
        ++cnt[dsu.get(i)];
    }

    if (count(all(cnt), 1) == 0) {
        for (int i = 0; i < n; ++i) {
            if (dsu.get(0) == dsu.get(i)) {
                solve5(i, 0);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    cin >> group;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
