//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());



class DSU {
private:
    vector <int> p, h;

public:
    DSU(int n) {
        p.resize(n); iota(all(p), 0);
        h.assign(n, 0);
    }

    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;

        if (h[u] < h[v]) swap(u, v);
        if (h[u] == h[v]) ++h[u];
        p[v] = u;
    }
};

int group;

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    set <pair <int, int>> g1, g2;
    DSU dsu(n);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v;
        --u; --v;
        dsu.unite(u, v);
        g1.insert({u, v});
        g1.insert({v, u});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v;
        --u; --v;
        g2.insert({u, v});
        g2.insert({v, u});
    }

    vector <pair <int, int>> ans;

    auto solve5 = [&](int a, int b) {
        for (int i = 0; i < n; ++i) {
            if (dsu.get(i) != dsu.get(a)) {
                if (!g2.count({a, i}) || g2.count({b, i})) {
                    ans.push_back({a, i});
                    dsu.unite(a, i);
                }
                else {
                    ans.push_back({b, i});
                    dsu.unite(b, i);
                }
            }
        }
    };

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dsu.get(i) == dsu.get(j) && g2.count({i, j})) {
                solve5(i, j);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
            if (dsu.get(i) != dsu.get(j) && !g2.count({i, j})) {
                ans.push_back({i, j});
                dsu.unite(i, j);

                solve5(i, j);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }

    if (n == 3) {
        cout << "No\n";
        return;
    }

    if (m2 == n * (n - 1) / 2) {
        for (int i = 0; i < n - 1; ++i) {
            ans.push_back({i, i + 1});
        }

        cout << "Yes\n" << ans.size() << '\n';
        for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
        return;
    }

    vector <int> cnt(n);
    for (int i = 0; i < n; ++i) {
        ++cnt[dsu.get(i)];
    }

    if (count(all(cnt), 1) == 0) {
        for (int i = 0; i < n; ++i) {
            if (dsu.get(0) == dsu.get(i)) {
                solve5(i, 0);

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }

    if (count(all(cnt), 1) >= 2) {
        int f = n, s = 0;
        for (int i = 0; i < n; ++i) {
            if (cnt[i] == 1) {
                f = min(f, i);
                s = i;
            }
        }

        ans.push_back({f, s});
        dsu.unite(f, s);

        solve5(f, s);

        cout << "Yes\n" << ans.size() << '\n';
        for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
        return;
    }


    int f = 0;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] == 1) {
            f = i;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (i != f && j != f) {
                if (!g1.count({i, j})) {
                    ans.push_back({i, j});
                    ans.push_back({i, f});

                    cout << "Yes\n" << ans.size() << '\n';
                    for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                    return;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (i != f && j != f) {
                ans.push_back({i, j});
                ans.push_back({i, f});

                cout << "Yes\n" << ans.size() << '\n';
                for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    cin >> group;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
