#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

void dfs(int v, vector<vector<int>> &A, vector<int> &used, vector<int> &path) {
    used[v] = 1;
    path.push_back(v);
    for (int u: A[v]) {
        if (used[u] == 0) {
            dfs(u, A, used, path);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> B;
    vector<vector<int>> A(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        B.insert({a - 1, b - 1});
        B.insert({b - 1, a - 1});
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        A[a - 1].push_back(b - 1);
        A[b - 1].push_back(a - 1);
    }
    int st, mini = 1e9;
    for (int i = 0; i < n; i++){
        if (mini > A[i].size()){
            st = i;
            mini = A[i].size();
        }
    }
    if (n == 3) {
        cout << "No\n";
        return;
    }
    vector<int> used(n), path;
    dfs(st, A, used, path);
    vector<int> newpath;
    for (int i = (n - 1) / 2 * 2; i >= 0; i -= 2) {
        newpath.push_back(path[i]);
    }
    for (int i = (n - 2) / 2 * 2 + 1; i >= 0; i -= 2) {
        newpath.push_back(path[i]);
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (B.find({newpath[i - 1], newpath[i]}) == B.end()) {
            ans.push_back({newpath[i - 1], newpath[i]});
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto e: ans) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }
}

signed main() {
    int t, g;
    cin >> t >> g;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}
