#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

void dfs(int v, vector<vector<int>> &A, vector<int> &used, set<pair<int, int>> &path) {
    used[v] = 1;
    for (int u: A[v]) {
        if (used[u] == 0) {
            path.insert({v, u});
            dfs(u, A, used, path);
        }
    }
}

bool is(vector<vector<int>>&A, int v, int u){
    for (int e: A[v]){
        if (e == u)
            return true;
    }
    return false;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> B;
    vector<vector<int>> A(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        B.insert({a - 1, b - 1});
        B.insert({b - 1, a - 1});
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        A[a - 1].push_back(b - 1);
        A[b - 1].push_back(a - 1);
    }
    if (n == 3) {
        cout << "No\n";
        return;
    }
    vector<int> used(n);
    set<pair<int, int>> path;
    dfs(0, A, used, path);
    vector<int> count(n);
    for (auto e: path) {
        count[e.first]++;
        count[e.second]++;
    }
    int ind1;
    for (int i = 0; i < n; i++) {
        if (count[i] == 1) {
            ind1 = i;
            break;
        }
    }
    vector<pair<int, int>> ans;
    int ind2;
    for (int i = 0; i < n; i++) {
        if (path.find({ind1, i}) != path.end() or path.find({i, ind1}) != path.end()) {
            ind2 = i;
        } else if (i != ind1 and B.find({ind1, i}) == B.end()) {
            ans.push_back({ind1, i});
        }
    }
    int temp = 1;
    if (temp == ind1 or temp == ind2) {
        temp = 2;
    }
    if (temp == ind1 or temp == ind2) {
        temp = 3;
    }
    int temp1 = 0;
    if (temp1 == ind1 or temp1 == ind2 or temp == temp1) {
        temp1 = 1;
    }
    if (temp1 == ind1 or temp1 == ind2 or temp == temp1) {
        temp1 = 2;
    }
    if (temp1 == ind1 or temp1 == ind2 or temp == temp1) {
        temp1 = 3;
    }
    if (!is(A, temp, temp1)) {
        ans.push_back({temp, temp1});
    }
    if (!is(A, temp, ind2) and B.find({temp, ind2}) == B.end())
        ans.push_back({temp, ind2});
    else if (B.find({temp1, ind2}) == B.end()){
        ans.push_back({temp1, ind2});
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto e: ans) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }
}

signed main() {
    int t, g;
    cin >> t >> g;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}
