#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

const ll INF=1e17+9;

void dfs1(int v,vector<vector<ll>> &g,vector<bool> &used) {
	if(used[v]) {return;}
	used[v]=true;
	for(auto u:g[v]) {
		dfs1(u,g,used);
	}
}

void solve1() {
	ll n,m1,m2;
	cin>>n>>m1>>m2;
	vector<vector<ll>> g1(n),g2(n);
	for(int i=0;i<m1;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g1[v].push_back(u);
		g1[u].push_back(v);
	}
	for(int i=0;i<m2;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g2[v].push_back(u);
		g2[u].push_back(v);
	}
	if(n==3 && m1==0) {cout<<"No\n";return;}
	cout<<"Yes\n";
	vector<bool> used(n);
	dfs1(0,g1,used);
	vector<pair<ll,ll>> ans;
	ans.reserve(n);
	ll lst=0;
	for(int i=0;i<n;i++) {
		if(!used[i]) {
			ans.push_back({lst+1,i+1});
			lst=i;
			dfs1(i,g1,used);
		}
	}
	cout<<ans.size()<<'\n';
	for(auto [v,u]:ans) {
		cout<<v<<' '<<u<<'\n';
	}
}

signed main() {
	ll group,n;
	ll t=1;
	cin>>t>>group;
	while(t--) {
		if(group==2)solve1();
	}
	return 0;
}




