#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

const ll INF=1e17+9;

void dfs1(int v,vector<vector<ll>> &g,vector<bool> &used) {
	if(used[v]) {return;}
	used[v]=true;
	for(auto u:g[v]) {
		dfs1(u,g,used);
	}
}

void dfs2(int v,vector<vector<bool>> &g,vector<int> &cols,int col) {
	if(cols[v]==col) {return;}
	cols[v]=col;
	for(int i=0;i<g[v].size();i++) {
		if(g[v][i]) dfs2(i,g,cols,col);
	}
}

void solve0(ll n,ll m1,ll m2,vector<vector<bool>> &g1,vector<vector<bool>> &g2) {
	vector<pair<int,int>> ans;
	vector<int> cols(n);
	int num_es=n*(n-1)/2;
	vector<pair<int,int>> alles;
	for(int i=0;i<n;i++) {
		for(int j=i+1;j<n;j++) {
			alles.push_back({i,j});
		}
	}
	vector<int> es;
	bool fnd=false;
	for(int mask=0;mask<(1<<num_es);mask++) {
		es.clear();
		if(__builtin_popcount(mask)>n) {continue;}
		for(int i=0;i<num_es;i++) {
			if(mask&(1<<i)) {es.push_back(i);}
		}
		for(auto i:es) {
			ll v=alles[i].first;
			ll u=alles[i].second;
			g1[v][u]=g1[u][v]=!g1[v][u];
			g2[v][u]=g2[u][v]=!g2[v][u];
		}
		bool ok=true;
		vector<int> cols(n);
		dfs2(0,g1,cols,1);
		for(auto i:cols) {if(i!=1)ok=false;}
		cols.assign(n,0);
		dfs2(0,g2,cols,1);
		for(auto i:cols) {if(i!=1)ok=false;}
		if(ok) {fnd=true;break;}
		for(auto i:es) {
			ll v=alles[i].first;
			ll u=alles[i].second;
			g1[v][u]=g1[u][v]=!g1[v][u];
			g2[v][u]=g2[u][v]=!g2[v][u];
		}
	}
	if(!fnd) {cout<<"No\n";return;}
	cout<<"Yes\n"<<es.size()<<'\n';
	for(auto i:es) {
		cout<<alles[i].first+1<<' '<<alles[i].second+1<<'\n';
	}
}

void solve1() {
	ll n,m1,m2;
	cin>>n>>m1>>m2;
	vector<vector<ll>> g1(n),g2(n);
	for(int i=0;i<m1;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g1[v].push_back(u);
		g1[u].push_back(v);
	}
	for(int i=0;i<m2;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g2[v].push_back(u);
		g2[u].push_back(v);
	}
	if(n==3 && m1==0) {cout<<"No\n";return;}
	cout<<"Yes\n";
	vector<bool> used(n);
	dfs1(0,g1,used);
	vector<pair<ll,ll>> ans;
	ans.reserve(n);
	ll lst=0;
	for(int i=0;i<n;i++) {
		if(!used[i]) {
			ans.push_back({lst+1,i+1});
			lst=i;
			dfs1(i,g1,used);
		}
	}
	cout<<ans.size()<<'\n';
	for(auto [v,u]:ans) {
		cout<<v<<' '<<u<<'\n';
	}
}

void solve2() {
	ll n,m1,m2;
	cin>>n>>m1>>m2;
	//vector<vector<ll>> g1(n),g2(n);
	vector<vector<bool>> g1(n,vector<bool> (n)),g2(n,vector<bool> (n));
	for(int i=0;i<m1;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g1[v][u]=true;
		g1[u][v]=true;
	}
	for(int i=0;i<m2;i++) {
		ll v,u;
		cin>>v>>u;v--;u--;
		g2[v][u]=true;
		g2[u][v]=true;
	}
	if(n<=5) {solve0(n,m1,m2,g1,g2);return;}
	vector<int> cols(n);
	int col=0;
	vector<vector<ll>> cs;
	for(int i=0;i<n;i++) {
		if(cols[i]==0) {
			cs.push_back({});
			dfs2(i,g1,cols,++col);
			for(int j=0;j<n;j++) {
				if(cols[j]==col){cs[col-1].push_back(j);}
			}
		}
	}
	vector<pair<ll,ll>> ans;
	for(int csn=0;csn+1<cs.size();csn++) {
		pair<ll,ll> res={-1,-1};
		for(auto v:cs[csn]) {
			for(auto u:cs[csn+1]) {
				if(!g2[v][u]) {res={v,u};break;}
			}
			if(res!=(pair<ll,ll>){-1,-1}) {break;}
		}
		if(res==(pair<ll,ll>){-1,-1}) {res={cs[csn][0],cs[csn+1][0]};}
		ans.push_back(res);
	}
	cout<<"Yes\n"<<ans.size()<<'\n';
	for(auto [v,u]:ans) {
		cout<<v+1<<' '<<u+1<<'\n';
	}
}

signed main() {
	ll group,n;
	ll t=1;
	cin>>t>>group;
	while(t--) {
		if(group==2)solve1();
		else if(group<9)solve2();
	}
	return 0;
}




