#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int _, group, n, m1, m2;

struct DSU {
    vector<int> p, sz;

    void build() {
        p.clear(), sz.clear();
        p.resize(n), sz.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }

    void un(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (sz[u] > sz[v]) swap(u, v);
        sz[v] += sz[u], p[u] = v;
    }
};

void solve() {
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n), g2(n);
    set<pii > e1, e2;
    DSU sok;
    sok.build();
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v, u--, v--;
        if (u > v) swap(u, v);
        e1.insert({u, v});
        sok.un(u, v);
        g1[u].push_back(v), g1[v].push_back(u);
    }
    DSU check;
    check.build();
    set<pii > norm;
    vector<pii > eall;
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v, u--, v--;
        if (u > v) swap(u, v);
        eall.push_back({u, v});
        e2.insert({u, v});
        g2[u].push_back(v), g2[v].push_back(u);
    }
    shuffle(all(eall), rnd);
    for (auto [u, v]: eall) {
        if (check.get(u) == check.get(v)) norm.insert({u, v});
        else check.un(u, v);
    }
    if (check.sz[check.get(0)] != n) {
        cout << "No\n";
        return;
    }
    if (sok.sz[sok.get(0)] == n) {
        cout << "Yes\n0\n";
        return;
    }
    if (group < 2 || n <= 5) {
        int m = (n - 1) * n / 2;
        vector<pii > all;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                all.push_back({i, j});
            }
        }
        int M = 1 << m;
        for (int mask = 0; mask < M; mask++) {
            if (__builtin_popcount(mask) > n) continue;
            auto E1 = e1, E2 = e2;
            vector<tuple<int, int, int>> was;
            for (int i = 0; i < m; ++i) {
                if ((mask >> i) & 1) {
                    auto [u, v] = all[i];
                    if (E1.find({u, v}) != E1.end()) E1.erase({u, v});
                    else E1.insert({u, v});

                    if (E2.find({u, v}) != E2.end()) E2.erase({u, v}), was.push_back({1, u, v});
                    else E2.insert({u, v}), was.push_back({0, u, v});
                }
            }
            DSU a1, a2;
            a1.build(), a2.build();
            for (auto [u1, v1]: E1) a1.un(u1, v1);
            if (a1.sz[a1.get(0)] != n) continue;

            for (auto [u2, v2]: E2) a2.un(u2, v2);
            if (a2.sz[a2.get(0)] != n) continue;

            cout << "Yes\n" << sz(was) << '\n';
            sort(all(was));
            for (auto [ty, u, v]: was)
                cout << u + 1 << ' ' << v + 1 << '\n';
            return;
        }
        cout << "No";
        return;
    }
    if (group == 2) {
        vector<pii > ans;
        for (int i = 0; i < n - 1; ++i) {
            if (e1.find({i, i + 1}) != e1.end()) continue;
            ans.push_back({i, i + 1});
        }
        cout << "Yes\n";
        cout << sz(ans) << '\n';
        for (auto [u, v]: ans) cout << u + 1 << ' ' << v + 1 << '\n';
        return;
    }
    if (group == 9) {
        cout << "Yes\n";
        vector<pii > nado;
        for (int i = 3; i <= n; ++i) {
            if (e1.find({0, i - 1}) == e1.end()) nado.push_back({1, i});
        }
        if (e1.find({1, n - 1}) == e1.end()) nado.push_back({2, n});
        cout << sz(nado) << '\n';
        for (auto [u, v]: nado) cout << u << ' ' << v << '\n';
        return;
    }
    if (group == 5) {
        cout << "Yes\n";
        vector<pii > nado;
        for (int i = 1; i < n - 1; ++i) {
            if (e1.find({i, i + 1}) == e1.end()) nado.push_back({i, i + 1});
        }
        if (e1.find({1, n - 1}) == e1.end()) nado.push_back({1, n - 1});
        if (nado.empty()) nado.push_back({1, 2});
        if (g1[0].empty()) {
            auto [u, v] = nado.back();
            nado.push_back({0, u});
        }
        cout << sz(nado) << '\n';
        for (auto [u, v]: nado) cout << u + 1 << ' ' << v + 1 << '\n';
        return;
    }
    vector<pii > ans;
    for (auto [u, v]: norm) e2.erase({u, v});
    vector<pii > edg;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (e1.find({i, j}) != e1.end() || e2.find({i, j}) != e2.end()) continue;
            edg.push_back({i, j});
        }
    }
    shuffle(all(edg), rnd);
    for (auto [i, j]: edg) {
        if (sok.get(i) == sok.get(j)) continue;
        ans.push_back({i, j}), sok.un(i, j);
    }
    if (sok.sz[sok.get(0)] == n) {
        cout << "Yes\n" << sz(ans) << '\n';
        for (auto [u, v]: ans) cout << u + 1 << ' ' << v + 1 << '\n';
        return;
    }
    vector<pii > notex;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (e2.find({i, j}) != e2.end()) continue;
            notex.push_back({i, j});
        }
    }
    shuffle(all(notex), rnd);
    for (int add = 1; add <= 10; ++add) {
        auto [ni, nj] = notex[add - 1];
        if (e1.find({ni, nj}) != e1.end()) e1.erase({ni, nj});
        else e1.insert({ni, nj});
        sok.build();
        for (auto [i, j]: e1) sok.un(i, j);
        edg.clear();
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (e1.find({i, j}) != e1.end() || e2.find({i, j}) != e2.end()) continue;
                edg.push_back({i, j});
            }
        }
        shuffle(all(edg), rnd);
        int tot = add;
        for (auto [i, j]: edg) {
            if (sok.get(i) == sok.get(j)) continue;
            ans.push_back({i, j}), sok.un(i, j);
            tot++;
            if(tot > n) break;
        }
        if(tot > n) continue;
        if (sok.sz[sok.get(0)] == n) {
            cout << "Yes\n" << sz(ans) << '\n';
            for (auto [u, v]: ans) cout << u + 1 << ' ' << v + 1 << '\n';
            return;
        }
    }
    cout << "No";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> _ >> group;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
