#include<bits/stdc++.h>
#define fi first
#define se second
#define ll long long
#define pii pair<int, int>
using namespace std;
const int N = 3e5 + 1;
const int Ns = 3e3 + 1;
int p[N];
int sz[N];
map<pii, bool> roads;
set<int> gr[N];
void ultra_clear(int n) {
    roads.clear();
    for (int i = 1; i <= n; ++i)
        gr[i].clear();
}
void init(int n) {
    for (int i = 1; i <= n; ++i)
        p[i] = i,
            sz[i] = 1;
}
int get(int u) {
    if (p[u] != u)
        p[u] = get(p[u]);
    return p[u];
}
void join(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (sz[u] > sz[v])
        swap(u, v);
    sz[v] += sz[u];
    p[u] = v;
}
bool check(int u, int v) {
    u = get(u);
    v = get(v);
    return (u == v);
}
int cnt;
pii road;
bool flag;
int tin[N];
int tout[N];
bitset<N> us;
void clear_tin_tout(int n) {
    for (int i = 1; i <= n; ++i)
        tout[i] = tin[i] = us[i] = 0;
}
void dfs(int city, int pr) {
    us[city] = 1;
    tin[city] = tout[city] = ++cnt;
    for (int i : gr[city]) {
        if (i == pr)
            continue;
        if (us[i]) {
            tout[city] = min(tout[city], tin[i]);
            continue;
        }
        dfs(i, city);
        tout[city] = min(tout[city], tout[i]);
        if (tout[i] > tin[city]) {
            if (i == road.fi && city == road.se || i == road.se && city == road.fi)
                flag = 1;
        }
    }
}
void add_edge(int u, int v) {
    gr[u].insert(v);
    gr[v].insert(u);
    roads[{u, v}] = roads[{v, u}] = 1;
}
void del_edge(int u, int v) {
    gr[u].erase(v);
    gr[v].erase(u);
    roads[{u, v}] = roads[{v, u}] = 0;
}
set<int> graph[N][2];
const int Nss = 6;
void clear_us(int n) {
    for (int i = 1; i <= n; ++i)
        us[i] = 0;
}
int pre_calc(int city, int type) {
//    cout<<city << ' ' << type << '\n';
    us[city] = 1;
    int kol = 1;
    for (int i : graph[city][type]) {
        if (us[i])
            continue;
        kol += pre_calc(i, type);
    }
    return kol;
}
bool can;
bool have[Nss][Nss];
vector<pii> now;
void recur(int n, vector<pii> & all, vector<pii> &ans) {
    int x1, x2;
    clear_us(n);
    x1 = pre_calc(1, 0);
    clear_us(n);
    x2 = pre_calc(1, 1);
//    cout<<"x1, x2 = " << x1 << ' ' << x2 << '\n';
    if (x1 == n && x2 == n) {
        ans = now;
        can = 1;
//        cout << "abudabi\n";
        return;
    }
    if (now.size() == n)
        return;
    for (int u = 1; u < n; ++u)
        for (int v = u + 1; v <= n; ++v)
            if (!have[u][v] && !can) {
                have[u][v] = 1;
                now.push_back({u, v});
                for (int i = 0; i < 2; ++i)
                    if (graph[u][i].find(v) != graph[u][i].end()) {
                        graph[u][i].erase(v);
                        graph[v][i].erase(u);
                    } else {
                        graph[u][i].insert(v);
                        graph[v][i].insert(u);
                    }
                int x2;
                clear_us(n);
                x2 = pre_calc(1, 1);
                if (x2 == n) {
//                    cout << "u, v = " << u << ' ' << v << '\n';
                    recur(n, all, ans);
                }
                for (int i = 0; i < 2; ++i)
                    if (graph[u][i].find(v) != graph[u][i].end()) {
                        graph[u][i].erase(v);
                        graph[v][i].erase(u);
                    } else {
                        graph[u][i].insert(v);
                        graph[v][i].insert(u);
                    }
                have[u][v] = 0;
                now.pop_back();
                if (can)
                    return;
            }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m[2];
        cin >> n >> m[0] >> m[1];
        init(n);
        for (int i = 0; i < 2; ++i)
            for (int j = 1; j <= m[i]; ++j) {
                int u, v;
                cin >> u >> v;
                graph[u][i].insert(v);
                graph[v][i].insert(u);
                if (i)
                    add_edge(u, v);
                else
                    join(u, v);
            }
        if (n <= 5) {
            vector<pii> ans;
            can = 0;
            vector<pii> all;
            for (int u = 1; u < n; ++u)
                for (int v = u + 1; v <= n; ++v)
                    all.push_back({u, v});
            recur(n, all, ans);
            if (can) {
                cout << "Yes\n";
                cout << ans.size() << '\n';
                for (auto i : ans)
                    cout << i.fi << ' ' << i.se << '\n';
            } else
                cout << "No\n";
            ultra_clear(n);
            for (int i = 0; i < 2; ++i)
                for (int j = 1; j <= n; ++j)
                    graph[j][i].clear();
            now.clear();
            continue;
        }
        vector<pii> ans;
        for (int u = 1; u < n; ++u)
            for (int v = u + 1; v <= n; ++v)
                if (!check(u, v)) {
                    if (!roads[{u, v}]) {
                        ans.push_back({u, v});
                        join(u, v);
                        add_edge(u, v);
                    } else {
                        cnt = 0;
                        flag = 0;
                        road = {u, v};
                        clear_tin_tout(n);
                        dfs(1, 0);
                        if (!flag) {
                            ans.push_back({u, v});
                            join(u, v);
                            del_edge(u, v);
                        }
                    }
                }
        if (sz[get(1)] == n) {
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto i : ans)
                cout << i.fi << ' ' << i.se << '\n';
        } else {
            cout << "No\n";
        }
        ultra_clear(n);
    }
    return 0;
}
