#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 3000;
int n, m1, m2;
int used[MAXN];
int g1[MAXN][MAXN];
int g2[MAXN][MAXN];

void init() {
    cin >> n >> m1 >> m2;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            g1[i][j] = 0;
            g2[i][j] = 0;
        }
    }
    for (int i = 0; i < m1; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g1[v][u] = 1;
        g1[u][v] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g2[v][u] = 1;
        g2[u][v] = 1;
    }
}

void dfs1(int v) {
    used[v] = 1;
    for (int u = 0; u < n; u++) {
        if (!used[u] && g1[v][u])
            dfs1(u);
    }
}
void dfs2(int v) {
    used[v] = 1;
    for (int u = 0; u < n; u++) {
        if (!used[u] && g2[v][u])
            dfs2(u);
    }
}

bool check1() {
    fill(used, used + n, 0);
    dfs1(0);
    return (*min_element(used, used + n)) == 1;
}
bool check2() {
    fill(used, used + n, 0);
    dfs2(0);
    return (*min_element(used, used + n)) == 1;
}

bool succes;
vpii stupid_ans;

void get_stupid_ans(int cur_sz, vpii &e) {
    if (succes)
        return;
    if (check1() && check2()) {
        succes = true;
        return;
    } else if (!check2()){
        return;
    }
    if (cur_sz < n) {
        for (auto [v, u] : e)  {
            g1[v][u] ^= 1;
            g1[u][v] ^= 1;
            g2[v][u] ^= 1;
            g2[u][v] ^= 1;

            stupid_ans.pb({v, u});
            get_stupid_ans(cur_sz + 1, e);
            if (succes)
                return;
            stupid_ans.pop_back();

            g1[v][u] ^= 1;
            g1[u][v] ^= 1;
            g2[v][u] ^= 1;
            g2[u][v] ^= 1;
        }
    }
}

void stupid() {
    succes = false;
    stupid_ans.clear();
    vpii e;
    for (int v = 0; v < n; v++)
        for (int u = v + 1; u < n; u++)
            e.pb({v, u});

    get_stupid_ans(0, e);
    if (succes) {
        cout << "Yes\n";
        cout << sz(stupid_ans) << '\n';
        for (auto [v, u] : stupid_ans)
            cout << v + 1 << ' ' << u + 1 << '\n';
    } else {
        cout << "No\n";
    }

}

int main() {
    fast_input;
    int t, g;
    cin >> t >> g;
    while (t--) {
        init();
        if (g == 1 || g == 0)
            stupid();
        /*else if (g == 2)
            full_g();
        else if (g == 3)
            two_comp();*/
    }
}