#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll infll = 1e18 + 10;

int group;

const int N = 3e5 + 10;

vector<int> g1[N];
vector<int> g2[N];

struct dsu {
    vector<int> d, p;
    int n;

    void init (int k) {
        n = k;
        d.assign(n, 1);
        p.assign(n, 0);
        iota(all(p), 0ll);
    }

    int find (int u) {
        if (u == p[u]) return u;
        return p[u] = find(p[u]);
    }

    bool good (int u, int v) {
        u = find(u), v = find(v);
        if (u == v) return d[u] == n;
        return d[u] + d[v] == n;
    }

    void unite (int u, int v) {
        u = find(u), v = find(v);
        if (u == v) return;
        if (d[u] < d[v]) swap(u, v);
        d[u] += d[v];
        p[v] = u;
    }

    bool check () {
        return d[find(0)] == n;
    }
};

void solve3() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<pair<int, int>> edges1, edges2;
    map<pair<int, int>, int> has;

    dsu d1;

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        if (u > v) swap(u, v);
        edges1.push_back({u, v});
        d1.unite(u, v);
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        edges2.push_back({u, v});
        has[{u, v}] = true;
    }

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (d1.good(i, j)) {
                if (has[{i, j}]) {
                    dsu d2;
                    for (int k = 0; k < sz(edges2); k++) {
                        if (edges2[k].first == i && edges2[k].second == j) continue;
                        d2.unite(edges2[k].first, edges2[k].second);
                    }
                    if (d2.check()) {
                        cout << "Yes\n";
                        cout << "1\n";
                        cout << i + 1 << " " << j + 1 << '\n';
                        return;
                    }
                }
            }
        }
    }

    cout << "No\n";
}

void solve() {
    if (group == 3) {
        solve3();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}