#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll infll = 1e18 + 10;

int group;

const int N = 3e5 + 10;

vector<pair<int, int>> available, answer;
vector<pair<int, int>> add;
const int K = 10;

struct dsu {
    vector<int> d, p;
    int n;

    void init (int k) {
        n = k;
        d.assign(n, 1);
        p.assign(n, 0);
        iota(all(p), 0ll);
    }

    int find (int u) {
        if (u == p[u]) return u;
        return p[u] = find(p[u]);
    }

    bool good (int u, int v) {
        u = find(u), v = find(v);
        if (u == v) return d[u] == n;
        return d[u] + d[v] == n;
    }

    void unite (int u, int v) {
        u = find(u), v = find(v);
        if (u == v) return;
        if (d[u] < d[v]) swap(u, v);
        d[u] += d[v];
        p[v] = u;
    }

    bool check () {
        return d[find(0)] == n;
    }

    void clear() {
        d.clear();
        p.clear();
        n = 0;
    }
};

dsu d1, d2;

int edges1[K][K];
int edges2[K][K];
int n;

bool found = false;

void build() {
    d1.clear();
    d2.clear();
    d1.init(n);
    d2.init(n);

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (edges1[i][j]) {
                d1.unite(i, j);
            }
            if (edges2[i][j]) {
                d2.unite(i, j);
            }
        }
    }
}

void gen (int have, int ind) {
    if (d1.check() && d2.check()) {
        found = true;
        answer = add;
        return;
    }

    if (found) return;

    if (have == 0) return;
    if (ind == sz(available)) return;

    for (int j = ind; j < sz(available); j++) {
        int u = available[j].first, v = available[j].second;
        edges1[u][v] ^= 1;
        edges2[u][v] ^= 1;
        add.push_back({u, v});
        build();
        gen(have - 1, ind + 1);
        if (found) return;
        edges1[u][v] ^= 1;
        edges2[u][v] ^= 1;
        build();
        add.pop_back();
    }
}

void solve1() {
    int m1, m2;
    cin >> n >> m1 >> m2;
    available.clear();
    answer.clear();
    add.clear();
    found = false;

    d1.clear();
    d2.clear();

    d1.init(n);
    d2.init(n);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            edges1[i][j] = edges2[i][j] = 0;
        }
    }

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        edges1[u][v] = edges1[v][u] = 1;
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        edges2[u][v] = edges2[v][u] = 1;
    }

    build();

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            available.push_back({i, j});
        }
    }

    gen(n, 0);

    if (!found) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        cout << sz(answer) << '\n';
        for (auto v : answer) {
            cout << v.first + 1 << " " << v.second + 1 << '\n';
        }
    }
}

void solve() {
//    if (group == 3) {
    solve1();
//    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t >> group;

    while (t--) {
        solve();
    }
}