#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using db = double;

struct Edge {
    int u, v;
};

struct Input {
    int n, m1, m2;
    vector<Edge> e1, e2;
};

Input input() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector<Edge> e1(m1), e2(m2);
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v; u--; v--;
        e1[i] = {u, v};
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v; u--; v--;
        e2[i] = {u, v};
    }
    return {n, m1, m2, e1, e2};
}

void dfs(int v, vector<int>& used, const vector<vector<int>>& g, vector<vector<int>>& g2) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) continue;
        pair<int, int> tmp = {v, u};
        if (tmp.first > tmp.second) swap(tmp.first, tmp.second);
        g2[v][u] = g2[u][v] = 0;
        dfs(u, used, g, g2);
    }
}

void dfs2(int v, vector<int>& used, const vector<vector<int>>& g, vector<Edge>& e) {
    used[v] = 1;
    for (int i = 0; i < (int)g.size(); ++i) {
        if (!g[v][i]) continue;
        if (used[i]) continue;
        e.push_back({v, i});
        dfs2(i, used, g, e);
    }
}

mt19937 rnd(57);

pair<int, vector<Edge>> kukarekuSolve(Input inp) {
    auto [n, m1, m2, e1, e2] = std::move(inp);
    vector<vector<int>> g1(n);
    for (auto [u, v] : e2) {
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        shuffle(g1[i].begin(), g1[i].end(), rnd);
    }
    vector<int> used(n);
    set<pair<int, int>> was;
    for (auto [u, v] : e1) {
        if (u > v) swap(u, v);
        was.insert({u, v});
    }
    vector<vector<int>> g2(n, vector<int>(n, 1));
    dfs(0, used, g1, g2);
    used.assign(n, 0);
    vector<Edge> eNeed;
    dfs2(0, used, g2, eNeed);
    if ((int)eNeed.size() < n - 1) return {0, {}};
    vector<Edge> ans;
    for (auto [u, v] : eNeed) {
        if (u > v) swap(u, v);
        if (was.find({u, v}) == was.end()) {
            ans.push_back({u, v});
        }
    }
    return {1, ans};
}

void output(const pair<int, vector<Edge>>& e) {
    if (e.first == 0) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << e.second.size() << '\n';
    for (auto [u, v] : e.second) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}

void run() {
    int t, G; cin >> t >> G;
    for (int i = 0; i < t; ++i) {
        output(kukarekuSolve(input()));
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}
