#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

// #define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));

ll rnd(ll x) {
    uniform_int_distribution<ll> uid(0, x - 1);
    return uid(rngl);
}

int rnd(int x) {
    uniform_int_distribution<int> uid(0, x - 1);
    return uid(rng);
}

int R = 1;
struct segment_tree {
    vector <ll> t, add;
    segment_tree(int n) {
        R = 1;
        while (R <= n + 10)
            R *= 2;
        t.resize(R * 2 + 32);
        add.resize(R * 2 + 32);
    }
    void push(int node, int nl, int nr) {
        t[node] += add[node] * (nr - nl + 1);
        if (node < R) {
            add[node * 2] += add[node];
            add[node * 2 + 1] += add[node];
        }
        add[node] = 0;
    }
    void calc(int node) {
        if (node < R) {
            t[node] = t[node * 2] + t[node * 2 + 1];
        }
    }
    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (qr <= nl && nr <= qr) {
            add[node] += val;
            push(node, nl, nr);
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }
    ll query(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (qr <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return query(ql, qr, node * 2, nl, nm) +
               query(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ll x, y;

    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    void in() {
        cin >> x >> y;
    }

    ll operator*(Point &other) {
        return x * other.x + y * other.y;
    }

    ll operator%(Point &other) {
        return x * other.y - y * other.x;
    }
};

ll get(int x, int y) {
    return (x << 10) ^ y;
}

int gg;
set <int> G1[300010], G2[300010], g1[300010], g2[300010];

int used1[300010], used2[300010];
void dfs1(int u) {
    used1[u] = 1;
    for (auto& v : g1[u])
        if (used1[v] == 0)
            dfs1(v);
}
void dfs2(int u) {
    used2[u] = 1;
    for (auto& v : g2[u])
        if (used2[v] == 0)
            dfs2(v);
}

int n, m1, m2;
void do_clear() {
    for (int i = 0; i < n; i++) {
        G1[i].clear();
        G2[i].clear();
    }
}

void solve() {
    cin >> n >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        G1[a].insert(b);
        G1[b].insert(a);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        G2[a].insert(b);
        G2[b].insert(a);
    }
    for (int _ = 0; _ < 100000; _++) {
        int ost = 50 * n, now = 1e5;
        copy(G1, G1 + n, g1);
        copy(G2, G2 + n, g2);
        vector<pair<int, int>> ans;
        while (ans.size() < n && ost--) {
            int u = rnd(n), v = rnd(n);
            while (u == v)
                v = rnd(n);
            if (g1[u].find(v) == g1[u].end()) {
                g1[u].insert(v);
                g1[v].insert(u);
            } else {
                g1[u].erase(v);
                g1[v].erase(u);
            }
            if (g2[u].find(v) == g2[u].end()) {
                g2[u].insert(v);
                g2[v].insert(u);
            } else {
                g2[u].erase(v);
                g2[v].erase(u);
            }
            ans.emplace_back(min(u, v), max(u, v));
            fill(used1, used1 + n, 0);
            fill(used2, used2 + n, 0);
            int cnt1 = 0, cnt2 = 0;
            for (int i = 0; i < n; i++) {
                if (used1[i] == 0) {
                    dfs1(i);
                    cnt1++;
                }
                if (used2[i] == 0) {
                    dfs2(i);
                    cnt2++;
                }
            }
            if (cnt1 + cnt2 < now && cnt2 == 1)
                now = cnt1 + cnt2;
            else {
                ans.pop_back();
                if (g1[u].find(v) == g1[u].end()) {
                    g1[u].insert(v);
                    g1[v].insert(u);
                } else {
                    g1[u].erase(v);
                    g1[v].erase(u);
                }
                if (g2[u].find(v) == g2[u].end()) {
                    g2[u].insert(v);
                    g2[v].insert(u);
                } else {
                    g2[u].erase(v);
                    g2[v].erase(u);
                }
            }
            if (now == 2)
                break;
        }
        if (ans.size() <= n && now == 2) {
            cout << "Yes" << endl;
            cout << ans.size() << endl;
            for (auto &i: ans)
                cout << i.F + 1 << ' ' << i.S + 1 << endl;
            do_clear();
            return;
        }
    }
    cout << "No" << endl;
    do_clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt >> gg;
    while (tt--)
        solve();
    cerr << "Ulyanovsk is the best!!!" << endl;
}
