#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int group;

const int MAXN = 3e5 + 10;

ve<int> g[MAXN];
ve<ve<int> > comps;
bool vis[MAXN];

void dfs(int v) {
    comps.back().push_back(v);
    vis[v] = 1;
    for (auto to : g[v])
        if (!vis[to])
            dfs(to);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        vis[i] = 0;
    }
    comps.clear();
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    set<pii> is;
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        is.insert({ u, v });
        is.insert({ v, u });
    }
    for (int i = 0; i < n; i++)
        if (!vis[i]) {
            comps.push_back(ve<int>());
            dfs(i);
        }
    ve<pii> res;
    for (int i = 1; i < comps.size(); i++) {
        bool fnd = 0;
        for (auto j : comps[i - 1]) {
            if (fnd) break;
            for (auto k : comps[i]) {
                if (is.find({ j, k }) == is.end()) {
                    fnd = 1;
                    is.insert({ j, k });
                    is.insert({ k, j });
                    res.push_back({ j, k });
                    break;
                }
            }

        }
        if (!fnd) {
            is.erase({ comps[i][0], comps[i - 1][0] });
            is.erase({ comps[i - 1][0], comps[i][0] });
            res.push_back({ comps[i][0], comps[i - 1][0] });
                
        }
    }
    for (int i = 0; i < n; i++) {
        g[i].clear();
        vis[i] = 0;
    }
    for (auto i : is) {
        g[i.fi].push_back(i.se);
    }
    comps.clear();
    for (int i = 0; i < n; i++)
        if (!vis[i]) {
            comps.push_back(ve<int>());
            dfs(i);
        }
    if (comps.size() > 1) {
        is.clear();
        for(int i = 0; i < n; i++)
            for (auto to : g[i]) {
                is.insert({ i, to });
                is.insert({ to, i });
            }
        for (auto i : res) {
            is.insert(i);
            is.insert({ i.se, i.fi });
        }
        bool fnd = 0;
        for (auto j : comps[0]) {
            if (fnd) break;
            for (auto k : comps[1]) {
                if (is.find({ j, k }) == is.end()) {
                    fnd = 1;
                    is.insert({ j, k });
                    is.insert({ k, j });
                    res.push_back({ j, k });
                    break;
                }
            }
        }
        if (!fnd) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << res.size() << "\n";
    for (auto i : res)
        cout << i.fi + 1 << " " << i.se + 1 << "\n";
}

int main() {
    int T;
    cin >> T >> group;
    while (T--) {
        solve();
    }
}
