#include <bits/stdc++.h>

using namespace std;

#define eb emplace_back

#define all(a) (a).begin(), (a).end()
#define srt(a) sort((a).begin(), (a).end())
#define lowb(a, x) (int)(lower_bound((a).begin(), (a).end(), x) - (a).begin())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

int group, n, m1, m2;

vector<vector<int>> g1, g2;
set<ii> e1, e2;
vector<int> comp, used;

void dfs(int v, vector<vector<int>> &g, vector<bool> &usd) {
    if (usd[v])
        return;
    usd[v] = true;
    for (int u : g2[v])
        dfs(u, g, usd);
}

bool connected(vector<vector<int>> &g) {
    vector<bool> usd(n + 1, false);
    dfs(1, g, usd);
    for (int i = 2; i <= n; ++i) {
        if (!usd[i])
            return false;
    }
    return true;
}

void solve1() {
    vector<ii> E1, E2;
    for (auto [a, b] : e1)
        E1.eb(a, b);
    for (auto [a, b] : e2)
        E2.eb(a, b);
    for (int msk = 1; msk << (1 << m1); ++msk) {
        vector<int> I;
        for (int i = 0; i < m1; ++i) {
            if ((msk >> i) & 1)
                I.eb(i);
        }
        if (I.size() > n)
            continue;
        do {
            vector<ii> res;
            for (int i : I) {
                res.eb(E1[i]);
                if (!connected(g2))
                    return;
            }
        } while (next_permutation(all(I)));
    }
}

void paint(int v, int color) {
    comp[v] = color;
    for (int u : g1[v]) {
        if (comp[u] == -1)
            paint(u, color);
    }
}

void solve2() {
    comp.assign(n + 1, -1);
    int colors = 0;
    for (int i = 1; i <= n; ++i) {
        if (comp[i] == -1) {
            paint(i, colors++);
        }
    }
    vector<bool> used_comp(colors);
    used_comp[0] = true;
    vector<ii> res;
    int f = 1;
    for (int i = 2; i <= n; ++i) {
        if (!used_comp[comp[i]]) {
            res.eb(f, i);
            used_comp[comp[i]] = true;
            f = i;
        }
    }
    cout << "Yes\n" << res.size() << '\n';
    for (auto [v, u] : res)
        cout << v << ' ' << u << '\n';
}

void solve3() {
    comp.assign(n + 1, -1);
    paint(1, 1);
    for (auto [a, b] : e1) {
        if (comp[a] != comp[b] && e2.find({a, b}) == e2.end() && e2.find({b, a}) == e2.end()) {
            cout << "Yes\n1\n" << a << ' ' << b << '\n';
            return;
        }
    }
    for (auto [a, b] : e2) {
        if (comp[a] != comp[b] && g2[a].size() > 1 && g2[b].size() > 1) {
            cout << "Yes\n1\n" << a << ' ' << b << '\n';
            return;
        }
    }
    cout << "No\n";
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n + 1, vector<int> ());
    g2.assign(n + 1, vector<int> ());
    e1.clear();
    e2.clear();
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        g1[v].eb(u);
        g1[u].eb(v);
        e1.insert({v, u});
    }
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        g1[a].eb(b);
        g1[b].eb(a);
        e2.insert({a, b});
    }
    if (group == 1) {
        solve1();
    } else if (group == 2) {
        solve2();
    } else if (group == 3) {
        solve3();
    }
}

int main() {
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/hui/input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
    cin >> tests >> group;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
