
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <climits>
#include <random>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
ll n;
vll used;
random_device r;
default_random_engine e1(r());

pll gen(uniform_int_distribution<ll>& uniform_dist) {
    pll res;
    res.first = 0;
    res.second = 0;
    while (res.first == res.second){
        res.first = uniform_dist(e1);
        res.second = uniform_dist(e1);
    }
    return res;
}

ll is_cool(vector<map<ll, ll>>& g, ll v){
    used[v] = true;
    ll cnt = 1;
    for (int i = 0; i < g.size(); ++i) {
        ll to = i;
        if (g[v][i] && !used[to]){
            cnt += is_cool(g, to);
        }
    }
    return cnt;
}



void solve(ll group){
    ll m1, m2, t1, t2;
    cin >> n >> m1 >> m2;
    vector<map<ll, ll>> g1(n);
    vector<map<ll, ll>> g1_origin(n);
    vector<map<ll, ll>> g2(n);
    vector<map<ll, ll>> g2_origin(n);
    for (int i = 0; i < m1; ++i) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g1[t1][t2] = 1;
        g1[t2][t1] = 1;
        g1_origin[t1][t2] = 1;
        g1_origin[t2][t1] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g2[t1][t2] = 1;
        g2[t2][t1] = 1;
        g2_origin[t1][t2] = 1;
        g2_origin[t2][t1] = 1;
    }
    uniform_int_distribution<ll> uniform_dist(0, n - 1);
    if (group == 1 || n <= 4) {
        ll cnt = 0;
        ll go = n;
        ll go2 = 0;
        vector<pll> arr;
        uniform_int_distribution<ll> uniform_dist2(0, n);
        while (cnt < 10000){
            g1 = g1_origin;
            g2 = g2_origin;
            cnt++;
            arr.clear();
            ll m = uniform_dist2(e1);
            for (int i = 0; i < m; ++i) {
                pll a = gen(uniform_dist);
                bool cool = true;
                for (int j = 0; j < arr.size(); ++j) {
                    if (arr[j] == a || (arr[j].first == a.second && arr[j].second == a.first)) {
                        cool = false;
                    }
                }
                if (!cool) {
                    i--;
                    continue;
                }
                arr.push_back(a);
            }
            go = n;
            for (int i = 0; i < arr.size(); ++i) {
                g1[arr[i].first][arr[i].second] = !g1[arr[i].first][arr[i].second];
                g2[arr[i].first][arr[i].second] = !g2[arr[i].first][arr[i].second];
                g1[arr[i].second][arr[i].first] = !g1[arr[i].second][arr[i].first];
                g2[arr[i].second][arr[i].first] = !g2[arr[i].second][arr[i].first];
                used.clear();
                used.resize(n);
                go = is_cool(g2, 0);
                if (go != n) {
                    break;
                }
            }
            used.clear();
            used.resize(n);
            go2 = is_cool(g1, 0);
            if (go == n && go2 == n) {
                break;
            }
        }
        if (go == n && go2 == n) {
            used.clear();
            used.resize(n);
            ll res1 = is_cool(g1, 0);
            used.clear();
            used.resize(n);
            ll res2 = is_cool(g2, 0);
            if (res1 != n || res2 != n){
                cout << 1 / 0;
            }
            cout << "Yes\n";
            cout << arr.size() << "\n";
            for (auto a : arr) {
                cout << a.first + 1 << " " << a.second + 1 << "\n";
            }
        }
        else{

            cout << "No\n";
        }
        return;
    }
    if (group == 5 || group == 6 || group == 9){
        vll color(n);
        set<ll> tobeat;
        for (int i = 0; i < n; ++i) {
            color[i] = i;
            if (i != 0) {
                tobeat.insert(i);
            }
        }
        vector<pll> tans;
        for (int i = 0; i < n; ++i) {
            if (color[i] == 0){
                vll ans;
                for (auto item : tobeat){
                    if (g1[i][item]){
                        ans.push_back(item);
                        color[item] = 0;
                        continue;
                    }
                    if (!g2[i][item]){
                        ans.push_back(item);
                        tans.push_back({i, item});
                        color[item] = 0;
                    }
                    //cout << item << " ";
                }
                //cout << " rt\n";
                for (int j = 0; j < ans.size(); ++j) {
                    tobeat.erase(ans[j]);
                }
                ans.clear();
            }
        }
        cout << "Yes\n";
        cout << tans.size() << "\n";
        for (int i = 0; i < tans.size(); ++i) {
            cout << tans[i].first + 1 << " " << tans[i].second + 1 << "\n";
        }
        return;
    }
    cout << 1 / 0;
}



int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
    }
}
