#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

void dfs1(int v, int n, const std::vector<std::vector<bool>>& gr, std::vector<bool>& used) {
    used[v] = true;
    for (int i = 0; i < n; i++) {
        if (gr[v][i] && !used[i]) {
            dfs1(i, n, gr, used);
        }
    }
}

void solveg1(int n, int m1, int m2, std::vector<std::vector<int>>& gr1, std::vector<std::vector<int>>& gr2) {
    std::vector<std::vector<bool>> conn1(n, std::vector<bool>(n, false)), conn2(n, std::vector<bool>(n, false));
    for (int u = 0; u < n; u++) {
        for (int v : gr1[u]) {
            conn1[u][v] = conn1[v][u] = true;
        }
    }
    for (int a = 0; a < n; a++) {
        for (int b : gr2[a]) {
            conn2[a][b] = conn2[b][a] = true;
        }
    }
    std::vector<std::pair<int, int>> edges;
    edges.reserve(n * (n - 1) / 2);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.emplace_back(i, j);
        }
    }
    int cnte = n * (n - 1) / 2;
    std::vector<bool> used(n);
    for (unsigned mask = 0; mask < (1u << cnte); mask++) {
        std::vector<int> cperm;
        cperm.reserve(__builtin_popcount(mask));
        for (int i = 0; i < cnte; i++) {
            if ((mask >> i) & 1) {
                cperm.emplace_back(i);
            }
        }
        do {
            bool cgood = true;
            for (int i = 0; i < (int)cperm.size(); i++) {
                auto [a, b] = edges[cperm[i]];
                conn1[a][b] = !conn1[a][b];
                conn2[a][b] = !conn2[a][b];
                conn1[b][a] = !conn1[b][a];
                conn2[b][a] = !conn2[b][a];
                std::fill(used.begin(), used.end(), false);
                dfs1(0, n, conn2, used);
                bool allused = true;
                for (int i = 0; i < n; i++) {
                    allused = allused && used[i];
                }
                if (!allused) {
                    cgood = false;
                }
            }
            if (cgood) {
                std::fill(used.begin(), used.end(), false);
                dfs1(0, n, conn1, used);
                bool allused = true;
                for (int i = 0; i < n; i++) {
                    allused = allused && used[i];
                }
                if (allused) {
                    std::cout << "Yes\n" << cperm.size() << '\n';
                    for (int num : cperm) {
                        std::cout << edges[num].first + 1 << ' ' << edges[num].second + 1 << '\n';
                    }
                    return;
                }
            }
            for (int num : cperm) {
                auto [a, b] = edges[num];
                conn1[a][b] = !conn1[a][b];
                conn1[b][a] = !conn1[b][a];
                conn2[a][b] = !conn2[a][b];
                conn2[b][a] = !conn2[b][a];
            }
        } while (std::next_permutation(cperm.begin(), cperm.end()));
    }
    std::cout << "No\n";
}

void solveg2(int n, int m1, int m2, const std::vector<std::vector<int>>& gr1, const std::vector<std::vector<int>>& gr2) {
    std::vector<std::vector<bool>> conn1(n, std::vector<bool>(n));
    std::vector<std::vector<bool>> conn2(n, std::vector<bool>(n));
    for (int i = 0; i < n; i++) {
        for (int to : gr1[i]) {
            conn1[i][to] = conn1[to][i] = true;
        }
        for (int to : gr2[i]) {
            conn2[i][to] = conn2[to][i] = true;
        }
    }
    std::vector<std::pair<int, int>> ch;
    for (int i = 0; i < n - 1; i++) {
        if (!conn1[i][i + 1]) {
            ch.emplace_back(i, i + 1);
        }
    }
    std::cout << "Yes\n" << ch.size() << '\n';
    for (auto [a, b] : ch) {
        std::cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

void dfs3(int v, const std::vector<std::vector<int>>& gr, std::vector<bool>& used) {
    used[v] = true;
    for (int to : gr[v]) {
        if (!used[to]) {
            dfs3(to, gr, used);
        }
    }
}

void dfs32(int v, int p, const std::vector<std::vector<int>>& gr, std::vector<bool>& used, std::vector<int>& dp, std::vector<int>& h, std::set<std::pair<int, int>>& br) {
    dp[v] = h[v];
    used[v] = true;
    for (int to : gr[v]) {
        if (used[to] && to != p) {
            dp[v] = std::min(dp[v], h[to]);
        }
        if (!used[to]) {
            h[to] = h[v] + 1;
            dfs32(to, v, gr, used, dp, h, br);
            dp[v] = std::min(dp[v], dp[to]);
            if (dp[to] > h[v]) {
                br.emplace(v, to);
                br.emplace(to, v);
            }
        }
    }
}

void solveg3(int n, int m1, int m2, const std::vector<std::vector<int>>& gr1, const std::vector<std::vector<int>>& gr2) {
    std::vector<int> comp1;
    std::vector<int> comp2;
    std::vector<std::vector<bool>> conn2(n, std::vector<bool>(n));
    for (int i = 0; i < n; i++) {
        for (int to : gr2[i]) {
            conn2[i][to] = conn2[to][i] = true;
        }
    }
    std::vector<bool> used(n, false);
    dfs3(0, gr1, used);
    int free = -1;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            comp1.emplace_back(i);
        } else {
            comp2.emplace_back(i);
        }
    }
    if (comp2.empty()) {
        std::cout << "Yes\n0\n";
        return;
    }
    std::fill(used.begin(), used.end(), false);
    std::set<std::pair<int, int>> br;
    std::vector<int> dp(n, 0);
    std::vector<int> h(n, 0);
    dfs32(0, 0, gr2, used, dp, h, br);
    for (int u : comp1) {
        for (int v : comp2) {
            if (br.find({u, v}) != br.end()) {
                std::cout << "Yes\n1\n" << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
    }
    std::cout << "No\n";
}

int main() {
    int t, g;
    std::cin >> t >> g;
    for (int num = 0; num < t; num++) {
        int n, m1, m2;
        std::cin >> n >> m1 >> m2;
        std::vector<std::vector<int>> gr1(n);
        std::vector<std::vector<int>> gr2(n);
        for (int i = 0; i < m1; i++) {
            int u, v;
            std::cin >> u >> v;
            u--;
            v--;
            gr1[u].emplace_back(v);
            gr1[v].emplace_back(u);
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            std::cin >> a >> b;
            a--;
            b--;
            gr2[a].emplace_back(b);
            gr2[b].emplace_back(a);
        }
        if (g == 1 || n <= 5) {
            solveg1(n, m1, m2, gr1, gr2);
        } else if (g == 2) {
            solveg2(n, m1, m2, gr1, gr2);
        } else if (g == 3) {
            solveg3(n, m1, m2, gr1, gr2);
        }
    }
}