#include <bits/stdc++.h>

void solve() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::pair<int, int>> edg1(m1), edg2(m2);
    std::vector<std::vector<int>> gr1(n), gr2(n);
    for (auto& [edg, gr] : std::array{std::pair{&edg1, &gr1}, std::pair{&edg2, &gr2}}) {
        for (auto& [u, v] : *edg) {
            std::cin >> u >> v;
            u--;
            v--;
            if (u > v) {
                std::swap(u, v);
            }
            gr->operator[](u).push_back(v);
            gr->operator[](v).push_back(u);
        }
        std::sort(edg->begin(), edg->end());
    }
    assert(n >= 3);

    if (n <= 5) {
        std::vector<std::pair<int, int>> all;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                all.push_back({i, j});
            }
        }
        assert(std::is_sorted(all.begin(), all.end()));
        int m = all.size();
        assert(m >= n);
        std::vector<int> cum(m, 0);
        std::fill(cum.begin() + m - n, cum.end(), 1);
        assert(std::is_sorted(cum.begin(), cum.end()));

        std::vector<int> pr_1(m), pr_2(m);
        for (auto& p : edg1) {
            auto it = std::lower_bound(all.begin(), all.end(), p) - all.begin();
            assert(it != m);
            assert(all[it] == p);
            pr_1[it] = 1;
        }
        for (auto& p : edg2) {
            auto it = std::lower_bound(all.begin(), all.end(), p) - all.begin();
            assert(it != m);
            assert(all[it] == p);
            pr_2[it] = 1;
        }

        bool suc = false;
        // do {
        for (int mask = 0; mask < (1 << m); mask++) {
            auto check = [&](std::vector<int> ind) {
                auto conn = [&](const auto& pr) {
                    assert(pr.size() == m);
                    std::vector<int> prv(n, -1);
                    auto get = [&](auto get, int i) -> int {
                        return prv[i] == -1 ? i : prv[i] = get(get, prv[i]);
                    };
                    int cnt = 0;
                    for (int i = 0; i < m; i++) {
                        if (pr[i]) {
                            auto [u, v] = all[i];
                            u = get(get, u);
                            v = get(get, v);
                            if (u != v) {
                                cnt++;
                                prv[u] = v;
                            }
                        }
                    }
                    return cnt == n - 1;
                };
                assert(!suc);
                assert(ind.size() <= n);

                auto pr1 = pr_1;
                auto pr2 = pr_2;
                std::sort(ind.begin(), ind.end(), [&](auto a, auto b) { return pr2[a] < pr2[b]; });
                assert(conn(pr2));

                for (int i : ind) {
                    pr1[i] ^= 1;
                    pr2[i] ^= 1;
                }
                if (conn(pr1) && conn(pr2)) {
                    {
                        pr2 = pr_2;
                        for (int i : ind) {
                            pr2[i] ^= 1;
                            assert(conn(pr2));
                        }
                    }
                    std::cout << "Yes\n";
                    std::cout << ind.size() << "\n";
                    for (int i : ind) {
                        auto [u, v] = all[i];
                        v++;
                        u++;
                        std::cout << u << " " << v << "\n";
                    }
                    suc = true;
                    return true;
                }
                return false;
            };

            std::vector<int> ind;
            for (int i = 0; i < m; i++) {
                if ((mask >> i) & 1) {
                    ind.push_back(i);
                }
            }
            if (ind.size() > n) {
                continue;
            }
            // assert(ind.size() == n);
            for (int i = 0; i <= ind.size() && !suc; i++) {
                check(std::vector<int>(ind.begin(), ind.begin() + i));
            }
        }
        // } while (!suc && std::next_permutation(cum.begin(), cum.end()));

        if (!suc) {
            std::cout << "No\n";
        }
        return;
    }

    struct DSU {
        std::vector<int> prv;

        DSU() = default;

        DSU(int n) {
            clear(n);
        }

        void clear(int n) {
            prv.assign(n, -1);
        }

        int get(int i) {
            return prv[i] == -1 ? i : prv[i] = get(prv[i]);
        }

        bool merge(int u, int v) {
            u = get(u);
            v = get(v);
            if (u != v) {
                prv[u] = v;
                return true;
            }
            return false;
        }
    };

    {
        DSU dsu(n);
        int cnt = 0;
        for (auto [u, v] : edg1) {
            cnt += dsu.merge(u, v);
        }
        if (cnt == n - 1) {
            std::cout << "Yes\n0\n";
            return;
        }
    }

    std::vector<int> tr2, dg2(n);
    {
        DSU dsu(n);
        for (int i = 0; i < m2; i++) {
            auto [u, v] = edg2[i];
            if (dsu.merge(u, v)) {
                tr2.push_back(i);
                dg2[u]++;
                dg2[v]++;
            }
        }
    }
    assert(tr2.size() == n - 1);
    int it = std::find(dg2.begin(), dg2.end(), n - 1) - dg2.begin();
    std::vector<std::pair<int, int>> ans;

    // std::set<std::pair<int, int>> set1(edg1.begin(), edg1.end());
    // std::set<std::pair<int, int>> set2(edg2.begin(), edg2.end());
    auto cont = [&](const auto& vec, auto val) {
        return std::binary_search(vec.begin(), vec.end(), val);
    };
    auto lb = [&](const auto& vec, auto val) {
        return std::lower_bound(vec.begin(), vec.end(), val) - vec.begin();
    };

    if (it != n) {
        bool suc = false;
        for (int t = 0; t < m2; t++) {
            auto [i, j] = edg2[t];
            if (i != it && j != it) {
                int it1 = lb(edg2, std::pair{std::min(it, i), std::max(it, i)});
                std::erase(tr2, it1);
                tr2.push_back(t);
                assert(tr2.size() == n - 1);
                suc = true;
                break;
            }
        }
        assert(suc == (m2 != n - 1));
        if (!suc) {
            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    if (i == it || j == it) {
                        continue;
                    }
                    if (!cont(edg1, std::pair{i, j})) {
                        suc = true;

                        int it1 = lb(edg2, std::pair{std::min(it, i), std::max(it, i)});
                        std::erase(tr2, it1);
                        assert(tr2.size() == n - 2);

                        ans.push_back({i, j});
                        edg1.push_back({i, j});
                        std::sort(edg1.begin(), edg1.end());
                        m1++;

                        std::vector<std::pair<int, int>> edg3;
                        for (int i : tr2) {
                            edg3.push_back(edg2[i]);
                        }
                        edg3.push_back({i, j});

                        assert(edg3.size() == n - 1);

                        std::sort(edg3.begin(), edg3.end());
                        edg2 = edg3;
                        tr2.assign(n - 1, 0);
                        std::iota(tr2.begin(), tr2.end(), 0);
                        m2 = n - 1;

                        break;
                    }
                }
            }
        }
        assert(suc);
    }

#define assert(exp) \
    if (!(exp)) {   \
        exit(0);    \
    }

    std::vector<std::pair<int, int>> edg3;
    for (int i : tr2) {
        edg3.push_back(edg2[i]);
    }
    std::sort(edg3.begin(), edg3.end());

    std::vector<std::pair<int, int>> fuck;
    for (int i = 0; i < n; i++) {
        if (gr1[i].size() == 0) {
            bool suc = false;
            for (int j = 0; j < n; j++) {
                if (i != j) {
                    if (!cont(edg3, std::pair{std::min(i, j), std::max(i, j)})) {
                        fuck.push_back({i, j});
                        suc = true;
                        break;
                    }
                }
            }
            assert(suc);
        }
    }

    DSU dsu(n);
    for (auto [u, v] : edg1) {
        dsu.merge(u, v);
    }
    for (auto [u, v] : fuck) {
        if (dsu.merge(u, v)) {
            ans.push_back({u, v});
        }
    }
    std::vector<std::vector<int>> cum(n);
    for (int i = 0; i < n; i++) {
        cum[dsu.get(i)].push_back(i);
    }

    std::vector<int> shit;
    for (int i = 0; i < n; i++) {
        assert(cum[i].size() != 1);
        if (shit.empty()) {
            shit = cum[i];
        } else {
            if (cum[i].size()) {
                bool suc = false;
                for (int a : shit) {
                    for (int b : cum[i]) {
                        if (!cont(edg3, std::pair{std::min(a, b), std::max(a, b)})) {
                            ans.push_back({a, b});
                            suc = true;
                            break;
                        }
                    }
                    if (suc) {
                        break;
                    }
                }
                assert(suc);
                if (shit.size() < cum[i].size()) {
                    shit.swap(cum[i]);
                }
                shit.insert(shit.end(), cum[i].begin(), cum[i].end());
            }
        }
    }

    assert(ans.size() <= n);

    std::cout << "Yes\n";
    std::cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        std::cout << u + 1 << " " << v + 1 << "\n";
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t, g;
    std::cin >> t >> g;
    while (t--) {
        solve();
    }

    return 0;
}
