#include <bits/stdc++.h>

using namespace std;

int g;

vector<set<int>> gr1;
vector<set<int>> gr2;
vector<bool> used;

void dfs(vector<set<int>> &gr, int u) {
    used[u] = true;
    for (auto v: gr[u]) {
        if (!used[v])
            dfs(gr, v);
    }
}

bool check(vector<set<int>> &gr) {
    used.assign(gr.size(), false);
    dfs(gr, 0);
    return count(used.begin(), used.end(), true) == used.size();
}

inline void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    gr1 = vector<set<int>>(n);
    gr2 = vector<set<int>>(n);
    used = vector<bool>(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        gr1[a - 1].insert(b - 1);
        gr1[b - 1].insert(a - 1);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        gr2[a - 1].insert(b - 1);
        gr2[b - 1].insert(a - 1);
    }
    vector<pair<int, int>> pairs;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j)
            pairs.emplace_back(i, j);
    }
    for (int mask = 0; mask < (1 << pairs.size()); ++mask) {
        vector<int> inds;
        for (int i = 0; i < pairs.size(); ++i) {
            if (mask & (1 << i)) {
                inds.push_back(i);
                if (inds.size() > n)
                    break;
            }
        }
        if (inds.size() > n)
            continue;
        do {
            vector<set<int>> newgr1 = gr1;
            vector<set<int>> newgr2 = gr2;
            bool flag = true;
            for (auto i: inds) {
                auto it1 = newgr1[pairs[i].first].find(pairs[i].second);
                if (it1 != newgr1[pairs[i].first].end()) {
                    newgr1[pairs[i].first].erase(it1);
                    newgr1[pairs[i].second].erase(pairs[i].first);
                } else {
                    newgr1[pairs[i].first].insert(pairs[i].second);
                    newgr1[pairs[i].second].insert(pairs[i].first);
                }
                auto it2 = newgr2[pairs[i].first].find(pairs[i].second);
                if (it2 != newgr2[pairs[i].first].end()) {
                    newgr2[pairs[i].first].erase(it2);
                    newgr2[pairs[i].second].erase(pairs[i].first);
                    if (!check(newgr2)) {
                        flag = false;
                        break;
                    }
                } else {
                    newgr2[pairs[i].first].insert(pairs[i].second);
                    newgr2[pairs[i].second].insert(pairs[i].first);
                }
            }
            if (flag && check(newgr1) && check(newgr2)) {
                cout << "Yes\n";
                cout << inds.size() << '\n';
                for (auto i: inds)
                    cout << pairs[i].first + 1 << ' ' << pairs[i].second + 1 << '\n';
                return;
            }
        } while (next_permutation(inds.begin(), inds.end()));
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    cin >> tests >> g;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
