#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

void solve(int task) {
    int n;
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    vector<vector<int>> g1(n);
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g1[v].push_back(u);
        g1[u].push_back(v);
    }
    vector<vector<int>> g2(n);
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g2[v].push_back(u);
        g2[u].push_back(v);
    }
    if (task == 3) {
        vector<int> col(n);
        int cnt = 0;
        auto dfs = [&] (auto self, int v) {
            if (col[v]) {
                return;
            }
            col[v] = 1;
            cnt++;
            for (auto u : g1[v]) {
                self(self, u);
            }
        };

        dfs(dfs, 0);

        vector<vector<int>> m(n, vector<int> (n));
        for (int v = 0; v < n; ++v) {
            for (auto u : g1[v]) {
                m[v][u] = 1;
            }
        }
        for (int v = 0; v < n; ++v) {
            for (auto u : g2[v]) {
                m[v][u] += 1;
            }
        }
        /*for (auto i : m) {
            for (auto j : i) {
                cout << j << ' ';
            }
            cout << endl;
        }*/

        for (int v = 0; v < n; ++v) {
            for (int u = v + 1; u < n; ++u) {
                if (m[v][u] == 0 && col[v] != col[u]) {
                    cout << "Yes\n";
                    cout << 1 << '\n';
                    cout << v + 1 << ' ' << u + 1 << '\n';
                    return;
                }
            }
        }
        if (cnt == 1) {
            for (int v = 0; v < n; ++v) {
                if (col[v] == 0) {
                    cout << "Yes\n";
                    cout << 1 << '\n';
                    cout << 1 << ' ' << v + 1 << '\n';
                    return;
                }
            }
        }
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t, task;
    cin >> t >> task;
    while (t--) {
        solve(task);
    }

}