#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

const int N = 3e3 + 3;
int n;
vector<vector<int>> g1, g2;

mt19937_64 rnd(time(0));

map<pair<int, int>, bool> ban;

int group;

void dfs(int v, vector<bool>& used) {
    used[v] = true;
    for (auto u : g2[v]) {
        if (used[u] || ban[{min(u, v), max(u, v)}]) continue;
        dfs(u, used);
    }
}

int cnt_comps() {
    int cnt = 0;
    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, used);
            cnt++;
        }
    }
    return cnt;
}

struct DSU {
    vector<int> p;
    vector<int> sz;
    int cnt = 0;
    explicit DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        sz.resize(n, 1);
        cnt = n;
    }
    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }
    bool check(int u, int v) {
        return get(u) == get(v);
    }
    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (v == u) return;
        if (sz[v] > sz[u]) swap(u, v);
        p[v] = u;
        sz[u] += sz[v];
        cnt--;
    }
};

void solve1(DSU dsu) {
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (!dsu.check(i, j))
                edges.emplace_back(i, j);
        }
    }

    shuffle(all(edges), rnd);

    //dbg2(edges);
    vector<pair<int, int>> ans;
    for (auto [u, v] : edges) {
        if (dsu.check(u, v))
            continue;
        // u < v
        ban[{u, v}] = true;
        //dbg(cnt_comps());
        if (cnt_comps() != 1)
            ban[{u, v}] = false;
        else {
            dsu.unite(u, v);
            ans.emplace_back(u, v);
        }

        if (dsu.cnt == 1)
            break;
    }

    //dbg(dsu.cnt);

    if (dsu.cnt == 1) {
        cout << "Yes\n" << ans.size() << '\n';
        for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
    } else {
        cout << "No\n";
    }
}

void solve2() {
    int m1, m2;
    cin >> m1 >> m2;

    map<pair<int, int>, bool> in1, in2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        in1[{min(u, v), max(u, v)}] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        in2[{min(u, v), max(u, v)}] = true;
    }

    vector<pair<int, int>> ans;

    for (int i = 1; i < n - 1; i++) {
        if (!in1[{i, i + 1}]) {
            ans.emplace_back(i, i + 1);
        }
    }

    if (ans.empty()) {
        ans.emplace_back(1, 3);
        ans.emplace_back(0, 1);
    } else {
        auto [u, v] = ans.back();
        ans.emplace_back(0, v);
        //ans.emplace_back(v, v - 2);
    }

    cout << "Yes\n" << ans.size() << '\n';
    for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
}

void dfs2(int v, vector<bool>& used, vector<set<int>>& gr) {
    used[v] = true;
    for (auto u : gr[v]) {
        if (used[u]) continue;
        dfs2(u, used, gr);
    }
}

int cnt_comps2(vector<set<int>>& gr) {
    int cnt = 0;
    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i, used, gr);
            cnt++;
        }
    }
    return cnt;
}

void solve3() {
    int m1, m2;

    cin >> m1 >> m2;

    vector<set<int>> gr1(n), gr2(n);

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        gr1[u].insert(v);
        gr1[v].insert(u);
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        gr2[u].insert(v);
        gr2[v].insert(u);
    }

    vector<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++)
            edges.emplace_back(i, j);
    }

    vector<int> p(n * (n - 1) / 2);
    iota(all(p), 0);

    for (int _ = 0; _ < 100000; _++) {
        shuffle(all(p), rnd);
        auto svgr1 = gr1, svgr2 = gr2;
        for (int i = 0; i < min(n, (int)p.size()); i++) {
            auto [u, v] = edges[p[i]];
            if (svgr1[u].count(v)) {
                svgr1[u].erase(v);
                svgr1[v].erase(u);
            } else {
                svgr1[u].insert(v);
                svgr1[v].insert(u);
            }

            if (svgr2[u].count(v)) {
                svgr2[u].erase(v);
                svgr2[v].erase(u);
            } else {
                svgr2[u].insert(v);
                svgr2[v].insert(u);
            }

            if (cnt_comps2(svgr2) != 1)
                break;
            if (cnt_comps2(svgr1) == 1) {
                cout << "Yes\n" << i + 1 << '\n';
                for (int j = 0; j <= i; j++)
                    cout << edges[p[j]].F + 1 << ' ' << edges[p[j]].S + 1 << '\n';
                return;
            }
        }
        //if (ok) break;
    }
    cout << "No\n";
}

void solve() {
    cin >> n;
    if (n <= 4) {
        solve3();
        return;
    }
    if (group == 5) {
        solve2();
        return;
    }
    int m1, m2;
    cin >> m1 >> m2;

    g1.assign(n, vector<int>());
    g2.assign(n, vector<int>());
    ban.clear();

    DSU dsu(n);

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g1[u].emplace_back(v);
        g1[v].emplace_back(u);
        dsu.unite(u, v);
    }

    //dbg(dsu.cnt);

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g2[u].emplace_back(v);
        g2[v].emplace_back(u);
    }

    solve1(dsu);

}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}
