// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <numeric>
#include <bitset>
#include <utility>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

struct UnionFind
{
    vector <int> len;
    vector <int>p;
    int cnt;
    UnionFind(int n) :p(n), len(n,1), cnt(n)
    {
        iota(p.begin(), p.end(), 0);
    }

    int find(int x)
    {
        if (p[x] == x)
            return x;
        return p[x] = find(p[x]);
    }

    bool inject(int a, int b)
    {
        a = find(a);
        b = find(b);
        if (a == b)
            return 0;
        if (len[a] > len[b])
            swap(a, b);
        len[b] += len[a];
        p[a] = b;
        cnt -= 1;
        return 1;
    }

    bool same(int a, int b)
    {
        return find(a) == find(b);
    }
};

void solve()
{
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set <pair<int, int>> g1, g2;
    vector <vector<int>>gr(n);
    UnionFind uf(n), unused(n);
    for (size_t i = 0; i < m1; i++)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g1.emplace(minmax(u, v));
        unused.inject(u, v);
    }
    for (size_t i = 0; i < m2; i++)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g2.emplace(minmax(u, v));
        if (uf.inject(u, v))
        {
            gr[u].push_back(v);
            gr[v].push_back(u);
        }
    }
    int leaf = 0;
    while (gr[leaf].size() != 1) leaf++;
    int v = gr[leaf][0];
    vector <pair<int, int>> ans;
    auto push = [&](int a, int b)
    {
        if (g1.count(minmax(a, b)))
            return;
        g1.emplace(minmax(a, b));
        ans.emplace_back(a, b);
        if (g2.count(minmax(a, b)))
            g2.erase(minmax(a, b));
        else
            g2.insert(minmax(a, b));
    };
    auto push2 = [&](int a, int b)
    {
        if (g2.count(minmax(a, b)))
            return;
        g2.emplace(minmax(a, b));
        ans.emplace_back(a, b);
        if (g1.count(minmax(a, b)))
            g1.erase(minmax(a, b));
        else
            g1.insert(minmax(a, b));
    };
    if (n == 3)
    {
        push2(0, 1);
        push2(1, 2);
        push2(0, 2);
        if (!unused.same(0, 1))
            push(0, 1);
        else if (!unused.same(0, 2))
            push(0, 2);
        else
            push(1, 2);
        for (auto& i : g1)
        {
            unused.inject(i.first, i.second);
        }
        if (unused.cnt == 1)
        {
            cout << "Yes\n" << ans.size() << '\n';
            for (auto& i : ans)
            {
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            return;
        }
        cout << "No\n";
        return;
        //exit(-1);
    }
    vector <int> tv;
    for (size_t i = 0; i < n; i++)
    {
        if (i == leaf || i == v)
            continue;
        push(leaf, i);
        tv.push_back(i);
    }
    int a = tv[0], b = tv[1];
    push2(a, b);
    push(a, v);
    cout << "Yes\n" << ans.size() << '\n';
    for (auto& i : ans)
    {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int t, g;
    cin >> t >> g;
    while (t--)
        solve();
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
