#include <bits/stdc++.h>
using namespace std;
#define int long long
struct DSU {
    vector < int > p, s;
    int n;
    DSU(int n) {
        p.resize(n + 1); iota(begin(p), end(p), 0);
        s.resize(n + 1, 1);
    };
    int get(int v) { return (v == p[v] ? v : p[v] = get(p[v])); }
    void unite(int a, int b) {
        a = get(a); b = get(b);
        if (a == b) return;
        if (s[a] < s[b]) swap(a, b);
        s[a] += s[b];
        p[b] = a;
    }
};
main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        DSU st(n);
        for (int i = 0; i < m1; i++) {
            int u, v;
            cin >> u >> v; u--; v--;
            st.unite(u, v);
        }
        vector < unordered_map < int , int > > G(n);
        for (int i = 0; i < m2; i++) {
            int u, v;
            cin >> u >> v; u--; v--;
            G[u][v] = 1;
            G[v][u] = 1;
        }
        vector < pair < int , int > > por;
        for (int d = 1; d < n; d++)
            for (int i = 0; i < n; i++) {
                int j = (i + d) % n;
                if (st.get(i) != st.get(j) && !G[i][j]) {
                    st.unite(i, j);
                    por.push_back({i, j});
                    G[i][j] = 1;
                    G[j][i] = 1;
                }
            }
        for (int d = 1; d < n; d++)
            for (int i = 0; i < n; i++) {
                int j = (i + d) % n;
                if (st.get(i) != st.get(j)) {
                    st.unite(i, j);
                    por.push_back({i, j});
                    G[i][j] ^= 1;
                    G[j][i] ^= 1;
                }
            }
        vector < bool > was(n);
        function < void(int) > dfs = [&](int v) {
            was[v] = 1;
            for (int u = 0; u < n; u++) if (G[v][u] && !was[u]) {
                dfs(u);
            }
        };
        int k = 0;
        for (int i = 0; i < n; i++) if (!was[i]) {
            k++;
            dfs(i);
        }
        if (k > 1) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << por.size() << '\n';
            for (auto u : por) cout << u.first << " " << u.second << '\n';
        }
    }

}
