#include <bits/stdc++.h>
using namespace std;
#define int long long
struct DSU {
    vector < int > p, s;
    int n;
    DSU(int n) {
        p.resize(n + 1); iota(begin(p), end(p), 0);
        s.resize(n + 1, 1);
    };
    int get(int v) { return (v == p[v] ? v : p[v] = get(p[v])); }
    int sz(int v) {
        v = get(v);
        return s[v];
    };
    void unite(int a, int b) {
        a = get(a); b = get(b);
        if (a == b) return;
        if (s[a] < s[b]) swap(a, b);
        s[a] += s[b];
        p[b] = a;
    }
};
mt19937 rnd(time(0));
main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        DSU st(n);
        for (int i = 0; i < m1; i++) {
            int u, v;
            cin >> u >> v; u--; v--;
            st.unite(u, v);
        }
        vector < unordered_map < int , int > > G(n);
        for (int i = 0; i < m2; i++) {
            int u, v;
            cin >> u >> v; u--; v--;
            G[u][v] = 1;
            G[v][u] = 1;
        }
        if (g == 3) {
            bool good = 0; int X,Y;
            for (int i = 0; !good && i < n; i++) {
                for (int j = 0; !good && j < n; j++) {
                    if (st.get(i) != st.get(j) && !G[i][j]) {
                        good = 1;
                        X = i; Y = j;
                    }
                }
            }
            if (good) {
                cout << "Yes\n";
                cout << "1\n";
                cout << X << " " << Y << '\n';
                continue;
            }
            for (int i = 0; !good && i < n; i++) {
                for (int j = 0; !good && j < n; j++) {
                    if (st.get(i) != st.get(j)) {
                        st.unite(i, j);
                        G[i][j] ^= 1;
                        G[j][i] ^= 1;
                        X = i; Y = j;
                    }
                }
            }
            vector < bool > was(n);
            function < void(int) > dfs = [&](int v) {
                was[v] = 1;
                for (int u = 0; u < n; u++) if (G[v][u] && !was[u]) {
                    dfs(u);
                }
            };
            int k = 0;
            for (int i = 0; i < n; i++) if (!was[i]) {
                k++;
                dfs(i);
            }
            if (k > 1) {
                cout << "No\n";
            } else {
                cout << "Yes\n";
                cout << "1\n";
                cout << X << " " << Y << "\n";
            };
            continue;
        }
        vector < pair < int , int > > por;
        for (int d = 1; d < n; d++)
            for (int i = 0; i < n; i++) {
                int j = (i + d) % n;
                if (st.get(i) != st.get(j) && !G[i][j]) {
                    st.unite(i, j);
                    por.push_back({i, j});
                    G[i][j] = 1;
                    G[j][i] = 1;
                }
            }
        while (1) {
            int x = rnd() % n, y = rnd() % n;
            if (st.sz(x) == n) break;
            if (st.get(x) != st.get(y)) {
                st.unite(x, y);
                por.push_back({x, y});
                G[x][y] ^= 1;
                G[y][x] ^= 1;
            }
        }
        vector < bool > was(n);
        function < void(int) > dfs = [&](int v) {
            was[v] = 1;
            for (int u = 0; u < n; u++) if (G[v][u] && !was[u]) {
                dfs(u);
            }
        };
        int k = 0;
        for (int i = 0; i < n; i++) if (!was[i]) {
            k++;
            dfs(i);
        }
        if (k > 1) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << por.size() << '\n';
            for (auto u : por) cout << u.first + 1 << " " << u.second + 1 << '\n';
        }
    }

}
