#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> comp;

void dfs(int v, int c) {
    comp[v] = c;
    for (auto to : g[v]) {
        if (comp[to] != -1)
            continue;
        dfs(to, c);
    }
}

mt19937 gen(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

template <typename T>
void shuffle(vector<T>& a) {
    for (int i = 0; i < a.size(); ++i)
        swap(a[i], a[gen() % a.size()]);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g.assign(n, {}), comp.assign(n, -1);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (m2 == n * (n - 1) / 2) {
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
        }
        vector<int> compheads;
        for (int i = 0; i < n; ++i) {
            if (comp[i] != -1)
                continue;
            dfs(i, 0);
            compheads.push_back(i);
        }
        if (n == 3 && compheads.size() > 2) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        cout << compheads.size() - 1 << "\n";
        for (int i = 1; i < compheads.size(); ++i) {
            cout << compheads[i - 1] + 1 << ' ' << compheads[i] + 1 << "\n";
        }
        return;
    }
    int curcomp = 0;
    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1)
            continue;
        dfs(i, curcomp++);
    }
    int ansu = -1, ansv = -1;
    int cnt = 0;
    int addu, addv;
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        if (comp[u] != comp[v]) {
            addu = u, addv = v;
            cnt += 1;
            if (cnt >= 2 && gen() % 2)
                ansu = u, ansv = v;
        }
    }
    if (ansu != -1) {
        cout << "Yes\n1\n" << ansu + 1 << ' ' << ansv + 1 << '\n';
        return;
    }
    vector<int> comp1, comp2;
    for (int i = 0; i < n; ++i) {
        if (comp[i] == 0)
            comp1.push_back(i);
        else
            comp2.push_back(i);
    }
    shuffle(comp1), shuffle(comp2);
    for (auto u : comp1) {
        for (auto v : comp2) {
            if ((addu == u && addv == v) || (addu == v && addv == u))
                continue;
            cout << "Yes\n1\n";
            cout << u + 1 << ' ' << v + 1 << '\n';
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc, gr;
    cin >> tc >> gr;
    while (tc--)
        solve();
}
