#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

int n, m1, m2;
vector<vi> g1, g2;

struct comp {
    int n0;
    vector<vi> comps;
    vector<char> used;

    vector<set<int>> g;
    vi where;

    comp() {}
    void findComp() {
        used.assign(n, 0);
        comps.clear();
        for (int i = 0; i < n; i++) {
            if (used[i] == 0) {
                comps.emplace_back();
                dfs(i);
            }
        }
        n0 = (int)comps.size();
    }
    void findRoads() {
        where.resize(n);
        for (int i = 0; i < n0; i++) {
            for (int v : comps[i]) {
                where[v] = i;
            }
        }
        g.assign(n0, set<int>());
        for (int v1 = 0; v1 < n; v1++) {
            for (int v2 : g2[v1]) {
                if (v2 < v1) continue;
                int a1 = where[v1];
                int a2 = where[v2];
                if (a1 != a2) {
                    g[a1].insert(a2);
                    g[a2].insert(a1);
                }
            }
        }
    }
    void dfs(int v) {
        used[v] = 1;
        comps.back().push_back(v);
        for (int to : g1[v])
            if (used[to] == 0)
                dfs(to);
    }
};

void yes(vp &ans) {
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto[a, b] : ans)
        cout << a+1 << " " << b+1 << "\n";
}
void no() {
    cout << "No\n";
}

void solve3() { // n = 3
    vi v1(3, 0), v2(3, 0);
    for (int i = 0; i < n; i++) {
        for (int to : g1[i]) {
            if (to < i) continue;
            v1[i+to-1]++;
        }
        for (int to : g2[i]) {
            if (to < i) continue;
            v2[i+to-1]++;
        }
    }
    bool b1 = false;
    bool b2 = false;
    vp ans;
    for (int i = 0; i < 3; i++) {
        if (v1[i] == 1 && v2[i] == 1) continue;
        if (v1[i] == 0 && v2[i] == 0) {
            ans.emplace_back(0, 1);
            continue;
        }
        if (v1[i] == 1) {
            if (b1 == false)
                b1 = true;
            else if (b2 == false) {
                b2 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        } else {
            if (b2 == false)
                b2 = true;
            else if (b1 == false) {
                b1 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        }
    }
    yes(ans);
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vi());
    g2.assign(n, vi());
    for (int i = 0; i < m1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    map<pi, int> ed2;
    for (int i = 0; i < m2; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
        ed2[{a, b}] = 1;
        ed2[{b, a}] = 1;
    }
    if (n == 3) { solve3(); return; }
    comp cmp;
    cmp.findComp();
    cmp.findRoads();

    vp ans;
    for (int i = 0; i < cmp.n0-1; i++) {
        // add road from cmp.comps[i] to somewhere
        int j = i+1;
        for (int t0 = i+1; t0 < cmp.n0; t0++) {
            if (cmp.g[i].count(t0) == 0) {
                j = t0;
                break;
            }
        }
        // add road from comps[i] to comps[j]
        bool good = false;
        for (int vi1 : cmp.comps[i]) {
            for (int vj1 : cmp.comps[j]) {
                if (ed2.find({vi1, vj1}) == ed2.end()) {
                    ans.emplace_back(vi1, vj1);
                    good = true;
                    break;
                }
            }
            if (good)
                break;
        }
        if (!good) {
            int vi1 = cmp.comps[i][0];
            int vj1 = cmp.comps[j][0];
            ans.emplace_back(vi1, vj1);
        }
        // add dots to comps[j]
        for (int t : cmp.comps[i]) {
            cmp.where[t] = j;
        }
        for (int t0 : cmp.g[i]) {
            cmp.g[j].insert(t0);
        }
    }
    yes(ans);
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    int t, g; cin >> t >> g;
    while (t--)
        solve();
}
