#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, m1, m2;
vector <vector <int>> g1, g2;

struct DSU {
	vector <int> p, r;
	DSU(int n) {
		p.resize(n), r.resize(n, 0);
		for (int i = 0; i < n; i++) p[i] = i;
	}
	int get(int u) {
		if (u == p[u]) return u;
		return p[u] = get(p[u]);
	}
	bool join(int x, int y) {
		x = get(x), y = get(y);
		if (x == y) return 0;
		if (r[x] < r[y]) swap(x, y);
		p[y] = x;
		if (r[x] == r[y]) r[x]++;
		return 1;
	}
};

int main() {
	int t, gr; cin >> t >> gr;
	while (t--) {
		g1.clear(), g2.clear();
		cin >> n >> m1 >> m2;
		set <pair <int, int>> v;
		vector <pair <int, int>> ans;
		DSU d(n);
		for (int i = 0; i < m1; i++) {
			int x, y; cin >> x >> y;
			if (x > y) swap(x, y);
			v.insert({ x, y });
			d.join(x, y);
			g1[x].push_back(y), g1[y].push_back(x);
		}
		for (int i = 0; i < m2; i++) {
			int x, y; cin >> x >> y;
			g2[x].push_back(y), g2[y].push_back(x);
		}
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if (v.find({ i, j }) != v.end()) continue;
				if (d.join(i, j)) ans.push_back({ i, j });
			}
		}
		cout << "Yes\n" << ans.size() << "\n";
		for (auto i : ans) cout << i.first + 1 << ' ' << i.second + 1 << "\n";
	}
	return 0;
}