// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

struct DSU {
    vector<int> p;
    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
    }
    int get(int v) {
        return (p[v] == v ? v : p[v] = get(p[v]));
    }
    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        p[u] = v;
    }
};

void solve() {
    int n, m1, m2, u, v;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> e1(m1), e2(m2);
    for (auto& [u, v] : e1) {
        cin >> u >> v;
        u--, v--;
        if (u > v) swap(u, v);
    }
    for (auto& [u, v] : e2) {
        cin >> u >> v;
        u--, v--;
        if (u > v) swap(u, v);
    }
    DSU dsu1(n), dsu2(n);
    sort(all(e1));
    sort(all(e2));
    vector<pair<int, int>> both, only2;
    for (int i = 0; i < m2; ++i) {
        auto it = lower_bound(all(e1), e2[i]);
        if (it != e1.end() && *it == e2[i]) {
            both.push_back(e2[i]);
        } else {
            only2.push_back(e2[i]);
        }
    }
    for (auto [u, v] : e1) {
        dsu1.unite(u, v);
    }
    for (auto [u, v] : both) {
        dsu2.unite(u, v);
    }
    vector<pair<int, int>> ans;
    set<pair<int, int>> ost1;
    vector<int> st(n, 0);
    for (auto [u, v] : only2) {
        if (dsu2.get(u) != dsu2.get(v) && st[u] != n - 1 && st[v] != n - 1) {
            // if (st[v] == n - 2) {
            //     set<int> tmp = { 1,2 };
            //     tmp.erase(v);
            //     dsu2.unite(u, *tmp.begin());
            //     ost1.emplace(u, *tmp.begin());
            //     ans.emplace_back(u, *tmp.begin());
            //     st[u]++;
            //     st[*tmp.begin()]++;
            //     continue;
            // }
            // if (st[u] == n - 2) {
            //     set<int> tmp = { 1,2 };
            //     tmp.erase(u);
            //     dsu2.unite(v, *tmp.begin());
            //     ost1.emplace(v, *tmp.begin());
            //     ans.emplace_back(v, *tmp.begin());
            //     ans.emplace_back(u, v);
            //     st[v]++;
            //     st[*tmp.begin()]++;
            //     continue;
            // }
            dsu2.unite(u, v);
            ost1.emplace(u, v);
            st[u]++;
            st[v]++;
        }
    }
    int x = -1;
    for (int u = 0; u < n; ++u) {
        if (st[u] == n - 1) {
            x = u;
            break;
        }
    }
    if(x != -1){
        bool ok=false;
        for(int u = 0; u < n; ++u){
            for(int v = u+1; v < n; ++v){
                if(u != v && u != x && v != x){
                    auto it = lower_bound(all(e1), make_pair(u,v));
                    if(it == e1.end() || (it->first != u || it->second != v)){
                        ans.emplace_back(u,v);
                        dsu1.unite(u, v);
                        ost1.emplace(u,v);
                        ost1.erase({min(u,x),max(u,x)});
                        ok=true;
                    }
                }
            }
        }
        if(!ok){
            ans.emplace_back(0,1);
                        dsu1.unite(0,1);
                        ost1.emplace(0,1);
                        ost1.erase({x,1});
        }
    }
    for (int u = 0; u < n; ++u) {
        for (int v = u + 1; v < n; ++v) {
            if (ost1.contains({ u,v }) || dsu1.get(u) == dsu1.get(v)) continue;
            dsu1.unite(u, v);
            ans.emplace_back(u, v);
        }
    }
    for (int u = 1; u < n; ++u) {
        if (dsu1.get(u) != dsu1.get(u - 1)) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
