#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void dfs(ll v, vector<bool> &used, vector<vector<ll>> &edges) {
    ll n = edges.size();
    used[v] = true;
    for (ll i = 0; i < n; ++i) {
        if (edges[v][i] && !used[i]) {
            dfs(i, used, edges);
        }
    }
}

void solve(ll g) {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<ll>> edges1(n, vector<ll>(n, 0)), edges2(n, vector<ll>(n, 0));
    for (ll i = 0; i < m1; ++i) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        edges1[a][b] = 1;
        edges1[b][a] = 1;
    }
    for (ll i = 0; i < m2; ++i) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        edges2[a][b] = 1;
        edges2[b][a] = 1;
    }

    if (g <= 1) {
        vector<pair<ll, ll>> sigma;
        for (ll i = 0; i < n; ++i) {
            for (ll j = i + 1; j < n; ++j) {
                sigma.emplace_back(i, j);
            }
        }
        unordered_map<ll, ll> rev_sigma;
        for (ll i = 0; i < sigma.size(); ++i) {
            rev_sigma[sigma[i].first * n + sigma[i].second] = i;
        }

        vector<vector<ll>> edges3(n, vector<ll> (n, 0)), edges4(n, vector<ll> (n, 0));
        for (ll i = 0; i < (1ll << (n * (n - 1) / 2)); ++i) {
            ll i1 = i, cnt = 0;
            while (i1) {
                cnt += i1 & 1;
                i1 >>= 1;
            }
            if (cnt > n) {
                continue;
            }
            i1 = i;

            for (ll j = 0; j < n; ++j) {
                for (ll k = j + 1; k < n; ++k) {
                    if ((edges1[k][j] ^ i1) & 1) {
                        edges3[k][j] = 1;
                        edges3[j][k] = 1;
                    } else {
                        edges3[k][j] = 0;
                        edges3[j][k] = 0;
                    }

                    if ((edges2[k][j] ^ i1) & 1) {
                        edges4[k][j] = 1;
                        edges4[j][k] = 1;
                    } else {
                        edges4[k][j] = 0;
                        edges4[j][k] = 0;
                    }
                    i1 >>= 1;
                }
            }

            vector<bool> used1(n, false), used2(n, false);
            dfs(0, used1, edges3);
            dfs(0, used2, edges4);
            bool sigma = false;
            for (ll j = 0; j < n; ++j) {
                if (!used1[j] || !used2[j]) {
                    sigma = true;
                }
            }
            if (sigma) {
                continue;
            }

            cout << "Yes\n" << cnt << '\n';
            for (ll j = 0; j < n; ++j) {
                for (ll k = j + 1; k < n; ++k) {
                    if (i & 1) {
                        cout << j + 1 << ' ' << k + 1 << '\n';
                    }
                    i >>= 1;
                }
            }
            return;
        }
        cout << "No\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t, g;
    cin >> t >> g;
    for (ll i = 0; i < t; ++i) {
        solve(g);
    }
}
