#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>
#include <assert.h>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(3);

struct dsu {
    vector<ll> lnk, rnk;
    dsu(ll n) {
        lnk.resize(n);
        rnk.resize(n, 1);
        iota(lnk.begin(), lnk.end(), 0);
    }

    ll get(ll a) {
        if (lnk[a] != a) lnk[a] = get(lnk[a]);
        return lnk[a];
    }

    void unite(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;
        if (rnk[a] < rnk[b]) swap(a, b);
        lnk[b] = a;
        rnk[a] += rnk[b];
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll t, g; cin >> t >> g;
    while (t--) {
        ll n, m1, m2; cin >> n >> m1 >> m2;
        if (m2 == n * (n - 1) / 2) {
            dsu d(n);
            for (ll i = 0; i < m1; i++) {
                ll a, b; cin >> a >> b; a--; b--;
                d.unite(a, b);
            }
            for (ll i = 0; i < m2; i++) {
                ll a, b; cin >> a >> b;
            }
            ll ost = m2;
            vector<ll> v;
            for (ll i = 0; i + 1 < n; i++) {
                if (d.get(i) != d.get(i + 1)) {
                    ost--;
                    d.unite(i, i + 1);
                    v.push_back(i);
                }
            }
            if (ost == 1) {
                cout << "No" << endl;
                continue;
            }
            cout << "Yes" << endl;
            cout << v.size() << endl;
            for (auto p : v) cout << p + 1 << " " << p + 2 << endl;
        }
    }
}