#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>
#include <assert.h>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(3);

struct dsu {
    vector<ll> lnk, rnk;
    dsu(ll n) {
        lnk.resize(n);
        rnk.resize(n, 1);
        iota(lnk.begin(), lnk.end(), 0);
    }

    ll get(ll a) {
        if (lnk[a] != a) lnk[a] = get(lnk[a]);
        return lnk[a];
    }

    void unite(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;
        if (rnk[a] < rnk[b]) swap(a, b);
        lnk[b] = a;
        rnk[a] += rnk[b];
    }
};

vector<vector<ll>> graph;
vector<ll> comp;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll t, g; cin >> t >> g;

    while (t--) {
        ll n, m1, m2; cin >> n >> m1 >> m2;
        if (m2 == n * (n - 1) / 2) {
            dsu d(n);
            for (ll i = 0; i < m1; i++) {
                ll a, b; cin >> a >> b; a--; b--;
                d.unite(a, b);
            }
            for (ll i = 0; i < m2; i++) {
                ll a, b; cin >> a >> b;
            }
            ll ost = m2;
            vector<ll> v;
            for (ll i = 0; i + 1 < n; i++) {
                if (d.get(i) != d.get(i + 1)) {
                    ost--;
                    d.unite(i, i + 1);
                    v.push_back(i);
                }
            }
            if (ost == 1) {
                cout << "No" << endl;
                continue;
            }
            cout << "Yes" << endl;
            cout << v.size() << endl;
            for (auto p : v) cout << p + 1 << " " << p + 2 << endl;
            continue;
        }

        dsu d(n);
        vector<unordered_map<ll, bool>> um(n);
        graph.assign(n, vector<ll>(0));
        vector<ll> deg(n);
        comp.assign(n, -1);
        for (ll i = 0; i < m1; i++) {
            ll a, b; cin >> a >> b; a--; b--;
            d.unite(a, b);
            graph[a].push_back(b);
            graph[b].push_back(a);
        }
        for (ll i = 0; i < m2; i++) {
            ll a, b; cin >> a >> b; a--; b--;
            um[a][b] = true;
            um[b][a] = true;
            deg[a]++;
            deg[b]++;
        }
        vector<pair<ll, ll>> vp;
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (d.get(i) != d.get(j) && !um[i][j]) {
                    vp.push_back({ i, j });
                    deg[i]++;
                    deg[j]++;
                    d.unite(i, j);
                }
            }
        }
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (d.get(i) != d.get(j) && deg[i] > 1 && deg[j] > 1) {
                    vp.push_back({ i, j });
                    d.unite(i, j);
                }
            }
        }
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (d.get(i) != d.get(j)) {
                    vp.push_back({ i, j });
                    d.unite(i, j);
                }
            }
        }
        cout << "Yes" << endl << vp.size() << endl;
        for (auto p : vp) cout << p.first + 1 << " " << p.second + 1 << endl;
    }
}