#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>
#include <assert.h>
#include <chrono>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct dsu {
    vector<ll> lnk, rnk;
    dsu(ll n) {
        lnk.resize(n);
        rnk.resize(n, 1);
        iota(lnk.begin(), lnk.end(), 0);
    }

    ll get(ll a) {
        if (lnk[a] != a) lnk[a] = get(lnk[a]);
        return lnk[a];
    }

    void unite(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;
        if (rnk[a] < rnk[b]) swap(a, b);
        lnk[b] = a;
        rnk[a] += rnk[b];
    }
};

vector<vector<ll>> graph;
vector<ll> comp;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll t, g; cin >> t >> g;

    while (t--) {
        ll n, m1, m2; cin >> n >> m1 >> m2;
        if (n <= 5) {
            vector<vector<bool>> vec1(n, vector<bool>(n));
            vector<vector<bool>> vec2(n, vector<bool>(n));
            for (ll i = 0; i < m1; i++) {
                ll a, b; cin >> a >> b; a--; b--;
                vec1[a][b] = true;
                vec1[b][a] = true;
            }
            for (ll i = 0; i < m2; i++) {
                ll a, b; cin >> a >> b; a--; b--;
                vec2[a][b] = true;
                vec2[b][a] = true;
            }
            vector<pair<ll, ll>> edge;
            for (ll i = 0; i < n; i++) {
                for (ll j = i + 1; j < n; j++) {
                    if (vec1[i][j] && vec2[i][j]) continue;
                    edge.push_back({ i, j });
                }
            }
            vector<ll> ans;
            ll bans = edge.size() + 1;
            vector<ll> por(edge.size());
            iota(por.begin(), por.end(), 0);
            vector<ll> p0 = por;
            do {
                if (bans <= 1) break;
                ll mi = 0;
                for (ll i = 0; i < bans; i++) {
                    dsu d1(n), d2(n);
                    for (ll i1 = 0; i1 < n; i1++) {
                        for (ll i2 = i1 + 1; i2 < n; i2++) {
                            if (vec1[i1][i2]) d1.unite(i1, i2);
                            if (vec2[i1][i2]) d2.unite(i1, i2);
                        }
                    }
                    bool b = true;
                    for (ll i1 = 0; i1 < n; i1++) {
                        for (ll i2 = i1 + 1; i2 < n; i2++) {
                            if (d1.get(i1) != d1.get(i2)) b = false;
                            if (d2.get(i1) != d2.get(i2)) b = false;
                        }
                    }
                    if (b) {
                        bans = i;
                        ans = por;
                    }
                    if (i == por.size()) break;
                    ll i1 = edge[por[i]].first, i2 = edge[por[i]].second;
                    vec1[i1][i2] = !vec1[i1][i2];
                    vec1[i2][i1] = !vec1[i2][i1];
                    vec2[i1][i2] = !vec2[i1][i2];
                    vec2[i2][i1] = !vec2[i2][i1];
                    mi++;
                }

                for (ll i = 0; i < mi; i++) {
                    ll i1 = edge[por[i]].first, i2 = edge[por[i]].second;
                    vec1[i1][i2] = !vec1[i1][i2];
                    vec1[i2][i1] = !vec1[i2][i1];
                    vec2[i1][i2] = !vec2[i1][i2];
                    vec2[i2][i1] = !vec2[i2][i1];
                }

                next_permutation(por.begin(), por.end());
            } while (p0 != por);
            if (bans == edge.size() + 1) {
                cout << "No" << endl;
                continue;
            }
            cout << "Yes" << endl << bans << endl;
            for (ll i = 0; i < bans; i++) {
                ll i1 = edge[ans[i]].first, i2 = edge[ans[i]].second;
                if (!vec2[i1][i2]) {
                    cout << i1 + 1 << " " << i2 + 1 << endl;
                }
            }
            for (ll i = 0; i < bans; i++) {
                ll i1 = edge[ans[i]].first, i2 = edge[ans[i]].second;
                if (vec2[i1][i2]) {
                    cout << i1 + 1 << " " << i2 + 1 << endl;
                }
            }
            continue;
        }

        if (m2 == n * (n - 1) / 2) {
            dsu d(n);
            for (ll i = 0; i < m1; i++) {
                ll a, b; cin >> a >> b; a--; b--;
                d.unite(a, b);
            }
            for (ll i = 0; i < m2; i++) {
                ll a, b; cin >> a >> b;
            }
            ll ost = m2;
            vector<ll> v;
            for (ll i = 0; i + 1 < n; i++) {
                if (d.get(i) != d.get(i + 1)) {
                    ost--;
                    d.unite(i, i + 1);
                    v.push_back(i);
                }
            }
            if (ost == 1) {
                cout << "No" << endl;
                continue;
            }
            cout << "Yes" << endl;
            cout << v.size() << endl;
            for (auto p : v) cout << p + 1 << " " << p + 2 << endl;
            continue;
        }

        dsu d(n);
        vector<unordered_map<ll, bool>> um(n);
        vector<unordered_map<ll, bool>> um2(n);
        graph.assign(n, vector<ll>(0));
        vector<ll> deg(n);
        comp.assign(n, -1);
        for (ll i = 0; i < m1; i++) {
            ll a, b; cin >> a >> b; a--; b--;
            d.unite(a, b);
            graph[a].push_back(b);
            graph[b].push_back(a);
            um2[a][b] = true;
            um2[b][a] = true;
        }
        for (ll i = 0; i < m2; i++) {
            ll a, b; cin >> a >> b; a--; b--;
            um[a][b] = true;
            um[b][a] = true;
            deg[a]++;
            deg[b]++;
        }
        vector<ll> por(n);
        iota(por.begin(), por.end(), 0);
        shuffle(por.begin(), por.end(), rnd);
        vector<pair<ll, ll>> vp;
        for (ll i1 = 0; i1 < n; i1++) {
            ll i = por[i1];
            for (ll j1 = n - 1; j1 > i1; j1--) {
                ll j = por[j1];
                if (d.get(i) != d.get(j) && !um[i][j]) {
                    vp.push_back({ i, j });
                    deg[i]++;
                    deg[j]++;
                    d.unite(i, j);
                    um2[i][j] = true;
                    um2[j][i] = true;
                }
            }
        }
        shuffle(por.begin(), por.end(), rnd);
        for (ll i1 = 0; i1 < n; i1++) {
            ll i = por[i1];
            for (ll j1 = n - 1; j1 > i1; j1--) {
                ll j = por[j1];
                if (d.get(i) != d.get(j) && deg[i] > 1 && deg[j] > 1) {
                    vp.push_back({ i, j });
                    d.unite(i, j);
                    deg[i]--;
                    deg[j]--;
                    um[i][j] = false;
                    um[j][i] = false;
                    um2[i][j] = true;
                    um2[j][i] = true;
                }
            }
        }
        shuffle(por.begin(), por.end(), rnd);
        for (ll i1 = 0; i1 < n; i1++) {
            ll i = por[i1];
            for (ll j1 = n - 1; j1 > i1; j1--) {
                ll j = por[j1];
                if (d.get(i) != d.get(j)) {
                    vp.push_back({ i, j });
                    d.unite(i, j);
                    um[i][j] = false;
                    um[j][i] = false;
                    um2[i][j] = true;
                    um2[j][i] = true;
                }
            }
        }
        dsu d2(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                if (um[i][j]) d2.unite(i, j);
            }
        }
        vector<pair<ll, ll>> vp2;
        shuffle(por.begin(), por.end(), rnd);
        for (ll i1 = 0; i1 < n; i1++) {
            ll i = por[i1];
            for (ll j1 = n - 1; j1 > i1; j1--) {
                ll j = por[j1];
                if (d2.get(i) != d2.get(j) && !um2[i][j]) {
                    vp2.push_back({ i, j });
                    d2.unite(i, j);
                }
            }
        }
        shuffle(por.begin(), por.end(), rnd);
        for (ll i1 = 0; i1 < n; i1++) {
            ll i = por[i1];
            for (ll j1 = n - 1; j1 > i1; j1--) {
                ll j = por[j1];
                if (d2.get(i) != d2.get(j)) {
                    vp2.push_back({ i, j });
                    d2.unite(i, j);
                }
            }
        }
        cout << "Yes" << endl << vp.size() + vp2.size() << endl;
        for (auto p : vp2) cout << p.first + 1 << " " << p.second + 1 << endl;
        for (auto p : vp) cout << p.first + 1 << " " << p.second + 1 << endl;
    }
}