#ifndef LOCALEGOR
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);


vector<vector<int>> g1;
vector<vector<int>> g2;
vector<bool> used1;
vector<bool> used2;

void dfs1(int v) {
    used1[v] = true;
    for (int u : g1[v]) {
        if (!used1[u]) dfs1(u);
    }
}

void dfs2(int v) {
    used2[v] = true;
    for (int u : g2[v]) {
        if (!used2[u]) dfs2(u);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n);
    g2.resize(n);
    vector<pair<int, int>> p;

    gp_hash_table<int, gp_hash_table<int, bool>> good1;
    gp_hash_table<int, gp_hash_table<int, bool>> good2;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            p.push_back({i, j});
        }
    }
    for (int i = 0; i  < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a > b) swap(a, b);
        good1[a][b] = 1;
    }
    for (int i = 0; i  < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a > b) swap(a, b);
        good2[a][b] = 1;
    }
    int t = sz(p);
    for (int msk = 3; msk < (1 << t); ++msk) {
        g1.clear();
        g2.clear();
        g1.resize(n);
        g2.resize(n);
        used1.assign(n, false);
        used2.assign(n, false);
        if (__builtin_popcount(msk) > n) continue;
        for (int bit = 0; bit < t; ++bit) {
            int c = (msk >> bit) & 1;
            auto [a, b] = p[bit];
            {
                if (c ^ good1[a][b]) {
                    g1[a].push_back(b);
                    g1[b].push_back(a);
                }
            }
            {
                if (c ^ good2[a][b]) {
                    g2[a].push_back(b);
                    g2[b].push_back(a);
                }
            }

        }
        dfs1(0);
        dfs2(0);
        bool f = 1;
        for (int v = 0; v < n; ++v) {
            if (!used1[v] || !used2[v]) {
                f = false;
                break;
            }
        }
        if (f) {
            cout << "YES\n";
            cout << __builtin_popcount(msk) << '\n';
            for (int bit = 0; bit < t; ++bit) {
                if ((msk >> bit) & 1) {
                    cout << p[bit].first + 1 << ' ' << p[bit].second + 1 << '\n';
                }
            }
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1,  gg;
    cin >> tt >> gg;
    while (tt--) {
        solve();
    }
    return 0;
}