#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

int group;

long long n, ma, mb;
vector<long long> ga[300000], gb[300000];

bool check1(vector<vector<int>>& gr)
{
	vector<bool> used(n);
	used[0] = true;
	deque<long long> q = { 0 };
	long long cnt = 0;
	while (q.size())
	{
		long long ver = q.front();
		q.pop_front();
		cnt++;
		for (long long i = 0; i < gr[ver].size(); i++)
		{
			if (!gr[ver][i])
			{
				continue;
			}
			if (!used[i])
			{
				used[i] = true;
				q.push_back(i);
			}
		}
	}
	return cnt == n;
}

void solve1()
{
	vector<pair<long long, long long>> e;
	for (long long i = 0; i < n; i++)
	{
		for (long long j = i + 1; j < n; j++)
		{
			e.push_back({ i, j });
		}
	}
	sort(e.begin(), e.end());

	vector<vector<int>> gra(n, vector<int>(n)), grb = gra;
	for (long long i = 0; i < n; i++)
	{
		for (auto& j : ga[i])
		{
			gra[i][j] = gra[j][i] = 1;
		}
		for (auto& j : gb[i])
		{
			grb[i][j] = grb[j][i] = 1;
		}
	}

	long long ans = INF;
	vector<pair<long long, long long>> res;
	do
	{
		if (check1(gra) && check1(grb))
		{
			ans = 0;
			res = {};
			break;
		}

		long long cnt = 0;
		for (long long i = 0; i < e.size(); i++)
		{
			gra[e[i].first][e[i].second] ^= 1;
			gra[e[i].second][e[i].first] ^= 1;
			grb[e[i].first][e[i].second] ^= 1;
			grb[e[i].second][e[i].first] ^= 1;
			cnt++;

			if (check1(gra) && check1(grb))
			{
				if (cnt < ans)
				{
					ans = cnt;
					res = {};
					for (long long j = 0; j < cnt; j++)
					{
						res.push_back(e[j]);
					}
				}
				break;
			}
		}
		for (long long i = 0; i < cnt; i++)
		{
			gra[e[i].first][e[i].second] ^= 1;
			gra[e[i].second][e[i].first] ^= 1;
			grb[e[i].first][e[i].second] ^= 1;
			grb[e[i].second][e[i].first] ^= 1;
		}
		if (ans <= n)
		{
			break;
		}
		next_permutation(e.begin(), e.end());
	} while (!is_sorted(e.begin(), e.end()));

	if (ans == INF)
	{
		cout << "No\n";
	}
	else
	{
		cout << "Yes\n" << ans << "\n";
		for (auto& i : res)
		{
			cout << i.first + 1 << " " << i.second + 1 << "\n";
		}
	}
}

void solve2()
{
	if (ma == 0)
	{
		cout << "No\n";
		return;
	}


}

void solve()
{
	cin >> n >> ma >> mb;
	for (long long i = 0; i < ma; i++)
	{
		long long a, b;
		cin >> a >> b;
		a--; b--;
		ga[a].push_back(b);
		ga[b].push_back(a);
	}
	for (long long i = 0; i < mb; i++)
	{
		long long a, b;
		cin >> a >> b;
		a--; b--;
		gb[a].push_back(b);
		gb[b].push_back(a);
	}

	if (group == 1)
	{
		solve1();
	}
}

void reset()
{
	for (long long i = 0; i < n; i++)
	{
		ga[i] = {};
		gb[i] = {};
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst >> group;
	while (tst--)
	{
		solve();
		reset();
	}

	return 0;
}

/*

























*/
