#include <bits/stdc++.h>

using namespace std;
#define int long long

struct DSU {
    vector<int> p;
    vector<int> sz;

    void init(int n) {
        p.resize(n), sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }

    void clear() {
        p.clear(), sz.clear();
    }

    int find(int v) {
        int pr = p[v];
        while (pr != p[pr])
            pr = p[pr];
        p[v] = pr;
        return pr;
    }

    void unite(int u, int v) {
        int p1 = find(u), p2 = find(v);
        if (p1 == p2) return;
        if (sz[p1] < sz[p2]) swap(p1, p2);
        p[p2] = p1;
        sz[p1] += sz[p2];
    }

    bool get(int u, int v) {
        return find(u) == find(v);
    }
};

int group, n, m1, m2;
vector<pair<int, int>> M1, M2;

vector<pair<int, int>> edges;


bool check() {
    DSU t1, t2;
    t1.init(n), t2.init(n);
    map<pair<int, int>, int> cnt;
    for (int i = 0; i < m2; i++) cnt[M2[i]]++;
    for (auto p: edges) cnt[p]++;
    for (int i = 0; i < m2; i++) {
        if ((cnt[M2[i]] + cnt[{M2[i].second, M2[i].first}]) % 2 == 1)
            t2.unite(M2[i].first, M2[i].second);
    }
    for (auto [u, v]: edges) {
        if ((cnt[{u, v}] + cnt[{v, u}]) % 2 == 1) t2.unite(u, v);
    }
    cnt.clear();
    for(int i = 0; i < m1; i++){
        cnt[M1[i]]++;
    }
    for (auto p: edges) cnt[p]++;
    for (int i = 0; i < m1; i++) {
        if ((cnt[M1[i]] + cnt[{M1[i].second, M1[i].first}]) % 2 == 1)
            t1.unite(M1[i].first, M1[i].second);
    }
    for (auto [u, v]: edges) {
        if ((cnt[{u, v}] + cnt[{v, u}]) % 2 == 1) t1.unite(u, v);
    }
    bool f = false;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (!t1.get(i, j) || !t2.get(i, j)) {
                f = true;
                break;
            }
        }
    }
    t1.clear(), t2.clear();
    return !f;
}

DSU t1, t2;

vector<pair<int, int>> ans;

int rec(int v) {
    if((int)edges.size() > n)
        return -1;
    if (check()) {
        if(ans.empty() || (int)edges.size() < (int)ans.size())
            ans = edges;
        return v;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.emplace_back(i, j);
            rec(v + 1);
            edges.pop_back();
        }
    }
    return -1;
}

void solve() {
    cin >> n >> m1 >> m2;
    t1.init(n), t2.init(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        M1.emplace_back(u - 1, v - 1);
        t1.unite(u - 1, v - 1);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        M2.emplace_back(u - 1, v - 1);
        t2.unite(u - 1, v - 1);
    }
    if (n <= 5) {
        if(check()){
            cout << "Yes\n0\n";
            t1.clear(), t2.clear();
            edges.clear(), M1.clear(), M2.clear(), ans.clear();
            return;
        }
        rec(0);
        if(ans.empty()){
            cout << "No\n";
            t1.clear(), t2.clear();
            edges.clear(), M1.clear(), M2.clear(), ans.clear();
            return;
        }
        cout << "Yes\n";
        cout << (int)ans.size() << "\n";
        for(auto p : ans)
            cout << p.first + 1 << " " << p.second + 1 << "\n";
        t1.clear(), t2.clear();
        edges.clear(), M1.clear(), M2.clear(), ans.clear();
        return;
    }
    t1.clear(), t2.clear();
    edges.clear(), M1.clear(), M2.clear(), ans.clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}