#include <bits/stdc++.h>

using namespace std;
#define int long long

struct DSU {
    vector<int> p;
    vector<int> sz;

    void init(int n) {
        p.resize(n), sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }

    void clear() {
        p.clear(), sz.clear();
    }

    int find(int v) {
        int pr = p[v];
        while (pr != p[pr])
            pr = p[pr];
        p[v] = pr;
        return pr;
    }

    void unite(int u, int v) {
        int p1 = find(u), p2 = find(v);
        if (p1 == p2) return;
        if (sz[p1] < sz[p2]) swap(p1, p2);
        p[p2] = p1;
        sz[p1] += sz[p2];
    }

    bool get(int u, int v) {
        return find(u) == find(v);
    }
};

int group, n, m1, m2;
vector<set<int>> g1, g2;
map<pair<int, int>, int> cnt1, cnt2;

vector<pair<int, int>> edges;

DSU t1, t2;

vector<pair<int, int>> ans;

bool con1() {
    bool used[n];
    for (int i = 0; i < n; i++) used[i] = false;
    function<void(int)> dfs = [&](int v) {
        if (used[v]) return;
        used[v] = true;
        for (auto u: g1[v])
            dfs(u);
    };
    dfs(0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) return false;
    }
    return true;
}

bool con2() {
    bool used[n];
    for (int i = 0; i < n; i++) used[i] = false;
    function<void(int)> dfs = [&](int v) {
        if (used[v]) return;
        used[v] = true;
        for (auto u: g2[v])
            dfs(u);
    };
    dfs(0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) return false;
    }
    return true;
}

int rec(int v) {
    if ((int)edges.size() > n) return -1;
    if (con1() && con2()) {
        if (ans.empty() || (int) edges.size() < (int) ans.size())
            ans = edges;
        return 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.emplace_back(i, j);
            if ((cnt1[{i, j}] + cnt1[{j, i}]) % 2 == 0)
                g1[i].insert(j), g1[j].insert(i);
            else
                g1[i].erase(j), g1[j].erase(i);
            if ((cnt2[{i, j}] + cnt2[{j, i}]) % 2 == 0)
                g2[i].insert(j), g2[j].insert(i);
            else
                g2[i].erase(j), g2[j].erase(i);
            cnt1[{i, j}]++, cnt2[{i, j}]++;
            rec(v + 1);
            edges.pop_back();
            if ((cnt1[{i, j}] + cnt1[{j, i}]) % 2 == 0)
                g1[i].insert(j), g1[j].insert(i);
            else
                g1[i].erase(j), g1[j].erase(i);
            if ((cnt2[{i, j}] + cnt2[{j, i}]) % 2 == 0)
                g2[i].insert(j), g2[j].insert(i);
            else
                g2[i].erase(j), g2[j].erase(i);
            cnt1[{i, j}]--, cnt2[{i, j}]--;
        }
    }
    return -1;
}

void solve() {
    cin >> n >> m1 >> m2;
    t1.init(n), t2.init(n);
    g1.resize(n), g2.resize(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u - 1].insert(v - 1);
        g1[v - 1].insert(u - 1);
        cnt1[{u - 1, v - 1}]++;
        t1.unite(u - 1, v - 1);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        g2[u - 1].insert(v - 1);
        g2[v - 1].insert(u - 1);
        cnt2[{u - 1, v - 1}]++;
        t2.unite(u - 1, v - 1);
    }
    if (n <= 5) {
        if (con1()) {
            cout << "Yes\n0\n";
            t1.clear(), t2.clear();
            edges.clear(), g1.clear(), g2.clear(), ans.clear();
            cnt1.clear(), cnt2.clear();
            return;
        }
        rec(0);
        if (ans.empty()) {
            cout << "No\n";
            t1.clear(), t2.clear();
            edges.clear(), g1.clear(), g2.clear(), ans.clear();
            cnt1.clear(), cnt2.clear();
            return;
        }
        cout << "Yes\n";
        cout << (int) ans.size() << "\n";
        for (auto p: ans)
            cout << p.first + 1 << " " << p.second + 1 << "\n";
        t1.clear(), t2.clear();
        edges.clear(), g1.clear(), g2.clear(), ans.clear();
        cnt1.clear(), cnt2.clear();
        return;
    }
    t1.clear(), t2.clear();
    edges.clear(), g1.clear(), g2.clear(), ans.clear();
    cnt1.clear(), cnt2.clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}