#include <bits/stdc++.h>

using namespace std;
#define int long long

int group;

struct DSU {
    vector<int> p;
    vector<int> sz;

    void init(int n) {
        p.resize(n), sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }

    void clear() {
        p.clear(), sz.clear();
    }

    int find(int v) {
        int pr = p[v];
        while (pr != p[pr])
            pr = p[pr];
        p[v] = pr;
        return pr;
    }

    void unite(int u, int v) {
        int p1 = find(u), p2 = find(v);
        if (p1 == p2) return;
        if (sz[p1] < sz[p2]) swap(p1, p2);
        p[p2] = p1;
        sz[p1] += sz[p2];
    }

    bool get(int u, int v) {
        return find(u) == find(v);
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map<pair<int, int>, bool> exist;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        exist[{u - 1, v - 1}] = exist[{v - 1, u - 1}] = true;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
    }
    if (n == 2) {
        cout << "No\n";
        return;
    }
    bool f = false;
    for (int i = 1; i < n; i++) {
        if (exist[{0, i}]) f = true;
    }
    if(f){
        vector<pair<int, int>> ans;
        for(int j = 2; j < n; j++){
            if(!exist[{1, j}]) ans.emplace_back(1, j);
        }
        cout << "Yes\n" << (int)ans.size() << '\n';
        for(auto p : ans)
            cout << p.first + 1 << " " << p.second + 1 << "\n";
        return;
    }
    int from = -1;
    for (int i = 1; i < n; i++) {
        f = false;
        for (int j = 1; j < n; j++) {
            if (i == j) continue;
            if (!exist[{i, j}]) f = true;
        }
        if (f) from = i;
    }
    if (from == -1) {
        cout << "No\n";
        return;
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (from == i) continue;
        if (!exist[{from, i}]) {
            ans.emplace_back(from, i);
        }
    }
    ans.emplace_back(0, 1);
    cout << "Yes\n" << (int) ans.size() << "\n";
    for (auto p: ans)
        cout << p.first + 1 << " " << p.second + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}