#include <bits/stdc++.h>

using namespace std;
#define int long long

int group;

struct DSU {
    vector<int> p;
    vector<int> sz;

    void init(int n) {
        p.resize(n), sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }

    void clear() {
        p.clear(), sz.clear();
    }

    int find(int v) {
        int pr = p[v];
        while (pr != p[pr])
            pr = p[pr];
        p[v] = pr;
        return pr;
    }

    void unite(int u, int v) {
        int p1 = find(u), p2 = find(v);
        if (p1 == p2) return;
        if (sz[p1] < sz[p2]) swap(p1, p2);
        p[p2] = p1;
        sz[p1] += sz[p2];
    }

    bool get(int u, int v) {
        return find(u) == find(v);
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map<pair<int, int>, bool> exist;
    vector<int> g1[n];
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u - 1].emplace_back(v - 1);
        g1[v - 1].emplace_back(u - 1);
        exist[{u - 1, v - 1}] = exist[{v - 1, u - 1}] = true;
    }
    map<pair<int, int>, bool> exist1;
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        exist1[{u - 1, v - 1}] = exist1[{v - 1, u - 1}] = true;
    }
    if (m2 == (n * (n - 1)) / 2) {
        if (n == 2) {
            if (m1 > 0) {
                cout << "Yes\n0\n";
                return;
            }
            cout << "No\n";
            return;
        }
        if (n == 3) {
            if (m1 == 1) {
                cout << "Yes\n1\n";
                if (!exist[{0, 1}]) cout << "1 2\n";
                else cout << "1 3\n";
            } else if (m1 >= 2) {
                cout << "Yes\n0\n";
            } else
                cout << "No\n";
            return;
        }
        cout << "Yes\n";
        vector<pair<int, int>> ans;
        for (int i = 2; i < n; i++) {
            if (!exist[{0, i - 1}])
                ans.emplace_back(1, i);
        }
        for (int i = 2; i < n; i++) {
            if (!exist[{i - 1, n - 1}]) {
                ans.emplace_back(i, n);
                break;
            }
        }
        cout << (int) ans.size() << "\n";
        for (auto p: ans)
            cout << p.first << " " << p.second << "\n";
        return;
    }
    if (group == 3) {
        bool used[n];
        function<void(int)> dfs = [&](int v) {
            if (used[v]) return;
            used[v] = true;
            for (auto u: g1[v]) {
                dfs(u);
            }
        };
        dfs(0);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i != j && used[i] != used[j]) {
                    if (!exist1[{i, j}]) {
                        cout << "Yes\n1\n" << i + 1 << " " << j + 1 << "\n";
                        return;
                    }
                }
            }
        }
        cout << "No\n";
        return;
    }
    if (n == 2) {
        cout << "No\n";
        return;
    }
    bool f = false;
    for (int i = 1; i < n; i++) {
        if (exist[{0, i}]) f = true;
    }
    if (f) {
        vector<pair<int, int>> ans;
        for (int j = 2; j < n; j++) {
            if (!exist[{1, j}]) ans.emplace_back(1, j);
        }
        cout << "Yes\n" << (int) ans.size() << '\n';
        for (auto p: ans)
            cout << p.first + 1 << " " << p.second + 1 << "\n";
        return;
    }
    int from = -1;
    for (int i = 1; i < n; i++) {
        f = false;
        for (int j = 1; j < n; j++) {
            if (i == j) continue;
            if (!exist[{i, j}]) f = true;
        }
        if (f) from = i;
    }
    if (from == -1) {
        if (n == 3) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n2\n" << "2 3\n" << "1 2\n";
        return;
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (from == i) continue;
        if (!exist[{from, i}]) {
            ans.emplace_back(from, i);
        }
    }
    ans.emplace_back(0, from);
    cout << "Yes\n" << (int) ans.size() << "\n";
    for (auto p: ans)
        cout << p.first + 1 << " " << p.second + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}