#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
using namespace std;

const int maxn = 3000 + 5, inf = 1e18, mod = 1e9 + 7;

vector <int> p(maxn), l(maxn);

int get_par(int h) {
    if (p[h] == h) {
        return h;
    }
    return p[h] = get_par(p[h]);
}

void merge(int h1, int h2) {
    if (h1 == h2) return;
    if (l[h1] < l[h2]) {
        swap(h1, h2);
    }
    p[h2] = h1;
    l[h1] += l[h2];
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector <vector <int> > g1(n + 1, vector <int> (n + 1));
    vector <vector <int> > g2(n + 1, vector <int> (n + 1));
    fill(l.begin(), l.begin() + n + 2, 1);
    iota(p.begin(), p.begin() + n + 2, 0ll);
    vector <pii> edge1, edge2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        g1[a][b] = 1;
        g1[b][a] = 1;
        edge1.emplace_back(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a][b] = 1;
        g2[b][a] = 1;
        edge2.emplace_back(a, b);
    }
    for (auto & [x, y] : edge1) {
        int h1 = get_par(x), h2 = get_par(y);
        merge(h1, h2);
    }
    vector <pii> ans;
    for (int i = 1; i < n + 1; i++) {
        for (int j = 1; j < n + 1; j++) {
            int h1 = get_par(i), h2 = get_par(j);
            if (h1 != h2 && !g2[i][j]) {
                ans.emplace_back(i, j);
                merge(h1, h2);
            }
        }
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 1; j < n + 1; j++) {
            int h1 = get_par(i), h2 = get_par(j);
            if (h1 != h2) {
                ans.emplace_back(i, j);
                merge(h1, h2);
            }
        }
    }
    cout << "Yes\n";
    cout << sz(ans) << "\n";
    for (auto [x, y] : ans) {
        cout << x << " " << y << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t, gg;
    cin >> t >> gg;
    while (t--) {
        solve();
    }

}
