#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;


bool check(vector<vector<ll>>& graph, map<ll, bool>& used, ll& n, ll u) {
	if (n == 1) {
		return true;
	}
	used[u] = true;
	n--;
	for (ll i : graph[u]) {
		if (!used[i]) {
			if (check(graph, used, n, i)) {
				return true;
			}
		}
	}
	return false;
}

bool buildComponents(vector<vector<ll>>& graph, map<ll, bool>& used, ll& n, vector<ll>& component, ll u) {
	if (n == 1) {
		return true;
	}
	used[u] = true;
	n--;
	for (ll i : graph[u]) {
		if (!used[i]) {
			component.push_back(i);
			if (check(graph, used, n, i)) {
				return true;
			}
		}
	}
	return false;
}

bool Buravchik(vector<vector<ll>>& graph1, vector<vector<ll>>& graph2, ll n, ll m1, ll m2, vector<vector<ll>>& components) {
	ll sz = components.size();
	vector<pair<ll, ll>> out;
	for (ll i = 0; i < sz - 1; i++) {
		bool find_add = false;
		for (ll j = i + 1; j < sz; j++) {
			for (ll& u : components[i]) {
				for (ll& v : components[j]) {
					if (find(graph2[u].begin(), graph2[u].end(), v) != graph2[u].end()) {
						graph2[u].erase(find(graph2[u].begin(), graph2[u].end(), v));
						graph2[v].erase(find(graph2[v].begin(), graph2[v].end(), u));
						map<ll, bool> used;
						ll nn = n;
						if (!check(graph2, used, nn, 0)) {
							graph2[u].push_back(v);
							graph2[v].push_back(u);
						}
						else {
							find_add = true;
							out.push_back({ u + 1, v + 1 });
							break;
						}
					}
					else {
						graph2[u].push_back(v);
						graph2[v].push_back(u);
						find_add = true;
						out.push_back({ u + 1, v + 1 });
						break;
					}
					if (find_add) break;
				}
				if (find_add) break;
			}
			if (find_add) break;
		}
		if (!find_add) {
			cout << "No" << '\n';
			return false;
		}
	}
	cout << "Yes\n" << out.size() << '\n';
	for (auto i : out) {
		cout << i.first << " " << i.second << '\n';
	}
}


int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	ll t, g;
	cin >> t >> g;
	while (t-- && t >= 0) {
		ll n, m1, m2;
		cin >> n >> m1 >> m2;
		vector<vector<ll>> graph1(n);
		vector<vector<ll>> graph2(n);
		map<pair<ll, ll>, bool> edges;
		for (ll i = 0; i < m1; i++) {
			ll u, v;
			cin >> u >> v;
			u--; v--;
			edges[{u, v}] = true;
			graph1[u].push_back(v);
			graph1[v].push_back(u);
		}
		for (ll i = 0; i < m2; i++) {
			ll u, v;
			cin >> u >> v;
			u--; v--;
			graph2[u].push_back(v);
			graph2[v].push_back(u);
		}
		vector<vector<ll>> components;
		ll nn = n;
		map<ll, bool> used;
		for (ll i = 0; i < n; i++) {
			if (!used[i]) {
				components.push_back({ i });
				if (buildComponents(graph1, used, nn, components.back(), i)) {
					break;
				}
			}
		}
		if (components.size() == 1) {
			cout << "Yes\n0" << '\n';
			continue;
		}
		if (g == 2) {
			if (components.size() == 2 && n < 3) {
				cout << "No" << '\n' << endl;
				continue;
			}
			if (components.size() == 3 && n == 3) {
				cout << "No" << '\n' << endl;
				continue;
			}
			if (components.size() == 2) {
				cout << "Yes\n1" << '\n' << components[0][0] + 1 << " " << components[1][0] + 1 << endl;
				continue;
			}
			cout << "Yes\n" << components.size() - 1 << '\n';
			for (ll i = 1; i < components.size() - 1; i++) {
				cout << components[i][0] + 1 << " " << components[0][0] + 1 << endl;
			}
			cout << components[components.size() - 1][0] + 1 << " " << components[1][0] + 1 << endl;
			continue;
		}
		if (g == 5) {
			if (components[0].size() ==	1) {
				if (components.size() == 2 || n == 3) {
					cout << "No" << endl;
					continue;
				}
				cout << "Yes\n" << components.size() - 1 << '\n';
				cout << 1 << " " << 2 << endl;
				for (ll i = 2; i < components.size(); i++) {
					cout << components[i][0] + 1 << " " << components[1][0] + 1 << endl;
				}
				continue;
			}
			cout << "Yes\n" << components.size() - 1 << '\n';
			for (ll i = 1; i < components.size(); i++) {
				cout << components[i][0] + 1 << " " << components[0][1] + 1 << endl;
			}
			continue;
		}
		if (g == 9) {
			cout << "Yes\n" << components.size() - 1 << '\n';
			for (ll i = 1; i < components.size(); i++) {
				cout << components[i][0] + 1 << " " << 1 << endl;
			}
			continue;
		}
		Buravchik(graph1, graph2, n, m1, m2, components);
	}

}





	/*    \|/ 0
	       | /|\  
	       |~ | '
	         / \       */
