#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct DSU {
    vector<int> p, r;
    int cnt;

    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        r.assign(n, 1);
        cnt = n;
    }

    int get(int v) {
        if (p[v] == v) {
            return v;
        }
        p[v] = get(p[v]);
        return p[v];
    }

    void merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        cnt--;
        if (r[a] < r[b]) {
            swap(a, b);
        }
        p[b] = a;
        r[a] += r[b];
    }
};

vector<vector<int>> g1, g2;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> e1(m1), e2(m2);
    for (int i = 0; i < m1; ++i) {
        cin >> e1[i].first >> e1[i].second;
        e1[i].first--, e1[i].second--;
        if (e1[i].first > e1[i].second) {
            swap(e1[i].first, e1[i].second);
        }
    }
    for (int i = 0; i < m2; ++i) {
        cin >> e2[i].first >> e2[i].second;
        e2[i].first--, e2[i].second--;
        if (e2[i].first > e2[i].second) {
            swap(e2[i].first, e2[i].second);
        }
    }

    DSU dsu(n);

    set<pair<int, int>> s1, s2;
    for (auto [u, v] : e1) {
        s1.insert({u, v});
        dsu.merge(u, v);
    }
    for (auto [u, v] : e2) {
        s2.insert({u, v});
    }

    vector<pair<int, int>> ne1 = e1, ne2 = e2;

    for (int u = 0; u < n; ++u) {
        for (int v = u + 1; v < n; ++v) {
            if (!s1.contains({u, v}) && !s2.contains({u, v})) {
                ne1.emplace_back(u, v);
                ne2.emplace_back(u, v);
                dsu.merge(u, v);
            }
        }
    }

    if (dsu.cnt != 1) {
        cout << "NO\n";
        return;
    }

    dsu = DSU(n);
    for (auto [u, v] : e1) {
        dsu.merge(u, v);
    }

    vector<pair<int, int>> ans;
    for (auto [u, v] : ne1) {
        if (dsu.get(u) != dsu.get(v)) {
            ans.emplace_back(u, v);
            dsu.merge(u, v);
        }
    }
    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    cin >> t;
    while (t--) {
        int g;
        cin >> g;
        solve();
    }
    return 0;
}
