#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct DSU {
    vector<int> p, r;
    int cnt;

    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        r.assign(n, 1);
        cnt = n;
    }

    int get(int v) {
        if (p[v] == v) {
            return v;
        }
        p[v] = get(p[v]);
        return p[v];
    }

    void merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        cnt--;
        if (r[a] < r[b]) {
            swap(a, b);
        }
        p[b] = a;
        r[a] += r[b];
    }
};

vector<vector<int>> g1, g2, g3;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> e1(m1), e2(m2);
    for (int i = 0; i < m1; ++i) {
        cin >> e1[i].first >> e1[i].second;
        e1[i].first--, e1[i].second--;
        if (e1[i].first > e1[i].second) {
            swap(e1[i].first, e1[i].second);
        }
    }
    for (int i = 0; i < m2; ++i) {
        cin >> e2[i].first >> e2[i].second;
        e2[i].first--, e2[i].second--;
        if (e2[i].first > e2[i].second) {
            swap(e2[i].first, e2[i].second);
        }
    }

    DSU dsu(n);

    set<pair<int, int>> s1, s2;
    for (auto [u, v] : e1) {
        s1.insert({u, v});
    }
    for (auto [u, v] : e2) {
        s2.insert({u, v});
    }

    vector<pair<int, int>> ne1 = e1, ne2 = e2;

    e1.clear();
    e2.clear();
    vector<pair<int, int>> e3;

    for (int u = 0; u < n; ++u) {
        for (int v = u + 1; v < n; ++v) {
            if (s1.contains({u, v}) && s2.contains({u, v})) {
                dsu.merge(u, v);
                e3.emplace_back(u, v);
            }
            if (s1.contains({u, v}) && !s2.contains({u, v})) {
                dsu.merge(u, v);
                e1.emplace_back(u, v);
            }
            if (!s1.contains({u, v}) && s2.contains({u, v})) {
                e2.emplace_back(u, v);
            }
            if (!s1.contains({u, v}) && !s2.contains({u, v})) {
                ne1.emplace_back(u, v);
                ne2.emplace_back(u, v);
                dsu.merge(u, v);
                e3.emplace_back(u, v);
            }
        }
    }

    if (dsu.cnt == 1) {
        dsu = DSU(n);
        for (auto [u, v] : e1) {
            dsu.merge(u, v);
        }

        vector<pair<int, int>> ans;
        for (auto [u, v] : ne1) {
            if (dsu.get(u) != dsu.get(v)) {
                ans.emplace_back(u, v);
                dsu.merge(u, v);
            }
        }
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v] : ans) {
            cout << u + 1 << " " << v + 1 << "\n";
        }
        return;
    }

    mt19937 rnd(1000-7);

    vector<pair<int, int>> e12 = e1;
    e12.insert(e12.end(), e2.begin(), e2.end());
    bool flag = false;
    for (int tr = 0; tr < 1000; tr++) {
        DSU d1(n), d2(n);
        for (auto [u, v] : e3) {
            d1.merge(u, v);
            d2.merge(u, v);
        }
        vector<pair<int, int>> ed1, ed2;
        for (int i = 0; i < e12.size(); ++i) {
            if (rnd() % 2 == 0) {
                d1.merge(e12[i].first, e12[i].second);
                ed1.push_back(e12[i]);
            } else {
                d2.merge(e12[i].first, e12[i].second);
                ed2.push_back(e12[i]);
            }
        }
        if (d1.cnt == 1 && d2.cnt == 1) {
            vector<pair<int, int>> ans;
            DSU ad1(n), ad2(n);
            for (auto [u, v] : e3) {
                if ((ad1.get(u) != ad1.get(v) || ad2.get(u) != ad2.get(v)) && !s1.contains({u, v})) {
                    ans.emplace_back(u, v);
                }
                ad1.merge(u, v);
                ad2.merge(u, v);
            }
            for (auto [u, v] : ed2) {
                if (!s2.contains({u, v}) && ad2.get(u) != ad2.get(v)) {
                    ans.emplace_back(u, v);
                }
                ad2.merge(u, v);
            }
            for (auto [u, v] : ed1) {
                if (!s1.contains({u, v}) && ad1.get(u) != ad1.get(v)) {
                    ans.emplace_back(u, v);
                }
                ad1.merge(u, v);
            }
            if (ans.size() > n) {
                continue;
            }
            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto [u, v] : ans) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
            flag = true;
            break;
        }
    }
    if (!flag) {
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    int g;
    cin >> t;
    cin >> g;

    while (t--) {
        solve();
    }
    return 0;
}
