#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

struct DSU {
    int n;
    vector<int> p;
    vector<int> r;

    DSU(int _n) : n(_n) {
        p.resize(n);
        r.assign(n, 1);
        iota(all(p), 0);
    }

    int get(int a) {
        if (a != p[a]) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);

        if (a != b) {
            if (r[a] < r[b]) swap(a, b);
            r[a] += r[b];
            p[b] = a;
            return true;
        }
        return false;
    }
};

int tests, group;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g1(n, vector<int>(n, 0));
    vector<vector<int>> g2(n, vector<int>(n, 0));

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g1[u][v] = g1[v][u] = 1;
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g2[u][v] = g2[v][u] = 1;
    }

    vector<vector<int>> c1, c2;
    auto change = [&](int u, int v) {
        c1[u][v] ^= 1;
        c1[v][u] ^= 1;
        c2[u][v] ^= 1;
        c2[v][u] ^= 1;
    };

    auto check = [&](vector<vector<int>>& g) {
        DSU dsu(n);
        for (int i = 0; i < n; i++) for (int j = i + 1; j < n; j++) if (g[i][j]) dsu.unite(i, j);
        return dsu.r[dsu.get(0)] == n;
    };

    vector<pair<int, int>> e;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            e.emplace_back(i, j);
        }
    }

    int ec = n * (n - 1) / 2;
    int mx_mask = 1 << ec;

    vector<int> res;

    for (int mask = 0; res.empty() && mask < mx_mask; mask++) {
        if (__builtin_popcount(mask) > n) continue;

        vector<int> p;
        for (int i = 0; i < ec; i++) {
            if ((mask >> i) & 1) {
                p.push_back(i);
            }
        }

        do {
            c1 = g1; c2 = g2;
            bool f = 1;
            for (auto el : p) {
                change(e[el].first, e[el].second);
                if (!check(c2)) {
                    f = 0;
                    break;
                }
            }
            f = f && check(c1);
            if (f) res = p;
        } while (!res.empty() && next_permutation(all(p)));
    }

    if (res.empty()) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); i++) {
            auto [u, v] = e[res[i]];
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> tests >> group;
    while (tests--) {
        solve();
#ifdef ONPC
        cout << "--------\n";
#endif
    }

    return 0;
}
