#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <cassert>
using namespace std;

typedef long long ll;

int t, g;
vector<vector<int>> G2;
map<pair<int, int>, bool> edges1, edges2, edges_real2;
vector<int> p, sz;
vector<int> dep;
int n, m1, m2;
int M1[10][10], M2[10][10];

int get(int v)
{
    return (v == p[v] ? v : (p[v] = get(p[v])));
}

bool union_sets(int v, int u)
{
    if ((v = get(v)) == (u = get(u)))
        return false;
    if (sz[v] < sz[u])
        swap(v, u);
    sz[v] += sz[u];
    p[u] = v;
    return true;
}

void solve3_good()
{
    assert(m2 >= 2);
    if (m1 >= 2)
    {
        cout << "Yes\n";
        cout << 0 << '\n';
    }else if (m1 == 0){
        cout << "No\n";
    }else if (m2 == 2){
        for (int i = 0; i < 3; i++)
        {
            for (int j = i + 1; j < 3; j++)
            {
                if (!M1[i][j] && !M2[i][j])
                {
                    cout << "Yes\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return;
                }
            }
        }
        cout << "No\n";
        return;
    }else
    {
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (!M1[i][j])
                {
                    cout << "Yes\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return;
                }
            }
        }
    }
}

void solve3()
{
    if (m1 < 1)
    {
        cout << "No\n";
        return;
    }
    if (m1 >= 2)
    {
        cout << "Yes\n";
        cout << 0 << '\n';
        return;
    }
    if (m2 == 3 && m1 >= 1)
    {
        int s = -1, e = -1;
        bool flag = false;
        for (int i = 0; i < 3 && !flag; i++)
        {
            for (int j = i + 1; j < 3 && !flag; j++)
            {
                if (!edges1.count({i, j}))
                {
                    s = i; e = j;
                    flag = true;
                }
            }
        }
        cout << "Yes\n";
        if (flag)
        {
            cout << 1 << '\n';
            assert(max(s, e) < n);
            assert(min(s, e) >= 0);
            assert(edges1.count({s, e}) == 0);
            cout << s + 1 << ' ' << e + 1 << '\n';
        }else
        {
            cout << 0 << '\n';
        }
        return;
    }
    int cnt = m1;
    int s = -1, e = -1;
    for (int i = 0; i < 3; i++)
    {
        for (int j = i + 1; j < 3; j++)
        {
            if (!edges1.count({i, j}) && !edges2.count({i, j}))
            {
                s = i; e = j;
                cnt++;
            }
        }
    }
    if (cnt >= 2)
    {
        cout << "Yes\n";
        cout << 1 << '\n';
        assert(max(s, e) < n);
        assert(min(s, e) >= 0);
        cout << s + 1 << ' ' << e + 1 << '\n';
        return;
    }
    cout << "No\n";
}

void solve_spec(int v)
{
    vector<pair<int, int>> res;
    for (int i = 1; i < G2[v].size(); i++)
    {
        int a = G2[v][i - 1];
        int b = G2[v][i];
        if (a > b)
            swap(a, b);
        if (edges1.count({a, b}))
            continue;
        res.push_back({a, b});
    }
    bool flag = false;
    for (int i = 0; i < G2[v].size(); i++)
    {
        int a = v, b = G2[v][i];
        if (a > b)
            swap(a, b);
        if (edges1.count({a, b}))
        {
            flag = true;
            continue;
        }
    }
    if (!flag)
    {
        int a = G2[v][0];
        int b = G2[v].back();
        if (a > b)
            swap(a, b);
        if (count(G2[a].begin(), G2[a].end(), b) == 0)
            res.push_back({a, b});
        res.push_back({v, a});
    }
    cout << "Yes\n";
    cout << res.size() << '\n';
    assert(res.size() <= n);
    for (int i = 0; i < res.size(); i++)
    {
        assert(max(res[i].first, res[i].second) < n);
        assert(min(res[i].first, res[i].second) >= 0);
        assert(res[i].first != res[i].second);
        cout << res[i].first + 1 << ' ' << res[i].second + 1 << '\n';
    }
}

void dfs(int v, int p = -1)
{
    for (int u : G2[v])
    {
        if (u == p) continue;
        dep[u] = dep[v] + 1;
        dfs(u, v);
    }
}

void solve()
{
    cin >> n >> m1 >> m2;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            M1[i][j] = M2[i][j] = M1[j][i] = M2[j][i] = 0;
    }
    int v, u;
    p = sz = vector<int>(n, 1);
    for (int i = 0; i < n; i++)
        p[i] = i;
    edges1.clear();
    edges2.clear();
    for (int i = 0; i < m1; i++)
    {
        cin >> v >> u; v--; u--;
        M1[v][u] = M1[u][v] = 1;
        if (v > u)
            swap(v, u);
        edges1[{v, u}] = true;
    }
    G2 = vector<vector<int>>(n);
    for (int i = 0; i < m2; i++)
    {
        cin >> u >> v; u--; v--;
        M2[v][u] = M2[u][v] = 1;
        if (v > u)
            swap(v, u);
        if (union_sets(v, u))
        {
            G2[v].push_back(u);
            G2[u].push_back(v);
            edges2[{v, u}] = true;
        }
    }
    if (n == 3)
    {
        solve3_good();
        return;
    }
    for (int i = 0; i < n; i++)
    {
        if (G2[i].size() == n - 1)
        {
            solve_spec(i);
            return;
        }
    }
    dep = vector<int>(n, 1);
    dfs(0);
    vector<int> order;
    for (int i = 0; i < n; i++)
        if (dep[i] & 1)
            order.push_back(i);
    if (G2[order.back()].size() >= n - order.size())
    {
        reverse(order.begin(), order.end());
    }
    assert(G2[order.back()].size() < n - order.size());
    int k = -1;
    set<int> counter;
    for (int i = 0; i < G2[order.back()].size(); i++)
        counter.insert(G2[order.back()][i]);
    for (int i = 0; i < n; i++)
    {
        if (!(dep[i] & 1) && counter.count(i) == 0)
        {
            k = i;
            break;
        }
    }
    assert(k >= 0);
    order.push_back(k);
    for (int i = 0; i < n; i++)
    {
        if (!(dep[i] & 1) && i != k)
            order.push_back(i);
    }
    vector<pair<int, int>> res;
    for (int i = 1; i < order.size(); i++)
    {
        int a = order[i], b = order[i - 1];
        if (a > b)
            swap(a, b);
        assert(edges2.count({a, b}) == 0);
        if (!edges1.count({a, b}))
            res.push_back({a, b});
    }
    cout << "Yes\n";
    cout << res.size() << '\n';
    assert(res.size() <= n);
    for (int i = 0; i < res.size(); i++)
    {
        assert(max(res[i].first, res[i].second) < n);
        assert(min(res[i].first, res[i].second) >= 0);
        assert(res[i].first != res[i].second);
        cout << res[i].first + 1 << ' ' << res[i].second + 1 << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    cin >> t >> g;
    while (t--)
    {
        solve();
    }
    return 0;
}