#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct DSU {
    vector <int> pr;
    vector <int> sz;
    vector <int> any;

    DSU(int n) {
        pr.resize(n);
        iota(all(pr), 0);
        any.resize(n);
        sz.assign(n, 1);
    }

    int getPr(int v) {
        if (pr[v] == v) return v;
        pr[v] = getPr(pr[v]);
        return pr[v];
    }

    void unionSets(int u, int v) {
        u = getPr(u);
        v = getPr(v);
        if (u == v) return;
        if (sz[u] < sz[v]) swap(u, v);
        sz[u] += sz[v];
        any[u] = v;
        pr[v] = u;
    }
};

struct Edge {
    int u, v;
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    DSU dsu(n);

    set <pair <int, int>> edges1;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges1.insert({u, v});
        dsu.unionSets(u, v);
    }
    set <pair <int, int>> edges2;
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges2.insert({u, v});
        edges2.insert({v, u});
    }

    set <int> pr;
    for (int i = 0; i < n; i++) {
        pr.insert(dsu.getPr(i));
    }
    vector <pair <int, int>> ans;
    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (edges2.count({u, v})) continue;
            if (dsu.getPr(u) == dsu.getPr(v)) continue;
            pr.erase(dsu.getPr(u));
            pr.erase(dsu.getPr(v));
            dsu.unionSets(u, v);
            pr.insert(dsu.getPr(u));
            ans.push_back({u + 1, v + 1});
        }
    }

    if (pr.size() == n) {
        if (n == 3) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        cout << n - 1 << "\n";
        for (int i = 2; i < n; i++) {
            cout << 1 << " " << i << "\n";
        }
        cout << 2 << " " << n << "\n";
        return;
    }

    int bruh = 0;
    for (int v : pr) {
        if (dsu.sz[v] > 1) {
            bruh = v;
        }
    }

    ans.push_back({bruh + 1, dsu.any[bruh] + 1});

    for (int v : pr) {
        if (v == bruh) continue;

        ans.push_back({bruh + 1, v + 1});
    }

    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u << " " << v << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    cin >> t;
    int g;
    cin >> g;
    while (t--) {
        solve();
    }
}