#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct DSU {
    vector <int> pr;
    vector <int> sz;
    vector <int> any;

    DSU(int n) {
        pr.resize(n);
        iota(all(pr), 0);
        any.resize(n);
        sz.assign(n, 1);
    }

    int getPr(int v) {
        if (pr[v] == v) return v;
        pr[v] = getPr(pr[v]);
        return pr[v];
    }

    void unionSets(int u, int v) {
        u = getPr(u);
        v = getPr(v);
        if (u == v) return;
        if (sz[u] < sz[v]) swap(u, v);
        sz[u] += sz[v];
        any[u] = v;
        pr[v] = u;
    }
};

struct Edge {
    int u, v;
};

int g;

bool is_connected(set <pair <int, int>>& edges, int n) {
    DSU dsu(n);
    for (auto [u, v] : edges) {
        dsu.unionSets(u, v);
    }
    return dsu.sz[dsu.getPr(0)] == n;
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    set <pair <int, int>> edges1;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        if (u > v) swap(u, v);
        edges1.insert({u, v});
    }
    set <pair <int, int>> edges2;
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        if (u > v) swap(u, v);
        edges2.insert({u, v});
    }
    vector <pair <int, int>> edges;
    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            edges.push_back({u, v});
        }
    }
    for (int mask = 0; mask < (1 << (int)edges.size()); mask++) {
        vector <pair <int, int>> edg;
        for (int i = 0; i < (int)edges.size(); i++) {
            if (mask & (1 << i)) {
                edg.push_back(edges[i]);
            }
        }
        int m = edg.size();
        vector <int> ord(m);
        iota(all(ord), 0);
        set <pair <int, int>> te1 = edges1, te2 = edges2;
        do {
            bool ok = true;
            for (int i : ord) {
                if (edges1.count(edg[i])) {
                    edges1.erase(edg[i]);
                } else {
                    edges1.insert(edg[i]);
                }
                if (edges2.count(edg[i])) {
                    edges2.erase(edg[i]);
                } else {
                    edges2.insert(edg[i]);
                }
                if (!is_connected(edges2, n)) {
                    ok = false;
                    break;
                }
            }
            if (ok && is_connected(edges1, n)) {
                cout << "Yes\n";
                cout << edg.size() << "\n";
                for (int i : ord) {
                    cout << edg[i].first + 1 << " " << edg[i].second + 1 << "\n";
                }
                return;
            }
            edges1 = te1;
            edges2 = te2;
        } while (next_permutation(all(ord)));
    }
    cout << "No\n";
}

void solve() {
    if (g <= 1) {
        solve1();
        return;
    }
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    DSU dsu(n);

    set <pair <int, int>> edges1;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges1.insert({u, v});
        edges1.insert({v, u});
        dsu.unionSets(u, v);
    }
    set <pair <int, int>> edges2;
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges2.insert({u, v});
        edges2.insert({v, u});
    }

    set <int> pr;
    for (int i = 0; i < n; i++) {
        pr.insert(dsu.getPr(i));
    }
    vector <pair <int, int>> ans;
    for (int u = 0; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (edges2.count({u, v})) continue;
            if (dsu.getPr(u) == dsu.getPr(v)) continue;
            pr.erase(dsu.getPr(u));
            pr.erase(dsu.getPr(v));
            dsu.unionSets(u, v);
            pr.insert(dsu.getPr(u));
            ans.push_back({u + 1, v + 1});
            edges1.insert({u, v});
            edges1.insert({v, u});
            edges2.insert({u, v});
            edges2.insert({v, u});
        }
    }

    if (pr.size() == n) {
        if (n == 3) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        cout << n - 1 << "\n";
        for (int i = 2; i < n; i++) {
            cout << 1 << " " << i << "\n";
        }
        cout << 2 << " " << n << "\n";
        return;
    }

    if (pr.size() == 1) {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v] : ans) {
            cout << u << " " << v << "\n";
        }
        return;
    }

    int bruh = 0;
    for (int v : pr) {
        if (dsu.sz[v] > dsu.sz[bruh]) {
            bruh = v;
        }
    }

    for (int v = 0; v < n; v++) {
        if (v == bruh) continue;
        if (dsu.getPr(v) == bruh) {
            if (!edges2.count({bruh, v})) {
                ans.push_back({bruh + 1, v + 1});
            }
            break;
        }
    }

    for (int v : pr) {
        if (v == bruh) continue;

        ans.push_back({bruh + 1, v + 1});
    }

    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        cout << u << " " << v << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    cin >> t;
    cin >> g;
    while (t--) {
        solve();
    }
}