#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll inf = ll(2e18) + 36;
const int mod = int(1e9) + 7;

vector<bool> used;

ll dfs(ll v, const vector<vector<ll>> &g) {
    used[v] = true;
    ll cnt = 1;
    for (auto &it: g[v]) {
        if (used[it]) continue;
        cnt += dfs(it, g);
    }
    return cnt;
}

set<ll> dfs3(ll v, vector<set<ll>> &g) {
    used[v] = true;
    set<ll> res;
    res.insert(v);
    for (auto &u: g[v]) {
        if (used[u]) continue;
        auto cur = dfs3(u, g);
        if (res.size() < cur.size()) swap(res, cur);
        for (auto &it: cur) {
            res.insert(it);
        }
    }
    return res;
}


ll dfs2(ll v, const vector<set<ll>> &g) {
    used[v] = true;
    ll cnt = 1;
    for (auto &it: g[v]) {
        if (used[it]) continue;
        cnt += dfs2(it, g);
    }
    return cnt;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt, gr;
    cin >> tt >> gr;
    while (tt--) {
        ll n, m1, m2;
        cin >> n >> m1 >> m2;
        if (n <= 5) {
            set<pair<ll, ll>> e1, e2;
            for (ll i = 0; i < m1; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e1.insert({u, v});
            }
            for (ll i = 0; i < m2; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e2.insert({u, v});
            }
            vector<pair<ll, ll>> e;
            for (ll u = 0; u < n; u++) {
                for (ll v = u + 1; v < n; v++) {
                    e.emplace_back(u, v);
                }
            }
            ll cntE = n * (n - 1) / 2;
            bool can = false;
            for (ll mask = 0; mask < (1ll << cntE); mask++) {
                auto r1 = e1, r2 = e2;
                deque<ll> ind;
                for (ll i = 0; i < cntE; i++) {
                    if (!((mask >> i) & 1)) continue;
                    auto [u, v] = e[i];
                    if (r1.count({u, v})) {
                        r1.erase({u, v});
                    } else {
                        r1.insert({u, v});
                    }
                    if (r2.count({u, v})) {
                        r2.erase({u, v});
                        ind.emplace_back(i);
                    } else {
                        r2.insert({u, v});
                        ind.emplace_front(i);
                    }
                }
                vector<vector<ll>> g1(n), g2(n);
                for (auto &[u, v]: r1) {
                    g1[u].emplace_back(v);
                    g1[v].emplace_back(u);
                }
                for (auto &[u, v]: r2) {
                    g2[u].emplace_back(v);
                    g2[v].emplace_back(u);
                }
                used.assign(n, false);
                ll cnt1 = dfs(0, g1);
                used.assign(n, false);
                ll cnt2 = dfs(0, g2);
                if (cnt1 == n && cnt2 == n) {
                    can = true;
                    cout << "Yes\n";
                    cout << ind.size() << '\n';
                    for (auto &i: ind) {
                        auto [u, v] = e[i];
                        cout << u + 1 << ' ' << v + 1 << '\n';
                    }
                    break;
                }
            }
            if (!can) {
                cout << "No\n";
            }
            continue;
        }
        if (gr == 2) {
            set<pair<ll, ll>> e1, e2;
            for (ll i = 0; i < m1; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e1.insert({u, v});
            }
            for (ll i = 0; i < m2; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e2.insert({u, v});
            }
            cout << "Yes\n";
            vector<pair<ll, ll>> cur;
            for (ll i = 0; i < n - 1; i++) {
                if (e1.count({i, i + 1})) {
                    continue;
                }
                cur.emplace_back(i, i + 1);
            }
            cout << cur.size() << '\n';
            for (auto &[u, v]: cur) {
                cout << u + 1 << ' ' << v + 1 << '\n';
            }
        }
        if (gr == 3) {
            vector<set<ll>> g1(n), g2(n);
            set<pair<ll, ll>> e1, e2;
            for (ll i = 0; i < m1; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e1.insert({u, v});
                g1[u].insert(v);
                g1[v].insert(u);
            }
            for (ll i = 0; i < m2; i++) {
                ll u, v;
                cin >> u >> v;
                u--;
                v--;
                if (u > v) swap(u, v);
                e2.insert({u, v});
                e2.insert({v, u});
                g2[u].insert(v);
                g2[v].insert(u);
            }
            used.assign(n, false);
            auto c1 = dfs3(0, g1);
            ll ru = -1, rv = -1;
            for (ll v = 0; v < n; v++) {
                if (!c1.count(v)) continue;
                for (ll u = 0; u < n; u++) {
                    if (c1.count(u)) continue;
                    if (!e2.count({v, u})) {
                        ru = u;
                        rv = v;
                        break;
                    }
                }
            }
            for (ll v = 0; v < n; v++) {
                if (!c1.count(v)) continue;
                for (auto &u: g2[v]) {
                    if (c1.count(u)) continue;
                    g2[v].erase(u);
                    g2[u].erase(v);
                    used.assign(n, false);
                    ll cnt = dfs2(0, g2);
                    g2[v].insert(u);
                    g2[u].insert(v);
                    if (cnt == n) {
                        ru = u;
                        rv = v;
                        break;
                    }
                }
            }
            if (rv < 0) {
                cout << "No\n";
                continue;
            }
            cout << "Yes\n1\n";
            cout << rv + 1 << ' ' << ru + 1 << '\n';
        }
    }
    return 0;
}
/*
3 1
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

 */