#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>
#include <numbers>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

//#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

/*
4
2
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5

3
4
2 4 5 12
1 3 4 10
4
3 5 8 20
1 2 6 7
4
4 4 4 4
1 2 3 4
*/

const int N = 3e3 + 5;
vector<pair<int, int>> gr1[N], gr2[N];
int used1[N], used2[N];
vector<int> used;
int g1[N][N], g2[N][N];
int u1[N][N], u2[N][N];
int g;
int p[N], d[N];

void dfs(int v, int t) {
	used[v] = 1;
	for (auto e: (t ? gr2[v] : gr1[v])) {
		int u = e.first;
		if (t == 1 && g2[u][v] == 0)
			continue;
		int num = e.second;
		if (!used[u]) {
			if (t) {
				used2[num] = 1;
				u2[u][v] = u2[v][u] = 1;
			}
			else {
				used1[num] = 1;
				u1[u][v] = u2[v][u] = 1;
			}
			dfs(u, t);
		}
	}
}

void init(int n, int m) {
	for (int i = 0; i < n; ++i) {
		p[i] = i;
		d[i] = 0;
		gr1[i].clear();
		gr2[i].clear();
		for (int j = 0; j < n; ++j) {
			g1[i][j] = g2[i][j] = 0;
			u1[i][j] = u2[i][j] = 0;
		}
	}
	for (int i = 0; i < m; ++i) {
		used1[i] = 0;
		used2[i] = 0;
	}
}

int getpar(int v) {
	return (p[v] == v ? v : p[v] = getpar(p[v]));
}

void unite(int u, int v) {
	u = getpar(u);
	v = getpar(v);
	if (u == v)
		return;
	if (d[v] < d[u])
		swap(u, v);
	p[u] = v;
	d[v] += d[u];
}

/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
*/

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	used.assign(n, 0);
	init(n, max(m2, m1));
	vector<pair<int, int>> e1(m1), e2(m2);
	for (int i = 0; i < m1; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g1[u][v] = g1[v][u] = 1;
		gr1[u].push_back({ v, i });
		gr1[v].push_back({ u, i });
		e1[i] = { u, v };
	}
	for (int i = 0; i < m2; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g2[u][v] = g2[v][u] = 1;
		gr2[u].push_back({ v, i });
		gr2[v].push_back({ u, i });
		e2[i] = { u, v };
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i, 0);
		}
	}
	for (auto e : e1) {
		unite(e.first, e.second);
	}
	used.assign(n, 0);
	dfs(0, 1);
	vector<pair<int, int>> ans;
	vector<pair<int, int>> maybe;
	for (int u = 0; u < n; ++u) {
		for (int v = u + 1; v < n; ++v) {
			int pu = getpar(u);
			int pv = getpar(v);
			if (pu != pv) {
				if (u2[u][v]) {
					maybe.push_back({ u, v });
				}
				else{
					g2[u][v] ^= 1;
					g2[v][u] ^= 1;
					unite(pu, pv);
					ans.push_back({ u, v });
				}
			}
		}
	}
	for (int u = 0; u < n; ++u) {
		for (int v = u + 1; v < n; ++v) {
			int pu = getpar(u);
			int pv = getpar(v);
			if (pu == pv)
				continue;
			used.assign(n, 0);
			bool ok = 0;
			for (auto e : maybe) {
				int nu = e.first;
				int nv = e.first;
				if (getpar(nv) != pv || getpar(nu) != pu)
					continue;
				g2[nu][nv] ^= 1;
				g2[nv][nu] ^= 1;
				dfs(0, 1);
				if (accumulate(all(used), 0) == n) {
					ok = 1;
					ans.push_back({ nv, nu });
				}
			}
			if (!ok) {
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto e : ans) {
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	cin >> t;
	cin >> g;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
