#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

set<int> open;
vector<vector<int>> g1;
vector<vector<int>> g2;
vector<bool> used;

void add(int v) {
    open.erase(v);
    used[v] = 1;
    for (auto x : g1[v]) {
        if (used[x]) continue;
        add(x);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1 = vector<vector<int>>(n);
    g2 = vector<vector<int>>(n);
    open = set<int>();
    used = vector<bool>(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        open.insert(i);
    }
    add(0);
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (auto x : g2[i]) {
            open.erase(x);
        }
        while (open.size()) {
            int it = *open.begin();
            add(it);
            ans.push_back({ i, it });
        }
        for (auto x : g2[i]) {
            if (!used[x]) {
                open.insert(x);
            }
        }
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x.first + 1 << " " << x.second + 1 << "\n";
    }
}

int main()
{
    ll t, g;
    cin >> t >> g;
    for (ll i = 0; i < t; i++) {
        solve();
    }
}