#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

set<int> open;
set<int> in;
vector<vector<int>> g1;
vector<vector<int>> g2;
vector<bool> used;

void add(int v) {
    open.erase(v);
    in.insert(v);
    used[v] = 1;
    for (auto x : g1[v]) {
        if (used[x]) continue;
        add(x);
    }
}

void solve(int o) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1 = vector<vector<int>>(n);
    g2 = vector<vector<int>>(n);
    open = set<int>();
    used = vector<bool>(n);
    set<pair<int, int>> rebrs1;
    set<pair<int, int>> rebrs2;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        g1[a].push_back(b);
        g1[b].push_back(a);
        rebrs1.insert({ a, b });
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        g2[a].push_back(b);
        g2[b].push_back(a);
        rebrs2.insert({ a, b });
    }
    if (o == 5) {
        bool f = 0;
        for (auto x : rebrs1) {
            if (x.first == 1) {
                f = 1;
            }
        }
        vector<pair<int, int>> ans;
        for (int j = 3; j <= n; j++) {
            if (rebrs1.find({ 2, j }) == rebrs1.end()) {
                ans.push_back({ 2, j });
            }
        }
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto x : ans) {
            cout << x.first + 1 << " " << x.second + 1 << "\n";
        }
        return;
    }
    if (n == 3) {
        if (m1 >= 2) {
            cout << "Yes\n0\n";
            return;
        }
        else if (m1 == 1) {
            if (rebrs2.find(*rebrs1.begin()) == rebrs2.end()) {
                cout << "No\n";
                return;
            }
            cout << "Yes\n1\n";
            for (int i = 1; i <= 3; i++) {
                for (int j = i + 1; j <= 3; j++) {
                    if (rebrs2.find({ i, j }) == rebrs2.end()) {
                        cout << i << " " << j << "\n";
                        return;
                    }
                }
            }
        }
        else {
            for (int i = 1; i <= 3; i++) {
                for (int j = i + 1; j <= 3; j++) {
                    if (rebrs2.find({ i, j }) == rebrs2.end()) {
                        cout << "Yes\n2\n";
                        cout << i << " " << j << "\n";
                        int ic = i, jc = j;
                        for (int t = 1; t <= 3; t++) {
                            if (t != i && t != j) {
                                ic = t;
                                break;
                            }
                        }
                        jc = ic % 3 + 1;
                        cout << ic << " " << jc << "\n";
                        return;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        open.insert(i);
    }
    add(0);
    vector<pair<int, int>> ans;
    while (in.size()) {
        int i = *in.begin();
        in.erase(in.begin());
        for (auto x : g2[i]) {
            open.erase(x);
        }
        while (open.size()) {
            int it = *open.begin();
            add(it);
            ans.push_back({ i, it });
        }
        for (auto x : g2[i]) {
            if (!used[x]) {
                open.insert(x);
            }
        }
    }
    bool f = 1;
    for (auto x : used) {
        if (x == 0) {
            f = 0;
        }
    }
    if (f == 0) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x.first + 1 << " " << x.second + 1 << "\n";
    }
}

int main()
{
    ll t, o;
    cin >> t >> o;
    for (ll i = 0; i < t; i++) {
        solve(o);
    }
}