#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <assert.h>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

vector<bool>used;
int cnt = 0;
void dfs(int v, vector<vector<bool>>&ej) {
    cnt++;
    used[v] = 1;

    for (int t = 0; t < ej.size(); t++) {
        if (ej[v][t] && !used[t])
            dfs(t, ej);
    }
}

void solve() {
    int vs;
    cin >> vs;
    vector<vector<bool>>ejf(vs, vector<bool>(vs));
    vector<vector<bool>>ejs(vs, vector<bool>(vs));
    int f, s;
    cin >> f >> s;
    while (f--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejf[f][t] = 1;
        ejf[t][f] = 1;
    }
    while (s--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejs[f][t] = 1;
        ejs[t][f] = 1;
    }

    for (int msk = 0; msk < (1 << (vs * (vs - 1) / 2)); msk++) {
        vector<pair<int, int>>ej;
        int ind = 0;
        for (int f = 0; f < vs; f++) {
            for (int t = f + 1; t < vs; t++) {
                if (msk & (1 << ind))
                    ej.push_back({f, t});
                ind++;
            }
        }

        if (ej.size() > vs)
            continue;

        vector<vector<bool>>eif = ejf, eis = ejs;
        for (auto [f, t] : ej) {
            eif[f][t] = !eif[f][t], eis[f][t] = !eis[f][t];
            swap(f, t);
            eif[f][t] = !eif[f][t], eis[f][t] = !eis[f][t];
        }

        cnt = 0;
        used.assign(vs, 0);
        dfs(0, eif);
        if (cnt == vs) {
            cnt = 0;
            used.assign(vs, 0);
            dfs(0, eis);
            if (cnt == vs) {
                cout << "Yes\n" << ej.size() << '\n';
                for (auto [f, t] : ej) {
                    if (!ejs[f][t])
                        cout << f + 1 << ' ' << t + 1 << '\n';
                }
                for (auto [f, t] : ej) {
                    if (ejs[f][t])
                        cout << f + 1 << ' ' << t + 1 << '\n';
                }
                return;
            }
        }
    }
    cout << "No";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qs;
    cin >> qs;
    int tq;
    cin >> tq;
    assert(tq <= 1);
    while (qs--) {
        solve();
        cout << '\n';
    }
}