#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <assert.h>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

vector<bool>used;
int cnt = 0;
void dfs(int v, vector<vector<bool>>&ej) {
    cnt++;
    used[v] = 1;

    for (int t = 0; t < ej.size(); t++) {
        if (ej[v][t] && !used[t])
            dfs(t, ej);
    }
}


vector<vector<int>>ejr;
set<pair<int, int>>br;
vector<int>d;
vector<int>mnd;

void buildb(int v, int p) {
    mnd[v] = d[v];
    for (int t : ejr[v]) {
        if (t == p) continue;
        if (d[t] != -1) mnd[v] = min(mnd[v], d[t]);
        else {
            d[t] = d[v] + 1;
            buildb(t, v);
            if (mnd[t] > d[v]) {
                br.insert({v, t});
                br.insert({t, v});
            }
            mnd[v] = min(mnd[v], mnd[t]);
        }
    }
}
vector<vector<int>>ejl;
vector<vector<int>>cmp;
vector<bool>usedc;
void buildc(int v) {
    usedc[v] = 1;
    cmp.back().push_back(v);
    for (int t : ejl[v]) {
        if (!usedc[t]) {
            buildc(t);
        }
    }
}
void solve4() {
    int vs;
    cin >> vs;
    ejr.assign(vs, {});
    ejl.assign(vs, {});
    br.clear();

    int el, er;
    cin >> el >> er;

    while (el--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejl[f].push_back(t);
        ejl[t].push_back(f);
    }
    while (er--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejr[f].push_back(t);
        ejr[t].push_back(f);
    }

    mnd.resize(vs);
    d.assign(vs, -1);
    d[0] = 0;
    buildb(0, 0);

    usedc.assign(vs, 0);
    cmp.clear();
    for (int v = 0; v < vs; v++) {
        if (!usedc[v]) {
            cmp.push_back({});
            buildc(v);
        }
    }

    vector<pair<int, int>>ans;
    for (int i = 0; i + 1 < cmp.size(); i++) {
        bool f = 0;
        for (int fi = 0; fi <= 1 && !f; fi++) {
            for (int si = 0; si <= 1 && !f; si++) {
                if (!br.contains({cmp[i][fi], cmp[i + 1][si]})) {
                    ans.push_back({cmp[i][fi], cmp[i + 1][si]});
                    f = 1;
                }
            }
        }
    }

    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto [f, t] : ans) {
        cout << f + 1 << ' ' << t + 1 << '\n';
    }
}

void solve() {
    int vs;
    cin >> vs;
    vector<vector<bool>>ejf(vs, vector<bool>(vs));
    vector<vector<bool>>ejs(vs, vector<bool>(vs));
    int f, s;
    cin >> f >> s;
    while (f--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejf[f][t] = 1;
        ejf[t][f] = 1;
    }
    while (s--) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        ejs[f][t] = 1;
        ejs[t][f] = 1;
    }

    for (int msk = 0; msk < (1 << (vs * (vs - 1) / 2)); msk++) {
        vector<pair<int, int>>ej;
        int ind = 0;
        for (int f = 0; f < vs; f++) {
            for (int t = f + 1; t < vs; t++) {
                if (msk & (1 << ind))
                    ej.push_back({f, t});
                ind++;
            }
        }

        if (ej.size() > vs)
            continue;

        vector<vector<bool>>eif = ejf, eis = ejs;
        for (auto [f, t] : ej) {
            eif[f][t] = !eif[f][t], eis[f][t] = !eis[f][t];
            swap(f, t);
            eif[f][t] = !eif[f][t], eis[f][t] = !eis[f][t];
        }

        cnt = 0;
        used.assign(vs, 0);
        dfs(0, eif);
        if (cnt == vs) {
            cnt = 0;
            used.assign(vs, 0);
            dfs(0, eis);
            if (cnt == vs) {
                cout << "Yes\n" << ej.size() << '\n';
                for (auto [f, t] : ej) {
                    if (!ejs[f][t])
                        cout << f + 1 << ' ' << t + 1 << '\n';
                }
                for (auto [f, t] : ej) {
                    if (ejs[f][t])
                        cout << f + 1 << ' ' << t + 1 << '\n';
                }
                return;
            }
        }
    }
    cout << "No";
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qs;
    cin >> qs;
    int tq;
    cin >> tq;
    assert(tq == 4);
    while (qs--) {
        solve4();
        cout << '\n';
    }
}