/*
⣿⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣟⣟⢟⣟⢟⣟⣟⣻⡻⣻⡻⣻⡻⣻⢟⣿⡻⣟⢿⢿⡿⣿⢿⡿⣿⣿⣿⣿⣿⡿⢟⠟⢟⠿⣿⣿⠿⠋⠝⣥⣡⢭⣨⣣⢭⢮⢵⡭⣪⡡⣩⡈⡧⢱⠥⢅⢍⡙⠛⠟⢛⢋⢍⣍⣬⡵⣝⢾⣝⣯⣻⡻⣻⢟⡿⣻⡻⣟⢟⣟⢿⡻⣿⢿⡿⣿⢿⡿⣿⡻⣟⢨⣿⣿⣿⣿
⣯⡻⣮⢷⣻⡵⣯⣻⢮⣯⣻⢮⡷⣻⡵⣏⡿⣪⣟⢾⣪⢷⣝⡽⣝⢷⣝⢯⣻⢮⡿⣝⣟⣿⣺⢯⡿⣾⣻⣞⣷⢟⠬⣂⣱⢞⣦⡢⠴⡌⠠⢈⠂⢞⢑⢳⡳⢕⢋⠕⡡⡑⢅⢊⢂⠳⢈⠢⠑⡂⢂⡩⡜⡴⢥⢣⢝⢦⡻⣺⣝⢷⡵⣳⣝⡽⣝⡽⣞⡽⣞⡽⣝⣽⢽⡽⢯⢷⡛⣙⡕⡿⣽⣻⠃⣼⣿⣿⣿⣿
⢮⡿⣵⢟⣵⢟⣞⢷⣻⣮⢡⣭⣭⡍⣺⢟⣞⢷⡝⡷⡽⡎⣬⣬⣥⣅⢫⢷⣝⢃⣭⣭⣭⣌⢻⡯⢩⣭⣬⣭⠑⣣⢞⡮⣗⢟⠎⣩⣥⣴⣦⣤⣅⢊⢂⠣⢑⣠⣥⣴⣬⣬⣁⡣⣅⣓⡢⡥⣃⠪⠚⣨⣬⣤⣥⣤⣕⡱⡹⡧⣯⡇⣭⣥⣭⡌⢟⡾⣵⡋⣬⣭⣬⣥⣥⣔⣓⢿⡍⡔⣽⢪⣿⡏⢸⣾⣿⣿⣿⣿
⡻⣞⣽⣫⡯⣿⢽⡯⣷⣻⢠⣿⣿⡇⣽⣫⢞⡷⣝⣟⠾⢡⣿⣿⣿⣿⡌⣷⡻⢄⣿⣿⣿⣿⡘⢇⣿⣿⣿⣿⠐⣯⢫⣮⢹⡁⣾⣿⣿⠉⠛⡿⡿⠇⠹⢡⣿⣿⡿⢛⠻⢿⣿⣷⡜⣽⣪⣛⢖⡑⢼⣿⣿⡋⠝⢿⠿⠷⢘⡝⡮⣰⣿⣿⣿⣿⡘⣟⣾⠕⣿⣿⡿⢛⠿⣿⣿⣦⠸⣜⢧⣿⡞⣢⣿⣿⣿⣿⣿⣿
⣝⢷⡽⣮⣻⣗⡿⣽⣞⣿⢐⣿⣿⡇⢾⢵⢯⡻⡮⣯⢃⣿⣿⢇⢹⣿⣷⡘⣿⠄⣿⣿⡝⣿⣇⢹⣿⠇⣿⣿⠐⢃⠅⠄⠢⠠⠹⢿⣿⣿⣿⣶⣦⡑⢍⣾⣿⣿⢰⡟⣷⠈⣿⣿⣧⢸⢮⣝⢵⣫⡘⢿⣿⣿⣿⣶⣶⣅⢫⡺⢠⣿⣿⠃⢻⣿⣧⢙⣴⡎⣿⣿⡗⣿⣷⢹⣿⣿⡆⣿⣟⡾⣨⣾⣿⣿⣿⣿⢿⣿
⡺⣯⡻⣾⢵⣯⣻⣗⢿⣺⢐⣿⣿⡇⣻⡳⣏⣟⢾⠃⣾⣿⣿⣦⣼⣿⣿⣇⢻⠌⣿⣿⠆⢿⣿⣿⣿⠀⣿⣿⡁⡶⡜⢋⡐⡁⣦⣤⡍⣍⡙⢿⣿⣿⢀⢻⣿⣿⡜⠽⠮⣡⣿⣿⡇⡜⢳⣕⢷⡅⣩⣤⣌⢩⡙⢻⣿⣿⡆⢁⣾⣿⣿⣬⣾⣿⣿⣇⢻⡇⣿⣿⣏⠿⠟⣸⣿⣿⢡⣿⠞⢴⣿⣿⣿⣿⣿⣿⣿⣿
⣝⡷⣻⣵⣟⡷⣻⣞⢯⡿⢐⣿⣿⡇⣝⣮⣣⢟⡏⣼⣿⣿⠛⡛⣛⠻⣿⣿⣎⠃⣿⣿⡛⠸⣿⣿⡇⡄⣿⣿⡐⠏⡠⣷⢹⢂⠻⣿⣿⣶⣶⣿⣿⠏⣼⣈⠻⣿⣿⣷⣾⣿⣿⠟⣴⣻⣔⠬⡣⢧⡹⢿⣿⣷⣶⣾⣿⠟⡐⣾⣿⣿⢛⣛⣛⢻⣿⣿⡎⢗⣿⣿⣿⣿⣿⣿⡿⢋⣮⢟⣨⣿⣿⣿⣿⣿⣯⣿⣿⣿
⢮⣻⢽⣞⡷⣻⡯⣾⣫⢿⢦⣭⣭⢵⣛⣎⣝⣍⡦⡭⣭⡥⡾⡶⡶⣤⣭⣭⣥⣬⡭⡭⢔⢧⡩⣍⠔⣤⠭⡩⡀⣱⡻⢎⢇⢜⠷⣦⢭⣩⣍⡭⣴⠺⡵⣽⡱⢦⡭⣍⡍⠭⣔⢟⢮⢖⡽⣲⡕⢕⢝⢦⣭⡭⣭⣭⣴⢾⣅⢭⣭⢡⣿⡽⣿⣦⣭⣭⣵⣦⣭⣭⣭⡭⣩⣴⢞⣯⠏⢤⣿⣿⣿⣿⣿⣽⣿⣿⡿⣿
⡽⣳⣟⢮⡿⣽⠞⣡⢦⡳⡳⣮⢺⢧⣫⢞⡮⣞⢾⢕⢷⣝⣞⢟⣞⢗⡷⡺⡶⣕⢯⡺⡱⡣⡞⣰⢾⡑⡡⢊⢤⢯⡫⣺⢁⣏⡳⡳⢯⡰⣧⢻⣞⢥⡛⣾⣕⡳⣹⢎⡿⣪⡪⣗⢟⣮⡻⣮⣫⡧⡱⡱⣣⢿⣞⢮⣟⡷⡻⢮⣳⡧⢿⣿⣹⣿⣿⢟⣯⣻⣿⣿⢟⣰⢯⣞⢯⠎⣲⣿⣿⣿⣿⣿⢿⣿⣿⢿⣿⣿
⣝⢷⣝⣟⢾⣻⡕⢝⢮⣹⢝⡮⣫⣗⢽⣣⢟⣼⡳⣽⡳⡽⣮⡻⣮⢯⣫⣟⡽⣺⢇⢯⢺⢁⣾⢙⢃⠔⣡⠃⣾⢣⣏⢷⠡⣏⢾⣑⠧⣝⣞⢷⡽⡠⣇⠘⣮⢳⣌⢳⣝⢷⢽⣌⢻⡮⣻⡺⡮⡷⣕⠵⢌⢗⣽⣟⣵⣻⢟⣎⡻⣻⢚⣿⣿⢋⣶⣿⣷⣝⢿⡭⣲⢯⢷⡝⠣⣼⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣺⡻⣮⢯⣻⣮⢿⣌⠳⡱⡇⡯⡺⣪⢷⡭⣫⢾⣝⢮⣯⢻⣎⢿⣪⢷⣳⣝⢞⢵⡱⡣⢃⢜⢡⠊⢎⢼⡣⡸⣳⢕⣯⣻⢘⣧⣫⡲⢱⡯⣺⡳⣽⠂⡮⡱⡈⢷⡻⣆⠙⣷⣫⢾⣆⡙⢷⡽⣺⢯⡻⡷⣝⢮⡦⣻⡼⣗⣿⡉⣯⣕⣝⣾⣥⣿⣻⣷⣻⡧⢿⣞⣯⣻⠏⢌⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣽⣿⣿⣿
⢮⣻⡳⣟⣵⢯⡿⣽⣧⢙⢜⢮⢬⢮⣬⣮⣭⣕⡙⠳⢝⠗⡽⡳⡝⢷⢵⣫⢞⣕⡕⢁⣮⢃⠇⡘⣜⢗⢆⡽⣪⢗⢷⢵⠸⢼⡵⣍⢼⣝⡽⣝⡽⡅⢺⠀⣿⡈⢿⡽⡄⢆⠹⣳⣝⢷⡐⢝⢝⢯⣻⣝⣯⢷⣎⠘⠿⣽⣟⣎⠿⣿⣽⣯⡿⣷⣟⣾⣽⣿⣾⣮⣮⡱⡡⣻⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⡿⣿⣿
⣝⢷⡻⣽⡺⣗⡿⣾⣝⣷⣅⠳⡕⣝⢺⡳⣯⢾⡻⣻⡳⣻⢖⡾⣲⢗⡶⡼⡧⡵⢀⡿⣊⡜⡐⢜⣭⣫⢢⢯⢏⣝⢗⢯⢸⢪⣟⠆⡾⣪⢟⡮⣳⢭⠘⡄⢷⣿⡌⢻⣽⡘⣦⢊⠚⣯⢿⣕⡱⣣⢝⡳⡽⣯⢿⣷⣕⠤⣙⠺⣻⢜⣷⣿⣻⢿⡾⣿⣾⢷⣿⣽⣟⢏⠢⣿⣿⣿⣿⣿⣾⣿⣿⣿⣿⣾⣿⣿⣿⣿
⡺⣯⣻⢽⡽⣽⢽⣞⡷⣽⣟⣷⣎⡪⡣⣟⢞⣗⢿⡽⣯⢯⣯⣻⣭⡻⣞⡽⣞⠢⡽⡎⢾⠌⢰⡻⣔⢷⢸⡗⠕⣮⡛⣼⢨⡎⡾⢱⡏⢾⣫⢾⣝⠷⡅⡹⢼⣾⣿⣆⠻⣧⠸⡷⣍⠦⣙⢯⣷⣬⢳⣭⡺⢔⡛⢮⣟⢷⣵⣍⢮⢻⣯⣿⣽⣿⣟⣿⣽⣟⣿⡢⡦⣫⡓⠸⣿⣿⣿⢿⣿⡿⣿⣾⣿⣿⢿⣿⣿⣿
⣽⡺⣗⢿⡺⣗⣟⢾⡽⣷⣽⣻⣞⢿⣜⡮⡫⣞⢷⢝⣯⣻⢽⣯⣻⣟⣮⣻⡎⢼⡫⣴⡻⢠⢹⣝⢞⡧⣻⢘⢕⠮⣱⣻⡐⢧⢃⡿⣝⠼⣳⢯⡞⣿⡱⣘⢾⡷⣿⣭⣵⡸⣶⠸⣿⣿⣦⡕⣌⠳⢇⢻⣟⣷⣬⣕⣨⠒⡑⣎⡗⣿⣿⣻⣷⣿⢾⣟⣯⣿⣿⢎⡾⣆⢻⡔⢩⡻⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿
⢮⣟⣽⣫⣟⡽⣞⣯⡻⡾⣾⢵⣟⣯⢿⡽⣶⣮⡑⢯⣞⢮⡷⣫⢿⢾⣯⣿⢀⣿⢢⢟⡜⢰⢹⣎⢟⡎⣾⠨⡪⡑⡷⣝⣦⡙⡌⣟⣾⠀⢻⣗⢟⣞⢷⢨⢾⣿⣻⡿⣿⣿⣮⣥⡙⣿⣿⢿⣯⢿⣦⢅⣍⢨⣃⢍⣋⡫⡩⡬⢷⣜⣋⢭⢦⡵⣋⡻⣿⣿⡏⣺⣝⣿⡺⣿⠄⣷⣎⠻⣿⣿⢿⣿⣷⣿⣿⡿⣿⣿
⣳⡽⣮⢷⡽⣞⣯⣞⡽⣝⣷⡻⣷⢽⣯⣻⢷⣽⣻⣦⣌⡓⠝⡽⡳⣏⢶⡹⢀⠏⣼⡳⡕⡱⢕⣽⡹⡣⣯⢘⠌⣼⡹⢮⡟⣔⢻⡌⣿⠆⣇⢿⡽⣺⣻⣇⠻⣟⣿⣿⣟⣿⡿⡿⣟⡮⡋⠽⠊⠡⠺⠗⠸⢑⣎⢿⡹⣯⣲⣚⠶⣨⣥⡕⣪⣗⠭⣪⣌⡻⡸⣕⣽⡯⣇⢟⣷⢹⣿⣧⢹⣿⣿⣿⣿⢿⣿⣿⣿⣿
⢮⡻⣞⢷⣻⢞⣮⢞⣽⡺⡮⡿⣽⣳⡯⣷⢿⡺⡷⡽⣯⢿⣻⣦⡙⢮⡳⡻⡌⢣⡿⡵⡇⣜⢕⣧⣻⣕⢷⠨⡂⣾⠝⡽⣸⣿⡕⢿⡌⣷⢹⡎⣿⢽⣮⣻⣪⢻⣿⣯⣿⣿⢍⠊⡈⠄⢐⣤⢪⣷⣶⡠⡔⠇⡞⢦⣝⡤⢅⣹⣾⣿⣿⡿⣺⡧⡳⢨⢎⢕⢎⠰⣿⡽⣫⡪⣿⣸⣿⣿⠢⣿⣿⣿⣿⣿⣿⡿⣿⣿
⡵⣻⣝⢗⣿⣻⣮⡻⣮⡻⣞⣽⣫⢾⡯⣿⡵⣻⢞⣽⡺⣗⡽⣮⣏⠸⢪⢛⢞⢸⡯⡞⡡⢸⡪⡾⢮⣞⣽⡘⢄⡣⡾⣱⣿⣽⣿⡜⣿⡜⣇⢿⣮⢳⡷⡽⣮⢳⣝⢿⣿⢓⣴⣁⡐⡁⢊⡉⡸⣞⣿⣟⣗⠡⣹⣧⣭⠄⣾⣿⡿⣷⢿⡇⣿⡣⣫⠰⡕⢭⣎⢘⣿⡺⡿⡌⣿⠜⣿⣿⢑⣿⣿⣿⣯⣿⣿⣿⣿⣿
⣺⢧⣯⡻⣾⢵⣯⣟⣮⡻⡮⡾⣕⢿⡽⣾⢯⣷⡻⣮⢻⣎⢿⣪⡾⣶⣁⠱⡅⣻⢞⡕⣅⠸⡕⣟⢷⡳⡵⢇⢕⢝⣼⣟⡿⣾⣯⣷⣹⣿⣞⢎⣿⡗⢿⡽⣷⢇⢿⣿⣽⣿⣿⣥⢀⢌⠦⡑⢎⡻⡙⢝⡎⠰⡰⣽⢾⢨⣿⣿⢯⣟⣿⡊⣿⡇⡽⡨⡪⣒⣷⠐⣿⣽⢿⡣⣻⣍⣿⡧⣽⣿⣿⣿⣿⣿⣟⣿⣿⣿
⣝⡿⣾⣽⣻⣯⢷⡿⣮⣟⢾⣝⡽⣳⡽⣺⢟⣾⢯⣞⢷⣹⡳⣿⢿⡺⡇⠒⠠⣯⡻⡆⡪⡈⣗⢯⣫⡯⣻⢸⠸⣎⢷⠯⣻⠛⡞⠟⣷⢿⣿⣷⡹⣿⣎⡻⣽⣿⡘⣿⣿⣿⣿⡿⢦⣠⣰⣾⣶⣞⣿⢮⡿⡐⡕⢺⣿⣺⣿⡟⢼⣯⣿⢌⣿⡆⣙⡮⡢⣵⢿⡈⣿⣯⢿⣏⠼⡇⢾⢒⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿
⢾⣽⣗⡿⣾⡽⣟⣽⡻⣞⢷⡽⣝⣷⣫⣯⢯⣯⣻⣽⣗⢽⡺⡵⣯⡻⢨⢁⢪⢒⢽⡣⡂⢵⡘⢽⢮⡻⣵⢱⠈⣏⠙⢁⠄⠄⡘⢰⣬⣝⣯⣿⣿⣟⣿⣮⡱⢿⣷⡹⣿⣿⣿⣿⣿⣞⣿⣿⣻⣷⢻⣝⡿⡄⣻⡈⣿⣿⣿⣿⣘⣷⢿⠣⣿⡆⡱⣟⢾⡳⣿⡑⣿⢯⡿⣇⣻⣫⢌⣿⣿⣿⣿⢿⣿⣿⣻⣿⣾⣿
⣻⢾⣽⣻⢾⣻⢯⡾⣝⣯⣗⡿⣽⢮⡷⡽⡾⣮⢾⢶⢯⢷⡝⡾⡕⢅⠳⡄⡕⡕⣸⣇⠆⢸⣧⡙⢗⣯⣻⠰⠁⡁⣨⣶⣔⠠⠂⢌⠠⡜⣿⣿⣿⣿⣿⣿⣿⣮⡻⢷⣽⣿⣿⣿⣿⣷⣽⣿⣟⣿⡽⣿⣝⠦⣸⡇⢿⣿⣷⣿⣷⡟⢑⡵⢿⡇⢜⣯⢿⣝⣿⢸⡯⣿⢽⡗⢼⡇⠴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣽⣻⢷⣯⣟⣽⡳⣯⢿⣮⣟⢾⡯⣷⣻⣝⣟⢾⡳⣯⡻⣳⢟⢽⣰⢝⢮⡪⣊⠎⣼⢷⠀⢹⡮⣷⢌⠳⣝⡇⡃⢶⢾⡿⣿⠧⠑⠅⣃⣸⣼⣿⣿⣽⣿⣟⣿⣿⣿⣯⣻⣽⣿⣿⣿⣿⡾⣯⣿⣿⣗⢿⡇⡗⡬⣟⡸⢟⢞⠿⠑⢤⢪⡟⣾⢇⢪⣟⣿⡺⡯⢸⡯⡻⣽⣟⢸⣷⢱⢹⣿⣿⣽⣿⣯⣿⣿⣽⣿⣿
⢾⡽⣳⢷⡽⣞⣯⣟⣷⣳⡯⣿⠽⡳⡛⣬⢵⢵⢞⡶⣳⡳⣻⢧⡫⣗⢯⠂⣕⠱⣯⣻⠀⢸⢯⡞⣷⡑⢮⡎⢎⠜⢳⢿⢨⣢⡘⣦⣽⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣽⣿⣾⣿⡍⡧⡣⣿⢸⡇⢤⠙⣮⠣⡁⣿⣝⡎⣷⢘⡷⣯⣻⡓⡈⢟⡼⡱⣿⢨⣿⡘⣦⠿⣿⣿⣿⣿⣿⣿⣿⡿⣿
⣳⣝⡷⣻⡽⣫⣺⣗⡯⢞⣹⡦⢳⡴⣻⡪⣗⡽⣳⣝⠗⢿⢘⣇⡫⠔⡡⢠⡑⣝⢷⡭⠀⡱⣻⢮⣫⢧⠘⢧⠫⡖⡄⠻⣮⡷⣯⢿⣿⣟⣿⣿⣿⣽⣿⣟⣿⣿⣿⣿⣿⣿⡿⣿⣿⢿⣿⣷⣿⣿⡟⡥⣓⠕⣿⢐⣿⠰⣹⡇⡇⢸⡿⣮⢐⣿⡁⣿⢿⡕⡭⡌⢺⡪⣓⣿⠢⣿⡇⢺⡽⣚⣿⣿⣽⣷⣿⣿⣿⣿
⢵⣯⢛⣵⢾⣻⢕⢥⡾⣾⡝⢜⡷⣝⡮⣻⠜⣋⣮⣦⠿⢚⡩⣡⣺⡖⢔⢎⡾⣹⡳⠸⡀⠸⣯⢷⡸⣇⢙⢦⡙⢾⡘⣧⡸⣟⣿⣟⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⢝⣾⣿⢕⠩⣿⢀⣿⢸⡻⣎⢢⣟⢿⡖⠠⡿⣧⢸⣟⢮⡃⣿⣐⢯⣪⣿⡑⢾⣻⡐⣟⢷⡜⢿⣿⣿⣿⡿⣿⣿
⡗⣱⣟⣯⢏⡵⢭⣾⣻⣾⠁⣟⢾⣪⢟⣼⣟⡿⡓⠡⣒⣵⡿⣽⢏⢜⡮⣳⢝⡮⠃⡽⠀⡪⣷⡳⢵⡇⢸⡕⣽⠷⣦⠨⣧⠭⣷⣿⡾⣿⣿⣿⣿⣾⣿⣿⣿⢿⣿⣿⣿⣾⣾⣿⣿⣿⣿⣻⣾⣿⣿⣿⡙⠌⡗⢤⣿⢸⣿⣕⣯⣾⣿⢁⠂⢿⣻⡄⣿⢴⢣⣿⣿⡜⣾⢷⡝⢺⣟⣧⠸⣿⣞⣕⢻⣿⣿⣿⣿⣿
⢧⡨⢛⠝⠰⣯⠸⣷⣻⡇⢸⣫⢳⢵⣿⣳⠟⡡⢊⡞⢿⣽⢟⢥⣞⢵⡫⣞⠕⡡⢜⠎⣸⠰⣿⡵⣿⠁⣪⠎⣾⣛⢾⡄⢿⡧⡜⢿⣿⡝⣿⣿⣟⣿⣿⣷⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⢻⢟⣋⡊⡝⣸⡿⣸⡷⣿⣸⣯⠗⡨⡃⢸⣿⡇⣻⣮⠸⣿⣿⡇⣿⣻⣎⢹⣯⢿⡆⢽⣿⣞⣧⡻⣿⣿⣻⣿
⣻⣟⣿⣻⣮⣙⡦⢍⡘⢧⠘⢧⣻⡷⢋⣭⡕⣹⣯⣇⠸⣯⣞⢗⡷⣹⢮⠳⡜⡕⡝⣰⡏⢼⣷⣟⡯⠠⡧⢹⣯⣻⣵⢇⣌⠻⡼⣎⡛⢿⣮⡻⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣟⣿⣿⣿⣿⠛⣋⢊⡾⡽⡆⡱⣸⡯⢺⡿⣇⢿⡾⠡⡣⡑⢘⣷⣗⢹⣯⢧⡹⣿⡗⣿⣵⢧⢹⣷⡻⣿⡠⣻⣿⣿⢯⠺⣿⣿⣿
⣽⡾⣽⣽⢯⣟⡿⣻⢏⣮⢛⣶⡷⣴⢿⡛⢵⢿⡝⣧⠘⣿⢮⢛⣩⣛⠕⡭⣪⠊⣰⢿⢬⡿⣮⢿⠠⡞⢰⣿⣳⣟⡾⢰⡿⣎⠦⡧⢝⢶⣩⣃⢛⠿⠿⢯⣿⣿⢿⣿⣿⡿⣿⣿⣿⢿⣺⢟⣾⣫⢗⣽⠻⡀⠳⢸⣿⠸⣿⡅⡿⣟⠨⡃⢜⠀⣿⣧⢹⣿⢖⢕⢿⡯⣺⣯⡗⢹⣞⢝⣯⣷⠨⣿⣿⣿⡑⢿⣿⣿
⣞⣿⣻⢾⢿⡝⢨⣗⢡⡷⣸⡯⡷⢹⣏⢫⡹⣣⣽⢇⢪⣧⣾⣿⡋⡕⢎⠎⣠⡼⠯⢋⣴⢿⢮⣣⢟⢆⣟⢷⣻⡵⢃⣿⣻⢾⣅⢏⢞⢵⢜⢵⢍⡞⣚⠶⣢⢕⡍⢧⠬⣩⢝⣏⣵⣾⣯⣟⣮⡷⠗⢃⠨⠰⠘⠾⢎⡇⢿⡸⠜⡷⢈⠇⡪⢀⣿⡞⢽⣿⢸⡡⡫⡗⣽⡷⣏⠸⣇⢧⢻⡾⣆⢚⣿⣯⡇⣻⣿⣿
⢉⣎⠷⠝⠕⡙⠸⢆⢌⡷⣯⢞⡕⣽⢯⣸⣷⢟⣮⣽⢾⣟⡷⣑⠋⣉⣠⣲⡭⠀⢢⣿⣝⣵⡯⡯⣫⣽⣽⣫⣾⠡⣽⡳⣿⣹⡮⢆⢫⡳⡱⡳⣕⡇⢸⡕⣗⢵⡹⡢⣳⠑⠇⣈⠉⡚⢉⢉⠄⢔⢐⠅⡑⣜⡜⣆⢢⡌⡌⡺⡡⠺⡄⢃⠆⠠⡿⡋⣼⡷⠐⡥⡫⢌⣿⣽⢧⠐⡗⡵⣙⣯⣿⡀⢻⣿⠇⣽⣿⣿
⣫⠇⡑⡡⣸⣞⣿⢾⢢⡟⡞⢥⡟⣼⢱⣟⡾⣻⣮⣿⣻⡏⠼⠿⠿⢟⡛⣭⡖⣱⢿⢮⣟⡾⡩⢞⡶⣻⣮⢿⢁⡾⣿⣝⡾⣽⢁⡾⠈⡓⡙⢚⠞⣔⠞⠮⢎⢐⣉⣤⢶⡾⣥⢄⠸⠄⢣⠐⣄⣅⢮⣼⢣⣿⡣⢹⣶⣬⡲⢌⢣⠊⠸⡣⢊⠐⣯⡀⣿⢏⢨⢢⡫⢰⡿⣞⢷⠀⢺⢪⠆⣻⣞⣿⡈⢿⣣⣿⣿⣿
⠀⣱⠈⣼⣯⡿⣽⠇⣺⣅⣣⣟⢷⢶⡟⣷⡽⣿⢾⣯⣟⢸⣿⣷⣿⣷⢿⣫⡶⣟⣽⢫⢎⢞⡸⣎⡯⣿⠎⣵⠫⣜⣷⢯⡟⡡⠎⣠⡶⣾⣾⣿⣷⠮⡔⢲⣺⢿⡿⣽⣗⣿⢿⣯⢓⢱⣷⣿⣷⣾⣿⡿⣼⣿⡱⠹⣿⣿⣿⣷⣾⣬⣅⡛⠦⡙⠦⣫⣞⢕⢸⢢⢑⡿⣽⡯⣷⠀⣣⢫⡣⡸⣷⢯⣟⢌⢿⣿⣿⣿
⡘⣼⡅⣿⣟⣾⡟⣠⣿⢽⡯⣾⠏⣵⣿⣽⣻⣟⡿⡷⣹⣿⡿⢾⣣⡷⣿⢱⠟⢝⠪⣡⡶⣿⢹⡮⡳⣣⣾⠯⡱⣽⡽⡋⣜⢕⣾⣿⠟⣾⣿⣿⡟⣜⢸⣲⣯⣟⣿⣽⣯⡛⣭⣣⣿⣦⡻⡛⣿⣿⣿⢧⣿⣿⢸⢃⣿⢿⡿⣿⣿⣿⣿⣿⣿⣿⣷⣯⣵⣅⣛⠥⣫⡼⣷⣻⣮⠀⣽⡔⣝⠔⣿⣝⡿⣦⢙⣿⣿⣿
⢘⣞⢷⣝⢿⣾⢡⡿⣷⣻⣽⣻⡼⣿⢾⡷⣿⣻⡿⣱⣿⡟⠵⣫⣭⣮⠖⠠⡑⠄⣡⣿⣽⣫⡗⢃⣼⠛⡜⣎⡺⡺⢃⡞⣴⣿⢟⢣⣿⣿⣿⢟⠼⢢⣻⣿⣿⣿⣿⣿⣿⣿⢔⣿⠷⣯⣏⣾⣾⣿⣿⢸⣿⡗⡯⢴⢽⣮⢿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣶⣾⣙⠻⢞⣽⣗⠀⣽⣷⢱⡃⢺⣯⣟⢾⡆⣻⣿⣿
⠪⡪⠷⠽⠶⣝⠇⢿⣻⣗⣿⣞⣿⣽⣿⣻⣿⡽⣃⣿⠋⢔⣮⣾⡿⠃⢠⠙⡌⣼⣟⢷⢳⡎⠰⡱⢃⢝⢬⣟⢼⢣⢏⣾⢟⢱⣵⣿⣿⡿⡩⡺⢁⣿⣿⣿⣿⣿⣿⣿⢿⣿⣕⣵⣷⣭⣣⣿⣿⣿⡏⣾⣿⣹⠇⣿⡚⣿⡞⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿⣿⣿⣧⡪⠱⣯⠀⣟⣿⣧⢫⢸⣿⢞⡿⣇⢪⣿⣿
⢛⣚⣷⣻⣵⡱⣫⠘⣻⣞⡷⣻⢞⣷⣻⣯⠚⣬⡾⢡⢊⣾⡿⢋⠔⡢⢑⣱⣾⡻⣞⠷⠋⣰⢁⢂⢗⡱⢰⣯⠟⢌⢣⣔⣾⣿⣿⣿⡟⡰⡑⢅⣿⣿⣿⣿⣿⣯⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡇⣿⢏⣾⠁⢼⡇⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⣿⣗⢧⡸⢰⡇⣿⣿⣧⡸⣯⣯⣻⡏⡮⣿⣿
⢿⢝⡯⣷⢻⢿⠔⡡⡀⢿⡽⣯⢿⡵⣿⢾⡄⣻⣇⠥⢼⣵⣴⣤⣷⣾⢿⢝⣭⡩⢠⢒⢝⢔⡁⢔⢕⢵⢈⢏⡆⣳⣿⣿⣿⠿⡾⡟⡰⡑⢡⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣯⡟⢢⡟⣰⠸⣗⢼⣿⡎⣿⣿⣿⣯⣿⣷⣿⣿⡿⣿⣷⣿⣿⢿⣿⡎⣇⢸⣷⢹⣿⣿⢸⣗⢷⣽⡊⣯⣿⣿
⢒⠎⣃⣑⣁⣂⠑⠌⣂⣙⣙⣓⣋⣛⠛⣙⣂⡹⢀⠏⣒⣉⠮⣙⣛⣙⣃⣛⠯⣿⣦⠑⣕⢕⠆⢈⣊⣐⣑⡈⣲⢟⣋⣛⢳⣉⣊⣘⡈⣊⣙⣛⣛⣛⣙⣛⢚⣙⣋⣓⣛⣛⡋⣿⣿⣿⡟⣙⣋⣛⣙⣃⢸⠃⣛⣈⠳⡪⡿⢃⣛⣋⣛⠿⣿⡿⢛⣙⣛⣙⠿⣿⣿⣿⣿⣇⠗⣘⣛⣀⣛⠷⣹⢋⣓⣙⣁⣛⣚⢻
⡅⣾⣿⡛⠻⠿⠷⡀⣿⣿⠟⠛⠛⢛⡄⢿⣿⣷⣄⠑⣿⣿⠠⣻⣿⡟⠻⢿⣷⡜⣿⣿⣤⠃⣼⣿⡿⠛⢿⣿⠜⢼⣿⣿⢸⡏⣿⣿⡇⣛⣛⢻⣿⡟⣛⣛⢸⣿⣿⠛⠛⠛⣃⣿⣿⣿⡇⣿⣿⠛⡻⣿⣷⠀⣿⣿⠅⣃⣾⣿⢟⡻⢿⡷⠙⣴⣿⡟⠙⠿⠷⢸⣿⣿⣿⢢⣾⣿⢟⡻⣿⣷⡙⢜⣿⣿⠛⣛⢛⣸
⣤⡙⠿⢿⣿⣷⣎⠃⣿⣿⡿⠿⠿⠇⡁⢿⣿⠻⣿⣮⣿⡿⠠⣽⣿⡇⣯⢸⣿⡇⣽⣿⣿⡇⣿⣿⠰⡑⠔⠶⢿⢺⣿⣿⠸⣁⣿⣿⡇⣿⣿⢸⣿⡇⣿⣿⢳⣿⣿⠿⠿⠿⢪⣿⣿⣿⡇⣿⣿⣶⣾⡿⠟⡄⣿⣿⡃⢸⣿⣯⢸⣿⠶⠿⢿⢌⠻⢿⣿⣷⣮⢻⣿⣿⣯⢸⣿⡇⣿⡿⢸⣿⡇⢸⣿⣿⢷⡾⡆⣿
⡇⢾⣿⣔⣢⣿⡿⠀⣿⣿⣦⣤⣥⣥⠁⣿⣿⢅⡙⣿⣿⣟⠐⢾⣿⣧⣤⣾⣿⢣⣿⣾⣽⣧⠻⣿⣦⣬⣾⣿⢃⠎⢿⣿⣤⣥⣿⡿⢡⡈⣄⢸⣿⡏⣿⣿⡳⣿⣿⣬⣭⣭⡍⣿⣿⣿⡇⣿⣿⢠⣶⠀⣾⡇⣿⣿⢆⣌⢿⣿⣬⣥⣾⡿⢂⢻⣿⣆⣢⣿⣿⢱⣿⣿⣿⡘⢿⣷⣬⣥⣿⡿⢣⡱⣿⣿⢀⣾⡖⣿
⢛⣢⡭⣩⢋⡍⢖⢧⠉⡉⣍⢭⢍⡭⡤⣩⡩⡴⣏⢌⡉⢭⣜⣭⣍⢩⣭⣭⣶⣷⣭⣻⣿⣿⣷⣭⣽⣭⣭⡁⠢⢈⢤⢍⣙⢍⢭⢔⠵⡱⣌⢬⠍⡭⣿⣿⣭⣭⣭⣭⣭⣭⣥⣿⣿⣿⣧⣭⣭⣴⡿⠀⡿⢅⠉⠭⣴⣿⣷⣬⣽⣭⣽⣶⢣⣶⣭⣭⣫⣭⣴⣿⣿⣿⣿⠃⡴⣭⣽⣭⣩⣶⣿⣬⣭⡍⣔⣿⢇⣿
⢏⠎⡢⡱⢔⢎⡾⢮⡖⢐⢜⠦⡳⢜⡪⣆⢳⡱⡱⢆⢜⠰⣮⣟⡿⢸⣝⣛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡀⢮⢢⡑⡬⣣⣛⢜⡕⡳⡜⣬⢃⢗⢸⣿⣿⣿⣿⣿⣿⡿⣿⣿⣿⣿⣿⣿⠟⢋⢙⡄⡳⣀⡁⡲⣄⢭⢐⣉⠻⣿⢿⣧⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⡏⡰⡨⣿⣿⠗⣼⣟⣾⣻⡞⢦⣹⣿⢸⣿
⠕⡸⡴⣻⢝⢋⢋⠕⡙⣀⣌⡑⣝⢊⣐⣁⠳⣈⣈⣊⣠⣃⣙⢻⣗⡐⣿⣿⠿⢛⣉⣍⣙⡻⢿⣋⣋⣋⣋⣛⣛⠢⡃⣉⣈⣑⣉⣑⣈⢳⢈⣂⣅⣙⣀⡻⢿⡟⣉⣋⠛⣘⣛⣙⣋⣋⣙⡁⠂⡔⢡⠃⠸⣀⣭⣨⣐⡑⠕⠭⡲⣁⣄⣘⠿⠟⠟⣙⣙⣙⣋⣛⡛⠻⢁⣌⣘⣋⣋⣊⠿⣮⣳⡟⡐⣮⣿⢇⣿⣿
⣸⣝⢾⡑⢔⠅⡕⢌⡂⢽⣿⡇⢈⠰⣿⣿⠨⣸⣿⡟⠛⢻⣿⡇⣿⢧⣜⠏⣼⣿⡟⣛⠿⠿⠎⣺⣿⣿⠛⢻⣿⣷⢸⢽⣿⡟⠛⠛⠛⡸⢼⣿⡟⡛⢿⣿⡆⡇⣿⣿⠀⡛⡛⢻⣿⡟⢛⣃⢜⢕⠱⢡⣾⣿⢟⡛⠿⠷⢘⡕⢰⣿⣿⣿⡆⢺⠂⣿⣿⡛⠛⣿⣿⠆⢸⣿⣿⠛⢿⣿⣦⢳⡟⡠⣹⣾⢏⣼⣿⣿
⢧⡻⣎⢆⢕⠌⢊⣤⡅⢾⣿⡇⢨⢐⣿⣿⢀⢺⣿⡿⢿⣿⡟⢁⢿⣝⣿⡆⣿⣿⢈⠫⣓⡻⠿⢺⣿⣿⢿⣿⣟⢣⡾⣹⣿⡿⠿⠿⠟⢼⢸⣿⡇⢌⢸⣿⡧⠐⣿⣿⠀⢎⠀⣹⣿⡇⡣⡕⡕⢭⡊⢸⣿⣯⢈⢟⢒⡛⠧⢃⣾⣿⡀⣿⣿⡰⡇⣿⣿⠿⣿⣿⡋⣼⢸⣿⣿⢸⢅⣿⣿⠘⠄⣾⣿⢋⣼⣿⣿⣿
⡳⣝⢾⠆⣢⣼⣿⣿⣿⡸⣿⣷⣦⣾⣿⠏⡄⣹⣿⡇⢌⢿⣿⣎⠢⣯⢺⠃⠹⣿⣷⣵⣾⡿⢃⢾⣿⣿⢠⠻⣿⣧⡙⣽⣿⣷⣵⣾⣶⢩⢺⣿⣷⣶⣾⡿⢃⢈⣿⣿⠈⠮⡅⢸⣿⡇⢎⠎⡪⠡⡊⢄⢻⣿⣦⣷⣿⡿⠁⣾⣿⠟⠻⠻⣿⣧⠁⣿⣿⡱⡜⣿⣿⡜⢸⣿⣷⣶⣾⣿⠏⣈⢾⡟⣡⣿⣿⣿⣿⣿
⣝⢷⡙⣼⣿⢿⣿⣽⣿⢷⣶⡍⢉⢍⠤⡪⡒⡌⡍⣡⢎⠦⡩⡩⡰⣄⢑⡑⡣⡈⢍⢉⠡⠒⡳⣄⠥⠥⠾⠷⠭⣭⣤⣬⣭⣬⣥⣭⣬⣴⣬⣉⢉⠅⠡⠠⡈⢀⣉⡉⡀⠣⠢⢌⢉⠡⡂⢕⠨⡢⢑⠌⠔⣮⣍⠩⢤⠲⡅⢉⠌⡜⠿⢓⠍⠩⠴⣭⣭⣼⣿⣬⣥⣥⣬⡭⢥⢩⢤⣦⢜⠣⣵⣾⣿⣿⣿⣿⣿⣿
⢞⢵⡃⣿⡽⢫⣥⣵⣥⣮⣰⣑⢠⡊⢎⢎⢜⠜⡔⢕⢕⠕⡕⡜⡢⢎⡄⢫⠰⡈⢢⠁⢎⠨⡂⢵⠀⢘⢖⢔⡄⠈⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣦⡝⡊⢖⢥⠄⡱⠠⡈⢕⠑⠔⡡⢑⢌⠢⡑⡬⡪⣣⡑⠘⢷⢽⣌⠣⡈⠢⡰⡨⡪⡢⡹⡰⡡⡈⠻⣿⣿⣿⢯⡷⣽⣶⣿⣿⣿⣷⡹⡝⣿⣿⣿⣿⣿⣿⣿⣿
*/

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define pint pair<int, int>
#define gay MikeKalyzhnyy
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
//#pragma GCC target("avx2")
#endif

int g;

vector<vector<int>> graph;
vector<int> comp;
int CMP = 0;

void dfs(int v) {
    comp[v] = CMP;
    for (auto& to : graph[v]) {
        if (comp[to] == -1) {
            dfs(to);
        }
    }
}

inline void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    graph.assign(n, {});
    vector<set<int>> negr(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        negr[a].insert(b);
        negr[b].insert(a);
    }
    CMP = 0;
    comp.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        if (comp[i] == -1) {
            dfs(i);
            CMP++;
        }
    }
    vector<vector<int>> cs(CMP);
    for (int i = 0; i < n; ++i) {
        cs[comp[i]].push_back(i);
    }
    vector<pint> path;
    while (CMP > 1) {
        bool any = false;
        for (int a = 0; a < cs.size() && !any; ++a) {
            if (cs[a].empty()) continue;
            for (int b = 0; b < cs.size(); ++b) {
                if (cs[b].empty()) continue;
                if (a == b) continue;
                bool good = false;
                for (auto& v : cs[a]) {
                    for (auto& u : cs[b]) {
                        if (!negr[u].count(v) || (negr[u].size() > 1 && negr[v].size() > 1)) {
                            good = true;
                            if (negr[u].count(v)) {
                                negr[u].erase(v);
                                negr[v].erase(u);
                            } else {
                                negr[u].insert(v);
                                negr[v].insert(u);
                            }
                            path.emplace_back(v, u);
                            break;
                        }
                    }
                    if (good) break;
                }
                if (good) {
                    any = true;
                    if (cs[a].size() > cs[b].size()) swap(cs[a], cs[b]);
                    for (auto& x : cs[a]) {
                        cs[b].push_back(x);
                    }
                    cs[a].clear();
                    CMP--;
                }
            }
        }
        if (!any) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << path.size() << endl;
    for (auto& [a, b] : path) cout << a + 1 << ' ' << b + 1 << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
     cin >> ttt;
     cin >> g;
    while (ttt--) {
        solve();
    }
    return 0;
}
