#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve3(int m1, int m2) {
    vector<bool> e1(3, false), e2(3, false);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        if (u > v)
            swap(u, v);
        if (u == 1) {
            if (v == 2)
                e1[0] = true;
            else
                e1[1] = true;
        }
        else
            e1[2] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        if (u > v)
            swap(u, v);
        if (u == 1) {
            if (v == 2)
                e2[0] = true;
            else
                e2[1] = true;
        }
        else
            e2[2] = true;
    }
    if (m1 >= 2)
        cout << "Yes\n0\n";
    else if (m1 == 1) {
        if (e1[0]) {
            if (m2 == 3 || !e2[1])
                cout << "Yes\n1\n1 3\n";
            else if (!e2[2])
                cout << "Yes\n1\n2 3\n";
            else
                cout << "No\n";
        }
        else if (e1[1]) {
            if (m2 == 3 || !e2[0])
                cout << "Yes\n1\n1 2\n";
            else if (!e2[2])
                cout << "Yes\n1\n2 3\n";
            else
                cout << "No\n";
        }
        else {
            if (m2 == 3 || !e2[0])
                cout << "Yes\n1\n1 2\n";
            else if (!e2[1])
                cout << "Yes\n1\n1 3\n";
            else
                cout << "No\n";
        }
    }
    else
        cout << "No\n";
}

set<pii> e1, e2;

bool is_in_set(set<pii> &s, pii x) {
    auto it = s.lower_bound(x);
    return (it != s.end() && *it == x);
}

bool check_edge(int u, int v) {
    if (u > v)
        swap(u, v);
    if (!is_in_set(e2, {u, v})) {
        e1.emplace(u, v);
        e2.emplace(u, v);
        return true;
    }
    else
        return false;
}

void rem_edge(int u, int v) {
    e1.emplace(u, v);
    e2.erase({u, v});
}

vi pr;
vector<vi> cp;

void unite(int u, int v) {
    u = pr[u];
    v = pr[v];
    if (u == v)
        return;
    if (cp[u].size() > cp[v].size())
        swap(u, v);
    for (int i: cp[u]) {
        pr[i] = v;
        cp[v].push_back(i);
    }
    cp[u].clear();
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (n == 3) {
        solve3(m1, m2);
        return;
    }
    e1.clear();
    e2.clear();
    pr.resize(n + 1);
    cp.assign(n + 1, vi(0));
    for (int i = 1; i <= n; ++i) {
        pr[i] = i;
        cp[i] = {i};
    }
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        if (u > v)
            swap(u, v);
        e1.emplace(u, v);
        unite(u, v);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        if (u > v)
            swap(u, v);
        e2.emplace(u, v);
    }
    int r1 = -1, r2 = -1;
    for (int i = 1; i <= n; ++i) {
        if (pr[i] != i)
            continue;
        if (r1 == -1)
            r1 = i;
        else {
            r2 = i;
            break;
        }
    }
    if (r2 == -1) {
        cout << "Yes\n0\n";
        return;
    }
    vector<pii> ans;
    for (int i = 1; i <= n; ++i) {
        if (pr[i] != i || i == r1 || i == r2)
            continue;
        if (check_edge(r1, r2)) {
            ans.emplace_back(r1, r2);
            unite(r1, r2);
            r1 = pr[r1];
            r2 = i;
        }
        else if (check_edge(r1, i)) {
            ans.emplace_back(r1, i);
            unite(r1, i);
            r1 = pr[r1];
        }
        else if (check_edge(r2, i)) {
            ans.emplace_back(r2, i);
            unite(r2, i);
            r2 = pr[r2];
        }
        else {
            rem_edge(r2, i);
            ans.emplace_back(r2, i);
            unite(r2, i);
            r2 = pr[r2];
        }
    }
    if (cp[r1].size() > cp[r2].size())
        swap(r1, r2);
    if (cp[r1].size() > 1) {
        bool f = false;
        for (int i = 0; i < 2; ++i) {
            if (f)
                break;
            for (int j = 0; j < 2; ++j) {
                if (check_edge(cp[r1][i], cp[r2][j])) {
                    ans.emplace_back(cp[r1][i], cp[r2][j]);
                    f = true;
                    break;
                }
            }
        }
        if (!f) {
            rem_edge(cp[r1][0], cp[r2][0]);
            ans.emplace_back(cp[r1][0], cp[r2][0]);
        }
    }
    else {
        bool f = false;
        for (int u: cp[r2]) {
            if (check_edge(r1, u)) {
                ans.emplace_back(r1, u);
                f = true;
                break;
            }
        }
        for (int u: cp[r2]) {
            if (f)
                break;
            for (int v: cp[r2]) {
                if (u >= v)
                    continue;
                bool f1 = is_in_set(e1, {u, v}), f2 = is_in_set(e2, {u, v});
                if (f2) {
                    ans.emplace_back(r1, u);
                    f = true;
                    break;
                }
                else if (!f1) {
                    ans.emplace_back(u, v);
                    ans.emplace_back(r1, u);
                    f = true;
                    break;
                }
            }
        }
        if (!f) {
            ans.emplace_back(cp[r2][0], cp[r2][1]);
            ans.emplace_back(r1, cp[r2][0]);
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto p: ans)
        cout << p.first << ' ' << p.second << '\n';
}

int main() {
    fast;
    int ts, gr;
    cin >> ts >> gr;
    while (ts--)
        solve();
}
