//#pragma GCC optimize("Ofast, inline, unroll-loops")
#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using ll = long long;

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const ll modll = 2286661337;
const int R = (1 << 19);

template<typename T>
void sort(T &s) {
    sort(all(s));
}

template<typename T>
void rsort(T &s) {
    sort(rall(s));
}

mt19937 rnd(124);

vector<int> p1, r1;
vector<int> p2, r2;

int get(int x, int ty) {
    if (ty == 1) {
        if (x != p1[x]) {
            x = get(p1[x], 1);
        }

        return x;
    } else {
        if (x != p2[x]) {
            x = get(p2[x], 2);
        }

        return x;
    }
}


void unite(int x, int y, int ty) {
    if (ty == 1) {
        x = get(x, 1);
        y = get(y, 1);

        if (r1[x] > r1[y]) {
            swap(x, y);
        }

        p1[x] = y;

        if (r1[x] == r1[y]) {
            ++r1[y];
        }
    } else {
        x = get(x, 2);
        y = get(y, 2);

        if (r2[x] > r2[y]) {
            swap(x, y);
        }

        p2[x] = y;

        if (r2[x] == r2[y]) {
            ++r2[y];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout << setprecision(20) << fixed;


    int t, g;
    cin >> t >> g;

    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        p1.resize(n);
        p2.resize(n);
        r1.resize(n);
        r2.resize(n);

        for (int i = 0; i < n; ++i) {
            p1[i] = i;
            p2[i] = i;
        }

        set<pair<int, int> > se1, se2;

        for (int i = 0; i < m1; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;

            se1.emplace(a, b);
            se1.emplace(b, a);

            unite(a, b, 1);
        }

        for (int i = 0; i < m2; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;

            se2.emplace(a, b);
            se2.emplace(b, a);

            unite(a, b, 2);
        }

        map<int, vector<int> > kos;

        for (int i = 0; i < n; ++i) {
            kos[get(i, 1)].push_back(i);
        }

        if (m1 == 0) {
            cout << "No\n";
            continue;
        }
        
        if (sz(kos) == 1) {
            cout << "Yes\n0\n";
            continue;
        }

        vector<pair<int, int> > res;

        pair<int, int> pa = {-1, -1};

        for (auto i : se1) {
            if (se2.contains(i)) {
                pa = i;
                break;
            }
        }

        if (pa == make_pair(-1, -1)) {
            if (m2 == n * (n - 1) / 2) {
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (!se1.contains({i, j})) {
                            pa = {i, j};
                            res.emplace_back(i, j);
                            unite(i, j, 1);
                            unite(i, j, 2);
                        }
                    }
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (!se1.contains({i, j}) && !se2.contains({i, j})) {
                            pa = {i, j};
                            res.emplace_back(i, j);
                            unite(i, j, 1);
                            unite(i, j, 2);
                        }
                    }
                }
            }
        }

        if (pa == make_pair(-1, -1)) {
            cout << "No\n";
            continue;
        }


        auto [a, b] = pa;


        for (int i = 0; i < n; ++i) {
            if (get(a, 1) != get(i, 1)) {
                bool fl1 = se2.contains({a, i});
                bool fl2 = se2.contains({b, i});

                if ((fl2 && fl1) || (!fl2 && !fl1) || (fl2)) {
                    res.emplace_back(a, i);
                } else {
                    res.emplace_back(b, i);
                }

                unite(a, i, 1);
            }
        }

        cout << "Yes\n";
        cout << sz(res) << "\n";
        for (auto i : res) {
            cout << i.first + 1 << ' ' << i.second + 1 << "\n";
        }
    }

}
