//#pragma GCC optimize("O3", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define F first
#define S second
#define vec vector
#define all(x) (x).begin(), (x).end()

//#pragma GCC target("avx2")

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}
template<typename A>
void read(A &a){
    for(auto &i: a)cin >> i;
}

const int bs = 320;
const int inf = 1e18;

int T;
int n, m1, m2;
vec<vi> g1, g2;

void col1(int u, vi &used, vi &col){
    used[u] = 1;
    for(int v: g1[u])if(!used[v]){
        col[v] = col[u];
        col1(v, used, col);
    }
}

struct DSU{
    vi p, sz;
    int n;

    int get(int u){
        if(p[u] == u)return u;
        return p[u] = get(p[u]);
    }

    void merge(int u, int v){
        u = get(u);
        v = get(v);
        if(u == v)return;
        if(sz[v] > sz[u])swap(u, v);
        sz[u] += sz[v];
        p[v] = u;
    }

    DSU(int n): n(n){
        p.resize(n, 0);
        sz.resize(n, 1);
        iota(all(p), 0);
    }
};

mt19937 rnd(43432);

void solve(){
    cin >> n >> m1 >> m2;
    g1 = g2 = vec<vi>(n);
    for(int i = 0; i < m1; ++i){
        int u, v; cin >> u >> v;
        u--; v--;
        g1[u].pb(v);
        g1[v].pb(u);
    }
    for(int i = 0; i < m2; ++i){
        int u, v; cin >> u >> v;
        u--; v--;
        g2[u].pb(v);
        g2[v].pb(u);
    }

    set<pii> ed2;
    for(int i = 0; i < n; ++i){
        for(int v: g2[i]){
            if(v > i)ed2.insert({i, v});
        }
    }

    vec<pii> cu;
    for(int i = 0; i < n; ++i){
        cu.eb(i, (i + 1) % n);
    }
    if(n == 3){
        if(m1 < 1)cout << "No\n";
        else if(m1 >= 2)cout << "Yes\n0\n";
        else{
            if(m2 == 3){
                cout << "Yes\n1\n";
                int fr = -1;
                for(int i = 0; i < n; ++i)
                    if(g1[i].size() == 0)fr = i;
                cout << fr + 1 << " " << (fr + 1) % n + 1 << "\n";
            }
            else{
                int fr = -1;
                for(int i = 0; i < n; ++i)
                    if(g1[i].size() == 0)fr = i;
                int f2 = -1;
                for(int i = 0; i < n; ++i)
                    if(g2[i].size() == 2)f2 = i;
                if(f2 == fr)cout << "No\n";
                else{
                    cout << "Yes\n1\n";
                    cout << fr + 1 << " " << 3 - fr - f2 + 1 << "\n";
                }
            }
        }
        return;
    }
    shuffle(all(cu), rnd);
    DSU dsu(n);
    for(int i = 0; i < n; ++i)
        for(int v: g1[i])
            dsu.merge(i, v);
    vec<pii> res;
    for(auto &&[u, v]: cu){
        if(dsu.get(u) == dsu.get(v))continue;
        res.eb(u + 1, v + 1);
        dsu.merge(u, v);
    }
    bool ok = true;
    for(int i = 1; i < n; ++i)
        ok &= dsu.get(i) == dsu.get(0);
    if(!ok)cout << "No\n";
    else{
        cout << "Yes\n";
        cout << res.size() << "\n";
        for(auto &i: res)
            cout << i.F << " " << i.S << "\n";
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    //clock_t start = clock();
    int TT = 1;
    cin >> TT >> T;
    while(TT--){
        solve();
    }
//    clock_t end = clock();
//    cout.precision(16);
//    cout << fixed;
//    cout << (ld)(end - start) / CLOCKS_PER_SEC << "\n";
    return 0;
}
