#include <vector>
#include <algorithm>
#include <iostream>
#include <map>

using namespace std;

#define ll long long

void dfs(int i, vector<vector<int>>& g, vector<int>& used, int & cnt) {
	used[i] = 1;
	for (auto j : g[i]) {
		if (!used[j]) {
			dfs(j, g, used, cnt);
		}
	}
	cnt++;
	return;
}

void dfs1(int i, vector<vector<int>>& g, vector<int>& used, int cnt, vector<int>&comp) {
	used[i] = 1;
	comp[i] = cnt;
	for (auto j : g[i]) {
		if (!used[j]) {
			dfs1(j, g, used, cnt, comp);
		}
	}
	return;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t, g;
	cin >> t>>g;
	for (int tt = 0; tt < t; tt++) {
		int n;
		cin >> n;
		int m1, m2;
		cin >> m1 >> m2;
		map<pair<int, int>, int>x;
		map<pair<int, int>, int>y;
		vector<vector<int>>a(n);
		vector<vector<int>>b(n);
		for (int i = 0; i < m1; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			x[{u, v}] = 1;
			a[u].push_back(v);
			a[v].push_back(u);
		}
		for (int i = 0; i < m2; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			b[u].push_back(v);
			b[v].push_back(u);
			y[{u, v}] = 1;
		}
		int cnt = 0;
		vector<int>used(n);
		dfs(0, a, used, cnt);
		if (cnt == n) {
			cout << "Yes" << "\n";
			cout << 0 << "\n";
		}
		else {
			pair<int, int>l;
			int o = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (j != i && (x[{i, j}] == y[{i, j}])) {
						l = { i, j };
						o = 1;
						break;
					}
				}
				if (o) {
					break;
				}
			}
			if (o) {
				int e = l.first;
				int f = l.second;
				vector<pair<int, int>>ans;
				if (!x[{e, f}]) {
					ans.push_back({ e, f });
				}
				for (int i = 0; i < n; i++) {
					if (i != e && i != f) {
						if (!(x[{i, e}] || x[{i, f}])) {
							if (!y[{i, e}]) {
								ans.push_back({ i, e });
							}
							else if (!y[{i, f}]) {
								ans.push_back({ i, f });
							}
							else {
								ans.push_back({ i, e });
							}
						}
					}
				}
				cout << "Yes" << "\n";
				cout << ans.size() << "\n";
				for (int i = 0; i < ans.size(); i++) {
					cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
				}
			}
			else {
				if (n == 3) {
					cout << "No" << "\n";
				}
				else {
					vector<int>comp(n);
					for (int i = 0; i < n; i++) {
						used[i] = 0;
					}
					cnt = 0;
					for (int i = 0; i < n; i++) {
						if (!used[i]) {
							dfs1(i, a, used, cnt, comp);
							cnt++;
						}
					}
					vector<int>sz(n);
					for (int i = 0; i < n; i++) {
						sz[comp[i]]++;
					}
					int r = -1;
					int q = -1;
					for (int i = 0; i < n; i++) {
						if (sz[comp[i]] > 1) {
							r = i;
							q = comp[i];
							break;
						}
					}
					if (r == -1) {
						cout << "Yes" << "\n";
						cout << n - 1 << "\n";
						for (int i = 0; i < n - 1; i++) {
							cout << i + 1 << " " << i + 2 << "\n";
						}
					}
					else {
						if (sz[q] == 2) {
							vector<int>s1;
							for (int i = 0; i < n; i++) {
								if (comp[i] == q) {
									s1.push_back(i);
								}
							}
							vector<pair<int, int>>ans;
							vector<int>sigm(n);
							for (int i = 0; i < n; i++) {
								if (comp[i] != q) {
									sigm[comp[i]] = 1;
									for (int j = 0; j < n; j++) {
										if (!sigm[comp[j]]) {
											ans.push_back({ i, j });
											sigm[comp[j]] = 1;
										}
									}
									break;
								}
							}
							cout << "Yes" << "\n";
							cout << ans.size() << "\n";
							for (int i = 0; i < ans.size(); i++) {
								cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
							}
						}
						else {
							pair<int, int>mem;
							vector<pair<int, int>>ans;
							int cn = 0;
							for (int i = 0; i < n; i++) {
								for (int j = 0; j < n; j++) {
									if (i != j && comp[i] == comp[j] && comp[i] == q) {
										if (!x[{i, j}]) {
											mem = { i, j };
											cn = 1;
											break;
										}
										else {
											mem = { i, j };
										}
									}
								}
								if (cn) {
									break;
								}
							}
							ans.push_back(mem);
							for (int i = 0; i < n; i++) {
								if (comp[i] != q) {
									ans.push_back({ i, mem.first });
								}
							}
							cout << "Yes" << "\n";
							cout << ans.size() << "\n";
							for (int i = 0; i < ans.size(); i++) {
								cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
							}
						}
					}

				}
			}
		}
	}
}