#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct DSU {
    vi p, r;
    int n;

    DSU(int _n) {
        n = _n;
        p.resize(n + 1);
        r.resize(n + 1);
        iota(p.begin(), p.end(), 0);
    }

    int leader(int x) {
        return (p[x] == x ? x : p[x] = leader(p[x]));
    }

    void unite(int x, int y) {
        x = leader(x), y = leader(y);
        if (x == y) return;
        p[y] = x;
    }
};

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    DSU s(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        s.unite(u, v);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
    }
    if (m1 == 0 and n == 3) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    vector<dui> ans;
    for (int i = 2; i <= n; i++) {
        if (s.leader(i - 1) != s.leader(i)) {
            ans.emplace_back(i - 1, i);
            s.unite(i - 1, i);
        }
    }
    cout << ans.size() << '\n';
    for (auto [i, j]: ans) cout << i << ' ' << j << '\n';
}

int dfs(int v, vi &used, vector<vi> &g) {
    if (used[v]) return 0;
    used[v] = 1;
    int cnt = 1;
    for (auto u: g[v]) {
        cnt += dfs(u, used, g);
    }
    return cnt;
}

bool check(vector<vi> &g) {
    int n = g.size() - 1;
    vi used(n + 1);
    return n == dfs(1, used, g);
}

void solve3() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    DSU s(n);
    vector<vi> r(n + 1);
    vector<vi> g(n + 1, vi(n + 1));
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        s.unite(u, v);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        g[u][v] = g[v][u] = 1;
        r[u].push_back(v);
        r[v].push_back(u);
    }
    vector<vi> comps(n + 1);
    for (int i = 1; i <= n; i++) {
        int c = s.leader(i);
        comps[c].push_back(i);
    }
    vector<dui> ans;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            bool ok = 0;
            if (i == j) continue;
            for (int v: comps[i]) {
                for (int u: comps[j]) {
                    if (g[v][u] == 1) {
                        r[v].erase(find(r[v].begin(), r[v].end(), u));
                        r[u].erase(find(r[u].begin(), r[u].end(), v));
                    }
                    if (check(r)) {
                        ans.emplace_back(u, v);
                        g[v][u] = g[u][v] = 0;
                        s.unite(u, v);
                        ok = 1;
                        break;
                    }
                    if (g[v][u] == 1) {
                        r[v].push_back(u);
                        r[u].push_back(v);
                    }
                }
                if (ok) break;
            }
        }
    }
    bool ok = 1;
    for (int v = 1; v < n; v++) {
        ok &= s.leader(v) == s.leader(v + 1);
    }
    if (ok) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [i, j]: ans) cout << i << ' ' << j << '\n';
        cout << '\n';
    } else {
        cout << "No\n";
    }
}

void solve(int g) {
    if (g == 2) {
        solve2();
    } else {
        solve3();
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    cin >> T;
    int g;
    cin >> g;
    while (T--) {
        solve(g);
    }
    return 0;
}
