#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ld long double
#define F first
#define S second
#define all(a) a.begin(), a.end();
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

int const maxn = 5e5;
ld const eps = 1e-12;
int const LOG = 20;
int const N = 2e3;

vector<int> g[maxn];
int p[maxn];
int sz[maxn];

void build(int n) {
    for (int i = 0; i < n; i++) {
        p[i] = i;
        sz[i] = 1;
    }
}

int leader(int v) {
    return p[v] == v ? v : p[v] = leader(p[v]);
}

void unite(int u, int v) {
    u = leader(u), v = leader(v);
    if (u == v) return;
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    sz[u] += sz[v];
    p[v] = u;
}

inline void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    set<pair<int, int>> w, tw;
    vector<pair<int, int>> ed;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        ed.pb({u, v});
    }
    build(n);
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        int u1 = leader(u), v1 = leader(v);
        w.insert({u, v});
        if (u1 == v1) continue;
        unite(u1, v1);
        g[v].pb(u);
        g[u].pb(v);
        tw.insert({u, v});
    }
    for (int i = 0; i < n; i++) {
        if (sz[i] == 1) {
            for (int j = 0; j < n; j++) {
                if (i == j) continue;
                if (!tw.count({i, j}) && !tw.count({j, i})) {
                    w.erase({i, j});
                    w.erase({j, i});
                    tw.erase({i, j});
                    tw.erase({j, i});
                    unite(i, j);
                    break;
                }
            }
        }
    }
    build(n);
    for (auto [x, y]: ed) {
        x = leader(x), y = leader(y);
        if (x != y) unite(x, y);
    }
    int V;
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == 1) {
            V = i;
            for (int j = 0; j < n; j++) {
                if (j != g[i][0] && j != i) {
                    int x = leader(j), y = leader(i);
                    if (x != y) {
                        unite(x, y);
                        ans.pb({i, j});
                    }
                }
            }
            break;
        }
    }
/*    for (int i = 0; i < n; i++) {
        for (int x: g[i]) {
            cout << x << ' ';
        }
        cout << '\n';
    }*/
    for (int i = 0; i < n; i++) {
        if (leader(i) != leader(0)) {
            pair<int, int> edge = {-1, -1};

            for (int j = 0; j < n; j++) {
                if (g[j].size() == 1 && j != V) {
                    for (int k = 0; k < n; k++) {
                        if (g[k].size() == 1 && k != V && k != j) {
                            edge = {j, k};
                            break;
                        }
                    }
                    if (edge.F != -1) break;
                }
            }
            auto [j, k] = edge;
            if (j == -1) {
                cout << "No\n";
                return;
            }
            if (!w.count({j, k}) && !w.count({k, j})) {
                ans.pb({edge});
            }
            if (leader(g[V][0]) != leader(j)) {
                ans.pb({g[V][0], j});
            }
        }
    }

    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto [x, y]: ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1, gr;
    cin >> tt >> gr;
    while (tt--) {
        solve();
    }
    return 0;
}
