#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;

struct dsu {
    vector<int> p, sz;
    dsu(int n) {
        p.assign(n, 0);
        sz.assign(n, 1);
        iota(p.begin(), p.end(), 0);
    }
    int get(int x) {
        if (p[x] != x) {
            p[x] = get(p[x]);
        }
        return p[x];
    }
    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) {
            return false;
        } else if (sz[u] > sz[v]) {
            swap(u, v);
        }
        sz[v] += sz[u];
        p[u] = v;
        return true;
    }
    bool same(int u, int v) {
        u = get(u), v = get(v);
        return u == v;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    dsu B(n + 1), C(n + 1);
    vector<int> dc(n + 1, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        B.unite(u, v);
    }
    set<pair<int, int>> cs;
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        cs.insert({u, v});
        cs.insert({v, u});
        ++dc[u], ++dc[v];
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 1);
    vector<pair<int, int>> edges;
    sort(ord.begin(), ord.end(), [&] (int i, int j) {
        return dc[i] > dc[j];
    });
    vector<pair<int, int>> ans;
    for (int i = 0; i < ord.size(); ++i) {
        for (int j = i + 1; j < ord.size(); ++j) {
            int u = ord[i], v = ord[j];
            if (cs.find({u, v}) == cs.end()) edges.pb({u, v});
        }
    }

    for (int i = 0; i < ord.size(); ++i) {
        for (int j = i + 1; j < ord.size(); ++j) {
            int u = ord[i], v = ord[j];
            if (cs.find({u, v}) == cs.end()) edges.pb({u, v});
        }
    }

    for (auto [u, v] : edges) {
        if (B.unite(u, v)) {
            ans.pb({u, v});
        }
    }
    if (B.sz[B.get(1)] != n) {
        cout << "No\n";
        return ;
    }
    cout << "Yes\n";
    assert((int)ans.size() <= n);
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
