#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;

struct dsu {
    vector<int> p, sz;
    vector<vector<int>> c;
    dsu(int n) {
        p.assign(n, 0);
        sz.assign(n, 1);
        c.assign(n, {});
        for (int i = 0; i < n; ++i) {
            c[i] = {i};
            p[i] = i;
        }
    }
    int get(int x) {
        if (p[x] != x) {
            p[x] = get(p[x]);
        }
        return p[x];
    }
    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) {
            return false;
        } else if (sz[u] > sz[v]) {
            swap(u, v);
        }
        sz[v] += sz[u];
        p[u] = v;
        for (int el : c[u]) {
            c[v].pb(el);
        }
        return true;
    }
    bool same(int u, int v) {
        u = get(u), v = get(v);
        return u == v;
    }
};

void solve() {

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T, g;
    cin >> T >> g;
    while (T--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        dsu B(n + 1), C(n + 1);
        unordered_set<int> t[n + 1];
        vector<int> dc(n + 1, 0);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            t[v].insert(u);
            t[u].insert(v);
        }
        vector<bool> used(n + 1, 0);
        int CMPS = 0;
        auto ok = [&] (int v) -> void {
            used[v] = 1;
            queue<int> q;
            while (!q.empty()) {
                ++CMPS;
                for (auto x : t[v]) {
                    if (!used[x]) q.push(x);
                }
            }
        };
        vector<pair<int, int>> ans;
        vector<vector<int>> cmps;
        vector<bool> vis(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            int v = B.get(i);
            if (vis[v]) continue;
            vis[v] = 1;
            auto arr = B.c[v];
            for (auto U : arr) {
                for (auto narr : cmps) {
                    if (B.same(narr[0], U)) continue;
                    for (auto V : narr) {
                        if (t[V].find(U) == t[V].end()) {
                            B.unite(U, V);
                            ans.pb({U, V});
                        }
                    }
                }
            }
            for (auto U : arr) {
                for (auto narr : cmps) {
                    if (B.same(narr[0], U)) continue;
                    for (auto V : narr) {
                        if (t[V].find(U) != t[V].end()) {
                            used.assign(n + 1, 0);
                            CMPS = 0;
                            t[V].erase(U);
                            t[U].erase(V);
                            ok(V);
                            if (CMPS == n) {
                                B.unite(U, V);
                                ans.pb({U, V});
                            } else {
                                t[V].insert(U);
                                t[U].insert(V);
                            }
                        }
                    }
                }
            }
            cmps.pb(arr);
        }
        if (B.sz[B.get(1)] != n) {
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
        assert((int)ans.size() <= n);
        cout << ans.size() << '\n';
        for (auto [x, y] : ans) {
            cout << x << ' ' << y << '\n';
        }
    }
}
