#pragma gcc optimize("O3, unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

struct dsu {
    vector <int> p, sz;

    void init (int n) {
        p.resize(n); iota(all(p), 0);
        sz.assign(n, 1);
    }

    inline int leader (int a) {
        return (p[a] == a ? a : p[a] = leader(p[a]));
    }

    void merge (int a, int b) {
        a = leader(a); b = leader(b);
        if (a == b) return;
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        sz[a] += sz[b];
        sz[b] = 0;
    }
};

int group;

vector <int> save;
void dfs (int k, vector <int>&used, vector<set<int>> &g) {
    used[k] = true;
    save.push_back(k);
    for (auto i : g[k]) {
        if (!used[i]) {
            dfs(i, used, g);
        }
    }
}

bool cmp (vector <int> &a, vector <int> &b) {
    return a.size() < b.size();
}

set <pii> bridges;
void dfs1 (int k, int par, vector<set<int>> &g, vector <int> &level, vector <int> &dp, vector <int>&used) {
    // debug(k);
    used[k] = 1;
    dp[k] = level[k];
    for (auto i : g[k]) {
        if (i == par) continue;
        if (!used[i]) {
            level[i] = level[k] + 1;
            dfs1(i, k, g, level, dp, used);
            dp[k] = min(dp[k], dp[i]);
            if (dp[i] > level[k]) {
                bridges.insert(minmax(k, i));
            }
        }
        else if (used[k] == 1) {
            dp[k] = min(dp[k], level[i]);
        }
    }
    used[k] = 2;
}

void greedy() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector<set<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g1[a].insert(b); g1[b].insert(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g2[a].insert(b); g2[b].insert(a);
    }
    vector <pii> ans;
    vector<vector<int>> c;
    vector <int> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            save.clear();
            dfs(i, used, g1);
            c.push_back(save);
            // vout(save);
        }
    }
    for (int _ = 0; _ < n; ++_) {
        bool found = false;
        vector <int> level(n, 0), dp(n, 0);
        used.assign(n, false);
        bridges.clear(); dfs1(0, -1, g2, level, dp, used);
        // cout << bridges.size() << endl;
        sort(rall(c), cmp);
        while (c.back().empty()) c.pop_back();
        // reverse(all(c));
        if (c.size() == 1) break;
        for (int i = 0; i < c.size(); ++i) {
            for (int j = i + 1; j < c.size(); ++j) {
                for (auto x : c[i]) {
                    for (auto y : c[j]) {
                        if (bridges.empty() || bridges.find(minmax(x, y)) == bridges.end()) {
                            found = true;
                            ans.push_back({x, y});
                            for (auto t : c[i]) c[j].push_back(t);
                            c[i].clear();
                            // vout(g2[x]); vout(g2[y]);
                            g1[x].insert(y); g1[y].insert(x);

                            if (g2[x].empty() || g2[x].find(y) == g2[x].end()) g2[x].insert(y);
                            else g2[x].erase(y);

                            if (g2[y].empty() || g2[y].find(x) == g2[y].end()) g2[y].insert(x);
                            else g2[y].erase(x);
                            break;
                        }
                    }
                    if (found) break;
                }
                if (found) break;
            }
            if (found) break;
        }
        if (!found) {
            sort(all(c), cmp);
            if (c.size() != 2 || c[0].size() != 1) exit(1);
            if (n == 3) {
                cout << "No" << '\n';
                return;
            }
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (i == c[0][0] || j == c[0][0]) continue;
                    if (g1[i].empty() || g1[i].find(j) == g1[i].end()) {
                        ans.push_back({i, j});
                        ans.push_back({c[0][0], j});
                        found = true;
                        break;
                    }
                }
                if (found) break;
            }
            if (!found) {
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (i == c[0][0] || j == c[0][0] || n == 3) continue;
                        ans.push_back({i, j});
                        ans.push_back({c[0][0], j});
                        found = true;
                        break;
                    }
                    if (found) break;
                }
            }
            if (!found) {
                exit(1);
            }
            cout << "Yes" << '\n';
            cout << ans.size() << '\n';
            for (auto i : ans) {
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            return;
        }
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

mt19937 rng(28);
void greedy1() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector<set<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g1[a].insert(b); g1[b].insert(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g2[a].insert(b); g2[b].insert(a);
    }
    vector <pii> ans;
    vector<vector<int>> c;
    vector <int> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            save.clear();
            dfs(i, used, g1);
            c.push_back(save);
            // vout(save);
        }
    }
    for (int _ = 0; _ < n; ++_) {
        bool found = false;
        vector <int> level(n, 0), dp(n, 0);
        used.assign(n, false);
        bridges.clear(); dfs1(0, -1, g2, level, dp, used);
        // cout << bridges.size() << endl;
        sort(rall(c), cmp);
        while (c.back().empty()) c.pop_back();
        // reverse(all(c));
        shuffle(all(c), rng);
        if (c.size() == 1) break;
        for (int i = 0; i < c.size(); ++i) {
            for (int j = i + 1; j < c.size(); ++j) {
                for (auto x : c[i]) {
                    for (auto y : c[j]) {
                        if (bridges.empty() || bridges.find(minmax(x, y)) == bridges.end()) {
                            found = true;
                            ans.push_back({x, y});
                            for (auto t : c[i]) c[j].push_back(t);
                            c[i].clear();
                            // vout(g2[x]); vout(g2[y]);
                            g1[x].insert(y); g1[y].insert(x);

                            if (g2[x].empty() || g2[x].find(y) == g2[x].end()) g2[x].insert(y);
                            else g2[x].erase(y);

                            if (g2[y].empty() || g2[y].find(x) == g2[y].end()) g2[y].insert(x);
                            else g2[y].erase(x);
                            break;
                        }
                    }
                    if (found) break;
                }
                if (found) break;
            }
            if (found) break;
        }
        if (!found) {
            sort(all(c), cmp);
            if (c.size() != 2 || c[0].size() != 1) exit(1);
            if (n == 3) {
                cout << "No" << '\n';
                return;
            }
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (i == c[0][0] || j == c[0][0]) continue;
                    if (g1[i].empty() || g1[i].find(j) == g1[i].end()) {
                        ans.push_back({i, j});
                        ans.push_back({c[0][0], j});
                        found = true;
                        break;
                    }
                }
                if (found) break;
            }
            if (!found) {
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (i == c[0][0] || j == c[0][0] || n == 3) continue;
                        ans.push_back({i, j});
                        ans.push_back({c[0][0], j});
                        found = true;
                        break;
                    }
                    if (found) break;
                }
            }
            if (!found) {
                exit(1);
            }
            cout << "Yes" << '\n';
            cout << ans.size() << '\n';
            for (auto i : ans) {
                cout << i.first + 1 << ' ' << i.second + 1 << '\n';
            }
            return;
        }
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

bool cmp1 (pii i, pii j) {
    return i.second - i.first < j.second - j.first || (i.second - i.first == j.second - j.first && i.first < j.first);
}

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector<set<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g1[a].insert(b); g1[b].insert(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        g2[a].insert(b); g2[b].insert(a);
    }
    if (n <= 100) {
        vector <pii> ans;
        vector<vector<int>> c;
        vector <int> used(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                save.clear();
                dfs(i, used, g1);
                c.push_back(save);
                // vout(save);
            }
        }
        for (int _ = 0; _ < n; ++_) {
            bool found = false;
            vector <int> level(n, 0), dp(n, 0);
            used.assign(n, false);
            bridges.clear(); dfs1(0, -1, g2, level, dp, used);
            // cout << bridges.size() << endl;
            sort(rall(c), cmp);
            while (c.back().empty()) c.pop_back();
            // reverse(all(c));
            shuffle(all(c), rng);
            if (c.size() == 1) break;
            for (int i = 0; i < c.size(); ++i) {
                for (int j = i + 1; j < c.size(); ++j) {
                    for (auto x : c[i]) {
                        for (auto y : c[j]) {
                            if (bridges.empty() || bridges.find(minmax(x, y)) == bridges.end()) {
                                found = true;
                                ans.push_back({x, y});
                                for (auto t : c[i]) c[j].push_back(t);
                                c[i].clear();
                                // vout(g2[x]); vout(g2[y]);
                                g1[x].insert(y); g1[y].insert(x);

                                if (g2[x].empty() || g2[x].find(y) == g2[x].end()) g2[x].insert(y);
                                else g2[x].erase(y);

                                if (g2[y].empty() || g2[y].find(x) == g2[y].end()) g2[y].insert(x);
                                else g2[y].erase(x);
                                break;
                            }
                        }
                        if (found) break;
                    }
                    if (found) break;
                }
                if (found) break;
            }
            if (!found) {
                sort(all(c), cmp);
                if (c.size() != 2 || c[0].size() != 1) exit(1);
                if (n == 3) {
                    cout << "No" << '\n';
                    return;
                }
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (i == c[0][0] || j == c[0][0]) continue;
                        if (g1[i].empty() || g1[i].find(j) == g1[i].end()) {
                            ans.push_back({i, j});
                            ans.push_back({c[0][0], j});
                            found = true;
                            break;
                        }
                    }
                    if (found) break;
                }
                if (!found) {
                    for (int i = 0; i < n; ++i) {
                        for (int j = i + 1; j < n; ++j) {
                            if (i == c[0][0] || j == c[0][0] || n == 3) continue;
                            ans.push_back({i, j});
                            ans.push_back({c[0][0], j});
                            found = true;
                            break;
                        }
                        if (found) break;
                    }
                }
                if (!found) {
                    exit(1);
                }
                cout << "Yes" << '\n';
                cout << ans.size() << '\n';
                for (auto i : ans) {
                    cout << i.first + 1 << ' ' << i.second + 1 << '\n';
                }
                return;
            }
        }
        cout << "Yes" << '\n';
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }
    vector<vector<int>> c;
    vector <int> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            save.clear();
            dfs(i, used, g1);
            c.push_back(save);
            // vout(save);
        }
    }
    set<pii, decltype(&cmp1)> v(&cmp1);
    for (auto i : c) {
        v.insert({*min_element(all(i)), *max_element(all(i))});
    }
    vector <pii> ans;
    while (v.size() > 1) {
        auto p1 = *(--(--v.end())), p2 = *(--v.end());
        v.erase(v.begin()); v.erase(--v.end());
        v.insert({p1.first, p2.second});
        if (abs(p1.first - p2.first) != 1) {
            ans.pb({p1.first, p2.first});
        }
        else if (abs(p1.first - p2.second) != 1) {
            ans.pb({p1.first, p2.second});
        }
        else if (abs(p1.second - p2.first) != 1) {
            ans.pb({p1.second, p2.first});
        }
        else if (abs(p1.second - p2.second) != 1) {
            ans.pb({p1.second, p2.second});
        }
        else {
            exit(1);
            cout << "No" << endl;
            return;
        } 
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt >> group;
    while (tt--) {
        if (group == 6 || group == 8 || group == 10) {
            greedy1();
        }
        else if (group == 9) {
            solve();
        }
        else greedy();
    }
}