#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct dsu {

    dsu(int n) : n(n) {
        p.resize(n);
        iota(all(p), 0);
    }

    int get(int i) {
        if (p[i] != i) p[i] = get(p[i]);
        return p[i];
    }

    void merge(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) return;
        p[b] = a;
    }

    int n;
    vector<int> p;

};

int n, m1, m2;
vector<vector<int>> g1, g2, gost;
vector<int> d;

void dfs1(int v) {
    for (int to : g2[v]) {
        if (d[to] == -1) {
            gost[v].push_back(to);
            gost[to].push_back(v);
            d[to] = d[v] + 1;
            dfs1(to);
        }
    }
}

void dfs2(int v) {
    for (int to : gost[v]) {
        if (d[to] == -1) {
            d[to] = d[v] + 1;
            dfs2(to);
        }
    }
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vector<int>());
    g2.assign(n, vector<int>());
    set<pair<int, int>> s;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        if (a > b) swap(a, b);
        s.emplace(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }

    vector<pair<int, int>> ans;
    auto add = [&](int a, int b) {
        if (a > b) swap(a, b);
        if (s.find(make_pair(a, b)) != s.end()) return false;
        ans.emplace_back(a, b);
        return true;
    };

    auto print = [&]() {
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [a, b] : ans) {
            cout << a + 1 << " " << b + 1 << "\n";
        }

//        ans.clear();

        assert(ans.size() <= n);

        set<pair<int, int>> e1, e2;
        for (int i = 0; i < n; i++) {
            for (int to : g1[i]) {
                int a = i, b = to;
                if (a > b) swap(a, b);
                e1.emplace(a, b);
            }
            for (int to : g2[i]) {
                int a = i, b = to;
                if (a > b) swap(a, b);
                e2.emplace(a, b);
            }
        }

        for (auto [a, b] : ans) {
            if (a > b) swap(a, b);
            if (e1.find(make_pair(a, b)) == e1.end()) e1.emplace(a, b);
            else e1.erase(e1.find(make_pair(a, b)));
            if (e2.find(make_pair(a, b)) == e2.end()) e2.emplace(a, b);
            else e2.erase(e2.find(make_pair(a, b)));
        }

        dsu d1(n), d2(n);
        for (auto [a, b] : e1) {
            d1.merge(a, b);
        }
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (d1.p[i] == i) cnt++;
        }
        assert(cnt == 1);

        for (auto [a, b] : e2) {
            d2.merge(a, b);
        }
        cnt = 0;
        for (int i = 0; i < n; i++) {
            if (d2.p[i] == i) cnt++;
        }
        assert(cnt == 1);
        assert(false);
    };

    if (n == 3) {
        int mask1 = 0, mask2 = 0;
        for (int i = 0; i < n; i++) {
            for (int to : g1[i]) {
                int ix, a = i, b = to;
                if (a > b) swap(a ,b);
                if (a == 0 && b == 1) ix = 0;
                if (a == 0 && b == 2) ix = 1;
                if (a == 1 && b == 2) ix = 2;
                mask1 |= (1 << ix);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int to : g2[i]) {
                int ix, a = i, b = to;
                if (a > b) swap(a ,b);
                if (a == 0 && b == 1) ix = 0;
                if (a == 0 && b == 2) ix = 1;
                if (a == 1 && b == 2) ix = 2;
                mask2 |= (1 << ix);
            }
        }
        for (int mask = 0; mask < (1 << 3); mask++) {
            int a = mask1 ^ mask, b = mask2 ^ mask;
            int ca = 0, cb = 0;
            for (int i = 0; i < n; i++) {
                if ((a >> i) & 1) ca++;
            }
            for (int i = 0; i < n; i++) {
                if ((b >> i) & 1) cb++;
            }
            if (ca >= 2 && cb >= 2) {
                for (int i = 0; i < n; i++) {
                    if ((mask >> i) & 1) {
                        if (i == 0) ans.emplace_back(0, 1);
                        if (i == 1) ans.emplace_back(0, 2);
                        if (i == 2) ans.emplace_back(1, 2);
                    }
                }
                print();
                return;
            }
        }
        cout << "No\n";
    } else {
        int pos = -1, cnt = 0;
        for (int i = 0; i < n; i++) {
            if (g2[i].size() == n - 1) {
                pos = i;
                cnt++;
            }
        }

        if (pos != -1 && m2 == n - 1) {
//            cout << "here\n";
            vector<int> t;
            for (int i = 0; i < n; i++) {
                if (i == pos) continue;
                t.push_back(i);
            }
            int good = -1;
            for (int i = 0; i < t.size(); i++) {
                if (add(t[i], t[(i + 1) % t.size()])) good = i;
            }
            if (good != -1) {
                add(pos, t[good]);
            } else {
                ans.emplace_back(t[0], t[1]);
                add(pos, t[0]);
            }
        } else {
            int root, good_v;
            if (pos == -1) {
                d.assign(n, -1);
                gost.assign(n, vector<int>());
                d[0] = 0;
                dfs1(0);
                good_v = -1;
                for (int i = 0; i < n; i++) {
                    if (d[i] >= 3) good_v = i;
                }
                root = 0;

                if (good_v == -1) {
                    int mx = 0;
                    for (int i = 0; i < n; i++) {
                        if (d[i] > d[mx]) mx = i;
                    }
//                cout << "mx = " << mx << "\n";
                    d.assign(n, -1);
                    d[mx] = 0;
                    dfs2(mx);
                    for (int i = 0; i < n; i++) {
                        if (d[i] >= 3) good_v = i;
                    }
                    root = mx;
                }
            } else {
                if (cnt == n) {
//                    cout << "here\n";
                    d.assign(n, -1);
                    iota(all(d), 0);
                    root = 0, good_v = n - 1;
                } else {
                    for (int i = 0; i < n; i++) {
                        if (g2[i].size() != n - 1) root = i;
                    }
                    d.assign(n, -1);
                    gost.assign(n, vector<int>());
                    d[root] = 0;
                    dfs1(root);
                    good_v = -1;
                    for (int i = 0; i < n; i++) {
                        if (d[i] >= 3) good_v = i;
                    }

                    if (good_v == -1) {
                        int mx = 0;
                        for (int i = 0; i < n; i++) {
                            if (d[i] > d[mx]) mx = i;
                        }
//                cout << "mx = " << mx << "\n";
                        d.assign(n, -1);
                        d[mx] = 0;
                        dfs2(mx);
                        for (int i = 0; i < n; i++) {
                            if (d[i] >= 3) good_v = i;
                        }
                        root = mx;
                    }
                }
            }

//            cout << good_v << "\n";
//            for (int x : d) cout << x << " ";
//            cout << "\n";
//            for (int i = 0; i < n; i++) {
//                cout << i << ": ";
//                for (int x : gost[i]) cout << x << " ";
//                cout << "\n";
//            }

            for (int i = 0; i < n; i++) {
                if (d[i] == 0) continue;
                if (d[i] >= 2) add(i, root);
                else add(i, good_v);
            }
        }

        print();
    }
}

//20 0
//4 1 3
//1 2
//1 2
//1 3
//1 4
//4 3 3
//1 3
//1 4
//2 4
//1 2
//1 3
//1 4
//4 0 3
//1 2
//1 3
//1 4
//3 2 2
//1 3
//2 3
//1 2
//1 3
//4 3 3
//3 4
//2 4
//1 2
//1 2
//1 3
//1 4
//4 3 3
//2 4
//2 3
//3 4
//1 2
//1 3
//1 4
//5 1 4
//2 4
//1 2
//1 3
//1 4
//1 5
//3 1 2
//1 3
//1 2
//1 3
//5 9 4
//4 5
//1 4
//3 4
//1 5
//1 2
//2 5
//2 3
//3 5
//2 4
//1 2
//1 3
//1 4
//1 5
//5 6 4
//2 5
//1 5
//1 4
//2 4
//4 5
//3 5
//1 2
//1 3
//1 4
//1 5
//5 7 4
//1 5
//3 4
//3 5
//2 4
//2 5
//1 3
//1 4
//1 2
//1 3
//1 4
//1 5
//3 2 2
//1 2
//2 3
//1 2
//1 3
//5 8 4
//3 4
//2 5
//1 2
//3 5
//1 4
//2 3
//4 5
//1 5
//1 2
//1 3
//1 4
//1 5
//3 0 2
//1 2
//1 3
//4 2 3
//1 3
//3 4
//1 2
//1 3
//1 4
//3 0 2
//1 2
//1 3
//3 0 2
//1 2
//1 3
//3 3 2
//1 3
//1 2
//2 3
//1 2
//1 3
//5 7 4
//1 2
//3 5
//4 5
//2 5
//1 3
//2 3
//1 4
//1 2
//1 3
//1 4
//1 5
//5 5 4
//2 4
//3 4
//2 3
//3 5
//2 5
//1 2
//1 3
//1 4
//1 5


//1 0
//5 5 4
//1 2
//2 3
//3 4
//4 5
//5 1
//1 2
//1 3
//1 4
//1 5

//1 0
//4 3 6
//1 2
//1 4
//2 4
//1 2
//1 3
//1 4
//2 3
//2 4
//3 4

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1, G;
    cin >> t >> G;
    while (t--) solve();
}