#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

struct Edge {
    ll u, v;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t, g;
    cin >> t >> g;

    while (t--) {
        ll n, m1, m2;
        cin >> n >> m1 >> m2;

        vector<Edge> g1(m1), g2(m2);

        set<pll> q1;

        for (ll i = 0; i < m1; i++) {
            cin >> g1[i].u >> g1[i].v;
            g1[i].u--;
            g1[i].v--;

            if (g1[i].u > g1[i].v) swap(g1[i].u, g1[i].v);

            q1.insert({g1[i].u, g1[i].v});
        }

        for (ll i = 0; i < m2; i++) cin >> g2[i].u >> g2[i].v;

        if (g == 5) {
            vpll ans;
            for (ll i = 0; i < n - 1; i++) {
                if (!q1.count({i, i + 1}))
                    ans.push_back({i, i + 1});
            }

            cout << "Yes\n" << ans.size() << "\n";
            for (auto [u, v] : ans) cout << u + 1 << " " << v + 1 << "\n";
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
