#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

vector<vector<bool>> g1m, g2m;
vector<vector<ll>> g1, g2;

vector<ll> comp1;
ll compCount2 = 0;
vector<bool> used1, used2;
void dfs1(ll v, ll c) {
    used1[v] = true;
    comp1[v] = c;

    for (ll to : g1[v]) {
        if (used1[to]) continue;
        dfs1(to, c);
    }
}

void dfs2(ll v, ll c) {
    used2[v] = true;

    for (ll to : g2[v]) {
        if (used2[to]) continue;
        dfs2(to, c);
    }
}

struct Edge {
    ll u, v;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t, g;
    cin >> t >> g;

    while (t--) {
        ll n, m1, m2;
        cin >> n >> m1 >> m2;

        if (n <= 6) {
            vector<Edge> g1(m1), g2(m2);

            set<pll> q1;

            for (ll i = 0; i < m1; i++) {
                cin >> g1[i].u >> g1[i].v;
                g1[i].u--;
                g1[i].v--;

                if (g1[i].u > g1[i].v) swap(g1[i].u, g1[i].v);

                q1.insert({g1[i].u, g1[i].v});
            }

            for (ll i = 0; i < m2; i++) {
                cin >> g2[i].u >> g2[i].v;
                g2[i].u--, g2[i].v--;
            }
            
            vpll edges;
            for (ll i = 0; i < n; i++) {
                for (ll j = i + 1; j < n; j++) {
                    edges.push_back({i, j});
                }
            }

            bool was = false;

            for (ll mask = 0; mask < (1 << edges.size()); mask++) {
                if (mask == 1 << 4)
                    cout << "";
                vector<vector<bool>> d1(n, vector<bool>(n, 0));
                vector<vector<bool>> d2(n, vector<bool>(n, 0));

                for (auto e : g1) d1[e.u][e.v] = d1[e.v][e.u] = true;
                for (auto e : g2) d2[e.u][e.v] = d2[e.v][e.u] = true;

                deque<pll> ord;

                for (ll i = 0; i < edges.size(); i++) {
                    if ((mask >> i & 1) == 0) continue;
                    ll u = edges[i].first, v = edges[i].second;
                    if (d2[u][v])
                        ord.push_back({u, v});
                    else
                        ord.push_front({u, v});

                    d1[u][v] = !d1[u][v];
                    d1[v][u] = !d1[v][u];
                    d2[u][v] = !d2[u][v];
                    d2[v][u] = !d2[v][u];
                }

                for (ll k = 0; k < n; k++) {
                    for (ll i = 0; i < n; i++) {
                        for (ll j = 0; j < n; j++) {
                            d1[i][j] = d1[i][j] || d1[i][k] && d1[k][j];
                            d2[i][j] = d2[i][j] || d2[i][k] && d2[k][j];

                        }
                    }
                }

                bool ok = true;
                for (ll i = 0; i < n; i++) {
                    for (ll j = 0; j < n; j++) {
                        ok &= d1[i][j] && d2[i][j];
                    }
                }

                if (ok) {
                    cout << "Yes\n" << ord.size() << "\n";
                    for (auto [u, v] : ord) cout << u + 1 << " " << v + 1 << "\n";
                    was = true;
                    break;
                }
            }

            if (!was) cout << "No\n";
            continue;
        }

        g1.assign(n, {});
        g2.assign(n, {});

        g1m.assign(n, vector<bool>(n, false));
        g2m.assign(n, vector<bool>(n, false));

        for (ll i = 0; i < m1; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;

            g1[u].push_back(v);
            g1[v].push_back(u);

            g1m[u][v] = g1m[v][u] = true;
        }

        for (ll i = 0; i < m2; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;

            g2[u].push_back(v);
            g2[v].push_back(u);

            g2m[u][v] = g2m[v][u] = true;
        }

        used1.assign(n, false);
        comp1.assign(n, -1);

        for (ll i = 0; i < n; i++) if (!used1[i]) dfs1(i, i);

        vpll ops;

        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (comp1[i] != comp1[j] && !g2m[i][j]) {
                    g1m[i][j] = g1m[j][i] = true;
                    g2m[i][j] = g2m[j][i] = true;
                    g1[i].push_back(j);
                    g1[j].push_back(i);
                    g2[i].push_back(j);
                    g2[j].push_back(i);

                    used1.assign(n, false);
                    comp1.assign(n, -1);

                    for (ll v = 0; v < n; v++) if (!used1[v]) dfs1(v, v);

                    ops.push_back({i, j});
                }
            }
        }


        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (!g1m[i][j] && g2m[i][j] && comp1[i] != comp1[j]) {
                    g2[i].erase(std::find(g2[i].begin(), g2[i].end(), j));
                    g2[j].erase(std::find(g2[j].begin(), g2[j].end(), i));

                    g2m[i][j] = g2m[j][i] = false;

                    compCount2 = 0;
                    used2.assign(n, false);
                    for (ll v = 0; v < n; v++) {
                        if (used2[v]) continue;
                        compCount2++;
                        dfs2(v, v);
                    }

                    if (compCount2 > 1) {
                        g2[i].push_back(j);
                        g2[j].push_back(i);
                        g2m[i][j] = g2m[j][i] = true;
                    } else {
                        g1[i].push_back(j);
                        g1[j].push_back(i);
                        g1m[i][j] = g2m[j][i] = true;

                        ops.push_back({i, j});
                    }
                }
            }
        }

        used1.assign(n, false);
        comp1.assign(n, -1);
        ll cc = 0;
        for (ll i = 0; i < n; i++) {
            if (used1[i]) continue;
            cc++;
            dfs1(i, i);
        }

        if (cc > 1) {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
        cout << ops.size() << "\n";
        for (auto [u, v] : ops) cout << u + 1 << " " << v + 1 << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
