#include <bits/stdc++.h>
using namespace std;

struct dsu {
  int comps;
  vector<int> parent, rank;

  dsu(int n) : parent(n), rank(n, 1), comps(n) {
    iota(parent.begin(), parent.end(), 0);
  }

  int get(int u) {
    return parent[u] == u ? u : (parent[u] = get(parent[u]));
  }

  void unite(int u, int v) {
    u = get(u), v = get(v);
    if (u != v) {
      if (rank[u] < rank[v]) {
        swap(u, v);
      }
      rank[u] += rank[v];
      parent[v] = u;
      comps--;
    }
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t, g;
  cin >> t >> g;
  while (t--) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> msk(n, vector<int>(n));
    for (int i = 0; i < m1; i++) {
      int u, v;
      cin >> u >> v;
      u--, v--;
      msk[u][v] |= 1;
    }
    for (int i = 0; i < m2; i++) {
      int u, v;
      cin >> u >> v;
      u--, v--;
      msk[u][v] |= 2;
    }
    dsu sets_a(n), sets_b(n);
    vector<pair<int, int>> answer;
    for (int i = 0; i < n; i++) {
      for (int j = i + 1; j < n; j++) {
        if (msk[i][j] == 0 && sets_a.get(i) != sets_a.get(j)) {
          answer.push_back({i, j});
          sets_a.unite(i, j);
          sets_b.unite(i, j);
        }
        if (msk[i][j] == 3) {
          sets_a.unite(i, j);
          sets_b.unite(i, j);
        }
      }
    }
    vector<pair<int, int>> edges;
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        if (msk[i][j] > 0 && msk[i][j] < 3) {
          edges.push_back({i, j});
        }
      }
    }
    bool ok = false;
    for (int it = 0; it < 50000; it++) {
      shuffle(edges.begin(), edges.end(), rng);
      dsu new_sets_a = sets_a, new_sets_b = sets_b;
      vector<pair<int, int>> new_answer = answer;
      for (auto [i, j] : edges) {
        if (new_sets_b.get(i) != new_sets_b.get(j)) {
          new_sets_b.unite(i, j);
          if (msk[i][j] == 1) {
            new_answer.push_back({i, j});
          }
        } else if (new_sets_a.get(i) != new_sets_a.get(j)) {
          new_sets_a.unite(i, j);
          if (msk[i][j] == 2) {
            new_answer.push_back({i, j});
          }
        }
      }
      if (new_answer.size() <= n && new_sets_a.comps == 1 && new_sets_b.comps == 1) {
        ok = true;
        answer = new_answer;
        break;
      }
    }
    if (ok) {
      cout << "Yes\n";
      cout << answer.size() << "\n";
      for (auto [x, y] : answer) {
        cout << 1 + x << " " << 1 + y << "\n";
      }
    } else {
      cout << "No\n";
    }
  }
}
