#include <bits/stdc++.h>
using namespace std;

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t, g;
  cin >> t >> g;
  while (t--) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> graph_a(n), graph_b(n);
    for (int i = 0; i < m1; i++) {
      int u, v;
      cin >> u >> v;
      u--, v--;
      graph_a[u].push_back(v);
      graph_a[v].push_back(u);
    }
    set<pair<int, int>> edges_b;
    for (int i = 0; i < m2; i++) {
      int u, v;
      cin >> u >> v;
      u--, v--;
      edges_b.insert({u, v});
      edges_b.insert({v, u});
      graph_b[u].push_back(v);
      graph_b[v].push_back(u);
    }
    vector<vector<int>> comps(n);
    vector<int> comp(n);
    vector<bool> active(n, true);
    iota(comp.begin(), comp.end(), 0);
    for (int i = 0; i < n; i++) {
      comps[i] = {i};
    }
    for (int i = 0; i < n; i++) {
      for (int j : graph_a[i]) {
        int ci = comp[i], cj = comp[j];
        if (ci != cj) {
          if (comps[ci].size() > comps[cj].size()) {
            active[cj] = false;
            for (int x : comps[cj]) {
              comp[x] = ci;
              comps[ci].push_back(x);
            }
          } else {
            active[ci] = false;
            for (int x : comps[ci]) {
              comp[x] = cj;
              comps[cj].push_back(x);
            }
          }
        }
      }
    }
    map<pair<int, int>, int> cnt;
    vector<pair<int, int>> mrg;
    for (int i = 0; i < n; i++) {
      for (int j : graph_b[i]) {
        cnt[{comp[i], comp[j]}]++;
      }
    }
    for (int i = 0; i < n; i++) {
      for (int j : graph_b[i]) {
        if (active[i] && active[j] && cnt[{comp[i], comp[j]}] != 1LL * int(comps[i].size()) * int(comps[j].size())) {
          mrg.push_back({i, j});
        }
      }
    }
    vector<pair<int, int>> answer;
    for (auto [x, y] : mrg) {
      x = comp[x], y = comp[y];
      if (x != y) {
        bool found = false;
        for (int u : comps[x]) {
          for (int v : comps[y]) {
            if (!edges_b.count({u, v})) {
              answer.push_back({u, v});
              found = true;
              break;
            }
          }
          if (found) {
            break;
          }
        }
        if (comps[x].size() > comps[y].size()) {
          active[y] = false;
          for (int v : comps[y]) {
            comp[v] = x;
            comps[x].push_back(v);
          }
        } else {
          active[x] = false;
          for (int v : comps[x]) {
            comp[v] = y;
            comps[y].push_back(v);
          }
        }
      }
    }
    vector<int> rem;
    for (int i = 0; i < n; i++) {
      if (active[i] && comps[i].size() > 1) {
        rem.push_back(i);
      }
    }
    for (int i = 0; i < (int)rem.size() - 1; i++) {
      answer.push_back({comps[rem[i]][0], comps[rem[i + 1]][0]});
      int x = rem[i], y = rem[i + 1];
      if (comps[x].size() > comps[y].size()) {
        active[y] = false;
        for (int v : comps[y]) {
          comp[v] = x;
          comps[x].push_back(v);
        }
      } else {
        active[x] = false;
        for (int v : comps[x]) {
          comp[v] = y;
          comps[y].push_back(v);
        }
      }
    }
    if (rem.empty()) {
      if (n < 5) {
        cout << "No\n";
        continue;
      } else {
        cout << "Yes\n";
        mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
        cout << n - 1 << "\n";
        for (int i = 1; i < n; i++) {
          uniform_int_distribution<int> dist(0, i - 1);
          cout << i << " " << dist(rng) << "\n";
        }
      }
    } else {
      int ic = comp[rem[0]];
      for (int i = 0; i < n; i++) {
        if (comps[i].size() == 1 && active[i]) {
          for (int j : graph_b[i]) {
            if (comp[j] == ic) {
              answer.push_back({i, j});
              comps[comp[j]].push_back(i);
              break;
            }
          }
        }
      }
      cout << "Yes\n";
      cout << answer.size() << "\n";
      for (auto [x, y] : answer) {
        cout << 1 + x << " " << 1 + y << "\n";
      }
    }
  }
}
