#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    
    vector adj1(n, vector<int>(n));
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        adj1[x][y] = adj1[y][x] = true;
    }
    
    vector adj2(n, vector<int>(n));
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        adj2[x][y] = adj2[y][x] = true;
    }
    
    vector<pair<int, int>> edg;
    for (int x = 0; x < n; x++) {
        for (int y = x + 1; y < n; y++) {
            edg.emplace_back(x, y);
        }
    }
    
    auto is_connected = [&](vector<vector<int>> &adj) {
        vector<bool> vis(n);
        auto dfs = [&](auto self, int x) -> void {
            vis[x] = true;
            for (int y = 0; y < n; y++) {
                if (adj[x][y] && !vis[y]) {
                    self(self, y);
                }
            }
        };
        dfs(dfs, 0);
        return count(vis.begin(), vis.end(), false) == 0;
    };
    
    vector<bool> vis((int)edg.size());
    vector<int> cur;
    bool done = false;
    auto gen = [&](auto self, int p) -> void {
        if (done) return;
        bool ok = true;
        for (auto id : cur) {
            auto [x, y] = edg[id];
            adj1[x][y] ^= 1;
            adj1[y][x] ^= 1;
            adj2[x][y] ^= 1;
            adj2[y][x] ^= 1;
            ok &= is_connected(adj2);
        }
        if (ok && is_connected(adj1)) {
            cout << "Yes\n";
            cout << p << '\n';
            for (auto i : cur) cout << edg[i].first + 1 << ' ' << edg[i].second + 1 << '\n';
            done = true;
            return;
        }
        // undo
        for (auto id : cur) {
            auto [x, y] = edg[id];
            adj1[x][y] ^= 1;
            adj1[y][x] ^= 1;
            adj2[x][y] ^= 1;
            adj2[y][x] ^= 1;
        }
        if (p == n) return;
        for (int x = 0; x < edg.size(); x++) {
            if (vis[x]) continue;
            vis[x] = true;
            cur.push_back(x);
            self(self, p + 1);
            if (done) return;
            vis[x] = false;
            cur.pop_back();
        }
    };
    gen(gen, 0);
    
    if (!done) {
        cout << "No\n";        
    }
}

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    
    map<pair<int, int>, bool> edg;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        edg[{u, v}] = edg[{v, u}] = true;
    }
    
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
    }
    
    vector<pair<int, int>> ans;
    auto add = [&](int x, int y) {
        if (x > y) swap(x, y);
        if (!edg.count({x, y})) {
            edg[{x, y}] = edg[{y, x}] = true;
            ans.emplace_back(x, y);
            return true;
        }
        return false;
    };
    auto print = [&]() {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
    };
    
    if (n == 3) {
        if (m1 == 0) {
            cout << "No\n";
        } else if (m1 == 1) {
            if (add(0, 1)) {
                print();
            } else if (add(1, 2)) {
                print();
            } else {
                assert(false);
            }
        } else {
            print();
        }
    } else {
        for (int x = 0; x < n - 1; x++) {
            add(x, x + 1);
        }
        print();
    }
}

struct DSU {
    vector<int> p;
    DSU(int _n) : p(_n) {
        iota(p.begin(), p.end(), 0);
    }
    
    int find(int x) {
        if (x == p[x]) return x;
        return p[x] = find(p[x]);
    }
    
    bool merge(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return false;
        p[y] = x;
        return true;
    }
};

void solve5() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    
    if (n == 3) {
        vector adj1(n, vector<int>(n));
        for (int i = 0; i < m1; i++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            adj1[x][y] = adj1[y][x] = true;
        }
        
        vector adj2(n, vector<int>(n));
        for (int i = 0; i < m2; i++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            adj2[x][y] = adj2[y][x] = true;
        }
        
        vector<pair<int, int>> edg;
        for (int x = 0; x < n; x++) {
            for (int y = x + 1; y < n; y++) {
                edg.emplace_back(x, y);
            }
        }
        
        auto is_connected = [&](vector<vector<int>> &adj) {
            vector<bool> vis(n);
            auto dfs = [&](auto self, int x) -> void {
                vis[x] = true;
                for (int y = 0; y < n; y++) {
                    if (adj[x][y] && !vis[y]) {
                        self(self, y);
                    }
                }
            };
            dfs(dfs, 0);
            return count(vis.begin(), vis.end(), false) == 0;
        };
        
        vector<bool> vis((int)edg.size());
        vector<int> cur;
        bool done = false;
        auto gen = [&](auto self, int p) -> void {
            if (done) return;
            bool ok = true;
            for (auto id : cur) {
                auto [x, y] = edg[id];
                adj1[x][y] ^= 1;
                adj1[y][x] ^= 1;
                adj2[x][y] ^= 1;
                adj2[y][x] ^= 1;
                ok &= is_connected(adj2);
            }
            if (ok && is_connected(adj1)) {
                cout << "Yes\n";
                cout << p << '\n';
                for (auto i : cur) cout << edg[i].first + 1 << ' ' << edg[i].second + 1 << '\n';
                done = true;
                return;
            }
            // undo
            for (auto id : cur) {
                auto [x, y] = edg[id];
                adj1[x][y] ^= 1;
                adj1[y][x] ^= 1;
                adj2[x][y] ^= 1;
                adj2[y][x] ^= 1;
            }
            if (p == n) return;
            for (int x = 0; x < edg.size(); x++) {
                if (vis[x]) continue;
                vis[x] = true;
                cur.push_back(x);
                self(self, p + 1);
                if (done) return;
                vis[x] = false;
                cur.pop_back();
            }
        };
        gen(gen, 0);
        
        if (!done) {
            cout << "No\n";
        }
        return;
    }
    
    DSU dsu(n);
    map<pair<int, int>, bool> edg;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        edg[{x, y}] = edg[{y, x}] = true;
        dsu.merge(x, y);
    }
    
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
    }
    
    vector<int> ver;
    vector<pair<int, int>> ans;
    for (int x = 1; x < n - 1; x++) {
        if (dsu.merge(x, x + 1)) {
            ver.push_back(x);
            ans.emplace_back(x, x + 1);
        }
    }
    if (dsu.find(0) == dsu.find(1)) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
        return;
    }
    if (!ver.empty()) {
        if (dsu.merge(0, ver[0])) {
            ans.emplace_back(0, ver[0]);
        }
    } else {
        for (int x = 1; x < n; x++) {
            for (int y = x + 1; y < n; y++) {
                if (!edg.count({x, y})) {
                    ans.emplace_back(x, y);
                    ans.emplace_back(0, x);
                    cout << "Yes\n";
                    cout << ans.size() << '\n';
                    for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
                    return;
                }
            }
        }
        ans.emplace_back(1, 2);
        ans.emplace_back(0, 1);
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t, group;
    cin >> t >> group;
    
    while (t--) {
        if (group == 1) solve1();
        if (group == 2) solve2();
        if (group == 5) solve5();
    }
    
    return 0;
}