#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 3e5 + 5;

unordered_set<ll> g1[N];
unordered_set<ll> g2[N];

vector<pair<ll, ll>> order;
ll n, m1, m2;

ll used1[N];
ll used2[N];
ll timer = 1;

ll dfs1(ll v) {
    ll cnt = 1;
    used1[v] = timer;
    for (ll u: g1[v]) {
        if (used1[u] != timer) {
            cnt += dfs1(u);
        }
    }
    return cnt;
}

ll dfs2(ll v) {
    ll cnt = 1;
    used2[v] = timer;
    for (ll u: g2[v]) {
        if (used2[u] != timer) {
            cnt += dfs2(u);
        }
    }
    return cnt;
}

string ans = "1";

ll dfs(ll i, ll l, ll r) {
    timer++;
    if (dfs1(1) == n && dfs2(1) == n) {
        ans = "Yes\n";
        ans += to_string((ll) order.size());
        for (auto &[v, u]: order) {
            ans += "\n" + to_string(v) + " " + to_string(u);
        }
        return 1;
    }
    if (i > n) {
        return 0;
    }
    if (r <= l) {
        r = l + 1;
    }
    for (ll j = l; j <= n; ++j) {
        for (ll k = r; k <= n; ++k) {
            if (j < k) {
                ll l1 = l;
                ll r1 = k;
                if (r1 == n) {
                    l1++;
                    r1 = 1;
                } else {
                    r1++;
                }
                ll pr1 = 0;
                ll pr2 = 0;
                if (g1[j].contains(k)) {
                    pr1 = 1;
                    g1[j].erase(k);
                    g1[k].erase(j);
                } else {
                    g1[j].insert(k);
                    g1[k].insert(j);
                }
                if (g2[j].contains(k)) {
                    pr2 = 1;
                    g2[j].erase(k);
                    g2[k].erase(j);
                } else {
                    g2[j].insert(k);
                    g2[k].insert(j);
                }
                order.emplace_back(j, k);
                if (dfs(i + 1, l1, r1)) {
                    return 1;
                }
                order.pop_back();
                if (pr1 == 0) {
                    g1[j].erase(k);
                    g1[k].erase(j);
                } else {
                    g1[j].insert(k);
                    g1[k].insert(j);
                }
                if (pr2 == 0) {
                    g2[j].erase(k);
                    g2[k].erase(j);
                } else {
                    g2[j].insert(k);
                    g2[k].insert(j);
                }
            }
        }
    }
    return 0;
}

void solve() {
    order.clear();
    ans = "No";
    cin >> n >> m1 >> m2;
    for (int i = 0; i <= n; ++i) {
        g1[i].clear();
        g2[i].clear();
    }
    for (int i = 0; i < m1; ++i) {
        ll v, u;
        cin >> v >> u;
        g1[v].insert(u);
        g1[u].insert(v);
    }
    for (int i = 0; i < m2; ++i) {
        ll v, u;
        cin >> v >> u;
        g2[v].insert(u);
        g2[u].insert(v);
    }
    dfs(0, 1, 1);
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    ll G;
    cin >> G;
    while (test--) {
        solve();
    }
}
