#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct DSU {
    vector<int> p;
    vector<vector<int>> comp;

    DSU(int n) {
        p.resize(n);
        comp.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            comp[i] = {i};
        }
    }

    int get(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) {
            return;
        }
        if (comp[u].size() < comp[v].size()) {
            swap(u, v);
        }
        for (auto x : comp[v]) {
            comp[u].push_back(x);
        }
        p[v] = u;
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t, G;
    cin >> t >> G;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<vector<bool>> g2(n, vector<bool>(n));
        DSU d(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            d.unite(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g2[u][v] = 1;
            g2[v][u] = 1;
        }
        vector<pair<int, int>> ans;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (d.get(j) != j) {
                    continue;
                }
                if (d.get(i) == j) {
                    continue;
                }
                bool gg = 0;
                for (auto x : d.comp[j]) {
                    if (!g2[i][x]) {
                        ans.push_back({i, x});
                        d.unite(i, j);
                        gg = 1;
                        break;
                    }
                }
            }
        }
        if (d.comp[d.get(0)].size() != n) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto [u, v] : ans) {
                cout << u + 1 << " " << v + 1 << "\n";
            }
        }
    }
}
