#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct DSU {
    int comp;
    vector<int> p;

    DSU() = default;
    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        comp = n;
    }

    int root(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = root(p[v]);
    }

    bool same(int u, int v) {
        return root(u) == root(v);
    }

    bool unite(int u, int v) {
        u = root(u);
        v = root(v);
        if (u == v) {
            return false;
        }
        p[v] = u;
        --comp;
        return true;
    }
};

void solve(int _) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (_ == 2) {
        DSU d(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            d.unite(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
        }
        if (n == 3 && m1 == 0) {
            cout << "No\n";
            return;
        }
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            if (!d.same(i, i + 1)) {
                ans.push_back({i, i + 1});
                d.unite(i, i + 1);
            }
        }
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v]: ans) {
            cout << u + 1 << " " << v + 1 << "\n";
        }
        return;
    }
    if (_ == 3) {
        vector<vector<int>> g1(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g1[u].push_back(v);
            g1[v].push_back(u);
        }
        vector<vector<int>> g2(n, vector<int>(n));
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g2[u][v] = g2[v][u] = 1;
        }
        vector<int> c(n, -1);
        auto dfs = [&](auto dfs, int v, int cl) -> void {
            c[v] = cl;
            for (auto u : g1[v]) {
                if (c[u] == -1) {
                    dfs(dfs, u, cl);
                }
            }
        };
        int num = 0;
        for (int i = 0; i < n; ++i) {
            if (c[i] == -1) {
                dfs(dfs, i, num++);
            }
        }
        vector<pair<int, int>> edg;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j) {
                    continue;
                }
                if (c[i] != c[j] && !g2[i][j]) {
                    cout << "Yes\n";
                    cout << 1 << "\n";
                    cout << i + 1 << " " << j + 1 << "\n";
                    return;
                }
                if (c[i] != c[j] && g2[i][j]) {
                    edg.push_back({i, j});
                }
            }
        }
        if (edg.size() > 1) {
            cout << "Yes\n";
            cout << 1 << "\n";
            cout << edg[0].first + 1 << " " << edg[0].second + 1 << "\n";
        } else {
            cout << "No\n";
        }
        return;
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t, _;
    cin >> t >> _;
    while (t--) {
        solve(_);
    }
    return 0;
}