#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct DSU {
    int comp;
    vector<int> p, sz;

    DSU() = default;
    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
        comp = n;
    }

    int root(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = root(p[v]);
    }

    bool same(int u, int v) {
        return root(u) == root(v);
    }

    bool unite(int u, int v) {
        u = root(u);
        v = root(v);
        if (u == v) {
            return false;
        }
        if (sz[u] < sz[v]) {
            swap(u, v);
        }
        p[v] = u;
        sz[u] += sz[v];
        --comp;
        return true;
    }
};

void solve(int _) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (_ == 2) {
        DSU d(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            d.unite(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
        }
        if (n == 3 && m1 == 0) {
            cout << "No\n";
            return;
        }
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            if (!d.same(i, i + 1)) {
                ans.push_back({i, i + 1});
                d.unite(i, i + 1);
            }
        }
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v]: ans) {
            cout << u + 1 << " " << v + 1 << "\n";
        }
        return;
    }
    vector<vector<int>> g1(n, vector<int>(n)), g2(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }
    vector<pair<int, int>> g;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            g.push_back({i, j});
        }
    }
    {
        vector<bool> used(n);
        auto dfs = [&](auto dfs, const vector<vector<int>> &g, int v) -> void {
            used[v] = 1;
            for (auto u: g[v]) {
                if (!used[u]) {
                    dfs(dfs, g, u);
                }
            }
        };
        vector<vector<int>> gg1(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (g1[i][j]) {
                    gg1[i].push_back(j);
                }
            }
        }
        used.assign(n, false);
        dfs(dfs, gg1, 0);
        if (count(used.begin(), used.end(), false) == 0) {
            cout << "Yes\n";
            cout << 0 << "\n";
            return;
        }
    }
    vector<int> p(g.size());
    iota(p.begin(), p.end(), 0);
    do {
        auto G1 = g1, G2 = g2;
        for (int k = 0; k < p.size(); ++k) {
            auto [u, v] = g[p[k]];
            G1[u][v] ^= 1;
            G1[v][u] ^= 1;
            G2[u][v] ^= 1;
            G2[v][u] ^= 1;
            vector<vector<int>> gg1(n), gg2(n);
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (G1[i][j]) {
                        gg1[i].push_back(j);
                    }
                    if (G2[i][j]) {
                        gg2[i].push_back(j);
                    }
                }
            }
            vector<bool> used(n);
            vector<bool> used(n);
            auto dfs = [&](auto dfs, const vector<vector<int>> &g, int v) -> void {
                used[v] = 1;
                for (auto u: g[v]) {
                    if (!used[u]) {
                        dfs(dfs, g, u);
                    }
                }
            };
            used.assign(n, false);
            dfs(dfs, gg1, 0);
            bool ok1 = (count(used.begin(), used.end(), false) == 0);
            used.assign(n, false);
            dfs(dfs, gg2, 0);
            bool ok2 = (count(used.begin(), used.end(), false) == 0);
            if (!ok2) {
                break;
            }
            if (ok1) {
                vector<pair<int, int>> cur;
                for (int i = 0; i <= k; ++i) {
                    auto [u, v] = g[p[i]];
                    cur.push_back({u + 1, v + 1});
                }
                if (cur.size() <= n) {
                    cout << "Yes\n";
                    cout << cur.size() << "\n";
                    for (auto [u, v] : cur) {
                        cout << u << " " << v << "\n";
                    }
                    return;
                }
                break;
            }
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t, _;
    cin >> t >> _;
    while (t--) {
        solve(_);
    }
    return 0;
}