//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve(int g) {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::vector<int>> g1(n, std::vector<int>(n)), g2(n, std::vector<int>(n));
    for (int i = 0; i < m1; i++) {
        int v, u;
        std::cin >> v >> u;
        v--, u--;
        g1[v][u] = g1[u][v] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int v, u;
        std::cin >> v >> u;
        v--, u--;
        g2[v][u] = g2[u][v] = 1;
    }
    if (g <= 1) {
        std::vector<std::pair<int, int>> t;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                t.emplace_back(i, j);
            }
        }
        for (int mask = 0; mask < (1 << t.size()); mask++) {
            int cnt = 0;
            for (int i = 0; i < t.size(); i++) {
                if (mask & (1 << i)) {
                    cnt++;
                }
            }
            if (cnt > n) {
                continue;
            }
            auto g11 = g1, g22 = g2;
            for (int i = 0; i < t.size(); i++) {
                if (mask & (1 << i)) {
                    auto [v, u] = t[i];
                    g11[v][u] ^= 1;
                    g11[u][v] ^= 1;
                    g22[v][u] ^= 1;
                    g22[u][v] ^= 1;
                }
            }
            std::vector<std::vector<int>> adj1(n), adj2(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    if (g11[i][j]) {
                        adj1[i].emplace_back(j);
                    }
                    if (g22[i][j]) {
                        adj2[i].emplace_back(j);
                    }
                }
            }
            std::vector<bool> vis1(n, false), vis2(n, false);
            auto dfs1 = [&](auto self, int v) -> void {
                vis1[v] = true;
                for (int u : adj1[v]) {
                    if (vis1[u]) {
                        continue;
                    }
                    self(self, u);
                }
            };
            auto dfs2 = [&](auto self, int v) -> void {
                vis2[v] = true;
                for (int u : adj2[v]) {
                    if (vis2[u]) {
                        continue;
                    }
                    self(self, u);
                }
            };
            dfs1(dfs1, 0);
            dfs2(dfs2, 0);
            if (!std::count(vis1.begin(), vis1.end(), false) && !std::count(vis2.begin(), vis2.end(), false)) {
                std::cout << "Yes\n";
                std::cout << cnt << "\n";
                for (int i = 0; i < t.size(); i++) {
                    if (mask & (1 << i)) {
                        auto [v, u] = t[i];
                        std::cout << v + 1 << " " << u + 1 << "\n";
                    }
                }
                return;
            }
        }
        std::cout << "No\n";
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
    std::cin >> t;

    int g;
    std::cin >> g;

    while (t--) {
        solve(g);
    }
}