//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve(int g) {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::vector<int>> g1(n, std::vector<int>(n)), g2(n, std::vector<int>(n));
    for (int i = 0; i < m1; i++) {
        int v, u;
        std::cin >> v >> u;
        v--, u--;
        g1[v][u] = g1[u][v] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int v, u;
        std::cin >> v >> u;
        v--, u--;
        g2[v][u] = g2[u][v] = 1;
    }
    if (n <= 5) {
        std::vector<std::pair<int, int>> t;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                t.emplace_back(i, j);
            }
        }
        std::vector<std::vector<int>> adj1(n), adj2(n);
        std::vector<bool> vis1(n, false), vis2(n, false);
        auto dfs1 = [&](auto self, int v) -> void {
            vis1[v] = true;
            for (int u : adj1[v]) {
                if (vis1[u]) {
                    continue;
                }
                self(self, u);
            }
        };
        auto dfs2 = [&](auto self, int v) -> void {
            vis2[v] = true;
            for (int u : adj2[v]) {
                if (vis2[u]) {
                    continue;
                }
                self(self, u);
            }
        };
        std::vector<std::pair<int, int>> ans;
        std::vector<bool> vis(int(t.size()), false);
        auto check = [&]() {
            for (int i = 0; i < n; i++) {
                adj1[i].clear();
                adj2[i].clear();
                for (int j = 0; j < n; j++) {
                    if (g1[i][j]) {
                        adj1[i].emplace_back(j);
                    }
                    if (g2[i][j]) {
                        adj2[i].emplace_back(j);
                    }
                }
            }
            vis1.assign(n, false);
            vis2.assign(n, false);
            dfs1(dfs1, 0);
            dfs2(dfs2, 0);
            if (!std::count(vis1.begin(), vis1.end(), false) && !std::count(vis2.begin(), vis2.end(), false)) {
                return true;
            } else {
                return false;
            }
        };
        auto check2 = [&]() {
            for (int i = 0; i < n; i++) {
                adj2[i].clear();
                for (int j = 0; j < n; j++) {
                    if (g2[i][j]) {
                        adj2[i].emplace_back(j);
                    }
                }
            }
            vis2.assign(n, false);
            dfs2(dfs2, 0);
            if (!std::count(vis2.begin(), vis2.end(), false)) {
                return true;
            } else {
                return false;
            }
        };
        bool found = false;
        auto get = [&](auto self) -> void {
            if (found) {
                return;
            }
            if (!check2()) {
                return;
            }
            if (check()) {
                std::cout << "Yes\n";
                std::cout << int(ans.size()) << "\n";
                for (auto [v, u] : ans) {
                    std::cout << v + 1 << " " << u + 1 << "\n";
                }
                found = true;
                return;
            }
            if (int(ans.size()) == n) {
                return;
            }
            for (int i = 0; i < int(t.size()); i++) {
                if (vis[i]) {
                    continue;
                }
                auto [v, u] = t[i];
                vis[i] = true;
                ans.emplace_back(v, u);
                g1[v][u] ^= 1;
                g1[u][v] ^= 1;
                g2[v][u] ^= 1;
                g2[u][v] ^= 1;
                self(self);
                vis[i] = false;
                ans.pop_back();
                g1[v][u] ^= 1;
                g1[u][v] ^= 1;
                g2[v][u] ^= 1;
                g2[u][v] ^= 1;
            }
        };
        get(get);
        if (!found) {
            std::cout << "No\n";
        }
    } else if (g == 2) {
        std::cout << "Yes\n";
        std::vector<std::pair<int, int>> res;
        for (int i = 0; i < n - 1; i++) {
            if (g1[i][i + 1]) {
                continue;
            }
            res.emplace_back(i, i + 1);
        }
        std::cout << int(res.size()) << "\n";
        for (auto [v, u] : res) {
            std::cout << v + 1 << " " << u + 1 << "\n";
        }
    } else if (g == 3) {
        int timer = 0;
        std::vector<int> cmp(n, -1);
        auto dfs = [&](auto self, int v) -> void {
            cmp[v] = timer;
            for (int u = 0; u < n; u++) {
                if (!g1[v][u]) {
                    continue;
                }
                if (cmp[u] != -1) {
                    continue;
                }
                self(self, u);
            }
        };
        for (int i = 0; i < n; i++) {
            if (cmp[i] == -1) {
                dfs(dfs, i);
                timer++;
            }
        }
        std::vector<std::pair<int, int>> edges;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (g2[i][j]) {
                    edges.emplace_back(i, j);
                }
            }
        }
        std::vector<std::vector<int>> bridge(n, std::vector<int>(n));
        for (int i = 0; i < m2; i++) {
            std::vector<std::vector<int>> adj(n);
            for (int j = 0; j < m2; j++) {
                if (i == j) {
                    continue;
                }
                auto [v, u] = edges[j];
                adj[v].emplace_back(u);
                adj[u].emplace_back(v);
            }
            std::vector<bool> vis(n, false);
            auto dfs2 = [&](auto self, int v) -> void {
                vis[v] = true;
                for (int u : adj[v]) {
                    if (vis[u]) {
                        continue;
                    }
                    self(self, u);
                }
            };
            dfs2(dfs2, 0);
            if (std::count(vis.begin(), vis.end(), false)) {
                bridge[edges[i].first][edges[i].second] = bridge[edges[i].second][edges[i].first] = true;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (cmp[i] != cmp[j] && (!g2[i][j] || !bridge[i][j])) {
                    std::cout << "Yes\n";
                    std::cout << 1 << "\n";
                    std::cout << i + 1 << " " << j + 1 << "\n";
                    return;
                }
            }
        }
        std::cout << "No\n";
    }
}

signed main() {
//    std::cin.tie(nullptr);
//    std::ios::sync_with_stdio(false);

    int t = 1;
    std::cin >> t;

    int g;
    std::cin >> g;

    while (t--) {
        solve(g);
    }
}