#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
//#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    int x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x - b.x, a.y - b.y));
    }

    friend int operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend int operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

vec<int> p(3e5), s(3e5);
vec<vec<int>> sv(3e5);

void make_set(int v) {
    p[v] = v;
    s[v] = 1;
    sv[v] = {v};
}

int find_set(int v) {
    if (v == p[v]) return v;
    return p[v] = find_set(p[v]);
}

void union_sets(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a != b) {
        if (s[a] < s[b]) swap(a, b);
        p[b] = a;
        s[a] += s[b];
        for (int& i : sv[b]) {
            sv[a].push_back(b);
        }
    }
}

int g;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < n; ++i) make_set(i);
    map<pair<int, int>, bool> mp2;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        mp2[{a, b}] = 1;
        mp2[{b, a}] = 1;
        union_sets(a, b);
    }
    map<pair<int, int>, bool> mp;
    int a0 = 0, b0 = 0;
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        a0 = a, b0 = b;
        mp[{a, b}] = 1;
        mp[{b, a}] = 1;
    }
    if (n <= 5) {
        for (int mask = 0; mask < (1 << (n * (n - 1) / 2)); ++mask) {
            for (int i = 0; i < n; ++i) {
                make_set(i);
            }
            auto mp3 = mp, mp4 = mp2;
            vec<pair<int, int>> ans;
            int c = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if ((mask | (1 << c)) == mask) {
                        ans.push_back({i, j});
                        mp3[{i, j}] = !mp3[{i, j}];
                        mp3[{j, i}] = mp3[{i, j}];
                        mp4[{i, j}] = !mp4[{i, j}];
                        mp4[{j, i}] = mp4[{i, j}];
                    }
                    c++;
                }
            }
            for (auto i : mp4) {
                if (i.second) {
                    union_sets(i.first.first, i.first.second);
                }
            }
            if ((int)ans.size() > n || s[find_set(0)] != n) continue;
            for (int i = 0; i < n; ++i) {
                make_set(i);
            }
            for (auto i : mp3) {
                if (i.second) {
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] == n) {
                cout << "Yes\n";
                cout << (int)ans.size() << endl;
                for (auto& i : ans) {
                    if (!mp[i]) {
                        cout << i.first + 1 << " " << i.second + 1 << endl;
                    }
                }
                for (auto& i : ans) {
                    if (mp[i]) {
                        cout << i.first + 1 << " " << i.second + 1 << endl;
                    }
                }
                return;
            }
        }
        cout << "No\n";
        return;
    }
    vec<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        if (i != a0 && i != b0) {
           // cout << i << " " << mp[{i, a0}] << " " << mp[{i, b0}] << endl;
            if (mp[{i, a0}] && mp[{i, b0}]) {
                if (!mp2[{i, a0}]) {
                    ans.push_back({i, a0});
                    mp2[{i, a0}] = 1;
                    mp2[{a0, i}] = 1;
                    mp[{i, a0}] = 0;
                    mp[{a0, i}] = 0;
                }
                else if (!mp2[{i, b0}]) {
                    ans.push_back({i, b0});
                    mp2[{i, b0}] = 1;
                    mp2[{b0, i}] = 1;
                    mp[{i, b0}] = 0;
                    mp[{b0, i}] = 0;
                }
            }
            else if (mp[{i, a0}]) {
                if (!mp2[{i, b0}]) {
                    ans.push_back({i, b0});
                    mp2[{i, b0}] = 1;
                    mp2[{b0, i}] = 1;
                    mp[{i, b0}] = 1;
                    mp[{b0, i}] = 1;
                }
            }
            else if (mp[{i, b0}]) {
                //cout << i << " " << a0 << " " << mp2[{i, a0}] << endl;
                if (!mp2[{i, a0}]) {
                    ans.push_back({i, a0});
                    mp2[{i, a0}] = 1;
                    mp2[{a0, i}] = 1;
                    mp[{i, a0}] = 1;
                    mp[{a0, i}] = 1;
                }
            }
            else {
                if (!mp2[{i, b0}]) {
                    ans.push_back({i, b0});
                    mp2[{i, b0}] = 1;
                    mp2[{b0, i}] = 1;
                    mp[{i, b0}] = 1;
                    mp[{b0, i}] = 1;
                }
                else {
                    ans.push_back({i, a0});
                    mp2[{i, a0}] = 1;
                    mp2[{a0, i}] = 1;
                    mp[{i, a0}] = 1;
                    mp[{a0, i}] = 1;
                }
            }
        }
    }
    if (mp2[{a0, b0}]) {
        {
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp2) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n";
        cout << (int) ans.size() << endl;
        for (auto &i: ans) cout << i.first + 1 << " " << i.second + 1 << endl;
        return;
    }
    vec<int> c, d;
    for (int i = 0; i < n; ++i) {
        if (i != a0 && i != b0) {
            if (mp2[{a0, i}]) {
                c.push_back(i);
            }
            else {
                d.push_back(i);
            }
        }
    }
    if ((int)c.size() == 0) {
        if (!mp2[{d[0], a0}]) {
            ans.push_back({d[0], a0});
        }
        {
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp2) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n";
        cout << (int) ans.size() << endl;
        for (auto &i: ans) cout << i.first + 1 << " " << i.second + 1 << endl;
        return;
    }
    if ((int)d.size() == 0) {
        if (!mp2[{c[0], b0}]) {
            ans.push_back({c[0], a0});
        }
        {
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
            for (int i = 0; i < n; ++i) make_set(i);
            for (auto i: mp2) {
                if (i.second) {
                    //cout << i.first.first << " " << i.first.second << endl;
                    union_sets(i.first.first, i.first.second);
                }
            }
            if (s[find_set(0)] != n) {
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n";
        cout << (int) ans.size() << endl;
        for (auto &i: ans) cout << i.first + 1 << " " << i.second + 1 << endl;
        return;
    }
    int j = rnd() % ((int)c.size());
    int q = rnd() % ((int)d.size());
    if (!mp2[{c[j], d[q]}]) {
        ans.push_back({c[j], d[q]});
    }
    {
        for (int i = 0; i < n; ++i) make_set(i);
        for (auto i: mp) {
            if (i.second) {
                //cout << i.first.first << " " << i.first.second << endl;
                union_sets(i.first.first, i.first.second);
            }
        }
        if (s[find_set(0)] != n) {
            cout << "No\n";
            return;
        }
        for (int i = 0; i < n; ++i) make_set(i);
        for (auto i: mp2) {
            if (i.second) {
                //cout << i.first.first << " " << i.first.second << endl;
                union_sets(i.first.first, i.first.second);
            }
        }
        if (s[find_set(0)] != n) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << (int) ans.size() << endl;
    for (auto &i: ans) cout << i.first + 1 << " " << i.second + 1 << endl;
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t >> g;
    for (; t > 0; --t) {
        solve();
    }
}