#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;

bool isPoss = true;
vector<pair<int, int>> res;

void change(int u, int v) {
    res.push_back({u, v});
}

int n;
vector<int> g[N];
vector<int> tr[N];
set<pair<int, int>> e1;
set<pair<int, int>> e2;


void solve1(int u, int v) {
    // cout << "solve1\n";
    // cout << u << ' ' << v << '\n';
    if (!e1.count({u, v})) {
        change(u, v);
        e1.insert({u, v});
        e2.insert({u, v});
    }
    for (int i = 1; i <= n; i++) {
        if (i == u || i == v) continue;
        if (e1.count({i, u}) || e1.count({i, v})) continue;
        if (!e2.count({i, u})) {
            change(i, u);
            continue;
        }
        if (!e2.count({i, v})) {
            change(i, v);
            continue;
        }
        change(i, u);
    }
}

int find_farest(int start) {
    vector<bool> vis(n + 1, 0);
    vector<int> dist(n + 1, 0);
    queue<int> q;
    q.push(start);
    vis[start] = true;
    while (!q.empty()) {
        int s = q.front();
        q.pop();
        for (int to : g[s]) {
            if (vis[to]) continue;
            dist[to] = dist[s] + 1;
            vis[to] = true;
            q.push(to);
        }
    }
    int mx = 0;
    for (int i = 1; i <= n; i++) {
        if (dist[mx] < dist[i])
            mx = i;
    }
    return mx;
}

vector<int> dep;
vector<bool> vis;

void dfs(int s, int p = -1) {
    vis[s] = true;
    for (int to : g[s]) {
        if (to == p) continue;
        if (!vis[to]) {
            dep[to] = dep[s] + 1;
            tr[s].push_back(to);
            dfs(to, s);
        } else {
            change(s, to);
        }
    }
}

void test_case() {
    cin >> n;
    e1.clear();
    e2.clear();
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        tr[i].clear();
    }
    int m1, m2;
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        g[u].push_back(v);
        g[v].push_back(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }
    // cout << "Here\n";
    // find an edge that both graphs contains
    for (auto c : e1) {
        if (e2.count(c)) {
            solve1(c.first, c.second);
            return;
        }
    }

    // find an edge that none of graphs contains
    {
        int u = 1, v = 2;
        while (e1.count({u, v}) || e2.count({u, v})) {
            if (v < n) v++;
            else {
                u++;
                v = u + 1;
            }
        }
        if (u <= n && v <= n) {
            solve1(u, v);
            return;
        }
    }

    if (n == 3) {
        isPoss = false;
        return;
    }

    int u = find_farest(1);
    int v = find_farest(u);

    // cout << u << ' ' << v << '\n';
    vis.assign(n + 1, false);
    dep.assign(n + 1, 0);
    dfs(u);
    if (dep[v] >= 3) return;
    int mid = tr[u].back(), ver = -1;
    for (int to : tr[mid]) {
        if (to == u || to == v) continue;
        ver = to;
    }
    change(ver, u);
    change(ver, mid);
}   

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("test.txt", "r", stdin);
    int t, type;
    cin >> t >> type;
    while (t--) {
        test_case();
        if (!isPoss) cout << "No\n";
        else {
            cout << "Yes\n";
            cout << (int)res.size() << '\n';
            for (auto [x, y] : res) {
                cout << x << ' ' << y << '\n';
            }
        }
        res.clear();
        isPoss = true;
        cout << '\n';
    }
}