#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;

bool isPoss = true;
vector<pair<int, int>> res;

void change(int u, int v) {
    res.push_back({u, v});
}

int n;
vector<int> g[N];
vector<int> tr[N];
set<pair<int, int>> e1;
set<pair<int, int>> e2;


void solve1(int u, int v) {
    // cout << "solve1\n";
    // cout << u << ' ' << v << '\n';
    if (!e1.count({u, v})) {
        change(u, v);
        e1.insert({u, v});
        e2.insert({u, v});
    }
    for (int i = 1; i <= n; i++) {
        if (i == u || i == v) continue;
        if (e1.count({i, u}) || e1.count({i, v})) continue;
        if (!e2.count({i, u})) {
            change(i, u);
            continue;
        }
        if (!e2.count({i, v})) {
            change(i, v);
            continue;
        }
        change(i, u);
    }
}

vector<bool> vis;
vector<int> dep;

void dfs(int s, bool chh, int p = -1) {
    vis[s] = true;
    // if (chh) {
    //     cout << s << '\n';
    // }
    for (int to : g[s]) {
        if (to == p) continue;
        if (!vis[to]) {
            dep[to] = dep[s] + 1;
            tr[s].push_back(to);
            tr[to].push_back(s);
            dfs(to, chh, s);
        } else {
            if (dep[to] < dep[s] && chh) 
                change(s, to);
        }
    }
}

int find_farest(int start) {
    vis.assign(n + 1, false);
    dep.assign(n + 1, 0);
    dfs(start, false);
    int mx = start;
    for (int i = 1; i <= n; i++)
        if (dep[i] > dep[mx]) mx = i;
    return mx;
}


void test_case() {
    cin >> n;
    e1.clear();
    e2.clear();
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        tr[i].clear();
    }
    int m1, m2;
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        g[u].push_back(v);
        g[v].push_back(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }

    /* find an edge that both graphs contains*/ {
        for (auto c : e1) {
            if (e2.count(c)) {
                solve1(c.first, c.second);
                return;
            }
        }

    }

    /* find an edge that none of graphs contains */ {
        int u = 1, v = 2;
        while (e1.count({u, v}) || e2.count({u, v})) {
            if (v < n) v++;
            else {
                u++;
                v = u + 1;
            }
        }
        if (u <= n && v <= n) {
            solve1(u, v);
            return;
        }
    }

    int u, v, val = 0;
    // u = find_farest(1);
    // v = find_farest(u);
    for (int i = 1; i <= n; i++) {
        int x = find_farest(i);
        if (dep[x] > val) {
            val = dep[x];
            u = i, v = x;
        }
    }

    vis.assign(n + 1, false);
    dep.assign(n + 1, 0);
    dfs(u, true);

    // cerr << u << ' ' << v << '\n';
    if (dep[v] >= 3) return;
    if (dep[v] == 1) {
        exit(1);
    }
    int mid = tr[u].back(), ver = -1;
    for (int to : tr[mid]) {
        if (to == u || to == v) continue;
        ver = to;
    }
    if (ver == -1) {
        isPoss = false;
        return;
    }
    change(ver, u);
    change(ver, mid);
}   

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("test.txt", "r", stdin);
    int t, type;
    cin >> t >> type;
    while (t--) {
        test_case();
        if (!isPoss) cout << "No\n";
        else {
            cout << "Yes\n";
            cout << (int)res.size() << '\n';
            for (auto [x, y] : res) {
                cout << x << ' ' << y << '\n';
            }
        }
        res.clear();
        isPoss = true;
        cout << '\n';
    }
}