#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int INF = INT_MAX;
const ld PI = atan2(0, -1);
mt19937_64 rnd(75743);

int G;
int n, m1, m2;
vector<vector<bool>> g1, g2;

struct DSU {
    vector<int> pr, r;
    int sz, cnt;

    DSU(int N) {
        pr.resize(N);
        for (int i = 0; i < N; i++) pr[i] = i;
        sz = N;
        cnt = N;
        r.resize(N, 1);
    }

    int getPred(int v) {
        if (pr[v] == v) return v;
        return pr[v] = getPred(pr[v]);
    }

    bool merge(int a, int b) {
        a = getPred(a);
        b = getPred(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        if (r[a] == r[b]) r[a]++;
        pr[b] = a;
        cnt--;
        return true;
    }
};

bool check(int a, int b, bool gr) {
    if (!gr) {
        cout << "CHECK " << a << " " << b << endl;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) cout << g1[i][j] << " ";
            cout << endl;
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) cout << g2[i][j] << " ";
            cout << endl;
        }
        cout << endl;
    }
    vector<int> dist(n, -1);
    dist[a] = 0;
    queue<int> q;
    while (!q.empty() && dist[b] == -1) {
        int v = q.front();
        q.pop();
        for (int u = 0; u < n; u++) {
            if (dist[u] == -1 && ((gr && g2[v][u]) || (!gr && g1[v][u]))) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    return (dist[b] != -1);
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vector<bool> (n, false));
    g2.assign(n, vector<bool> (n, false));
    DSU dsu(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        dsu.merge(a, b);
        g1[a][b] = g1[b][a] = true;
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g2[a][b] = g2[b][a] = true;
    }

//    bool st = (dsu.cnt > 1);
    vector<pair<int, int>> ans;
//    for (int a = 0; a < n; a++) {
//        for (int b = a + 1; b < n; b++) {
//            if (dsu.getPred(a) == dsu.getPred(b)) {
//                if (g2[a][b] || g2[b][a]) continue;
//                g1[a][b] = g1[b][a] = false;
//                if (check(a, b, false)) {
//                    ans.emplace_back(a, b);
//                    g2[a][b] = g2[b][a] = true;
//                } else {
//                    g1[b][a] = g1[b][a] = true;
//                }
//            } else {
//                if (!g2[a][b]) {
//                    ans.emplace_back(a, b);
//                    g2[a][b] = g2[b][a] = true;
//                    dsu.merge(a, b);
//                    g1[a][b] = g1[b][a] = true;
//                } else {
//                    g2[a][b] = g2[b][a] = false;
//                    if (check(a, b, true)) {
//                        ans.emplace_back(a, b);
//                        dsu.merge(a, b);
//                        g1[a][b] = g1[b][a] = true;
//                    } else {
//                        g2[a][b] = g2[b][a] = true;
//                    }
//                }
//            }
//        }
//    }
    while (dsu.cnt > 1) {
        bool ch = false;
        for (int it = 0; it < 10000; it++) {
            int a = rnd() % n;
            int b = rnd() % n;
            if (a == b) continue;
            if (dsu.getPred(a) == dsu.getPred(b)) {
                if (g2[a][b] || g2[b][a]) continue;
                g1[a][b] = g1[b][a] = false;
                if (check(a, b, false)) {
                    ans.emplace_back(a, b);
                    g2[a][b] = g2[b][a] = true;
                    ch = true;
                    break;
                } else if (rnd() % 1000 < 800) {
                    g1[b][a] = g1[b][a] = true;
                } else {
                    ans.emplace_back(a, b);
                    g2[a][b] = g2[b][a] = true;
                    ch = true;
                    dsu = DSU(n);
                    for (int i = 0; i < n; i++) {
                        for (int j = i + 1; j < n; j++) {
                            if (g1[i][j]) {
                                dsu.merge(i, j);
                            }
                        }
                    }
                    break;
                }
            } else {


//                cout << "df " << a + 1 << " " << b + 1 << endl;
                if (!g2[a][b]) {
                    ans.emplace_back(a, b);
                    g2[a][b] = g2[b][a] = true;
                    dsu.merge(a, b);
                    g1[a][b] = g1[b][a] = true;
                    ch = true;
                    break;
                } else {
                    g2[a][b] = g2[b][a] = false;
                    if (check(a, b, true)) {
                        ans.emplace_back(a, b);
                        dsu.merge(a, b);
                        g1[a][b] = g1[b][a] = true;
                        ch = true;
                        break;
                    } else {
                        g2[a][b] = g2[b][a] = true;
                    }
                }
            }
//            if (dsu.getPred(a) == dsu.getPred(b)) continue;
//            if (!g2[a][b]) {
//                ch = true;
//                dsu.merge(a, b);
//                ans.push_back({a, b});
//                g2[a][b] = g2[b][a] = true;
//                break;
//            } else {
//                g2[a][b] = g2[b][a] = false;
//                if (check(a, b)) {
//                    ans.push_back({a, b});
//                    dsu.merge(a, b);
//                    ch = true;
//                    break;
//                } else {
//                    g2[a][b] = g2[b][a] = true;
//                }
//
//            }
        }
        if (!ch) {
            break;
        }
    }
    if (dsu.cnt > 1) {
        cout << "No" << '\n';
        return;
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto [a, b] : ans) cout << a + 1 << " " << b + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);

    int t;
    cin >> t >> G;

    while (t--) solve();
}