// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

int _g;
const int maxn = 300005;

vector<set<int>> g1;
vector<set<int>> g2;
bool used[maxn];

int n;

int dfs(int g = 1, int v = 1) {
    if (v == 1) memset(used, 0, n+1);
    used[v] = true;
    int cur = 1;
    if (g == 1) {
        for (int u : g1[v]) {
            if (used[u]) continue;
            cur += dfs(1, u);
        }
    } else {
        for (int u : g2[v]) {
            if (used[u]) continue;
            cur += dfs(2, u);
        }
    } 
    return cur;
}

void solve() {
    int m1, m2;
    cin >> n >> m1 >> m2;
    g1.clear();
    g1.resize(n+1);
    g2.clear();
    g2.resize(n+1);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a].insert(b);
        g2[b].insert(a);
    }
    
    if (n <= 5) {
        vector<pair<int, int>> edges;
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                edges.emplace_back(i, j);
            }
        }

        for (int mask = 0; mask < (1 << edges.size()); mask++) {
            vector<pair<int, int>> sel;
            for (int i = 0; i < edges.size(); i++) {
                if (mask & (1 << i)) {
                    sel.emplace_back(edges[i]);
                }
            }

            vector<pair<int, int>> toadd, torem;

            for (auto [u, v] : sel) {
                if (g2[u].count(v)) 
                    torem.emplace_back(u, v);
                else
                    toadd.emplace_back(u, v);
            }

            for (auto [u, v] : toadd) {
                g2[u].insert(v);
                g2[v].insert(u);
                
                if (g1[u].count(v)) {
                    g1[u].erase(v);
                    g1[v].erase(u);
                } else {
                    g1[u].insert(v);
                    g1[v].insert(u);
                }
            }

            for (auto [u, v] : torem) {
                g2[u].erase(v);
                g2[v].erase(u);
                
                if (g1[u].count(v)) {
                    g1[u].erase(v);
                    g1[v].erase(u);
                } else {
                    g1[u].insert(v);
                    g1[v].insert(u);
                }
            }

            if (dfs(2) == n && dfs(1) == n) {
                cout << "Yes\n";
                cout << toadd.size() + torem.size() << '\n';
                for (auto [u, v] : toadd) cout << u << ' ' << v << '\n';
                for (auto [u, v] : torem) cout << u << ' ' << v << '\n';
                return;
            }

            for (auto [u, v] : toadd) {
                g2[u].erase(v);
                g2[v].erase(u);
                
                if (g1[u].count(v)) {
                    g1[u].erase(v);
                    g1[v].erase(u);
                } else {
                    g1[u].insert(v);
                    g1[v].insert(u);
                }
            }

            for (auto [u, v] : torem) {
                g2[u].insert(v);
                g2[v].insert(u);
                
                if (g1[u].count(v)) {
                    g1[u].erase(v);
                    g1[v].erase(u);
                } else {
                    g1[u].insert(v);
                    g1[v].insert(u);
                }
            }

        }
        cout << "No\n";

        return;
    }

    if (_g == 2) {
        vector<pair<int, int>> ops;
        if (!g1[1].count(2)) {
            ops.emplace_back(1, 2);
        }
        for (int j = 3; j <= n/2; j++) {
            if (!g1[1].count(j)) {
                ops.emplace_back(1, j);
            }
        }

        for (int j = n/2 + 1; j <= n; j++) {
            if (!g1[2].count(j)) {
                ops.emplace_back(2, j);
            }
        }

        cout << "Yes\n";
        cout << ops.size() << '\n';
        for (auto [u, v] : ops) {
            cout << u << ' ' << v << '\n';
        }
        return;
    }

    if (_g == 7) {
    vector<pair<int, int>> ops;

    for (int i = 3; i <= n; i++) {
        if (g1[1].count(i) || g1[2].count(i)) continue;
        if (g2[1].count(i)) {
            g1[2].insert(i);
            g1[i].insert(2);
            ops.emplace_back(2, i);
            if (g2[2].count(i)) {
                g2[2].erase(i);
                g2[i].erase(2);
            } else {
                g2[2].insert(i);
                g2[i].insert(2);
            } 
        } else if (g2[2].count(i)) {
            g1[1].insert(i);
            g1[i].insert(1);
            ops.emplace_back(1, i);
            if (g2[1].count(i)) {
                g2[1].erase(i);
                g2[i].erase(1);
            } else {
                g2[1].insert(i);
                g2[i].insert(1);
            }
        } else {
            g1[2].insert(i);
            g1[i].insert(2);
            ops.emplace_back(2, i);
            if (g2[2].count(i)) {
                g2[2].erase(i);
                g2[i].erase(2);
            } else {
                g2[2].insert(i);
                g2[i].insert(2);
            }
        }
    }

    cout << "Yes\n";
    cout << ops.size() << '\n';
    for (auto [u, v] : ops) cout << u << ' ' << v << '\n';
        return;
    }

    if (_g == 9) {
        vector<pair<int, int>> ops;
        for (int i = 3; i <= n; i++) {
            if (!g1[1].count(i)) {
                ops.emplace_back(1, i);
            }
        }

        for (int i = 4; i <= n; i++) {
            if (!g1[2].count(i)) {
                ops.emplace_back(2, i);
            }
        }

        cout << "Yes\n";
        cout << ops.size() << '\n';
        for (auto [u, v] : ops) cout << u << ' ' << v << '\n';
        return;
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t >> _g;
    while (t--) solve();
}