//#pragma GCC optimize("03")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("no-online")
//#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

// #define int long long
// #define double long double

using pii = pair<int, int>;
using ll = long long;
using pll = pair<ll, ll>;
using ld = long double;

const int max_n = 80;

int gen(int l, int r) {
    int x = rand() << 15;
    x += rand();
    return x % (r - l + 1) + l;
}

vector<int> p(max_n), sz(max_n, 1);

int asz;

int get(int x) {
    if (x == p[x]) {
        return x;
    }
    return p[x] = get(p[x]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    asz--;
    sz[b] += sz[a];
    p[a] = b;
}

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    int g1[n][n], g2[n][n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            g1[i][j] = 0;
            g2[i][j] = 0;
        }
    }
    set<pii> s1, s2;
    for (int i = 0; i < m1; i++) {
        int v, u; cin >> v >> u;
        v--, u--;
        if (v > u) swap(v, u);
        g1[v][u] = 1;
        g1[u][v] = 1;
        s1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        int v, u; cin >> v >> u;
        v--, u--;
        if (v > u) swap(v, u);
        g2[v][u] = 1;
        g2[u][v] = 1;
        s2.insert({v, u});
    }
    set<pii> change;
    int lim = 5e5;
    while (lim--) {
        std::fill(sz.begin(), sz.end(), 1);
        for (int i = 0; i < n; i++) p[i] = i;
        asz = n;
        for (auto [i, j] : s1) {
            unite(i, j);
        }
        if (asz == 1) {
            cout << "Yes" << '\n';
            cout << change.size() << '\n';
            for (auto [i, j] : change) {
                cout << i + 1 << " " << j + 1 << '\n';
            }
            return;
        }
        if (change.size() >= n) {
            for (auto e : change) {
                if (s1.find(e) != s1.end()) {
                    s1.erase(e);
                } else {
                    s1.insert(e);
                }
                if (s2.find(e) != s2.end()) {
                    s2.erase(e);
                } else {
                    s2.insert(e);
                }
            }
            change.clear();
        }
        int v = gen(0, n - 2);
        int u = gen(v + 1, n - 1);
        if (s1.find({v, u}) != s1.end() && s2.find({v, u}) != s2.end()) continue;
        std::fill(sz.begin(), sz.end(), 1);
        for (int i = 0; i < n; i++) p[i] = i;
        asz = n;
        for (auto [i, j] : s1) {
            unite(i, j);
        }
        if (get(v) == get(u)) continue;
        std::fill(sz.begin(), sz.end(), 1);
        for (int i = 0; i < n; i++) p[i] = i;
        asz = n;
        for (auto [i, j] : s2) {
            if (i != v || j != u) {
                unite(i, j);
            }
        }
        if (asz == 1) {
            change.insert({v, u});
            pii e = {v, u};
            if (s1.find(e) != s1.end()) {
                s1.erase(e);
            } else {
                s1.insert(e);
            }
            if (s2.find(e) != s2.end()) {
                s2.erase(e);
            } else {
                s2.insert(e);
            }
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    int gr;
    cin >> t >> gr;
    while (t--) {
        solve();
    }
}
