#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename V>
istream &operator>>(istream &in, pair<T, V> &v) {
    in >> v.first >> v.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}


template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

int count1(int x) {
    int count = 0;
    while (x) {
        count += x & 1;
        x >>= 1;
    }
    return count;
}

int n, m1, m2;

namespace solve1 {
    vector<vector<bool>> g1, g2;
    vector<pii>
            edges3 = {{0, 1},
                      {0, 2},
                      {1, 2}},
            edges4 = {{0, 1},
                      {0, 2},
                      {0, 3},
                      {1, 2},
                      {1, 3},
                      {2, 3}},
            edges5 = {{0, 1},
                      {0, 2},
                      {0, 3},
                      {0, 4},
                      {1, 2},
                      {1, 3},
                      {1, 4},
                      {2, 3},
                      {2, 4},
                      {3, 4}};

    void dfs(int v, vector<bool> &used, vector<vector<bool>> &g) {
        used[v] = true;
        RANGE(u, n) {
            if (g[v][u] && !used[u]) {
                dfs(u, used, g);
            }
        }
    }

    bool _check() {
        vector<bool> used1(n, false), used2(n, false);
        dfs(0, used1, g1);
        dfs(0, used2, g2);
        for (bool x: used1) {
            if (!x) {
                return false;
            }
        }
        for (bool x: used2) {
            if (!x) {
                return false;
            }
        }
        return true;
    }

    bool _check(int mask, vector<pii> &edges) {
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                g1[a][b] = g1[b][a] = !g1[a][b];
                g2[a][b] = g2[b][a] = !g2[a][b];
            }
        }
        bool res = _check();
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                g1[a][b] = g1[b][a] = !g1[a][b];
                g2[a][b] = g2[b][a] = !g2[a][b];
            }
        }
        return res;
    }

    void _print(int mask, vector<pii> &edges) {
        cout << count1(mask) << ENDLINE;
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                cout << (pii) {a + 1, b + 1} << ENDLINE;
            }
        }
    }

    void _solve(vector<pii> &edges) {
        RANGE(mask, 1 << edges.size()) {
            if (count1(mask) <= n) {
                if (_check(mask, edges)) {
                    cout << "Yes" << ENDLINE;
                    _print(mask, edges);
                    return;
                }
            }
        }
        cout << "No" << ENDLINE;
    }

    void read() {
        g1.clear();
        g1.resize(n, vector<bool>(n, false));
        LOOP(m1) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g1[v][u] = g1[u][v] = true;
        }
        g2.clear();
        g2.resize(n, vector<bool>(n, false));
        LOOP(m2) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g2[v][u] = g2[u][v] = true;
        }
    }

    void solve() {
        read();
        if (n == 3) {
            _solve(edges3);
        } elif (n == 4) {
            _solve(edges4);
        } else {
            _solve(edges5);
        }

    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    LOOP(t) {
        cin >> n >> m1 >> m2;
        if (n <= 5) {
            solve1::solve();
        }
    }
}
