#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename V>
istream &operator>>(istream &in, pair<T, V> &v) {
    in >> v.first >> v.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}


template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}

int count1(int x) {
    int count = 0;
    while (x) {
        count += x & 1;
        x >>= 1;
    }
    return count;
}

int n, m1, m2;

namespace solve1 {
    vector<vector<bool>> g1, g2;
    vector<pii>
            edges3 = {{0, 1},
                      {0, 2},
                      {1, 2}},
            edges4 = {{0, 1},
                      {0, 2},
                      {0, 3},
                      {1, 2},
                      {1, 3},
                      {2, 3}},
            edges5 = {{0, 1},
                      {0, 2},
                      {0, 3},
                      {0, 4},
                      {1, 2},
                      {1, 3},
                      {1, 4},
                      {2, 3},
                      {2, 4},
                      {3, 4}};

    void dfs(int v, vector<bool> &used, vector<vector<bool>> &g) {
        used[v] = true;
        RANGE(u, n) {
            if (g[v][u] && !used[u]) {
                dfs(u, used, g);
            }
        }
    }

    bool _check() {
        vector<bool> used1(n, false), used2(n, false);
        dfs(0, used1, g1);
        dfs(0, used2, g2);
        for (bool x: used1) {
            if (!x) {
                return false;
            }
        }
        for (bool x: used2) {
            if (!x) {
                return false;
            }
        }
        return true;
    }

    bool _check(int mask, vector<pii> &edges) {
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                g1[a][b] = g1[b][a] = !g1[a][b];
                g2[a][b] = g2[b][a] = !g2[a][b];
            }
        }
        bool res = _check();
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                g1[a][b] = g1[b][a] = !g1[a][b];
                g2[a][b] = g2[b][a] = !g2[a][b];
            }
        }
        return res;
    }

    void _print(int mask, vector<pii> &edges) {
        cout << count1(mask) << ENDLINE;
        vector<pii> st1, st2;
        RANGE(i, edges.size()) {
            if ((mask >> i) & 1) {
                auto [a, b] = edges[i];
                if (g2[a][b]) {
                    st2.emplace_back(a + 1, b + 1);
                } else {
                    st1.emplace_back(a + 1, b + 1);
                }
            }
        }
        cout << st1 << st2;
    }

    void _solve(vector<pii> &edges) {
        RANGE(mask, 1 << edges.size()) {
            if (count1(mask) <= n) {
                if (_check(mask, edges)) {
                    cout << "Yes" << ENDLINE;
                    _print(mask, edges);
                    return;
                }
            }
        }
        cout << "No" << ENDLINE;
    }

    void read() {
        g1.clear();
        g1.resize(n, vector<bool>(n, false));
        LOOP(m1) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g1[v][u] = g1[u][v] = true;
        }
        g2.clear();
        g2.resize(n, vector<bool>(n, false));
        LOOP(m2) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g2[v][u] = g2[u][v] = true;
        }
    }

    void solve() {
        read();
        if (n == 3) {
            _solve(edges3);
        } elif (n == 4) {
            _solve(edges4);
        } else {
            _solve(edges5);
        }

    }
}

namespace solve {
    vector<set<int>> g1, g2;
    set<pii> edges12;
    vector<pii> edges1;
    pii edge_in_12;

    vector<int> i_color;
    vector<set<int>> color_is;
    int count_color;

    void read() {
        g1.clear();
        g2.clear();
        g1.resize(n);
        g2.resize(n);
        edges1.resize(m1);
        edge_in_12 = {-1, -1};
        set<pii> edges1_s;
        RANGE(i, m1) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            if (u > v) {
                swap(u, v);
            }
            edges12.insert({u, v});
            edges1_s.insert({u, v});
            edges1[i] = {u, v};
            g1[u].insert(v);
            g1[v].insert(u);
        }
        LOOP(m2) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            if (u > v) {
                swap(u, v);
            }
            edges12.insert({u, v});
            auto it = edges1_s.find({u, v});
            if (it != edges1_s.end()) {
                edge_in_12 = {u, v};
            }
            g2[u].insert(v);
            g2[v].insert(u);
        }
    }

    void dfs_color(int v, int color) {
        i_color[v] = color;
        for (int u: g1[v]) {
            if (i_color[u] == -1) {
                dfs_color(u, color);
            }
        }
    }

    void _colors(int v0) {
        i_color.clear();
        i_color.resize(n, -1);
        dfs_color(v0, 0);
        count_color = 1;
        RANGE(i, n) {
            if (i_color[i] == -1) {
                dfs_color(i, count_color);
                count_color++;
            }
        }
        color_is.clear();
        color_is.resize(count_color);
        RANGE(i, n) {
            color_is[i_color[i]].insert(i);
        }
    }

    void _solve1(bool k) {
        auto [u, v] = edge_in_12;
        _colors(u);
        vector<pii> new_edges;
        if (k) {
            new_edges.emplace_back(u + 1, v + 1);
        }
        RANGE1(i, count_color) {
            int w = *color_is[i].begin();
            if (g2[u].find(w) == g2[u].end()) {
                new_edges.emplace_back(u + 1, w + 1);
                g1[u].insert(w);
                g1[w].insert(u);
                g2[u].insert(w);
                g2[w].insert(u);
            } else {
                new_edges.emplace_back(v + 1, w + 1);
                g1[v].insert(w);
                g1[w].insert(v);
                if (g2[v].find(w) == g2[v].end()) {
                    g2[v].insert(w);
                    g2[w].insert(v);
                } else {
                    g2[v].erase(w);
                    g2[w].erase(v);
                }
            }
        }
        cout << "Yes" << ENDLINE << new_edges.size() << ENDLINE << new_edges;
    }

    void _solve1() {
        _solve1(false);
    }

    void _solve2(bool k, pii r1) {
        auto [u, v] = r1;
        _colors(u);
        vector<pii> new_edges;
        if (k) {
            new_edges.emplace_back(u + 1, v + 1);
        }
        RANGE1(i, count_color) {
            int w = *color_is[i].begin();
            if (g1[u].size() < n - 2) {
                new_edges.emplace_back(u + 1, w + 1);
                g1[u].insert(w);
                g1[w].insert(u);
                g2[u].erase(w);
                g2[w].erase(u);
            } elif (g1[v].size() < n - 2) {
                new_edges.emplace_back(v + 1, w + 1);
                g1[v].insert(w);
                g1[w].insert(v);
                g2[v].erase(w);
                g2[w].erase(v);
            } else {
                new_edges.emplace_back(u, v);
                g1[v].erase(u);
                g1[u].erase(v);
                g2[v].insert(u);
                g2[u].insert(v);
                new_edges.emplace_back(v + 1, w + 1);
                g1[v].insert(w);
                g1[w].insert(v);
                g2[v].erase(w);
                g2[w].erase(v);
//                exit(-1);
            }
        }
        cout << "Yes" << ENDLINE << new_edges.size() << ENDLINE << new_edges;
    }

    void solve() {
        read();
        if (edge_in_12.first != -1) {
            _solve1();
        } elif (m1 + m2 == n * (n - 1) / 2) {
            if (m1 == 0) {
                edges1.emplace_back(0, 1);
                g1[0].insert(1);
                g1[1].insert(0);
                g2[0].erase(1);
                g2[1].erase(0);
                _solve2(true, {0, 1});
            } else {
                _solve2(false, edges1[0]);
            }
        } else {
            RANGE(i, n) {
                for (int j = i + 1; j < n; j++) {
                    if (edges12.find({i, j}) == edges12.end()) {
                        edge_in_12 = {i, j};
                        g1[i].insert(j);
                        g1[j].insert(i);
                        g2[i].insert(j);
                        g2[j].insert(i);
                        _solve1(true);
                        return;
                    }
                }
            }
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    LOOP(t) {
        cin >> n >> m1 >> m2;
        if (n <= 5) {
            solve1::solve();
        } else {
            solve::solve();
        }
    }
}
