#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

#define int ll

const int MAXN = 3e5 + 1;

vector<int> g1[MAXN], g2[MAXN];

struct DSU {
    vector<int> p, rng;

    DSU(int n) {
        p.resize(n + 1), rng.resize(n + 1, 1);
        iota(p.begin() + 1, p.end(), 1);
    }

    int fnd(int x) {
        return x == p[x] ? x : p[x] = fnd(p[x]);
    }

    void unite(int x, int y) {
        x = fnd(x), y = fnd(y);
        if (x == y) return;
        if (rng[x] > rng[y]) swap(x, y);
        p[x] = y;
        rng[y] += rng[x];
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 1; i <= n; ++i) {
        g1[i].clear(), g2[i].clear();
    }
    DSU dsu(n);
    for (int i = 0, x, y; i < m1; ++i) {
        cin >> x >> y;
        dsu.unite(x, y);
    }
    for (int i = 0, x, y; i < m2; ++i) {
        cin >> x >> y;
    }
    if (m1 == 0) {
        cout << "No\n";
        return;
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (dsu.fnd(i) != dsu.fnd(j)) {
                ans.emplace_back(i, j);
                dsu.unite(i, j);
            }
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto &[x, y] : ans) {
        cout << x<< " " << y << '\n';
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}