// In the name of Allah

#include <bits/stdc++.h>
using namespace std;

typedef		long long			ll;
typedef		long double			ld;
typedef		pair<int, int>		pii;
typedef		pair<ll, ll>		pll;

#define		endl				'\n'
#define		sep					' '
#define		F					first
#define		S					second
#define		len(x)				((ll) (x).size())
#define		all(x)				(x).begin(),(x).end()
#define		Mp					make_pair
#define		pb					push_back

int n, m1, m2;
const int maxn = 3e5 + 4;
const int oo = 1e9 + 7;
set<int> adj[maxn], M;
vector<pii> E, E1, E2;
vector<pii> ans, ans0, ans1;
int col[maxn], c = 0;
int p[2][maxn], sz[2][maxn], num[2];
vector<pii> A1, A2;

int G1(pii x) {
	int j = lower_bound(all(A1), x) - A1.begin();
	if (j < len(A1) && A1[j] == x) return j;
	return -1;
}

int G2(pii x) {
	int j = lower_bound(all(A2), x) - A2.begin();
	if (j < len(A2) && A2[j] == x) return j;
	return -1;
}

void addE(pii f) {
	int u = f.F, v = f.S;
	E.pb(Mp(u, v));
	adj[u].insert(v); adj[v].insert(u);
}

int get(int a, int R) {
	return (p[R][a] == a) ? a : p[R][a] = get(p[R][a], R);
}

void merge(int a, int b, int R) {
	a = get(a, R); b = get(b, R);
	if (a == b) return ;
	num[R]--;
	if (sz[R][a] > sz[R][b]) swap(a, b);
	p[R][a] = b; sz[R][b] += sz[R][a];
}

void dfs(int v) {
	M.erase(v); col[v] = c;
	int r = 0; auto it = M.lower_bound(r);
	while (it != M.end()) {
		int u = *it;
		if (adj[v].find(u) == adj[v].end()) {
			int u1 = min(u, v), v1 = max(u, v);
			if (G1(Mp(u1, v1)) == -1) ans.pb(Mp(u1, v1));
			dfs(u);
		}
		r = u + 1;
		it = M.lower_bound(r);
	}
}

void solve() {
	cin >> n >> m1 >> m2;

	E.clear(); ans.clear();
	for (int i = 0; i < n; i++) adj[i].clear();
	A1.clear(); A2.clear();

	for (int i = 0; i < m1; i++) {
		int u, v;
		cin >> u >> v; u--; v--;
		if (u > v) swap(u, v);
		A1.pb(Mp(u, v));
	}
	sort(all(A1));

	for (int i = 0; i < m2; i++) {
		int u, v;
		cin >> u >> v; u--; v--;
		if (u > v) swap(u, v);
		A2.pb(Mp(u, v));
	}
	sort(all(A2));

	for (auto f : A1) {
		if (G2(f) == -1) addE(f);
	}
	for (auto f : A2) {
		if (G1(f) == -1) addE(f);
	}

	c = 0; M.clear();
	for (int i = 0; i < n; i++) M.insert(i);
	while (!M.empty()) {
		int v = *M.begin();
		dfs(v); c++;
	}

	int SEED = 23232323;
	for (int T = 0; T < 100; T++) {
		for (int R = 0; R < 2; R++) {
			num[R] = c;
			for (int i = 0; i < c; i++) {
				p[R][i] = i; sz[R][i] = 1;
			}
		}

		shuffle(all(E), default_random_engine(SEED));
		SEED = (SEED * 7ll + 23) % oo;

		E1.clear(); E2.clear();
		for (auto f : E) {
			int u = col[f.F], v = col[f.S];
			if (get(u, 0) != get(v, 0)) {
				merge(u, v, 0);
				if (G1(f) == -1) E1.pb(f);
				else E2.pb(f);
			}
			else if (get(u, 1) != get(v, 1)) {
				merge(u, v, 1);
				if (G2(f) == -1) E1.pb(f);
				else E2.pb(f);
			}
		}

		if (num[0] == 1 && num[1] == 1) break;
	}

	if (len(E1) > len(E2)) swap(E1, E2);
	for (auto f : E1) ans.pb(f);
	
	ans0.clear(); ans1.clear();
	for (auto f : ans) {
		if (G2(f) == -1) ans0.pb(f);
		else ans1.pb(f);
	}

	ans.clear();
	for (auto f : ans0) ans.pb(f);
	for (auto f : ans1) ans.pb(f);

	if (num[0] != 1 || num[1] != 1) {
		cout << "No" << endl;
		return ;
	}

	cout << "Yes" << endl;
	cout << len(ans) << endl;
	for (auto f : ans) {
		cout << f.F + 1 << sep << f.S + 1 << endl;
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int T, G;
	cin >> T >> G;
	while (T--) {
		solve();
	}

	return 0;
}