#include <bits/stdc++.h>
#define F first
#define S second
using namespace std;

const int N = 3e5 + 10;
int n , m[3] , c[3] , deg[N];
vector <pair<int , int>> E[3];
vector <pair<int , int>> ans , tree;
vector <int> adj[N];
bool marked[N];

void Solve3()
{
	ans.clear();
	c[0] = c[1] = c[2] = 0;
	for(auto u : E[1])
		c[(u.F + u.S) % 3]++;
	for(auto u : E[0])
		c[(u.F + u.S) % 3]++;
	bool flg = false;
	for(int i = 0 ; i < 3 ; i++)  if(c[i] != 1)
		flg = true;
	if(!flg)
	{
		cout << "No" << '\n';
		return;
	}
	cout << "Yes" << '\n';
	if(c[0] == 0)
		ans.push_back({1 , 2});
	if(c[1] == 0)
		ans.push_back({1 , 3});
	if(c[2] == 0)
		ans.push_back({2 , 3});
	int tmp = ans.size() + E[0].size();
	if(tmp == 1)
	{
		if(c[0] == 1)
			ans.push_back({1 , 2});
		else if(c[1] == 1)
			ans.push_back({1 , 3});
		else if(c[2] == 1)
			ans.push_back({2 , 3});
	}
	cout << ans.size() << '\n';
	for(auto u : ans)
		cout << u.F << " " << u.S << '\n';
}

void Bfs(int star)
{
	marked[star] = true;
	queue <int> q;
	q.push(star);
	while(!q.empty())
	{
		int now = q.front();  q.pop();
		for(auto u : adj[now])  if(!marked[u])
		{
			marked[u] = true;
			q.push(u);
			tree.push_back({now , u});
			deg[now]++;
		}
	}
}

void Solve()
{
	ans.clear();
	tree.clear();
	for(int i = 1 ; i <= n ; i++)
		deg[i] = 0;
	for(auto u : E[1])
	{
		deg[u.F]++;
		deg[u.S]++;
	}
	int root = 1;
	while(deg[root] == 1)
		root++;
	for(int i = 1 ; i <= n ; i++)
	{
		deg[i] = 0;
		marked[i] = 0;
		adj[i].clear();
	}
	for(auto u : E[1])
	{
		adj[u.F].push_back(u.S);
		adj[u.S].push_back(u.F);
	}
	Bfs(root);
	if(deg[root] == n-1)
	{
		int a = tree.back().S , b = 1;
		while(b == a || b == root)
			b++;
		bool flg = false;
		for(auto u : E[1])
		{
			if(u.F == min(a , b) && u.S == max(a , b))
				flg = true;
		}
		if(!flg)
			ans.push_back({a , b});
		tree.pop_back();
		tree.push_back({b , a});
		if(!flg)
		{
			vector <pair<int , int>> tmp;
			for(auto u : E[0])
			{
				if(u.F == min(a , b) && u.S == max(a , b))
					continue;
				tmp.push_back(u);
			}
			E[0] = tmp;
		}
	}
	sort(E[0].begin() , E[0].end());
	int leaf = tree.back().S;
	int bad = tree.back().F;
	for(int i = 1 ; i <= n ; i++)  if(i != bad && i != leaf)
	{
		pair <int , int> now = make_pair(min(i , leaf) , max(i , leaf));
		int pos = lower_bound(E[0].begin() , E[0].end() , now) - E[0].begin();
		if(pos < m[0] && E[0][pos] == now)
			continue;
		ans.push_back(now);
	}
	for(int i = 1 ; i <= n ; i++)
		marked[i] = false;
	for(auto u : tree)  if(u.F == bad || u.S == bad)
	{
		marked[u.F] = true;
		marked[u.S] = true;
	}
	for(int i = 1 ; i <= n ; i++)  if(!marked[i])
	{
		pair <int , int> now = make_pair(min(i , bad) , max(i , bad));
		int pos = lower_bound(E[0].begin() , E[0].end() , now) - E[0].begin();
		if(pos >= m[0] || E[0][pos] != now)
			ans.push_back(now);
		break;
	}
	cout << "Yes" << '\n';
	cout << ans.size() << '\n';
	for(auto u : ans)
		cout << u.F << " " << u.S << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);  cout.tie(0);
	int Tc , g;  cin >> Tc >> g;
	while(Tc--)
	{
		cin >> n >> m[0] >> m[1];
		E[0].clear(); E[1].clear();
		for(int i = 0 ; i < m[0] ; i++)
		{
			int a , b;  cin >> a >> b;
			if(a > b)
				swap(a , b);
			E[0].push_back({a , b});
		}
		for(int i = 0 ; i < m[1] ; i++)
		{
			int a , b;  cin >> a >> b;
			if(a > b)
				swap(a , b);
			E[1].push_back({a , b});
		}
		if(n == 3)
			Solve3();
		else
			Solve();
	}
	return 0;
}