#include <bits/stdc++.h>
#define int long long
#define FOR(a, b, c) for (int a = (b); a < (c); ++a)
using namespace std;
using ar = array<int, 2>;

const int N = 3e5 + 50;

namespace dsu {
	int dpr[N];

	void build(int n) {
		iota(dpr, dpr + n, 0);
	}
	int gpr(int x) {
		return dpr[x] == x ? x : dpr[x] = gpr(dpr[x]);
	}
	bool merge(int u, int v) {
		u = gpr(u);
		v = gpr(v);
		if (u == v) return false;
		dpr[u] = v;
		return true;
	}
}

set<int> head;
set<ar> E, E2;
vector<int> V[N];
vector<ar> ans;
int n, m1, m2, dpr[N];

void merge(int u, int v) {
	u = dpr[u];
	v = dpr[v];
	if (u == v) return;
	if (V[u].size() > V[v].size()) swap(u, v);
	head.erase(u);
	for (auto x: V[u]) dpr[x] = v;
	V[v].insert(V[v].end(), V[u].begin(), V[u].end());
	V[u].clear();
}



bool ext(int u, int v, const set<ar> &E) {
	return E.count({u, v}) || E.count({v, u});
}

void add_ans(int x, int y) {
	ans.push_back({x, y});
	if (!ext(x, y, E)) E.insert({x, y});
	else
		E.erase({x, y}), E.erase({y, x});
	if (!ext(x, y, E2)) E2.insert({x, y});
	else E2.erase({x, y}), E2.erase({y, x});
}

ar check(int v, int u) {
	for (auto x: V[v]) for (auto y: V[u]) if (!ext(x, y, E)) {
		return {x, y};
	}
	return {-1, -1};
}

void merge_ta_K() {
	int cur = 0;
	for (auto it = head.lower_bound(0); it != head.end(); it = head.upper_bound(cur)) {
		cur = *it;
		int cur2 = cur;
		for (auto it2 = head.upper_bound(cur2); it2 != head.end(); it2 = head.upper_bound(cur2)) {
			cur2 = *it2;
			auto A = check(cur, cur2);
			if (A[0] != -1) {
				add_ans(A[0], A[1]);
				merge(cur, cur2);
				if (!head.count(cur))
					break;
			}
		}
	}
}

void max_con() {
	vector<ar> heads;
	for (auto u: head) if (V[u].size() >= 2) heads.push_back({V[u].size(), u});
	sort(heads.rbegin(), heads.rend());

	FOR(i, 0, heads.size()) {
		int v = heads[i][1];
		if (dpr[v] != v) continue;
		FOR(j, i + 1, heads.size()) {
			int u = heads[j][1];
			if (dpr[u] != u) continue;
			int x = V[v][0], y = V[u][0];
			add_ans(x, y);
			merge(u, v);
		}
	}
}

void td_con() {
	while (head.size() >= 3) {
		int a[3] = {*head.begin(), 0, 0};
		FOR(i, 1, 3) a[i] = *head.upper_bound(a[i - 1]);
		int u = V[a[0]][0], v = V[a[1]][0];
		add_ans(u, v);
		merge(u, v);
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tc, g;
	cin >> tc >> g;
	while (tc--) {
		E.clear();
		head.clear();
		E2.clear();
		ans.clear();
		cin >> n >> m1 >> m2;
		dsu::build(n);

		FOR(i, 0, n) {
			V[i] = {i};
			dpr[i] = i;
			head.insert(i);
		}

		FOR(i, 0, m1) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			merge(u, v);
			E2.insert({u, v});
		}
		FOR(i, 0, m2) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			E.insert({u, v});
		}

		merge_ta_K();
		td_con();
		max_con();

		if (head.size() == 2) {
			vector<ar> heads;
			for (auto u: head) heads.push_back({V[u].size(), u});
			sort(heads.rbegin(), heads.rend());
			assert(heads.size() == 2);
			assert(heads[0][0] == n - 1);

			ar OK = {-1, -1};
			for (auto [x, y]: E2) {
				if (!dsu::merge(x, y)) OK = {x, y};
			}

			int u = heads[1][1];
			bool f = true;
			for (auto [x, y]: E) if (dpr[x] == dpr[y]) {
				add_ans(x, u);
				f = false;
				break;
			}
			if (f) {
				if (n == 3) {
					cout << "No\n";
					continue;
				}
				if (OK[0] != -1) {
					add_ans(OK[0], OK[1]);
					add_ans(u, OK[0]);
				}
				else { //hame boreshi
					vector<int> oth;
					FOR(i, 0, n) if (i != u) oth.push_back(i);
					for (auto x: oth) for (auto v: oth) {
						if (!f) break;
						if (x != v && !ext(x, v, E2)) {
							f = false;	
							add_ans(x, v);
							add_ans(u, x);
						}
					}
				}
			}
		}
		cout << "Yes\n";
		cout << ans.size() << '\n';
		for (auto [a, b]: ans) cout << a + 1 << ' ' << b + 1 << '\n';
	}
	return 0;
}
