#pragma GCC optimaze("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
using namespace std;
auto now = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(now);

const long double e = 2.71243;

long long randrange(long long a, long long b) {
    return a + rnd() % (b - a);
}

bool chance(long double x) {
    return randrange(0, 100 + 1) <= floor(x);
}

ostream& operator<< (ostream& stream, const pair<int, int>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<int>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<int, int>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const pair<long long, long long>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<long long>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<long long, long long>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}
















int n;
vector<long long> D, L, R;
long long a0, b0;

long long f(const vector<bool>& mask) {
    vector<long long> a(n + 1), b(n + 1);
    a[0] = a0,  b[0] = b0;
    for (int i = 1; i <= n; i++) {
        a[i] = a[i - 1] + D[i - 1];
        b[i] = b[i - 1] + D[i - 1];
        if (mask[i - 1]) {
            b[i] = min(b[i], R[i - 1]);
        } else {
            a[i] = min(a[i], L[i - 1]);
        }
    }
    return a[n] + b[n];
}

vector<bool> upd(vector<bool> mask) {
    mask[randrange(0, n)] = randrange(0, 2);
    return mask;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    
    cin >> n;
    D.resize(n), L.resize(n), R.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> R[i];
    }
    cin >> a0 >> b0;
    vector<bool> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = randrange(0, 2);
    }
    long long ans = 0;
    long double t = 1.0;
    for (int iters = 0; iters < 300 * 300; iters++) {
        auto to = upd(p);
        long long to_val = f(to);
        long long p_val = f(p);
        // cout << to_val << " " << p_val << "\n";
        ans = max(ans, max(to_val, p_val));
        t *= 0.99;
        if (to_val > p_val || chance(pow(e, -t))) {
            p = to;
        }
    }
    cout << ans;
}