#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<ll> TR, TL;

void solve() {
	int n;
	cin >> n;

	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> d[i];
	for (int i = 1; i <= n; i++)
		cin >> l[i];
	for (int i = 1; i <= n; i++)
		cin >> r[i];
	ll a, b;
	cin >> a >> b;

	vector<ll> dpr(n + 1);
	for (int i = 1; i <= n; i++)
		dpr[i] = dpr[i - 1] + d[i];

	ll res = -1;
	for (int i = 1; i <= n; i++) {
		ll va = a, vb = b;
		for (int j = 1; j < i; j++) {
			va += d[j];
			vb += d[j];
			va = min(va, l[j]);
		}
		for (int j = i; j <= n; j++) {
			va += d[j];
			vb += d[j];
			vb = min(vb, r[j]);
		}
		res = max(res, va + vb);
	}

	cout << res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
