#include <bits/stdc++.h>

using ll = long long;

struct DSU {
    std::vector<ll> p, rank;

    DSU(ll n) {
        p.resize(n);
        rank.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    ll find(ll v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }

    void unite(ll v, ll u) {
        v = find(v), u = find(u);
        if (v == u) {
            return;
        }
        if (rank[u] < rank[v]) {
            std::swap(v, u);
        }
        p[u] = v;
        rank[u] += rank[v];
    }
};

void solve() {
    ll n;
    std::cin >> n;
    std::vector<ll> l(n), d(n), a;
    std::vector<ll> r(n), b;
    for (int i = 0; i < n; ++i) {
        std::cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> r[i];
    }
    ll a0, b0;
    std::cin >> a0 >> b0;
    a.push_back(a0);
    b.push_back(b0);
    ll sm = a0 + b0;
    for (int i = 0; i < n; ++i) {
        ll ao = a.back(), bo = b.back();
        ao += d[i], bo += d[i];
        if (std::min(ao, l[i]) + bo > ao + std::min(bo, r[i])) {
            a.push_back(std::min(ao, l[i]));
            b.push_back(bo);
        } else {
            b.push_back(std::min(bo, r[i]));
            a.push_back(ao);
        }
        sm += a.back();
        sm += b.back();
    }
    std::cout << a.back() + b.back();
}

int main() {
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
