#include <bits/stdc++.h>

using ll = long long;

struct DSU {
    std::vector<ll> p, rank;

    DSU(ll n) {
        p.resize(n);
        rank.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    ll find(ll v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }

    void unite(ll v, ll u) {
        v = find(v), u = find(u);
        if (v == u) {
            return;
        }
        if (rank[u] < rank[v]) {
            std::swap(v, u);
        }
        p[u] = v;
        rank[u] += rank[v];
    }
};

void solve() {
    ll n;
    std::cin >> n;
    std::vector<ll> l(n + 1), d(n), a;
    std::vector<ll> r(n + 1), b;
    for (int i = 0; i < n; ++i) {
        std::cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        std::cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        std::cin >> r[i];
    }
    ll a0, b0;
    std::cin >> a0 >> b0;
    l[0] = a0, r[0] = b0;
    std::map<ll, std::vector<ll>> dd;
    for (int i = 0; i <= n; ++i) {
        dd[l[i]].push_back(i);
    }
    ll ans = *std::min_element(l.begin(), l.end());
    ll rr = -1e12;
    for (auto it = dd.begin(); it != dd.end(); ++it) {
        ans = std::max(it -> first + rr, ans);
        if(rr < 0){
            rr = 1e12;
        }
        for (auto u : it->second) {
            rr = std::min(rr, r[u]);
        }
    }
    std::cout << std::max(ans, *std::min_element(r.begin(), r.end()));
}

int main() {
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
