#include <bits/stdc++.h>

using ll = long long;
using pll = std::pair<ll, ll>;

struct DSU {
    std::vector<ll> p, rank;

    DSU(ll n) {
        p.resize(n);
        rank.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    ll find(ll v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }

    void unite(ll v, ll u) {
        v = find(v), u = find(u);
        if (v == u) {
            return;
        }
        if (rank[u] < rank[v]) {
            std::swap(v, u);
        }
        p[u] = v;
        rank[u] += rank[v];
    }
};

ll get(ll n, ll m, std::vector<ll> l, std::vector<ll> r, ll a0, ll b0, std::vector<std::pair<ll, pll>> ind) {
    std::vector<ll> used(n);
    ll mn1 = a0, mn2 = b0;
    for (int i = 0; i < m; ++i) {
        mn1 = std::min(mn1, l[ind[i].second.second]);
        used[ind[i].second.second] = 1;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            mn2 = std::min(mn2, r[i]);
        }
    }
    return mn1 + mn2;
}

bool cmp(std::pair<ll, pll> x, std::pair<ll, pll> y) {
    return x.first > y.first || ((x.first == y.first) && (x.second.first > y.second.first));
}

void solve() {
    ll n;
    std::cin >> n;
    std::vector<ll> l(n), d(n), a;
    std::vector<ll> r(n), b;
    for (int i = 0; i < n; ++i) {
        std::cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> r[i];
    }
    ll a0, b0;
    std::cin >> a0 >> b0;
    std::vector<std::pair<ll, pll>> ind(n);
    for (int i = 0; i < n; ++i) {
        ind[i] = {l[i], {r[i], i}};
    }
    std::sort(ind.begin(), ind.end(), cmp);
    ll mnx = b0;
    ll ans = -1e18;
    std::reverse(ind.begin(), ind.end());
    for(auto [el, pr] : ind){
        ans = std::max(ans, mnx + std::min(a0, el));
        auto [X, ind] = pr;
        mnx = std::min(mnx, r[ind]);
    }
    std::cout << std::max(ans, a0 + mnx);
}

int main() {
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
