#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const ll inf = 3e18;

const int N = 301;
bitset<N> dp[N][N];

inline void solve() {
	int n;
	cin >> n;
	vector<ll> d(n), l(n), r(n);
	for (int i = 0; i < n; i++)
		cin >> d[i];
	for (int i = 0; i < n; i++)
		cin >> l[i];
	for (int i = 0; i < n; i++)
		cin >> r[i];
	vector<ll> pd(n + 1);
	for (int i = 0; i < n; i++)
		pd[i + 1] = pd[i] + d[i];
	ll a0, b0;
	cin >> a0 >> b0;
	dp[0][0][0] = true;
	for (int i = 0; i < n; i++) {
		for (int la = 0; la <= i; la++)
			for (int lb = 0; lb <= i; lb++)
				if (dp[i][la][lb]) {
					ll ca = (la == 0 ? a0 : l[la - 1]) + pd[i + 1] - pd[la];
					ll cb = (lb == 0 ? b0 : r[lb - 1]) + pd[i + 1] - pd[lb];
					if (ca > l[i])
						dp[i + 1][i + 1][lb] = true;
					else
						dp[i + 1][la][lb] = true;
					if (cb > r[i])
						dp[i + 1][la][i + 1] = true;
					else
						dp[i + 1][la][lb] = true;
				}
	}
	ll ans = 0;
	for (int i = 0; i <= n; i++)
		for (int j = 0; j <= n; j++)
			if (dp[n][i][j]) {
				ll ca = (i == 0 ? a0 : l[i - 1]) + pd[n] - pd[i];
				ll cb = (j == 0 ? b0 : r[j - 1]) + pd[n] - pd[j];
				ans = max(ans, ca + cb);
			}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
