#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int inf = 1e9;

void smax(int& a, int b) {
	a = max(a, b);
}

struct segtree {
	vector<int> tree, push;
	int sz;

	segtree() {}

	segtree(int n) {
		sz = 1;
		while (sz < n)
			sz *= 2;
		tree.resize(2 * sz, -inf);
		push.resize(2 * sz, -inf);
	}

	void prop(int x, int tl, int tr) {
		if (tr - tl == 1 || push[x] == -inf)
			return;
		tree[2 * x + 1] = push[x];
		tree[2 * x + 2] = push[x];
		push[2 * x + 1] = push[x];
		push[2 * x + 2] = push[x];
		push[x] = -inf;
	}

	void set(int i, int v, int x, int tl, int tr) {
		prop(x, tl, tr);
		if (tr - tl == 1) {
			tree[x] = v;
			return;
		}
		int m = (tl + tr) / 2;
		if (i < m)
			set(i, v, 2 * x + 1, tl, m);
		else
			set(i, v, 2 * x + 2, m, tr);
		tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
	}

	void set(int i, int v) {
		set(i, v, 0, 0, sz);
	}

	void set(int l, int r, int v, int x, int tl, int tr) {
		prop(x, tl, tr);
		if (l <= tl && tr <= r) {
			tree[x] = v;
			push[x] = v;
			return;
		}
		if (l >= tr || r <= tl)
			return;
		int m = (tl + tr) / 2;
		set(l, r, v, 2 * x + 1, tl, m);
		set(l, r, v, 2 * x + 2, m, tr);
		tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
	}

	void set(int l, int r, int v) {
		set(l, r, v, 0, 0, sz);
	}

	int get(int l, int r, int x, int tl, int tr) {
		prop(x, tl, tr);
		if (l <= tl && tr <= r)
			return tree[x];
		if (l >= tr || r <= tl)
			return -inf;
		int m = (tl + tr) / 2;
		int s1, s2;
		s1 = get(l, r, 2 * x + 1, tl, m);
		s2 = get(l, r, 2 * x + 2, m, tr);
		return max(s1, s2);
	}

	int get(int l, int r) {
		return get(l, r, 0, 0, sz);
	}

	int find(int v, int x, int tl, int tr) {
		prop(x, tl, tr);
		if (tree[x] <= v)
			return -1;
		if (tr - tl == 1)
			return tl;
		int m = (tl + tr) / 2;
		int s1;
		s1 = find(v, 2 * x + 2, m, tr);
		if (s1 > -1)
			return s1;
		return find(v, 2 * x + 1, tl, m);
	}

	int find(int v) {
		return find(v, 0, 0, sz);
	}
};

inline void solve() {
	int n;
	cin >> n;
	vector<int> d(n + 1), l(n + 1), r(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> d[i];
	for (int i = 1; i <= n; i++)
		cin >> l[i];
	for (int i = 1; i <= n; i++)
		cin >> r[i];
	n++;
	cin >> l[0] >> r[0];
	vector<ll> pd(n + 1);
	for (int i = 0; i < n; i++)
		pd[i + 1] = pd[i] + d[i];
	vector<ll> lp(n), rp(n);
	for (int i = 0; i < n; i++) {
		if (i) {
			lp[i] = l[i] - pd[i + 1];
			rp[i] = r[i] - pd[i + 1];
		} else {
			lp[i] = l[i];
			rp[i] = r[i];
		}
	}
	sort(all(lp));
	sort(all(rp));
	lp.erase(unique(all(lp)), lp.end());
	rp.erase(unique(all(rp)), rp.end());
	vector<int> ordl(n), ordr(n);
	for (int i = 0; i < n; i++) {
		if (i) {
			ordl[i] = lower_bound(all(lp), l[i] - pd[i + 1]) - lp.begin();
			ordr[i] = lower_bound(all(rp), r[i] - pd[i + 1]) - rp.begin();
		}
		else {
			ordl[i] = lower_bound(all(lp), l[i]) - lp.begin();
			ordr[i] = lower_bound(all(rp), r[i]) - rp.begin();
		}
	}
	segtree st(lp.size());
	st.set(0, ordl[0] + 1, ordr[0]);
	for (int i = 1; i < n; i++) {
		int pos = st.find(ordr[i]);
		if (pos <= ordl[i])
			continue;
		int val = st.get(ordl[i] + 1, pos + 1);
		st.set(ordl[i], val);
		st.set(ordl[i] + 1, pos + 1, ordr[i]);
	}
	ll ans = 0;
	for (int i = 0; i < (int) lp.size(); i++) {
		int pos = st.get(i, i + 1);
		if (pos > -inf) {
			ll ca, cb;
			ca = pd[n] + lp[i];
			cb = pd[n] + rp[pos];
			ans = max(ans, ca + cb);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
