#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

vector<ll> d, leftt, rightt;

bool cmp(const ll &a, const ll &b) {
    if (leftt[a] != leftt[b]) return leftt[a] < leftt[b];
    return rightt[a] > rightt[b];
}

void solve() {
    ll n;
    cin >> n;

    d.resize(n + 1);
    leftt.resize(n + 1);
    rightt.resize(n + 1);
    for (ll i = 0; i < n; ++i) cin >> d[i + 1];
    for (ll i = 0; i < n; ++i) cin >> leftt[i + 1];
    for (ll i = 0; i < n; ++i) cin >> rightt[i + 1];

    ll a0, b0;
    cin >> a0 >> b0;

    bool flag_di_0 = true;
    for (ll i = 1; i <= n; ++i) {
        if (d[i] != 0) {
            flag_di_0 = false;
            break;
        }
    }

    if (flag_di_0) {
        vector<ll> gh;
        for (ll i = 1; i <= n; ++i) gh.push_back(i);

        sort(all(gh), cmp);

        ll min_r = INF;
        ll ans = 0;

        for (ll i = 0; i <= n; ++i) {
            ll new_a = a0;
            if (i != n) new_a = min(a0, leftt[gh[i]]);
            ll new_b = min(b0, min_r);
            ans = max(ans, new_a + new_b);

            if (i != n) min_r = min(min_r, rightt[gh[i]]);
        }

        cout << ans;
        return;
    }

    vector<map<ll, ll>> dp(n + 1);
    dp[0][a0] = b0;

    for (ll i = 0; i < n; ++i) {
        map<ll, ll> neww;
        for (auto j : dp[i]) {
            while (neww.size() > 0 && (--neww.end())->second <= j.second) {
                neww.erase(--neww.end());
            }
            neww[j.first] = j.second;
        }
        dp[i].clear();
        for (auto j : neww) {
            ll a = j.first, b = j.second;

            dp[i + 1][min(leftt[i + 1], a + d[i + 1])] = max(dp[i + 1][min(leftt[i + 1], a + d[i + 1])], b + d[i + 1]);
            dp[i + 1][a + d[i + 1]] = max(dp[i + 1][a + d[i + 1]], min(rightt[i + 1], b + d[i + 1]));
        }
    }

    ll ans = 0;

    for (auto i : dp[n]) {
        ans = max(ans, i.first + i.second);
    }

    cout << ans;
}

int main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}
