#include "bits/stdc++.h"
#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(x) (x).begin(), (x).end()

struct dsu {
    vector<int> p;
    vector<int> sz;
    void init(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
    }
    int get(int x) {
        if (p[x] == x) {
            return p[x];
        }
        return p[x] = get(p[x]);
    }
    bool same(int a, int b) {
        return get(a) == get(b);
    }
    bool merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        return true;
    }
};


void solve(int gr) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> sta;
    set<pair<int, int>> stb;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x > y) {
            swap(x, y);
        }
        sta.insert({x, y});
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x > y) {
            swap(x, y);
        }
        stb.insert({x, y});
    }
    dsu d;
    d.init(n);
    for (auto e : sta) {
        if (stb.count(e)) {
            d.merge(e.first, e.second);
        }
    }
    vector<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (!sta.count({i, j}) && !stb.count({i, j})) {
                st.emplace_back(i, j);
                d.merge(i, j);
            }
        }
    }

}

const int inf = 1e9;
int n;
vector<int> a, b, d;
int a0, b0;

mt19937 rnd(179);
void gen() {
    n = rnd() % 10 + 1;
    a.assign(n, 0);
    b.assign(n, 0);
    d.assign(n, 0);
    for (int i = 0; i < n; i++) {
        a[i] = rnd() % 10;
        b[i] = rnd() % 10;
        d[i] = rnd() % 10;
    }
    a0 = rnd() % 10;
    b0 = rnd() % 10;
}
int smart() {

}

int stupid() {
    int bst = -1;
    for (int mask = 0; mask < (1 << n); mask++) {
        int aa = a0;
        int bb = b0;
        for (int i = 0; i < n; i++) {
            aa += d[i];
            bb += d[i];
            if (mask & (1 << i)) {
                aa = min(aa, a[i]);
            } else {
                bb = min(bb, b[i]);
            }
        }
        bst = max(bst, aa + bb);
    }
    return bst;
}
void print_test() {

}
void stress() {
    while (true) {
        auto sm = smart();
        auto st = stupid();
        if (sm == st) {
            cout << "OK" << '\n';
        } else {
            cout << "WA" << '\n';
            cout << "sm: " << sm << '\n';
            cout << "st: " << st << '\n';
            print_test();
            break;
        }
    }
}

void read() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    d.resize(n);
    for (int& i : d) {
        cin >> i;
    }
    for (int& i : a) {
        cin >> i;
    }
    for (int& i : b) {
        cin >> i;
    }
    cin >> a0 >> b0;
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    cout << stupid() << '\n';
    return 0;
    /*
     *
     5
4 0 7 0 8
10 5 3 7 7
8 5 9 2 23
4 8

     */
    int n;
    cin >> n;
    vector<int> d(n);
    for (int& i : d) {
        cin >> i;
    }
    if (d == vector<int> (n)) {
        vector<int> a(n);
        for (int& i : a) {
            cin >> i;
        }
        vector<int> b(n);
        for (int& i : b) {
            cin >> i;
        }
        int a0, b0;
        cin >> a0 >> b0;
        int ans = -inf;
        int aa = a0;
        int bb = b0;
        for (int i = 0; i < n; i++) {
            if (a[i] < aa) {
                bb = min(bb, b[i]);
            }
        }
        ans = max(ans, bb + aa);
        aa = a0;
        bb = b0;
        for (int i = 0; i < n; i++) {
            if (b[i] < bb) {
                aa = min(aa, a[i]);
            }
        }
        ans = max(ans, bb + aa);
        map<int, int> mpa;
        map<int, int> mpb;
        for (int i = 0; i < n; i++) {
            mpa[a[i]] = min(b[i], (mpa.count(a[i])) ? mpa[a[i]] : inf);
            mpb[b[i]] = min(a[i], (mpb.count(b[i])) ? mpb[b[i]] : inf);
        }
        bb = b0;
        for (auto [x, y] : mpa) {
            ans = max(ans, x + bb);
            bb = min(bb, y);
        }
        aa = a0;
        for (auto [x, y] : mpb) {
            ans = max(ans, x + aa);
            aa = min(aa, y);
        }
        cout << ans;
    }

    return 0;
}
/*
 *
 *
4
2
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5
 */