#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

const int inf = 1e9 + 100;
const int mod = 1e9 + 9;

int add(int a, int b) {
	return a + b < mod ? a + b : a + b - mod;
}

int rem(int a, int b) {
	return a - b >= 0 ? a - b : a - b + mod;
}

int mul(int a, int b) {
	return 1ll * a * b % mod;
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int bin_pow(int a, int b) {
	if (b == 0) return 1;
	if (b % 2) return 1ll * a * bin_pow(a, b - 1) % mod;
	ll z = bin_pow(a, b / 2);
	return z * z % mod;
}

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> D(n), L(n), R(n);
	cin >> D;
	cin >> L;
	cin >> R;
	set<pair<ll, ll>> st;
	int a, b;
	cin >> a >> b;
	if (accumulate(D.begin(), D.end(), 0ll) == 0ll) {
		vector<ll> prefmna(n + 1), prefmnb(n + 1), suffmna(n + 1), suffmnb(n + 1);
		prefmna[0] = min(a, L[0]);
		suffmna.back() = a;
		prefmnb[0] = min(b, R[0]);
		suffmnb.back() = b;
		for (int i = 1; i <= n; i++) {
			prefmna[i] = min(prefmna[i - 1], 1ll * L[i - 1]);
			prefmnb[i] = min(prefmnb[i - 1], 1ll * R[i - 1]);
		}
		for (int i = n - 1; i >= 0; i--) {
			suffmna[i] = min(suffmna[i + 1], 1ll * L[i]);
			suffmnb[i] = min(suffmnb[i + 1], 1ll * R[i]);
		}
		ll ans = 0;
		for (int i = 0; i <= n; i++) {
			ans = max({ ans, prefmna[i] + suffmna[i], prefmnb[i] + suffmna[i] });
		}
		cout << ans;
		exit(0);
	}
	st.insert({ a, b });
	for (int i = 0; i < n; i++) {
		set<pair<ll, ll>> n_st;
		ll mx_lft = -1, mx_rgt = -1;
		for (auto& el : st) {
			if (L[i] < el.first + D[i] && R[i] < el.second + D[i]) {
				mx_lft = max(mx_lft, el.second + D[i]);
				mx_rgt = max(mx_rgt, el.first + D[i]);
			}
			else {
				n_st.insert({ el.first + D[i], el.second + D[i] });
			}
		}
		if (mx_lft != -1) {
			n_st.insert({ L[i], mx_lft});
		}
		if (mx_rgt != -1) {
			n_st.insert({ mx_rgt, R[i] });
		}
		pair<ll, ll> prv = { -1, -1 };
		for (auto& el : n_st) {
			if (el.second >= prv.second) {
				n_st.erase(prv);
			}
			prv = el;
		}
		swap(st, n_st);
		
	}
	ll ans = 0;
	for (auto& i : st) {
		ans = max(ans, i.first + i.second);
	}
	cout << ans << '\n';


}