#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

ll n, a0, b0;
vector <ll> d, l, r;

ll check(ll min_l) {
    ll a = a0, b = b0;
    for (ll j = 0; j < n; ++j) {
        if (l[j] >= min_l) {
            a = min(a, l[j]);
        } else {
            b = min(b, r[j]);
        }
    }

    return a + b;
}

void solution() {
    cin >> n;
    vector <ll> d(n), l(n), r(n);
    d.resize(n), l.resize(n), r.resize(n);
    cin >> d >> l >> r;
    cin >> a0 >> b0;

    ll ml = l[0], mr = r[0], md = d[0];
    for (ll i = 0; i < n; ++i) {
        ml = min(ml, l[i]);
        mr = min(mr, r[i]);
        md = max(md, d[i]);
    }

    if (md == 0) {
        ll li = 0, ri = n - 1;
        while (li + 1 < ri) {
            ll mid = (li + ri) / 2;
            if (check(l[mid]) < check(l[mid + 1])) {
                li = mid;
            } else {
                ri = mid;
            }
        }

        cout << max(check(l[li]), check(l[n - 1]));
        return;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solution();

    return 0;
}
