#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

ll n, a0, b0;
vector <ll> d, l, r;

ll check(ll ned_v) {
    vector <ll> need(n + 1);
    need[n - 1] = ned_v;
    for (ll j = n - 2; j >= 0; --j) {
        need[j] = need[j + 1] - d[j + 1];
    }

    bool f = false;
    ll a = a0, b = b0;
    for (ll j = 0; j < n; ++j) {
        a += d[j], b += d[j];
        if (a < need[j]) {
            f = true;
            break;
        }
        if (min(a, l[j]) < need[j]) {
            b = min(b, r[j]);
        } else {
            a = min(a, l[j]);
        }
    }

    if (f) {
        return 0;
    }

    return a + b;
}

void solution() {
    cin >> n;
    d.resize(n), l.resize(n), r.resize(n);
    cin >> d >> l >> r;
    cin >> a0 >> b0;

    ll ml = l[0], mr = r[0], md = d[0];
    for (ll i = 0; i < n; ++i) {
        ml = min(ml, l[i]);
        mr = min(mr, r[i]);
        md = max(md, d[i]);
    }

    ll dsm = d[0];
    vector <ll> pref(n + 57);
    pref[0] = d[0];
    for (ll i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + d[i];
        dsm += d[i];
    }

    ll bb = b0;
    for (ll i = 0; i < n; ++i) {
        bb += d[i];
        bb = min(bb, r[i]);
    }
    ll ans = a0 + dsm + bb;

    vector <ll> tmp(n);
    for (ll i = 0; i < n; ++i) {
        tmp[i] = l[i] + dsm - pref[i];
    }

    sort(all(tmp));

    ll li = 0, ri = n - 1;
    while (li + 1 < ri) {
        ll mid = li + ri / 2;
        if (check(tmp[mid]) < check(tmp[mid + 1])) {
            li = mid;
        } else {
            ri = mid;
        }
    }

    ans = max(ans, check(tmp[li]));
    ans = max(ans, check(tmp[ri]));
    ans = max(ans, check(tmp[n - 1]));

    cout << ans;

//    ll ans = 0;
//    get_ans(0, a0, b0, ans);
//    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solution();

    return 0;
}
