#ifndef BUY
#pragma GCC optimize("Ofast")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;
#define int long long
using pii = pair <int, int>;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

constexpr int INF = 1e15;

struct SegTree {
private:
    vector <int> mx;
    vector <int> mn;
    vector <pii> fl;
    vector <int> t;
    int n;

    void upd(int i) {
        mx[i] = max(mx[2 * i], mx[2 * i + 1]);
        mn[i] = min(mn[2 * i], mn[2 * i + 1]);
    }

    void set(int i, int x) {
        mn[i] = mx[i] = x;
        fl[i].ss = 0;
        fl[i].ff = x;
        t[i] = 1;
    }

    void add(int i, int x) {
        if (t[i] == 1) {
            fl[i].ff += x;
        } else {
            t[i] = 2;
            fl[i].ss += x;
        }
        mx[i] += x;
        mn[i] += x;
    }

    void push(int i) {
        if (t[i] == 1) {
            set(2 * i, fl[i].ff);
            set(2 * i + 1, fl[i].ff);
        } else if (t[i] == 2) {
            add(2 * i, fl[i].ss);
            add(2 * i + 1, fl[i].ss);
            fl[i].ss = 0;
        }
        t[i] = 0;
    }

    void set(int ql, int qr, int x, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return;
        }
        if (ql <= l && r <= qr) {
            set(i, x);
            return;
        }
        push(i);
        int m = (l + r) / 2;
        set(ql, qr, x, l, m, 2 * i);
        set(ql, qr, x, m, r, 2 * i + 1);
        upd(i);
    }

    void minravno(int ql, int qr, int x, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r || mx[i] <= x) {
            return;
        }
        if (ql <= l && r <= qr && mn[i] >= x) {
            set(i, x);
            return;
        }
        push(i);
        int m = (l + r) / 2;
        minravno(ql, qr, x, l, m, 2 * i);
        minravno(ql, qr, x, m, r, 2 * i + 1);
        upd(i);
    }

    void add(int ql, int qr, int x, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return;
        }
        if (ql <= l && r <= qr) {
            return add(i, x);
        }
        push(i);
        int m = (l + r) / 2;
        add(ql, qr, x, l, m, 2 * i);
        add(ql, qr, x, m, r, 2 * i + 1);
        upd(i);
    }

    int getmx(int ql, int qr, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return -INF;
        }
        if (ql <= l && r <= qr) {
            return mx[i];
        }
        push(i);
        int m = (l + r) / 2;
        return max(getmx(ql, qr, l, m, 2 * i),
            getmx(ql, qr, m, r, 2 * i + 1));
    }

public:
    explicit SegTree(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        mx.resize(2 * n, -INF);
        mn.resize(2 * n, -INF);
        t.resize(2 * n, 0);
        fl.resize(2 * n);
    }

    void upd(int i, int x) {
        int cur = 1;
        int l = 0, r = n;
        while (cur < n) {
            int m = (l + r) / 2;
            push(cur);
            if (i >= m) {
                cur = cur * 2 + 1;
                l = m;
            } else {
                cur = cur * 2;
                r = m;
            }
        }
        mxr(mx[cur], x);
        mxr(mn[cur], x);
        while (cur >>= 1) {
            upd(cur);
        }
    }

    int get(int i) {
        int cur = 1;
        int l = 0, r = n;
        while (cur < n) {
            int m = (l + r) / 2;
            push(cur);
            if (i >= m) {
                cur = cur * 2 + 1;
                l = m;
            } else {
                r = m;
                cur = cur * 2;
            }
        }
        return mx[cur];
    }

    int getmx(int ql, int qr) {
        return getmx(ql, qr, 0, n, 1);
    }

    void add(int ql, int qr, int x) {
        return add(ql, qr, x, 0, n, 1);
    }

    void minravno(int ql, int qr, int x) {
        return minravno(ql, qr, x, 0, n, 1);
    }

    void set(int ql, int qr, int x) {
        return set(ql, qr, x, 0, n, 1);
    }
};

void solve(int g = 0) {
    int n;
    cin >> n;
    vector <int> d(n), l(n), r(n);
    for (auto &i : d) {
        cin >> i;
    }
    for (auto &i : l) {
        cin >> i;
    }
    for (auto &i : r) {
        cin >> i;
    }
    int a0, b0;
    cin >> a0 >> b0;
    vector <int> dp(n + 1, -INF);
    vector <int> pp = d;
    for (int i = 1; i < n; ++i) {
        pp[i] += pp[i - 1];
    }
    vector <int> funnyValues = {a0};
    for (int i = 0; i < n; ++i) {
        funnyValues.push_back(l[i] - pp[i]);
//        cerr << funnyValues.back() << " ";
    }
//    cerr << "\n";
    sort(all(funnyValues));
    funnyValues.resize(unique(all(funnyValues)) - funnyValues.begin());
    auto gets= [&](int l, int r) {
        return pp[r] - (l ? pp[l - 1] : 0);
    };
//    cerr << "f: ";
//    for (auto i : funnyValues) {
//        cerr << i << " ";
//    }
//    cerr << "\n";
    int m = sz(funnyValues);
    SegTree seg(m);
    auto getid = [&](int t) {
        return lower_bound(all(funnyValues), t) - funnyValues.begin();
    };
    seg.upd(getid(a0), b0);

//    for (int i = 1; i <= n; ++i) {
//        vector <int> dp2(n + 1, -INF);
//        for (int k = 0; k < i; ++k) {
//            int curb = dp[k] + d[i - 1];
//            int cura = (k == 0 ? a0 : l[k - 1]);
//            cura += gets(k, i - 1);
//            if (cura >= l[i - 1]) {
//                mxr(dp2[i],  curb);
//            } else {
//                mxr(dp2[k], curb);
//            }
//            mxr(dp2[k], min(curb, r[i - 1]));
//        }
//        dp2.swap(dp);
//    }


//    for (int j = 0; j < m; ++j) {
//        cerr << seg.get(j) << " ";
//    }
//    cerr << "\n";
    for (int i = 1; i <= n; ++i) {
        auto it = upper_bound(all(funnyValues), l[i - 1] - pp[i - 1]) - funnyValues.begin();
//        cerr << "it: " << it << "\n";
        int pt = seg.getmx(it, m) + d[i - 1];
        seg.add(0, m, d[i - 1]);
        seg.minravno(it, m, r[i - 1]);
        seg.upd(getid(l[i - 1] - pp[i - 1]), pt);
//        for (int j = 0; j < m; ++j) {
//            cerr << seg.get(j) << " ";
//        }
//        cerr << "\n";
    }
//    cerr << "\n\n\n\n\n\n";

    int res = 0;
    for (int i = 0; i < m; ++i) {
        int curb = seg.get(i);
        int cura = funnyValues[i] + pp.back();
//        cerr << cura << " " << curb << " " << funnyValues[i] << "\n";
        mxr(res, cura + curb);
    }
    cout << res;
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef BUY
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
#ifdef BUY
    cerr << "\n";
#endif
}