#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

ll t[4 * MAXN];
ll add[4 * MAXN];

void push(ll v, ll l, ll r) {
    if (add[v] != -INF) {
        t[v] = min(add[v], t[v]);
        if (l + 1 != r) {
            add[2 * v + 1] = min(add[2 * v + 1], add[v]);
            add[2 * v + 2] = min(add[2 * v + 2], add[v]);
        }
    }
    add[v] = -INF;
}

void upd(ll v, ll l, ll r, ll ql, ll qr, ll val) {
    push(v, l, r);
    if (r <= ql || l >= qr) {
        return;
    } else if (ql <= l && r <= qr) {
        add[v] = val;
        push(v, l, r);
    } else {
        ll m = (l + r) / 2;
        upd(2 * v + 1, l, m, ql, qr, val);
        upd(2 * v + 2, m, r, ql, qr, val);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    push(v, l, r);
    if (r <= ql || l >= qr) {
        return -INF;
    } else if (ql <= l && r <= qr) {
        return t[v];
    } else {
        ll m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
}

void build(ll v, ll l, ll r) {
    add[v] = -INF;
    if (l + 1 == r) {
        t[v] = -INF;
    } else {
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
}

void postav(ll v, ll l, ll r, ll pos, ll val) {
    push(v, l, r);
    if (l + 1 == r) {
        t[v] = val;
    } else {
        ll m = (l + r) / 2;
        if (pos < m) {
            postav(2 * v + 1, l, m, pos, val);
        } else {
            postav(2 * v + 2, m, r, pos, val);
        }
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
}

void solve() {
    ll n;
    cin >> n;
    ll d[n + 1];
    for (ll i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    ll l[n + 1], r[n + 1];
    for (ll i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (ll i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    ll prefd[n + 1];
    prefd[0] = 0;
    for (ll i = 1; i <= n; ++i) {
        prefd[i] = prefd[i - 1] + d[i];
    }
    cin >> l[0] >> r[0];
    if (n <= 5000) {
        vector<ll> dp(n + 1, -INF);
        dp[0] = r[0];
        for (ll step = 1; step <= n; ++step) {
            vector<ll> ndp(n + 1, -INF);
            for (ll i = 0; i < step; ++i) {
                if (l[i] + prefd[step] - prefd[i] >= l[step]) {
                    ndp[i] = min(r[step], dp[i] + d[step]);
                    ndp[step] = max(ndp[step], dp[i] + d[step]);
                } else {
                    ndp[i] = max(ndp[i], dp[i] + d[step]);
                }
            }
            dp = ndp;
        }
        ll ans = -INF;
        for (ll i = 0; i <= n; ++i) {
            ans = max(ans, dp[i] + l[i] + prefd[n] - prefd[i]);
        }
        cout << ans << '\n';
    } else {
        vector<ll> ind(n + 1);
        for (ll i = 0; i <= n; ++i) {
            ind[i] = i;
        }
        sort(ind.begin(), ind.end(), [&](ll i, ll j) {
            if (l[i] - prefd[i] == l[j] - prefd[j]) {
                return i > j;
            }
            return l[i] - prefd[i] < l[j] < prefd[j];
        });
        vector<ll> mest(n + 1);
        for (ll i = 0; i <= n; ++i) {
            mest[ind[i]] = i;
        }
        build(0, 0, n + 1);
        postav(0, 0, n + 1, mest[0], r[0]);
        for (ll step = 1; step <= n; ++step) {
            ll m = mest[step];
            upd(0, 0, n + 1, m + 1, n + 1, r[step]);
            postav(0, 0, n + 1, m, get(0, 0, n + 1, m + 1, n + 1));
        }
        ll ans = -INF;
        for (ll i = 0; i <= n; ++i) {
            ans = max(ans, get(0, 0, n + 1, mest[i], mest[i + 1]) + l[i] + prefd[n] - prefd[i]);
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
