#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = (long long)1e18 + 7;

constexpr int R = 1 << 17;

long long add[R * 2], psh_mn[R * 2];

long long mx[R * 2];

void push(int node) {
    if (add[node] != 0) {
        add[node * 2] += add[node];
        psh_mn[node * 2] += add[node];
        mx[node * 2] += add[node];

        add[node * 2 + 1] += add[node];
        psh_mn[node * 2 + 1] += add[node];
        mx[node * 2 + 1] += add[node];
    }
    add[node] = 0;

    if (psh_mn[node] < inf) {
        psh_mn[node * 2] = min(psh_mn[node * 2], psh_mn[node]);
        mx[node * 2] = min(mx[node * 2], psh_mn[node]);

        psh_mn[node * 2 + 1] = min(psh_mn[node * 2 + 1], psh_mn[node]);
        mx[node * 2 + 1] = min(mx[node * 2 + 1], psh_mn[node]);
    }
    psh_mn[node] = inf;
}

void add_segm(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        add[node] += val;
        psh_mn[node] += val;
        mx[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    add_segm(ql, qr, val, node * 2, nl, nm);
    add_segm(ql, qr, val, node * 2 + 1, nm, nr);
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
}

void assign_min(int ql, int qr, long long val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        psh_mn[node] = min(psh_mn[node], val);
        mx[node] = min(mx[node], val);
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    assign_min(ql, qr, val, node * 2, nl, nm);
    assign_min(ql, qr, val, node * 2 + 1, nm, nr);
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
}

void assign_pos(int pos, long long val, int node = 1, int nl = 0, int nr = R) {
    if (pos <= nl && nr <= pos + 1) {
        add[node] = 0;
        psh_mn[node] = inf;
        mx[node] = val;
        return;
    }
    if (pos + 1 <= nl || nr <= pos) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    assign_pos(pos, val, node * 2, nl, nm);
    assign_pos(pos, val, node * 2 + 1, nm, nr);
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
}

long long get_max(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return mx[node];
    }
    if (qr <= nl || nr <= ql) {
        return -inf;
    }
    push(node);
    int nm = (nl + nr) / 2;
    auto ans = max(get_max(ql, qr, node * 2, nl, nm), get_max(ql, qr, node * 2 + 1, nm, nr));
    mx[node] = max(mx[node * 2], mx[node * 2 + 1]);
    return ans;
}

constexpr int maxn = 5005;

long long dp[maxn][maxn];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = -inf;
        }
    }
    vector<long long> d(n + 1), l(n + 1), r(n + 1), pr(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        pr[i + 1] = pr[i] + d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    vector<int> ord(n + 1);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return l[i] + (pr[n] - pr[i]) < l[j] + (pr[n] - pr[j]);
    });
    vector<int> pos(n + 1);
    for (int i = 0; i <= n; ++i) {
        pos[ord[i]] = i;
    }
    for (int i = 0; i <= n; ++i) {
        assign_pos(i, -inf);
    }
    assign_pos(pos[0], r[0]);
    dp[0][0] = r[0];
    for (int i = 0; i < n; ++i) {
        long long vl = get_max(pos[i + 1], n + 1) + d[i];
        add_segm(0, n + 1, d[i]);
        assign_min(pos[i + 1] + 1, n + 1, r[i + 1]);
        // cout << r[i + 1] << ' ' << get_max(pos[i + 1] + 1, pos[i + 1] + 2) << '\n';
        if (get_max(pos[i + 1], pos[i + 1] + 1) < vl) {
            assign_pos(pos[i + 1], vl);
        }
        // for (int j = 0; j <= i; ++j) {
        //     if (l[j] + (pr[i + 1] - pr[j]) <= l[i + 1]) {
        //         dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i]);
        //     } else {
        //         dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i][j] + d[i]);
        //     }
        //     if (dp[i][j] + d[i] <= r[i + 1]) {
        //         dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i]);
        //     } else {
        //         dp[i + 1][j] = max(dp[i + 1][j], r[i + 1]);
        //     }
        // }
        // for (int j = 0; j <= n; ++j) {
        //     cout << '(' << ord[j] << ' ' << get_max(j, j + 1) << ' ' << dp[i + 1][ord[j]] << ')' << ' ';
        // }
        // cout << '\n';
    }
    long long ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, l[i] + (pr[n] - pr[i]) + get_max(pos[i], pos[i + 1]));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
