#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 2e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<ll, ll, ll>;

ll n;
vector<ll> d, l, r;
ll a0, b0;

void solve1() {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ll A = a0, B = b0;
        for (int i = 0; i < n; ++i) {
            A += d[i];
            B += d[i];

            if ((mask >> i) & 1) {
                B = min(B, r[i]);
            } else {
                A = min(A, l[i]);
            }
        }

        ans = max(ans, A + B);
    }
    cout << ans << '\n';
}

void solve() {
    vector<pair<ll, ll>> dp(2);
    dp[0] = dp[1] = {a0, b0};

    for (int i = 0; i < n; ++i) {
        vector<pair<ll, ll>> nw(2);
        if (nw[0].first + nw[0].second < min(dp[0].first + d[i], l[i]) + dp[0].second + d[i]) {
            nw[0] = {min(dp[0].first + d[i], l[i]), dp[0].second + d[i]};
        }

        if (nw[1].first + nw[1].second < dp[0].first + d[i] + min(dp[0].second + d[i], r[i])) {
            nw[1] = {dp[0].first + d[i], min(dp[0].second + d[i], r[i])};
        }

        if (nw[0].first + nw[0].second < min(dp[1].first + d[i], l[i]) + dp[1].second + d[i]) {
            nw[0] = {min(dp[1].first + d[i], l[i]), dp[1].second + d[i]};
        }

        if (nw[1].first + nw[1].second < dp[1].first + d[i] + min(dp[1].second + d[i], r[i])) {
            nw[1] = {dp[1].first + d[i], min(dp[1].second + d[i], r[i])};
        }
        dp = nw;
    }

    cout << max(dp[0].first + dp[0].second, dp[1].first + dp[1].second);
}

void start() {
    cin >> n;
    d.assign(n, 0);
    l.assign(n, 0);
    r.assign(n, 0);

    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> r[i];
    }

    cin >> a0 >> b0;

    solve();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

    while (T --> 0) {
        start();
    }

    return 0;
}
