#include <iostream>
#include <algorithm>
using namespace std;
using ll = long long;

const ll inf = 1e18;

struct par
{
    ll x;
    int i;
};

bool comp(par a, par b)
{
    if(a.x == b.x) return a.i < b.i;
    else return a.x > b.x;
}

ll *ma;
ll *st;
int k;

void set(int v, ll x, int i = 1, int l = 0, int r = k - 1)
{
    st[i] = min(st[i], ma[i]);
    if(v < l || r < v) return;
    if(l == r){
        st[i] = x;
        return;
    }
    int m = (l + r)/2;
    ma[2*i] = min(ma[2*i], ma[i]);
    ma[2*i + 1] = min(ma[2*i + 1], ma[i]);
    set(v, x, 2*i, l, m);
    set(v, x, 2*i + 1, m + 1, r);
    st[i] = max(st[2*i], st[2*i + 1]);
}

void min_eq(int a, ll x, int i = 1, int l = 0, int r = k - 1)
{
    st[i] = min(st[i], ma[i]);
    if(a < l) return;
    if(r <= a){
        ma[i] = min(ma[i], x);
        st[i] = min(st[i], ma[i]);
        return;
    }
    int m = (l + r)/2;
    ma[2*i] = min(ma[2*i], ma[i]);
    ma[2*i + 1] = min(ma[2*i + 1], ma[i]);
    min_eq(a, x, 2*i, l, m);
    min_eq(a, x, 2*i + 1, m + 1, r);
    st[i] = max(st[2*i], st[2*i + 1]);
}

ll get_max(int a, int b, int i = 1, int l = 0, int r = k - 1)
{
    st[i] = min(st[i], ma[i]);
    if(b < l || r < a) return -inf;
    if(a <= l && r <= b) return st[i];
    int m = (l + r)/2;
    ma[2*i] = min(ma[2*i], ma[i]);
    ma[2*i + 1] = min(ma[2*i + 1], ma[i]);
    return max(get_max(a, b, 2*i, l, m), get_max(a, b, 2*i + 1, m + 1, r));
}

int main()
{
    int n;
    cin >> n;
    int *d = new int[n];
    for(int i = 0; i < n; ++i) cin >> d[i];
    ll *l = new ll[n + 1];
    for(int i = 1; i <= n; ++i) cin >> l[i];
    ll *r = new ll[n + 1];
    for(int i = 1; i <= n; ++i) cin >> r[i];
    ll b0;
    cin >> l[0] >> b0;
    ll s = 0;
    for(int i = 0; i < n; ++i){
        s += d[i];
        l[i + 1] -= s;
        r[i + 1] -= s;
    }
    par *v = new par[n + 1];
    for(int i = 0; i <= n; ++i) v[i] = {l[i], i};
    sort(v, v + n + 1, comp);
    int *ind = new int[n + 1];
    for(int i = 0; i <= n; ++i) ind[v[i].i] = i;
    k = n + 1;
    ma = new ll[4*k];
    st = new ll[4*k];
    for(int i = 0; i < 4*k; ++i){
        ma[i] = inf;
        st[i] = -inf;
    }
    set(ind[0], b0);
    for(int i = 1; i <= n; ++i){
        set(ind[i], get_max(0, ind[i] - 1));
        min_eq(ind[i] - 1, r[i]);
    }
    ll ans = -inf;
    for(int i = 0; i <= n; ++i){
        ans = max(ans, l[i] + get_max(ind[i], ind[i]));
    }
    cout << ans + 2*s << endl;
    return 0;
}