#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif
#define int long long

using ll = long long;
using namespace std;

namespace st {
    static constexpr int size = 1 << 17;
    static constexpr int no = LLONG_MAX;

    struct node {
        int max = LLONG_MIN;
        int op = no;
    };

    node tree[size * 2 - 1];

    void apply(int x, int y) {
        tree[x].max = min(tree[x].max, y);
        tree[x].op = min(tree[x].op, y);
    }

    void push(int x) {
        if (tree[x].op != no) {
            apply(x * 2 + 1, tree[x].op);
            apply(x * 2 + 2, tree[x].op);
            tree[x].op = no;
        }
    }

    int get(int l, int r = size, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x].max;
        }

        if (l >= rx || lx >= r) {
            return LLONG_MIN;
        }

        push(x);

        return max(
            get(l, r, x * 2 + 1, lx, (lx + rx) / 2),
            get(l, r, x * 2 + 2, (lx + rx) / 2, rx)
        );
    }

    void set(int i, int v, int x = 0, int lx = 0, int rx = size) {
        if (rx - lx == 1) {
            tree[x].max = v;
            return;
        }

        push(x);

        if (i < (lx + rx) / 2) {
            set(i, v, x * 2 + 1, lx, (lx + rx) / 2);
        } else {
            set(i, v, x * 2 + 2, (lx + rx) / 2, rx);
        }

        tree[x].max = max(tree[x * 2 + 1].max, tree[x * 2 + 2].max);
    }

    void mnq(int l, int r, int v, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            apply(x, v);
            return;
        }

        if (l >= rx || lx >= r) {
            return;
        }

        push(x);

        mnq(l, r, v, x * 2 + 1, lx, (lx + rx) / 2);
        mnq(l, r, v, x * 2 + 2, (lx + rx) / 2, rx);

        tree[x].max = max(tree[x * 2 + 1].max, tree[x * 2 + 2].max);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }

    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }

    map<int, int> p;
    int a0, b0;
    cin >> a0 >> b0;

    st::set(a0, b0);

    set<int> xs = {a0};
    for (int i = 0, sumd = 0; i < n; i++) {
        sumd += d[i];
        xs.insert(l[i] - sumd);
    }

    vector<int> X(xs.begin(), xs.end());

    int sumd = 0;

    for (int i = 0; i < n; i++) {
        sumd += d[i];

        auto j = lower_bound(X.begin(), X.end(), l[i] - sumd) - X.begin();

        int mx = st::get(j);
        st::mnq(j, st::size, r[i] - sumd);

        if (mx != LLONG_MIN) {
            st::set(j, mx);
        }
    }

    int ans = LLONG_MIN;

    for (int i = 0; i < (int)X.size(); i++) {
        ans = max(ans, X[i] + st::get(i, i + 1));
    }

    cout << ans + sumd * 2  << '\n';
    return 0;
}
