#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const ll INF = 1e18;
const int INF2 = 1e9;

struct segTree {
	int size;
	vector<int> tree, push;

	void init(int n) {
		size = 1;
		while (size < n)
			size *= 2;
		tree.resize(2 * size - 1, -INF2);
		push.resize(2 * size - 1, INF2);
	}
	void make_push(int x) {
		if (push[x] == INF2)
			return;
		push[2 * x + 1] = min(push[2 * x + 1], push[x]);
		tree[2 * x + 1] = min(tree[2 * x + 1], push[x]);
		push[2 * x + 2] = min(push[2 * x + 2], push[x]);
		tree[2 * x + 2] = min(tree[2 * x + 2], push[x]);
		push[x] = INF2;
	}
	void upd2(int x, int lx, int rx, int pos, int val) {
		if (lx + 1 == rx) {
			tree[x] = val;
			return;
		}
		int mid = (lx + rx) / 2;
		if (mid > pos)
			upd2(2 * x + 1, lx, mid, pos, val);
		else
			upd2(2 * x + 2, mid, rx, pos, val);
	}
	void upd(int x, int lx, int rx, int l, int r, int val) {
		if (lx >= l && rx <= r) {
			tree[x] = min(tree[x], val);
			push[x] = min(push[x], val);
			return;
		}
		if (lx >= r || rx <= l)
			return;
		int mid = (lx + rx) / 2;
		make_push(x);
		upd(2 * x + 1, lx, mid, l, r, val);
		upd(2 * x + 2, mid, rx, l, r, val);
	}
	int get_val(int x, int lx, int rx, int pos) {
		if (lx + 1 == rx) {
			return tree[x];
		}
		int mid = (lx + rx) / 2;
		make_push(x);
		if (mid > pos)
			return get_val(2 * x + 1, lx, mid, pos);
		else
			return get_val(2 * x + 2, mid, rx, pos);
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	ll a0, b0;
	for (int i = 1; i <= n; ++i)
		cin >> d[i];
	for (int i = 1; i <= n; ++i)
		cin >> l[i];
	for (int i = 1; i <= n; ++i)
		cin >> r[i];
	cin >> a0 >> b0;
	if (n <= 15) {
		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ll a = a0, b = b0;
			for (int i = 1; i <= n; ++i) {
				a += d[i]; b += d[i];
				if ((mask >> (i - 1)) & 1) {
					a = min(a, l[i]);
				}
				else {
					b = min(b, r[i]);
				}
			}
			ans = max(ans, a + b);
		}
		cout << ans;
	}
	else {
		vector<int> l2;
		l2.push_back(a0);
		for (int i = 1; i <= n; ++i)
			l2.push_back(l[i]);
		sort(l2.begin(), l2.end());
		l2.resize(unique(l2.begin(), l2.end()) - l2.begin());
		unordered_map<int, int> dict;
		for (int i = 0; i < l2.size(); ++i)
			dict[l2[i]] = i;
		vector<int> l12(n + 1);
		for (int i = 1; i <= n; ++i)
			l12[i] = dict[l[i]];
		segTree tr;
		tr.init(l2.size());
		for (int i = 0; i <= dict[a0]; ++i) {
			tr.upd2(0, 0, tr.size, i, b0);
		}
		for (int i = 1; i <= n; ++i) {
			tr.upd(0, 0, tr.size, l12[i] + 1, l2.size(), r[i]);
		}
		int ans = 0;
		for (int i = 0; i < l2.size(); ++i) {
			int x = l2[i];
			ans = max(ans, tr.get_val(0, 0, tr.size, i) + x);
		}
		cout << ans;
	}

	return 0;
}