#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long 

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e18;
const int N = 1e5 + 10;
ll t[4 * N];

void update(int v, int tl, int tr, int l, int r, ll val) {
	if (l > r) return;
	if (tl == l && tr == r) {
		t[v] = min(t[v], val);
		return;
	}
	int tm = (tl + tr) / 2;
	update(2 * v, tl, tm, l, min(r, tm), val);
	update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
}

ll get(int v, int l, int r, int pos) {
	if (l == r) {
		return t[v];
	}
	int m = (l + r) / 2;
	if (pos <= m) {
		return min(t[v], get(2 * v, l, m, pos));
	} else {
		return min(t[v], get(2 * v + 1, m + 1, r, pos));
	}
}

ll solve(int n, vector<ll> l, vector<ll> r, vector<ll> pr, vector<ll> d) {
	for (int i = 0; i < 4 * N; i++) {
		t[i] = INF;
	}
	vector<ll> u;
	for (int i = 0; i <= n; i++) {
		u.pb(l[i] - pr[i]);
	}
	sort(all(u));
	u.erase(unique(all(u)), u.end());
	ll ans = -INF;
	int sz = u.size();
	for (int i = n; i >= 1; i--) {
		int ind = lower_bound(all(u), l[i] - pr[i]) - u.begin();
		for (int j = 0; j < i; j++) {
			bool good = 1;
			good &= l[0] + pr[i] >= l[i];
			good &= r[0] + pr[j] >= r[j];
			for (int k = 1; k < j; k++) {
				good &= (l[k] + pr[i] - pr[k] >= l[i]) || (r[k] + pr[j] - pr[k] >= r[j]);
			}
			for (int k = j + 1; k < i; k++) {
				good &= r[j] - pr[j] <= r[k] - pr[k];
			}
			for (int k = i + 1; k <= n; k++) {
				good &= (r[j] + pr[k] - pr[j] <= r[k]) && (l[i] + pr[k] - pr[i] <= l[k]);
			}
			if (good) {
				ans = max(ans, l[i] - pr[i] + r[j] - pr[j]);
			} 
		}
		int k = upper_bound(all(u), l[i] - pr[i]) - u.begin();
		update(1, 0, sz - 1, k, sz - 1, r[i] - pr[i]);
	}
	return ans;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<ll> l(n + 1), r(n + 1), d(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> l[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> r[i];
	}
	cin >> l[0] >> r[0];
	vector<ll> pr(n + 1);
	for (int i = 1; i <= n; i++) {
		pr[i] = pr[i - 1] + d[i - 1];
	}
	cout << max(solve(n, l, r, pr, d), solve(n, r, l, pr, d)) + 2 * pr[n] << endl;
	return 0;
}