#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
int rnd() {return abs((int) rng());}

constexpr long long N = 1.5e7;
constexpr long long T = 20;
constexpr long long A = 300;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);

    for (int i = 1; i < n + 1; i++) cin >> d[i];
    for (int i = 1; i < n + 1; i++) cin >> l[i];
    for (int i = 1; i < n + 1; i++) cin >> r[i];

    int sa, sb;
    cin >> sa >> sb;

    vector<int> pd(n + 1, 0);
    for (int i = 1; i < n + 1; i++) pd[i] = pd[i - 1] + d[i];

    int ans = 0;
    for (int i = 0; i < n + 1; i++) {
        vector<int> a(n + 1, 0), b(n + 1, 0);
        a[0] = sa; b[0] = sb;
        for (int j = 1; j <= i; j++) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];

            a[j] = min(a[j], l[j]);
        }
        
        for (int j = i + 1; j <= n; j++) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];

            b[j] = min(b[j], r[j]);
        }

        ans = max(ans, a[n] + b[n]);

        
        a[0] = sa; b[0] = sb;
        for (int j = 1; j <= i; j++) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];

            b[j] = min(b[j], r[j]);
        }
        
        for (int j = i + 1; j <= n; j++) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];

            a[j] = min(a[j], l[j]);
        }

        ans = max(ans, a[n] + b[n]);

        // cout << a << " | " << b << endl;
    }

    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stderr);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}