#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);

    for (int i = 1; i < n + 1; i++) cin >> d[i];
    for (int i = 1; i < n + 1; i++) cin >> l[i];
    for (int i = 1; i < n + 1; i++) cin >> r[i];

    int sa, sb;
    cin >> sa >> sb;

    vector<int> pd(n + 1, 0);
    for (int i = 1; i < n + 1; i++) pd[i] = pd[i - 1] + d[i];

    vector<pair<int, int>> dpa(n + 1, {0, 0}), dpb(n + 1, {0, 0});

    for (int i = 1; i < n + 1; i++) {
        int ca = sa, cb = sb;

        for (int j = 1; j <= i; j++) {
            ca += d[j];
            cb += d[j];

            if (min(l[j], ca) + pd[i] - pd[j] >= l[i]) {
                ca = min(l[j], ca);
            } else {
                cb = min(cb, r[j]);
            }
        }

        dpa[i] = {ca, cb};

        ca = sa, cb = sb;

        for (int j = 1; j <= i; j++) {
            ca += d[j];
            cb += d[j];

            if (min(r[j], cb) + pd[i] - pd[j] >= r[i]) {
                cb = min(r[j], cb);
            } else {
                ca = min(ca, l[j]);
            }
        }

        dpb[i] = {ca, cb};
    }
    int ans = -1;

    for (int i = 1; i < n + 1; i++) {
        auto [ca, cb] = dpa[i];

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];

            ca = min(ca, l[j]);
        }

        ans = max(ans, ca + cb);
    }

    for (int i = 1; i < n + 1; i++) {
        auto [ca, cb] = dpa[i];

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];

            cb = min(cb, r[j]);
        }

        ans = max(ans, ca + cb);
    }

    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}