#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long inf = 1e18;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);

    for (int i = 1; i < n + 1; i++) cin >> d[i];
    for (int i = 1; i < n + 1; i++) cin >> l[i];
    for (int i = 1; i < n + 1; i++) cin >> r[i];

    vector<int> pd(n + 1, 0);
    for (int i = 1; i < n + 1; i++) {
        pd[i] = pd[i - 1] + d[i];
    }

    int sa, sb;
    cin >> sa >> sb;

    l[0] = sa;
    r[0] = sb;
    
    vector<pair<int, int>> dpa(n + 1, pair<int, int> (0, 0));
    vector<pair<int, int>> dpb(n + 1, pair<int, int> (0, 0));
    dpa[0] = {sa, sb};
    dpb[0] = {sa, sb};

    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < i; j++) {
            auto [ca, cb] = dpa[i];
            for (int t = j + 1; t <= i; t++) {
                ca += d[t];
                cb += d[t];

                cb = min(cb, r[t]);
            }

            if (ca >= l[i]) {
                if (dpa[i].second < cb) {
                    dpa[i] = {ca, cb};
                }
            }
        }

        for (int j = 0; j < i; j++) {
            auto [ca, cb] = dpa[i];
            for (int t = j + 1; t <= i; t++) {
                ca += d[t];
                cb += d[t];

                ca = min(ca, l[t]);
            }

            if (cb >= r[i]) {
                if (dpa[i].second < ca) {
                    dpa[i] = {ca, cb};
                }
            }
        }

        dpa[i].first = min(dpa[i].first, l[i]);
        dpb[i].second = min(dpb[i].second, r[i]);
    }
    int ans = 0;
    int ca = sa, cb = sb;
    for (int i = 1; i < n; i++) {
        ca += d[i];
        cb += d[i];
        ca = min(ca, l[i]);
    }
    ans = ca + cb;

    for (int i = 0; i < n + 1; i++) {
        ca = dpa[i].first, cb = dpa[i].second;

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];
            ca = min(ca, l[j]);
        }
        ans = max(ans, ca + cb);

        ca = dpa[i].first, cb = dpa[i].second;

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];
            cb = min(cb, r[j]);
        }
        ans = max(ans, ca + cb);
        
        ca = dpb[i].first, cb = dpb[i].second;

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];
            ca = min(ca, l[j]);
        }
        ans = max(ans, ca + cb);

        ca = dpb[i].first, cb = dpb[i].second;

        for (int j = i + 1; j < n + 1; j++) {
            ca += d[j];
            cb += d[j];
            cb = min(cb, r[j]);
        }
        ans = max(ans, ca + cb);
    }

    // cout << dpa << endl << dpb << endl;

    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}