#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, sa, sb;
vector<int> d, l, r;

void clear() {
    d.clear();
    l.clear();
    r.clear();
}

void resize() {
    d.resize(n);
    l.resize(n);
    r.resize(n);
}

void solve5() {
    vector<pii> arr(n);
    for (int i = 0; i < n; ++i) {
        arr[i] = {l[i], r[i]};
    }
    arr.push_back({sa, sb});
    sort(all(arr));
    int ans = 0;
    int mi = INT_MAX;
    for (int i = 0; i < n; ++i) {
        if (arr[i].first > sa) {
            break;
        }
        int a_val = arr[i].first;
        int b_val = min(sb, mi);
        ans = max(ans, a_val + b_val);
        mi = min(mi, arr[i].second);
    }
    cout << ans << endl;
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    cin >> n;

    resize();

    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    cin >> sa >> sb;

    bool g5 = true;

    for (int i = 0; i < n; ++i) {
        if (d[i] != 0) {
            g5 = false;
            break;
        }
    }

    if (g5) {
        solve5();
    }

    return 0;
}