#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#include <unordered_map>
// #define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, sa, sb;
vector<int> d, l, r;

void resize() {
    d.resize(n);
    l.resize(n);
    r.resize(n);
}

void solve5() {
    vector<pii> arr(n);
    for (int i = 0; i < n; ++i) {
        arr[i] = {l[i], r[i]};
    }
    arr.push_back({sa, sb});
    sort(all(arr));
    int ans = 0;
    int mi = INT_MAX;
    int cache = INT_MAX;
    int cache_type = -1;
    for (int i = 0; i < n; ++i) {
        if (arr[i].first != cache_type) {
            mi = min(mi, cache);
            cache_type = arr[i].first;
            cache = INT_MAX;
        }
        int a_val = min(sa, arr[i].first);
        int b_val = min(sb, mi);
        ans = max(ans, a_val + b_val);
        cache = min(cache, arr[i].second);
    }
    mi = min(mi, cache);
    ans = max(ans, sa + min(sb, mi));
    cout << ans << endl;
}

void solve4() {
    vector<unordered_map<int, int>> dp(n + 1);
    dp[0][sa] = sb;
    for (int i = 0; i < n; ++i) {
        for (auto [_a, _b] : dp[i]) {

            int a = _a + d[i];
            int b = _b + d[i];
            // применяем фильтр к a
            int a1 = min(a, l[i]);
            int b1 = b;
            dp[i + 1][a1] = max(dp[i + 1][a1], b1);
            // применяем фильтр к b
            int a2 = a;
            int b2 = min(b, r[i]);
            dp[i + 1][a2] = max(dp[i + 1][a2], b2);
        }
    }
    int ans = 0;

    for (const auto [a, b] : dp[n]) {
        ans = max(ans, a + b);
    }
    cout << ans << endl;
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    cin >> n;

    resize();

    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    cin >> sa >> sb;

    bool g5 = true;

    for (int i = 0; i < n; ++i) {
        if (d[i] != 0) {
            g5 = false;
            break;
        }
    }

    if (g5) {
        solve5();
    } else {
        solve4();
    }

    return 0;
}