#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#include <unordered_map>
#define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

struct Node {
    int bdelta = LLONG_MAX;
    int maxb = -1;
    Node *l = nullptr;
    Node *r = nullptr;
};

Node *root = new Node();

int ans = 0;

void push(Node *v) {
    if (v->bdelta == LLONG_MAX) return;
    if (v->l) {
        v->l->bdelta = min(v->l->bdelta, v->bdelta);
    }
    if (v->r) {
        v->r->bdelta = min(v->r->bdelta, v->bdelta);
    }
    v->maxb = min(v->maxb, v->bdelta);
    v->bdelta = LLONG_MAX;
}

void se(Node *v, int l, int r, int a, int b) {
    push(v);
    if (l == r - 1) {
        assert(l == a);
        v->maxb = b;
        return;
    }
    int m = (l + r) / 2;
    if (a < m) {
        if (!v->l) v->l = new Node();
        se(v->l, l, m, a, b);
    } else {
        if (!v->r) v->r = new Node();
        se(v->r, m, r, a, b);
    }
    v->maxb = 0;
    if (v->l) v->maxb = max(v->maxb, v->l->maxb);
    if (v->r) v->maxb = max(v->maxb, v->r->maxb);
}

int get_ma(Node *v, int l, int r, int L, int R) {
    if (!v) return -1;
    push(v);
    if (R <= l || r <= L) return -1;
    if (L <= l && r <= R) {
        return v->maxb;
    }
    int m = (l + r) / 2;
    return max(get_ma(v->l, l, m, L, R), get_ma(v->r, m, r, L, R));
}

void upd(Node *v, int l, int r, int L, int R, int b) {
    if (!v) return;
    push(v);
    if (R <= l || r <= L) return;
    if (L <= l && r <= R) {
        v->bdelta = b;
        push(v);
        return;
    }
    int m = (l + r) / 2;
    upd(v->l, l, m, L, R, b);
    upd(v->r, m, r, L, R, b);
    v->maxb = 0;
    if (v->l) v->maxb = max(v->maxb, v->l->maxb);
    if (v->r) v->maxb = max(v->maxb, v->r->maxb);
}

void compute_ans(Node *v, int l, int r) {
    push(v);
    if (v->maxb == -1) return;
    if (l == r - 1) {
        ans = max(ans, l + v->maxb);
        return;
    }
    int m = (l + r) / 2;
    if (v->l) compute_ans(v->l, l, m);
    if (v->r) compute_ans(v->r, m, r);
}

int n, sa, sb;
vector<int> d, l, r;

void resize() {
    d.resize(n);
    l.resize(n);
    r.resize(n);
}


signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    // cout << "local run" << endl;
    // freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    cin >> n;

    resize();

    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    cin >> sa >> sb;

    int dsu = 0;
    for (int i = 0; i < n; ++i) dsu += d[i];
    int ma = 1e15 + 1;
    se(root, 0, ma, sa + dsu, sb + dsu);
    for (int i = 0; i < n; ++i) {
        dsu -= d[i];
        // теперь нам нужно либо уменьшить а, либо уменьшить б
        int new_a = l[i] + dsu; // такое значние будет иметь а, если мы его уменьшим
        int maxb = get_ma(root, 0, ma, new_a, ma); // максимальное значение б всреди всех значений, которые мы можем уменьшить
        upd(root, 0, ma, new_a + 1, ma, r[i] + dsu); // если мы не хотим уменьшать а, то нужно уменьшить б до r[i] + dsu или меньше
        if (maxb != -1) se(root, 0, ma, new_a, maxb); // если мы убавили a до new_a, то можем взять максимальное возможное значение b
    }
    // int a = sa;
    // int b = sb;
    // for (int i = 0; i < n; ++i) {
    //     a += d[i];
    //     b += d[i];
    //     a = min(a, l[i]);
    // }
    //     ans = max(ans, a + b);
    compute_ans(root, 0, ma);
    cout << ans << endl;

    return 0;
}