//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Point{
    ld x, y;

    Point() = default;

    Point(ld x, ld y): x(x), y(y){}

    ld sqr_len(){
        return x * x + y * y;
    }

    ld len(){
        return sqrtl(sqr_len());
    }
};

ld operator*(Point a, Point b){
    return a.x * b.x + a.y * b.y;
}

ld operator%(Point a, Point b){
    return a.x * b.y - a.y * b.x;
}

Point operator+(Point a, Point b){
    return Point(a.x + b.x, a.y + b.y);
}

Point operator-(Point a, Point b){
    return Point(a.x - b.x, a.y - b.y);
}

istream& operator>>(istream& in, Point& a){
    in >> a.x >> a.y;
    return in;
}

struct segtree{
    vector<ll> tree;
    int size;

    void push(int v, int vl, int vr){

    }


    void init(int n){
        size = 1;
        while(size < n)
            size++;
        tree.assign(size * 2 - 1, 0);
    }


};

struct dsu{
    vector<int> par, size;

    void init(int n){
        for(int i = 0; i < n; i++){
            par.push_back(i);
            size.push_back(1);
        }
    }

    bool get(int v) {
        if (v == par[v])
            return v;
        return par[v] = get(par[v]);
    }

    bool union_sets(int v, int u){
        v = get(v), u = get(u);
        if(v == u)
            return false;
        if(size[v] < size[u])
            swap(u,v);
        size[v] += size[u];
        par[u] = v;
        size[u] = 0;
    }
};

bool kuhn(int v){
    return false;
}

struct fenwick{
    vector<ll> tree, ar;
    int size;

    void init(vector<ll>& a){
        ar = a;
        size = a.size() + 1;
        tree.assign(a.size() + 1, 0);
    }

    void change(int i, ll x){
        for(int j = i; j < size; j += j & -j){
            tree[j] += x;
        }
    }

    void set(int i, ll x){
        change(i, ar[i - 1] - x);
        ar[i - 1] = x;
    }

    ll get(int i){
        ll res = 0;
        for(int j = i; j > 0; j -= j & -j)
            res += tree[j];
        return res;
    }

    ll get(int l, int r){
        return get(r) - get(l - 1);
    }
};

ll f(ll x){
    return x * x;
}

void ternary(){
    ll l = -1000, r = 1000;
    while(r - l > 1){
        ll m1 = l + (r - l) / 2;
        ll m2 = r - (r - l) / 2;
        if(f(m1) < f(m2)) {
            l = m1;
            r = m2;
        }
        else {
            r = m1;
            l = m2;
        }
    }
    cout<<l << ' ' << r;
}
int n;
vector<ll> d, l, r;
ll a0, b0;
vector<ll> pref;
void solve(){
    vector<pair<ll, ll>> fora(n), forb(n);
    for(int i = 0; i < n; i++){
        fora[i] = {l[i], r[i]};
        forb[i] = {r[i], l[i]};
    }
    sort(fora.begin(), fora.end());
    sort(forb.begin(), forb.end());
    ll mn1 = b0;
    ll ans = 0;
    for(auto& i : fora){
        if(a0 < i.first)
            break;
        ans = max(ans, i.first + mn1);
        mn1 = min(mn1, i.second);
    }
    ll mn2 = a0;
    for(auto& i : forb){
        if(b0 < i.first)
            break;
        ans = max(ans, i.first + mn2);
        mn2 = min(mn2, i.second);
    }
    cout<<ans;
}

ll solve1(vector<ll> la, vector<ll> rb){
    ll ans = 0;
    for(int i = n; i > 0; i--) {
        ll bans = rb[0];
        if(la[0] + pref[i] >= la[i]){
            ll st = la[0];
            for(int j = 1; j <= n; j++){
                bans += d[j];
                st += d[j];
                if(j == i) {
                    st = min(st, la[i]);
                    continue;
                }
                if(j < i && (st <= la[j] || la[j] + pref[i] - pref[j] >= la[i]))
                    st = min(st, la[j]);
                else if(j < i && la[j] < st && la[j] + pref[i] - pref[j] < la[i]){
                    bans = min(bans, rb[j]);
                }
                if(j > i && st <= la[j])
                    st = min(st, la[j]);
                else if(j > i &&  st > la[j])
                    bans = min(bans, rb[j]);
            }
            ans = max(ans, bans + la[i] + pref[n] - pref[i]);
        }
    }
    return ans;
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);


    cin >> n;
    d.resize(n), l.resize(n), r.resize(n);
    pref.resize( n + 1);
    for(auto& i : d)
        cin >> i;
    for(auto& i : l)
        cin >> i;
    for(auto& i : r)
        cin >> i;
    cin >> a0 >> b0;
    d.insert(d.begin(), 0);
    l.insert(l.begin(), a0);
    r.insert(r.begin(), b0);
    for(int i = 1; i <= n; i++){
        pref[i] = pref[i - 1] + d[i];
    }
//    d.insert(d.begin(), 2e9);
//    l.insert(l.begin(), 2e9);
//    r.insert(r.begin(), 2e9);
    ll mx = 0;
    for(auto i : d)
        mx = max(mx, i);
    if(mx == 0)
        solve();
    else{
        cout<<max(solve1(l,r), solve1(r,l));
    }
    return 0;
}
