#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()


struct DSU {
    int sz;
    vector<int> par;
    vector<int> rank;
    DSU(int num) : sz(num) {
        par.resize(sz);
        iota(in(par), 0);
        rank.assign(sz, 1);
    }
    int find_par(int v) {
        if (par[v] == v) return v;
        return par[v] = find_par(par[v]);
    }
    bool unite(int u, int v) {
        u = find_par(u);
        v = find_par(v);
        if (u == v) return false;
        if (rank[u] < rank[v]) swap(u, v);
        par[v] = u;
        rank[u] += rank[v];
        return true;
    }
};
const int mxN = 2e5 + 500;
int n, G;

struct edge {
    int u, v, w;
};
edge edges[mxN];
vector<int> c[mxN];
vector<pair<int, int>> g[mxN], g2[mxN];
int mn_av[mxN];
bool ok;

void dfs(int v, int p = -1, int p_e_id = -1) {
    vector<tuple< int, int, int>> ord;
    for (auto ed : g[v]) {
        int u, w;
        int e_id;
        tie(u, e_id) = ed;
        w = edges[e_id].w;
        if (u == p) continue;
        dfs(u, v, e_id);
        if (!ok) return;
        ord.emplace_back(mn_av[u] - w, u, e_id);
    }
    sort(in(ord), [](auto& lhs, auto& rhs) { return lhs > rhs; });
    debug << v << ": ";
    debug << endl;
    // for (auto elem : ord) {
    //     debug << "(" << elem.first << ", " << elem.second << ")" << endl;
    // }
    vector<int> my_ord(c[v].size());
    iota(in(my_ord), 0);
    sort(in(my_ord), [&](int i, int j) { return c[v][i] < c[v][j]; });
    g2[v].resize(g[v].size());

    debug << "my_ord: ";
    for (int i : my_ord) debug << i << ' ' ;
    debug << endl;

    vector<bool> used(c[v].size());
    int j = 0;
    for (int i = 0; i < (int)ord.size(); ++i) {
        int val, u, e_id;
        tie(val, u, e_id) = ord[i];
        while (j < (int)c[v].size() && c[v][my_ord[j]] + val < 0) {
            j += 1;
        }
        if (j < (int)c[v].size()) {
            used[j] = true;
            g2[v][my_ord[j]] = {u, e_id};
            debug << my_ord[j] << " -> " << u << endl;
            j += 1;
        }
        else { ok = false; return; }
    }
    if (p == -1) return;
    int not_used = -1;
    for (int i = 0; i < (int)c[v].size(); ++i) {
        if (!used[i]) {
            not_used = my_ord[i];

            break;
        }
    }
    debug << "not_used: " << not_used << endl;
    assert(not_used != -1);
    mn_av[v] = c[v][not_used];
    g2[v][not_used] = {p, p_e_id};
    debug << endl;

}

vector<int> ans;

void dfs2(int v, int p = - 1) {
    for (auto e : g2[v]) {
        int u, e_id;
        tie(u, e_id) = e;
        if (u == p) {
            ans.push_back(e_id);
            continue;
        }
        dfs2(u, v);
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> G;
    for (int  i= 0 ; i+ 1 < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        edges[i] = {u, v, w};
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);

    }
    for (int i = 0; i < n; ++i) {
        // int d;
        // cin >> d;
        for (int j = 0; j < (int) g[i].size(); ++j) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(in(c[i]));
    }
    ok = true;
    dfs(0);


    if (!ok) {
        cout << "No\n";
    }
    else {
        dfs2(0);
        cout << "Yes\n";
        for (int i : ans) cout << i + 1 << ' ';
        cout << '\n';
    }
    return 0;
}