#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>
#include <random>
#include <chrono>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;

mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());


void solve(int n) {
    vector<int> R(n);
    vector<pii> lr(n);
    vector<int> el;
    for (int i = 0; i < n; i++) {
        cin >> lr[i].first;
        el.push_back(lr[i].first);
    }
    for (int i = 0; i < n; i++) {
        cin >> lr[i].second;
        R[i] = lr[i].second;
    }
    int a0, b0;
    cin >> a0 >> b0;

    sort(el.begin(), el.end());
    el.erase(unique(el.begin(), el.end()), el.end());

    sort(lr.begin(), lr.end());

    int ans = a0 + min(b0, *min_element(R.begin(), R.end()));
    int prefmin = 1e18;
    for (int i = 0; i < n; i++) {
        ans = max(ans, min(a0, lr[i].first) + min(b0, prefmin));
        prefmin = min(prefmin, lr[i].second);
    }

    cout << ans << "\n";



}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int mod = 1000000;
    int n = 400;
    cin >> n;
    vector<int> D(n + 1, 0), L(n + 1, 0), R(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
        //D[i] = rnd()% mod;
    }
    if (*max_element(D.begin(), D.end()) == 0) {
        solve(n);
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
        //L[i] = rnd()% mod;
    }
    for (int i = 1; i <= n; i++) {
        cin >> R[i];
        //R[i] = rnd()% mod;
    }
    int a0 = rnd() % mod, b0 = rnd()% mod;
    cin >> a0 >> b0;


    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + D[i];
    }
    L[0] = a0, R[0] = b0;

    vector<int> lvals(n + 1, 0);
    lvals[0] = a0;
    for (int i = 1; i <= n; i++) {
        lvals[i] = min(L[i], lvals[i - 1] + D[i]);
    }
    vector<int> rvals(n + 1, 0);
    rvals[0] = b0;
    for (int i = 1; i <= n; i++) {
        rvals[i] = min(R[i], rvals[i - 1] + D[i]);
    }

    if (n > 0) {
        int ans = 0;
        for (int l = 0; l <= n; l++) {
            vector<bool> used(n + 1, false);
            for (int i = 0; i <= l; i++) {
                used[i] = true;
            }
            int cur = lvals[l];
            for (int i = l + 1; i <= n; i++) {
                cur += D[i];
                if (L[i] >= cur) {
                    used[i] = true;
                }
            }
            int res = cur;
            cur = b0;
            for (int i = 1; i <= n; i++) {
                cur += D[i];
                if (!used[i]) {
                    cur = min(cur, R[i]);
                }
            }
            ans = max(ans, res + cur);
        }
        for (int r = 0; r <= n; r++) {
            vector<bool> used(n + 1, false);
            for (int i = 0; i <= r; i++) {
                used[i] = true;
            }
            int cur = rvals[r];
            for (int i = r + 1; i <= n; i++) {
                cur += D[i];
                if (R[i] >= cur) {
                    used[i] = true;
                }
            }
            int res = cur;
            cur = a0;
            for (int i = 1; i <= n; i++) {
                cur += D[i];
                if (!used[i]) {
                    cur = min(cur, L[i]);
                }
            }
            ans = max(ans, res + cur);
        }
        cout << ans << "\n";
    } else {

        vector<unordered_map<int, unordered_map<int, int>>> dp(n + 1, unordered_map<int, unordered_map<int, int>>());
        dp[0][0][0] = a0 + b0;
        for (int i = 0; i < n; i++) {
            for (auto [l, vec]: dp[i]) {
                for (auto [r, val]: vec) {
                    if (L[l] + pref[i + 1] - pref[l] < L[i + 1]) {
                        dp[i + 1][l][r] = max(dp[i + 1][l][r],
                                              L[l] + pref[i + 1] - pref[l] + R[r] + pref[i + 1] - pref[r]);
                    } else {
                        dp[i + 1][i + 1][r] = max(dp[i + 1][i + 1][r], L[i + 1] + R[r] + pref[i + 1] - pref[r]);
                    }
                    if (R[r] + pref[i + 1] - pref[r] < R[i + 1]) {
                        dp[i + 1][l][r] = max(dp[i + 1][l][r],
                                              L[l] + pref[i + 1] - pref[l] + R[r] + pref[i + 1] - pref[r]);
                    } else {
                        dp[i + 1][l][i + 1] = max(dp[i + 1][l][i + 1], R[i + 1] + L[l] + pref[i + 1] - pref[l]);
                    }
                }
            }
        }

        int rans = 0;
        for (int l = 0; l <= n; l++) {
            for (int r = 0; r <= n; r++) {
                rans = max(rans, dp[n][l][r]);
            }
        }
        cout << rans << "\n";
    }






    return 0;
}
