#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x=0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
	ll operator%(Point oth)
	{
		return x * oth.y - y * oth.x;
	}
	Point operator+(Point oth)
	{
		return Point(x + oth.x, y + oth.y);
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> d(n+1), l(n+1), r(n+1);
	vector<vector<ll>> dp1(n + 1, vector<ll>(2)), dp2(n + 1, vector<ll>(2));
	for (int i = 1; i <= n; i++) cin >> d[i];
	for (int i = 1; i <= n; i++) cin >> l[i];
	for (int i = 1; i <= n; i++) cin >> r[i];
	ll a0, b0;
	cin >> a0 >> b0;
	dp1[0][0] = a0;
	dp1[0][1] = a0;
	dp2[0][0] = b0;
	dp2[0][1] = b0;
	for (int i = 1; i <= n; i++)
	{
		if (min(dp1[i - 1][0] + d[i], l[i]) + dp2[i - 1][0] + d[i] >= min(dp1[i - 1][1] + d[i], l[i]) + dp2[i - 1][1] + d[i])
		{
			dp1[i][0] = min(dp1[i - 1][0] + d[i], l[i]);
			dp2[i][0] = dp2[i - 1][0] + d[i];
		}
		else
		{
			dp1[i][0] = min(dp1[i - 1][1] + d[i], l[i]);
			dp2[i][0] = dp2[i - 1][1] + d[i];
		}
		if (min(dp2[i - 1][0] + d[i], r[i]) + dp1[i - 1][0] + d[i] >= min(dp2[i - 1][1] + d[i], r[i]) + dp1[i - 1][1] + d[i])
		{
			dp2[i][1] = min(dp2[i - 1][0] + d[i], r[i]);
			dp1[i][1] = dp1[i - 1][0] + d[i];
		}
		else
		{
			dp2[i][1] = min(dp2[i - 1][1] + d[i], r[i]);
			dp1[i][1] = dp1[i - 1][1] + d[i];
		}
	}
	cout << max(dp1[n][0] + dp2[n][0], dp1[n][1] + dp2[n][1]);
}