#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e18 + 7;
struct Point
{
	ll x, y;
	Point(int _x = 0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
	ll operator%(Point oth)
	{
		return x * oth.y - y * oth.x;
	}
	Point operator+(Point oth)
	{
		return Point(x + oth.x, y + oth.y);
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	//vector<vector<ll>> dp1(n + 1, vector<ll>(2)), dp2(n + 1, vector<ll>(2));
	for (int i = 1; i <= n; i++) cin >> d[i];
	for (int i = 1; i <= n; i++) cin >> l[i];
	for (int i = 1; i <= n; i++) cin >> r[i];
	vector<ll> pref(n + 1);
	for (int i = 1; i <= n; i++)
	{
		pref[i] = pref[i - 1] + d[i];
		l[i] -= pref[i];
		r[i] -= pref[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;
	vector<map<ll, ll>> dp(n + 1);
	map<ll, ll> f;
	dp[0][a0] = b0;
	for (int i = 1; i <= n; i++)
	{
		for (auto [a, b] : dp[i - 1])
		{
			if (b == -INF) continue;
			dp[i][min(a, l[i])] = -INF;
			dp[i][a] = -INF;
		}
		for (auto [a, b] : dp[i - 1])
		{
			//if (dp[i].find(min(a + d[i], l[i])) == dp[i].end()) dp[i][min(a + d[i], l[i])] = -INF;
			//if (dp[i].find(a) == dp[i].end()) dp[i][a] = -INF;
			//dp[i].insert({ min(a, l[i]),b });
			if (b == -INF) continue;
			dp[i][min(a, l[i])] = max(dp[i][min(a, l[i])], b);
			//dp[i].insert({ a,min(b, r[i]) });
			dp[i][a] = max(dp[i][a], min(b, r[i]));
		}
	}
	ll ans = -INF;
	for (auto [a, b] : dp[n])
	{
		ans = max(ans, a + b);
	}
	cout << ans + 2 * pref[n];
}