// #include <bits/stdc++.h>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct segtree {
    ll sz = 1;
    vector<ll> tr;

    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
    }

    ll sumseg(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return 0;
        }
        int mid = (r + l) / 2;
        ll m1 = sumseg(2 * v + 1, l, mid, lseg, rseg);
        ll m2 = sumseg(2 * v + 2, mid, r, lseg, rseg);
        return m1 + m2;
    }

    ll sumseg(int lseg, int rseg) {
        sumseg(0, 0, sz, lseg, rseg);
    }

    void ch(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tr[v] = x;
            return;
        }
        int mid = (r + l) / 2;
        if (ind < mid) {
            ch(2 * v + 1, l, mid, ind, x);
        } else {
            ch(2 * v + 2, mid, r, ind, x);
        }
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
    }

    void ch(int ind, int x) {
        ch(0, 0, sz, ind, x);
    }
};

vector<pair<ll, ll>> ans;
struct xui{
    vector<set<ll>> gr1;
    vector<set<ll>> gr2;
    xui(ll n){
        gr1.resize(n);
        gr2.resize(n);
    }

    void ch(ll a, ll b){
        if (gr1[a].find(b) != gr1[a].end()){
            gr1[a].erase(b);
        }
        else{
            gr1[a].insert(b);
        }
        if (gr2[a].find(b) != gr2[a].end()){
            gr2[a].erase(b);
        }
        else{
            gr2[a].insert(b);
        }
    }

    bool check2(ll a, ll b){
        return gr2[a].find(b) != gr2[a].end();
    }

    void swedge(ll a, ll b){
        ans.push_back({a, b});
        ch(a, b);
        ch(b, a);
    }
};


xui mach(1);
vector<bool> used;
pair<ll, ll> dfs(int v){
    used[v] = true;
    pair<ll, ll> d = {v, v};
    for (auto el : mach.gr1[v]){
        if (!used[el]){
            pair<ll, ll> x = dfs(el);
            d.first = min(d.first, x.first);
            d.second = max(d.second, x.second);
        }
    }
    return d;
}
vector<ll> prefs;
ll get(int l, int r){
    ll x = prefs[r];
    if (l != 0){
        x -= prefs[l - 1];
    }
    return x;
}
void solve() {
    ll n;
    cin >> n;
    vector<ll> d(n + 1);
    vector<ll> l(n + 1);
    vector<ll> r(n + 1);
    prefs.resize(n + 1, 0);
    for (int i = 0; i < n; i++){
        cin >> d[i + 1];
        prefs[i + 1] += d[i + 1] + prefs[i];
    }
    for (int i = 0; i < n; i++){
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++){
        cin >> r[i + 1];
    }
    cin >> l[0];
    cin >> r[0];
    vector<vector<ll>> dp(n + 1, vector<ll> (n + 1, -1e15));
    dp[0][0] = r[0];
    for (int i = 0; i < n ; i++){
        for (auto el : dp[i]){
            cout << el << " ";
        }
        cout << endl;
        for (int j = 0; j <= i; j++){
            ll cur  = l[j] + get(j + 1, i + 1);
            if (cur <= l[i + 1]){
                dp[i + 1][j]  = max(dp[i + 1][j], dp[i][j] + d[i + 1]);
            }
            else{
                dp[i + 1][j] = max(dp[i + 1][j], min(dp[i][j] + d[i + 1], r[i + 1]));
                dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i][j] + d[i + 1]);
            }
        }
    }
    ll maxim = 0;
    for (int j = 0; j <= n; j++){
        ll cur = l[j] + get(j + 1, n);
//        cout << cur << " " << dp[n][j] << endl;
        maxim = max(maxim, cur + dp[n][j]);
    }
    cout << maxim << "\n";


}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
