// #include <bits/stdc++.h>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct segtree {
    ll sz = 1;
    vector<ll> tr;
    vector<ll> op;

    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1, -1e9);
        op.resize(2 * sz - 1, 1e15);
    }

    void minr(int v, ll x){
        tr[v] = min(tr[v], x);
        op[v] = min(op[v], x);
    }

    void push(int v){
        minr(2 * v + 1,  op[v]);
        minr(2 * v + 2, op[v]);
        op[v] = 1e15;
    }

    ll sumseg(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return -1e9;
        }
        push(v);
        int mid = (r + l) / 2;
        ll m1 = sumseg(2 * v + 1, l, mid, lseg, rseg);
        ll m2 = sumseg(2 * v + 2, mid, r, lseg, rseg);
        return max(m1, m2);
    }

    ll sumseg(int lseg, int rseg) {
        return sumseg(0, 0, sz, lseg, rseg);
    }

    void ch(int v, int l, int r, int ind, ll x) {
        if (r - l == 1) {
            tr[v] = max(x, tr[v]);
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        if (ind < mid) {
            ch(2 * v + 1, l, mid, ind, x);
        } else {
            ch(2 * v + 2, mid, r, ind, x);
        }
        tr[v] = max(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void ch(int ind, int x) {
        ch(0, 0, sz, ind, x);
    }

    void chseg(int v, int l, int r, int lseg, int rseg, ll x) {
        if (lseg <= l && r <= rseg) {
            minr(v, x);
            return;
        }
        if (r <= lseg || rseg <= l) {
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        chseg(2 * v + 1, l, mid, lseg, rseg, x);
        chseg(2 * v + 2, mid, r, lseg, rseg, x);
        tr[v] = max(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void chseg(int lseg, int rseg, ll x) {
        chseg(0, 0, sz, lseg, rseg, x);
    }
};

vector<ll> prefs;
ll get(int l, int r){
    ll x = prefs[r];
    if (l != 0){
        x -= prefs[l - 1];
    }
    return x;
}
void solve() {
    ll n;
    cin >> n;
    vector<ll> d(n + 1);
    vector<ll> l(n + 1);
    vector<ll> r(n + 1);
    prefs.resize(n + 1, 0);
    for (int i = 0; i < n; i++){
        cin >> d[i + 1];
        prefs[i + 1] += d[i + 1] + prefs[i];
    }
    for (int i = 0; i < n; i++){
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++){
        cin >> r[i + 1];
    }
    cin >> l[0];
    cin >> r[0];
    bool good = true;
    for (auto el : d){
        if (el != 0){
            good = false;
        }
    }
    if (!good) {
        vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, -1e15));
        dp[0][0] = r[0];
        for (int i = 0; i < n; i++) {
//        for (auto el : dp[i]){
//            cout << el << " ";
//        }
//        cout << endl;
            for (int j = 0; j <= i; j++) {
                ll cur = l[j] + get(j + 1, i + 1);
                if (cur <= l[i + 1]) {
                    dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i + 1]);
                } else {
                    dp[i + 1][j] = max(dp[i + 1][j], min(dp[i][j] + d[i + 1], r[i + 1]));
                    dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i][j] + d[i + 1]);
                }
            }
        }
        ll maxim = 0;
        for (int j = 0; j <= n; j++) {
            ll cur = l[j] + get(j + 1, n);
//        cout << cur << " " << dp[n][j] << endl;
            maxim = max(maxim, cur + dp[n][j]);
        }
        cout << maxim << "\n";
    }
    else{
        vector<ll> ls = l;
        sort(ls.begin(), ls.end());
        segtree mach(n + 1);
        mach.ch(std::lower_bound(ls.begin(), ls.end(), l[0]) - ls.begin(), r[0]);
        for (int i = 1; i <= n; i++){
            ll mx = mach.sumseg(std::lower_bound(ls.begin(), ls.end(),l[i]) - ls.begin(), n + 1);
            mach.ch(std::lower_bound(ls.begin(), ls.end(), l[i]) - ls.begin(), mx);
            mach.chseg(std::lower_bound(ls.begin(), ls.end(),l[i]) - ls.begin(), n + 1, r[i]);
        }
        ll maxim = 0;
        for (int j = 0; j <= n; j++) {
            ll cur = l[j] + mach.sumseg(j, j + 1);
            maxim = max(maxim, cur );
        }
cout << maxim << "\n";
    }


}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}