#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> D(n);
    vector<ll> L(n);
    vector<ll> R(n);
    ll dMax = 0;
    for (auto &item: D) {
        cin >> item;
        dMax = max(dMax, item);
    }

    for (auto &item: L) {
        cin >> item;
    }

    for (auto &item: R) {
        cin >> item;
    }

    ll a0, b0;
    cin >> a0 >> b0;

    if (n <= 15) {
        ll maxMask = 1LL << n;
        ll res = 0;
        for (ll mask = 0; mask < maxMask; ++mask) {
            ll a = a0;
            ll b = b0;
            for (ll i = 0; i < n; ++i) {
                a += D[i];
                b += D[i];
                if (mask & (1LL << i)) {
                    a = min(a, L[i]);
                } else {
                    b = min(b, R[i]);
                }
            }

            res = max(res, a + b);
        }

        cout << res << '\n';
    } else if (dMax == 0) {
        vector<ll> aVal;
        aVal.push_back(a0);
        set<ll> was;
        for (const auto &item: L) {
            if (item < a0 && was.find(item) == was.end()) {
                aVal.push_back(item);
                was.insert(item);
            }
        }

        sort(aVal.begin(), aVal.end());
        ll M = ll(aVal.size());
        vector<ll> minFrom(M, b0);
        for (ll i = 0; i < n; ++i) {
            ll from = upper_bound(aVal.begin(), aVal.end(), L[i]) - aVal.begin();
            if (from < M) {
                minFrom[from] = min(minFrom[from], R[i]);
            }
        }

        ll mn = b0;
        ll res = 0;
        for (ll i = 0; i < M; ++i) {
            mn = min(mn, minFrom[i]);
            res = max(res, aVal[i] + mn);
        }

        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
