#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> D(n);
    vector<ll> L(n);
    vector<ll> R(n);
    ll dMax = 0;
    for (auto &item: D) {
        cin >> item;
        dMax = max(dMax, item);
    }

    for (auto &item: L) {
        cin >> item;
    }

    for (auto &item: R) {
        cin >> item;
    }

    ll a0, b0;
    cin >> a0 >> b0;
    if (dMax == 0) {
        vector<ll> aVal;
        aVal.push_back(a0);
        set<ll> was;
        for (const auto &item: L) {
            if (item < a0 && was.find(item) == was.end()) {
                aVal.push_back(item);
                was.insert(item);
            }
        }

        sort(aVal.begin(), aVal.end());
        ll M = ll(aVal.size());
        vector<ll> minFrom(M, b0);
        for (ll i = 0; i < n; ++i) {
            ll from = upper_bound(aVal.begin(), aVal.end(), L[i]) - aVal.begin();
            if (from < M) {
                minFrom[from] = min(minFrom[from], R[i]);
            }
        }

        ll mn = b0;
        ll res = 0;
        for (ll i = 0; i < M; ++i) {
            mn = min(mn, minFrom[i]);
            res = max(res, aVal[i] + mn);
        }

        cout << res << '\n';
    } else {
        unordered_map<ll, ll> dp;
        dp[a0] = b0;
        for (ll i = 0; i < n; ++i) {
            unordered_map<ll, ll> nDp;
            for (const auto &item: dp) {
                if (item.first + D[i] > L[i]) {
                    nDp[item.first + D[i]] = max(nDp[item.first + D[i]], min(item.second + D[i], R[i]));
                    nDp[L[i]] = max(nDp[L[i]], item.second + D[i]);
                } else {
                    nDp[item.first + D[i]] = max(nDp[item.first + D[i]], item.second + D[i]);
                }
            }

            set<pair<ll, pair<ll, ll>>> bestA;
            set<pair<ll, pair<ll, ll>>> bestB;
            set<pair<ll, pair<ll, ll>>> bestAB;
            for (const auto &item: nDp) {
                bestA.insert({item.first, item});
                if (bestA.size() > 100) {
                    bestA.erase(bestA.begin());
                }

                bestB.insert({item.second, item});
                if (bestB.size() > 100) {
                    bestB.erase(bestB.begin());
                }

                bestAB.insert({item.first + item.second, item});
                if (bestAB.size() > 100) {
                    bestAB.erase(bestAB.begin());
                }
            }

            dp.clear();
            for (const auto &item: bestA) {
                dp[item.second.first] = item.second.second;
            }

            for (const auto &item: bestB) {
                dp[item.second.first] = item.second.second;
            }

            for (const auto &item: bestAB) {
                dp[item.second.first] = item.second.second;
            }
        }

        ll res = 0;
        for (const auto &item: dp) {
            res = max(res, item.first + item.second);
        }

        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
