#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(2346927423);
const ll INF = 2e18;

struct DDnode {
    DDnode* l;
    DDnode* r;
    ll val, prior;
    DDnode(ll val = 0) : val(val) {
        l = nullptr;
        r = nullptr;
        prior = rd();
    }
};
DDnode* mer(DDnode* l, DDnode* r) {
    if (l == nullptr)
        return r;
    if (r == nullptr)
        return l;

    if (l->prior > r->prior) {
        l->r = mer(l->r, r);
        return l;
    }
    else {
        r->l = mer(l, r->l);
        return l;
    }
}
pair<DDnode*, DDnode*> split(DDnode* v, ll x) {
    return { v, v };
}

struct pt {
    ll x, y;
    pt(ll x = 0, ll y = 0) : x(x), y(y) {}
};
pt operator+(pt a, pt b) {
    return pt(a.x + b.x, a.y + b.y);
}
pt operator-(pt a, pt b) {
    return pt(a.x - b.x, a.y - b.y);
}
ll operator*(pt a, pt b) {
    return a.x * b.x + a.y * b.y;
}
ll operator%(pt a, pt b) {
    return a.x * b.y - a.y * b.x;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    vector<ll> p(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
        p[i] = d[i] + p[i - 1];
    }
    for (int i = 1; i <= n; i++)
        cin >> l[i];
    for (int i = 1; i <= n; i++)
        cin >> r[i];
    //ll a0, b0;
    cin >> l[0] >> r[0];

    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, -INF));
    dp[0][0] = l[0] + r[0];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= i; j++) {
            ll a = (l[i - j] + p[i] - p[i - j]);
            ll b = dp[i][j] - a;
            dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + d[i + 1] - b + min(r[i + 1], b + d[i + 1]));
            if (a + d[i + 1] <= l[i + 1]) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + 2 * d[i + 1]);
            }
            else {
                dp[i + 1][0] = max(dp[i + 1][0], dp[i][j] - a + l[i + 1] + d[i + 1]);
            }
        } 
    }
    ll ans = 0;
    for (int i = 0; i <= n; i++)
        ans = max(ans, dp[n][i]);
    cout << ans;
}