#pragma GCC optimize("avx2")
#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;

struct poly_hash {
    vector<int> p, h;
    string s;
    int n, mod;

    poly_hash(string s, int P, int mod) : s(s), mod(mod) {
        n = s.size();
        p.resize(n + 1);
        h.resize(n + 1);
        p[0] = 1;
        for (int i = 0; i < n; ++i) {
            p[i + 1] = p[i] * P;
            if (p[i + 1] >= mod) p[i + 1] %= mod;
            h[i + 1] = (h[i] * P + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get(int ind, int len) {
        return ((h[ind + len] - h[ind] * p[len]) % mod + mod) % mod;
    }
};

struct Node {

};

struct SegTree {
    int sz;
    vector<Node> tr;
    Node def;

    SegTree(int n) {
        sz = (1 << (int)(log2(n) + 1));
        tr.resize(sz * 2, def);
    }

    Node merge(Node a, Node b) {

    }

    void push(int v) {

    }

    void update(int v, int l, int r, int ql, int qr, int x) {
        push(v);
        if (qr <= l || ql >= r) return;
        if (ql <= l && r <= qr) {

            push(v);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, x);
        update(2 * v + 2, m, r, ql, qr, x);
        tr[v] = merge(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void update(int l, int r, int x) {
        update(0, 0, sz, l, r, x);
    }

    Node get(int v, int l, int r, int ql, int qr) {
        push(v);
        if (qr <= l || ql >= r) return def;
        if (ql <= l && r <= qr) {
            return tr[v];
        }
        int m = (l + r) / 2;
        return merge(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    Node get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

struct BIT {
    int n;
    vector<int> a;

    BIT(int n) : n(n) {
        a.resize(n + 1);
    }

    void upd(int ind, int x) {
        for (; ind < n; ind = (ind | (ind + 1))) a[ind] += x;
    }

    int get(int ind) {
        int ans = 0;
        for (; ind >= 0; ind = (ind & (ind + 1)) - 1) ans += a[ind];
        return ans;
    }

    int get(int l, int r) { // [l; r]
        return get(r) - get(l - 1);
    }
};


void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];
    int a0, b0;
    cin >> a0 >> b0;
    int ans = 0;
    int a = a0, b = b0;
    for (int i = 0; i < n; ++i) {
        a += d[i];
        b += d[i];
        if (a <= l[i]) continue;
        b = min(b, r[i]);
    }
    ans = a + b;
    for (int i = 0; i < n; ++i) {
        a = a0, b = b0;
        vector<bool> used(n);
        used[i] = 1;
        int cur = l[i];
        for (int j = i - 1; j >= 0; --j) {
            cur -= d[j];
            if (l[j] >= cur) {
                used[j] = 1;
            }
        }
        cur = l[i];
        for (int j = i + 1; j < n; ++j) {
            cur += d[j];
            if (l[i] >= cur) {
                used[j] = 1;
            }
        }
        for (int i = 0; i < n; ++i) {
            a += d[i];
            b += d[i];
            if (used[i]) a = min(a, l[i]);
            else b = min(b, r[i]);
        }
        ans = max(ans, a + b);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}