#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

struct seg_tree {
    int size = 1;
    vector<int> tree;
    void init(int n, vector<int> &v) {
        while (size < n) {
            size *= 2;
        }
        tree.resize(size * 2 - 1, 1e9);
        for (int i = size - 1; i < size * 2  -1; i++) {
            tree[i] = v[i];
        }
    }

    void build(int v, int l, int r) {
        if (l == r) return;
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid + 1, r);
        tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    int get(int ql, int qr, int v, int l, int r) {
        if (r < ql || qr < l) return 1e9;
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        return min(get(ql, qr, v * 2 + 1, l, mid), get(ql, qr, v * 2 + 2, mid + 1, r));
    }
};


void solve() {

    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int &i : d) {
        cin >> i;
    }
    for (int &i : l) {
        cin >> i;
    }
    for (int &i : r) {
        cin >> i;
    }
    int a0, b0;
    cin >> a0 >> b0;

    vector<int> pref_d(n + 1);
    for (int i = 0; i < n; i++) {
        pref_d[i + 1] = pref_d[i] + d[i];
    }


    vector<tuple<int, int, int>> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = {l[i], r[i], i};
    }

    sort(v.begin(), v.end());
    vector<int> to_st;
    for (auto [a, b, c] : v) {
        to_st.push_back(b);
    }

    auto st = seg_tree();
    st.init(n, to_st);
    st.build(0, 0, st.size - 1);

    vector<int> pos(n);
    int left = 0;
    for (int right = 0; right < n; right++) {
        auto [r_a, r_b, r_c] = v[right];
        while (true) {
            auto [l_a, l_b , l_c] = v[left];
            if (l_a >= r_a) break;
            left++;
        }
        pos[r_c] = left - 1;
    }


    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (l[i] >= a0) { //
            continue;
        }

        int b_now = b0;
        if (pos[i] >= 0) {
            b_now = min(b_now, st.get(0, pos[i], 0, 0, st.size - 1));
        }

//        for (int j = 0; j < n; j++) {
//            if (l[j] < l[i]) {
//                b_now = min(b_now, r[j]);
//            }
//        }

        ans = max(ans, l[i] + b_now);
    }

    int a_worst = a0, b_worst = b0;
    for (int i = 0; i < n; i++) {
        a_worst += d[i];
        a_worst = min(a_worst, l[i]);
        b_worst += d[i];
        b_worst = min(b_worst, r[i]);
    }

//    cout << ans << endl;

    ans = max(ans, a0 + pref_d.back() + b_worst);
    ans = max(ans, b0 + pref_d.back() + a_worst);
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
