#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

struct seg_tree {
    int size = 1;
    vector<int> tree;
    void init(int n, vector<int> &v) {
        while (size <= n) {
            size *= 2;
        }
        tree.resize(size * 2 - 1, 0);
        for (int i = size - 1; i < size + n  -1; i++) {
            tree[i] = v[i - size + 1];
        }
    }

    void build(int v, int l, int r) {
        if (l == r) return;
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid + 1, r);
        tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    ll get(int ql, int qr, int v, int l, int r) {
//        cout << ql << " " << qr << " " << v << " " << l << " " << r << " " << tree[v] << "\n";
        if (r < ql || l > qr) return 1e9;
        if (ql <= l && r <= qr) return tree[v];
        int mid = (l + r) / 2;

        ll res1 = get(ql, qr, v * 2 + 1, l, mid);
        ll res2 = get(ql, qr, v * 2 + 2, mid + 1, r);
        return min(res1, res2);
    }
};


void solve() {

    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int &i : d) {
        cin >> i;
    }
    for (int &i : l) {
        cin >> i;
    }
    for (int &i : r) {
        cin >> i;
    }
    int a0, b0;
    cin >> a0 >> b0;


//    for (int i = 0; i < n; i++) {
//        pref_d[i + 1] = pref_d[i] + d[i];
//    }


    vector<tuple<int, int, int>> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = {l[i], r[i], i};
    }

    sort(v.begin(), v.end());
    vector<int> to_st;
    for (auto [a, b, c] : v) {
        to_st.push_back(b);
    }

    auto st = seg_tree();
    st.init(n, to_st);
    st.build(0, 0, st.size - 1);

    vector<int> pos(n);

    int left = 0;
    for (int right = 0; right < n; right++) {
        auto [r_a, r_b, r_c] = v[right];
        while (left <= right) {
            auto [l_a, l_b , l_c] = v[left];
            if (l_a >= r_a) break;
            left++;
        }
        pos[r_c] = left - 1;
    }

//    for (int i = 0; i < n; i++) {
//        if (pos[i] >= 0) {
//            auto [a, b, c] = v[pos[i]];
//            if (a >= l[i]) exit(1);
//        }
//    }

    int d_sum = 0;
    for (int i : d) {
        d_sum += i;
    }
    if (d_sum != 0) {
        vector<int> pref_d(n + 1);
        for (int i = 0; i < n; i++) {
            pref_d[i + 1] = pref_d[i] + d[i];
        }


        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (l[i] >= a0 + pref_d[i + 1]) { //
                continue;
            }

            vector<int> use_b(n + 1);
            //use_b[i] = 1;
            for (int j = 0; j < i; j++) {
                if (l[i] - l[j] > pref_d[i + 1] - pref_d[j + 1]) { //
                    use_b[j] = 1;
                }
            }
            int next_a = l[i];
            for (int j = i + 1; j < n; j++) {
                next_a += d[j];
                if (l[j] < next_a) {
                    use_b[j] = 1;
                }
            }

            int b_now = b0;
            for (int j = 0; j < n;j++) {
                b_now += d[j];
                if (use_b[j]) b_now = min(r[j], b_now);
            }
            ans = max(ans, next_a + b_now);
        }

        int a_worst = a0, b_worst = b0;
        for (int i = 0; i < n; i++) {
            a_worst += d[i];
            a_worst = min(a_worst, l[i]);
            b_worst += d[i];
            b_worst = min(b_worst, r[i]);
        }

//    cout << ans << endl;

        ans = max(ans, a0 + pref_d.back() + b_worst);
        ans = max(ans, b0 + pref_d.back() + a_worst);
        cout << ans;
        return;
    }


    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (l[i] > a0) { //
            continue;
        }

        int b_now = b0;
        if (pos[i] >= 0) {
            b_now = min(b_now, st.get(0, pos[i], 0, 0, st.size - 1));
        }

        ans = max(ans, l[i] + b_now);
    }

    int a_worst = a0, b_worst = b0;
    for (int i = 0; i < n; i++) {
        a_worst = min(a_worst, l[i]);
        b_worst = min(b_worst, r[i]);
    }

//    cout << ans << endl;

    ans = max(ans, a0 + b_worst);
    ans = max(ans, b0 + a_worst);
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
