#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

class vec {
public:
    int a, b;

    vec() {}

    vec(int a, int b) : a(a), b(b) {}

    vec operator-(vec other) {
        return vec(other.a - a, other.b - b);
    }

    int operator*(vec other) {
        return (a - other.b) * (other.a - b);
    }
};

#define int long long

signed main() {
    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> R[i];
    }
    reverse(D.begin(), D.end());
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + D[i - 1];
    }
    reverse(L.begin(), L.end());
    reverse(R.begin(), R.end());
    for (int i = 0; i < n; i++) {
        L[i] += pref[i];
    }
    reverse(L.begin(), L.end());
    reverse(R.begin(), R.end());
    int a, b;
    cin >> a >> b;
    a += pref.back();
    b += pref.back();
    vector<pair<int, int>> Ls(n), Rs(n);
    for (int i = 0; i < n; i++) {
        Ls[i] = {L[i], i};
        Rs[i].first = R[i];
    }
    sort(Ls.rbegin(), Ls.rend());
    sort(Rs.begin(), Rs.end());
    int ans = max(a + min(b, Rs[0].first), b + min(a, Ls.back().first));
    int ind = 0;
    for (int i = 0; i < n - 1; i++) {
        int l = 0, r = n;
        while (r - l != 1) {
            int mid = (r + l) / 2;
            if (Rs[mid].first > R[Ls[i].second]) {
                r = mid;
            } else {
                l = mid;
            }
        }
        Rs[l].second = 1;
        while (Rs[ind].second == 1) {
            ind++;
        }
        ans = max(ans, min(a, Ls[i].first) + min(b, Rs[ind].first));
    }
    cout << ans;
}
