#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <immintrin.h>

#pragma target("avx2")

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")
//
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/rope>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;

#define int long long

using namespace std;

class ST {
    vector<pair<int, int>> tree;
    vector<int> value;
    int n;

    ST(vector<int> &value) : value(value) {
        n = value.size();
        tree.resize(4 * n);
    }

    void build(int v, int l, int r) {
        if (l == r - 1) {
            tree[v].first = value[l];
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid, r);
        tree[v].first = tree[v * 2 + 1].first + tree[v * 2 + 2].first;
    }

    void push(int v, int l, int r) {
        if (l == r - 1) {
            tree[v].first += tree[v].second;
            tree[v].second = 0;
            return;
        }
        tree[v].first += tree[v].second * (r - l);
        tree[v * 2 + 1].second += tree[v].second;
        tree[v * 2 + 2].second += tree[v].second;
        tree[v].second = 0;
    }

    int get_sum(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (ql <= l and r <= qr) {
            return tree[v].first;
        }
        if (r <= ql and qr <= l) {
            return 0;
        }
        int mid = (l + r) / 2;
        return get_sum(v * 2 + 1, l, mid, ql, qr) + get_sum(v * 2 + 2, mid, r, ql, qr);
    }

    void update(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (ql <= l and r <= qr) {
            tree[v].first += x;
        }
        if (r <= ql and qr <= l) {
            return;
        }
        int mid = (r + l) / 2;
        update(v * 2 + 1, l, mid, ql, qr, x);
        update(v * 2 + 2, mid, r, ql, qr, x);
    }
};

#define int long long

signed main() {
    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> R[i];
    }
    reverse(D.begin(), D.end());
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + D[i - 1];
    }
    reverse(L.begin(), L.end());
    reverse(R.begin(), R.end());
    for (int i = 0; i < n; i++) {
        L[i] += pref[i];
        R[i] += pref[i];
    }
    reverse(L.begin(), L.end());
    reverse(R.begin(), R.end());
    int a, b;
    cin >> a >> b;
    a += pref.back();
    b += pref.back();
    vector<pair<int, int>> Ls(n), Rs(n);
    for (int i = 0; i < n; i++) {
        Ls[i] = {L[i], i};
        Rs[i].first = R[i];
    }
    sort(Ls.rbegin(), Ls.rend());
    sort(Rs.begin(), Rs.end());
    int ans = max(a + min(b, Rs[0].first), b + min(a, Ls.back().first));
    int ind = 0;
    for (int i = 0; i < n - 1; i++) {
        int l = 0, r = n;
        while (r - l != 1) {
            int mid = (r + l) / 2;
            if (Rs[mid].first > R[Ls[i].second]) {
                r = mid;
            } else if (Rs[mid].first == R[Ls[i].second] and Rs[mid].second == 1) {
                r = mid;
            } else {
                l = mid;
            }
        }
        Rs[l].second = 1;
        while (Rs[ind].second == 1) {
            ind++;
        }
        ans = max(ans, min(a, Ls[i].first) + min(b, Rs[ind].first));
    }
    cout << ans;
}
