#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 1e5;
int n;
int L[MAXN + 1], R[MAXN + 1], D[MAXN];
ll pref[MAXN + 2];
set <pair <pair <int, int>, int>> dp;

void build_pref() {
    for (int i = 0; i <= n; i++)
        pref[i + 1] = pref[i] + D[i];
}

void calc(int l, int r, int i) {
    if (i == n + 1) {
        return;
    }
    if (dp.count({{l, r}, i}))
        return;


    dp.insert({{l, r}, i});
    ll a = L[l] + pref[i] - pref[l];
    ll b = R[r] + pref[i] - pref[r];

    if (b + D[i] >= R[i + 1])
        calc(l, i + 1, i + 1);
    else
        calc(l, r, i + 1);
    if (a + D[i] >= L[i + 1])
        calc(i + 1, r, i + 1);
    else
        calc(l, r, i + 1);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> D[i];
    for (int i = 1; i <= n; i++)
        cin >> L[i];
    for (int i = 1; i <= n; i++)
        cin >> R[i];
    cin >> L[0] >> R[0];
    build_pref();
    calc(0, 0, 0);
    ll max_ans = 0;
    for (auto v : dp)
        if (v.ss == n) {
            ll a = L[v.ff.ff] + pref[n] - pref[v.ff.ff];
            ll b = R[v.ff.ss] + pref[n] - pref[v.ff.ss];
            max_ans = max(max_ans, a + b);
        }
    cout << max_ans << '\n';
}

int main() {
    fast_input;
    solve();
}