#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRng (int l, int r) {
    return rng() % (r - l + 1) + l;
}

void solve() {
    int n;
    cin >> n;
    vector<int> D(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }

    vector<int> L(n);
    vector<int> R(n);

    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> R[i];
    }

    int a0, b0;
    cin >> a0 >> b0;

    int ans = -1e18;

    for (int mask = 0; mask < (1 << n); mask++) {
        int A = a0, B = b0;
        for (int i = 0; i < n; i++) {
            A += D[i], B += D[i];
            if ((mask >> i) & 1) {
                A = min(A, L[i]);
            } else {
                B = min(B, R[i]);
            }
        }

        ans = max(ans, A + B);
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}