#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRng (int l, int r) {
    return rng() % (r - l + 1) + l;
}

const ll infll = 1e18;

struct SegTree {
    struct node {
        int mn = infll;
    };

    int n;
    vector<node> tree;

    void init (int k) {
        n = 1;
        while (n < k) n *= 2;
        tree.resize(2 * n - 1);
    }

    node merge (node l, node r) {
        node res;
        res.mn = min(l.mn, r.mn);
        return res;
    }

    void update (int x, int i, int v, int l, int r) {
        if (r - l == 1) {
            tree[x].mn = v;
            return;
        }

        int m = (r + l) / 2;

        if (i < m) {
            update(2 * x + 1, i, v, l, m);
        } else {
            update(2 * x + 2, i, v, m, r);
        }

        tree[x] = merge(tree[2 * x + 1], tree[2 * x + 2]);
    }

    node get (int x, int lx, int rx, int l, int r) {
        if (l >= rx || lx >= r) return node();
        if (lx <= l && r <= rx) return tree[x];
        int m = (r + l) / 2;
        return merge(get(2 * x + 1, lx, rx, l, m), get(2 * x + 2, lx, rx, m, r));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1), r(n + 1);

    vector<int> pref(n + 2, 0);

    for (int i = 1; i <= n; i++) {
        cin >> d[i];
        pref[i + 1] = pref[i] + d[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }

    cin >> l[0] >> r[0];

    int ans = -1e18;

    vector<int> find_b(n + 1, -infll);

    {
        vector<int> indL(n + 1, 0);
        vector<int> indR(n + 1, 0);

        iota(all(indL), 0ll);

        sort(all(indL), [&] (int i, int j) {
            if (l[i] - pref[i + 1] == l[j] - pref[j + 1]) return i > j;
            return l[i] - pref[i + 1] < l[j] - pref[j + 1];
        });

        SegTree t;
        t.init(n + 2);

        for (int i = 0; i <= n; i++) {
            t.update(0, i, infll, 0, t.n);
        }

        for (int i = 0; i < sz(indL); i++) {
            int j = indL[i];

            t.update(0, j, r[j] - pref[j + 1], 0, t.n);

            if (l[j] - pref[j] > l[0]) {
                continue;
            }

            find_b[j] = min(r[0] + pref[j + 1], pref[j + 1] + t.get(0, 0, j, 0, t.n).mn);
        }
    }

    {
        vector<int> indL(n + 1, 0);

        iota(all(indL), 0ll);

        sort(all(indL), [&] (int i, int j) {
            if (l[i] - pref[i + 1] == l[j] - pref[j + 1]) return i > j;
            return l[i] - pref[i + 1] < l[j] - pref[j + 1];
        });

        SegTree t;
        t.init(n + 2);

        for (int i = 0; i <= n; i++) {
            t.update(0, i, infll, 0, t.n);
        }

        for (int i = 0; i < sz(indL); i++) {
            int j = indL[i];

            t.update(0, j, r[j] - pref[j + 1], 0, t.n);

            int score = l[j] + pref.back() - pref[j + 1];

            int mx = t.get(0, j + 1, n + 1, 0, t.n).mn;

            int B = min(find_b[j] + pref.back() - pref[j + 1], pref.back() + mx);

            score += B;

            ans = max(ans, score);
//            cout << j << " " << find_b[j] << " " << score << endl;
        }
    }


    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}