#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));

ll rnd(ll x) {
    uniform_int_distribution<ll> uid(0, x - 1);
    return uid(rngl);
}

int rnd(int x) {
    uniform_int_distribution<int> uid(0, x - 1);
    return uid(rng);
}

int R = 1;
struct segment_tree {
    vector <ll> t, add;
    segment_tree(int n) {
        R = 1;
        while (R <= n + 10)
            R *= 2;
        t.resize(R * 2 + 32);
        add.resize(R * 2 + 32);
    }
    void push(int node, int nl, int nr) {
        t[node] += add[node] * (nr - nl + 1);
        if (node < R) {
            add[node * 2] += add[node];
            add[node * 2 + 1] += add[node];
        }
        add[node] = 0;
    }
    void calc(int node) {
        if (node < R) {
            t[node] = t[node * 2] + t[node * 2 + 1];
        }
    }
    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (qr <= nl && nr <= qr) {
            add[node] += val;
            push(node, nl, nr);
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }
    ll query(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (qr <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return query(ql, qr, node * 2, nl, nm) +
               query(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ll x, y;

    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    void in() {
        cin >> x >> y;
    }

    ll operator*(Point &other) {
        return x * other.x + y * other.y;
    }

    ll operator%(Point &other) {
        return x * other.y - y * other.x;
    }
};

ll get(int x, int y) {
    return (x << 10) ^ y;
}

int sz = 12;

void solve() {
    int n;
    cin >> n;
    sz = log2(100000000 / n / n) + 1;
    vector <ll> d(n + 1), l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (auto& i : l)
        cin >> i;
    for (auto& i : r)
        cin >> i;
    ll a0, b0;
    cin >> a0 >> b0;
    ll ans = 0;
    for (int mask = 0; mask < (1 << min(sz, n)); mask++) {
        for (int i = 0; i <= n - min(sz, n); i++) {
            ll a = a0, b = b0;
            for (int j = 0; j < i; j++) {
                a += d[j];
                b += d[j];
                if (a >= l[j])
                    b = min(b, r[j]);
            }
            for (int j = i; j < n - min(sz, n); j++) {
                a += d[j];
                b += d[j];
                if (b >= r[j])
                    a = min(a, l[j]);
            }
            for (int j = n - min(sz, n); j < n; j++) {
                a += d[j];
                b += d[j];
                if (mask & (1 << (j - (n - min(sz, n)))))
                    a = min(a, l[j]);
                else
                    b = min(b, r[j]);
            }
            ans = max(ans, a + b);
        }
        for (int i = 0; i <= n - min(sz, n); i++) {
            ll a = a0, b = b0;
            for (int j = 0; j < i; j++) {
                a += d[j];
                b += d[j];
                if (b >= r[j])
                    a = min(a, l[j]);
            }
            for (int j = i; j < n - min(sz, n); j++) {
                a += d[j];
                b += d[j];
                if (a >= l[j])
                    b = min(b, r[j]);
            }
            for (int j = n - min(sz, n); j < n; j++) {
                a += d[j];
                b += d[j];
                if (mask & (1 << (j - (n - min(sz, n)))))
                    a = min(a, l[j]);
                else
                    b = min(b, r[j]);
            }
            ans = max(ans, a + b);
        }
    }
    ll ap = a0, bp = b0;
    for (int i = 0; i < n; i++) {
        ap += d[i];
        ap = min(ap, l[i]);
        bp += d[i];
        ll a = ap, b = bp;
        for (int j = i + 1; j < n; j++) {
            if (a + d[j] <= l[j]) {
                a += d[j];
                b += d[j];
            }
            else {
                a += d[j];
                b += d[j];
                b = min(b, r[j]);
            }
        }
        ans = max(ans, a + b);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    cerr << "Ulyanovsk is the best!!!" << endl;
}
