#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;


#pragma GCC optimize("Ofast")

const int MAXN = 1e5 + 10;

ll d[MAXN];
ll l[MAXN];
ll r[MAXN];
ll post[MAXN];
int n;
ll a, b;

struct node {
    ll l, r, id;
};

inline bool comp(const node& p1, const node& p2) {
    if (p1.l != p2.l)
        return p1.l > p2.l;
    return p1.r < p2.r;
}

ll slow() {
    ll res = 0;
    ve<int> ans;
    ll ansa, ansb;
    for (int i = 0; i < (1 << n); i++) {
        ll ca = a, cb = b;
        for (int j = 0; j < n; j++) {
            ca += d[j];
            cb += d[j];
            if ((i >> j) & 1)
                ca = min(ca, l[j]);
            else cb = min(cb, r[j]);
        }
        if (res < ca + cb) {
            ans.clear();
            res = ca + cb;
            ansa = ca;
            ansb = cb;
        }
        if (res == ca + cb)
            ans.push_back(i);
    }
    return res;
}

ll calc(ve<bool>& ok) {
    ll ca = a, cb = b;
    for (int i = 0; i < n; i++) {
        ca += d[i];
        cb += d[i];
        if (ok[i])
            ca = min(ca, l[i]);
        else cb = min(cb, r[i]);
    }
    return ca + cb;
}

ll solve() {
    for (int i = n; i >= 0; i--)
        post[i] = post[i + 1] + d[i];
    ve<bool> ok(n);
    ve<node> psts;
    for (int i = 1; i <= n; i++)
        psts.push_back({ l[i - 1] + post[i + 1], r[i - 1] + post[i + 1], i - 1 });
    ll res = 0;
    sort(all(psts), comp);
    for (int i = 0; i < n; i++) {
        res = max(res, calc(ok));
        ok[psts[i].id] = 1;
    }
    res = max(res, calc(ok));
    return res;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> d[i];
    for (int i = 0; i < n; i++)
        cin >> l[i];
    for (int i = 0; i < n; i++)
        cin >> r[i];
    cin >> a >> b;
    cout << solve() << endl;

}
