#include <algorithm>
#include <iostream>
#include <vector>

int solved0(int n, std::vector<long long>& d, std::vector<long long>& l, std::vector<long long>& r, long long a0, long long b0) {
    l[0] = a0;
    r[0] = b0;
    std::vector<std::pair<long long, int>> possl(n + 1);
    for (int i = 0; i <= n; i++) {
        possl[i].first = l[i];
        possl[i].second = i;
    }
    std::sort(possl.begin(), possl.end());
    long long minr = r[0];
    long long maxres = 0;
    for (int i = 0; i <= n; i++) {
        maxres = std::max(maxres, minr + std::min(l[0], possl[i].first));
        minr = std::min(minr, r[possl[i].second]);
    }
    std::cout << maxres << '\n';
    return 0;
}

int main() {
    int n;
    std::cin >> n;
    std::vector<long long> d(n + 1);
    std::vector<long long> l(n + 1);
    std::vector<long long> r(n + 1);
    std::vector<long long> a(n + 1);
    std::vector<long long> b(n + 1);
    bool d0 = true;
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
        if (d[i + 1] != 0) {
            d0 = false;
        }
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    long long a0, b0;
    std::cin >> a0 >> b0;
    if (d0) {
        return solved0(n, d, l, r, a0, b0);
    }
    std::vector<std::vector<std::pair<long long, long long>>> dp(n + 1, std::vector<std::pair<long long, long long>>(n + 1));
    dp[0][0] = {a0, b0};

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            auto [pra, prb] = dp[i - 1][j];
            pra += d[i];
            prb += d[i];
            dp[i][j].first = pra;
            dp[i][j].second = std::min(prb, r[i]);
            if (j != 0) {
                auto [pra2, prb2] = dp[i - 1][j - 1];
                pra2 += d[i];
                prb2 += d[i];
                pra2 = std::min(pra2, l[i]);
                if (pra2 + prb2 > dp[i][j].first + dp[i][j].second) {
                    dp[i][j] = {pra2, prb2};
                }
            }
        }
    }
    long long maxres = 0;
    for (int i = 0; i <= n; i++) {
        maxres = std::max(maxres, dp[n][i].first + dp[n][i].second);
    }
    std::cout << maxres << '\n';
    return 0;
}