#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll &i : d) {
        cin >> i;
    }
    for (ll &i : l) {
        cin >> i;
    }
    for (ll &i : r) {
        cin >> i;
    }
    vector<ll> a(1), b(1);
    cin >> a[0] >> b[0];
    vector<vector<pair<ll, ll>>> dp(n + 1, vector<pair<ll, ll>> (2));
    dp[0][0] = {a[0], b[0]};
    dp[0][1] = {a[0], b[0]};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            auto [a1, b1] = dp[j][0];
            auto [a2, b2] = dp[j][0];
            for (int k = j; k <= i; ++k) {
                a1 = min(l[k], a1 + d[k]);
                b1 += d[k];
                a2 += d[k];
                b2 = min(r[k], b2 + d[k]);
            }
            if (a1 + b1 >= dp[i + 1][0].first + dp[i + 1][0].second) {
                dp[i + 1][0] = {a1, b1};
            }
            if (a2 + b2 >= dp[i + 1][1].first + dp[i + 1][1].second) {
                dp[i + 1][1] = {a2, b2};
            }
            a1 = dp[j][1].first;
            b1 = dp[j][1].second;
            a2 = dp[j][1].first;
            b2 = dp[j][1].second;
            for (int k = j; k <= i; ++k) {
                a1 = min(l[k], a1 + d[k]);
                b1 += d[k];
                a2 += d[k];
                b2 = min(r[k], b2 + d[k]);
            }
            if (a1 + b1 >= dp[i + 1][0].first + dp[i + 1][0].second) {
                dp[i + 1][0] = {a1, b1};
            }
            if (a2 + b2 >= dp[i + 1][1].first + dp[i + 1][1].second) {
                dp[i + 1][1] = {a2, b2};
            }
        }
        //cout << dp[i + 1][0].first << ' ' << dp[i + 1][0].second << "; ";
        //cout << dp[i + 1][1].first << ' ' << dp[i + 1][1].second << ';' << endl;
    }
    auto [a1, b1] = dp[n][0];
    auto [a2, b2] = dp[n][1];
    cout << max(a1 + b1, a2 + b2) << ' ';
}

void correct() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll &i : d) {
        cin >> i;
    }
    for (ll &i : l) {
        cin >> i;
    }
    for (ll &i : r) {
        cin >> i;
    }
    int a, b;
    cin >> a >> b;
    ll ans = 0;
    int ans_mask = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ll x = a, y = b;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                x = min(x + d[i], l[i]);
                y += d[i];
            } else {
                x += d[i];
                y = min(y + d[i], r[i]);
            }
        }
        if (ans < x + y) {
            ans_mask = mask;
        }
        ans = max(ans, x + y);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        //correct();
    }
}