#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << " } "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

const int N = 1e5 + 3;
ll L[N], R[N], D[N], pref[N];
ll dp[2][N];
int n, a0, b0;

void solve1() {
    vector<pair<ll, ll>> bebra(n + 1);
    for (int i = 0; i <= n; i++)
        bebra[i] = {L[i], R[i]};

    sort(all(bebra));
    vector<ll> pref_mn(n + 2);
    pref_mn[0] = INF;
    for (int i = 1; i <= n + 1; i++) {
        pref_mn[i] = min(pref_mn[i - 1], bebra[i - 1].S);
    }

    //dbg1(pref);
    ll ans = 0;
    //dbg2(bebra);
    for (int i = 0; i <= n; i++) {
        if (L[i] > a0) continue;
        
        int l = 0, r = n + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (bebra[m].F >= L[i]) r = m;
            else l = m;
        }

        //cout << L[i] << ' ' << pref[r] << ' ' << r << '\n';
        ans = max(ans, L[i] + min(1ll * b0, pref_mn[r]));
    }

    cout << ans << '\n';
}

void solve2() {
    for (int i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + D[i - 1];

    for (int i = 1; i <= n; i++) {
        int ci = i & 1, pri = ci ^ 1;
        fill(dp[ci], dp[ci] + n + 1, -INF);
        for (int j = 0; j < i; j++) {
            if (pref[i] - pref[j] + L[j] <= L[i] && dp[pri][j] != -INF)
                dp[ci][j] = dp[pri][j] + D[i - 1];
            else if (dp[pri][j] != -INF)
                dp[ci][j] = min(dp[pri][j] + D[i - 1], R[i]);

            if (pref[i] - pref[j] + L[j] >= L[i] && dp[pri][j] != -INF)
                dp[ci][i] = max(dp[ci][i], dp[pri][j] + D[i - 1]);
        }

    }

    ll ans = 0;
    for (int prev = n; prev >= 0; prev--) {
        ll a = pref[n] - pref[prev] + L[prev];
        //dbg(a << ' ' << dp[n & 1][prev]);
        ans = max(ans, dp[n & 1][prev] + a);
    }

    cout << ans << '\n';
}

void solve() {
    cin >> n;
    bool fl = true;
    for (int i = 0; i < n; i++) {
        cin >> D[i];
        fl &= (D[i] == 0);
    }
    for (int i = 1; i <= n; i++)
        cin >> L[i];
    for (int i = 1; i <= n; i++)
        cin >> R[i];

    //int a0, b0;
    cin >> a0 >> b0;
    L[0] = a0;
    R[0] = b0;
    dp[0][0] = b0;

    if (fl) {
        solve1();
    } else {
        solve2();
    }
}

signed main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
