#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;


bool check(vector<vector<ll>>& graph, map<ll, bool>& used, ll& n, ll u) {
	if (n == 1) {
		return true;
	}
	used[u] = true;
	n--;
	for (ll i : graph[u]) {
		if (!used[i]) {
			if (check(graph, used, n, i)) {
				return true;
			}
		}
	}
	return false;
}

bool buildComponents(vector<vector<ll>>& graph, map<ll, bool>& used, ll& n, vector<ll>& component, ll u) {
	if (n == 1) {
		return true;
	}
	used[u] = true;
	n--;
	for (ll i : graph[u]) {
		if (!used[i]) {
			component.push_back(i);
			if (check(graph, used, n, i)) {
				return true;
			}
		}
	}
	return false;
}

bool Buravchik(vector<vector<ll>>& graph1, vector<vector<ll>>& graph2, ll n, ll m1, ll m2, vector<vector<ll>>& components) {
	ll sz = components.size();
	vector<pair<ll, ll>> out;
	for (ll i = 0; i < sz - 1; i++) {
		bool find_add = false;
		for (ll j = i + 1; j < sz; j++) {
			for (ll& u : components[i]) {
				for (ll& v : components[j]) {
					if (find(graph2[u].begin(), graph2[u].end(), v) != graph2[u].end()) {
						graph2[u].erase(find(graph2[u].begin(), graph2[u].end(), v));
						graph2[v].erase(find(graph2[v].begin(), graph2[v].end(), u));
						map<ll, bool> used;
						ll nn = n;
						if (!check(graph2, used, nn, 0)) {
							graph2[u].push_back(v);
							graph2[v].push_back(u);
						}
						else {
							find_add = true;
							out.push_back({ u + 1, v + 1 });
							break;
						}
					}
					else {
						graph2[u].push_back(v);
						graph2[v].push_back(u);
						find_add = true;
						out.push_back({ u + 1, v + 1 });
						break;
					}
					if (find_add) break;
				}
				if (find_add) break;
			}
			if (find_add) break;
		}
		if (!find_add) {
			cout << "No" << '\n';
			return false;
		}
	}
	cout << "Yes\n" << out.size() << '\n';
	for (auto i : out) {
		cout << i.first << " " << i.second << '\n';
	}
}


int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	
	ll n;
	cin >> n;
	vector<ll> d, l, r;
	d = l = r = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> r[i];
	}
	vector<ll> a, b;
	a = b = vector<ll>(n + 1);
	cin >> a[0] >> b[0];
	for (ll i = 1; i < n + 1; i++) {
		ll j = i - 1;
		a[i] = a[j] + d[j];
		b[i] = b[j] + d[j];
		ll sum = a[i] + b[i];

		ll newa = min(a[i], l[j]);
		ll newb = min(b[i], r[j]);

		if (sum - a[i] + newa > sum - b[i] + newb) {
			a[i] = newa;
		}
		else {
			b[i] = newb;
		}
	}

	cout << a[n] + b[n] << endl;

}
