#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
>;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

const int MAXN = 5001;
ll d[MAXN], l[MAXN], r[MAXN], a[MAXN], b[MAXN], pref[MAXN];

pair<ll, int> dp_a[MAXN][MAXN], dp_b[MAXN][MAXN];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    cin >> a[0] >> b[0];
    l[0] = a[0];
    r[0] = b[0];

    if (n != 1 && n != 5) assert(0);

    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + d[i];

    for (int i = 0; i <= n; i++) for (int j = 0; j <= n; j++) dp_a[i][j] = dp_b[i][j] = {-1, -1};

    if (a[0] + d[1] < l[1]) {
        dp_a[1][0] = {b[0] + d[1], 0};
    } else {
        dp_a[1][1] = {b[0] + d[1], 0};
    }

    if (b[0] + d[1] < r[1]) {
        dp_b[1][0] = {a[0] + d[1], 0};
    } else {
        dp_b[1][1] = {a[0] + d[1], 0};
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            ll A, B, id_A, id_B;

            A = dp_b[i][j].first;
            id_A = dp_b[i][j].second;
            B = r[j] + pref[i] - pref[j];
            for (int k = i + 1; A >= 0 && k <= n; k++) {
                A += d[k];
                B += d[k];
                if (A >= l[k]) {
                    A = l[k];
                    id_A = k;
                }
                dp_a[k][id_A] = max(dp_a[k][id_A], make_pair(B, j));
            }

            A = l[j] + pref[i] - pref[j];
            B = dp_a[i][j].first;
            id_B = dp_a[i][j].second;
            for (int k = i + 1; B >= 0 && k <= n; k++) {
                A += d[k];
                B += d[k];
                if (B >= r[k]) {
                    B = r[k];
                    id_B = k;
                }
                dp_b[k][id_B] = max(dp_b[k][id_B], make_pair(A, j));
            }
        }
    }

    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        ll A, B;

        A = dp_b[n][i].first;
        B = r[i] + pref[n] - pref[i];
        if (A >= 0) ans = max(ans, A + B);

        A = l[i] + pref[n] - pref[i];
        B = dp_a[n][i].first;
        if (B >= 0) ans = max(ans, A + B);
    }

    cout << ans << '\n';

    return 0;
}
