#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
>;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

const int MAXN = 5001;
ll d[MAXN], l[MAXN], r[MAXN], a[MAXN], b[MAXN], pref[MAXN];

pair<ll, int> dp_a[MAXN][MAXN], dp_b[MAXN][MAXN];
int n;

ll solve() {
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + d[i];
    for (int i = 0; i <= n; i++) for (int j = 0; j <= n; j++) dp_a[i][j] = dp_b[i][j] = {-1, -1};

    ll A, B, id_A, id_B;

    A = a[0];
    B = b[0];
    id_A = 0;
    for (int i = 1; i <= n; i++) {
        A += d[i];
        B += d[i];
        if (A >= l[i]) {
            A = l[i];
            id_A = i;
        }
        dp_a[i][id_A] = {B, 0};
    }

    A = a[0];
    B = b[0];
    id_B = 0;
    for (int i = 1; i <= n; i++) {
        A += d[i];
        B += d[i];
        if (B >= r[i]) {
            B = r[i];
            id_B = i;
        }
        dp_b[i][id_B] = {A, 0};
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            ll A, B, id_A, id_B;

            A = dp_b[i][j].first;
            id_A = dp_b[i][j].second;
            B = r[j] + pref[i] - pref[j];
            for (int k = i + 1; A >= 0 && k <= n; k++) {
                A += d[k];
                B += d[k];
                if (A >= l[k]) {
                    A = l[k];
                    id_A = k;
                }
                dp_a[k][id_A] = max(dp_a[k][id_A], make_pair(B, j));
            }

            A = l[j] + pref[i] - pref[j];
            B = dp_a[i][j].first;
            id_B = dp_a[i][j].second;
            for (int k = i + 1; B >= 0 && k <= n; k++) {
                A += d[k];
                B += d[k];
                if (B >= r[k]) {
                    B = r[k];
                    id_B = k;
                }
                dp_b[k][id_B] = max(dp_b[k][id_B], make_pair(A, j));
            }
        }
    }

    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        ll A, B;

        A = dp_b[n][i].first;
        B = r[i] + pref[n] - pref[i];
        if (A >= 0) ans = max(ans, A + B);

        A = l[i] + pref[n] - pref[i];
        B = dp_a[n][i].first;
        if (B >= 0) ans = max(ans, A + B);
    }

    return ans;
}

ll stupid() {
    ll ans = 0;
    int mx_mask = 1 << n;
    for (int mask = 0; mask < mx_mask; mask++) {
        for (int i = 1; i <= n; i++) {
            a[i] = a[i - 1] + d[i];
            b[i] = b[i - 1] + d[i];
            if ((mask >> (i - 1)) & 1) {
                a[i] = min(a[i], l[i]);
            } else {
                b[i] = min(b[i], r[i]);
            }
        }
    }
    ans = max(ans, a[n] + b[n]);

    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    cin >> a[0] >> b[0];
    l[0] = a[0];
    r[0] = b[0];
    cout << solve() << '\n';

//
//    while (true) {
//        n = rng() % 2 + 1;
//        for (int i = 1; i <= n; i++) l[i] = rng() % 5;
//        for (int i = 1; i <= n; i++) r[i] = rng() % 5;
//        for (int i = 1; i <= n; i++) d[i] = rng() % 5;
//        a[0] = rng() % 5; b[0] = rng() % 5;
//
//        l[0] = a[0];
//        r[0] = b[0];
//
//        if (solve() != stupid()) {
//            cout << n << '\n';
//            for (int i = 1; i <= n; i++) cout << d[i] << " \n"[i == n];
//            for (int i = 1; i <= n; i++) cout << l[i] << " \n"[i == n];
//            for (int i = 1; i <= n; i++) cout << r[i] << " \n"[i == n];
//            cout << a[0] << ' ' << b[0] << '\n';
//            cout << solve() << ' ' << stupid() << '\n';
//            break;
//        }
//    }


    return 0;
}

/*
2
4 3
3 2
3 1
0 1


8 10
 */