#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

vector <vector <int>> res;
vector <int> suff;
vector <int> d, l, r;
int a0, b0;

void dfs(int va, int vb, vector <vector <int>>& gra, vector <vector <int>>& grb) {
    int il = 0, ir = 0;
    while (il < gra[va].size() && ir < grb[vb].size()) {
        if (gra[va][il] == grb[vb][ir]) {
            int u = gra[va][il];
            if (res[va][u] == -1) {
                dfs(va, u, gra, grb);
            }
            if (res[u][vb] == -1) {
                dfs(u, vb, gra, grb);
            }
            res[va][vb] = max(res[va][u], res[u][vb]);
            return;
        } else if (gra[va][il] < gra[vb][ir]) {
            il++;
        } else {
            ir++;
        }
    }
    res[va][vb] = (va == 0 ? a0 : l[va - 1]) + suff[va] + (vb == 0 ? b0 : r[vb - 1]) + suff[vb];
}

void solve() {
    int n;
    cin >> n;

    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }

    suff.resize(n + 1);
    suff[n] = 0;
    suff[n - 1] = d[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suff[i] = suff[i + 1] + d[i];
    }

    cin >> a0 >> b0;

    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            int cura = a0, curb = b0;
            for (int i = 0; i < n; i++) {
                cura += d[i];
                curb += d[i];
                if (mask & (1 << i)) {
                    cura = min(cura, l[i]);
                } else {
                    curb = min(curb, r[i]);
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans << "\n";
        return;
    }

    vector <vector <int>> gra(n + 2);
    for (int v = 0; v <= n; v++) {
        int st;
        if (v == 0) {
            st = a0;
        } else {
            st = l[v - 1];
        }
        for (int u = v + 1; u <= n; u++) {
            st += d[u - 1];
            if (st > l[u - 1]) {
                gra[v].push_back(u);
            }
        }
    }
    vector <vector <int>> grb(n + 2);
    for (int v = 0; v <= n; v++) {
        int st;
        if (v == 0) {
            st = b0;
        } else {
            st = r[v - 1];
        }
        for (int u = v + 1; u <= n; u++) {
            st += d[u - 1];
            if (st > r[u - 1]) {
                grb[v].push_back(u);
            }
        }
    }

    res.assign(n + 2, vector <int> (n + 2, -1));
    dfs(0, 0, gra, grb);
    cout << res[0][0] << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}