#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct segtree_min {
    vi t;
    int n;

    segtree_min(int _n, vi &a) {
        n = _n;
        t.resize(n * 4);
        build(a, 0, n);
    }

    void build(vi &a, int l, int r, int p = 0) {
        if (l + 1 == r) {
            t[p] = a[l];
            return;
        }
        int m = (r + l) >> 1;
        build(a, l, m, p * 2 + 1);
        build(a, m, r, p * 2 + 2);
    }

    int get(int lx, int rx, int l, int r, int p = 0) {
        if (l >= rx or r <= lx) return MX;
        if (lx <= l and r <= rx) return t[p];
        int m = (r + l) >> 1;
        return min(get(lx, rx, l, m, p * 2 + 1),
                   get(lx, rx, m, r, p * 2 + 2));
    }
};

int dfs(int i, vi &d, vi &l, vi &r, int suma, int sumb) {
    if (i == d.size()) return suma + sumb;
    suma += d[i];
    sumb += d[i];
    int res = max(dfs(i + 1, d, l, r, suma, min(sumb, r[i])),
                  dfs(i + 1, d, l, r, min(suma, l[i]), sumb));
    return res;
}

void solve() {
    int n;
    cin >> n;
    vi d(n), l(n), r(n), pre(n + 1);
    for (auto &i: d) cin >> i;
    for (auto &i: l) cin >> i;
    for (auto &i: r) cin >> i;
    for (int i = 1; i <= n; i++) {
        pre[i] = pre[i - 1] + d[i - 1];
    }
    int a0, b0;
    cin >> a0 >> b0;
    if (n <= 15) {
        cout << dfs(0, d, l, r, a0, b0);
        return;
    }
    int mx = 0;
    vector<dui> tog(n);
    for (int i = 0; i < n; i++) {
        tog[i].first = l[i], tog[i].second = r[i];
    }
    sort(tog.begin(), tog.end());
    set<int> mns;
    for (int i = 0; i < n; i++) {
        while(i + 1 < n and tog[i].first == tog[i + 1].first) {
            mns.insert(tog[i].second);
            i++;
        }
        mx = max(mx, min(tog[i].first, a0) + min(*mns.begin(), b0));
    }
    cout << mx;
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
