#include <iostream>
#include <cassert>
#include <algorithm>
#include <random>
#include <vector>
using namespace std;
using ll = long long;

const ll INF = 1e18 + 177013;
const int MAXN = 1e5 + 123;
int d[MAXN];
ll dsm[MAXN];
ll l[MAXN];
ll r[MAXN];

int break_ind[MAXN];

void init(int n) {
    for (int i = 1; i <= n; ++i)
        cin >> d[i];
    for (int i = 1; i <= n; ++i)
        dsm[i] = dsm[i - 1] + d[i];
    for (int i = 1; i <= n; ++i)
        cin >> l[i];
    for (int i = 1; i <= n; ++i)
        cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;
    vector<pair<ll, int>> cpr(n + 1);
    for (int i = 0; i <= n; ++i)
        cpr[i] = {l[i] - dsm[i], i};
    sort(cpr.begin(), cpr.end());
    for (int i = 0; i <= n; ++i) {
        break_ind[i] = lower_bound(cpr.begin(), cpr.end(), pair<ll, int>(l[i] - dsm[i], i)) - cpr.begin();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    init(n);

    vector<ll> dp(n + 1, -INF);
    dp[break_ind[0]] = r[0];
    for (int i = 0; i < n; ++i) {
        vector<ll> ndp(n + 1, -INF);
        for (int j = 0; j <= break_ind[i + 1]; ++j) {
            ndp[j] = dp[j] + d[i + 1];
        }
        for (int j = break_ind[i + 1] + 1; j <= n; ++j) {
            ndp[break_ind[i + 1]] = max(ndp[break_ind[i + 1]], dp[j] + d[i + 1]);
            ndp[j] = max(ndp[j], min(dp[j] + d[i + 1], r[i + 1]));
        }
        dp = ndp;
    }
    ll ans = -INF;
    for (int i = 0; i <= n; ++i) for (int j = i + 1; j <= n; ++j)
        assert(break_ind[i] != break_ind[j]);
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dp[break_ind[i]] + l[i] + dsm[n] - dsm[i]);
    }
    cout << ans << endl;
}
