#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    bool d0 = true;
    for (ll i = 0; i < n; i++) cin >> d[i], d0 &= d[i] == 0;
    for (ll i = 0; i < n; i++) cin >> l[i];
    for (ll i = 0; i < n; i++) cin >> r[i];

    ll a, b;
    cin >> a >> b;

    if (d0) {
        ll ans = 0;

        ll bMin = b;

        vector<pll> p(n);
        for (ll i = 0; i < n; i++) p[i] = {l[i], -r[i]};
        std::sort(p.begin(), p.end());

        for (ll i = 0; i < n; i++) {
            if (i > 0) bMin = min(bMin, -p[i - 1].second);
            ans = max(ans, bMin + min(a, p[i].first));
        }

        ans = max(ans, a + min(bMin, p[n - 1].second));

        cout << ans;
        return 0;
    }

    vector<ll> p(n + 1);
    for (ll i = 1; i <= n; i++) p[i] = p[i - 1] + d[i - 1];

    map<ll, ll> dp;
    dp[a] = b;

    for (ll i = 0; i < n; i++) {
        map<ll, ll> nxtDP;
        for (auto [k, v] : dp) {
            {
                ll na = min(k + d[i], l[i]);
                ll nb = v + d[i];
                nxtDP[na] = max(nxtDP[na], nb);
            }

            {
                ll na = k + d[i];
                ll nb = min(v + d[i], r[i]);

                nxtDP[na] = max(nxtDP[na], nb);
            }
        }

        dp = nxtDP;
    }

    ll ans = 0;
    for (auto [k, v] : dp) ans = max(ans, k + v);

    cout << ans;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
