#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct Fenwick {
    vector<int> t;
    int n;

    Fenwick(int n) : n(n) {
        t.resize(n + 1);
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> d(n);
    cin >> d;
    vector<int> l(n);
    cin >> l;
    vector<int> r(n);
    cin >> r;
    int a0, b0;
    cin >> a0 >> b0;
    ll aa = a0, bb = b0;
    for (int i = 0; i < n; ++i) {
        ll cura = aa + d[i], curb = bb + d[i];
        if (cura <= l[i] || curb <= r[i]) {
            aa = cura;
            bb = curb;
            continue;
        }
        if (cura - l[i] <= curb - r[i]) {
            cura = l[i];
        }  else {
            curb = r[i];
        }
        aa = cura;
        bb = curb;
    }
    cout << aa + bb << "\n";
}
