#define _CRT_SECURE_NO_WARNINGS

#pragma gcc optimise("Ofast")
#pragma gcc optimise("unswith-loops")
#pragma gcc optimise("unroll-loops")
#pragma gcc optimise("no-stack-protector")
#pragma gcc optimise("fast-math")
#pragma gcc optimise("rename-registers")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const int N = 2e5 + 228, INF = 1e13;

vector<int> d, l, r;

void solve_d_0(int n, int a, int b) {
	vector<pii> comb(n);
	for (int i = 0; i < n; i++)
		comb[i] = { l[i], r[i] };
	sort(walk(comb));
	reverse(walk(comb));
	int prev_ = -1;
	vector<int> pref_min(n);
	pref_min.back() = comb.back().second;
	for (int i = n - 2; i >= 0; i--)
		pref_min[i] = min(comb[i].second, pref_min[i + 1]);
	pref_min.push_back(INF);
	int ans = -1;
	for (int i = 0; i < n; i++) {
		int f = min(a, comb[i].first), s = min(b, pref_min[i + 1]);
		ans = max(ans, f + s);
	}
	ans = max(ans, a + min(b, pref_min[0]));
	ans = max(ans, b + min(a, comb.back().first));
	cout << ans;
}

void solve_bin(int n, int a, int b) {
	int ans = 0;
	for (int mask = 0; mask < (1ll << n); mask++) {
		int cura = a, curb = b;
		for (int j = 0; j < n; j++) {
			cura += d[j];
			curb += d[j];
			if ((mask >> j) & 1)
				cura = min(cura, l[j]);
			else
				curb = min(curb, r[j]);
		}
		ans = max(ans, cura + curb);
	}
	cout << ans;
}

void solve() {
	int n;
	cin >> n;
	d.resize(n);
	l.resize(n);
	r.resize(n);
	int a, b;
	for (int i = 0; i < n; i++)
		cin >> d[i];
	for (int i = 0; i < n; i++)
		cin >> l[i];
	for (int i = 0; i < n; i++)
		cin >> r[i];
	cin >> a >> b;
	if (n <= 15)
		solve_bin(n, a, b);
	else
		solve_d_0(n, a, b);
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}