#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    int x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x - b.x, a.y - b.y));
    }

    friend int operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend int operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

void solve() {
    int n, a0, b0;
    cin >> n;
    vec<int> d(n), l(n), r(n);
    vec<int> s(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        s[i + 1] = s[i] + d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    vec<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        st.push_back({max(0ll, s[i + 1] + a0 - l[i]), i});
    }
    sort(all(st));
    int ans = 0;
    set<pair<int, int>> st2;
    for (int i = 0; i < n; ++i) {
        st2.insert({max(0ll, s[i + 1] + b0 - r[i]), i});
    }
    int mx = 0;
    for (int i = 0; i <= n; ++i) {
        if (i > 0) {
            mx = max(mx, st[i - 1].first);
            int j = st[i - 1].second;
            st2.erase({max(0ll, s[j + 1] + b0 - r[j]), j});
        }
        int mx2 = 0;
        if ((int)st2.size() > 0) {
            auto it = st2.end();
            it--;
            mx2 = (*it).first;
        }
        //cout << i << " " << a0 + s[n] + b0 + s[n] - mx - mx2 << endl;
        ans = max(a0 + s[n] + b0 + s[n] - mx - mx2, ans);
    }
    cout << ans << endl;
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}