#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if
#define read(x) x; cin>>x;

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int read(n);
    vector<int> D(n), L(n), R(n);
    cin >> D >> L >> R;
    int a0, b0;
    cin >> a0 >> b0;
    vector<ll> A(n), B(n);
    A[0] = a0 + D[0];
    B[0] = b0 + D[0];
    RANGE(i, n - 1) {
        A[i + 1] = A[i] + D[i + 1];
        B[i + 1] = B[i] + D[i + 1];
    }
    vector<pair<ll, ll>> mAB(n + 1);
    RANGE(i, n) {
        mAB[i] = {max(A[i] - L[i], 0LL), max(B[i] - R[i], 0LL)};
    }
    mAB[n] = {0, 0};
    sort(mAB.begin(), mAB.end());
    ll sum0 = A[n - 1] + B[n - 1];
    ll best = mAB[n].first;
    ll mB_max = 0;
    for (int i = n; i > 0; i--) {
        mB_max = max(mB_max, mAB[i].second);
        best = min(best, mAB[i - 1].first + mB_max);
    }
    cout << sum0 - best << ENDLINE;
}
