// t1.cpp
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <deque>
#include <random>
#include <functional>
#include <cassert>
#include <queue>

using namespace std;

const int lg = 19;
const int maxn = 1 << lg;
const int inf = 1e9;

int p[maxn];
int sz[maxn];
int r[maxn];

void init() {
    iota(p, p + maxn, 0);
    iota(r, r + maxn, 0);
    fill(sz, sz + maxn, 1);
}

int c(int v) {
    return (p[v] == v) ? v : p[v] = c(p[v]);
}

void unite(int u, int v) {
    u = c(u), v = c(v);
    if (u == v) return;
    p[u] = v;
    sz[v] += sz[u];
    r[v] = max(r[u], r[v]);
}

int up[lg][maxn];

pair<int, int> tree[maxn * 2];

void upd(int i, int x) {
    i += maxn;
    tree[i] = { x, i - maxn };
    while (i > 1) {
        i >>= 1;
        tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
    }
}

int get(int l, int r) {
    l += maxn;
    r += maxn;
    pair<int, int> ans = { inf, -1 };
    while (l < r) {
        if (l & 1) {
            ans = min(ans, tree[l++]);
        }
        if (r & 1) {
            ans = min(ans, tree[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans.second;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    map<int, vector<int>> dt;
    for (int& i : a) {
        cin >> i;
    }
    init();
    fill(tree, tree + maxn * 2, make_pair(inf, -1));
    for (int i = 0; i < n; ++i) {
        dt[-a[i]].push_back(i);
    }
    vector<int> rt(n, n);
    vector<int> arr(n, 0);
    set<int> ends;
    for (auto [x, v] : dt) {
        for (int i : v) {
            arr[i] = 1;
            if (i > 0 && arr[i - 1]) {
                ends.erase(i - 1);
                unite(i - 1, i);
            }
            if (i + 1 < n && arr[i + 1]) {
                unite(i, i + 1);
                if (sz[c(i)] >= d) {
                    ends.insert(r[c(i)]);
                }
            } else {
                if (sz[c(i)] >= d) {
                    ends.insert(i);
                }
            }
        }
        for (int i : v) {
            auto ptr = ends.lower_bound(i + d);
            if (ptr != ends.end()) {
                int id = *ptr;
                int bgn = max(i + 1, r[c(id)] - sz[c(id)] + 1);
                rt[i] = bgn + d;
            }
            upd(i, a[i]);
            up[0][i] = get(i + 1, rt[i]);
            if (up[0][i] == -1) {
                up[0][i] = i;
            }
            for (int j = 1; j < lg; ++j) {
                up[j][i] = up[j - 1][up[j - 1][i]];
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        assert(t == 1);
        --u; --v;
        for (int j = lg - 1; j >= 0; --j) {
            if (up[j][u] < v) {
                u = up[j][u];
            }
        }
        if (a[v] > a[u] && v < rt[u]) {
            cout << 1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }
}
