// nnq.cpp
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <deque>
#include <random>
#include <functional>
#include <cassert>
#include <queue>

using namespace std;

const int maxn = 1 << 17;
const int inf = 1e9;

int p[maxn];
int sz[maxn];
int r[maxn];

void init() {
    iota(p, p + maxn, 0);
    iota(r, r + maxn, 0);
    fill(sz, sz + maxn, 1);
}

int c(int v) {
    return (p[v] == v) ? v : p[v] = c(p[v]);
}

void unite(int u, int v) {
    u = c(u), v = c(v);
    if (u == v) return;
    p[u] = v;
    sz[v] += sz[u];
    r[v] = max(r[u], r[v]);
}

vector<int> bfs(int v, vector<vector<int>> &g) {
    queue<int> q;
    q.push(v);
    vector<int> dist(g.size(), inf);
    dist[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    return dist;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    map<int, vector<int>> dt;
    for (int& i : a) {
        cin >> i;
    }
    init();
    for (int i = 0; i < n; ++i) {
        dt[-a[i]].push_back(i);
    }
    vector<int> rt(n, n);
    vector<int> arr(n, 0);
    set<int> ends;
    for (auto [x, v] : dt) {
        for (int i : v) {
            arr[i] = 1;
            if (i > 0 && arr[i - 1]) {
                ends.erase(i - 1);
                unite(i - 1, i);
            }
            if (i + 1 < n && arr[i + 1]) {
                unite(i, i + 1);
                if (sz[c(i)] >= d) {
                    ends.insert(r[c(i)]);
                }
            } else {
                if (sz[c(i)] >= d) {
                    ends.insert(i);
                }
            }
        }
        for (int i : v) {
            auto ptr = ends.lower_bound(i + d);
            if (ptr != ends.end()) {
                int id = *ptr;
                int bgn = max(i + 1, r[c(id)] - sz[c(id)] + 1);
                rt[i] = bgn + d;
            }
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < rt[i]; ++j) {
            if (a[j] > a[i]) {
                g[i].push_back(j);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u; --v;
        int res = bfs(u, g)[v];
        if (t == 2) {
            cout << (res < inf ? res : 0) << '\n';
        } else {
            cout << (res < inf ? 1 : 0) << '\n';
        }
    }
}
