// tikhon_q_sqrt_n.cpp
#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

constexpr int N = 3 * 100000 + 10;

namespace segtree {  // снизу set в точке, max на отрезке

int tree[2 * N];

void setup() {
    fill(tree, tree + 2 * N, -1);
}

void upd(int pos, int val) {  // arr[pos] := val
    pos += N;
    tree[pos] = val;
    pos >>= 1;
    while (pos > 0) {
        tree[pos] = max(tree[pos << 1], tree[(pos << 1) | 1]);
        pos >>= 1;
    }
}

int get(int l, int r) {  // [l, r)
    l += N;
    r += N;
    int ans = -1;
    while (l < r) {
        if (l & 1) {
            ans = max(ans, tree[l++]);
        }
        if (r & 1) {
            ans = max(ans, tree[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

};  // namespace segtree


// seems faster then with extra arrays
namespace dsu {

int dsu[N];
void setup(int n = N) {
    iota(dsu, dsu + n, 0);
}

int get(int u) {
    if (dsu[u] == u) return u;
    return dsu[u] = get(dsu[u]);
}

void merge(int u, int v) {
    dsu[get(u)] = get(v);
}

};  // namespace dsu

namespace fast_max_sqrt {

constexpr int BLOCK = 1300;

int arr[N];
int block_pref_max[N];

void setup() {
    fill(arr, arr + N, -1);
    fill(block_pref_max, block_pref_max + N, -1);
}

void inc(int pos, int val) {
    arr[pos] = val;
    int lim = min(N, (pos / BLOCK + 1) * BLOCK);
    for (int i = pos; i < lim; ++i) {
        // block_pref_max[i] = max(block_pref_max[i], val);
        block_pref_max[i] = val;
    }
}

int get(int min_l, int max_l, int r) {  // [l, r)
    int res = -1;
    r--;  // [[min_l, max_l], r]

    int at_mn_l = min_l / BLOCK; 
    int at_mx_l = max_l / BLOCK;

    if (at_mn_l == at_mx_l) {
        if (r < (at_mx_l + 1) * BLOCK) {
            for (int i = max_l; i <= r; ++i) {
                res = max(res, arr[i]);
            }
            return res;
        } else {
            for (int i = max_l; i < (at_mx_l + 1) * BLOCK; ++i) {
                res = max(res, arr[i]);
            }   
            at_mx_l++;     
        }
    }

    int at_r = r / BLOCK;

    res = max(res, block_pref_max[r]);

    for (; at_r > at_mx_l; --at_r) {
        res = max(res, block_pref_max[at_r * BLOCK - 1]);
    }

    // cerr << "on ";
    // for (int i = 0; i < 10; ++i) {
    //     cerr << arr[i] << ' ';
    // } cerr << '\n';

    // cerr << "get [[" << min_l << ", " << max_l << "], " << r << "] : " << res << '\n'; 
    return res;
}


};  // namespace fast_max_sqrt

int n, d;
int a[N];
int segm[N];  // [., r) of possible jumps

struct Ask {
    int u, v, t;
    int ind;
    void input(int _ind) {
        ind = _ind;
        cin >> t >> u >> v;
        u--, v--;
        // what if u > v
    }
};

bool operator<(Ask lhs, Ask rhs) {
    return a[lhs.v] < a[rhs.v];  // not like author
}

int q;
vector<Ask> ask;
vector<int> ans;

void get_segms() {
    vector<pii> elem(n);
    for (int i = 0; i < n; ++i) {
        elem[i] = {a[i], i};
    }
    sort(all(elem));

    segtree::setup();
    dsu::setup();
    for (auto e : elem) {
        int i = e.second;
        int any = segtree::get(i, min(n, i + d + 1));
        if (any == -1) any = i;
        
        dsu::merge(i, any);
        segm[i] = min(n, dsu::get(i) + d + 1);
        
        any = segtree::get(max(0, i - d), i + 1);
        if (any != -1) dsu::merge(any, i);

        segtree::upd(i, i);
    }
}

int ind_by_val[N];

void make_elems_unique() {
    vector<pii> elem(n);
    for (int i = 0; i < n; ++i) {
        elem[i] = {a[i], -i};
    }
    sort(all(elem));

    for (int i = 0; i < n; ++i) {
        a[-elem[i].second] = i;
        ind_by_val[i] = -elem[i].second;
    }
}

int st[N];
int st_top = 0;

vector<int> get_max_upto_x(int x) {  // for each index get jump to max in segm, that is less (<) than x
    vector<int> res(n, -1);
    dsu::setup();

    st_top = -1;
    for (int i = n - 1; i >= 0; --i) {
        // get res;
        int g = dsu::get(segm[i] - 1);
        if (a[i] < a[g] && a[g] < x) res[i] = g;

        if (st_top >= 0 && x <= a[st[st_top]]) {
            dsu::merge(st[st_top--], i);
        }

        if (a[i] < x) {
            while (st_top >= 0 && a[i] >= a[st[st_top]]) {
                dsu::merge(st[st_top--], i);
            }
        }

        st[++st_top] = i;
    }
    return res;
}

int get_cur_jump(int u, int min_l, int max_l) {
    // l = max(l, u);
    // int g = segtree::get(l, segm[u]);
    int g = fast_max_sqrt::get(min_l, max_l, segm[u]);
    if (g <= a[u]) return -1;
    return ind_by_val[g];
}

int giga_jmp[N];
int giga_jmp_cnt[N];

void calc_correct_giga_jumps(const vector<int>& old_jumps, const vector<int>& new_jumps) {
    for (int i = n - 1; i >= 0; --i) {
        if ((old_jumps[i] != new_jumps[i]) || new_jumps[i] == -1) {
            giga_jmp[i] = i;
            giga_jmp_cnt[i] = 0;
        } else {
            giga_jmp[i] = giga_jmp[new_jumps[i]];
            giga_jmp_cnt[i] = giga_jmp_cnt[new_jumps[i]] + 1;
        }
    }
}

int get_ans(int u, int v) {
    if (u > v || a[u] > a[v]) return 0;

    // cerr << "getting ans for " << u << " -> " << v << '\n';
    // cerr << segtree::get(4, 8) << '\n';

    // for now:
    int at = u;
    int res = 0;

    int cur_l = 0;
    while (at != -1 && at != v) {
        res += giga_jmp_cnt[at];
        at = giga_jmp[at];

        if (at == v) break;
        // cerr << "at : " << at << '\n';
        // cerr << "segm[at] = " << segm[at] << '\n';
        int new_l = segm[at];
        at = get_cur_jump(at, u, max(at + 1, cur_l));
        cur_l = new_l;
        ++res;
    }

    if (at == -1) return 0;
    return res;
}

const int C = 900;  // about sqrt(n*alpha), solution in about qC

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int group;
    cin >> n >> d >> group;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cin >> q;
    ask.resize(q);
    ans.resize(q);

    for (int i = 0; i < q; ++i) {
        ask[i].input(i);
    }

    get_segms();
    make_elems_unique();

    // for (int i = 0; i < n; ++i) {
    //     cerr << a[i] << ' ';
    // } cerr << '\n';

    sort(all(ask));
    int ask_ptr = 0;

    // segtree::setup();
    // for (int i = 0; i < n; ++i) {
    //     segtree::upd(i, a[i]);
    // }
    fast_max_sqrt::setup();

    vector<int> old_jumps = get_max_upto_x(0);
    for (int at = 0; at < n; at += C) {
        int at1 = min(n, at + C);
        auto new_jumps = get_max_upto_x(at1);

        // add all true correct edges & giga jumps
        calc_correct_giga_jumps(old_jumps, new_jumps);

        // run down the values of a[i], maintain segtree
        // answer queries in process

        for (int i = at; i < at1; ++i) {
            fast_max_sqrt::inc(ind_by_val[i], i);
            while (ask_ptr < q && a[ask[ask_ptr].v] == i) {
                ans[ask[ask_ptr].ind] = get_ans(ask[ask_ptr].u, ask[ask_ptr].v);
                if (ask[ask_ptr].t == 1) ans[ask[ask_ptr].ind] = min(ans[ask[ask_ptr].ind], 1);
                ask_ptr++;
            }
            // cerr << "put down " << ind_by_val[i] << "(" << i << ")" << '\n';
        }

        old_jumps = std::move(new_jumps);
    }

    for (int an : ans) {
        cout << an << '\n';
    }

    return 0;
}
