// ormlis_nlog3.cpp
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,popcnt")

#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpl = vector<pl>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 2e9;
const ll INF = 2e18;


const int N = 3e5 + 5;
int r[N];
int a[N], b[N];
int n, d;

auto Merge = [](int u, int v) {
    if (u == -1) return v;
    if (v == -1) return u;
    return a[u] < a[v] ? v : u;
};

template<class T, class Fun = function<T(const T &, const T &)>>
struct SegTree {
    Fun f;
    vector<T> t;
    int n;

    SegTree(int sz, const Fun &g, T default_value = T()) : f(g) {
        n = 1;
        while (n < sz) n <<= 1;
        t.resize(n * 2, default_value);
    }

    SegTree(vector<T> &a, const Fun &g, T default_value = T()) : SegTree(a.size(), g, default_value) {
        for (int i = 0; i < a.size(); ++i) t[i + n] = a[i];
        for (int i = n - 1; i >= 1; --i) t[i] = f(t[i << 1], t[i << 1 | 1]);
    }

    void upd(int i, T x) {
        t[i += n] = x;
        for (i >>= 1; i >= 1; i >>= 1) t[i] = f(t[i << 1], t[i << 1 | 1]);
    }

    // [l, r)
    T get(int l, int r) {
        T resL = t[0], resR = t[0];
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) resL = f(resL, t[l++]);
            if (r & 1) resR = f(t[--r], resR);
        }
        return f(resL, resR);
    }
};

SegTree<int> st(1, Merge, -1);


void build_borders() {
    set<pi> segs;
    if (d <= n) segs.insert({0, n - 1});
    vi ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](const int &i, const int &j) { return a[i] < a[j]; });
    auto Del = [&](int i) {
        auto it = segs.lower_bound({i + 1, -1});
        if (it == segs.begin()) return;
        it--;
        if (it->second < i) return;
        assert(it->first <= i && it->second >= i);
        auto [left, right] = *it;
        segs.erase(it);
        if (i - left >= d) {
            segs.insert({left, i - 1});
        }
        if (right - i >= d) {
            segs.insert({i + 1, right});
        }
    };
    for (auto &i: ord) {
        Del(i);
        auto it = segs.lower_bound({i, i});
        if (it == segs.end()) {
            r[i] = n;
        } else {
            r[i] = it->first + d;
        }
    }
}

struct Query {
    int i;
    int from;
    int to;
};

ll ans[N];

void CheckQueries(vector<Query> &qs) {
    int j = 0;
    rep(i, qs.size()) {
        if (qs[i].from == qs[i].to) continue;
        swap(qs[i], qs[j++]);
    }
    qs.resize(j);
}

const int LG = 20;
int up[N][LG];

void solve(int left, int right, vector<Query> &qs) {
    CheckQueries(qs);
    if (qs.empty()) return;
    assert(right - left >= 2);
    int mid = (left + right) / 2;
    vector<Query> L, R, M;
    for (auto &query: qs) {
        if (a[query.to] < mid) {
            L.push_back(query);
        } else if (a[query.from] >= mid) {
            R.push_back(query);
        } else {
            M.push_back(query);
        }
    }
    if (!M.empty()) {
        // [l, mid) -> to Right
        sort(all(M), [&](const Query &x, const Query &y) { return a[x.to] < a[y.to]; });
        for(int x = mid - 1; x >= left; --x) {
            int i = b[x];
            st.upd(i, i);
            up[i][0] = st.get(i, r[i]);
            for(int j = 1; j < LG; ++j) {
                up[i][j] = up[up[i][j - 1]][j - 1];
            }
        }
        int itM = 0;
        for(int x = mid; x < right && itM < M.size(); ++x) {
            st.upd(b[x], b[x]);
            while (itM < M.size() && M[itM].to == b[x]) {
                auto query = M[itM++];
                int& pos = query.from;
                {
                    int to = st.get(pos, r[pos]);
                    if (a[to] >= mid) {
                        pos = to;
                        ans[query.i] += 1;
                        R.push_back(query);
                        continue;
                    }
                }
                for(int j = LG - 1; j >= 0; --j) {
                    int nxt = up[pos][j];
                    if (a[st.get(pos, r[nxt])] >= mid) continue;
                    pos = nxt;
                    ans[query.i] += (1ll << j);
                }
                ans[query.i] += 1;
                pos = up[pos][0];
                int to = st.get(pos, r[pos]);
                if (a[to] >= mid) {
                    pos = to;
                    ans[query.i] += 1;
                    R.push_back(query);
                } else {
                    ans[query.i] = 0;
                }
            }
        }
        for(int x = left; x < right; ++x) {
            st.upd(b[x], -1);
        }
    }
    solve(left, mid, L);
    solve(mid, right, R);
}

void solve() {
    int group;
    cin >> n >> d >> group;
    rep(i, n) {
        cin >> a[i];
        assert(a[i] >= 1);
        a[i]--;
    }
    st = SegTree<int>(n, Merge, -1);
    rep(i, n) b[a[i]] = i;
    build_borders();
    int q;
    cin >> q;
    vi t(q);
    vector<Query> qs;
    rep(i, q) {
        Query query;
        query.i = i;
        cin >> t[i];
        cin >> query.from >> query.to;
        query.from--;
        query.to--;
        if (query.from > query.to || a[query.from] > a[query.to]) {
            continue;
        }
        qs.push_back(query);
    }
    solve(0, n, qs);
    rep(i, q) {
        if (t[i] == 1) ckmin(ans[i], 1ll);
        cout << ans[i] << '\n';
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}
