// golikov_lazha.cpp
//  Nikita Golikov, 2024

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

template <class T, class Compare = less<T>>
struct min_queue {
  deque<pair<int, T>> q;
  int l{};
  int r{};
  Compare cmp{};

  void clear() {
    l = 0;
    r = 0;
    q.clear();
  }

  void push(T const& x) {
    while (!q.empty() && !(cmp(q.back().second, x))) {
      q.pop_back();
    }
    q.emplace_back(r++, x);
  }

  void pop() {
    if (l++ == q.front().first) q.pop_front();
  }

  [[nodiscard]] T get() const {
    return q.front().second;
  }

  [[nodiscard]] int size() const {
    return r - l;
  }

  [[nodiscard]] bool empty() const {
    return l == r;
  }
};

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, d, group;
  cin >> n >> d >> group;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
    --x;
  }
  vector<int> nxt(n);
  for (int i = n - 1; i >= 0; --i) {
    nxt[i] = i + 1;
    while (nxt[i] < n && a[nxt[i]] < a[i]) {
      nxt[i] = nxt[nxt[i]];
    }
  }
  int q; cin >> q;
  while (q--) {
    int tp, l, r;
    cin >> tp >> l >> r;
    --l, --r;
    if (l >= r || a[l] >= a[r]) {
      cout << 0 << '\n';
      continue;
    }
    int cur = l;
    int ans = 1;
    int curMax = a[l];
    while (cur < r) {
      if (r <= cur + d) {
        break;
      }
      int pmax = -1;
      for (int i = 1; i <= d; ++i) {
        if (a[cur + i] <= curMax) {
          pmax = cur + i;
          break;
        }
        if (a[cur + i] < a[r] && (pmax < 0 || a[cur + i] > a[pmax])) {
          pmax = cur + i;
        }
      }
      if (pmax < 0) {
        ans = 0;
        break;
      }
      if (a[pmax] > curMax) {
        curMax = a[pmax];
        ans++;
      }
      cur = pmax;
    }
    if (tp == 1) {
      ans = min(ans, 1);
    }
    cout << ans << '\n';
    /*int ans = 0;
    int cur = l;
    while (cur < r) {
      int nx = nxt[cur];
      if (nx + d - 1 >= r) {
        ans++;
        break;
      }
      int pmax = -1;
      int L = nx;
      int R = nx + d;
      for (int i = L; i < R; ++i) {
        if (a[i] < a[r] && (pmax < 0 || a[i] > a[pmax])) {
          pmax = i;
        }
      }
      if (pmax < 0) {
        ans = 0;
        break;
      }
      ans++;
      cur = pmax;
    }
    if (tp == 1) {
      ans = min(ans, 1);
    }
    cout << ans << '\n';*/
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
