// ormlis_nlog2_opt.cpp
#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpl = vector<pl>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 2e9;
const ll INF = 2e18;


const int N = 3e5 + 5;
const int LG = 20;
int r[N];
int a[N], b[N];
int up[N][LG];
int n, d;

namespace SegTree {
    int t[N * 2];

    void Set(int i) {
        t[i + n] = a[i];
        for (i += n; i > 1; i >>= 1) t[i >> 1] = max(t[i], t[i ^ 1]);
    }

    void Reset(int i) {
        t[i + n] = 0;
        for (i += n; i > 1; i >>= 1) t[i >> 1] = max(t[i], t[i ^ 1]);
    }

    int Get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ckmax(res, t[l++]);
            if (r & 1) ckmax(res, t[--r]);
        }
        return res;
    }
}

namespace Fenwick {
    int t[N];

    void Set(int i) {
        for (; i < n; i = i | (i + 1)) ++t[i];
    }

    void Reset(int i) {
        for (; i < n; i = i | (i + 1)) --t[i];
    }

    int Get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) res += t[i];
        return res;
    }

    int GetNext(int i) {
        int x = Get(i) + 1;
        int r = -1;
        for(int j = LG - 1; j >= 0; --j) {
            int r2 = r + (int)(1 << j);
            if (r2 < n && t[r2] < x) x -= t[r = r2];
        }
        return r + 1;
    }
}


void build_borders() {
    set<pi> segs;
    if (d <= n) segs.insert({0, n - 1});
    vi ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](const int &i, const int &j) { return a[i] < a[j]; });
    auto Del = [&](int i) {
        auto it = segs.lower_bound({i + 1, -1});
        if (it == segs.begin()) return;
        it--;
        if (it->second < i) return;
        assert(it->first <= i && it->second >= i);
        auto [left, right] = *it;
        segs.erase(it);
        if (i - left >= d) {
            segs.insert({left, i - 1});
        }
        if (right - i >= d) {
            segs.insert({i + 1, right});
        }
    };
    for (auto &i: ord) {
        Del(i);
        auto it = segs.lower_bound({i, i});
        if (it == segs.end()) {
            r[i] = n;
        } else {
            r[i] = it->first + d;
        }
    }
}

struct Query {
    int i;
    int from;
    int to;
};

ll ans[N];

void CheckQueries(vector<Query> &qs) {
    int j = 0;
    rep(i, qs.size()) {
        if (qs[i].from == qs[i].to) continue;
        swap(qs[i], qs[j++]);
    }
    qs.resize(j);
}

void SolveMid(int left, int mid, int right, vector<Query> &qs, vector<Query> &L, vector<Query> &R) {
    for (int x = mid - 1; x >= left; --x) {
        int i = b[x];
        SegTree::Set(i);
        up[i][0] = b[SegTree::Get(i, r[i])];
        for (int j = 1; j < LG; ++j) up[i][j] = up[up[i][j - 1]][j - 1];
    }
    int itM = 0;
    while (itM < qs.size() && a[qs[itM].to] < mid) {
        L.push_back(qs[itM++]);
    }
    int x;
    for (x = mid; x < right && itM < qs.size(); ++x) {
        SegTree::Set(b[x]);
        Fenwick::Set(b[x]);
        while (itM < qs.size() && qs[itM].to == b[x]) {
            auto &query = qs[itM++];
            int &pos = query.from;
            if (a[pos] >= mid) {
                R.push_back(query);
                continue;
            }
            {
                int to = SegTree::Get(pos, r[pos]);
                if (to >= mid) {
                    pos = b[to];
                    ans[query.i] += 1;
                    R.push_back(query);
                    continue;
                }
            }
            int must = Fenwick::GetNext(pos);
            for (int j = LG - 1; j >= 0; --j) {
                int nxt = up[pos][j];
                if (must < r[nxt]) continue;
                pos = nxt;
                ans[query.i] += (1ll << j);
            }
            ans[query.i] += 1;
            pos = up[pos][0];
            int to = SegTree::Get(pos, r[pos]);
            if (to >= mid) {
                pos = b[to];
                ans[query.i] += 1;
                R.push_back(query);
            } else {
                ans[query.i] = 0;
            }
        }
    }
    for(int y = mid; y < x; ++y) {
        Fenwick::Reset(b[y]);
    }
    for (--x; x >= left; --x) {
        SegTree::Reset(b[x]);
    }
}

void solve(int left, int right, vector<Query> &qs) {
    CheckQueries(qs);
    if (qs.empty()) return;
    assert(right - left >= 2);
    int mid = (left + right) / 2;
    vector<Query> L, R;
    SolveMid(left, mid, right, qs, L, R);
    solve(left, mid, L);
    solve(mid, right, R);
}

void solve() {
    int group;
    cin >> n >> d >> group;
    rep(i, n) cin >> a[i];
    rep(i, n) b[a[i]] = i;
    build_borders();
    int q;
    cin >> q;
    vi t(q);
    vector<Query> qs;
    rep(i, q) {
        Query query;
        query.i = i;
        cin >> t[i];
        cin >> query.from >> query.to;
        query.from--;
        query.to--;
        if (query.from > query.to || a[query.from] > a[query.to]) {
            continue;
        }
        qs.push_back(query);
    }
    sort(all(qs), [&](const Query &x, const Query &y) { return a[x.to] < a[y.to]; });
    solve(1, n + 1, qs);
    rep(i, q) {
        if (t[i] == 1) ckmin(ans[i], 1ll);
        cout << ans[i] << '\n';
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}
