// stupWalk.cpp
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <deque>
#include <random>
#include <functional>
#include <cassert>
#include <queue>

using namespace std;

const int lg = 7;
const int maxn = 1 << 19;
const int inf = 1e9;

int p[maxn];
int sz[maxn];
int r[maxn];

void init() {
    iota(p, p + maxn, 0);
    iota(r, r + maxn, 0);
    fill(sz, sz + maxn, 1);
}

int c(int v) {
    return (p[v] == v) ? v : p[v] = c(p[v]);
}

void unite(int u, int v) {
    u = c(u), v = c(v);
    if (u == v) return;
    p[u] = v;
    sz[v] += sz[u];
    r[v] = max(r[u], r[v]);
}

int up[lg][maxn];

pair<int, int> tree[maxn * 2];

void upd(int i, int x) {
    i += maxn;
    tree[i] = { x, i - maxn };
    while (i > 1) {
        i >>= 1;
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
    }
}

int get(int l, int r) {
    l += maxn;
    r += maxn;
    pair<int, int> ans = { -inf, -1 };
    while (l < r) {
        if (l & 1) {
            ans = max(ans, tree[l++]);
        }
        if (r & 1) {
            ans = max(ans, tree[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans.second;
}

const int rebuildSize = 320;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    map<int, vector<int>> dt;
    for (int& i : a) {
        cin >> i;
    }
    init();
    fill(tree, tree + maxn * 2, make_pair(-inf, -1));
    for (int i = 0; i < n; ++i) {
        dt[-a[i]].push_back(i);
    }
    vector<int> rt(n, n);
    vector<int> arr(n, 0);
    set<int> ends;
    for (auto [x, v] : dt) {
        for (int i : v) {
            arr[i] = 1;
            if (i > 0 && arr[i - 1]) {
                ends.erase(i - 1);
                unite(i - 1, i);
            }
            if (i + 1 < n && arr[i + 1]) {
                unite(i, i + 1);
                if (sz[c(i)] >= d) {
                    ends.insert(r[c(i)]);
                }
            } else {
                if (sz[c(i)] >= d) {
                    ends.insert(i);
                }
            }
        }
        for (int i : v) {
            auto ptr = ends.lower_bound(i + d);
            if (ptr != ends.end()) {
                int id = *ptr;
                int bgn = max(i + 1, r[c(id)] - sz[c(id)] + 1);
                rt[i] = bgn + d;
            }
        }
    }
    int q;
    cin >> q;
    vector<vector<pair<pair<int, int>, int>>> queries(n);
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        --u; --v;
        if (a[u] > a[v]) continue;
        queries[v].push_back({ { t, u }, i });
    }
    vector<int> ans(q, 0);
    for (auto pt = dt.rbegin(); pt != dt.rend(); ++pt) {
        int i = pt->second[0];
        upd(i, a[i]);
        for (auto [g, j] : queries[i]) {
            int res = 0;
            auto [t, u] = g;
            while (get(u, rt[u]) != u) {
                u = get(u, rt[u]);
                ++res;
            }
            if (u == i) {
                ans[j] = res;
                if (t == 1) {
                    ans[j] = (bool) res;
                }
            }
        }
    }
    for (int j : ans) {
        cout << j << '\n';
    }
    cerr << *max_element(ans.begin(), ans.end()) << endl;
}
