#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 3e5 + 1, LG = 19;

int go[LG][N], r[N], mn[N];

void update(int x, int v) {
    for (++x; x < N; x += x & -x) {
        mn[x] = min(mn[x], v);
    }
}

int query(int x) {
    int ans = 1e9;
    for (++x; x > 0; x -= x & -x) {
        ans = min(ans, mn[x]);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, g;
    cin >> n >> d >> g;

    vector<int> a(n), pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[--a[i]] = i;
    }

    set<int> cant;
    cant.insert(n);
    for (int x = 0; x < n; ++x) {
        int i = pos[x];
        cant.insert(i);
        auto it = cant.find(i);
        if (it != cant.begin() && i - *prev(it) <= d) {
            cant.erase(prev(it));
        }
        it = cant.find(i);
        if (*next(it) - i <= d) {
            cant.erase(it);
        }
        r[i] = min(n - 1, *cant.lower_bound(i) + d);
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return r[i] > r[j];
    });
    fill(mn, mn + N + 1, int(1e9));
    for (int i = n - 1, j = 0; i >= 0; --i) {
        while (j < n && r[ord[j]] >= i) {
            update(a[ord[j]], ord[j]);
            j += 1;
        }
        go[0][i] = query(a[i]);
        if (go[0][i] >= i) {
            go[0][i] = -1;
        }
    }

    for (int l = 1; l < LG; ++l) {
        for (int i = 0; i < n; ++i) {
            if (go[l - 1][i] == -1) {
                go[l][i] = -1;
            } else {
                go[l][i] = go[l - 1][go[l - 1][i]];
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, i, j;
        cin >> t >> i >> j;
        i -= 1, j -= 1;

        if (a[i] > a[j]) {
            cout << "0\n";
            continue;
        }

        int ans = 0;
        for (int l = LG - 1; l >= 0; --l) {
            if (go[l][j] != -1 && go[l][j] > i) {
                ans += 1 << l;
                j = go[l][j];
            }
        }
        if (go[0][j] > i) {
            cout << "0\n";
            continue;
        }
        ans += 1;
        if (t == 1) {
            cout << "1\n";
        } else {
            cout << ans << '\n';
        }
    }

    return 0;
}
