#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 3e5 + 1, LG = 19;

int go[LG][N], r[N], mn[N];

void update(int x, int v) {
    for (++x; x < N; x += x & -x) {
        mn[x] = min(mn[x], v);
    }
}

int query(int x) {
    int ans = 1e9;
    for (++x; x > 0; x -= x & -x) {
        ans = min(ans, mn[x]);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, g;
    cin >> n >> d >> g;

    vector<int> a(n), pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[--a[i]] = i;
    }

    if (n > 100) {
        return 0;
    }

    set<int> cant;
    cant.insert(n);
    for (int x = 0; x < n; ++x) {
        int i = pos[x];
        if (1) {
            r[i] = -1;
            for (int u = i, v = i; u < n; u = v) {
                while (v < n && (a[u] <= x) == (a[v] <= x)) {
                    v += 1;
                }
                if (a[u] > x && v - u >= d) {
                    r[i] = min(n - 1, u - 1 + d);
                    break;
                }
            }
            if (r[i] == -1) {
                r[i] = n - 1;
            }
            continue;
        }
        cant.insert(i);
        auto it = cant.find(i);
        if (it != cant.begin() && i - *prev(it) <= d) {
            cant.erase(prev(it));
        }
        it = cant.find(i);
        if (*next(it) - i <= d) {
            cant.erase(it);
        }
        r[i] = min(n - 1, *cant.lower_bound(i) + d);
    }

    vector dist(n, vector<int>(n, -1));
    vector<vector<int>> adj(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= r[i]; ++j) {
            if (a[j] >= a[i]) {
                adj[i].push_back(j);
            }
        }
    }
    for (int source = 0; source < n; ++source) {
        queue<int> q;
        q.push(source);
        dist[source][source] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int to : adj[v]) {
                if (dist[source][to] == -1) {
                    dist[source][to] = dist[source][v] + 1;
                    q.push(to);
                }
            }
        }
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return r[i] > r[j];
    });
    fill(mn, mn + N + 1, int(1e9));
    fill(go[0], go[0] + n, -1);
    if (1) {
        for (int j = 0; j < n; ++j) {
            for (int i = j + 1; i <= r[j]; ++i) {
                if (a[i] > a[j] && go[0][i] == -1) {
                    go[0][i] = j;
                }
            }
        }
    } else {
        for (int i = n - 1, j = 0; i >= 0; --i) {
            while (j < n && r[ord[j]] >= i) {
                update(a[ord[j]], ord[j]);
                j += 1;
            }
            go[0][i] = query(a[i]);
            if (go[0][i] >= i) {
                go[0][i] = -1;
            }
        }
    }

    for (int l = 1; l < LG; ++l) {
        for (int i = 0; i < n; ++i) {
            if (go[l - 1][i] == -1) {
                go[l][i] = -1;
            } else {
                go[l][i] = go[l - 1][go[l - 1][i]];
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, i, j;
        cin >> t >> i >> j;
        i -= 1, j -= 1;

        if (a[i] > a[j]) {
            cout << "0\n";
            continue;
        }
        if (0) {
            if (dist[i][j] == -1) {
                cout << "0\n";
            } else if (t == 2) {
                cout << dist[i][j] << '\n';
            } else {
                cout << "1\n";
            }
            continue;
        }

        int ans = 0;
        for (int l = LG - 1; l >= 0; --l) {
            if (go[l][j] != -1 && go[l][j] > i) {
                ans += 1 << l;
                j = go[l][j];
            }
        }
        if (r[i] < j) {
            cout << "0\n";
            continue;
        }
        ans += 1;
        if (t == 1) {
            cout << "1\n";
        } else {
            cout << ans << '\n';
        }
    }

    return 0;
}
