#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 3e5 + 1, LG = 19;

int go[LG][N], mn[N];

void update(int x, int v) {
    for (++x; x < N; x += x & -x) {
        mn[x] = min(mn[x], v);
    }
}

int query(int x) {
    int ans = 1e9;
    for (++x; x > 0; x -= x & -x) {
        ans = min(ans, mn[x]);
    }
    return ans;
}

constexpr int N_ = 1 << 19;

int stMax[N_ * 2];

void modify(int x, int v) {
    x += N_;
    for (stMax[x] = max(stMax[x], v); x >>= 1;) {
        stMax[x] = max(stMax[x << 1], stMax[x << 1 | 1]);
    }
}

int rangeMax(int l, int r) {
    int ans = 0;
    for (l += N_, r += N_; l < r; l >>= 1, r >>= 1) {
        if (l & 1) ans = max(ans, stMax[l++]);
        if (r & 1) ans = max(ans, stMax[--r]);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, g;
    cin >> n >> d >> g;

    vector<int> a(n), pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[--a[i]] = i;
    }

    auto work = [&]() {
        vector<int> p(n);
        for (int i = 0; i < n; ++i) {
            p[a[i]] = i;
        }
        set<int> cant, ones;
        ones.insert(n), cant.insert(n);
        vector<int> r(n, -1);
        for (int x = 0; x < n; ++x) {
            int i = p[x];
            if (0) {
                r[i] = -1;
                for (int u = i, v = i; u < n; u = v) {
                    while (v < n && (a[u] <= x) == (a[v] <= x)) {
                        v += 1;
                    }
                    if (a[u] > x && v - u >= d) {
                        r[i] = min(n - 1, u - 1 + d);
                        break;
                    }
                }
                if (r[i] == -1) {
                    r[i] = n - 1;
                }
                continue;
            }
            cant.insert(i);
            ones.insert(i);
            auto it = cant.find(i);
            if (it != cant.begin() && i - *prev(it) <= d) {
                cant.erase(prev(it));
            }
            it = ones.lower_bound(i + 1);
            if (*it - i <= d) {
                cant.erase(i);
            }
            r[i] = min(n - 1, *cant.lower_bound(i) + d);
        }
        return r;
    };

    auto r = work();
    reverse(a.begin(), a.end());
    auto l_ = work();
    reverse(a.begin(), a.end());
    for (int &x: l_) {
        if (x != -1) {
            x = n - x - 1;
        }
    }
    reverse(l_.begin(), l_.end());
//    for (int x : l_) {
//        cout << x << " ";
//    }
//    cout << endl;

    if (g == 1 || g == 2) {
        vector dist(n, vector<int>(n, -1));
        vector<vector<int>> adj(n);
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j <= r[i]; ++j) {
                if (a[j] >= a[i]) {
                    adj[i].push_back(j);
                }
            }
        }
        for (int source = 0; source < n; ++source) {
            queue<int> q;
            q.push(source);
            dist[source][source] = 0;
            while (!q.empty()) {
                int v = q.front();
                q.pop();
                for (int to: adj[v]) {
                    if (dist[source][to] == -1) {
                        dist[source][to] = dist[source][v] + 1;
                        q.push(to);
                    }
                }
            }
        }
        int q;
        cin >> q;
        while (q--) {
            int t, i, j;
            cin >> t >> i >> j;
            i -= 1, j -= 1;

            if (a[i] > a[j]) {
                cout << "0\n";
                continue;
            }
            if (dist[i][j] == -1) {
                cout << "0\n";
            } else if (t == 2) {
                cout << dist[i][j] << '\n';
            } else {
                cout << "1\n";
            }
            continue;
        }

        return 0;
    }

    if (g == 8) {
        int q;
        cin >> q;
        while (q--) {
            int t, i, j;
            cin >> t >> i >> j;
            i -= 1, j -= 1;

            if (a[i] > a[j]) {
                cout << "0\n";
                continue;
            }
            if (t == 1 || 1) {
                if (l_[j] <= i) {
                    cout << "1\n";
                } else {
                    cout << "0\n";
                }
                continue;
            }
        }
        return 0;
    }

    int q;
    cin >> q;
    vector<int> answers(q);
    vector<array<int, 3>> qq(q);
    vector<vector<int>> queries(n);
    for (int t = 0; t < q; ++t) {
        int tp, i, j;
        cin >> tp >> i >> j;
        qq[t] = {tp, i, j};
        if (a[i] > a[j] || l_[j] > i) {
            answers[t] = 0;
            continue;
        }
        queries[j].push_back(t);
    }
    
    if (g == 6 || g == 7) {
        for (int x = 0; x < n; ++x) {
            int i = pos[x];
            modify(x, x);
            for (int t : queries[i]) {
                auto [tp, L, R] = qq[t];
                int l = L;
                int ans = 0;
                while (r[l] < i) {
                    l = rangeMax(l, r[l] + 1);
                    ans += 1;
                }
                ans += 1;
                answers[t] = ans;
            }
        }
        for (int i = 0; i < q; ++i) {
            if (answers[i] == 0) {
                cout << 0 << '\n';
            } else if (qq[i][0] == 1) {
                cout << "1\n";
            } else {
                cout << answers[i] << '\n';
            }
        }
        return 0;
    }

    if (0) {
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return r[i] > r[j];
        });
        fill(mn, mn + N + 1, int(1e9));
        fill(go[0], go[0] + n, -1);
        if (0) {
            for (int j = 0; j < n; ++j) {
                for (int i = j + 1; i <= r[j]; ++i) {
                    if (a[i] > a[j] && go[0][i] == -1) {
                        go[0][i] = j;
                    }
                }
            }
        } else {
            for (int i = n - 1, j = 0; i >= 0; --i) {
                while (j < n && r[ord[j]] >= i) {
                    update(a[ord[j]], ord[j]);
                    j += 1;
                }
                go[0][i] = query(a[i]);
                if (go[0][i] >= i) {
                    go[0][i] = -1;
                }
            }
        }

        for (int l = 1; l < LG; ++l) {
            for (int i = 0; i < n; ++i) {
                if (go[l - 1][i] == -1) {
                    go[l][i] = -1;
                } else {
                    go[l][i] = go[l - 1][go[l - 1][i]];
                }
            }
        }
    }


    return 0;
}
