#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;


void solve() {
	ll n, d, g;
	cin >> n >> d >> g;
	vector<ll> a(n);
	for (ll& elem : a) {
		cin >> elem;
	}
	vector<vector<ll>> G(n, vector<ll>(n, INF));

	for (ll i = 0; i < n; i++) {
		ll last = i;
		for (ll j = i + 1; j < n; j++) {
			if (j - last > d) break;
			if (a[i] > a[j]) {
				last = j;
			}
			else {
				G[i][j] = 1;
			}
		}
	}

	for (ll i = 0; i < n; i++) {
		for (ll k = i + 1; k < n; k++) {
			for (ll j = k + 1; j < n; j++) {
				G[i][j] = min(G[i][j], G[i][k] + G[k][j]);
			}
		}
	}

	ll q;
	cin >> q;
	ll t, u, v;
	while (q--) {
		cin >> t >> u >> v; u--; v--;
		if (t == 1) {
			cout << (G[u][v] != INF ? "1\n" : "0\n");
		}
		else {
			if (G[u][v] == INF) {
				cout << "0\n";
			}
			else {
				cout << G[u][v] << "\n";
			}
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/