#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<vector<int>> G;

void solve() {
	int n, d, g;
	cin >> n >> d >> g;

	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	G.resize(n);
	for (int i = 0; i < n; i++) {
		int maxj = i + d;
		for (int j = i + 1; j <= maxj && j < n; j++) {
			if (a[j] > a[i])
				G[i].push_back(j);
			else
				maxj = j + d;
		}
	}

	int q;
	cin >> q;
	vector<vector<int>> reses(n, vector<int>(n, -1));
	while (q--) {
		int t, a, b;
		cin >> t >> a >> b;
		a--, b--;

		if (reses[a][b] != -1) {
			if (reses[a][b] == INT_MAX)
				cout << 0;
			else if (t == 2)
				cout << reses[a][b];
			else
				cout << 1;
			cout << '\n';
			continue;
		}

		vector<int> d(n, INT_MAX);
		d[a] = 0;
		queue<int> que;
		que.push(a);
		while (que.size()) {
			int v = que.front();
			que.pop();

			for (int u : G[v]) {
				if (d[u] != INT_MAX) continue;
				que.push(u);
				d[u] = d[v] + 1;
			}
		}

		for (int i = 0; i < n; i++) {
			reses[a][i] = d[i];
		}

		if (d[b] == INT_MAX)
			cout << 0;
		else if (t == 1)
			cout << 1;
		else
			cout << d[b];
		cout << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
