#include <iostream>
#include <cstdint>
#include <vector>
#include <random>
#include <set>
#include <stack>

using namespace std;

void sol() {
    int64_t n, d, g, q;
    cin >> n >> d >> g;
    vector<int64_t> ids(n);
    for (auto &v: ids) cin >> v;
    cin >> q;
    vector<bool> processed(n, false);
    vector<set<int64_t>> graph(n);
    deque<int64_t> from1, from2;
    for (int64_t _ = 0, t, u, v; _ < q; ++_) {
        cin >> t >> u >> v;
        --u, --v;
        from1.clear();
        from2.clear();
        from1.push_back(u);
        int64_t l = 0;
        bool was_found = false;
        while (!from1.empty() && !was_found) {
            ++l;
            while (!from1.empty() && !was_found) {
                auto el = from1.front();
                from1.pop_front();
                if (processed[el]) {
                    for (auto ff: graph[el]) {
                        if (ff == v) {
                            was_found = true;
                            break;
                        }
                        from2.push_back(ff);
                    }
                } else {
                    processed[el] = true;
                    int64_t now_without_n = 0;
                    for (int64_t j = el + 1; j < n; ++j) {
                        if (now_without_n > d) break;
                        if (ids[j] < ids[el]) now_without_n = 0;
                        else ++now_without_n;
                        if (now_without_n > d) break;
                        if (ids[el] < ids[j]) {
                            graph[el].insert(j);
                            from2.push_back(j);
                            if (j == v) was_found = true;
                        }
                    }
                }
            }
            swap(from2, from1);
            from2.clear();
        }
        if (!was_found) cout << "0\n";
        else if (t == 1) cout << "1\n";
        else cout << l << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    uint64_t t = 3;
#else
    uint64_t t = 1;
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while (t--) {
        sol();
        cout << "\n";
    }
    return 0;
}
