
#include <bits/stdc++.h>
using namespace std;

const int inf = 1e9;

struct SegTree {
    int n, N;
    vector<int> st;
    SegTree() {}
    SegTree(int _n) {
        n = _n, N = 1;
        while (N < 1) {
            N <<= 1;
        }
        st.resize(2 * N, inf);
    }
    void clear() {
        for (int i = 0; i < 2 * N; ++i) {
            st[i] = inf;
        }
    }
    void assign(int i, int x) {
        int v = N + i;
        st[v] = x;
        v >>= 1;
        while (v > 0) {
            st[v] = min(st[2 * v], st[2 * v + 1]);
            v >>= 1;
        }
    }
    int getMin(int l, int r) {
        int vl = N + l, vr = N + r;
        int res = inf;
        while (vl < vr) {
            if (vl & 1) {
                res = min(res, st[vl]);
            }
            if ((vr ^ 1) & 1) {
                res = min(res, st[vr]);
            }
            vl = (vl + 1) >> 1;
            vr = (vr - 1) >> 1;
        }
        if (vl == vr) {
            res = min(res, st[vl]);
        }
        return res;
    }
    ~SegTree() {}
};

const int maxn = 3e5;
vector<int> g[maxn];

void solvestupid(int n, int d) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        int curlen = 0;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] > a[i]) {
                g[i].emplace_back(j);
                // cerr << i + 1 << ' ' << j + 1 << '\n';
                ++curlen;
                if (curlen == d) {
                    break;
                }
            } else {
                curlen = 0;
            }
        }
    }
    int qNum;
    cin >> qNum;
    vector<vector<pair<int, int>>> queries(n);
    vector<int> t(qNum), ans(qNum);
    for (int iter = 0; iter < qNum; ++iter) {
        int from, to;
        cin >> t[iter] >> from >> to;
        --from, --to;
        queries[from].emplace_back(to, iter);
    }
    queue<int> q;
    vector<int> dist(n);
    for (int from = 0; from < n; ++from) {
        dist.assign(n, -1);
        dist[from] = 0;
        q.emplace(from);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (const int& u : g[v]) {
                if (dist[u] == -1) {
                    dist[u] = dist[v] + 1;
                    q.emplace(u);
                }
            }
        }
        while (!queries[from].empty()) {
            auto [to, i] = queries[from].back();
            queries[from].pop_back();
            if (dist[to] == -1) {
                ans[i] = 0;
            } else if (t[i] == 1) {
                ans[i] = 1;
            } else {
                ans[i] = dist[to];
            }
        }
    }
    for (int i = 0; i < qNum; ++i) {
        cout << ans[i] << '\n';
    }
}

void solvelast(int n, int d) {
    set<pair<int, int>> segs, bads;
    vector<int> a(n), inv(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        inv[a[i]] = i;
    }
    SegTree st(n);
    auto insert = [&](int i) -> void {
        auto itR = segs.lower_bound(make_pair(i, i));
        auto itL = itR;
        int newR = i, newL = i;
        if (itR != segs.end() && itR->first == i + 1) {
            bads.erase(*itR);
            newR = itR->second;
            segs.erase(itR);
        }
        if (itL != segs.begin() && (--itL)->second == i - 1) {
            bads.erase(*itL);
            newL = itL->first;
            segs.erase(itL);
        }
        segs.emplace(newL, newR);
        if (newR - newL + 1 >= d) {
            bads.emplace(newL, newR);
        }
    };
    vector<int> ans(n);
    for (int val = n - 1; val >= 0; --val) {
        int i = inv[val];
        auto it = bads.lower_bound(make_pair(l, l));
        int lim = n - 1;
        if (it != bads.end()) {
            lim = it->first + d - 1;
        }
        ans[i] = st.getMin(i + 1, lim) + 1;
        ans[i] = min(ans[i], inf);
        st.assign(i, ans[i]);
        insert(i);
    }
    int q;
    cin >> q;
    while (q--) {
        int t, from, to;
        cin >> t >> from >> to;
        --from, --to;
        if (ans[from] == inf) {
            cout << 0 << '\n';
        } else if (t == 1) {
            cout << 1 << '\n';
        } else {
            cout << ans[from] << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        int n, d, grp;
        cin >> n >> d >> grp;
        if (grp >= 3 && grp <= 5) {
            solvelast(n, d);
        } else {
            solvestupid(n, d);
        }
        cout << "--------\n";
        cerr << "--------\n";
    }
    #else
    int T = 1;
    // cin >> T;
    while (T--) {
        int n, d, grp;
        cin >> n >> d >> grp;
        if (grp >= 3 && grp <= 5) {
            solvelast(n, d);
        } else {
            solvestupid(n, d);
        }
    }
    #endif

    return 0;
}