#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    ll n, d, group;
    cin >> n >> d >> group;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    vector<ll> real_pos(n);
    for (ll i = 0; i < n; ++i) real_pos[a[i] - 1] = i;

    vector<vector<ll>> g(n);

    for (ll i = 0; i < n; ++i) {
        ll now = i;

        for (ll j = i + 1; j < n; ++j) {
            if (a[j] > a[i]) {
                g[i].push_back(j);
            }
            if (a[j] < a[i]) {
                now = j;
            }
            if (j - now == d) break;
        }
    }

    ll q;
    cin >> q;

    while (q--) {
        ll type, u, v;
        cin >> type >> u >> v;

        --u, --v;

        if (a[u] > a[v] || u > v) {
            cout << "0\n";
            continue;
        }

        vector<ll> used(n, -1);
        queue<ll> qq;
        qq.push(u);
        used[u] = 0;

        while (qq.size()) {
            ll now = qq.front();
            qq.pop();

            if (now == v) break;

            for (auto i : g[now]) {
                if (used[i] != -1) continue;
                used[i] = used[now] + 1;
                qq.push(i);
            }
        }

        if (used[v] == -1) {
            cout << "0\n";
        }
        else if (type == 1) {
            cout << "1\n";
        }
        else {
            cout << used[v] << '\n';
        }
    }
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
