//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    vector<vector<int>> dist(n, vector<int>(n, inf));
    for (int i = 0; i < n; ++i) {
        vector<bool> can(n, false);
        can[i] = true;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[i])
                for (int x = j - d; x < j; ++x)
                    if (can[x])
                        can[j] = true;
        }
        for (int j = i + 1; j < n; ++j)
            if (a[j] > a[i])
                for (int x = j - d; x < j; ++x)
                    if (can[x])
                        dist[i][j] = 1;
    }
    for (int _ = 0; _ < 3; ++_)
        for (int k = 0; k < n; ++k)
            for (int i = 0; i < n; ++i)
                for (int j = 0; j < n; ++j)
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        int u, v;
        cin >> u >> v;
        --u, --v;
        int x = dist[u][v];
        if (x == inf)
            x = 0;
        if (t == 1 && x != 0)
            x = 1;
        cout << x << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
