#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

struct Tree{
    vector<vector<int>> tr;
    vector<int> dat;

    void build(int id, int l, int r) {
        if (r - l == 1) {
            tr[id] = {dat[l]};
            return;
        }
        int mid = (l + r) / 2;
        build(id * 2 + 1, l, mid);
        build(id * 2 + 2, mid, r);
        tr[id].resize(r - l);
        merge(tr[id * 2 + 1].begin(), tr[id * 2 + 1].end(), tr[id * 2 + 2].begin(), tr[id * 2 + 2].end(), tr[id].begin());
    }

    Tree(vector<int> &dat) : dat(dat) {
        tr.resize(dat.size() * 4);
        build(0, 0, dat.size());
    }

    int get(int id, int x) {
        auto it = upper_bound(tr[id].begin(), tr[id].end(), x);
        if (it == tr[id].begin()) {
            return -1;
        }
        it--;
        return *it;
    }

    int ask(int id, int l, int r, int ql, int qr, int x) {
        //cout << id << " " << l << " " << r << endl;
        if (ql <= l && r <= qr) {
            return get(id, x);
        }
        if (qr <= l || r <= ql) {
            return -1;
        }
        int mid = (l + r) / 2;
        return max(ask(id * 2 + 1, l, mid, ql, qr, x), ask(id * 2 + 2, mid, r, ql, qr, x));
    }
};

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> v(n);
    vector<int> v2(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
        v2[v[i]] = i;
    }

    vector<int> to(n, -1);
    for (int i = 0; i < n; i++) {
        int cur = v2[i];
        for (int j = cur + 1; j < n; j++) {
            if (j - cur > d) {
                break;
            }
            if (to[j] != -1) {
                j = to[j];
                cur = j;
            } else if (v[j] < v[v2[i]]) {
                cur = j;
            }
        }
        to[v2[i]] = cur;
    }

    Tree tr(v);

    /*vector<int> mx(n);
    for (int i = 0; i < n; i++) {

        int mxt = 0;
        for (int j = i; j <= min(to[i] + d, n - 1); j++) {
            mxt = max(mxt, v[j]);
        }
        mx[i] = v2[mxt];
    }*/
    /*for (auto i : to) {
        cout << i << " ";
    } cout << '\n';
    for (auto i : mx) {
        cout << i << " ";
    } cout << '\n';*/
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, u, k;
        cin >> t >> u >> k;
        u--;
        k--;
        if (v[u] > v[k] || u == k) {
            cout << "0" << '\n';
            continue;
        }
        int cnt = 0;
        bool fl = true;
        while (to[u] + d < k) {
            cnt++;
            int mx = 0;
            int upr = u;

            mx = tr.ask(0, 0, n, u, to[u] + d + 1, v[k]);
            if (mx <= v[u]) {
                cout << "0" << '\n';
                fl = false;
                break;
            }
            u = v2[mx];
        }
        if (t == 1) {
            cnt = 0;
        }
        if (fl) {
            cout << cnt + 1 << '\n';
        }
    }
    return 0;
}
