#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    const int inf = 1e9;
    int n, d, g_;
    cin >> n >> d >> g_;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int p = i;
        for (int j = i + 1; j < n && j <= p + d; ++j) {
            if (a[i] < a[j]) {
                g[i].push_back(j);
            } else {
                p = j;
            }
        }
    }
    vector<vector<int>> dist(n, vector<int>(n, inf));
    queue<int> que;
    for (int i = 0; i < n; ++i) {
        vector<bool> used(n);
        dist[i][i] = 0;
        used[i] = true;
        que.push(i);
        while (!que.empty()) {
            auto v = que.front();
            que.pop();
            for (auto u: g[v]) {
                if (dist[i][u] > dist[i][v] + 1) {
                    dist[i][u] = dist[i][v] + 1;
                }
                if (!used[u]) {
                    que.push(u);
                    used[u] = true;
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, s, f;
        cin >> t >> s >> f;
        --s, --f;
        int res = dist[s][f];
        if (res == inf) {
            cout << 0 << "\n";
        } else if (t == 1) {
            cout << 1 << "\n";
        } else {
            cout << res << "\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1, g;
//    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}