#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

const int MAXN = 1001;
vector<ll> g[MAXN];
ll dist[MAXN][MAXN];

void bfs(int v) {
    fill(dist[v], dist[v] + MAXN, -1);
    dist[v][v] = 0;
    queue<ll> q;
    q.push(v);
    while (!q.empty()) {
        ll u = q.front();
        q.pop();
        for (auto k : g[u]) {
            if (dist[v][k] == -1) {
                dist[v][k] = dist[v][u] + 1;
                q.push(k);
            }
        }
    }
}

void solve() {
    ll n, d, group;
    cin >> n >> d >> group;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        int lst = i;
        for (int j = i; j <= n; ++j) {
            if (j - lst > d) {
                break;
            }
            if (a[j] <= a[i]) {
                lst = j;
            }
        }
        for (int j = i; j <= min(n, lst + d); ++j) {
            if (a[j] > a[i]) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        bfs(i);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        if (dist[u][v] == -1) {
            cout << 0 << '\n';
            continue;
        }
        cout << (t == 1 ? 1 : dist[u][v]) << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
