#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9, MAXN = (1ll << 20), mod = 1e9 + 7, P = 1073;
mt19937 rnd(2356374786);

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) ans *= n;
        ans %= mod;
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

struct SegmentTree{
    vector<int> tree;
    vector<int> p;
    SegmentTree() {
        tree.resize(MAXN * 2, 0);
        p.resize(MAXN * 2, 0);
    }
    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    void push(int v, int l, int r) {
        if (p[v] == 0) return;
        tree[v] = (r - l) * p[v];
        if (l + 1 != r) {
            p[2 * v] = p[v];
            p[2 * v + 1] = p[v];
        }
        p[v] = 0;
    }
    void update(int v, int lv, int rv, int l, int r, int x) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return;
        if (lv >= l && rv <= r) {
            p[v] += x;
            push(v, lv, rv);
            return;
        }
        int mv = (lv + rv) / 2;
        update(2 * v, lv, mv, l, r, x);
        update(2 * v + 1, mv, rv, l, r, x);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    int get(int v, int lv, int rv, int l, int r) {
        push(v, lv, rv);
        if (l >= rv || r <= lv) return 0;
        if (lv >= l && rv <= r) {
            return tree[v];
        }
        int mv = (lv + rv) / 2;
        return get(2 * v, lv, mv, l, r) + get(2 * v + 1, mv, rv, l, r);
    }
};

struct MaxSegmentTree{
    vector<int> tree;
    MaxSegmentTree() {
        tree.resize(MAXN * 2, 0);
    }
    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
    void update(int v, int lv, int rv, int l, int r, int x) {
        if (l >= rv || r <= lv) return;
        if (lv >= l && rv <= r) {
            tree[v] = x;
            return;
        }
        int mv = (lv + rv) / 2;
        update(2 * v, lv, mv, l, r, x);
        update(2 * v + 1, mv, rv, l, r, x);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
    int get(int v, int lv, int rv, int l, int r) {
        if (l >= rv || r <= lv) return 0;
        if (lv >= l && rv <= r) {
            return tree[v];
        }
        int mv = (lv + rv) / 2;
        return max(get(2 * v, lv, mv, l, r), get(2 * v + 1, mv, rv, l, r));
    }
};

struct Fenwick{
    vector<int> pref;
    int n;
    Fenwick(int nn) {
        n = nn;
        pref.resize(n + 1, 0);
    }
    void update(int i, int x) {
        for (; i < n + 1; i += (i & -i))
            pref[i] += x;
    }
    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= (i & -i))
            ans += pref[i];
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n, d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    for (auto &el : a) cin >> el;
    vector<pair<int, int>> to(n);
    for (int i = 0; i < n; i++) {
        to[i] = {a[i], i};
    }
    sort(to.begin(), to.end());
    SegmentTree right, left;
    vector<int> dd(n);
    for (int i = 0; i < n; i++) {
        dd[i] = i - d;
    }
    left.build(1, 0, n, dd);
    for (int i = 0; i < n; i++) {
        dd[i] = i + d;
    }
    right.build(1, 0, n, dd);
    vector<int> can(n);
    vector<int> maxl(n), maxr(n);
    for (int i = 0; i < n; i++) {
        maxl[i] = i - d;
        maxr[i] = i + d;
    }
    for (auto [x, pos] : to) {
//        int l = left.get(1, 0, n, pos, pos + 1);
//        int r = right.get(1, 0, n, pos, pos + 1);
//        left.update(1, 0, n, pos, r + 1, l);
//        right.update(1, 0, n, l, pos + 1, r);
//        can[pos] = r;
        for (int i = max(0ll, maxl[pos]); i < pos; i++) {
            maxr[i] = maxr[pos];
        }
        for (int i = pos; i <= min(n - 1, maxr[pos]); i++) {
            maxl[i] = maxl[pos];
        }
        can[pos] = maxr[pos];
    }
    MaxSegmentTree tree;
    tree.build(1, 0, n, can);
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        if (a[u] > a[v]) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        } else {
            int cnt = 0;
            int r = u;
            while (r < v) {
//                r = tree.get(1, 0, n, u, r + 1);
                cnt++;
                int next = r;
//                cout << u << ' ' << r << '\n';
                for (int i = u; i <= r; i++) {
                    if (a[i] >= a[u])
                        next = max(next, can[i]);
                }
                r = next;
            }
            cout << cnt << '\n';
        }
    }
}



signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef home
    int test;
    int cnt = 0;
    while(cin >> test) {
        cnt++;
        cout << "TEST " << cnt << ":\n";
        solve();
        cout << '\n' << '\n';
    }
#else
    int test = 1, group;
//    cin >> test >> group;
    while (test--) {
        solve();
    }
#endif
}
