#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19;

int mn[R * 2];

int get_min(int l, int r) {
    l += R;
    r += R;
    int ans = R;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void assign(int pos, int val) {
    pos += R;
    mn[pos] = val;
    for (pos /= 2; pos > 0; pos /= 2) {
        mn[pos] = min(mn[pos * 2], mn[pos * 2 + 1]);
    }
}

vector<pair<int, int>> get_segms(int n, int d, vector<int> &a) {
    vector<pair<int, int>> ans(n), ord(n);
    for (int i = 0; i < n; ++i) {
        ord[i] = {a[i], i};
    }
    sort(ord.begin(), ord.end());
    set<int> pos, pos2;
    pos2.insert(n);
    for (auto [vl, ind] : ord) {
        auto it = pos.lower_bound(ind);
        if (it != pos.begin()) {
            it--;
            if (ind - *it <= d && pos2.count(*it)) {
                pos2.erase(*it);
            }
            it++;
        }
        if (it == pos.end() || *it - ind > d) {
            pos2.insert(ind);
        }
        pos.insert(ind);
        ans[ind].first = ind + 1;
        ans[ind].second = min(n, *pos2.lower_bound(ind) + d + 1);
    }
    return ans;
}

vector<int> get_dist(int n, int d, vector<int> &a, vector<pair<int, int>> &segms, int v) {
    for (int i = 0; i < n; ++i) {
        assign(i, n);
    }
    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; ++i) {
        ord[i] = {a[i], i};
    }
    sort(ord.rbegin(), ord.rend());
    for (auto [vl, ind] : ord) {
        if (ind == v) {
            assign(ind, 0);
        } else {
            assign(ind, min(n, get_min(segms[ind].first, segms[ind].second) + 1));
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = mn[i + R];
    }
    return ans;
}

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    auto segms = get_segms(n, d, a);
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        auto ans = get_dist(n, d, a, segms, v);
        if (ans[u] == n) {
            cout << 0 << '\n';
        } else if (t == 1) {
            cout << 1 << '\n';
        } else {
            cout << ans[u] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
