#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 1e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<int, int, int>;

int n, d, g;
vector<int> a;
int q;
vector<t3> req;
void solve() {
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        --a[i];
        pos[a[i]] = i;
    }

    vector<vector<int>> dp(n, vector<int>(n, INF));
    for (int u = 0; u < n; ++u) {
        vector<int> tmp;
        for (int i = pos[u] + 1; i < n; ++i) {
            int v = a[i];

            if (a[i - 1] <= u) {
                tmp.push_back(i - 1);
            }

            if (i - tmp.back() > d) {
                break;
            }
            if (u < v <= d) {
                dp[u][v] = 1;
            }
        }
    }

    for (int w = 0; w < n; ++w) {
        for (int u = 0; u < n; ++u) {
            for (int v = 0; v < n; ++v) {
                dp[u][v] = min(dp[u][v], dp[u][w] + dp[w][v]);
            }
        }
    }

    for (auto &[t, l, r] : req) {
        --l, --r;
        int ans = 0;
        if (t == 1) {
            if (dp[l][r] != INF) {
                ans = 1;
            }
        } else {
            if (dp[l][r] != INF) {
                ans = dp[l][r];
            }
        }
        cout << ans << '\n';
    }
}

void start() {
    cin >> n >> d >> g;
    a.assign(n, 0);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cin >> q;
    req.assign(q, {});

    for (auto &[t, l, r] : req) {
        cin >> t >> l >> r;
    }

    solve();
    cout << '\n' << '\n' << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

    while (T --> 0) {
        start();
    }

    return 0;
}
