#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <queue>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 1e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<int, int, int>;

int n, d, G;
vector<int> a;
int q;
vector<t3> req;

vector<vector<int>> g;
vector<int> bfs(int s, int n) {
    vector<int> dist(n, INF);
    dist[s] = 0;
    
    queue<int> q;
    q.push(s);
    
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        
        for (auto to : g[v]) {
            if (dist[v] + 1 < dist[to]) {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    
    return dist;
}

void solve() {
    g.assign(n, {});
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        --a[i];
        pos[a[i]] = i;
    }
    
    for (int u = 0; u < n; ++u) {
        vector<int> tmp;
        for (int i = pos[u] + 1; i < n; ++i) {
            int v = a[i];

            if (a[i - 1] <= u) {
                tmp.push_back(i - 1);
            }

            if (i - tmp.back() > d) {
                break;
            }

            if (u < v) {
                g[u].push_back(v);
            }
        }
    }

    vector<vector<int>> dp(n, vector<int>(n, INF));
    for (int u = 0; u < n; ++u) {
        vector<int> dist = bfs(u, n);
        for (int v = 0; v < n; ++v) {
            dp[u][v] = min(dp[u][v], dist[v]);
        }
    }

    for (auto &[t, l, r] : req) {
        --l, --r;
        l = a[l], r = a[r];
        int ans = 0;
        if (t == 1) {
            if (dp[l][r] != INF) {
                ans = 1;
            }
        } else {
            if (dp[l][r] != INF) {
                ans = dp[l][r];
            }
        }
        cout << ans << '\n';
    }
}

void start() {
    cin >> n >> d >> G;
    a.assign(n, 0);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cin >> q;
    req.assign(q, {});

    for (auto &[t, l, r] : req) {
        cin >> t >> l >> r;
    }

    solve();
    cout << '\n' << '\n' << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

    while (T --> 0) {
        start();
    }

    return 0;
}
