#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

vector<vector<int>> edge;
vector<vector<int>> dist;

inline void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    edge.resize(n);
    for (int i = 0; i < n; ++i) {
        int lst = i;
        for (int r = i + 1; r < n; ++r) {
            if (r - lst > d) {
                break;
            }
            if (a[r] < a[i]) {
                lst = r;
            } else {
                edge[i].push_back(r);
            }
        }
    }
    dist.resize(n);
    for (int i = 0; i < n; ++i) {
        dist[i].resize(n, -1);
        dist[i][i] = 0;
        vector<int> bfs = { i };
        for (int j = 0; j < (int)bfs.size(); ++j) {
            int v = bfs[j];
            for (int k : edge[v]) {
                if (dist[i][k] == -1) {
                    dist[i][k] = dist[i][v] + 1;
                    bfs.push_back(k);
                }
            }
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v; cin >> t >> u >> v;
        --u; --v;
        if (dist[u][v] == -1) {
            cout << "0\n";
        } else {
            if (t == 1) {
                cout << "1\n";
            } else {
                cout << dist[u][v] << '\n';
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1, g; //cin >> t >> g;
    while (t--) {
        solve();
    }
}