#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <string>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll n, d, group;
vector<ll> a;

struct O {
	ll l, r;
	O() : l(0), r(0) {}
	O(ll l, ll r) : l(l), r(r) {}
	bool operator<(const O& a) const {
		if (l != a.l) return l < a.l;
		return r < a.r;
	}
};

struct Seg {
	struct Node {
		ll mn, pos;
		Node() : mn(-INF), pos(-1) {}
		Node(ll mn, ll pos) : mn(mn), pos(pos) {}
		Node operator+(const Node& a) const {
			if (mn >= a.mn) return *this;
			return a;
		}
	};
	vector<Node> t;
	ll sz;
	Seg(vector<ll>& r) {
		ll n = r.size();
		sz = 1;
		while (sz < n)sz *= 2;
		t.resize(sz * 2, Node());
		for (ll i = 0; i < n; i++) t[sz + i] = Node(r[i], i);
		for (ll i = sz - 1; i >= 1; i--) t[i] = t[i * 2] + t[i * 2 + 1];
	}
	Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
		if (r == -1) r = sz;
		if (lx <= l && r <= rx) return t[v];
		if (l >= rx || lx >= r) return Node();
		ll m = (l + r) / 2;
		return get(lx, rx, v * 2, l, m) + get(lx, rx, v * 2 + 1, m, r);
	}
};

set<O> st;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d >> group;
	a.resize(n);
	vector<ll> ra(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		ra[a[i] - 1] = i;
	}
	vector<ll> r(n);
	set<ll> t = {ra[0]};
	st.insert({ra[0], ra[0] + d});
	r[ra[0]] = ra[0] + d;
	for (ll i = 1; i < n; i++) {
		auto it = t.lower_bound(ra[i]);
		if (it != t.begin()) {
			it--;
			st.erase({*it, *it + d});
		}
		t.insert(ra[i]);
		it = t.find(ra[i]);
		if (it != t.begin()) {
			auto jt = it;
			jt--;
			if (*jt + d < *it) st.insert({*jt, *jt + d});
		}
		auto kt = it;
		kt++;
		if (kt == t.end() || *it + d < *kt) {
			st.insert({*it, *it + d});
		}
		r[ra[i]] = st.lower_bound({ra[i], 0})->r;
	}
	Seg ss = Seg(r);
	ll C = 20;
	vector<vector<ll>> go(n, vector<ll>(C, 0));
	for (ll i = 0; i < n; i++) {
		go[i][0] = ss.get(i, r[i] + 1).pos;
		if (a[i] > a[go[i][0]]) {
			exit(-1);
		}
	}
	for (ll k = 0; k + 1 < C; k++) {
		for (ll i = 0; i < n; i++) {
			go[i][k + 1] = go[go[i][k]][k];
		}
	}
	ll q;
	cin >> q;
	while (q--) {
		ll t, u, v;
		cin >> t >> u >> v;
		u--; v--;
		if (a[u] > a[v] || r[go[u][C - 1]] < v) cout << "0\n";
		else {
			if (t == 1) cout << "1\n";
			else {
				if (r[u] >= v) {
					cout << "1\n";
					continue;
				}
				ll ans = 2;
				for (ll i = C - 1; i >= 0; i--) {
					if (r[go[u][i]] < v) {
						ans += (1ll << i);
						u = go[u][i];
					}
				}
				cout << ans << "\n";
			}
		}
	}
	return 0;
}