#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <string>
#include <iomanip>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
#pragma GCC optimize(O3)

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll n, d, group;
vector<ll> a;

struct O {
	ll l, r;
	O() : l(0), r(0) {}
	O(ll l, ll r) : l(l), r(r) {}
	bool operator<(const O& a) const {
		if (l != a.l) return l < a.l;
		return r < a.r;
	}
};

struct Seg {
	struct Node {
		ll mn, pos;
		Node() : mn(-INF), pos(-1) {}
		Node(ll mn, ll pos) : mn(mn), pos(pos) {}
		Node operator+(const Node& a) const {
			if (mn >= a.mn) return *this;
			return a;
		}
	};
	vector<Node> t;
	ll sz;
	Seg(vector<ll> r) {
		ll n = r.size();
		sz = 1;
		while (sz < n)sz *= 2;
		t.resize(sz * 2, Node());
		for (ll i = 0; i < n; i++) t[sz + i] = Node(r[i], i);
		for (ll i = sz - 1; i >= 1; i--) t[i] = t[i * 2] + t[i * 2 + 1];
	}
	Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
		if (r == -1) r = sz;
		if (lx <= l && r <= rx) return t[v];
		if (l >= rx || lx >= r) return Node();
		ll m = (l + r) / 2;
		return get(lx, rx, v * 2, l, m) + get(lx, rx, v * 2 + 1, m, r);
	}
	void change(ll i, ll d) {
		t[sz + i] = Node(d, i);
		ll v = (sz + i) / 2;
		while (v > 0) {
			t[v] = t[v * 2] + t[v * 2 + 1];
			v /= 2;
		}
	}
};

set<O> st;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d >> group;
	a.resize(n);
	vector<ll> ra(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		ra[a[i] - 1] = i;
	}
	vector<ll> r(n);
	set<ll> t = {ra[0]};
	st.insert({ra[0], ra[0] + d});
	r[ra[0]] = ra[0] + d;
	for (ll i = 1; i < n; i++) {
		auto it = t.lower_bound(ra[i]);
		if (it != t.begin()) {
			it--;
			st.erase({*it, *it + d});
		}
		t.insert(ra[i]);
		it = t.find(ra[i]);
		if (it != t.begin()) {
			auto jt = it;
			jt--;
			if (*jt + d < *it) st.insert({*jt, *jt + d});
		}
		auto kt = it;
		kt++;
		if (kt == t.end() || *it + d < *kt) {
			st.insert({*it, *it + d});
		}
		r[ra[i]] = st.lower_bound({ra[i], 0})->r;
	}
	if (3 <= group && group <= 5) {
		vector<ll> f(n);
		for (ll i = 0; i < n; i++) f[i] = i;
		Seg ss = Seg(f);
		for (ll i = 0; i < a[n - 1]; i++) {
			ss.change(ra[i], r[ra[i]]);
		}
		ll C = 20;
		vector<vector<ll>> go(n, vector<ll>(C, 0));
		for (ll i = 0; i < n; i++) {
			go[i][0] = ss.get(i, r[i] + 1).pos;
		}
		for (ll k = 0; k + 1 < C; k++) {
			for (ll i = 0; i < n; i++) {
				go[i][k + 1] = go[go[i][k]][k];
			}
		}
		ll q;
		cin >> q;
		while (q--) {
			ll t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			if (a[u] > a[v] || r[go[u][C - 1]] < v) cout << "0\n";
			else {
				if (t == 1) cout << "1\n";
				else {
					if (r[u] >= v) {
						cout << "1\n";
						continue;
					}
					ll ans = 2;
					for (ll i = C - 1; i >= 0; i--) {
						if (r[go[u][i]] < v) {
							ans += (1ll << i);
							u = go[u][i];
						}
					}
					cout << ans << "\n";
				}
			}
		}
	}
	if (1<= group && group <= 2) {
		vector<vector<array<ll, 4>>> f(n);
		ll q;
		cin >> q;
		for (ll i = 0; i < q; i++) {
			ll t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			f[a[v] - 1].push_back({u, v, t, i});
		}
		vector<ll> e(n);
		for (ll i = 0; i < n; i++) e[i] = i;
		Seg ss = Seg(e);
		ll C = 11;
		vector<vector<ll>> go(n, vector<ll>(C, 0));
		vector<ll> ans(q);
		for (ll i = 0; i < n; i++) {
			ss.change(ra[i], r[ra[i]]);
			if (f[i].size() == 0) continue;
			for (ll i = 0; i < n; i++) {
				go[i][0] = ss.get(i, r[i] + 1).pos;
			}
			for (ll k = 0; k + 1 < C; k++) {
				for (ll i = 0; i < n; i++) {
					go[i][k + 1] = go[go[i][k]][k];
				}
			}
			for (auto& p : f[i]) {
				ll t, u, v;
				u = p[0], v = p[1], t = p[2];
				ll i = p[3];
				if (a[u] > a[v] || r[go[u][C - 1]] < v) ans[i] = 0;
				else {
					if (t == 1) ans[i] = 1;
					else {
						if (r[u] >= v) {
							ans[i] = 1;
							continue;
						}
						ll res = 2;
						for (ll i = C - 1; i >= 0; i--) {
							if (r[go[u][i]] < v) {
								res += (1ll << i);
								u = go[u][i];
							}
						}
						ans[i] = res;
					}
				}
			}
		}
		for (ll x : ans) cout << x << "\n";
	}
	if (group == 6) {
		vector<vector<array<ll, 4>>> f(n);
		ll q;
		cin >> q;
		for (ll i = 0; i < q; i++) {
			ll t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			f[a[v] - 1].push_back({u, v, t, i});
		}
		vector<ll> e(n);
		for (ll i = 0; i < n; i++) e[i] = i;
		Seg ss = Seg(e);
		vector<ll> ans(q);
		const ll C = 10;
		for (ll i = 0; i < n; i++) {
			ss.change(ra[i], r[ra[i]]);
			if (f[i].size() == 0) continue;
			for (auto& p : f[i]) {
				ll t, u, v;
				u = p[0], v = p[1], t = p[2];
				ll i = p[3];
				if (a[u] > a[v]) ans[i] = 0;
				else {
					ans[i] = 0;
					for (ll j = 0; j < C; j++) {
						if (r[u] >= v) {
							ans[i] = j + 1;
							break;
						}
						u = ss.get(u, r[u] + 1).pos;
					}
				}
			}
		}
		for (ll x : ans) cout << x << "\n";
	}
	if (group == 7) {
		vector<vector<array<ll, 4>>> f(n);
		ll q;
		cin >> q;
		for (ll i = 0; i < q; i++) {
			ll t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			f[a[v] - 1].push_back({u, v, t, i});
		}
		vector<ll> e(n);
		for (ll i = 0; i < n; i++) e[i] = i;
		Seg ss = Seg(e);
		vector<ll> ans(q);
		const ll C = 150;
		for (ll i = 0; i < n; i++) {
			ss.change(ra[i], r[ra[i]]);
			if (f[i].size() == 0) continue;
			for (auto& p : f[i]) {
				ll t, u, v;
				u = p[0], v = p[1], t = p[2];
				ll i = p[3];
				if (a[u] > a[v]) ans[i] = 0;
				else {
					ans[i] = 0;
					for (ll j = 0; j < C; j++) {
						if (r[u] >= v) {
							ans[i] = j + 1;
							break;
						}
						u = ss.get(u, r[u] + 1).pos;
					}
				}
			}
		}
		for (ll x : ans) cout << x << "\n";
	}
	if (group == 8 || group == 0) {
		vector<vector<array<ll, 4>>> f(n);
		ll q;
		cin >> q;
		for (ll i = 0; i < q; i++) {
			ll t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			f[a[v] - 1].push_back({u, v, t, i});
		}
		vector<ll> e(n);
		for (ll i = 0; i < n; i++) e[i] = i;
		Seg ss = Seg(e);
		vector<ll> go(n, 0);
		vector<ll> ans(q);
		const ll B = 2600;
		vector<vector<array<ll, 2>>> rpob(n / B + 1);
		vector<ll> num(n);
		for (ll i = 0; i < n; i++) {
			rpob[i / B].push_back({ra[i], ra[i]});
		}
		for (ll i = 0; i < rpob.size(); i++) {
			sort(all(rpob[i]));
			for (ll x = 0; x < rpob[i].size(); x++) {
				num[a[rpob[i][x][0]] - 1] = x;
			}
		}
		for (ll i = 0; i < n; i++) {
			ll indrpob = i / B;
			ss.change(ra[i], r[ra[i]]);
			go[ra[i]] = ss.get(ra[i], r[ra[i]] + 1).pos;
			go[ra[i]] = go[go[ra[i]]];
			rpob[indrpob][num[i]][1] = r[go[ra[i]]];
			if (i % B == 0) {
				for (ll i = n - 1; i >= 0; i--) {
					go[i] = ss.get(i, r[i] + 1).pos;
					go[i] = go[go[i]];
				}
			}
			ll jj = i;
			if (jj == 4) {
				ll awob = 0;
			}
			for (auto& p : f[i]) {
				ll t, u, v;
				u = p[0], v = p[1], t = p[2];
				ll i = p[3];
				if (a[u] > a[v]) ans[i] = 0;
				else {
					ll nu = u;
					u = go[u];
					ll it = 0;
					ll indrpob = i / B;
					while (r[a[u]] < v && it < rpob[indrpob].size()) {
						auto p = rpob[indrpob][it];
						if (nu <= p[0] && p[0] <= r[u] && p[1] > r[u]) {
							u = go[p[0]];
						}
						it++;
					}
					if (r[a[u]] >= v) ans[i] = 1;
					else ans[i] = 0;
				}
			}
		}
		for (ll x : ans) cout << x << "\n";
	}
	return 0;
}