#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int n, d;
vector<int> a;

void solve1() {
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int prev = i;
        for (int j = i + 1; j < n; ++j) {
            if (j - prev > d) break;
            if (a[j] < a[i]) prev = j;
            else g[i].push_back(j);
        }
    }
    vector<vector<int>> dist(n, vector<int> (n, 1e9));
    for (int i = n - 1; i >= 0; --i) {
        for (auto x : g[i]) {
            dist[i][x] = 1;
            for (int j = x + 1; j < n; ++j) dist[i][j] = min(dist[i][j], dist[x][j] + 1);
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        if (dist[u - 1][v - 1] == 1e9) cout << 0 << "\n";
        else if (t == 1) cout << 1 << "\n";
        else cout << dist[u - 1][v - 1] << "\n";
    }
}

void solve2() {
    int c = 20;
    vector<vector<int>> nx(c, vector<int>(n, -1));
    vector<int>st;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.back()] < a[i]) st.pop_back();
        if (!st.empty()) nx[0][i] = st.back();
        st.push_back(i);
    }
    for (int i = 1; i < c; ++i) {
        for (int j = 0; j < n; ++j) {
            if (nx[i - 1][j] != -1) nx[i][j] = nx[i - 1][nx[i - 1][j]];
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        int cur = u - 1;
        for (int j = c - 1; j >= 0; --j) {
            if (nx[j][cur] < v && nx[j][cur] != -1) cur = nx[j][cur];
        }
        if (cur == v - 1) cout << 1 << "\n";
        else cout << 0 << "\n";
    }
}

int main() {
    int gr;
    cin >> n >> d >> gr;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (gr <= 2) solve1();
    if (gr == 8) solve2();
    return 0;
}

/*
6 1 8
2 1 3 4 5 6
6
2 1 3
2 1 2
1 1 4
2 1 5
2 1 6
1 2 6

6 2 8
1 2 3 4 5 6
6
2 1 5
2 2 5
2 1 6
2 2 6
2 1 4
2 2 4

 */
