#include <bits/stdc++.h>
#pragma GCC optimize("Ofast", "inline")
#pragma GCC target("avx2")

#define int int64_t
#define endl '\n'
#define pb push_back
#define pw(x) (int64_t(1)<<x)
#define TIME 1.0*clock()/CLOCKS_PER_SEC

using namespace std;

const int INF = 1e9;
mt19937 gen(time(0));

struct fenwick {
    vector <int> f;
    fenwick (int n) {
        f.resize(n, 0);
    }
    void upd (int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i = (i | (i + 1));
        }
    }
    int get (int i) {
        int ans = 0;
        while (i >= 0) {
            ans += f[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }
    int get (int l, int r) {
        return get(r) - get(l - 1);
    }
};

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, d, g;
    cin >> n >> d >> g;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector <vector <bool>> can(n, vector <bool> (n, 0));
    vector <int> scan[n + 1];
    for (int i = 0; i < n; ++i) {
        vector <bool> have(n);
        have[i] = 1;
        can[i][i] = 1;
        fenwick f(n);
        f.upd(i, 1);
        for (int j = i; j < n; ++j) {
            int ps = max(i, j - d);
            int sum = f.get(ps, j - 1);
            if (sum > 0) {
                if (a[j] < a[i]) {
                    have[j] = 1;
                    f.upd(j, 1);
                }
                if (a[j] > a[i]) {
                    scan[i].push_back(j);
                    can[i][j] = 1;
                }
            }
        }
    }
    vector <vector <int>> dp(n, vector <int> (n, INF));
    for (int i = 0; i < n; ++i) {
        dp[i][i] = 0;
        for (int j = i; j < n; ++j) {
            for (auto x : scan[j]) {
                dp[i][x] = min(dp[i][x], dp[i][j] + 1);
            }
        }
    }
    int it = 0;
    while (q--) {
        it++;
        int t, x, y;
        cin >> t >> x >> y;
        x--;
        y--;
        if (a[x] >= a[y]) {
            cout << 0 << endl;
            continue;
        }
        if (t == 1) {
            if (dp[x][y] == INF) {
                cout << 0 << endl;
            } else {
                cout << 1 << endl;
            }
        } else {
            if (dp[x][y] == INF) {
                cout << 0 << endl;
            } else {
                cout << dp[x][y] << endl;
            }
        }
    }
}

