#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct segTree {
	int size;
	vector<int> tree;

	void init(int n) {
		size = 1;
		while (size < n)
			size *= 2;
		tree.resize(2 * size - 1, -1);
	}
	void upd(int x, int lx, int rx, int pos, int val) {
		if (lx + 1 == rx) {
			tree[x] = val;
			return;
		}
		int mid = (lx + rx) / 2;
		if (mid > pos)
			upd(2 * x + 1, lx, mid, pos, val);
		else
			upd(2 * x + 2, mid, rx, pos, val);
		tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
	}
	int get_max(int x, int lx, int rx, int l, int r) {
		if (lx >= l && rx <= r)
			return tree[x];
		if (lx >= r || rx <= l)
			return -1;
		int mid = (lx + rx) / 2;
		int left = get_max(2 * x + 1, lx, mid, l, r);
		int right = get_max(2 * x + 2, mid, rx, l, r);
		return max(left, right);
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d, g;
	cin >> n >> d >> g;
	vector<int> a(n), que(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
		que[a[i]] = i;
	}
	if (n <= 1000) {
		vector<vector<int>> gr(n);
		for (int start = 0; start < n; ++start) {
			vector<int> ost_ind;
			for (int j = start; j < n; ++j) {
				if (a[j] <= a[start])
					ost_ind.push_back(j);
			}
			int k = 0;
			set<int> dost;
			while (k + 1 < ost_ind.size() && ost_ind[k + 1] - ost_ind[k] <= d) {
				k++;
				dost.insert(ost_ind[k]);
			}
			for (int fin = start + 1; fin < n; ++fin) {
				if (a[fin] < a[start]) continue;
				if (fin - start <= d) {
					gr[start].push_back(fin);
					continue;
				}
				if (dost.lower_bound(fin) != dost.begin()) {
					int lst = *prev(dost.lower_bound(fin));
					if (fin - lst <= d) {
						gr[start].push_back(fin);

					}
				}
			}
		}
		vector<vector<int>> dist(n, vector<int>(n, INF));
		for (int u = 0; u < n; ++u) {
			dist[u][u] = 0;
			deque<int> queue;
			queue.push_back(u);
			while (!queue.empty()) {
				int v = queue.front();
				queue.pop_front();
				for (int w : gr[v]) {
					if (dist[u][w] > dist[u][v] + 1) {
						queue.push_back(w);
						dist[u][w] = dist[u][v] + 1;
					}
				}
			}
		}
		int q; cin >> q;
		for (int _ = 0; _ < q; ++_) {
			int t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			cout << "     ";
			if (dist[u][v] == INF)
				cout << 0 << "\n";
			else if (t == 1)
				cout << 1 << "\n";
			else
				cout << dist[u][v] << "\n";
		}
	}
	else {
		segTree tr;
		tr.init(n);
		vector<vector<int>> gr(n);
		for (int i = 0; i < n; ++i) {
			int u = que[i];
			int max_v = tr.get_max(0, 0, tr.size, u + 1, u + d + 1);
			max_v = max(max_v, u);
			gr[min(n - 1, max_v + d)].push_back(u);
			tr.upd(0, 0, tr.size, u, max_v);
		}
		vector<int> dist(n, INF);
		dist[n - 1] = 0;
		deque<int> queue;
		queue.push_back(n - 1);
		while (!queue.empty()) {
			int v = queue.front();
			queue.pop_front();
			for (int w : gr[v]) {
				if (dist[w] > dist[v] + 1) {
					queue.push_back(w);
					dist[w] = dist[v] + 1;
				}
			}
		}
		int q; cin >> q;
		for (int _ = 0; _ < q; ++_) {
			int t, u, v;
			cin >> t >> u >> v;
			u--; v--;
			cout << "     ";
			if (dist[u] == INF)
				cout << 0 << "\n";
			else if (t == 1)
				cout << 1 << "\n";
			else
				cout << dist[u] << "\n";
		}
	}

	return 0;
}