#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<int> par, rc;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u == v) return;
	par[u] = v;
	rc[v] = max(rc[u], rc[v]);
}

vector<set<pair<int, int>>> t;

int min_(int v, int l, int r, int lq, int rq, int a) {
	if (lq <= l && r <= rq) {
		auto it = t[v].upper_bound({ a, -1 });
		return it == t[v].end() ? 1e9 : it->second;
	}
	if (lq >= r || rq <= l) {
		return 1e9;
	}
	int m = (l + r) / 2;
	return min(min_(v * 2 + 1, l, m, lq, rq, a), min_(v * 2 + 2, m, r, lq, rq, a));
}

void add(int v, int a, int val) {
	auto it = t[v].upper_bound({ a, val });
	while (it != t[v].begin() && prev(it)->second >= val) {
		t[v].erase(prev(it));
		it = t[v].upper_bound({ a, val });
	}
	it = t[v].upper_bound({ a, val });
	if (it != t[v].end() && it->second < val) {
		return;
	}
	t[v].insert({ a, val });
}

void set_(int v, int l, int r, int pos, int a, int val) {
	if (l == r - 1) {
		add(v, a, val);
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) {
		set_(v * 2 + 1, l, m, pos, a, val);
	}
	else {
		set_(v * 2 + 2, m, r, pos, a, val);
	}
	add(v, a, val);
}


void solve() {
	int n, d, group;
	cin >> n >> d >> group;
	par.resize(n);
	rc.resize(n);
	vector<int> a(n);
	vector<int> pa(n);
	for (int i = 0; i < n; i++) {
		par[i] = i;
		rc[i] = i;
		cin >> a[i];
		a[i]--;
		pa[a[i]] = i;
	}
	set<int> ps;
	vector<int> rd(n);
	for (int i = 0; i < n; i++) {
		auto up = ps.upper_bound(pa[i]);
		if (up != ps.end() && *up - pa[i] <= d) {
			unite(*up, pa[i]);
		}
		if (up != ps.begin() && pa[i] - *prev(up) <= d) {
			unite(*prev(up), pa[i]);
		}
		rd[pa[i]] = min(n - 1, rc[find(pa[i])] + d);
		ps.insert(pa[i]);
	}
	int q;
	cin >> q;
	vector<int> dst(n, 1e9);
	dst[n-1] = 0;
	t.resize(n * 4);
	set_(0, 0, n, n-1, a[n-1], 0);
	for (int i = n-2; i >= 0; i--) {
		dst[i] = min_(0, 0, n, i+1, rd[i] + 1, a[i] + 1) + 1;
		set_(0, 0, n, i, a[i], dst[i]);
	}
	while (q--) {
		int t, l, r;
		cin >> t >> l >> r;
		l--;r--;
		if (dst[l] >= 1e9) {
			cout << 0 << '\n';
		}
		else {
			cout << (t == 1 ? 1 : dst[l]) << '\n';
		}
	}
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	t = 1;//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}