#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<int> par, rc;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u == v) return;
	par[u] = v;
	rc[v] = max(rc[u], rc[v]);
}

vector<set<pair<int, int>>> t;

int min_(int v, int l, int r, int lq, int rq, int a) {
	if (lq <= l && r <= rq) {
		auto it = t[v].upper_bound({ a, -1 });
		return it == t[v].end() ? 1e9 : it->second;
	}
	if (lq >= r || rq <= l) {
		return 1e9;
	}
	int m = (l + r) / 2;
	return min(min_(v * 2 + 1, l, m, lq, rq, a), min_(v * 2 + 2, m, r, lq, rq, a));
}

void add(int v, int a, int val) {
	auto it = t[v].upper_bound({ a, val });
	while (it != t[v].begin() && prev(it)->second >= val) {
		t[v].erase(prev(it));
		it = t[v].upper_bound({ a, val });
	}
	it = t[v].upper_bound({ a, val });
	if (it != t[v].end() && it->second < val) {
		return;
	}
	t[v].insert({ a, val });
}

void set_(int v, int l, int r, int pos, int a, int val) {
	if (l == r - 1) {
		add(v, a, val);
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) {
		set_(v * 2 + 1, l, m, pos, a, val);
	}
	else {
		set_(v * 2 + 2, m, r, pos, a, val);
	}
	add(v, a, val);
}

vector<int> par1;

int find1(int v) {
	return par1[v] == v ? v : par1[v] = find1(par1[v]);
}

void unite1(int u, int v) {
	u = find1(u);
	v = find1(v);
	if (u == v) {
		return;
	}
	par1[u] = v;
}

void solve() {
	int n, d, group;
	cin >> n >> d >> group;
	if (group < 3) {
		par.resize(n);
		rc.resize(n);
		vector<int> a(n);
		vector<int> pa(n);
		for (int i = 0; i < n; i++) {
			par[i] = i;
			rc[i] = i;
			cin >> a[i];
			a[i]--;
			pa[a[i]] = i;
		}
		set<int> ps;
		vector<int> rd(n);
		for (int i = 0; i < n; i++) {
			auto up = ps.upper_bound(pa[i]);
			if (up != ps.end() && *up - pa[i] <= d) {
				unite(*up, pa[i]);
			}
			if (up != ps.begin() && pa[i] - *prev(up) <= d) {
				unite(*prev(up), pa[i]);
			}
			rd[pa[i]] = min(n - 1, rc[find(pa[i])] + d);
			ps.insert(pa[i]);
		}
		vector<vector<int>> g(n);
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j <= rd[i]; j++) {
				if (a[j] > a[i]) {
					g[i].push_back(j);
				}
			}
		}
		int q;
		cin >> q;
		vector<vector<int>> dst(n, vector<int>(n, 1e9));
		for (int r = 0; r < n; r++) {
			dst[r][r] = 0;
			for (int i = r - 1; i >= 0; i--) {
				for (auto to : g[i]) {
					dst[r][i] = min(dst[r][to] + 1, dst[r][i]);
				}
			}
		}
		while (q--) {
			int t, l, r;
			cin >> t >> l >> r;
			l--;r--;
			if (dst[r][l] == 1e9) {
				cout << 0 << '\n';
			}
			else {
				cout << (t == 1 ? 1 : dst[r][l]) << '\n';
			}
		}
		return;
	}
	par.resize(n);
	par1.resize(n);
	rc.resize(n);
	vector<int> a(n);
	vector<int> pa(n);
	for (int i = 0; i < n; i++) {
		par[i] = i;
		rc[i] = i;
		cin >> a[i];
		a[i]--;
		pa[a[i]] = i;
	}
	set<int> ps;
	vector<int> rd(n);
	for (int i = 0; i < n; i++) {
		auto up = ps.upper_bound(pa[i]);
		if (up != ps.end() && *up - pa[i] <= d) {
			unite(*up, pa[i]);
		}
		if (up != ps.begin() && pa[i] - *prev(up) <= d) {
			unite(*prev(up), pa[i]);
		}
		rd[pa[i]] = min(n - 1, rc[find(pa[i])] + d);
		ps.insert(pa[i]);
	}
	int q;
	cin >> q;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j <= rd[i]; j++) {
			if (a[j] > a[i]) {
				unite1(i, j);
			}
		}
	}
	while (q--) {
		int t, l, r;
		cin >> t >> l >> r;
		l--;r--;
		if (a[l] > a[r] || find1(l) != find1(r)) {
			cout << 0 << '\n';
		}
		else {
			cout << 1 << '\n';
		}
	}
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	t = 1;//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}