#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

struct SegmentTree {
	int n;
	vector<int> d;
	SegmentTree(int tn) {
		n = 1;
		while (n < tn) n <<= 1;
		d.resize(n * 2 - 1, 0);
	}

	void add(int ind) {
		ind += n - 1;
		while (ind) {
			++d[ind];
			ind = (ind - 1) / 2;
		}
		++d[ind];
	}

	int query(int v, int lt, int rt, int L, int R) {
		if (L <= lt && rt <= R) return d[v];
		if (R <= lt || rt <= L) return 0;
		int m = (lt + rt) / 2;
		return	query(v * 2 + 1, lt, m, L, R) +
				query(v * 2 + 2, m, rt, L, R);
	}
	int query(int lt, int rt) {
		return query(0, 0, n, lt, rt); 
	}
};

struct RMQ {
	int n;
	vector<int> vals;
	vector<int> d;

	int merge(int x, int y) {
		if (x == -1) return y;
		if (y == -1) return x; 
		return (vals[x] > vals[y] ? x : y);
	}

	RMQ (int tn) {
		vals.resize(tn, INT_MAX);
		n = 1;
		while (n < tn) n <<= 1;
		d.resize(n * 2 - 1, -1);
		for (int i = 0; i < tn; ++i) d[i + n - 1] = -1;
		for (int i = n - 2; i >= 0; --i) d[i] = merge(d[i * 2 + 1], d[i * 2 + 2]);
	}

	int query(int v, int lt, int rt, int L, int R) {
		if (L <= lt && rt <= R) return d[v];
		if (R <= lt || rt <= R) return -1;
		int m = (lt + rt) / 2;
		return merge(
				query(v * 2 + 1, lt, m, L, R),
				query(v * 2 + 2, m, rt, L, R));
	}
	int query(int lt, int rt) {
		return query(0, 0, n, lt, rt); 
	}

	void change(int ind, int val) {
		vals[ind] = val;
		ind += n - 1;
		while (ind) {
			ind = (ind - 1) / 2;
			d[ind] = merge(d[ind * 2 + 1], d[ind * 2 + 2]);
		}
	}
};

signed main() {
	FastIO;
	int n, d, g;
	cin >> n >> d >> g;
	vector<int> a(n);
	for (auto &it : a) cin >> it;
	int q;
	cin >> q;
	
	vector<int> p(n);
	iota(all(p), 0);
	sort(all(p), [&a](int i, int j){ return a[i] < a[j]; });

	SegmentTree d1(n);

	vector<int> nxt(n, -1);

	for (int ind = 0; ind < n; ++ind) {
		int i = p[ind];

		nxt[i] = i;

		int lt = i, rt = n;
		while (rt - lt > 1) {
			int m = (lt + rt) / 2;
			if (d1.query(m, n)) rt = m;
			else lt = m;
		}
		
		d1.add(p[i]);

		if (rt == n || rt - i > d) continue;
		nxt[i] = nxt[rt];
	}

	vector<int> vw(n);
	for (int i = 0; i < n; ++i) vw[i] = min(n, nxt[i] + d + 1);

	RMQ d2(n);
	vector<int> dist(n, INT_MAX);

	d2.change(n - 1, 0);
	dist[n - 1] = 0;
	
	reverse(all(p));

	bool flag = 0;

	for (int ind = 0; ind < n; ++ind) {
		int i = p[ind];
		if (i == n - 1) {
			flag = 1;
			continue;
		}
		if (!flag) continue;
		int j = d2.query(i + 1, vw[i]);
		if (dist[j] == INT_MAX) continue;
		dist[i] = dist[j] + 1;
		d2.change(i, dist[i]);
	}

	for (int i = 0; i < q; ++i) {
		int t, u, v;
		cin >> t >> u >> v;
		--u; --v;
		if (v == n - 1) {
			int tmp = dist[u];
			if (tmp == INT_MAX) {
				cout << "0\n";
				continue;
			}
			cout << (t == 1 ? 1 : tmp) << '\n';
		}
	}

	return 0;
}


