#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <deque>

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g;
vector<vector<int>> dists;
int n;

void solve(int u) {
    deque <int> q = {u};
    vector<int> d(n, 1e9);
    d[u] = 0;
    while (!q.empty()) {
        auto el = q.front();
        q.pop_front();
        for (auto ch : g[el]) {
            if (d[ch] > d[el] + 1) {
                d[ch] = d[el] + 1;
                q.push_back(ch);
            }
        }
    }
    dists[u] = d;
}

int sol(int u, int v) {
    map<int, int> d;
    d[u] = 1;
    deque <int> q = {u};
    while (!q.empty()) {
        auto el = q.front();
        q.pop_front();
        if (d[el] > 11) return 1e9;
        for (auto ch : g[el]) {
            if (d[ch] == 0) {
                d[ch] = d[el] + 1;
                q.push_back(ch);
            }
        }
    }
    if (d[v] == 0) return 1e9;
    return d[v];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int q;
    cin >> q;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int cnt_big = 0;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] > a[i]) {
                if (cnt_big == d) break;
                g[i].push_back(j);
                cnt_big++;
            } else {
                if (cnt_big == d) break;
                cnt_big = 0;
            }
        }
    }
    if (group <= 2) {
        dists.resize(n);
        for (int i = 0; i < n; ++i) {
            solve(i);
        }
    }
    for (; q > 0; --q) {
        int t, u, v;
        cin >> t >> u >> v;
        --u; --v;
        int ans;
        if (group <= 2) {
            ans = dists[u][v];
        } else {
            ans = sol(u, v);
        }
        if (ans == 1e9) {
            cout << 0 << "\n";
        } else {
            if (t == 1) {
                cout << 1 << "\n";
            } else {
                cout << ans << "\n";
            }
        }
    }
    return 0;
}
