#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));
const int N = 3e5 + 1;
struct RMQ {
    vector<vector<int>> st;
    int lg = 0;
    int n;
    RMQ(vector<int> a) {
        n = a.size();
        while ((1 << lg) < a.size()) lg++;
        st.assign(lg, vector<int>(n));
        for (int i = 0; i < n; i++) {
            st[0][i] = a[i];
        }
        for (int l = 0; l < lg; l++) {
            for (int i = 0; i + (2 << l) <= n; i++) {
                st[l + 1][i] = max(st[l][i], st[l][i + (1 << l)]);
            }
        }
    }
    int query(int l, int r) {
        r++;
        int d = __lg(r - l);
        return max(st[d][l], st[d][r - (1 << d)]);
    }
};
struct SegTree {
    vector<int> tree;
    int n;
    SegTree(int _n) : n(_n), tree(2 * _n, inf) {}
    void update(int pos, int val) {
        for (tree[pos += n] = val; pos > 1; pos >>= 1) tree[pos >> 1] = min(tree[pos], tree[pos ^ 1]);
    }
    int query(int l, int r) {
        int ans = inf;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) chmin(ans, tree[l++]);
            if (r & 1) chmin(ans, tree[--r]);
        }
        return ans;
    }
};
void solve_case() {
    int n, d, G;
    cin >> n >> d >> G;
    vector<int> a(n);
    d = min(d, n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> ad(n - d + 1);
    {
        set<int> st;
        for (int i = 0; i < d; i++) st.insert(a[i]);
        for (int i = 0; i + d <= n; i++) {
            ad[i] = *st.begin();
            st.erase(a[i]);
            if (i + d != n) st.insert(a[i + d]);
        }
    }
    RMQ rmq_ad(ad);
    vector<int> maxR(n);
    {
        vector<int> stk;
        for (int i = n - 1; i >= 0; i--) {
            int left = min(n - 1, i + d), right = n;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (rmq_ad.query(i, mid - d) <= a[i]) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            maxR[i] = left;
        }
    }
    if (G == 3 || G == 4 || G == 5) {
        int q;
        cin >> q;
        vector<int> dist(n, inf);
        SegTree st(n);
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int l, int r){
            return a[l] > a[r];
        });
        for (int x : ord) {
            if (x == n - 1) {
                dist[x] = 0;
            }
            chmin(dist[x], st.query(x, maxR[x]) + 1);
            st.update(x, dist[x]);
        }
        while (q--) {
            int t, l, r;
            cin >> t >> l >> r;
            l--, r--;
            int ans = dist[l];
            if (ans == inf) ans = 0;
            if (t == 1 && ans != 0) ans = 1;
            cout << ans << "\n";
        }
        return;
    }
    if (G == 1 || G == 2) {
        vector<vector<int>> dist(n, vector<int>(n, inf));
        for (int l = 0; l < n; l++) {
            dist[l][l] = 0;
            vector<vector<int>> rem(n);
            SegTree st(n);
            for (int i = l; i < n; i++) {
                chmin(dist[l][i], st.query(0, a[i]) + 1);
                if (dist[l][i] == inf) continue;
                rem[maxR[i]].push_back(i);
                st.update(a[i], dist[l][i]);
                for (int j : rem[i]) {
                    st.update(a[j], inf);
                }
            }
        }
        int q;
        cin >> q;
        for (int iq = 0; iq < q; iq++) {
            int t, l, r;
            cin >> t >> l >> r;
            l--, r--;
            int ans = dist[l][r];
            if (ans == inf) ans = 0;
            if (t == 1 && ans != 0) ans = 1;
            cout << ans << "\n";
        }
        return;
    }

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
