#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

constexpr ll INF = 1e9 + 9;

struct SegTree {
    vector<int> tree;
    int sz;
    SegTree(vector<int> a) {
        for (sz = 1; sz < a.size(); sz <<= 1) {}
        tree.assign(2 * sz, -1);
        for (int i = 0; i < a.size(); i++)
            tree[sz + i] = a[i];
        for (int i = sz - 1; i > 0; --i)
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
    }
    int get(int l, int r) {
        l += sz; r += sz;
        int ans = -1;
        while (r - l > 0) {
            if (l & 1)
                ans = max(ans, tree[l++]);
            if (r & 1)
                ans = max(ans, tree[--r]);
            l >>= 1;
            r >>= 1;
        }
        return ans;
    }
};

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n), pos(n), gl(n), gr(n), border(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
        gl[i] = gr[i] = -1;
    }

    set<int> cum;
    for (int i = n - 1; i >= 0; --i) {
        int v = pos[i];
        auto it = cum.lower_bound(v);
        border[v] = (it == cum.end() ? n - 1 : *it + d - 1);
        if (v != 0 && v != n - 1 && gl[v - 1] != -1 && gr[v + 1] != -1) {
            int l = gl[v - 1], r = gr[v + 1];
            gr[l] = r;
            gl[r] = l;
            for (int i = max(l, v - d + 1); i <= min(v, r - d + 1); i++)
                cum.insert(i);
        } else if (v != 0 && gl[v - 1] != -1) {
            int l = gl[v - 1];
            gr[l] = v;
            gl[v] = l;
            if (v - d + 1 >= l)
                cum.insert(v - d + 1);
        } else if (v != n - 1 && gr[v + 1] != -1) {
            int r = gr[v + 1];
            gl[r] = v;
            gr[v] = r;
            if (v + d - 1 <= r)
                cum.insert(v);
        } else {
            gl[v] = gr[v] = v;
            if (d == 1)
                cum.insert(v);
        }
    }

    vector<int> tmp(n);
    for (int i = 0; i < n; i++) {
        if (a[i] > a[n - 1])
            tmp[i] = -1;
        else
            tmp[i] = a[i];
    }

    if (g == 3 || g == 4 || g == 5) {
        SegTree st(tmp);
        vector<int> nxt(n), ans(n, INF);
        for (int i = 0; i < n; i++) {
            int res = st.get(i, border[i] + 1);
            nxt[i] = (res == -1 ? -1 : pos[res]);
        }
        ans[n - 1] = 0;
        for (int i = n - 2; i >= 0; --i) {
            if (a[i] > a[n - 1])
                continue;
            ans[i] = (nxt[i] == -1 ? INF : ans[nxt[i]] + 1);
        }

        int q;
        cin >> q;
        while (q--) {
            int t, a, b;
            cin >> t >> a >> b;
            a--; b--;
            // assert(b == n - 1);
            if (ans[a] >= INF)
                cout << "0\n";
            else
                cout << (t == 1 ? 1 : ans[a]) << '\n';
        }
    } else if (g <= 2) {
        vector<vector<int>> ans(n, vector<int>(n, INF));
        for (int st = 0; st < n; st++) {
            vector<int> tmp(n, -1);
            for (int i = 0; i <= st; i++) {
                if (a[i] <= a[st])
                    tmp[i] = a[i];
            }
            SegTree cum(tmp);
            ans[st][st] = 0;
            for (int i = st - 1; i >= 0; --i) {
                if (a[i] > a[st])
                    continue;
                int res = cum.get(i, border[i] + 1);
                if (res == -1)
                    continue;
                ans[i][st] = ans[pos[res]][st] + 1;
            }
        }
        int q;
        cin >> q;
        while (q--) {
            int t, a, b;
            cin >> t >> a >> b;
            a--; b--;
            // assert(b == n - 1);
            if (ans[a][b] >= INF)
                cout << "0\n";
            else
                cout << (t == 1 ? 1 : ans[a][b]) << '\n';
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
    
    return 0;
}
