#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int> p) {
    out << "| " << p.first << " " << p.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
int rnd() {return abs((int) rng());}
constexpr long long N = 3e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

int p[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

int unite(int a, int b) {
    a = get(a); b = get(b);
    if (a == b) return 0;
    if (rnd() & 1) p[a] = b;
    else p[b] = a;
    return 1;
}

void solve() {
    struct qry {
        int t, u, v, i;
    };

    int n, d, g;
    cin >> n >> d >> g;

    for (int i = 0; i < n; i++) p[i] = i;

    vector<int> a(n, 0);
    cin >> a;
    for (auto& el : a) el--;

    vector<int> ind(n, 0);
    for (int i = 0; i < n; i++) ind[i] = i;

    sort(ind.begin(), ind.end(), [&](int i, int j) {
        return (a[i] > a[j]);
    });
    set<int> cur;

    int q; cin >> q;
    vector<vector<qry>> qs(n, vector<qry> (0)); 
    vector<int> ans(q, -1);

    for (int i = 0; i < q; i++) {
        int t, u, v; cin >> t >> u >> v; u--;--v;
        qs[a[u]].push_back({t, u, v, i});
    }

    for (int j = 0; j < n; j++) {
        int i = ind[j];

        cur.insert(i);
        auto it = cur.lower_bound(i);

        if (it != cur.begin()) {
            int u = *prev(it);
            if (abs(u - i) <= d) unite(u, i);
        }
        if (next(it) != cur.end()) {
            int u = *next(it);
            if (abs(u - i) <= d) unite(u, i);
        }

        for (auto [t, u, v, i] : qs[a[i]]) {
            if (get(u) == get(v)) ans[i] = 1;
            else ans[i] = 0;
        }
    }

    for (auto el : ans) cout << el << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}