#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int> p) {
    out << "| " << p.first << " " << p.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 1e6;
constexpr long long T = 20;
constexpr long long inf = 1e18;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n, x, g;
    cin >> n >> x >> g;
    vector<int> a(n);
    cin >> a;
    vector<vector<int>> gr(n, vector<int> (0));

    for (int i = 0; i < n; i++) {
        int lg = i;
        for (int j = i + 1; j < n; j++) {
            if (j - lg > x) break;
            if (a[i] < a[j] && j - lg <= x) {
                gr[i].push_back(j);
            } else if (a[i] > a[j]) {
                lg = j;
            }
        }
    }

    vector<vector<int>> d(n, vector<int> (n, inf));

    queue<int> q;
    for (int i = 0; i < n; i++) {
        d[i][i] = 0;
        q.push(i);
        while (q.size()) {
            int v = q.front();
            q.pop();
            for (int to : gr[v]) {
                if (d[i][to] > d[i][v] + 1) {
                    d[i][to] = d[i][v] + 1;
                    q.push(to);
                }
            }
        }
    }

    int m; cin >> m;
    while (m --> 0) {
        int t, u, v; cin >> t >> u >> v; u--;--v;
        if (d[u][v] == inf) cout << 0 << endl;
        else if (t == 1) cout << 1 << endl;
        else cout << d[u][v] << endl;
    }
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}