#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#include <set>
#define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

// #define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end();

struct Quest {
    int id, s, t, type;
};

int n, d, G, Q;
vector<int> a;
vector<int> ans;
vector<vector<Quest>> qq;
vector<vector<int>> g;

void resize() {
    a.resize(n);
    qq.resize(n);
    g.resize(n, vector(n, INT_MAX));
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    cin >> n >> d >> G;
    resize();
    for (int i = 0; i < n; ++i) cin >> a[i];

    for (int i = n - 1; i >= 0; --i) {
        for (int t = i + 1; t < n; ++t) {
            if (a[t] < a[i]) continue;
            if (t - i <= d) {
                g[i][t] = 1;
                continue;
            }
            bool ok_fwd = true;
            int lst = i;
            for (int m = i + 1; m < t; ++m) {
                if (g[i][m] != INT_MAX && g[m][t] != INT_MAX) {
                    g[i][t] = min(g[i][t], g[i][m] + g[m][t]);
                }
                if (a[m] < a[i]) {
                    int dist = m - lst;
                    if (dist > d) {
                        ok_fwd = false;
                    }
                    lst = m;
                }
            }
            int dist = t - lst;
            if (dist > d) {
                ok_fwd = false;
            }
            if (ok_fwd) {
                g[i][t] = min(g[i][t], 1);
            }
        }
    }


    cin >> Q;

    for (int q = 0; q < Q; ++q) {
        int type, s, t;
        cin >> type >> s >> t;
        --s, --t;
        int dist = g[s][t];
        if (dist == INT_MAX) {
            cout << 0 << endl;
        } else {
            if (type == 1) {
                cout << 1 << endl;
            } else {
                cout << dist << endl;   
            }
        }
    }

    return 0;
}