#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;

typedef long double ld;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 5E3, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t MOD = 998244353, MOD_phi = MOD - 1;
struct Mod_int
{
	uint32_t val;
	Mod_int(uint64_t val = 0) :val(val% MOD) {}
	Mod_int operator+ (const Mod_int m) const
	{
		return val + m.val;
	}
	Mod_int operator+= (const Mod_int m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int m) const
	{
		return MOD - m.val + val;
	}
	Mod_int operator-= (const Mod_int m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int m) const
	{
		return uint64_t(val) * m.val;
	}
	Mod_int operator*= (const Mod_int m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step_val) const
	{
		Mod_int ans = 1, cur = *this;
		while (step_val > 0)
		{
			if (step_val & 1)
			{
				ans *= cur;
			}
			step_val >>= 1;
			cur *= cur;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int m) const
	{
		return *this * m.step(MOD_phi - 1);
	}
	Mod_int operator/= (const Mod_int m)
	{
		return *this = *this / m;
	}
};

int64_t dp[MAXN + 1][MAXN + 1];

void solve()
{
	int n;
	cin >> n;
	bool all_d0 = true;
	vector <int64_t> pref_d(n + 1), l(n + 1), r(n + 1);
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		pref_d[i + 1] = pref_d[i] + x;
		all_d0 &= x == 0;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i + 1];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> r[i + 1];
	}
	int a0, b0;
	cin >> a0 >> b0;
	l[0] = a0;
	r[0] = b0;

	if (all_d0)
	{
		vector <pair <int, int>> srt;
		multiset <int> val_b;
		for (int i = 0; i < n; i++)
		{
			srt.push_back({ l[i + 1], r[i + 1] });
			val_b.insert(r[i + 1]);
		}
		sort(ALL(srt));

		int ans = 0;
		for (int i = 0; i < srt.size(); i++)
		{
			val_b.erase(val_b.find(srt[i].second));
			rmax(ans, srt[i].first + *val_b.begin());
		}
		cout << ans;
	}
	else
	{
		for (int pos = 0; pos <= n; pos++)
		{
			for (int last_ch = 0; last_ch <= pos; last_ch++)
			{
				dp[pos][last_ch] = -INFl;
			}
		}
		dp[0][0] = b0;
		for (int pos = 0; pos < n; pos++)
		{
			for (int last_ch = 0; last_ch <= pos; last_ch++)
			{
				int64_t dop = pref_d[pos + 1] - pref_d[last_ch];
				rmax(dp[pos + 1][last_ch], min(r[pos + 1], dp[pos][last_ch] + pref_d[pos + 1] - pref_d[pos]));
				if (l[last_ch] + dop > l[pos + 1])
				{
					rmax(dp[pos + 1][pos + 1], dp[pos][last_ch] + pref_d[pos + 1] - pref_d[pos]);
				}
				else
					rmax(dp[pos + 1][last_ch], dp[pos][last_ch] + pref_d[pos + 1] - pref_d[pos]);
			}
		}

		int64_t ans = 0;
		for (int last_ch = 0; last_ch <= n; last_ch++)
		{
			int64_t dop = pref_d.back() - pref_d[last_ch];
			rmax(ans, l[last_ch] + dop + dp[n][last_ch]);
		}
		cout << ans;
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}