#include<bits/stdc++.h>
#define sz(a) (int)a.size()

using namespace std;

const int N = 3e5 + 10, INF = 1e8;
int n, d, G;

int t[4 * N], b[4 * N];

void push(int v, int l, int r) {
    t[v] += b[v];
    if (l + 1 != r) {
        b[2 * v + 1] += b[v];
        b[2 * v + 2] += b[v];
    }
    b[v] = 0;
}

void upd(int v, int l, int r, int ql, int qr, int x) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        b[v] += x;
        push(v, l, r);
        return;
    }
    if (ql >= r || qr <= l) {
        return;
    }
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, ql, qr, x);
    upd(2 * v + 2, m, r, ql, qr, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        return t[v];
    }
    if (ql >= r || qr <= l) {
        return -1;
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

void upd0(int v, int l, int r, int qi, int x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) {
        upd0(2 * v + 1, l, m, qi, x);
    }
    else {
        upd0(2 * v + 2, m, r, qi, x);
    }
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

int get0(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return t[v];
    }
    if (ql >= r || qr <= l) {
        return INF;
    }
    int m = (l + r) / 2;
    return min(get0(2 * v + 1, l, m, ql, qr), get0(2 * v + 2, m, r, ql, qr));
}

void solve1() {
    vector<int> a(n);
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int st = 0; st < n; ++st) {
        int last = st;
        for (int i = st + 1; i < n; ++i) {
            if (i - last > d) break;
            if (i - last <= d && a[i] > a[st]) {
                g[st].push_back(i);
            }
            if (a[i] < a[st]) {
                last = i;
            }
        }
    }
    vector<vector<int>> dp(n, vector<int> (n, INF));
    for (int st = 0; st < n; ++st) {
        dp[st][st] = 0;
        for (int i = st; i < n; ++i) {
            if (dp[st][i] == INF) continue;
            for (int j : g[i]) {
                dp[st][j] = min(dp[st][j], dp[st][i] + 1);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u;
        --v;
        if (dp[u][v] == INF) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        }
        else {
            cout << dp[u][v] << '\n';
        }
    }
}

signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    cin >> n >> d >> G;
    if (n <= 1000) {
        solve1();
        return 0;
    }
    vector<int> a(n), go(n);
    vector<pair<int, int>> A0;
    for (int i = 0; i < n; ++i) {
        go[i] = i;
        cin >> a[i];
        A0.push_back({a[i], i});
    }
    sort(A0.begin(), A0.end());
    set<int> s;
    s.insert(n);
    for (int i = 0; i <= n; ++i) {
        upd(0, 0, n + 1, i, i + 1, n - i);
    }
    for (int i = 0; i < n; ++i) {
        int id = A0[i].second;
        int nxt = (*s.lower_bound(id));
        int dl = nxt - id;
        auto it = s.lower_bound(id);
        int pre = 0;
        if (it != s.begin()) {
            --it;
            pre = (*it);
        }
        upd(0, 0, n + 1, pre, id, -dl);
        int L = i - 1, R = n;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            if (get(0, 0, n + 1, i, M + 1) <= d) {
                L = M;
            }
            else {
                R = M;
            }
        }
        go[id] = min(n - 1, L + 1 + d);
        s.insert(id);
    }
    reverse(A0.begin(), A0.end());
    fill(t, t + 4 * N, INF);
    for (int i = 0; i < n; ++i) {
        int cur = A0[i].second;
        if (cur == n - 1) {
            upd0(0, 0, n, cur, 0);
            continue;
        }
        int ans = get0(0, 0, n, cur, go[cur] + 1);
        if (ans == INF) continue;
        upd0(0, 0, n, cur, ans + 1);
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u;
        --v;
        int ret = get0(0, 0, n, u, u + 1);
        if (ret == INF) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        }
        else {
            cout << ret << '\n';
        }
    }
}
