#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9 + 7;

int n, d, g, q;
vector<int> lst;
vector<vector<int>> gr, ans;

template <typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << ' ';
    return out;
}

void djkstra(int s) {
    ans[s][s] = 0;
    set<pair<int, int>> q;
    q.emplace(0, s);

    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());

        for (auto u : gr[v]) {
            if (ans[s][v] + 1 < ans[s][u]) {
                q.erase({ans[s][u], u});
                ans[s][u] = ans[s][v] + 1;
                q.emplace(ans[s][u], u);
            }
        }
    }
}

void solve1() {
    for (int i = 0; i < n; i++) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (j - last > d) break;
            if (lst[j] < lst[i]) {
                last = j;
                continue;
            }

            gr[i].emplace_back(j);
        }
    }

    for (int i = 0; i < n; i++) djkstra(i);

    cin >> q;
    while (q--) {
        int t, a, b; cin >> t >> a >> b;
        int cur = ans[a - 1][b - 1];

        if (cur == INF) cout << 0 << endl;
        else {
            if (t == 1) cout << 1 << endl;
            else cout << cur << endl;
        }
    }
}

void solve2() {
    vector<int> dp(n, INF);
    dp[n - 1] = 0;

    for (int i = n - 1; i >= 0; i--) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (j - last > d) break;
            if (lst[j] < lst[i]) {
                last = j;
                continue;
            }

            dp[i] = min(dp[i], dp[j] + 1);
        }
    }

    cin >> q;
    while (q--) {
        int t, a, b; cin >> t >> a >> b;
        int cur = dp[a - 1];

        if (cur == INF) cout << 0 << endl;
        else {
            if (t == 1) cout << 1 << endl;
            else cout << cur << endl;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> d >> g;

    lst.resize(n);
    gr.resize(n);
    if (g <= 2) ans.assign(n, vector<int>(n, INF));

    for (int i = 0; i < n; i++) cin >> lst[i];

    if (g <= 2) solve1();
    else solve2();
}
