#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1, g;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int LG = 19, N = 1 << LG;

struct seg_tree_max {
	int st[2 * N]{};
	void set_element(int i, int v) {
		i += N - 1;
		st[i] = v;
		while (i) {
			i = (i - 1) / 2;
			st[i] = max(st[2 * i + 1], st[2 * i + 2]);
		}
	}
	int get_max(int l, int r) {
		l += N - 1;
		r += N - 1;
		int res = 0;
		while (l <= r) {
			if (~l & 1) {
				res = max(res, st[l++]);
			}
			if (r & 1) {
				res = max(res, st[r--]);
			}
			l = (l - 1) / 2;
			r = (r - 1) / 2;
		}
		return res;
	}
	int down_l(int l, int r, int v, int l1 = 0, int r1 = N - 1, int i = 0) {
		if (st[i] <= v) {
			return N;
		}
		if (l1 >= l && r1 <= r) {
			if (l1 == r1) {
				return l1;
			}
			if (st[2 * i + 1] > v) {
				return down_l(l, r, v, l1, (l1 + r1) / 2, 2 * i + 1);
			} else {
				return down_l(l, r, v, (l1 + r1) / 2 + 1, r1, 2 * i + 2);
			}
		}
		if (l1 > r || r1 < l) {
			return N;
		}
		int ans = down_l(l, r, v, l1, (l1 + r1) / 2, 2 * i + 1);
		if (ans == N) {
			return down_l(l, r, v, (l1 + r1) / 2 + 1, r1, 2 * i + 2);
		}
		return ans;
	}
	int down_r(int l, int r, int v, int l1 = 0, int r1 = N - 1, int i = 0) {
		if (st[i] <= v) {
			return -1;
		}
		if (l1 >= l && r1 <= r) {
			if (l1 == r1) {
				return l1;
			}
			if (st[2 * i + 2] > v) {
				return down_r(l, r, v, (l1 + r1) / 2 + 1, r1, 2 * i + 2);
			} else {
				return down_r(l, r, v, l1, (l1 + r1) / 2, 2 * i + 1);
			}
		}
		if (l1 > r || r1 < l) {
			return -1;
		}
		int ans = down_r(l, r, v, (l1 + r1) / 2 + 1, r1, 2 * i + 2);
		if (ans == -1) {
			return down_r(l, r, v, l1, (l1 + r1) / 2, 2 * i + 1);
		}
		return ans;
	}
};

struct seg_tree_min {
	int st[2 * N]{};
	void set_element(int i, int v) {
		i += N - 1;
		st[i] = v;
		while (i) {
			i = (i - 1) / 2;
			st[i] = min(st[2 * i + 1], st[2 * i + 2]);
		}
	}
	int get_min(int l, int r) {
		l += N - 1;
		r += N - 1;
		int res = INT32_MAX;
		while (l <= r) {
			if (~l & 1) {
				res = min(res, st[l++]);
			}
			if (r & 1) {
				res = min(res, st[r--]);
			}
			l = (l - 1) / 2;
			r = (r - 1) / 2;
		}
		return res;
	}
};

seg_tree_min clcc;
seg_tree_max clcto, sta;

int used[N], dd[N];

void dfs(int s, vector<vector<int>>& g) {
	used[s] = 1;
	for (int i : g[s]) {
		if (!used[i]) {
			dd[i] = dd[s] + 1;
			dfs(i, g);
		}
	}
}

void solve() {
	int n, d, gr;
	cin >> n >> d >> gr;
	vector<int> a(n), c(n), to(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		clcc.set_element(i, a[i]);
	}
	// cout << '\n';
	for (int i = 0; i < n; i++) {
		c[i] = clcc.get_min(i, min(i + d - 1, n - 1));
		clcto.set_element(i, c[i]);
		// cout << c[i] << ' ';
	}
	// cout << '\n';
	for (int i = 0; i < n; i++) {
		to[i] = clcto.down_l(i, n - 1, a[i]);
		to[i] += d - 1;
		to[i] = min(to[i], n - 1);
		// cout << to[i] << ' ';
	}
	// cout << '\n';
	if (gr < 3) {
		return;
		vector<vector<int>> g(n), dist(n, vector<int>(n, INT32_MAX / 2));
		for (int i = 0; i < n; i++) {
			dist[i][i] = 0;
			for (int j = i + 1; j <= to[i]; j++) {
				if (a[j] > a[i]) {
					// g[i].push_back(g[j]);
					dist[i][j] = 1;
				}
			}
		}
		for (int l = 0; l < n; l++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					dist[i][j] = min(dist[i][j], dist[i][l] + dist[l][j]);
				}
			}
		}
		int q;
		cin >> q;
		while (q--) {
			int t, u, v;
			cin >> t >> u >> v; u--; v--;
			if (t == 1) {
				if (dist[u][v] < N) {
					cout << "1\n";
				} else {
					cout << "0\n";
				}
			} else {
				if (dist[u][v] < N) {
					cout << dist[u][v] << '\n';
				} else {
					cout << "0\n";
				}
			}
		}
	} else {
		return;
		for (int i = 0; i < n; i++) {
			if (a[i] <= a[n - 1]) {
				sta.set_element(i, a[i]);
			} else {
				sta.set_element(i, -1);
			}
		}
		vector<int> a_obr(n + 1);
		for (int i = 0; i < n; i++) {
			a_obr[a[i]] = i;
			dd[i] = INT32_MAX / 2;
		}
		dd[n - 1] = 0;
		vector<vector<int>> g(n);
		for (int i = 0; i < n; i++) {
			int t = a_obr[sta.get_max(i, to[i])];
			if (a[t] > a[i]) {
				g[t].push_back(i);
			}
		}
		return;
		dfs(n - 1, g);
		int q;
		cin >> q;
		while (q--) {
			int t, u, v;
			cin >> t >> u >> v; u--; v--;
			if (t == 1) {
				if (dd[u] < N) {
					cout << "1\n";
				} else {
					cout << "0\n";
				}
			} else {
				if (dd[u] < N) {
					cout << dd[u] << '\n';
				} else {
					cout << "0\n";
				}
			}
		}
	}
}