#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

struct SegTree {
    int n;
    vector<int> t;
    void build(int p, int l, int r, vector<int>& dat) {
        if (l + 1 == r) {
            t[p] = dat[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * p + 1, l, mid, dat);
        build(2 * p + 2, mid, r, dat);
        t[p] = max(t[2 * p + 1], t[2 * p + 2]);
    }
    SegTree(vector<int>& dat) {
        n = (int)dat.size();
        t.resize(4 * n);
        build(0, 0, n, dat);
    }
    int find(int p, int l, int r, int i, int x) {
        if (r <= i || t[p] < x) return -1;
        if (l + 1 == r) return l;
        int mid = (l + r) / 2;
        int left = find(2 * p + 1, l, mid, i, x);
        if (left != -1) return left;
        return find(2 * p + 2, mid, r, i, x);
    }
    int find(int i, int x) {
        if (i >= n) return -1;
        return find(0, 0, n, i, x);
    }
};

void solve() {
    int n, d, g; cin >> n >> d >> g;
    d = min(n, d);
    vector<int> a(n); cin >> a;
    vector<int> b(n, 0);
    vector<pair<int, int>> c(n, {0, 0});
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        st.emplace(a[i], i);
        if (i >= d) {
            st.erase({a[i - d], i - d});
        }
        if ((int)st.size() == d) {
            b[i] = (*st.begin()).first;
            c[i] = (*--st.end());
        }
    }
    SegTree tr(b);
    int q; cin >> q;
    for (int _ = 0; _ < q; ++_) {
        int t, u, v; cin >> t >> u >> v;
        --u, --v;
        if (a[u] > a[v]) {
            cout << "0\n";
            continue;
        }
        int cnt = 0;
        while (true) {
            int pl = tr.find(u + d, a[u]); cnt++;
            if (pl == -1 || pl >= v || v - u <= d) break;
            u = c[pl].second;
        }
        cout << (t == 1 ? 1: cnt) << '\n';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/c.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}