#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

struct SSegTree {
    int n;
    vector<pair<int, int>> t;
    void build(int p, int l, int r, vector<int>& dat) {
        if (l + 1 == r) {
            t[p] = {dat[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build(2 * p + 1, l, mid, dat);
        build(2 * p + 2, mid, r, dat);
        t[p] = max(t[2 * p + 1], t[2 * p + 2]);
    }
    SSegTree(vector<int>& dat) {
        n = (int)dat.size();
        t.resize(4 * n);
        build(0, 0, n, dat);
    }
    pair<int, int> get(int p, int l, int r, int a, int b) {
        if (l >= b || r <= a) return {0, -1};
        if (a <= l && r <= b) return t[p];
        int mid = (l + r) / 2;
        return max(get(2 * p + 1, l, mid, a, b), get(2 * p + 2, mid, r, a, b));
    }
    pair<int, int> get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

struct SegTree {
    int n;
    vector<int> t;
    void build(int p, int l, int r, vector<int>& dat) {
        if (l + 1 == r) {
            t[p] = dat[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * p + 1, l, mid, dat);
        build(2 * p + 2, mid, r, dat);
        t[p] = max(t[2 * p + 1], t[2 * p + 2]);
    }
    SegTree(vector<int>& dat) {
        n = (int)dat.size();
        t.resize(4 * n);
        build(0, 0, n, dat);
    }
    int find(int p, int l, int r, int i, int x) {
        if (r <= i || t[p] < x) return -1;
        if (l + 1 == r) return l;
        int mid = (l + r) / 2;
        int left = find(2 * p + 1, l, mid, i, x);
        if (left != -1) return left;
        return find(2 * p + 2, mid, r, i, x);
    }
    int find(int i, int x) {
        if (i >= n) return -1;
        return find(0, 0, n, i, x);
    }
};

void solve() {
    int n, d, g; cin >> n >> d >> g;
    d = min(n, d);
    vector<int> a(n); cin >> a;
    vector<int> b(n, 0);
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        st.emplace(a[i], i);
        if (i >= d) {
            st.erase({a[i - d], i - d});
        }
        if ((int)st.size() == d) {
            b[i] = (*st.begin()).first;
        }
    }
    SegTree tr(b);
    SSegTree trr(a);
    vector<int> idx(n, 0);
    for (int u = n - 2; u >= 0; --u) {
        int pl = tr.find(u + d, a[u]);
        if (pl == -1 || pl >= n - 1 || n - 1 - u <= d) idx[u] = 1;
        else idx[u] = idx[trr.get(u + 1, pl + 1).second] + 1;
    }
    int q; cin >> q;
    for (int _ = 0; _ < q; ++_) {
        int t, u, v; cin >> t >> u >> v;
        --u, --v;
        if (a[u] > a[v]) {
            cout << "0\n";
            continue;
        }
        if (g <= 1) {
            int cnt = 0;
            bool flag = true;
            while (true) {
                int pl = tr.find(u + d, a[u]); cnt++;
                if (pl == -1 || pl >= v) break;
                int opt = u;
                for (int j = u + 1; j <= pl; ++j) {
                    if (a[j] < a[v] && a[opt] < a[j]) opt = j;
                }
                if (opt == u) {
                    cout << "0\n";
                    flag = false;
                    break;
                }
                u = opt;
            }
            if (flag) {
                cout << (t == 1 ? 1: cnt) << '\n';
            }
            continue;
        }
        cout << (t == 1 ? 1: idx[u]) << '\n';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/c.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}