#include<bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl "\n"
typedef long long ll;
using namespace std;

const int INF = 1e9;

struct ST {
    int sz = 1;
    vector<int> tree;

    ST(int n) {
        while (sz < n) sz *= 2;
        tree.resize(sz * 2, INF);
    }

    void update(int v, int val) {
        tree[v += sz] = val;
        while (v /= 2) {
            tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
        }
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl >= l && tr <= r) return tree[v];
        if (tl > r || tr < l) return INF;

        int m = (tl + tr) / 2;

        int ls = get(v * 2, tl, m, l, r);
        int rs = get(v * 2 + 1, m + 1, tr, l, r);
        return min(ls, rs);
    }
};


struct ST2 {
    int sz = 1;
    vector<int> tree;

    ST2(int n) {
        while (sz < n) sz *= 2;
        tree.resize(sz * 2);
    }

    void update(int v, int val) {
        tree[v += sz] = val;
        while (v /= 2) {
            tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
        }
    }

    ll get(int v, int tl, int tr, int l, int r) {
        if (tl >= l && tr <= r) return tree[v];
        if (tl > r || tr < l) return 0;

        int m = (tl + tr) / 2;

        ll ls = get(v * 2, tl, m, l, r);
        ll rs = get(v * 2 + 1, m + 1, tr, l, r);
        return max(ls, rs);
    }
};

void solve(int n, int d) {
    vector<int> a(n), len(n);

    for (int i = 0; i < n; i++) cin >> a[i];

    ST mn(n + 1);
    ST2 up(n);

    set<int> s;
    for (int i = n - 1; i >= 0; i--) {
        s.insert(a[i]);
        if (n - i > d) s.erase(a[i + d]);

        int k = mn.get(1, 0, mn.sz - 1, a[i], n);
        len[i] = min(n - 1, k);
        up.update(i, len[i]);

        if (n - i >= d) mn.update(*s.begin(), i + d - 1);
    }

    int q;
    cin >> q;

    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;

        u--;
        v--;

        int ans = 0, rt = u;

        while (rt < v) {
            ans++;
            int rt2 = up.get(1, 0, up.sz - 1, u, rt);

            if (rt2 == rt) {
                ans = -1;
                break;
            }

            rt = rt2;
        }

        if (t == 1) {
            if (a[u] < a[v]) cout << 1 << endl;
            else cout << 0 << endl;
        }

        else if (ans == -1 || a[u] >= a[v]) cout << 0 << endl;
        else cout << ans << endl;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, g, d;
    cin >> n >> d >> g;

    solve(n, d);
}
