#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

struct SegTree {
    int sz;
    vector<int> st;
    SegTree (int num) {
        sz = num;
        st.assign(4 * sz, 0);
    }
    void upd(int v, int l, int r, int ind, int val) {
        if (ind < l || r <= ind) return;
        if (l + 1 == r) {
            st[v] = val;
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * v, l, m, ind,val);
        upd(2 * v + 1, m, r, ind, val);
        st[v] = st[2 * v] + st[2 * v + 1];
    }
    int rsq(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return st[v];
        }
        int m = (l + r) >> 1;
        return rsq(2 * v, l, m, ql, qr) + 
        rsq(2 * v + 1, m, r, ql, qr);
    }
    int kth_one(int v, int l, int r, int k) {
        if (l + 1 == r) {
            return l;
        }
        int m = (l + r) >> 1;
        if (st[2 * v] <= k) {
            return kth_one(2 * v + 1, m, r, k - st[2 * v]);
        }
        return kth_one(2 * v, l, m, k);
    }
    int kth_one(int k) {
        if (k > st[1]) return -1;
        if (k == st[1]) return sz;
        return kth_one(1, 0, sz, k);
    }
    int rsq(int ql, int qr) {
        return rsq(1, 0, sz, ql, qr);
    }
    void upd(int ind, int val) {
        upd(1, 0, sz, ind, val);
    }
}; 

struct DSU {
    int sz;
    vector<int> szs, mxs, par;

    DSU(int num) {
        sz = num;
        szs.assign(sz, 1);
        mxs.resize(sz); par.resize(sz);
        for (int i = 0; i < sz; ++i) {
            mxs[i] = par[i] = i;
        }
    }
    int find_par(int v) {
        if (par[v] == v) return v;
        return par[v] = find_par(par[v]);
    }
    void unite(int u, int v) {
        u = find_par(u);
        v = find_par(v);
        if (u == v) return;
        if (szs[v] > szs[u]) {
            swap(u, v);
        }
        szs[u] += szs[v];
        mxs[u] = max(mxs[u], mxs[v]);
        par[v] = u;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);

    // SegTree st(10);
    // st.upd(3, 1);
    // st.upd(5, 1);
    // cout << st.kth_one(1) << endl;
    
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    vector<int> ord(n);
    iota(in(ord), 0);
    sort(in(ord), [&](int i, int j) { return a[i] < a[j]; });
    SegTree st(n);
    vector<int> diap(n, d);

    DSU dsu(n);

    for (int z = 0; z < n; ++z) {
        int u = ord[z];
        int kth = st.rsq(0, u + 1);
        int nxt = st.kth_one(kth);
        if (nxt < n && nxt - u <= d) {
            dsu.unite(u, nxt);
        }
        if (kth - 1 >= 0) {
            int prev = st.kth_one(kth - 1);
            if (u - prev <= d) {
                dsu.unite(u, prev);
            }
        }
        diap[u] = min(dsu.mxs[dsu.find_par(u)] + d + 1, n);
    }
    int q;
    cin >> q;
    //vector<vector<tuple<int, int, int>>> mem(n);
    //vector<int> ans(q);
    for (int qry = 0; qry < q; ++qry) {
        int tp, u, v;
        cin >> tp >> u >> v, --u, --v;
        //mem[u].emplace_back(tp, v, qry);
        if (v < u || a[v] < a[u]) {
            cout << 0 << '\n';
            continue;
        }
        int i = u;
        int num = 1;
        while (diap[i] < v) {
            int best = i + 1;
            for (int j = i + 1; j < diap[i]; ++j) {
                if (a[j] > a[best]) {
                    best = j;
                }
            }
            i = best;
            num += 1;
        }
        if (tp == 1) {
            cout << "1" << '\n';
        }
        else {
            cout << num << '\n';
        }
    }
    return 0;
}