#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

struct SegTree {
    int sz;
    vector<int> st;
    SegTree (int num) {
        sz = num;
        st.assign(4 * sz, 0);
    }
    void upd(int v, int l, int r, int ind, int val) {
        if (ind < l || r <= ind) return;
        if (l + 1 == r) {
            st[v] = val;
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * v, l, m, ind,val);
        upd(2 * v + 1, m, r, ind, val);
        st[v] = st[2 * v] + st[2 * v + 1];
    }
    int rsq(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return st[v];
        }
        int m = (l + r) >> 1;
        return rsq(2 * v, l, m, ql, qr) + 
        rsq(2 * v + 1, m, r, ql, qr);
    }
    int kth_one(int v, int l, int r, int k) {
        if (l + 1 == r) {
            return l;
        }
        int m = (l + r) >> 1;
        if (st[2 * v] <= k) {
            return kth_one(2 * v + 1, m, r, k - st[2 * v]);
        }
        return kth_one(2 * v, l, m, k);
    }
    int kth_one(int k) {
        if (k > st[1]) return -1;
        if (k == st[1]) return sz;
        return kth_one(1, 0, sz, k);
    }
    int rsq(int ql, int qr) {
        return rsq(1, 0, sz, ql, qr);
    }
    void upd(int ind, int val) {
        upd(1, 0, sz, ind, val);
    }
}; 

struct DSU {
    int sz;
    vector<int> szs, mxs, par;

    DSU(int num) {
        sz = num;
        szs.assign(sz, 1);
        mxs.resize(sz); par.resize(sz);
        for (int i = 0; i < sz; ++i) {
            mxs[i] = par[i] = i;
        }
    }
    int find_par(int v) {
        if (par[v] == v) return v;
        return par[v] = find_par(par[v]);
    }
    void unite(int u, int v) {
        u = find_par(u);
        v = find_par(v);
        if (u == v) return;
        if (szs[v] > szs[u]) {
            swap(u, v);
        }
        szs[u] += szs[v];
        mxs[u] = max(mxs[u], mxs[v]);
        par[v] = u;
    }
};

struct SegTree2 {
    int sz;
    vector<int> a;
    vector<pair<int, int>> st;

    SegTree2 (vector<int> _a) : a(_a) {
        sz = a.size();
        st.assign(4 * sz, {0, 0});
        build(1, 0, sz);
    }
    void build(int v, int l, int r) {
        if (l + 1 == r) {
            st[v] = {a[l], l};
            return;
        }
        int m = (l + r) >> 1;
        build(2 * v, l, m);
        build(2 * v + 1,m, r);
        st[v] = max(st[2 * v], st[2 * v + 1]);
    }
    pair<int, int> rmq(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return {-1, -1};
        }
        if (ql <= l && r <= qr) {
            return st[v];
        }
        int m = (l + r) >> 1;
        return max(rmq(2 * v, l, m, ql, qr),
        rmq(2 * v + 1, m, r, ql, qr));
    }
    int rmq(int ql, int qr) {
        return rmq(1, 0, sz, ql, qr).second;
    }
};

int n, d, g;

void solve3() {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    
    vector<int> ord(n);
    iota(in(ord), 0);
    sort(in(ord), [&](int i, int j) { return a[i] < a[j]; });
    SegTree st(n);
    vector<int> diap(n, d);

    DSU dsu(n);

    const int oo = 1e9;

    vector<int> suc(n);
    
    vector<int> to_last(n);
    
    SegTree2 st2(a);

    for (int z = 0; z < n; ++z) {
        int u = ord[z];
        int kth = st.rsq(0, u + 1);
        int nxt = st.kth_one(kth);
        if (nxt < n && nxt - u <= d) {
            dsu.unite(u, nxt);
        }
        if (kth - 1 >= 0) {
            int prev = st.kth_one(kth - 1);
            if (u - prev <= d) {
                dsu.unite(u, prev);
            }
        }
        diap[u] = min(dsu.mxs[dsu.find_par(u)] + d + 1, n);
        st.upd(u, 1);
        suc[u] = st2.rmq(u + 1, diap[u]);
        
    }



    int q;
    cin >> q;
    //vector<vector<tuple<int, int, int>>> mem(n);
    //vector<int> ans(q);
    for (int i = 0; i < n; ++i) {
        debug << diap[i] << ' ';
    }
    debug << endl;

    struct block {
        vector<pair<int, int>> elems;
    };

    vector<int> mem(n, -1);
    function<void(int)> Dfs = [&](int v) {
        if (mem[v] != -1) return;
        if (v == n - 1) {
            mem[v] = 0;
            return;
        }
        Dfs(suc[v]);
        mem[v] = mem[suc[v]] + 1;
    };
    for (int i = 0; i < n; ++i) {
        Dfs(i);
    }

    for (int qry = 0; qry < q; ++qry) {
        int tp, u, v;
        cin >> tp >> u >> v, --u, --v;
        
        //mem[u].emplace_back(tp, v, qry);
        if (v < u || a[v] < a[u]) {
            cout << 0 << '\n';
            continue;
        }
        
        // int i = u;
        // int num = 1;
        // debug << u << " -> " << v << ":\n";
        // while (diap[i] <= v) {
        //     debug << i << ' ';
        //     int best = -1;
        //     // for (int j = i + 1; j < diap[i]; ++j) {
        //     //     if (a[j] < a[v] && (best == -1 || a[j] > a[best])) {
        //     //         best = j;
        //     //     }
        //     // }
        //     best = suc[i]; //Qry(i + 1, diap[i], a[v]);
        //     if (best == -1 || a[best] < a[i]) {
        //         break;
        //     }
        //     i = best;
        //     num += 1;
        // }
        // debug << endl;

        if (tp == 1) {
            cout << "1" << '\n';
        }
        else {
            cout << mem[u] << '\n';
        }
        
    }
}

void solve5() {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    
    vector<int> ord(n);
    iota(in(ord), 0);
    sort(in(ord), [&](int i, int j) { return a[i] < a[j]; });
    SegTree st(n);
    vector<int> diap(n, d);

    DSU dsu(n);

    const int oo = 1e9;

    for (int z = 0; z < n; ++z) {
        int u = ord[z];
        int kth = st.rsq(0, u + 1);
        int nxt = st.kth_one(kth);
        if (nxt < n && nxt - u <= d) {
            dsu.unite(u, nxt);
        }
        if (kth - 1 >= 0) {
            int prev = st.kth_one(kth - 1);
            if (u - prev <= d) {
                dsu.unite(u, prev);
            }
        }
        diap[u] = min(dsu.mxs[dsu.find_par(u)] + d + 1, n);
        st.upd(u, 1);
       
    }
    int q;
    cin >> q;
    //vector<vector<tuple<int, int, int>>> mem(n);
    //vector<int> ans(q);
    for (int i = 0; i < n; ++i) {
        debug << diap[i] << ' ';
    }
    debug << endl;

    struct block {
        vector<pair<int, int>> elems;
    };
    const int K = 333;
    vector<block> blocks((n + K - 1) / K);
    for (int bl = 0; bl < (int)blocks.size(); ++bl) {
        int l = bl * K;
        int r = min((bl + 1) * K, n);
        for (int i = l; i < r; ++i) {
            blocks[bl].elems.push_back({a[i], i});
        }
        sort(in(blocks[bl].elems));
    }

    auto Qry = [&](int l, int r, int key) {
        pair<int, int> res = {-1, -1};
        while (l % K != 0 && l < r) {
            if (a[l] < key && (res.first == -1 || a[l] > res.first)) {
                res = {a[l], l};
            }
            l += 1;
        }
        while (l + K <= r) {
            int ind = lower_bound(in(blocks[l / K].elems), pair<int, int>(key, -1)) - blocks[l / K].elems.begin();
            if (ind - 1 >= 0) {
                res = max(res, blocks[l / K].elems[ind - 1]);
            }
            l += K;
        }
        while (l < r) {
            if (a[l] < key && (res.first == -1 || a[l] > res.first)) {
                res = {a[l], l};
            }
            l += 1;
        }
        return res.second;
    };



    vector<int> suc(n);
    for (int i = 0; i < n; ++i) {
        suc[i] = Qry(i + 1, diap[i], a[n - 1]);
        if (suc[i] != -1) {
            if (a[suc[i]] > a[n - 1]) {
                suc[i] = -1;
            }
        }
    }

    vector<int> mem(n, -2);
    function<void(int)> Dfs = [&](int v) {
        if (mem[v] != -2) return;
        if (v == n - 1) {
            mem[v] = 0;
            return;
        }
        if (suc[v] == -1) {
            mem[v] = -1;
            return;
        }
        Dfs(suc[v]);
        if (mem[suc[v]] == -1) {
            mem[v] = -1;
            return;
        }
        mem[v] = mem[suc[v]] + 1;
    };
    for (int i = 0; i < n; ++i) {
        Dfs(i);
    }

    for (int qry = 0; qry < q; ++qry) {
        int tp, u, v;
        cin >> tp >> u >> v, --u, --v;
        
        //mem[u].emplace_back(tp, v, qry);
        if (v < u || a[v] < a[u]) {
            cout << 0 << '\n';
            continue;
        }
        
        // int i = u;
        // int num = 1;
        // debug << u << " -> " << v << ":\n";
        // while (diap[i] <= v) {
        //     debug << i << ' ';
        //     int best = -1;
        //     // for (int j = i + 1; j < diap[i]; ++j) {
        //     //     if (a[j] < a[v] && (best == -1 || a[j] > a[best])) {
        //     //         best = j;
        //     //     }
        //     // }
        //     best = Qry(i + 1, diap[i], a[v]);
        //     if (best == -1 || a[best] < a[i]) {
        //         break;
        //     }
        //     i = best;
        //     num += 1;
        // }
        // debug << endl;

        if (mem[u] == -1) {
            cout << "0\n";
            continue;
        }
        if (tp == 1) {
            cout << "1" << '\n';
        }
        else {
            cout << mem[u] << '\n';
        }
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    // SegTree st(10);
    // st.upd(3, 1);
    // st.upd(5, 1);
    // cout << st.kth_one(1) << endl;
    
    // int n, d, g;
    cin >> n >> d >> g;
    if (g == 3) {
        solve3();
        return 0;
    }
    if (g == 5) {
        solve5();
        return 0;
    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    
    vector<int> ord(n);
    iota(in(ord), 0);
    sort(in(ord), [&](int i, int j) { return a[i] < a[j]; });
    SegTree st(n);
    vector<int> diap(n, d);

    DSU dsu(n);

    const int oo = 1e9;

    for (int z = 0; z < n; ++z) {
        int u = ord[z];
        int kth = st.rsq(0, u + 1);
        int nxt = st.kth_one(kth);
        if (nxt < n && nxt - u <= d) {
            dsu.unite(u, nxt);
        }
        if (kth - 1 >= 0) {
            int prev = st.kth_one(kth - 1);
            if (u - prev <= d) {
                dsu.unite(u, prev);
            }
        }
        diap[u] = min(dsu.mxs[dsu.find_par(u)] + d + 1, n);
        st.upd(u, 1);
       
    }
    int q;
    cin >> q;
    //vector<vector<tuple<int, int, int>>> mem(n);
    //vector<int> ans(q);
    for (int i = 0; i < n; ++i) {
        debug << diap[i] << ' ';
    }
    debug << endl;

    struct block {
        vector<pair<int, int>> elems;
    };
    const int K = 333;
    vector<block> blocks((n + K - 1) / K);
    for (int bl = 0; bl < (int)blocks.size(); ++bl) {
        int l = bl * K;
        int r = min((bl + 1) * K, n);
        for (int i = l; i < r; ++i) {
            blocks[bl].elems.push_back({a[i], i});
        }
        sort(in(blocks[bl].elems));
    }

    auto Qry = [&](int l, int r, int key) {
        pair<int, int> res = {-1, -1};
        while (l % K != 0 && l < r) {
            if (a[l] < key && (res.first == -1 || a[l] > res.first)) {
                res = {a[l], l};
            }
            l += 1;
        }
        while (l + K <= r) {
            int ind = lower_bound(in(blocks[l / K].elems), pair<int, int>(key, -1)) - blocks[l / K].elems.begin();
            if (ind - 1 >= 0) {
                res = max(res, blocks[l / K].elems[ind - 1]);
            }
            l += K;
        }
        while (l < r) {
            if (a[l] < key && (res.first == -1 || a[l] > res.first)) {
                res = {a[l], l};
            }
            l += 1;
        }
        return res.second;
    };


    for (int qry = 0; qry < q; ++qry) {
        int tp, u, v;
        cin >> tp >> u >> v, --u, --v;
        
        //mem[u].emplace_back(tp, v, qry);
        if (v < u || a[v] < a[u]) {
            cout << 0 << '\n';
            continue;
        }
        
        int i = u;
        int num = 1;
        debug << u << " -> " << v << ":\n";
        while (diap[i] <= v) {
            debug << i << ' ';
            int best = -1;
            // for (int j = i + 1; j < diap[i]; ++j) {
            //     if (a[j] < a[v] && (best == -1 || a[j] > a[best])) {
            //         best = j;
            //     }
            // }
            best = Qry(i + 1, diap[i], a[v]);
            if (best == -1 || a[best] < a[i]) {
                break;
            }
            i = best;
            num += 1;
        }
        debug << endl;

        if (diap[i] <= v) {
            cout << "0\n";
            continue;
        }
        if (tp == 1) {
            cout << "1" << '\n';
        }
        else {
            cout << num << '\n';
        }
    }
    return 0;
}