#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

const ll INF = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct segment_tree_max {
	vector<ll> tree;
	ll size;
	segment_tree_max(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2, 0);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		ll mid = (l + r) / 2;
		return max(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
	}
	void set(ll x, ll y) {
		set(1, 0, size, x, y);
	}
	void set(ll v, ll l, ll r, ll x, ll y) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v] = y;
			return;
		}
		ll mid = (l + r) / 2;
		set(v * 2, l, mid, x, y);
		set(v * 2 + 1, mid, r, x, y);
		tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
	}
};

struct segment_tree_min {
	vector<ll> tree;
	ll size;
	segment_tree_min(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2, INF);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return INF;
		}
		ll mid = (l + r) / 2;
		return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
	}
	void set(ll x, ll y) {
		set(1, 0, size, x, y);
	}
	void set(ll v, ll l, ll r, ll x, ll y) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v] = y;
			return;
		}
		ll mid = (l + r) / 2;
		set(v * 2, l, mid, x, y);
		set(v * 2 + 1, mid, r, x, y);
		tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
	}
};

void solve() {
	ll n, d, g;
	cin >> n >> d >> g;
	vector<ll> a(n);
	vector<ll> w(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		w[a[i]] = i;
	}
	set<pair<ll, ll>> now;
	vector<ll> jump(n, 0);
	now.emplace(0, n);
	now.emplace(n, n);
	for (ll i = 0; i < n; i++) {
		ll j = w[i];
		auto it = now.lower_bound(make_pair(j + 1, 0));
		if (it != now.begin()) {
			it--;
			if (it->second > j) {
				auto[nl, nr] = *it;
				now.erase(it);
				if (j - nl >= d) {
					now.emplace(nl, j);
				}
				if (nr - (j + 1) >= d) {
					now.emplace(j + 1, nr);
				}
			}
		}
		it = now.lower_bound(make_pair(j, 0));
		jump[i] = min(n, it->first + d);
	}
	ll q;
	cin >> q;
	vector<vector<pair<ll, ll>>> qs(n);
	vector<ll> ans(q, 0);
	vector<ll> t(q);
	for (ll i = 0; i < q; i++) {
		ll u, v;
		cin >> t[i] >> u >> v;
		t[i]--;
		u--;
		v--;
		if (a[u] <= a[v]) {
			qs[a[v]].emplace_back(u, i);
		}
	}
	if (g == 7 || g == 6) {
		ll mc = 150;
		segment_tree_max st(n);
		for (ll i = 0; i < n; i++) {
			ll j = w[i];
			st.set(j, jump[i]);
			for (auto[u, k] : qs[i]) {
				ll ost = mc;
				ll nr = u + 1;
				while (ost && nr <= j) {
					ll x = st.get(u, nr);
					if (x == nr) {
						break;
					}
					ans[k]++;
					nr = x;
					ost--;
				}
				if (nr <= j) {
					ans[k] = 0;
				}
			}
		}
	} else {
		segment_tree_min st(n);
		vector<ll> dp(n, 0);
		for (ll i = 0; i < n; i++) {
			ll j = w[i];
			st.set(j, jump[i]);
			if (qs[i].empty()) {
				continue;
			}
			vector<ll> need;
			for (ll k = 0; k < n; k++) {
				if (a[k] <= i && k != j) {
					st.set(k, INF);
					need.push_back(k);
				}
			}
			st.set(j, 0);
			reverse(need.begin(), need.end());
			for (auto k : need) {
				st.set(k, st.get(k, jump[a[k]]) + 1);
			}
			for (auto[u, k] : qs[i]) {
				ans[k] = st.get(u, u + 1);
				if (ans[k] >= INF) {
					ans[k] = 0;
				}
			}
		}
	}
	for (ll i = 0; i < q; i++) {
		if (!t[i]) {
			assign_min(ans[i], 1ll);
		}
		cout << ans[i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
