#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

const ll INF = 1'000'000'000, K = 50;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct segment_tree {
	vector<pair<ll, ll>> tree;
	ll size;
	segment_tree(ll n = 0) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2, make_pair(0, 0));
		for (ll i = 0; i < size; i++) {
			tree[i + size].second = i;
		}
	}
	pair<ll, ll> get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	pair<ll, ll> get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return make_pair(0ll, 0ll);
		}
		ll mid = (l + r) / 2;
		return max(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
	}
	void set(ll x, ll y) {
		set(1, 0, size, x, y);
	}
	void set(ll v, ll l, ll r, ll x, ll y) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v].first = y;
			return;
		}
		ll mid = (l + r) / 2;
		set(v * 2, l, mid, x, y);
		set(v * 2 + 1, mid, r, x, y);
		tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
	}
};

struct sqrt_dec {
	vector<pair<ll, ll>> b;
	segment_tree st;
	vector<pair<ll, ll>> dp, dppref;
	vector<ll> prefj, j;
	sqrt_dec(ll n = 0) {
		st = segment_tree(n);
		dp.resize(n, make_pair(0, INF));
		dppref.resize(n, make_pair(0, INF));
		prefj.resize(n, 0);
		j.resize(n, 0);
		ll nl = 0;
		for (ll i = 0; i < n; i++) {
			if (i - nl + 1 == K || i == n - 1) {
				b.emplace_back(nl, i);
				nl = i + 1;
			}
		}
	}
	void upd(ll x, ll y) {
		st.set(x, y);
		j[x] = y;
		for (ll i = 0; i < b.size(); i++) {
			if (b[i].first <= x && x <= b[i].second) {
				recalc(i);
			}
		}
	}
	void recalc(ll k) {
		for (ll i = b[k].second; i >= b[k].first; i--) {
			if (j[i] == 0) {
				dp[i] = make_pair(0, INF);
				continue;
			}
			if (j[i] > b[k].second) {
				dp[i] = make_pair(j[i], 1);
			} else {
				ll x = st.get(i, j[i]).second;
				dp[i] = dp[x];
				dp[i].second++;
			}
		}
		dppref[b[k].first] = dp[b[k].first];
		prefj[b[k].first] = j[b[k].first];
		for (ll i = b[k].first; i <= b[k].second; i++) {
			if (i != b[k].first) {
				prefj[i] = prefj[i - 1];
				dppref[i] = dppref[i - 1];
			}
			assign_max(prefj[i], j[i]);
			if (dp[i].second < dppref[i].second) {
				dppref[i] = dp[i];
			}
			if (dp[i].second == dppref[i].second) {
				assign_max(dppref[i], dp[i]);
			}
		}
	}
	ll get(ll l, ll r) {
		ll nb = 0;
		while (nb < b.size() && b[nb].first <= l) {
			nb++;
		}
		ll na = 0;
		ll nr = l + 1;
		if (b[nb - 1].second < r) {
			na = dp[l].second;
			nr = dp[l].first;
		}
		bool bbb = true;
		while (nb < b.size() && b[nb].second < r) {
			if (nr > r) {
				return na;
			}
			na++;
			ll nnr = nr;
			if (bbb) {
				for (ll i = l; i < b[nb].first; i++) {
					assign_max(nr, j[i]);
				}
			}
			bbb = false;
			while (b[nb].second < nnr) {
				assign_max(nr, prefj[b[nb].second]);
				nb++;
			}
			if (nnr > b[nb].first) {
				assign_max(nr, prefj[nnr - 1]);
			}
			if (b[nb].second < r && nr <= b[nb].second && nr > b[nb].first) {
				na += dppref[nr - 1].second;
				nr = dppref[nr - 1].first;
			}
			if (nr == nnr) {
				return 0;
			}
		}
		while (nr <= r) {
			na++;
			ll onr = nr;
			nr = st.get(l, nr).first;
			if (nr == onr) {
				return 0;
			}
		}
		return na;
	}
};

void solve() {
	ll n, d, g;
	cin >> n >> d >> g;
	vector<ll> a(n);
	vector<ll> w(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		w[a[i]] = i;
	}
	set<pair<ll, ll>> now;
	vector<ll> jump(n, 0);
	now.emplace(0, n);
	now.emplace(n, n);
	for (ll i = 0; i < n; i++) {
		ll j = w[i];
		auto it = now.lower_bound(make_pair(j + 1, 0));
		if (it != now.begin()) {
			it--;
			if (it->second > j) {
				auto[nl, nr] = *it;
				now.erase(it);
				if (j - nl >= d) {
					now.emplace(nl, j);
				}
				if (nr - (j + 1) >= d) {
					now.emplace(j + 1, nr);
				}
			}
		}
		it = now.lower_bound(make_pair(j, 0));
		jump[i] = min(n, it->first + d);
	}
	ll q;
	cin >> q;
	vector<vector<pair<ll, ll>>> qs(n);
	vector<ll> ans(q, 0);
	vector<ll> t(q);
	for (ll i = 0; i < q; i++) {
		ll u, v;
		cin >> t[i] >> u >> v;
		t[i]--;
		u--;
		v--;
		if (a[u] <= a[v]) {
			qs[a[v]].emplace_back(u, i);
		}
	}
	if (g == 7 || g == 6) {
		ll mc = 150;
		segment_tree st(n);
		for (ll i = 0; i < n; i++) {
			ll j = w[i];
			st.set(j, jump[i]);
			for (auto[u, k] : qs[i]) {
				ll ost = mc;
				ll nr = u + 1;
				while (ost && nr <= j) {
					ll x = st.get(u, nr).first;
					if (x == nr) {
						break;
					}
					ans[k]++;
					nr = x;
					ost--;
				}
				if (nr <= j) {
					ans[k] = 0;
				}
			}
		}
	} else {
		if (g > 0 && g < 6) {
			segment_tree st(n);
			vector<ll> dp(n, INF);
			for (ll i = 0; i < n; i++) {
				ll j = w[i];
				st.set(j, jump[i]);
				if (qs[i].empty()) {
					continue;
				}
				vector<ll> need;
				for (ll k = 0; k < n; k++) {
					if (a[k] <= i) {
						dp[k] = INF;
						if (k < j) {
							need.push_back(k);
						}
					}
				}
				dp[j] = 0;
				reverse(need.begin(), need.end());
				for (auto k : need) {
					ll x = st.get(k, jump[a[k]]).second;
					assign_min(x, j);
					dp[k] = dp[x] + 1;
				}
				for (auto[u, k] : qs[i]) {
					ans[k] = dp[u];
					if (ans[k] >= INF) {
						ans[k] = 0;
					}
				}
			}
		} else {
			if (g == 8) {
				set<pair<ll, ll>> segs;
				for (ll i = 0; i < n; i++) {
					segs.emplace(i, i);
				}
				for (ll i = 0; i < n; i++) {
					ll j = w[i];
					auto it = segs.lower_bound(make_pair(j + 1, 0));
					it--;
					auto[nl, nr] = *it;
					segs.erase(it);
					while (true) {
						auto it = segs.lower_bound(make_pair(j, 0));
						if (it == segs.end() || it->first >= jump[i]) {
							break;
						}
						nr = it->second;
						segs.erase(it);
					}
					segs.emplace(nl, nr);
					for (auto[u, k] : qs[i]) {
						ans[k] = u >= nl;
					}
				}
			} else {
				sqrt_dec sd(n);
				for (ll i = 0; i < n; i++) {
					ll j = w[i];
					sd.upd(j, jump[i]);
					for (auto[u, k] : qs[i]) {
						ans[k] = sd.get(u, j);
					}
				}
			}
		}
	}
	for (ll i = 0; i < q; i++) {
		if (!t[i]) {
			assign_min(ans[i], 1ll);
		}
		cout << ans[i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
