#include <iostream>
#include <vector>
#include <queue>

using namespace std;
using ll = long long;

const ll INF18 = 1e18;

void dfs(ll from, vector<bool> &used, ll start, ll d, const vector<ll> &ids, vector<vector<ll>> &graph) {
    used[from] = true;
    ll n = ll(graph.size());
    for (ll i = 1; i <= d; ++i) {
        ll V = from + i;
        if (V >= n) {
            break;
        }

        if (ids[start] < ids[V]) {
            used[V] = true;
            graph[start].push_back(V);
        } else {
            if (!used[V]) {
                dfs(V, used, start, d, ids, graph);
            }
        }
    }
}

void solve() {
    ll n, d, g;
    cin >> n >> d >> g;
    vector<ll> ids(n);
    for (auto &item: ids) {
        cin >> item;
        --item;
    }

    vector<vector<ll>> graph(n);
    for (ll start = 0; start < n; ++start) {
        vector<bool> used(n);
        dfs(start, used, start, d, ids, graph);
    }

    vector<vector<ll>> dists(n, vector<ll>(n, INF18));
    for (ll start = 0; start < n; ++start) {
        queue<ll> kids;
        kids.push(start);
        dists[start][start] = 0;
        while (!kids.empty()) {
            ll from = kids.front();
            kids.pop();

            for (const auto &to: graph[from]) {
                if (dists[start][to] == INF18) {
                    dists[start][to] = dists[start][from] + 1;
                    kids.push(to);
                }
            }
        }
    }

    ll q;
    cin >> q;
    while (q--) {
        ll type;
        cin >> type;
        ll id0, id1;
        cin >> id0;
        cin >> id1;
        --id0;
        --id1;
        if (type == 1) {
            if (dists[id0][id1] == INF18) {
                cout << "0\n";
            } else {
                cout << "1\n";
            }
        } else {
            if (dists[id0][id1] == INF18) {
                cout << "0\n";
            } else {
                cout << dists[id0][id1] << '\n';
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
