#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int INF18 = 1e9;

void dfs(int from, vector<bool> &used, int start, int d, const vector<int> &ids, vector<vector<int>> &graph) {
    used[from] = true;
    if (ids[from] > ids[start]) {
        graph[start].push_back(from);
        return;
    }

    int n = int(graph.size());
    for (int i = 1; i <= d; ++i) {
        int V = from + i;
        if (V >= n) {
            break;
        }

        if (!used[V]) {
            dfs(V, used, start, d, ids, graph);
        }
    }
}

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> ids(n);
    for (auto &item: ids) {
        cin >> item;
        --item;
    }

    vector<vector<int>> graph(n);
    for (int start = 0; start < n; ++start) {
        vector<bool> used(n);
        dfs(start, used, start, d, ids, graph);
    }

    vector<vector<int>> dists(n, vector<int>(n, INF18));
    for (int start = 0; start < n; ++start) {
        queue<int> kids;
        kids.push(start);
        dists[start][start] = 0;
        while (!kids.empty()) {
            int from = kids.front();
            kids.pop();

            for (const auto &to: graph[from]) {
                if (dists[start][to] == INF18) {
                    dists[start][to] = dists[start][from] + 1;
                    kids.push(to);
                }
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;
        int id0, id1;
        cin >> id0;
        cin >> id1;
        --id0;
        --id1;
        if (type == 1) {
            if (dists[id0][id1] == INF18) {
                cout << "0\n";
            } else {
                cout << "1\n";
            }
        } else {
            if (dists[id0][id1] == INF18) {
                cout << "0\n";
            } else {
                cout << dists[id0][id1] << '\n';
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
