#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;

// #define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;

struct poly_hash {
    vector<int> p, h;
    string s;
    int n, mod;

    poly_hash(string s, int P, int mod) : s(s), mod(mod) {
        n = s.size();
        p.resize(n + 1);
        h.resize(n + 1);
        p[0] = 1;
        for (int i = 0; i < n; ++i) {
            p[i + 1] = p[i] * P;
            if (p[i + 1] >= mod) p[i + 1] %= mod;
            h[i + 1] = (h[i] * P + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get(int ind, int len) {
        return ((h[ind + len] - h[ind] * p[len]) % mod + mod) % mod;
    }
};

struct BIT {
    int n;
    vector<int> a;

    BIT(int n) : n(n) {
        a.resize(n + 1);
    }

    void upd(int ind, int x) {
        for (; ind < n; ind = (ind | (ind + 1))) a[ind] += x;
    }

    int get(int ind) {
        int ans = 0;
        for (; ind >= 0; ind = (ind & (ind + 1)) - 1) ans += a[ind];
        return ans;
    }

    int get(int l, int r) { // [l; r]
        return get(r) - get(l - 1);
    }
};

vector<int> mrg(vector<int> &a, vector<int> &b) {
    vector<int> ans;
    int i = 0, j = 0;
    for (int xx = 0; xx < a.size() + b.size(); ++xx) {
        if (i == a.size()) ans.push_back(b[j++]);
        else if(j == b.size()) ans.push_back(a[i++]);
        else {
            if (a[i] < b[j]) {
                ans.push_back(a[i++]);
            }
            else {
                ans.push_back(b[j++]);
            }
        }
    }
    return ans;
}

struct MergeSortTree {
    int sz;
    vector<vector<int>> tr;


    MergeSortTree(vector<int> a) {
        int n = a.size();
        sz = ((int)1 << (int)(log2(n) + 1));
        tr.resize(sz * 2);
        for (int i =  0; i < n; ++i) tr[i + sz - 1] = {a[i]};
        for (int i = sz - 2; i >= 0; --i) {
            tr[i] = mrg(tr[2 * i + 1], tr[2 * i + 2]);
        }
        // for (auto e : tr) {
        //     for (auto i : e) cout << i << ' ';
        //     cout << '\n';
        // }
    }

    int getmax(int v, int l, int r, int ql, int qr, int x) {
        if (l >= ql && r <= qr) {
            // cout << l << ' ' << r << '\n';
            int L = -1, R = tr[v].size();
            while (R - L > 1) {
                int m = (L + R) / 2;
                if (tr[v][m] <= x) L = m;
                else R = m;
            }
            if (L == -1) return -1;
            return tr[v][L];
        }
        if (l >= qr || r <= ql) return -1;
        int m = (l + r) / 2;
        return max(getmax(2 * v + 1, l, m, ql, qr, x), getmax(2 * v + 2, m, r, ql, qr, x));
    }


    int getmax(int l, int r, int x) {
        return getmax(0, 0, sz, l, r, x);
    }
};

struct SparseTable {
    vector<vector<int>> sp;
    vector<int> a;

    SparseTable(vector<int> a) : a(a) {
        int n = a.size();
        int log2n = log2(n);
        sp.resize(log2n + 1, vector<int>(n));
        for (int i = 0; i < n; ++i) sp[0][i] = i;
        for (int i = 1; i <= log2n; ++i) {
            for (int j = 0; j < n; ++j) {
                int x = min(n - 1, j + (1 << (i - 1)));
                if (a[sp[i - 1][j]] > a[sp[i - 1][x]]) sp[i][j] = sp[i - 1][j];
                else sp[i][j] = sp[i - 1][x];
            }
        }
    }

    int maxind(int l, int r) {
        if (r > (int)a.size()) r = a.size();
        int len = r - l;
        int log2len = __lg(len);
        if (a[sp[log2len][l]] > a[sp[log2len][r - (1 << log2len)]]) return sp[log2len][l];
        return sp[log2len][r - (1 << log2len)];
    }
};


void solve2(int n, int d) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) { return a[i] < a[j]; });
    set<int> cur;
    set<int> fucked;
    fucked.insert(n);
    vector<int> dist(n);
    vector<int> to(n);
    for (auto i : ord) {
        if (cur.size() && cur.upper_bound(i) != cur.end()) {
            int x = *cur.upper_bound(i);
            if (dist[x] > d) {
                fucked.erase(x);
            }
            dist[x] = x - i;
            if (dist[x] > d) {
                fucked.insert(x);
            }
        }
        if (cur.size() && cur.lower_bound(i) != cur.begin()) {
            int x = *--cur.lower_bound(i);
            dist[i] = i - x;
            if (dist[i] > d) fucked.insert(i);
        }
        cur.insert(i);
        to[i] = *(--cur.lower_bound(*fucked.upper_bound(i)));
    }
    vector<int> bck(n + 1);
    for (int i = 0; i < n; ++i) bck[a[i]] = i;
    SparseTable aulol(a);
    vector<vector<int>> to2(20, vector<int>(n));
    for (int i = 0; i < n; ++i) to2[0][i] = to[i];
    for (int i = 1; i < 20; ++i) {
        for (int j = 0; j < n; ++j) {
            to2[i][j] = to2[i - 1][aulol.maxind(j, to2[i - 1][j] + d + 1)];
        }
    }
    // MergeSortTree auau(a);
    int q;
    cin >> q;
    // for (auto e : to) cout << e << ' '; cout << '\n';
    for (int i = 0; i < q; ++i) {
        int t, x, y;
        cin >> t >> x >> y;
        --x; --y;
        if (a[y] < a[x]) {
            cout << "0\n";
            continue;
        }
        if (to2[19][x] + d < y) {
            cout << "0\n";
            continue;
        }
        int ans = 0;
        int cur = x;
        for (int i = 19; i >= 0; --i) {
            if (to2[i][cur] + d < y) {
                ans += (1 << i);
                cur = aulol.maxind(cur, to2[i][cur] + d + 1);
            }
        }
        ans++;
        if (t == 1) if (ans > 0) ans = 1;
        cout << ans << '\n';
    }
}

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    if (g == 3) {
        solve2(n, d);
        return;
    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) { return a[i] < a[j]; });
    set<int> cur;
    set<int> fucked;
    fucked.insert(n);
    vector<int> dist(n);
    vector<int> to(n);
    for (auto i : ord) {
        if (cur.size() && cur.upper_bound(i) != cur.end()) {
            int x = *cur.upper_bound(i);
            if (dist[x] > d) {
                fucked.erase(x);
            }
            dist[x] = x - i;
            if (dist[x] > d) {
                fucked.insert(x);
            }
        }
        if (cur.size() && cur.lower_bound(i) != cur.begin()) {
            int x = *--cur.lower_bound(i);
            dist[i] = i - x;
            if (dist[i] > d) fucked.insert(i);
        }
        cur.insert(i);
        to[i] = *(--cur.lower_bound(*fucked.upper_bound(i)));
    }
    vector<int> bck(n + 1);
    for (int i = 0; i < n; ++i) bck[a[i]] = i;
    // SparseTable aulol(a);
    MergeSortTree auau(a);
    int q;
    cin >> q;
    // for (auto e : to) cout << e << ' '; cout << '\n';
    for (int i = 0; i < q; ++i) {
        int t, x, y;
        cin >> t >> x >> y;
        --x; --y;
        if (a[y] < a[x]) {
            cout << "0\n";
            continue;
        }
        int ans = 1;
        int cur = x;
        while (to[cur] + d < y) {
    // cout << "OK" << endl;
            // cout << cur << ' ';
            int newcur = bck[auau.getmax(cur, to[cur] + d + 1, a[y])];
            // cout << auau.getmax(to[cur], to[cur] + d + 1, a[y]) << ' ';
            if (cur == newcur) {
                ans = 0;
                break;
            }
            ans++;
            cur = newcur;
            // cout << cur << endl;
        }
        if (t == 1) if (ans > 0) ans = 1;
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}