#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

//#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());


class SegmentTree {
private:
    struct Node {
        int l, r, a, ln;

        Node(int n = 0, int ln = 0): ln(ln) {
            if (n == 0) {
                l = 0;
                r = 0;
                a = 0;
            }
            else {
                l = 1;
                r = 1;
                a = 1;
            }
        }

        Node operator+(const Node& other) const {
            Node res;
            res.ln = ln + other.ln;
            if (l == ln) {
                res.l = ln + other.l;
            }
            else {
                res.l = l;
            }

            if (other.r == other.ln) {
                res.r = other.ln + r;
            }
            else {
                res.r = other.r;
            }

            res.a = max({a, other.a, r + other.l});
            return res;
        }
    };

    vector <Node> data;
    int sz;

    Node get(int ql, int qr, int nl, int nr, int node) {
        if (ql >= nr || nl >= qr) return Node(0, 0);
        if (ql <= nl && nr <= qr) return data[node];

        return
            get(ql, qr, nl, (nl + nr) / 2, node * 2) +
            get(ql, qr, (nl + nr) / 2, nr, node * 2 + 1);
    }

public:
    SegmentTree(int n) {
        sz = 1;
        while (sz < n) sz *= 2;

        data.assign(sz * 2, Node(0, 1));
        for (int i = sz - 1; i > 0; --i) {
            data[i] = data[i * 2] + data[i * 2 + 1];
        }
    }

    int get(int l, int r) {
        return get(l, r, 0, sz, 1).a;
    }

    void upd(int pos) {
        pos += sz;
        data[pos] = Node(1, 1);
        while ((pos /= 2) > 0) {
            data[pos] = data[pos * 2] + data[pos * 2 + 1];
        }
    }
};


void solve() {
    int n, d, group;
    cin >> n >> d >> group;
    vector <int> v(n);
    for (auto &x: v) {
        cin >> x;
        --x;
    }

    vector <int> rp(n);
    for (int i = 0; i < n; ++i) {
        rp[v[i]] = i;
    }

    vector <int> up(n);
    {
        SegmentTree tree(n);
        vector <pair <int, int>> sv(n);
        for (int i = 0; i < n; ++i) {
            sv[i] = {v[i], i};
        }
        sort(rall(sv));

        for (auto [val, i] : sv) {
            int l = i, r = n;
            while (l + 1 != r) {
                int m = (l + r) / 2;

                if (tree.get(i, m) < d) l = m;
                else r = m;
            }

            up[i] = l;
            tree.upd(i);
        }
    }

    if (group == 3 || group == 5) {
        vector <int> lg(n + 1, -1);
        for (int i = 1; i < lg.size(); ++i) {
            lg[i] = lg[i / 2] + 1;
        }

        vector <vector <int>> spr(lg.back() + 1, v);
        for (int i = 0; i < n; ++i) {
            if (v[i] > v.back()) spr[0][i] = -1;
        }
        for (int l = 1; l < spr.size(); ++l) {
            for (int i = 0; i + (1 << l) <= n; ++i) {
                spr[l][i] = max(spr[l - 1][i], spr[l - 1][i + (1 << (l - 1))]);
            }
        }

        auto get = [&](int l, int r) {
            return max(spr[lg[r - l]][l], spr[lg[r - l]][r - (1 << (lg[r - l]))]);
        };

        vector <vector <int>> bup(20, vector <int>(n));
        for (int i = 0; i < n; ++i) {
            int r = up[i];
            int mx = get(i, r + 1);
            if (mx == -1) bup[0][i] = -1;
            else bup[0][i] = rp[mx];
        }
        for (int l = 1; l < 20; ++l) {
            for (int i = 0; i < n; ++i) {
                int x = bup[l - 1][i];
                if (x == -1) bup[l][i] = -1;
                else {
                    bup[l][i] = bup[l - 1][x];
                }
            }
        }

        int q;
        cin >> q;
        while (q--) {
            int a, b, t;
            cin >> t >> a >> b;
            --a;
            --b;

            if (v[a] > v[b]) {
                cout << "0\n";
                continue;
            }


            int ans = 0;
            if (up[a] >= b) {
                cout << "1\n";
                continue;
            }

            for (int i = 19; i >= 0; --i) {
                if (up[bup[i][a]] < b) {
                    a = bup[i][a];
                    ans += (1 << i);
                }
            }
            a = bup[0][a];
            ++ans;

            if (up[a] < b) {
                cout << "0\n";
                continue;
            }
            else {
                if (t == 1) cout << "1\n";
                else cout << ans + 1 << '\n';
            }
        }

        return;
    }


    int q;
    cin >> q;
    while (q--) {
        int a, b, t;
        cin >> t >> a >> b;
        --a;
        --b;

        if (v[a] > v[b]) {
            cout << "0\n";
            continue;
        }


        int r = a;
        int mx = v[a];
        int cur = v[a];
        int ans = 1;
        int lst = a;
        for (int i = a; i < b; ++i) {
            if (v[i] <= cur) r = i + d;
            if (v[i] <= v[b]) mx = max(mx, v[i]);
            if (v[i] <= v[b]) lst = i;

            if (i == r) {
                if (cur == mx) break;
                cur = mx;
                if (lst + d == r) break;
                r = lst + d;
                ++ans;
            }
        }

        if (r < b) {
            cout << "0\n";
        } else {
            if (t == 1) cout << "1\n";
            else cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
