#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <complex>
#include <assert.h>
#include <deque>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <immintrin.h>
using namespace std;

///*
#define int long long
#define INTLONGLONG
//*/

#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second

const int INF = 1e18;

vvi graph;

struct snm {
	vi par;
	vi sz;
	snm(int n) {
		par.assign(n, 0);
		sz.assign(n, 1);
		for (int i = 0; i < n; i++) {
			par[i] = i;
		}
	}
	int get(int i) {
		if (par[i] == i) return i;
		int x = get(par[i]);
		par[i] = x;
		return x;
	}
	void unite(int i, int j) {
		i = get(i);
		j = get(j);
		if (i == j) return;
		if (sz[i] > sz[j]) swap(i, j);
		par[i] = j;
		sz[j] += sz[i];
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, d, g;
	cin >> n >> d >> g;
	vi vec(n);
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
	}
	
	if (n <= 1000) {
		graph = vvi(n, vi(n));
		for (int i = 0; i < n; i++) {
			int lst = i;
			for (int j = i; j < n; j++) {
				if (vec[j] > vec[i] && j - lst <= d) {
					graph[i][j] = 1;
				}
				if (vec[j] < vec[i] && j - lst <= d) {
					lst = j;
				}
			}
		}
		vvi dist(n, vi(n));
		for (int st = 0; st < n; st++) {
			dist[st] = vi(n, INF);
			dist[st][st] = 0;
			deque<int> dq;
			dq.push_back(st);
			vi used(n);
			while (dq.size()) {
				int u = dq.front();
				dq.pop_front();
				if (used[u]) continue;
				used[u] = 1;
				for (int i = 0; i < n; i++) {
					if (used[i]) continue;
					if (graph[u][i]) {
						dist[st][i] = min(dist[st][i], dist[st][u] + 1);
						dq.push_back(i);
					}
				}
			}
		}
		int q;
		cin >> q;
		while (q--) {
			int t;
			cin >> t;
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			if (dist[u][v] == INF) {
				cout << 0 << endl;
				continue;
			}
			int ans = dist[u][v];
			if (!(t - 1)) ans = min(ans, (int)1);
			cout << ans << endl;
		}
	}
	else {
		snm sm(n);
		int i = 0;
		for (; i < n - 1; i += 0) {
			int lst = i;
			bool breaked = 0;
			for (int j = i + 1; j < n; j++) {
				if (vec[j] > vec[i] && j - lst <= d) {
					sm.unite(i, j);
					i = j;
					breaked = 1;
					break;
				}
				if (j - lst <= d) {
					lst = j;
					sm.unite(i, j);
				}
				else {
					i = j;
					breaked = 1;
					break;
				}
			}
			if (!breaked) break;
		}
		int q;
		cin >> q;
		while (q--) {
			int t, u, v;
			cin >> t >> u >> v;
			u--;
			v--;
			if (u == v) {
				cout << 1 << endl;
				continue;
			}
			if (vec[u] > vec[v] || u > v) {
				cout << 0 << endl;
				continue;
			}
			cout << (sm.get(u) == sm.get(v)) << endl;
		}
	}
	return 0;
};