#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRng (int l, int r) {
    return rng() % (r - l + 1) + l;
}

const ll infll = 1e18;

const int N = 1e3 + 10;

int dp[N][N];

bool can[N][N];

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ind(n, 0);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j) {
        return a[i] < a[j];
    });

    vector<bool> have(n, false);

    for (int i = 0; i < n; i++) {
        have[ind[i]] = true;

        int j = ind[i];

        int last = j;

        for (int k = j; i < n; i++) {
            if (k - last > d) break;
            if (a[j] < a[k]) {
                can[j][k] = true;
            }
            if (a[k] < a[j]) {
                last = j;
            }
        }
    }


    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (can[i][j]) {
                dp[i][j] = 1;
            } else {
                dp[i][j] = infll;
            }
        }
    }

    for (int l = 0; l < n; l++) {
        for (int k = l + 1; k < n; k++) {
            for (int t = k + 1; t < n; t++) {
                dp[l][t] = min(dp[l][t], dp[l][k] + dp[k][t]);
            }
        }
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int t, u, v;
        cin >> t >> u >> v;

        u--;v--;

        if (t == 1) {
            if (dp[u][v] != infll) {
                cout << 1 << '\n';
            } else {
                cout << 0 << "\n";
            }
        } else {
            if (dp[u][v] != infll) {
                cout << dp[u][v] << "\n";
            } else {
                cout << 0 << '\n';
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}