
#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRng (int l, int r) {
    return rng() % (r - l + 1) + l;
}

const ll infll = 1e18;

const int N = 1e3 + 10;

int dp2[N][N];

bool can[N][N];


struct SegTree {
    struct node {
        int left = -1;
        int zero = -1;
        bool push = false;
    };

    int n = 1;
    int nt;
    vector<node> tree;

    void init (int k) {
        n = 1;
        nt = k;
        while (n < k) {
            n *= 2;
        }
        tree.resize(2e6);
    }

    void push (int x) {
        if (!tree[x].push) return;
        tree[x].zero = -1;
        tree[2 * x + 1].push |= tree[x].push;
        tree[2 * x + 2].push |= tree[x].push;
        tree[x].push = false;
    }

    node merge (node l, node r) {
        node res;
        if (l.zero == -1) res.zero = r.zero;
        else res.zero = l.zero;
        return res;
    }

    void build (int x, int l, int r) {
        if (r - l == 1) {
            if (l < nt) {
                tree[x].zero = l;
            }
            return;
        }

        int m = (r + l) / 2;
        build(2 * x + 1,  l, m);
        build(2 * x + 2,  m, r);

        tree[x] = merge(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void update (int x, int lx, int rx, int l, int r) {
        push(x);
        if (l >= rx || lx >= r) return;
        if (lx <= l && r <= rx) {
            tree[x].push = true;
            push(x);
            return;
        }

        int m = (r + l) / 2;

        update(2 * x + 1, lx, rx, l, m);
        update(2 * x + 2, lx, rx, m, r);
        tree[x] = merge(tree[2 * x + 1], tree[2 * x + 2]);
    }

    node get (int x, int lx, int rx, int l, int r) {
        push(x);
        if (lx >= r || l >= rx) return node();
        if (lx <= l && r <= rx) {
            return tree[x];
        }

        int m = (r + l) / 2;

        return merge(get(2 * x + 1, lx, rx, l, m), get(2 * x + 2, lx, rx, m, r));
    }
};

struct SegTree2 {
    struct node {
        int mn = infll;
    };

    int n = 1;
    vector<node> tree;

    void init (int k) {
        n = 1;
        while (n < k) {
            n *= 2;
        }
        tree.resize(2e6);
    }

    node merge (node l, node r) {
        node res;
        res.mn = min(l.mn, r.mn);
        return res;
    }

    void update (int x, int i, int v, int l, int r) {
        if (r - l == 1) {
            tree[x].mn = v;
            return;
        }

        int m = (r + l) / 2;

        if (i < m) {
            update(2 * x + 1, i, v, l, m);
        } else {
            update(2 * x + 2, i, v, m, r);
        }

        tree[x] = merge(tree[2 * x + 1], tree[2 * x + 2]);
    }

    node get (int x, int lx, int rx, int l, int r) {
        if (lx >= r || l >= rx) return node();
        if (lx <= l && r <= rx) {
            return tree[x];
        }

        int m = (r + l) / 2;

        return merge(get(2 * x + 1, lx, rx, l, m), get(2 * x + 2, lx, rx, m, r));
    }
};

int n, d, g;

void solve() {
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ind(n, 0);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j) {
        return a[i] < a[j];
    });

    vector<bool> have(n, false);

    for (int i = 0; i < n; i++) {
        have[ind[i]] = true;

        int j = ind[i];

        int last = j;

        for (int k = j; k < n; k++) {
            if (k - last > d) break;
            if (a[j] < a[k]) {
                can[j][k] = true;
            }
            if (a[k] < a[j]) {
                last = k;
            }
        }
    }


    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (can[i][j]) {
                dp2[i][j] = 1;
            } else {
                dp2[i][j] = infll;
            }
        }
    }

    for (int l = 0; l < n; l++) {
        for (int k = l + 1; k < n; k++) {
            for (int t = k + 1; t < n; t++) {
                dp2[l][t] = min(dp2[l][t], dp2[l][k] + dp2[k][t]);
            }
        }
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int t, u, v;
        cin >> t >> u >> v;

        u--;v--;

        if (t == 1) {
            if (dp2[u][v] != infll) {
                cout << 1 << '\n';
            } else {
                cout << 0 << "\n";
            }
        } else {
            if (dp2[u][v] != infll) {
                cout << dp2[u][v] << "\n";
            } else {
                cout << 0 << '\n';
            }
        }
    }
}

void solve_special() {
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ind(n, 0);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j) {
        return a[i] < a[j];
    });

    vector<int> R(n, 0);

    SegTree t;
    t.init(n + 100);
    t.build(0, 0, t.n);

    for (int i = 0; i < n; i++) {
        int j = ind[i];
        int where = t.get(0, j + d, n, 0, t.n).zero;
        int lx = max(0ll, j + 1), rx = min(j + d + 1, n + 1);
        t.update(0, lx, rx, 0, t.n);
        if (where == -1) {
            R[j] = n;
        } else {
            R[j] = min(n, max(where, j + d + 1));
        }
    }

    reverse(all(ind));


    SegTree2 t2;
    t2.init(n + 100);

    vector<int> dp(n, infll);

    for (int i = 0; i < n; i++) {
        if (ind[i] == n - 1) {
            dp[ind[i]] = 0;
            t2.update(0, ind[i], dp[ind[i]], 0, t2.n);
        } else {
            dp[ind[i]] = 1 + t2.get(0, ind[i], R[ind[i]], 0, t2.n).mn;
            t2.update(0, ind[i], dp[ind[i]], 0, t2.n);
        }
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int tx, u, v;
        cin >> tx >> u >> v;
        u--;v--;

        if (tx == 1) {
            cout << (dp[u] >= infll ? 0 : 1) << '\n';
        } else {
            cout << (dp[u] >= infll ? 0 : dp[u]) << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    cin >> n >> d >> g;

    if (g == 2 || g == 1) {
        solve();
    } else {
        solve_special();
    }

    return 0;
}