#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using db = double;

struct Query {
    int from, to, t;
};

struct Input {
    int d, G;
    vector<int> a;
    vector<Query> qs;
};

Input input() {
    int n, d, G; cin >> n >> d >> G;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int q; cin >> q;
    vector<Query> qs;
    for (int i = 0; i < q; ++i) {
        int from, to, t; cin >> t >> from >> to;
        from--; to--;
        qs.push_back({from, to, t});
    }
    return {d, G, a, qs};
}

vector<int> stupidSolve(Input inp) {
    auto [d, G, a, qs] = std::move(inp);
    int n = (int)a.size(), q = (int)qs.size();
    vector<vector<int>> g(n);
    for (int start = 0; start < n; ++start) {
        deque<int> w;
        w.push_back(1);
        int sumW = 1;
        for (int j = start + 1; j < n; ++j) {
            if (a[j] > a[start] && sumW) {
                g[start].push_back(j);
            }
            if (a[j] < a[start]) {
                w.push_back(1);
                sumW++;
            } else {
                w.push_back(0);
            }
            if ((int)w.size() > d) {
                sumW -= w.front();
                w.pop_front();
            }
        }
    }
    vector<vector<int>> dist(n);
    for (int start = 0; start < n; ++start) {
        queue<int> que;
        que.push(start);
        vector<int> dst(n, INT32_MAX);
        dst[start] = 0;
        while (!que.empty()) {
            int v = que.front();
            que.pop();
            for (auto u : g[v]) {
                if (dst[u] == INT32_MAX) {
                    dst[u] = dst[v] + 1;
                    que.push(u);
                }
            }
        }
        dist[start] = dst;
    }
    vector<int> ans;
    for (auto [from, to, t] : qs) {
        int dst = dist[from][to];
        if (dst == INT32_MAX) {
            ans.push_back(0);
        } else {
            if (t == 1) ans.push_back(1);
            else ans.push_back(dst);
        }
    }
    return ans;
}

void output(const vector<int>& a) {
    for (auto i : a) cout << i << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    output(stupidSolve(input()));
    return 0;
}
