#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


vector<vector<ll>> g;
vector<ll> a, mxr;
ll n, d;


void init_transit() {
    set<pair<ll, ll>> s;
    ll i = 0, max_right = 0;
    while (i < n) {
        if (s.empty())
            s.emplace(a[i], i);
        max_right = max(max_right, min(s.begin()->second + d + 1, n));
        for (; i < max_right && i < n; ++i) {
            s.emplace(a[i], i);
            max_right = max(max_right, min(s.begin()->second + d + 1, n));
        }
        mxr[s.begin()->second] = max_right;
        s.erase(s.begin());
    }
    for (auto& [q, j] : s)
        mxr[j] = max_right;
}


vector<vector<tuple<ll, ll, ll>>> zpr;
vector<ll> res;


vector<map<ll, ll>> dl;
vector<bool> used;
vector<ll> top_sort;
void dfs_top(const ll v) {
    if (used[v])
        return;
    used[v] = true;
    for (auto& u : g[v])
        dfs_top(u);
    top_sort.push_back(v);
}
void dfs(const ll v) {
    if (used[v])
        return;
    used[v] = true;
    dl[v][v] = 0;
    for (auto& u : g[v]) {
        dfs(u);
        if (dl[v].size() < dl[u].size())
            swap(dl[v], dl[u]);
        for (auto& [a, b] : dl[u]) {
            if (dl[v].find(a) == dl[v].end())
                dl[v][a] = b;
            else
                dl[v][a] = min(dl[v][a], b);
        }
    }

    for (auto& [u, t, id] : zpr[v]) {
        if (dl[v].find(u) == dl[v].end()) {
            res[id] = 0;
            continue;
        }
        res[id] = (t == 1) ? 1 : dl[v][u];
    }
    for (auto& [a, b] : dl[v])
        ++b;
}

void solve(istream& cin, ostream& cout) {
    cin >> n >> d >> group;
    a.resize(n);
    mxr.resize(n);
    for (auto& t : a)
        cin >> t;
    init_transit();


    dl.resize(n);
    zpr.resize(n);
    g.resize(n);
    for (ll i = 0; i < n; ++i) {
        ll best_j = -1;
        for (ll j = i + 1; j < mxr[i]; ++j) {
            if(a[i] < a[j])
                dl[j][i] = 1;
            if (a[i] < a[j] && (best_j == -1 || a[j] > a[best_j]))
                best_j = j;  // TODO Optimize
        }
        if (best_j != -1)
            g[best_j].push_back(i);
    }


    ll q;
    cin >> q;
    res.resize(q);
    for (ll i = 0; i < q; ++i) {
        ll v, u, t;
        cin >> t >> v >> u;
        --v, --u;
        zpr[u].emplace_back(v, t, i);
    }


    top_sort.reserve(n);
    used.resize(n);
    for (ll i = 0; i < n; ++i)
        dfs_top(i);
    reverse(top_sort.begin(), top_sort.end());
    fill(used.begin(), used.end(), 0);
    for (auto& v : top_sort)
        dfs(v);

    for (auto& t : res)
        cout << t << '\n';
}
