#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

// #define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));

ll rnd(ll x) {
    uniform_int_distribution<ll> uid(0, x - 1);
    return uid(rngl);
}

int rnd(int x) {
    uniform_int_distribution<int> uid(0, x - 1);
    return uid(rng);
}

int R = 1;
struct segment_tree {
    vector <ll> t, add;
    segment_tree(int n) {
        R = 1;
        while (R <= n + 10)
            R *= 2;
        t.resize(R * 2 + 32);
        add.resize(R * 2 + 32);
    }
    void push(int node, int nl, int nr) {
        t[node] += add[node] * (nr - nl + 1);
        if (node < R) {
            add[node * 2] += add[node];
            add[node * 2 + 1] += add[node];
        }
        add[node] = 0;
    }
    void calc(int node) {
        if (node < R) {
            t[node] = t[node * 2] + t[node * 2 + 1];
        }
    }
    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (qr <= nl && nr <= qr) {
            add[node] += val;
            push(node, nl, nr);
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }
    ll query(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (qr <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return query(ql, qr, node * 2, nl, nm) +
               query(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ll x, y;

    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    void in() {
        cin >> x >> y;
    }

    ll operator*(Point &other) {
        return x * other.x + y * other.y;
    }

    ll operator%(Point &other) {
        return x * other.y - y * other.x;
    }
};

ll get(int x, int y) {
    return (x << 10) ^ y;
}

#define int long long
int n, d, g;
int a[300010], ans[300010];
vector <int> inds[300010];

void solve() {
    cin >> n >> d >> g;
    vector <vector <int>> sa;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        inds[a[i]].push_back(i);
        sa.push_back({a[i], i});
    }
    sort(sa.begin(), sa.end());
    vector <vector <int>> qs;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        qs.push_back({a[u], t, u, v, i});
    }
    sort(qs.begin(), qs.end());
    set <int> stpref, stsuf;
    for (int i = 0; i < n; i++)
        stsuf.insert(i);
    int lastpref = 0, lastsuf = 0;
    for (auto& el : qs) {
        int t = el[1], u = el[2], v = el[3];

        if (u >= v || a[u] >= a[v]) {
            ans[el[4]] = 0;
            continue;
        }

        for (int i = lastpref; i < a[u]; i++)
            for (auto& ind : inds[i])
                stpref.insert(ind);
        lastpref = a[u];

        for (int i = lastsuf; i <= a[u]; i++)
            for (auto& ind : inds[i])
                stsuf.erase(ind);
        lastsuf = a[u] + 1;

        map <int, int> dist;
        deque <int> dq;
        dist[u] = 0;
        dq.push_back(u);

        while (!dq.empty() && dist.find(v) == dist.end()) {
            int u1 = dq.front();
            dq.pop_front();
            while (u1 < v) {
                auto it = stpref.upper_bound(u1 + d);
                if (it == stpref.begin() || *prev(it) <= u1)
                    break;
                else
                    u1 = *prev(it);
            }
            auto it = stsuf.upper_bound(u1 + d);
            if (it == stsuf.begin())
                break;
            while (it != stsuf.begin() && (*prev(it)) > u1) {
                it--;
                if (a[*it] <= a[v] && a[u1] <= a[*it] && dist.find(*it) == dist.end()) {
                    dist[*it] = dist[u1] + 1;
                    dq.push_back(*it);
                }
            }
        }
        ans[el[4]] = (dist.find(v) != dist.end() ? (t == 1 ? 1 : dist[v]) : 0);
    }
    for (int i = 0; i < q; i++)
        cout << ans[i] << ' ';
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    cerr << "Ulyanovsk is the best!!!" << endl;
}
