#include <algorithm>
#include <iostream>
#include <vector>

constexpr int inf = 1000000000;

void getall(int v, std::vector<int>& arr, const std::vector<int>& a, int d, int n) {
    std::vector<bool> rc(n, false);
    rc[v] = true;
    for (int j = v; j < n; j++) {
        if (rc[j]) {
            for (int k = j + 1; k <= j + d && k < n; k++) {
                if (a[k] < a[v]) {
                    rc[k] = true;
                } else if (a[k] > a[v]) {
                    arr.emplace_back(k);
                }
            }
        }
    }
}

int dfs(const std::vector<std::vector<int>>& gr, std::vector<bool>& used, std::vector<int>& ress, int v, int dest) {
    if (used[v]) {
        return ress[v];
    }
    used[v] = true;
    if (v == dest) {
        return ress[v] = 0;
    }
    int res = inf;
    for (int to : gr[v]) {
        res = std::min(res, dfs(gr, used, ress, to, dest) + 1);
    }
    return ress[v] = res;
}

int main() {
    int n, d, g;
    std::cin >> n >> d >> g;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        a[i]--;
    }
    std::vector<std::vector<int>> gr(n);
    for (int i = 0; i < n; i++) {
        getall(i, gr[i], a, d, n);
    }
    int q;
    std::cin >> q;
    std::vector<bool> used(n);
    std::vector<int> ress(n);
    for (int qr = 0; qr < q; qr++) {
        int t, u, v;
        std::cin >> t >> u >> v;
        u--;
        v--;
        std::fill(used.begin(), used.end(), false);
        int res = dfs(gr, used, ress, u, v);
        if (res == inf) {
            std::cout << "0\n";
        } else {
            if (t == 1) {
                std::cout << "1\n";
            } else {
                std::cout << res << '\n';
            }
        }
    }
    return 0;
}