#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

constexpr int inf = 1000000000;

constexpr int maxn = 524288;

int tree[2 * maxn];

void init() {
    std::fill(tree, tree + 2 * maxn, inf);
}

void mineq(int i, int x) {
    i += maxn;
    while (i > 0) {
        tree[i] = std::min(tree[i], x);
        i >>= 1;
    }
}

int getmin(int l, int r) {
    l += maxn;
    r += maxn;
    int res = inf;
    while (l < r) {
        if (l & 1) {
            res = std::min(res, tree[l++]);
        }
        if (r & 1) {
            res = std::min(res, tree[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return res;
}

int main() {
    int n, d, g;
    std::cin >> n >> d >> g;
    if (g != 3) {
        return 1;
    }
    std::vector<int> a(n);
    std::vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
    }
    std::vector<int> anss(n, inf);
    std::set<std::pair<int, int>> segs;
    std::set<std::pair<int, int>> bigsegs;

    init();
    anss[n - 1] = 0;
    mineq(n - 1, 0);
    segs.emplace(n - 1, n - 1);
    if (1 >= d) {
        bigsegs.emplace(n - 1, n - 1);
    }

    for (int el = n - 2; el >= 0; el--) {
        int i = pos[el];
        auto csegit = bigsegs.lower_bound({i, -1});
        int firstbad = n;
        if (csegit != bigsegs.end()) {
            firstbad = std::min(firstbad, csegit->first + d);
        }
        anss[i] = std::min(inf, getmin(i, firstbad) + 1);
        mineq(i, anss[i]);

        std::pair<int, int> cseg(i, i);
        auto cnxt = segs.lower_bound({i, -1});
        auto cprv = cnxt;
        bool goodpr = false;
        if (cprv != segs.begin()) {
            goodpr = true;
            cprv--;
        }
        if (cnxt != segs.end()) {
            if (cnxt->first == i + 1) {
                bigsegs.erase(*cnxt);
                cseg.second = cnxt->second;
                segs.erase(cnxt);
            }
        }
        if (goodpr && cprv != segs.end()) {
            if (cprv->second == i - 1) {
                bigsegs.erase(*cprv);
                cseg.first = cprv->first;
                segs.erase(cprv);
            }
        }
        segs.emplace(cseg);
        if (cseg.second - cseg.first + 1 >= d) {
            bigsegs.emplace(cseg);
        }
    }

    int q;
    std::cin >> q;
    for (int i = 0; i < q; i++) {
        int t, l, r;
        std::cin >> t >> l >> r;
        l--;
        r--;
        if (r != n - 1) {
            std::cout << "0\n";
            continue;
        }
        if (anss[l] == inf) {
            std::cout << "0\n";
        } else {
            if (t == 2) {
                std::cout << anss[l] << '\n';
            } else {
                std::cout << 1 << '\n';
            }
        }
    }
    return 0;
}