#include <bits/stdc++.h>

struct ST {
    int size;
    std::vector<std::pair<int, int>> data;

    ST(std::vector<int> vec) {
        size = 1 << std::__lg(std::max(1, (int)vec.size() - 1)) + 1;
        data.assign(size * 2, std::pair{-1, -1});
        for (int i = 0; i < vec.size(); i++) {
            data[size + i] = {vec[i], i};
        }
        for (int i = size - 1; i > 0; i--) {
            data[i] = std::max(data[2 * i], data[2 * i + 1]);
        }
    }

    ST(int n) {
        size = 1 << std::__lg(std::max(1, n - 1)) + 1;
        data.assign(size * 2, std::pair{-1, -1});
    }

    void update(int i, int val) {
        i += size;
        data[i] = {val, i - size};
        for (i >>= 1; i > 0; i >>= 1) {
            data[i] = std::max(data[2 * i], data[2 * i + 1]);
        }
    }

    int get_max_pos(int l, int r) {
        std::pair<int, int> max(-1, -1);
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                max = std::max(max, data[l++]);
            if (r & 1)
                max = std::max(max, data[--r]);
        }
        return max.second;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, d, g;
    std::cin >> n >> d >> g;
    std::vector<int> input(n);
    for (auto& i : input) {
        std::cin >> i;
        i--;
    }

    std::vector<int> prv(n, -1);
    auto get = [&](auto get, int i) -> int {
        return prv[i] == -1 ? i : prv[i] = get(get, prv[i]);
    };
    std::vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[input[i]] = i;
    }
    std::set<int> set;
    std::vector<int> nxt(n);
    for (int i = 0; i < n; i++) {
        auto it = set.insert(p[i]).first;
        if (it != set.begin()) {
            auto it1 = std::prev(it);
            if (*it - *it1 <= d && prv[*it1] == -1) {
                prv[*it1] = *it;
            }
        }
        if (std::next(it) != set.end()) {
            auto it2 = std::next(it);
            if (*it2 - *it <= d) {
                prv[*it] = *it2;
            }
        }
        int t = get(get, p[i]);
        nxt[p[i]] = t + d;
    }

    int q;
    std::cin >> q;
    std::vector<std::array<int, 4>> quer(q);
    for (int i = 0; i < q; i++) {
        int t, a, b;
        std::cin >> t >> a >> b;
        a--;
        b--;
        quer[i] = {t, a, b, i};
    }
    std::sort(quer.begin(), quer.end(), [&](auto a, auto b) { return input[a[2]] < input[b[2]]; });

    ST st(n);
    std::vector<int> ans(q, -1);
    for (int i = 0, j = 0; i < n; i++) {
        int ind = p[i];
        st.update(ind, i);

        while (j < quer.size() && input[quer[j][2]] == i) {
            auto [tp, a, b, id] = quer[j];
            int res = 0;
            if (a > b || input[a] > input[b]) {
                res = -1;
            } else {
                while (nxt[a] < b) {
                    if (res > 160) {
                        res = -1;
                        break;
                    }
                    res++;
                    int t = st.get_max_pos(a, nxt[a] + 1);
                    if (t == a) {
                        res = -1;
                        break;
                    }
                    a = t;
                }
                if (res != -1) {
                    assert(nxt[a] >= b);
                    res++;
                }
            }

            ans[id] = res == -1 ? 0 : (tp == 1 ? 1 : res);
            j++;
        }
    }

    for (int i = 0; i < q; i++) {
        std::cout << ans[i] << " \n"[i == q - 1];
    }

    return 0;
}
