#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, d, g;
vector<int> a;
vector<set<int>> gr;
vector<set<int>> gr_add;
vector<vector<int>> ds;
vector<bool> used;

void bfs(int s) {
    ds[s][s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : gr[u]) {
            if (ds[s][v] > ds[s][u] + 1) {
                ds[s][v] = ds[s][u] + 1;
                q.push(v);
            }
        }
    }
}

void dfs(int s, int u) {
    used[u] = true;
    for (auto v : gr[u]) {
        if (v < n && !used[v] && a[s] > a[v])
            dfs(s, v);
        else if (v >= n && a[s] < a[v - n])
            gr_add[s].insert(v);
    }
}

inline void solve() {
    cin >> n >> d >> g;
    a.resize(n);
    gr.resize(n * 2);
    gr_add.resize(n);
    used.resize(n);
    ds.resize(n * 2);
    for (auto& i : a)
        cin >> i;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= min(n - 1, i + d); ++j) {
            gr[i].insert(j);
            if (a[i] < a[j]) {
                gr[i].insert(n + j);
                gr[n + i].insert(n + j);
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        used.assign(n, false);
        dfs(i, i);
        for (auto j : gr_add[i]) {
            gr[i].insert(j);
            gr[i + n].insert(j);
        }
    }
//    for (int i = 0; i < n; ++i) {
//        for (auto j : gr[i])
//            cout << i + 1 << ' ' << j + 1 << '\n';
//    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        if (ds[n + u - 1].empty()) {
            ds[n + u - 1].resize(n * 2, INF);
            bfs(n + u - 1);
        }
        if (t == 1)
            cout << (ds[n + u - 1][n + v - 1] != INF ? 1 : 0) << '\n';
        else
            cout << (ds[n + u - 1][n + v - 1] != INF ? ds[n + u - 1][n + v - 1] : 0) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
