#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, d, task;
    cin >> n >> d >> task;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<vector<int>> dist(n, vector<int> (n, INF));
    vector<vector<int>> g(n, vector<int> (n, -1));
    for (int i = 0; i < n; ++i) {
        int pst = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[i] > a[j]) {
                if (j - pst <= d) {
                    g[i][j] = 0;
                    //dist[i][j] = 0;
                    pst = j;
                    //cout << "0 " << i << ' ' << j << endl;
                }
                continue;
            }
            if (j - i <= d) {
                g[i][j] = 1;
                dist[i][j] = 1;
                //cout << i << ' ' << j << endl;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (g[i][j] != 0) {
                continue;
            }
            for (int k = j + 1; k < min(n, j + d + 1); ++k) {
                if (g[j][k]) {
                    dist[i][k] = 1;
                    //cout << i << ' ' << k << endl;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
    }
    for (int k = 0; k < n; ++k) {
        for (int v = 0; v < n; ++v) {
            for (int u = v + 1; u < n; ++u) {
                if (v <= k && k <= u) {
                    dist[v][u] = min(dist[v][u], dist[v][k] + dist[k][u]);
                }
            }
        }
    }
    /*for (auto i : dist) {
        for (auto j : i) {
            cout << j << ' ';
        }
        cout << endl;
    }*/

    int q;
    cin >> q;
    while (q--) {
        int v, u, t;
        cin >> t >> v >> u;
        v--;
        u--;
        if (t == 1) {
            cout << (dist[v][u] != INF && dist[v][u] != 0) << '\n';
        } else {
            cout << (dist[v][u] != INF) * dist[v][u] << '\n';
        }
    }
}