#include <iostream>
#include <vector>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;

const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, d, task;
    cin >> n >> d >> task;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<vector<ll>> dist(n, vector<ll> (n, INF));
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int pst = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[i] > a[j]) {
                pst = j;
                continue;
            }
            if (a[j] > a[i] && j - pst <= d) {
                g[i].push_back(j);
                dist[i][j] = 1;
            } else if (j - pst > d) {
                break;
            }
        }
    }

    /*for (auto i : g) {
        for (auto j : i) {
            cout << j << ' ';
        }
        cout << '\n';
    }*/

    auto bfs = [&] (int st) {
        vector<int> used(n);
        queue<pair<int, int>> q;
        q.push({st, 0});
        used[st] = 1;
        while (!q.empty()) {
            auto [v, l] = q.front();
            dist[st][v] = l;
            q.pop();
            for (auto u : g[v]) {
                if (!used[u]) {
                    used[u] = 1;
                    q.push({u, l + 1});
                }
            }
        }
    };

    for (int v = 0; v < n; ++v) {
        bfs(v);
    }

    int q;
    cin >> q;
    while (q--) {
        int v, u, t;
        cin >> t >> v >> u;
        v--;
        u--;
        if (t == 1) {
            cout << (dist[v][u] != INF && dist[v][u] != 0) << '\n';
        } else {
            cout << (dist[v][u] != INF) * dist[v][u] << '\n';
        }
    }
}