#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

vector<vector<int>> g;
vector<vector<int>> dist;

int n, d, group;

void bfs(int st) {
    dist[st].resize(n, INF);
    dist[st][st] = 0;

    queue<int> q;
    q.push(st);
    vector<bool> used(n);
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (used[u]) continue;
            used[u] = true;
            dist[st][u] = dist[st][v] + 1;
            q.push(u);
        }
    }
}

void solve() {
    cin >> n >> d >> group;
    vector<int> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    g.resize(n);

    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = i + 1; j < n; j++) {
            if (a[j] > a[i])
                g[i].emplace_back(j);

            if (a[j] > a[i]) cnt++;
            else cnt = 0;

            if (cnt >= d) break;
        }
    }

//    for (int j = 0; j < n; j++) {
//        dbg1(g[j]);
//    }


    dist.resize(n);
    for (int i = 0; i < n; i++)
        bfs(i);


    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--; v--;
        if (t == 1) {
            cout << (dist[u][v] == INF ? 0 : 1) << '\n';
        } else if (t == 2) {
            cout << (dist[u][v] == INF ? 0 : dist[u][v]) << '\n';
        }

    }
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
