#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int ans, pref, suf, kol;
};

vector <st> t;
vector <int> mx, a;
int n, d, g;

st j(st a, st b) {
	if (a.ans == -1) return b;
	if (b.ans == -1) return a;
	int ans = max({ a.ans, b.ans, a.suf + b.pref });
	int pref = a.pref;
	if (pref == a.kol) pref += b.pref;
	int suf = b.suf;
	if (suf == b.kol) suf += a.suf;
	return { ans, pref, suf, a.kol + b.kol };
}

void build(int v = 0, int l = 0, int r = n) {
	if (l == r - 1) {
		t[v] = { 0, 0, 0, 1 };
		return;
	}
	build(v * 2 + 1, l, (l + r) / 2);
	build(v * 2 + 2, (l + r) / 2, r);
	t[v].kol = t[v * 2 + 1].kol + t[v * 2 + 2].kol;
}

void buildmx(int v = 0, int l = 0, int r = n) {
	if (l == r - 1) {
		mx[v] = a[l];
		return;
	}
	buildmx(v * 2 + 1, l, (l + r) / 2);
	buildmx(v * 2 + 2, (l + r) / 2, r);
	mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
}

void upd(int ind, int v = 0, int l = 0, int r = n) {
	if (ind < l || ind >= r) return;
	if (l == r - 1) {
		t[v] = { 1, 1, 1, 1 };
		return;
	}
	upd(ind, v * 2 + 1, l, (l + r) / 2);
	upd(ind, v * 2 + 2, (l + r) / 2, r);
	t[v] = j(t[v * 2 + 1], t[v * 2 + 2]);
}

st get(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (qr <= l || r <= ql) return { -1, -1, -1, -1 };
	if (l >= ql && r <= qr) return t[v];
	return j(get(ql, qr, v * 2 + 1, l, (l + r) / 2), get(ql, qr, v * 2 + 2, (l + r) / 2, r));
}

int getmx(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (qr <= l || r <= ql) return -1;
	if (l >= ql && r <= qr) return mx[v];
	return max(getmx(ql, qr, v * 2 + 1, l, (l + r) / 2), getmx(ql, qr, v * 2 + 2, (l + r) / 2, r));
}

int main() {
	cin >> n >> d >> g;
	vector <int> g(n), ind(n);
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i], ind[a[i] - 1] = i;
	vector <vector <int>> binup(20, vector <int>(n + 1));
	vector <pair <int, int>> otr(n + 1);
	t.resize(4 * n, { 0, 0, 0, 0 }), mx.resize(4 * n, 0);
	build();
	buildmx();
	for (int i = n - 1; i >= 0; i--) {
		int l = ind[i] - 1, r = n;
		while (l < r - 1) {
			int m = (l + r) / 2;
			if (get(ind[i], m + 1).ans >= d) r = m;
			else l = m;
		}
		upd(ind[i]);
		if (r != n) {
			int m = getmx(r - d + 1, r + 1);
			otr[ind[i]] = { r - d + 1, r };
			binup[0][ind[i]] = ind[m - 1];
		}
		else {
			if (1) binup[0][ind[i]] = r, otr[ind[i]] = { ind[i] + 1, n - 1 };
			else binup[0][ind[i]] = ind[i], otr[ind[i]] = { ind[i], ind[i] };
		}
	}
	otr[n] = { n - 1, n - 1 };
	for (int i = 0; i < 20; i++) binup[i][n] = n;
	for (int i = 1; i < 20; i++) {
		for (int j = 0; j < n; j++) {
			binup[i][j] = binup[i - 1][binup[i - 1][j]];
		}
	}
	int q; cin >> q;
	while (q--) {
		int t, u, v; cin >> t >> u >> v; u--; v--;
		if (a[u] >= a[v]) { cout << "0\n"; continue; }
		if (otr[u].second >= v) { cout << "1\n"; continue; }
		int ans = 0;
		bool fl = 0;
		for (int k = 1; k >= 0; k--) {
			if (otr[binup[k][u]].second < v) {
				ans += (1 << k);
				int mx = -1;
				for (int i = otr[binup[k][u]].first; i <= otr[binup[k][i]].second; i++) {
					if (a[i] > a[u] && a[i] > mx) mx = a[i];
				}
				u = ind[mx - 1];
			}
		}
		if (otr[binup[0][u]].second < v) cout << "0\n";
		else {
			if (t == 1) cout << "1\n";
			else {
				cout << ans + 2 << "\n";
			}
		}
	}
	return 0;
}