#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;

struct st {
	int ans, pref, suf, kol;
};

vector <st> t;
vector <int> mx, a;
int n, d, g;

st j(st a, st b) {
	if (a.ans == -1) return b;
	if (b.ans == -1) return a;
	int ans = max({ a.ans, b.ans, a.suf + b.pref });
	int pref = a.pref;
	if (pref == a.kol) pref += b.pref;
	int suf = b.suf;
	if (suf == b.kol) suf += a.suf;
	return { ans, pref, suf, a.kol + b.kol };
}

void build(int v = 0, int l = 0, int r = n) {
	if (l == r - 1) {
		t[v] = { 0, 0, 0, 1 };
		return;
	}
	build(v * 2 + 1, l, (l + r) / 2);
	build(v * 2 + 2, (l + r) / 2, r);
	t[v].kol = t[v * 2 + 1].kol + t[v * 2 + 2].kol;
}

void buildmx(int v = 0, int l = 0, int r = n) {
	if (l == r - 1) {
		mx[v] = a[l];
		return;
	}
	buildmx(v * 2 + 1, l, (l + r) / 2);
	buildmx(v * 2 + 2, (l + r) / 2, r);
	mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
}

void upd(int ind, int v = 0, int l = 0, int r = n) {
	if (ind < l || ind >= r) return;
	if (l == r - 1) {
		t[v] = { 1, 1, 1, 1 };
		return;
	}
	upd(ind, v * 2 + 1, l, (l + r) / 2);
	upd(ind, v * 2 + 2, (l + r) / 2, r);
	t[v] = j(t[v * 2 + 1], t[v * 2 + 2]);
}

st get(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (qr <= l || r <= ql) return { -1, -1, -1, -1 };
	if (l >= ql && r <= qr) return t[v];
	return j(get(ql, qr, v * 2 + 1, l, (l + r) / 2), get(ql, qr, v * 2 + 2, (l + r) / 2, r));
}

int getmx(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (qr <= l || r <= ql) return -1;
	if (l >= ql && r <= qr) return mx[v];
	return max(getmx(ql, qr, v * 2 + 1, l, (l + r) / 2), getmx(ql, qr, v * 2 + 2, (l + r) / 2, r));
}

vector <vector <int>> gr;

int bfs(int st, int f) {
	vector <int> d(n, 1e9);
	d[st] = 0;
	queue <int> q;
	q.push(st);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto i : gr[v]) {
			if (d[i] == 1e9) {
				d[i] = d[v] + 1;
				q.push(i);
			}
		}
	}
	if (d[f] == 1e9) return -1;
	return d[f];
}

int main() {
	cin >> n >> d >> g;
	vector <int> g(n), ind(n);
	gr.resize(n);
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i], ind[a[i] - 1] = i;
	vector <vector <int>> binup(20, vector <int>(n + 1));
	vector <pair <int, int>> otr(n + 1);
	t.resize(4 * n, { 0, 0, 0, 0 }), mx.resize(4 * n, 0);
	build();
	buildmx();
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (a[i] < a[j]) {
				int pr = i;
				bool fl = 1;
				for (int u = i + 1; u <= j; u++) {
					if (a[u] < a[i]) pr = u;
					if (u - pr > d) { fl = 0; break; }
				}
				if (fl) gr[i].push_back(j);
			}
		}
	}
	otr[n] = { n - 1, n - 1 };
	for (int i = 0; i < 20; i++) binup[i][n] = n;
	for (int i = 1; i < 20; i++) {
		for (int j = 0; j < n; j++) {
			binup[i][j] = binup[i - 1][binup[i - 1][j]];
		}
	}
	/*vector <pair <int, int>> ans(n, vector <int>(n));
	for (int i = 0; i < n; i++) {
		bfs(i);
	}*/
	int q; cin >> q;
	while (q--) {
		int t, u, v; cin >> t >> u >> v; u--; v--;
		int ans = bfs(u, v);
		if (ans == -1) cout << "0\n";
		else {
			if (t == 1) cout << "1\n";
			else cout << ans << "\n";
		}
	}
	return 0;
}