#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAX = 2e5 + 7;
const int mod = 1e9 + 7;

struct segment_tree {
    vector<int> t;
    int n;

    segment_tree(int _n) {
        n = _n;
        t.resize(n * 4 + 7);
        build(1, 1, n);
    }

    void build(int v, int tl, int tr) {
        if (tl == tr) {
            t[v] = 1e9;
        } else {
            int tm = (tl + tr) / 2;
            build(v * 2, tl, tm);
            build(v * 2 + 1, tm + 1, tr);
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    void upd(int v, int tl, int tr, int pos, int val) {
        if (tl == tr) {
            t[v] = min(t[v], val);
        } else {
            int tm = (tl + tr) / 2;
            if (pos <= tm) {
                upd(v * 2, tl, tm, pos, val);
            } else {
                upd(v * 2 + 1, tm + 1, tr, pos, val);
            }
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (l > r) return 1e9;
        if (tl == l && tr == r) return t[v];
        int tm = (tl + tr) / 2;
        return min(get(v * 2, tl, tm, l, min(r, tm)),
                    get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
    }

    void upd(int pos, int val) {
        upd(1, 1, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 1, n, l, r);
    }
};

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    while (q--) {
        int type, v, u;
        cin >> type >> v >> u;
        vector<int> dp(n + 1, 1e9);
        dp[v] = 0;
        for (int i = v + 1; i <= u; i++) {
            for (int j = v; j < i; j++) {
                if ((a[j] + d >= a[i] && a[j] < a[i]) || (a[j] < a[i] && i - j <= d)) {
                    dp[i] = min(dp[i], dp[j] + 1);
                }
            }
        }
        if (type == 1) if (dp[u] != 1e9) dp[u] = min(dp[u], 1);
        cout << (dp[u] == 1e9 ? 0 : dp[u]) << '\n';
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}