#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

vector<ll> solve_transactions(ll n, ll d, vector<ll> &a) {
    vector<ll> ans(n, n - 1);
    vector<ll> pos(n);
    for (ll i = 0; i < n; ++i) {
        pos[a[i]] = i;
    }

    set<ll> window;
    for (ll i = 0; i < d; ++i) {
        window.insert(a[i]);
    }
    vector<ll> ends(n, 0);
    for (ll i = 0; i + d < n; ++i) {
        window.erase(a[i]);
        window.insert(a[i + d]);
        ends[i] = *window.begin();
    }

    vector<vector<ll>> sigma(n, vector<ll> ());
    for (ll i = 0; i < n; ++i) {
        sigma[ends[i]].push_back(i);
    }
    set<ll> cur;
    cur.insert(n - 1);
    for (ll i = n - 1; i >= 0; --i) {
        ans[pos[i]] = min(n - 1, *cur.lower_bound(pos[i]) + d);
        for (ll add : sigma[i]) {
            cur.insert(add);
        }
    }
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, d, g;
    cin >> n >> d >> g;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    auto trans = solve_transactions(n, d, a);

    //for (auto g : trans) {
    //    cout << g << ' ';
    //}
    //cout << '\n';

    if (g <= 1) {
        ll q;
        cin >> q;
        for (ll i = 0; i < q; ++i) {
            ll t, u, v;
            cin >> t >> u >> v;
            u--;
            v--;
            if (a[u] > a[v]) {
                cout << "0\n";
                continue;
            }

            vector<ll> dist(n, INF);
            dist[v] = 0;
            for (ll j = v - 1; j >= u; --j) {
                for (ll k = j; k <= trans[j]; ++k) {
                    if (a[j] <= a[k]) {
                        dist[j] = min(dist[j], dist[k] + 1);
                    }
                }
            }

            //for (auto f : dist) {
            //    cout << (f + 1) % (INF  + 1) - 1 << ' ';
            //}
            //cout << '\n';

            if (dist[u] == INF) {
                cout << "0\n";
                continue;
            }

            if (t == 1) {
                cout << "1\n";
                continue;
            }
            cout << dist[u] << '\n';
        }
    }
}
