#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>
#include <assert.h>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(3);

struct stack {
    vector<ll> vec;
    vector<ll> mn;

    ll pop() {
        ll ans = vec.back();
        vec.pop_back();
        mn.pop_back();
        return ans;
    }

    void push(ll x) {
        vec.push_back(x);
        if (mn.empty()) mn.push_back(x);
        else mn.push_back(min(mn.back(), x));
    }

    ll get() {
        if (mn.empty()) return INF;
        return mn.back();
    }
};

struct que {
    stack s1, s2;

    ll get() {
        return min(s1.get(), s2.get());
    }

    void push(ll x) {
        s1.push(x);
    }

    ll pop() {
        if (s2.vec.empty()) {
            while (!s1.vec.empty()) s2.push(s1.pop());
        }
        return s2.pop();
    }
};

struct segmentTree {
    vector<ll> vec;
    vector<ll> segTree;
    vector<ll> segTree2;

    void build(ll i, ll l, ll r) {
        if (r - l == 1) {
            segTree[i] = vec[l];
            segTree2[i] = vec[l];
            return;
        }
        ll m = (l + r) / 2;
        build(i * 2 + 1, l, m);
        build(i * 2 + 2, m, r);
        segTree[i] = min(segTree[i * 2 + 1], segTree[i * 2 + 2]);
        segTree2[i] = max(segTree2[i * 2 + 1], segTree2[i * 2 + 2]);
    }

    segmentTree(vector<ll> vec) : vec(vec) {
        ll n = vec.size();
        segTree.resize(4 * n);
        segTree2.resize(4 * n);
        build(0, 0, n);
    }

    ll id(ll i, ll l, ll r, ll ql, ll x) {
        if (segTree2[i] <= x) return INF;
        if (r <= ql) return INF;
        if (l < ql) {
            ll m = (l + r) / 2;
            ll ans = id(i * 2 + 1, l, m, ql, x);
            if (ans == INF) ans = id(i * 2 + 2, m, r, ql, x);
            return ans;
        }
        if (segTree[i] > x) return l;
        if (r - l == 1) return INF;
        ll m = (l + r) / 2;
        ll ans = id(i * 2 + 1, l, m, ql, x);
        if (ans == INF) ans = id(i * 2 + 2, m, r, ql, x);
        return ans;
    }
};

struct segmentTree2 {
    vector<ll> segTree;

    segmentTree2(ll n) {
        segTree.resize(4 * n);
    }

    ll get(ll i, ll l, ll r, ll ql, ll qr) {
        if (l >= ql && r <= qr) return segTree[i];
        if (l >= qr || r <= ql) return INF;
        ll m = (l + r) / 2;
        return min(get(i * 2 + 1, l, m, ql, qr), get(i * 2 + 2, m, r, ql, qr));
    }

    void replace(ll i, ll l, ll r, ll id, ll x) {
        if (r - l == 1) {
            segTree[i] = x;
            return;
        }
        ll m = (l + r) / 2;
        if (id < m) replace(i * 2 + 1, l, m, id, x);
        else replace(i * 2 + 2, m, r, id, x);
        segTree[i] = min(segTree[i * 2 + 1], segTree[i * 2 + 2]);
    }
};

void solve1(ll n, ll d, ll g, ll q, vector<ll>& vec) {
    vector<ll> wind(n + d - 1);
    que qu;
    for (ll j = 0; j < n + d - 1; j++) {
        if (j < n) qu.push(vec[j]);
        if (j - d + 1 > 0) qu.pop();
        wind[j] = qu.get();
    }
    segmentTree st = wind;
    vector<ll> r(n, INF);
    for (ll i = 0; i < n; i++) {
        r[i] = st.id(0, 0, wind.size(), i + d - 1, vec[i]);
    }
    segmentTree2 dist(n);
    vector<ll> dst(n);
    for (ll i = n - 2; i >= 0; i--) {
        ll ans = INF;
        ans = dist.get(0, 0, n, i + 1, r[i] + 1) + 1;
        if (vec[i] > vec[n - 1]) ans = INF;
        dist.replace(0, 0, n, i, ans);
        dst[i] = ans;
    }
    while (q--) {
        ll t, a, b; cin >> t >> a >> b; a--; b--;
        ll ans = dst[a];
        if (ans >= INF) ans = 0;
        if (t == 1) ans = min(ans, 1ll);
        if (vec[b] < vec[a] || a > b) ans = 0;
        cout << ans << endl;
    }
}

void solve2(ll n, ll d, ll g, ll q, vector<ll>& vec) {
    vector<ll> wind(n + d - 1);
    que qu;
    for (ll j = 0; j < n + d - 1; j++) {
        if (j < n) qu.push(vec[j]);
        if (j - d + 1 > 0) qu.pop();
        wind[j] = qu.get();
    }
    segmentTree st = wind;
    vector<ll> r(n, INF);
    for (ll i = 0; i < n; i++) {
        r[i] = st.id(0, 0, wind.size(), i + d - 1, vec[i]);
    }
    vector<vector<ll>> dss;
    for (ll I = 0; I < n; I++) {
        segmentTree2 dist(n);
        vector<ll> dst(n);
        for (ll i = n - 1; i >= 0; i--) {
            ll ans = INF;
            if (i <= I - 1) {
                ans = dist.get(0, 0, n, i + 1, r[i] + 1) + 1;
                if (vec[i] > vec[n - 1]) ans = INF;
            }
            if (i == I) ans = 0;
            dist.replace(0, 0, n, i, ans);
            dst[i] = ans;
        }
        dss.push_back(dst);
    }
    while (q--) {
        ll t, a, b; cin >> t >> a >> b; a--; b--;
        ll ans = dss[b][a];
        if (ans >= INF) ans = 0;
        if (t == 1) ans = min(ans, 1ll);
        if (vec[b] < vec[a] || a > b) ans = 0;
        cout << ans << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n, d, g; cin >> n >> d >> g;
    vector<ll> vec(n);
    for (ll i = 0; i < n; i++) cin >> vec[i];
    ll q; cin >> q;

    if (n <= 1000) {
        solve2(n, d, g, q, vec);
        return 0;
    }

    solve1(n, d, g, q, vec);
}