#ifndef LOCALEGOR
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> dp(n, vector<int>(n, INF));
    for (int i = 0; i < n; ++i) {
        dp[i][i] = 0;
    }
    vector<int> rm(n, n);
    {
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            while (sz(st) && a[st.back()] > a[i]) {
                rm[st.back()] = i;
                st.pop_back();
            }
            st.push_back(i);
        }
    }
    vector<int> jump(n + 1);
    jump[n] = n;
    for (int i = n - 1; ~i; --i) {
        int t = rm[i];
        if (t - i <= d) jump[i] = jump[t];
        else jump[i] = min(n, i + d);
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len - 1;
            if (a[l] < a[r]) {
                if (jump[l] >= r) dp[l][r] = 1;
                else {
                    for (int k = l + 1; k <= r - 1; ++k) {
                        dp[l][r] = min(dp[l][r], dp[l][k] + dp[k][r]);
                    }
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (dp[u][v] == INF) { cout << 0 << '\n'; }
        else if (t == 1) {
             cout << 1 << '\n';
        } else {
            cout << dp[u][v] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}