#ifndef LOCALEGOR
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

struct DSU {
    int n;
    vector<int> par, mx;
    DSU () {}
    DSU(int n) : n(n) {
        par.resize(n);
        mx.resize(n);
        for (int i = 0; i < n; ++i) {
            par[i] = i;
            mx[i] = i;
        }
    }
    int find_par(int v) {
        if (v == par[v]) return v;
        return par[v] = find_par(par[v]);
    }
    bool unite(int a, int b) {
        a = find_par(a);
        b = find_par(b);
        if (a == b) return false;
        if (rnd() & 1) {
            par[a] = b;
            mx[b] = max(mx[b], mx[a]);
        } else {
            par[b] = a;
            mx[a] = max(mx[a], mx[b]);
        }
        return true;
    }
};

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    vector<int> idx(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        idx[a[i]] = i;
    }

//    vector<int> rm(n, n);
//    {
//        vector<int> st;
//        for (int i = 0; i < n; ++i) {
//            while (sz(st) && a[st.back()] > a[i]) {
//                rm[st.back()] = i;
//                st.pop_back();
//            }
//            st.push_back(i);
//        }
//    }
    DSU dsu(n);
    vector<int> jump(n);
    set<int> st;
    for (int i = 0; i < n; ++i) {
        int j = idx[i];
        auto it = st.lower_bound(j);
        if (it != st.end() && *it - j <= d) dsu.unite(j, *it);
        if (it != st.begin()) {
            --it;
            if (j - *it <= d) dsu.unite(j, *it);
        }
        jump[j] = dsu.mx[dsu.find_par(j)];
        st.insert(j);
    };
    if (g <= 2) {
        vector<vector<int>> dp(n, vector<int>(n, INF));
        for (int i = 0; i < n; ++i) {
            dp[i][i] = 0;
        }
        for (int len = 2; len <= n; ++len) {
            for (int l = 0; l + len <= n; ++l) {
                int r = l + len - 1;
                if (a[l] < a[r]) {
                    if (r - jump[l] <= d) dp[l][r] = 1;
                    for (int k = l + 1; k <= r - 1; ++k) {
                        dp[l][r] = min(dp[l][r], dp[l][k] + dp[k][r]);
                    }
                }
            }
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int t;
            cin >> t;
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            if (dp[u][v] >= INF) { cout << 0 << '\n'; }
            else if (t == 1) {
                cout << 1 << '\n';
            } else {
                cout << dp[u][v] << '\n';
            }
        }
    } else {
        vector<int> dp(n, INF);
        dp[n - 1] = 0;
        set<pair<int, int>> st;
        st.insert({a[n - 1], n - 1});
        for (int i = n - 2; ~i; --i) {
            if (i + d + 1 < n) {
                st.erase({a[i + d + 1], i + d + 1});
            }
            if (n - 1 - jump[i] <= d) dp[i] = 1;
            else {
                auto vl = st.rbegin()->first;
                if (vl > a[i]) dp[i] = 1 + dp[st.rbegin()->second];
            }
            st.insert({a[i], i});
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int t;
            cin >> t;
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            if (dp[u] >= INF) { cout << 0 << '\n'; }
            else if (t == 1) {
                cout << 1 << '\n';
            } else {
                cout << dp[u] << '\n';
            }
        }
    }

}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}