#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

long long n, d, group;
vector<long long> v;

void solve2()
{
	vector<vector<long long>> g(n);
	for (long long i = n - 1; i > -1; i--)
	{
		long long rest = d;
		long long to = i;
		for (long long j = i + 1; j < n; j++)
		{
			rest--;
			if (rest < 0)
			{
				break;
			}
			if (v[j] >= v[i])
			{
				continue;
			}

			rest = d;
			to = j;
		}

		for (long long j = i + 1; j <= to + d; j++)
		{
			if (j >= n)
			{
				break;
			}

			if (v[j] > v[i])
			{
				g[i].push_back(j);
			}
		}
	}

	vector<vector<long long>> dist(n, vector<long long>(n, INF));
	for (long long i = n - 1; i > -1; i--)
	{
		dist[i][i] = 0;
		for (auto& j : g[i])
		{
			for (long long k = 0; k < n; k++)
			{
				if (dist[j][k] == INF)
				{
					continue;
				}

				dist[i][k] = min(dist[i][k], 1 + dist[j][k]);
			}
		}
	}

	long long q;
	cin >> q;
	while (q--)
	{
		long long t, a, b;
		cin >> t >> a >> b;
		a--; b--;
		if (a > b || v[a] > v[b] || dist[a][b] >= INF)
		{
			cout << 0 << "\n";
			continue;
		}

		if (t == 1)
		{
			cout << 1 << "\n";
		}
		else
		{
			cout << dist[a][b] << "\n";
		}
	}
}

void solve()
{
	cin >> n >> d >> group;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	if (group <= 2)
	{
		solve2();
		return;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
