#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define st string
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define ll long long
#define ld long double

#define int long long

using namespace std;
using vl = vec<int>;
using vi = vec<int>;
using vvi = vec<vi>;
using pi = pair<int, int>;
using vpi = vec<pi>;
using vvvi = vec<vvi>;
using vvpi = vec<vec<pi>>;
using vvvpi = vec<vvpi>;
using vvvvi = vec<vvvi>;
using vppi = vec<pair<pair<int, int>, pair<int, int>>>;

using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18;
const int M = 1e9 + 7;

struct seg_tree {
    struct Node {
        int pref = 0;
        int suff = 0;
        int id = INF;
    };

    vec<Node> t;
    int d = 0;

    void init(int n, int dd) {
        d = dd;
        int k = 1;
        while (k < n) k *= 2;
        t.resize(2 * k - 1);
    }

    Node recalc(int tl, int tr, Node& ch1, Node& ch2) {
        int m = (tr + tl) / 2;
        Node ans;
        ans.pref = ch1.pref;
        if (ch1.pref == m - tl) {
            ans.pref += ch2.pref;
        }
        ans.suff = ch2.suff;
        if (ch2.suff == tr - m) {
            ans.suff += ch1.suff;
        }
        int idd = min(ch1.id, ch2.id);
        int idd2 = (ans.pref >= d ? tl : INF);
        int idd3 = (ans.suff >= d ? tr - ans.suff : INF);
        ans.id = min({idd, idd2, idd3});
        return ans;
    }

    void upd(int v, int tl, int tr, int id) {
        if (tr - tl == 1) {
            t[v] = {1, 1};
            if (d == 1) {
                t[v].id = tl;
            }
            return;
        }
        int m = (tl + tr) / 2;
        if (id < m) {
            upd(2 * v + 1, tl, m, id);
        }
        else {
            upd(2 * v + 2, m, tr, id);
        }
        t[v] = recalc(tl, tr, t[2 * v + 1], t[2 * v + 2]);
    }

    Node get(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l) {
            return {0, 0, INF};
        }
        if (tl >= l && tr <= r) {
            return t[v];
        }
        int m = (tl + tr) / 2;
        Node ans1 = get(2 * v + 1, tl, m, l, r);
        Node ans2 = get(2 * v + 2, m, tr, l, r);
        Node now = recalc(l, r, ans1, ans2);
        return now;
    }
};

struct seg_tree_max {
    vi t;

    void init(int n) {
        int k = 1;
        while (k < n) k *= 2;
        t.assign(2 * k - 1, -INF);
    }

    void upd(int v, int tl, int tr, int id, int val) {
        if (tr - tl == 1) {
            t[v] = val;
            return;
        }
        int m = (tl + tr) / 2;
        if (id < m) {
            upd(2 * v + 1, tl, m, id, val);
        }
        else {
            upd(2 * v + 2, m, tr, id, val);
        }
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l) {
            return -INF;
        }
        if (tl >= l && tr <= r) {
            return t[v];
        }
        int m = (tl + tr) / 2;
        int ans1 = get(2 * v + 1, tl, m, l, r);
        int ans2 = get(2 * v + 2, m, tr, l, r);
        return max(ans1, ans2);
    }
};

void solve() {
    int n, d, g; cin >> n >> d >> g;
    vi a(n);
    vpi b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        b[i] = {a[i], i};
    }
    sort(all(b));
    reverse(all(b));
    vi dp(n, INF);
    int mxa = a[n - 1];
    seg_tree t_bl;
    seg_tree_max t_mx;
    t_bl.init(n, d);
    t_mx.init(n);
    for (auto [id, an] : b) {
        int mxto = t_bl.get(0, 0, n, id, n).id;
        mxto = min(mxto + d - 1, n - 1);
        int cango = t_mx.get(0, 0, n, id, mxto + 1);
        if (cango != -INF) {
            dp[an] = dp[cango] + 1;
        }
        t_bl.upd(0, 0, n, id);
        if (an <= mxa) {
            t_mx.upd(0, 0, n, id, an);
        }
        if (an == mxa) {
            dp[an] = 0;
        }
    }
    int q; cin >> q;
    while (q--) {
        int t, u, v; cin >> t >> u >> v;
        u--; v--;
        if (t == 2) {
            cout << dp[u] << '\n';
        }
        else {
            cout << (dp[u] != INF ? 1 : 0) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}