#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
using namespace std;

const int maxn = 1e5 + 5, inf = 1e18, mod = 1e9 + 7;

struct point {
    int l, r, ln, mx;

    point() {
        l = 0, r = 0, ln = 0, mx = 0;
    }

    point(int x) {
        l = r = ln = mx = x;
    }
};

struct TREE {
    vector <point> tree, f;

    TREE() {

    }

    TREE(int n) {
        tree.resize(4 * n);
        f.resize(4 * n);
    }



    void build(int l, int r, int h) {
        if (l + 1 == r) {
            tree[h].ln = 1;
            tree[h].l = tree[h].r = tree[h].mx = 1;
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        build(l, m, h1);
        build(m, r, h2);
        tree[h].ln = tree[h1].ln + tree[h2].ln;
        tree[h].l = tree[h].r = tree[h].mx = tree[h].ln;
    }

    void upd(int l, int r, int h, int pos) {
        if (l + 1 == r) {
            tree[h].l = tree[h].r = tree[h].mx = 0;
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        if (pos < m) {
            upd(l, m, h1, pos);
        } else {
            upd(m, r,  h2, pos);
        }
        tree[h].l = tree[h1].l + tree[h2].l * (tree[h1].l == tree[h1].ln);
        tree[h].r = tree[h2].r + tree[h1].r * (tree[h2].r == tree[h2].ln);
        tree[h].mx = max(tree[h1].r + tree[h2].l, max(max(tree[h1].mx, tree[h2].mx), max(tree[h].l, tree[h].r)));
    }

    point get(int l, int r, int h, int tl, int tr) {
        if (tl <= l && r <= tr) {
            return tree[h];
        }
        if (tr <= l || r <= tl) {
            return point(0);
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        auto p1 = get(l, m, h1, tl, tr);
        auto p2 = get(m, r, h2, tl, tr);
        point p;
        p.l = p1.l + p2.l * (p1.l == p1.ln);
        p.r = p2.r + p1.r * (p2.r == p2.ln);
        p.mx = max(p1.r + p2.l, max(max(p1.mx, p2.mx), max(p.l, p.r)));
        p.ln = p1.ln + p2.ln;
        return p;
    }

    TREE(vector <int> & a) {
        TREE(sz(a));
        build(0, sz(a), 0);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, d, g;
    cin >> n >> d >> g;
    vector <int> a(n + 1);
    vector <vector <int> > st;
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
        st.push_back({a[i], 0, i});
    }
    ll q;
    cin >> q;
    vector <vector <int> > qq;
    vector <int> ans(q);
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
//        cout << t << " " << u << " " << v << endl;
//        cout << sz(qq) << " " << a[v] << endl;
        qq.push_back({t, u, v});
        st.push_back({a[v], 1, sz(qq) - 1});
//        cout << (a[u] < a[v]) << "\n";
    }
    sort(all(st));
    TREE tree(n + 1);
    tree.build(1, n + 1, 0);
//    return 0;
    for (int i = 0; i < sz(st); i++) {
//        cout << st[i][0] << "    " << st[i][1] << " " << st[i][2] << endl;
        if (!st[i][1]) {
            tree.upd(1, n + 1, 0, st[i][2]);
        } else {
            int id = st[i][2];
            auto p = tree.get(1, n + 1, 0, qq[id][1], qq[id][2] + 1);
//            cout << p.l << " " << p.r << " " << p.ln << endl;
            if (p.mx <= d && a[qq[id][1]] < a[qq[id][2]]) {
                ans[id] = 1;
            } else {
                ans[id] = 0;
            }
        }
    }
//    return 0;
    for (auto & e : ans) {
        cout << e << "\n";
    }
}
