#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
using namespace std;

const int maxn = 1e5 + 5, inf = 1e18, mod = 1e9 + 7;

struct point {
    int l, r, ln, mx, pos = 0;

    point() {
        l = 0, r = 0, ln = 0, mx = 0, pos = 0;
    }

    point(int x) {
        l = r = ln = mx = x, pos = x;
    }
};

int d;

struct TREE {
    vector <point> tree, f;

    TREE() {

    }

    TREE(int n) {
        tree.resize(4 * n);
        f.resize(4 * n);
    }



    void build(int l, int r, int h, int x) {
        if (l + 1 == r) {
            tree[h].ln = 1;
            tree[h].l = tree[h].r = tree[h].mx = x;
            tree[h].pos = l * (tree[h].l == d);
//            if (!tree[h].pos)
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        build(l, m, h1, x);
        build(m, r, h2, x);
        tree[h].ln = tree[h1].ln + tree[h2].ln;
        tree[h].l = tree[h].r = tree[h].mx = tree[h].ln;
        tree[h].pos = l * (tree[h].ln >= d);
    }

    void upd(int l, int r, int h, int pos, int x) {
        if (l + 1 == r) {
            tree[h].l = tree[h].r = tree[h].mx = x;
            tree[h].pos = l * (tree[h].l == d);
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        if (pos < m) {
            upd(l, m, h1, pos, x);
        } else {
            upd(m, r,  h2, pos, x);
        }
        tree[h].l = tree[h1].l + tree[h2].l * (tree[h1].l == tree[h1].ln);
        tree[h].r = tree[h2].r + tree[h1].r * (tree[h2].r == tree[h2].ln);
        tree[h].mx = max(tree[h1].r + tree[h2].l, max(max(tree[h1].mx, tree[h2].mx), max(tree[h].l, tree[h].r)));
        if (tree[h1].mx >= d) {
            tree[h].pos = tree[h1].pos;
        } else if (tree[h1].r + tree[h2].l >= d) {
            tree[h].pos = m - tree[h1].r;
        } else {
            tree[h].pos = tree[h2].pos;
        }
    }

    point get(int l, int r, int h, int tl, int tr) {
        if (tl <= l && r <= tr) {
            return tree[h];
        }
        if (tr <= l || r <= tl) {
            return point(0);
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        auto p1 = get(l, m, h1, tl, tr);
        auto p2 = get(m, r, h2, tl, tr);
        point p;
        p.l = p1.l + p2.l * (p1.l == p1.ln);
        p.r = p2.r + p1.r * (p2.r == p2.ln);
        p.mx = max(p1.r + p2.l, max(max(p1.mx, p2.mx), max(p.l, p.r)));
        p.ln = p1.ln + p2.ln;
        if (p1.mx >= d) {
            p.pos = p1.pos;
        } else if (p1.r + p2.l >= d) {
            p.pos = m - p1.r;
        } else {
            p.pos = p2.pos;
        }
        return p;
    }

    TREE(vector <int> & a, int x) {
        TREE(sz(a));
        build(0, sz(a), 0, x);
    }
};

struct SUM_TREE {
    vector <int> tree, f;

    SUM_TREE() {

    }

    SUM_TREE(int n) {
        tree.resize(4 * n);
        f.resize(4 * n);
    }



    void build(int l, int r, int h) {
        if (l + 1 == r) {
            tree[h] = inf;
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        build(l, m, h1);
        build(m, r, h2);
        tree[h] = min(tree[h1], tree[h2]);
    }

    void upd(int l, int r, int h, int pos, int x) {
        if (l + 1 == r) {
            tree[h] = x;
            return;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        if (pos < m) {
            upd(l, m, h1, pos, x);
        } else {
            upd(m, r,  h2, pos, x);
        }
        tree[h] = min(tree[h1], tree[h2]);
    }

    int get(int l, int r, int h, int tl, int tr) {
        if (tl <= l && r <= tr) {
            return tree[h];
        }
        if (tr <= l || r <= tl) {
            return inf;
        }
        int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
        return min(get(l, m, h1, tl, tr), get(m, r, h2, tl, tr));
    }

    SUM_TREE(vector <int> & a) {
        TREE(sz(a));
        build(0, sz(a), 0);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, g;
    cin >> n >> d >> g;
    vector <int> a(n + 1);
    vector <vector <int> > st;
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
        st.push_back({a[i], 0, i});
    }
    if (n <= 1000) {
        vector <vector <int> > gg(n + 1);
        for (int i = 1; i < n + 1; i++) {
            int cnt = 0;
            int f = 1;
            for (int  j = i + 1; j < n + 1; j++) {
                if (a[i] > a[j]) {
                    cnt = 0;
                    continue;
                } 
                if (f) {
                    gg[i].emplace_back(j);
                }
                cnt++;
                if(cnt >= d) {
                    f = 0;
                }
                
//                int cnt = 0;
//                int f = 1;
//                for (int k = i + 1; k < j; k++) {
//                    if (a[i] < a[k]) {
//                        cnt++;
//                    } else {
//                        cnt = 0;
//                    }
//                    if (cnt >= d) {
//                        f = 0;
//                    }
//                }
                if (f) {
                    gg[i].emplace_back(j);
                }
            }

        }
        vector <vector <int> > dst(n + 1, vector <int> (n + 1, inf));
        for (int i = 1; i < n + 1; i++) {
            deque <int> dd = {i};
            dst[i][i] = 0;
            while (!dd.empty()) {
                int h = dd.front();
                dd.pop_front();
                for (auto & e : gg[h]) {
                    if (dst[i][h] + 1 < dst[i][e]) {
                        dst[i][e] = dst[i][h] + 1;
                        dd.push_back(e);
                    }
                }
            }
        }
        ll q;
        cin >> q;
        while (q--) {
            int t, u, v;
            cin >> t >> u >> v;
            if (dst[u][v] == inf) {
                cout << 0 << "\n";
            } else if (t == 1) {
                cout << 1 << "\n";
            } else {
                cout << dst[u][v] << "\n";
            }
        }

        return 0;
    }
    ll q;
    cin >> q;
    vector <vector <int> > qq;
    vector <int> ans(q);
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
//        cout << t << " " << u << " " << v << endl;
//        cout << sz(qq) << " " << a[v] << endl;
        qq.push_back({t, u, v});
        st.push_back({a[v], 1, sz(qq) - 1});
//        cout << (a[u] < a[v]) << "\n";
    }
    sort(all(st));
    TREE tree(n + 1);
    tree.build(1, n + 1, 0, 1);
    SUM_TREE dp_tree(n + 1);
    dp_tree.build(1, n + 1, 0);
    vector <int> dp(n + 1, inf);
//    return 0;
    for (int i = 0; i < sz(st); i++) {
//        cout << st[i][0] << "    " << st[i][1] << " " << st[i][2] << endl;
        if (!st[i][1]) {
            tree.upd(1, n + 1, 0, st[i][2], 0);
//            if (st[i][2] == n) {
//                dp_tree.upd(1, n + 1, 0, st[i][2], 0);
//                continue;
//            }
//            auto p = tree.get(1, n + 1, 0, st[i][2], n + 1);
//            cout << st[i][0] << " " << p.pos << endl;
//            if (p.pos == 0) {
//                int mn = dp_tree.get(1, n + 1, 0, st[i][2], n + 1);
//                dp[st[i][2]] = min(inf, mn + 1);
//                dp_tree.upd(1, n + 1, 0, st[i][2], dp[st[i][2]]);
//            } else {
//                int mn = dp_tree.get(1, n + 1, 0, st[i][2], p.pos + d + 1);
//                dp[st[i][2]] = min(inf, mn + 1);
//                dp_tree.upd(1, n + 1, 0, st[i][2], dp[st[i][2]]);
//            }

        } else {
            int id = st[i][2];
            auto p = tree.get(1, n + 1, 0, qq[id][1], qq[id][2] + 1);
//            cout << p.l << " " << p.r << " " << p.ln << endl;
            if (p.mx < d && a[qq[id][1]] < a[qq[id][2]]) {


                ans[id] = 1;

            } else {
                ans[id] = 0;
            }
        }
        st[i][1] ^= 1;
//        st[i][0] = qq[st[i][2]][1];
    }
    st.clear();
    for (int i = 1; i < n + 1; i++) {
        st.push_back({a[i], 0, i});
    }
//    return 0;
    sort(all(st));
    reverse(all(st));
    tree.build(1, n + 1, 0, 0);

    for (int i = 0; i < sz(st); i++) {
//        cout << st[i][0] << "    " << st[i][1] << " " << st[i][2] << endl;
        if (!st[i][1]) {
            if (st[i][2] == n) {
                tree.upd(1, n + 1, 0, n, 1);
                dp_tree.upd(1, n + 1, 0, st[i][2], 0);
                continue;
            } else {

            }
            auto p = tree.get(1, n + 1, 0, st[i][2], n + 1);
//            cout << st[i][2] << " " << p.pos << " " << p.mx << endl;
            if (p.pos == 0) {
                int mn = dp_tree.get(1, n + 1, 0, st[i][2], n + 1);
                dp[st[i][2]] = min(inf, mn + 1);
                dp_tree.upd(1, n + 1, 0, st[i][2], dp[st[i][2]]);
//                cout << st[i][2] << " " << dp[st[i][2]] << endl;
            } else {
                int mn = dp_tree.get(1, n + 1, 0, st[i][2], p.pos + d);
                dp[st[i][2]] = min(inf, mn + 1);
                dp_tree.upd(1, n + 1, 0, st[i][2], dp[st[i][2]]);
//                cout << st[i][2] << " " << dp[st[i][2]] << endl;

            }
            tree.upd(1, n + 1, 0, st[i][2], 1);

        } else {
            continue;
        }

    }
//    return 0;
    for (int i = 0; i < sz(qq); i++) {
        if (qq[i][0] == 1 || !qq[i][0]) {
            cout << ans[i] << "\n";
        } else {
            if (dp[qq[i][1]] == inf) {
                cout << 0 << "\n";
            } else {
                cout << dp[qq[i][1]] << "\n";
            }
        }
    }
}
