#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;



ll Buravchik_g6(map<ll, ll>& a, ll u, ll v, ll d, ll minimum_prev) {
	if (minimum_prev > 10) return 0;
	ll minimum = 1;
	ll prevpoint = u;
	map<ll, ll> prevpoint_by_last_stay;
	vector<ll> last_stays;
	ll last_u = u;
	for (ll i = u + 1; i <= v; i++) {
		if (i - prevpoint > d) {
			ll minimum_out = INT64_MAX;
			for (ll j = last_stays.size() - 1; j > -1; j--) {
				if (last_stays[j] <= prevpoint) {
					break;
				}
				ll out = Buravchik_g6(a, last_stays[j], v, d, minimum_prev + 1);
				if (out != 0) minimum_out = min(out, minimum_out);
			}
			if (minimum_out == INT64_MAX) return 0;
			return minimum + minimum_out;
		}
		if (a[last_u] < a[i] && a[i] < a[v]) {
			last_stays.push_back(i);
		}
		if (a[i] < a[last_u]) {
			prevpoint = i;
		}
		for (ll j = last_stays.size() - 1; j > -1; j--) {
			if (i - last_stays[j] < d) {
				break;
			}
			if (a[i] < a[last_stays[j]]) {
				prevpoint_by_last_stay[last_stays[j]] = i;
			}
		}
	}
	return minimum;
}


ll Buravchik(map<ll, ll>& a, ll u, ll v, ll d) {
	ll minimum = 1;
	ll prevpoint = u;
	ll prevpoint_by_last_stay = u;
	ll last_stay = u;
	ll prevpoint_by_prev_last_stay = u;
	ll prev_last_stay = u;
	ll last_u = u;
	for (ll i = u + 1; i <= v; i++) {
		if (i - prevpoint > d) {
			ll minimum_out = INT64_MAX;
			if (last_stay > prevpoint) {
				ll out = Buravchik(a, last_stay, v, d);
				if (out != 0) minimum_out = min(out, minimum_out);
			}
			if (prev_last_stay > prevpoint) {
				ll out = Buravchik(a, prev_last_stay, v, d);
				if (out != 0) minimum_out = min(out, minimum_out);
			}
			if (minimum_out == INT64_MAX) return 0;
			return minimum + minimum_out;
		}
		if (a[last_u] < a[i] && a[i] < a[v]) {
			prev_last_stay = last_stay;
			last_stay = i;
		}
		if (a[i] < a[last_u]) {
			prevpoint = i;
		}
	}
	return minimum;
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);


	ll n, d, g;
	cin >> n >> d >> g;
	map<ll, ll> a;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}

	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++) {
		ll t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		if (a[u] >= a[v] || u >= v) {
			cout << 0 << '\n';
			continue;
		}
		if (g == 4) {

		}
		if (g == 6) {
			ll out = Buravchik_g6(a, u, v, d, 1);
			if (t == 1) cout << (out > 0 ? 1 : 0) << '\n';
			else cout << out << '\n';
			continue;
		}
		ll out = Buravchik(a, u, v, d);
		if (t == 1) cout << (out > 0 ? 1 : 0) << '\n';
		else cout << out << '\n';
	}
}
