#pragma GCC target("sse,sse2")
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math,inline")
#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e9+2;
const ll N=1e6+2;

ll n,d;

namespace brute
{
    const ll M=1002;

    ll arr[M],dist[M][M];
    char can[M][M];

    void solve()
    {
        for(ll i=0;i<n;i++)
            cin>>arr[i];

        for(ll i=0;i<n;i++)
        {
            for(ll j=0;j<n;j++)
                dist[i][j]=INF;
        }

        for(ll i=0;i<n;i++)
            dist[i][i]=0;

        for(ll i=0;i<n;i++)
        {
            ll lst=i;

            for(ll j=i;j<n;j++)
            {
                if(j-lst>d) break;

                if(arr[j]<arr[i])
                    lst=j;

                else if(j>i)
                    dist[i][j]=1;
            }
        }

        for(ll k=0;k<n;k++)
        {
            for(ll i=0;i<n;i++)
            {
                for(ll j=0;j<n;j++)
                    dist[i][j]=min(dist[i][j],dist[i][k]+dist[k][j]);
            }
        }

        ll q;
        cin>>q;

        while(q--)
        {
            ll t,a,b;
            cin>>t>>a>>b;
            a--, b--;
            if(t==1) cout<<(dist[a][b]!=INF)<<endl;
            else cout<<(dist[a][b]==INF? 0:dist[a][b])<<endl;
        }
    }
}

namespace vn
{
    struct segtree
    {
        struct node
        {
            ll pref=1,suf=1,mx=1,sz=1;
            bool ex=0;
        };

        node add(node a, node b)
        {
            if(!a.ex) return b;
            if(!b.ex) return a;
            node c;
            c.pref=(a.pref==a.sz? a.pref+b.pref:a.pref);
            c.suf=(b.suf==b.sz? b.suf+a.suf:b.suf);
            c.mx=max({a.mx,b.mx,a.suf+b.pref});
            c.sz=a.sz+b.sz;
            c.ex=1;
            return c;
        }

        ve<node> tree;
        ll sz;

        void build(ll v, ll tl, ll tr)
        {
            if(tr-tl==1)
            {
                tree[v].ex=1;
                return;
            }

            ll tm=(tl+tr)/2;
            build(v*2+1,tl,tm);
            build(v*2+2,tm,tr);
            tree[v]=add(tree[v*2+1],tree[v*2+2]);
        }

        void init(ll n)
        {
            sz=1;
            while(sz<n) sz*=2;
            tree.assign(sz*2,node());
            build(0,0,sz);
        }

        void upd(ll k, ll v, ll tl, ll tr)
        {
            if(tr-tl==1)
            {
                tree[v].pref=tree[v].suf=tree[v].mx=0;
                return;
            }

            ll tm=(tl+tr)/2;
            if(k<tm) upd(k,v*2+1,tl,tm);
            else upd(k,v*2+2,tm,tr);
            tree[v]=add(tree[v*2+1],tree[v*2+2]);
        }

        void upd(ll k)
        {
            upd(k,0,0,sz);
        }

        node get(ll l, ll r, ll v, ll tl, ll tr)
        {
            if(l>=tr||tl>=r) return node();
            if(l<=tl&&tr<=r) return tree[v];

            ll tm=(tl+tr)/2;
            node a=get(l,r,v*2+1,tl,tm);
            node b=get(l,r,v*2+2,tm,tr);
            return add(a,b);
        }

        ll get(ll l, ll r)
        {
            return get(l,r+1,0,0,sz).mx;
        }
    };

    struct treap
    {
        struct node
        {
            ll key,prior,val,mn;
            ll l=-1,r=-1;

            node(ll x, ll y)
            {
                key=x;
                val=mn=y;
                prior=gen();
            }
        };

        ve<node> t;

        void recalc(ll v)
        {
            if(v==-1) return;
            t[v].mn=t[v].val;
            if(t[v].l!=-1) t[v].mn=min(t[v].mn,t[t[v].l].mn);
            if(t[v].r!=-1) t[v].mn=min(t[v].mn,t[t[v].r].mn);
        }

        ll merge(ll a, ll b)
        {
            if(a==-1) return b;
            if(b==-1) return a;

            if(t[a].prior>t[b].prior)
            {
                t[a].r=merge(t[a].r,b);
                recalc(a);
                return a;
            }

            t[b].l=merge(a,t[b].l);
            recalc(b);
            return b;
        }

        pll split(ll v, ll x)
        {
            if(v==-1) return {-1,-1};

            if(x<t[v].key)
            {
                pll p=split(t[v].l,x);
                t[v].l=p.S;
                recalc(v);
                return {p.F,v};
            }

            pll p=split(t[v].r,x);
            t[v].r=p.F;
            recalc(v);
            return {v,p.S};
        }

        void add(ll &rt, ll x, ll y)
        {
            ll a,b;
            tie(a,b)=split(rt,x);
            t.PB(node(x,y));
            a=merge(a,sz(t)-1);
            rt=merge(a,b);
        }

        ll get(ll &rt, ll x)
        {
            ll a,b;
            tie(a,b)=split(rt,x);
            ll res=(b==-1? INF:t[b].mn);
            rt=merge(a,b);
            return res;
        }
    };

    struct merge_sort_tree
    {
        ve<ll> tree;
        treap t;
        ll sz;

        void init(ll n)
        {
            sz=1;
            while(sz<n) sz*=2;
            tree.assign(sz*2,-1);
        }

        void upd(ll k, ll x, ll y, ll v, ll tl, ll tr)
        {
            t.add(tree[v],x,y);
            if(tr-tl==1) return;
            ll tm=(tl+tr)/2;
            if(k<tm) upd(k,x,y,v*2+1,tl,tm);
            else upd(k,x,y,v*2+2,tm,tr);
        }

        void upd(ll k, ll x, ll y)
        {
            upd(k,x,y,0,0,sz);
        }

        ll get(ll l, ll r, ll x, ll v, ll tl, ll tr)
        {
            if(l>=tr||tl>=r||tree[v]==-1) return INF;
            if(l<=tl&&tr<=r) return t.get(tree[v],x);

            ll tm=(tl+tr)/2;
            ll a=get(l,r,x,v*2+1,tl,tm);
            ll b=get(l,r,x,v*2+2,tm,tr);
            return min(a,b);
        }

        ll get(ll l, ll r, ll x)
        {
            return get(l,r+1,x,0,0,sz);
        }
    };

    ll arr[N],lft[N];

    void calc_lft()
    {
        ve<pll> v(n);

        for(ll i=0;i<n;i++)
            v[i]={arr[i],i};

        sort(all(v));
        segtree st;
        st.init(n);

        for(pll p:v)
        {
            ll l=p.S,r=n-1;
            st.upd(p.S);

            while(l<r)
            {
                ll mid=(l+r+1)/2;
                if(st.get(p.S,mid)<=d) l=mid;
                else r=mid-1;
            }

            lft[p.S]=l;
        }

        /*for(ll i=0;i<n;i++)
            cout<<lft[i]<<' ';

        cout<<endl;*/
    }

    ll dp[N];

    void calc_dp()
    {
        fill(dp,dp+n,INF);
        dp[n-1]=0;
        merge_sort_tree st;
        st.init(n);

        for(ll i=n-1;i>=0;i--)
        {
            dp[i]=min(dp[i],st.get(i,lft[i],arr[i]));
            st.upd(i,arr[i],dp[i]+1);
        }

        /*for(ll i=0;i<n;i++)
            cout<<dp[i]<<' ';

        cout<<endl;*/
    }

    void solve()
    {
        for(ll i=0;i<n;i++)
            cin>>arr[i];

        calc_lft();
        calc_dp();
        ll q;
        cin>>q;

        while(q--)
        {
            ll t,a,b;
            cin>>t>>a>>b;
            a--, b--;
            if(t==1) cout<<(dp[a]!=INF)<<endl;
            else cout<<(dp[a]==INF? 0:dp[a])<<endl;
        }
    }
}

void solve()
{
    ll g;
    cin>>n>>d>>g;
    if(g==3||g==4||g==5) vn::solve();
    //brute::solve();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}

/*
6 1 3
2 1 3 4 5 6
2
2 1 6
1 2 6
*/
