#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

#ifndef ONPC
    const int MAXN = 303030;
#else
    const int MAXN = 1000;
#endif

int a[MAXN], ind[MAXN], ans[MAXN];
vector<array<int, 3>> q[MAXN];

struct node {
    ll s, mn_pref;
    int i;
};
const node NEUTRAL = {0, (ll)1e18, 0};

node merge(const node& a, const node& b) {
    node c;
    c.s = a.s + b.s;
    if (a.mn_pref < 0 || a.mn_pref < a.s + b.mn_pref) {
        c.mn_pref = a.mn_pref;
        c.i = a.i;
    } else {
        c.mn_pref = a.s + b.mn_pref;
        c.i = b.i;
    }
    return c;
}

node t[1 << 20];

void build(int x, int l, int r) {
    if (l + 1 == r) {
        t[x] = {-1, -1, l};
        return;
    }

    int m = (l + r) / 2;
    build(2 * x + 1, l, m);
    build(2 * x + 2, m, r);
    t[x] = merge(t[2 * x + 1], t[2 * x + 2]);
}

void update(int i, int v, int x, int l, int r) {
    if (l + 1 == r) {
        t[x].s = t[x].mn_pref = v;
        return;
    }

    int m = (l + r) / 2;
    if (i < m) {
        update(i, v, 2 * x + 1, l, m);
    } else {
        update(i, v, 2 * x + 2, m, r);
    }
    t[x] = merge(t[2 * x + 1], t[2 * x + 2]);
}

node get(int lq, int rq, int x, int l, int r) {
    if (rq <= l || r <= lq) return NEUTRAL;
    if (lq <= l && r <= rq) return t[x];

    int m = (l + r) / 2;
    return merge(get(lq, rq, 2 * x + 1, l, m), get(lq, rq, 2 * x + 2, m, r));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, group;
    cin >> n >> d >> group;

    for (int i = 0; i < n; i++) cin >> a[i], a[i]--, ind[a[i]] = i;

    int q_cnt;
    cin >> q_cnt;
    for (int i = 0; i < q_cnt; i++) {
        int type, u, v;
        cin >> type >> u >> v;
        u--; v--;
        q[a[v]].push_back({u, type, i});
    }


    build(0, 0, n);
    for (int i = 0; i < n; i++) {
        update(ind[i], d - 1, 0, 0, n);
        for (auto [lq, type, id] : q[i]) {
            if (a[lq] > i) {
                ans[id] = 0;
                continue;
            }
            auto res = get(ind[i], n, 0, 0, n);

            if (res.mn_pref < 0 && res.i <= ind[i]) {
                ans[id] = 0;
            } else {
                ans[id] = 1;
            }
        }
    }

    for (int i = 0; i < q_cnt; i++) cout << ans[i] << '\n';

    return 0;
}
