#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>
#include <queue>
#include <numbers>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

//#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1000 + 5;
vector<int> gr[N];
vector<int> cgr[N];
int d[N][N];
vector<int> a;
vector<int> used;
int start;

void dfs(int v) {
	used[v] = 1;
	if (a[v] > a[start]) {
		cgr[start].push_back(v);
		return;
	}
	for (int u : gr[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
}

void bfs2(int start, int n) {
	for (int i = 0; i < n; ++i)d[start][i] = -1;
	d[start][start] = 0;
	queue<int> q;
	q.push(start);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : cgr[v]) {
			if (d[start][u] == -1) {
				d[start][u] = d[start][v] + 1;
				q.push(u);
			}
		}
	}
}

const int M = 3e5 + 5;
int t[1 << 23];
const int INF = 1e9;

void upd(int v, int l, int r, int pos, int x) {
	if (l == r - 1) {
		t[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (pos < m)
		upd(2 * v + 1, l, m, pos, x);
	else
		upd(2 * v + 2, m, r, pos, x);
	t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

int ask(int v, int l, int r, int askl, int askr) {
	if (askr <= l || r <= askl || askr <= askl)
		return INF;
	if (askl <= l && r <= askr)
		return t[v];
	int m = (l + r) / 2;
	return min(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}

int get(int v, int l, int r, int pos) {
	if (l == r - 1)return t[v];
	int m = (l + r) / 2;
	if (pos < m)return get(2 * v + 1, l, m, pos);
	else return get(2 * v + 2, m, r, pos);
}

void solve() {
	int n, r, g;
	cin >> n >> r >> g;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
	}
	if (g == 3) {
		for (int i = 0; i < (1 << 23); ++i)t[i] = INF;
		set<int> s;
		vector<int> ans(n);
		upd(0, 0, n, n - 1, 0);
		ans[n - 1] = 0;
		for (int i = n - r - 1; i < n - 1; ++i) {
			upd(0, 0, n, a[i], 1);
			ans[i] = 1;
		}
		for (int i = n - r - 2; i > -1; --i) {
			upd(0, 0, n, a[i + r + 1], INF);
			int x = ask(0, 0, n, a[i] + 1, n) + 1;
			int y = ask(0, 0, n, 0, a[i]);
			upd(0, 0, n, a[i], min(x, y));
			ans[i] = min(x, y);
		}
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i) {
			int t, u, v;
			cin >> t >> u >> v;
			--u, --v;
			int x = ans[u];
			if (x >= INF || a[u] > a[v]) {
				cout << "0\n";
				continue;
			}
			if (t == 1)
				cout << 1 << '\n';
			else
				cout << x << '\n';
		}
		return;
	}
	for (int v = 0; v < n; ++v) {
		for (int u = v + 1; v + r >= u && u < n; ++u) {
			gr[v].push_back(u);
		}
	}
	for (int i = 0; i < n; ++i) {
		start = i;
		used.assign(n, 0);
		dfs(i);
	}
	for (int i = 0; i < n; ++i) {
		bfs2(i, n);
	}
	int q;
	cin >> q;
	for (int _ = 0; _ < q; ++_) {
		int t, u, v;
		cin >> t >> u >> v;
		--u, --v;
		if (t == 1) {
			if (d[u][v] == -1 || a[u] > a[v])
				cout << "0\n";
			else
				cout << "1\n";
		}
		else {
			if (d[u][v] == -1 || a[u] > a[v])
				cout << "0\n";
			else
				cout << d[u][v] << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;
	//cin >> g;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
