#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

vector<int>tree;
void upd(int x, int y, int v, int l, int r) {
    if (r < x || l > x)
        return;
    if (l == r) {
        tree[v] = y;
        return;
    }

    upd(x, y, v * 2 + 1, l, (l + r) / 2);
    upd(x, y, v * 2 + 2, (l + r) / 2 + 1, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int lq, int rq, int v, int l, int r) {
    if (rq < l || lq > r)
        return MD;
    if (lq <= l && r <= rq)
        return tree[v];
    return min(get(lq, rq, v * 2 + 1, l, (l + r) / 2), get(lq, rq, v * 2 + 2, (l + r) / 2 + 1 , r));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, dst, tq;
    cin >> vs >> dst >> tq;
    vector<int>x(vs);
    for (int &i : x)
        cin >> i;

    vector<int>ord(vs);
    iota(all(ord), 0);
    sort(rall(ord), [&](int l, int r) {return x[l] < x[r];});

    tree.assign(vs * 4, MD);
    upd(vs - 1, 0, 0, 0, vs - 1);
    for (int ind = 1; ind < vs; ind++) {
        int i = ord[ind];
        upd(i, get(i + 1, min(vs - 1, i + dst), 0, 0, vs - 1) + 1, 0, 0, vs - 1);
    }

    int qs;
    cin >> qs;
    while (qs--) {
        int tqi;
        cin >> tqi;
        int f, t;
        cin >> f >> t;
        f--, t--;
        int ansi = get(f, f, 0, 0, vs - 1);
        if (ansi == MD)
            cout << 0;
        else {
            cout << (tqi == 1 ? 1 : ansi);
        }
        cout << '\n';
    }
}