#include <iostream>

#include <vector>
#include <set>
#include <map>
#include <deque>

#include <algorithm>
#include <cmath>
#include <assert.h>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

vector<int> tree;

void upd(int x, int y, int v, int l, int r) {
    if (r < x || l > x)
        return;
    if (l == r) {
        tree[v] = y;
        return;
    }

    upd(x, y, v * 2 + 1, l, (l + r) / 2);
    upd(x, y, v * 2 + 2, (l + r) / 2 + 1, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int lq, int rq, int v, int l, int r) {
    if (rq < l || lq > r)
        return MD;
    if (lq <= l && r <= rq)
        return tree[v];
    return min(get(lq, rq, v * 2 + 1, l, (l + r) / 2), get(lq, rq, v * 2 + 2, (l + r) / 2 + 1, r));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, dst, tq;
    cin >> vs >> dst >> tq;
    vector<int> v(vs);
    for (int &i: v)
        cin >> i;
    vector<int> ord(vs);
    iota(all(ord), 0);
    sort(rall(ord), [&](int l, int r) { return v[l] < v[r]; });

    vector<vector<int>> ans(vs, vector<int>(vs, MD));
    for (int t = vs - 1; t >= 0; t--) {
        ans[t][t] = 0;
        for (int i: ord) {
            if (i < t && v[i] < v[t]) {
                int r = i + dst;
                for (int m = i + 1; m <= min(t, r); m++) {
                    if (v[m] < v[i])
                        r = m + dst;
                    ans[i][t] = min(ans[i][t], ans[m][t] + 1);
                }
            }
        }
    }

    int qs;
    cin >> qs;
    while (qs--) {
        int tq;
        cin >> tq;
        int f, t;
        cin >> f >> t;
        f--, t--;
        if (ans[f][t] == MD) {
            cout << 0;
        } else {
            if (tq == 1) cout << 1;
            else cout << ans[f][t];
        }
        cout << '\n';
    }
}