#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;

const int inf = 1e9;

struct segtree {
    vector<i64> t;
    int sz = 1;
    segtree(int n) {
        while (sz < n) sz <<= 1;
        t.assign(sz << 1, inf);
    }
    void set(int v, int x) {
        v += sz - 1;
        t[v] = x;
        while (v) {
            v = (v - 1) / 2;
            t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
        }
    }
    i64 get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return t[v];
        } else if (ql > r || l > qr) {
            return inf;
        }
        int m = (l + r) / 2;
        return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m + 1, r, ql, qr));
    }
    i64 get(int l, int r) {
        return get(0, 0, sz - 1, l, r);
    }
};

struct segtreeMax {
    vector<i64> t;
    int sz = 1;
    segtreeMax(int n) {
        while (sz < n) sz <<= 1;
        t.assign(sz << 1, inf);
    }
    void set(int v, int x) {
        v += sz - 1;
        t[v] = x;
        while (v) {
            v = (v - 1) / 2;
            t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
        }
    }
    i64 get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return t[v];
        } else if (ql > r || l > qr) {
            return -inf;
        }
        int m = (l + r) / 2;
        return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m + 1, r, ql, qr));
    }
    i64 get(int l, int r) {
        return get(0, 0, sz - 1, l, r);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, g;
    cin >> n >> d >> g;

    vector<int> a(n + 1);
    vector<vector<int>> dist(n + 1, vector<int> (n + 1, inf));
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    segtree st(n + 1);
    for (int r = n; r >= 1; --r) {
        dist[r][r] = 0;
//        st.set(a[r], dist[r][r]);
        int ptr = r - 1;
        for (int l = r - 1; l >= 1; --l) {
            if (r - l <= d && a[l] <= a[r]) dist[l][r] = 1;
            while (ptr - l > d) {
                st.set(a[ptr], inf);
                --ptr;
            }
            int val = st.get(1, a[l]);
            dist[l][r] = min(dist[l][r], (val == inf ? inf : val));
            st.set(a[l], dist[l][r]);
        }
        while (ptr > 0) {
            st.set(a[ptr], inf);
            --ptr;
        }
    }

//    debug(dist[1][3]);

    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (t == 1) {
            if (dist[u][v] == inf) cout << 0;
            else cout << 1;
        } else {
            cout << (dist[u][v] == inf ? 0 : max(0ll, dist[u][v]));
        }
        cout << '\n';
    }
}