#pragma gcc optimize("O3, unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

void solve() {
    int n, d, g; cin >> n >> d >> g;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (g <= 2) {
        vector<vector<int>> can(n, vector<int>(n, false)), dist(n, vector<int>(n, mxn));
        vector <pii> v;
        for (int i = 0; i < n; ++i) {
            v.push_back({a[i], i});
        }
        sort(all(v));
        set <int> s {-1, n};
        set <int> bad {-1};
        for (auto i : v) {
            for (int j = i.second + 1; j < n; ++j) {
                if (a[j] > a[i.second]) {
                    auto t = bad.lower_bound(i.second);
                    auto it = s.lower_bound(i.second);
                    if ((t != bad.end() && (*t) + d < j) || (i.second + d < *it && i.second + d < j)) can[i.second][j] = false;
                    else {
                        // debug(i.second << ' ' << j);
                        can[i.second][j] = true;
                    }
                }
            }
            auto it = s.lower_bound(i.second);
            auto it1 = it; --it1;
            if (*it - *it1 <= d) {
                s.insert(i.second);
            }
            else {
                if (i.second - *it1 <= d) {
                    bad.erase(*it1);
                }
                s.insert(i.second);
                if (*it - i.second > d) bad.insert(i.second);
            }
        }
        vector<vector<int>> G(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (can[i][j]) {
                    G[i].push_back(j);
                }
            }
        }
        for (int to = n - 1; to >= 0; --to) {
            for (int from = to - 1; from >= 0; --from) {
                if (can[from][to]) {
                    dist[from][to] = 1;
                }
                else {
                    for (auto j : G[from]) {
                        dist[from][to] = min(dist[from][to], 1 + dist[j][to]);
                    }
                }
            }
        }
        int q; cin >> q;
        while (q--) {
            int t, u, v; cin >> t >> u >> v; --u; --v;
            if (t == 1) {
                cout << (dist[u][v] == mxn ? 0 : 1) << '\n';
            }
            else {
                cout << (dist[u][v] == mxn ? 0 : dist[u][v]) << '\n';
            }
        }
        return;
    }
    vector <int> jump(n, n), dp(n, mxn);
    vector <pii> v;
    for (int i = 0; i < n; ++i) {
        v.push_back({a[i], i});
    }
    sort(all(v));
    set <int> s {-1, n};
    set <int> bad {-1};
    for (auto i : v) {
        auto t = bad.lower_bound(i.second);
        auto it = s.lower_bound(i.second);
        if (*it - i.second > d) {
            jump[i.second] = i.second + d;
        } else {
            if (t != bad.end()) {
                jump[i.second] = *t + d;
            } else {
                jump[i.second] = n - 1;
            }
        }
        auto it1 = it;
        --it1;
        if (*it - *it1 <= d) {
            s.insert(i.second);
        } else {
            if (i.second - *it1 <= d) {
                bad.erase(*it1);
            }
            s.insert(i.second);
            if (*it - i.second > d) bad.insert(i.second);
        }
    }
    dp[n - 1] = 0;
    for (int i = n - 2; i >= 0; --i) {
        if (jump[i] != n) {
            dp[i] = min(dp[i], 1 + dp[jump[i]]);
        }
    }
    int q; cin >> q;
    while (q--) {
        int t, u, v; cin >> t >> u >> v; --u; --v;
        if (t == 1) {
            cout << (dp[u] == mxn ? 0 : 1) << '\n';
        }
        else {
            cout << (dp[u] == mxn ? 0 : dp[u]) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> t;
    while (tt--) solve();
}