#include <iostream>
#include <bitset>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = 3e5 + 123;
int a[MAXN];

struct Query {
    int t;
    int l;
    int r;
    int qi;

    bool operator<(const Query& q) const {
        return a[r] < a[q.r];
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, d, g;
    cin >> n >> d >> g;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<int> ra(n);
    for (int i = 0; i < n; ++i)
        ra[a[i]] = i;
    int q;
    cin >> q;
    vector<Query> qrs(q);
    for (int qi = 0; qi < q; ++qi) {
        cin >> qrs[qi].t >> qrs[qi].l >> qrs[qi].r;
        --qrs[qi].l;
        --qrs[qi].r;
        qrs[qi].qi = qi;
    }
    sort(qrs.begin(), qrs.end());
    set<int> terminal_vertecies;
    bitset<MAXN> active;
    for (int i = 0; i < n; ++i)
        terminal_vertecies.insert(i);
    vector<int> qrans(q);
    int rai = 0;
    for (auto qr : qrs) {
        if (a[qr.l] >= a[qr.r] || qr.l >= qr.r) {
            qrans[qr.qi] = 0;
            continue;
        }
        while (rai < n && rai <= a[qr.r]) {
            int i = ra[rai];
            active[i] = true;
            while (true) {
                auto it = terminal_vertecies.lower_bound(i - d);
                if (it == terminal_vertecies.end() || *it >= i)
                    break;
                //cout << "ERASE " << *it << endl;
                terminal_vertecies.erase(it);
            }
            ++rai;
        }
        //cout << qr.qi << ": " << qr.l << ' ' << qr.r << " | ";
        //for (auto x : terminal_vertecies)
            //cout << x << ' ';
        //for (int i = 0; i < n; ++i)
            //cout << active[i];
        //cout << endl;
        auto lit = terminal_vertecies.lower_bound(qr.l);
        if (lit != terminal_vertecies.end() && *lit < qr.r - d) {
            qrans[qr.qi] = 0;
            continue;
        }
        if (qr.t == 1) {
            qrans[qr.qi] = 1;
            continue;
        }
        qrans[qr.qi] = 2;
    }
    for (int i = 0; i < q; ++i)
        cout << qrans[i] << '\n';
}
