#include <iostream>
#include <bitset>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = 3e5 + 123;
int a[MAXN];
int edg_terminal[MAXN];

struct Query {
    int t;
    int l;
    int r;
    int qi;

    bool operator<(const Query& q) const {
        return a[l] < a[q.l];
    }
};

void init_terminal(int n, int d) {
    vector<int> ra(n);
    for (int i = 0; i < n; ++i)
        ra[a[i]] = i;
    set<int> terminal_vertecies;
    bitset<MAXN> active;
    for (int i = 0; i < n; ++i)
        terminal_vertecies.insert(i);
    for (int rai = 0; rai < n; ++rai) {
        int i = ra[rai];
        active[i] = true;
        while (true) {
            auto it = terminal_vertecies.lower_bound(i - d);
            if (it == terminal_vertecies.end() || *it >= i)
                break;
            //cout << "ERASE " << *it << endl;
            terminal_vertecies.erase(it);
        }
        //edg_terminal[i] = 
        auto it = terminal_vertecies.lower_bound(i);
        if (it == terminal_vertecies.end())
            edg_terminal[i] = n;
        else
            edg_terminal[i] = *it;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, d, g;
    cin >> n >> d >> g;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    init_terminal(n, d);
    int q;
    cin >> q;
    vector<Query> qrs(q);
    for (int qi = 0; qi < q; ++qi) {
        cin >> qrs[qi].t >> qrs[qi].l >> qrs[qi].r;
        --qrs[qi].l;
        --qrs[qi].r;
        qrs[qi].qi = qi;
    }
    vector<int> qrans(q);
    int rai = 0;
    for (auto qr : qrs) {
        if (a[qr.l] >= a[qr.r] || qr.l >= qr.r) {
            qrans[qr.qi] = 0;
            continue;
        }
        int movi = qr.l;
        while (qr.l < qr.r) {
            if (edg_terminal[qr.l] + d >= qr.r) {
                ++qrans[qr.qi];
                break;
            }
            int besti = qr.l;
            while (movi + 1 <= edg_terminal[qr.l] + d) {
                ++movi;
                if (a[besti] < a[movi] && a[movi] < a[qr.r])
                    besti = movi;
            }
            if (besti == qr.l) {
                qrans[qr.qi] = 0;
                break;
            }
            ++qrans[qr.qi];
            qr.l = besti;
        }
        if (qr.t == 1 && qrans[qr.qi] > 0) {
            qrans[qr.qi] = 1;
        }
        //cout << qr.qi << ": " << qr.l << ' ' << qr.r << " | ";
        //for (auto x : terminal_vertecies)
            //cout << x << ' ';
        //for (int i = 0; i < n; ++i)
            //cout << active[i];
        //cout << endl;
    }
    for (int i = 0; i < q; ++i) {
        cout << qrans[i] << '\n';
    }
}
