#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

struct Req {
    ll t, u, v, ind;
};

struct DSU {
    vector<ll> p, sz;

    DSU(ll n) {
        p.assign(n, 0);
        std::iota(p.begin(), p.end(), 0);
        sz.assign(n, 1);
    }

    ll get(ll v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void merge(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        sz[a] += sz[b];
        p[b] = a;
    }
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, d, g;
    cin >> n >> d >> g;

    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];

    vector<pll> p(n);
    for (ll i = 0; i < n; i++) p[i] = {a[i], i};
    std::sort(p.begin(), p.end());

    ll q;
    cin >> q;

    vector<Req> req(q);
    for (ll i = 0; i < q; i++) {
        cin >> req[i].t >> req[i].u >> req[i].v;
        req[i].u--, req[i].v--;
        req[i].ind = i;
    }

    std::sort(req.begin(), req.end(), [&] (const Req &x, const Req &y) {
        return mt(a[x.u], x.ind) < mt(a[y.u], y.ind);
    });

    set<ll> pos;
    DSU dsu(n);

    vector<ll> ans(q, -1);

    vector<bool> used(n, false);

    ll ptr = 0;
    for (ll i = 0; i < n; i++) {
        while (ptr < q && (i == n - 1 || a[req[ptr].u] >= p[i + 1].first)) {
//            ll out = 0;
//            stack<ll> pth;
//            for (ll j = req[ptr].u; j <= req[ptr].v; j++) {
//
//            }

            ans[req[ptr].ind] = 0;

            if (a[req[ptr].u] >= a[req[ptr].v]) {
                ptr++;
                continue;
            }

            if (req[ptr].v - req[ptr].u <= d) {
                ans[req[ptr].ind] = 1;
            } else if (a[req[ptr].u] < a[req[ptr].v] && !pos.empty()) {
                auto itL = pos.lower_bound(req[ptr].u);
                auto itR = pos.lower_bound(req[ptr].v);
                if (itL != pos.end() && itR != pos.begin()) {
                    itR--;

                    ll l = *itL, r = *itR;
                    if (req[ptr].u - l <= d && r - req[ptr].v <= d)
                        ans[req[ptr].ind] = dsu.get(l) == dsu.get(r);
                }
            }

            ptr++;
        }

        used[p[i].second] = true;

        pos.insert(p[i].second);

        auto itPrev = pos.lower_bound(p[i].second);
        if (itPrev != pos.begin()) {
            itPrev--;
            auto pv = *itPrev;
            if (p[i].second - pv <= d) dsu.merge(p[i].second, pv);
        }

        auto itNxt = pos.upper_bound(p[i].second);
        if (itNxt != pos.end()) {
            ll nxt = *itNxt;
            if (nxt - p[i].second <= d) dsu.merge(p[i].second, nxt);
        }
    }

    for (ll w : ans) {
        assert(w != -1);
        cout << w << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
