#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

struct Req {
    ll t, u, v, ind;
};

struct DSU {
    vector<ll> p, sz;

    DSU(ll n) {
        p.assign(n, 0);
        std::iota(p.begin(), p.end(), 0);
        sz.assign(n, 1);
    }

    ll get(ll v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void merge(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        sz[a] += sz[b];
        p[b] = a;
    }
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, d, g;
    cin >> n >> d >> g;

    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];

    vector<pll> p(n);
    for (ll i = 0; i < n; i++) p[i] = {a[i], i};
    std::sort(p.begin(), p.end());

    ll q;
    cin >> q;

    vector<vector<ll>> gr(n, vector<ll>(n, INF));
    for (ll i = 0; i < n; i++) {
        ll last = i;
        for (ll j = i + 1; j < n; j++) {
            if (j - last > d) break;
            if (a[j] < a[i]) last = j;

            if (a[j] > a[i]) gr[i][j] = 1;
        }
    }

    for (ll k = 0; k < n; k++) {
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                gr[i][j] = min(gr[i][j], gr[i][k] + gr[k][j]);
            }
        }
    }

    vector<Req> req(q);
    for (ll i = 0; i < q; i++) {
        ll t, u, v;
        cin >> t >> u >> v;

        u--, v--;

        if (gr[u][v] >= INF / 2)
            cout << "0\n";
        else
            cout << (t == 1 ? 1 : gr[u][v]) << "\n";
    }



#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
