#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    d = min(d, n - 1);
    
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    
    vector<vector<int>> adj(n);
    for (int x = 0; x < n; x++) {
        int last = x;
        for (int y = x + 1; y < n; y++) {
            if (y - last <= d && a[x] < a[y]) {
                // cout << "edge " << x+1 << ' ' << y+1 << endl;
                adj[x].push_back(y);
            }
            if (a[x] > a[y] && y - last <= d) {
                last = y;
            }
        }
    }
    
    constexpr int inf = 1e9;
    vector dis(n, vector<int>(n, inf));
    for (int x = 0; x < n; x++) {
        queue<int> q;
        q.push(x);
        dis[x][x] = 0;
        while (!q.empty()) {
            int y = q.front();
            q.pop();
            for (auto z : adj[y]) {
                if (dis[x][z] > dis[x][y] + 1) {
                    dis[x][z] = dis[x][y] + 1;
                    q.push(z);
                }
            }
        }
    }
    
    int q;
    cin >> q;
    
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        if (dis[u][v] == inf) {
            cout << "0\n";
            continue;
        }
        if (t == 1) {
            cout << "1\n";
        } else {
            cout << dis[u][v] << '\n';
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}