#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    int x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x - b.x, a.y - b.y));
    }

    friend int operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend int operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

int n, d, g;
vec<int> p(3e5), s(3e5);
//vec<set<int>> sv(2e5);

void make_set(int v) {
    p[v] = v;
    s[v] = 1;
    //sv[v] = {v};
}

int find_set(int v) {
    if (v == p[v]) return v;
    return p[v] = find_set(p[v]);
}

void union_sets(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a != b) {
        if (s[a] < s[b]) swap(a, b);
        p[b] = a;
        s[a] += s[b];
        //for (int i : sv[b]) {
       //     sv[a].insert(i);
        //}
    }
}

void solve() {
    cin >> n >> d >> g;
    vec<int> a(n);
    vec<pair<int, int>> qq;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        qq.push_back({a[i], i});
    }
    sort(all(qq));
    int q; cin >> q;
    vec<pair<int, pair<int, int>>> pr;
    vec<vec<pair<pair<int, int>, int>>> z(n);
    for (int i = 0; i < q; ++i) {
        int t, v, u;
        cin >> t >> v >> u;
        v--, u--;
        if (v < u && a[v] < a[u]) {
            pr.push_back({t, {v, u}});
            z[v].push_back({{t, u}, i});
        }
        else {
            pr.push_back({t, {v, u}});
        }
    }
    for (int i = 0; i < n; ++i) {
        make_set(i);
    }
    vec<int> ans(q);
    set<pair<int, int>> st;
    for (int jj = 0; jj < n; ++jj) {
        int i = qq[jj].second;
        {
            for (auto& qq: z[i]) {
                int u = qq.first.second;
                if (abs(i - u) <= d || qq.first.first == 1) {
                    ans[qq.second] = 1;
                }
                else {
                    
                }
            }
        }
        {
            auto it = st.lower_bound({i, -1});
            bool flag1 = 0, flag2 = 0;
            if (it != st.end()) {
                if ((*it).first - i <= d) {
                    flag1 = 1;
                    int r = (*it).second;
                    st.erase(it);
                    st.insert({i, r});
                    union_sets(i, r);
                    it = st.lower_bound({i, -1});
                }
            }
            if (it != st.begin()) {
                it--;
                if (i - (*it).second <= d) {
                    flag2 = 1;
                    int l = (*it).first;
                    st.erase(it);
                    union_sets(i, l);
                    st.insert({l, i});
                    it = st.lower_bound({i, -1});
                }
            }
            if (flag1 && flag2) {
                it--;
                int l = (*it).first;
                it++;
                int r = (*it).second;
                st.erase({l, i});
                st.erase({i, r});
                st.insert({l, r});
            }
            if (!flag1 && !flag2) {
                st.insert({i, i});
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << endl;
    }
}

signed main() {
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}