#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if
#define read(x) x; cin >> x;

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename V>
istream &operator>>(istream &in, pair<T, V> &v) {
    in >> v.first >> v.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}


template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}

int count1(int x) {
    int count = 0;
    while (x) {
        count += x & 1;
        x >>= 1;
    }
    return count;
}

const int INF = 1e9;

int n, d, q;
vector<int> a;

namespace solve12 {
    vector<vector<int>> g;
    vector<vector<int>> min_dist;

    void build_g() {
        g.resize(n);
        RANGE(i, n) {
            int k = i;
            for (int j = i + 1; j < n && j - k <= d; j++) {
                if (a[j] < a[i]) {
                    k = j;
                } elif (a[j] > a[i]) {
                    g[i].push_back(j);
                }
            }
        }
    }

    void _build(int v, vector<int> &md) {
        md[v] = 0;
        deque<int> q;
        q.push_back(v);
        vector<bool> used(n, false);
        while (!q.empty()) {
            int x = q.front();
            q.pop_front();
            if (used[x]) {
                continue;
            }
            used[x] = true;
            for (int u: g[x]) {
                if (md[u] > md[x] + 1) {
                    md[u] = md[x] + 1;
                    q.push_back(u);
                }
            }
        }
    }

    void build_min_dist() {
        min_dist.resize(n, vector<int>(n, INF));
        RANGE(i, n) {
            _build(i, min_dist[i]);
        }
    }

    void _pre() {
        build_g();
        build_min_dist();
    }

    void solve() {
        _pre();
        LOOP(q) {
            int t, u, v;
            cin >> t >> u >> v;
            u--;
            v--;
            if (min_dist[u][v] == INF) {
                cout << 0 << ENDLINE;
            } elif (t == 1) {
                cout << 1 << ENDLINE;
            } else {
                cout << min_dist[u][v] << ENDLINE;
            }
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int g;
    cin >> n >> d >> g;
    a.resize(n);
    cin >> a >> q;
    solve12::solve();
}
