#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MX = 1000;

int go[MX][MX], dst[MX][MX];

struct Node {
    int pref, suf, mx;
    bool f;

    Node() {
        pref = suf = mx = 0;
        f = false;
    }
};

const int R = 1 << 19;

struct Tree {
    vector<Node> t;

    Tree() {
        t.resize(R * 2);
    }

    Node merge(Node l, Node r) {
        Node ans;
        ans.mx = max(l.mx, r.mx);
        ans.f = l.f & r.f;
        ans.pref = l.pref, ans.suf = r.suf;
        if (l.f) {
            ans.pref += r.pref;
        }
        if (r.f) {
            ans.suf += l.suf;
        }
        ans.mx = max({ans.mx, ans.pref, ans.suf, l.suf + r.pref});
        return ans;
    }

    void merge(int node) {
        t[node] = merge(t[node * 2], t[node * 2 + 1]);
    }

    void del(int i) {
        i += R;
        t[i].pref = t[i].suf = t[i].mx = 0;
        t[i].f = false;
        i /= 2;
        while (i) {
            merge(i), i /= 2;
        }
    }

    void add(int i) {
        i += R;
        t[i].pref = t[i].suf = t[i].mx = 1;
        t[i].f = true;
        i /= 2;
        while (i) {
            merge(i), i /= 2;
        }
    }

    Node get(int ql, int qr, int node = 1, int nl = 1, int nr = R) {
        if (ql <= nl && nr <= qr) {
            return t[node];
        }
        if (qr < nl || nr < ql) {
            return Node();
        }
        int nm = (nr + nl) / 2;
        return merge(get(ql, qr, node * 2, nl, nm), get(ql, qr, node * 2 + 1, nm + 1, nr));
    }
};

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i, --i;
    }
    if (g == 4 || g == 5) {


        return 0;
    }
    vector<int> lst(n, -1);
    for (int i = 0; i < MX; ++i) {
        for (int j = 0; j < MX; ++j) {
            go[i][j] = false;
        }
    }
    vector<int> max_r(n, -1);
    iota(max_r.begin(), max_r.end(), 0);
    vector<pair<int, int>> t;
    for (int i = 0; i < n; ++i) {
        t.emplace_back(a[i], i);
    }
    sort(t.begin(), t.end());
    Tree tree;
    for (int i = 0; i < n; ++i) {
        tree.add(i);
    }
    vector<int> p(n, 1);
    for (auto &[x, ind] : t) {
        p[ind] = 0;
        tree.del(ind);
        for (int j = ind, cs = 0, mx = 0; j < n; ++j) {
            if (!tree.get(j + 1, j + 1).suf && tree.get(ind + 1, j + 1).mx <= d - 1) {
                max_r[ind] = j;
            }
//            if (p[j] == 0) {
//                mx = max(mx, cs), cs = 0;
//                if (mx <= d - 1) max_r[ind] = j;
//            } else {
//                ++cs;
//            }
        }
    }
//    for (int i = 0; i < n; ++i) tree.add(i);
//    for (auto &[x, ind] : t) { //
//        cerr << max_r[ind] << ' ';
//        tree.del(ind);
//        int l = ind + 1, r = n + 1;
//        while (r - l > 1) {
//            int mid = (l + r) / 2;
//            tree.get(ind + 1, mid).mx <= d - 1 ? l = mid : r = mid;
//        }
//        ++l;
//        while (tree.get(l, l).suf) --l;
//        max_r[ind] = l - 1;
//        cerr << max_r[ind] << '\n';
//    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            go[i][j] = a[i] < a[j] && j - max_r[i] <= d;
        }
    }
    const int INF = 1010;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (go[i][j]) {
                dst[i][j] = 1;
            } else {
                dst[i][j] = INF;
            }
        }
        dst[i][i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = i + 1; k < j; ++k) {
                if (max(dst[i][k], dst[k][j]) == INF) continue;
                dst[i][j] = min(dst[i][j], dst[i][k] + dst[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int tt;
        cin >> tt;
        int u, v;
        cin >> u >> v;
        --u, --v;
        if (tt == 1) {
            cout << (dst[u][v] != INF) << '\n';
        } else {
            if (dst[u][v] == INF) {
                cout << "0\n";
            } else {
                cout << dst[u][v] << '\n';
            }
        }
    }
}