#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MX = 1000;

int go[MX][MX], dst[MX][MX];

struct Node {
    int pref, suf, mx;
    bool f;

    Node() {
        pref = suf = mx = 0;
        f = false;
    }
};

const int R = 1 << 19;

struct Tree {
    vector<Node> t;

    Tree() {
        t.resize(R * 2);
    }

    Node merge(Node l, Node r) {
        Node ans;
        ans.mx = max(l.mx, r.mx);
        ans.f = l.f & r.f;
        ans.pref = l.pref, ans.suf = r.suf;
        if (l.f) {
            ans.pref += r.pref;
        }
        if (r.f) {
            ans.suf += l.suf;
        }
        ans.mx = max({ans.mx, ans.pref, ans.suf, l.suf + r.pref});
        return ans;
    }

    void merge(int node) {
        t[node] = merge(t[node * 2], t[node * 2 + 1]);
    }

    void del(int i) {
        i += R;
        t[i].pref = t[i].suf = t[i].mx = 0;
        t[i].f = false;
        i /= 2;
        while (i) {
            merge(i), i /= 2;
        }
    }

    void add(int i) {
        i += R;
        t[i].pref = t[i].suf = t[i].mx = 1;
        t[i].f = true;
        i /= 2;
        while (i) {
            merge(i), i /= 2;
        }
    }

    Node get(int ql, int qr) {
        Node ansl, ansr;
        for (ql += R - 1, qr += R - 1; ql <= qr; ql >>= 1, qr >>= 1) {
            if (ql & 1) ansl = merge(ansl, t[ql++]);
            if (~qr & 1) ansr = merge(t[qr--], ansr);
        }
        return merge(ansl, ansr);
    }
};


struct Tr {
    vector<pair<int, int>> t;

    Tr() {
        t.resize(R * 2, make_pair(-1, -1));
    }

    void add(int i, int x) {
        i += R;
        t[i] = {x, i - R};
        i /= 2;
        while (i) {
            t[i] = max(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }

    void del(int i) {
        i += R;
        t[i] = {-1, -1};
        i /= 2;
        while (i) {
            t[i] = max(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }

    pair<int, int> get(int ql, int qr) {
        pair<int, int> ans = {-1, -1};
        for (ql += R, qr += R; ql <= qr; ql /= 2, qr /= 2) {
            if (ql & 1) ans = max(ans, t[ql--]);
            if (~qr & 1) ans = max(ans, t[qr++]);
        }
        return ans;
    }
};

vector<int> g[R];

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i, --i;
    }
    if (g == 3 || g == 4 || g == 5) {
        vector<int> max_r(n, -1);
        iota(max_r.begin(), max_r.end(), 0);
        vector<pair<int, int>> t;
        for (int i = 0; i < n; ++i) {
            t.emplace_back(a[i], i);
        }
        sort(t.begin(), t.end());
        vector<int> p(n, 1);
        Tree tree;
        for (int i = 0; i < n; ++i) {
            tree.add(i);
        }
        set<int> st;
        for (auto &[x, ind]: t) {
            p[ind] = 0;
            st.insert(ind);
            tree.del(ind);
            int l = ind + 1, r = n + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                tree.get(ind + 1, mid).mx <= d - 1 ? l = mid : r = mid;
            }
            max_r[ind] = *prev(st.upper_bound(l - 1));
        }
        const int INF = 1e9;
        vector<int> dst(n, INF);
        queue<int> q;
        dst[n - 1] = 0;
        q.push(n - 1);
        Tr tr;
        for (int i = 0; i < n; ++i) {
            tr.add(i, max_r[i]);
        }
        int qq;
        cin >> qq;
        int tt, u, vvv;
        cin >> tt >> u >> vvv;
        --u, --vvv;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int i = v - 1; i >= u; --i) {
                if (a[i] < a[v] && v - max_r[i] <= d && dst[i] == INF) {
                    dst[i] = dst[v] + 1;
                    q.push(i);
                }
            }
        }
        if (tt == 1) {
            cout << (dst[u] != INF) << '\n';
        } else {
            if (dst[u] == INF) {
                cout << "0\n";
            } else {
                cout << dst[u] << '\n';
            }
        }
        return 0;
    }
    vector<int> lst(n, -1);
    for (int i = 0; i < MX; ++i) {
        for (int j = 0; j < MX; ++j) {
            go[i][j] = false;
        }
    }
    vector<int> max_r(n, -1);
    iota(max_r.begin(), max_r.end(), 0);
    vector<pair<int, int>> t;
    for (int i = 0; i < n; ++i) {
        t.emplace_back(a[i], i);
    }
    sort(t.begin(), t.end());
    vector<int> p(n, 1);
    Tree tree;
    for (int i = 0; i < n; ++i) {
        tree.add(i);
    }
    set<int> st;
    for (auto &[x, ind]: t) {
        p[ind] = 0;
        st.insert(ind);
        tree.del(ind);
        int l = ind + 1, r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            tree.get(ind + 1, mid).mx <= d - 1 ? l = mid : r = mid;
        }
        max_r[ind] = *prev(st.upper_bound(l - 1));
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            go[i][j] = a[i] < a[j] && j - max_r[i] <= d;
        }
    }
    const int INF = 1010;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (go[i][j]) {
                dst[i][j] = 1;
            } else {
                dst[i][j] = INF;
            }
        }
        dst[i][i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = i + 1; k < j; ++k) {
                if (max(dst[i][k], dst[k][j]) == INF) continue;
                dst[i][j] = min(dst[i][j], dst[i][k] + dst[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int tt;
        cin >> tt;
        int u, v;
        cin >> u >> v;
        --u, --v;
        if (tt == 1) {
            cout << (dst[u][v] != INF) << '\n';
        } else {
            if (dst[u][v] == INF) {
                cout << "0\n";
            } else {
                cout << dst[u][v] << '\n';
            }
        }
    }
}