#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10 , M = 1e3 + 10;
int n , d , g , a[N] , r[N] , q , dis[M][M] , dp[N];
vector <int> adj[M];
bool cmp(int i , int j)
{
	return a[i] > a[j];
}

struct SEG{
	struct NODE{
		int prf , suf , ans;
		bool all_one;
		NODE(){
			prf = suf = ans = all_one = 0;
		}
	};
	NODE t[N << 2] , pooch;
	NODE Merge(NODE a , NODE b)
	{
		NODE res;
		res.all_one = (a.all_one & b.all_one);
		res.prf = a.prf;  res.suf = b.suf;
		res.ans = max({a.ans , b.ans , a.suf + b.prf});
		if(a.all_one)
			res.prf = a.prf + b.prf;
		if(b.all_one)
			res.suf = a.suf + b.suf;
		return res;
	}
	NODE Get(int l , int r , int node = 1 , int nl = 0 , int nr = n)
	{
		if(r <= nl || nr <= l)
			return pooch;
		if(l <= nl && nr <= r)
			return t[node];
		int mid = (nl + nr) >> 1 , lc = node << 1 , rc = lc | 1;
		return Merge(Get(l , r , lc , nl , mid) , Get(l , r , rc , mid , nr));
	}
	void Add(int id , int node = 1 , int nl = 0 , int nr = n)
	{
		if(nr - nl == 1)
		{
			t[node].prf = t[node].suf = t[node].ans = t[node].all_one = 1;
			return;
		}
		int mid = (nl + nr) >> 1 , lc = node << 1 , rc = lc | 1;
		if(id < mid)
			Add(id , lc , nl , mid);
		else
			Add(id , rc , mid , nr);
		t[node] = Merge(t[lc] , t[rc]);
	}
} seg;

struct SEG2{
	int mn[N << 2];
	void Build(int node = 1 , int nl = 0 , int nr = n)
	{
		mn[node] = N;
		if(nr - nl == 1)
			return;
		int mid = (nl + nr) >> 1 , lc = node << 1 , rc = lc | 1;
		Build(lc , nl , mid);  Build(rc , mid , nr);
	}
	void Set(int id , int val , int node = 1 , int nl = 0 , int nr = n)
	{
		if(nr - nl == 1)
		{
			mn[node] = val;
			return;
		}
		int mid = (nl + nr) >> 1 , lc = node << 1 , rc = lc | 1;
		if(id < mid)
			Set(id , val , lc , nl , mid);
		else
			Set(id , val , rc , mid , nr);
		mn[node] = min(mn[lc] , mn[rc]);
	}
	int Get(int l , int r , int node = 1 , int nl = 0 , int nr = n)
	{
		if(r <= nl || nr <= l)
			return N;
		if(l <= nl && nr <= r)
			return mn[node];
		int mid = (nl + nr) >> 1 , lc = node << 1 , rc = lc | 1;
		return min(Get(l , r , lc , nl , mid) , Get(l , r , rc , mid , nr));
	}
} seg2;

void Bfs(int star)
{
	queue <int> q;
	q.push(star);
	while(!q.empty())
	{
		int v = q.front();  q.pop();
		for(auto u : adj[v])  if(dis[star][u] == 0)
		{
			dis[star][u] = dis[star][v] + 1;
			q.push(u);
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);  cout.tie(0);
	cin >> n >> d >> g;
	vector <int> vec;
	for(int i = 0 ; i < n ; i++)
	{
		cin >> a[i];
		vec.push_back(i);
	}
	sort(vec.begin() , vec.end() , cmp);
	for(auto l : vec)
	{
		int low = l , high = n - 1;
		while(high - low > 1)
		{
			int mid = (low + high) >> 1;
			if(seg.Get(l , mid + 1).ans >= d)
				high = mid;
			else
				low = mid;
		}
		r[l] = high;
		seg.Add(l);
	}
	if(g <= 2)
	{
		for(int i = 0 ; i < n ; i++)  for(int j = i ; j <= r[i] ; j++)  if(a[i] < a[j])
			adj[i].push_back(j);
		for(int i = 0 ; i < n ; i++)
			Bfs(i);
		cin >> q;
		while(q--)
		{
			int t , fr , to;  cin >> t >> fr >> to; fr--; to--;
			int ans = dis[fr][to];
			if(t == 1)
				ans = min(ans , 1);
			cout << ans << '\n';
		}
		return 0;
	}
	if(g <= 5)
	{
		seg2.Build();
		dp[n - 1] = 0;
		for(int i = 0 ; i < n - 1 ; i++)
			dp[i] = N;
		for(auto u : vec)
		{
			dp[u] = min(dp[u] , seg2.Get(u , r[u] + 1) + 1);
			seg2.Set(u , dp[u]);
		}
		cin >> q;
		while(q--)
		{
			int t , fr , to;  cin >> t >> fr >> to;  fr--;  to--;
			int ans = dp[fr];
			if(ans >= N)
				ans = 0;
			if(t == 1)
				ans = min(ans , 1);
			cout << ans << '\n';
		}
	}
	return 0;
}