// vaaven_lazha_2.cpp
#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef pair<int, int> pi;

const int maxn = 2e5 + 228;
int a[maxn], b[maxn];

set<pi> segments;
int mx = 0;

void add(pi new_segment) {
    while (!segments.empty()) {
        auto it = segments.upper_bound({new_segment.second, 1e9});
        if (it == segments.begin()) {
            break;
        }
        --it;
        if (it->second < new_segment.first) {
            break;
        }
        new_segment = make_pair(min(new_segment.first, it->first), max(new_segment.second, it->second));
        segments.erase(it);
        // only difference between main solution and this solution is line below
        // it provides logic when participant want to delete segments only inside new segment
        // if i undestand everything correctly it should work on group 4 and 5
        break;
    }
    mx = max(mx, new_segment.second - new_segment.first);
    segments.insert(new_segment);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q;
    cin >> q;
    for (int _ = 0; _ < q; _++) {
        segments.clear();
        mx = 0;
        int n;
        cin >> n;
        for (int i = 0; i < n; i++)
            cin >> a[i];
        for (int i = 0; i < n; i++)
            cin >> b[i];
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i] - b[i];
            add({b[i], a[i]});
            cout << sum - mx << " ";
        }
        cout << endl;
    }
}
