#pragma GCC optimaze("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <queue>
using namespace std;

ostream& operator<< (ostream& stream, const pair<int, int>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<int>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<int, int>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const pair<long long, long long>& a) {
    stream << "{" << a.first << ", " << a.second << "}";
    return stream;
}

ostream& operator<< (ostream& stream, const vector<long long>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const multiset<long long>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

ostream& operator<< (ostream& stream, const vector<pair<long long, long long>>& a) {
    for (auto x : a) {
        stream << x << " ";
    }
    return stream;
}

void print_map(string name, const map<long long, long long>& mapa) {
    cout << string(10, '=') << name << string(10, '=') << "\n";
    for (auto to : mapa) {
        cout << to.first << ": " << to.second << "\n";
    }
    cout << string(10, '=') << "end" << string(10, '=') << "\n";
}

int n;
vector<long long> a, b;

void solve1() {
    multiset<long long> pa, pb;
    for (int k = 0; k < n; k++) {
        bool sa = true;
        bool sb = true;
        if (pb.find(a[k]) != pb.end()) {
            pb.erase(pb.find(a[k]));
            sa = false;
        }
        if (pa.find(b[k]) != pa.end()) {
            pa.erase(pa.find(b[k]));
            sb = false;
        }
        if (sa) {
            pa.insert(a[k]);
        }
        if (sb) {
            pb.insert(b[k]);
        }
        // cout << "k = " << k << ":\n";
        // cout << "pa = " << pa << "\npb = " << pb << "\n\n";
        
        int sz = (int) pa.size();
        vector<long long> a2, b2;
        a2.reserve(sz), b2.reserve(sz);
        for (auto x : pa) {
            a2.push_back(x);
        }
        for (auto x : pb) {
            b2.push_back(x);
        }
        long long ans = 1e18;
        // cout << "sz = " << sz << ",k = " << k << "\na2: " << a2 << "\nb2: " << b2 << "\n";
        for (int i = 0; i < sz; i++) {
            for (int j = 0; j < sz; j++) {
                int ai = 0;
                int bi = 0;
                long long res = 0;
                bool state = true;
                while (1) {
                    if (ai == i) {
                        ai++;
                    }
                    if (bi == j) {
                        bi++;
                    }
                    if (ai == sz && bi == sz) {
                        break;
                    }
                    if (a2[ai] < b2[bi]) {
                        state = false;
                        break;
                    }
                    res += a2[ai] - b2[bi];
                    ai++;
                    bi++;
                }
                if (!state) {
                    continue;
                }
                // cout << i << " " << j << ": " << res << "\n";
                ans = min(ans, res);
            }
        }
        // cout << "ans: " << ans << "\n\n";
        cout << ans << " ";
    }
    cout << "\n";
}

void solve() {
    cin >> n;
    a.resize(n), b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    solve1();

}
int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}