#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n);
	for (ll& elem : a) {
		cin >> elem;
	}
	vector<ll> b(n);
	for (ll& elem : b) {
		cin >> elem;
	}
	for (ll i = 0; i < n; i++) {
		ll ans = 0;
		vector<ll> x, y;
		for (ll q = 0; q < n; q++) {
			x.push_back(a[q]);
			y.push_back(b[q]);
		}
		sort(x.begin(), x.end());
		sort(y.begin(), y.end());
		for (ll q = 0; q <= i; q++) {
			if (x[q] - y[q] < 0) {
				assert(0);
				ans = INF;
			}
			ans += x[q] - y[q];
		}
		for (ll j = 0; j <= i; j++) {
			for (ll k = 0; k <= i; k++) {
				vector<ll> x, y;
				for (ll q = 0; q <= i; q++) {
					if (q != j) {
						x.push_back(a[q]);
					}
					if (q != k) {
						y.push_back(b[q]);
					}
				}
				sort(x.begin(), x.end());
				sort(y.begin(), y.end());
				ll cur_sum = 0;
				for (ll q = 0; q <= i - 1; q++) {
					if (x[q] - y[q] < 0) {
						cur_sum = INF;
					}
					cur_sum += x[q] - y[q];
				}
				ans = min(ans, cur_sum);
			}
		}
		assert(ans < INF);
		cout << ans << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/