#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

int g;

vector<set<ll>> G1, G2;

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	G1.assign(n, {});
	G2.assign(n, {});
	ll u, v;
	vector<vector<bool>> G_v(n, vector<bool>(n, false));
	for (ll i = 0; i < m1; i++) {
		cin >> u >> v; u--; v--;
		G_v[u][v] = true;
		G_v[v][u] = true;
		G1[u].insert(v);
		G1[v].insert(u);
	}
	vector<vector<bool>> G2_v(n, vector<bool>(n, false));
	for (ll i = 0; i < m2; i++) {
		cin >> u >> v; u--; v--;
		G2_v[u][v] = true;
		G2_v[v][u] = true;
		G2[u].insert(v);
		G2[v].insert(u);
	}
	cout << "Yes\n";
	vector<pair<ll, ll>> rs;
	for (int i = 1; i < n; i++) {
		if (!G_v[i][i + 1]) {
			rs.push_back({ i + 1, i + 2 });
		}
	}
	rs.push_back({ 1, 2 });
	cout << rs.size() << "\n";
	for (pair<ll, ll> elem : rs) {
		cout << elem.first << " " << elem.second << "\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	cin >> t >> g;
	assert(g == 5);
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/