#include <bits/stdc++.h>

using ll = long long;

struct DSU {
    std::vector<ll> p, rank;

    DSU(ll n) {
        p.resize(n);
        rank.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    ll find(ll v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }

    void unite(ll v, ll u) {
        v = find(v), u = find(u);
        if (v == u) {
            return;
        }
        if (rank[u] < rank[v]) {
            std::swap(v, u);
        }
        p[u] = v;
        rank[u] += rank[v];
    }
};

void solve() {
    ll n;
    std::cin >> n;
    std::vector<ll> a(n);
    std::vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
    }
    ll sm = 0, mx = 0, mx1 = 1e9;
    std::set<ll> diff;
    for (int i = 0; i < n; ++i) {
        sm += a[i];
        sm -= b[i];
        for (int j = 0; j <= i; ++j) {
            if (a[j] > b[i]) {
                diff.insert(a[j] - b[i]);
            }
            if (a[i] > b[j]) {
                diff.insert(a[i] - b[j]);
            }
        }
        auto it = diff.upper_bound(sm);
        --it;
        std::cout << sm - *it << ' ';
    }
    std::cout << '\n';
}

int main() {
    int tt;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
