#include <bits/stdc++.h>

using ll = long long;
using pll = std::pair<ll, ll>;

struct DSU {
    std::vector<ll> p, rank;

    DSU(ll n) {
        p.resize(n);
        rank.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    ll find(ll v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }

    void unite(ll v, ll u) {
        v = find(v), u = find(u);
        if (v == u) {
            return;
        }
        if (rank[u] < rank[v]) {
            std::swap(v, u);
        }
        p[u] = v;
        rank[u] += rank[v];
    }
};

ll get(ll n, ll m, std::vector<ll> l, std::vector<ll> r, ll a0, ll b0, std::vector<std::pair<ll, pll>> ind) {
    std::vector<ll> used(n);
    ll mn1 = a0, mn2 = b0;
    for (int i = 0; i < m; ++i) {
        mn1 = std::min(mn1, l[ind[i].second.second]);
        used[ind[i].second.second] = 1;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            mn2 = std::min(mn2, r[i]);
        }
    }
    return mn1 + mn2;
}

bool cmp(std::pair<ll, pll> x, std::pair<ll, pll> y) {
    return x.first > y.first || ((x.first == y.first) && (x.second.first > y.second.first));
}

void solve() {
    ll n;
    std::cin >> n;
    std::vector<ll> a(n);
    std::vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
    }
    std::multiset<ll> x;
    std::multiset<ll> y;
    ll sm = 0;
    for (int i = 0; i < n; ++i) {
        x.insert(a[i]);
        y.insert(b[i]);
        sm += a[i];
        sm -= b[i];
        ll mx = -1e9;
        for (int j = 0; j <= i; ++j) {
            for (int k = 0; k <= i; ++k) {
                x.erase(x.find(a[k]));
                y.erase(y.find(b[j]));
                auto it = x.begin();
                auto it1 = y.begin();
                bool flg = false;
                for (auto it = x.begin(); it != x.end(); ++it, ++it1) {
                    if(*it < *it1){
                        flg = true;
                        break;
                    }
                }
                x.insert(a[k]);
                y.insert(b[j]);
                if(!flg){
                    mx = std::max(mx, a[k] - b[j]);
                }
            }
        }
        std::cout << sm - mx <<' ';
    }
    std::cout << '\n';
}

int main() {
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
