#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void sol() {
    uint32_t t;
    cin >> t;
    vector<int32_t> arr_a(2e5), arr_b(2e5);
    multiset<int32_t> a, b, a2, b2;
    while (t--) {
        int32_t n;
        cin >> n;
        a.clear();
        b.clear();
        for (int32_t i = 0; i < n; ++i) cin >> arr_a[i];
        for (int32_t i = 0; i < n; ++i) cin >> arr_b[i];
        for (int32_t i = 0; i < n; ++i) {
            a.insert(arr_a[i]);
            b.insert(arr_b[i]);
            int32_t max_dif = 0, sum_dif = 0;
            while (!a.empty()) {
                auto a_it = a.begin();
                auto b_it = prev(b.upper_bound(*a_it));
                auto dif = *a_it - *b_it;
                if (dif > max_dif) max_dif = dif;
                sum_dif += dif;
                a2.insert(*a_it);
                b2.insert(*b_it);
                a.erase(a_it);
                b.erase(b_it);
            }
            swap(a, a2);
            swap(b, b2);
            cout << sum_dif - max_dif << " ";
        }
        cout << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    uint32_t t = 2;
#else
    uint32_t t = 1;
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while (t--) {
        sol();
        cout << "\n";
    }
    return 0;
}
