#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

ll calc(vector<ll> a, vector<ll> b) {
	int n = a.size();
	sort(all(a));
	sort(all(b));
	ll mx = 0;
	int i = n - 1;
	while (i > -1) {
		int j = i;
		while (j > 0 && a[j - 1] >= b[j])
			j--;
		mx = max(mx, a[i] - b[j]);
		i = j - 1;
	}
	ll ans = 0;
	for (ll i : a)
		ans += i;
	for (ll i : b)
		ans -= i;
	ans -= mx;
	return ans;
}

inline void solve() {
	int n;
	cin >> n;
	vector<ll> a(n), b(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	bool sasb = true;
	for (int i = 0; i < n - 1; i++) {
		if (a[i] > a[i + 1])
			sasb = false;
		if (b[i] > b[i + 1])
			sasb = false;
	}
	if (sasb) {
		ll mx = 0;
		ll sa = 0;
		ll sb = 0;
		set<int> inds;
		for (int i = 0; i < n; i++) {
			sa += a[i];
			sb += b[i];
			inds.insert(i);
			if (!i) {
				cout << 0 << ' ';
				continue;
			}
			if (a[i - 1] >= b[i])
				inds.erase(i - 1);
			if (inds.size() == 1) {
				mx = max(mx, a[i] - b[0]);
			}
			else {
				auto it = inds.end();
				it--;
				it--;
				mx = max(mx, a[i] - b[*it + 1]);
			}
			cout << sa - sb - mx << ' ';
		}
		cout << '\n';
		return;
	}
	bool sorted = true;
	for (int i = 0; i < n - 1; i++)
		if (a[i] >= b[i + 1])
			sorted = false;
	if (sorted) {
		ll ans = 0;
		ll mx = 0;
		for (int i = 0; i < n; i++) {
			mx = max(mx, a[i] - b[i]);
			ans += a[i] - b[i];
			cout << ans - mx << ' ';
		}
		cout << '\n';
		return;
	}
	vector<ll> aa, bb;
	for (int i = 0; i < n; i++) {
		aa.push_back(a[i]);
		bb.push_back(b[i]);
		cout << calc(aa, bb) << ' ';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
