#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n), b(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];
    for (ll i = 0; i < n; ++i) cin >> b[i];

    bool flag = true;
    bool flag2 = true;

    for (ll i = 0; i < n - 1; ++i) {
        if (a[i] >= b[i + 1]) {
            flag = false;
        }
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            flag2 = false;
        }
    }

    if (flag) {
        multiset<ll> st;
        ll sum = 0;

        for (ll i = 0; i < n; ++i) {
            sum += a[i] - b[i];
            st.insert(a[i] - b[i]);

            cout << sum - *(--st.end()) << ' ';
        }
        cout << '\n';
        return;
    }

    if (flag2) {
        vector<ll> g, h;
        vector<ll> to_pref(n);
        to_pref[0] = 0;
        ll last_ans = 0;
        vector<ll> prv_j(n), sum_last(n, 0);
        prv_j[0] = 0;
        sum_last[0] = 0;
        for (ll beg = 0; beg < n; ++beg) {
            g.push_back(a[beg]);
            h.push_back(b[beg]);

            if (beg != 0) to_pref[beg] = to_pref[beg - 1] + g[beg - 1] - h[beg - 1];

            for (ll i = max(1LL, beg); i <= beg; ++i) {
                if (g[i - 1] >= h[i]) {
                    prv_j[i] = prv_j[i - 1];
                    sum_last[i] = sum_last[i - 1] + g[i - 1] - h[i];
                }
                else {
                    prv_j[i] = i;
                    sum_last[i] = 0;
                }
            }

            ll ans = last_ans + g.back() - h.back();

            for (ll i = beg; i <= beg; ++i) {
                ll j = prv_j[i];
                ll local = 0;

                local += to_pref[j];
                local += sum_last[i];

                ans = min(ans, local);
            }

            cout << ans << ' ';
            last_ans = ans;
        }
        cout << '\n';
        return;
    }

    for (ll beg = 0; beg < n; ++beg) {
        vector<ll> g, h;
        for (ll i = 0; i <= beg; ++i) g.push_back(a[i]);
        for (ll i = 0; i <= beg; ++i) h.push_back(b[i]);

        sort(all(g));
        sort(all(h));

        ll ans = INF;

        vector<ll> to_pref(beg + 1);
        to_pref[0] = 0;
        for (ll i = 1; i <= beg; ++i) {
            to_pref[i] = to_pref[i - 1] + g[i - 1] - h[i - 1];
        }
        vector<ll> to_suff(beg + 2);
        to_suff[beg + 1] = 0;
        for (ll i = beg; i >= 0; --i) {
            to_suff[i] = to_suff[i + 1] + g[i] - h[i];
        }

        vector<ll> prv_j(beg + 1), sum_last(beg + 1, 0);
        prv_j[0] = 0;
        sum_last[0] = 0;

        for (ll i = 1; i <= beg; ++i) {
            if (g[i - 1] >= h[i]) {
                prv_j[i] = prv_j[i - 1];
                sum_last[i] = sum_last[i - 1] + g[i - 1] - h[i];
            }
            else {
                prv_j[i] = i;
                sum_last[i] = 0;
            }
        }

        for (ll i = 0; i <= beg; ++i) {
            ll j = prv_j[i];
            ll local = 0;

            local += to_pref[j];
            local += sum_last[i];
            local += to_suff[i + 1];

            ans = min(ans, local);
        }

        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    fast_stream();

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}
