#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

const int inf = 1e9 + 100;
const int mod = 1e9 + 9;

int add(int a, int b) {
	return a + b < mod ? a + b : a + b - mod;
}

int rem(int a, int b) {
	return a - b >= 0 ? a - b : a - b + mod;
}

int mul(int a, int b) {
	return 1ll * a * b % mod;
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int bin_pow(int a, int b) {
	if (b == 0) return 1;
	if (b % 2) return 1ll * a * bin_pow(a, b - 1) % mod;
	ll z = bin_pow(a, b / 2);
	return z * z % mod;
}

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int j = 0; j < n; j++) {
		cin >> b[j];
	}
	ll sm1 = 0, sm2 = 0;
	for (int k = 1; k <= n; k++) {
		sm1 += a[k - 1];
		sm2 += b[k - 1];
		vector<int> n_a = vector<int>(a.begin(), a.begin() + k);
		vector<int> n_b = vector<int>(b.begin(), b.begin() + k);
		sort(n_a.begin(), n_a.end());
		sort(n_b.begin(), n_b.end());
		int ind_lst = 0;
		int sm = 0;
		for (int i = 1; i < k; i++) {
			if (n_b[i] <= n_a[i - 1]) continue;
			sm = max(sm, n_a[i - 1] - n_b[ind_lst]);
			ind_lst = i;
		}
		sm = max(sm, n_a.back() - n_b[ind_lst]);
		cout << sm1 - sm2 - sm << ' ';
	}
	cout << '\n';
}
						
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

}