#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

void solution() {
    ll n;
    cin >> n;
    vector <ll> ai(n), bi(n);
    cin >> ai >> bi;
    vector <ll> a, b;
    for (ll i = 0; i < n; ++i) {
        a.emplace_back(ai[i]), b.emplace_back(bi[i]);
        if (i == 0) {
            cout << 0 << ' ';
            continue;
        }
        sort(all(a)), sort(all(b));
        const ll INF = 1e16;
        vector <pll> dpr(i + 1, {INF, INF}), dpl(i + 1, {INF, INF}); // 0 - base, 1 - changed
        for (ll j = 0; j < i; ++j) {
            if (j == 0) {
                dpr[0].first = a[0] - b[0], dpr[0].second = a[1] - b[0];
                continue;
            }

            dpr[j].first = dpr[j - 1].first + a[j] - b[j];
            dpr[j].second = min(dpr[j - 1].first, dpr[j - 1].second) + a[j + 1] - b[j];
        }

        for (ll j = i; j > 0; --j) {
            if (j == i) {
                dpl[j].first = a[j] - b[j];
                if (a[j - 1] - b[j] > 0) dpl[j].second = a[j - 1] - b[j];
                continue;
            }

            dpl[j].first = a[j] - b[j] + dpl[j + 1].first;
            if (a[j - 1] - b[j] > 0) dpl[j].second = a[j - 1] - b[j] + min(dpl[j + 1].first, dpl[j + 1].second);
        }

        ll tmp1 = min(dpr[i - 1].first, dpr[i - 1].second);
        ll tmp2 = min(dpl[1].first, dpl[1].second);
        ll ans = min(tmp1, tmp2);
        for (ll j = 1; j < i; ++j) {
            tmp1 = min(dpr[j - 1].first, dpr[j - 1].second) + dpl[j + 1].first;
            tmp2 = dpr[j - 1].first + min(dpl[j + 1].first, dpl[j + 1].second);
            ans = min({ans, tmp1, tmp2});
        }

//        cout << i << ' ' << "Ans: " << ans << '\n';
//        for (auto el : dpl) cout << el.first << ' ' << el.second << ", ";
//        cout << '\n';
//        for (auto el : dpr) cout << el.first << ' ' << el.second << ", ";
//        cout << '\n';

        cout << ans << ' ';
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tt;
    cin >> tt;
    while (tt--) {
        solution();
        cout << '\n';
    }

    return 0;
}
