#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;
//#define int long long
using pii = pair <int, int>;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Fenwick {
private:
    vector <int> d;
    int n;

public:
    explicit Fenwick(int n1) : n(n1) {
        d.resize(n1);
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += d[i];
        }
        return res;
    }

    void upd(int i, int x) {
        for (; i < n; i |= (i + 1)) {
            d[i] += x;
        }
    }
};

struct SegmentTree {
private:
    vector <int> d;
    vector <int> p;
    vector <int> t;
    int n;

    void upd(int i) {
        d[i] = max(d[2 * i], d[2 * i + 1]);
    }

    void upd(int i, int x) {
        d[i] += x;
        p[i] += x;
        t[i] = 1;
    }

    void push(int i) {
        if (t[i]) {
            t[i] = 0;
            upd(2 * i, p[i]);
            upd(2 * i + 1, p[i]);
        }
    }

    void upd(int ql, int qr, int x, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return;
        }
        if (ql <= l && r <= qr) {
            return upd(i, x);
        }
        push(i);
        int m = (l + r) / 2;
        upd(ql, qr, x, l, m, 2 * i);
        upd(ql, qr, x, m, r, 2 * i + 1);
        upd(i);
    }

public:
    explicit SegmentTree(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n);
        t.resize(2 * n);
        p.resize(2 * n);
    }

    int get() {
        if (!d[1]) {
            return -1;
        }
        int cur = 1;
        while (cur < n) {
            push(cur);
            if (d[2 * cur + 1]) {
                cur = 2 * cur + 1;
            } else {
                cur = 2 * cur;
            }
        }
        return cur - n;
    }

    void upd(int ql, int qr, int x) {
        return upd(ql, qr, x, 0, n, 1);
    }
};

void solve123(int n, vector <int> a, vector <int> b) {
    long long sum = 0;
    vector <int> a0 = a, b0 = b;
    for (int i = 0; i < n; ++i) {
        sum += a0[i] - b0[i];
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        int am = 0;
        int t = a[i];
        int mxd = 0;
        vector <int> bad(i + 1);
        for (int j = 0; j <= i; ++j) {
            while (am <= i && b[am] <= a[j]) {
                ++am;
            }
            mxr(mxd, a[j] - b[j]);
            if (am <= j + 1) {
                bad[j] = 1;
            }
        }
        for (int j = i - 1; j >= 0; --j) {
            if (bad[j]) {
                t = a[j];
            }
            mxr(mxd, t - b[j]);
        }
        cout << sum - mxd << " ";
    }
}

void solve45(int n, const vector <int>& a, const vector <int>& b) {
    long long sum = 0;
    int mxd = 0;
    SegmentTree segmentTree(n);
    for (int i = 0; i < n; ++i) {
        sum += a[i] - b[i];
        mxr(mxd, a[i] - b[i]);
        auto it = lower_bound(all(a), b[i]);
        segmentTree.upd(it - a.begin(), n, 0);
        int s = segmentTree.get();
        mxr(mxd, a[i] - b[s + 1]);
        segmentTree.upd(i, i + 1, 1);
        cout << sum - mxd << " ";
    }
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (auto &i : a) {
        cin >> i;
    }
    for (auto &i : b) {
        cin >> i;
    }
    bool flag = true;
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i] >= b[i + 1]) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        solve123(n, a, b);
    } else {
        solve45(n, a, b);
    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef BUY
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
#ifdef BUY
    cerr << "\n";
#endif
}