#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
#define int long long

struct Node
{
    int val;
};

struct SegmentTree
{
    int n;
    std::vector<Node> t;

    SegmentTree(std::vector<int> &a)
    {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    Node mer(Node a, Node b)
    {
        return {a.val + b.val};
    }

    void build(int i, int l, int r, std::vector<int> &a)
    {
        if (l == r - 1)
        {
            t[i].val = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * i + 1, l, mid, a);
        build(2 * i + 2, mid, r, a);
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    void upd(int i, int l, int r, int pos, int v)
    {
        if (l == r - 1)
        {
            t[i].val = v;
            return;
        }
        int mid = (l + r) / 2;
        if (mid > pos)
        {
            upd(2 * i + 1, l, mid, pos, v);
        }
        else
        {
            upd(2 * i + 2, mid, r, pos, v);
        }
        t[i] = mer(t[2 * i + 1], t[2 * i + 2]);
    }

    Node query(int i, int l, int r, int ql, int qr)
    {
        if (l >= ql && r <= qr)
        {
            return t[i];
        }
        if (r <= ql || l >= qr)
        {
            return {0};
        }
        int mid = (l + r) / 2;
        return mer(query(2 * i + 1, l, mid, ql, qr), query(2 * i + 2, mid, r, ql, qr));
    }
};

std::mt19937_64 rnd(2683248);

int32_t main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n;
    std::cin>>n;

    std::vector<int>d(n),l(n),r(n);
    for(int i=0;i<n;i++){
        std::cin>>d[i];
    }
    for(int j=0;j<n;j++){
        std::cin>>l[j];
    }
    for(int i=0;i<n;i++){
        std::cin>>r[i];
    }
    int a,b;
    std::cin>>a>> b;
    int max=0;

    for(int j=0;j<(1<<n);j++){
        int clone_a=a,clone_b=b;
        for(int i=0;i<n;i++){
            clone_a=clone_a+d[i];
            clone_b=clone_b+d[i];
            if((j>>i)&1){
                clone_a=std::min(clone_a,l[i]);
            }else{
                clone_b=std::min(clone_b,r[i]);
            }
        }
        max=std::max(clone_a+clone_b,max);
    }
    std::cout<<max;
}
