

#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <assert.h>
#include <random>
#include <algorithm>
#include <string>
#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

mt19937 rnd(0);
#define fast ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define ff first
#define ss second

//#define int long long
const int MOD = 1e9 + 7, INF = 1e9 + 7;
int n;
map<int, int> ind;
vector<int> tree, add;
vi a, b, sorted;
int sz;

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        tree[v] = 1;
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm, tr);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}
void push(int v, int tl, int tr) {
    if (add[v] == 0) return;
    add[v] = 0;
    tree[v] = 0;
    if (tr - tl > 1) {
        add[2 * v + 1] = 1;
        add[2 * v + 2] = 1;
    }
}

void upd(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (l >= tr || tl >= r) return;
    if (l <= tl && tr <= r) {
        add[v] = 1;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v + 1, tl, tm, l, r);
    upd(2 * v + 2, tm, tr, l, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get_zero(int v, int tl, int tr, int l, int r) {
    if (l >= tr || tl >= r) return 0;
    push(v, tl, tr);
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl + tr) / 2;
    int c1 = get_zero(2 * v + 1, tl, tm, l, r);
    int c2 = get_zero(2 * v + 2, tm, tr, l, r);
    return c1 + c2;
}

int left_z(int id) {
    int l = -1, r = id;
    //if (get_zero(0, 0, sz, 0, id) == 0) return -1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (get_zero(0, 0, sz, m, id))
            l = m;
        else
            r = m;
    }
    return l;
}

int right_z(int id) {
    int l = id, r = sz;
    //if (get_zero(0, 0, sz, 0, id) == 0) return -1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (get_zero(0, 0, sz, id, m))
            r = m;
        else
            l = m;
    }
    return r;
}

void solve() {
    cin >> n;
    a.clear();
    a.resize(n);
    b.clear();
    b.resize(n);
    for (auto& i : a) cin >> i;
    for (auto& i : b) cin >> i;

    set<int> s;
    sz = 0;
    for (auto& i : a) s.insert(i);
    for (auto& i : b) s.insert(i);
    sorted.clear();
    sorted.resize(s.size());
    for (auto& x : s) {
        ind[x] = sz;
        sorted[sz] = x;
        sz++;
    }

    tree.clear();
    add.clear();
    tree.resize(4 * sz);
    add.resize(4 * sz);

    build(0, 0, sz);

    long long SM = 0;
    int maxi = 0;
    set<int> id_b, id_a;
    for (int i = 0; i < n; ++i) {
        int a0 = a[i], b0 = b[i];
        int x = ind[a0], y = ind[b0];
        id_a.insert(x);
        id_b.insert(y);
        SM += a0 - b0;
        maxi = max(maxi, a0 - b0);

        upd(0, 0, sz, y, x);

        int l = left_z(y), r = right_z(x);
        int idb = *id_b.upper_bound(l);
        int ida = *(--id_a.upper_bound(r));

        if (idb <= r && ida > l) {
            maxi = max(maxi, sorted[ida] - sorted[idb]);
        }
        cout << (long long) SM - maxi << " ";
    }
    cout << "\n";
}

signed main()
{
    fast;
    int t;
    cin >> t;
    while (t--) solve();
}