//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 4e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct node{
    int v, l ,r;
};

int n;
vector<int> a, b;
vector<node> tree(4 * N);

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = {0, l, r};
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m), build(2 * v + 2, m, r);
    tree[v] = {0, l, r};
}

void update(int v, int i, int x) {
    if (tree[v].r - tree[v].l == 1) {
        tree[v].v += x;
        return;
    }
    int m = (tree[v].r + tree[v].l) / 2;
    if (i < m) {
        update(2 * v + 1, i, x);
    } else {
        update(2 * v + 2, i, x);
    }
    tree[v].v = tree[2 * v + 1].v + tree[2 * v + 2].v;
}

int get(int v, int l, int r) {
    if (tree[v].r <= l || tree[v].l >= r || tree[v].v == 0) {
        return INF;
    }
    if (tree[v].r - tree[v].l == 1 && tree[v].v >= 1) {
        return l;
    }
    if (tree[v].r - tree[v].l == 1) {
        return INF;
    }
    return min(get(2 * v + 1, l, r), get(2 * v + 2, l, r));
}

int gets(int v, int l, int r) {
    if (tree[v].r <= l || tree[v].l >= r) {
        return 0;
    }
    if (tree[v].r <= r && tree[v].l >= l) {
        return tree[v].v;
    }
    return gets(2 * v + 1, l, r) + gets(2 * v + 2, l, r);
}

void a2() {
    vector<int> all;
    int yk1 = 0, yk2 = 0;
    while (yk1 < n && yk2 < n) {
        if (a[yk1] < b[yk2]) {
            all.push_back(a[yk1++]);
        } else if (a[yk1] > b[yk2]) {
            all.push_back(b[yk2++]);
        } else {
            yk1++;
        }
    }
    while (yk1 < n) {
        all.push_back(a[yk1++]);
    }
    while (yk2 < n) {
        all.push_back(a[yk2++]);
    }
    for (int &e : a) {
        e = lower_bound(all.begin(), all.end(), e) - all.begin();
    }
    for (int &e : b) {
        e = lower_bound(all.begin(), all.end(), e) - all.begin();
    }

    int m = (int)all.size();
    build(0, 0, m);

    int mx = all[a[0]] - all[b[0]], sum = all[a[0]] - all[b[0]];
    update(0, a[0], 1);
    int cnt = 1;
    vector<int> l(n);
    iota(l.begin(), l.end(), 0);
    for (int i = 1; i < n; i++) {
        int pos = get(0, b[i], m);
        if (pos == b[i]) {
            update(0, b[i], -1);
            l[i] = l[i - 1];
            cnt--;
            mx = max(mx, all[a[i]] - all[b[l[i - 1]]]);
        } else {
            int s = gets(0, pos + 1, m);
            mx = max(mx, all[a[i]] - all[b[l[i - s]]]);
        }
        update(0, a[i], 1);
        cnt++;
        sum += all[a[i]] - all[b[i]];
        cout << sum - mx << ' ';
    }
}

void a1() {
    int mx = a[0] - b[0], sum = a[0] - b[0];
    for (int i = 1; i < n; i++) {
        mx = max(mx, a[i] - b[i]);
        sum += a[i] - b[i];
        cout << sum - mx << ' ';
    }
}

void stupid() {
    vector<int> va = {a[0]}, vb = {b[0]};
    int sum = a[0] - b[0];
    for (int i = 1; i < n; i++) {
        va.push_back(a[i]), vb.push_back(b[i]);
        stack<int> st;
        sort(va.begin(), va.end());
        sort(vb.begin(), vb.end());
        int yk1 = 0, yk2 = 0, ans = 0;
        while (yk1 <= i && yk2 <= i) {
            if (va[yk1] < vb[yk2]) {
                if (!st.empty() && st.top() < 0) {
                    ans = max(ans, va[yk1] + st.top());
                    st.pop();
                } else {
                    st.push(va[yk1]);
                }
                yk1++;
            } else if (va[yk1] == vb[yk2]) {
                yk1++, yk2++;
            } else {
                if (!st.empty() && st.top() > 0) {
                    ans = max(ans, st.top() - vb[yk2]);
                    st.pop();
                } else {
                    st.push(-vb[yk2]);
                }
                yk2++;
            }
        }
        while (!st.empty() && yk1 <= i) {
            ans = max(ans, va[yk1] + st.top());
            st.pop();
            yk1++;
        }
        while (!st.empty() && yk2 <= i) {
            ans = max(ans, st.top() - vb[yk2]);
            st.pop();
            yk2++;
        }
        sum += a[i] - b[i];
        cout << sum - ans << ' ';
    }
}


void solve() {
    cin >> n;
    a.resize(n), b.resize(n);
    for (int &e : a) {
        cin >> e;
    }
    for (int &e : b) {
        cin >> e;
    }
    bool fl = true, fl1 = true;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] >= b[i + 1]) {
            fl = false;
        }
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            fl1 = false;
        }
    }
    cout << "0 ";
    if (fl) {
        a1();
    } else if (fl1) {
        a2();
    } else {
        stupid();
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
