#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

//#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 2e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

int n;
vector<int> a(N), b(N), tree(8 * N);

void update(int v, int &i, int x, int l, int r) {
    if (r - l == 1) {
        tree[v] += x;
        return;
    }
    int m = (r + l) >> 1;
    if (i < m) {
        update(2 * v + 1, i, x, l, m);
    } else {
        update(2 * v + 2, i, x, m, r);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int &lq, int &rq, int l, int r) {
    if (r <= lq || l >= rq || tree[v] == 0) {
        return INFi;
    }
    if (r - l == 1 && tree[v] >= 1) {
        return l;
    }
    if (r - l == 1) {
        return INFi;
    }
    int m = (r + l) >> 1;
    return min(get(2 * v + 1, lq, rq, l, m), get(2 * v + 2, lq, rq, m, r));
}

int gets(int v, int &lq, int &rq, int l, int r) {
    if (r <= lq || l >= rq) {
        return 0;
    }
    if (r <= rq && l >= lq) {
        return tree[v];
    }
    int m = (r + l) >> 1;
    return gets(2 * v + 1, lq, rq, l, m) + gets(2 * v + 2, lq, rq, m, r);
}

void a2() {
    vector<int> all = a;
    for (int &e : b) {
        all.emplace_back(e);
    }
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    vector<int> a1 = a, b1 = b;
    for (int &e : a) {
        e = (int)(lower_bound(all.begin(), all.end(), e) - all.begin());
    }
    for (int &e : b) {
        e = (int)(lower_bound(all.begin(), all.end(), e) - all.begin());
    }

    int m = (int)all.size(), mx = a1[0] - b1[0];
    for (int i = 0; i < min(8 * N, 4 * m); i++) {
        tree[i] = 0;
    }
    ll sum = a1[0] - b1[0];
    update(0, a[0], 1, 0, m);
    int cnt = 0;
    for (int i = 1; i < n; i++) {
        int pos = get(0, b[i], m, 0, m), s = 0;
        if (pos != INFi) {
            s = gets(0, pos, m, 0, m);
        }
        if (s > 0) {
            cnt++;
        } else {
            cnt = 0;
        }
        mx = max(mx, a1[i] - b1[i - cnt]);
        update(0, a[i], 1, 0, m);
        sum += a1[i] - b1[i];
        cout << sum - mx << ' ';
    }
}

void stupid() {
    vector<int> va = {a[0]}, vb = {b[0]};
    ll sum = a[0] - b[0];
    for (int i = 1; i < n; i++) {
        va.emplace_back(a[i]), vb.emplace_back(b[i]);
        stack<int> st;
        sort(va.begin(), va.end());
        sort(vb.begin(), vb.end());
        int yk1 = 0, yk2 = 0, ans = 0;
        while (yk1 <= i && yk2 <= i) {
            if (va[yk1] < vb[yk2]) {
                if (!st.empty() && st.top() < 0) {
                    ans = max(ans, va[yk1] + st.top());
                    st.pop();
                } else {
                    st.push(va[yk1]);
                }
                yk1++;
            } else if (va[yk1] == vb[yk2]) {
                yk1++, yk2++;
            } else {
                if (!st.empty() && st.top() > 0) {
                    ans = max(ans, st.top() - vb[yk2]);
                    st.pop();
                } else {
                    st.push(-vb[yk2]);
                }
                yk2++;
            }
        }
        while (!st.empty() && yk1 <= i) {
            ans = max(ans, va[yk1] + st.top());
            st.pop();
            yk1++;
        }
        while (!st.empty() && yk2 <= i) {
            ans = max(ans, st.top() - vb[yk2]);
            st.pop();
            yk2++;
        }
        sum += a[i] - b[i];
        cout << sum - ans << ' ';
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    bool fl = true;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            fl = false;
            break;
        }
    }
    cout << "0 ";
    if (fl) {
        a2();
    } else {
        stupid();
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
