#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));
struct SegTree {
    vector<int> tree;
    int n;
    SegTree(int _n) : n(_n), tree(2 * _n, inf) {}
    void update(int pos, int val) {
        for (tree[pos += n] = val; pos > 1; pos >>= 1) tree[pos >> 1] = min(tree[pos], tree[pos ^ 1]);
    }
    int query(int l, int r) {
        int ans = inf;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) chmin(ans, tree[l++]);
            if (r & 1) chmin(ans, tree[--r]);
        }
        return ans;
    }
};
void solve_case() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    vector<int> fst(n, n);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int l, int r){
        return a[l] > a[r];
    });
    int ptr = 0;
    SegTree st(n);
    for (int i : ord) {
        while (ptr != n && a[ord[ptr]] >= a[i]) {
            st.update(ord[ptr], b[ord[ptr]]);
            ptr++;
        }
        if (i != 0 && st.query(0, i - 1) <= a[i]) {
            fst[i] = i;
        } else {
            int left = i, right = n;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (st.query(i + 1, mid) <= a[i]) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            fst[i] = right;
        }
    }
    vector<int> diff(n);
    for (int i = 0; i < n; i++) diff[i] = a[i] - b[i];
    multiset<int> bad; bad.insert(-1), bad.insert(inf);
    multiset<pair<int, int>> good;
    vector<vector<int>> add(n + 1);
    function<int(int)> relax = [&](int v) {
        int ra = *bad.upper_bound(a[v]) - 1;
        int la = *prev(bad.lower_bound(a[v])) + 1;
        int mb = good.lower_bound({la, 0})->se;
        int ma = prev(good.upper_bound({ra, 0}))->fi;
        if (ra + 1 != inf) ma = max(ma, ra + 1);
        return ma - mb;
    };
    for (int i = 0; i < n; i++) {
        add[fst[i]].push_back(i);
        bad.insert(a[i]);
        for (int v : add[i]) {
            bad.extract(a[v]);
            good.insert({a[v], b[v]});
            chmax(diff[i], relax(v));
        }
    }
    for (int i = 0; i + 1 < n; i++) chmax(diff[i + 1], diff[i]);
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        cout << sum - diff[i] << " \n"[i == n - 1];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
}
