#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

constexpr ll INF = 1e18;

struct SegTree {
    vector<ll> tree, md;
    int sz;
    SegTree(int n) {
        for (sz = 1; sz < n; sz <<= 1) {}
        tree.assign(2 * sz, INF);
        md.assign(2 * sz, 0);
    }
    void push(int v) {
        tree[v] += md[v];
        if (v < sz) {
            tree[2 * v] += md[v];
            tree[2 * v + 1] += md[v];
        }
        md[v] = 0;
    }
    ll get(int l, int r, int tl, int tr, int v) {
        push(v);
        if (tr <= l || r <= tl)
            return INF;
        if (l <= tl && tr <= r)
            return tree[v];
        int tm = (tl + tr) / 2;
        return min(get(l, r, tl, tm, 2 * v), get(l, r, tm, tr, 2 * v + 1));
    }
    void add(int l, int r, ll val, int tl, int tr, int v) {
        push(v);
        if (tr <= l || r <= tl)
            return;
        if (l <= tl && tr <= r) {
            md[v] = val;
            push(v);
            return;
        }
        int tm = (tl + tr) / 2;
        add(l, r, val, tl, tm, 2 * v);
        add(l, r, val, tm, tr, 2 * v + 1);
        tree[v] = min(tree[2 * v], tree[2 * v + 1]);
    }
    void setv(int i, ll val, int tl, int tr, int v) {
        push(v);
        if (tr <= i || i + 1 <= tl)
            return;
        if (tl == i && tr == i + 1) {
            tree[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        setv(i, val, tl, tm, 2 * v);
        setv(i, val, tm, tr, 2 * v + 1);
        tree[v] = min(tree[2 * v], tree[2 * v + 1]);
    }
};

ll solve(vector<int> a, vector<int> b) {
    ll ans = INF, cur = 0;
    sort(all(a));
    sort(all(b));
    int n = a.size();

    vector<ll> pref_fuck(n), pref(n + 1);
    vector<int> poses;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] < b[i + 1])
            poses.push_back(i);
        pref_fuck[i + 1] = pref_fuck[i] + a[i] - b[i + 1];
        pref[i + 1] = pref[i] + a[i] - b[i];
    }
    poses.push_back(n - 1);
    pref[n] = pref[n - 1] + a[n - 1] - b[n - 1];

    for (int i = 0; i < n; i++) {
        int j = *lower_bound(all(poses), i);
        // от i до j - 1 берём косые, потом прямые
        ll val = pref_fuck[j] - pref_fuck[i] + pref[i] + (pref[n] - pref[j + 1]);
        ans = min(ans, val);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    bool fl = 1;
    for (int i = 0; i < n - 1; i++)
        fl &= a[i] <= a[i + 1];
    for (int i = 0; i < n - 1; i++)
        fl &= b[i] <= b[i + 1];

    if (!fl) {
        for (int i = 0; i < n; i++) {
            vector<int> c = a, d = b;
            c.resize(i + 1);
            d.resize(i + 1);
            cout << solve(c, d) << ' ';
        }
        cout << '\n';
    } else {
        SegTree st(n);
        vector<int> poses;
        ll cur = 0;
        for (int i = 0; i < n; i++) {
            if (i && a[i - 1] < b[i]) {
                st.add(0, i, a[i] - b[i], 0, st.sz, 1);
                poses.push_back(i - 1);
            } else if (i) {
                st.add((poses.empty() ? 0 : poses.back() + 1), i, a[i - 1] - b[i], 0, st.sz, 1);
                st.add(0, (poses.empty() ? 0 : poses.back() + 1), a[i] - b[i], 0, st.sz, 1);
            }
            st.setv(i, cur, 0, st.sz, 1);
            cout << st.get(0, i + 1, 0, st.sz, 1) << ' ';
            cur += a[i] - b[i];
        }
        cout << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}
