#include<bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;


const int INF = 2e9 + 1;


struct Sigma3mx
{
    vector<int> mx = {INF};
    vector<int> L = {-1};
    vector<int> R = {-1};

    int make_nw()
    {
        L.push_back(-1);
        R.push_back(-1);
        mx.push_back(-INF);
        return mx.size() - 1;
    }

    void update(int ind, int l, int r, int x, int val)
    {
        if (l > x || r <= x)
        {
            return;
        }
        if (r - l == 1)
        {
            mx[ind] = max(val, mx[ind]);
            return;
        }
        if (L[ind] == -1)
        {
            L[ind] = make_nw();
        }
        if (R[ind] == -1)
        {
            R[ind] = make_nw();
        }
        update(L[ind], l, (l + r) / 2, x, val);
        update(R[ind], (l + r) / 2, r, x, val);
        mx[ind] = max(mx[L[ind]], mx[R[ind]]);
        return;
    }

    int get_mx(int ind, int l, int r, int lf, int rf)
    {
        if (ind == -1)
        {
            return -INF;
        }
        if (l > rf || lf > r)
        {
            return -INF;
        }
        if (l >= lf && rf >= r)
        {
            return mx[ind];
        }
        return max(get_mx(L[ind], l, (l + r) / 2, lf, rf), get_mx(R[ind], (l + r) / 2, r, lf, rf));
    }
};


struct Sigma3mn
{
    vector<int> mn = {INF};
    vector<int> L = {-1};
    vector<int> R = {-1};

    int make_nw()
    {
        L.push_back(-1);
        R.push_back(-1);
        mn.push_back(INF);
        return mn.size() - 1;
    }

    void update(int ind, int l, int r, int x, int val)
    {
        if (l > x || r <= x)
        {
            return;
        }
        if (r - l == 1)
        {
            mn[ind] = min(val, mn[ind]);
            return;
        }
        if (L[ind] == -1)
        {
            L[ind] = make_nw();
        }
        if (R[ind] == -1)
        {
            R[ind] = make_nw();
        }
        update(L[ind], l, (l + r) / 2, x, val);
        update(R[ind], (l + r) / 2, r, x, val);
        mn[ind] = min(mn[L[ind]], mn[R[ind]]);
        return;
    }

    int get_mn(int ind, int l, int r, int lf, int rf)
    {
        if (ind == -1)
        {
            return INF;
        }
        if (l > rf || lf > r)
        {
            return INF;
        }
        if (l >= lf && rf >= r)
        {
            return mn[ind];
        }
        return min(get_mn(L[ind], l, (l + r) / 2, lf, rf), get_mn(R[ind], (l + r) / 2, r, lf, rf));
    }
};


int32_t main()
{
    if (0)
    {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    if (1)
    {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    map<int, int> match;
    int free_ = 0;
    while (t--)
    {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<int> b(n);
        Sigma3mn mn;
        Sigma3mx mx;
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
        }
        for (int i = 0; i < n; i++)
        {
            cin >> b[i];
        }
        ll sma = 0;
        ll smb = 0;
        int mxr = 0;
        for (int i = 0; i < n; i++)
        {
            mn.update(0, 0, INF, a[i], b[i]);
            mx.update(0, 0, INF, b[i], a[i]);
            mxr = max(mxr, mx.get_mx(0, 0, INF, b[i], a[i] + 1) - mn.get_mn(0, 0, INF, b[i], a[i] + 1));
            sma += a[i];
            smb += b[i];
            cout << sma - smb - mxr << ' ';
        }
        cout << '\n';
    }
    return 0;
}
