#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = 1e9;

struct Fenwick {
	vector<int> t;
	Fenwick(int n) {
		t.resize(n);
	}
	void inc(int i, int val) {
		for (; i < t.size(); i = (i | (i + 1))) {
			t[i] += val;
		}
	}
	int get(int r) {
		int ans = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			ans += t[r];
		}
		return ans;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n), b(n);
		set<int> zeroes{INF}, As;
		vector<int> u;
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			u.pb(a[i]);
		}
		for (int i = 0; i < n; i++) {
			cin >> b[i];
			u.pb(b[i]);
		}
		sort(all(u));
		u.erase(unique(all(u)), u.end());
		set<pair<int, int>> st;
		int sz = u.size();
		vector<int> anss(sz, -1);
		Fenwick F(sz);
		auto del = [&](int i) -> void {
			st.erase({anss[i], i});
			anss[i] = -1;
			zeroes.erase(i);
		};
		auto upd = [&](int i) -> void {
			if (anss[i] != -1) {
				del(i);
			}
			zeroes.insert(i);
			int nxt = *zeroes.upper_bound(i);
			int Last = *prev(As.lower_bound(nxt));
			anss[i] = u[Last] - u[i];
			st.insert({anss[i], i});
		};
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			ans += a[i] - b[i];
			int j = lower_bound(all(u), a[i]) - u.begin();
			int k = lower_bound(all(u), b[i]) - u.begin();
			As.insert(j);
			F.inc(j, 1);
			F.inc(k, -1);
			while (1) {
				int val = *zeroes.upper_bound(k);
				if (val <= j) {
					del(val);
				} else {
					break;
				}
			}
			if (F.get(k, sz - 1) == 0) {
				upd(k);
			}
			if (zeroes.lower_bound(k) != zeroes.begin()) {
				upd(*prev(zeroes.lower_bound(k)));
			}	
			cout << ans - (*st.rbegin()).first << ' ';
		}
		cout << '\n';
	}
	return 0;
}