#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 2000;
constexpr long long T = 20;
constexpr long long inf = 1e18;
constexpr long long A = 20028;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> ans(n, inf);
    for (int i = 0; i < n; i++) {
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        int cs = 0;
        for (int j = 0; j < i + 1; j++) {
            cs += a[j];
            cs -= b[j];
        }
        vector<int> gd(i + 1, 0);
        for (int j = 1; j < i + 1; j++) {
            if (b[j] <= a[j - 1]) gd[j] = 1;
        }
        int l0 = 0;
        for (int j = 1; j < i + 1; j++) {
            if (gd[j] == 0) l0 = j;
            else {
                ans[i] = min(ans[i], cs - a[j] + b[l0]);
            }
        }

        for (int j = 0; j < i + 1; j++) {
            ans[i] = min(ans[i], cs - a[j] + b[j]);
        }

        // cout << gd << endl;
    }

    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;

    while (tests --> 0) solve();
}