#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <climits>
#define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n;
vector<int> a1, b1;
vector<int> a, b;

void clear() {
    a1.clear();
    b1.clear();
    a.clear();
    b.clear();
}

void resize() {
    a1.resize(n);
    b1.resize(n);
}

void merge(const vector<int> &arr, int el, vector<int> &res) {
    bool taken = false;
    int i;
    for (i = 0; i < arr.size() && arr[i] <= el; ++i) {
        res.push_back(arr[i]);
    }
    res.push_back(el);
    for (; i < arr.size(); ++i) {
        res.push_back(arr[i]);
    }
    assert(res.size() == arr.size() + 1);
}

void solve1() {
    // решаем за квадрат
    int asu = 0;
    int bsu = 0;
    int maxd = 0;
    for (int i = 0; i < n; ++i) {
        vector<int> ac(0), bc(0);
        swap(ac, a);
        swap(bc, b);
        a.reserve(i + 1);
        b.reserve(i + 1);
        merge(ac, a1[i], a);
        merge(bc, b1[i], b);
        asu += a1[i];
        bsu += b1[i];
        maxd = max(maxd, a1[i] - b1[i]);

        int pref = 0;
        int mm = INT_MAX;
        for (int j = 0; j < a.size() - 1; ++j) {
            if (!(a[j] >= b[j + 1])) {
                int var = b[pref] - a[j];
                mm = min(mm, var);
                pref = j + 1;
            }
        }
        mm = min(mm, b[pref] - a[a.size() - 1]);
        int ans = min(asu - bsu - maxd, asu - bsu + mm);
        cout << ans << " ";
    }
    cout << endl;
}

void solve() {
    clear();
    cin >> n;
    resize();

    for (int i = 0; i < n; ++i) cin >> a1[i];
    for (int i = 0; i < n; ++i) cin >> b1[i];
    if (n <= 3000) {
        solve1();
    } else {
        cout << "no solution" << endl;
    }
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("C:/Users/olymp/Documents/code/in.txt", "r", stdin);
    #endif

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}