#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_map>

using namespace std;

#define int long long

struct node {
	int li, ri, val;
};

vector<node> t(3000000);
int maxNode = 0;
int newNode() {
	t[maxNode] = { -1, -1, 0 };
	return maxNode++;
}

void update(int now, int left, int right, int ind, int val) {
	if (left == right) {
		t[now].val += val;
		return;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (ind <= mid) update(t[now].li, left, mid, ind, val);
	else update(t[now].ri, mid + 1, right, ind, val);
	t[now].val = t[t[now].li].val + t[t[now].ri].val;
}

int sum(int now, int left, int right, int tleft, int tright) {
	if (tleft > tright) return 0;
	if (tleft == left and tright == right) return t[now].val;
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	return sum(t[now].li, left, mid, tleft, min(tright, mid)) +
		sum(t[now].ri, mid + 1, right, max(tleft, mid + 1), tright);
}

int sum2(int now, int left, int right, int k) {
	if (left == right) return left;
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (t[t[now].ri].val >= k) return sum2(t[now].ri, mid + 1, right, k);
	else return sum2(t[now].li, left, mid, k - t[t[now].ri].val);
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t2;
	for (cin >> t2; t2 > 0; t2--) {
		int n;
		cin >> n;
		maxNode = 0;
		t.resize(0);
		t.resize(3000000);
		vector<int> a(n);
		for (int i = 0; i < n; i++) cin >> a[i];
		vector<int> b(n);
		for (int i = 0; i < n; i++) cin >> b[i];

		multiset<int> as;
		multiset<int> bs;
		int ans = 0;
		newNode();
		newNode();
		for (int i = 0; i < n; i++) {
			as.insert(a[i]);
			update(0, 0, 1100000000, a[i], 1);
			bs.insert(b[i]);
			update(1, 0, 1100000000, b[i], 1);
			ans += a[i];
			ans -= b[i];
			int ans2 = ans;
			int ans3 = ans;
			for (int j = 0; j <= i; j++) {
				ans2 = ans;
				ans2 -= a[j];
				ans2 += b[j];

				update(0, 0, 1100000000, a[j], -1);
				update(1, 0, 1100000000, b[j], -1);
				//as.erase(as.find(a[j]));
				bs.erase(bs.find(b[j]));

				// Используем оставшуюся ашку на какой-то другой точке
				if (bs.upper_bound(a[j]) != bs.begin()) {
					//cout << i << " " << j << " LOl\n";
					int u = *(--bs.upper_bound(a[j]));
					int u2 = sum(1, 0, 1100000000, u, 1100000000);
					int u3 = sum2(0, 0, 1100000000, u2);
					int u4 = sum(1, 0, 1100000000, u3, 1100000000);
					int u5 = sum2(0, 0, 1100000000, u4 + 1);
					//cout << j << " " << u << " " << u2 << " " << u3 << " lolol\n";
					if (a[j] < u5) {
						ans2 += a[j];
						ans2 -= u5;
					}
				}
				//cout << i << " " << j << " " << ans3 << " ehhee ";
				ans3 = min(ans3, ans2);
				//as.insert(a[j]);
				bs.insert(b[j]);
				update(0, 0, 1100000000, a[j], 1);
				update(1, 0, 1100000000, b[j], 1);
			}
			cout << ans3 << " ";
		}
		cout << "\n";
	}


}

/*

Предположим, что мы на i ходе взяли минимум от a, какой результат?
1) Есть куча челов вида l[i], X. Среди них выбираем максимальный икс
2) Есть ещё челики, вида a < l[i], Y
Сразу выкидываем тех, у кого Y <= X
А с остальными что делать? Например:
l[i] - 1, X + 1
l[i] - 2, X + 2
l[i] - 3, X + 3
И тд

4 0 7 0 8
10 5 3 7 7
8 5 9 2 23

4 0 7 0 8
6 1 -8 -4 -12
4 1 -2 -9 4
4 8

В итоге убираем все d, теперь числа монотонно убывают
Можно перебрать первый минимум


*/
