#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 300;

struct block {
    int len, mnDP;
    int mn, mx;
    vector<pii> a;

    block();
    block(pii b) {
        mnDP = 0;
        len = 1;
        mn = mx = b.fi;
        a.pb(b);
    }
    block(vector<pii> b) {
        mnDP = 0;
        len = sz(b);
        fe (x, b) {
            mn = min(mn, x.fi);
            mx = max(mx, x.se);
            a.pb(x);
        }
    }

    void insert(pii b) {
        mx = max(mx, b.fi);
        mn = min(mn, b.fi);
        fr (i, 0, len - 1) {
            if(a[i].fi >= b.fi) {
                a.insert(a.begin() + i, b);
                return;
            }
        }
        a.pb(b);
        return;
    }
};

struct {
    int len, curAns, curDp, curSum;
    vector<block> sqrtArr;
    vector<block> revSqrt;

    void rebuild(int index) {
        int to = sqrtArr[index].len / 2;
        vector<pii> left, right;
        fr (i, 0, to - 1) {
            left.pb(sqrtArr[index].a[i]);
        }
        fr (i, to, len - 1) {
            right.pb(sqrtArr[index].a[i]);
        }
        sqrtArr.insert(sqrtArr.begin() + index, block(left));
        sqrtArr[index] = block(right);
    }

    void insert(pii curElement) {
        if(sqrtArr.empty()) {
            sqrtArr.pb(curElement);
            curSum += curElement.fi - curElement.se;
            sqrtArr[0].mnDP = max(sqrtArr[0].mnDP, curElement.fi - curElement.se);
            curDp = max(curDp, sqrtArr[0].mnDP);
            return;
        }
        rf (i, sz(sqrtArr) - 1, 0) {
            if(sqrtArr[i].mn <= curElement.fi || i == 0) {
                bool vs = 0;
                pii qLess = {-1, -1};
                rf (j, i, 0) {
                    if(sqrtArr[j].mx >= curElement.se) {
                        fr (l, 0, sz(sqrtArr[j].a) - 1) {
                            pii q = sqrtArr[j].a[l];
                            if(q.fi >= curElement.se) {
                                if(qLess.fi == -1 || (curElement.fi - curElement.se) + (qLess.fi - qLess.se) - (qLess.fi - curElement.se) < (curElement.fi - curElement.se) + (q.fi - q.se) - (q.fi - curElement.se)) {
                                    vs = 1;
                                    qLess = q;
                                }
                                if(sqrtArr[i].mnDP < (curElement.fi - curElement.se) + (q.fi - q.se) - (q.fi - curElement.se)) {
                                    sqrtArr[i].mnDP = (curElement.fi - curElement.se) + (q.fi - q.se) - (q.fi - curElement.se);
                                }
                            }
                        }
                        break;
                    }
                }
                sqrtArr[i].insert(curElement);
                sqrtArr[i].mnDP = max(sqrtArr[i].mnDP, curElement.fi - curElement.se);
                curSum += curElement.fi - curElement.se;

                curDp = max(curDp, sqrtArr[0].mnDP);

                if(sqrtArr[i].len >= 2 * len) {
                    rebuild(i);
                }
                return;
            }
        }
    }

    void init(int LEN) {
        curDp = 0;
        curSum = 0;
        curAns = 1e9;
        len = LEN;
        sqrtArr.clear();
    }
} sqrt_arr;

int main() {
    int t;
    cin >> t;

    while(t--) {
        int n;
        cin >> n;

        int len = (int)sqrt(n) + 1;

        vector<pii> ls(n);
        sqrt_arr.init(len);
        fr (i, 0, n - 1) {
            cin >> ls[i].fi;
        }
        fr (i, 0, n - 1) {
            cin >> ls[i].se;
        }

        fr (i, 0, n - 1) {
            sqrt_arr.insert(ls[i]);
            cout << sqrt_arr.curSum - sqrt_arr.curDp << " \n"[i == n - 1];
        }
    }    
    
    return 0;
}