#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;

typedef long double ld;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 1E5, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;

constexpr uint32_t MOD = 998244353, MOD_phi = MOD - 1;
struct Mod_int
{
	uint32_t val;
	Mod_int(uint64_t val = 0) :val(val% MOD) {}
	Mod_int operator+ (const Mod_int m) const
	{
		return val + m.val;
	}
	Mod_int operator+= (const Mod_int m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int m) const
	{
		return MOD - m.val + val;
	}
	Mod_int operator-= (const Mod_int m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int m) const
	{
		return uint64_t(val) * m.val;
	}
	Mod_int operator*= (const Mod_int m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step_val) const
	{
		Mod_int ans = 1, cur = *this;
		while (step_val > 0)
		{
			if (step_val & 1)
			{
				ans *= cur;
			}
			step_val >>= 1;
			cur *= cur;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int m) const
	{
		return *this * m.step(MOD_phi - 1);
	}
	Mod_int operator/= (const Mod_int m)
	{
		return *this = *this / m;
	}
};



void solve()
{
	int n;
	cin >> n;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
	}

	if (n <= 3000)
	{
		vector <int> srt_a, srt_b;
		int64_t sum_a = 0, sum_b = 0;
		for (int i = 0; i < n; i++)
		{
			srt_a.push_back(a[i]);
			sort(ALL(srt_a));
			sum_a += a[i];

			srt_b.push_back(b[i]);
			sum_b += b[i];
			sort(ALL(srt_b));

			vector <int> bad_ind;
			bad_ind.push_back(-1);
			for (int i = 0; i < srt_a.size() - 1; i++)
			{
				if (srt_a[i] < srt_b[i + 1])
				{
					bad_ind.push_back(i);
				}
			}
			bad_ind.push_back(srt_a.size() - 1);

			int mx_raz = 0;
			for (int i = 1; i < bad_ind.size(); i++)
			{
				rmax(mx_raz, srt_a[bad_ind[i]] - srt_b[bad_ind[i - 1] + 1]);
			}

			cout << sum_a - sum_b - mx_raz << ' ';
		}
	}
	else
	{
		vector <int> srt_a, srt_b, bad_ind;
		bad_ind.push_back(-1);
		int64_t sum_a = 0, sum_b = 0;
		int last_raz = 0, fix_raz = 0;
		for (int i = 0; i < n; i++)
		{
			srt_a.push_back(a[i]);
			sum_a += a[i];

			srt_b.push_back(b[i]);
			sum_b += b[i];

			if (srt_a[srt_a.size() - 2] < srt_b.back())
			{
				rmax(fix_raz, last_raz);
			}
			else
			{
				bad_ind.pop_back();
			}
			last_raz = srt_a.back() - srt_b[bad_ind.back() + 1];
			bad_ind.push_back(i);

			cout << sum_a - sum_b - max(last_raz, fix_raz) << ' ';
		}
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}