#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

ll solve_part(vector<ll> a, vector<ll> b) {
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    ll n = a.size();
    vector<bool> shift(n);
    for (ll i = 0; i + 1 < n; i++) {
        if (a[i] >= b[i + 1]) {
            shift[i] = true;
        }
    }//use ll
    ll mx = 0;
    ll r = 0;
    for (ll l = 0; l < n; l++) {
        r = max(r, l);
        while (shift[r]) {
            r++;
        }
        mx = max(mx, a[r] - b[l]);
    }
    return accumulate(a.begin(), a.end(), 0ll) - accumulate(b.begin(), b.end(), 0ll) - mx;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    cin >> a >> b;
    if (!is_sorted(a.begin(), a.end()) || !is_sorted(b.begin(), b.end())) {
        for (ll i = 0; i < n; i++) {
            vector<ll> t1(a.begin(), a.begin() + i + 1), t2(b.begin(), b.begin() + i + 1);
            cout << solve_part(t1, t2) << ' ';
        }
        cout << '\n';
    } else {
        ll sum = 0, mx = 0;
        vector<bool> shift(n);
        for (ll i = 0; i + 1 < n; i++) {
            if (a[i] >= b[i + 1]) {
                shift[i] = true;
            }
        }
        vector<ll> nearest_left_zero(n, -1);
        vector<ll> st;
        for (ll i = n - 1; i >= 0; i--) {
            while (!st.empty() && !shift[i]) {
                nearest_left_zero[st.back()] = i;
                st.pop_back();
            }
            st.push_back(i);
        }
        for (ll i = 0; i < n; i++) {
            sum += a[i] - b[i];
            mx = max(mx, a[i] - b[nearest_left_zero[i] + 1]);
            cout << sum - mx << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
