#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1, g;
	cin >> t;
	while (t--) {
		solve();
	}
}

const int LG = 19, N = 1 << LG;

struct seg_tree_max {
	int st[2 * N]{};
	void set_element(int i, int v) {
		i += N - 1;
		st[i] = v;
		while (i) {
			i = (i - 1) / 2;
			st[i] = max(st[2 * i + 1], st[2 * i + 2]);
		}
	}
	int get_max(int l, int r) {
		l += N - 1;
		r += N - 1;
		int res = 0;
		while (l <= r) {
			if (~l & 1) {
				res = max(res, st[l++]);
			}
			if (r & 1) {
				res = max(res, st[r--]);
			}
			l = (l - 1) / 2;
			r = (r - 1) / 2;
		}
		return res;
	}
};

struct seg_tree_min {
	int st[2 * N]{};
	void set_element(int i, int v) {
		i += N - 1;
		st[i] = v;
		while (i) {
			i = (i - 1) / 2;
			st[i] = min(st[2 * i + 1], st[2 * i + 2]);
		}
	}
	int get_min(int l, int r) {
		l += N - 1;
		r += N - 1;
		int res = INT32_MAX;
		while (l <= r) {
			if (~l & 1) {
				res = min(res, st[l++]);
			}
			if (r & 1) {
				res = min(res, st[r--]);
			}
			l = (l - 1) / 2;
			r = (r - 1) / 2;
		}
		return res;
	}
};

seg_tree_max stmx;
seg_tree_min stmn;

void solve() {
	int n;
	cin >> n;
	map<int, int> mp;
	vector<int> a(n), b(n), na(n), nb(n);
	vector<pair<int, int>> ab(2 * n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		ab[i] = {a[i], i};
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		ab[i + n] = {b[i], i + n};
	}
	sort(ab.begin(), ab.end());
	for (int i = 0; i < 2 * n; i++) {
		if (ab[i].y >= n) {
			if (i && ab[i].x != ab[i - 1].x) {
				mp[ab[i].x] = i;
			}
			nb[ab[i].y - n] = i;
		} else {
			if (i && ab[i].x != ab[i - 1].x) {
				mp[ab[i].x] = i;
			}
			na[ab[i].y] = i;
		}
	}
	for (int i = 0; i < 2 * N - 1; i++) {
		stmn.st[i] = INT32_MAX;
	}
	for (int i = 0; i < 2 * N - 1; i++) {
		stmx.st[i] = 0;
	}
	ll sum = 0;
	int v = 0;
	for (int i = 0; i < n; i++) {
		sum += a[i] - b[i];
		stmx.set_element(nb[i], na[i]);
		stmn.set_element(na[i], nb[i]);
		// cout << na[i] << ' ' << nb[i] << '\n';
		int l = stmn.get_min(mp[b[i]], mp[a[i]]), r = stmx.get_max(mp[b[i]], mp[a[i]]);
		// cout << l << ' ' << r << '\n';
		v = max(v, ab[r].x - ab[l].x);
		cout << sum - v << ' ';
	}
	cout << '\n';
}