#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x = 0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
	ll operator%(Point oth)
	{
		return x * oth.y - y * oth.x;
	}
	Point operator+(Point oth)
	{
		return Point(x + oth.x, y + oth.y);
	}
};
ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % INF;
	}
	else
	{
		return (binpow(n, p - 1) * n) % INF;
	}
}

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) cin >> b[i];
	bool four = true, five = true;
	for (int i = 0; i < n - 1; i++)
	{
		if (a[i] >= b[i + 1]) four = false;
		if (a[i] > a[i + 1] || b[i] > b[i + 1]) five = false;
	}
	if (four)
	{
		multiset<int> s;
		ll sum = 0;
		for (int i = 0; i < n; i++)
		{
			sum += a[i] - b[i];
			s.insert(a[i] - b[i]);
			cout << sum - *s.rbegin() << ' ';
		}
	}
	else if (five)
	{
		ll asum = 0, bsum = 0;
		ll mx = 0;
		ll lst = -INF;
		for (int i = 0; i < n; i++)
		{
			asum += a[i];
			bsum += b[i];
			vector<int> bb;
			if (b[i] > lst)
			{
				mx = b[i];
			}
			lst = a[i];
			cout << (asum - a[i]) - (bsum - mx) << ' ';
		}
	}
	else if (n <= 3000)
	{
		multiset<int> f, s;
		for (int i = 0; i < n; i++)
		{
			f.insert(a[i]);
			s.insert(b[i]);
			ll sum = 0;
			vector<int> bb;
			auto fi = f.begin(); auto si = s.begin();
			ll mx = 0;
			for (int j = 0; j <= i; j++)
			{
				while (si != s.end() && *si <= *fi)
				{
					bb.push_back(*si); si++;
				}
				sum += (ll)*fi - bb[bb.size() - 1];
				mx = max(mx, (ll)*fi - bb[bb.size() - 1]);
				bb.pop_back();
				fi++;
			}
			cout << sum - mx << ' ';
		}
	}
	cout << '\n';
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	while (t--) solve();
}