#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> A(n);
    vector<ll> B(n);
    for (auto &item: A) {
        cin >> item;
    }

    for (auto &item: B) {
        cin >> item;
    }

    bool verGr = true;
    bool incGr = true;
    for (int i = 0; i < n - 1; ++i) {
        if (A[i] >= B[i + 1]) {
            verGr = false;
        }
        if (A[i] > A[i + 1] || B[i] > B[i + 1]) {
            incGr = false;
        }
    }

    if (verGr) {
        ll sum = 0;
        ll bad = 0;
        for (int i = 0; i < n; ++i) {
            ll d = A[i] - B[i];
            sum += d;
            bad = max(bad, d);
            cout << sum - bad << ' ';
        }
        cout << '\n';
        return;
    }

    if (incGr) {
        ll shPast = 0;
        ll addVer = 0;
        ll shCur = 0;
        cout << 0 << ' ';
        for (ll k = 1; k < n; ++k) {
            addVer += A[k] - B[k];
            if (A[k - 1] >= B[k]) {
                shCur += A[k - 1] - B[k];
            } else {
                if (shPast + addVer > shCur) {
                    shPast = shCur;
                    addVer = 0;
                }
            }

            cout << min(shCur, shPast + addVer) << ' ';
        }

        cout << '\n';
        return;
    }

    multiset<ll> aSet;
    multiset<ll> bSet;
    for (ll k = 0; k < n; ++k) {
        aSet.insert(A[k]);
        bSet.insert(B[k]);

        vector<ll> aa(aSet.begin(), aSet.end());
        vector<ll> bb(bSet.begin(), bSet.end());

        ll m = ll(aa.size());
        vector<ll> prefVer(m);
        ll bad = 0;
        for (ll j = 0; j < m; ++j) {
            prefVer[j] = aa[j] - bb[j];
            bad = max(bad, aa[j] - bb[j]);
            if (j) {
                prefVer[j] += prefVer[j - 1];
            }
        }

        ll res = prefVer.back() - bad;

        vector<ll> sufVer(m);
        for (ll j = m - 1; j >= 0; --j) {
            sufVer[j] = aa[j] - bb[j];
            if (j < m - 1) {
                sufVer[j] += sufVer[j + 1];
            }
        }

        vector<ll> sufSh(m);
        for (ll j = m - 2; j >= 0; --j) {
            if (aa[j] < bb[j + 1]) {
                sufSh[j] = sufVer[j + 1];
            } else {
                sufSh[j] = sufSh[j + 1] + aa[j] - bb[j + 1];
            }
        }

        for (ll shI = 0; shI < m; ++shI) {
            ll tmp = sufSh[shI];
            if (shI) {
                tmp += prefVer[shI - 1];
            }

            res = min(res, tmp);
        }

        cout << res << ' ';
    }

    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll TT;
    cin >> TT;
    while (TT--) {
        solve();
    }
    return 0;
}
