#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(2346927423);

struct DDnode {
    DDnode* l;
    DDnode* r;
    ll val, prior;
    DDnode(ll val = 0) : val(val) {
        l = nullptr;
        r = nullptr;
        prior = rd();
    }
};
DDnode* mer(DDnode* l, DDnode* r) {
    if (l == nullptr)
        return r;
    if (r == nullptr)
        return l;

    if (l->prior > r->prior) {
        l->r = mer(l->r, r);
        return l;
    }
    else {
        r->l = mer(l, r->l);
        return l;
    }
}
pair<DDnode*, DDnode*> split(DDnode* v, ll x) {
    return { v, v };
}

struct pt {
    ll x, y;
    pt(ll x = 0, ll y = 0) : x(x), y(y) {}
};
pt operator+(pt a, pt b) {
    return pt(a.x + b.x, a.y + b.y);
}
pt operator-(pt a, pt b) {
    return pt(a.x - b.x, a.y - b.y);
}
ll operator*(pt a, pt b) {
    return a.x * b.x + a.y * b.y;
}
ll operator%(pt a, pt b) {
    return a.x * b.y - a.y * b.x;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    vector<vector<ll>> ans(t);
    for (int q = 0; q < t; q++) {
        int n;
        cin >> n;
        vector<ll> a(n), b(n);
        vector<int> pos(n), nxt(n), sop(n, -1);
        bool tf = 1;
        for (int i = 0; i < n; i++) {
            nxt[i] = i;
            cin >> a[i];
            if (i > 0 && a[i] < a[i - 1])
                tf = 0;
        }
        for (int i = 0; i < n; i++) {
            cin >> b[i];
            if (i > 0 && b[i] < b[i - 1])
                tf = 0;
        }

        ans[q].assign(n, 0);
        ll mx = 0;
        set<ll> st;
        for (int i = 0; i < n; i++) {
            if (!tf) {
                sort(a.begin(), a.begin() + i + 1);
                sort(b.begin(), b.begin() + i + 1);
                for (int j = 0; j <= i; j++) {
                    nxt[j] = j;
                    pos[j] = upper_bound(b.begin(), b.begin() + i + 1, a[j]) - b.begin() - 1;
                }

                mx = 0;
                for (int j = 0; j <= i; j++) {
                    int p = pos[j];
                    if (p < 0)
                        return 0;
                    while (p != nxt[p])
                        p = nxt[p];
                    nxt[pos[j]] = p - 1;
                    ans[q][i] += a[j] - b[p];
                    mx = max(a[j] - b[p], mx);
                }
                ans[q][i] -= mx;
            }
            else {
                if (i > 0)
                    ans[q][i] = ans[q][i - 1] + mx;

                //for (int j = i - 1; j >= 0 && sop[j] != -1 && a[sop[j]] >= b[j + 1]; j--) {
                //    nxt[i] = j;
                //    nxt[j - 1] = nxt[j];
                //    nxt[j] = j;
                //}

                pos[i] = upper_bound(b.begin(), b.begin() + i + 1, a[i]) - b.begin() - 1;
                int p = pos[i];
                if (p < 0)
                    return 0;
                while (p != nxt[p])
                    p = nxt[p];
                nxt[pos[i]] = p - 1;
                sop[p] = i;
                ans[q][i] += a[i] - b[p];
                mx = max(a[i] - b[p], mx);

                ans[q][i] -= mx;
            }
        }
    }

    for (int q = 0; q < t; q++) {
        for (auto x : ans[q])
            cout << x << ' ';
        cout << '\n';
    }
}