#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <complex>
#include <assert.h>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <immintrin.h>
using namespace std;

///*
#define int long long
#define INTLONGLONG
//*/

#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second

int INF = (int)1e18;

struct str_min {
	int n2;
	vi vec;
	vi add;
	str_min(int n) {
		n2 = 1;
		while (n2 < n) n2 *= 2;
		vec.assign(2 * n2, INF);
		add.assign(2 * n2, INF);
	}
	int get(int l, int r, int ql, int qr, int v) {
		push(v, ql, qr);
		if (l <= ql && qr <= r) {
			return vec[v];
		}
		if (l >= qr) return INF;
		if (ql >= r) return INF;
		int m = (ql + qr) / 2;
		return min(get(l, r, ql, m, 2 * v + 1), get(l, r, m, qr, 2 * v + 2));
	}
	void set(int l, int r, int x, int ql, int qr, int v) {
		push(v, ql, qr);
		if (l <= ql && qr <= r) {
			vec[v] = x;
			add[v] = x;
			return;
		}
		if (l >= qr) return;
		if (ql >= r) return;
		int m = (ql + qr) / 2;
		set(l, r, x, ql, m, 2 * v + 1);
		set(l, r, x, m, qr, 2 * v + 2);
		vec[v] = min(vec[2 * v + 1], vec[2 * v + 2]);
	}
	void push(int v, int ql, int qr) {
		if (ql + 1 == qr) return;
		if (add[v] == INF) return;
		add[2 * v + 1] = min(add[v], add[2 * v + 1]);
		add[2 * v + 2] = min(add[v], add[2 * v + 2]);
		vec[2 * v + 1] = min(add[2 * v + 1], add[v]);
		vec[2 * v + 2] = min(add[2 * v + 2], add[v]);
		add[v] = INF;
	}
};

struct str_max {
	int n2;
	vi vec;
	vi add;
	str_max(int n) {
		n2 = 1;
		while (n2 < n) n2 *= 2;
		vec.assign(2 * n2, -INF);
		add.assign(2 * n2, -INF);
	}
	int get(int l, int r, int ql, int qr, int v) {
		push(v, ql, qr);
		if (l <= ql && qr <= r) {
			return vec[v];
		}
		if (l >= qr) return -INF;
		if (ql >= r) return -INF;
		int m = (ql + qr) / 2;
		return max(get(l, r, ql, m, 2 * v + 1), get(l, r, m, qr, 2 * v + 2));
	}
	void set(int l, int r, int x, int ql, int qr, int v) {
		push(v, ql, qr);
		if (l <= ql && qr <= r) {
			vec[v] = x;
			add[v] = x;
			return;
		}
		if (l >= qr) return;
		if (ql >= r) return;
		int m = (ql + qr) / 2;
		set(l, r, x, ql, m, 2 * v + 1);
		set(l, r, x, m, qr, 2 * v + 2);
		vec[v] = max(vec[2 * v + 1], vec[2 * v + 2]);
	}
	void push(int v, int ql, int qr) {
		if (ql + 1 == qr) return;
		if (add[v] == -INF) return;
		add[2 * v + 1] = max(add[v], add[2 * v + 1]);
		add[2 * v + 2] = max(add[v], add[2 * v + 2]);
		vec[2 * v + 1] = max(add[2 * v + 1], add[v]);
		vec[2 * v + 2] = max(add[2 * v + 2], add[v]);
		add[v] = -INF;
	}
};


map<int, int> sq(vi vec) {
	set<int> s;
	for (int el : vec) s.insert(el);
	int t = 0;
	map<int, int> ans;
	for (int el : s) {
		ans[el] = t;
		t++;
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vi a(n);
		vi b(n);
		vi tvec;
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			tvec.push_back(a[i]);
		}
		for (int i = 0; i < n; i++) {
			cin >> b[i];
			tvec.push_back(b[i]);
		}
		map<int, int> dict = sq(tvec);
		int sa = 0;
		int sb = 0;
		str_max trmax(dict.size());
		str_min trmin(dict.size());
		int td = 0;
		for (int i = 0 ;i  <n; i++) {
			sa += a[i];
			sb += b[i];
			int mn = min(b[i], trmin.get(dict[b[i]], dict[a[i]] + 1, 0, trmin.n2, 0));
			int mx = max(a[i], trmax.get(dict[b[i]], dict[a[i]] + 1, 0, trmax.n2, 0));
			td = max(td, mx - mn);
			trmin.set(dict[mn], dict[mx] + 1, mn, 0, trmin.n2, 0);
			trmax.set(dict[mn], dict[mx] + 1, mx, 0, trmax.n2, 0);
			cout << sa - sb - td << ' ';
		}
		cout << endl;
	}
};