#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

struct SegTree {
    static const int size = 1024 * 1024 * 1024;
    struct Node {
        int left, right, seg, len;

        Node(int _left = 0, int _right = 0, int _seg = 0, int _len = 0) {
            left = _left;
            right = _right;
            seg = _seg;
            len = _len;
        }
    };
    vector<Node> tree;
    vector<int> fl, left, right;

    int newNode(int len) {
        int i = sz(tree);
        tree.emplace_back(0, 0, 0, len);
        fl.emplace_back(0);
        left.emplace_back(-1);
        right.emplace_back(-1);
        return i;
    }

    SegTree() {
        newNode(size);
    }

    void apply(int x, int mod) {
        if (mod) {
            tree[x] = {
                    tree[x].len,
                    tree[x].len,
                    tree[x].len,
                    tree[x].len
            };
            fl[x] = mod;
        }
    }

    void push(int x) {
        apply(left[x], fl[x]);
        apply(right[x], fl[x]);
        fl[x] = 0;
    }

    Node merge(Node a, Node b) {
        Node res;
        res.left = a.left;
        if (a.left == a.len) {
            res.left += b.left;
        }
        res.right = b.right;
        if (b.right == b.len) {
            res.right += a.right;
        }
        res.seg = max({res.left, res.right, a.seg, b.seg, a.right + b.left});
        res.len = a.len + b.len;
        return res;
    }

    void update(int l, int r, int x, int lx, int rx) {
        if (r <= lx || rx <= l) {
            return;
        }
        if (l <= lx && rx <= r) {
            apply(x, 1);
            return;
        }
        if (left[x] == -1) {
            left[x] = newNode((rx - lx) / 2);
        }
        if (right[x] == -1) {
            right[x] = newNode((rx - lx) / 2);
        }
        push(x);
        int mx = (lx + rx) / 2;
        update(l, r, left[x], lx, mx);
        update(l, r, right[x], mx, rx);
        tree[x] = merge(tree[left[x]], tree[right[x]]);
    }

    void update(int l, int r) {
        update(l, r, 0, 0, size);
    }
};

void solve() {
    SegTree t;
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &i : a) {
        cin >> i;
    }
    for (int &i : b) {
        cin >> i;
    }
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += a[i] - b[i];
        t.update(b[i], a[i]);
        cout << sum - t.tree[0].seg << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}