#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 2e5;
int n;
int a[MAXN];
int b[MAXN];

void solve() {
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    for (int i = 1; i <= n; i++) {
        sort(a, a + i);
        sort(b, b + i);

        ll good = 0;
        ll bad = 0;
        ll cur = 0;
        ll ans = INFLL;
        for (int j = 0; j < i; j++)
            cur += a[j] - b[j];

        for (int j = 0; j < i; j++) {
            cur -= a[j] - b[j];
            if (j > 0 && a[j - 1] >= b[j]) {
                good += a[j - 1] - b[j];
                cur += a[j - 1] - b[j];
                bad += a[j - 1] - b[j - 1];
            } else {
                cur -= good;
                cur += bad;
                good = 0;
                bad = 0;
                cur += (j > 0 ? a[j - 1] - b[j - 1] : 0);
            }

            ans = min(ans, cur);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

void solve_smart() {
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    ll sum = 0;
    int cur_max = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        cur_max = max(cur_max, a[i] - b[i]);
        cout << sum - cur_max << ' ';
    }
    cout << '\n';
}

int main() {
    fast_input;
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        if (n <= 3000)
            solve();
        else
            solve_smart();
    }
}