#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 2e5;
int n;
int a[MAXN];
int b[MAXN];

void init() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
}
bool check() {
    for (int i = 0; i < n - 1; i++) {
        if (a[i] >= b[i + 1])
            return false;
    }
    return true;
}

void solve() {
    for (int i = 1; i <= n; i++) {
        sort(a, a + i);
        sort(b, b + i);

        ll good = 0;
        ll bad = 0;
        ll cur = 0;
        ll ans = INFLL;
        for (int j = 0; j < i; j++)
            cur += a[j] - b[j];

        for (int j = 0; j < i; j++) {
            cur -= a[j] - b[j];
            if (j > 0 && a[j - 1] >= b[j]) {
                good += a[j - 1] - b[j];
                cur += a[j - 1] - b[j];
                bad += a[j - 1] - b[j - 1];
            } else {
                cur -= good;
                cur += bad;
                good = 0;
                bad = 0;
                cur += (j > 0 ? a[j - 1] - b[j - 1] : 0);
            }

            ans = min(ans, cur);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

void solve_smart() {
    ll sum = 0;
    int cur_max = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        cur_max = max(cur_max, a[i] - b[i]);
        cout << sum - cur_max << ' ';
    }
    cout << '\n';
}

pll t[MAXN << 2];

pll combine(pll l, pll r, ll bonus) {
    return {min(l.ff, r.ff) + bonus, bonus};
}

void build(int tl, int tr, int v) {
    if (tl == tr) {
        t[v] = {INFLL, INFLL};
    } else {
        int tm = (tl + tr) >> 1;
        build(tl, tm, v << 1);
        build(tm + 1, tr, v << 1 | 1);
        t[v] = combine(t[v << 1], t[v << 1 | 1], 0);
    }
}
void upd(int tl, int tr, int v, int pos, ll x) {
    if (tl == tr) {
        t[v] = {x, x};
    } else {
        int tm = (tl + tr) >> 1;
        if (pos <= tm)
            upd(tl, tm, v << 1, pos, x);
        else
            upd(tm + 1, tr, v << 1 | 1, pos, x);
        t[v] = combine(t[v << 1], t[v << 1 | 1], t[v].ss);
    }
}
void add(int tl, int tr, int v, int l, int r, ll x) {
    if (l > r)
        return;
    if (tl == l && tr == r) {
        t[v].ff += x;
        t[v].ss += x;
    } else {
        int tm = (tl + tr) >> 1;
        add(tl, tm, v << 1, l, min(tm, r), x);
        add(tm + 1, tr, v << 1 | 1, max(tm + 1, l), r, x);
        t[v] = combine(t[v << 1], t[v << 1 | 1], t[v].ss);
    }
}
ll get_min(int tl, int tr, int v, int l, int r) {
    if (l > r)
        return INFLL;
    if (tl == l && tr == r)
        return t[v].ff;
    int tm = (tl + tr) >> 1;
    return min(get_min(tl, tm, v << 1, l, min(tm, r)), get_min(tm + 1, tr, v << 1 | 1, max(tm + 1, l), r)) + t[v].ss;
}

void very_smart_solve() {
    ll good = 0;
    ll bad = 0;
    ll cur = 0;
    ll ans = INFLL;
    build(0, n - 1, 1);
    for (int i = 0; i < n; i++) {
        if (i > 0 && a[i - 1] >= b[i]) {
            good += a[i - 1] - b[i];
            cur += a[i - 1] - b[i];
            bad += a[i - 1] - b[i - 1];
        } else {
            cur -= good;
            cur += bad;
            good = 0;
            bad = 0;
            cur += (i > 0 ? a[i - 1] - b[i - 1] : 0);
        }

        upd(0, n - 1, 1, i, cur);
        add(0, n - 1, 1, 0, i - 1, a[i] - b[i]);
        ans = get_min(0, n - 1, 1, 0, i);
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    fast_input;
    int t;
    cin >> t;
    while (t--) {
        init();
        if (!check())
            solve();
        else if (check())
            solve_smart();
        else
            very_smart_solve();
    }
}