#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <climits>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

ll count(vll& open, vll& close){
    ll n = (ll)open.size(), ind_a = 0, ind_b = 0;
    vll ans;
    vll list;
    while (!(ind_a == open.size() && ind_b == close.size())) {
        if (ind_a == open.size()) {
            ans.push_back(close[ind_b] - list.back());
            list.pop_back();
            ind_b++;
            continue;
        }
        if (ind_b == close.size()) {
            list.push_back(open[ind_a]);
            ind_a++;
            continue;
        }
        if (open[ind_a] <= close[ind_b]){
            list.push_back(open[ind_a]);
            ind_a++;
        }
        else{
            ans.push_back(close[ind_b] - list.back());
            list.pop_back();
            ind_b++;
        }
    }
    std::sort(ans.begin(), ans.end());
    ll sum = 0;
    for (int i = 0; i < ans.size() - 1; ++i) {
        sum += ans[i];
    }
    return sum;
}



void solve(){
    ll n;
    cin >> n;
    vll a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vll open, close;
    for (int i = 0; i < n; ++i) {
        open.push_back(b[i]);
        close.push_back(a[i]);
        std::sort(open.begin(), open.end());
        std::sort(close.begin(), close.end());
        cout << count(open, close) << " ";
    }
    cout << "\n";
}



int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
