#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

long long getmaxd(const std::set<long long>& as, const std::set<long long>& bs) {
    long long cminb = *bs.begin();
    long long maxd = 0;
    for (auto ita = as.begin(), itb = bs.begin(); ita != as.end(); ita++, itb++) {
        maxd = std::max(maxd, *ita - cminb);
        auto cnxt = std::next(itb);
        if (cnxt == bs.end() || *ita < *cnxt) {
            if (cnxt != bs.end()) {
                cminb = *cnxt;
            } else {
                cminb = 1000000000000000000;
            }
        }
    }
    return maxd;
}

void solve() {
    long long n;
    std::cin >> n;
    std::vector<long long> a(n), b(n);
    for (long long i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    for (long long i = 0; i < n; i++) {
        std::cin >> b[i];
    }
    std::set<long long> as, bs;
    long long asum = 0;
    long long bsum = 0;
    for (long long i = 0; i < n; i++) {
        as.insert(a[i]);
        bs.insert(b[i]);
        asum += a[i];
        bsum += b[i];
        std::cout << asum - bsum - getmaxd(as, bs) << " \n"[i == n - 1];
    }
}

int main() {
    long long t;
    std::cin >> t;
    for (long long i = 0; i < t; i++) {
        solve();
    }
    return 0;
}