#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

void solvelinear(int n, std::vector<long long>& a, std::vector<long long>& b) {
    long long cminb = b[0];
    long long asum = 0;
    long long bsum = 0;
    long long cmaxdiff = 0;
    for (int i = 0; i < n; i++) {
        asum += a[i];
        bsum += b[i];
        cmaxdiff = std::max(cmaxdiff, a[i] - cminb);
        if (i != n - 1) {
            if (a[i] < b[i + 1]) {
                cminb = b[i + 1];
            }
        }
        std::cout << asum - bsum - cmaxdiff << " \n"[i == n - 1];
    }
}

long long getmaxd(const std::multiset<long long>& as, const std::multiset<long long>& bs) {
    long long cminb = *bs.begin();
    long long maxd = 0;
    for (auto ita = as.begin(), itb = bs.begin(); ita != as.end(); ita++, itb++) {
        maxd = std::max(maxd, *ita - cminb);
        auto cnxt = std::next(itb);
        if (cnxt == bs.end() || *ita < *cnxt) {
            if (cnxt != bs.end()) {
                cminb = *cnxt;
            } else {
                cminb = 1000000000000000000;
            }
        }
    }
    return maxd;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<long long> a(n), b(n);
    bool abincr = true;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        if (i > 0 && a[i] < a[i - 1]) {
            abincr = false;
        }
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
        if (i > 0 && b[i] > b[i - 1]) {
            abincr = false;
        }
    }
    if (abincr) {
        solvelinear(n, a, b);
        return;
    }
    std::multiset<long long> as, bs;
    long long asum = 0;
    long long bsum = 0;
    for (int i = 0; i < n; i++) {
        as.insert(a[i]);
        bs.insert(b[i]);
        asum += a[i];
        bsum += b[i];
        std::cout << asum - bsum - getmaxd(as, bs) << " \n"[i == n - 1];
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}