#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

struct Node {
    int pos, type, id;

    Node(int pos, int type, int id) : pos(pos), type(type), id(id) {}

    bool operator<(const Node &node) const {
        return pos < node.pos || (pos == node.pos && (type < node.type || (type == node.type && id < node.id)));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<int> b(n);
    for (int &i : b) {
        cin >> i;
    }

    set<Node> s;
    ll sum_a = 0, sum_b = 0;
    int mx_dist = 0;
    for (int i = 0; i < n; ++i) {
        sum_a += a[i];
        sum_b += b[i];
        s.insert({a[i], 1, i});
        s.insert({b[i], -1, i});
        int bal = 0, pst = 1e9 + 5, start = 1e9 + 5;
        for (auto [pos, type, id] : s) {
            if (bal == 0) {
                start = pos;
            }
            bal += type;
            if (bal == 0) {
                mx_dist = max(mx_dist, pos - start);
            }
        }
        //cerr << mx_dist << endl;
        cout << sum_a - sum_b - mx_dist << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}