// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <numeric>
#include <bitset>
#include <utility>
#include <map>
#include <set>
#include <deque>
#include <ranges>

using namespace std;
using ll = long long;
using ld = long double;

ll calc2(vector <int> a, vector<int> b)
{
    ranges::sort(a);
    ranges::sort(b);
    ranges::reverse(b);
    multiset<int> ca(a.begin(), a.end());
    ll s1 = accumulate(a.begin(), a.end(), 0ll), s2 = accumulate(b.begin(), b.end(), 0ll);
    for (auto& i : b)
    {
        auto it = ca.lower_bound(i);
        if (it == ca.end())
            return s1 - s2 + i;
        ca.erase(it);
    }
}

ll calc(vector <int> a, vector<int> b)
{
    /* ll ans = 1e18;
    for (size_t i = 0; i < a.size(); i++)
    {
        auto t = a;
        t.erase(t.begin() + i);
        ans = min(ans, calc2(t, b));
    }
    return ans;*/
    ranges::sort(a);
    ranges::sort(b);
    int n = a.size();
    vector <ll> prefans(n);
    prefans[0] = b[0];
    ll best = 0, s1 = a[0], s2 = b[0];
    for (size_t i = 1; i < n; i++)
    {
        s1 += a[i];
        s2 += b[i];
        best += (ll)a[i] - b[i];
        auto it = ranges::lower_bound(a, b[i]);
        if (it - a.begin() == i)
        {
            prefans[i] = b[i];
        }
        else
        {
            prefans[i] = prefans[it - a.begin()];
        }
        best = min(best, s1 - a[i] - (s2 - prefans[i]));
    }
    return best;
}

void solve()
{
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (auto& i : a)
    {
        cin >> i;
    }
    for (auto& i : b)
    {
        cin >> i;
    }
    // a and b are sorted
    /*deque<int> cache;
    cache.push_back(a[0]);
    int curans = 0;
    cout << curans << ' ';
    for (size_t i = 1; i < n; i++)
    {
        cache.push_back(a[i]);
        if (cache.front() >= b[i])
        {
            curans += cache.front() - b[i];
            cache.pop_front();
        }
        else
        {
            curans += cache.back() - b[i];
            cache.pop_back();
        }
        cout << curans << ' ';
    }
    cout << '\n';*/
    if (is_sorted(a.begin(), a.end()) && is_sorted(b.begin(), b.end()))
    {
        vector <ll> prefans(n);
        prefans[0] = b[0];
        ll best = 0, s1 = a[0], s2 = b[0];
        cout << 0 << ' ';
        for (size_t i = 1; i < n; i++)
        {
            s1 += a[i];
            s2 += b[i];
            best += (ll)a[i] - b[i];
            auto it = ranges::lower_bound(a, b[i]);
            if (it - a.begin() == i)
            {
                prefans[i] = b[i];
            }
            else
            {
                prefans[i] = prefans[it - a.begin()];
            }
            best = min(best, s1 - a[i] - (s2 - prefans[i]));
            cout << best << ' ';
        }
        cout << '\n';
        return;
    }
    for (size_t i = 0; i < n; i++)
    {
        cout << calc(vector<int>(a.begin(), a.begin() + i + 1), vector<int>(b.begin(), b.begin() + i + 1)) << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
