#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

ll solve(vector <ll> a, vector <ll> b, int n) {
	vector <ll> u(n), pref(n + 1), gr(n), pl(n);
	for (int i = 0; i < n; i++) {
		if (i && a[i - 1] >= b[i]) u[i] = 1, pref[i] = pref[i - 1] + u[i];
	}
	for (int i = 0; i < n; i++) {
		int l = -1, r = i;
		while (l < r - 1) {
			int m = (l + r) / 2;
			if (pref[i] - pref[m] >= (i - m)) r = m;
			else l = m;
		}
		gr[i] = r;
		pl[i] = a[i] - b[gr[i]];
	}
	ll mx = 0, suma = 0, sumb = 0;
	for (int i = 0; i < n; i++) {
		suma += a[i], sumb += b[i];
		mx = max(mx, pl[i]);
		if (i == n - 1) return suma - sumb - mx;
	}
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		ll suma = 0, sumb = 0;
		vector <ll> a(n), b(n);
		bool fl = 1;
		for (int i = 0; i < n; i++) cin >> a[i];
		for (int i = 0; i < n; i++) {
			cin >> b[i];
			if (i < n && a[i] >= b[i + 1]) fl = 0;
		}
		if (fl) {
			vector <ll> u(n), pref(n + 1), gr(n), pl(n);
			for (int i = 0; i < n; i++) {
				if (i && a[i - 1] >= b[i]) u[i] = 1, pref[i] = pref[i - 1] + u[i];
			}
			for (int i = 0; i < n; i++) {
				int l = -1, r = i;
				while (l < r - 1) {
					int m = (l + r) / 2;
					if (pref[i] - pref[m] >= (i - m)) r = m;
					else l = m;
				}
				gr[i] = r;
				pl[i] = a[i] - b[gr[i]];
			}
			ll mx = 0;
			for (int i = 0; i < n; i++) {
				suma += a[i], sumb += b[i];
				mx = max(mx, pl[i]);
				cout << suma - sumb - mx << ' ';
			}
			cout << "\n";
		}
		else {
			for (int i = 0; i < n; i++) {
				vector <ll> a1, b1;
				for (int j = 0; j <= i; j++) a1.push_back(a[j]), b1.push_back(b[j]);
				sort(a1.begin(), a1.end()), sort(b1.begin(), b1.end());
				cout << solve(a1, b1, i + 1) << ' ';
			}
			cout << "\n";
		}
	}
	return 0;
}