#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define gen(a, b) uniform_int_distribution<int>(a, b)(rnd)
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
struct SegmentTreeMass
{
	struct Node
	{
		int sum = 0;
		int add = 0;

		Node(int Sum = 0, int Add = 0)
		{
			sum = Sum;
			add = Add;
		}
	};

	Node neutral = Node();
	int n;
	vector<Node> tree;

	SegmentTreeMass(vector<int>& start)
	{
		n = start.size();
		tree.resize(4 * n + 228);
		init(start);
	}

	SegmentTreeMass(int N)
	{
		n = N;
		tree.resize(4 * n + 228);
		vector<int> start(n, 0);
		init(start);
	}

	Node merge(Node n1, Node n2)
	{
		return Node(max(n1.sum, n2.sum));
	}

	void fix(int v, int l, int r)
	{
		tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
	}

	void apply(int v, int l, int r, int val)
	{
		tree[v].add += val;
		tree[v].sum += val;
	}

	void init(int v, int l, int r, vector<int>& start)
	{
		if (l + 1 == r)
		{
			tree[v] = Node(start[l], 0);
			return;
		}

		int m = (r + l) / 2;
		init(v * 2 + 1, l, m, start);
		init(v * 2 + 2, m, r, start);
		fix(v, l, r);
	}

	void init(vector<int>& start)
	{
		init(0, 0, n, start);
	}

	void push(int v, int l, int r)
	{
		int m = (r + l) / 2;

		apply(v * 2 + 1, l, m, tree[v].add);
		apply(v * 2 + 2, m, r, tree[v].add);
		tree[v].add = 0;
	}

	// [l: r)
	Node query(int v, int l, int r, int ql, int qr)
	{
		if (ql <= l && r <= qr)
		{
			return tree[v];
		}
		if (r <= ql || qr <= l)
		{
			return neutral;
		}

		int m = (r + l) / 2;
		push(v, l, r);
		return merge(
			query(v * 2 + 1, l, m, ql, qr),
			query(v * 2 + 2, m, r, ql, qr));

	}

	Node query(int ql, int qr)
	{
		return query(0, 0, n, ql, qr);
	}

	void add(int v, int l, int r, int ql, int qr, int val)
	{
		if (ql <= l && r <= qr)
		{
			apply(v, l, r, val);
			return;
		}
		if (r <= ql || qr <= l)
		{
			return;
		}

		int m = (r + l) / 2;
		push(v, l, r);
		add(v * 2 + 1, l, m, ql, qr, val);
		add(v * 2 + 2, m, r, ql, qr, val);
		fix(v, l, r);
	}

	void add(int ql, int qr, int val)
	{
		add(0, 0, n, ql, qr, val);
	}
 
	void add(int idx, int val)
	{
		add(0, 0, n, idx, idx + 1, val);
	}
};
struct fenv {
    vector<int> T;
    fenv(int N) {
        T.assign(N + 1, {});
    }
    void add(int x, int val) {
        for(x++;x < T.size();x += (x & -x)) {
            T[x - 1] += val;
        }
    }
    int sum(int x) {
        int sum = 0;
        for(x++;x > 0;x -= (x & -x)) {
            sum += T[x - 1];
        }
        return sum;
    }
    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};
void solve() {
int n;
    cin >> n;
    vector<int>a(n),b(n);
    for(auto &x:a)cin>>x;
    for(auto &x:b)cin>>x;
    set<int> S;
    fenv f(n * 2 + 10);
    SegmentTreeMass T(n * 2 + 10);
    vector<pair<int,int>> idx;
    for(int i = 0; i < n; i++) {
        idx.push_back({a[i], i});
        idx.push_back({b[i], n + i});
    }
    sort(all(idx), [&](auto a, auto b) {
        if(a.first != b.first) {
            return a.first < b.first;
        } else {
            return a.second > b.second;
        }
    });
    vector<int> Ma(n);
    vector<int>  Mb(n);
    vector<int> getB(n * 2 + 10);
    vector<int> getA(n * 2 + 10);
    for(int i = 0; i < idx.size(); i++) {
        if(idx[i].second < n) {
            Ma[idx[i].second] = i;
            getA[i] = idx[i].first;
        } else {
            Mb[idx[i].second - n] = i;
            getB[i] = idx[i].first;
        }
    }
    int maxn = 2 * n + 5;
    multiset<int> maxAns;
    vector<int> curAn(maxn);
    auto add = [&] (int x) {
        S.insert(x);
        auto tt = S.lower_bound(x);
        if(tt != S.begin()) {
            tt--;
            maxAns.extract(curAn[*tt]);
            curAn[*tt] = -getB[*tt] + T.query(*tt, x).sum;
            maxAns.insert(curAn[*tt]);
            tt++;
        }
        tt++;
        int rside = maxn;
        if(tt != S.end()) {
            rside = *tt;
        }
        maxAns.insert(-getB[x] + T.query(x, rside).sum);
        curAn[x] = -getB[x] + T.query(x, rside).sum;
    };
    auto del = [&](int x) {
        auto tt = S.lower_bound(x);
        if(tt != S.begin()) {
           int pr = *prev(tt);
            tt++;
            int rside = maxn;
            if(tt != S.end()) {
                rside = *tt;
            }
            maxAns.extract(curAn[pr]);
            curAn[pr] = -getB[pr] + T.query(pr, rside).sum;
            maxAns.insert(curAn[pr]);
        }
        S.erase(x);
        maxAns.extract(curAn[x]);
        curAn[x] = 0;
    };
    ll Sa = 0;
    ll Sb = 0;
    auto get = [&]() {
        if(maxAns.empty()) return (int)0;
        else return *maxAns.rbegin();
    };
    for(int i = 0; i < n; i++) {
        T.add(Ma[i], a[i]);
        f.add(Ma[i], 1);
        f.add(Mb[i], -1);

        auto lb = S.lower_bound(Ma[i]);
        if(lb != S.begin()) {
            lb--;
            int val =  *lb;
            del(val);
            add(val);
        }
        Sa += a[i];
        Sb += b[i];
        if(!S.empty()) {
            auto tt = S.lower_bound(Mb[i]);
            vector<int> todel;
            while(tt != S.end() && *tt < Ma[i]) {
                todel.push_back(*tt);
                tt++;
            }
            for(auto x : todel) {
                del(x);
            }
        }
        if(f.sum(Mb[i], maxn) == 0) {
            add(Mb[i]);
        }
        cout << Sa- Sb - get() << " ";
    }
    cout << endl;
}
signed main() {
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while(tt--) {
        solve();
    }
}