#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(3);

unordered_map<ll, ll> um;
unordered_map<ll, ll> um2;

struct node {
    ll l = 0, r = 0, ans = 0, sz = 0;
    node(ll l = 0, ll r = 0, ll ans = 0, ll sz = 0) : l(l), r(r), ans(ans), sz(sz) {}
};

node merge(node a, node b) {
    node n;
    n.sz = a.sz + b.sz;
    n.l = a.l;
    if (a.l == a.sz) n.l += b.l;
    n.r = b.r;
    if (b.r == b.sz) n.r += a.r;
    n.ans = max(n.l, n.r);
    n.ans = max(n.ans, a.r + b.l);
    n.ans = max(n.ans, max(a.ans, b.ans));
    return n;
}

struct segmentTree {
    vector<node> segTree;
    vector<ll> hmass;
    void build(ll i, ll l, ll r) {
        if (r - l == 1) {
            segTree[i] = node(0, 0, 0, 1);
            return;
        }
        ll m = (l + r) / 2;
        build(i * 2 + 1, l, m);
        build(i * 2 + 2, m, r);
        segTree[i] = merge(segTree[i * 2 + 1], segTree[i * 2 + 2]);
    }

    segmentTree(ll n) {
        segTree.resize(4 * n);
        hmass.resize(4 * n);
        build(0, 0, n);
    }

    void push(ll i, ll l, ll r) {
        if (hmass[i] == 0) return;
        if (r - l > 1) {
            ll m = (l + r) / 2;
            hmass[i * 2 + 1] += hmass[i];
            segTree[i * 2 + 1] = node(um2[m] - um2[l], um2[m] - um2[l], um2[m] - um2[l], um2[m] - um2[l]);
            segTree[i * 2 + 2] = node(um2[r] - um2[m], um2[r] - um2[m], um2[r] - um2[m], um2[r] - um2[m]);
            hmass[i * 2 + 2] += hmass[i];
        }
        hmass[i] = 0;
    }

    void rep(ll i, ll l, ll r, ll ql, ll qr) {
        push(i, l, r);
        if (l >= qr || r <= ql) return;
        if (l >= ql && r <= qr) {
            segTree[i] = node(um2[r] - um2[l], um2[r] - um2[l], um2[r] - um2[l], um2[r] - um2[l]);
            hmass[i]++;
            return;
        }
        ll m = (l + r) / 2;
        rep(i * 2 + 1, l, m, ql, qr);
        rep(i * 2 + 2, m, r, ql, qr);
        segTree[i] = merge(segTree[i * 2 + 1], segTree[i * 2 + 2]);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll t; cin >> t;
    while (t--) {
        um.clear();
        um2.clear();
        ll n = 10;
        vector<ll> a(n);
        vector<ll> b(n);
        ll prev = 0;
        for (ll i = 0; i < n; i++) {
            b[i] = rnd() % 10 + 1 + prev;
            prev = b[i];
            a[i] = rnd() % 10 + prev;
            prev = a[i];
        }
        vector<ll> vc;
        for (auto p : a) vc.push_back(p);
        for (auto p : b) vc.push_back(p);
        swap(a, b);
        sort(vc.begin(), vc.end());
        vc.erase(unique(vc.begin(), vc.end()), vc.end());
        for (ll i = 0; i < vc.size(); i++) {
            um[vc[i]] = i;
            um2[i] = vc[i];
        }
        segmentTree st(vc.size());
        segmentTree st2(vc.size());
        ll sum = 0;
        ll mxdel = 0;
        ll mxdel2 = 0;
        set<ll> sst;
        set<ll> sst2;
        for (ll i = 0; i < n; i++) {
            sum += b[i] - a[i];
            //update mxdel;
            /*sst.insert(a[i]);
            sst2.insert(-b[i]);
            st.rep(0, 0, vc.size(), um[a[i]], um[b[i]]);
            ll l = um[b[i]], r = um[a[i]];
            st2.rep(0, 0, vc.size(), vc.size() - l, vc.size() - r);
            ll id = st.get(0, 0, vc.size(), um[b[i]]);
            ll id2 = st2.get(0, 0, vc.size(), vc.size() - r);
            ll num = um2[id];
            ll num2 = um2[vc.size() - 1 - id2];
            id = *sst.upper_bound(num);
            id2 = *sst2.lower_bound(-num2);
            mxdel = max(mxdel, b[i] - id);
            mxdel = max(mxdel, -id2 - a[i]);*/
            st.rep(0, 0, vc.size(), um[a[i]], um[b[i]]);
            mxdel = st.segTree[0].ans;
            mxdel2 = max(mxdel2, b[i] - a[i]);
            //endof update
            ll ans = sum - mxdel;
            cout << ans << " ";
        }
        cout << endl;
    }
}