#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

bool check(multiset<int>& a, multiset<int>& b) {
    auto it_a = a.begin();
    auto it_b = b.begin();

    for (; it_a != a.end(); it_a++, it_b++) {
        if (*it_a < *it_b) {
            return false;
        }
    }
    return true;
}

vector<int> a, b;

int find_mx(multiset<int>& as, multiset<int>& bs) {
    int n = as.size();

    int mx = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            as.erase(as.find(a[i]));
            bs.erase(bs.find(b[j]));
            if (check(as, bs)) mx = max(mx, a[i] - b[j]);
            as.insert(a[i]);
            bs.insert(b[j]);
        }
    }
    return mx;
}

void solve() {
    int n;
    cin >> n;
    a.resize(n); b.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    multiset<int> as, bs;
    ll s = 0;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        as.insert(a[i]);
        bs.insert(b[i]);
        s += a[i] - b[i];
        mx = find_mx(as, bs);
        cout << s - mx << " \n"[i + 1 == n];
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}
