#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);


vector<int> a, b;

int find_mx(vector<int>& srt_a, vector<int>& srt_b) {
    int n = srt_a.size();
    int mx = 0;

    vector<int> ok(n);
    for (int i = 0; i + 1 < n; i++) ok[i] = srt_a[i] >= srt_b[i + 1];

    for (int i = 0; i < n; i++) {
        mx = max(mx, a[i] - b[i]);
        if (!ok[i]) continue;
        int j = i;
        while (j + 1 < n && ok[j + 1]) j++;
        mx = max(srt_a[j + 1] - srt_b[i], mx);
        i = j;
    }

    return mx;
}

void solve_last(int n, vector<int> a, vector<int> b) {
    vector<int> ok(n);
    ll s = 0;
    int mx = 0, lst = -1e9, fst = -1e9;
    for (int i = 0; i < n; i++) {
        s += a[i] - b[i];
        mx = max(mx, a[i] - b[i]);

        if (i > 0) {
            if (a[i - 1] >= b[i]) {
                ok[i - 1] = 1;
                if (lst == i - 2) {
                    lst = i - 1;
                } else {
                    lst = fst = i - 1;
                }
                mx = max(a[lst + 1] - b[fst], mx);
            }
        }

        cout << s - mx << " \n"[i + 1 == n];
    }
}

void solve() {
    int n;
    cin >> n;
    a.resize(n); b.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    bool f = 1;
    for (int i = 0; i + 1 < n; i++) f = f && (a[i] <= a[i + 1]);
    for (int i = 0; i + 1 < n; i++) f = f && (b[i] <= b[i + 1]);

    if (f) {
        solve_last(n, a, b);
        return;
    }

    vector<int> srt_a, srt_b;
    ll s = 0;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        s += a[i] - b[i];
        srt_a.push_back(a[i]);
        srt_b.push_back(b[i]);
        sort(all(srt_a));
        sort(all(srt_b));
        mx = max(mx, find_mx(srt_a, srt_b));
        cout << s - mx << " \n"[i + 1 == n];
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
#ifdef ONPC
        cout << "---------\n";
#endif
    }

    return 0;
}
