#include <ext/pb_ds/assoc_container.hpp>

#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

template<typename type, typename comp=less<>>
using pbds = __gnu_pbds::tree<type, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        pbds<int, less_equal<>> msa, msb;
        for (int &i: a)
                cin >> i, msa.insert(i);
        for (int &i: b)
                cin >> i, msb.insert(i);
        vector<int> ans(n), dp(n + 1);
        dp[n] = n;
        for (int i = n - 1; i >= 0; --i) {
                dp[i] = min(i, dp[i + 1]);
                while (dp[i] > 0) {
                        if (*msa.find_by_order(dp[i] - 1) < *msb.find_by_order(dp[i]))
                                break;
                        --dp[i];
                }
                msa.erase(msa.upper_bound(a[i]));
                msb.erase(msb.upper_bound(b[i]));
        }
        debug(dp);
        ans[0] = 0;
        for (int i = 1, mx = a[0] - b[0], sa = a[0], sb = b[0]; i < n; ++i) {
                smax(mx, a[i] - b[dp[i]]);
                sa += a[i], sb += b[i];
                ans[i] = sa - sb - mx;
        }
        for (int &i: ans)
                cout << i << ' ';
        cout << endl;
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        cin >> _t;
        while (_t--)
                solve();

        return 0;
}
