#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 1337;
const int INF = 1e16 + 1337;
int mn[4 * N], mx[4 * N];

void build(int n) {
    fill(mn, mn + 4 * n, INF);
    fill(mx, mx + 4 * n, -INF);
}

void upd_mn(int tl, int tr, int v, int l, int r, int x) {
    if (tl >= r || tr <= l)
        return;

    if (tl >= l && tr <= r) {
        mn[v] = x;
        return;
    }

    int m = (tl + tr) / 2;
    upd_mn(tl, m, 2 * v + 1, l, r, x);
    upd_mn(m, tr, 2 * v + 2, l, r, x);
    mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
}

void upd_mx(int tl, int tr, int v, int l, int r, int x) {
    if (tl >= r || tr <= l)
        return;

    if (tl >= l && tr <= r) {
        mx[v] = x;
        return;
    }

    int m = (tl + tr) / 2;
    upd_mx(tl, m, 2 * v + 1, l, r, x);
    upd_mx(m, tr, 2 * v + 2, l, r, x);
    mx[v] = max(mx[2 * v + 1], mx[2 * v + 2]);
}

int get_mn(int tl, int tr, int v, int l, int r) {
    if (tl >= r || tr <= l)
        return INF;

    if (tl >= l && tr <= r)
        return mn[v];

    int m = (tl + tr) / 2;
    return min(get_mn(tl, m, 2 * v + 1, l, r), get_mn(m, tr, 2 * v + 2, l, r));
}

int get_mx(int tl, int tr, int v, int l, int r) {
    if (tl >= r || tr <= l)
        return -INF;

    if (tl >= l && tr <= r)
        return mx[v];

    int m = (tl + tr) / 2;
    return max(get_mx(tl, m, 2 * v + 1, l, r), get_mx(m, tr, 2 * v + 2, l, r));
}

void solve() {
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int b[n];
    for (int i = 0; i < n; i++)
        cin >> b[i];

    bool g4 = true;
    for (int i = 0; i < n - 1; i++)
        g4 &= (a[i] < b[i + 1]);

    if (g4) {
        int mx = 0, sa = 0, sb = 0;
        for (int i = 0; i < n; i++) {
            sa += a[i], sb += b[i];
            mx = max(mx, a[i] - b[i]);
            cout << sa - sb - mx << " ";
        }
        cout << "\n";
        return;
    }

    bool g5 = true;
    for (int i = 0; i < n - 1; i++)
        g5 &= (a[i] <= a[i + 1] && b[i] <= b[i + 1]);

    if (g5) {
        build(n);
        int mx = 0, sa = 0, sb = 0;
        for (int i = 0; i < n; i++) {
            sa += a[i], sb += b[i];

            int l = -1, r = i;
            while (r - l > 0) {
                int m = (l + r) / 2;
                if (a[m] >= b[i])
                    r = m;
                else
                    l = m + 1;
            }

            upd_mn(0, n, 0, i, i + 1, b[i]);
            upd_mx(0, n, 0, i, i + 1, a[i]);
            mx = max(mx, get_mx(0, n, 0, l + 1, i + 1) - get_mn(0, n, 0, l + 1, i + 1));
            cout << sa - sb - mx << " ";
        }
        cout << "\n";
        return;
    }

    if (n <= 3000) {
        int sa = 0, sb = 0;
        multiset <int> sta;
        for (int i = 0; i < n; i++) {
            sa += a[i], sb += b[i];
            sta.insert(a[i]);
            multiset <int> stb;
            for (int j = 0; j <= i; j++)
                stb.insert(b[j]);

            int und = 0;
            for (auto& x : sta) {
                auto it = stb.upper_bound(x);
                it--;
                int y = *it;
                stb.erase(it);
                und = max(und, x - y);
            }

            cout << sa - sb - und << " ";
        }
        cout << "\n";
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
