#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vector deque

const int maxn = 2e5 + 100;
vector<int> a(maxn, 0);
vector<int> b(maxn, 0);


bool could_del(vector<int> & lst_a, vector<int> & lst_b, int ind1, int ind2, int & ans) {
    bool check = true;
    int ind_a = 0, ind_b = 0;
    int local_ans = 0;
    while (ind_a < lst_a.size() && ind_b < lst_b.size()) {
        if (ind_a == ind1 && ind_b == ind2) {
            ind_a++;
            ind_b++;
        } else if (ind_a == ind1) {
            ind_a++;
        } else if (ind_b == ind2) {
            ind_b++;
        } else {
            if (lst_a[ind_a] < lst_b[ind_b]) {
                return false;
            }
            local_ans += lst_a[ind_a] - lst_b[ind_b];
            ind_a++;
            ind_b++;
        }
    }
    if (check) {
        ans = min(ans, local_ans);
    }
    return check;
}


void very_slow_solution(int n) {
    vector<int> lst_a, lst_b;
    for (int i = 1; i <= n; i++) {
        lst_a.push_back(a[i]);
        lst_b.push_back(b[i]);
        int ans = 1e18 + 100;
        sort(lst_a.begin(), lst_a.end());
        sort(lst_b.begin(), lst_b.end());
        int ind1 = lst_a.size() - 1, ind2 = lst_b.size() - 1;
        for (; (ind1 >= 0) && (ind2 >= 0); --ind1) {
            while (ind2 >= 0 && could_del(lst_a, lst_b, ind1, ind2, ans)) {
                ind2--;
            }
        }
        cout << ans << " ";
    }
    cout << '\n';
}

void sol_for_g_5(int n) {
    int ans = 0;
    int summ_a = a[1];
    int summ_b = b[1];
    cout << 0 << " ";
    int prev_ans = 0;
    for (int i = 2; i <= n; i++) {
        prev_ans += a[i] - b[i];
        summ_a += a[i];
        summ_b += b[i];
        int left = 0, right = i;
        while (left + 1 < right) {
            int mid = (left + right) / 2;
            if (a[mid] >= b[mid + 1]) {
                right = mid;
            } else {
                left = mid;
            }
        }
        prev_ans = min(prev_ans, summ_a - summ_b - a[i] + b[right]);
        cout << prev_ans << " ";
    }
    cout << endl;
}



void sol_for_g_4(int n) {
    int maxx_diff = 0;
    int summ = 0;
    for (int i = 1; i <= n; i++) {
        summ += a[i] - b[i];
        maxx_diff = max(maxx_diff, a[i] - b[i]);
        cout << summ - maxx_diff << " ";
    }
    cout << '\n';
}



signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (; t > 0; --t) {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }
    bool check_for_g_4 = true;
    for (int i = 1; i + 1 <= n; i++) {
        if (a[i] >= b[i + 1]) {
            check_for_g_4 = false;
        }
    }
    if (check_for_g_4) {
        sol_for_g_4(n);
    } else if (n <= 500){
        very_slow_solution(n);
    } else {
        sol_for_g_5(n);
    }
    }
}
