#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

void psolve(vector<int> x, vector<int> t) {
    sort(all(x));
    sort(all(t));
    int xs = x.size();
    ll ans = INF;
    for (int di = 0; di < xs; di++) {
        int xi = 0;
        ll ansi = 0;
        for (int ti = 0; ti < xs; ti++) {
            if (ti == di) continue;
            if (x[xi] < t[ti]) xi++;
            ansi += x[xi] - t[ti];
            xi++;
        }

        ans = min(ans, ansi);
    }
    cout << ans;
}

void solve() {
    int xs;
    cin >> xs;
    vector<int> x(xs);
    for (int &i: x)
        cin >> i;
    vector<int> t(xs);
    for (int &i: t)
        cin >> i;

    for (int r = 1; r <= xs; r++) {
        psolve({x.begin(), x.begin() + r}, {t.begin(), t.begin() + r});
        cout << ' ';
    }
}

void solvep() {
    int xs;
    cin >> xs;
    vector<int> x(xs);
    for (int &i: x)
        cin >> i;
    vector<int> t(xs);
    for (int &i: t)
        cin >> i;

    ll sm = x[0] - t[0];
    ll di = x[0] - t[0];
    ll mxd = di;
    cout << 0 << ' ';
    for (int r = 1; r < xs; r++) {
        if (t[r] > x[r - 1])
            di = x[r] - t[r];
        else
            di += x[r] - x[r - 1];
        mxd = max(mxd, di);
        sm += x[r] - t[r];
        cout << sm - mxd << ' ';
    }
}

int main() {
    int qs;
    cin >> qs;
    while (qs--) {
        solvep();
        cout << '\n';
    }
}