#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct node {
    node *left = nullptr, *right = nullptr;
    int push = 0, lmn = 0, rmn = 0, mn = 0;
};

const int R = (1 << 30);
node *root;

node *create_node(int l, int r) {
    node *v = new node;
    v->lmn = l;
    v->rmn = r - 1;
    return v;
}

void merge_node(node *v) {
    if (v->left->mn < v->right->mn) {
        v->mn = v->left->mn;
        v->lmn = v->left->lmn;
        v->rmn = v->left->rmn;
    }
    else if (v->left->mn > v->right->mn) {
        v->mn = v->right->mn;
        v->lmn = v->right->lmn;
        v->rmn = v->right->rmn;
    }
    else {
        v->mn = v->left->mn;
        v->lmn = v->left->lmn;
        v->rmn = v->right->rmn;
    }
}

void push(node *v, int l, int r) {
    if (v->left == nullptr) {
        int m = (l + r) / 2;
        v->left = create_node(l, m);
        v->right = create_node(m, r);
    }
    if (v->push != 0) {
        v->left->push += v->push;
        v->left->mn += v->push;
        v->right->push += v->push;
        v->right->mn += v->push;
        v->push = 0;
    }
}

void update(int ql, int qr, int x, node *v = root, int l = 0, int r = R) {
    if (ql >= r || l >= qr)
        return;
    if (ql <= l && r <= qr) {
        v->mn += x;
        v->push += x;
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    update(ql, qr, x, v->left, l, m);
    update(ql, qr, x, v->right, m, r);
    merge_node(v);
}

int find_left(int i, node *v = root, int l = 0, int r = R) {
    if (l >= i || v->mn > 0)
        return -1;
    push(v, l, r);
    int m = (l + r) / 2;
    if (i < r)
        return max(find_left(i, v->left, l, m), find_left(i, v->right, m, r));
    else
        return v->rmn;
}

int find_right(int i, node *v = root, int l = 0, int r = R) {
    if (r <= i + 1 || v->mn > 0)
        return R;
    push(v, l, r);
    int m = (l + r) / 2;
    if (i >= l)
        return min(find_right(i, v->left, l, m), find_right(i, v->right, m, r));
    else
        return v->lmn;
}

void destroy_tree(node *v = root) {
    if (v == nullptr)
        return;
    destroy_tree(v->left);
    destroy_tree(v->right);
    delete v;
}

void solve() {
    root = create_node(0, R);
    int n;
    cin >> n;
    vi a(n), b(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];
    ll x = 0, y = 0;
    for (int i = 0; i < n; ++i) {
        x += a[i] - b[i];
        update(b[i], a[i], 1);
        y = max(y, (ll)(find_right(b[i] - 1) - find_left(b[i]) - 1));
        cout << x - y << ' ';
    }
    cout << '\n';
    destroy_tree();
}

int main() {
    fast;
    int ts;
    cin >> ts;
    while (ts--)
        solve();
}
