#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct node {
    int push = 0, lmn = 0, rmn = 0, mn = 0;
};

const int R = (1 << 19);
vector<node> t(R * 2);

void push(int v) {
    if (t[v].push != 0) {
        t[v * 2].mn += t[v].push;
        t[v * 2].push += t[v].push;
        t[v * 2 + 1].mn += t[v].push;
        t[v * 2 + 1].push += t[v].push;
        t[v].push = 0;
    }
}

void merge_node(int v) {
    if (t[v * 2].mn < t[v * 2 + 1].mn) {
        t[v].mn = t[v * 2].mn;
        t[v].lmn = t[v * 2].lmn;
        t[v].rmn = t[v * 2].rmn;
    }
    else if (t[v * 2].mn > t[v * 2 + 1].mn) {
        t[v].mn = t[v * 2 + 1].mn;
        t[v].lmn = t[v * 2 + 1].lmn;
        t[v].rmn = t[v * 2 + 1].rmn;
    }
    else {
        t[v].mn = t[v * 2].mn;
        t[v].lmn = t[v * 2].lmn;
        t[v].rmn = t[v * 2 + 1].rmn;
    }
}

void update(int ql, int qr, int x, int v = 1, int l = 0, int r = R) {
    if (ql >= r || l >= qr)
        return;
    if (ql <= l && r <= qr) {
        t[v].mn += x;
        t[v].push += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(ql, qr, x, v * 2, l, m);
    update(ql, qr, x, v * 2 + 1, m, r);
    merge_node(v);
}

int find_left(int i, int v = 1, int l = 0, int r = R) {
    if (l >= i || t[v].mn > 0)
        return -1;
    push(v);
    int m = (l + r) / 2;
    if (i < r)
        return max(find_left(i, v * 2, l, m), find_left(i, v * 2 + 1, m, r));
    else
        return t[v].rmn;
}

int find_right(int i, int v = 1, int l = 0, int r = R) {
    if (r <= i + 1 || t[v].mn > 0)
        return R;
    push(v);
    int m = (l + r) / 2;
    if (i >= l)
        return min(find_right(i, v * 2, l, m), find_right(i, v * 2 + 1, m, r));
    else
        return t[v].lmn;
}

void init_tree(int v = 1, int l = 0, int r = R) {
    t[v].lmn = l;
    t[v].rmn = r - 1;
    if (r - l > 1) {
        int m = (l + r) / 2;
        init_tree(v * 2, l, m);
        init_tree(v * 2 + 1, m, r);
    }
}

void solve() {
    int n;
    cin >> n;
    vi a(n), b(n), c(n * 2);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        c[i] = a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        c[n + i] = b[i];
    }
    sort(all(c));
    vi aa(n), bb(n);
    for (int i = 0; i < n; ++i) {
        aa[i] = lower_bound(all(c), a[i]) - c.begin();
        bb[i] = lower_bound(all(c), b[i]) - c.begin();
    }
    ll x = 0, y = 0;
    for (int i = 0; i < n; ++i) {
        x += a[i] - b[i];
        update(bb[i], aa[i], 1);
        y = max(y, (ll)(c[find_right(bb[i] - 1)] - c[find_left(bb[i]) + 1]));
        cout << x - y << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; ++i)
        update(bb[i], aa[i], -1);
}

int main() {
    fast;
    init_tree();
    int ts;
    cin >> ts;
    while (ts--)
        solve();
}
