#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

vector <int> lal;

struct segtree {
    struct node {
        int mi = 0, add = 0, ind1 = 0, ind2 = 0, val = 0;
    };

    vector <node> t;

    void init (int n) {
        int sz = 1;
        while (sz < n) sz *= 2;
        t.resize(2 * sz - 1);
    }

    void build (int x, int lx, int rx) {
        t[x].ind1 = lx; t[x].ind2 = rx - 1;
        if (rx - lx == 1) {
            return;
        }
        int m = (lx + rx) >> 1;
        build(2 * x + 1, lx, m); build(2 * x + 2, m, rx);
        t[x].val = 1;
    }

    void push (int x, int lx, int rx) {
        if (rx - lx == 1 || !t[x].add) return;
        t[2 * x + 1].mi += t[x].add; t[2 * x + 2].mi += t[x].add;
        t[2 * x + 1].add += t[x].add; t[2 * x + 2].add += t[x].add;
        t[x].add = 0;
    }

    void update (int l, int r, int v, int x, int lx, int rx) {
        // debug(lx << ' ' << rx << ' ' << t[x].ind1 << ' ' << t[x].ind2);
        if (lx >= r || l >= rx) return;
        if (lx >= l && rx <= r) {
            t[x].mi += v; t[x].add += v;
            return;
        }
        push(x, lx, rx);
        int m = (lx + rx) >> 1;
        update(l, r, v, 2 * x + 1, lx, m); update(l, r, v, 2 * x + 2, m, rx);
        t[x].mi = min(t[2 * x + 1].mi, t[2 * x + 2].mi);
        if (t[2 * x + 1].mi == t[2 * x + 2].mi) {
            t[x].val = max(max(t[2 * x + 1].val, t[2 * x + 2].val), lal[t[2 * x + 2].ind1] - lal[t[2 * x + 1].ind2]);
            t[x].ind2 = t[2 * x + 2].ind2;
            t[x].ind1 = t[2 * x + 1].ind1;
        }
        else if (t[2 * x + 1].mi < t[2 * x + 2].mi) {
            t[x].val = t[2 * x + 1].val;
            t[x].mi = t[2 * x + 1].mi;
            t[x].ind1 = t[2 * x + 1].ind1;
            t[x].ind2 = t[2 * x + 1].ind2;
        }
        else {
            t[x].val = t[2 * x + 2].val;
            t[x].mi = t[2 * x + 2].mi;
            t[x].ind1 = t[2 * x + 2].ind1;
            t[x].ind2 = t[2 * x + 2].ind2;
        }
    }
};

void solve() {
    int n; cin >> n;
    vector <ll> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    lal.resize(*max_element(all(a)) + 1); iota(all(lal), 0);
    segtree st; st.init(lal.size()); st.build(0, 0, lal.size());
    vector <ll> ans(n, 0);
    ll s1 = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        s1 += a[i]; s2 += b[i];
        st.update(lower_bound(all(lal), b[i]) - lal.begin(), lal.size(), 1, 0, 0, lal.size());
        st.update(lower_bound(all(lal), a[i]) - lal.begin(), lal.size(), -1, 0, 0, lal.size());
        // debug(st.t[0].ind1 << ' ' << st.t[0].ind2 << ' ' << st.t[0].val);
        ans[i] = s1 - s2 - st.t[0].val + 1;
    }
    vout(ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}