#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

struct segtree {
    struct node {
        int mi = 0, add = 0, ind1 = 0, ind2 = 0, val = 0;
        node *l = nullptr, *r = nullptr;
    };

    node *A;

    void init () {
        A = new node();
        A->ind1 = 0; A->ind2 = mxn - 1;
        A->val = 1;
    }

    void build (node *x, int lx, int rx) {
        x->ind1 = lx; x->ind2 = rx - 1;
        if (rx - lx > 1) x->val = 1;
    }
    
    void push (node *x, int lx, int rx) {
        if (rx - lx == 1 || !x->add) return;
        x->l->mi += x->add; x->r->mi += x->add;
        x->l->add += x->add; x->r->add += x->add;
        x->add = 0;
    }

    void update (int l, int r, int v, node *x, int lx, int rx) {
        if (lx >= r || l >= rx) return;
        if (lx >= l && rx <= r) {
            x->mi += v; x->add += v;
            return;
        }
        int m = (lx + rx) >> 1;
        if (x->l == nullptr) {
            x->l = new node();
            build(x->l, lx, m);
        }
        if (x->r == nullptr) {
            x->r = new node();
            build(x->r, m, rx);
        }
        push(x, lx, rx);
        update(l, r, v, x->l, lx, m); update(l, r, v, x->r, m, rx);
        x->mi = min(x->l->mi, x->r->mi);
        if (x->l->mi == x->r->mi) {
            x->val = max(max(x->l->val, x->r->val), x->r->ind1 - x->l->ind2);
            x->ind2 = x->r->ind2;
            x->ind1 = x->l->ind1;
        }
        else if (x->l->mi < x->r->mi) {
            x->val = x->l->val;
            x->mi = x->l->mi;
            x->ind1 = x->l->ind1;
            x->ind2 = x->l->ind2;
        }
        else {
            x->val = x->r->val;
            x->mi = x->r->mi;
            x->ind1 = x->r->ind1;
            x->ind2 = x->r->ind2;
        }
    }
};

void solve() {
    int n; cin >> n;
    vector <ll> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    segtree st; st.init();
    vector <ll> ans(n, 0);
    ll s1 = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        s1 += a[i]; s2 += b[i];
        st.update(b[i], mxn, 1, st.A, 0, mxn);
        st.update(a[i], mxn, -1, st.A, 0, mxn);
        // debug(st.A-> mi << ' ' << st.A->ind1 << ' ' << st.A->ind2 << ' ' << st.A->val);
        ans[i] = s1 - s2 - st.A->val + 1;
    }
    vout(ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}