#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
using ll = long long;

const int INF = 1e9 + 177013;
const int MAXN = 2e5 + 123;
int a[MAXN];
ll psma[MAXN];
int b[MAXN];
ll psmb[MAXN];

struct dsu {
    vector<int> rt;
    vector<int> sz;
    vector<int> lb;
    vector<int> rb;

    void resize(int n) {
        sz.assign(n, 1);
        rt.resize(n);
        for (int i = 0; i < n; ++i)
            rt[i] = i;
        lb = rb = rt;
    }

    int gst(int i) {
        if (rt[i] == i)
            return i;
        return rt[i] = gst(rt[i]);
    }

    void unite(int i, int j) {
        i = gst(i);
        j = gst(j);
        if (i == j)
            return;
        if (sz[i] < sz[j])
            swap(i, j);
        rt[j] = i;
        sz[i] += sz[j];
        lb[i] = min(lb[i], lb[j]);
        rb[i] = max(rb[i], rb[j]);
    }

    pair<int, int> get_borders(int i) {
        i = gst(i);
        return {lb[i], rb[i]};
    }

    void unite_segment(int l, int r) {
        l = rb[gst(l)];
        while (l < r) {
            unite(l, l + 1);
            l = rb[gst(l)];
        }
    }
};

vector<int> init(int n) {
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int j = 0; j < n; ++j)
        cin >> b[j];
    for (int i = 0; i < n; ++i)
        psma[i] = (i > 0 ? psma[i - 1] : 0) + a[i];
    for (int i = 0; i < n; ++i)
        psmb[i] = (i > 0 ? psmb[i - 1] : 0) + b[i];
    vector<int> cpr;
    for (int i = 0; i < n; ++i)
        cpr.push_back(a[i]);
    for (int i = 0; i < n; ++i)
        cpr.push_back(b[i]);
    sort(cpr.begin(), cpr.end());
    cpr.resize(unique(cpr.begin(), cpr.end()) - cpr.begin());
    for (int i = 0; i < n; ++i)
        a[i] = lower_bound(cpr.begin(), cpr.end(), a[i]) - cpr.begin();
    for (int i = 0; i < n; ++i)
        b[i] = lower_bound(cpr.begin(), cpr.end(), b[i]) - cpr.begin();
    return cpr;
}

void solve() {
    int n;
    cin >> n;
    vector<int> cpr = init(n);
    int m = cpr.size();

    dsu su;
    su.resize(m);

    multiset<int> sta;
    multiset<int> stb;
    ll mxdel = 0;
    for (int i = 0; i < n; ++i) {
        sta.insert(a[i]);
        stb.insert(b[i]);
        su.unite_segment(b[i], a[i]);
        auto [l, r] = su.get_borders(b[i]);
        mxdel = max(mxdel, 1ll * cpr[r] - cpr[l]);
        cout << psma[i] - psmb[i] - mxdel << ' ';
    }
    cout << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
