#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];

        for (ll i = 0; i < n; i++) {
            ll ans = 0;

            for (ll j = 0; j <= i; j++) ans += a[i] - b[i];

            for (ll j = 0; j <= i; j++) {
                for (ll k = 0; k <= i; k++) {
                    vll ac(a.begin(), a.begin() + i + 1), bc(b.begin(), b.begin() + i + 1);
                    ac.erase(ac.begin() + j);
                    bc.erase(bc.begin() + k);

                    std::sort(ac.begin(), ac.end());
                    std::sort(bc.begin(), bc.end());

                    ll nw = 0;
                    for (ll w = 0; w < i; w++) {
                        if (ac[w] < bc[w]) nw = INF;
                        nw += ac[w] - bc[w];
                    }

                    ans = min(ans, nw);
                }
            }

            cout << ans << " ";
        }

        cout << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
