#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops,fast-math")
#endif

#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vll = vector<ll>;
using vii = vector<int>;
using vpll = vector<pll>;
using vpii = vector<pii>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

#define mp make_pair
#define mt make_tuple
#define ordered_set tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
ll seed = rd();
mt19937_64 gen(rd());

ld rnd() {
    return (ld)(gen() % RAND_MAX) / RAND_MAX;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        vector<ll> a(n), b(n);
        bool cond45 = true;
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];

        for (ll i = 0; i < n - 1; i++) cond45 &= a[i] < b[i + 1];

        if (!cond45) {
            for (ll i = 0; i < n; i++) {
                ll ans = 0;

                for (ll j = 0; j <= i; j++) ans += a[j] - b[j];

                vll ac(a.begin(), a.begin() + i + 1), bc(b.begin(), b.begin() + i + 1);
                std::sort(ac.begin(), ac.end());
                std::sort(bc.begin(), bc.end());

                ll sz = i + 1;

                vector<vector<vector<ll>>> dp(sz, vector<vector<ll>>(2, vector<ll>(2, INF)));
                dp[0][0][0] = 0;

                for (ll j = 0; j < sz; j++) {
                    for (ll p = 0; p < 2; p++) {
                        for (ll s = 0; s < 2; s++) {
                            if (!p) {
                                dp[j][1][s] = min(dp[j][1][s], dp[j][0][s]);
                            }


                            if (!s) {
                                dp[j][p][1] = min(dp[j][p][1], dp[j][p][0]);
                            }

                            if (j + 1 < sz && ac[j + p] >= bc[j + s])
                                dp[j + 1][p][s] = min(dp[j + 1][p][s], dp[j][p][s] + ac[j + p] - bc[j + s]);
                        }
                    }
                }

                cout << dp[sz - 1][1][1] << " ";
            }

            cout << "\n";
        } else {
            ll s = 0, mxD = 0;
            for (ll i = 0; i < n; i++) {
                mxD = max(mxD, a[i] - b[i]);
                s += a[i] - b[i];

                cout << s - mxD << " ";
            }

            cout << "\n";
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
    cout << "\nSeed = " << seed;
#endif
}
