#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct Fenwick {
    vector<int> t;
    int n;

    Fenwick(int n) : n(n) {
        t.resize(n + 1);
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        cin >> a >> b;
        if (n <= 3000) {
            vector<int> aa, bb;
            for (int k = 0; k < n; ++k) {
                aa.push_back(a[k]);
                bb.push_back(b[k]);
                sort(aa.begin(), aa.end());
                sort(bb.begin(), bb.end());
                vector<bool> can(k + 1);
                for (int i = k - 1; i >= 0; --i) {
                    can[i] = (aa[i] >= bb[i + 1]);
                }
                vector<int> ind(k + 1);
                int ii = -1;
                for (int i = 0; i <= k; ++i) {
                    if (!can[i]) {
                        ind[i] = ii;
                        ii = i;
                    }
                }
                int mx = -INF;
                for (int i = 0; i <= k; ++i) {
                    if (!can[i]) {
                        mx = max(mx, aa[i] - bb[ind[i] + 1]);
                    }
                }
                ll sum = 0;
                for (int i = 0; i <= k; ++i) {
                    sum += aa[i] - bb[i];
                    mx = max(mx, aa[i] - bb[i]);
                }
                cout << sum - mx << " ";
            }
        } else {
            vector<int> aa, bb;
            vector<bool> can(n);
            vector<int> ind(n);
            ll sum = 0;
            int mx = -INF;
            for (int k = 0; k < n; ++k) {
                aa.push_back(a[k]);
                bb.push_back(b[k]);
                sum += a[k] - b[k];
                mx = max(mx, a[k] - b[k]);
                if (k > 0) {
                    can[k - 1] = (aa[k - 1] >= bb[k]);
                }
                {
                    if (k == 0) {
                        ind[k] = -1;
                    } else {
                        if (!can[k - 1]) {
                            ind[k] = k - 1;
                        } else {
                            ind[k] = ind[k - 1];
                        }
                    }
                }
                mx = max(mx, aa[k] - bb[ind[k] + 1]);
                cout << sum - mx << " ";
            }
        }
        cout << "\n";
    }
}
