//#pragma GCC optimize("03")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

i64 solve(std::vector<int> a, std::vector<int> b) {
    std::sort(a.begin(), a.end());
    std::sort(b.begin(), b.end());
    i64 base = std::accumulate(a.begin(), a.end(), 0LL) - std::accumulate(b.begin(), b.end(), 0LL);
    int max = 0;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        max = std::max(max, a[i] - b[i]);
    }
    i64 res = base - max;
    std::vector<int> pref(n);
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + (b[i] <= a[i - 1]);
    }
    for (int i = 0; i < n; i++) {
        bool breaked = false;
        int low = i, high = n;
        while (high - low > 1) {
            int mid = (low + high) / 2;
            if (pref[mid] - pref[i] == mid - i) {
                low = mid;
            } else {
                high = mid;
            }
        }
//        for (int cnt = 0; i + 1 + cnt < n; cnt++) {
//            if (b[i + 1 + cnt] > a[i + cnt]) {
//                res = std::min(res, base - a[i + cnt] + b[i]);
//                breaked = true;
//                break;
//            }
//        }
        res = std::min(res, base - a[low] + b[i]);
    }
    return res;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
    }
    bool group1 = true, group2 = true;
    for (int i = 1; i < n; i++) {
        if (b[i] <= a[i - 1]) {
            group1 = false;
            break;
        }
    }
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1] || b[i] < b[i - 1]) {
            group2 = false;
            break;
        }
    }
    if (group1) {
        i64 base = 0;
        int max = 0;
        for (int p = 0; p < n; p++) {
            base += a[p] - b[p];
            max = std::max(max, a[p] - b[p]);
            std::cout << base - max << " \n"[p == n - 1];
        }
    } else if (group2) {
        std::vector<int> pref(n);
//        for (int i = 1; i < n; i++) {
//            pref[i] = pref[i - 1] + (b[i] <= a[i - 1]);
//        }
        for (int i = 0; i < n; i++) {
            bool breaked = false;
            int low = i, high = n;
            while (high - low > 1) {
                int mid = (low + high) / 2;
                if (pref[mid] - pref[i] == mid - i) {
                    low = mid;
                } else {
                    high = mid;
                }
            }
//        for (int cnt = 0; i + 1 + cnt < n; cnt++) {
//            if (b[i + 1 + cnt] > a[i + cnt]) {
//                res = std::min(res, base - a[i + cnt] + b[i]);
//                breaked = true;
//                break;
//            }
//        }
//            res = std::min(res, base - a[low] + b[i]);
        }
        i64 base = 0;
        int max = 0;
        int best = 0;
        i64 res = 0;
        for (int p = 0; p < n; p++) {
            base += a[p] - b[p];
            max = std::max(max, a[p] - b[p]);
            if (p > 0) {
                pref[p] = pref[p - 1] + (b[p] <= a[p - 1]);
            }
            int low = 0, high = p + 1;
            while (high - low > 1) {
                int mid = (low + high) / 2;
                if (pref[p] - pref[mid - 1] == p - mid + 1) {
                    high = mid;
                } else {
                    low = mid;
                }
            }
            best = std::max(best, a[p] - b[low]);
            std::cout << base - std::max(best, max) << " \n"[p == n - 1];
        }
    } else {
        std::vector<int> a_, b_;
        for (int p = 0; p < n; p++) {
            a_.emplace_back(a[p]);
            b_.emplace_back(b[p]);
            std::cout << solve(a_, b_) << " \n"[p == n - 1];
        }
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
    std::cin >> t;

    while (t--) {
        solve();
    }
}