#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <queue>
#include <math.h>
#include <fstream>
#include <random>
#include <cassert>
#include <hash_map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define int long long

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

struct Fenwick{
    vec<int> t;
    int n = 0;

    void init(int n_) {
        n = n_;
        t.assign(n, 0);
    }

    void upd(int a, int x) {
        for (; a < n; a += a & -a) {
            t[a] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r > 0; r -= r & -r) {
            s += t[r];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    int x, y;

    Vector(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    friend Vector operator+(Vector& a, Vector& b) {
        return (*new Vector(a.x + b.x, a.y + b.y));
    }

    friend Vector operator-(Vector& a, Vector& b) {
        return (*new Vector(a.x - b.x, a.y - b.y));
    }

    friend int operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }

    friend int operator^(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }

    ld len() {
        return x * x + y + y;
    }

    ld len2() {
        return sqrt(x * x + y * y);
    }
};

void solve() {
    int n;
    cin >> n;
    vec<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    int s = 0;
    int mx = -INF, mn = INF;
    int s2 = 0;
    for (int i = 0; i < n; ++i) {
        s += a[i] - b[i];
        int ans = s;
        for (int j = 0; j <= i; ++j) {
            for (int q = 0; q <= i; ++q) {
                vec<int> c, d;
                for (int e = 0; e <= i; ++e) {
                    if (e != j) c.push_back(a[e]);
                    if (e != q) d.push_back(b[e]);
                }
                sort(all(c));
                sort(all(d));
                bool flag = 1;
                for (int e = 0; e < i; ++e) {
                    //cout << c[e] << " " << d[e] << endl;
                    if (d[e] > c[e]) {
                        flag = 0;
                        break;
                    }
                }
                //cout << j << " " << q << " " << " " << flag << " " << i << endl;
                if (flag) ans = min(ans, s - (a[j] - b[q]));
            }
        }
        cout << ans << " ";
    }
    cout << endl;
}

signed main() {
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}