#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if
#define read(x) x; cin >> x;

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename V>
istream &operator>>(istream &in, pair<T, V> &v) {
    in >> v.first >> v.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}


template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}

int count1(int x) {
    int count = 0;
    while (x) {
        count += x & 1;
        x >>= 1;
    }
    return count;
}

int n;
vector<int> a, b;

namespace solve123 {
    multiset<int> as, bs;

    int ans() {
        auto ita = as.begin(),
                itb = bs.begin();
        int f = *itb;
        itb++;
        int best = 0;
        for (; itb != bs.end(); ita++, itb++) {
            if (*ita < *itb) {
                best = max(best, *ita - f);
                f = *itb;
            }
        }
        return max(best, *ita - f);
    }

    void solve() {
        as.clear();
        bs.clear();
        ll sum_r = 0;
        RANGE(i, n) {
            as.insert(a[i]);
            bs.insert(b[i]);
            sum_r += a[i] - b[i];
            cout << sum_r - ans() << " ";
        }
    }
}

namespace solve45 {
    void solve() {
        ll sum_r = a[0] - b[0];
        cout << "0 ";
        int f = b[0],
                best = 0;
        RANGE1(i, n) {
            sum_r += a[i] - b[i];
            if (a[i - 1] < b[i]) {
                best = max(best, a[i - 1] - f);
                f = b[i];
            }
            best = max(best, a[i] - f);
            cout << sum_r - best << " ";
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int read(t);
    LOOP(t) {
        cin >> n;
        a.resize(n);
        b.resize(n);
        cin >> a >> b;
        if (n <= 3000) {
            solve123::solve();
        } else {
            solve45::solve();
        }
        cout << ENDLINE;
    }
}
